(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S4 S3) S1)
(declare-fun f6 (S5 S2) S4)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) S3)
(declare-fun f9 (S7 S2) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 Int) S2)
(declare-fun f12 () S8)
(declare-fun f13 () S2)
(declare-fun f14 (S9 S2) Int)
(declare-fun f15 () S9)
(declare-fun f16 () S3)
(declare-fun f17 (S10 S3) S3)
(declare-fun f18 () S10)
(declare-fun f19 (S11 S2) S2)
(declare-fun f20 (S12 S2) S11)
(declare-fun f21 () S12)
(declare-fun f22 (S13 S3) S10)
(declare-fun f23 () S13)
(declare-fun f24 () S13)
(declare-fun f25 () S13)
(declare-fun f26 () S10)
(declare-fun f27 (S14 S1) S1)
(declare-fun f28 (S15 S1) S14)
(declare-fun f29 () S15)
(declare-fun f30 (S16 S3) S6)
(declare-fun f31 () S16)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (exists ((?v1 S2)) (and (= (f5 (f6 f7 ?v1) (f8 (f9 f10 (f11 f12 0)) f13)) f1) (= ?v0 (f11 f12 (+ (* 2 (f14 f15 ?v1)) 1))))))))
(assert (forall ((?v0 S2)) (= (= (f3 f16 ?v0) f1) (exists ((?v1 S2)) (and (= (f5 (f6 f7 ?v1) (f8 (f9 f10 (f11 f12 0)) f13)) f1) (= ?v0 (f11 f12 (* 2 (f14 f15 ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S2)) (= (= (f3 (f17 f18 ?v0) ?v1) f1) (= (f5 (f6 f7 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f19 (f20 f21 ?v0) ?v1) (f11 f12 (* (f14 f15 ?v0) (f14 f15 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (let ((?v_0 (f6 f7 ?v2))) (= (= (f3 (f17 (f22 f23 ?v0) ?v1) ?v2) f1) (or (= (f5 ?v_0 ?v0) f1) (= (f5 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f17 (f22 f24 ?v0) ?v1) ?v2) f1) (or (= (f3 ?v0 ?v2) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (not (= (f8 (f9 f10 (f11 f12 0)) (f11 f12 (* 2 (f14 f15 f13)))) (f17 (f22 f25 (f17 f26 f16)) (f17 f26 f4)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f5 ?v_0 (f17 (f22 f25 ?v1) ?v2)) f1) (=> (=> (= (f5 ?v_0 ?v1) f1) false) (=> (=> (= (f5 ?v_0 ?v2) f1) false) false))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (=> (= (f3 (f17 (f22 f25 ?v0) ?v1) ?v2) f1) (=> (=> (= (f3 ?v0 ?v2) f1) false) (=> (=> (= (f3 ?v1 ?v2) f1) false) false)))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (=> (=> (not (= (f3 ?v0 ?v1) f1)) (= (f3 ?v2 ?v1) f1)) (= (f3 (f17 (f22 f25 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (=> (not (= (f5 ?v_0 ?v1) f1)) (= (f5 ?v_0 ?v2) f1)) (= (f5 ?v_0 (f17 (f22 f25 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v1)) (?v_1 (f9 f10 ?v0))) (let ((?v_2 (f11 f12 (+ ?v_0 (f14 f15 ?v2))))) (=> (<= (f14 f15 ?v0) ?v_0) (= (f8 ?v_1 ?v_2) (f17 (f22 f25 (f8 ?v_1 ?v1)) (f8 (f9 f10 ?v1) ?v_2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f17 (f22 f25 ?v0) ?v1) ?v2) f1) (= (f27 (f28 f29 (f3 ?v0 ?v2)) (f3 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f17 (f22 f25 ?v0) ?v1) ?v2) f1) (= (f27 (f28 f29 (f3 ?v0 ?v2)) (f3 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f17 f26 (f17 (f22 f24 ?v0) ?v1)) (f17 (f22 f25 (f17 f26 ?v0)) (f17 f26 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f17 (f22 f25 (f17 f18 ?v0)) (f17 f18 ?v1)) ?v2) f1) (= (f5 (f6 f7 ?v2) (f17 (f22 f25 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (exists ((?v2 S2)) (and (< (f14 f15 ?v2) (f14 f15 ?v0)) (= (f3 ?v1 ?v2) f1))) (exists ((?v2 S2)) (and (= (f5 (f6 f7 ?v2) (f8 (f9 f10 (f11 f12 0)) ?v0)) f1) (= (f3 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (forall ((?v2 S2)) (=> (< (f14 f15 ?v2) (f14 f15 ?v0)) (= (f3 ?v1 ?v2) f1))) (forall ((?v2 S2)) (=> (= (f5 (f6 f7 ?v2) (f8 (f9 f10 (f11 f12 0)) ?v0)) f1) (= (f3 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f28 f29 ?v0))) (= (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) f1) (= (f27 ?v_0 (f27 (f28 f29 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f17 (f22 f25 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f22 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f28 f29 ?v0))) (= (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) f1) (= (f27 ?v_0 (f27 (f28 f29 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f17 (f22 f25 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f22 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f28 f29 ?v0))) (= (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) f1) (= (f27 ?v_0 (f27 (f28 f29 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f17 (f22 f25 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f22 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f28 f29 ?v0)) (?v_0 (f28 f29 ?v1))) (= (= (f27 ?v_1 (f27 ?v_0 ?v2)) f1) (= (f27 ?v_0 (f27 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f22 f25 ?v0)) (?v_0 (f22 f25 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f28 f29 ?v0)) (?v_0 (f28 f29 ?v1))) (= (= (f27 ?v_1 (f27 ?v_0 ?v2)) f1) (= (f27 ?v_0 (f27 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f22 f25 ?v0)) (?v_0 (f22 f25 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_1 (f28 f29 ?v0)) (?v_0 (f28 f29 ?v1))) (= (= (f27 ?v_1 (f27 ?v_0 ?v2)) f1) (= (f27 ?v_0 (f27 ?v_1 ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f22 f25 ?v0)) (?v_0 (f22 f25 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (= (f27 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (= (f27 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (let ((?v_0 (f28 f29 ?v0))) (let ((?v_1 (f27 ?v_0 ?v1))) (= (= (f27 ?v_0 ?v_1) f1) (= ?v_1 f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f27 (f28 f29 ?v0) ?v1) f1) (= (f27 (f28 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f17 (f22 f25 ?v0) ?v1) (f17 (f22 f25 ?v1) ?v0))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f27 (f28 f29 ?v0) ?v1) f1) (= (f27 (f28 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f17 (f22 f25 ?v0) ?v1) (f17 (f22 f25 ?v1) ?v0))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (f27 (f28 f29 ?v0) ?v1) f1) (= (f27 (f28 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f17 (f22 f25 ?v0) ?v1) (f17 (f22 f25 ?v1) ?v0))))
(assert (forall ((?v0 S1)) (= (= (f27 (f28 f29 ?v0) ?v0) f1) (= ?v0 f1))))
(assert (forall ((?v0 S3)) (= (f17 (f22 f25 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S1)) (= (= (f27 (f28 f29 ?v0) ?v0) f1) (= ?v0 f1))))
(assert (forall ((?v0 S3)) (= (f17 (f22 f25 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f5 ?v_0 ?v1) f1) (= (f5 ?v_0 (f17 (f22 f25 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f5 ?v_0 ?v1) f1) (= (f5 ?v_0 (f17 (f22 f25 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f17 (f22 f25 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f17 (f22 f25 ?v0) ?v2) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (forall ((?v3 S2)) (=> (= (f5 (f6 f7 ?v3) (f17 (f22 f25 ?v0) ?v1)) f1) (= (f3 ?v2 ?v3) f1))) (and (forall ((?v3 S2)) (=> (= (f5 (f6 f7 ?v3) ?v0) f1) (= (f3 ?v2 ?v3) f1))) (forall ((?v3 S2)) (=> (= (f5 (f6 f7 ?v3) ?v1) f1) (= (f3 ?v2 ?v3) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (exists ((?v3 S2)) (and (= (f5 (f6 f7 ?v3) (f17 (f22 f25 ?v0) ?v1)) f1) (= (f3 ?v2 ?v3) f1))) (or (exists ((?v3 S2)) (and (= (f5 (f6 f7 ?v3) ?v0) f1) (= (f3 ?v2 ?v3) f1))) (exists ((?v3 S2)) (and (= (f5 (f6 f7 ?v3) ?v1) f1) (= (f3 ?v2 ?v3) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f25 ?v0))) (= (f17 (f22 f25 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f22 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (= (f5 ?v_0 (f17 (f22 f25 ?v1) ?v2)) f1) (or (= (f5 ?v_0 ?v1) f1) (= (f5 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f22 f25 ?v0)) (?v_0 (f22 f25 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f25 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f17 (f22 f25 ?v0) ?v1) (f17 (f22 f25 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f17 (f22 f25 ?v0) ?v1) (f17 f26 (f17 (f22 f23 ?v0) ?v1)))))
(assert (forall ((?v0 S3)) (= (f17 (f22 f25 ?v0) ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (= (= (f3 (f8 (f30 f31 ?v0) ?v1) ?v2) f1) (forall ((?v3 S2)) (=> (= (f5 (f6 f7 ?v3) (f8 (f9 f10 ?v1) ?v2)) f1) (= (f3 ?v0 ?v3) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f14 f15 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f14 f15 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f14 f15 ?v0)) (?v_2 (f14 f15 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f14 f15 ?v0)) (?v_2 (f14 f15 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f11 f12 (* (f14 f15 ?v0) (f14 f15 ?v1)))) (or (= ?v1 (f11 f12 1)) (= ?v0 (f11 f12 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f14 f15 ?v1)) (?v_0 (f14 f15 ?v0)) (?v_3 (f14 f15 ?v3)) (?v_1 (f14 f15 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f14 f15 ?v1)) (?v_1 (f14 f15 ?v0)) (?v_0 (f14 f15 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f14 f15 ?v1)) (?v_0 (f14 f15 ?v0)) (?v_1 (f14 f15 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f14 f15 ?v1)) (?v_1 (f14 f15 ?v0)) (?v_2 (f14 f15 ?v2)) (?v_4 (f14 f15 ?v4)) (?v_3 (f14 f15 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= (+ (* (f14 f15 (f11 f12 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f14 f15 ?v1)) (?v_1 (f14 f15 ?v0)) (?v_2 (f14 f15 ?v2)) (?v_4 (f14 f15 ?v4)) (?v_3 (f14 f15 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< (+ (* (f14 f15 (f11 f12 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f14 f15 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f14 f15 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f11 f12 (* 0 (f14 f15 ?v0))) (f11 f12 0))))
(assert (forall ((?v0 S2)) (= (f11 f12 (* 1 (f14 f15 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f14 f15 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 1))) (= (= ?v_0 (f11 f12 (* (f14 f15 ?v0) (f14 f15 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f11 f12 (* (f14 f15 ?v0) 0)) (f11 f12 0))))
(assert (forall ((?v0 S2)) (= (f11 f12 (* (f14 f15 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f14 f15 ?v0)) (?v_0 (f14 f15 ?v1))) (= (f11 f12 (* ?v_1 ?v_0)) (f11 f12 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S2)) (= (f11 f12 (f14 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f15 (f11 f12 ?v0)) 0))))
(check-sat)
(exit)
