(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 () S2)
(declare-fun f11 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))))))
(assert (not (exists ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (and (< ?v_0 (f8 f9 f10)) (= f11 (f6 f7 (* 2 ?v_0))))))))
(assert (< (f8 f9 f11) (* 2 (f8 f9 f10))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< ?v_0 (f8 f9 f10)) (not (= f11 (f6 f7 (+ (* 2 ?v_0) 1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (* (f8 f9 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0))) (f8 f9 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f8 f9 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f8 f9 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* ?v_1 ?v_0)) (f6 f7 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (* (f8 f9 (f6 f7 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f8 f9 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_3 (f8 f9 ?v3)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 (- ?v0))) (f8 f9 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 ?v0)) (f8 f9 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1))) (= (= (f6 f7 (* (f8 f9 ?v0) ?v_0)) (f6 f7 (* (f8 f9 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (f8 f9 (f6 f7 (- ?v_0 ?v_2))) ?v_1)) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (+ ?v_0 ?v_2) ?v_1)) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* (* ?v_0 ?v_1) ?v_2)) (f6 f7 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* (+ ?v_1 1) ?v_0)) (f6 f7 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (f8 f9 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (+ ?v_1 1))) (f6 f7 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (f6 f7 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f6 f7 (- (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f6 f7 (+ (* ?v_0 ?v_2) ?v_3)) (f6 f7 (+ (* ?v_1 ?v_2) (f8 f9 ?v4)))) (= (f6 f7 (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= ?v_3 (+ (* (f8 f9 (f6 f7 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< ?v_3 (+ (* (f8 f9 (f6 f7 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_0 ?v_1) (= (f6 f7 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f6 f7 (- ?v_3 (+ (* (f8 f9 (f6 f7 (- ?v_1 ?v_0))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_3 (f8 f9 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f6 f7 (+ (* ?v_0 ?v_2) (f8 f9 ?v3))) (f6 f7 (+ (* ?v_1 ?v_2) ?v_3))) (= ?v3 (f6 f7 (+ (* (f8 f9 (f6 f7 (- ?v_1 ?v_0))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (* (f8 f9 (f6 f7 ?v0)) (f8 f9 (f6 f7 ?v1)))) (f6 f7 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (=> (< 0 ?v_0) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (=> (< 0 ?v_0) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (or (= ?v0 (f6 f7 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2)) (?v_3 (f8 f9 ?v3))) (= (f6 f7 (+ (* ?v_1 ?v_0) (+ (* ?v_2 ?v_0) ?v_3))) (f6 f7 (+ (* (+ ?v_1 ?v_2) ?v_0) ?v_3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f8 f9 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (+ (f8 f9 (f6 f7 (- ?v_0 2))) 1) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 4 (f8 f9 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (+ (f8 f9 (f6 f7 (- ?v_0 2))) 1) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
