(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) Int)
(declare-fun f8 () S5)
(declare-fun f9 () S3)
(declare-fun f10 (S6 S2) S3)
(declare-fun f11 () S6)
(declare-fun f12 () S6)
(declare-fun f13 () S3)
(declare-fun f14 (S3 S7) S1)
(declare-fun f15 () S7)
(declare-fun f16 (S2 S7) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 f6 (* 2 (f7 f8 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 f9 ?v0) (f5 f6 (+ (f7 f8 ?v0) 1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f10 f11 ?v0) ?v1) (f5 f6 (- (f7 f8 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f10 f12 ?v0) ?v1) (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 f13 ?v0) ?v0)))
(assert (not (= (f14 f4 f15) f1)))
(assert (forall ((?v0 S2) (?v1 S7)) (= (f14 (f10 f12 ?v0) ?v1) f1)))
(assert (forall ((?v0 S7)) (= (f14 f9 ?v0) f1)))
(assert (forall ((?v0 S7)) (= (f14 f13 ?v0) f1)))
(assert (forall ((?v0 S7) (?v1 S2)) (=> (forall ((?v2 S2)) (=> (= (f16 ?v2 ?v0) f1) (<= (f7 f8 ?v1) (f7 f8 ?v2)))) (= (f14 (f10 f11 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S7)) (= (= (f14 ?v0 ?v1) f1) (forall ((?v2 S2)) (=> (= (f16 ?v2 ?v1) f1) (forall ((?v3 S2)) (=> (= (f16 ?v3 ?v1) f1) (=> (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)) (= ?v2 ?v3)))))))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S2) (?v3 S2)) (=> (= (f14 ?v0 ?v1) f1) (=> (not (= ?v2 ?v3)) (=> (= (f16 ?v2 ?v1) f1) (=> (= (f16 ?v3 ?v1) f1) (not (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)))))))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S2) (?v3 S2)) (=> (= (f14 ?v0 ?v1) f1) (=> (= (f16 ?v2 ?v1) f1) (=> (= (f16 ?v3 ?v1) f1) (= (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)) (= ?v2 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S2) (?v3 S2)) (=> (= (f14 ?v0 ?v1) f1) (=> (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)) (=> (= (f16 ?v2 ?v1) f1) (=> (= (f16 ?v3 ?v1) f1) (= ?v2 ?v3)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f5 f6 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f5 f6 (* (f7 f8 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0))) (f7 f8 (f5 f6 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f7 f8 ?v0) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f7 f8 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f5 f6 (* (f7 f8 ?v0) (f7 f8 ?v1)))) (or (= ?v1 (f5 f6 1)) (= ?v0 (f5 f6 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_3 (f7 f8 ?v3)) (?v_1 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f5 f6 (* ?v0 ?v1)) (f5 f6 (* (f7 f8 (f5 f6 (- ?v0))) (f7 f8 (f5 f6 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f5 f6 (* ?v0 ?v1)) (f5 f6 (* (f7 f8 (f5 f6 ?v0)) (f7 f8 (f5 f6 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f7 f8 ?v0) 1)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f7 f8 ?v0) 1)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f7 f8 ?v0) 1))) (= (= (f5 f6 (* ?v_0 (f7 f8 ?v1))) (f5 f6 (* ?v_0 (f7 f8 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v1))) (= (= (f5 f6 (* (f7 f8 ?v0) ?v_0)) (f5 f6 (* (f7 f8 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f5 f6 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f5 f6 (* ?v_0 (f7 f8 ?v1))) (f5 f6 (* ?v_0 (f7 f8 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f5 f6 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v2)) (?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v2)) (?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2)) (= (f5 f6 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
