(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 Int) Int)
(declare-fun f7 (S5 Int) S4)
(declare-fun f8 () S5)
(declare-fun f9 (S6 S7) S8)
(declare-fun f10 (S9 S8) S6)
(declare-fun f11 () S9)
(declare-fun f12 () S6)
(declare-fun f13 () S7)
(declare-fun f14 () S8)
(declare-fun f15 (S10 S7) Int)
(declare-fun f16 (S11 Int) S10)
(declare-fun f17 () S11)
(declare-fun f18 (S12 Int) S7)
(declare-fun f19 () S12)
(declare-fun f20 () S4)
(declare-fun f21 () S8)
(declare-fun f22 () S10)
(declare-fun f23 (S13 S8) S8)
(declare-fun f24 () S13)
(declare-fun f25 () S5)
(declare-fun f26 () S5)
(declare-fun f27 (S14 S3) S5)
(declare-fun f28 () S14)
(declare-fun f29 () S14)
(declare-fun f30 () S4)
(declare-fun f31 (S15 S8) S13)
(declare-fun f32 () S15)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (* ?v0 ?v1))))
(assert (not (= (f9 (f10 f11 (f9 f12 f13)) f13) f14)))
(assert (forall ((?v0 S7)) (= (f9 (f10 f11 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 1) ?v0) 1)))
(assert (= (f9 (f10 f11 f14) (f18 f19 2)) f14))
(assert (= (f15 (f16 f17 1) (f18 f19 2)) 1))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 ?v0) (f18 f19 0)) f14)))
(assert (forall ((?v0 Int)) (= (f15 (f16 f17 ?v0) (f18 f19 0)) 1)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 ?v0) (f18 f19 0)) f14)))
(assert (forall ((?v0 Int)) (= (f15 (f16 f17 ?v0) (f18 f19 0)) 1)))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f6 f20 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 (f6 f20 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 (f16 f17 ?v0) (f18 f19 2)))) (= (f6 f20 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f15 (f16 f17 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f15 (f16 f17 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f19 2))) (= (f15 (f16 f17 (f6 f20 ?v0)) ?v_0) (f15 (f16 f17 ?v0) ?v_0)))))
(assert (= (f6 f20 1) 1))
(assert (forall ((?v0 S8)) (= (= f14 ?v0) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S7)) (not (= (f9 f12 ?v0) f21))))
(assert (= (f6 f20 0) 0))
(assert (forall ((?v0 S8)) (= (= f21 ?v0) (= ?v0 f21))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f6 f20 ?v0) 0) (= ?v0 0))))
(assert (not (= f21 f14)))
(assert (not (= 0 1)))
(assert (not (= f14 f21)))
(assert (not (= 1 0)))
(assert (forall ((?v0 S8) (?v1 S7)) (=> (not (= ?v0 f21)) (not (= (f9 (f10 f11 ?v0) ?v1) f21)))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (not (= ?v0 0)) (not (= (f15 (f16 f17 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S8)) (= (= (f9 (f10 f11 ?v0) (f18 f19 2)) f21) (= ?v0 f21))))
(assert (forall ((?v0 Int)) (= (= (f15 (f16 f17 ?v0) (f18 f19 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S7)) (= (= (f9 (f10 f11 ?v0) ?v1) f21) (and (= ?v0 f21) (not (= ?v1 (f18 f19 0)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (= (f15 (f16 f17 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f18 f19 0)))))))
(assert (= (f9 (f10 f11 f21) (f18 f19 2)) f21))
(assert (= (f15 (f16 f17 0) (f18 f19 2)) 0))
(assert (forall ((?v0 S7)) (= (f9 (f10 f11 f21) (f18 f19 (+ (f15 f22 ?v0) 1))) f21)))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 0) (f18 f19 (+ (f15 f22 ?v0) 1))) 0)))
(assert (forall ((?v0 S7)) (= (f9 (f10 f11 f21) ?v0) (ite (= ?v0 (f18 f19 0)) f14 f21))))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 0) ?v0) (ite (= ?v0 (f18 f19 0)) 1 0))))
(assert (= (f23 f24 f21) f14))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (=> (<= (f15 f22 ?v0) (f15 f22 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f15 ?v_0 ?v1) (f15 ?v_0 ?v0))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (=> (< (f15 f22 ?v0) (f15 f22 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f15 ?v_0 ?v1) (f15 ?v_0 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f15 (f16 f17 ?v0) (f18 f19 (+ (f15 f22 ?v1) 1))) 1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (=> (<= (f15 f22 ?v0) (f15 f22 ?v1)) (=> (<= 1 ?v2) (<= (f15 ?v_0 ?v0) (f15 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 1 ?v0) (<= 1 (f15 (f16 f17 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (=> (< (f15 f22 ?v0) (f15 f22 ?v1)) (=> (< 1 ?v2) (< (f15 ?v_0 ?v0) (f15 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (< 1 ?v0) (=> (< (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (< (f15 f22 ?v1) (f15 f22 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (< 1 ?v0) (=> (< 0 (f15 f22 ?v1)) (< 1 (f15 (f16 f17 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (< 1 ?v0) (= (< (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (< (f15 f22 ?v1) (f15 f22 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (< 1 ?v0) (= (= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 f20 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f6 f20 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (=> (< (f15 (f16 f17 ?v0) ?v_0) (f15 (f16 f17 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int)) (=> (< (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f15 f22 ?v2)) (< (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (< 1 ?v0) (= (<= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (<= (f15 f22 ?v1) (f15 f22 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (< 1 ?v0) (=> (<= (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (<= (f15 f22 ?v1) (f15 f22 ?v2)))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f6 f20 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f6 f20 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f6 f20 ?v0) 0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f20 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f6 f20 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (<= 0 (f6 f20 ?v0))))
(assert (< 0 1))
(assert (not (< 1 0)))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (< 0 ?v0) (< 0 (f15 (f16 f17 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f15 (f16 f17 ?v0) (f18 f19 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f15 (f16 f17 ?v0) (f18 f19 2)) 0))))
(assert (<= 0 1))
(assert (not (<= 1 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (=> (= (f15 (f16 f17 ?v0) ?v_0) (f15 (f16 f17 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (=> (<= (f15 (f16 f17 ?v0) ?v_0) (f15 (f16 f17 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int)) (let ((?v_0 (f18 f19 (+ (f15 f22 ?v1) 1)))) (=> (= (f15 (f16 f17 ?v0) ?v_0) (f15 (f16 f17 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int)) (let ((?v_0 (f18 f19 (+ (f15 f22 ?v1) 1)))) (=> (<= (f15 (f16 f17 ?v0) ?v_0) (f15 (f16 f17 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int)) (=> (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f15 f22 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (<= 0 (f15 (f16 f17 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S7)) (<= 0 (f15 (f16 f17 (f6 f20 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= 0 (f15 (f16 f17 ?v0) (f18 f19 2)))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (< 1 ?v0) (< 1 (f15 (f16 f17 ?v0) (f18 f19 (+ (f15 f22 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (=> (<= ?v0 1) (<= (f15 (f16 f17 ?v0) (f18 f19 (+ (f15 f22 ?v1) 1))) ?v0)))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f6 (f7 f25 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f6 (f7 f26 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f6 (f7 f25 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f6 (f7 f26 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f6 (f7 f25 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f6 (f7 f26 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f6 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f6 ?v1 ?v5) (f6 ?v1 ?v4)))) (< (f6 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f6 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f6 ?v2 ?v5) (f6 ?v2 ?v4)))) (< ?v3 (f6 ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f25 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f25 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f6 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f6 ?v1 ?v5) (f6 ?v1 ?v4)))) (<= (f6 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f26 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f6 (f7 f26 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f6 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f6 ?v2 ?v5) (f6 ?v2 ?v4)))) (<= ?v3 (f6 ?v2 ?v1)))))))
(assert (= f25 (f27 f28 f5)))
(assert (= f26 (f27 f29 f5)))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f6 f30 ?v0) 1))))
(assert (forall ((?v0 Int)) (= (= (f6 f30 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f6 f20 (* ?v0 ?v1)) (* (f6 f20 ?v0) (f6 f20 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f6 f20 ?v1) ?v0) (f6 f20 (* ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f23 (f31 f32 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (not (= (f23 (f31 f32 ?v0) ?v1) f21))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f23 (f31 f32 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 ?v0) f21) f21)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 ?v0) f21) f21)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 f21) ?v0) f21)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 f21) ?v0) f21)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f15 (f16 f17 ?v0) (f18 f19 2)))))
(assert (forall ((?v0 S8)) (= (f23 (f31 f32 ?v0) ?v0) (f9 (f10 f11 ?v0) (f18 f19 2)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1))) (* ?v0 (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1))) (f23 (f31 f32 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1))) (* ?v0 (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1))) (f23 (f31 f32 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1))) (* (f15 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1))) (f23 (f31 f32 (f9 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f15 (f16 f17 ?v0) (f18 f19 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 ?v0) (f18 f19 2)) (f23 (f31 f32 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f15 (f16 f17 ?v0) (f18 f19 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 ?v0) (f18 f19 3)) (f23 (f31 f32 (f23 (f31 f32 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (* ?v0 (f15 ?v_0 ?v1)) (f15 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f23 (f31 f32 ?v0) (f9 ?v_0 ?v1)) (f9 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f18 f19 (+ (f15 f22 ?v1) (f15 f22 ?v2)))) (* (f15 ?v_0 ?v1) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f18 f19 (+ (f15 f22 ?v1) (f15 f22 ?v2)))) (f23 (f31 f32 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (* (f15 ?v_0 ?v1) ?v0) (f15 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f23 (f31 f32 (f9 ?v_0 ?v1)) ?v0) (f9 ?v_0 (f18 f19 (+ (f15 f22 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (= (f23 (f31 f32 ?v_0) ?v0) (f23 (f31 f32 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f15 (f16 f17 (* ?v0 ?v1)) ?v2) (* (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S7)) (= (f9 (f10 f11 (f23 (f31 f32 ?v0) ?v1)) ?v2) (f23 (f31 f32 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f15 (f16 f17 (* ?v0 ?v1)) ?v2) (* (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S7)) (= (f9 (f10 f11 (f23 (f31 f32 ?v0) ?v1)) ?v2) (f23 (f31 f32 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (* (f15 ?v_0 ?v1) (f15 ?v_0 ?v2)) (f15 ?v_0 (f18 f19 (+ (f15 f22 ?v1) (f15 f22 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f23 (f31 f32 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) (f9 ?v_0 (f18 f19 (+ (f15 f22 ?v1) (f15 f22 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_0 (f15 f22 ?v0)) (?v_1 (f16 f17 ?v1))) (=> (< 0 ?v_0) (= (* (f15 ?v_1 (f18 f19 (- ?v_0 1))) ?v1) (f15 ?v_1 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S8)) (let ((?v_0 (f15 f22 ?v0)) (?v_1 (f10 f11 ?v1))) (=> (< 0 ?v_0) (= (f23 (f31 f32 (f9 ?v_1 (f18 f19 (- ?v_0 1)))) ?v1) (f9 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f18 f19 (* (f15 f22 ?v1) (f15 f22 ?v2)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f18 f19 (* (f15 f22 ?v1) (f15 f22 ?v2)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f18 f19 (* 2 (f15 f22 ?v1)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) (f18 f19 2))))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f18 f19 (* 2 (f15 f22 ?v1)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f18 f19 2))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f18 f19 (* (f15 f22 ?v1) (f15 f22 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S7) (?v2 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f18 f19 (* (f15 f22 ?v1) (f15 f22 ?v2))))))))
(assert (forall ((?v0 Int)) (= (= (f6 f30 ?v0) 0) (= ?v0 0))))
(assert (= (f6 f30 0) 0))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 (f18 f19 (* 2 (f15 f22 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f18 f19 (* 2 (f15 f22 ?v1)))) (f23 (f31 f32 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 (f18 f19 (+ (* 2 (f15 f22 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f18 f19 (+ (* 2 (f15 f22 ?v1)) 1))) (f23 (f31 f32 ?v0) (f23 (f31 f32 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f18 f19 (+ (* 2 (f15 f22 ?v1)) 1))) (* ?v0 (f15 (f16 f17 (f15 ?v_0 ?v1)) (f18 f19 2)))))))
(assert (forall ((?v0 S8) (?v1 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f18 f19 (+ (* 2 (f15 f22 ?v1)) 1))) (f23 (f31 f32 ?v0) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f18 f19 2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f31 f32 ?v0))) (= (f23 (f31 f32 (f23 ?v_0 ?v1)) (f23 (f31 f32 ?v2) ?v3)) (f23 (f31 f32 (f23 ?v_0 ?v2)) (f23 (f31 f32 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_1 (f31 f32 (f23 (f31 f32 ?v0) ?v1))) (?v_0 (f31 f32 ?v2))) (= (f23 ?v_1 (f23 ?v_0 ?v3)) (f23 ?v_0 (f23 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f31 f32 ?v0)) (?v_1 (f23 (f31 f32 ?v2) ?v3))) (= (f23 (f31 f32 (f23 ?v_0 ?v1)) ?v_1) (f23 ?v_0 (f23 (f31 f32 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f31 f32 ?v0))) (= (f23 (f31 f32 (f23 ?v_0 ?v1)) ?v2) (f23 (f31 f32 (f23 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f31 f32 ?v0))) (= (f23 (f31 f32 (f23 ?v_0 ?v1)) ?v2) (f23 ?v_0 (f23 (f31 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S7)) (= (f18 f19 (f15 f22 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f15 f22 (f18 f19 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f15 f22 (f18 f19 ?v0)) 0))))
(check-sat)
(exit)
