(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S6)
(declare-fun f7 (S7 S6) S4)
(declare-fun f8 () S7)
(declare-fun f9 () S4)
(declare-fun f10 () S5)
(declare-fun f11 () S5)
(declare-fun f12 () S6)
(declare-fun f13 (S8 S5) Int)
(declare-fun f14 () S8)
(declare-fun f15 (S9 S5) S5)
(declare-fun f16 (S10 S5) S9)
(declare-fun f17 () S10)
(declare-fun f18 () S5)
(declare-fun f19 (S11 Int) S8)
(declare-fun f20 () S11)
(declare-fun f21 (S12 Int) S5)
(declare-fun f22 () S12)
(declare-fun f23 () S2)
(declare-fun f24 () S10)
(declare-fun f25 (S13 S6) S6)
(declare-fun f26 (S14 S6) S13)
(declare-fun f27 () S14)
(declare-fun f28 (S15 S10) S10)
(declare-fun f29 (S16 S5) S15)
(declare-fun f30 () S16)
(declare-fun f31 (S17 S14) S7)
(declare-fun f32 (S18 S6) S17)
(declare-fun f33 () S18)
(declare-fun f34 (S19 S3) S11)
(declare-fun f35 (S20 Int) S19)
(declare-fun f36 () S20)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (not (not (= (f6 (f7 f8 (f6 f9 f10)) f11) f12))))
(assert (< 0 (f13 f14 f11)))
(assert (< (f13 f14 f11) (f13 f14 f10)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 (f6 f9 ?v0)) ?v0) f12)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 f18) ?v0) f18)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f12) ?v0) f12)))
(assert (forall ((?v0 S5)) (= (f13 (f19 f20 1) ?v0) 1)))
(assert (= (f15 (f16 f17 f18) (f21 f22 2)) f18))
(assert (= (f6 (f7 f8 f12) (f21 f22 2)) f12))
(assert (= (f13 (f19 f20 1) (f21 f22 2)) 1))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) (f21 f22 0)) f18)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f21 f22 0)) f12)))
(assert (forall ((?v0 Int)) (= (f13 (f19 f20 ?v0) (f21 f22 0)) 1)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) (f21 f22 0)) f18)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f21 f22 0)) f12)))
(assert (forall ((?v0 Int)) (= (f13 (f19 f20 ?v0) (f21 f22 0)) 1)))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f3 f23 (f13 (f19 f20 ?v0) ?v1)) (f13 (f19 f20 (f3 f23 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 (f19 f20 ?v0) (f21 f22 2)))) (= (f3 f23 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f13 (f19 f20 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f13 (f19 f20 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 2))) (= (f13 (f19 f20 (f3 f23 ?v0)) ?v_0) (f13 (f19 f20 ?v0) ?v_0)))))
(assert (= (f3 f23 1) 1))
(assert (forall ((?v0 S5)) (= (= f18 ?v0) (= ?v0 f18))))
(assert (forall ((?v0 S6)) (= (= f12 ?v0) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v0))) (=> (< 0 ?v_0) (= (f6 (f7 f8 (f6 f9 (f21 f22 (* ?v_0 (f13 f14 ?v1))))) (f21 f22 (* ?v_0 (f13 f14 ?v2)))) (f6 (f7 f8 (f6 f9 ?v1)) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f23 (* ?v0 ?v1)) (* (f3 f23 ?v0) (f3 f23 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f15 (f16 f24 ?v0) ?v1) (f15 (f16 f24 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 ?v1) (ite (= ?v1 (f21 f22 0)) (f21 f22 1) (f21 f22 (* (f13 f14 ?v0) (f13 f14 (f15 ?v_0 (f21 f22 (- (f13 f14 ?v1) 1)))))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 0)) (?v_2 (f13 f14 ?v0)) (?v_1 (f13 f14 ?v1))) (= (f21 f22 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f21 f22 (+ ?v_1 (* (f13 f14 (f21 f22 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f21 f22 (* ?v_0 2)) (f21 f22 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f13 ?v_0 (f21 f22 (+ (* 2 (f13 f14 ?v1)) 1))) (* ?v0 (f13 (f19 f20 (f13 ?v_0 ?v1)) (f21 f22 2)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f21 f22 (+ (* 2 (f13 f14 ?v1)) 1))) (f25 (f26 f27 ?v0) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f21 f22 2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f21 f22 (+ (* 2 (f13 f14 ?v1)) 1))) (f15 (f16 f24 ?v0) (f15 (f16 f17 (f15 ?v_0 ?v1)) (f21 f22 2)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f21 f22 (+ (* 2 (f13 f14 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f21 f22 (+ (* 2 (f13 f14 ?v1)) 1))) (f25 (f26 f27 ?v0) (f25 (f26 f27 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 (f21 f22 (+ (* 2 (f13 f14 ?v1)) 1))) (f15 (f16 f24 ?v0) (f15 (f16 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f16 f24 ?v0)) (?v_0 (f16 f24 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f26 f27 ?v0)) (?v_0 (f26 f27 ?v1))) (= (f25 ?v_1 (f25 ?v_0 ?v2)) (f25 ?v_0 (f25 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f24 ?v0))) (= (f15 ?v_0 (f15 (f16 f24 ?v1) ?v2)) (f15 (f16 f24 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2)) (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f21 f22 (* 2 (f13 f14 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f21 f22 (* 2 (f13 f14 ?v1)))) (f25 (f26 f27 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 (f21 f22 (* 2 (f13 f14 ?v1)))) (f15 (f16 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f23 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f21 f22 (* 2 ?v_0)) (f21 f22 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f24 ?v0))) (= (f15 (f16 f24 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f24 ?v0))) (= (f15 (f16 f24 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f24 ?v0))) (= (f15 (f16 f24 (f15 ?v_0 ?v1)) ?v2) (f15 (f16 f24 (f15 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 (f26 f27 (f25 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f16 f24 ?v0)) (?v_1 (f15 (f16 f24 ?v2) ?v3))) (= (f15 (f16 f24 (f15 ?v_0 ?v1)) ?v_1) (f15 ?v_0 (f15 (f16 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f25 (f26 f27 ?v2) ?v3))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v_1) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f16 f24 (f15 (f16 f24 ?v0) ?v1))) (?v_0 (f16 f24 ?v2))) (= (f15 ?v_1 (f15 ?v_0 ?v3)) (f15 ?v_0 (f15 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f26 f27 (f25 (f26 f27 ?v0) ?v1))) (?v_0 (f26 f27 ?v2))) (= (f25 ?v_1 (f25 ?v_0 ?v3)) (f25 ?v_0 (f25 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f16 f24 ?v0))) (= (f15 (f16 f24 (f15 ?v_0 ?v1)) (f15 (f16 f24 ?v2) ?v3)) (f15 (f16 f24 (f15 ?v_0 ?v2)) (f15 (f16 f24 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) (f25 (f26 f27 ?v2) ?v3)) (f25 (f26 f27 (f25 ?v_0 ?v2)) (f25 (f26 f27 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S5)) (= (f15 (f16 f24 ?v0) f18) ?v0)))
(assert (forall ((?v0 S6)) (= (f25 (f26 f27 ?v0) f12) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f24 ?v0) f18) ?v0)))
(assert (forall ((?v0 S6)) (= (f25 (f26 f27 ?v0) f12) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f24 ?v0) f18) ?v0)))
(assert (forall ((?v0 S6)) (= (f25 (f26 f27 ?v0) f12) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f24 f18) ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f25 (f26 f27 f12) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f24 f18) ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f25 (f26 f27 f12) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f24 f18) ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f25 (f26 f27 f12) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (* (f13 ?v_0 ?v1) (f13 ?v_0 ?v2)) (f13 ?v_0 (f21 f22 (+ (f13 f14 ?v1) (f13 f14 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f25 (f26 f27 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f21 f22 (+ (f13 f14 ?v1) (f13 f14 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f24 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) (f15 ?v_0 (f21 f22 (+ (f13 f14 ?v1) (f13 f14 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f13 (f19 f20 (* ?v0 ?v1)) ?v2) (* (f13 (f19 f20 ?v0) ?v2) (f13 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (= (f6 (f7 f8 (f25 (f26 f27 ?v0) ?v1)) ?v2) (f25 (f26 f27 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f15 (f16 f17 (f15 (f16 f24 ?v0) ?v1)) ?v2) (f15 (f16 f24 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f13 (f19 f20 (* ?v0 ?v1)) ?v2) (* (f13 (f19 f20 ?v0) ?v2) (f13 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (= (f6 (f7 f8 (f25 (f26 f27 ?v0) ?v1)) ?v2) (f25 (f26 f27 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f15 (f16 f17 (f15 (f16 f24 ?v0) ?v1)) ?v2) (f15 (f16 f24 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f13 (f19 f20 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (= (f25 (f26 f27 ?v_0) ?v0) (f25 (f26 f27 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v1))) (= (f15 (f16 f24 ?v_0) ?v0) (f15 (f16 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (* (f13 ?v_0 ?v1) ?v0) (f13 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f25 (f26 f27 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f24 (f15 ?v_0 ?v1)) ?v0) (f15 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f13 ?v_0 (f21 f22 (+ (f13 f14 ?v1) (f13 f14 ?v2)))) (* (f13 ?v_0 ?v1) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f21 f22 (+ (f13 f14 ?v1) (f13 f14 ?v2)))) (f25 (f26 f27 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f21 f22 (+ (f13 f14 ?v1) (f13 f14 ?v2)))) (f15 (f16 f24 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (* ?v0 (f13 ?v_0 ?v1)) (f13 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f25 (f26 f27 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f24 ?v0) (f15 ?v_0 ?v1)) (f15 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f13 (f19 f20 ?v0) (f21 f22 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f21 f22 3)) (f25 (f26 f27 (f25 (f26 f27 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) (f21 f22 3)) (f15 (f16 f24 (f15 (f16 f24 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f13 (f19 f20 ?v0) (f21 f22 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f21 f22 2)) (f25 (f26 f27 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) (f21 f22 2)) (f15 (f16 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f13 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1))) (* (f13 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1))) (f25 (f26 f27 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1))) (f15 (f16 f24 (f15 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f13 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1))) (* ?v0 (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1))) (f25 (f26 f27 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1))) (f15 (f16 f24 ?v0) (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f13 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1))) (* ?v0 (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1))) (f25 (f26 f27 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f21 f22 (+ (f13 f14 ?v1) 1))) (f15 (f16 f24 ?v0) (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f13 (f19 f20 ?v0) (f21 f22 2)))))
(assert (forall ((?v0 S6)) (= (f25 (f26 f27 ?v0) ?v0) (f6 (f7 f8 ?v0) (f21 f22 2)))))
(assert (forall ((?v0 S5)) (= (f15 (f16 f24 ?v0) ?v0) (f15 (f16 f17 ?v0) (f21 f22 2)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f13 (f19 f20 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f21 f22 (* (f13 f14 ?v1) (f13 f14 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f21 f22 (* (f13 f14 ?v1) (f13 f14 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f21 f22 (* (f13 f14 ?v1) (f13 f14 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f13 ?v_0 (f21 f22 (* 2 (f13 f14 ?v1)))) (f13 (f19 f20 (f13 ?v_0 ?v1)) (f21 f22 2))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f21 f22 (* 2 (f13 f14 ?v1)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f21 f22 2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f21 f22 (* 2 (f13 f14 ?v1)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) (f21 f22 2))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f13 ?v_0 (f21 f22 (* (f13 f14 ?v1) (f13 f14 ?v2)))) (f13 (f19 f20 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f21 f22 (* (f13 f14 ?v1) (f13 f14 ?v2)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f21 f22 (* (f13 f14 ?v1) (f13 f14 ?v2)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 ?v1) (ite (= ?v1 (f21 f22 0)) f18 (f15 (f16 f24 ?v0) (f15 ?v_0 (f21 f22 (- (f13 f14 ?v1) 1)))))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 ?v1) (ite (= ?v1 (f21 f22 0)) f12 (f25 (f26 f27 ?v0) (f6 ?v_0 (f21 f22 (- (f13 f14 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f19 f20 ?v0))) (= (f13 ?v_0 ?v1) (ite (= ?v1 (f21 f22 0)) 1 (* ?v0 (f13 ?v_0 (f21 f22 (- (f13 f14 ?v1) 1)))))))))
(assert (= f17 (f28 (f29 f30 f18) f24)))
(assert (= f8 (f31 (f32 f33 f12) f27)))
(assert (= f20 (f34 (f35 f36 1) f5)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f13 f14 ?v1)) (?v_1 (f13 f14 ?v0)) (?v_2 (f19 f20 ?v2))) (=> (<= ?v_1 ?v_0) (= (f13 ?v_2 (f21 f22 (- (+ ?v_0 1) ?v_1))) (* (f13 ?v_2 (f21 f22 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S6)) (let ((?v_0 (f13 f14 ?v1)) (?v_1 (f13 f14 ?v0)) (?v_2 (f7 f8 ?v2))) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f21 f22 (- (+ ?v_0 1) ?v_1))) (f25 (f26 f27 (f6 ?v_2 (f21 f22 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f13 f14 ?v1)) (?v_1 (f13 f14 ?v0)) (?v_2 (f16 f17 ?v2))) (=> (<= ?v_1 ?v_0) (= (f15 ?v_2 (f21 f22 (- (+ ?v_0 1) ?v_1))) (f15 (f16 f24 (f15 ?v_2 (f21 f22 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 Int)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f19 f20 ?v1))) (=> (< 0 ?v_0) (= (* (f13 ?v_1 (f21 f22 (- ?v_0 1))) ?v1) (f13 ?v_1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f7 f8 ?v1))) (=> (< 0 ?v_0) (= (f25 (f26 f27 (f6 ?v_1 (f21 f22 (- ?v_0 1)))) ?v1) (f6 ?v_1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f16 f17 ?v1))) (=> (< 0 ?v_0) (= (f15 (f16 f24 (f15 ?v_1 (f21 f22 (- ?v_0 1)))) ?v1) (f15 ?v_1 ?v0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f13 f14 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f13 f14 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f21 f22 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f21 f22 (* (f13 f14 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0))) (f13 f14 (f21 f22 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (* (f13 f14 ?v0) (f13 f14 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5)) (= (f21 f22 (f13 f14 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f13 f14 (f21 f22 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f13 f14 (f21 f22 ?v0)) 0))))
(check-sat)
(exit)
