(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S6)
(declare-fun f7 (S7 S6) S4)
(declare-fun f8 () S7)
(declare-fun f9 () S4)
(declare-fun f10 (S8 Int) S5)
(declare-fun f11 () S8)
(declare-fun f12 (S9 S5) Int)
(declare-fun f13 () S9)
(declare-fun f14 () S5)
(declare-fun f15 () S5)
(declare-fun f16 () S5)
(declare-fun f17 (S10 S6) S6)
(declare-fun f18 (S11 S6) S10)
(declare-fun f19 () S11)
(declare-fun f20 (S12 S5) S5)
(declare-fun f21 (S13 S5) S12)
(declare-fun f22 () S13)
(declare-fun f23 () S13)
(declare-fun f24 (S14 Int) S9)
(declare-fun f25 () S14)
(declare-fun f26 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (let ((?v_0 (* (f12 f13 f15) (f12 f13 f16)))) (not (= (f6 (f7 f8 (f6 f9 (f10 f11 (* 2 (f12 f13 f14))))) (f10 f11 (* 2 ?v_0))) (f6 (f7 f8 (f6 f9 f14)) (f10 f11 ?v_0))))))
(assert (let ((?v_0 (f7 f8 (f6 f9 (f10 f11 (* 2 (f12 f13 f14)))))) (?v_1 (f12 f13 f15)) (?v_2 (f12 f13 f16))) (= (f6 ?v_0 (f10 f11 (* ?v_1 (* 2 ?v_2)))) (f6 ?v_0 (f10 f11 (* 2 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f12 f13 ?v0))) (=> (< 0 ?v_0) (= (f6 (f7 f8 (f6 f9 (f10 f11 (* ?v_0 (f12 f13 ?v1))))) (f10 f11 (* ?v_0 (f12 f13 ?v2)))) (f6 (f7 f8 (f6 f9 ?v1)) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (f17 (f18 f19 ?v0) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f10 f11 2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (f20 (f21 f23 ?v0) (f20 (f21 f22 (f20 ?v_0 ?v1)) (f10 f11 2)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (* ?v0 (f12 (f24 f25 (f12 ?v_0 ?v1)) (f10 f11 2)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (f17 (f18 f19 ?v0) (f17 (f18 f19 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f20 ?v_0 ?v1))) (= (f20 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (f20 (f21 f23 ?v0) (f20 (f21 f23 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f10 f11 (* 2 (f12 f13 ?v1)))) (f17 (f18 f19 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f20 ?v_0 ?v1))) (= (f20 ?v_0 (f10 f11 (* 2 (f12 f13 ?v1)))) (f20 (f21 f23 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f10 f11 (* 2 (f12 f13 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (* (f12 f13 ?v1) (f12 f13 ?v2)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (* (f12 f13 ?v1) (f12 f13 ?v2)))) (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 ?v_0 (f10 f11 (* (f12 f13 ?v1) (f12 f13 ?v2)))) (f12 (f24 f25 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (* 2 (f12 f13 ?v1)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f10 f11 2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (* 2 (f12 f13 ?v1)))) (f20 (f21 f22 (f20 ?v_0 ?v1)) (f10 f11 2))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 ?v_0 (f10 f11 (* 2 (f12 f13 ?v1)))) (f12 (f24 f25 (f12 ?v_0 ?v1)) (f10 f11 2))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f10 f11 (* (f12 f13 ?v1) (f12 f13 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f10 f11 (* (f12 f13 ?v1) (f12 f13 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 (f24 f25 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f10 f11 (* (f12 f13 ?v1) (f12 f13 ?v2))))))))
(assert (forall ((?v0 S6)) (= (f17 (f18 f19 ?v0) ?v0) (f6 (f7 f8 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f23 ?v0) ?v0) (f20 (f21 f22 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f12 (f24 f25 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1))) (f17 (f18 f19 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1))) (f20 (f21 f23 ?v0) (f20 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1))) (* ?v0 (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1))) (f17 (f18 f19 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1))) (f20 (f21 f23 ?v0) (f20 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1))) (* ?v0 (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1))) (f17 (f18 f19 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1))) (f20 (f21 f23 (f20 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1))) (* (f12 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f10 f11 2)) (f17 (f18 f19 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 ?v0) (f10 f11 2)) (f20 (f21 f23 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f12 (f24 f25 ?v0) (f10 f11 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f10 f11 3)) (f17 (f18 f19 (f17 (f18 f19 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 ?v0) (f10 f11 3)) (f20 (f21 f23 (f20 (f21 f23 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f12 (f24 f25 ?v0) (f10 f11 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 ?v1) (ite (= ?v1 (f10 f11 0)) (f10 f11 1) (f10 f11 (* (f12 f13 ?v0) (f12 f13 (f20 ?v_0 (f10 f11 (- (f12 f13 ?v1) 1)))))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f21 f23 ?v0))) (= (f20 (f21 f23 (f20 ?v_0 ?v1)) (f20 (f21 f23 ?v2) ?v3)) (f20 (f21 f23 (f20 ?v_0 ?v2)) (f20 (f21 f23 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 (f18 f19 (f17 ?v_0 ?v1)) (f17 (f18 f19 ?v2) ?v3)) (f17 (f18 f19 (f17 ?v_0 ?v2)) (f17 (f18 f19 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f21 f23 (f20 (f21 f23 ?v0) ?v1))) (?v_0 (f21 f23 ?v2))) (= (f20 ?v_1 (f20 ?v_0 ?v3)) (f20 ?v_0 (f20 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f18 f19 (f17 (f18 f19 ?v0) ?v1))) (?v_0 (f18 f19 ?v2))) (= (f17 ?v_1 (f17 ?v_0 ?v3)) (f17 ?v_0 (f17 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f21 f23 ?v0)) (?v_1 (f20 (f21 f23 ?v2) ?v3))) (= (f20 (f21 f23 (f20 ?v_0 ?v1)) ?v_1) (f20 ?v_0 (f20 (f21 f23 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f18 f19 ?v0)) (?v_1 (f17 (f18 f19 ?v2) ?v3))) (= (f17 (f18 f19 (f17 ?v_0 ?v1)) ?v_1) (f17 ?v_0 (f17 (f18 f19 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f23 ?v0))) (= (f20 (f21 f23 (f20 ?v_0 ?v1)) ?v2) (f20 (f21 f23 (f20 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 (f18 f19 (f17 ?v_0 ?v1)) ?v2) (f17 (f18 f19 (f17 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f23 ?v0))) (= (f20 (f21 f23 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f21 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 (f18 f19 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f18 f19 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f23 ?v0))) (= (f20 ?v_0 (f20 (f21 f23 ?v1) ?v2)) (f20 (f21 f23 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 ?v_0 (f17 (f18 f19 ?v1) ?v2)) (f17 (f18 f19 (f17 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f21 f23 ?v0)) (?v_0 (f21 f23 ?v1))) (= (f20 ?v_1 (f20 ?v_0 ?v2)) (f20 ?v_0 (f20 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f18 f19 ?v0)) (?v_0 (f18 f19 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 (f21 f23 ?v0) ?v1) (f20 (f21 f23 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f17 (f18 f19 ?v0) ?v1) (f17 (f18 f19 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2))) (= (f12 (f24 f25 (f3 f26 ?v0)) ?v_0) (f12 (f24 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f12 (f24 f25 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f12 (f24 f25 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 (f24 f25 ?v0) (f10 f11 2)))) (= (f3 f26 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f3 f26 (f12 (f24 f25 ?v0) ?v1)) (f12 (f24 f25 (f3 f26 ?v0)) ?v1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 ?v0))) (= (f10 f11 (* 2 ?v_0)) (f10 f11 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 ?v0))) (= (f10 f11 (* ?v_0 2)) (f10 f11 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f10 f11 0)) (?v_2 (f12 f13 ?v0)) (?v_1 (f12 f13 ?v1))) (= (f10 f11 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f10 f11 (+ ?v_1 (* (f12 f13 (f10 f11 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f17 (f18 f19 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f10 f11 (+ (f12 f13 ?v1) (f12 f13 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f23 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) (f20 ?v_0 (f10 f11 (+ (f12 f13 ?v1) (f12 f13 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (* (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (f12 ?v_0 (f10 f11 (+ (f12 f13 ?v1) (f12 f13 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (= (f6 (f7 f8 (f17 (f18 f19 ?v0) ?v1)) ?v2) (f17 (f18 f19 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f22 (f20 (f21 f23 ?v0) ?v1)) ?v2) (f20 (f21 f23 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f12 (f24 f25 (* ?v0 ?v1)) ?v2) (* (f12 (f24 f25 ?v0) ?v2) (f12 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (= (f6 (f7 f8 (f17 (f18 f19 ?v0) ?v1)) ?v2) (f17 (f18 f19 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f22 (f20 (f21 f23 ?v0) ?v1)) ?v2) (f20 (f21 f23 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f12 (f24 f25 (* ?v0 ?v1)) ?v2) (* (f12 (f24 f25 ?v0) ?v2) (f12 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (= (f17 (f18 f19 ?v_0) ?v0) (f17 (f18 f19 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f20 (f21 f22 ?v0) ?v1))) (= (f20 (f21 f23 ?v_0) ?v0) (f20 (f21 f23 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f12 (f24 f25 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f17 (f18 f19 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f23 (f20 ?v_0 ?v1)) ?v0) (f20 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (* (f12 ?v_0 ?v1) ?v0) (f12 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f12 f13 ?v1) (f12 f13 ?v2)))) (f17 (f18 f19 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (+ (f12 f13 ?v1) (f12 f13 ?v2)))) (f20 (f21 f23 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 ?v_0 (f10 f11 (+ (f12 f13 ?v1) (f12 f13 ?v2)))) (* (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f17 (f18 f19 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f23 ?v0) (f20 ?v_0 ?v1)) (f20 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (* ?v0 (f12 ?v_0 ?v1)) (f12 ?v_0 (f10 f11 (+ (f12 f13 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S6)) (let ((?v_0 (f12 f13 ?v1)) (?v_1 (f12 f13 ?v0)) (?v_2 (f7 f8 ?v2))) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (f17 (f18 f19 (f6 ?v_2 (f10 f11 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f12 f13 ?v1)) (?v_1 (f12 f13 ?v0)) (?v_2 (f21 f22 ?v2))) (=> (<= ?v_1 ?v_0) (= (f20 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (f20 (f21 f23 (f20 ?v_2 (f10 f11 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f12 f13 ?v1)) (?v_1 (f12 f13 ?v0)) (?v_2 (f24 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f12 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (* (f12 ?v_2 (f10 f11 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S6)) (let ((?v_0 (f12 f13 ?v0)) (?v_1 (f7 f8 ?v1))) (=> (< 0 ?v_0) (= (f17 (f18 f19 (f6 ?v_1 (f10 f11 (- ?v_0 1)))) ?v1) (f6 ?v_1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f12 f13 ?v0)) (?v_1 (f21 f22 ?v1))) (=> (< 0 ?v_0) (= (f20 (f21 f23 (f20 ?v_1 (f10 f11 (- ?v_0 1)))) ?v1) (f20 ?v_1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 Int)) (let ((?v_0 (f12 f13 ?v0)) (?v_1 (f24 f25 ?v1))) (=> (< 0 ?v_0) (= (* (f12 ?v_1 (f10 f11 (- ?v_0 1))) ?v1) (f12 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 (f24 f25 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f10 f11 (* (f12 f13 ?v1) (f12 f13 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_2 (f12 f13 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f12 f13 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1)) (?v_1 (f12 f13 ?v0)) (?v_2 (f12 f13 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1)) (?v_1 (f12 f13 ?v0)) (?v_2 (f12 f13 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 (f10 f11 (* (f12 f13 ?v0) (f12 f13 ?v1)))) (or (= ?v1 (f10 f11 1)) (= ?v0 (f10 f11 0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_2 (f12 f13 ?v1)) (?v_0 (f12 f13 ?v0)) (?v_3 (f12 f13 ?v3)) (?v_1 (f12 f13 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_2 (f12 f13 ?v1)) (?v_1 (f12 f13 ?v0)) (?v_0 (f12 f13 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_2 (f12 f13 ?v1)) (?v_0 (f12 f13 ?v0)) (?v_1 (f12 f13 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (let ((?v_0 (f12 f13 ?v1)) (?v_1 (f12 f13 ?v0)) (?v_2 (f12 f13 ?v2)) (?v_4 (f12 f13 ?v4)) (?v_3 (f12 f13 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= (+ (* (f12 f13 (f10 f11 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f12 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f12 f13 (f20 (f21 f22 ?v0) ?v1)) (f12 (f24 f25 (f12 f13 ?v0)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f12 f13 (f20 (f21 f22 ?v0) ?v1))) (or (< 0 (f12 f13 ?v0)) (= ?v1 (f10 f11 0))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f12 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f10 f11 0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f24 f25 ?v0))) (= (f12 ?v_0 (f10 f11 (+ (f12 f13 ?v1) (f12 f13 ?v2)))) (* (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f10 f11 (+ 0 1)))) (= (f20 (f21 f22 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f12 (f24 f25 (f12 f13 ?v0)) ?v1) (f12 f13 (f20 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f10 f11 (+ 0 1)))) (= (= (f20 (f21 f22 ?v0) ?v1) ?v_0) (or (= ?v1 (f10 f11 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f10 f11 (f12 (f24 f25 ?v0) ?v1)) (f20 (f21 f22 (f10 f11 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 0 (f12 f13 ?v0)) (=> (< (f12 f13 (f20 ?v_0 ?v1)) (f12 f13 (f20 ?v_0 ?v2))) (< (f12 f13 ?v1) (f12 f13 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f12 f13 ?v0)) (<= ?v_0 (f12 f13 (f20 (f21 f22 ?v0) ?v1)))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f10 f11 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f10 f11 (* (f12 f13 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0))) (f12 f13 (f10 f11 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5)) (= (f10 f11 (f12 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f13 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
