(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S3)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S6) S3)
(declare-fun f7 (S7 S3) S5)
(declare-fun f8 () S7)
(declare-fun f9 () S3)
(declare-fun f10 (S8 Int) S6)
(declare-fun f11 () S8)
(declare-fun f12 (S9 S6) Int)
(declare-fun f13 () S9)
(declare-fun f14 () S6)
(declare-fun f15 () S6)
(declare-fun f16 () S6)
(declare-fun f17 () S3)
(declare-fun f18 (S10 Int) S9)
(declare-fun f19 () S10)
(declare-fun f20 () S4)
(declare-fun f21 (S11 S6) S6)
(declare-fun f22 (S12 S6) S11)
(declare-fun f23 () S12)
(declare-fun f24 () S12)
(declare-fun f25 (S13 Int) Int)
(declare-fun f26 () S13)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 f9)) (?v_1 (f12 f13 f14))) (not (= (f3 (f4 f5 (f6 ?v_0 (f10 f11 (* ?v_1 (f12 f13 f15))))) (f6 ?v_0 (f10 f11 (* (f12 f13 f16) ?v_1)))) (f6 (f7 f8 (f3 (f4 f5 (f6 ?v_0 f15)) (f6 ?v_0 f16))) f14)))))
(assert (not (= f9 f17)))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f12 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (* ?v0 (f12 (f18 f19 (f12 ?v_0 ?v1)) (f10 f11 2)))))))
(assert (forall ((?v0 S3) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (f3 (f4 f20 ?v0) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f10 f11 2)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (f21 (f22 f24 ?v0) (f21 (f22 f23 (f21 ?v_0 ?v1)) (f10 f11 2)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f18 f19 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (f3 (f4 f20 ?v0) (f3 (f4 f20 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f21 ?v_0 ?v1))) (= (f21 ?v_0 (f10 f11 (+ (* 2 (f12 f13 ?v1)) 1))) (f21 (f22 f24 ?v0) (f21 (f22 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f18 f19 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f10 f11 (* 2 (f12 f13 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f10 f11 (* 2 (f12 f13 ?v1)))) (f3 (f4 f20 ?v_1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f21 ?v_0 ?v1))) (= (f21 ?v_0 (f10 f11 (* 2 (f12 f13 ?v1)))) (f21 (f22 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S6)) (=> (not (= ?v0 f17)) (= (f6 (f7 f8 (f3 (f4 f5 ?v1) ?v0)) ?v2) (f3 (f4 f5 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S6) (?v2 S6)) (let ((?v_0 (f12 f13 ?v2)) (?v_1 (f12 f13 ?v1)) (?v_2 (f7 f8 ?v0))) (=> (not (= ?v0 f17)) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f10 f11 (- ?v_0 ?v_1))) (f3 (f4 f5 (f6 ?v_2 ?v2)) (f6 ?v_2 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f17)) (= (= ?v1 (f3 (f4 f5 ?v2) ?v0)) (= (f3 (f4 f20 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f17)) (= (= (f3 (f4 f5 ?v1) ?v0) ?v2) (= ?v1 (f3 (f4 f20 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f17)) (=> (not (= ?v1 f17)) (= (= (f3 (f4 f5 ?v2) ?v0) (f3 (f4 f5 ?v3) ?v1)) (= (f3 (f4 f20 ?v2) ?v1) (f3 (f4 f20 ?v3) ?v0)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 ?v1) (ite (= ?v1 (f10 f11 0)) (f10 f11 1) (f10 f11 (* (f12 f13 ?v0) (f12 f13 (f21 ?v_0 (f10 f11 (- (f12 f13 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 (f4 f20 (f3 ?v_0 ?v1)) (f3 (f4 f20 ?v2) ?v3)) (f3 (f4 f20 (f3 ?v_0 ?v2)) (f3 (f4 f20 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f22 f24 ?v0))) (= (f21 (f22 f24 (f21 ?v_0 ?v1)) (f21 (f22 f24 ?v2) ?v3)) (f21 (f22 f24 (f21 ?v_0 ?v2)) (f21 (f22 f24 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f4 f20 (f3 (f4 f20 ?v0) ?v1))) (?v_0 (f4 f20 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f22 f24 (f21 (f22 f24 ?v0) ?v1))) (?v_0 (f22 f24 ?v2))) (= (f21 ?v_1 (f21 ?v_0 ?v3)) (f21 ?v_0 (f21 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f20 ?v0)) (?v_1 (f3 (f4 f20 ?v2) ?v3))) (= (f3 (f4 f20 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f20 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f22 f24 ?v0)) (?v_1 (f21 (f22 f24 ?v2) ?v3))) (= (f21 (f22 f24 (f21 ?v_0 ?v1)) ?v_1) (f21 ?v_0 (f21 (f22 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 (f4 f20 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f20 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f22 f24 ?v0))) (= (f21 (f22 f24 (f21 ?v_0 ?v1)) ?v2) (f21 (f22 f24 (f21 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 (f4 f20 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f20 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f22 f24 ?v0))) (= (f21 (f22 f24 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f22 f24 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f25 f26 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 (f3 (f4 f20 ?v1) ?v2)) (f3 (f4 f20 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f22 f24 ?v0))) (= (f21 ?v_0 (f21 (f22 f24 ?v1) ?v2)) (f21 (f22 f24 (f21 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f20 ?v0)) (?v_0 (f4 f20 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f22 f24 ?v0)) (?v_0 (f22 f24 ?v1))) (= (f21 ?v_1 (f21 ?v_0 ?v2)) (f21 ?v_0 (f21 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f20 ?v0) ?v1) (f3 (f4 f20 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f21 (f22 f24 ?v0) ?v1) (f21 (f22 f24 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f25 f26 (* ?v0 ?v1)) (* (f25 f26 ?v0) (f25 f26 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2))) (= (f12 (f18 f19 (f25 f26 ?v0)) ?v_0) (f12 (f18 f19 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f12 (f18 f19 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f21 (f22 f23 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f12 (f18 f19 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f21 (f22 f23 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 (f18 f19 ?v0) (f10 f11 2)))) (= (f25 f26 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (f25 f26 (f12 (f18 f19 ?v0) ?v1)) (f12 (f18 f19 (f25 f26 ?v0)) ?v1))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f12 f13 ?v0))) (= (f10 f11 (* 2 ?v_0)) (f10 f11 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f12 f13 ?v0))) (= (f10 f11 (* ?v_0 2)) (f10 f11 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f10 f11 0)) (?v_2 (f12 f13 ?v0)) (?v_1 (f12 f13 ?v1))) (= (f10 f11 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f10 f11 (+ ?v_1 (* (f12 f13 (f10 f11 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S6)) (= (f10 f11 (f12 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f13 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
