(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 (S7 S2) S8)
(declare-fun f11 (S9 S7) S7)
(declare-fun f12 (S10 S2) S9)
(declare-fun f13 () S10)
(declare-fun f14 () S2)
(declare-fun f15 () S10)
(declare-fun f16 () S7)
(declare-fun f17 () S2)
(declare-fun f18 (S11 S8) S8)
(declare-fun f19 (S12 S8) S11)
(declare-fun f20 () S12)
(declare-fun f21 () S7)
(declare-fun f22 (S13 Int) Int)
(declare-fun f23 () S13)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))))))
(assert (not (= (f10 (f11 (f12 f13 f14) (f11 (f12 f15 f14) f16)) f17) (f18 (f19 f20 (f10 f21 f14)) (f10 f16 f17)))))
(assert (< (f8 f9 f17) (f8 f9 f14)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f10 f21 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (f18 (f19 f20 (f10 f21 ?v0)) (f10 f21 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= (f8 f9 (f6 f7 ?v_0)) ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f22 f23 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f10 f21 ?v0) (f10 f21 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f8 f9 ?v0) (f8 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 f23 (* ?v0 ?v1)) (* (f22 f23 ?v0) (f22 f23 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f19 f20 ?v0)) (?v_0 (f19 f20 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f8 f9 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f8 f9 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* ?v_1 ?v_0)) (f6 f7 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (+ ?v_1 1))) (f6 f7 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (f8 f9 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1)) (?v_0 (+ 0 1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* (+ ?v_1 1) ?v_0)) (f6 f7 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* (* ?v_0 ?v_1) ?v_2)) (f6 f7 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (+ ?v_0 ?v_2) ?v_1)) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (f8 f9 (f6 f7 (- ?v_0 ?v_2))) ?v_1)) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
