(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 (S7 S2) S8)
(declare-fun f11 (S9 S7) S7)
(declare-fun f12 (S2) S9)
(declare-fun f13 () S4)
(declare-fun f14 () S2)
(declare-fun f15 () S7)
(declare-fun f16 () S2)
(declare-fun f17 (S2) S9)
(declare-fun f18 (S10 Int) Int)
(declare-fun f19 () S10)
(declare-fun f20 (S11 Int) S6)
(declare-fun f21 () S11)
(declare-fun f22 () S3)
(declare-fun f23 () S10)
(declare-fun f24 (S12 S2) S1)
(declare-fun f25 (S13 S2) S12)
(declare-fun f26 () S13)
(declare-fun f27 (S2) S9)
(declare-fun f28 (S2) S9)
(declare-fun f29 () S4)
(declare-fun f30 () S5)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))))))
(assert (not (= (f10 (f11 (f12 (f3 (f4 f13 (f6 f7 2)) f14)) f15) f16) (f10 (f11 (f17 f14) f15) f16))))
(assert (< (f8 f9 f16) (f8 f9 (f3 (f4 f13 (f6 f7 2)) f14))))
(assert (forall ((?v0 S7)) (= (f11 (f17 (f6 f7 0)) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f8 f9 (f3 (f4 f13 ?v0) ?v1))) (or (< 0 (f8 f9 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f8 f9 (f3 (f4 f13 ?v0) ?v1))) (or (= ?v1 (f6 f7 0)) (< 0 (f8 f9 ?v0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f13 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f13 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f13 ?v0))) (=> (< 0 (f8 f9 ?v0)) (=> (< (f8 f9 (f3 ?v_0 ?v1)) (f8 f9 (f3 ?v_0 ?v2))) (< (f8 f9 ?v1) (f8 f9 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f8 f9 ?v0)) (<= ?v_0 (f8 f9 (f3 (f4 f13 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f18 f19 (f8 (f20 f21 ?v0) ?v1)) (f8 (f20 f21 (f18 f19 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 (f20 f21 ?v0) (f6 f7 2)))) (= (f18 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f8 (f20 f21 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f13 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 (f20 f21 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f13 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f20 f21 (f18 f19 ?v0)) ?v_0) (f8 (f20 f21 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 f9 (f3 (f4 f13 ?v0) ?v1)) (f8 (f20 f21 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f22 (f3 (f4 f13 ?v0) ?v1)) (f3 (f4 f13 (f3 f22 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f3 (f4 f13 (f6 f7 ?v0)) ?v1) (f6 f7 (f8 (f20 f21 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f20 f21 ?v0) ?v1)) (f3 (f4 f13 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f20 f21 (f8 f9 ?v0)) ?v1) (f8 f9 (f3 (f4 f13 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f20 f21 (f8 f9 ?v0)) ?v1) (f8 f9 (f3 (f4 f13 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 f9 (f3 (f4 f13 ?v0) ?v1)) (f8 (f20 f21 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f18 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f8 f9 ?v0) (f8 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f22 ?v0) (f3 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f13 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 (f3 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f6 f7 (f18 f23 ?v1)))) (= (< 0 (f8 f9 (f3 (f4 f13 ?v0) ?v_0))) (or (= ?v_0 (f6 f7 0)) (< 0 (f8 f9 ?v0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f13 ?v0))) (=> (= (f24 (f25 f26 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) f1) (=> (< 1 (f8 f9 ?v0)) (<= (f8 f9 ?v1) (f8 f9 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S7)) (let ((?v_0 (f3 (f4 f13 (f6 f7 2)) ?v1))) (=> (< (f8 f9 ?v0) (f8 f9 ?v_0)) (= (f10 (f11 (f27 ?v_0) ?v2) ?v0) (f10 (f11 (f28 ?v1) ?v2) ?v0))))))
(assert (forall ((?v0 S2)) (= (f24 (f25 f26 (f6 f7 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f24 (f25 f26 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f8 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= (f8 f9 (f6 f7 ?v_0)) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f22 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (f3 (f4 f29 (f3 f22 ?v0)) (f3 f22 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f8 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f29 ?v0) ?v1) (f3 (f4 f29 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (* (f8 f9 (f6 f7 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f29 ?v0)) (?v_0 (f4 f29 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f29 ?v0))) (= (f3 ?v_0 (f3 (f4 f29 ?v1) ?v2)) (f3 (f4 f29 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (* (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 (f20 f21 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f29 ?v0))) (= (f3 (f4 f29 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f29 ?v0))) (= (f3 (f4 f29 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f29 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f29 ?v0)) (?v_1 (f3 (f4 f29 ?v2) ?v3))) (= (f3 (f4 f29 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f29 (f3 (f4 f29 ?v0) ?v1))) (?v_0 (f4 f29 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f29 ?v0))) (= (f3 (f4 f29 (f3 ?v_0 ?v1)) (f3 (f4 f29 ?v2) ?v3)) (f3 (f4 f29 (f3 ?v_0 ?v2)) (f3 (f4 f29 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f8 (f20 f21 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 (f6 f30 ?v0)))) (=> (< 0 ?v_0) (= (f6 f7 (f18 f23 ?v0)) (f6 f7 (+ (f8 f9 (f6 f7 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f24 (f25 f26 (f6 f7 (* ?v_0 (f8 f9 ?v1)))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) f1) (=> (< 0 ?v_0) (= (f24 (f25 f26 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f24 (f25 f26 ?v0) ?v1) f1)) (?v_0 (= (f24 (f25 f26 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f25 f26 ?v0)) (?v_0 (f25 f26 ?v1)) (?v_2 (f25 f26 ?v2))) (=> (and (= (f24 ?v_1 ?v1) f1) (not (= (f24 ?v_0 ?v0) f1))) (=> (and (= (f24 ?v_0 ?v2) f1) (not (= (f24 ?v_2 ?v1) f1))) (and (= (f24 ?v_1 ?v2) f1) (not (= (f24 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f24 (f25 f26 ?v0) ?v1) f1)) (?v_0 (= (f24 (f25 f26 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f25 f26 ?v0)) (?v_0 (f25 f26 ?v1))) (=> (and (= (f24 ?v_1 ?v1) f1) (not (= (f24 ?v_0 ?v0) f1))) (=> (= (f24 ?v_0 ?v2) f1) (and (= (f24 ?v_1 ?v2) f1) (not (= (f24 (f25 f26 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (=> (and (= (f24 ?v_0 ?v1) f1) (not (= (f24 (f25 f26 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f24 ?v_0 ?v2) f1) (not (= (f24 (f25 f26 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S1)) (let ((?v_1 (= (f24 (f25 f26 ?v0) ?v1) f1)) (?v_0 (= (f24 (f25 f26 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f24 (f25 f26 ?v0) ?v1) f1) (not (= (f24 (f25 f26 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f24 (f25 f26 ?v0) ?v1) f1) (not (= (f24 (f25 f26 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f24 (f25 f26 ?v0) ?v1) f1)) (?v_0 (= (f24 (f25 f26 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f24 (f25 f26 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f24 (f25 f26 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (= (f24 (f25 f26 ?v0) ?v1) f1)) (?v_0 (= (f24 (f25 f26 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (= (f24 (f25 f26 ?v0) ?v1) f1) (not (= (f24 (f25 f26 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f8 f9 ?v2)) (?v_2 (f8 f9 ?v1))) (=> (= (f24 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f24 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f24 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f8 f9 ?v2)) (?v_2 (f8 f9 ?v1))) (=> (= (f24 ?v_0 (f6 f7 (- ?v_2 ?v_1))) f1) (=> (= (f24 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f24 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f25 f26 ?v2))) (=> (= (f24 ?v_0 ?v1) f1) (=> (and (= (f24 (f25 f26 ?v1) ?v2) f1) (not (= (f24 ?v_1 ?v1) f1))) (and (= (f24 ?v_0 ?v2) f1) (not (= (f24 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f24 (f25 f26 ?v1) ?v2) f1) (not (= (f24 ?v_0 ?v1) f1))) (and (= (f24 (f25 f26 ?v0) ?v2) f1) (not (= (f24 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_3 (f8 f9 ?v3)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f24 ?v_0 ?v1) f1) (=> (= (f24 ?v_0 ?v2) f1) (= (f24 ?v_0 (f6 f7 (- (f8 f9 ?v1) (f8 f9 ?v2)))) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f24 ?v_0 ?v1) f1) (=> (= (f24 (f25 f26 ?v1) ?v2) f1) (= (f24 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (=> (= (f24 (f25 f26 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (=> (= (f24 (f25 f26 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f24 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f24 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f24 (f25 f26 ?v1) ?v2) f1) (= (f24 (f25 f26 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v1))) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f8 f9 ?v0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f24 (f25 f26 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f24 (f25 f26 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f24 (f25 f26 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f24 (f25 f26 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (= (= (f24 (f25 f26 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 ?v1) (= (f24 (f25 f26 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 (- ?v0))) (f8 f9 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f8 f9 ?v1)) (not (= (f24 (f25 f26 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (* (f8 f9 (f6 f7 ?v0)) (f8 f9 (f6 f7 ?v1)))) (f6 f7 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (= (= (f24 (f25 f26 (f6 f7 (* (f8 f9 ?v1) ?v_0))) ?v0) f1) (= ?v1 (f6 f7 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (= (= (f24 (f25 f26 (f6 f7 (* ?v_0 (f8 f9 ?v1)))) ?v0) f1) (= ?v1 (f6 f7 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 ?v0)) (f8 f9 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f24 (f25 f26 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f24 (f25 f26 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1))) (= (= (f6 f7 (* (f8 f9 ?v0) ?v_0)) (f6 f7 (* (f8 f9 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (and (= (f24 (f25 f26 ?v0) ?v1) f1) (not (= (f24 (f25 f26 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f24 (f25 f26 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f24 (f25 f26 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (f8 f9 (f6 f7 (- ?v_0 ?v_2))) ?v_1)) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (+ ?v_0 ?v_2) ?v_1)) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* (* ?v_0 ?v_1) ?v_2)) (f6 f7 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (f18 f23 ?v0) (* (f18 f23 ?v1) ?v2)) (* (f18 f23 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 f23 ?v0) (f18 f23 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f18 f23 ?v0) (f18 f23 ?v1)) (f18 f23 (* ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* (+ ?v_1 1) ?v_0)) (f6 f7 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f6 f30 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f23 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (f8 f9 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (= (f24 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v0)))) f1) (= (f24 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (+ ?v_1 1))) (f6 f7 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f24 (f25 f26 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f24 (f25 f26 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f24 (f25 f26 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 ?v1) (and (= (f24 (f25 f26 ?v0) ?v1) f1) (= (f24 (f25 f26 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* ?v_1 ?v_0)) (f6 f7 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f24 (f25 f26 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
