(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S3) S3)
(declare-fun f7 (S6 S3) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S5)
(declare-fun f10 () S3)
(declare-fun f11 (S7 S8) S3)
(declare-fun f12 () S7)
(declare-fun f13 () S8)
(declare-fun f14 (S9 S8) S8)
(declare-fun f15 (S10 S8) S9)
(declare-fun f16 () S10)
(declare-fun f17 () S8)
(declare-fun f18 () S8)
(declare-fun f19 () S6)
(declare-fun f20 () S8)
(declare-fun f21 () S11)
(declare-fun f22 () S11)
(declare-fun f23 () S5)
(declare-fun f24 () S10)
(declare-fun f25 () S6)
(declare-fun f26 (S12 S11) S11)
(declare-fun f27 (S13 S11) S12)
(declare-fun f28 () S13)
(declare-fun f29 () S13)
(declare-fun f30 () S11)
(declare-fun f31 () S10)
(declare-fun f32 () S3)
(declare-fun f33 (S14 Int) Int)
(declare-fun f34 (S15 Int) S14)
(declare-fun f35 () S15)
(declare-fun f36 () S6)
(declare-fun f37 () S15)
(declare-fun f38 () S6)
(declare-fun f39 () S14)
(declare-fun f40 (S16 S8) S12)
(declare-fun f41 () S16)
(declare-fun f42 (S17 S11) S9)
(declare-fun f43 () S17)
(declare-fun f44 (S19 S18) S5)
(declare-fun f45 () S19)
(declare-fun f46 (S20 S18) S18)
(declare-fun f47 (S21 S3) S20)
(declare-fun f48 () S21)
(declare-fun f49 () S4)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f6 (f7 f8 (f6 f9 f10)) (f11 f12 f13))) (f11 f12 (f14 (f15 f16 f17) f18))) f1)))
(assert (= (f3 (f4 f5 (f6 (f7 f19 (f6 (f7 f8 (f6 f9 f10)) (f11 f12 f13))) (f11 f12 f18))) (f11 f12 f17)) f1))
(assert (not (= f18 f20)))
(assert (not (= f18 f20)))
(assert (= (f3 (f4 f5 (f6 (f7 f19 (f6 (f7 f8 (f6 f9 f10)) (f11 f12 f13))) (f11 f12 f18))) (f11 f12 f17)) f1))
(assert (not (= f21 f22)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f8 ?v0) ?v1))) (f6 (f7 f8 (f6 f23 ?v0)) (f6 f23 ?v1))) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f24 ?v0) ?v1))) (f6 (f7 f8 (f11 f12 ?v0)) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f16 ?v0) ?v1))) (f6 (f7 f25 (f11 f12 ?v0)) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f25 ?v0) ?v1))) (f6 (f7 f25 (f6 f23 ?v0)) (f6 f23 ?v1))) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f11 f12 (f14 (f15 f16 ?v0) ?v1)) (f6 (f7 f25 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f23 (f6 (f7 f25 ?v0) ?v1)) (f6 (f7 f25 (f6 f23 ?v0)) (f6 f23 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f14 (f15 f24 ?v1) ?v2)) (f14 (f15 f24 (f14 ?v_0 ?v1)) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (+ ?v1 ?v2)) (+ (* ?v0 ?v1) (* ?v0 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f29 ?v1) ?v2)) (f26 (f27 f29 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f14 (f15 f24 ?v1) ?v2)) (f14 (f15 f24 (f14 ?v_0 ?v1)) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f14 (f15 f24 ?v1) ?v2)) (f14 (f15 f24 (f14 ?v_0 ?v1)) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (* ?v0 ?v2) (* ?v1 ?v3)) (+ (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11) (?v3 S11)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f27 f28 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f26 (f27 f29 (f26 ?v_0 ?v2)) (f26 ?v_1 ?v3)) (f26 (f27 f29 (f26 ?v_0 ?v3)) (f26 ?v_1 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f7 f25 ?v0)) (?v_1 (f7 f25 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f6 (f7 f8 (f6 ?v_0 ?v2)) (f6 ?v_1 ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v3)) (f6 ?v_1 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f15 f16 ?v0)) (?v_1 (f15 f16 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f14 (f15 f24 (f14 ?v_0 ?v2)) (f14 ?v_1 ?v3)) (f14 (f15 f24 (f14 ?v_0 ?v3)) (f14 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (= (f26 (f27 f28 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f25 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f14 (f15 f16 (f14 (f15 f24 ?v0) ?v1)) ?v2) (f14 (f15 f24 (f14 (f15 f16 ?v0) ?v2)) (f14 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (= (f26 (f27 f28 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f25 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f14 (f15 f16 (f14 (f15 f24 ?v0) ?v1)) ?v2) (f14 (f15 f24 (f14 (f15 f16 ?v0) ?v2)) (f14 (f15 f16 ?v1) ?v2)))))
(assert (not (not (= f30 f22))))
(assert (forall ((?v0 S8)) (= (f14 (f15 f31 f20) ?v0) f20)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f19 f32) ?v0) f32)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f31 f20) ?v0) f20)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f19 f32) ?v0) f32)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f31 ?v0) f20) f20)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f19 ?v0) f32) f32)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 (f7 f25 ?v0) ?v1) (f6 (f7 f25 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 (f7 f25 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S8)) (= (= (f11 f12 ?v0) f32) (= ?v0 f20))))
(assert (forall ((?v0 S3)) (= (= (f6 f23 ?v0) f32) (= ?v0 f32))))
(assert (= (f11 f12 f20) f32))
(assert (= (f6 f23 f32) f32))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f25 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f20)) (= (f11 f12 (f14 (f15 f31 ?v1) ?v0)) (f6 (f7 f19 (f11 f12 ?v1)) (f11 f12 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f32)) (= (f6 f23 (f6 (f7 f19 ?v1) ?v0)) (f6 (f7 f19 (f6 f23 ?v1)) (f6 f23 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f20)) (=> (= (f14 (f15 f16 ?v1) ?v0) ?v2) (= ?v1 (f14 (f15 f31 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (=> (= (f6 (f7 f25 ?v1) ?v0) ?v2) (= ?v1 (f6 (f7 f19 ?v2) ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f20)) (=> (= ?v1 (f14 (f15 f16 ?v2) ?v0)) (= (f14 (f15 f31 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (=> (= ?v1 (f6 (f7 f25 ?v2) ?v0)) (= (f6 (f7 f19 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f20)) (= (= (f14 (f15 f31 ?v1) ?v0) ?v2) (= ?v1 (f14 (f15 f16 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (= (= (f6 (f7 f19 ?v1) ?v0) ?v2) (= ?v1 (f6 (f7 f25 ?v2) ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f20)) (= (= ?v1 (f14 (f15 f31 ?v2) ?v0)) (= (f14 (f15 f16 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (= (= ?v1 (f6 (f7 f19 ?v2) ?v0)) (= (f6 (f7 f25 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f23 (f6 (f7 f19 ?v0) ?v1)) (f6 (f7 f19 (f6 f23 ?v0)) (f6 f23 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f11 f12 (f14 (f15 f31 ?v0) ?v1)) (f6 (f7 f19 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 S8)) (= (= (f3 (f4 f5 (f11 f12 ?v0)) f32) f1) (= ?v0 f20))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f6 f23 ?v0)) f32) f1) (= ?v0 f32))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f14 (f15 f31 ?v1) ?v2)) (f14 (f15 f31 (f14 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f6 (f7 f19 ?v1) ?v2)) (f6 (f7 f19 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f19 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f19 ?v0) ?v2)) (f6 (f7 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f14 (f15 f31 (f14 (f15 f24 ?v0) ?v1)) ?v2) (f14 (f15 f24 (f14 (f15 f31 ?v0) ?v2)) (f14 (f15 f31 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f19 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f19 ?v0) ?v2)) (f6 (f7 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f14 (f15 f31 (f14 (f15 f24 ?v0) ?v1)) ?v2) (f14 (f15 f24 (f14 (f15 f31 ?v0) ?v2)) (f14 (f15 f31 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f14 (f15 f16 ?v0) ?v1) f20) (or (= ?v0 f20) (= ?v1 f20)))))
(assert (forall ((?v0 S11) (?v1 S11)) (=> (= (f26 (f27 f28 ?v0) ?v1) f22) (or (= ?v0 f22) (= ?v1 f22)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f6 (f7 f25 ?v0) ?v1) f32) (or (= ?v0 f32) (= ?v1 f32)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f20)) (=> (not (= ?v1 f20)) (not (= (f14 (f15 f16 ?v0) ?v1) f20))))))
(assert (forall ((?v0 S11) (?v1 S11)) (=> (not (= ?v0 f22)) (=> (not (= ?v1 f22)) (not (= (f26 (f27 f28 ?v0) ?v1) f22))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f32)) (=> (not (= ?v1 f32)) (not (= (f6 (f7 f25 ?v0) ?v1) f32))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f14 (f15 f16 ?v0) ?v1) f20) (or (= ?v0 f20) (= ?v1 f20)))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (= (f26 (f27 f28 ?v0) ?v1) f22) (or (= ?v0 f22) (= ?v1 f22)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 (f7 f25 ?v0) ?v1) f32) (or (= ?v0 f32) (= ?v1 f32)))))
(assert (forall ((?v0 S8)) (= (f14 (f15 f16 ?v0) f20) f20)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f25 ?v0) f32) f32)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f16 ?v0) f20) f20)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f25 ?v0) f32) f32)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f16 ?v0) f20) f20)))
(assert (forall ((?v0 S11)) (= (f26 (f27 f28 ?v0) f22) f22)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f25 ?v0) f32) f32)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f16 ?v0) f20) f20)))
(assert (forall ((?v0 S11)) (= (f26 (f27 f28 ?v0) f22) f22)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f25 ?v0) f32) f32)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f16 f20) ?v0) f20)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f25 f32) ?v0) f32)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f16 f20) ?v0) f20)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f25 f32) ?v0) f32)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f16 f20) ?v0) f20)))
(assert (forall ((?v0 S11)) (= (f26 (f27 f28 f22) ?v0) f22)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f25 f32) ?v0) f32)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f16 f20) ?v0) f20)))
(assert (forall ((?v0 S11)) (= (f26 (f27 f28 f22) ?v0) f22)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f25 f32) ?v0) f32)))
(assert (forall ((?v0 S11) (?v1 S11)) (= (= ?v0 (f26 (f27 f29 ?v0) ?v1)) (= ?v1 f22))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 (f6 (f7 f8 ?v0) ?v1)) (= ?v1 f32))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= ?v0 (f14 (f15 f24 ?v0) ?v1)) (= ?v1 f20))))
(assert (forall ((?v0 S11)) (= (f26 (f27 f29 ?v0) f22) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) f32) ?v0)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f24 ?v0) f20) ?v0)))
(assert (forall ((?v0 S11)) (= (f26 (f27 f29 f22) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f32) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f14 (f15 f24 f20) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f33 (f34 f35 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f6 (f7 f36 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f33 (f34 f37 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f38 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f3 (f4 f5 (f11 f12 ?v0)) (f6 (f7 f8 (f11 f12 (f14 (f15 f24 ?v0) ?v1))) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11) (?v3 S11)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) (f26 (f27 f28 ?v2) ?v3)) (f26 (f27 f28 (f26 ?v_0 ?v2)) (f26 (f27 f28 ?v1) ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 (f15 f16 (f14 ?v_0 ?v1)) (f14 (f15 f16 ?v2) ?v3)) (f14 (f15 f16 (f14 ?v_0 ?v2)) (f14 (f15 f16 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 (f7 f25 (f6 ?v_0 ?v1)) (f6 (f7 f25 ?v2) ?v3)) (f6 (f7 f25 (f6 ?v_0 ?v2)) (f6 (f7 f25 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11) (?v3 S11)) (let ((?v_1 (f27 f28 (f26 (f27 f28 ?v0) ?v1))) (?v_0 (f27 f28 ?v2))) (= (f26 ?v_1 (f26 ?v_0 ?v3)) (f26 ?v_0 (f26 ?v_1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_1 (f15 f16 (f14 (f15 f16 ?v0) ?v1))) (?v_0 (f15 f16 ?v2))) (= (f14 ?v_1 (f14 ?v_0 ?v3)) (f14 ?v_0 (f14 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f7 f25 (f6 (f7 f25 ?v0) ?v1))) (?v_0 (f7 f25 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11) (?v3 S11)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f26 (f27 f28 ?v2) ?v3))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v_1) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f15 f16 ?v0)) (?v_1 (f14 (f15 f16 ?v2) ?v3))) (= (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v_1) (f14 ?v_0 (f14 (f15 f16 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f7 f25 ?v0)) (?v_1 (f6 (f7 f25 ?v2) ?v3))) (= (f6 (f7 f25 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f28 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v2) (f14 (f15 f16 (f14 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 (f7 f25 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f25 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f14 (f15 f16 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 (f7 f25 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f33 f39 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f9 ?v0))) (= (f6 (f7 f25 ?v_0) ?v_0) (f6 (f7 f25 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2)) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f14 (f15 f16 ?v1) ?v2)) (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f6 (f7 f25 ?v1) ?v2)) (f6 (f7 f25 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_1 (f27 f28 ?v0)) (?v_0 (f27 f28 ?v1))) (= (f26 ?v_1 (f26 ?v_0 ?v2)) (f26 ?v_0 (f26 ?v_1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f15 f16 ?v0)) (?v_0 (f15 f16 ?v1))) (= (f14 ?v_1 (f14 ?v_0 ?v2)) (f14 ?v_0 (f14 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f7 f25 ?v0)) (?v_0 (f7 f25 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f14 (f15 f16 ?v0) ?v1) (f14 (f15 f16 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 (f7 f25 ?v0) ?v1) (f6 (f7 f25 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f33 f39 (* ?v0 ?v1)) (* (f33 f39 ?v0) (f33 f39 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f9 (f6 (f7 f25 ?v0) ?v1)) (f6 (f7 f25 (f6 f9 ?v0)) (f6 f9 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11) (?v3 S11)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) (f26 (f27 f29 ?v2) ?v3)) (f26 (f27 f29 (f26 ?v_0 ?v2)) (f26 (f27 f29 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 (f7 f8 ?v2) ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v2)) (f6 (f7 f8 ?v1) ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f15 f24 ?v0))) (= (f14 (f15 f24 (f14 ?v_0 ?v1)) (f14 (f15 f24 ?v2) ?v3)) (f14 (f15 f24 (f14 ?v_0 ?v2)) (f14 (f15 f24 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f29 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f8 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f24 ?v0))) (= (f14 (f15 f24 (f14 ?v_0 ?v1)) ?v2) (f14 (f15 f24 (f14 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f24 ?v0))) (= (f14 (f15 f24 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f14 (f15 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f27 f29 ?v0))) (= (f26 ?v_0 (f26 (f27 f29 ?v1) ?v2)) (f26 (f27 f29 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f24 ?v0))) (= (f14 ?v_0 (f14 (f15 f24 ?v1) ?v2)) (f14 (f15 f24 (f14 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f15 f24 ?v0)) (?v_0 (f15 f24 ?v1))) (= (f14 ?v_1 (f14 ?v_0 ?v2)) (f14 ?v_0 (f14 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f14 (f15 f24 ?v0) ?v1) (f14 (f15 f24 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f9 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f32))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f32) f1)) (and (= (f3 (f4 f5 ?v0) f32) f1) (= (f3 ?v_0 ?v1) f1))) (= (f3 (f4 f5 (f6 (f7 f25 ?v0) ?v1)) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f32))) (=> (and (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v0) f32) f1)) (or (= (f3 ?v_0 ?v1) f1) (= (f3 (f4 f5 ?v1) f32) f1))) (= (f6 f9 (f6 (f7 f25 ?v0) ?v1)) (f6 (f7 f25 (f6 f9 ?v0)) (f6 f9 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f33 f39 (* ?v0 ?v1)) (* (f33 f39 ?v0) (f33 f39 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f32))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f32) f1) (= (f3 (f4 f5 ?v1) f32) f1))) (= (f3 ?v_0 (f6 (f7 f25 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f5 f32))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f5 f32))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f32) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f32) f1) (= (f3 (f4 f5 (f6 (f7 f25 ?v1) ?v2)) (f6 (f7 f25 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f32) ?v2) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f32) ?v2) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f32) ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f32) f1) (=> (= (f3 (f4 f5 ?v1) f32) f1) (= (f3 (f4 f5 f32) (f6 (f7 f25 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f32) f1) (=> (= (f3 (f4 f5 f32) ?v1) f1) (= (f3 (f4 f5 (f6 (f7 f25 ?v0) ?v1)) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f32) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f32) f1) (= (f3 (f4 f5 (f6 (f7 f25 ?v1) ?v0)) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f32) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f32) f1) (= (f3 (f4 f5 (f6 (f7 f25 ?v0) ?v1)) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f32))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f25 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f32) ?v0) f1) (= (f6 (f7 f25 (f6 f9 ?v1)) ?v0) (f6 f9 (f6 (f7 f25 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f33 f39 ?v1) ?v0) (f33 f39 (* ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f32))) (= (= (f3 (f4 f5 (f6 (f7 f25 ?v0) ?v1)) f32) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f32) f1)) (and (= (f3 (f4 f5 ?v0) f32) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f32))) (= (= (f3 ?v_0 (f6 (f7 f25 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f32) f1) (= (f3 (f4 f5 ?v1) f32) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f32) (f6 (f7 f25 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8) (?v4 S8)) (let ((?v_0 (f15 f16 ?v0))) (=> (not (= ?v0 f20)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f14 (f15 f24 ?v1) (f14 ?v_0 ?v3)) (f14 (f15 f24 ?v2) (f14 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3) (?v4 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (not (= ?v0 f32)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f6 (f7 f8 ?v1) (f6 ?v_0 ?v3)) (f6 (f7 f8 ?v2) (f6 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (* ?v0 ?v3)) (+ ?v2 (* ?v0 ?v4))))))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11) (?v3 S11) (?v4 S11)) (let ((?v_0 (f27 f28 ?v0))) (=> (not (= ?v0 f22)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f26 (f27 f29 ?v1) (f26 ?v_0 ?v3)) (f26 (f27 f29 ?v2) (f26 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f15 f16 ?v0)) (?v_1 (f15 f16 ?v2))) (= (= (f14 (f15 f24 (f14 ?v_0 ?v1)) (f14 ?v_1 ?v3)) (f14 (f15 f24 (f14 ?v_0 ?v3)) (f14 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f7 f25 ?v0)) (?v_1 (f7 f25 ?v2))) (= (= (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_1 ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v3)) (f6 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f14 (f15 f24 (f14 (f15 f16 ?v0) ?v1)) (f14 (f15 f24 (f14 (f15 f16 ?v2) ?v1)) ?v3)) (f14 (f15 f24 (f14 (f15 f16 (f14 (f15 f24 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v1)) (f6 (f7 f8 (f6 (f7 f25 ?v2) ?v1)) ?v3)) (f6 (f7 f8 (f6 (f7 f25 (f6 (f7 f8 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f14 (f15 f24 (f14 (f15 f16 ?v0) ?v1)) (f14 (f15 f16 ?v2) ?v1)) (f14 (f15 f16 (f14 (f15 f24 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v1)) (f6 (f7 f25 ?v2) ?v1)) (f6 (f7 f25 (f6 (f7 f8 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f14 (f15 f16 (f14 (f15 f24 ?v0) ?v1)) ?v2) (f14 (f15 f24 (f14 (f15 f16 ?v0) ?v2)) (f14 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f25 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f14 (f15 f16 (f14 (f15 f24 ?v0) ?v1)) ?v2) (f14 (f15 f24 (f14 (f15 f16 ?v0) ?v2)) (f14 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f25 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v2)))))
(assert (= f30 f22))
(assert (forall ((?v0 S8)) (exists ((?v1 S3)) (forall ((?v2 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f31 ?v2) ?v0))) (f6 (f7 f25 (f11 f12 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f19 ?v2) ?v0))) (f6 (f7 f25 (f6 f23 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f25 ?v2) ?v0))) (f6 (f7 f25 (f6 f23 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S8)) (exists ((?v1 S3)) (forall ((?v2 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f16 ?v2) ?v0))) (f6 (f7 f25 (f11 f12 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f25 ?v0) ?v2))) (f6 (f7 f25 (f6 f23 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S8)) (exists ((?v1 S3)) (forall ((?v2 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f16 ?v0) ?v2))) (f6 (f7 f25 (f11 f12 ?v2)) ?v1)) f1)))))
(assert (exists ((?v0 S3)) (forall ((?v1 S3) (?v2 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f25 ?v1) ?v2))) (f6 (f7 f25 (f6 (f7 f25 (f6 f23 ?v1)) (f6 f23 ?v2))) ?v0)) f1))))
(assert (exists ((?v0 S3)) (forall ((?v1 S8) (?v2 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f16 ?v1) ?v2))) (f6 (f7 f25 (f6 (f7 f25 (f11 f12 ?v1)) (f11 f12 ?v2))) ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f32) f1) (=> (= (f3 (f4 f5 (f6 f23 ?v1)) (f6 (f7 f25 ?v0) (f6 f23 ?v2))) f1) (= ?v1 f32)))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (=> (= (f3 (f4 f5 ?v0) f32) f1) (=> (= (f3 (f4 f5 (f11 f12 ?v1)) (f6 (f7 f25 ?v0) (f11 f12 ?v2))) f1) (= ?v1 f20)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (not (= ?v0 f20)) (=> (not (= ?v1 f20)) (= (f14 (f15 f24 (f14 (f15 f31 ?v2) ?v0)) (f14 (f15 f31 ?v3) ?v1)) (f14 (f15 f31 (f14 (f15 f24 (f14 (f15 f16 ?v2) ?v1)) (f14 (f15 f16 ?v3) ?v0))) (f14 (f15 f16 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f32)) (=> (not (= ?v1 f32)) (= (f6 (f7 f8 (f6 (f7 f19 ?v2) ?v0)) (f6 (f7 f19 ?v3) ?v1)) (f6 (f7 f19 (f6 (f7 f8 (f6 (f7 f25 ?v2) ?v1)) (f6 (f7 f25 ?v3) ?v0))) (f6 (f7 f25 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f20)) (= (f14 (f15 f24 (f14 (f15 f31 ?v1) ?v0)) ?v2) (f14 (f15 f31 (f14 (f15 f24 ?v1) (f14 (f15 f16 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (= (f6 (f7 f8 (f6 (f7 f19 ?v1) ?v0)) ?v2) (f6 (f7 f19 (f6 (f7 f8 ?v1) (f6 (f7 f25 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f20)) (= (f14 (f15 f24 (f14 (f15 f31 ?v1) ?v0)) ?v2) (f14 (f15 f31 (f14 (f15 f24 ?v1) (f14 (f15 f16 ?v2) ?v0))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (= (f6 (f7 f8 (f6 (f7 f19 ?v1) ?v0)) ?v2) (f6 (f7 f19 (f6 (f7 f8 ?v1) (f6 (f7 f25 ?v2) ?v0))) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f20)) (= (f14 (f15 f24 ?v1) (f14 (f15 f31 ?v2) ?v0)) (f14 (f15 f31 (f14 (f15 f24 (f14 (f15 f16 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (= (f6 (f7 f8 ?v1) (f6 (f7 f19 ?v2) ?v0)) (f6 (f7 f19 (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f20)) (= (f14 (f15 f24 ?v1) (f14 (f15 f31 ?v2) ?v0)) (f14 (f15 f31 (f14 (f15 f24 ?v2) (f14 (f15 f16 ?v1) ?v0))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (= (f6 (f7 f8 ?v1) (f6 (f7 f19 ?v2) ?v0)) (f6 (f7 f19 (f6 (f7 f8 ?v2) (f6 (f7 f25 ?v1) ?v0))) ?v0)))))
(assert (not (= (f26 (f40 f41 f18) f30) f22)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (not (= ?v0 f32)) (= (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (= (= (f6 (f7 f25 ?v1) ?v0) (f6 (f7 f25 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f32) f1) (=> (= (f3 (f4 f5 (f6 f9 ?v1)) (f6 (f7 f25 ?v0) (f6 f9 ?v2))) f1) (= ?v1 f32)))))
(assert (forall ((?v0 S8)) (= (f3 (f4 f5 f32) (f11 f12 ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f32))) (= (= (f3 ?v_0 (f6 (f7 f19 ?v0) ?v1)) f1) (and (or (= (f3 (f4 f5 ?v0) f32) f1) (= (f3 ?v_0 ?v1) f1)) (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f32) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v0)) (f6 (f7 f25 ?v1) ?v1)) f32) (and (= ?v0 f32) (= ?v1 f32)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f9 (f6 (f7 f19 ?v0) ?v1)) (f6 (f7 f19 (f6 f9 ?v0)) (f6 f9 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f32)) (= (f6 f9 (f6 (f7 f19 ?v1) ?v0)) (f6 (f7 f19 (f6 f9 ?v1)) (f6 f9 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f6 (f7 f25 (f6 (f7 f19 ?v0) ?v1)) (f6 (f7 f19 ?v2) ?v3)) (f6 (f7 f19 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f14 (f15 f16 (f14 (f15 f31 ?v0) ?v1)) (f14 (f15 f31 ?v2) ?v3)) (f14 (f15 f31 (f14 (f15 f16 ?v0) ?v2)) (f14 (f15 f16 ?v1) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f32))) (= (= (f3 ?v_0 (f6 (f7 f19 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f32) f1) (= (f3 (f4 f5 ?v1) f32) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f32))) (= (= (f3 (f4 f5 (f6 (f7 f19 ?v0) ?v1)) f32) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f32) f1)) (and (= (f3 (f4 f5 ?v0) f32) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f32) ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f19 ?v0) ?v2)) (f6 (f7 f19 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f32) f1) (= (f3 (f4 f5 (f6 (f7 f19 ?v1) ?v2)) (f6 (f7 f19 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= ?v0 (f6 (f7 f19 ?v1) ?v2)) (ite (not (= ?v2 f32)) (= (f6 (f7 f25 ?v0) ?v2) ?v1) (= ?v0 f32)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (= ?v0 (f14 (f15 f31 ?v1) ?v2)) (ite (not (= ?v2 f20)) (= (f14 (f15 f16 ?v0) ?v2) ?v1) (= ?v0 f20)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f6 (f7 f19 ?v0) ?v1) ?v2) (ite (not (= ?v1 f32)) (= ?v0 (f6 (f7 f25 ?v2) ?v1)) (= ?v2 f32)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (= (f14 (f15 f31 ?v0) ?v1) ?v2) (ite (not (= ?v1 f20)) (= ?v0 (f14 (f15 f16 ?v2) ?v1)) (= ?v2 f20)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f32)) (= (f6 (f7 f19 (f6 (f7 f25 ?v1) ?v0)) (f6 (f7 f25 ?v2) ?v0)) (f6 (f7 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f20)) (= (f14 (f15 f31 (f14 (f15 f16 ?v1) ?v0)) (f14 (f15 f16 ?v2) ?v0)) (f14 (f15 f31 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (not (= ?v0 f32)) (= (f6 (f7 f19 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 (f7 f19 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f15 f16 ?v0))) (=> (not (= ?v0 f20)) (= (f14 (f15 f31 (f14 ?v_0 ?v1)) (f14 ?v_0 ?v2)) (f14 (f15 f31 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f32)) (=> (not (= ?v1 f32)) (= (= (f6 (f7 f19 ?v2) ?v0) (f6 (f7 f19 ?v3) ?v1)) (= (f6 (f7 f25 ?v2) ?v1) (f6 (f7 f25 ?v3) ?v0)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (not (= ?v0 f20)) (=> (not (= ?v1 f20)) (= (= (f14 (f15 f31 ?v2) ?v0) (f14 (f15 f31 ?v3) ?v1)) (= (f14 (f15 f16 ?v2) ?v1) (f14 (f15 f16 ?v3) ?v0)))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f32) ?v1) f1) (forall ((?v2 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f31 ?v2) ?v0))) (f6 (f7 f25 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f32) ?v1) f1) (forall ((?v2 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f19 ?v2) ?v0))) (f6 (f7 f25 (f6 f23 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f5 f32) ?v0) f1) (forall ((?v1 S3) (?v2 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f25 ?v1) ?v2))) (f6 (f7 f25 (f6 (f7 f25 (f6 f23 ?v1)) (f6 f23 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f5 f32) ?v0) f1) (forall ((?v1 S8) (?v2 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f16 ?v1) ?v2))) (f6 (f7 f25 (f6 (f7 f25 (f11 f12 ?v1)) (f11 f12 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f32) ?v1) f1) (forall ((?v2 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f25 ?v0) ?v2))) (f6 (f7 f25 (f6 f23 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f32) ?v1) f1) (forall ((?v2 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f16 ?v0) ?v2))) (f6 (f7 f25 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f32) ?v1) f1) (forall ((?v2 S3)) (= (f3 (f4 f5 (f6 f23 (f6 (f7 f25 ?v2) ?v0))) (f6 (f7 f25 (f6 f23 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f32) ?v1) f1) (forall ((?v2 S8)) (= (f3 (f4 f5 (f11 f12 (f14 (f15 f16 ?v2) ?v0))) (f6 (f7 f25 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (=> (not (= f30 f22)) (exists ((?v0 S3)) (forall ((?v1 S8)) (=> (= (f3 (f4 f5 ?v0) (f11 f12 ?v1)) f1) (= (f3 (f4 f5 f10) (f11 f12 (f14 (f42 f43 (f26 (f40 f41 f13) (f26 (f40 f41 f18) f30))) ?v1))) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v0)) (f6 (f7 f25 ?v1) ?v1))) f32) f1) (and (= ?v0 f32) (= ?v1 f32)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 f32) (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v0)) (f6 (f7 f25 ?v1) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= 0 (+ (* ?v0 ?v0) (* ?v1 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (not (= f30 f22)) (exists ((?v2 S3)) (forall ((?v3 S8)) (=> (= (f3 (f4 f5 ?v2) (f11 f12 ?v3)) f1) (= (f3 (f4 f5 ?v0) (f11 f12 (f14 (f42 f43 (f26 (f40 f41 ?v1) f30)) ?v3))) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v0)) (f6 (f7 f25 ?v1) ?v1)) f32) (and (= ?v0 f32) (= ?v1 f32)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8) (?v1 S11) (?v2 S8)) (= (f14 (f42 f43 (f26 (f40 f41 ?v0) ?v1)) ?v2) (f14 (f15 f24 ?v0) (f14 (f15 f16 ?v2) (f14 (f42 f43 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S18) (?v2 S3)) (= (f6 (f44 f45 (f46 (f47 f48 ?v0) ?v1)) ?v2) (f6 (f7 f8 ?v0) (f6 (f7 f25 ?v2) (f6 (f44 f45 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S11)) (exists ((?v2 S8)) (forall ((?v3 S8)) (let ((?v_0 (f42 f43 ?v1))) (=> (= (f3 (f4 f5 (f11 f12 ?v3)) ?v0) f1) (= (f3 (f4 f5 (f11 f12 (f14 ?v_0 ?v2))) (f11 f12 (f14 ?v_0 ?v3))) f1)))))))
(assert (= (f3 (f4 f49 f32) (f11 f12 f18)) f1))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f49 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f49 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f49 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f49 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f49 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f49 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f49 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f49 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f49 ?v0) ?v1) f1)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f49 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= (f3 (f4 f49 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f49 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f49 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f49 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f3 (f4 f49 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f3 (f4 f49 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f49 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v0) f1) (= (f3 (f4 f49 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 ?v1) ?v2) f1) (= (f3 (f4 f49 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f49 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f6 f9 ?v0)) (?v_1 (f6 f9 ?v2))) (=> (= (f3 (f4 f49 ?v_0) ?v1) f1) (=> (= (f3 (f4 f49 ?v_1) ?v3) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v_0) ?v_1)) (f6 (f7 f25 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f49 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f49 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f49 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f49 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f49 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f49 ?v2))) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f49 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f49 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f49 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f49 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f49 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f49 ?v1) ?v2) f1) (= (f3 (f4 f49 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f49 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (= (not (= (f3 (f4 f49 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (not (= (f3 (f4 f49 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f49 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f49 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f49 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f49 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f49 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f49 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f49 (f6 (f7 f36 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f49 ?v0) ?v2) f1) (= (f3 (f4 f49 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f49 (f6 (f7 f38 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f49 ?v0) ?v2) f1) (= (f3 (f4 f49 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f49 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f36 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f49 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f38 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f49 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f49 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f49 ?v0) ?v1) f1)) (or (= (f3 (f4 f49 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f49 ?v0) ?v1) f1) (= (f3 (f4 f49 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f49 ?v0) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v2))) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 ?v2) f32) f1) (= (f3 (f4 f49 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 ?v2) f32) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v1) ?v2)) (f6 (f7 f25 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v2))) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 f32) ?v2) f1) (= (f3 (f4 f49 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v2))) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 f32) ?v2) f1) (= (f3 (f4 f49 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 f32) ?v2) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) f32) f1) (=> (= (f3 (f4 f49 ?v1) f32) f1) (= (f3 (f4 f49 f32) (f6 (f7 f25 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) f32) f1) (=> (= (f3 (f4 f49 f32) ?v1) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v1)) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f3 (f4 f49 ?v0) f32) f1) (= (= (f3 (f4 f49 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f49 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f49 f32))) (=> (= (f3 ?v_0 (f6 (f7 f25 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f49 f32))) (=> (= (f3 ?v_0 (f6 (f7 f25 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 f32) ?v0) f1) (=> (= (f3 (f4 f49 ?v1) f32) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v1) ?v0)) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 f32) ?v0) f1) (=> (= (f3 (f4 f49 ?v1) f32) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v1)) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f49 f32))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f25 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f3 (f4 f49 f32) ?v0) f1) (= (= (f3 (f4 f49 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f49 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (= (= (f3 (f4 f49 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (or (and (= (f3 (f4 f49 f32) ?v0) f1) (= (f3 (f4 f49 ?v1) ?v2) f1)) (and (= (f3 (f4 f49 ?v0) f32) f1) (= (f3 (f4 f49 ?v2) ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v1)) (f6 (f7 f25 ?v2) ?v1)) f1) (or (and (= (f3 (f4 f49 f32) ?v1) f1) (= (f3 (f4 f49 ?v0) ?v2) f1)) (and (= (f3 (f4 f49 ?v1) f32) f1) (= (f3 (f4 f49 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v0)) f32) f1))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f49 ?v1))) (=> (= (f3 (f4 f49 f32) ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f49 f32))) (= (= (f3 ?v_0 (f6 (f7 f19 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f49 ?v0) f32) f1) (= (f3 (f4 f49 ?v1) f32) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f49 f32))) (= (= (f3 (f4 f49 (f6 (f7 f19 ?v0) ?v1)) f32) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f49 ?v1) f32) f1)) (and (= (f3 (f4 f49 ?v0) f32) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f49 (f6 (f7 f19 ?v0) ?v1)) (f6 (f7 f19 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f49 f32) ?v1) f1) (= (f3 (f4 f49 ?v0) ?v2) f1)) (and (=> (= (f3 (f4 f49 ?v1) f32) f1) (= (f3 (f4 f49 ?v2) ?v0) f1)) (not (= ?v1 f32)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 f32) ?v0) f1) (= (f6 (f7 f19 (f6 f9 ?v1)) ?v0) (f6 f9 (f6 (f7 f19 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f49 f32))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f19 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 f32) ?v0) f1) (=> (= (f3 (f4 f49 ?v1) f32) f1) (= (f3 (f4 f49 (f6 (f7 f19 ?v0) ?v1)) f32) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) f32) f1) (=> (= (f3 (f4 f49 f32) ?v1) f1) (= (f3 (f4 f49 (f6 (f7 f19 ?v0) ?v1)) f32) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f49 ?v0) f32) f1) (=> (= (f3 (f4 f49 ?v1) f32) f1) (= (f3 (f4 f49 f32) (f6 (f7 f19 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 f32) ?v2) f1) (= (f3 (f4 f49 (f6 (f7 f19 ?v0) ?v2)) (f6 (f7 f19 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 ?v2) f32) f1) (= (f3 (f4 f49 (f6 (f7 f19 ?v1) ?v2)) (f6 (f7 f19 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f49 f32) ?v0) f1) (= (= (f3 (f4 f49 (f6 (f7 f25 ?v1) ?v0)) (f6 (f7 f25 ?v2) ?v0)) f1) (= (f3 (f4 f49 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f49 f32))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f25 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f3 (f4 f49 f32) ?v0) f1) (=> (= (f3 (f4 f49 ?v1) ?v2) f1) (= (f3 (f4 f49 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S8)) (not (= (f3 (f4 f49 (f11 f12 ?v0)) f32) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f49 f32) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 (f6 (f7 f25 ?v0) ?v1)) (f6 (f7 f25 ?v2) ?v1)) f1) (=> (= (f3 (f4 f49 f32) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v2 ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f3 (f4 f49 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f5 f32) ?v0) f1) (= (f3 (f4 f49 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f3 (f4 f49 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f5 f32) ?v0) f1) (= (f3 (f4 f49 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v1)) (f6 (f7 f25 ?v2) ?v1)) f1) (=> (= (f3 (f4 f5 f32) ?v1) f1) (= (f3 (f4 f49 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v1)) (f6 (f7 f25 ?v2) ?v1)) f1) (=> (= (f3 (f4 f5 f32) ?v1) f1) (= (f3 (f4 f49 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 ?v2) ?v3) f1) (=> (= (f3 (f4 f49 f32) ?v0) f1) (=> (= (f3 (f4 f5 f32) ?v2) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 (f4 f5 f32) ?v0) f1) (=> (= (f3 (f4 f49 f32) ?v2) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f5 f32))) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f49 ?v0) ?v1) f1) (=> (= (f3 (f4 f49 ?v2) ?v3) f1) (=> (= (f3 (f4 f49 f32) ?v1) f1) (=> (= (f3 (f4 f5 f32) ?v2) f1) (= (f3 (f4 f49 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f3 (f4 f49 ?v0) f32) f1) (= (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f3 (f4 f49 f32) ?v0) f1) (= (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f49 f32) (f6 (f7 f8 (f6 (f7 f25 ?v0) ?v0)) (f6 (f7 f25 ?v1) ?v1))) f1) (or (not (= ?v0 f32)) (not (= ?v1 f32))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< 0 (+ (* ?v0 ?v0) (* ?v1 ?v1))) (or (not (= ?v0 0)) (not (= ?v1 0))))))
(check-sat)
(exit)
