(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S4)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S4)
(declare-fun f10 () S6)
(declare-fun f11 () S4)
(declare-fun f12 (S7 S8) S4)
(declare-fun f13 (S9 S4) S7)
(declare-fun f14 () S9)
(declare-fun f15 (S10 Int) S8)
(declare-fun f16 () S10)
(declare-fun f17 (S11 S8) Int)
(declare-fun f18 () S11)
(declare-fun f19 () S8)
(declare-fun f20 () S4)
(declare-fun f21 (S12 Int) S11)
(declare-fun f22 () S12)
(declare-fun f23 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (not (not (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f8 f9)) (?v_1 (f7 f10 f11)) (?v_2 (f15 f16 (- (f17 f18 f19) 1)))) (= (f6 ?v_0 (f6 (f7 f10 ?v0) (f6 ?v_1 (f12 (f13 f14 ?v0) ?v_2)))) (f6 ?v_0 (f6 (f7 f10 ?v1) (f6 ?v_1 (f12 (f13 f14 ?v1) ?v_2))))))))))
(assert (not (= f11 f20)))
(assert (not (= f19 (f15 f16 0))))
(assert (not (= f11 f20)))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f17 ?v_0 ?v1) (ite (= ?v1 (f15 f16 0)) 1 (* ?v0 (f17 ?v_0 (f15 f16 (- (f17 f18 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 ?v1) (ite (= ?v1 (f15 f16 0)) f9 (f6 (f7 f10 ?v0) (f12 ?v_0 (f15 f16 (- (f17 f18 ?v1) 1)))))))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (* (+ 1 1) ?v0))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) ?v0) (f6 (f7 f10 (f6 (f7 f8 f9) f9)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (* ?v1 ?v0)) (* (+ ?v1 1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 ?v0) (f6 (f7 f10 ?v1) ?v0)) (f6 (f7 f10 (f6 (f7 f8 ?v1) f9)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (* ?v0 ?v1) ?v1) (* (+ ?v0 1) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 (f6 (f7 f10 ?v0) ?v1)) ?v1) (f6 (f7 f10 (f6 (f7 f8 ?v0) f9)) ?v1))))
(assert (forall ((?v0 S8)) (= (f17 (f21 f22 1) ?v0) 1)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f9) ?v0) f9)))
(assert (= (f17 (f21 f22 1) (f15 f16 2)) 1))
(assert (= (f12 (f13 f14 f9) (f15 f16 2)) f9))
(assert (forall ((?v0 Int)) (= (f17 (f21 f22 ?v0) (f15 f16 0)) 1)))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f15 f16 0)) f9)))
(assert (forall ((?v0 Int)) (= (f17 (f21 f22 ?v0) (f15 f16 0)) 1)))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f15 f16 0)) f9)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 ?v0) ?v0) (f12 (f13 f14 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f17 (f21 f22 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f6 (f7 f10 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (* ?v0 (f17 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f6 (f7 f10 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (* ?v0 (f17 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f6 (f7 f10 (f12 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (* (f17 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f15 f16 (* (f17 f18 ?v1) (f17 f18 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f17 (f21 f22 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f15 f16 (* (f17 f18 ?v1) (f17 f18 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f17 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f17 (f21 f22 (f17 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (* (f17 f18 ?v1) (f17 f18 ?v2)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f17 ?v_0 (f15 f16 (* (f17 f18 ?v1) (f17 f18 ?v2)))) (f17 (f21 f22 (f17 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 ?v0) f20) f20)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 f20) ?v0) f20)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 (f6 (f7 f8 ?v0) ?v1)) (= ?v1 f20))))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) f20) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 f20) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f17 (f21 f22 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (not (= ?v0 f20)) (not (= (f12 (f13 f14 ?v0) ?v1) f20)))))
(assert (forall ((?v0 Int)) (= (= (f17 (f21 f22 ?v0) (f15 f16 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= (f12 (f13 f14 ?v0) (f15 f16 2)) f20) (= ?v0 f20))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f17 (f21 f22 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f15 f16 0)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (= (f12 (f13 f14 ?v0) ?v1) f20) (and (= ?v0 f20) (not (= ?v1 (f15 f16 0)))))))
(assert (= (f17 (f21 f22 0) (f15 f16 2)) 0))
(assert (= (f12 (f13 f14 f20) (f15 f16 2)) f20))
(assert (forall ((?v0 S8)) (= (f17 (f21 f22 0) (f15 f16 (+ (f17 f18 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f20) (f15 f16 (+ (f17 f18 ?v0) 1))) f20)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 (f7 f10 (f6 ?v_0 ?v1)) (f6 (f7 f10 ?v2) ?v3)) (f6 (f7 f10 (f6 ?v_0 ?v2)) (f6 (f7 f10 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f7 f10 (f6 (f7 f10 ?v0) ?v1))) (?v_0 (f7 f10 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f10 ?v0)) (?v_1 (f6 (f7 f10 ?v2) ?v3))) (= (f6 (f7 f10 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 (f7 f10 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f10 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 (f7 f10 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 ?v_0 (f6 (f7 f10 ?v1) ?v2)) (f6 (f7 f10 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f7 f10 ?v0)) (?v_0 (f7 f10 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f10 ?v0) ?v1) (f6 (f7 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 (f7 f8 ?v2) ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v2)) (f6 (f7 f8 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f8 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2))) (= (f17 (f21 f22 (f3 f23 ?v0)) ?v_0) (f17 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f17 (f21 f22 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f17 (f21 f22 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 (f21 f22 ?v0) (f15 f16 2)))) (= (f3 f23 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f23 (f17 (f21 f22 ?v0) ?v1)) (f17 (f21 f22 (f3 f23 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (* ?v0 ?v3)) (+ ?v2 (* ?v0 ?v4))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f7 f10 ?v0))) (=> (not (= ?v0 f20)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f6 (f7 f8 ?v1) (f6 ?v_0 ?v3)) (f6 (f7 f8 ?v2) (f6 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (= (+ (f17 (f21 f22 ?v0) ?v_0) (f17 (f21 f22 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S8)) (= (f17 (f21 f22 0) ?v0) (ite (= ?v0 (f15 f16 0)) 1 0))))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f20) ?v0) (ite (= ?v0 (f15 f16 0)) f9 f20))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (+ (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 ?v3) (* ?v2 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f10 ?v0)) (?v_1 (f7 f10 ?v2))) (= (= (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_1 ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v3)) (f6 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (* ?v0 ?v1) (* ?v2 ?v1)) (* (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f8 (f6 (f7 f10 ?v0) ?v1)) (f6 (f7 f10 ?v2) ?v1)) (f6 (f7 f10 (f6 (f7 f8 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f10 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f10 ?v0) ?v2)) (f6 (f7 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (* ?v0 ?v2) (* ?v1 ?v3)) (+ (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f10 ?v0)) (?v_1 (f7 f10 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f6 (f7 f8 (f6 ?v_0 ?v2)) (f6 ?v_1 ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v3)) (f6 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (+ ?v1 ?v2)) (+ (* ?v0 ?v1) (* ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 ?v0) f9) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 f9) ?v0) ?v0)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0)) (?v_2 (f13 f14 ?v2))) (=> (<= ?v_1 ?v_0) (= (f12 ?v_2 (f15 f16 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f10 (f12 ?v_2 (f15 f16 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0)) (?v_2 (f21 f22 ?v2))) (=> (<= ?v_1 ?v_0) (= (f17 ?v_2 (f15 f16 (- (+ ?v_0 1) ?v_1))) (* (f17 ?v_2 (f15 f16 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 (f7 f10 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) (f12 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (* (f17 ?v_0 ?v1) (f17 ?v_0 ?v2)) (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f12 (f13 f14 (f6 (f7 f10 ?v0) ?v1)) ?v2) (f6 (f7 f10 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f17 (f21 f22 (* ?v0 ?v1)) ?v2) (* (f17 (f21 f22 ?v0) ?v2) (f17 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f12 (f13 f14 (f6 (f7 f10 ?v0) ?v1)) ?v2) (f6 (f7 f10 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f17 (f21 f22 (* ?v0 ?v1)) ?v2) (* (f17 (f21 f22 ?v0) ?v2) (f17 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f6 (f7 f10 ?v_0) ?v0) (f6 (f7 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f17 (f21 f22 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 (f7 f10 (f12 ?v_0 ?v1)) ?v0) (f12 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (* (f17 ?v_0 ?v1) ?v0) (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 S8)) (= (f15 f16 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
