(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S4)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 Int) S4)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S4) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S10 S9) S9)
(declare-fun f14 (S11 S9) S10)
(declare-fun f15 () S11)
(declare-fun f16 (S12 S4) S9)
(declare-fun f17 (S13 S9) S12)
(declare-fun f18 () S13)
(declare-fun f19 () S4)
(declare-fun f20 () S9)
(declare-fun f21 () S9)
(declare-fun f22 (S14 Int) S8)
(declare-fun f23 () S14)
(declare-fun f24 () S6)
(declare-fun f25 () S6)
(declare-fun f26 (S16 S15) S17)
(declare-fun f27 () S16)
(declare-fun f28 (S17 S15) S15)
(declare-fun f29 (S18 S4) S15)
(declare-fun f30 (S19 S15) S18)
(declare-fun f31 () S19)
(declare-fun f32 () S2)
(declare-fun f33 () S4)
(declare-fun f34 () S15)
(declare-fun f35 () S10)
(declare-fun f36 (S20 S15) S4)
(declare-fun f37 () S20)
(declare-fun f38 () S15)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 ?v0) ?v1) (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))))))
(assert (not (exists ((?v0 S9) (?v1 S9)) (let ((?v_0 (f9 f10 (- (f11 f12 f19) (+ 0 1))))) (not (= (f13 (f14 f15 ?v0) (f16 (f17 f18 ?v0) ?v_0)) (f13 (f14 f15 ?v1) (f16 (f17 f18 ?v1) ?v_0))))))))
(assert (not (= f20 f21)))
(assert (not (= f19 (f9 f10 0))))
(assert (not (= f20 f21)))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f11 (f22 f23 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f24 ?v0) ?v0) (f6 (f7 f25 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S9)) (= (f13 (f14 f15 ?v0) ?v0) (f16 (f17 f18 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S15)) (= (f28 (f26 f27 ?v0) ?v0) (f29 (f30 f31 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* ?v0 (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f24 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f13 (f14 f15 ?v0) (f16 ?v_0 ?v1))))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f28 (f26 f27 ?v0) (f29 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* ?v0 (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f24 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f13 (f14 f15 ?v0) (f16 ?v_0 ?v1))))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f28 (f26 f27 ?v0) (f29 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* (f11 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f13 (f14 f15 (f16 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f28 (f26 f27 (f29 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f9 f10 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f25 ?v0) (f9 f10 2)) (f6 (f7 f24 ?v0) ?v0))))
(assert (forall ((?v0 S9)) (= (f16 (f17 f18 ?v0) (f9 f10 2)) (f13 (f14 f15 ?v0) ?v0))))
(assert (forall ((?v0 S15)) (= (f29 (f30 f31 ?v0) (f9 f10 2)) (f28 (f26 f27 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f9 f10 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f25 ?v0) (f9 f10 3)) (f6 (f7 f24 (f6 (f7 f24 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S9)) (= (f16 (f17 f18 ?v0) (f9 f10 3)) (f13 (f14 f15 (f13 (f14 f15 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S15)) (= (f29 (f30 f31 ?v0) (f9 f10 3)) (f28 (f26 f27 (f28 (f26 f27 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (* ?v0 (f11 (f22 f23 (f11 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f6 (f7 f24 ?v0) (f6 (f7 f25 (f6 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f13 (f14 f15 ?v0) (f16 (f17 f18 (f16 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f28 (f26 f27 ?v0) (f29 (f30 f31 (f29 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f6 (f7 f24 ?v0) (f6 (f7 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f17 f18 ?v0))) (let ((?v_1 (f16 ?v_0 ?v1))) (= (f16 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f13 (f14 f15 ?v0) (f13 (f14 f15 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f30 f31 ?v0))) (let ((?v_1 (f29 ?v_0 ?v1))) (= (f29 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f28 (f26 f27 ?v0) (f28 (f26 f27 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (* ?v0 (f11 ?v_0 ?v1)) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 (f7 f24 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f13 (f14 f15 ?v0) (f16 ?v_0 ?v1)) (f16 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f28 (f26 f27 ?v0) (f29 ?v_0 ?v1)) (f29 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f6 (f7 f24 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f13 (f14 f15 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 S15) (?v1 S4) (?v2 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f28 (f26 f27 (f29 ?v_0 ?v1)) (f29 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f6 (f7 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f17 f18 ?v0))) (let ((?v_1 (f16 ?v_0 ?v1))) (= (f16 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f13 (f14 f15 ?v_1) ?v_1))))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f30 f31 ?v0))) (let ((?v_1 (f29 ?v_0 ?v1))) (= (f29 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f28 (f26 f27 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (* (f11 ?v_0 ?v1) ?v0) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f13 (f14 f15 (f16 ?v_0 ?v1)) ?v0) (f16 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f28 (f26 f27 (f29 ?v_0 ?v1)) ?v0) (f29 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 ?v1) (ite (= ?v1 (f9 f10 0)) (f9 f10 1) (f9 f10 (* (f11 f12 ?v0) (f11 f12 (f6 ?v_0 (f9 f10 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f9 f10 (+ ?v_1 (* (f11 f12 (f9 f10 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* ?v_0 2)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* 2 ?v_0)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 (f22 f23 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 (f7 f25 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S9) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S15) (?v1 S4) (?v2 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2) (f29 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f11 (f22 f23 (f11 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f6 (f7 f25 (f6 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f16 (f17 f18 (f16 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f29 (f30 f31 (f29 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f11 (f22 f23 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f6 (f7 f25 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S15) (?v1 S4) (?v2 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) (f13 (f14 f15 ?v2) ?v3)) (f13 (f14 f15 (f13 ?v_0 ?v2)) (f13 (f14 f15 ?v1) ?v3))))))
(assert (forall ((?v0 S15) (?v1 S15) (?v2 S15) (?v3 S15)) (let ((?v_0 (f26 f27 ?v0))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) (f28 (f26 f27 ?v2) ?v3)) (f28 (f26 f27 (f28 ?v_0 ?v2)) (f28 (f26 f27 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f24 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) (f6 (f7 f24 ?v2) ?v3)) (f6 (f7 f24 (f6 ?v_0 ?v2)) (f6 (f7 f24 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_1 (f14 f15 (f13 (f14 f15 ?v0) ?v1))) (?v_0 (f14 f15 ?v2))) (= (f13 ?v_1 (f13 ?v_0 ?v3)) (f13 ?v_0 (f13 ?v_1 ?v3))))))
(assert (forall ((?v0 S15) (?v1 S15) (?v2 S15) (?v3 S15)) (let ((?v_1 (f26 f27 (f28 (f26 f27 ?v0) ?v1))) (?v_0 (f26 f27 ?v2))) (= (f28 ?v_1 (f28 ?v_0 ?v3)) (f28 ?v_0 (f28 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f7 f24 (f6 (f7 f24 ?v0) ?v1))) (?v_0 (f7 f24 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f13 (f14 f15 ?v2) ?v3))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v_1) (f13 ?v_0 (f13 (f14 f15 ?v1) ?v_1))))))
(assert (forall ((?v0 S15) (?v1 S15) (?v2 S15) (?v3 S15)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f28 (f26 f27 ?v2) ?v3))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) ?v_1) (f28 ?v_0 (f28 (f26 f27 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f24 ?v0)) (?v_1 (f6 (f7 f24 ?v2) ?v3))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 (f14 f15 (f13 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S15) (?v1 S15) (?v2 S15)) (let ((?v_0 (f26 f27 ?v0))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) ?v2) (f28 (f26 f27 (f28 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f24 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f24 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f13 (f14 f15 ?v1) ?v2))))))
(assert (forall ((?v0 S15) (?v1 S15) (?v2 S15)) (let ((?v_0 (f26 f27 ?v0))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) ?v2) (f28 ?v_0 (f28 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f24 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f24 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f13 (f14 f15 ?v1) ?v2)) (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S15) (?v1 S15) (?v2 S15)) (let ((?v_0 (f26 f27 ?v0))) (= (f28 ?v_0 (f28 (f26 f27 ?v1) ?v2)) (f28 (f26 f27 (f28 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f24 ?v0))) (= (f6 ?v_0 (f6 (f7 f24 ?v1) ?v2)) (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_1 (f14 f15 ?v0)) (?v_0 (f14 f15 ?v1))) (= (f13 ?v_1 (f13 ?v_0 ?v2)) (f13 ?v_0 (f13 ?v_1 ?v2))))))
(assert (forall ((?v0 S15) (?v1 S15) (?v2 S15)) (let ((?v_1 (f26 f27 ?v0)) (?v_0 (f26 f27 ?v1))) (= (f28 ?v_1 (f28 ?v_0 ?v2)) (f28 ?v_0 (f28 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f7 f24 ?v0)) (?v_0 (f7 f24 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f13 (f14 f15 ?v0) ?v1) (f13 (f14 f15 ?v1) ?v0))))
(assert (forall ((?v0 S15) (?v1 S15)) (= (f28 (f26 f27 ?v0) ?v1) (f28 (f26 f27 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f24 ?v0) ?v1) (f6 (f7 f24 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (= (f11 (f22 f23 (f3 f32 ?v0)) ?v_0) (f11 (f22 f23 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f25 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S9)) (= (f16 (f17 f18 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S15)) (= (f29 (f30 f31 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f25 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S9)) (= (f16 (f17 f18 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S15)) (= (f29 (f30 f31 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f22 f23 ?v0) (f9 f10 2)))) (= (f3 f32 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (f3 f32 (f11 (f22 f23 ?v0) ?v1)) (f11 (f22 f23 (f3 f32 ?v0)) ?v1))))
(assert (forall ((?v0 S9)) (= (f13 (f14 f15 ?v0) f21) f21)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f24 ?v0) f33) f33)))
(assert (forall ((?v0 S15)) (= (f28 (f26 f27 ?v0) f34) f34)))
(assert (forall ((?v0 S9)) (= (f13 (f14 f15 f21) ?v0) f21)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f24 f33) ?v0) f33)))
(assert (forall ((?v0 S15)) (= (f28 (f26 f27 f34) ?v0) f34)))
(assert (forall ((?v0 S9) (?v1 S4)) (=> (not (= ?v0 f21)) (not (= (f16 (f17 f18 ?v0) ?v1) f21)))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (not (= ?v0 0)) (not (= (f11 (f22 f23 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S15) (?v1 S4)) (=> (not (= ?v0 f34)) (not (= (f29 (f30 f31 ?v0) ?v1) f34)))))
(assert (forall ((?v0 S9)) (= (= (f16 (f17 f18 ?v0) (f9 f10 2)) f21) (= ?v0 f21))))
(assert (forall ((?v0 Int)) (= (= (f11 (f22 f23 ?v0) (f9 f10 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S15)) (= (= (f29 (f30 f31 ?v0) (f9 f10 2)) f34) (= ?v0 f34))))
(assert (forall ((?v0 S9) (?v1 S4)) (= (= (f16 (f17 f18 ?v0) ?v1) f21) (and (= ?v0 f21) (not (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (= (f11 (f22 f23 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 (f7 f25 ?v0) ?v1) f33) (and (= ?v0 f33) (not (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S15) (?v1 S4)) (= (= (f29 (f30 f31 ?v0) ?v1) f34) (and (= ?v0 f34) (not (= ?v1 (f9 f10 0)))))))
(assert (= (f16 (f17 f18 f21) (f9 f10 2)) f21))
(assert (= (f11 (f22 f23 0) (f9 f10 2)) 0))
(assert (= (f6 (f7 f25 f33) (f9 f10 2)) f33))
(assert (= (f29 (f30 f31 f34) (f9 f10 2)) f34))
(assert (forall ((?v0 S4)) (= (f16 (f17 f18 f21) (f9 f10 (+ (f11 f12 ?v0) 1))) f21)))
(assert (forall ((?v0 S4)) (= (f11 (f22 f23 0) (f9 f10 (+ (f11 f12 ?v0) 1))) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f25 f33) (f9 f10 (+ (f11 f12 ?v0) 1))) f33)))
(assert (forall ((?v0 S4)) (= (f29 (f30 f31 f34) (f9 f10 (+ (f11 f12 ?v0) 1))) f34)))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f25 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S9) (?v1 S4) (?v2 S4)) (let ((?v_0 (f17 f18 ?v0))) (= (f13 (f14 f15 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2)) (f16 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S15) (?v1 S4) (?v2 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f28 (f26 f27 (f29 ?v_0 ?v1)) (f29 ?v_0 ?v2)) (f29 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (= (f11 (f22 f23 (* ?v0 ?v1)) ?v2) (* (f11 (f22 f23 ?v0) ?v2) (f11 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f25 (f6 (f7 f24 ?v0) ?v1)) ?v2) (f6 (f7 f24 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S4)) (= (f16 (f17 f18 (f13 (f14 f15 ?v0) ?v1)) ?v2) (f13 (f14 f15 (f16 (f17 f18 ?v0) ?v2)) (f16 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 S15) (?v1 S15) (?v2 S4)) (= (f29 (f30 f31 (f28 (f26 f27 ?v0) ?v1)) ?v2) (f28 (f26 f27 (f29 (f30 f31 ?v0) ?v2)) (f29 (f30 f31 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (= (f11 (f22 f23 (* ?v0 ?v1)) ?v2) (* (f11 (f22 f23 ?v0) ?v2) (f11 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f25 (f6 (f7 f24 ?v0) ?v1)) ?v2) (f6 (f7 f24 (f6 (f7 f25 ?v0) ?v2)) (f6 (f7 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S4)) (= (f16 (f17 f18 (f13 (f14 f15 ?v0) ?v1)) ?v2) (f13 (f14 f15 (f16 (f17 f18 ?v0) ?v2)) (f16 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 S15) (?v1 S15) (?v2 S4)) (= (f29 (f30 f31 (f28 (f26 f27 ?v0) ?v1)) ?v2) (f28 (f26 f27 (f29 (f30 f31 ?v0) ?v2)) (f29 (f30 f31 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f11 (f22 f23 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f6 (f7 f25 ?v0) ?v1))) (= (f6 (f7 f24 ?v_0) ?v0) (f6 (f7 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 S9) (?v1 S4)) (let ((?v_0 (f16 (f17 f18 ?v0) ?v1))) (= (f13 (f14 f15 ?v_0) ?v0) (f13 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 S15) (?v1 S4)) (let ((?v_0 (f29 (f30 f31 ?v0) ?v1))) (= (f28 (f26 f27 ?v_0) ?v0) (f28 (f26 f27 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f22 f23 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (* (f11 ?v_2 (f9 f10 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f7 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f24 (f6 ?v_2 (f9 f10 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S9)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f17 f18 ?v2))) (=> (<= ?v_1 ?v_0) (= (f16 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (f13 (f14 f15 (f16 ?v_2 (f9 f10 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S15)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f30 f31 ?v2))) (=> (<= ?v_1 ?v_0) (= (f29 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (f28 (f26 f27 (f29 ?v_2 (f9 f10 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f22 f23 ?v1))) (=> (< 0 ?v_0) (= (* (f11 ?v_1 (f9 f10 (- ?v_0 1))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f7 f25 ?v1))) (=> (< 0 ?v_0) (= (f6 (f7 f24 (f6 ?v_1 (f9 f10 (- ?v_0 1)))) ?v1) (f6 ?v_1 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S9)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f17 f18 ?v1))) (=> (< 0 ?v_0) (= (f13 (f14 f15 (f16 ?v_1 (f9 f10 (- ?v_0 1)))) ?v1) (f16 ?v_1 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S15)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f30 f31 ?v1))) (=> (< 0 ?v_0) (= (f28 (f26 f27 (f29 ?v_1 (f9 f10 (- ?v_0 1)))) ?v1) (f29 ?v_1 ?v0))))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f13 (f14 f15 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 (f7 f24 ?v0) ?v1) f33) (or (= ?v0 f33) (= ?v1 f33)))))
(assert (forall ((?v0 S15) (?v1 S15)) (=> (= (f28 (f26 f27 ?v0) ?v1) f34) (or (= ?v0 f34) (= ?v1 f34)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (not (= (f13 (f14 f15 ?v0) ?v1) f21))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f33)) (=> (not (= ?v1 f33)) (not (= (f6 (f7 f24 ?v0) ?v1) f33))))))
(assert (forall ((?v0 S15) (?v1 S15)) (=> (not (= ?v0 f34)) (=> (not (= ?v1 f34)) (not (= (f28 (f26 f27 ?v0) ?v1) f34))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f13 (f14 f15 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S15) (?v1 S15)) (= (= (f28 (f26 f27 ?v0) ?v1) f34) (or (= ?v0 f34) (= ?v1 f34)))))
(assert (forall ((?v0 S9)) (= (f13 (f14 f15 ?v0) f21) f21)))
(assert (forall ((?v0 S9)) (= (f13 (f14 f15 ?v0) f21) f21)))
(assert (forall ((?v0 S9)) (= (f13 (f14 f15 ?v0) f21) f21)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f24 ?v0) f33) f33)))
(assert (forall ((?v0 S15)) (= (f28 (f26 f27 ?v0) f34) f34)))
(assert (forall ((?v0 S9)) (= (f13 (f14 f15 f21) ?v0) f21)))
(assert (forall ((?v0 S9)) (= (f13 (f14 f15 f21) ?v0) f21)))
(assert (forall ((?v0 S9)) (= (f13 (f14 f15 f21) ?v0) f21)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f24 f33) ?v0) f33)))
(assert (forall ((?v0 S15)) (= (f28 (f26 f27 f34) ?v0) f34)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (< 0 (f11 f12 (f6 (f7 f25 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (f6 (f7 f25 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f6 (f7 f25 ?v0) ?v1) ?v_0) (or (= ?v1 (f9 f10 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f25 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f6 ?v_0 ?v1)) (f11 f12 (f6 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f6 (f7 f25 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f32 (* ?v0 ?v1)) (* (f3 f32 ?v0) (f3 f32 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f32 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S9)) (= (f16 (f17 f18 (f13 f35 ?v0)) (f9 f10 2)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 f12 (f6 (f7 f25 ?v0) ?v1)) (f11 (f22 f23 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (< 0 (f11 f12 (f6 (f7 f25 ?v0) ?v1))) (or (= ?v1 (f9 f10 0)) (< 0 (f11 f12 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 (f22 f23 (f11 f12 ?v0)) ?v1) (f11 f12 (f6 (f7 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 (f22 f23 (f11 f12 ?v0)) ?v1) (f11 f12 (f6 (f7 f25 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (= (f9 f10 (f11 (f22 f23 ?v0) ?v1)) (f6 (f7 f25 (f9 f10 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (= (f6 (f7 f25 (f9 f10 ?v0)) ?v1) (f9 f10 (f11 (f22 f23 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (<= 0 (f11 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (< 0 (f11 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (<= 0 (f11 (f22 f23 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f9 f10 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f9 f10 (* (f11 f12 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0))) (f11 f12 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 (f22 f23 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f11 f12 (f9 f10 ?v0)) (f11 f12 (f9 f10 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f9 f10 (* (f11 f12 (f9 f10 ?v0)) (f11 f12 (f9 f10 ?v1)))) (f9 f10 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f11 f12 (f9 f10 (- ?v0))) (f11 f12 (f9 f10 (- ?v1)))))))))
(assert (not (= (f36 f37 f38) (f9 f10 (+ (f11 f12 f19) 1)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* 0 (f11 f12 ?v0))) (f9 f10 0))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (<= 2 (f11 f12 (f36 f37 f38))))
(assert (< (+ (f11 f12 f19) 1) (f11 f12 (f36 f37 f38))))
(assert (forall ((?v0 S15)) (= (= (f36 f37 ?v0) (f9 f10 0)) (= ?v0 f34))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= ?v0 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (or (= ?v1 (f9 f10 1)) (= ?v0 (f9 f10 0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f9 f10 (* (f11 f12 ?v0) ?v_0)) (f9 f10 (* (f11 f12 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f9 f10 (* (f11 f12 (f9 f10 (- ?v_0 ?v_2))) ?v_1)) (f9 f10 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f9 f10 (* (+ ?v_0 ?v_2) ?v_1)) (f9 f10 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f9 f10 (* (* ?v_0 ?v_1) ?v_2)) (f9 f10 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 0))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 1))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f9 f10 (* (+ ?v_1 1) ?v_0)) (f9 f10 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_0 (f11 f12 (f9 f10 (- ?v_1 ?v_2))))) (f9 f10 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f9 f10 (* ?v_0 (+ ?v_1 ?v_2))) (f9 f10 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_0 (+ ?v_1 1))) (f9 f10 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f9 f10 (* ?v_1 ?v_0)) (f9 f10 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f9 f10 (* (f11 f12 ?v0) 0)) (f9 f10 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 1))) (= (= ?v_0 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4)) (= (f9 f10 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
