(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S1)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S8) S5)
(declare-fun f10 (S9 S5) S7)
(declare-fun f11 () S9)
(declare-fun f12 () S5)
(declare-fun f13 () S8)
(declare-fun f14 () S5)
(declare-fun f15 () S5)
(declare-fun f16 (S10 S8) Int)
(declare-fun f17 () S10)
(declare-fun f18 () S6)
(declare-fun f19 (S11 Int) S8)
(declare-fun f20 () S11)
(declare-fun f21 (S12 Int) S10)
(declare-fun f22 () S12)
(declare-fun f23 (S13 S8) S14)
(declare-fun f24 (S15 S14) S13)
(declare-fun f25 () S15)
(declare-fun f26 () S14)
(declare-fun f27 () S14)
(declare-fun f28 () S14)
(declare-fun f29 () S5)
(declare-fun f30 (S16 S5) S5)
(declare-fun f31 (S17 S5) S16)
(declare-fun f32 () S17)
(declare-fun f33 (S18 Int) Int)
(declare-fun f34 (S19 Int) S18)
(declare-fun f35 () S19)
(declare-fun f36 () S17)
(declare-fun f37 () S19)
(declare-fun f38 () S16)
(declare-fun f39 () S18)
(declare-fun f40 () S16)
(declare-fun f41 (S20 S3) S19)
(declare-fun f42 () S20)
(declare-fun f43 (S21 S6) S17)
(declare-fun f44 () S21)
(declare-fun f45 () S20)
(declare-fun f46 () S21)
(declare-fun f47 () S17)
(declare-fun f48 () S17)
(declare-fun f49 (S22 S14) S14)
(declare-fun f50 (S23 S14) S22)
(declare-fun f51 () S23)
(declare-fun f52 () S23)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 (f9 (f10 f11 f12) f13)) f14) f1)))
(assert (=> (= (f6 (f7 f8 f15) f12) f1) (=> (< 0 (f16 f17 f13)) (= (f6 (f7 f18 (f9 (f10 f11 f12) f13)) (f9 (f10 f11 f14) f13)) f1))))
(assert (= (f6 (f7 f18 f15) f12) f1))
(assert (not (= f13 (f19 f20 0))))
(assert (not (= f13 (f19 f20 0))))
(assert (= (f6 (f7 f18 f15) f12) f1))
(assert (= (f6 (f7 f18 f12) f14) f1))
(assert (=> (= (f6 (f7 f8 f15) f12) f1) (=> (< 0 (f16 f17 f13)) (= (f6 (f7 f18 (f9 (f10 f11 f12) f13)) (f9 (f10 f11 f14) f13)) f1))))
(assert (= (f6 (f7 f18 f15) (f9 (f10 f11 f12) f13)) f1))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 1 ?v0) (<= 1 (f16 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f7 f8 f14))) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (<= 1 ?v2) (<= (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S5)) (let ((?v_0 (f10 f11 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f6 (f7 f8 f14) ?v2) f1) (= (f6 (f7 f8 (f9 ?v_0 ?v0)) (f9 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f18 f15) ?v0) f1) (exists ((?v1 S5)) (let ((?v_0 (f7 f18 ?v1))) (and (= (f6 (f7 f18 f15) ?v1) f1) (and (= (f6 ?v_0 f14) f1) (= (f6 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (forall ((?v0 S8)) (= (f16 (f21 f22 1) ?v0) 1)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f14) ?v0) f14)))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 f26) ?v0) f26)))
(assert (= (f16 (f21 f22 1) (f19 f20 2)) 1))
(assert (= (f9 (f10 f11 f14) (f19 f20 2)) f14))
(assert (= (f23 (f24 f25 f26) (f19 f20 2)) f26))
(assert (forall ((?v0 Int)) (= (f16 (f21 f22 ?v0) (f19 f20 0)) 1)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f19 f20 0)) f14)))
(assert (forall ((?v0 S14)) (= (f23 (f24 f25 ?v0) (f19 f20 0)) f26)))
(assert (forall ((?v0 Int)) (= (f16 (f21 f22 ?v0) (f19 f20 0)) 1)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f19 f20 0)) f14)))
(assert (forall ((?v0 S14)) (= (f23 (f24 f25 ?v0) (f19 f20 0)) f26)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (=> (<= ?v0 1) (<= (f16 (f21 f22 ?v0) (f19 f20 (+ (f16 f17 ?v1) 1))) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (= (f6 (f7 f8 f15) ?v0) f1) (=> (= (f6 (f7 f8 ?v0) f14) f1) (= (f6 (f7 f8 (f9 (f10 f11 ?v0) (f19 f20 (+ (f16 f17 ?v1) 1)))) ?v0) f1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v0))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S5)) (let ((?v_0 (f10 f11 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f6 (f7 f8 f15) ?v2) f1) (=> (= (f6 (f7 f8 ?v2) f14) f1) (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f6 (f7 f18 f14) ?v0) f1) (= (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (=> (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f6 (f7 f18 f14) ?v0) f1) (=> (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (not (= f27 f28)))
(assert (= (f6 (f7 f18 f15) f29) f1))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f18 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= ?v0 ?v1)) (or (= (f6 (f7 f18 ?v0) ?v1) f1) (= (f6 (f7 f18 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f18 ?v0) ?v1) f1)) (or (= (f6 (f7 f18 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f18 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f6 (f7 f18 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (= (= (f6 ?v_0 (f30 (f31 f32 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f33 (f34 f35 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (= (= (f6 ?v_0 (f30 (f31 f36 ?v1) ?v2)) f1) (and (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f33 (f34 f37 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f18 (f30 (f31 f32 ?v0) ?v1)) ?v2) f1) (and (= (f6 (f7 f18 ?v0) ?v2) f1) (= (f6 (f7 f18 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f33 (f34 f35 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f18 (f30 (f31 f36 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f18 ?v0) ?v2) f1) (= (f6 (f7 f18 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f33 (f34 f37 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f18 ?v0) ?v1) f1)) (= (not (= (f6 (f7 f18 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f18 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f18 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (not (= (f6 (f7 f18 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (= (not (= (f6 (f7 f18 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S1)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (= (=> (= (f6 (f7 f18 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (= (f6 (f7 f18 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (= (f6 (f7 f18 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f18 ?v1) ?v2) f1) (= (f6 (f7 f18 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f18 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f18 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v2))) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (=> (not false) (= (f6 (f7 f18 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f18 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 (f7 f18 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (< 0 (f16 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f7 f18 f15))) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f16 (f21 f22 ?v0) (f19 f20 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f18 f15) (f9 (f10 f11 ?v0) (f19 f20 2))) f1) (not (= ?v0 f15)))))
(assert (forall ((?v0 Int)) (not (< (f16 (f21 f22 ?v0) (f19 f20 2)) 0))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f18 (f9 (f10 f11 ?v0) (f19 f20 2))) f15) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f18 ?v1) ?v2) f1) (= (f6 (f7 f18 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v0) f1) (= (f6 (f7 f18 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f6 (f7 f18 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f6 (f7 f18 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f18 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (not (= (f6 (f7 f18 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= (f6 (f7 f18 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= (f6 (f7 f18 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f18 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f18 ?v0) ?v1) f1)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f18 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f18 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f18 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f18 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= (f6 (f7 f8 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f18 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f18 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f18 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f18 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f18 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f18 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S14) (?v1 S8)) (=> (not (= ?v0 f28)) (not (= (f23 (f24 f25 ?v0) ?v1) f28)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f16 (f21 f22 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (not (= ?v0 f15)) (not (= (f9 (f10 f11 ?v0) ?v1) f15)))))
(assert (forall ((?v0 S14)) (= (= (f23 (f24 f25 ?v0) (f19 f20 2)) f28) (= ?v0 f28))))
(assert (forall ((?v0 Int)) (= (= (f16 (f21 f22 ?v0) (f19 f20 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f9 (f10 f11 ?v0) (f19 f20 2)) f15) (= ?v0 f15))))
(assert (forall ((?v0 S14) (?v1 S8)) (= (= (f23 (f24 f25 ?v0) ?v1) f28) (and (= ?v0 f28) (not (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f16 (f21 f22 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (= (f9 (f10 f11 ?v0) ?v1) f15) (and (= ?v0 f15) (not (= ?v1 (f19 f20 0)))))))
(assert (= (f23 (f24 f25 f28) (f19 f20 2)) f28))
(assert (= (f16 (f21 f22 0) (f19 f20 2)) 0))
(assert (= (f9 (f10 f11 f15) (f19 f20 2)) f15))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 f28) (f19 f20 (+ (f16 f17 ?v0) 1))) f28)))
(assert (forall ((?v0 S8)) (= (f16 (f21 f22 0) (f19 f20 (+ (f16 f17 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f15) (f19 f20 (+ (f16 f17 ?v0) 1))) f15)))
(assert (not (= f15 f14)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (=> (< (f16 (f21 f22 ?v0) ?v_0) (f16 (f21 f22 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f19 f20 2))) (=> (= (f6 (f7 f18 (f9 (f10 f11 ?v0) ?v_0)) (f9 (f10 f11 ?v1) ?v_0)) f1) (=> (= (f6 (f7 f8 f15) ?v1) f1) (= (f6 (f7 f18 ?v0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (< (f16 (f21 f22 ?v0) ?v1) (f16 (f21 f22 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S5)) (=> (= (f6 (f7 f18 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 ?v2) ?v1)) f1) (=> (= (f6 (f7 f8 f15) ?v2) f1) (= (f6 (f7 f18 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f16 f17 ?v2)) (< (f16 (f21 f22 ?v0) ?v2) (f16 (f21 f22 ?v1) ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f15) ?v0) f1) (=> (< 0 (f16 f17 ?v2)) (= (f6 (f7 f18 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v0))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S5)) (let ((?v_0 (f10 f11 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f6 (f7 f18 f15) ?v2) f1) (=> (= (f6 (f7 f18 ?v2) f14) f1) (= (f6 (f7 f18 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f16 (f21 f22 ?v0) (f19 f20 (+ (f16 f17 ?v1) 1))) 1)))))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (= (f6 (f7 f18 f15) ?v0) f1) (=> (= (f6 (f7 f18 ?v0) f14) f1) (= (f6 (f7 f18 (f9 (f10 f11 ?v0) (f19 f20 (+ (f16 f17 ?v1) 1)))) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f8 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f8 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f33 (f34 f37 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f30 (f31 f36 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f8 ?v0) ?v2) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f33 (f34 f35 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 (f30 (f31 f32 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f19 f20 2))) (= (f9 (f10 f11 (f30 f38 ?v0)) ?v_0) (f9 (f10 f11 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 2))) (= (f16 (f21 f22 (f33 f39 ?v0)) ?v_0) (f16 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S14)) (= (f23 (f24 f25 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f16 (f21 f22 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S14)) (= (f23 (f24 f25 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f16 (f21 f22 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 (f10 f11 ?v0) (f19 f20 2)))) (= (f30 f38 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 (f21 f22 ?v0) (f19 f20 2)))) (= (f33 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (f30 f38 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 (f30 f38 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f33 f39 (f16 (f21 f22 ?v0) ?v1)) (f16 (f21 f22 (f33 f39 ?v0)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (< 1 ?v2) (< (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S5)) (let ((?v_0 (f10 f11 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f6 (f7 f18 f14) ?v2) f1) (= (f6 (f7 f18 (f9 ?v_0 ?v0)) (f9 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (=> (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f6 (f7 f18 f14) ?v0) f1) (=> (= (f6 (f7 f18 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (=> (< 0 (f16 f17 ?v1)) (< 1 (f16 (f21 f22 ?v0) ?v1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f7 f18 f14))) (=> (= (f6 ?v_0 ?v0) f1) (=> (< 0 (f16 f17 ?v1)) (= (f6 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f6 (f7 f18 f14) ?v0) f1) (= (= (f6 (f7 f18 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f6 (f7 f18 f14) ?v0) f1) (= (= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (f16 (f21 f22 ?v0) (f19 f20 (+ (f16 f17 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f7 f18 f14))) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 (f9 (f10 f11 ?v0) (f19 f20 (+ (f16 f17 ?v1) 1)))) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (=> (= (f16 (f21 f22 ?v0) ?v_0) (f16 (f21 f22 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_1 (f7 f8 f15)) (?v_0 (f19 f20 2))) (=> (= (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0)) (=> (= (f6 ?v_1 ?v0) f1) (=> (= (f6 ?v_1 ?v1) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (=> (<= (f16 (f21 f22 ?v0) ?v_0) (f16 (f21 f22 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f19 f20 2))) (=> (= (f6 (f7 f8 (f9 (f10 f11 ?v0) ?v_0)) (f9 (f10 f11 ?v1) ?v_0)) f1) (=> (= (f6 (f7 f8 f15) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (let ((?v_0 (f19 f20 (+ (f16 f17 ?v1) 1)))) (=> (= (f16 (f21 f22 ?v0) ?v_0) (f16 (f21 f22 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S5)) (let ((?v_1 (f7 f8 f15)) (?v_0 (f19 f20 (+ (f16 f17 ?v1) 1)))) (=> (= (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v2) ?v_0)) (=> (= (f6 ?v_1 ?v0) f1) (=> (= (f6 ?v_1 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (let ((?v_0 (f19 f20 (+ (f16 f17 ?v1) 1)))) (=> (<= (f16 (f21 f22 ?v0) ?v_0) (f16 (f21 f22 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S5)) (let ((?v_0 (f19 f20 (+ (f16 f17 ?v1) 1)))) (=> (= (f6 (f7 f8 (f9 (f10 f11 ?v0) ?v_0)) (f9 (f10 f11 ?v2) ?v_0)) f1) (=> (= (f6 (f7 f8 f15) ?v2) f1) (= (f6 (f7 f8 ?v0) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (= (f16 (f21 f22 ?v0) ?v1) (f16 (f21 f22 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f16 f17 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S5)) (let ((?v_0 (f7 f8 f15))) (=> (= (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v2) ?v1)) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (=> (< 0 (f16 f17 ?v1)) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f16 (f21 f22 ?v0) ?v2) (f16 (f21 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f15) ?v0) f1) (= (f6 (f7 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (<= 0 (f16 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f7 f8 f15))) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (f6 (f7 f8 f15) (f9 (f10 f11 (f30 f38 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S8)) (<= 0 (f16 (f21 f22 (f33 f39 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= 0 (f16 (f21 f22 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f15) (f9 (f10 f11 ?v0) (f19 f20 2))) f1)))
(assert (forall ((?v0 S8)) (= (f16 (f21 f22 0) ?v0) (ite (= ?v0 (f19 f20 0)) 1 0))))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f15) ?v0) (ite (= ?v0 (f19 f20 0)) f14 f15))))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 f28) ?v0) (ite (= ?v0 (f19 f20 0)) f26 f28))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f18 (f30 f38 ?v0)) f14) f1) (= (f6 (f7 f18 (f9 (f10 f11 ?v0) (f19 f20 2))) f14) f1))))
(assert (< 0 1))
(assert (= (f6 (f7 f18 f15) f14) f1))
(assert (not (< 1 0)))
(assert (not (= (f6 (f7 f18 f14) f15) f1)))
(assert (<= 0 1))
(assert (= (f6 (f7 f8 f15) f14) f1))
(assert (not (<= 1 0)))
(assert (not (= (f6 (f7 f8 f14) f15) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f18 f15))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (exists ((?v2 S5)) (let ((?v_1 (f7 f18 ?v2))) (and (= (f6 ?v_0 ?v2) f1) (and (= (f6 ?v_1 ?v0) f1) (= (f6 ?v_1 ?v1) f1))))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f18 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f18 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (= (f30 f38 f14) f14))
(assert (= (f33 f39 1) 1))
(assert (not (= 1 0)))
(assert (not (= f14 f15)))
(assert (not (= f26 f28)))
(assert (not (= 0 1)))
(assert (not (= f15 f14)))
(assert (not (= f28 f26)))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (=> (= (f6 (f7 f18 ?v2) ?v0) f1) (= (f6 (f7 f8 ?v2) ?v1) f1))) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (forall ((?v3 S5)) (=> (= (f6 (f7 f18 ?v0) ?v3) f1) (=> (= (f6 (f7 f18 ?v3) ?v1) f1) (= (f6 (f7 f8 ?v3) ?v2) f1)))) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f18 f15) ?v0) f1) (= (f30 f38 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f33 f39 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f18 f15) (f30 f38 ?v0)) f1) (not (= ?v0 f15)))))
(assert (forall ((?v0 Int)) (= (< 0 (f33 f39 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f18 (f30 f38 ?v0)) f15) f1))))
(assert (forall ((?v0 Int)) (not (< (f33 f39 ?v0) 0))))
(assert (= (f30 f38 f15) f15))
(assert (= (f33 f39 0) 0))
(assert (forall ((?v0 S14)) (= (= f28 ?v0) (= ?v0 f28))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f15 ?v0) (= ?v0 f15))))
(assert (forall ((?v0 S5)) (= (= (f30 f38 ?v0) f15) (= ?v0 f15))))
(assert (forall ((?v0 Int)) (= (= (f33 f39 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 (f30 f38 ?v0)) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f33 f39 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) (f30 f38 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f33 f39 ?v0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S5)) (= (= f14 ?v0) (= ?v0 f14))))
(assert (forall ((?v0 S14)) (= (= f26 ?v0) (= ?v0 f26))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f15) ?v0) f1) (= (f30 f38 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f33 f39 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f30 f38 ?v0)) f15) f1) (= ?v0 f15))))
(assert (forall ((?v0 Int)) (= (<= (f33 f39 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f15) (f30 f38 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f33 f39 ?v0))))
(assert (forall ((?v0 S8) (?v1 S5)) (=> (< 0 (f16 f17 ?v0)) (=> (= (f6 (f7 f18 f15) ?v1) f1) (exists ((?v2 S5)) (and (and (= (f6 (f7 f18 f15) ?v2) f1) (= (f9 (f10 f11 ?v2) ?v0) ?v1)) (forall ((?v3 S5)) (=> (and (= (f6 (f7 f18 f15) ?v3) f1) (= (f9 (f10 f11 ?v3) ?v0) ?v1)) (= ?v3 ?v2)))))))))
(assert (forall ((?v0 S8) (?v1 S5)) (=> (< 0 (f16 f17 ?v0)) (=> (= (f6 (f7 f18 f15) ?v1) f1) (exists ((?v2 S5)) (and (= (f6 (f7 f18 f15) ?v2) f1) (= (f9 (f10 f11 ?v2) ?v0) ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (= (f6 (f7 f18 f15) ?v0) f1) (exists ((?v2 S5)) (and (= (f6 (f7 f18 f15) ?v2) f1) (= (f9 (f10 f11 ?v2) (f19 f20 (+ (f16 f17 ?v1) 1))) ?v0))))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f18 f15) ?v0) f1) (= (= (f6 (f7 f8 f15) (f30 f40 ?v0)) f1) (= (f6 (f7 f8 f14) ?v0) f1)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f15) (f30 f40 ?v0)) f1) (=> (= (f6 (f7 f18 f15) ?v0) f1) (= (f6 (f7 f8 f14) ?v0) f1)))))
(assert (forall ((?v0 S4)) (=> (exists ((?v1 S5)) (= (f6 ?v0 ?v1) f1)) (=> (exists ((?v1 S5)) (forall ((?v2 S5)) (=> (= (f6 ?v0 ?v2) f1) (= (f6 (f7 f18 ?v2) ?v1) f1)))) (exists ((?v1 S5)) (forall ((?v2 S5)) (= (exists ((?v3 S5)) (and (= (f6 ?v0 ?v3) f1) (= (f6 (f7 f18 ?v2) ?v3) f1))) (= (f6 (f7 f18 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f18 f15) ?v0) f1) (= (f6 (f7 f18 (f30 f40 ?v0)) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f18 f15))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (= (f30 f40 ?v0) (f30 f40 ?v1)) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f18 f15))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (= (f6 (f7 f18 (f30 f40 ?v0)) (f30 f40 ?v1)) f1) (= (f6 (f7 f18 ?v0) ?v1) f1)))))))
(assert (= (f30 f40 f14) f15))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f18 f15))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (= (f6 (f7 f8 (f30 f40 ?v0)) (f30 f40 ?v1)) f1) (= (f6 (f7 f8 ?v0) ?v1) f1)))))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f14) ?v0) f1) (= (f6 (f7 f8 f15) (f30 f40 ?v0)) f1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f18 f15))) (=> (= (f6 ?v_0 (f30 f40 ?v0)) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f18 f14) ?v0) f1))))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f18 f15) ?v0) f1) (=> (= (f6 (f7 f18 ?v0) f14) f1) (= (f6 (f7 f18 (f30 f40 ?v0)) f15) f1)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f18 f15) ?v0) f1) (= (= (f6 (f7 f18 (f30 f40 ?v0)) f15) f1) (= (f6 (f7 f18 ?v0) f14) f1)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f18 f15) ?v0) f1) (= (= (f30 f40 ?v0) f15) (= ?v0 f14)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f18 f15))) (=> (= (f6 ?v_0 ?v0) f1) (= (= (f6 ?v_0 (f30 f40 ?v0)) f1) (= (f6 (f7 f18 f14) ?v0) f1))))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f18 f14) ?v0) f1) (= (f6 (f7 f18 f15) (f30 f40 ?v0)) f1))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (= (f6 (f7 f18 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (= (f6 (f7 f18 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (exists ((?v2 S5)) (and (= (f6 (f7 f18 ?v0) ?v2) f1) (= (f6 (f7 f18 ?v2) ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S16) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f30 ?v1 ?v2)) (=> (= (f6 (f7 f18 ?v3) ?v2) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f18 ?v5) ?v4) f1) (= (f6 (f7 f18 (f30 ?v1 ?v5)) (f30 ?v1 ?v4)) f1))) (= (f6 (f7 f18 (f30 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S18) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f33 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f33 ?v1 ?v5) (f33 ?v1 ?v4)))) (< (f33 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S16) (?v3 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (= (f30 ?v2 ?v0) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f18 ?v5) ?v4) f1) (= (f6 (f7 f18 (f30 ?v2 ?v5)) (f30 ?v2 ?v4)) f1))) (= (f6 (f7 f18 ?v3) (f30 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S18) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f33 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f33 ?v2 ?v5) (f33 ?v2 ?v4)))) (< ?v3 (f33 ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f33 (f34 f35 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f30 (f31 f32 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f33 (f34 f35 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f30 (f31 f32 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S18) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f33 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f33 ?v1 ?v5) (f33 ?v1 ?v4)))) (<= (f33 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S16) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f30 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v3) ?v2) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (= (f6 (f7 f8 (f30 ?v1 ?v5)) (f30 ?v1 ?v4)) f1))) (= (f6 (f7 f8 (f30 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f33 (f34 f37 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f30 (f31 f36 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f33 (f34 f37 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f30 (f31 f36 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S18) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f33 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f33 ?v2 ?v5) (f33 ?v2 ?v4)))) (<= ?v3 (f33 ?v2 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S16) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f30 ?v2 ?v0) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (= (f6 (f7 f8 (f30 ?v2 ?v5)) (f30 ?v2 ?v4)) f1))) (= (f6 (f7 f8 ?v3) (f30 ?v2 ?v1)) f1))))))
(assert (= f35 (f41 f42 f5)))
(assert (= f32 (f43 f44 f8)))
(assert (= f37 (f41 f45 f5)))
(assert (= f36 (f43 f46 f8)))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f15) ?v0) f1) (= (f6 (f7 f8 (f30 f40 (f30 (f31 f47 f14) ?v0))) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f16 (f21 f22 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (=> (= (f6 (f7 f18 f15) ?v0) f1) (=> (= (f6 (f7 f18 ?v0) f14) f1) (= (f6 (f7 f18 (f30 (f31 f48 ?v0) ?v_0)) ?v_0) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f18 f15))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f30 f40 (f30 (f31 f48 ?v0) ?v1)) (f30 (f31 f47 (f30 f40 ?v0)) (f30 f40 ?v1))))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f8 f15))) (= (= (f6 ?v_0 (f30 (f31 f47 ?v0) ?v0)) f1) (= (f6 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f30 (f31 f47 ?v0) ?v0)) f15) f1) (= (f6 (f7 f8 ?v0) f15) f1))))
(assert (forall ((?v0 Int)) (= (<= (+ ?v0 ?v0) 0) (<= ?v0 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f15))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f30 (f31 f47 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f15))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (= (f30 (f31 f47 ?v0) ?v1) f15) (and (= ?v0 f15) (= ?v1 f15))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v1))) (=> (= (f6 (f7 f8 f15) ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 ?v_0 (f30 (f31 f47 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v1))) (=> (= (f6 (f7 f8 f15) ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 ?v_0 (f30 (f31 f47 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f15) f1) (=> (= (f6 (f7 f8 ?v1) f15) f1) (= (f6 (f7 f8 (f30 (f31 f47 ?v0) ?v1)) f15) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f18 f15))) (= (= (f6 ?v_0 (f30 (f31 f47 ?v0) ?v0)) f1) (= (f6 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (+ ?v0 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f18 (f30 (f31 f47 ?v0) ?v0)) f15) f1) (= (f6 (f7 f18 ?v0) f15) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f18 f15))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f30 (f31 f47 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) f15) f1) (=> (= (f6 (f7 f18 ?v1) f15) f1) (= (f6 (f7 f18 (f30 (f31 f47 ?v0) ?v1)) f15) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v1))) (=> (= (f6 (f7 f18 f15) ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 ?v_0 (f30 (f31 f47 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f18 ?v2) ?v3) f1) (= (f6 (f7 f18 (f30 (f31 f47 ?v0) ?v2)) (f30 (f31 f47 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f18 (f30 (f31 f47 ?v0) ?v2)) (f30 (f31 f47 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S5)) (= (f30 (f31 f47 ?v0) f15) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S14)) (= (f49 (f50 f51 ?v0) f28) ?v0)))
(assert (forall ((?v0 S5)) (= (f30 (f31 f47 ?v0) f15) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S14)) (= (f49 (f50 f51 ?v0) f28) ?v0)))
(assert (forall ((?v0 S5)) (= (= f15 (f30 (f31 f47 ?v0) ?v0)) (= ?v0 f15))))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (f30 (f31 f47 f15) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S14)) (= (f49 (f50 f51 f28) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f30 (f31 f47 f15) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S14)) (= (f49 (f50 f51 f28) ?v0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f30 f38 (f30 (f31 f47 ?v0) ?v1))) (f30 (f31 f47 (f30 f38 ?v0)) (f30 f38 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f33 f39 (+ ?v0 ?v1)) (+ (f33 f39 ?v0) (f33 f39 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f30 (f31 f47 ?v0) ?v1)) (f30 (f31 f47 ?v2) ?v1)) f1) (= (f6 (f7 f8 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f31 f47 ?v0))) (= (= (f6 (f7 f8 (f30 ?v_0 ?v1)) (f30 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f30 (f31 f47 ?v0) ?v2)) (f30 (f31 f47 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f31 f47 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f30 ?v_0 ?v0)) (f30 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f8 (f30 (f31 f47 ?v0) ?v2)) (f30 (f31 f47 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 (f30 (f31 f47 ?v0) ?v1)) (f30 (f31 f47 ?v2) ?v1)) f1) (= (f6 (f7 f8 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f31 f47 ?v0))) (=> (= (f6 (f7 f8 (f30 ?v_0 ?v1)) (f30 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f30 (f31 f48 f14) ?v0) ?v0)))
(assert (forall ((?v0 S14)) (= (f49 (f50 f52 f26) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f30 (f31 f48 f14) ?v0) ?v0)))
(assert (forall ((?v0 S14)) (= (f49 (f50 f52 f26) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f30 (f31 f48 ?v0) f14) ?v0)))
(assert (forall ((?v0 S14)) (= (f49 (f50 f52 ?v0) f26) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f30 (f31 f48 ?v0) f14) ?v0)))
(assert (forall ((?v0 S14)) (= (f49 (f50 f52 ?v0) f26) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f30 (f31 f47 (f30 f38 ?v0)) (f30 f38 ?v1)))) (= (f30 f38 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f33 f39 ?v0) (f33 f39 ?v1)))) (= (f33 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f31 f47 ?v0))) (= (f30 (f31 f47 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f30 (f31 f47 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S14) (?v1 S14) (?v2 S14)) (let ((?v_0 (f50 f51 ?v0))) (= (f49 (f50 f51 (f49 ?v_0 ?v1)) ?v2) (f49 ?v_0 (f49 (f50 f51 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f31 f48 ?v0))) (= (f30 (f31 f48 (f30 ?v_0 ?v1)) ?v2) (f30 ?v_0 (f30 (f31 f48 ?v1) ?v2))))))
(assert (forall ((?v0 S14) (?v1 S14) (?v2 S14)) (let ((?v_0 (f50 f52 ?v0))) (= (f49 (f50 f52 (f49 ?v_0 ?v1)) ?v2) (f49 ?v_0 (f49 (f50 f52 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f30 (f31 f47 (f30 (f31 f32 ?v0) ?v1)) ?v2) (f30 (f31 f32 (f30 (f31 f47 ?v0) ?v2)) (f30 (f31 f47 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f33 (f34 f35 ?v0) ?v1) ?v2) (f33 (f34 f35 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f30 (f31 f47 (f30 (f31 f36 ?v0) ?v1)) ?v2) (f30 (f31 f36 (f30 (f31 f47 ?v0) ?v2)) (f30 (f31 f47 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f33 (f34 f37 ?v0) ?v1) ?v2) (f33 (f34 f37 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f31 f47 ?v0))) (= (= (f30 ?v_0 ?v1) (f30 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S14) (?v1 S14) (?v2 S14)) (let ((?v_0 (f50 f51 ?v0))) (= (= (f49 ?v_0 ?v1) (f49 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f30 (f31 f47 ?v0) ?v1) (f30 (f31 f47 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S14) (?v1 S14) (?v2 S14)) (= (= (f49 (f50 f51 ?v0) ?v1) (f49 (f50 f51 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f31 f47 ?v0))) (=> (= (f30 ?v_0 ?v1) (f30 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S14) (?v1 S14) (?v2 S14)) (let ((?v_0 (f50 f51 ?v0))) (=> (= (f49 ?v_0 ?v1) (f49 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f31 f47 ?v0))) (=> (= (f30 ?v_0 ?v1) (f30 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S14) (?v1 S14) (?v2 S14)) (let ((?v_0 (f50 f51 ?v0))) (=> (= (f49 ?v_0 ?v1) (f49 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f30 (f31 f47 ?v0) ?v1) (f30 (f31 f47 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S14) (?v1 S14) (?v2 S14)) (=> (= (f49 (f50 f51 ?v0) ?v1) (f49 (f50 f51 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f18 (f30 (f31 f47 ?v0) ?v1)) (f30 (f31 f47 ?v2) ?v1)) f1) (= (f6 (f7 f18 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f31 f47 ?v0))) (= (= (f6 (f7 f18 (f30 ?v_0 ?v1)) (f30 ?v_0 ?v2)) f1) (= (f6 (f7 f18 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f1) (= (f6 (f7 f18 (f30 (f31 f47 ?v0) ?v2)) (f30 (f31 f47 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S8)) (= (f19 f20 (f16 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f19 f20 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f17 (f19 f20 ?v0)) 0))))
(check-sat)
(exit)
