(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S3) S2)
(declare-fun f5 (S4 S3) S3)
(declare-fun f6 (S5 S3) S4)
(declare-fun f7 () S5)
(declare-fun f8 () S3)
(declare-fun f9 () S3)
(declare-fun f10 (S6 S7) S3)
(declare-fun f11 () S6)
(declare-fun f12 () S7)
(declare-fun f13 () S5)
(declare-fun f14 () S3)
(declare-fun f15 () S7)
(declare-fun f16 () S3)
(declare-fun f17 () S4)
(declare-fun f18 (S8 S7) S7)
(declare-fun f19 (S9 S7) S8)
(declare-fun f20 () S9)
(declare-fun f21 (S10 Int) Int)
(declare-fun f22 () S10)
(declare-fun f23 () S4)
(declare-fun f24 () S7)
(declare-fun f25 () S7)
(declare-fun f26 () S11)
(declare-fun f27 () S11)
(declare-fun f28 () S9)
(declare-fun f29 (S12 S11) S11)
(declare-fun f30 (S13 S11) S12)
(declare-fun f31 () S13)
(declare-fun f32 (S14 S3) S7)
(declare-fun f33 () S14)
(declare-fun f34 () S4)
(declare-fun f35 (S3) S2)
(declare-fun f36 (S15 S11) S8)
(declare-fun f37 () S15)
(declare-fun f38 () S11)
(declare-fun f39 () S4)
(declare-fun f40 () S8)
(declare-fun f41 (S17 S7) S12)
(declare-fun f42 () S17)
(declare-fun f43 () S10)
(declare-fun f44 () S11)
(declare-fun f45 () S11)
(declare-fun f46 (S8) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 (f6 f7 f8) f9)) (f10 f11 f12)) f1)))
(assert (= (f3 (f4 f8) (f5 (f6 f13 (f10 f11 f12)) f9)) f1))
(assert (= (f3 (f4 f14) f9) f1))
(assert (= (f3 (f4 f14) f9) f1))
(assert (= (f3 (f4 f14) f8) f1))
(assert (= (f3 (f4 f8) (f5 (f6 f13 (f10 f11 f12)) f9)) f1))
(assert (not (= f12 f15)))
(assert (= (f3 (f4 f8) f16) f1))
(assert (= (f3 (f4 f14) (f5 (f6 f13 (f10 f11 f12)) f9)) f1))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 (f5 f17 ?v0)) ?v1) f1) (=> (= (f3 (f4 (f5 f17 ?v2)) ?v3) f1) (= (f3 (f4 (f5 f17 (f5 (f6 f7 ?v0) ?v2))) (f5 (f6 f7 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S7) (?v3 S3)) (=> (= (f3 (f4 (f10 f11 ?v0)) ?v1) f1) (=> (= (f3 (f4 (f10 f11 ?v2)) ?v3) f1) (= (f3 (f4 (f10 f11 (f18 (f19 f20 ?v0) ?v2))) (f5 (f6 f7 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f17 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f17 ?v0)) (f5 f17 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f10 f11 (f18 (f19 f20 ?v0) ?v1)) (f5 (f6 f7 (f10 f11 ?v0)) (f10 f11 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f21 f22 ?v0)) (?v_1 (f21 f22 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f5 f23 ?v0)) (?v_1 (f5 f23 ?v2))) (=> (= (f3 (f4 ?v_0) ?v1) f1) (=> (= (f3 (f4 ?v_1) ?v3) f1) (= (f3 (f4 (f5 (f6 f7 ?v_0) ?v_1)) (f5 (f6 f7 ?v1) ?v3)) f1))))))
(assert (exists ((?v0 S3)) (let ((?v_0 (f4 ?v0))) (and (= (f3 (f4 f14) ?v0) f1) (and (= (f3 ?v_0 (f5 (f6 f13 (f10 f11 f12)) f9)) f1) (= (f3 ?v_0 f16) f1))))))
(assert (=> (forall ((?v0 S3)) (let ((?v_0 (f4 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 ?v_0 (f5 (f6 f13 (f10 f11 f12)) f9)) f1) (=> (= (f3 ?v_0 f16) f1) false))))) false))
(assert (forall ((?v0 S2)) (=> (exists ((?v1 S3)) (= (f3 ?v0 ?v1) f1)) (=> (exists ((?v1 S3)) (forall ((?v2 S3)) (=> (= (f3 ?v0 ?v2) f1) (= (f3 (f4 ?v2) ?v1) f1)))) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (exists ((?v3 S3)) (and (= (f3 ?v0 ?v3) f1) (= (f3 (f4 ?v2) ?v3) f1))) (= (f3 (f4 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S7)) (not (= (f3 (f4 (f10 f11 ?v0)) f14) f1))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 (f5 f17 ?v0)) f14) f1))))
(assert (forall ((?v0 S3)) (= (not (= (f3 (f4 f14) (f5 (f6 f7 ?v0) ?v0)) f1)) (= ?v0 f14))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f4 (f5 (f6 f7 ?v1) ?v0)) (f5 (f6 f7 ?v2) ?v0)) f1) (= (f3 (f4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) ?v2) f1) (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 (f5 (f6 f7 ?v0) ?v0)) f14) f1))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (not (= f24 f15)))
(assert (not (= f25 f15)))
(assert (not (= f26 f27)))
(assert (not (= f16 f14)))
(assert (not (= 1 0)))
(assert (not (= f15 f25)))
(assert (not (= f27 f26)))
(assert (not (= f14 f16)))
(assert (not (= 0 1)))
(assert (not (= f14 f16)))
(assert (= (f21 f22 1) 1))
(assert (= (f5 f23 f16) f16))
(assert (= (f10 f11 f25) f16))
(assert (= (f5 f17 f16) f16))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f28 f15) ?v0) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f28 f15) ?v0) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f28 ?v0) f15) f15)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f28 ?v0) f25) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 ?v0) f16) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f28 ?v0) ?v0) (ite (= ?v0 f15) f15 f25))))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 ?v0) ?v0) (ite (= ?v0 f14) f14 f16))))
(assert (forall ((?v0 S7)) (=> (not (= ?v0 f15)) (= (f18 (f19 f28 ?v0) ?v0) f25))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f14)) (= (f5 (f6 f13 ?v0) ?v0) f16))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 f15)) (= (= (f18 (f19 f28 ?v1) ?v0) f25) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (= (f5 (f6 f13 ?v1) ?v0) f16) (= ?v1 ?v0)))))
(assert (= (f3 (f4 f14) f16) f1))
(assert (< 0 1))
(assert (not (= (f3 (f4 f16) f14) f1)))
(assert (not (< 1 0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f16) ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (f5 f17 (f5 (f6 f13 ?v1) ?v0)) (f5 (f6 f13 (f5 f17 ?v1)) (f5 f17 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 f15)) (= (f10 f11 (f18 (f19 f28 ?v1) ?v0)) (f5 (f6 f13 (f10 f11 ?v1)) (f10 f11 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (=> (= (f5 (f6 f7 ?v1) ?v0) ?v2) (= ?v1 (f5 (f6 f13 ?v2) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (=> (= (f18 (f19 f20 ?v1) ?v0) ?v2) (= ?v1 (f18 (f19 f28 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (=> (= ?v1 (f5 (f6 f7 ?v2) ?v0)) (= (f5 (f6 f13 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (=> (= ?v1 (f18 (f19 f20 ?v2) ?v0)) (= (f18 (f19 f28 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (= (= (f5 (f6 f13 ?v1) ?v0) ?v2) (= ?v1 (f5 (f6 f7 ?v2) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (= (= (f18 (f19 f28 ?v1) ?v0) ?v2) (= ?v1 (f18 (f19 f20 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (= (= ?v1 (f5 (f6 f13 ?v2) ?v0)) (= (f5 (f6 f7 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (= (= ?v1 (f18 (f19 f28 ?v2) ?v0)) (= (f18 (f19 f20 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f10 f11 (f18 (f19 f28 ?v0) ?v1)) (f5 (f6 f13 (f10 f11 ?v0)) (f10 f11 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f17 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 (f5 f17 ?v0)) (f5 f17 ?v1)))))
(assert (forall ((?v0 S3)) (= (= (f5 f17 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 S7)) (= (= (f10 f11 ?v0) f14) (= ?v0 f15))))
(assert (= (f5 f17 f14) f14))
(assert (= (f10 f11 f15) f14))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f16))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (f5 (f6 f13 ?v1) ?v2)) (f5 (f6 f13 (f5 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f18 (f19 f28 ?v1) ?v2)) (f18 (f19 f28 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f5 (f6 f7 ?v0) ?v1) f14) (or (= ?v0 f14) (= ?v1 f14)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f18 (f19 f20 ?v0) ?v1) f15) (or (= ?v0 f15) (= ?v1 f15)))))
(assert (forall ((?v0 S11) (?v1 S11)) (=> (= (f29 (f30 f31 ?v0) ?v1) f27) (or (= ?v0 f27) (= ?v1 f27)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (=> (not (= ?v1 f14)) (not (= (f5 (f6 f7 ?v0) ?v1) f14))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 f15)) (=> (not (= ?v1 f15)) (not (= (f18 (f19 f20 ?v0) ?v1) f15))))))
(assert (forall ((?v0 S11) (?v1 S11)) (=> (not (= ?v0 f27)) (=> (not (= ?v1 f27)) (not (= (f29 (f30 f31 ?v0) ?v1) f27))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f5 (f6 f7 ?v0) ?v1) f14) (or (= ?v0 f14) (= ?v1 f14)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f18 (f19 f20 ?v0) ?v1) f15) (or (= ?v0 f15) (= ?v1 f15)))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (= (f29 (f30 f31 ?v0) ?v1) f27) (or (= ?v0 f27) (= ?v1 f27)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f15) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f15) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f15) f15)))
(assert (forall ((?v0 S11)) (= (f29 (f30 f31 ?v0) f27) f27)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f15) ?v0) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f15) ?v0) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f15) ?v0) f15)))
(assert (forall ((?v0 S11)) (= (f29 (f30 f31 f27) ?v0) f27)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f13 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v0)) (f5 (f6 f13 ?v1) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (not (= ?v0 f14)) (= (= (f5 ?v_0 ?v1) (f5 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (= (= (f5 (f6 f7 ?v1) ?v0) (f5 (f6 f7 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f14) (f5 f17 ?v0)) f1) (not (= ?v0 f14)))))
(assert (forall ((?v0 S7)) (= (= (f3 (f4 f14) (f10 f11 ?v0)) f1) (not (= ?v0 f15)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 f23 ?v0))) (= (f5 (f6 f7 ?v_0) ?v_0) (f5 (f6 f7 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 f22 (* ?v0 ?v1)) (* (f21 f22 ?v0) (f21 f22 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f23 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f23 ?v0)) (f5 f23 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f5 f23 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 f17 ?v0))) (= (f5 f23 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) f14) f1) (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) f14) f1) (= (f3 (f4 (f5 (f6 f7 ?v1) ?v2)) (f5 (f6 f7 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 f14) (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f4 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 (f5 (f6 f7 ?v1) ?v0)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f4 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (or (and (= (f3 (f4 f14) ?v0) f1) (= (f3 (f4 ?v1) ?v2) f1)) (and (= (f3 (f4 ?v0) f14) f1) (= (f3 (f4 ?v2) ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v1)) f1) (or (and (= (f3 (f4 f14) ?v1) f1) (= (f3 (f4 ?v0) ?v2) f1)) (and (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f13 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) f14) f1) (=> (= (f3 (f4 f14) (f5 (f6 f7 ?v0) ?v1)) f1) (= (f3 (f4 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14)) (?v_1 (f6 f13 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v1) ?v0)) f1) (= (f3 (f4 (f5 ?v_1 ?v1)) (f5 ?v_1 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f4 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f4 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1) (= (f3 (f4 ?v2) (f5 (f6 f7 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 (f5 (f6 f7 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) (f5 (f6 f7 ?v2) ?v0)) f1) (= (f3 (f4 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f4 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 ?v1) (f5 (f6 f7 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f4 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1) (= (f3 (f4 (f5 (f6 f7 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f14)) (?v_0 (f5 (f6 f7 ?v2) ?v1))) (= (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) ?v2) f1) (ite (= (f3 ?v_1 ?v1) f1) (= (f3 (f4 ?v0) ?v_0) f1) (ite (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 ?v_0) ?v0) f1) (= (f3 ?v_1 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 ?v0)) (?v_0 (f5 (f6 f7 ?v0) ?v2))) (= (= (f3 ?v_1 (f5 (f6 f13 ?v1) ?v2)) f1) (ite (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 ?v_0) ?v1) f1) (ite (= (f3 (f4 ?v2) f14) f1) (= (f3 (f4 ?v1) ?v_0) f1) (= (f3 ?v_1 f14) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f23 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 (f5 f23 ?v0)) (f5 f23 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (f5 f23 (f5 (f6 f13 ?v1) ?v0)) (f5 (f6 f13 (f5 f23 ?v1)) (f5 f23 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f5 (f6 f7 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 ?v2) ?v3)) (f5 (f6 f13 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (= (f18 (f19 f20 (f18 (f19 f28 ?v0) ?v1)) (f18 (f19 f28 ?v2) ?v3)) (f18 (f19 f28 (f18 (f19 f20 ?v0) ?v2)) (f18 (f19 f20 ?v1) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (= (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 ?v0) f14) f1) (= (f3 (f4 ?v1) f14) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (= (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) f14) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 ?v1) f14) f1)) (and (= (f3 (f4 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f4 ?v0) ?v2) f1)) (and (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 ?v2) ?v0) f1)) (not (= ?v1 f14)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (f5 (f6 f13 (f5 f23 ?v1)) ?v0) (f5 f23 (f5 (f6 f13 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 f14) (f5 (f6 f13 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v2)) (f5 (f6 f13 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) f14) f1) (= (f3 (f4 (f5 (f6 f13 ?v1) ?v2)) (f5 (f6 f13 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= ?v0 (f5 (f6 f13 ?v1) ?v2)) (ite (not (= ?v2 f14)) (= (f5 (f6 f7 ?v0) ?v2) ?v1) (= ?v0 f14)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= ?v0 (f18 (f19 f28 ?v1) ?v2)) (ite (not (= ?v2 f15)) (= (f18 (f19 f20 ?v0) ?v2) ?v1) (= ?v0 f15)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f5 (f6 f13 ?v0) ?v1) ?v2) (ite (not (= ?v1 f14)) (= ?v0 (f5 (f6 f7 ?v2) ?v1)) (= ?v2 f14)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f18 (f19 f28 ?v0) ?v1) ?v2) (ite (not (= ?v1 f15)) (= ?v0 (f18 (f19 f20 ?v2) ?v1)) (= ?v2 f15)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (= (f5 (f6 f13 (f5 (f6 f7 ?v1) ?v0)) (f5 (f6 f7 ?v2) ?v0)) (f5 (f6 f13 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (= (f18 (f19 f28 (f18 (f19 f20 ?v1) ?v0)) (f18 (f19 f20 ?v2) ?v0)) (f18 (f19 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (not (= ?v0 f14)) (= (f5 (f6 f13 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) (f5 (f6 f13 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (=> (not (= ?v0 f15)) (= (f18 (f19 f28 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2)) (f18 (f19 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f14)) (=> (not (= ?v1 f14)) (= (= (f5 (f6 f13 ?v2) ?v0) (f5 (f6 f13 ?v3) ?v1)) (= (f5 (f6 f7 ?v2) ?v1) (f5 (f6 f7 ?v3) ?v0)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (not (= ?v0 f15)) (=> (not (= ?v1 f15)) (= (= (f18 (f19 f28 ?v2) ?v0) (f18 (f19 f28 ?v3) ?v1)) (= (f18 (f19 f20 ?v2) ?v1) (f18 (f19 f20 ?v3) ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (exists ((?v2 S3)) (let ((?v_1 (f4 ?v2))) (and (= (f3 ?v_0 ?v2) f1) (and (= (f3 ?v_1 ?v0) f1) (= (f3 ?v_1 ?v1) f1))))))))))
(assert (not (= (f32 f33 f8) f15)))
(assert (forall ((?v0 S11)) (= (f29 (f30 f31 f26) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f25) ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S11)) (= (f29 (f30 f31 f26) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f25) ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S11)) (= (f29 (f30 f31 f26) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f25) ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f5 f34 ?v0) (f5 f34 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f32 f33 ?v0) (f32 f33 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3)) (= (f5 f17 (f5 f34 ?v0)) (f5 f23 ?v0))))
(assert (forall ((?v0 S3)) (= (f10 f11 (f32 f33 ?v0)) (f5 f23 ?v0))))
(assert (= (f5 f34 f14) f14))
(assert (= (f32 f33 f14) f15))
(assert (= (f5 f34 f14) f14))
(assert (= (f32 f33 f14) f15))
(assert (forall ((?v0 S3)) (= (= (f5 f34 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 S3)) (= (= (f32 f33 ?v0) f15) (= ?v0 f14))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f34 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f34 ?v0)) (f5 f34 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f32 f33 (f5 (f6 f7 ?v0) ?v1)) (f18 (f19 f20 (f32 f33 ?v0)) (f32 f33 ?v1)))))
(assert (= (f5 f34 f16) f16))
(assert (= (f32 f33 f16) f25))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f34 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 (f5 f34 ?v0)) (f5 f34 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f32 f33 (f5 (f6 f13 ?v0) ?v1)) (f18 (f19 f28 (f32 f33 ?v0)) (f32 f33 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (f5 f34 (f5 (f6 f13 ?v1) ?v0)) (f5 (f6 f13 (f5 f34 ?v1)) (f5 f34 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (f32 f33 (f5 (f6 f13 ?v1) ?v0)) (f18 (f19 f28 (f32 f33 ?v1)) (f32 f33 ?v0))))))
(assert (= (f21 f22 0) 0))
(assert (= (f5 f23 f14) f14))
(assert (forall ((?v0 S3)) (= (= f14 ?v0) (= ?v0 f14))))
(assert (forall ((?v0 S7)) (= (= f15 ?v0) (= ?v0 f15))))
(assert (forall ((?v0 S11)) (= (= f27 ?v0) (= ?v0 f27))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f21 f22 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f5 f23 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11) (?v3 S11)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) (f29 (f30 f31 ?v2) ?v3)) (f29 (f30 f31 (f29 ?v_0 ?v2)) (f29 (f30 f31 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) (f5 (f6 f7 ?v2) ?v3)) (f5 (f6 f7 (f5 ?v_0 ?v2)) (f5 (f6 f7 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 (f19 f20 ?v2) ?v3)) (f18 (f19 f20 (f18 ?v_0 ?v2)) (f18 (f19 f20 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11) (?v3 S11)) (let ((?v_1 (f30 f31 (f29 (f30 f31 ?v0) ?v1))) (?v_0 (f30 f31 ?v2))) (= (f29 ?v_1 (f29 ?v_0 ?v3)) (f29 ?v_0 (f29 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f6 f7 (f5 (f6 f7 ?v0) ?v1))) (?v_0 (f6 f7 ?v2))) (= (f5 ?v_1 (f5 ?v_0 ?v3)) (f5 ?v_0 (f5 ?v_1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_1 (f19 f20 (f18 (f19 f20 ?v0) ?v1))) (?v_0 (f19 f20 ?v2))) (= (f18 ?v_1 (f18 ?v_0 ?v3)) (f18 ?v_0 (f18 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11) (?v3 S11)) (let ((?v_0 (f30 f31 ?v0)) (?v_1 (f29 (f30 f31 ?v2) ?v3))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v_1) (f29 ?v_0 (f29 (f30 f31 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f6 f7 ?v0)) (?v_1 (f5 (f6 f7 ?v2) ?v3))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v_1) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f19 f20 ?v0)) (?v_1 (f18 (f19 f20 ?v2) ?v3))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v_1) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2) (f29 (f30 f31 (f29 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 (f6 f7 (f5 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 (f19 f20 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2) (f29 ?v_0 (f29 (f30 f31 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2) (f29 ?v_0 (f29 (f30 f31 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f29 (f30 f31 ?v1) ?v2)) (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2)) (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S11) (?v1 S11) (?v2 S11)) (let ((?v_1 (f30 f31 ?v0)) (?v_0 (f30 f31 ?v1))) (= (f29 ?v_1 (f29 ?v_0 ?v2)) (f29 ?v_0 (f29 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f6 f7 ?v0)) (?v_0 (f6 f7 ?v1))) (= (f5 ?v_1 (f5 ?v_0 ?v2)) (f5 ?v_0 (f5 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f19 f20 ?v0)) (?v_0 (f19 f20 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S11) (?v1 S11)) (= (f29 (f30 f31 ?v0) ?v1) (f29 (f30 f31 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v1) ?v0))))
(assert (forall ((?v0 S7)) (= (= f25 ?v0) (= ?v0 f25))))
(assert (forall ((?v0 S11)) (= (= f26 ?v0) (= ?v0 f26))))
(assert (forall ((?v0 S3)) (= (= f16 ?v0) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f21 f22 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (f5 f23 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f21 f22 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f14) (f5 f23 ?v0)) f1) (not (= ?v0 f14)))))
(assert (forall ((?v0 Int)) (not (< (f21 f22 ?v0) 0))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 (f5 f23 ?v0)) f14) f1))))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f15) f15)))
(assert (forall ((?v0 S11)) (= (f29 (f30 f31 ?v0) f27) f27)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f15) ?v0) f15)))
(assert (forall ((?v0 S11)) (= (f29 (f30 f31 f27) ?v0) f27)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S11)) (= (f29 (f30 f31 ?v0) f26) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f25) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f16) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S11)) (= (f29 (f30 f31 ?v0) f26) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f25) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f16) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f16) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f25) ?v0)))
(assert (= (f3 (f35 (f10 f11 (f32 f33 f8))) f16) f1))
(assert (let ((?v_0 (f32 f33 f8))) (= (f10 f11 (f18 (f19 f20 ?v_0) (f18 (f36 f37 f38) ?v_0))) (f10 f11 f12))))
(assert (forall ((?v0 S3)) (= (f5 f17 (f5 f39 ?v0)) (ite (= ?v0 f14) f14 f16))))
(assert (forall ((?v0 S7)) (= (f10 f11 (f18 f40 ?v0)) (ite (= ?v0 f15) f14 f16))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (= (f3 (f4 ?v0) ?v1) f1))))
(assert (=> (forall ((?v0 S7)) (=> (not (= ?v0 f15)) (= (f18 (f36 f37 f38) ?v0) f15))) (= f38 f27)))
(assert (forall ((?v0 S16) (?v1 S7)) (=> (= (f3 (f35 (f10 f11 ?v1)) f16) f1) (= (f3 (f35 (f10 f11 (f18 (f36 f37 f38) ?v1))) f9) f1))))
(assert (= (f3 (f35 (f10 f11 (f18 (f36 f37 f38) (f32 f33 f8)))) f9) f1))
(assert (let ((?v_0 (f32 f33 f8))) (= (f3 (f35 (f10 f11 (f18 (f19 f20 ?v_0) (f18 (f36 f37 f38) ?v_0)))) (f5 (f6 f7 f8) f9)) f1)))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f14) ?v0) f1) (forall ((?v1 S7)) (=> (= (f3 (f35 (f10 f11 ?v1)) f16) f1) (= (f3 (f35 (f10 f11 (f18 (f36 f37 f38) ?v1))) ?v0) f1))))))
(assert (forall ((?v0 S7)) (=> (not (= ?v0 f15)) (= (f18 (f36 f37 (f29 (f41 f42 f12) f38)) ?v0) f15))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f35 f14) ?v0) f1) (= (f5 f23 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f21 f22 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f35 (f5 f23 ?v0)) f14) f1) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (<= (f21 f22 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (f3 (f35 f14) (f5 f23 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f21 f22 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f35 ?v0) (f5 f23 ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 (f5 f23 ?v0)) ?v1) f1) (= (f3 (f35 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3)) (= (f18 f40 (f32 f33 ?v0)) (f32 f33 (f5 f39 ?v0)))))
(assert (forall ((?v0 S3)) (= (f5 f39 (f5 f34 ?v0)) (f5 f34 (f5 f39 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f35 ?v0) ?v1) f1) (or (= (f3 (f4 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 ?v0) ?v1) f1) (and (= (f3 (f35 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3)) (= (f3 (f35 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 f39 ?v0))) (= (f5 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f35 ?v0) ?v1) f1) (= (f3 (f35 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f35 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f35 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3)) (= (= (f5 f39 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 S7)) (= (= (f18 f40 ?v0) f15) (= ?v0 f15))))
(assert (forall ((?v0 S3)) (= (= (f5 f39 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= (f21 f43 ?v0) 0) (= ?v0 0))))
(assert (= (f5 f39 f14) f14))
(assert (= (f18 f40 f15) f15))
(assert (= (f5 f39 f14) f14))
(assert (= (f21 f43 0) 0))
(assert (forall ((?v0 S3)) (= (f5 f39 ?v0) (f5 (f6 f13 ?v0) (f5 f23 ?v0)))))
(assert (forall ((?v0 S3)) (= (f5 f23 ?v0) (f5 (f6 f7 ?v0) (f5 f39 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f39 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f39 ?v0)) (f5 f39 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f39 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f39 ?v0)) (f5 f39 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f18 f40 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f20 (f18 f40 ?v0)) (f18 f40 ?v1)))))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 (f5 f39 ?v0)) (f5 f23 ?v0)) ?v0)))
(assert (= (f5 f39 f16) f16))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f35 f14) (f5 (f6 f7 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (= (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f35 ?v0) f14) f1) (= (f3 (f35 ?v1) f14) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (= (= (f3 (f35 (f5 (f6 f7 ?v0) ?v1)) f14) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f35 ?v1) f14) f1)) (and (= (f3 (f35 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 f14) ?v0) f1) (= (f5 (f6 f7 (f5 f23 ?v1)) ?v0) (f5 f23 (f5 (f6 f7 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f21 f22 ?v1) ?v0) (f21 f22 (* ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 f14) ?v0) f1) (=> (= (f3 (f35 ?v1) f14) f1) (= (f3 (f35 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 f14) ?v0) f1) (=> (= (f3 (f35 ?v1) f14) f1) (= (f3 (f35 (f5 (f6 f7 ?v1) ?v0)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 ?v0) f14) f1) (=> (= (f3 (f35 f14) ?v1) f1) (= (f3 (f35 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 ?v0) f14) f1) (=> (= (f3 (f35 ?v1) f14) f1) (= (f3 (f35 f14) (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 f14) ?v2) f1) (= (f3 (f35 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 f14) ?v2) f1) (= (f3 (f35 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 f14) ?v2) f1) (= (f3 (f35 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 ?v2) f14) f1) (= (f3 (f35 (f5 (f6 f7 ?v1) ?v2)) (f5 (f6 f7 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 ?v2) f14) f1) (= (f3 (f35 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f35 f14))) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f35 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f35 f14))) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f35 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f35 ?v0) f14) f1) (= (f3 (f35 ?v1) f14) f1))) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (=> (and (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f35 ?v0) f14) f1)) (or (= (f3 ?v_0 ?v1) f1) (= (f3 (f35 ?v1) f14) f1))) (= (f5 f23 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f23 ?v0)) (f5 f23 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f21 f22 (* ?v0 ?v1)) (* (f21 f22 ?v0) (f21 f22 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f35 ?v1) f14) f1)) (and (= (f3 (f35 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1))) (= (f3 (f35 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (<= 0 1))
(assert (= (f3 (f35 f14) f16) f1))
(assert (not (<= 1 0)))
(assert (not (= (f3 (f35 f16) f14) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 ?v2) f14) f1) (= (f3 (f35 (f5 (f6 f13 ?v1) ?v2)) (f5 (f6 f13 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 f14) ?v2) f1) (= (f3 (f35 (f5 (f6 f13 ?v0) ?v2)) (f5 (f6 f13 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (= (= (f3 (f35 (f5 (f6 f13 ?v0) ?v1)) f14) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f35 ?v1) f14) f1)) (and (= (f3 (f35 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (= (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f35 ?v0) f14) f1) (= (f3 (f35 ?v1) f14) f1)))))))
(assert (forall ((?v0 S3)) (= (f3 (f35 f14) (f5 f17 ?v0)) f1)))
(assert (forall ((?v0 S7)) (= (f3 (f35 f14) (f10 f11 ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (= (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1) (and (or (= (f3 (f35 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1)) (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f35 ?v1) f14) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f14))) (= (= (f3 ?v_0 (f5 f39 ?v0)) f1) (= (f3 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f21 f43 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 (f5 f39 ?v0)) f14) f1) (= (f3 (f4 ?v0) f14) f1))))
(assert (forall ((?v0 Int)) (= (< (f21 f43 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f35 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f35 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f35 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f35 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) ?v3) f1) (=> (= (f3 (f4 f14) ?v1) f1) (=> (= (f3 (f35 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f35 f14))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f35 ?v2) ?v3) f1) (=> (= (f3 (f35 f14) ?v0) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) ?v3) f1) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f35 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v1)) f1) (=> (= (f3 (f35 f14) ?v1) f1) (= (f3 (f4 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v1)) f1) (=> (= (f3 (f35 f14) ?v1) f1) (= (f3 (f4 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (=> (= (f3 (f35 f14) ?v0) f1) (= (f3 (f4 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (=> (= (f3 (f35 f14) ?v0) f1) (= (f3 (f4 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v2 ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f35 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v1)) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f35 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f35 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f14) ?v0) f1) (= (f3 (f35 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v1 ?v0) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f35 ?v1) f16) f1) (= (f3 (f35 (f5 (f6 f7 ?v1) ?v0)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v0 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f35 ?v1) f16) f1) (= (f3 (f35 (f5 (f6 f7 ?v0) ?v1)) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 ?v0) f14) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f35 f14) (f5 (f6 f13 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 ?v0) f14) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f35 (f5 (f6 f13 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f35 f14) ?v0) f1) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (=> (= (f3 (f35 ?v2) ?v3) f1) (= (f3 (f35 (f5 (f6 f13 ?v0) ?v3)) (f5 (f6 f13 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f35 f14) ?v0) f1) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (=> (= (f3 (f35 ?v2) ?v3) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v3)) (f5 (f6 f13 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 (f4 ?v2) ?v3) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v3)) (f5 (f6 f13 ?v1) ?v2)) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f35 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f35 (f5 (f6 f13 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f35 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f35 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f35 ?v0) ?v2) f1)) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f35 ?v2) ?v0) f1))))))
(assert (forall ((?v0 S7)) (= (= (f3 (f35 (f10 f11 ?v0)) f14) f1) (= ?v0 f15))))
(assert (forall ((?v0 S3)) (= (= (f3 (f35 (f5 f17 ?v0)) f14) f1) (= ?v0 f14))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f3 (f35 (f10 f11 (f18 (f19 f20 ?v0) ?v1))) (f5 (f6 f7 (f10 f11 ?v0)) (f10 f11 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f35 (f5 f17 (f5 (f6 f7 ?v0) ?v1))) (f5 (f6 f7 (f5 f17 ?v0)) (f5 f17 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f35 (f5 (f6 f7 ?v1) ?v0)) (f5 (f6 f7 ?v2) ?v0)) f1) (= (f3 (f35 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f35 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f35 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (f5 f39 ?v0) f16))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f21 f43 ?v0) 1))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (f5 f39 ?v0) f16))))
(assert (forall ((?v0 Int)) (= (= (f21 f43 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f5 f39 ?v0) f16) (= (f3 (f4 f14) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f35 ?v0)) (?v_0 (f5 (f6 f7 ?v0) ?v2))) (= (= (f3 ?v_1 (f5 (f6 f13 ?v1) ?v2)) f1) (ite (= (f3 (f4 f14) ?v2) f1) (= (f3 (f35 ?v_0) ?v1) f1) (ite (= (f3 (f4 ?v2) f14) f1) (= (f3 (f35 ?v1) ?v_0) f1) (= (f3 ?v_1 f14) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 (f6 f7 ?v2) ?v1))) (= (= (f3 (f35 (f5 (f6 f13 ?v0) ?v1)) ?v2) f1) (ite (= (f3 (f4 f14) ?v1) f1) (= (f3 (f35 ?v0) ?v_0) f1) (ite (= (f3 (f4 ?v1) f14) f1) (= (f3 (f35 ?v_0) ?v0) f1) (= (f3 (f35 f14) ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f35 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1) (= (f3 (f35 (f5 (f6 f7 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f35 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1) (= (f3 (f35 ?v1) (f5 (f6 f7 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f35 ?v1) (f5 (f6 f7 ?v2) ?v0)) f1) (= (f3 (f35 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f35 (f5 (f6 f7 ?v1) ?v0)) ?v2) f1) (= (f3 (f35 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f35 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1) (= (f3 (f35 ?v2) (f5 (f6 f7 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f35 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1) (= (f3 (f35 (f5 (f6 f7 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f13 ?v2))) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 f14) ?v2) f1) (=> (= (f3 (f4 f14) (f5 (f6 f7 ?v1) ?v0)) f1) (= (f3 (f35 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f13 ?v2))) (=> (= (f3 (f35 ?v0) ?v1) f1) (=> (= (f3 (f35 ?v2) f14) f1) (=> (= (f3 (f4 f14) (f5 (f6 f7 ?v0) ?v1)) f1) (= (f3 (f35 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S7)) (=> (not (= ?v0 f15)) (= (f18 (f36 f37 f44) ?v0) f15))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f14) ?v0) f1) (forall ((?v1 S3)) (= (f3 (f35 (f10 f11 (f32 f33 ?v1))) (f5 (f6 f7 (f5 f17 ?v1)) ?v0)) f1)))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f14) ?v0) f1) (forall ((?v1 S3)) (= (f3 (f35 (f5 f17 (f5 f34 ?v1))) (f5 (f6 f7 (f5 f17 ?v1)) ?v0)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (and (= (f3 (f4 f14) ?v1) f1) (forall ((?v2 S3)) (= (f3 (f35 (f5 f17 (f5 (f6 f13 ?v2) ?v0))) (f5 (f6 f7 (f5 f17 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S3)) (and (= (f3 (f4 f14) ?v1) f1) (forall ((?v2 S7)) (= (f3 (f35 (f10 f11 (f18 (f19 f28 ?v2) ?v0))) (f5 (f6 f7 (f10 f11 ?v2)) ?v1)) f1))))))
(assert (not (exists ((?v0 S7) (?v1 S11)) (and (not (= ?v0 f15)) (and (= ?v1 f27) (= f45 (f29 (f41 f42 ?v0) ?v1)))))))
(assert (= (f46 (f36 f37 (f29 (f41 f42 f24) f44))) f1))
(check-sat)
(exit)
