(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S3)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S6) S3)
(declare-fun f7 (S7 S3) S5)
(declare-fun f8 () S7)
(declare-fun f9 () S3)
(declare-fun f10 (S8 Int) S6)
(declare-fun f11 () S8)
(declare-fun f12 (S9 Int) S3)
(declare-fun f13 () S9)
(declare-fun f14 (S10 Int) Int)
(declare-fun f15 () S10)
(declare-fun f16 () S10)
(declare-fun f17 () Int)
(declare-fun f18 () S10)
(declare-fun f19 () S8)
(declare-fun f20 (S11 S6) S6)
(declare-fun f21 (S12 S6) S11)
(declare-fun f22 () S12)
(declare-fun f23 (S13 S6) Int)
(declare-fun f24 (S14 Int) S13)
(declare-fun f25 () S14)
(declare-fun f26 () S2)
(declare-fun f27 () S10)
(declare-fun f28 (S3) S1)
(declare-fun f29 (Int) S1)
(declare-fun f30 (S3 S15) S1)
(declare-fun f31 () S15)
(declare-fun f32 (Int S16) S1)
(declare-fun f33 () S16)
(declare-fun f34 () S4)
(declare-fun f35 () S4)
(declare-fun f36 () S3)
(declare-fun f37 (S6 S17) S1)
(declare-fun f38 (S17 S6) S1)
(declare-fun f39 (S16 Int) S1)
(declare-fun f40 (S15 S3) S1)
(declare-fun f41 () S13)
(declare-fun f42 () S12)
(declare-fun f43 () S12)
(declare-fun f44 () S17)
(assert (not (= f1 f2)))
(assert (let ((?v_1 (f10 f11 2)) (?v_0 (f14 f15 (f14 f16 f17)))) (not (= (f3 (f4 f5 (f6 (f7 f8 f9) ?v_1)) (f12 f13 (f14 f15 ?v_0))) (f6 (f7 f8 (f3 (f4 f5 f9) (f12 f13 ?v_0))) ?v_1)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S6)) (= (f6 (f7 f8 (f3 (f4 f5 ?v0) ?v1)) ?v2) (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (= (f14 f15 f17) f17))
(assert (forall ((?v0 Int)) (= (- f17 (f14 f15 ?v0)) (f14 f15 (- f17 ?v0)))))
(assert (forall ((?v0 Int)) (= (= f17 (f14 f15 ?v0)) (= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (< f17 (f14 f15 ?v0)) (< f17 ?v0))))
(assert (forall ((?v0 Int)) (= (<= f17 (f14 f15 ?v0)) (<= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f14 f15 ?v0) f17) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (< (f14 f15 ?v0) f17) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (<= (f14 f15 ?v0) f17) (<= ?v0 f17))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f14 f16 ?v0) ?v1) (+ (f14 f15 (* ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 f13 ?v0) (f12 f13 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f18 ?v0) (f14 f18 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f10 f19 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f12 f13 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f18 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f16 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f16 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f16 ?v0) (f14 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f14 f16 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f14 f16 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f17 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* f17 ?v0) f17)))
(assert (= (<= f17 f17) true))
(assert (= (< f17 0) false))
(assert (= (< f17 f17) false))
(assert (= (= f17 f17) true))
(assert (= (- f17) f17))
(assert (= f17 0))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f20 (f21 f22 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S6)) (= (f3 f26 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f3 f26 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (f14 f27 (f23 (f24 f25 ?v0) ?v1)) (f23 (f24 f25 (f14 f27 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f15 ?v0) (f14 f15 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f15 ?v0) (f14 f15 ?v1)) (f14 f15 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f15 ?v0) (f14 f15 ?v1)) (f14 f15 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f14 f15 ?v0) ?v1) (f14 f15 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f14 f15 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f14 f15 ?v0)) (f14 f15 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f14 f15 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f14 f16 ?v0) f17) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (< (f14 f16 ?v0) f17) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= (f14 f16 ?v0) f17) false)))
(assert (forall ((?v0 Int)) (= (<= f17 (f14 f16 ?v0)) (<= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (< f17 (f14 f16 ?v0)) (<= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (= f17 (f14 f16 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f16 ?v0) (f14 f16 ?v1)) (f14 f15 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f16 ?v0) (f14 f15 ?v1)) (f14 f16 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f16 ?v0) (f14 f15 ?v1)) (f14 f16 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f15 ?v0) (f14 f16 ?v1)) (f14 f16 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f16 ?v0) (f14 f15 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f15 ?v0) (f14 f16 ?v1)) false)))
(assert (forall ((?v0 Int)) (=> (<= 0 (f14 f18 ?v0)) (and (<= 0 (f14 f18 (f14 f15 ?v0))) (<= 0 (f14 f18 (f14 f16 ?v0)))))))
(assert (not (= (f28 (f12 f13 (f14 f16 f17))) f1)))
(assert (not (= (f29 1) f1)))
(assert (forall ((?v0 Int)) (=> (<= f17 ?v0) (= (f30 (f12 f13 ?v0) f31) f1))))
(assert (forall ((?v0 Int)) (=> (<= f17 ?v0) (= (f32 (f14 f18 ?v0) f33) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f5 ?v1)) (?v_0 (f4 f34 (f12 f13 (f14 f15 (f14 f16 f17)))))) (= (= ?v0 (f3 ?v_1 (f3 ?v_0 ?v2))) (= (f3 ?v_0 ?v0) (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S3)) (let ((?v_1 (f10 f11 2)) (?v_0 (f14 f15 (f14 f16 f17)))) (= (f3 (f4 f34 (f12 f13 (f14 f15 ?v_0))) (f6 (f7 f8 ?v0) ?v_1)) (f6 (f7 f8 (f3 (f4 f34 (f12 f13 ?v_0)) ?v0)) ?v_1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f4 f5 ?v0) (f12 f13 (f14 f15 (f14 f16 f17)))))) (= (f3 (f4 f35 ?v_0) ?v_0) ?v0))))
(assert (let ((?v_0 (f12 f13 (f14 f15 (f14 f16 f17))))) (not (= (f3 (f4 f5 f36) ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= (f28 (f12 f13 (f14 f15 ?v0))) f1) (= (f28 (f12 f13 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (= (f29 (f14 f18 (f14 f15 ?v0))) f1) (= (f29 (f14 f18 ?v0)) f1))))
(assert (= (f28 (f12 f13 f17)) f1))
(assert (= (f29 0) f1))
(assert (forall ((?v0 Int)) (not (= (f28 (f12 f13 (f14 f16 ?v0))) f1))))
(assert (forall ((?v0 Int)) (not (= (f29 (f14 f18 (f14 f16 ?v0))) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f26 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f3 f26 ?v0)) (f3 f26 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S17)) (= (= (f37 ?v0 ?v1) f1) (= (f38 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S16)) (= (= (f32 ?v0 ?v1) f1) (= (f39 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S15)) (= (= (f30 ?v0 ?v1) f1) (= (f40 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int)) (= (f14 f18 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (- (f14 f18 ?v0)) (f14 f18 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f18 ?v0) (f14 f18 ?v1)) (f14 f18 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f14 f18 ?v0) (f14 f18 ?v1)) (f14 f18 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f18 ?v0) (f14 f18 ?v1)) (f14 f18 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f18 ?v0) (f14 f18 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f18 ?v0) (f14 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 Int)) (let ((?v_0 (f14 f18 ?v1))) (= (= (f23 f41 ?v0) ?v_0) (and (= ?v0 (f10 f11 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (= (f3 (f4 f34 (f3 (f4 f35 ?v0) ?v1)) ?v_0) (f3 (f4 f35 (f3 (f4 f34 ?v0) ?v_0)) (f3 (f4 f34 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f18 ?v2))) (= (* (+ ?v0 ?v1) ?v_0) (+ (* ?v0 ?v_0) (* ?v1 ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f10 f19 ?v2))) (= (f20 (f21 f42 (f20 (f21 f43 ?v0) ?v1)) ?v_0) (f20 (f21 f43 (f20 (f21 f42 ?v0) ?v_0)) (f20 (f21 f42 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 (f12 f13 ?v0)))) (= (f3 ?v_0 (f3 (f4 f35 ?v1) ?v2)) (f3 (f4 f35 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f18 ?v0))) (= (* ?v_0 (+ ?v1 ?v2)) (+ (* ?v_0 ?v1) (* ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f21 f42 (f10 f19 ?v0)))) (= (f20 ?v_0 (f20 (f21 f43 ?v1) ?v2)) (f20 (f21 f43 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S3)) (let ((?v_0 (f23 f41 ?v1)) (?v_1 (f23 f41 ?v0)) (?v_2 (f7 f8 ?v2))) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f34 (f6 ?v_2 (f10 f11 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f23 f41 ?v1)) (?v_1 (f23 f41 ?v0)) (?v_2 (f24 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f23 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (* (f23 ?v_2 (f10 f11 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f23 f41 ?v1)) (?v_1 (f23 f41 ?v0)) (?v_2 (f21 f22 ?v2))) (=> (<= ?v_1 ?v_0) (= (f20 ?v_2 (f10 f11 (- (+ ?v_0 1) ?v_1))) (f20 (f21 f42 (f20 ?v_2 (f10 f11 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f3 (f4 f34 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 ?v2) ?v3)) (f3 (f4 f5 (f3 (f4 f34 ?v0) ?v2)) (f3 (f4 f34 ?v1) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f34 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v0)) (f3 (f4 f5 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 f13 (+ ?v0 ?v1)) (f3 (f4 f35 (f12 f13 ?v0)) (f12 f13 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 f18 (+ ?v0 ?v1)) (+ (f14 f18 ?v0) (f14 f18 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f35 (f12 f13 ?v0)) (f12 f13 ?v1)) (f12 f13 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f18 ?v0) (f14 f18 ?v1)) (f14 f18 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f35 (f12 f13 ?v0)) (f3 (f4 f35 (f12 f13 ?v1)) ?v2)) (f3 (f4 f35 (f12 f13 (+ ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f14 f18 ?v0) (+ (f14 f18 ?v1) ?v2)) (+ (f14 f18 (+ ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 f13 (* ?v0 ?v1)) (f3 (f4 f34 (f12 f13 ?v0)) (f12 f13 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 f18 (* ?v0 ?v1)) (* (f14 f18 ?v0) (f14 f18 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f34 (f12 f13 ?v0)) (f12 f13 ?v1)) (f12 f13 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f14 f18 ?v0) (f14 f18 ?v1)) (f14 f18 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f34 (f12 f13 ?v0)) (f3 (f4 f34 (f12 f13 ?v1)) ?v2)) (f3 (f4 f34 (f12 f13 (* ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (f14 f18 ?v0) (* (f14 f18 ?v1) ?v2)) (* (f14 f18 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 S3) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f23 f41 ?v1) 1))) (f3 (f4 f34 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f10 f11 (+ (f23 f41 ?v1) 1))) (* ?v0 (f23 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (+ (f23 f41 ?v1) 1))) (f20 (f21 f42 ?v0) (f20 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f23 f41 ?v1) 1))) (f3 (f4 f34 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f10 f11 (+ (f23 f41 ?v1) 1))) (* (f23 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (+ (f23 f41 ?v1) 1))) (f20 (f21 f42 (f20 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S6) (?v2 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (+ (f23 f41 ?v1) (f23 f41 ?v2)))) (f3 (f4 f34 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f10 f11 (+ (f23 f41 ?v1) (f23 f41 ?v2)))) (* (f23 ?v_0 ?v1) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (+ (f23 f41 ?v1) (f23 f41 ?v2)))) (f20 (f21 f42 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S6)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (= (f3 (f4 f34 ?v_0) ?v0) (f3 (f4 f34 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f23 (f24 f25 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 (f21 f22 ?v0) ?v1))) (= (f20 (f21 f42 ?v_0) ?v0) (f20 (f21 f42 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S6)) (= (f6 (f7 f8 (f3 (f4 f34 ?v0) ?v1)) ?v2) (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f23 (f24 f25 (* ?v0 ?v1)) ?v2) (* (f23 (f24 f25 ?v0) ?v2) (f23 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f20 (f21 f22 (f20 (f21 f42 ?v0) ?v1)) ?v2) (f20 (f21 f42 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f34 ?v0) (f12 f13 (f14 f15 (f14 f16 f17)))) (f3 (f4 f35 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f34 ?v0) (f12 f13 (f14 f15 (f14 f16 f17)))) (f3 (f4 f35 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S6)) (= (f20 (f21 f42 ?v0) (f10 f19 (f14 f15 (f14 f16 f17)))) (f20 (f21 f43 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f34 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0) (f3 (f4 f35 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f34 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0) (f3 (f4 f35 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S6)) (= (f20 (f21 f42 (f10 f19 (f14 f15 (f14 f16 f17)))) ?v0) (f20 (f21 f43 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 f13 ?v0) (f12 f13 ?v1)) (= (f28 (f12 f13 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f18 ?v0) (f14 f18 ?v1)) (= (f29 (f14 f18 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f35 ?v0) (f12 f13 f17)) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f35 (f12 f13 f17)) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f34 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f34 (f12 f13 (f14 f16 f17))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f10 f11 2))) (= (f6 (f7 f8 (f3 (f4 f35 ?v0) ?v1)) ?v_0) (f3 (f4 f35 (f3 (f4 f35 (f6 (f7 f8 ?v0) ?v_0)) (f6 (f7 f8 ?v1) ?v_0))) (f3 (f4 f34 (f3 (f4 f34 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0)) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f10 f11 2))) (= (f6 (f7 f8 (f3 (f4 f35 ?v0) ?v1)) ?v_0) (f3 (f4 f35 (f3 (f4 f35 (f6 (f7 f8 ?v0) ?v_0)) (f6 (f7 f8 ?v1) ?v_0))) (f3 (f4 f34 (f3 (f4 f34 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0)) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f23 (f24 f25 (+ ?v0 ?v1)) ?v_0) (+ (+ (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0)) (* (* 2 ?v0) ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f10 f11 2))) (= (f20 (f21 f22 (f20 (f21 f43 ?v0) ?v1)) ?v_0) (f20 (f21 f43 (f20 (f21 f43 (f20 (f21 f22 ?v0) ?v_0)) (f20 (f21 f22 ?v1) ?v_0))) (f20 (f21 f42 (f20 (f21 f42 (f10 f19 (f14 f15 (f14 f16 f17)))) ?v0)) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (f3 (f4 f35 (f12 f13 ?v0)) (f12 f13 ?v1)) (f12 f13 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (+ (f14 f18 ?v0) (f14 f18 ?v1)) (f14 f18 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (f20 (f21 f43 (f10 f19 ?v0)) (f10 f19 ?v1)) (f10 f19 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f6 (f7 f8 ?v_0) (f10 f11 2)) (f3 (f4 f34 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f18 ?v0))) (= (f23 (f24 f25 ?v_0) (f10 f11 2)) (* ?v_0 ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f19 ?v0))) (= (f20 (f21 f22 ?v_0) (f10 f11 2)) (f20 (f21 f42 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (f3 (f4 f34 (f12 f13 ?v0)) (f12 f13 ?v1)) (f12 f13 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (* (f14 f18 ?v0) (f14 f18 ?v1)) (f14 f18 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (f20 (f21 f42 (f10 f19 ?v0)) (f10 f19 ?v1)) (f10 f19 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f30 ?v0 f31) f1) (=> (= (f30 ?v1 f31) f1) (= (f30 (f3 (f4 f35 ?v0) ?v1) f31) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f32 ?v0 f33) f1) (=> (= (f32 ?v1 f33) f1) (= (f32 (+ ?v0 ?v1) f33) f1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f37 ?v0 f44) f1) (=> (= (f37 ?v1 f44) f1) (= (f37 (f20 (f21 f43 ?v0) ?v1) f44) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (let ((?v_0 (f23 f41 ?v2))) (= (f10 f11 (* (f23 f41 (f10 f19 ?v0)) (* (f23 f41 (f10 f19 ?v1)) ?v_0))) (ite (< ?v0 f17) (f10 f11 0) (f10 f11 (* (f23 f41 (f10 f19 (* ?v0 ?v1))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 f11 (* (f23 f41 (f10 f19 ?v0)) (f23 f41 (f10 f19 ?v1)))) (ite (< ?v0 f17) (f10 f11 0) (f10 f11 (f14 f18 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (* 2 (f23 f41 ?v1)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f10 f11 2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (* 2 (f23 f41 ?v1)))) (f20 (f21 f22 (f20 ?v_0 ?v1)) (f10 f11 2))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f10 f11 (* 2 (f23 f41 ?v1)))) (f23 (f24 f25 (f23 ?v_0 ?v1)) (f10 f11 2))))))
(assert (forall ((?v0 S3) (?v1 S6) (?v2 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f10 f11 (* (f23 f41 ?v1) (f23 f41 ?v2)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f10 f11 (* (f23 f41 ?v1) (f23 f41 ?v2)))) (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f10 f11 (* (f23 f41 ?v1) (f23 f41 ?v2)))) (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f23 f41 (f10 f19 ?v0)) (f23 f41 (f10 f19 ?v1))) (ite (< ?v0 ?v1) (< f17 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f23 f41 (f10 f19 ?v0)) (f23 f41 (f10 f19 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f17)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 f11 (+ (f23 f41 (f10 f19 ?v0)) (f23 f41 (f10 f19 ?v1)))) (ite (< ?v0 f17) (f10 f11 (f14 f18 ?v1)) (ite (< ?v1 f17) (f10 f11 (f14 f18 ?v0)) (f10 f11 (f14 f18 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f10 f11 (f14 f18 ?v0)) (f10 f11 0)) (<= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= (f10 f11 0) (f10 f11 (f14 f18 ?v0))) (<= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (< 0 (f23 f41 (f10 f19 ?v0))) (< f17 ?v0))))
(assert (forall ((?v0 S6)) (= (f10 f11 (f23 f41 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f23 f41 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f23 f41 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
