(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S5)
(declare-fun f7 () S4)
(declare-fun f8 (S6 Int) S5)
(declare-fun f9 () S6)
(declare-fun f10 () S2)
(declare-fun f11 () S2)
(declare-fun f12 () Int)
(declare-fun f13 (S7 S8) S5)
(declare-fun f14 (S9 S5) S7)
(declare-fun f15 () S9)
(declare-fun f16 (S10 Int) S8)
(declare-fun f17 () S10)
(declare-fun f18 () S2)
(declare-fun f19 () S10)
(declare-fun f20 (S11 S5) S4)
(declare-fun f21 () S11)
(declare-fun f22 () S4)
(declare-fun f23 (Int) S1)
(declare-fun f24 (S5) S1)
(declare-fun f25 (Int S12) S1)
(declare-fun f26 () S12)
(declare-fun f27 (S5 S13) S1)
(declare-fun f28 () S13)
(declare-fun f29 () S11)
(declare-fun f30 () S2)
(declare-fun f31 (S14 S8) Int)
(declare-fun f32 (S15 Int) S14)
(declare-fun f33 () S15)
(declare-fun f34 (S16 S8) S8)
(declare-fun f35 (S17 S8) S16)
(declare-fun f36 () S17)
(declare-fun f37 () S17)
(declare-fun f38 (S8 S18) S1)
(declare-fun f39 (S18 S8) S1)
(declare-fun f40 (S12 Int) S1)
(declare-fun f41 (S13 S5) S1)
(declare-fun f42 () S14)
(declare-fun f43 () S18)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (let ((?v_0 (f3 f10 (f3 f11 f12)))) (not (= (f6 f7 (f8 f9 (f3 f10 ?v_0))) (f8 f9 ?v_0)))))
(assert (let ((?v_0 (f3 f10 (f3 f11 f12)))) (= (f6 f7 (f8 f9 (f3 f10 ?v_0))) (f6 f7 (f13 (f14 f15 (f8 f9 ?v_0)) (f16 f17 2))))))
(assert (let ((?v_0 (f3 f10 (f3 f11 f12)))) (= (f6 f7 (f8 f9 (f3 f10 ?v_0))) (f6 f7 (f13 (f14 f15 (f8 f9 ?v_0)) (f16 f17 2))))))
(assert (= (f3 f10 f12) f12))
(assert (forall ((?v0 Int)) (= (- f12 (f3 f10 ?v0)) (f3 f10 (- f12 ?v0)))))
(assert (forall ((?v0 Int)) (= (= f12 (f3 f10 ?v0)) (= f12 ?v0))))
(assert (forall ((?v0 Int)) (= (< f12 (f3 f10 ?v0)) (< f12 ?v0))))
(assert (forall ((?v0 Int)) (= (<= f12 (f3 f10 ?v0)) (<= f12 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f3 f10 ?v0) f12) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (= (< (f3 f10 ?v0) f12) (< ?v0 f12))))
(assert (forall ((?v0 Int)) (= (<= (f3 f10 ?v0) f12) (<= ?v0 f12))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f3 f11 ?v0) ?v1) (+ (f3 f10 (* ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 f10 ?v0) (f3 f11 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 f11 ?v0) (f3 f10 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f3 f10 ?v0) (f3 f11 ?v1)) (f3 f11 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 f18 ?v0) (f3 f18 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f9 ?v0) (f8 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f16 f19 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 f18 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f11 ?v0) (f3 f11 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f11 ?v0) (f3 f11 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f11 ?v0) (f3 f11 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f11 ?v0) (f3 f11 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 f11 ?v0) (f3 f11 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f3 f11 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f3 f11 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f12) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f12) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f12 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* f12 ?v0) f12)))
(assert (= (<= f12 f12) true))
(assert (= (< f12 0) false))
(assert (= (< f12 f12) false))
(assert (= (= f12 f12) true))
(assert (= (- f12) f12))
(assert (= f12 0))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f10 ?v0) (f3 f10 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f10 ?v0) (f3 f10 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f10 ?v0) (f3 f10 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f10 ?v0) (f3 f10 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 f10 ?v0) (f3 f10 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 f10 ?v0) (f3 f10 ?v1)) (f3 f10 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f3 f10 ?v0) (f3 f10 ?v1)) (f3 f10 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f3 f10 ?v0) ?v1) (f3 f10 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f3 f10 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f3 f10 ?v0)) (f3 f10 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f3 f10 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f3 f11 ?v0) f12) (< ?v0 f12))))
(assert (forall ((?v0 Int)) (= (< (f3 f11 ?v0) f12) (< ?v0 f12))))
(assert (forall ((?v0 Int)) (= (= (f3 f11 ?v0) f12) false)))
(assert (forall ((?v0 Int)) (= (<= f12 (f3 f11 ?v0)) (<= f12 ?v0))))
(assert (forall ((?v0 Int)) (= (< f12 (f3 f11 ?v0)) (<= f12 ?v0))))
(assert (forall ((?v0 Int)) (= (= f12 (f3 f11 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f11 ?v0) (f3 f10 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f11 ?v0) (f3 f10 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f10 ?v0) (f3 f11 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f10 ?v0) (f3 f11 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f11 ?v0) (f3 f10 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f11 ?v0) (f3 f10 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f10 ?v0) (f3 f11 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f10 ?v0) (f3 f11 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 f11 ?v0) (f3 f11 ?v1)) (f3 f10 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 f11 ?v0) (f3 f10 ?v1)) (f3 f11 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f3 f11 ?v0) (f3 f10 ?v1)) (f3 f11 (+ ?v0 ?v1)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f3 f10 (f3 f11 f12))) (?v_1 (f16 f17 2))) (= (f6 (f20 f21 (f13 (f14 f15 ?v0) ?v_1)) (f8 f9 (f3 f10 ?v_0))) (f13 (f14 f15 (f6 (f20 f21 ?v0) (f8 f9 ?v_0))) ?v_1)))))
(assert (forall ((?v0 S5)) (= (f6 f7 (f13 (f14 f15 ?v0) (f16 f17 2))) (f6 f22 ?v0))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (f6 f7 (f13 (f14 f15 ?v0) ?v1)) (f13 (f14 f15 (f6 f7 ?v0)) ?v1))))
(assert (not (= (f23 1) f1)))
(assert (not (= (f24 (f8 f9 (f3 f11 f12))) f1)))
(assert (forall ((?v0 Int)) (=> (<= f12 ?v0) (= (f25 (f3 f18 ?v0) f26) f1))))
(assert (forall ((?v0 Int)) (=> (<= f12 ?v0) (= (f27 (f8 f9 ?v0) f28) f1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f3 f10 (f3 f11 f12))) (?v_1 (f16 f17 2))) (= (f6 (f20 f29 (f8 f9 (f3 f10 ?v_0))) (f13 (f14 f15 ?v0) ?v_1)) (f13 (f14 f15 (f6 (f20 f29 (f8 f9 ?v_0)) ?v0)) ?v_1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 f7 ?v0) (f6 f7 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (= (f23 (f3 f18 (f3 f10 ?v0))) f1) (= (f23 (f3 f18 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (= (f24 (f8 f9 (f3 f10 ?v0))) f1) (= (f24 (f8 f9 ?v0)) f1))))
(assert (= (f23 0) f1))
(assert (= (f24 (f8 f9 f12)) f1))
(assert (forall ((?v0 Int)) (not (= (f23 (f3 f18 (f3 f11 ?v0))) f1))))
(assert (forall ((?v0 Int)) (not (= (f24 (f8 f9 (f3 f11 ?v0))) f1))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (f6 f22 (f13 (f14 f15 ?v0) ?v1)) (f13 (f14 f15 (f6 f22 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f30 (f31 (f32 f33 ?v0) ?v1)) (f31 (f32 f33 (f3 f30 ?v0)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f20 f29 ?v0))) (= (f6 (f20 f21 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v0)) (f6 (f20 f21 ?v1) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f13 (f14 f15 (f6 (f20 f21 ?v0) ?v1)) ?v2) (f6 (f20 f21 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f13 (f14 f15 (f6 (f20 f29 ?v0) ?v1)) ?v2) (f6 (f20 f29 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f31 (f32 f33 (* ?v0 ?v1)) ?v2) (* (f31 (f32 f33 ?v0) ?v2) (f31 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f34 (f35 f36 (f34 (f35 f37 ?v0) ?v1)) ?v2) (f34 (f35 f37 (f34 (f35 f36 ?v0) ?v2)) (f34 (f35 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f13 (f14 f15 ?v0) ?v1))) (= (f6 (f20 f29 ?v_0) ?v0) (f6 (f20 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f31 (f32 f33 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f34 (f35 f36 ?v0) ?v1))) (= (f34 (f35 f37 ?v_0) ?v0) (f34 (f35 f37 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S18)) (= (= (f38 ?v0 ?v1) f1) (= (f39 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S12)) (= (= (f25 ?v0 ?v1) f1) (= (f40 ?v1 ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S13)) (= (= (f27 ?v0 ?v1) f1) (= (f41 ?v1 ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (f31 f42 ?v1) (f31 f42 ?v2)))) (f6 (f20 f29 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f16 f17 (+ (f31 f42 ?v1) (f31 f42 ?v2)))) (* (f31 ?v_0 ?v1) (f31 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f16 f17 (+ (f31 f42 ?v1) (f31 f42 ?v2)))) (f34 (f35 f37 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (f31 f42 ?v1) 1))) (f6 (f20 f29 (f13 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f16 f17 (+ (f31 f42 ?v1) 1))) (* (f31 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f16 f17 (+ (f31 f42 ?v1) 1))) (f34 (f35 f37 (f34 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (f31 f42 ?v1) 1))) (f6 (f20 f29 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f16 f17 (+ (f31 f42 ?v1) 1))) (* ?v0 (f31 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f16 f17 (+ (f31 f42 ?v1) 1))) (f34 (f35 f37 ?v0) (f34 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f7 (f6 (f20 f21 ?v0) ?v1)) (f6 (f20 f21 (f6 f7 ?v0)) (f6 f7 ?v1)))))
(assert (forall ((?v0 S5)) (= (f6 f7 (f6 (f20 f29 ?v0) ?v0)) (f6 f22 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f7 (f6 (f20 f29 ?v0) ?v1)) (f6 (f20 f29 (f6 f7 ?v0)) (f6 f7 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f9 (* ?v0 ?v1)) (f6 (f20 f29 (f8 f9 ?v0)) (f8 f9 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f18 (* ?v0 ?v1)) (* (f3 f18 ?v0) (f3 f18 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f20 f29 (f8 f9 ?v0)) (f8 f9 ?v1)) (f8 f9 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f3 f18 ?v0) (f3 f18 ?v1)) (f3 f18 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f6 (f20 f29 (f8 f9 ?v0)) (f6 (f20 f29 (f8 f9 ?v1)) ?v2)) (f6 (f20 f29 (f8 f9 (* ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (f3 f18 ?v0) (* (f3 f18 ?v1) ?v2)) (* (f3 f18 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 f18 ?v0) (f3 f18 ?v1)) (= (f23 (f3 f18 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f9 ?v0) (f8 f9 ?v1)) (= (f24 (f8 f9 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 S5)) (= (f6 (f20 f21 ?v0) (f8 f9 (f3 f11 f12))) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f20 f21 ?v0) (f8 f9 (f3 f11 f12))) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f20 f29 ?v0) (f8 f9 (f3 f11 f12))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f20 f29 (f8 f9 (f3 f11 f12))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f13 (f14 f15 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f31 (f32 f33 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f20 f29 (f8 f9 (f3 f10 (f3 f11 f12))))) (?v_1 (f20 f21 ?v1))) (= (= ?v0 (f6 ?v_1 (f6 ?v_0 ?v2))) (= (f6 ?v_0 ?v0) (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (f13 (f14 f15 ?v_0) (f16 f17 2)) (f6 (f20 f29 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f18 ?v0))) (= (f31 (f32 f33 ?v_0) (f16 f17 2)) (* ?v_0 ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f19 ?v0))) (= (f34 (f35 f36 ?v_0) (f16 f17 2)) (f34 (f35 f37 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f12 ?v0) (=> (<= f12 ?v1) (= (f6 (f20 f29 (f8 f9 ?v0)) (f8 f9 ?v1)) (f8 f9 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f12 ?v0) (=> (<= f12 ?v1) (= (* (f3 f18 ?v0) (f3 f18 ?v1)) (f3 f18 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f12 ?v0) (=> (<= f12 ?v1) (= (f34 (f35 f37 (f16 f19 ?v0)) (f16 f19 ?v1)) (f16 f19 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f27 ?v0 f28) f1) (=> (= (f27 ?v1 f28) f1) (= (f27 (f6 (f20 f29 ?v0) ?v1) f28) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f25 ?v0 f26) f1) (=> (= (f25 ?v1 f26) f1) (= (f25 (* ?v0 ?v1) f26) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f38 ?v0 f43) f1) (=> (= (f38 ?v1 f43) f1) (= (f38 (f34 (f35 f37 ?v0) ?v1) f43) f1)))))
(assert (forall ((?v0 Int)) (=> (<= 0 (f3 f18 ?v0)) (and (<= 0 (f3 f18 (f3 f10 ?v0))) (<= 0 (f3 f18 (f3 f11 ?v0)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f6 (f20 f29 (f6 (f20 f21 ?v0) ?v1)) (f6 (f20 f21 ?v2) ?v3)) (f6 (f20 f21 (f6 (f20 f29 ?v0) ?v2)) (f6 (f20 f29 ?v1) ?v3)))))
(assert (forall ((?v0 Int)) (= (f3 f18 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (- (f3 f18 ?v0)) (f3 f18 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f3 f18 ?v0) (f3 f18 ?v1)) (f3 f18 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f3 f18 ?v0) (f3 f18 ?v1)) (f3 f18 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 f18 ?v0) (f3 f18 ?v1)) (f3 f18 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f18 ?v0) (f3 f18 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f18 ?v0) (f3 f18 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f3 f18 ?v1))) (= (= (f31 f42 ?v0) ?v_0) (and (= ?v0 (f16 f17 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (let ((?v_0 (f31 f42 ?v2))) (= (f16 f17 (* (f31 f42 (f16 f19 ?v0)) (* (f31 f42 (f16 f19 ?v1)) ?v_0))) (ite (< ?v0 f12) (f16 f17 0) (f16 f17 (* (f31 f42 (f16 f19 (* ?v0 ?v1))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f17 (* (f31 f42 (f16 f19 ?v0)) (f31 f42 (f16 f19 ?v1)))) (ite (< ?v0 f12) (f16 f17 0) (f16 f17 (f3 f18 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 (f3 f18 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 (f3 f18 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (* 2 (f31 f42 ?v1)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f16 f17 2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f16 f17 (* 2 (f31 f42 ?v1)))) (f34 (f35 f36 (f34 ?v_0 ?v1)) (f16 f17 2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f16 f17 (* 2 (f31 f42 ?v1)))) (f31 (f32 f33 (f31 ?v_0 ?v1)) (f16 f17 2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (* (f31 f42 ?v1) (f31 f42 ?v2)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f16 f17 (* (f31 f42 ?v1) (f31 f42 ?v2)))) (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f16 f17 (* (f31 f42 ?v1) (f31 f42 ?v2)))) (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f31 f42 (f16 f19 ?v0)) (f31 f42 (f16 f19 ?v1))) (ite (< ?v0 ?v1) (< f12 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f31 f42 (f16 f19 ?v0)) (f31 f42 (f16 f19 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f12)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f17 (+ (f31 f42 (f16 f19 ?v0)) (f31 f42 (f16 f19 ?v1)))) (ite (< ?v0 f12) (f16 f17 (f3 f18 ?v1)) (ite (< ?v1 f12) (f16 f17 (f3 f18 ?v0)) (f16 f17 (f3 f18 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f16 f17 (f3 f18 ?v0)) (f16 f17 0)) (<= ?v0 f12))))
(assert (forall ((?v0 Int)) (= (= (f16 f17 0) (f16 f17 (f3 f18 ?v0))) (<= ?v0 f12))))
(assert (forall ((?v0 Int)) (= (< 0 (f31 f42 (f16 f19 ?v0))) (< f12 ?v0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f13 (f14 f15 ?v0) (f16 f17 2)))) (= (f6 f22 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f31 (f32 f33 ?v0) (f16 f17 2)))) (= (f3 f30 ?v_0) ?v_0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f16 f17 2))) (= (f13 (f14 f15 (f6 f22 ?v0)) ?v_0) (f13 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2))) (= (f31 (f32 f33 (f3 f30 ?v0)) ?v_0) (f31 (f32 f33 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f22 (f6 (f20 f21 ?v0) ?v1)) (f6 (f20 f21 (f6 f22 ?v0)) (f6 f22 ?v1)))))
(assert (forall ((?v0 S5)) (= (f13 (f14 f15 ?v0) (f16 f17 2)) (f6 (f20 f29 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f31 (f32 f33 ?v0) (f16 f17 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 ?v0) (f16 f17 2)) (f34 (f35 f37 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f13 (f14 f15 ?v0) (f16 f17 3)) (f6 (f20 f29 (f6 (f20 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f31 (f32 f33 ?v0) (f16 f17 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 ?v0) (f16 f17 3)) (f34 (f35 f37 (f34 (f35 f37 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (* 2 (f31 f42 ?v1)) 1))) (f6 (f20 f29 ?v0) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f16 f17 2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f16 f17 (+ (* 2 (f31 f42 ?v1)) 1))) (* ?v0 (f31 (f32 f33 (f31 ?v_0 ?v1)) (f16 f17 2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f16 f17 (+ (* 2 (f31 f42 ?v1)) 1))) (f34 (f35 f37 ?v0) (f34 (f35 f36 (f34 ?v_0 ?v1)) (f16 f17 2)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f20 f29 ?v0))) (= (f6 ?v_0 (f6 (f20 f21 ?v1) ?v2)) (f6 (f20 f21 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5)) (= (f6 (f20 f29 ?v0) ?v0) (f13 (f14 f15 ?v0) (f16 f17 2)))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f31 (f32 f33 ?v0) (f16 f17 2)))))
(assert (forall ((?v0 S8)) (= (f34 (f35 f37 ?v0) ?v0) (f34 (f35 f36 ?v0) (f16 f17 2)))))
(assert (forall ((?v0 S8)) (= (f16 f17 (f31 f42 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f31 f42 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f31 f42 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
