(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S3 S2) S2)
(declare-fun f6 (S4 S2) S3)
(declare-fun f7 () S4)
(declare-fun f8 () S4)
(declare-fun f9 () S2)
(declare-fun f10 () S2)
(declare-fun f11 (S5 Int) S2)
(declare-fun f12 () S5)
(declare-fun f13 (S6 Int) Int)
(declare-fun f14 () S6)
(declare-fun f15 () S6)
(declare-fun f16 () Int)
(declare-fun f17 () S6)
(declare-fun f18 (S7 Int) S8)
(declare-fun f19 () S7)
(declare-fun f20 () S8)
(declare-fun f21 (S9 S8) Int)
(declare-fun f22 () S9)
(declare-fun f23 () S7)
(declare-fun f24 () S3)
(declare-fun f25 () S6)
(declare-fun f26 () S2)
(declare-fun f27 (Int) S1)
(declare-fun f28 (S2) S1)
(declare-fun f29 () S2)
(declare-fun f30 (S8) S1)
(declare-fun f31 () S8)
(declare-fun f32 (S8 S8) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f5 (f6 f7 (f5 (f6 f8 f9) f10)) (f11 f12 (f13 f14 (f13 f15 f16)))))) (not (and (= (f3 f4 ?v_0) f1) (and (= (f3 ?v_0 f9) f1) (= (f3 ?v_0 f10) f1))))))
(assert (= (f3 f4 f9) f1))
(assert (= (f3 f4 f10) f1))
(assert (forall ((?v0 S2)) (= (= (f3 f4 (f5 (f6 f7 ?v0) (f11 f12 (f13 f14 (f13 f15 f16))))) f1) (= (f3 f4 ?v0) f1))))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (= (f3 f4 (f5 (f6 f7 ?v0) (f11 f12 (f13 f14 (f13 f15 f16))))) f1))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f11 f12 (f13 f15 f16))) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f11 f12 (f13 f15 f16))) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f11 f12 f16)) f4)))
(assert (forall ((?v0 Int)) (= (< 0 (f13 f17 ?v0)) (< f16 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f3 f4 (f11 f12 ?v0)) f1) (< f16 ?v0))))
(assert (forall ((?v0 Int)) (= (< (f13 f17 ?v0) 0) (< ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f3 (f11 f12 ?v0) f4) f1) (< ?v0 f16))))
(assert (= 0 0))
(assert (= f4 (f11 f12 f16)))
(assert (= 0 0))
(assert (= (f11 f12 f16) f4))
(assert (= 0 0))
(assert (= (f11 f12 f16) f4))
(assert (= (f18 f19 f16) f20))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) f1) (or (and (= (f3 f4 ?v0) f1) (= (f3 f4 ?v1) f1)) (and (= (f3 ?v0 f4) f1) (= (f3 ?v1 f4) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f5 (f6 f7 ?v0) ?v1) f4) f1) (or (and (= (f3 f4 ?v0) f1) (= (f3 ?v1 f4) f1)) (and (= (f3 ?v0 f4) f1) (= (f3 f4 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f21 f22 (f18 f19 ?v0)) (f21 f22 (f18 f19 ?v1))) (ite (< ?v0 ?v1) (< f16 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f21 f22 (f18 f19 ?v0)) (f21 f22 (f18 f19 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f16)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 f23 (+ (f21 f22 (f18 f19 ?v0)) (f21 f22 (f18 f19 ?v1)))) (ite (< ?v0 f16) (f18 f23 (f13 f17 ?v1)) (ite (< ?v1 f16) (f18 f23 (f13 f17 ?v0)) (f18 f23 (f13 f17 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f18 f23 (f13 f17 ?v0)) (f18 f23 0)) (<= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f18 f23 0) (f18 f23 (f13 f17 ?v0))) (<= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (< 0 (f21 f22 (f18 f19 ?v0))) (< f16 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 f17 ?v0) (f13 f17 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 f12 ?v0) (f11 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f17 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f18 f19 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f15 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f15 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f15 ?v0) (f13 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f15 ?v0) (f13 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 f15 ?v0) (f13 f15 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f13 f15 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f13 f15 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f16) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f16) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f16 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* f16 ?v0) f16)))
(assert (= (<= f16 f16) true))
(assert (= (< f16 0) false))
(assert (= (< f16 f16) false))
(assert (= (= f16 f16) true))
(assert (= (- f16) f16))
(assert (= f16 0))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f14 ?v0) (f13 f14 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f14 ?v0) (f13 f14 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f14 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f14 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 f14 ?v0) (f13 f14 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f13 f14 ?v0) (f13 f14 ?v1)) (f13 f14 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f13 f14 ?v0) (f13 f14 ?v1)) (f13 f14 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f13 f14 ?v0) ?v1) (f13 f14 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f13 f14 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f13 f14 ?v0)) (f13 f14 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f13 f14 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 f24 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f24 ?v0)) (f5 f24 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f17 ?v0) (f13 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f11 f12 ?v0) (f11 f12 ?v1)) f1) (< ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f4)) (= (f5 f24 (f5 (f6 f7 ?v1) ?v0)) (f5 (f6 f7 (f5 f24 ?v1)) (f5 f24 ?v0))))))
(assert (forall ((?v0 Int)) (= (<= (f13 f15 ?v0) f16) (< ?v0 f16))))
(assert (forall ((?v0 Int)) (= (< (f13 f15 ?v0) f16) (< ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f13 f15 ?v0) f16) false)))
(assert (forall ((?v0 Int)) (= (<= f16 (f13 f15 ?v0)) (<= f16 ?v0))))
(assert (forall ((?v0 Int)) (= (< f16 (f13 f15 ?v0)) (<= f16 ?v0))))
(assert (forall ((?v0 Int)) (= (= f16 (f13 f15 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f15 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f15 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f14 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f14 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f15 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f15 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f14 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f14 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f13 f15 ?v0) (f13 f15 ?v1)) (f13 f14 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f13 f15 ?v0) (f13 f14 ?v1)) (f13 f15 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f13 f15 ?v0) (f13 f14 ?v1)) (f13 f15 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f13 f14 ?v0) (f13 f15 ?v1)) (f13 f15 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 f15 ?v0) (f13 f14 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 f14 ?v0) (f13 f15 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f13 f15 ?v0) ?v1) (+ (f13 f14 (* ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 Int)) (= (<= (f13 f14 ?v0) f16) (<= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (< (f13 f14 ?v0) f16) (< ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f13 f14 ?v0) f16) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (<= f16 (f13 f14 ?v0)) (<= f16 ?v0))))
(assert (forall ((?v0 Int)) (= (< f16 (f13 f14 ?v0)) (< f16 ?v0))))
(assert (forall ((?v0 Int)) (= (= f16 (f13 f14 ?v0)) (= f16 ?v0))))
(assert (forall ((?v0 Int)) (= (- f16 (f13 f14 ?v0)) (f13 f14 (- f16 ?v0)))))
(assert (= (f13 f14 f16) f16))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 f4) f1) (= (f3 (f5 (f6 f7 ?v1) ?v2) (f5 (f6 f7 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 f4 ?v2) f1) (= (f3 (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 f4) f1) (=> (= (f3 ?v1 f4) f1) (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 f4) f1) (=> (= (f3 f4 ?v1) f1) (= (f3 (f5 (f6 f7 ?v0) ?v1) f4) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 ?v1 f4) f1) (= (f3 (f5 (f6 f7 ?v0) ?v1) f4) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 f4 ?v1) f1) (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f4 ?v0) f1) (= (f5 (f6 f7 (f5 f24 ?v1)) ?v0) (f5 f24 (f5 (f6 f7 ?v1) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v2) ?v1)) f1) (and (=> (= (f3 f4 ?v1) f1) (= (f3 ?v0 ?v2) f1)) (and (=> (= (f3 ?v1 f4) f1) (= (f3 ?v2 ?v0) f1)) (not (= ?v1 f4)))))))
(assert (forall ((?v0 Int)) (=> (<= 0 (f13 f17 ?v0)) (and (<= 0 (f13 f17 (f13 f14 ?v0))) (<= 0 (f13 f17 (f13 f15 ?v0)))))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) f4) f4)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 f4) ?v0) f4)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 f4) ?v0) f4)))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f13 f25 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (= (f5 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f13 f25 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S2)) (= (= (f3 f4 (f5 f24 ?v0)) f1) (not (= ?v0 f4)))))
(assert (forall ((?v0 Int)) (not (< (f13 f25 ?v0) 0))))
(assert (forall ((?v0 S2)) (not (= (f3 (f5 f24 ?v0) f4) f1))))
(assert (= (f3 f4 (f5 (f6 f7 f26) (f11 f12 (f13 f14 (f13 f15 f16))))) f1))
(assert (not (= (f27 1) f1)))
(assert (not (= (f28 (f11 f12 (f13 f15 f16))) f1)))
(assert (= (f3 f4 (f5 (f6 f7 f29) (f11 f12 (f13 f14 (f13 f15 f16))))) f1))
(assert (forall ((?v0 Int)) (= (= (f13 f17 ?v0) 0) (= (f27 (f13 f17 (+ ?v0 (- f16)))) f1))))
(assert (forall ((?v0 Int)) (= (= (f11 f12 ?v0) f4) (= (f28 (f11 f12 (+ ?v0 (- f16)))) f1))))
(assert (not (= (f27 1) f1)))
(assert (not (= (f30 f31) f1)))
(assert (not (= (f28 f26) f1)))
(assert (forall ((?v0 Int)) (= (f13 f17 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f23 (f13 f17 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f23 (f13 f17 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (= (- (f13 f17 ?v0)) (f13 f17 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f13 f17 ?v0) (f13 f17 ?v1)) (f13 f17 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f13 f17 ?v0) (f13 f17 ?v1)) (f13 f17 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f13 f17 ?v0) (f13 f17 ?v1)) (f13 f17 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f17 ?v0) (f13 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f17 ?v0) (f13 f17 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f13 f17 ?v1))) (= (= (f21 f22 ?v0) ?v_0) (and (= ?v0 (f18 f23 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 (f18 f19 ?v0)))) (=> (< 0 ?v_0) (= (f18 f23 (f13 f17 ?v0)) (f18 f23 (+ (f21 f22 (f18 f23 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S8)) (= (= f31 ?v0) (= ?v0 f31))))
(assert (forall ((?v0 S2)) (= (= f26 ?v0) (= ?v0 f26))))
(assert (= (f13 f25 1) 1))
(assert (= (f5 f24 f26) f26))
(assert (not (= 1 0)))
(assert (not (= f26 f4)))
(assert (not (= f31 f20)))
(assert (not (= 0 1)))
(assert (not (= f4 f26)))
(assert (not (= f20 f31)))
(assert (not (= f29 f4)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) f26) ?v0)))
(assert (not (< 1 0)))
(assert (not (= (f3 f26 f4) f1)))
(assert (not (= (f32 f31 f20) f1)))
(assert (< 0 1))
(assert (= (f3 f4 f26) f1))
(assert (= (f32 f20 f31) f1))
(assert (not (= (f3 f29 f4) f1)))
(assert (= (f3 f4 f29) f1))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) ?v0) (ite (= ?v0 f4) f4 f26))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f4)) (= (f5 (f6 f7 ?v0) ?v0) f26))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f4)) (= (= (f5 (f6 f7 ?v1) ?v0) f26) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int)) (= (= 1 (f13 f17 ?v0)) (= (f27 (f13 f17 (+ (f13 f15 f16) (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= f26 (f11 f12 ?v0)) (= (f28 (f11 f12 (+ (f13 f15 f16) (- ?v0)))) f1))))
(assert (forall ((?v0 S8)) (= (f18 f23 (f21 f22 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f21 f22 (f18 f23 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f21 f22 (f18 f23 ?v0)) 0))))
(check-sat)
(exit)
