(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status sat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S6) S2)
(declare-fun f8 () S5)
(declare-fun f9 () S6)
(declare-fun f10 () S4)
(declare-fun f11 () S2)
(declare-fun f12 () S2)
(declare-fun f13 () S2)
(declare-fun f14 () S3)
(declare-fun f15 () S6)
(declare-fun f16 (S7 S6) S6)
(declare-fun f17 (S8 S6) S7)
(declare-fun f18 () S8)
(declare-fun f19 () S3)
(declare-fun f20 () S8)
(declare-fun f21 (S9 S10) S7)
(declare-fun f22 () S9)
(declare-fun f23 () S10)
(declare-fun f24 () S6)
(declare-fun f25 () S2)
(declare-fun f26 (S2 S2) S1)
(declare-fun f27 () S6)
(declare-fun f28 () S4)
(declare-fun f29 () S4)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 f9)) (?v_1 (f4 (f5 f10 f11) f12))) (not (= (f3 (f4 (f5 f6 ?v_0) ?v_1) (f4 (f5 f6 (f4 (f5 f6 f13) ?v_0)) (f4 f14 ?v_1))) f1))))
(assert (= (f3 (f7 f8 f15) f11) f1))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f3 (f7 f8 (f16 (f17 f18 ?v0) ?v1)) (f4 (f5 f6 (f7 f8 ?v0)) (f7 f8 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f19 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f19 ?v0)) (f4 f19 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f19 (f4 (f5 f10 ?v0) ?v1)) (f4 (f5 f10 (f4 f19 ?v0)) (f4 f19 ?v1))) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f3 (f7 f8 (f16 (f17 f20 ?v0) ?v1)) (f4 (f5 f10 (f7 f8 ?v0)) (f7 f8 ?v1))) f1)))
(assert (forall ((?v0 S6)) (=> (= (f3 (f7 f8 ?v0) f11) f1) (= (f3 (f7 f8 (f16 (f21 f22 f23) ?v0)) f12) f1))))
(assert (= (f7 f8 f24) f13))
(assert (= (f4 f19 f13) f13))
(assert (= (f3 f25 f11) f1))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f19 (f4 (f5 f10 ?v0) ?v1)) (f4 (f5 f10 (f4 f19 ?v0)) (f4 f19 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f7 f8 (f16 (f17 f20 ?v0) ?v1)) (f4 (f5 f10 (f7 f8 ?v0)) (f7 f8 ?v1)))))
(assert (forall ((?v0 S6)) (= (f16 (f17 f18 ?v0) ?v0) (f16 (f17 f20 (f16 (f17 f18 f24) f24)) ?v0))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) ?v0) (f4 (f5 f10 (f4 (f5 f6 f13) f13)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (* (+ 1 1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f16 (f17 f18 ?v0) (f16 (f17 f20 ?v1) ?v0)) (f16 (f17 f20 (f16 (f17 f18 ?v1) f24)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 ?v0) (f4 (f5 f10 ?v1) ?v0)) (f4 (f5 f10 (f4 (f5 f6 ?v1) f13)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (* ?v1 ?v0)) (* (+ ?v1 1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f16 (f17 f18 (f16 (f17 f20 ?v0) ?v1)) ?v1) (f16 (f17 f20 (f16 (f17 f18 ?v0) f24)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 (f4 (f5 f10 ?v0) ?v1)) ?v1) (f4 (f5 f10 (f4 (f5 f6 ?v0) f13)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (* ?v0 ?v1) ?v1) (* (+ ?v0 1) ?v1))))
(assert (= (f26 f25 (f4 (f5 f6 (f4 (f5 f6 f13) (f7 f8 f9))) (f4 f14 (f4 (f5 f10 f11) f12)))) f1))
(assert (forall ((?v0 S2)) (= (f3 ?v0 ?v0) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f10 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f10 ?v0) ?v2)) (f4 (f5 f10 ?v1) ?v2)))))
(assert (exists ((?v0 S2)) (and (= (f26 f25 ?v0) f1) (forall ((?v1 S6)) (=> (= (f3 (f7 f8 ?v1) f11) f1) (= (f3 (f7 f8 (f16 (f21 f22 f23) ?v1)) ?v0) f1))))))
(assert (= (f3 (f7 f8 (f16 (f21 f22 f23) f15)) f12) f1))
(assert (let ((?v_0 (f5 f6 (f7 f8 f9)))) (= (f3 (f4 ?v_0 (f7 f8 (f16 (f17 f20 f15) (f16 (f21 f22 f23) f15)))) (f4 ?v_0 (f4 (f5 f10 f11) f12))) f1)))
(assert (=> (forall ((?v0 S2)) (=> (forall ((?v1 S6)) (=> (= (f3 (f7 f8 ?v1) f11) f1) (= (f3 (f7 f8 (f16 (f21 f22 f23) ?v1)) ?v0) f1))) false)) false))
(assert (forall ((?v0 S2)) (not (= (f26 ?v0 ?v0) f1))))
(assert (forall ((?v0 S2)) (not (= (f26 (f4 f19 ?v0) f25) f1))))
(assert (forall ((?v0 S6)) (not (= (f26 (f7 f8 ?v0) f25) f1))))
(assert (= (f7 f8 f27) f25))
(assert (= (f4 f19 f25) f25))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= ?v0 ?v1)) (or (= (f26 ?v0 ?v1) f1) (= (f26 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= (f26 ?v0 ?v1) f1)) (or (= (f26 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6)) (= (= (f26 f25 (f7 f8 ?v0)) f1) (not (= ?v0 f27)))))
(assert (forall ((?v0 S2)) (= (= (f26 f25 (f4 f19 ?v0)) f1) (not (= ?v0 f25)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f26 ?v0 ?v1) f1) (or (= ?v0 ?v1) (= (f26 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f26 ?v0 (f4 (f5 f28 ?v1) ?v2)) f1) (or (= (f26 ?v0 ?v1) f1) (= (f26 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f26 ?v0 (f4 (f5 f29 ?v1) ?v2)) f1) (and (= (f26 ?v0 ?v1) f1) (= (f26 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S6)) (= (= (f7 f8 ?v0) f25) (= ?v0 f27))))
(assert (forall ((?v0 S2)) (= (= (f4 f19 ?v0) f25) (= ?v0 f25))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f26 (f4 (f5 f28 ?v0) ?v1) ?v2) f1) (and (= (f26 ?v0 ?v2) f1) (= (f26 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f26 (f4 (f5 f29 ?v0) ?v1) ?v2) f1) (or (= (f26 ?v0 ?v2) f1) (= (f26 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= (f26 ?v0 ?v1) f1)) (= (not (= (f26 ?v1 ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f26 ?v0 ?v1) f1) false) (=> (=> (= (f26 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f26 f25 ?v0) f1) (= (= (f26 (f4 (f5 f10 ?v1) ?v0) (f4 (f5 f10 ?v2) ?v0)) f1) (= (f26 ?v1 ?v2) f1)))))
(check-sat)
(exit)
