(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S3) S1)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S2) S2)
(declare-fun f7 (S6 S2) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S2)
(declare-fun f10 () S6)
(declare-fun f11 () S2)
(declare-fun f12 (S7 S8) S2)
(declare-fun f13 (S9 S2) S7)
(declare-fun f14 () S9)
(declare-fun f15 () S8)
(declare-fun f16 () S3)
(declare-fun f17 (S10 Int) S8)
(declare-fun f18 () S10)
(declare-fun f19 () S2)
(declare-fun f20 (S11 S3) S3)
(declare-fun f21 (S12 S3) S11)
(declare-fun f22 () S12)
(declare-fun f23 (S13 S8) S3)
(declare-fun f24 (S14 S3) S13)
(declare-fun f25 () S14)
(declare-fun f26 (S15 S8) Int)
(declare-fun f27 (S16 Int) S15)
(declare-fun f28 () S16)
(declare-fun f29 () S11)
(declare-fun f30 () S12)
(declare-fun f31 () S15)
(declare-fun f32 () S3)
(declare-fun f33 () S11)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 S2)) (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 ?v0) f15)))) f16) f1))))
(assert (not (= f15 (f17 f18 0))))
(assert (not (= f15 (f17 f18 0))))
(assert (not (= f11 f19)))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f16 ?v0) f1) (= (f3 f16 (f20 (f21 f22 ?v0) (f23 (f24 f25 ?v0) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (* ?v0 (f26 (f27 f28 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f23 (f24 f25 ?v0) ?v1))) (=> (= (f3 f16 ?v0) f1) (= (f3 ?v_0 (f20 (f21 f22 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f26 (f27 f28 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (* ?v0 ?v_0))))))
(assert (= (f4 f5 f9) f16))
(assert (= (f20 f29 f16) f16))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f20 (f21 f30 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f20 f29 ?v0) ?v1) f1) (=> (= (f3 (f20 f29 ?v2) ?v3) f1) (= (f3 (f20 f29 (f20 (f21 f30 ?v0) ?v2)) (f20 (f21 f30 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f10 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f20 f29 ?v0) ?v1) f1) (=> (= (f3 (f20 f29 ?v2) ?v3) f1) (= (f3 (f20 f29 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) f9 (f6 (f7 f10 ?v0) (f12 ?v_0 (f17 f18 (- (f26 f31 ?v1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) f16 (f20 (f21 f22 ?v0) (f23 ?v_0 (f17 f18 (- (f26 f31 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) 1 (* ?v0 (f26 ?v_0 (f17 f18 (- (f26 f31 ?v1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f16 ?v0) f1) (= (f3 f16 (f23 (f24 f25 ?v0) (f17 f18 (+ (f26 f31 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (f26 (f27 f28 ?v0) (f17 f18 (+ (f26 f31 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (=> (= (f3 f16 ?v0) f1) (= (= (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 1 ?v0) (= (= (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (=> (= (f3 f16 ?v0) f1) (= (= (f3 (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) f1) (< (f26 f31 ?v1) (f26 f31 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 1 ?v0) (= (< (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (< (f26 f31 ?v1) (f26 f31 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f16 ?v0) f1) (=> (< 0 (f26 f31 ?v1)) (= (f3 f16 (f23 (f24 f25 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (=> (< 0 (f26 f31 ?v1)) (< 1 (f26 (f27 f28 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (=> (= (f3 f16 ?v0) f1) (=> (= (f3 (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) f1) (< (f26 f31 ?v1) (f26 f31 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 1 ?v0) (=> (< (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (< (f26 f31 ?v1) (f26 f31 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S3)) (let ((?v_0 (f24 f25 ?v2))) (=> (< (f26 f31 ?v0) (f26 f31 ?v1)) (=> (= (f3 f16 ?v2) f1) (= (f3 (f23 ?v_0 ?v0) (f23 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (< (f26 f31 ?v0) (f26 f31 ?v1)) (=> (< 1 ?v2) (< (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)))))))
(assert (= (f4 f5 f19) f32))
(assert (= (f20 f29 f32) f32))
(assert (forall ((?v0 S2)) (= (= (f4 f5 ?v0) f32) (= ?v0 f19))))
(assert (forall ((?v0 S3)) (= (= (f20 f29 ?v0) f32) (= ?v0 f32))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f17 f18 (* (f26 f31 ?v1) (f26 f31 ?v2)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f17 f18 (* (f26 f31 ?v1) (f26 f31 ?v2)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f17 f18 (* (f26 f31 ?v1) (f26 f31 ?v2)))) (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2)) (= (f6 (f7 f10 ?v0) f19) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f21 f22 ?v0) f32) f32)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f10 ?v0) f19) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f21 f22 ?v0) f32) f32)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f10 f19) ?v0) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f21 f22 f32) ?v0) f32)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f10 f19) ?v0) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f21 f22 f32) ?v0) f32)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f26 (f27 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (not (= ?v0 f19)) (not (= (f12 (f13 f14 ?v0) ?v1) f19)))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (not (= ?v0 f32)) (not (= (f23 (f24 f25 ?v0) ?v1) f32)))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f26 (f27 f28 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S2) (?v1 S8)) (= (= (f12 (f13 f14 ?v0) ?v1) f19) (and (= ?v0 f19) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S3) (?v1 S8)) (= (= (f23 (f24 f25 ?v0) ?v1) f32) (and (= ?v0 f32) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 0) (f17 f18 (+ (f26 f31 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f19) (f17 f18 (+ (f26 f31 ?v0) 1))) f19)))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 f32) (f17 f18 (+ (f26 f31 ?v0) 1))) f32)))
(assert (forall ((?v0 S2)) (= (= (f3 f32 (f4 f5 ?v0)) f1) (not (= ?v0 f19)))))
(assert (forall ((?v0 S3)) (= (= (f3 f32 (f20 f29 ?v0)) f1) (not (= ?v0 f32)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f20 f33 ?v0) f16) f1) (= (f3 (f23 (f24 f25 ?v0) (f17 f18 2)) f16) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (< 0 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f32 ?v0) f1) (= (f3 f32 (f23 (f24 f25 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f19) ?v0) (ite (= ?v0 (f17 f18 0)) f9 f19))))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 f32) ?v0) (ite (= ?v0 (f17 f18 0)) f16 f32))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 0) ?v0) (ite (= ?v0 (f17 f18 0)) 1 0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S3)) (let ((?v_0 (f24 f25 ?v2))) (=> (< (f26 f31 ?v0) (f26 f31 ?v1)) (=> (= (f3 f32 ?v2) f1) (=> (= (f3 ?v2 f16) f1) (= (f3 (f23 ?v_0 ?v1) (f23 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (< (f26 f31 ?v0) (f26 f31 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f26 ?v_0 ?v1) (f26 ?v_0 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f32 ?v0) f1) (=> (= (f3 ?v0 f16) f1) (= (f3 (f23 (f24 f25 ?v0) (f17 f18 (+ (f26 f31 ?v1) 1))) f16) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f26 (f27 f28 ?v0) (f17 f18 (+ (f26 f31 ?v1) 1))) 1)))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f23 (f24 f25 ?v0) ?v1))) (=> (= (f3 f32 ?v0) f1) (=> (= (f3 ?v0 f16) f1) (= (f3 (f20 (f21 f22 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f26 (f27 f28 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 Int)) (= (f26 (f27 f28 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f12 (f13 f14 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f23 (f24 f25 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f17 f18 (f26 f31 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f26 f31 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f26 f31 (f17 f18 ?v0)) 0))))
(check-sat)
(exit)
