(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S4)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S4)
(declare-fun f10 () S6)
(declare-fun f11 () S4)
(declare-fun f12 (S7 S8) S4)
(declare-fun f13 (S9 S4) S7)
(declare-fun f14 () S9)
(declare-fun f15 () S5)
(declare-fun f16 () S4)
(declare-fun f17 () S8)
(declare-fun f18 () S2)
(declare-fun f19 () S8)
(declare-fun f20 (S10 Int) S8)
(declare-fun f21 () S10)
(declare-fun f22 (S11 S8) Int)
(declare-fun f23 () S11)
(declare-fun f24 () S4)
(declare-fun f25 (S8) S1)
(declare-fun f26 (S12 S2) S2)
(declare-fun f27 (S13 S2) S12)
(declare-fun f28 () S13)
(declare-fun f29 (S14 S8) S2)
(declare-fun f30 (S15 S2) S14)
(declare-fun f31 () S15)
(declare-fun f32 (S16 Int) S11)
(declare-fun f33 () S16)
(declare-fun f34 () S12)
(declare-fun f35 () S13)
(declare-fun f36 () S2)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 (f6 f15 f16)) f17)))) f18) f1)))
(assert (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 f16) f19)))) f18) f1))
(assert (not (= f19 (f20 f21 0))))
(assert (not (= f17 (f20 f21 0))))
(assert (< (f22 f23 f19) (f22 f23 f17)))
(assert (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 f16) f19)))) f18) f1))
(assert (not (= f11 f24)))
(assert (forall ((?v0 S8)) (=> (< (f22 f23 ?v0) (f22 f23 f17)) (=> (not (= ?v0 (f20 f21 0))) (exists ((?v1 S4)) (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 ?v1) ?v0)))) f18) f1))))))
(assert (= (f25 f17) f1))
(assert (=> (forall ((?v0 S4)) (=> (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 ?v0) f19)))) f18) f1) false)) false))
(assert (=> (< (f22 f23 f19) (f22 f23 f17)) (=> (not (= f19 (f20 f21 0))) (exists ((?v0 S4)) (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 ?v0) f19)))) f18) f1)))))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 (f6 f15 ?v0)) (f20 f21 2)) ?v0)))
(assert (= f17 (f20 f21 (* 2 (f22 f23 f19)))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (= (f3 f18 ?v0) f1) (= (f3 f18 (f26 (f27 f28 ?v0) (f29 (f30 f31 ?v0) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (* ?v0 (f22 (f32 f33 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f29 (f30 f31 ?v0) ?v1))) (=> (= (f3 f18 ?v0) f1) (= (f3 ?v_0 (f26 (f27 f28 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 (f32 f33 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (* ?v0 ?v_0))))))
(assert (= (f4 f5 f9) f18))
(assert (= (f26 f34 f18) f18))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4) (?v3 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f26 (f27 f35 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f26 f34 ?v0) ?v1) f1) (=> (= (f3 (f26 f34 ?v2) ?v3) f1) (= (f3 (f26 f34 (f26 (f27 f35 ?v0) ?v2)) (f26 (f27 f35 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4) (?v3 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f10 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f26 f34 ?v0) ?v1) f1) (=> (= (f3 (f26 f34 ?v2) ?v3) f1) (= (f3 (f26 f34 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f9 (f6 (f7 f10 ?v0) (f12 ?v_0 (f20 f21 (- (f22 f23 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f18 (f26 (f27 f28 ?v0) (f29 ?v_0 (f20 f21 (- (f22 f23 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f32 f33 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) 1 (* ?v0 (f22 ?v_0 (f20 f21 (- (f22 f23 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (= (f3 f18 ?v0) f1) (= (f3 f18 (f29 (f30 f31 ?v0) (f20 f21 (+ (f22 f23 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (f22 (f32 f33 ?v0) (f20 f21 (+ (f22 f23 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f3 f18 ?v0) f1) (= (= (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f33 ?v0))) (=> (< 1 ?v0) (= (= (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f3 f18 ?v0) f1) (= (= (f3 (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) f1) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f33 ?v0))) (=> (< 1 ?v0) (= (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (= (f3 f18 ?v0) f1) (=> (< 0 (f22 f23 ?v1)) (= (f3 f18 (f29 (f30 f31 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (=> (< 0 (f22 f23 ?v1)) (< 1 (f22 (f32 f33 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f3 f18 ?v0) f1) (=> (= (f3 (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) f1) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f33 ?v0))) (=> (< 1 ?v0) (=> (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (=> (forall ((?v0 S8)) (=> (= f17 (f20 f21 (* 2 (f22 f23 ?v0)))) false)) false))
(assert (exists ((?v0 S8)) (= f17 (f20 f21 (* 2 (f22 f23 ?v0))))))
(assert (= (f4 f5 f24) f36))
(assert (= (f26 f34 f36) f36))
(assert (forall ((?v0 S4)) (= (= (f4 f5 ?v0) f36) (= ?v0 f24))))
(assert (forall ((?v0 S2)) (= (= (f26 f34 ?v0) f36) (= ?v0 f36))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f20 f21 (* (f22 f23 ?v1) (f22 f23 ?v2)))) (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f33 ?v0))) (= (f22 ?v_0 (f20 f21 (* (f22 f23 ?v1) (f22 f23 ?v2)))) (f22 (f32 f33 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f20 f21 (* (f22 f23 ?v1) (f22 f23 ?v2)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 ?v0) f24) f24)))
(assert (forall ((?v0 S2)) (= (f26 (f27 f28 ?v0) f36) f36)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 ?v0) f24) f24)))
(assert (forall ((?v0 S2)) (= (f26 (f27 f28 ?v0) f36) f36)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 f24) ?v0) f24)))
(assert (forall ((?v0 S2)) (= (f26 (f27 f28 f36) ?v0) f36)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 f24) ?v0) f24)))
(assert (forall ((?v0 S2)) (= (f26 (f27 f28 f36) ?v0) f36)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f22 (f32 f33 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (not (= ?v0 f24)) (not (= (f12 (f13 f14 ?v0) ?v1) f24)))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (not (= ?v0 f36)) (not (= (f29 (f30 f31 ?v0) ?v1) f36)))))
(assert (forall ((?v0 S8)) (= (f20 f21 (f22 f23 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f22 f23 (f20 f21 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f22 f23 (f20 f21 ?v0)) 0))))
(check-sat)
(exit)
