(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S1)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S5) S5)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S9) S5)
(declare-fun f12 () S8)
(declare-fun f13 (S10 S11) S9)
(declare-fun f14 () S10)
(declare-fun f15 () S11)
(declare-fun f16 (S12 S5) S7)
(declare-fun f17 () S12)
(declare-fun f18 () S5)
(declare-fun f19 () S5)
(declare-fun f20 () S8)
(declare-fun f21 (S13) S1)
(declare-fun f22 () S13)
(declare-fun f23 (S14 Int) S11)
(declare-fun f24 () S14)
(declare-fun f25 () S5)
(declare-fun f26 (S15 Int) Int)
(declare-fun f27 () S15)
(declare-fun f28 (S16 S9) S9)
(declare-fun f29 (S17 S9) S16)
(declare-fun f30 () S17)
(declare-fun f31 () S7)
(declare-fun f32 () S13)
(declare-fun f33 () S9)
(declare-fun f34 (S18 Int) S15)
(declare-fun f35 () S18)
(declare-fun f36 () S12)
(declare-fun f37 () S18)
(declare-fun f38 () S12)
(declare-fun f39 () S9)
(declare-fun f40 () S16)
(declare-fun f41 () S7)
(declare-fun f42 (S19 S11) Int)
(declare-fun f43 () S19)
(declare-fun f44 (S13 S11) S11)
(declare-fun f45 () S15)
(declare-fun f46 () S16)
(declare-fun f47 (S20 S3) S18)
(declare-fun f48 () S20)
(declare-fun f49 (S21 S6) S12)
(declare-fun f50 () S21)
(declare-fun f51 () S20)
(declare-fun f52 () S21)
(declare-fun f53 (Int S2) S1)
(declare-fun f54 () S2)
(declare-fun f55 (S9 S22) S1)
(declare-fun f56 () S22)
(declare-fun f57 (S5 S4) S1)
(declare-fun f58 () S4)
(declare-fun f59 () S12)
(declare-fun f60 () S17)
(declare-fun f61 (S5 S5) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 (f9 f10 (f11 f12 (f13 f14 f15)))) (f9 (f16 f17 f18) f19)) f1)))
(assert (let ((?v_0 (f13 f14 f15))) (= (f6 (f7 f8 (f9 f10 (f11 f12 ?v_0))) (f11 f20 ?v_0)) f1)))
(assert (= (f6 (f7 f8 (f11 f20 (f13 f14 f15))) f18) f1))
(assert (= (f21 f22) f1))
(assert (let ((?v_0 (f13 f14 f15))) (= (f6 (f7 f8 (f9 f10 (f11 f12 ?v_0))) (f11 f20 ?v_0)) f1)))
(assert (= (f6 (f7 f8 (f11 f20 (f13 f14 f15))) f18) f1))
(assert (forall ((?v0 S11)) (= (f6 (f7 f8 (f11 f20 (f13 f14 ?v0))) f18) f1)))
(assert (= (f6 (f7 f8 (f11 f20 (f13 f14 (f23 f24 0)))) f18) f1))
(assert (= (f6 (f7 f8 f25) f18) f1))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f9 ?v_0 ?v0)) (f9 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f9 f10 (f9 (f16 f17 ?v0) ?v1))) (f9 (f16 f17 (f9 f10 ?v0)) (f9 f10 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f26 f27 (+ ?v0 ?v1)) (+ (f26 f27 ?v0) (f26 f27 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f9 (f16 f17 ?v0) ?v1)) (f9 (f16 f17 ?v2) ?v1)) f1) (= (f6 (f7 f8 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f9 (f16 f17 ?v0) ?v2)) (f9 (f16 f17 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f9 ?v_0 ?v0)) (f9 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f8 (f9 (f16 f17 ?v0) ?v2)) (f9 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 (f9 (f16 f17 ?v0) ?v1)) (f9 (f16 f17 ?v2) ?v1)) f1) (= (f6 (f7 f8 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f6 (f7 f8 (f11 f20 (f28 (f29 f30 ?v0) ?v1))) (f9 (f16 f17 (f11 f20 ?v0)) (f11 f20 ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f9 f31 (f9 (f16 f17 ?v0) ?v1))) (f9 (f16 f17 (f9 f31 ?v0)) (f9 f31 ?v1))) f1)))
(assert (= (f21 f32) f1))
(assert (= (f9 f10 f25) f25))
(assert (= (f26 f27 0) 0))
(assert (= (f11 f20 f33) f25))
(assert (= (f9 f31 f25) f25))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f31 ?v0))) (= (f9 f10 ?v_0) ?v_0))))
(assert (forall ((?v0 S9)) (let ((?v_0 (f11 f20 ?v0))) (= (f9 f10 ?v_0) ?v_0))))
(assert (forall ((?v0 S9)) (= (= f33 ?v0) (= ?v0 f33))))
(assert (forall ((?v0 S5)) (= (= f25 ?v0) (= ?v0 f25))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f9 f10 ?v0) f25) (= ?v0 f25))))
(assert (forall ((?v0 Int)) (= (= (f26 f27 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S9)) (= (= (f11 f20 ?v0) f25) (= ?v0 f33))))
(assert (forall ((?v0 S5)) (= (= (f9 f31 ?v0) f25) (= ?v0 f25))))
(assert (forall ((?v0 S9)) (= (= (f6 (f7 f8 (f11 f20 ?v0)) f25) f1) (= ?v0 f33))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f9 f31 ?v0)) f25) f1) (= ?v0 f25))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f25) (f9 f31 ?v0)) f1)))
(assert (forall ((?v0 S9)) (= (f6 (f7 f8 f25) (f11 f20 ?v0)) f1)))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f25) ?v0) f1) (= (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f26 f27 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f9 f10 ?v0)) f25) f1) (= ?v0 f25))))
(assert (forall ((?v0 Int)) (= (<= (f26 f27 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f25) (f9 f10 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f26 f27 ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f30 ?v0) f33) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f17 ?v0) f25) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f30 ?v0) f33) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f17 ?v0) f25) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f25 (f9 (f16 f17 ?v0) ?v0)) (= ?v0 f25))))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f30 f33) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f17 f25) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f30 f33) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f17 f25) ?v0) ?v0)))
(assert (not (= f25 f19)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f25) f1) (=> (= (f6 (f7 f8 ?v1) f25) f1) (= (f6 (f7 f8 (f9 (f16 f17 ?v0) ?v1)) f25) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v1))) (=> (= (f6 (f7 f8 f25) ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 ?v_0 (f9 (f16 f17 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v1))) (=> (= (f6 (f7 f8 f25) ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 ?v_0 (f9 (f16 f17 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (= (f9 (f16 f17 ?v0) ?v1) f25) (and (= ?v0 f25) (= ?v1 f25))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f9 (f16 f17 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int)) (= (<= (+ ?v0 ?v0) 0) (<= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f9 (f16 f17 ?v0) ?v0)) f25) f1) (= (f6 (f7 f8 ?v0) f25) f1))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f8 f25))) (= (= (f6 ?v_0 (f9 (f16 f17 ?v0) ?v0)) f1) (= (f6 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f6 (f7 f8 (f11 f20 ?v0)) (f9 (f16 f17 (f11 f20 (f28 (f29 f30 ?v0) ?v1))) (f11 f20 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f8 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 (f9 f10 ?v0)) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f26 f27 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f8 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f26 (f34 f35 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f9 (f16 f36 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f8 ?v0) ?v2) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f26 (f34 f37 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 (f9 (f16 f38 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) (f9 f10 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f26 f27 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (=> (= (f28 (f29 f30 ?v0) ?v1) (f28 (f29 f30 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f9 (f16 f17 ?v0) ?v1) (f9 (f16 f17 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f30 ?v0))) (=> (= (f28 ?v_0 ?v1) (f28 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f30 ?v0))) (=> (= (f28 ?v_0 ?v1) (f28 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (= (f28 (f29 f30 ?v0) ?v1) (f28 (f29 f30 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f9 (f16 f17 ?v0) ?v1) (f9 (f16 f17 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f30 ?v0))) (= (= (f28 ?v_0 ?v1) (f28 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f26 (f34 f35 ?v0) ?v1) ?v2) (f26 (f34 f35 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f9 (f16 f17 (f9 (f16 f36 ?v0) ?v1)) ?v2) (f9 (f16 f36 (f9 (f16 f17 ?v0) ?v2)) (f9 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f26 (f34 f37 ?v0) ?v1) ?v2) (f26 (f34 f37 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f9 (f16 f17 (f9 (f16 f38 ?v0) ?v1)) ?v2) (f9 (f16 f38 (f9 (f16 f17 ?v0) ?v2)) (f9 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 (f29 f30 (f28 ?v_0 ?v1)) ?v2) (f28 ?v_0 (f28 (f29 f30 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f16 f17 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f9 (f16 f17 (f9 f10 ?v0)) (f9 f10 ?v1)))) (= (f9 f10 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f26 f27 ?v0) (f26 f27 ?v1)))) (= (f26 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S9)) (= (= f39 ?v0) (= ?v0 f39))))
(assert (forall ((?v0 S5)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (= (f11 f20 f39) f19))
(assert (= (f9 f31 f19) f19))
(assert (forall ((?v0 S9)) (= (f6 (f7 f8 (f9 f10 (f11 f12 ?v0))) (f11 f20 ?v0)) f1)))
(assert (forall ((?v0 S9)) (= (f6 (f7 f8 (f11 f12 ?v0)) (f11 f20 ?v0)) f1)))
(assert (<= 0 1))
(assert (= (f6 (f7 f8 f25) f19) f1))
(assert (not (<= 1 0)))
(assert (not (= (f6 (f7 f8 f19) f25) f1)))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f11 f12 (f28 (f29 f30 ?v0) ?v1)) (f9 (f16 f17 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (not (= 0 1)))
(assert (not (= f33 f39)))
(assert (not (= f25 f19)))
(assert (not (= 1 0)))
(assert (not (= f39 f33)))
(assert (not (= f19 f25)))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f9 (f16 f17 ?v0) ?v0) f25) (= ?v0 f25))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= ?v0 (f28 (f29 f30 ?v0) ?v1)) (= ?v1 f33))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f9 (f16 f17 ?v0) ?v1)) (= ?v1 f25))))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f30 ?v0) f33) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f17 ?v0) f25) ?v0)))
(assert (= (f11 f12 f39) f19))
(assert (= (f11 f12 f33) f25))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f28 (f29 f30 ?v0) ?v1) (f28 (f29 f30 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f9 (f16 f17 ?v0) ?v1) (f9 (f16 f17 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_1 (f29 f30 ?v0)) (?v_0 (f29 f30 ?v1))) (= (f28 ?v_1 (f28 ?v_0 ?v2)) (f28 ?v_0 (f28 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f16 f17 ?v0)) (?v_0 (f16 f17 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 ?v_0 (f28 (f29 f30 ?v1) ?v2)) (f28 (f29 f30 (f28 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 ?v_0 (f9 (f16 f17 ?v1) ?v2)) (f9 (f16 f17 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 (f29 f30 (f28 ?v_0 ?v1)) ?v2) (f28 ?v_0 (f28 (f29 f30 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f16 f17 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 (f29 f30 (f28 ?v_0 ?v1)) ?v2) (f28 (f29 f30 (f28 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f16 f17 (f9 ?v_0 ?v1)) ?v2) (f9 (f16 f17 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 (f29 f30 (f28 ?v_0 ?v1)) (f28 (f29 f30 ?v2) ?v3)) (f28 (f29 f30 (f28 ?v_0 ?v2)) (f28 (f29 f30 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f16 f17 (f9 ?v_0 ?v1)) (f9 (f16 f17 ?v2) ?v3)) (f9 (f16 f17 (f9 ?v_0 ?v2)) (f9 (f16 f17 ?v1) ?v3))))))
(assert (= (f9 f10 f19) f19))
(assert (= (f26 f27 1) 1))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f30 f33) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f17 f25) ?v0) ?v0)))
(assert (forall ((?v0 S9)) (= (f11 f20 (f28 f40 ?v0)) (ite (= ?v0 f33) f25 f19))))
(assert (forall ((?v0 S5)) (= (f9 f31 (f9 f41 ?v0)) (ite (= ?v0 f25) f25 f19))))
(assert (forall ((?v0 S13) (?v1 S11)) (=> (= (f21 ?v0) f1) (<= (f42 f43 ?v1) (f42 f43 (f44 ?v0 ?v1))))))
(assert (forall ((?v0 S13)) (= (= (f21 ?v0) f1) (forall ((?v1 S11)) (< (f42 f43 (f44 ?v0 ?v1)) (f42 f43 (f44 ?v0 (f23 f24 (+ (f42 f43 ?v1) 1)))))))))
(assert (forall ((?v0 S13)) (= (= (f21 ?v0) f1) (forall ((?v1 S11) (?v2 S11)) (=> (< (f42 f43 ?v1) (f42 f43 ?v2)) (< (f42 f43 (f44 ?v0 ?v1)) (f42 f43 (f44 ?v0 ?v2))))))))
(assert (= (f9 f41 f25) f25))
(assert (= (f26 f45 0) 0))
(assert (= (f28 f40 f33) f33))
(assert (= (f9 f41 f25) f25))
(assert (forall ((?v0 S9)) (= (= (f28 f40 ?v0) f33) (= ?v0 f33))))
(assert (forall ((?v0 S5)) (= (= (f9 f41 ?v0) f25) (= ?v0 f25))))
(assert (forall ((?v0 S5)) (= (= (f9 f41 ?v0) f25) (= ?v0 f25))))
(assert (forall ((?v0 Int)) (= (= (f26 f45 ?v0) 0) (= ?v0 0))))
(assert (= (f28 f40 f39) f39))
(assert (= (f9 f41 f19) f19))
(assert (= (f28 f46 f33) f39))
(assert (forall ((?v0 Int) (?v1 S15) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f26 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f26 ?v1 ?v5) (f26 ?v1 ?v4)))) (<= (f26 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S7) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f9 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v3) ?v2) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (= (f6 (f7 f8 (f9 ?v1 ?v5)) (f9 ?v1 ?v4)) f1))) (= (f6 (f7 f8 (f9 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f26 (f34 f37 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f9 (f16 f38 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f26 (f34 f37 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f9 (f16 f38 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f26 (f34 f35 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f9 (f16 f36 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f26 (f34 f35 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f8 ?v0) ?v2) f1)) (= (f9 (f16 f36 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S15) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f26 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f26 ?v2 ?v5) (f26 ?v2 ?v4)))) (<= ?v3 (f26 ?v2 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S7) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f9 ?v2 ?v0) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (= (f6 (f7 f8 (f9 ?v2 ?v5)) (f9 ?v2 ?v4)) f1))) (= (f6 (f7 f8 ?v3) (f9 ?v2 ?v1)) f1))))))
(assert (= f37 (f47 f48 f5)))
(assert (= f38 (f49 f50 f8)))
(assert (= f35 (f47 f51 f5)))
(assert (= f36 (f49 f52 f8)))
(assert (forall ((?v0 Int)) (=> (= (f53 ?v0 f54) f1) (not (= (+ (+ 1 ?v0) ?v0) 0)))))
(assert (forall ((?v0 S9)) (=> (= (f55 ?v0 f56) f1) (not (= (f28 (f29 f30 (f28 (f29 f30 f39) ?v0)) ?v0) f33)))))
(assert (forall ((?v0 S5)) (=> (= (f57 ?v0 f58) f1) (not (= (f9 (f16 f17 (f9 (f16 f17 f19) ?v0)) ?v0) f25)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (<= (+ (* ?v3 ?v0) (* ?v4 ?v2)) ?v1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v1) f1) (=> (= (f6 ?v_0 ?v3) f1) (=> (= (f6 ?v_0 ?v4) f1) (=> (= (f9 (f16 f17 ?v3) ?v4) f19) (= (f6 (f7 f8 (f9 (f16 f17 (f9 (f16 f59 ?v3) ?v0)) (f9 (f16 f59 ?v4) ?v2))) ?v1) f1)))))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f28 f40 (f28 (f29 f60 ?v0) ?v1)) (f28 (f29 f60 (f28 f40 ?v0)) (f28 f40 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f9 f41 (f9 (f16 f59 ?v0) ?v1)) (f9 (f16 f59 (f9 f41 ?v0)) (f9 f41 ?v1)))))
(assert (forall ((?v0 S5)) (= (f9 f10 ?v0) (f9 (f16 f59 ?v0) (f9 f41 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f9 f41 (f9 (f16 f59 ?v0) ?v1)) (f9 (f16 f59 (f9 f41 ?v0)) (f9 f41 ?v1)))))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 (f9 f41 ?v0)) (f9 f10 ?v0)) ?v0)))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f55 ?v0 f56) f1) (=> (= (f55 ?v1 f56) f1) (= (f55 (f28 (f29 f60 ?v0) ?v1) f56) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f57 ?v0 f58) f1) (=> (= (f57 ?v1 f58) f1) (= (f57 (f9 (f16 f59 ?v0) ?v1) f58) f1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f29 f60 ?v0))) (= (f28 (f29 f60 (f28 ?v_0 ?v1)) (f28 (f29 f60 ?v2) ?v3)) (f28 (f29 f60 (f28 ?v_0 ?v2)) (f28 (f29 f60 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f16 f59 ?v0))) (= (f9 (f16 f59 (f9 ?v_0 ?v1)) (f9 (f16 f59 ?v2) ?v3)) (f9 (f16 f59 (f9 ?v_0 ?v2)) (f9 (f16 f59 ?v1) ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_1 (f29 f60 (f28 (f29 f60 ?v0) ?v1))) (?v_0 (f29 f60 ?v2))) (= (f28 ?v_1 (f28 ?v_0 ?v3)) (f28 ?v_0 (f28 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f16 f59 (f9 (f16 f59 ?v0) ?v1))) (?v_0 (f16 f59 ?v2))) (= (f9 ?v_1 (f9 ?v_0 ?v3)) (f9 ?v_0 (f9 ?v_1 ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f29 f60 ?v0)) (?v_1 (f28 (f29 f60 ?v2) ?v3))) (= (f28 (f29 f60 (f28 ?v_0 ?v1)) ?v_1) (f28 ?v_0 (f28 (f29 f60 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f16 f59 ?v0)) (?v_1 (f9 (f16 f59 ?v2) ?v3))) (= (f9 (f16 f59 (f9 ?v_0 ?v1)) ?v_1) (f9 ?v_0 (f9 (f16 f59 ?v1) ?v_1))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f60 ?v0))) (= (f28 (f29 f60 (f28 ?v_0 ?v1)) ?v2) (f28 (f29 f60 (f28 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (= (f9 (f16 f59 (f9 ?v_0 ?v1)) ?v2) (f9 (f16 f59 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f60 ?v0))) (= (f28 (f29 f60 (f28 ?v_0 ?v1)) ?v2) (f28 ?v_0 (f28 (f29 f60 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (= (f9 (f16 f59 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f16 f59 ?v1) ?v2))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 ?v0))) (= (f9 (f16 f59 ?v_0) ?v_0) (f9 (f16 f59 ?v0) ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f60 ?v0))) (= (f28 ?v_0 (f28 (f29 f60 ?v1) ?v2)) (f28 (f29 f60 (f28 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (= (f9 ?v_0 (f9 (f16 f59 ?v1) ?v2)) (f9 (f16 f59 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_1 (f29 f60 ?v0)) (?v_0 (f29 f60 ?v1))) (= (f28 ?v_1 (f28 ?v_0 ?v2)) (f28 ?v_0 (f28 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f16 f59 ?v0)) (?v_0 (f16 f59 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f28 (f29 f60 ?v0) ?v1) (f28 (f29 f60 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f9 (f16 f59 ?v0) ?v1) (f9 (f16 f59 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f9 f10 (f9 (f16 f59 ?v0) ?v1)) (f9 (f16 f59 (f9 f10 ?v0)) (f9 f10 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f11 f20 (f28 (f29 f60 ?v0) ?v1)) (f9 (f16 f59 (f11 f20 ?v0)) (f11 f20 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f9 f31 (f9 (f16 f59 ?v0) ?v1)) (f9 (f16 f59 (f9 f31 ?v0)) (f9 f31 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f6 (f7 f8 (f11 f20 (f28 (f29 f60 ?v0) ?v1))) (f9 (f16 f59 (f11 f20 ?v0)) (f11 f20 ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f9 f31 (f9 (f16 f59 ?v0) ?v1))) (f9 (f16 f59 (f9 f31 ?v0)) (f9 f31 ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f60 ?v0))) (= (f28 (f29 f60 (f28 ?v_0 ?v1)) ?v2) (f28 ?v_0 (f28 (f29 f60 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (= (f9 (f16 f59 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f16 f59 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f9 (f16 f59 (f9 (f16 f17 ?v0) ?v1)) ?v2) (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v2)) (f9 (f16 f59 ?v1) ?v2)))))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 f19) ?v0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (=> (not (= ?v0 f25)) (= (= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f25)) (= (= (f9 (f16 f59 ?v1) ?v0) (f9 (f16 f59 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 f39) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 ?v0) f39) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 f39) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 f39) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 ?v0) f39) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 ?v0) f39) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (+ ?v1 ?v2)) (+ (* ?v0 ?v1) (* ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f60 ?v0))) (= (f28 ?v_0 (f28 (f29 f30 ?v1) ?v2)) (f28 (f29 f30 (f28 ?v_0 ?v1)) (f28 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (= (f9 ?v_0 (f9 (f16 f17 ?v1) ?v2)) (f9 (f16 f17 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (* ?v0 ?v2) (* ?v1 ?v3)) (+ (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f29 f60 ?v0)) (?v_1 (f29 f60 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f28 (f29 f30 (f28 ?v_0 ?v2)) (f28 ?v_1 ?v3)) (f28 (f29 f30 (f28 ?v_0 ?v3)) (f28 ?v_1 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f16 f59 ?v0)) (?v_1 (f16 f59 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f9 (f16 f17 (f9 ?v_0 ?v2)) (f9 ?v_1 ?v3)) (f9 (f16 f17 (f9 ?v_0 ?v3)) (f9 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f28 (f29 f60 (f28 (f29 f30 ?v0) ?v1)) ?v2) (f28 (f29 f30 (f28 (f29 f60 ?v0) ?v2)) (f28 (f29 f60 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f9 (f16 f59 (f9 (f16 f17 ?v0) ?v1)) ?v2) (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v2)) (f9 (f16 f59 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f28 (f29 f60 (f28 (f29 f30 ?v0) ?v1)) ?v2) (f28 (f29 f30 (f28 (f29 f60 ?v0) ?v2)) (f28 (f29 f60 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f9 (f16 f59 (f9 (f16 f17 ?v0) ?v1)) ?v2) (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v2)) (f9 (f16 f59 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (* ?v0 ?v1) (* ?v2 ?v1)) (* (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f28 (f29 f30 (f28 (f29 f60 ?v0) ?v1)) (f28 (f29 f60 ?v2) ?v1)) (f28 (f29 f60 (f28 (f29 f30 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v1)) (f9 (f16 f59 ?v2) ?v1)) (f9 (f16 f59 (f9 (f16 f17 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (= (f28 (f29 f30 (f28 (f29 f60 ?v0) ?v1)) (f28 (f29 f30 (f28 (f29 f60 ?v2) ?v1)) ?v3)) (f28 (f29 f30 (f28 (f29 f60 (f28 (f29 f30 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v1)) (f9 (f16 f17 (f9 (f16 f59 ?v2) ?v1)) ?v3)) (f9 (f16 f17 (f9 (f16 f59 (f9 (f16 f17 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (+ (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 ?v3) (* ?v2 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f29 f60 ?v0)) (?v_1 (f29 f60 ?v2))) (= (= (f28 (f29 f30 (f28 ?v_0 ?v1)) (f28 ?v_1 ?v3)) (f28 (f29 f30 (f28 ?v_0 ?v3)) (f28 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f16 f59 ?v0)) (?v_1 (f16 f59 ?v2))) (= (= (f9 (f16 f17 (f9 ?v_0 ?v1)) (f9 ?v_1 ?v3)) (f9 (f16 f17 (f9 ?v_0 ?v3)) (f9 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f60 ?v0))) (= (f28 ?v_0 (f28 (f29 f30 ?v1) ?v2)) (f28 (f29 f30 (f28 ?v_0 ?v1)) (f28 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (= (f9 ?v_0 (f9 (f16 f17 ?v1) ?v2)) (f9 (f16 f17 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f29 f60 ?v0))) (= (f28 ?v_0 (f28 (f29 f30 ?v1) ?v2)) (f28 (f29 f30 (f28 ?v_0 ?v1)) (f28 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (= (f9 ?v_0 (f9 (f16 f17 ?v1) ?v2)) (f9 (f16 f17 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f28 (f29 f60 (f28 (f29 f30 ?v0) ?v1)) ?v2) (f28 (f29 f30 (f28 (f29 f60 ?v0) ?v2)) (f28 (f29 f60 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f9 (f16 f59 (f9 (f16 f17 ?v0) ?v1)) ?v2) (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v2)) (f9 (f16 f59 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f28 (f29 f60 (f28 (f29 f30 ?v0) ?v1)) ?v2) (f28 (f29 f30 (f28 (f29 f60 ?v0) ?v2)) (f28 (f29 f60 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f9 (f16 f59 (f9 (f16 f17 ?v0) ?v1)) ?v2) (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v2)) (f9 (f16 f59 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f28 (f29 f60 ?v0) ?v1) f33) (or (= ?v0 f33) (= ?v1 f33)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f9 (f16 f59 ?v0) ?v1) f25) (or (= ?v0 f25) (= ?v1 f25)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (not (= ?v0 f33)) (=> (not (= ?v1 f33)) (not (= (f28 (f29 f60 ?v0) ?v1) f33))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f25)) (=> (not (= ?v1 f25)) (not (= (f9 (f16 f59 ?v0) ?v1) f25))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f28 (f29 f60 ?v0) ?v1) f33) (or (= ?v0 f33) (= ?v1 f33)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f9 (f16 f59 ?v0) ?v1) f25) (or (= ?v0 f25) (= ?v1 f25)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 ?v0) f33) f33)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 ?v0) f25) f25)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 ?v0) f33) f33)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 ?v0) f25) f25)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 f33) ?v0) f33)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 f25) ?v0) f25)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 f33) ?v0) f33)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 f25) ?v0) f25)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 ?v0) f33) f33)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 ?v0) f25) f25)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 ?v0) f33) f33)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 ?v0) f25) f25)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 f33) ?v0) f33)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 f25) ?v0) f25)))
(assert (forall ((?v0 S9)) (= (f28 (f29 f60 f33) ?v0) f33)))
(assert (forall ((?v0 S5)) (= (f9 (f16 f59 f25) ?v0) f25)))
(assert (= (f55 f33 f56) f1))
(assert (= (f57 f25 f58) f1))
(assert (= (f53 0 f54) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f53 ?v0 f54) f1) (=> (= (f53 ?v1 f54) f1) (= (f53 (+ ?v0 ?v1) f54) f1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f55 ?v0 f56) f1) (=> (= (f55 ?v1 f56) f1) (= (f55 (f28 (f29 f30 ?v0) ?v1) f56) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f57 ?v0 f58) f1) (=> (= (f57 ?v1 f58) f1) (= (f57 (f9 (f16 f17 ?v0) ?v1) f58) f1)))))
(assert (= (f53 1 f54) f1))
(assert (= (f55 f39 f56) f1))
(assert (= (f57 f19 f58) f1))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f25) (f9 (f16 f59 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (= (= (f6 ?v_0 (f9 (f16 f59 ?v0) ?v1)) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f8 ?v0) f25) f1) (= (f6 (f7 f8 ?v1) f25) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (= (= (f6 (f7 f8 (f9 (f16 f59 ?v0) ?v1)) f25) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v1) f25) f1)) (and (= (f6 (f7 f8 ?v0) f25) f1) (= (f6 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f25) ?v0) f1) (= (f9 (f16 f59 (f9 f10 ?v1)) ?v0) (f9 f10 (f9 (f16 f59 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f26 f27 ?v1) ?v0) (f26 f27 (* ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f9 (f16 f59 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f25) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) f25) f1) (= (f6 (f7 f8 (f9 (f16 f59 ?v0) ?v1)) f25) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f25) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) f25) f1) (= (f6 (f7 f8 (f9 (f16 f59 ?v1) ?v0)) f25) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f25) f1) (=> (= (f6 (f7 f8 f25) ?v1) f1) (= (f6 (f7 f8 (f9 (f16 f59 ?v0) ?v1)) f25) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f25) f1) (=> (= (f6 (f7 f8 ?v1) f25) f1) (= (f6 (f7 f8 f25) (f9 (f16 f59 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f25) ?v2) f1) (= (f6 (f7 f8 (f9 (f16 f59 ?v0) ?v2)) (f9 (f16 f59 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f25) ?v2) f1) (= (f6 (f7 f8 (f9 ?v_0 ?v0)) (f9 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f25) ?v2) f1) (= (f6 (f7 f8 (f9 ?v_0 ?v0)) (f9 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) f25) f1) (= (f6 (f7 f8 (f9 (f16 f59 ?v1) ?v2)) (f9 (f16 f59 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) f25) f1) (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 (f7 f8 (f9 (f16 f59 ?v0) ?v2)) (f9 (f16 f59 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 (f7 f8 (f9 (f16 f59 ?v0) ?v2)) (f9 (f16 f59 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (=> (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f8 ?v0) f25) f1) (= (f6 (f7 f8 ?v1) f25) f1))) (= (f6 ?v_0 (f9 (f16 f59 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (=> (and (or (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v0) f25) f1)) (or (= (f6 ?v_0 ?v1) f1) (= (f6 (f7 f8 ?v1) f25) f1))) (= (f9 f10 (f9 (f16 f59 ?v0) ?v1)) (f9 (f16 f59 (f9 f10 ?v0)) (f9 f10 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f26 f27 (* ?v0 ?v1)) (* (f26 f27 ?v0) (f26 f27 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (=> (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v1) f25) f1)) (and (= (f6 (f7 f8 ?v0) f25) f1) (= (f6 ?v_0 ?v1) f1))) (= (f6 (f7 f8 (f9 (f16 f59 ?v0) ?v1)) f25) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (* ?v0 ?v3)) (+ ?v2 (* ?v0 ?v4))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S9)) (let ((?v_0 (f29 f60 ?v0))) (=> (not (= ?v0 f33)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f28 (f29 f30 ?v1) (f28 ?v_0 ?v3)) (f28 (f29 f30 ?v2) (f28 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (let ((?v_0 (f16 f59 ?v0))) (=> (not (= ?v0 f25)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f9 (f16 f17 ?v1) (f9 ?v_0 ?v3)) (f9 (f16 f17 ?v2) (f9 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (* ?v0 ?v1) ?v1) (* (+ ?v0 1) ?v1))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f28 (f29 f30 (f28 (f29 f60 ?v0) ?v1)) ?v1) (f28 (f29 f60 (f28 (f29 f30 ?v0) f39)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v1)) ?v1) (f9 (f16 f59 (f9 (f16 f17 ?v0) f19)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (* ?v1 ?v0)) (* (+ ?v1 1) ?v0))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f28 (f29 f30 ?v0) (f28 (f29 f60 ?v1) ?v0)) (f28 (f29 f60 (f28 (f29 f30 ?v1) f39)) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f9 (f16 f17 ?v0) (f9 (f16 f59 ?v1) ?v0)) (f9 (f16 f59 (f9 (f16 f17 ?v1) f19)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (* (+ 1 1) ?v0))))
(assert (forall ((?v0 S9)) (= (f28 (f29 f30 ?v0) ?v0) (f28 (f29 f60 (f28 (f29 f30 f39) f39)) ?v0))))
(assert (forall ((?v0 S5)) (= (f9 (f16 f17 ?v0) ?v0) (f9 (f16 f59 (f9 (f16 f17 f19) f19)) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v0)) (f9 (f16 f59 ?v1) ?v1)) f25) (and (= ?v0 f25) (= ?v1 f25)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f28 f46 (f28 (f29 f30 ?v0) ?v1)) (f28 (f29 f60 (f28 f46 ?v0)) (f28 f46 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f53 ?v0 f54) f1) (= (= (+ ?v0 ?v0) 0) (= ?v0 0)))))
(assert (forall ((?v0 S9)) (=> (= (f55 ?v0 f56) f1) (= (= (f28 (f29 f30 ?v0) ?v0) f33) (= ?v0 f33)))))
(assert (forall ((?v0 S5)) (=> (= (f57 ?v0 f58) f1) (= (= (f9 (f16 f17 ?v0) ?v0) f25) (= ?v0 f25)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v1 ?v0) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) f19) f1) (= (f6 (f7 f8 (f9 (f16 f59 ?v1) ?v0)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v0 ?v1) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) f19) f1) (= (f6 (f7 f8 (f9 (f16 f59 ?v0) ?v1)) ?v0) f1)))))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f8 f25) ?v0) f1) (forall ((?v1 S9)) (= (f6 (f7 f8 (f9 f31 (f11 f12 ?v1))) (f9 (f16 f59 (f11 f20 ?v1)) ?v0)) f1)))))
(assert (forall ((?v0 S9)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f25) ?v1) f1) (forall ((?v2 S9)) (= (f6 (f7 f8 (f11 f20 (f28 (f29 f60 ?v2) ?v0))) (f9 (f16 f59 (f11 f20 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f25) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f9 f31 (f9 (f16 f59 ?v2) ?v0))) (f9 (f16 f59 (f9 f31 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S9)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f25) ?v1) f1) (forall ((?v2 S9)) (= (f6 (f7 f8 (f11 f20 (f28 (f29 f60 ?v0) ?v2))) (f9 (f16 f59 (f11 f20 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f8 f25) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f9 f31 (f9 (f16 f59 ?v0) ?v2))) (f9 (f16 f59 (f9 f31 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f8 f25) ?v0) f1) (forall ((?v1 S9) (?v2 S9)) (= (f6 (f7 f8 (f11 f20 (f28 (f29 f60 ?v1) ?v2))) (f9 (f16 f59 (f9 (f16 f59 (f11 f20 ?v1)) (f11 f20 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f8 f25) ?v0) f1) (forall ((?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f9 f31 (f9 (f16 f59 ?v1) ?v2))) (f9 (f16 f59 (f9 (f16 f59 (f9 f31 ?v1)) (f9 f31 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (= (f9 (f16 f59 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f16 f59 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f9 (f16 f59 ?v0) ?v1) (f9 (f16 f59 ?v1) ?v0))))
(assert (forall ((?v0 S5)) (= (f9 f31 ?v0) (f9 f10 ?v0))))
(assert (exists ((?v0 S5)) (forall ((?v1 S9)) (= (f6 (f7 f8 (f9 f31 (f11 f12 ?v1))) (f9 (f16 f59 (f11 f20 ?v1)) ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S9) (?v2 S9)) (=> (= (f6 (f7 f8 ?v0) f25) f1) (=> (= (f6 (f7 f8 (f11 f20 ?v1)) (f9 (f16 f59 ?v0) (f11 f20 ?v2))) f1) (= ?v1 f33)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) f25) f1) (=> (= (f6 (f7 f8 (f9 f31 ?v1)) (f9 (f16 f59 ?v0) (f9 f31 ?v2))) f1) (= ?v1 f25)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) f25) f1) (=> (= (f6 (f7 f8 (f9 f10 ?v1)) (f9 (f16 f59 ?v0) (f9 f10 ?v2))) f1) (= ?v1 f25)))))
(assert (forall ((?v0 S9)) (exists ((?v1 S5)) (forall ((?v2 S9)) (= (f6 (f7 f8 (f11 f20 (f28 (f29 f60 ?v2) ?v0))) (f9 (f16 f59 (f11 f20 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (forall ((?v2 S5)) (= (f6 (f7 f8 (f9 f31 (f9 (f16 f59 ?v2) ?v0))) (f9 (f16 f59 (f9 f31 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S9)) (exists ((?v1 S5)) (forall ((?v2 S9)) (= (f6 (f7 f8 (f11 f20 (f28 (f29 f60 ?v0) ?v2))) (f9 (f16 f59 (f11 f20 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (forall ((?v2 S5)) (= (f6 (f7 f8 (f9 f31 (f9 (f16 f59 ?v0) ?v2))) (f9 (f16 f59 (f9 f31 ?v2)) ?v1)) f1)))))
(assert (exists ((?v0 S5)) (forall ((?v1 S9) (?v2 S9)) (= (f6 (f7 f8 (f11 f20 (f28 (f29 f60 ?v1) ?v2))) (f9 (f16 f59 (f9 (f16 f59 (f11 f20 ?v1)) (f11 f20 ?v2))) ?v0)) f1))))
(assert (exists ((?v0 S5)) (forall ((?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f9 f31 (f9 (f16 f59 ?v1) ?v2))) (f9 (f16 f59 (f9 (f16 f59 (f9 f31 ?v1)) (f9 f31 ?v2))) ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= 0 (+ (* ?v0 ?v0) (* ?v1 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 f25) (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v0)) (f9 (f16 f59 ?v1) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v0)) (f9 (f16 f59 ?v1) ?v1)) f25) (and (= ?v0 f25) (= ?v1 f25)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 (f9 (f16 f17 (f9 (f16 f59 ?v0) ?v0)) (f9 (f16 f59 ?v1) ?v1))) f25) f1) (and (= ?v0 f25) (= ?v1 f25)))))
(assert (exists ((?v0 S5)) (and (= (f61 f25 ?v0) f1) (forall ((?v1 S9)) (= (f6 (f7 f8 (f9 f31 (f11 f12 ?v1))) (f9 (f16 f59 (f11 f20 ?v1)) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (< (+ (* ?v3 ?v0) (* ?v4 ?v2)) ?v1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f61 ?v0 ?v1) f1) (=> (= (f61 ?v2 ?v1) f1) (=> (= (f6 ?v_0 ?v3) f1) (=> (= (f6 ?v_0 ?v4) f1) (=> (= (f9 (f16 f17 ?v3) ?v4) f19) (= (f61 (f9 (f16 f17 (f9 (f16 f59 ?v3) ?v0)) (f9 (f16 f59 ?v4) ?v2)) ?v1) f1)))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (=> (= (f61 f25 ?v0) f1) (= (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f16 f59 ?v0))) (=> (= (f61 ?v0 f25) f1) (= (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f61 ?v0 ?v1) f1) (=> (= (f61 ?v2 ?v3) f1) (=> (= (f61 f25 ?v1) f1) (=> (= (f6 (f7 f8 f25) ?v2) f1) (= (f61 (f9 (f16 f59 ?v0) ?v2) (f9 (f16 f59 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 f25))) (=> (= (f61 ?v0 ?v1) f1) (=> (= (f61 ?v2 ?v3) f1) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f61 (f9 (f16 f59 ?v0) ?v2) (f9 (f16 f59 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f61 ?v0 ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (= (f6 (f7 f8 f25) ?v0) f1) (=> (= (f61 f25 ?v2) f1) (= (f61 (f9 (f16 f59 ?v0) ?v2) (f9 (f16 f59 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S11)) (= (f23 f24 (f42 f43 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f42 f43 (f23 f24 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f42 f43 (f23 f24 ?v0)) 0))))
(check-sat)
(exit)
