(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S1)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 () S5)
(declare-fun f10 (S7 S5) S5)
(declare-fun f11 (S8 S5) S7)
(declare-fun f12 () S8)
(declare-fun f13 () S5)
(declare-fun f14 () S5)
(declare-fun f15 () S7)
(declare-fun f16 (S9 Int) Int)
(declare-fun f17 () S9)
(declare-fun f18 () S8)
(declare-fun f19 (S10 Int) S9)
(declare-fun f20 () S10)
(declare-fun f21 () S8)
(declare-fun f22 () S10)
(declare-fun f23 (S11 Int) S5)
(declare-fun f24 (S12 S5) Int)
(declare-fun f25 () S6)
(declare-fun f26 (S13 S6) S8)
(declare-fun f27 () S13)
(declare-fun f28 (S14 S3) S10)
(declare-fun f29 () S14)
(declare-fun f30 () S13)
(declare-fun f31 () S14)
(declare-fun f32 () S8)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (<= ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 f9) (f10 (f11 f12 f13) f14)) f1)))
(assert (= (f6 (f7 f8 f9) f13) f1))
(assert (= (f6 (f7 f8 f9) f14) f1))
(assert (= (f6 (f7 f8 f9) f13) f1))
(assert (= (f6 (f7 f8 f9) f14) f1))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f9))) (= (= (f6 ?v_0 (f10 (f11 f12 ?v0) ?v1)) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f8 ?v0) f9) f1) (= (f6 (f7 f8 ?v1) f9) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f9))) (= (= (f6 (f7 f8 (f10 (f11 f12 ?v0) ?v1)) f9) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v1) f9) f1)) (and (= (f6 (f7 f8 ?v0) f9) f1) (= (f6 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 ?v2) ?v1)) f1) (and (=> (= (f6 (f7 f8 f9) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)) (and (=> (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f8 ?v2) ?v0) f1)) (not (= ?v1 f9)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f9) ?v0) f1) (= (f10 (f11 f12 (f10 f15 ?v1)) ?v0) (f10 f15 (f10 (f11 f12 ?v1) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f9))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f10 (f11 f12 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f9) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f8 (f10 (f11 f12 ?v0) ?v1)) f9) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f9) f1) (=> (= (f6 (f7 f8 f9) ?v1) f1) (= (f6 (f7 f8 (f10 (f11 f12 ?v0) ?v1)) f9) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f9) f1) (=> (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f8 f9) (f10 (f11 f12 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f9) ?v2) f1) (= (f6 (f7 f8 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) f9) f1) (= (f6 (f7 f8 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 f9) ?v0) f9)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 f9) ?v0) f9)))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f8 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f10 f15 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 (f10 f15 ?v0)) (f10 f15 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f9)) (= (f10 f15 (f10 (f11 f12 ?v1) ?v0)) (f10 (f11 f12 (f10 f15 ?v1)) (f10 f15 ?v0))))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) f9) f9)))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f16 f17 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f9) ?v0) f1) (= (f10 f15 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f16 f17 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 f9) (f10 f15 ?v0)) f1) (not (= ?v0 f9)))))
(assert (forall ((?v0 Int)) (not (< (f16 f17 ?v0) 0))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f8 (f10 f15 ?v0)) f9) f1))))
(assert (forall ((?v0 S4)) (=> (exists ((?v1 S5)) (= (f6 ?v0 ?v1) f1)) (=> (exists ((?v1 S5)) (forall ((?v2 S5)) (=> (= (f6 ?v0 ?v2) f1) (= (f6 (f7 f8 ?v2) ?v1) f1)))) (exists ((?v1 S5)) (forall ((?v2 S5)) (= (exists ((?v3 S5)) (and (= (f6 ?v0 ?v3) f1) (= (f6 (f7 f8 ?v2) ?v3) f1))) (= (f6 (f7 f8 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f9))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (exists ((?v2 S5)) (let ((?v_1 (f7 f8 ?v2))) (and (= (f6 ?v_0 ?v2) f1) (and (= (f6 ?v_1 ?v0) f1) (= (f6 ?v_1 ?v1) f1))))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f8 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (=> (not false) (= (f6 (f7 f8 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (= (f16 f17 0) 0))
(assert (= (f10 f15 f9) f9))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f9 ?v0) (= ?v0 f9))))
(assert (forall ((?v0 Int)) (= (= (f16 f17 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f10 f15 ?v0) f9) (= ?v0 f9))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f8 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= ?v0 ?v1)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (or (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 (f10 (f11 f18 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f16 (f19 f20 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 (f10 (f11 f21 ?v1) ?v2)) f1) (and (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f16 (f19 f22 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f10 (f11 f18 ?v0) ?v1)) ?v2) f1) (and (= (f6 (f7 f8 ?v0) ?v2) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f16 (f19 f20 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f10 (f11 f21 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f8 ?v0) ?v2) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f16 (f19 f22 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (not (= (f6 (f7 f8 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f8 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (not (= (f6 (f7 f8 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S1)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f8 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (exists ((?v2 S5)) (and (= (f6 (f7 f8 ?v0) ?v2) f1) (= (f6 (f7 f8 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S11)) (let ((?v_0 (f7 f8 ?v2))) (=> (< ?v0 ?v1) (=> (= (f6 ?v_0 (f23 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f6 (f7 f8 (f23 ?v3 ?v5)) (f23 ?v3 ?v4)) f1))) (= (f6 ?v_0 (f23 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int) (?v3 S12)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (< ?v2 (f24 ?v3 ?v0)) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (< (f24 ?v3 ?v5) (f24 ?v3 ?v4)))) (< ?v2 (f24 ?v3 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S7) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f10 ?v2 ?v0) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (= (f6 (f7 f8 (f10 ?v2 ?v5)) (f10 ?v2 ?v4)) f1))) (= (f6 (f7 f8 ?v3) (f10 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f16 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f16 ?v2 ?v5) (f16 ?v2 ?v4)))) (< ?v3 (f16 ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11) (?v3 S5)) (=> (< ?v0 ?v1) (=> (= (f23 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f8 (f23 ?v2 ?v4)) (f23 ?v2 ?v5)) f1))) (= (f6 (f7 f8 (f23 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S12) (?v3 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f24 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (< (f24 ?v2 ?v4) (f24 ?v2 ?v5)))) (< (f24 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11) (?v3 S5)) (=> (< ?v0 ?v1) (=> (= (f6 (f7 f8 (f23 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f8 (f23 ?v2 ?v4)) (f23 ?v2 ?v5)) f1))) (= (f6 (f7 f8 (f23 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S12) (?v3 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (< (f24 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (< (f24 ?v2 ?v4) (f24 ?v2 ?v5)))) (< (f24 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S11) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f23 ?v1 ?v2)) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f8 (f23 ?v1 ?v4)) (f23 ?v1 ?v5)) f1))) (= (f6 (f7 f8 ?v0) (f23 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S12) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f24 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (< (f24 ?v1 ?v4) (f24 ?v1 ?v5)))) (< ?v0 (f24 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S12) (?v2 S5) (?v3 S5)) (=> (< ?v0 (f24 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (< (f24 ?v1 ?v4) (f24 ?v1 ?v5)))) (< ?v0 (f24 ?v1 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S11) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 (f23 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f8 (f23 ?v1 ?v4)) (f23 ?v1 ?v5)) f1))) (= (f6 ?v_0 (f23 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 S12) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (< (f24 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f8 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (< (f24 ?v0 ?v5) (f24 ?v0 ?v4)))) (< (f24 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S11) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f8 (f23 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f6 (f7 f8 (f23 ?v0 ?v5)) (f23 ?v0 ?v4)) f1))) (= (f6 (f7 f8 (f23 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S7) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f10 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v3) ?v2) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (= (f6 (f7 f8 (f10 ?v1 ?v5)) (f10 ?v1 ?v4)) f1))) (= (f6 (f7 f8 (f10 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f16 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f16 ?v1 ?v5) (f16 ?v1 ?v4)))) (< (f16 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f10 (f11 f21 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f16 (f19 f22 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f10 (f11 f21 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f16 (f19 f22 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f10 (f11 f18 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f16 (f19 f20 ?v2) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f10 (f11 f18 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f16 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) f9) f1) (=> (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f25 f9) (f10 (f11 f12 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f25 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 (f10 (f11 f18 ?v0) ?v1)) ?v2) f1) (=> (=> (= (f6 (f7 f25 ?v0) ?v2) f1) (=> (= (f6 (f7 f25 ?v1) ?v2) f1) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f16 (f19 f20 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f6 ?v_0 (f10 (f11 f21 ?v1) ?v2)) f1) (=> (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f16 (f19 f22 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) ?v3) f1) (= (f6 (f7 f25 (f10 (f11 f21 ?v0) ?v2)) (f10 (f11 f21 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f16 (f19 f22 ?v0) ?v2) (f16 (f19 f22 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) ?v3) f1) (= (f6 (f7 f25 (f10 (f11 f18 ?v0) ?v2)) (f10 (f11 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f16 (f19 f20 ?v0) ?v2) (f16 (f19 f20 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) ?v1) f1) (= (f6 (f7 f25 (f10 (f11 f18 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f16 (f19 f20 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) ?v1) f1) (= (f6 (f7 f25 (f10 (f11 f18 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f16 (f19 f20 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 ?v_0 (f10 (f11 f21 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f16 (f19 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 ?v_0 (f10 (f11 f21 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f16 (f19 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f10 (f11 f21 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f16 (f19 f22 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f10 (f11 f18 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f16 (f19 f20 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f10 (f11 f21 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f16 (f19 f22 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f10 (f11 f18 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f16 (f19 f20 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f6 (f7 f25 (f10 (f11 f21 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f16 (f19 f22 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f6 (f7 f25 (f10 (f11 f21 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f16 (f19 f22 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f10 (f11 f18 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f16 (f19 f20 ?v2) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f10 (f11 f18 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f16 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f21 ?v0))) (= (f6 (f7 f25 (f10 (f11 f18 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))) (f10 ?v_0 (f10 (f11 f18 ?v1) ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f19 f22 ?v0))) (<= (f16 (f19 f20 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2)) (f16 ?v_0 (f16 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f25 (f10 (f11 f18 ?v0) ?v1)) ?v2) f1) (and (= (f6 (f7 f25 ?v0) ?v2) f1) (= (f6 (f7 f25 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f16 (f19 f20 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f18 ?v0))) (= (f6 (f7 f25 (f10 ?v_0 (f10 (f11 f21 ?v1) ?v2))) (f10 (f11 f21 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f19 f20 ?v0))) (<= (f16 ?v_0 (f16 (f19 f22 ?v1) ?v2)) (f16 (f19 f22 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (= (= (f6 ?v_0 (f10 (f11 f21 ?v1) ?v2)) f1) (and (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f16 (f19 f22 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f10 (f11 f21 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f16 (f19 f22 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f10 (f11 f18 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f16 (f19 f20 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f25 (f10 (f11 f21 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f16 (f19 f22 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f25 (f10 (f11 f21 ?v0) ?v1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f16 (f19 f22 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f25 ?v0) (f10 (f11 f18 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f16 (f19 f20 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f25 ?v0) (f10 (f11 f18 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f16 (f19 f20 ?v0) ?v1))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f25 ?v0) (f10 f15 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f16 f17 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f6 (f7 f25 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (and (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f6 (f7 f25 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (= (= (f6 ?v_0 (f10 (f11 f18 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f16 (f19 f20 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f25 (f10 (f11 f21 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f25 ?v0) ?v2) f1) (= (f6 (f7 f25 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f16 (f19 f22 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f6 (f7 f25 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (= (= (f6 (f7 f25 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f25 ?v1) ?v2) f1) (= (f6 (f7 f25 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f25 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f25 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v2))) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 (f10 f15 ?v0)) ?v1) f1) (= (f6 (f7 f25 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f16 f17 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f25 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f25 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 Int)) (<= 0 (f16 f17 ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f25 f9) (f10 f15 ?v0)) f1)))
(assert (forall ((?v0 Int)) (= (<= (f16 f17 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f25 (f10 f15 ?v0)) f9) f1) (= ?v0 f9))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f25 f9) ?v0) f1) (= (f10 f15 ?v0) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f25 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f25 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (and (= (f6 (f7 f25 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (and (= (f6 (f7 f25 ?v0) ?v1) f1) (not (= (f6 (f7 f25 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f25 ?v0) ?v1) f1) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f25 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f25 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (= (f6 (f7 f25 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f25 ?v1) ?v0) f1) (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (not (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f25 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (= (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f6 (f7 f8 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f6 (f7 f8 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f25 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) ?v0) f1) (= (f6 (f7 f8 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (and (= (f6 (f7 f25 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f25 ?v0) ?v1) f1) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (= (= (f6 ?v_0 (f10 (f11 f12 ?v0) ?v1)) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f25 ?v0) f9) f1) (= (f6 (f7 f25 ?v1) f9) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (= (= (f6 (f7 f25 (f10 (f11 f12 ?v0) ?v1)) f9) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f25 ?v1) f9) f1)) (and (= (f6 (f7 f25 ?v0) f9) f1) (= (f6 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 f9) ?v2) f1) (= (f6 (f7 f25 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) f9) f1) (= (f6 (f7 f25 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (= (= (f6 ?v_0 (f10 (f11 f12 ?v0) ?v1)) f1) (and (or (= (f6 (f7 f25 ?v0) f9) f1) (= (f6 ?v_0 ?v1) f1)) (or (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f25 ?v1) f9) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f25 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 ?v2) ?v1)) f1) (and (=> (= (f6 (f7 f8 f9) ?v1) f1) (= (f6 (f7 f25 ?v0) ?v2) f1)) (=> (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f25 ?v2) ?v0) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 (f7 f8 f9) ?v1) f1) (= (f6 ?v_0 (f10 (f11 f12 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 f9) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f25 (f10 (f11 f12 ?v0) ?v1)) f9) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 f9))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v2) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f8 (f10 (f11 f12 ?v0) ?v3)) (f10 (f11 f12 ?v1) ?v2)) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f25 f9) ?v0) f1) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f9) ?v2) f1) (=> (= (f6 (f7 f25 ?v2) ?v3) f1) (= (f6 (f7 f8 (f10 (f11 f12 ?v0) ?v3)) (f10 (f11 f12 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f25 f9) ?v0) f1) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f9) ?v2) f1) (=> (= (f6 (f7 f25 ?v2) ?v3) f1) (= (f6 (f7 f25 (f10 (f11 f12 ?v0) ?v3)) (f10 (f11 f12 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) f9) f1) (=> (= (f6 (f7 f8 f9) ?v1) f1) (= (f6 (f7 f25 (f10 (f11 f12 ?v0) ?v1)) f9) f1)))))
(assert (forall ((?v0 S11) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f25 (f23 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f6 (f7 f8 (f23 ?v0 ?v5)) (f23 ?v0 ?v4)) f1))) (= (f6 (f7 f8 (f23 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S12) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (<= (f24 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f8 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (< (f24 ?v0 ?v5) (f24 ?v0 ?v4)))) (< (f24 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S11) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f8 (f23 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f6 (f7 f25 (f23 ?v0 ?v5)) (f23 ?v0 ?v4)) f1))) (= (f6 (f7 f8 (f23 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S12) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (< (f24 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f25 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v5) ?v4) f1) (<= (f24 ?v0 ?v5) (f24 ?v0 ?v4)))) (< (f24 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S11) (?v2 Int) (?v3 Int)) (=> (= (f6 (f7 f25 ?v0) (f23 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f8 (f23 ?v1 ?v4)) (f23 ?v1 ?v5)) f1))) (= (f6 (f7 f8 ?v0) (f23 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S12) (?v2 S5) (?v3 S5)) (=> (<= ?v0 (f24 ?v1 ?v2)) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (< (f24 ?v1 ?v4) (f24 ?v1 ?v5)))) (< ?v0 (f24 ?v1 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S11) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 (f23 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f25 (f23 ?v1 ?v4)) (f23 ?v1 ?v5)) f1))) (= (f6 ?v_0 (f23 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S12) (?v2 S5) (?v3 S5)) (=> (< ?v0 (f24 ?v1 ?v2)) (=> (= (f6 (f7 f25 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v4) ?v5) f1) (<= (f24 ?v1 ?v4) (f24 ?v1 ?v5)))) (< ?v0 (f24 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11) (?v3 S5)) (=> (<= ?v0 ?v1) (=> (= (f6 (f7 f8 (f23 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f25 (f23 ?v2 ?v4)) (f23 ?v2 ?v5)) f1))) (= (f6 (f7 f8 (f23 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S12) (?v3 Int)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (< (f24 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v4) ?v5) f1) (<= (f24 ?v2 ?v4) (f24 ?v2 ?v5)))) (< (f24 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11) (?v3 S5)) (=> (< ?v0 ?v1) (=> (= (f6 (f7 f25 (f23 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f8 (f23 ?v2 ?v4)) (f23 ?v2 ?v5)) f1))) (= (f6 (f7 f8 (f23 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S12) (?v3 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (<= (f24 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v4) ?v5) f1) (< (f24 ?v2 ?v4) (f24 ?v2 ?v5)))) (< (f24 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f25 ?v0) ?v0) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f25 ?v0) ?v1) f1) (= (f6 (f7 f25 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f25 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (=> (= (f6 (f7 f8 ?v2) ?v0) f1) (= (f6 (f7 f25 ?v2) ?v1) f1))) (= (f6 (f7 f25 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (forall ((?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v3) f1) (=> (= (f6 (f7 f8 ?v3) ?v1) f1) (= (f6 (f7 f25 ?v3) ?v2) f1)))) (= (f6 (f7 f25 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S11)) (let ((?v_0 (f7 f8 ?v2))) (=> (<= ?v0 ?v1) (=> (= (f6 ?v_0 (f23 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f6 (f7 f25 (f23 ?v3 ?v5)) (f23 ?v3 ?v4)) f1))) (= (f6 ?v_0 (f23 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int) (?v3 S12)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (< ?v2 (f24 ?v3 ?v0)) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v5) ?v4) f1) (<= (f24 ?v3 ?v5) (f24 ?v3 ?v4)))) (< ?v2 (f24 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S11)) (=> (< ?v0 ?v1) (=> (= (f6 (f7 f25 ?v2) (f23 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f6 (f7 f8 (f23 ?v3 ?v5)) (f23 ?v3 ?v4)) f1))) (= (f6 (f7 f8 ?v2) (f23 ?v3 ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int) (?v3 S12)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (<= ?v2 (f24 ?v3 ?v0)) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (< (f24 ?v3 ?v5) (f24 ?v3 ?v4)))) (< ?v2 (f24 ?v3 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f25 ?v0) ?v2) f1)) (= (f10 (f11 f18 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f16 (f19 f20 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S12) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (<= (f24 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f25 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v5) ?v4) f1) (<= (f24 ?v0 ?v5) (f24 ?v0 ?v4)))) (<= (f24 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S11) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f25 (f23 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f6 (f7 f25 (f23 ?v0 ?v5)) (f23 ?v0 ?v4)) f1))) (= (f6 (f7 f25 (f23 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S7) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f10 ?v1 ?v2)) (=> (= (f6 (f7 f25 ?v3) ?v2) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v5) ?v4) f1) (= (f6 (f7 f25 (f10 ?v1 ?v5)) (f10 ?v1 ?v4)) f1))) (= (f6 (f7 f25 (f10 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f16 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f16 ?v1 ?v5) (f16 ?v1 ?v4)))) (<= (f16 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 S12) (?v2 S5) (?v3 S5)) (=> (<= ?v0 (f24 ?v1 ?v2)) (=> (= (f6 (f7 f25 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v4) ?v5) f1) (<= (f24 ?v1 ?v4) (f24 ?v1 ?v5)))) (<= ?v0 (f24 ?v1 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S11) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f25 ?v0))) (=> (= (f6 ?v_0 (f23 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f25 (f23 ?v1 ?v4)) (f23 ?v1 ?v5)) f1))) (= (f6 ?v_0 (f23 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f25 ?v0) ?v2) f1)) (= (f10 (f11 f18 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f16 (f19 f20 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f25 ?v0) ?v2) f1)) (= (f10 (f11 f21 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f16 (f19 f22 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (forall ((?v2 S5)) (= (f6 (f7 f25 ?v0) ?v2) f1)) (= (f10 (f11 f21 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f16 (f19 f22 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S11) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f23 ?v1 ?v2)) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f25 (f23 ?v1 ?v4)) (f23 ?v1 ?v5)) f1))) (= (f6 (f7 f25 ?v0) (f23 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S12) (?v2 S5) (?v3 S5)) (=> (= ?v0 (f24 ?v1 ?v2)) (=> (= (f6 (f7 f25 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v4) ?v5) f1) (<= (f24 ?v1 ?v4) (f24 ?v1 ?v5)))) (<= ?v0 (f24 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11) (?v3 S5)) (=> (<= ?v0 ?v1) (=> (= (f6 (f7 f25 (f23 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f25 (f23 ?v2 ?v4)) (f23 ?v2 ?v5)) f1))) (= (f6 (f7 f25 (f23 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S12) (?v3 Int)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (<= (f24 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v4) ?v5) f1) (<= (f24 ?v2 ?v4) (f24 ?v2 ?v5)))) (<= (f24 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11) (?v3 S5)) (=> (<= ?v0 ?v1) (=> (= (f23 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f6 (f7 f25 (f23 ?v2 ?v4)) (f23 ?v2 ?v5)) f1))) (= (f6 (f7 f25 (f23 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S12) (?v3 Int)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f24 ?v2 ?v1) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v4) ?v5) f1) (<= (f24 ?v2 ?v4) (f24 ?v2 ?v5)))) (<= (f24 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S11)) (let ((?v_0 (f7 f25 ?v2))) (=> (<= ?v0 ?v1) (=> (= (f6 ?v_0 (f23 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f6 (f7 f25 (f23 ?v3 ?v5)) (f23 ?v3 ?v4)) f1))) (= (f6 ?v_0 (f23 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int) (?v3 S12)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (<= ?v2 (f24 ?v3 ?v0)) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v5) ?v4) f1) (<= (f24 ?v3 ?v5) (f24 ?v3 ?v4)))) (<= ?v2 (f24 ?v3 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S7) (?v3 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f10 ?v2 ?v0) ?v3) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f25 ?v5) ?v4) f1) (= (f6 (f7 f25 (f10 ?v2 ?v5)) (f10 ?v2 ?v4)) f1))) (= (f6 (f7 f25 ?v3) (f10 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (= (f16 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f16 ?v2 ?v5) (f16 ?v2 ?v4)))) (<= ?v3 (f16 ?v2 ?v1)))))))
(assert (= f21 (f26 f27 f25)))
(assert (= f22 (f28 f29 f5)))
(assert (= f18 (f26 f30 f25)))
(assert (= f20 (f28 f31 f5)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f7 f25 ?v0)) (?v_0 (f10 (f11 f32 ?v0) ?v2))) (= (= (f6 ?v_1 (f10 (f11 f12 ?v1) ?v2)) f1) (ite (= (f6 (f7 f8 f9) ?v2) f1) (= (f6 (f7 f25 ?v_0) ?v1) f1) (ite (= (f6 (f7 f8 ?v2) f9) f1) (= (f6 (f7 f25 ?v1) ?v_0) f1) (= (f6 ?v_1 f9) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f10 (f11 f32 ?v2) ?v1))) (= (= (f6 (f7 f25 (f10 (f11 f12 ?v0) ?v1)) ?v2) f1) (ite (= (f6 (f7 f8 f9) ?v1) f1) (= (f6 (f7 f25 ?v0) ?v_0) f1) (ite (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f25 ?v_0) ?v0) f1) (= (f6 (f7 f25 f9) ?v2) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 f9) ?v0) f1) (= (= (f6 (f7 f8 (f10 (f11 f32 ?v1) ?v0)) (f10 (f11 f32 ?v2) ?v0)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f9))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f10 (f11 f32 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v0))) (=> (= (f6 (f7 f8 f9) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 (f7 f8 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f10 f15 ?v0)) (?v_1 (f10 f15 ?v2))) (=> (= (f6 (f7 f8 ?v_0) ?v1) f1) (=> (= (f6 (f7 f8 ?v_1) ?v3) f1) (= (f6 (f7 f8 (f10 (f11 f32 ?v_0) ?v_1)) (f10 (f11 f32 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f16 f17 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f25 f9) (f10 (f11 f32 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (= (= (f6 ?v_0 (f10 (f11 f32 ?v0) ?v1)) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f25 ?v0) f9) f1) (= (f6 (f7 f25 ?v1) f9) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (= (= (f6 (f7 f25 (f10 (f11 f32 ?v0) ?v1)) f9) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f25 ?v1) f9) f1)) (and (= (f6 (f7 f25 ?v0) f9) f1) (= (f6 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f16 f17 ?v1) ?v0) (f16 f17 (* ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 f9) ?v0) f1) (= (f10 (f11 f32 (f10 f15 ?v1)) ?v0) (f10 f15 (f10 (f11 f32 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f10 (f11 f32 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 f9) ?v0) f1) (=> (= (f6 (f7 f25 ?v1) f9) f1) (= (f6 (f7 f25 (f10 (f11 f32 ?v0) ?v1)) f9) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 f9) ?v0) f1) (=> (= (f6 (f7 f25 ?v1) f9) f1) (= (f6 (f7 f25 (f10 (f11 f32 ?v1) ?v0)) f9) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) f9) f1) (=> (= (f6 (f7 f25 f9) ?v1) f1) (= (f6 (f7 f25 (f10 (f11 f32 ?v0) ?v1)) f9) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f25 ?v0) f9) f1) (=> (= (f6 (f7 f25 ?v1) f9) f1) (= (f6 (f7 f25 f9) (f10 (f11 f32 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 f9) ?v2) f1) (= (f6 (f7 f25 (f10 (f11 f32 ?v0) ?v2)) (f10 (f11 f32 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v2))) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 f9) ?v2) f1) (= (f6 (f7 f25 (f10 ?v_0 ?v0)) (f10 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v2))) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 f9) ?v2) f1) (= (f6 (f7 f25 (f10 ?v_0 ?v0)) (f10 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) f9) f1) (= (f6 (f7 f25 (f10 (f11 f32 ?v1) ?v2)) (f10 (f11 f32 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v2))) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) f9) f1) (= (f6 (f7 f25 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f25 f9))) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) ?v3) f1) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 (f7 f25 (f10 (f11 f32 ?v0) ?v2)) (f10 (f11 f32 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f25 f9))) (=> (= (f6 (f7 f25 ?v0) ?v1) f1) (=> (= (f6 (f7 f25 ?v2) ?v3) f1) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 (f7 f25 (f10 (f11 f32 ?v0) ?v2)) (f10 (f11 f32 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (=> (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f25 ?v0) f9) f1) (= (f6 (f7 f25 ?v1) f9) f1))) (= (f6 ?v_0 (f10 (f11 f32 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f16 f17 (* ?v0 ?v1)) (* (f16 f17 ?v0) (f16 f17 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (=> (and (or (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f25 ?v0) f9) f1)) (or (= (f6 ?v_0 ?v1) f1) (= (f6 (f7 f25 ?v1) f9) f1))) (= (f10 f15 (f10 (f11 f32 ?v0) ?v1)) (f10 (f11 f32 (f10 f15 ?v0)) (f10 f15 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f25 f9))) (=> (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f25 ?v1) f9) f1)) (and (= (f6 (f7 f25 ?v0) f9) f1) (= (f6 ?v_0 ?v1) f1))) (= (f6 (f7 f25 (f10 (f11 f32 ?v0) ?v1)) f9) f1)))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f8 (f10 (f11 f32 ?v0) ?v0)) f9) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f10 (f11 f32 ?v0) ?v1)) (f10 (f11 f32 ?v2) ?v1)) f1) (or (and (= (f6 (f7 f8 f9) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)) (and (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f8 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v0))) (= (= (f6 (f7 f8 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) f1) (or (and (= (f6 (f7 f8 f9) ?v0) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)) (and (= (f6 (f7 f8 ?v0) f9) f1) (= (f6 (f7 f8 ?v2) ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v0))) (=> (= (f6 (f7 f8 f9) ?v0) f1) (= (= (f6 (f7 f8 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f9))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f10 (f11 f32 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f9) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f8 (f10 (f11 f32 ?v0) ?v1)) f9) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f9) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f8 (f10 (f11 f32 ?v1) ?v0)) f9) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f9))) (=> (= (f6 ?v_0 (f10 (f11 f32 ?v0) ?v1)) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f9))) (=> (= (f6 ?v_0 (f10 (f11 f32 ?v0) ?v1)) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v0))) (=> (= (f6 (f7 f8 ?v0) f9) f1) (= (= (f6 (f7 f8 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f9) f1) (=> (= (f6 (f7 f8 f9) ?v1) f1) (= (f6 (f7 f8 (f10 (f11 f32 ?v0) ?v1)) f9) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f9) f1) (=> (= (f6 (f7 f8 ?v1) f9) f1) (= (f6 (f7 f8 f9) (f10 (f11 f32 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f9) ?v2) f1) (= (f6 (f7 f8 (f10 (f11 f32 ?v0) ?v2)) (f10 (f11 f32 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f9) ?v2) f1) (= (f6 (f7 f8 (f10 ?v_0 ?v0)) (f10 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f9) ?v2) f1) (= (f6 (f7 f8 (f10 ?v_0 ?v0)) (f10 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) f9) f1) (= (f6 (f7 f8 (f10 (f11 f32 ?v1) ?v2)) (f10 (f11 f32 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) f9) f1) (= (f6 (f7 f8 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v0))) (= (f10 (f11 f32 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f10 f15 ?v0))) (= (f10 (f11 f32 ?v_0) ?v_0) (f10 (f11 f32 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f10 f15 (f10 (f11 f32 ?v0) ?v1)) (f10 (f11 f32 (f10 f15 ?v0)) (f10 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f17 (* ?v0 ?v1)) (* (f16 f17 ?v0) (f16 f17 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f9)) (= (= (f10 (f11 f32 ?v1) ?v0) (f10 (f11 f32 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v0))) (=> (not (= ?v0 f9)) (= (= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f32 ?v0))) (= (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f10 (f11 f32 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 ?v2) ?v3)) (f10 (f11 f12 (f10 (f11 f32 ?v0) ?v2)) (f10 (f11 f32 ?v1) ?v3)))))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f32 f9) ?v0) f9)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f32 f9) ?v0) f9)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f32 f9) ?v0) f9)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f32 ?v0) f9) f9)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f32 ?v0) f9) f9)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f32 ?v0) f9) f9)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f10 (f11 f32 ?v0) ?v1) f9) (or (= ?v0 f9) (= ?v1 f9)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f9)) (=> (not (= ?v1 f9)) (not (= (f10 (f11 f32 ?v0) ?v1) f9))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f10 (f11 f32 ?v0) ?v1) f9) (or (= ?v0 f9) (= ?v1 f9)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= ?v0 (f10 (f11 f12 ?v1) ?v2)) (ite (not (= ?v2 f9)) (= (f10 (f11 f32 ?v0) ?v2) ?v1) (= ?v0 f9)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f10 (f11 f12 ?v0) ?v1) ?v2) (ite (not (= ?v1 f9)) (= ?v0 (f10 (f11 f32 ?v2) ?v1)) (= ?v2 f9)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f9)) (= (= ?v1 (f10 (f11 f12 ?v2) ?v0)) (= (f10 (f11 f32 ?v1) ?v0) ?v2)))))
(check-sat)
(exit)
