(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S3)
(declare-fun f7 (S5 S3) S3)
(declare-fun f8 (S6 S3) S5)
(declare-fun f9 () S6)
(declare-fun f10 () S3)
(declare-fun f11 () S3)
(declare-fun f12 () S6)
(declare-fun f13 () S3)
(declare-fun f14 () S3)
(declare-fun f15 () S5)
(declare-fun f16 (S7 Int) Int)
(declare-fun f17 () S7)
(declare-fun f18 () S4)
(declare-fun f19 () S6)
(declare-fun f20 (S8 Int) S7)
(declare-fun f21 () S8)
(declare-fun f22 () S6)
(declare-fun f23 () S8)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 f6) (f7 (f8 f9 f10) f11)) f1)))
(assert (= (f3 (f4 f5 f6) f10) f1))
(assert (= (f3 (f4 f5 f10) (f7 (f8 f12 f13) f11)) f1))
(assert (= (f3 (f4 f5 f6) f11) f1))
(assert (= (f3 (f4 f5 f6) f13) f1))
(assert (= (f3 (f4 f5 f6) f11) f1))
(assert (= (f3 (f4 f5 f6) f10) f1))
(assert (= (f3 (f4 f5 f10) (f7 (f8 f12 f13) f11)) f1))
(assert (= (f3 (f4 f5 f10) f14) f1))
(assert (= (f3 (f4 f5 f6) (f7 (f8 f12 f13) f11)) f1))
(assert (forall ((?v0 S3)) (= (not (= (f3 (f4 f5 f6) (f7 (f8 f9 ?v0) ?v0)) f1)) (= ?v0 f6))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f5 (f7 (f8 f9 ?v1) ?v0)) (f7 (f8 f9 ?v2) ?v0)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f7 (f8 f9 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v0)) f6) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 ?v2) ?v1)) f1) (or (and (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)) (and (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (or (and (= (f3 (f4 f5 f6) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f7 (f8 f9 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v1) ?v0)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 (f7 (f8 f9 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (= (f3 (f4 f5 f6) f14) f1))
(assert (=> (forall ((?v0 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 ?v_0 f14) f1) (=> (= (f3 ?v_0 (f7 (f8 f12 f13) f11)) f1) false))))) false))
(assert (exists ((?v0 S3)) (let ((?v_0 (f4 f5 ?v0))) (and (= (f3 (f4 f5 f6) ?v0) f1) (and (= (f3 ?v_0 f14) f1) (= (f3 ?v_0 (f7 (f8 f12 f13) f11)) f1))))))
(assert (= (f7 f15 f14) f14))
(assert (= (f16 f17 1) 1))
(assert (forall ((?v0 S3)) (= (f7 (f8 f12 ?v0) f14) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (= (f7 (f8 f12 ?v1) ?v0) f14) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f6)) (= (f7 (f8 f12 ?v0) ?v0) f14))))
(assert (forall ((?v0 S3)) (= (f7 (f8 f12 ?v0) ?v0) (ite (= ?v0 f6) f6 f14))))
(assert (not (= 0 1)))
(assert (not (= f6 f14)))
(assert (not (= 1 0)))
(assert (not (= f14 f6)))
(assert (not (= f6 f14)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 f14) ?v0) ?v0)))
(assert (< 0 1))
(assert (= (f3 (f4 f5 f6) f14) f1))
(assert (not (< 1 0)))
(assert (not (= (f3 (f4 f5 f14) f6) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f7 (f8 f9 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3)) (= (f7 (f8 f12 ?v0) f6) f6)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f12 f6) ?v0) f6)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f12 ?v1) ?v2)) (f7 (f8 f12 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f12 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v0)) (f7 (f8 f12 ?v1) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f15 ?v0))) (= (f7 (f8 f9 ?v_0) ?v_0) (f7 (f8 f9 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 f15 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 (f7 f15 ?v0)) (f7 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f17 (* ?v0 ?v1)) (* (f16 f17 ?v0) (f16 f17 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (=> (= (f7 (f8 f9 ?v1) ?v0) ?v2) (= ?v1 (f7 (f8 f12 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (=> (= ?v1 (f7 (f8 f9 ?v2) ?v0)) (= (f7 (f8 f12 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (= (= (f7 (f8 f12 ?v1) ?v0) ?v2) (= ?v1 (f7 (f8 f9 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (= (= ?v1 (f7 (f8 f12 ?v2) ?v0)) (= (f7 (f8 f9 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f7 (f8 f9 ?v0) ?v1) f6) (or (= ?v0 f6) (= ?v1 f6)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (=> (not (= ?v1 f6)) (not (= (f7 (f8 f9 ?v0) ?v1) f6))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f7 (f8 f9 ?v0) ?v1) f6) (or (= ?v0 f6) (= ?v1 f6)))))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 ?v0) f6) f6)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 f6) ?v0) f6)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f7 f15 ?v0)) (?v_1 (f7 f15 ?v2))) (=> (= (f3 (f4 f5 ?v_0) ?v1) f1) (=> (= (f3 (f4 f5 ?v_1) ?v3) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v_0) ?v_1)) (f7 (f8 f9 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f16 f17 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (not (= ?v0 f6)) (= (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (= (= (f7 (f8 f9 ?v1) ?v0) (f7 (f8 f9 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f7 ?v_0 ?v0)) (f7 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f7 ?v_0 ?v0)) (f7 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 f6) (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (= (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 (f7 (f8 f9 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f12 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (=> (= (f3 (f4 f5 f6) (f7 (f8 f9 ?v0) ?v1)) f1) (= (f3 (f4 f5 (f7 ?v_0 ?v0)) (f7 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 f6)) (?v_1 (f8 f12 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 ?v_0 (f7 (f8 f9 ?v1) ?v0)) f1) (= (f3 (f4 f5 (f7 ?v_1 ?v1)) (f7 ?v_1 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (= (f3 (f4 f5 (f7 (f8 f12 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (= (f3 (f4 f5 ?v1) (f7 (f8 f12 ?v2) ?v0)) f1) (= (f3 (f4 f5 ?v2) (f7 (f8 f9 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 (f7 (f8 f9 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f5 ?v1) (f7 (f8 f12 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) (f7 (f8 f9 ?v2) ?v0)) f1) (= (f3 (f4 f5 (f7 (f8 f12 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f5 (f7 (f8 f12 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f5 ?v1) (f7 (f8 f9 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f5 ?v1) (f7 (f8 f12 ?v2) ?v0)) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f5 f6)) (?v_0 (f7 (f8 f9 ?v2) ?v1))) (= (= (f3 (f4 f5 (f7 (f8 f12 ?v0) ?v1)) ?v2) f1) (ite (= (f3 ?v_1 ?v1) f1) (= (f3 (f4 f5 ?v0) ?v_0) f1) (ite (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 ?v_0) ?v0) f1) (= (f3 ?v_1 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f5 ?v0)) (?v_0 (f7 (f8 f9 ?v0) ?v2))) (= (= (f3 ?v_1 (f7 (f8 f12 ?v1) ?v2)) f1) (ite (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 ?v_0) ?v1) f1) (ite (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 ?v1) ?v_0) f1) (= (f3 ?v_1 f6) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 f15 (f7 (f8 f12 ?v0) ?v1)) (f7 (f8 f12 (f7 f15 ?v0)) (f7 f15 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f7 f15 (f7 (f8 f12 ?v1) ?v0)) (f7 (f8 f12 (f7 f15 ?v1)) (f7 f15 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f7 (f8 f9 (f7 (f8 f12 ?v0) ?v1)) (f7 (f8 f12 ?v2) ?v3)) (f7 (f8 f12 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f7 (f8 f12 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 (f4 f5 ?v1) f6) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 (f4 f5 (f7 (f8 f12 ?v0) ?v1)) f6) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f6) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f7 (f8 f12 ?v0) ?v1)) (f7 (f8 f12 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)) (and (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 ?v2) ?v0) f1)) (not (= ?v1 f6)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f7 (f8 f12 (f7 f15 ?v1)) ?v0) (f7 f15 (f7 (f8 f12 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f7 (f8 f12 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f7 (f8 f12 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 (f7 (f8 f12 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 f6) (f7 (f8 f12 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f7 (f8 f12 ?v0) ?v2)) (f7 (f8 f12 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f7 (f8 f12 ?v1) ?v2)) (f7 (f8 f12 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= ?v0 (f7 (f8 f12 ?v1) ?v2)) (ite (not (= ?v2 f6)) (= (f7 (f8 f9 ?v0) ?v2) ?v1) (= ?v0 f6)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f7 (f8 f12 ?v0) ?v1) ?v2) (ite (not (= ?v1 f6)) (= ?v0 (f7 (f8 f9 ?v2) ?v1)) (= ?v2 f6)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (= (f7 (f8 f12 (f7 (f8 f9 ?v1) ?v0)) (f7 (f8 f9 ?v2) ?v0)) (f7 (f8 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (not (= ?v0 f6)) (= (f7 (f8 f12 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) (f7 (f8 f12 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f6)) (=> (not (= ?v1 f6)) (= (= (f7 (f8 f12 ?v2) ?v0) (f7 (f8 f12 ?v3) ?v1)) (= (f7 (f8 f9 ?v2) ?v1) (f7 (f8 f9 ?v3) ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (exists ((?v2 S3)) (let ((?v_1 (f4 f5 ?v2))) (and (= (f3 ?v_0 ?v2) f1) (and (= (f3 ?v_1 ?v0) f1) (= (f3 ?v_1 ?v1) f1))))))))))
(assert (forall ((?v0 S3)) (= (f7 (f8 f12 f6) ?v0) f6)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 ?v0) f14) ?v0)))
(assert (forall ((?v0 S3)) (= (= (f7 f15 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= (f16 f17 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= f6 ?v0) (= ?v0 f6))))
(assert (= (f7 f15 f6) f6))
(assert (= (f16 f17 0) 0))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 (f8 f9 ?v2) ?v3)) (f7 (f8 f9 (f7 ?v_0 ?v2)) (f7 (f8 f9 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f8 f9 (f7 (f8 f9 ?v0) ?v1))) (?v_0 (f8 f9 ?v2))) (= (f7 ?v_1 (f7 ?v_0 ?v3)) (f7 ?v_0 (f7 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f7 (f8 f9 ?v2) ?v3))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v_1) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 (f8 f9 (f7 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f7 ?v_1 (f7 ?v_0 ?v2)) (f7 ?v_0 (f7 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3)) (= (= f14 ?v0) (= ?v0 f14))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f7 f15 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f16 f17 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 f6) (f7 f15 ?v0)) f1) (not (= ?v0 f6)))))
(assert (forall ((?v0 Int)) (= (< 0 (f16 f17 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f5 (f7 f15 ?v0)) f6) f1))))
(assert (forall ((?v0 Int)) (not (< (f16 f17 ?v0) 0))))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 ?v0) f6) f6)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 ?v0) f6) f6)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 ?v0) f6) f6)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 f6) ?v0) f6)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 f6) ?v0) f6)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 f6) ?v0) f6)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f8 f9 ?v0) f14) ?v0)))
(assert (forall ((?v0 S2)) (=> (exists ((?v1 S3)) (= (f3 ?v0 ?v1) f1)) (=> (exists ((?v1 S3)) (forall ((?v2 S3)) (=> (= (f3 ?v0 ?v2) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (exists ((?v3 S3)) (and (= (f3 ?v0 ?v3) f1) (= (f3 (f4 f5 ?v2) ?v3) f1))) (= (f3 (f4 f5 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f12 ?v2))) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v2) f6) f1) (=> (= (f3 (f4 f5 f6) (f7 (f8 f9 ?v0) ?v1)) f1) (= (f3 (f4 f18 (f7 ?v_0 ?v0)) (f7 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f12 ?v2))) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 f6) ?v2) f1) (=> (= (f3 (f4 f5 f6) (f7 (f8 f9 ?v1) ?v0)) f1) (= (f3 (f4 f18 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f18 f6) (f7 f15 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f16 f17 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f18 (f7 f15 ?v0)) f6) f1) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (<= (f16 f17 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f18 f6) ?v0) f1) (= (f7 f15 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f18 ?v0) (f7 f15 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f16 f17 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 (f7 f15 ?v0)) ?v1) f1) (= (f3 (f4 f18 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f16 f17 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f18 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f18 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f18 f6) (f7 (f8 f9 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (= (= (f3 ?v_0 (f7 (f8 f9 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f18 ?v0) f6) f1) (= (f3 (f4 f18 ?v1) f6) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (= (= (f3 (f4 f18 (f7 (f8 f9 ?v0) ?v1)) f6) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f18 ?v1) f6) f1)) (and (= (f3 (f4 f18 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 f6) ?v0) f1) (= (f7 (f8 f9 (f7 f15 ?v1)) ?v0) (f7 f15 (f7 (f8 f9 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f16 f17 ?v1) ?v0) (f16 f17 (* ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f7 (f8 f9 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 f6) ?v0) f1) (=> (= (f3 (f4 f18 ?v1) f6) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 f6) ?v0) f1) (=> (= (f3 (f4 f18 ?v1) f6) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v1) ?v0)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 ?v0) f6) f1) (=> (= (f3 (f4 f18 f6) ?v1) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 ?v0) f6) f1) (=> (= (f3 (f4 f18 ?v1) f6) f1) (= (f3 (f4 f18 f6) (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 f6) ?v2) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 f6) ?v2) f1) (= (f3 (f4 f18 (f7 ?v_0 ?v0)) (f7 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 f6) ?v2) f1) (= (f3 (f4 f18 (f7 ?v_0 ?v0)) (f7 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v2) f6) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v2) f6) f1) (= (f3 (f4 f18 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f18 f6))) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f18 f6))) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f18 ?v0) f6) f1) (= (f3 (f4 f18 ?v1) f6) f1))) (= (f3 ?v_0 (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (=> (and (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f18 ?v0) f6) f1)) (or (= (f3 ?v_0 ?v1) f1) (= (f3 (f4 f18 ?v1) f6) f1))) (= (f7 f15 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 (f7 f15 ?v0)) (f7 f15 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f16 f17 (* ?v0 ?v1)) (* (f16 f17 ?v0) (f16 f17 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f18 ?v1) f6) f1)) (and (= (f3 (f4 f18 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1))) (= (f3 (f4 f18 (f7 (f8 f9 ?v0) ?v1)) f6) f1)))))
(assert (<= 0 1))
(assert (= (f3 (f4 f18 f6) f14) f1))
(assert (not (<= 1 0)))
(assert (not (= (f3 (f4 f18 f14) f6) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (= (= (f3 ?v_0 (f7 (f8 f12 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f18 ?v0) f6) f1) (= (f3 (f4 f18 ?v1) f6) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (= (= (f3 (f4 f18 (f7 (f8 f12 ?v0) ?v1)) f6) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f18 ?v1) f6) f1)) (and (= (f3 (f4 f18 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 f6) ?v2) f1) (= (f3 (f4 f18 (f7 (f8 f12 ?v0) ?v2)) (f7 (f8 f12 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v2) f6) f1) (= (f3 (f4 f18 (f7 (f8 f12 ?v1) ?v2)) (f7 (f8 f12 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (= (= (f3 ?v_0 (f7 (f8 f12 ?v0) ?v1)) f1) (and (or (= (f3 (f4 f18 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)) (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f18 ?v1) f6) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f18 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (= (f3 (f4 f18 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (= (f3 (f4 f18 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (= (f3 (f4 f18 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (=> (= (f3 (f4 f18 f6) ?v2) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f18 f6))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v2) ?v3) f1) (=> (= (f3 (f4 f18 f6) ?v0) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f18 f6) ?v2) f1) (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 ?v2) ?v1)) f1) (=> (= (f3 (f4 f18 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 ?v2) ?v1)) f1) (=> (= (f3 (f4 f18 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f18 f6) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f18 f6) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v2 ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f18 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 ?v2) ?v1)) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f18 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 f18 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f3 (f4 f18 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v0 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f18 ?v1) f14) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v0) ?v1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v1 ?v0) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f18 ?v1) f14) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v1) ?v0)) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f18 (f7 (f8 f12 ?v0) ?v1)) (f7 (f8 f12 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f18 ?v0) ?v2) f1)) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f18 ?v2) ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f18 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 ?v_0 (f7 (f8 f12 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f18 (f7 (f8 f12 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f7 (f8 f12 ?v0) ?v3)) (f7 (f8 f12 ?v1) ?v2)) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f18 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (=> (= (f3 (f4 f18 ?v2) ?v3) f1) (= (f3 (f4 f5 (f7 (f8 f12 ?v0) ?v3)) (f7 (f8 f12 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f18 f6) ?v0) f1) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (=> (= (f3 (f4 f18 ?v2) ?v3) f1) (= (f3 (f4 f18 (f7 (f8 f12 ?v0) ?v3)) (f7 (f8 f12 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 ?v0) f6) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f18 (f7 (f8 f12 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 ?v0) f6) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f18 f6) (f7 (f8 f12 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f18 (f7 (f8 f9 ?v1) ?v0)) (f7 (f8 f9 ?v2) ?v0)) f1) (= (f3 (f4 f18 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f18 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (= (f3 (f4 f18 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f18 ?v0)) (?v_0 (f7 (f8 f9 ?v0) ?v2))) (= (= (f3 ?v_1 (f7 (f8 f12 ?v1) ?v2)) f1) (ite (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f18 ?v_0) ?v1) f1) (ite (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f18 ?v1) ?v_0) f1) (= (f3 ?v_1 f6) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 (f8 f9 ?v2) ?v1))) (= (= (f3 (f4 f18 (f7 (f8 f12 ?v0) ?v1)) ?v2) f1) (ite (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f18 ?v0) ?v_0) f1) (ite (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f18 ?v_0) ?v0) f1) (= (f3 (f4 f18 f6) ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f18 ?v1) (f7 (f8 f12 ?v2) ?v0)) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f18 (f7 (f8 f12 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f18 ?v1) (f7 (f8 f9 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f18 ?v1) (f7 (f8 f9 ?v2) ?v0)) f1) (= (f3 (f4 f18 (f7 (f8 f12 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f18 (f7 (f8 f9 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f18 ?v1) (f7 (f8 f12 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (= (f3 (f4 f18 ?v1) (f7 (f8 f12 ?v2) ?v0)) f1) (= (f3 (f4 f18 ?v2) (f7 (f8 f9 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (= (f3 (f4 f18 (f7 (f8 f12 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (forall ((?v2 S3)) (=> (= (f3 (f4 f5 f6) ?v2) f1) (=> (= (f3 (f4 f5 ?v2) f14) f1) (= (f3 (f4 f18 (f7 (f8 f9 ?v2) ?v0)) ?v1) f1)))) (= (f3 (f4 f18 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f18 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f18 ?v0) f6) f1) (=> (= (f3 (f4 f18 (f7 f15 ?v1)) (f7 (f8 f9 ?v0) (f7 f15 ?v2))) f1) (= ?v1 f6)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f18 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f18 ?v0) ?v1) f1) (= (f3 (f4 f18 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f18 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f18 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f18 ?v0) ?v1) f1) (= (f3 (f4 f18 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f3 (f4 f18 ?v0) ?v1) f1) (= (f3 (f4 f18 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f18 ?v0))) (= (= (f3 ?v_0 (f7 (f8 f19 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f16 (f20 f21 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f18 (f7 (f8 f22 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f18 ?v0) ?v2) f1) (= (f3 (f4 f18 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f16 (f20 f23 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f3 (f4 f18 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (= (= (f3 (f4 f18 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f18 ?v1) ?v2) f1) (= (f3 (f4 f18 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f18 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f18 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f18 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f18 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f18 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 (f4 f18 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f18 ?v2))) (=> (= (f3 (f4 f18 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f18 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f18 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f5 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f7 (f8 f22 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f16 (f20 f23 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f7 (f8 f19 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f16 (f20 f21 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f7 (f8 f22 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f16 (f20 f23 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f7 (f8 f19 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f16 (f20 f21 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (or (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f5 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f18 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f18 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f18 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f18 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f18 ?v0) ?v1) f1) (not (= (f3 (f4 f18 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f18 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f18 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(check-sat)
(exit)
