(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S3) S3)
(declare-fun f7 (S6 S3) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S3)
(declare-fun f10 () S3)
(declare-fun f11 () S3)
(declare-fun f12 () S6)
(declare-fun f13 () S3)
(declare-fun f14 () S3)
(declare-fun f15 () S3)
(declare-fun f16 () S5)
(declare-fun f17 (S7 Int) Int)
(declare-fun f18 () S7)
(declare-fun f19 () S4)
(declare-fun f20 () S6)
(declare-fun f21 (S8 Int) S7)
(declare-fun f22 () S8)
(declare-fun f23 () S6)
(declare-fun f24 () S8)
(declare-fun f25 (S9 Int) S3)
(declare-fun f26 (S10 S3) Int)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f6 (f7 f8 f9) f10)) f11) f1)))
(assert (= (f3 (f4 f5 f9) (f6 (f7 f12 f11) f10)) f1))
(assert (= (f3 (f4 f5 f13) f10) f1))
(assert (= (f3 (f4 f5 f13) f10) f1))
(assert (= (f3 (f4 f5 f13) f11) f1))
(assert (= (f3 (f4 f5 f13) f9) f1))
(assert (= (f3 (f4 f5 f13) f14) f1))
(assert (= (f3 (f4 f5 f9) (f6 (f7 f12 f11) f10)) f1))
(assert (= (f3 (f4 f5 f14) (f6 (f7 f12 f11) f10)) f1))
(assert (= (f3 (f4 f5 f9) f15) f1))
(assert (= (f3 (f4 f5 f13) (f6 (f7 f12 f11) f10)) f1))
(assert (= (f3 (f4 f5 (f6 (f7 f8 f14) f10)) f11) f1))
(assert (= (f3 (f4 f5 f13) (f6 (f7 f8 f14) f10)) f1))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f6 f16 ?v0)) (?v_1 (f6 f16 ?v2))) (=> (= (f3 (f4 f5 ?v_0) ?v1) f1) (=> (= (f3 (f4 f5 ?v_1) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v_0) ?v_1)) (f6 (f7 f8 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f17 f18 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (exists ((?v0 S3)) (let ((?v_0 (f4 f5 ?v0))) (and (= (f3 (f4 f5 f13) ?v0) f1) (and (= (f3 ?v_0 f15) f1) (= (f3 ?v_0 (f6 (f7 f12 f11) f10)) f1))))))
(assert (=> (forall ((?v0 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 ?v_0 f15) f1) (=> (= (f3 ?v_0 (f6 (f7 f12 f11) f10)) f1) false))))) false))
(assert (forall ((?v0 S2)) (=> (exists ((?v1 S3)) (= (f3 ?v0 ?v1) f1)) (=> (exists ((?v1 S3)) (forall ((?v2 S3)) (=> (= (f3 ?v0 ?v2) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (exists ((?v3 S3)) (and (= (f3 ?v0 ?v3) f1) (= (f3 (f4 f5 ?v2) ?v3) f1))) (= (f3 (f4 f5 ?v2) ?v1) f1))))))))
(assert (= (f3 (f4 f19 f13) f9) f1))
(assert (forall ((?v0 S3)) (= (not (= (f3 (f4 f5 f13) (f6 (f7 f8 ?v0) ?v0)) f1)) (= ?v0 f13))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (= (f3 (f4 f5 (f6 (f7 f8 ?v1) ?v0)) (f6 (f7 f8 ?v2) ?v0)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v0)) f13) f1))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (= (f3 (f4 f5 f14) f15) f1))
(assert (= (f3 (f4 f5 f13) f15) f1))
(assert (not (= 1 0)))
(assert (not (= f15 f13)))
(assert (not (= 0 1)))
(assert (not (= f13 f15)))
(assert (not (= f13 f15)))
(assert (not (<= 1 0)))
(assert (not (= (f3 (f4 f19 f15) f13) f1)))
(assert (<= 0 1))
(assert (= (f3 (f4 f19 f13) f15) f1))
(assert (forall ((?v0 S3)) (= (f3 (f4 f19 ?v0) ?v0) f1)))
(assert (= (f6 f16 f15) f15))
(assert (= (f17 f18 1) 1))
(assert (forall ((?v0 S3)) (= (f6 (f7 f12 f13) ?v0) f13)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (= (= (f3 ?v_0 (f6 (f7 f12 ?v0) ?v1)) f1) (and (or (= (f3 (f4 f19 ?v0) f13) f1) (= (f3 ?v_0 ?v1) f1)) (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f19 ?v1) f13) f1)))))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f12 ?v0) f13) f13)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f12 ?v0) f15) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f19 ?v0) ?v1) f1) (= (f3 (f4 f19 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f12 ?v0) ?v0) (ite (= ?v0 f13) f13 f15))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f13)) (= (f6 (f7 f12 ?v0) ?v0) f15))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f13)) (= (= (f6 (f7 f12 ?v1) ?v0) f15) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v0 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f19 ?v1) f15) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v0) ?v1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v1 ?v0) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f19 ?v1) f15) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v1) ?v0)) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f19 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f19 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (< 0 1))
(assert (= (f3 (f4 f5 f13) f15) f1))
(assert (not (< 1 0)))
(assert (not (= (f3 (f4 f5 f15) f13) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f19 ?v1) f13) f1)) (and (= (f3 (f4 f19 ?v0) f13) f1) (= (f3 ?v_0 ?v1) f1))) (= (f3 (f4 f19 (f6 (f7 f8 ?v0) ?v1)) f13) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (=> (and (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f19 ?v0) f13) f1)) (or (= (f3 ?v_0 ?v1) f1) (= (f3 (f4 f19 ?v1) f13) f1))) (= (f6 f16 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f6 f16 ?v0)) (f6 f16 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f17 f18 (* ?v0 ?v1)) (* (f17 f18 ?v0) (f17 f18 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f19 ?v0) f13) f1) (= (f3 (f4 f19 ?v1) f13) f1))) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f19 f13))) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f19 f13))) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v2) f13) f1) (= (f3 (f4 f19 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v2) f13) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 f13) ?v2) f1) (= (f3 (f4 f19 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 f13) ?v2) f1) (= (f3 (f4 f19 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 f13) ?v2) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) f13) f1) (=> (= (f3 (f4 f19 ?v1) f13) f1) (= (f3 (f4 f19 f13) (f6 (f7 f8 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) f13) f1) (=> (= (f3 (f4 f19 f13) ?v1) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v0) ?v1)) f13) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 f13) ?v0) f1) (=> (= (f3 (f4 f19 ?v1) f13) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v1) ?v0)) f13) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 f13) ?v0) f1) (=> (= (f3 (f4 f19 ?v1) f13) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v0) ?v1)) f13) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 f13) ?v0) f1) (= (f6 (f7 f8 (f6 f16 ?v1)) ?v0) (f6 f16 (f6 (f7 f8 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f17 f18 ?v1) ?v0) (f17 f18 (* ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (= (= (f3 (f4 f19 (f6 (f7 f8 ?v0) ?v1)) f13) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f19 ?v1) f13) f1)) (and (= (f3 (f4 f19 ?v0) f13) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (= (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f19 ?v0) f13) f1) (= (f3 (f4 f19 ?v1) f13) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f19 f13) (f6 (f7 f8 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f19 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f19 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f15) ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f13)) (=> (= (f6 (f7 f8 ?v1) ?v0) ?v2) (= ?v1 (f6 (f7 f12 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f13)) (=> (= ?v1 (f6 (f7 f8 ?v2) ?v0)) (= (f6 (f7 f12 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f13)) (= (= (f6 (f7 f12 ?v1) ?v0) ?v2) (= ?v1 (f6 (f7 f8 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f13)) (= (= ?v1 (f6 (f7 f12 ?v2) ?v0)) (= (f6 (f7 f8 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f19 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (f3 (f4 f19 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f19 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) f1) (=> (= (f3 (f4 f5 f13) ?v1) f1) (= (f3 (f4 f19 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v2 ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f19 f13) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f19 f13) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) f1) (=> (= (f3 (f4 f19 f13) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) f1) (=> (= (f3 (f4 f19 f13) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 (f4 f19 f13) ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v2) ?v3) f1) (=> (= (f3 (f4 f19 f13) ?v0) f1) (=> (= (f3 (f4 f5 f13) ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f19 f13))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 (f4 f5 f13) ?v1) f1) (=> (= (f3 (f4 f19 f13) ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f5 ?v0) f13) f1) (= (= (f3 (f4 f19 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f19 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (= (f3 (f4 f19 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f19 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (= (f3 (f4 f19 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f19 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (= (f3 (f4 f19 (f6 (f7 f8 ?v1) ?v0)) (f6 (f7 f8 ?v2) ?v0)) f1) (= (f3 (f4 f19 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f15))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f12 ?v1) ?v2)) (f6 (f7 f12 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f6 (f7 f8 ?v0) ?v1) f13) (or (= ?v0 f13) (= ?v1 f13)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f13)) (=> (not (= ?v1 f13)) (not (= (f6 (f7 f8 ?v0) ?v1) f13))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 (f7 f8 ?v0) ?v1) f13) (or (= ?v0 f13) (= ?v1 f13)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) f13) f13)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f13) ?v0) f13)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f12 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v0)) (f6 (f7 f12 ?v1) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (not (= ?v0 f13)) (= (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f13)) (= (= (f6 (f7 f8 ?v1) ?v0) (f6 (f7 f8 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f16 ?v0))) (= (f6 (f7 f8 ?v_0) ?v_0) (f6 (f7 f8 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f16 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f6 f16 ?v0)) (f6 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 f18 (* ?v0 ?v1)) (* (f17 f18 ?v0) (f17 f18 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f13) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f13) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f13) ?v2) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f13) ?v2) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f13) ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f13) f1) (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f5 f13) (f6 (f7 f8 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f13) f1) (=> (= (f3 (f4 f5 f13) ?v1) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) f13) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f5 ?v0) f13) f1) (= (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f13))) (=> (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f13))) (=> (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v1) ?v0)) f13) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) f13) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (or (and (= (f3 (f4 f5 f13) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)) (and (= (f3 (f4 f5 ?v0) f13) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) f1) (or (and (= (f3 (f4 f5 f13) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)) (and (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f5 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f12 ?v2))) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v2) f13) f1) (=> (= (f3 (f4 f5 f13) (f6 (f7 f8 ?v0) ?v1)) f1) (= (f3 (f4 f19 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f12 ?v2))) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 f13) ?v2) f1) (=> (= (f3 (f4 f5 f13) (f6 (f7 f8 ?v1) ?v0)) f1) (= (f3 (f4 f19 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f13) f1) (= (= (f3 (f4 f19 (f6 (f7 f12 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f13) f1) (= (= (f3 (f4 f19 ?v1) (f6 (f7 f12 ?v2) ?v0)) f1) (= (f3 (f4 f19 ?v2) (f6 (f7 f8 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 (f4 f19 (f6 (f7 f8 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f19 ?v1) (f6 (f7 f12 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 (f4 f19 ?v1) (f6 (f7 f8 ?v2) ?v0)) f1) (= (f3 (f4 f19 (f6 (f7 f12 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (= (f3 (f4 f19 (f6 (f7 f12 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f19 ?v1) (f6 (f7 f8 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (= (f3 (f4 f19 ?v1) (f6 (f7 f12 ?v2) ?v0)) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 (f7 f8 ?v2) ?v1))) (= (= (f3 (f4 f19 (f6 (f7 f12 ?v0) ?v1)) ?v2) f1) (ite (= (f3 (f4 f5 f13) ?v1) f1) (= (f3 (f4 f19 ?v0) ?v_0) f1) (ite (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f19 ?v_0) ?v0) f1) (= (f3 (f4 f19 f13) ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f19 ?v0)) (?v_0 (f6 (f7 f8 ?v0) ?v2))) (= (= (f3 ?v_1 (f6 (f7 f12 ?v1) ?v2)) f1) (ite (= (f3 (f4 f5 f13) ?v2) f1) (= (f3 (f4 f19 ?v_0) ?v1) f1) (ite (= (f3 (f4 f5 ?v2) f13) f1) (= (f3 (f4 f19 ?v1) ?v_0) f1) (= (f3 ?v_1 f13) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f16 (f6 (f7 f12 ?v0) ?v1)) (f6 (f7 f12 (f6 f16 ?v0)) (f6 f16 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f13)) (= (f6 f16 (f6 (f7 f12 ?v1) ?v0)) (f6 (f7 f12 (f6 f16 ?v1)) (f6 f16 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f6 (f7 f8 (f6 (f7 f12 ?v0) ?v1)) (f6 (f7 f12 ?v2) ?v3)) (f6 (f7 f12 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v2) f13) f1) (= (f3 (f4 f19 (f6 (f7 f12 ?v1) ?v2)) (f6 (f7 f12 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 f13) ?v2) f1) (= (f3 (f4 f19 (f6 (f7 f12 ?v0) ?v2)) (f6 (f7 f12 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (= (= (f3 (f4 f19 (f6 (f7 f12 ?v0) ?v1)) f13) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f19 ?v1) f13) f1)) (and (= (f3 (f4 f19 ?v0) f13) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (= (= (f3 ?v_0 (f6 (f7 f12 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f19 ?v0) f13) f1) (= (f3 (f4 f19 ?v1) f13) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f13))) (= (= (f3 ?v_0 (f6 (f7 f12 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f13) f1) (= (f3 (f4 f5 ?v1) f13) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f13))) (= (= (f3 (f4 f5 (f6 (f7 f12 ?v0) ?v1)) f13) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f13) f1)) (and (= (f3 (f4 f5 ?v0) f13) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f6 (f7 f12 ?v0) ?v1)) (f6 (f7 f12 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f5 f13) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)) (and (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f5 ?v2) ?v0) f1)) (not (= ?v1 f13)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (f6 (f7 f12 (f6 f16 ?v1)) ?v0) (f6 f16 (f6 (f7 f12 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f12 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f5 (f6 (f7 f12 ?v0) ?v1)) f13) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f13) f1) (=> (= (f3 (f4 f5 f13) ?v1) f1) (= (f3 (f4 f5 (f6 (f7 f12 ?v0) ?v1)) f13) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f13) f1) (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f5 f13) (f6 (f7 f12 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f13) ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f12 ?v0) ?v2)) (f6 (f7 f12 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f13) f1) (= (f3 (f4 f5 (f6 (f7 f12 ?v1) ?v2)) (f6 (f7 f12 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= ?v0 (f6 (f7 f12 ?v1) ?v2)) (ite (not (= ?v2 f13)) (= (f6 (f7 f8 ?v0) ?v2) ?v1) (= ?v0 f13)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f6 (f7 f12 ?v0) ?v1) ?v2) (ite (not (= ?v1 f13)) (= ?v0 (f6 (f7 f8 ?v2) ?v1)) (= ?v2 f13)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f13)) (= (f6 (f7 f12 (f6 (f7 f8 ?v1) ?v0)) (f6 (f7 f8 ?v2) ?v0)) (f6 (f7 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (not (= ?v0 f13)) (= (f6 (f7 f12 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 (f7 f12 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f13)) (=> (not (= ?v1 f13)) (= (= (f6 (f7 f12 ?v2) ?v0) (f6 (f7 f12 ?v3) ?v1)) (= (f6 (f7 f8 ?v2) ?v1) (f6 (f7 f8 ?v3) ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) f13) f1) (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f19 f13) (f6 (f7 f12 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) f13) f1) (=> (= (f3 (f4 f5 f13) ?v1) f1) (= (f3 (f4 f19 (f6 (f7 f12 ?v0) ?v1)) f13) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f19 f13) ?v0) f1) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f13) ?v2) f1) (=> (= (f3 (f4 f19 ?v2) ?v3) f1) (= (f3 (f4 f19 (f6 (f7 f12 ?v0) ?v3)) (f6 (f7 f12 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f19 f13) ?v0) f1) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f13) ?v2) f1) (=> (= (f3 (f4 f19 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f12 ?v0) ?v3)) (f6 (f7 f12 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f5 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f12 ?v0) ?v3)) (f6 (f7 f12 ?v1) ?v2)) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 f13) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f19 (f6 (f7 f12 ?v0) ?v1)) f13) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f19 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f5 f13) ?v1) f1) (= (f3 ?v_0 (f6 (f7 f12 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f19 (f6 (f7 f12 ?v0) ?v1)) (f6 (f7 f12 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f5 f13) ?v1) f1) (= (f3 (f4 f19 ?v0) ?v2) f1)) (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f19 ?v2) ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f5 ?v0)) (?v_0 (f6 (f7 f8 ?v0) ?v2))) (= (= (f3 ?v_1 (f6 (f7 f12 ?v1) ?v2)) f1) (ite (= (f3 (f4 f5 f13) ?v2) f1) (= (f3 (f4 f5 ?v_0) ?v1) f1) (ite (= (f3 (f4 f5 ?v2) f13) f1) (= (f3 (f4 f5 ?v1) ?v_0) f1) (= (f3 ?v_1 f13) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f5 f13)) (?v_0 (f6 (f7 f8 ?v2) ?v1))) (= (= (f3 (f4 f5 (f6 (f7 f12 ?v0) ?v1)) ?v2) f1) (ite (= (f3 ?v_1 ?v1) f1) (= (f3 (f4 f5 ?v0) ?v_0) f1) (ite (= (f3 (f4 f5 ?v1) f13) f1) (= (f3 (f4 f5 ?v_0) ?v0) f1) (= (f3 ?v_1 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (= (f3 (f4 f5 ?v1) (f6 (f7 f12 ?v2) ?v0)) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (= (= (f3 (f4 f5 (f6 (f7 f12 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f5 ?v1) (f6 (f7 f8 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) (f6 (f7 f8 ?v2) ?v0)) f1) (= (f3 (f4 f5 (f6 (f7 f12 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v0) f1) (=> (= (f3 (f4 f5 (f6 (f7 f8 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f5 ?v1) (f6 (f7 f12 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f13) f1) (= (= (f3 (f4 f5 ?v1) (f6 (f7 f12 ?v2) ?v0)) f1) (= (f3 (f4 f5 ?v2) (f6 (f7 f8 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f13) f1) (= (= (f3 (f4 f5 (f6 (f7 f12 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 f13)) (?v_1 (f7 f12 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 ?v_0 (f6 (f7 f8 ?v1) ?v0)) f1) (= (f3 (f4 f5 (f6 ?v_1 ?v1)) (f6 ?v_1 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f12 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f13) f1) (=> (= (f3 (f4 f5 f13) (f6 (f7 f8 ?v0) ?v1)) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (forall ((?v2 S3)) (=> (= (f3 (f4 f5 f13) ?v2) f1) (=> (= (f3 (f4 f5 ?v2) f15) f1) (= (f3 (f4 f19 (f6 (f7 f8 ?v2) ?v0)) ?v1) f1)))) (= (f3 (f4 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f19 ?v0) f13) f1) (=> (= (f3 (f4 f19 (f6 f16 ?v1)) (f6 (f7 f8 ?v0) (f6 f16 ?v2))) f1) (= ?v1 f13)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f19 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (exists ((?v2 S3)) (let ((?v_1 (f4 f5 ?v2))) (and (= (f3 ?v_0 ?v2) f1) (and (= (f3 ?v_1 ?v0) f1) (= (f3 ?v_1 ?v1) f1))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f19 ?v0) ?v1) f1) (= (f3 (f4 f19 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f3 (f4 f19 ?v0) ?v1) f1) (= (f3 (f4 f19 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f19 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f20 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f17 (f21 f22 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f19 (f6 (f7 f23 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f19 ?v0) ?v2) f1) (= (f3 (f4 f19 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f17 (f21 f24 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f3 (f4 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (= (= (f3 (f4 f19 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f19 ?v1) ?v2) f1) (= (f3 (f4 f19 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f19 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f19 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f19 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f19 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f19 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f19 ?v2))) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f19 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f19 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f5 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f6 (f7 f23 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f17 (f21 f24 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f6 (f7 f20 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f17 (f21 f22 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f23 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f17 (f21 f24 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f20 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f17 (f21 f22 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (or (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f5 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f19 ?v2) ?v0) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f19 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f19 ?v1) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (= (f3 (f4 f19 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f19 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f19 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f19 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f19 ?v0) ?v1) f1) (not (= (f3 (f4 f19 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f19 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f19 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f19 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f19 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S9) (?v1 Int) (?v2 S3) (?v3 Int)) (=> (= (f3 (f4 f19 (f25 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f3 (f4 f5 (f25 ?v0 ?v5)) (f25 ?v0 ?v4)) f1))) (= (f3 (f4 f5 (f25 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S10) (?v1 S3) (?v2 Int) (?v3 S3)) (=> (<= (f26 ?v0 ?v1) ?v2) (=> (= (f3 (f4 f5 ?v3) ?v1) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (< (f26 ?v0 ?v5) (f26 ?v0 ?v4)))) (< (f26 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S9) (?v1 Int) (?v2 S3) (?v3 Int)) (=> (= (f3 (f4 f5 (f25 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f3 (f4 f19 (f25 ?v0 ?v5)) (f25 ?v0 ?v4)) f1))) (= (f3 (f4 f5 (f25 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S10) (?v1 S3) (?v2 Int) (?v3 S3)) (=> (< (f26 ?v0 ?v1) ?v2) (=> (= (f3 (f4 f19 ?v3) ?v1) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f19 ?v5) ?v4) f1) (<= (f26 ?v0 ?v5) (f26 ?v0 ?v4)))) (< (f26 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 Int) (?v3 Int)) (=> (= (f3 (f4 f19 ?v0) (f25 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f25 ?v1 ?v4)) (f25 ?v1 ?v5)) f1))) (= (f3 (f4 f5 ?v0) (f25 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S3) (?v3 S3)) (=> (<= ?v0 (f26 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f26 ?v1 ?v4) (f26 ?v1 ?v5)))) (< ?v0 (f26 ?v1 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (forall ((?v2 S3)) (=> (= (f3 (f4 f5 ?v2) ?v0) f1) (= (f3 (f4 f19 ?v2) ?v1) f1))) (= (f3 (f4 f19 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 (f25 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f3 (f4 f19 (f25 ?v1 ?v4)) (f25 ?v1 ?v5)) f1))) (= (f3 ?v_0 (f25 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S3) (?v3 S3)) (=> (< ?v0 (f26 ?v1 ?v2)) (=> (= (f3 (f4 f19 ?v2) ?v3) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f19 ?v4) ?v5) f1) (<= (f26 ?v1 ?v4) (f26 ?v1 ?v5)))) (< ?v0 (f26 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9) (?v3 S3)) (=> (<= ?v0 ?v1) (=> (= (f3 (f4 f5 (f25 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f3 (f4 f19 (f25 ?v2 ?v4)) (f25 ?v2 ?v5)) f1))) (= (f3 (f4 f5 (f25 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S10) (?v3 Int)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (< (f26 ?v2 ?v1) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f19 ?v4) ?v5) f1) (<= (f26 ?v2 ?v4) (f26 ?v2 ?v5)))) (< (f26 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (forall ((?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v3) f1) (=> (= (f3 (f4 f5 ?v3) ?v1) f1) (= (f3 (f4 f19 ?v3) ?v2) f1)))) (= (f3 (f4 f19 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S9)) (=> (< ?v0 ?v1) (=> (= (f3 (f4 f19 ?v2) (f25 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f3 (f4 f5 (f25 ?v3 ?v5)) (f25 ?v3 ?v4)) f1))) (= (f3 (f4 f5 ?v2) (f25 ?v3 ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int) (?v3 S10)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (<= ?v2 (f26 ?v3 ?v0)) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (< (f26 ?v3 ?v5) (f26 ?v3 ?v4)))) (< ?v2 (f26 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9) (?v3 S3)) (=> (< ?v0 ?v1) (=> (= (f3 (f4 f19 (f25 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f25 ?v2 ?v4)) (f25 ?v2 ?v5)) f1))) (= (f3 (f4 f5 (f25 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S10) (?v3 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (<= (f26 ?v2 ?v1) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f26 ?v2 ?v4) (f26 ?v2 ?v5)))) (< (f26 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S9)) (let ((?v_0 (f4 f5 ?v2))) (=> (<= ?v0 ?v1) (=> (= (f3 ?v_0 (f25 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f3 (f4 f19 (f25 ?v3 ?v5)) (f25 ?v3 ?v4)) f1))) (= (f3 ?v_0 (f25 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int) (?v3 S10)) (=> (= (f3 (f4 f19 ?v0) ?v1) f1) (=> (< ?v2 (f26 ?v3 ?v0)) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f19 ?v5) ?v4) f1) (<= (f26 ?v3 ?v5) (f26 ?v3 ?v4)))) (< ?v2 (f26 ?v3 ?v1)))))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f12 f13) ?v0) f13)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f15) ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (= (f6 f16 ?v0) f13) (= ?v0 f13))))
(assert (forall ((?v0 Int)) (= (= (f17 f18 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= f13 ?v0) (= ?v0 f13))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (= (f6 f16 f13) f13))
(assert (= (f17 f18 0) 0))
(check-sat)
(exit)
