(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 Int) S3)
(declare-fun f5 (S5 Int) S4)
(declare-fun f6 () S5)
(declare-fun f7 () S4)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 () Int)
(declare-fun f12 (S8 S2) Int)
(declare-fun f13 (S9 S2) S8)
(declare-fun f14 () S9)
(declare-fun f15 () S2)
(declare-fun f16 () S2)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () S2)
(declare-fun f20 (S10 S2) S2)
(declare-fun f21 (S11 Int) S10)
(declare-fun f22 () S11)
(declare-fun f23 (S12 S13) Int)
(declare-fun f24 () S12)
(declare-fun f25 () S13)
(declare-fun f26 () Int)
(declare-fun f27 (S14 Int) S1)
(declare-fun f28 () S12)
(declare-fun f29 (Int Int S2) S13)
(declare-fun f30 (S17 S15) S15)
(declare-fun f31 (S18 S16) S17)
(declare-fun f32 () S18)
(declare-fun f33 (S20 S19) S19)
(declare-fun f34 (S21 S15) S20)
(declare-fun f35 () S21)
(declare-fun f36 (S4 S5 S5 S13) S1)
(declare-fun f37 (Int) S1)
(declare-fun f38 (Int) S1)
(declare-fun f39 () S7)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (= (f3 (f4 (f5 f6 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f3 (f4 f7 ?v0) ?v1) f1) false)))
(assert (let ((?v_0 (f12 (f13 f14 f15) f16))) (not (= (f8 (f9 f10 (+ f11 ?v_0)) f17) (f8 (f9 f10 (+ (f8 (f9 f10 f11) f17) (f8 (f9 f10 ?v_0) f17))) f17)))))
(assert (let ((?v_0 (+ f11 (f12 (f13 f14 f15) f16)))) (= (f8 (f9 f10 (+ f18 ?v_0)) f17) (f8 (f9 f10 (+ (f8 (f9 f10 f18) f17) (f8 (f9 f10 ?v_0) f17))) f17))))
(assert (= f19 (f20 (f21 f22 1) f15)))
(assert (let ((?v_0 (f23 f24 f25))) (= (f8 (f9 f10 f11) ?v_0) (f8 (f9 f10 f26) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) 2))) (= (not (= ?v_0 0)) (= ?v_0 1)))))
(assert (forall ((?v0 S14) (?v1 Int) (?v2 Int)) (= (= (f27 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f27 ?v0 ?v1) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f27 ?v0 ?v4) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f27 ?v0 ?v4) f1)))))))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) ?v0) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (mod ?v0 ?v1) (ite (<= 0 ?v1) (f8 ?v_0 ?v1) (f8 ?v_0 (- ?v1)))))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) (- 1)) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) (- ?v1)) (- (f8 (f9 f10 (- ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (- ?v1)) (ite (= ?v_1 0) 0 (- ?v_1 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f8 (f9 f10 (- ?v0)) ?v1) (ite (= ?v_0 0) 0 (- ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) (- ?v1)) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (= (f23 f28 f25) 1))
(assert (=> (forall ((?v0 S2)) (=> (= f19 (f20 (f21 f22 1) ?v0)) false)) false))
(assert (= f25 (f29 f17 f18 f19)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v1) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f8 (f9 f10 ?v0) ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f8 (f9 f10 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v1) ?v0))) (=> (< ?v0 0) (and (<= ?v_0 0) (< ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f8 (f9 f10 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (- (* 2 (f8 (f9 f10 (+ ?v1 1)) ?v0)) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (<= (f8 (f9 f10 ?v1) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (< ?v0 (f8 (f9 f10 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ ?v0 ?v1))) (=> (< 0 ?v0) (=> (<= ?v_0 0) (= (f8 (f9 f10 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (<= (+ (* ?v1 (f8 (f9 f10 ?v3) ?v0)) ?v2) 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (< (* ?v1 ?v0) (+ (* ?v1 (f8 (f9 f10 ?v3) ?v0)) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f8 (f9 f10 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (< (+ (* ?v2 (f8 (f9 f10 ?v3) ?v0)) ?v1) (* ?v2 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (<= 0 (+ (* ?v2 (f8 (f9 f10 ?v3) ?v0)) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f8 (f9 f10 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (+ 1 (* 2 (f8 (f9 f10 ?v1) ?v0)))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f8 (f9 f10 (- 1)) ?v0) (- ?v0 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (<= (f8 (f9 f10 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (< (f8 (f9 f10 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v1) ?v0))) (=> (< 0 ?v0) (and (<= 0 ?v_0) (< ?v_0 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= 0 (f8 (f9 f10 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= (f8 (f9 f10 (- ?v0)) ?v1) 0)) (not (= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (not (= (f8 ?v_0 (- ?v1)) 0)) (not (= (f8 ?v_0 ?v1) 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- (f8 (f9 f10 ?v0) ?v1) ?v2)) ?v1) (f8 (f9 f10 (- ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (* ?v0 (f8 (f9 f10 ?v1) ?v2))) ?v2) (f8 (f9 f10 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 (f8 (f9 f10 ?v1) ?v2))) ?v2) (f8 (f9 f10 (- ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (* ?v0 ?v1)) ?v2) (f8 (f9 f10 (* ?v0 (f8 (f9 f10 ?v1) ?v2))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 0) (exists ((?v2 Int)) (= ?v0 (* ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- (f8 (f9 f10 ?v0) ?v1))) ?v1) (f8 (f9 f10 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 0) (exists ((?v2 Int)) (= ?v0 (* ?v1 ?v2))))))
(assert (forall ((?v0 S15) (?v1 S16)) (not (= ?v0 (f30 (f31 f32 ?v1) ?v0)))))
(assert (forall ((?v0 S19) (?v1 S15)) (not (= ?v0 (f33 (f34 f35 ?v1) ?v0)))))
(assert (forall ((?v0 S2) (?v1 Int)) (not (= ?v0 (f20 (f21 f22 ?v1) ?v0)))))
(assert (forall ((?v0 S16) (?v1 S15)) (not (= (f30 (f31 f32 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S15) (?v1 S19)) (not (= (f33 (f34 f35 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (not (= (f20 (f21 f22 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S16) (?v1 S15) (?v2 S16) (?v3 S15)) (= (= (f30 (f31 f32 ?v0) ?v1) (f30 (f31 f32 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S15) (?v1 S19) (?v2 S15) (?v3 S19)) (= (= (f33 (f34 f35 ?v0) ?v1) (f33 (f34 f35 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (= (= (f20 (f21 f22 ?v0) ?v1) (f20 (f21 f22 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (= (= f1 f1) true))
(assert (= (= f2 f1) false))
(assert (= (f36 f7 f6 f6 f25) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f37 ?v0) f1) (=> (= (f37 ?v1) f1) (= (f37 (f8 (f9 f10 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f38 ?v0) f1) (= (f8 (f9 f10 ?v0) 2) 0))))
(assert (= (f38 0) f1))
(assert (not (= (f38 1) f1)))
(assert (forall ((?v0 Int)) (= (= (f38 ?v0) f1) (exists ((?v1 Int)) (= ?v0 (* 2 ?v1))))))
(assert (forall ((?v0 Int)) (= (= (f38 (- ?v0)) f1) (= (f38 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f8 (f9 f39 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f8 (f9 f10 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
