(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 (S6 Int) S4)
(declare-fun f8 () S6)
(declare-fun f9 (S7 Int) S5)
(declare-fun f10 () S7)
(declare-fun f11 () Int)
(declare-fun f12 (S8 Int) S1)
(declare-fun f13 () S8)
(declare-fun f14 () S3)
(declare-fun f15 () S4)
(declare-fun f16 () S2)
(declare-fun f17 (S9 S5) S5)
(declare-fun f18 (S10 S5) S9)
(declare-fun f19 () S10)
(declare-fun f20 (S11 Int) S8)
(declare-fun f21 () S11)
(declare-fun f22 (S12 S5) S1)
(declare-fun f23 (S13 S5) S12)
(declare-fun f24 () S13)
(declare-fun f25 () S10)
(declare-fun f26 () S3)
(declare-fun f27 (S14 S5) S13)
(declare-fun f28 () S14)
(declare-fun f29 () S12)
(declare-fun f30 () S10)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (not (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (+ (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (+ (* 4 f11) 1))))))
(assert (= (f12 f13 (+ (* 4 f11) 1)) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f12 f13 ?v_0) f1) (= (f3 (f4 f14 (- 1)) ?v_0) 1)))))
(assert (= (f12 f13 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f12 f13 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 (f7 f8 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 2))) (let ((?v_0 (f6 (f7 f8 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 3))) (let ((?v_0 (f6 (f7 f8 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f6 f15 ?v1) (f6 f15 ?v2)))) (* (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (* ?v0 (f6 ?v_0 (f9 f10 2))) (f6 ?v_0 (f9 f10 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 3))) (= (f6 (f7 f8 (- ?v0)) ?v_0) (- (f6 (f7 f8 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f7 f8 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (=> (= (f6 (f7 f8 ?v0) (f9 f10 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (= (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2)) (?v_1 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_1 ?v_0)) ?v_0) (f6 ?v_1 (f9 f10 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_3 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (* (* 3 (f6 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_1 (f7 f8 ?v0)) (?v_3 (f7 f8 ?v1))) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (* (* 3 (f6 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f7 f8 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f6 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f9 f10 ?v0))) (=> (< 0 ?v0) (= (f6 ?v_0 ?v_1) (* ?v1 (f6 ?v_0 (f9 f10 (- (f6 f15 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (<= 0 (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f6 (f7 f8 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (= (f6 (f7 f8 (f3 f16 ?v0)) ?v_0) (f6 (f7 f8 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f17 (f18 f19 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f17 (f18 f19 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) (f9 f10 2)))) (= (f3 f16 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f3 f16 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f3 f16 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 f13 ?v0) f1) (=> (= (f12 ?v_0 (f6 (f7 f8 ?v1) ?v2)) f1) (= (f12 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f20 f21 (f6 (f7 f8 ?v0) ?v2)))) (=> (= (f12 f13 ?v0) f1) (=> (not (= (f12 (f20 f21 ?v0) ?v1) f1)) (=> (= (f12 ?v_0 (* ?v3 ?v1)) f1) (= (f12 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f20 f21 (f6 (f7 f8 ?v0) ?v2)))) (=> (= (f12 f13 ?v0) f1) (=> (not (= (f12 (f20 f21 ?v0) ?v1) f1)) (=> (= (f12 ?v_0 (* ?v1 ?v3)) f1) (= (f12 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f12 (f20 f21 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (= (f12 ?v_0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f12 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f12 (f20 f21 (* ?v0 ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f12 (f20 f21 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f12 (f20 f21 ?v0) ?v1) f1) (=> (= (f12 (f20 f21 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f12 (f20 f21 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 ?v_0 ?v1) f1) (= (= (f12 ?v_0 (+ ?v2 ?v3)) f1) (= (f12 ?v_0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 (f20 f21 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 (f20 f21 ?v0) ?v1) f1) (=> (= (f12 (f20 f21 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f12 ?v_0 ?v2) f1) (= (f12 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f12 (f20 f21 (* ?v0 ?v1)) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f12 (f20 f21 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f12 (f20 f21 ?v0) ?v1) f1) (= (f12 (f20 f21 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (= (f22 (f23 f24 (f17 (f18 f19 ?v0) ?v2)) (f17 (f18 f19 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f7 f8 ?v2))) (=> (<= (f6 f15 ?v0) (f6 f15 ?v1)) (= (f12 (f20 f21 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f18 f19 ?v2))) (=> (<= (f6 f15 ?v0) (f6 f15 ?v1)) (= (f22 (f23 f24 (f17 ?v_0 ?v0)) (f17 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S5)) (=> (= (f12 (f20 f21 ?v0) ?v1) f1) (=> (<= (f6 f15 ?v2) (f6 f15 ?v3)) (= (f12 (f20 f21 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (=> (<= (f6 f15 ?v2) (f6 f15 ?v3)) (= (f22 (f23 f24 (f17 (f18 f19 ?v0) ?v2)) (f17 (f18 f19 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f12 (f20 f21 (f6 ?v_0 ?v1)) ?v2) f1) (=> (<= (f6 f15 ?v3) (f6 f15 ?v1)) (= (f12 (f20 f21 (f6 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f22 (f23 f24 (f17 ?v_0 ?v1)) ?v2) f1) (=> (<= (f6 f15 ?v3) (f6 f15 ?v1)) (= (f22 (f23 f24 (f17 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 f15 ?v0)) ?v1) (f6 f15 (f17 (f18 f19 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f17 (f18 f19 (f9 f10 ?v0)) ?v1) (f9 f10 (f6 (f7 f8 ?v0) ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f15 (f17 (f18 f19 ?v0) ?v1)) (f6 (f7 f8 (f6 f15 ?v0)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 f15 ?v0)) ?v1) (f6 f15 (f17 (f18 f19 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f9 f10 (f6 (f7 f8 ?v0) ?v1)) (f17 (f18 f19 (f9 f10 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 f13 ?v0) f1) (=> (= (f12 ?v_0 (f6 (f7 f8 ?v1) ?v2)) f1) (=> (< 0 (f6 f15 ?v2)) (= (f12 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f12 f13 ?v1) f1) (= (f12 (f20 f21 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (= (= (f12 f13 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f12 (f20 f21 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 f13 ?v0) f1) (=> (= (f12 ?v_0 (* ?v1 ?v2)) f1) (or (= (f12 ?v_0 ?v1) f1) (= (f12 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v1))) (=> (<= 0 ?v0) (=> (= (f12 f13 ?v1) f1) (=> (= (f12 ?v_0 (* ?v0 ?v2)) f1) (or (= (f12 ?v_0 ?v0) f1) (= (f12 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f12 (f20 f21 (f6 (f7 f8 ?v1) ?v0)) (f6 (f7 f8 ?v2) ?v0)) f1) (= (f12 (f20 f21 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v1))) (=> (< 0 (f6 f15 ?v0)) (=> (= (f12 ?v_0 ?v2) f1) (= (f12 ?v_0 (f6 (f7 f8 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f12 (f20 f21 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) f1) (=> (not (= ?v1 (f9 f10 0))) (= (f12 (f20 f21 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 (f20 f21 ?v0) ?v1) f1) (= (f12 (f20 f21 (- ?v0)) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f18 f19 ?v0))) (=> (= (f22 (f23 f24 (f17 ?v_0 ?v1)) (f17 ?v_0 ?v2)) f1) (=> (< 1 (f6 f15 ?v0)) (<= (f6 f15 ?v1) (f6 f15 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f6 f15 ?v0)) (<= ?v_0 (f6 f15 (f17 (f18 f19 ?v0) ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f18 f19 ?v0))) (=> (< 0 (f6 f15 ?v0)) (=> (< (f6 f15 (f17 ?v_0 ?v1)) (f6 f15 (f17 ?v_0 ?v2))) (< (f6 f15 ?v1) (f6 f15 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f22 (f23 f24 (f17 (f18 f19 ?v1) ?v0)) (f17 (f18 f19 ?v2) ?v0)) f1) (= (f22 (f23 f24 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f17 (f18 f19 ?v0) ?v1) ?v_0) (or (= ?v1 (f9 f10 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (f17 (f18 f19 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f6 f15 (f17 (f18 f19 ?v0) ?v1))) (or (< 0 (f6 f15 ?v0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f12 (f20 f21 (f6 f15 ?v0)) (f6 f15 ?v1)) f1) (= (f22 (f23 f24 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f22 (f23 f24 (f9 f10 ?v0)) (f9 f10 ?v1)) f1) (= (f12 (f20 f21 ?v0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (= (f22 (f23 f24 (f9 f10 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f12 (f20 f21 ?v0) (f6 f15 ?v1)) f1) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S5) (?v1 Int)) (= (= (f12 (f20 f21 (f6 f15 ?v0)) ?v1) f1) (= (f22 (f23 f24 ?v0) (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (= (f12 (f20 f21 ?v0) (f6 f15 ?v1)) f1) (= (f22 (f23 f24 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f22 (f23 f24 ?v0) ?v1) f1) (= (f12 (f20 f21 (f6 f15 ?v0)) (f6 f15 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 0)) (= (= (f12 (f20 f21 ?v1) ?v2) f1) (= (f12 (f20 f21 (* ?v0 ?v1)) (* ?v0 ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 (f20 f21 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (= (f12 ?v_0 ?v1) f1) (= (f12 ?v_0 (- ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f22 (f23 f24 (f17 (f18 f19 ?v0) ?v1)) (f17 (f18 f19 ?v2) ?v1)) f1) (=> (not (= ?v1 (f9 f10 0))) (= (f22 (f23 f24 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (= (f22 (f23 f24 (f17 (f18 f19 ?v0) ?v2)) (f17 (f18 f19 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) f1) (= (f22 ?v_0 (f17 (f18 f19 ?v1) (f9 f10 (+ (f6 f15 ?v2) 1)))) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 (f9 f10 0))) (=> (= (f22 (f23 f24 (f17 (f18 f19 ?v1) ?v0)) ?v2) f1) (= (f22 (f23 f24 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 (+ (f6 f15 ?v1) 1)))) (= (<= (f6 f15 (f17 (f18 f19 ?v0) ?v_0)) (f6 f15 (f17 (f18 f19 ?v2) ?v_0))) (<= (f6 f15 ?v0) (f6 f15 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 (+ (f6 f15 ?v1) 1)))) (= (< (f6 f15 (f17 (f18 f19 ?v0) ?v_0)) (f6 f15 (f17 (f18 f19 ?v2) ?v_0))) (< (f6 f15 ?v0) (f6 f15 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 (+ (f6 f15 ?v1) 1)))) (= (= (f17 (f18 f19 ?v0) ?v_0) (f17 (f18 f19 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) f1) (=> (= (f22 ?v_0 (f9 f10 (+ (f6 f15 ?v1) (f6 f15 ?v2)))) f1) (= (f22 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (or (= ?v1 (f9 f10 0)) (<= (f6 f15 ?v0) (f6 f15 ?v1))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 1))) (=> (= (f22 (f23 f24 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (< 0 (f6 f15 ?v0)) (=> (= (f22 (f23 f24 ?v1) ?v0) f1) (< 0 (f6 f15 ?v1))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 0))) (=> (= (f22 (f23 f24 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (and (= (f22 (f23 f24 ?v0) ?v1) f1) (= (f22 (f23 f24 ?v1) ?v0) f1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 1))) (= (= (f22 (f23 f24 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 0))) (= (= (f22 (f23 f24 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 0))) (= (not (= ?v0 ?v_0)) (and (= (f22 (f23 f24 ?v0) ?v_0) f1) (not (= (f22 (f23 f24 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 1))) (= (not (= ?v0 ?v_0)) (and (= (f22 (f23 f24 ?v_0) ?v0) f1) (not (= (f22 (f23 f24 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S5)) (= (f22 (f23 f24 ?v0) (f9 f10 0)) f1)))
(assert (forall ((?v0 S5)) (= (f22 (f23 f24 (f9 f10 1)) ?v0) f1)))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 1))) (not (and (= (f22 (f23 f24 ?v0) ?v_0) f1) (not (= (f22 (f23 f24 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 0))) (not (and (= (f22 (f23 f24 ?v_0) ?v0) f1) (not (= (f22 (f23 f24 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f9 f10 0))) (= (= (f17 (f18 f19 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f9 f10 1))) (= (= (f17 (f18 f19 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S5)) (= (f22 (f23 f24 (f9 f10 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S5)) (= (f22 (f23 f24 ?v0) ?v0) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f6 f15 (f17 (f18 f19 ?v0) ?v1))) (or (= ?v1 (f9 f10 0)) (< 0 (f6 f15 ?v0))))))
(assert (forall ((?v0 Int)) (= (f12 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v0) f1)))
(assert (forall ((?v0 Int)) (= (f12 (f20 f21 ?v0) (ite (< ?v0 0) (- ?v0) ?v0)) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_1 (= (f22 (f23 f24 ?v0) ?v1) f1)) (?v_0 (= (f22 (f23 f24 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (= (f22 (f23 f24 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 1))) (= (= (f22 (f23 f24 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (and (= (f22 (f23 f24 ?v0) ?v1) f1) (= (f22 (f23 f24 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (= (f22 (f23 f24 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f22 (f23 f24 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f22 (f23 f24 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (= (= (f22 ?v_0 (f9 f10 (+ (f6 f15 ?v1) (f6 f15 ?v0)))) f1) (= (f22 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (= (f22 (f23 f24 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f22 (f23 f24 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (and (= (f22 (f23 f24 ?v0) ?v1) f1) (not (= (f22 (f23 f24 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (= (f22 (f23 f24 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f22 (f23 f24 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f6 f15 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f6 f15 ?v1)) (not (= (f22 (f23 f24 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f22 (f23 f24 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (or (<= (f6 f15 ?v0) (f6 f15 ?v1)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (= (= (f22 (f23 f24 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (= (f22 (f23 f24 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f22 (f23 f24 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (= (f22 (f23 f24 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f22 (f23 f24 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f6 f15 ?v1))) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f6 f15 ?v0) ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f22 (f23 f24 ?v1) ?v2) f1) (= (f22 (f23 f24 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f22 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (=> (= (f22 (f23 f24 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (=> (= (f22 (f23 f24 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) f1) (=> (= (f22 (f23 f24 ?v1) ?v2) f1) (= (f22 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) f1) (=> (= (f22 ?v_0 ?v2) f1) (= (f22 ?v_0 (f9 f10 (- (f6 f15 ?v1) (f6 f15 ?v2)))) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f22 (f23 f24 ?v1) ?v2) f1) (not (= (f22 ?v_0 ?v1) f1))) (and (= (f22 (f23 f24 ?v0) ?v2) f1) (not (= (f22 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f23 f24 ?v2))) (=> (= (f22 ?v_0 ?v1) f1) (=> (and (= (f22 (f23 f24 ?v1) ?v2) f1) (not (= (f22 ?v_1 ?v1) f1))) (and (= (f22 ?v_0 ?v2) f1) (not (= (f22 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f6 f15 ?v2)) (?v_2 (f6 f15 ?v1))) (=> (= (f22 ?v_0 (f9 f10 (- ?v_2 ?v_1))) f1) (=> (= (f22 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f22 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f6 f15 ?v2)) (?v_2 (f6 f15 ?v1))) (=> (= (f22 ?v_0 (f9 f10 (- ?v_2 ?v_1))) f1) (=> (= (f22 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f22 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (and (= (f22 (f23 f24 ?v0) ?v1) f1) (not (= (f22 (f23 f24 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_1 (= (f22 (f23 f24 ?v0) ?v1) f1)) (?v_0 (= (f22 (f23 f24 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (= (f22 (f23 f24 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f22 (f23 f24 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_1 (= (f22 (f23 f24 ?v0) ?v1) f1)) (?v_0 (= (f22 (f23 f24 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (and (= (f22 (f23 f24 ?v0) ?v1) f1) (not (= (f22 (f23 f24 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (and (= (f22 (f23 f24 ?v0) ?v1) f1) (not (= (f22 (f23 f24 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S1)) (let ((?v_1 (= (f22 (f23 f24 ?v0) ?v1) f1)) (?v_0 (= (f22 (f23 f24 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (and (= (f22 ?v_0 ?v1) f1) (not (= (f22 (f23 f24 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f22 ?v_0 ?v2) f1) (not (= (f22 (f23 f24 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f23 f24 ?v0)) (?v_0 (f23 f24 ?v1))) (=> (and (= (f22 ?v_1 ?v1) f1) (not (= (f22 ?v_0 ?v0) f1))) (=> (= (f22 ?v_0 ?v2) f1) (and (= (f22 ?v_1 ?v2) f1) (not (= (f22 (f23 f24 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_1 (= (f22 (f23 f24 ?v0) ?v1) f1)) (?v_0 (= (f22 (f23 f24 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f23 f24 ?v0)) (?v_0 (f23 f24 ?v1)) (?v_2 (f23 f24 ?v2))) (=> (and (= (f22 ?v_1 ?v1) f1) (not (= (f22 ?v_0 ?v0) f1))) (=> (and (= (f22 ?v_0 ?v2) f1) (not (= (f22 ?v_2 ?v1) f1))) (and (= (f22 ?v_1 ?v2) f1) (not (= (f22 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S9) (?v1 S5) (?v2 S5)) (=> (forall ((?v3 S5)) (= (f22 (f23 f24 (f17 ?v0 ?v3)) (f17 ?v0 (f9 f10 (+ (f6 f15 ?v3) 1)))) f1)) (=> (<= (f6 f15 ?v1) (f6 f15 ?v2)) (= (f22 (f23 f24 (f17 ?v0 ?v1)) (f17 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 S9) (?v1 S5) (?v2 S5)) (let ((?v_1 (f17 ?v0 ?v1)) (?v_0 (f17 ?v0 ?v2))) (=> (forall ((?v3 S5)) (let ((?v_3 (f17 ?v0 ?v3)) (?v_2 (f17 ?v0 (f9 f10 (+ (f6 f15 ?v3) 1))))) (and (= (f22 (f23 f24 ?v_3) ?v_2) f1) (not (= (f22 (f23 f24 ?v_2) ?v_3) f1))))) (= (and (= (f22 (f23 f24 ?v_1) ?v_0) f1) (not (= (f22 (f23 f24 ?v_0) ?v_1) f1))) (< (f6 f15 ?v1) (f6 f15 ?v2)))))))
(assert (forall ((?v0 S9) (?v1 S5) (?v2 S5)) (let ((?v_1 (f17 ?v0 ?v1)) (?v_0 (f17 ?v0 ?v2))) (=> (forall ((?v3 S5)) (let ((?v_3 (f17 ?v0 ?v3)) (?v_2 (f17 ?v0 (f9 f10 (+ (f6 f15 ?v3) 1))))) (and (= (f22 (f23 f24 ?v_3) ?v_2) f1) (not (= (f22 (f23 f24 ?v_2) ?v_3) f1))))) (=> (< (f6 f15 ?v1) (f6 f15 ?v2)) (and (= (f22 (f23 f24 ?v_1) ?v_0) f1) (not (= (f22 (f23 f24 ?v_0) ?v_1) f1))))))))
(assert (forall ((?v0 Int)) (= (f12 (f20 f21 ?v0) ?v0) f1)))
(assert (forall ((?v0 S5)) (= (f22 (f23 f24 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 ?v0))) (= (= (f12 ?v_0 (f3 f16 ?v1)) f1) (= (f12 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 f16 ?v0) (f3 f16 ?v1)) (= (f12 (f20 f21 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 ?v_0 ?v1) f1) (=> (= (f12 (f20 f21 ?v1) ?v2) f1) (= (f12 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) f1) (=> (= (f22 (f23 f24 ?v1) ?v2) f1) (= (f22 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 (f20 f21 (f3 f16 ?v0)) ?v1) f1) (= (f12 (f20 f21 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f22 (f23 f24 ?v0) (f17 (f18 f25 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f22 (f23 f24 ?v0) (f17 (f18 f25 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (< 0 (f6 f15 ?v0)) (=> (< 0 (f6 f15 ?v1)) (< 0 (f6 f15 (f17 (f18 f25 ?v0) ?v1)))))))
(assert (forall ((?v0 S5)) (= (f17 (f18 f25 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 0))) (= (f17 (f18 f25 ?v0) ?v_0) ?v_0))))
(assert (forall ((?v0 S5)) (= (f17 (f18 f25 (f9 f10 1)) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 f10 0))) (= (f17 (f18 f25 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (=> (= (f22 (f23 f24 ?v2) ?v1) f1) (= (f22 (f23 f24 (f17 (f18 f25 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f26 ?v0) ?v1) (f6 f15 (f17 (f18 f25 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0))) (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f20 f21 ?v0) (f3 (f4 f26 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f20 f21 ?v0) (f3 (f4 f26 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (< 0 (f3 (f4 f26 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 ?v_0 ?v1) f1) (= (f12 ?v_0 (f3 (f4 f26 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 ?v_0 ?v1) f1) (= (f12 ?v_0 (f3 (f4 f26 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f23 f24 ?v3))) (=> (= (f22 (f23 (f27 f28 ?v0) ?v1) ?v2) f1) (=> (= (f22 ?v_0 ?v0) f1) (=> (= (f22 ?v_0 ?v1) f1) (= (f22 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v2))) (= (= (f22 (f23 (f27 f28 ?v0) ?v1) ?v2) f1) (and (= (f22 ?v_0 ?v0) f1) (and (= (f22 ?v_0 ?v1) f1) (forall ((?v3 S5)) (let ((?v_1 (f23 f24 ?v3))) (=> (= (f22 ?v_1 ?v0) f1) (=> (= (f22 ?v_1 ?v1) f1) (= (f22 ?v_1 ?v2) f1)))))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 f29 ?v0) f1) (=> (= (f22 ?v_0 (f17 (f18 f19 ?v1) (f9 f10 2))) f1) (= (f22 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S5)) (= (= (f22 f29 ?v0) f1) (and (< 1 (f6 f15 ?v0)) (forall ((?v1 S5)) (=> (= (f22 (f23 f24 ?v1) ?v0) f1) (or (= ?v1 (f9 f10 1)) (= ?v1 ?v0))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f22 f29 (f17 (f18 f19 ?v0) ?v1)) f1) (and (= (f22 f29 ?v0) f1) (= ?v1 (f9 f10 1))))))
(assert (forall ((?v0 S5)) (=> (= (f22 f29 ?v0) f1) (= (f12 f13 (f6 f15 ?v0)) f1))))
(assert (forall ((?v0 S5)) (=> (= (f22 f29 ?v0) f1) (<= 2 (f6 f15 ?v0)))))
(assert (= (f22 f29 (f9 f10 2)) f1))
(assert (not (= (f22 f29 (f9 f10 (+ 0 1))) f1)))
(assert (not (= (f22 f29 (f9 f10 0)) f1)))
(assert (not (= (f22 f29 (f9 f10 1)) f1)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f23 (f27 f28 ?v0) ?v1))) (=> (= (f22 ?v_0 ?v2) f1) (=> (= (f22 ?v_0 ?v3) f1) (= ?v2 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f22 (f23 (f27 f28 ?v0) ?v1) ?v2) f1) (= (f22 (f23 (f27 f28 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 f29 ?v0) f1) (=> (= (f22 ?v_0 (f17 (f18 f19 ?v1) ?v2)) f1) (= (f22 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f22 f29 ?v0) f1) (= (= (f22 (f23 f24 ?v1) (f17 (f18 f19 ?v0) ?v2)) f1) (exists ((?v3 S5)) (and (<= (f6 f15 ?v3) (f6 f15 ?v2)) (= ?v1 (f17 (f18 f19 ?v0) ?v3))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 f29 ?v0) f1) (=> (= (f22 ?v_0 (f17 (f18 f19 ?v1) ?v2)) f1) (= (f22 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 (f18 f19 ?v1) ?v2))) (=> (= (f22 f29 ?v0) f1) (=> (= (f22 (f23 f24 ?v0) ?v_0) f1) (= (f22 (f23 f24 (f17 (f18 f19 ?v0) ?v2)) ?v_0) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 f29 ?v0) f1) (=> (= (f22 ?v_0 (f17 (f18 f19 ?v1) (f9 f10 (+ (+ 0 1) 1)))) f1) (= (f22 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f22 f29 ?v0) f1) (=> (not (= ?v1 (f9 f10 0))) (=> (= (f17 (f18 f19 ?v2) ?v1) (f17 (f18 f19 ?v0) ?v3)) (exists ((?v4 S5)) (= ?v2 (f17 (f18 f19 ?v0) ?v4))))))))
(assert (forall ((?v0 S5)) (=> (not (= ?v0 (f9 f10 1))) (exists ((?v1 S5)) (and (= (f22 f29 ?v1) f1) (= (f22 (f23 f24 ?v1) ?v0) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f22 f29 ?v0) f1) (=> (= (f22 f29 ?v1) f1) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (= ?v0 ?v1))))))
(assert (forall ((?v0 S5)) (=> (= (f22 f29 ?v0) f1) (< (+ 0 1) (f6 f15 ?v0)))))
(assert (forall ((?v0 S5)) (=> (= (f22 f29 ?v0) f1) (< 0 (f6 f15 ?v0)))))
(assert (forall ((?v0 S5)) (=> (= (f22 f29 ?v0) f1) (not (= (f22 (f23 f24 ?v0) (f9 f10 (+ 0 1))) f1)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f22 f29 ?v1) f1) (< (f6 f15 ?v0) (f6 f15 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f23 f24 (f17 (f18 f19 ?v0) ?v2)))) (=> (= (f22 f29 ?v0) f1) (=> (not (= (f22 (f23 f24 ?v0) ?v1) f1)) (=> (= (f22 ?v_0 (f9 f10 (* (f6 f15 ?v3) (f6 f15 ?v1)))) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f6 f15 ?v0))) (=> (< 0 ?v_0) (=> (= (f9 f10 (* ?v_0 (f6 f15 ?v1))) (f9 f10 (* ?v_0 (f6 f15 ?v2)))) (= ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f6 f15 ?v0))) (=> (< 0 ?v_0) (=> (= (f9 f10 (* ?v_0 (f6 f15 ?v1))) ?v0) (= ?v1 (f9 f10 (+ 0 1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f6 f15 ?v0)) (?v_2 (f6 f15 ?v1)) (?v_0 (f6 f15 ?v2))) (=> (< 0 ?v_1) (=> (< 0 ?v_2) (=> (< (+ 0 1) ?v_0) (=> (= (f9 f10 (* ?v_0 ?v_1)) ?v1) (< ?v_1 ?v_2))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_1 (+ 0 1)) (?v_2 (f6 f15 ?v1))) (let ((?v_0 (* (f6 f15 ?v0) ?v_2))) (=> (not (= ?v0 (f9 f10 ?v_0))) (=> (< ?v_1 ?v_0) (< ?v_1 ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1)) (?v_1 (f6 f15 ?v0))) (=> (not (= ?v0 (f9 f10 (* ?v_1 (f6 f15 ?v1))))) (=> (not (= ?v0 (f9 f10 ?v_0))) (< ?v_0 ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 f29 ?v0) f1) (= (= (f22 ?v_0 (f9 f10 (* (f6 f15 ?v1) (f6 f15 ?v2)))) f1) (or (= (f22 ?v_0 ?v1) f1) (= (f22 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 f29 ?v0) f1) (=> (= (f22 ?v_0 (f9 f10 (* (f6 f15 ?v1) (f6 f15 ?v2)))) f1) (or (= (f22 ?v_0 ?v1) f1) (= (f22 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 f29 ?v0) f1) (=> (= (f22 ?v_0 (f9 f10 (* (f6 f15 ?v1) (f6 f15 ?v2)))) f1) (or (= (f22 ?v_0 ?v1) f1) (= (f22 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f16 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f16 (* ?v0 ?v1)) (* (f3 f16 ?v0) (f3 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f20 f21 ?v0) (* ?v0 ?v1)) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f22 (f23 f24 ?v0) (f17 (f18 f30 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f20 f21 ?v0) (* ?v1 ?v0)) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f22 (f23 f24 ?v0) (f17 (f18 f30 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 ?v_0 ?v1) f1) (= (f12 ?v_0 (* ?v1 ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) f1) (= (f22 ?v_0 (f17 (f18 f30 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f12 ?v_0 ?v1) f1) (= (f12 ?v_0 (* ?v2 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) f1) (= (f22 ?v_0 (f17 (f18 f30 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f12 (f20 f21 ?v0) ?v1) f1) (=> (= (f12 (f20 f21 ?v2) ?v3) f1) (= (f12 (f20 f21 (* ?v0 ?v2)) (* ?v1 ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (=> (= (f22 (f23 f24 ?v2) ?v3) f1) (= (f22 (f23 f24 (f17 (f18 f30 ?v0) ?v2)) (f17 (f18 f30 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (* ?v1 ?v2)) (= (f12 (f20 f21 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 (f17 (f18 f30 ?v1) ?v2)) (= (f22 (f23 f24 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f12 (f20 f21 (* ?v0 ?v1)) ?v2) f1) (= (f12 (f20 f21 ?v0) ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f22 (f23 f24 (f17 (f18 f30 ?v0) ?v1)) ?v2) f1) (= (f22 (f23 f24 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f12 (f20 f21 (* ?v0 ?v1)) ?v2) f1) (= (f12 (f20 f21 ?v1) ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f22 (f23 f24 (f17 (f18 f30 ?v0) ?v1)) ?v2) f1) (= (f22 (f23 f24 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f9 f10 (* (f6 f15 ?v1) (f6 f15 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f9 f10 2)) (?v_1 (f6 f15 ?v0)) (?v_2 (f6 f15 ?v1))) (= (f9 f10 (- (f6 f15 (f17 (f18 f19 ?v0) ?v_0)) (f6 f15 (f17 (f18 f19 ?v1) ?v_0)))) (f9 f10 (* (+ ?v_1 ?v_2) (f6 f15 (f9 f10 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 ?v_0 ?v1) (ite (= ?v1 (f9 f10 0)) (f9 f10 1) (f9 f10 (* (f6 f15 ?v0) (f6 f15 (f17 ?v_0 (f9 f10 (- (f6 f15 ?v1) 1)))))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f9 f10 1))) (= (= (f9 f10 (* (f6 f15 ?v0) (f6 f15 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f9 f10 (* (f6 f15 (f9 f10 ?v0)) (f6 f15 (f9 f10 ?v1)))) (f9 f10 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f18 f30 ?v0))) (= (f17 (f18 f30 (f17 ?v_0 ?v1)) (f17 (f18 f30 ?v2) ?v3)) (f17 (f18 f30 (f17 ?v_0 ?v2)) (f17 (f18 f30 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f18 f30 (f17 (f18 f30 ?v0) ?v1))) (?v_0 (f18 f30 ?v2))) (= (f17 ?v_1 (f17 ?v_0 ?v3)) (f17 ?v_0 (f17 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f18 f30 ?v0)) (?v_1 (f17 (f18 f30 ?v2) ?v3))) (= (f17 (f18 f30 (f17 ?v_0 ?v1)) ?v_1) (f17 ?v_0 (f17 (f18 f30 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f18 f30 ?v0))) (= (f17 (f18 f30 (f17 ?v_0 ?v1)) ?v2) (f17 (f18 f30 (f17 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f18 f30 ?v0))) (= (f17 (f18 f30 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f18 f30 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f6 f15 ?v0))) (= (f9 f10 (* 2 ?v_0)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (* (f6 f15 ?v0) (f6 f15 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f18 f30 ?v0))) (= (f17 ?v_0 (f17 (f18 f30 ?v1) ?v2)) (f17 (f18 f30 (f17 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f18 f30 ?v0)) (?v_0 (f18 f30 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f6 f15 ?v0))) (= (f9 f10 (* ?v_0 2)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f9 f10 0)) (?v_2 (f6 f15 ?v0)) (?v_1 (f6 f15 ?v1))) (= (f9 f10 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f9 f10 (+ ?v_1 (* (f6 f15 (f9 f10 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f17 (f18 f30 ?v0) ?v1) (f17 (f18 f30 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f15 (f9 f10 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f9 f10 (* ?v_0 ?v_0)) (f9 f10 (+ (* (f6 f15 (f9 f10 (- ?v0 1))) (f6 f15 (f9 f10 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f6 f15 (f9 f10 (- ?v0))) (f6 f15 (f9 f10 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f6 f15 (f9 f10 ?v0)) (f6 f15 (f9 f10 ?v1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (* (f6 f15 ?v0) (f6 f15 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (* (f6 f15 ?v0) (f6 f15 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f9 f10 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f9 f10 (* (f6 f15 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0))) (f6 f15 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f6 f15 ?v1)) 1))) (* ?v0 (f6 (f7 f8 (f6 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 ?v_0 (f9 f10 (+ (* 2 (f6 f15 ?v1)) 1))) (f17 (f18 f30 ?v0) (f17 (f18 f19 (f17 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f6 f15 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f18 f19 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 (f9 f10 (+ (* 2 (f6 f15 ?v1)) 1))) (f17 (f18 f30 ?v0) (f17 (f18 f30 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (* 2 (f6 f15 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f18 f19 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 (f9 f10 (* 2 (f6 f15 ?v1)))) (f17 (f18 f30 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f6 f15 ?v2)) (?v_0 (f6 f15 ?v3))) (=> (= ?v0 (f9 f10 (+ (* (f6 f15 ?v1) ?v_1) ?v_0))) (=> (< 0 ?v_0) (=> (< ?v_0 ?v_1) (not (= (f22 (f23 f24 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f6 f15 ?v2))) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (= (f22 (f23 f24 (f9 f10 (* ?v_0 (f6 f15 ?v0)))) (f9 f10 (* ?v_0 (f6 f15 ?v1)))) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f6 f15 ?v2))) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (= (f22 (f23 f24 (f9 f10 (* (f6 f15 ?v0) ?v_0))) (f9 f10 (* (f6 f15 ?v1) ?v_0))) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f22 (f23 f24 ?v0) ?v1) f1) (or (= ?v1 (f9 f10 0)) (or (= ?v1 ?v0) (<= (* 2 (f6 f15 ?v0)) (f6 f15 ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f6 f15 ?v1))) (= (= (f22 (f23 f24 (f9 f10 (* (f6 f15 ?v0) ?v_0))) (f9 f10 (* (f6 f15 ?v2) ?v_0))) f1) (or (= ?v1 (f9 f10 0)) (= (f22 (f23 f24 ?v0) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (* (f6 f15 ?v1) (f6 f15 ?v2)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 ?v_0 (f9 f10 (* (f6 f15 ?v1) (f6 f15 ?v2)))) (f17 (f18 f19 (f17 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (* 2 (f6 f15 ?v1)))) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 ?v_0 (f9 f10 (* 2 (f6 f15 ?v1)))) (f17 (f18 f19 (f17 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f9 f10 (* (f6 f15 ?v1) (f6 f15 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 (f18 f19 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f9 f10 (* (f6 f15 ?v1) (f6 f15 ?v2))))))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f6 (f7 f8 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S5)) (= (f17 (f18 f30 ?v0) ?v0) (f17 (f18 f19 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f6 f15 ?v1) 1))) (* ?v0 (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 ?v_0 (f9 f10 (+ (f6 f15 ?v1) 1))) (f17 (f18 f30 ?v0) (f17 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f6 f15 ?v1) 1))) (* ?v0 (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 ?v_0 (f9 f10 (+ (f6 f15 ?v1) 1))) (f17 (f18 f30 ?v0) (f17 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f6 f15 ?v1) 1))) (* (f6 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 ?v_0 (f9 f10 (+ (f6 f15 ?v1) 1))) (f17 (f18 f30 (f17 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f9 f10 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S5)) (= (f17 (f18 f19 ?v0) (f9 f10 2)) (f17 (f18 f30 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f6 (f7 f8 ?v0) (f9 f10 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f17 (f18 f19 ?v0) (f9 f10 3)) (f17 (f18 f30 (f17 (f18 f30 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (* ?v0 (f6 ?v_0 ?v1)) (f6 ?v_0 (f9 f10 (+ (f6 f15 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f18 f19 ?v0))) (= (f17 (f18 f30 ?v0) (f17 ?v_0 ?v1)) (f17 ?v_0 (f9 f10 (+ (f6 f15 ?v1) 1)))))))
(assert (forall ((?v0 S5)) (= (f9 f10 (f6 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f15 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f15 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
