(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (Int) S2)
(declare-fun f5 (S3 Int) Int)
(declare-fun f6 (S4 Int) S3)
(declare-fun f7 () S4)
(declare-fun f8 () Int)
(declare-fun f9 (Int) S2)
(declare-fun f10 (Int) S1)
(declare-fun f11 (S5 Int) S2)
(declare-fun f12 (Int) S5)
(declare-fun f13 (Int) S1)
(declare-fun f14 () S3)
(declare-fun f15 () S4)
(declare-fun f16 () S4)
(declare-fun f17 (Int S2) S1)
(declare-fun f18 (Int S2) S1)
(declare-fun f19 (Int) S5)
(declare-fun f20 (S6 S2) S7)
(declare-fun f21 () S6)
(declare-fun f22 (S8 Int) S5)
(declare-fun f23 (Int) S8)
(declare-fun f24 (S9 Int) S7)
(declare-fun f25 () S9)
(declare-fun f26 (S10 S7) Int)
(declare-fun f27 (S11 Int) S10)
(declare-fun f28 () S11)
(declare-fun f29 (Int) S2)
(declare-fun f30 () S4)
(declare-fun f31 () S4)
(declare-fun f32 (S2) S2)
(declare-fun f33 () S10)
(declare-fun f34 () S4)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 ?v0) ?v1) f1) (and (< 0 ?v1) (< ?v1 ?v0)))))
(assert (not (not (= (f5 (f6 f7 (- 1)) (+ (* 4 f8) 1)) 1))))
(assert (not (= (f3 (f9 (+ (* 4 f8) 1)) (- 1)) f1)))
(assert (not (= (f3 (f9 (+ (* 4 f8) 1)) (- 1)) f1)))
(assert (= (f5 (f6 f7 (- 1)) (+ (* 4 f8) 1)) 1))
(assert (= (f10 (+ (* 4 f8) 1)) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f10 ?v_0) f1) (= (f5 (f6 f7 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 ?v0) ?v1) (ite (= (f3 (f11 (f12 ?v0) 0) ?v1) f1) 0 (ite (= (f3 (f9 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 ?v0) f1) (=> (= (f13 ?v1) f1) (= (f13 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f11 (f12 ?v2) 0) ?v0) f1)) (not (= (f3 (f11 (f12 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (f11 (f12 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (not (= (f3 (f11 (f12 ?v2) 0) ?v0) f1))) (not (= (f3 (f11 (f12 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f11 (f12 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f3 (f11 (f12 ?v1) 0) ?v0) f1) (= (f3 (f11 (f12 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 ?v1))) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f11 (f12 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f3 (f11 ?v_0 1) ?v0) f1) (= (f3 (f11 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (= (f10 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f10 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f11 (f12 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (= (f3 (f11 (f12 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 (f12 ?v0) ?v1))) (= (= (f3 ?v_0 (- ?v2)) f1) (= (f3 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f11 (f12 ?v3) ?v4) ?v2) f1) (= (f3 (f11 (f12 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f11 (f12 ?v3) ?v4) ?v2) f1) (= (f3 (f11 (f12 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f11 (f12 ?v3) ?v4) ?v2) f1) (= (f3 (f11 (f12 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 ?v0))) (=> (= (f3 (f11 ?v_0 ?v1) ?v2) f1) (=> (= (f3 (f11 (f12 ?v1) ?v3) ?v2) f1) (= (f3 (f11 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f12 ?v0))) (=> (= (f3 (f11 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 (f11 (f12 ?v3) ?v4) ?v2) f1) (= (f3 (f11 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (= (f3 (f11 (f12 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (= (f3 (f11 (f12 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (= (f3 (f11 (f12 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f12 ?v3))) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (= (= (f3 (f11 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f3 (f11 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f12 ?v3))) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (= (= (f3 (f11 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f3 (f11 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 ?v1))) (=> (< 2 ?v0) (=> (= (f3 (f11 ?v_0 (- 1)) ?v0) f1) (not (= (f3 (f11 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f11 (f12 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f11 (f12 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 (f11 (f12 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 (f11 (f12 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f11 (f12 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f11 (f12 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f11 (f12 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f11 (f12 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int)) (= (f3 (f11 (f12 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (f11 (f12 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f3 (f11 (f12 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f10 ?v0) f1) (= (f3 (f11 (f12 (f5 f14 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f3 (f11 (f12 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f3 (f11 (f12 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f3 (f11 (f12 (* ?v1 (f5 (f6 f15 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f3 (f11 (f12 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 ?v2))) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f11 ?v_0 0) ?v0) f1)) (=> (not (= (f3 (f9 ?v0) ?v1) f1)) (not (= (f3 (f11 ?v_0 (* ?v1 (f5 (f6 f16 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f17 ?v0 ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f18 ?v2 ?v1) f1) (and (= (f18 ?v3 ?v1) f1) (= (f3 (f11 (f12 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 (f6 f16 ?v0) ?v1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (= (f3 (f11 (f12 (* (* ?v_0 ?v1) ?v2)) (* ?v_0 ?v3)) ?v0) f1) (= (f3 (f11 (f12 ?v2) (* ?v3 ?v_0)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 (* ?v2 ?v1)))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (= (f3 (f11 ?v_0 (* (* ?v3 (f5 (f6 f16 ?v0) ?v1)) ?v1)) ?v0) f1) (= (f3 (f11 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f12 ?v1)) (?v_0 (f6 f16 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f11 (f12 ?v2) 0) ?v0) f1)) (=> (= (f3 (f11 (f12 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) ?v0) f1) (= (f3 (f11 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f12 ?v1)) (?v_0 (f12 ?v2)) (?v_2 (f6 f16 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f11 ?v_0 0) ?v0) f1)) (=> (= (f3 (f11 ?v_0 (* ?v3 (f5 ?v_2 ?v1))) ?v0) f1) (= (f3 (f11 ?v_1 (* ?v3 (f5 ?v_2 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f16 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f11 (f12 ?v1) ?v2) ?v0) f1) (= (f3 (f11 (f12 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 f16 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f11 (f12 ?v1) ?v2) ?v0) f1) (= (f3 (f11 (f12 (* ?v3 (f5 ?v_0 ?v1))) (* ?v3 (f5 ?v_0 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f5 (f6 f16 ?v2) ?v3)))) (=> (= (f3 (f11 (f12 ?v0) ?v_0) ?v2) f1) (= (f3 (f11 (f12 (* ?v0 ?v3)) (* ?v_0 ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 (f6 f16 ?v3) ?v0))) (=> (= (f3 (f11 (f12 (* ?v0 ?v1)) ?v2) ?v3) f1) (= (f3 (f11 (f12 (* (* ?v_0 ?v0) ?v1)) (* ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f5 (f6 f15 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f5 (f6 f15 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f5 (f6 f15 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f5 (f6 f15 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f5 (f6 f15 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f5 (f6 f15 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f15 ?v0))) (=> (= (f10 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f5 ?v_0 (f5 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (not (= (f3 (f11 (f12 (f5 (f6 f16 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (= (f3 (f11 (f12 (* ?v1 (f5 (f6 f16 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f16 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (= (f3 (f11 (f12 (f5 ?v_0 (f5 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f16 ?v0))) (let ((?v_1 (f5 ?v_0 ?v1))) (let ((?v_2 (f5 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (= (f3 (f11 (f12 ?v_2) (* (* ?v1 ?v_1) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (= (f3 (f11 (f12 (* (f5 (f6 f16 ?v0) ?v1) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f16 ?v0))) (let ((?v_1 (f5 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (= (f3 (f11 (f12 (* (* ?v1 ?v_1) (f5 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f12 ?v3)) (?v_0 (f6 f16 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f11 (f12 ?v2) 0) ?v0) f1)) (=> (not (= (f3 (f11 ?v_1 0) ?v0) f1)) (=> (= (f3 (f11 (f12 (* ?v1 (f5 ?v_0 ?v3))) (* ?v1 (f5 ?v_0 ?v2))) ?v0) f1) (= (f3 (f11 ?v_1 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int)) (= (f5 f14 ?v0) (ite (<= ?v0 0) 1 (* ?v0 (f5 f14 (- ?v0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f11 (f19 ?v1) ?v0))) (=> (= (f10 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f18 (f5 (f6 f15 ?v0) ?v2) ?v_1) f1) (= (f18 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 (f19 ?v1) ?v0))) (=> (= (f10 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f18 ?v2 ?v_0) f1) (= (f18 (f5 (f6 f15 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f9 ?v0) ?v1) f1)) (=> (not (= (f3 (f11 (f12 ?v2) 0) ?v0) f1)) (= (f20 f21 (f11 (f22 (f23 ?v1) ?v0) ?v2)) (f24 f25 2)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f9 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f3 (f11 (f12 (f26 (f27 f28 ?v2) (f24 f25 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (f17 ?v0 (f29 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f9 ?v0) ?v1) f1)) (= (f3 (f11 (f12 (f5 f14 ?v_0)) (f26 (f27 f28 ?v1) (f24 f25 (f5 (f6 f30 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 ?v0))) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (= (f18 ?v2 ?v_0) f1) (= (f18 (f5 (f6 f31 ?v0) (* ?v1 (f5 (f6 f16 ?v0) ?v2))) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f18 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (f32 ?v0) ?v0)))
(assert (forall ((?v0 S7)) (let ((?v_0 (f26 (f27 f28 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f27 f28 ?v1)) (?v_1 (f24 f25 ?v0))) (=> (< 0 ?v0) (= (f26 ?v_0 ?v_1) (* ?v1 (f26 ?v_0 (f24 f25 (- (f26 f33 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (= (f29 ?v0) (f32 (f4 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= 0 (f5 (f6 f31 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (< (f5 (f6 f31 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 ?v0 (f29 ?v1)) f1) (= (f5 (f6 f31 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (= (f26 f33 (f20 f21 (f29 ?v0))) (- ?v0 1)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f26 (f27 f28 ?v0) (f24 f25 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f24 f25 2))) (let ((?v_0 (f26 (f27 f28 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f26 (f27 f28 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f24 f25 3))) (let ((?v_0 (f26 (f27 f28 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f26 (f27 f28 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (* ?v0 (f26 ?v_0 (f24 f25 2))) (f26 ?v_0 (f24 f25 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f24 f25 3))) (= (f26 (f27 f28 (- ?v0)) ?v_0) (- (f26 (f27 f28 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f24 f25 2))) (= (f26 (f27 f28 (+ ?v0 ?v1)) ?v_0) (+ (+ (f26 (f27 f28 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f26 (f27 f28 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f24 f25 2))) (= (f26 (f27 f28 (- ?v0 ?v1)) ?v_0) (+ (- (f26 (f27 f28 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f26 (f27 f28 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f24 f25 2)) (?v_0 (f24 f25 3)) (?v_1 (f27 f28 ?v0)) (?v_3 (f27 f28 ?v1))) (= (f26 (f27 f28 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f26 ?v_1 ?v_0) (* (* 3 (f26 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f26 ?v_3 ?v_2))) (f26 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f24 f25 2)) (?v_0 (f24 f25 3)) (?v_3 (f27 f28 ?v1)) (?v_1 (f27 f28 ?v0))) (= (f26 (f27 f28 (- ?v0 ?v1)) ?v_0) (- (+ (- (f26 ?v_1 ?v_0) (* (* 3 (f26 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f26 ?v_3 ?v_2))) (f26 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f24 f25 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f26 (f27 f28 ?v0) ?v_0) (f26 (f27 f28 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f24 f25 2)) (?v_1 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_1 ?v_0)) ?v_0) (f26 ?v_1 (f24 f25 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f24 f25 2))) (= (= (f26 (f27 f28 ?v0) ?v_0) (f26 (f27 f28 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f18 ?v0 (f11 (f19 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f5 (f6 f30 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f5 (f6 f30 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f18 ?v1 (f11 (f19 (- ?v0 1)) ?v2)) f1) (= (f18 ?v1 (f11 (f19 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f5 (f6 f30 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int)) (=> (= (f26 (f27 f28 ?v0) (f24 f25 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (= (= (f18 (f5 (f6 f31 ?v0) ?v1) (f29 ?v0)) f1) (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 ?v0))) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (= (f18 ?v1 ?v_0) f1) (=> (= (f18 ?v2 ?v_0) f1) (= (f18 (f5 (f6 f31 ?v0) (* ?v1 ?v2)) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f29 ?v0))) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (= (f18 ?v1 ?v_0) f1) (= (f18 (f5 (f6 f31 ?v0) ?v1) ?v_0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (= (f3 (f11 (f12 ?v1) 0) ?v0) f1) (= (f3 (f11 (f12 0) (f26 (f27 f28 ?v1) (f24 f25 (f5 (f6 f30 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f3 (f11 (f12 ?v0) ?v1) ?v2) f1) (= (f3 (f11 (f12 (f26 (f27 f28 ?v0) ?v3)) (f26 (f27 f28 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f27 f28 (- 1)))) (let ((?v_1 (f26 ?v_0 ?v1)) (?v_2 (f26 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f3 (f11 (f12 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f16 ?v0) ?v1) (f26 (f27 f28 ?v1) (f24 f25 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f29 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (= (f18 ?v1 ?v_0) f1) (= (f18 (f5 (f6 f31 ?v0) (f5 (f6 f16 ?v0) ?v1)) ?v_0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (= (f3 (f9 ?v0) ?v1) f1) (= (f3 (f11 (f12 (f26 (f27 f28 ?v1) (f24 f25 (f5 (f6 f30 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f11 (f12 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f9 ?v0) ?v1) f1)) (= (f3 (f11 (f12 (f26 (f27 f28 ?v1) (f24 f25 (f5 (f6 f30 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f31 ?v0))) (=> (< 2 ?v0) (= (f3 (f11 (f12 (* (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))) (* ?v1 ?v2)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f31 ?v0))) (=> (< 0 ?v0) (= (= (f5 ?v_0 ?v1) (f5 ?v_0 ?v2)) (= (f3 (f11 (f12 ?v1) ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f11 (f12 ?v0) (f5 (f6 f31 ?v1) ?v0)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 (f6 f31 ?v0) ?v1) 0) (= (f3 (f11 (f12 ?v1) 0) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= (f3 (f11 (f12 ?v0) 0) ?v1) f1)) (not (= (f5 (f6 f31 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 ?v0 (f29 ?v1)) f1) (not (= (f3 (f11 (f12 ?v0) 0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (= (f3 (f11 (f12 (f5 (f6 f7 ?v1) ?v0)) (f26 (f27 f28 ?v1) (f24 f25 (f5 (f6 f30 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f18 ?v2 (f11 (f19 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f18 ?v2 (f11 (f19 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f18 ?v2 (f11 (f19 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 S7)) (= (f24 f25 (f26 f33 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f26 f33 (f24 f25 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f26 f33 (f24 f25 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f5 (f6 f30 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f5 (f6 f34 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
