(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (Int Int) S1)
(declare-fun f8 (Int) S1)
(declare-fun f9 (Int Int Int) S1)
(declare-fun f10 (Int) S1)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 f5 (- 1)) (+ (* 4 f6) 1)) 1))))
(assert (not (= (f7 (+ (* 4 f6) 1) (- 1)) f1)))
(assert (not (= (f7 (+ (* 4 f6) 1) (- 1)) f1)))
(assert (= (f3 (f4 f5 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (= (f8 (+ (* 4 f6) 1)) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f8 ?v_0) f1) (= (f3 (f4 f5 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (ite (= (f9 ?v0 0 ?v1) f1) 0 (ite (= (f7 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (= (f10 ?v1) f1) (= (f10 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 ?v0) f1) (=> (not (= (f9 ?v1 0 ?v0) f1)) (=> (not (= (f9 ?v2 0 ?v0) f1)) (not (= (f9 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f9 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f9 ?v1 0 ?v0) f1)) (not (= (f9 ?v2 0 ?v0) f1))) (not (= (f9 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 ?v0) f1) (=> (< 0 ?v1) (=> (= (f9 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f9 ?v1 0 ?v0) f1) (= (f9 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 ?v0) f1) (=> (< 0 ?v1) (=> (= (f9 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f9 ?v1 1 ?v0) f1) (= (f9 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (= (f8 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f8 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f9 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f9 ?v0 ?v1 ?v2) f1) (= (f9 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f9 ?v0 ?v1 (- ?v2)) f1) (= (f9 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (=> (= (f9 ?v3 ?v4 ?v2) f1) (= (f9 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (=> (= (f9 ?v3 ?v4 ?v2) f1) (= (f9 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (=> (= (f9 ?v3 ?v4 ?v2) f1) (= (f9 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (=> (= (f9 ?v1 ?v3 ?v2) f1) (= (f9 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f9 ?v3 ?v4 ?v2) f1) (= (f9 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (= (f9 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (= (f9 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (= (f9 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (= (= (f9 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f9 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f9 ?v0 ?v1 ?v2) f1) (= (= (f9 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f9 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v1 (- 1) ?v0) f1) (not (= (f9 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f9 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f9 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f9 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(check-sat)
(exit)
