(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (Int) S2)
(declare-fun f5 () S1)
(declare-fun f6 (S3 Int) S2)
(declare-fun f7 (Int) S3)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 (S6 Int) S4)
(declare-fun f10 () S6)
(declare-fun f11 (S7 Int) S5)
(declare-fun f12 () S7)
(declare-fun f13 () Int)
(declare-fun f14 (Int) S2)
(declare-fun f15 (Int) S1)
(declare-fun f16 (S8 Int) Int)
(declare-fun f17 (S9 Int) S8)
(declare-fun f18 () S9)
(declare-fun f19 () S4)
(declare-fun f20 () S8)
(declare-fun f21 () S9)
(declare-fun f22 () S9)
(declare-fun f23 () S9)
(declare-fun f24 () S8)
(declare-fun f25 (S10 S5) S5)
(declare-fun f26 (S11 S5) S10)
(declare-fun f27 () S11)
(declare-fun f28 (S12 S2) S1)
(declare-fun f29 (Int) S12)
(declare-fun f30 (S2 S12) S1)
(declare-fun f31 (S2) S2)
(declare-fun f32 (Int) S3)
(declare-fun f33 (Int) S2)
(declare-fun f34 (Int) S12)
(declare-fun f35 (S13 S12) S5)
(declare-fun f36 () S13)
(declare-fun f37 (S14 Int) S12)
(declare-fun f38 (Int) S14)
(declare-fun f39 (S15 S2) S5)
(declare-fun f40 () S15)
(declare-fun f41 (S16 Int) S3)
(declare-fun f42 (Int) S16)
(declare-fun f43 () S9)
(declare-fun f44 (Int) S2)
(declare-fun f45 (S12) S1)
(declare-fun f46 (S2) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 ?v0) ?v1) f1) (and (< 0 ?v1) (< ?v1 ?v0)))))
(assert (not (= f5 f1)))
(assert (forall ((?v0 Int)) (=> (= (f3 (f6 (f7 (f8 (f9 f10 ?v0) (f11 f12 2))) (- 1)) (+ (* 4 f13) 1)) f1) (= f5 f1))))
(assert (= (f3 (f14 (+ (* 4 f13) 1)) (- 1)) f1))
(assert (= (f3 (f14 (+ (* 4 f13) 1)) (- 1)) f1))
(assert (= (f15 (+ (* 4 f13) 1)) f1))
(assert (= (f16 (f17 f18 (- 1)) (+ (* 4 f13) 1)) 1))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (=> (not (= (f3 (f14 ?v_0) (- 1)) f1)) (not (= (f16 (f17 f18 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 (- 1)))) (let ((?v_1 (f8 ?v_0 ?v1)) (?v_2 (f8 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f3 (f6 (f7 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S5)) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f3 (f6 (f7 (f8 (f9 f10 ?v0) ?v3)) (f8 (f9 f10 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f14 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f3 (f6 (f7 (f8 (f9 f10 ?v2) (f11 f12 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f8 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f8 (f9 f10 ?v0) (f11 f12 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f11 f12 2))) (let ((?v_0 (f8 (f9 f10 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f11 f12 3))) (let ((?v_0 (f8 (f9 f10 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f8 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f11 f12 0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f11 f12 (+ (f8 f19 ?v1) (f8 f19 ?v2)))) (* (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (* ?v0 (f8 ?v_0 (f11 f12 2))) (f8 ?v_0 (f11 f12 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 3))) (= (f8 (f9 f10 (- ?v0)) ?v_0) (- (f8 (f9 f10 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v_0) (+ (+ (f8 (f9 f10 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f8 (f9 f10 ?v1) ?v_0))))))
(assert (= (f15 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f15 ?v_0) f1) (= (f16 (f17 f18 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f6 (f7 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f3 (f6 (f7 ?v1) 0) ?v0) f1) (= (f3 (f6 (f7 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (not (= (f3 (f6 (f7 ?v2) 0) ?v0) f1))) (not (= (f3 (f6 (f7 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f6 (f7 ?v2) 0) ?v0) f1)) (not (= (f3 (f6 (f7 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f18 ?v0) ?v1) (ite (= (f3 (f6 (f7 ?v0) 0) ?v1) f1) 0 (ite (= (f3 (f14 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f7 ?v0))) (=> (= (f3 (f6 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 (f6 (f7 ?v3) ?v4) ?v2) f1) (= (f3 (f6 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f3 (f6 (f7 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f7 ?v3))) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (= (f3 (f6 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f3 (f6 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f7 ?v3))) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (= (f3 (f6 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f3 (f6 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 ?v1))) (=> (< 2 ?v0) (=> (= (f3 (f6 ?v_0 (- 1)) ?v0) f1) (not (= (f3 (f6 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f3 (f6 (f7 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f6 (f7 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f6 (f7 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f3 (f6 (f7 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int)) (=> (= (f8 (f9 f10 ?v0) (f11 f12 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f8 (f9 f10 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (= (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 2)) (?v_1 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_1 ?v_0)) ?v_0) (f8 ?v_1 (f11 f12 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f11 f12 2)) (?v_0 (f11 f12 3)) (?v_3 (f9 f10 ?v1)) (?v_1 (f9 f10 ?v0))) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v_0) (- (+ (- (f8 ?v_1 ?v_0) (* (* 3 (f8 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f11 f12 2)) (?v_0 (f11 f12 3)) (?v_1 (f9 f10 ?v0)) (?v_3 (f9 f10 ?v1))) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f8 ?v_1 ?v_0) (* (* 3 (f8 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v_0) (+ (- (f8 (f9 f10 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f8 (f9 f10 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 ?v1))) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f6 (f7 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f3 (f6 ?v_0 1) ?v0) f1) (= (f3 (f6 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (f6 (f7 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int)) (=> (= (f15 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 ?v1)) (?v_1 (f11 f12 ?v0))) (=> (< 0 ?v0) (= (f8 ?v_0 ?v_1) (* ?v1 (f8 ?v_0 (f11 f12 (- (f8 f19 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (<= 0 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f6 (f7 ?v3) ?v4) ?v2) f1) (= (f3 (f6 (f7 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f6 (f7 ?v3) ?v4) ?v2) f1) (= (f3 (f6 (f7 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f6 (f7 ?v3) ?v4) ?v2) f1) (= (f3 (f6 (f7 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 ?v0))) (=> (= (f3 (f6 ?v_0 ?v1) ?v2) f1) (=> (= (f3 (f6 (f7 ?v1) ?v3) ?v2) f1) (= (f3 (f6 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f3 (f6 (f7 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f6 (f7 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f3 (f6 (f7 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 (f7 ?v0) ?v1))) (= (= (f3 ?v_0 (- ?v2)) f1) (= (f3 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (f6 (f7 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f3 (f6 (f7 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f6 (f7 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f6 (f7 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f6 (f7 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 (f6 (f7 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 (f6 (f7 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f6 (f7 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f3 (f6 (f7 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int)) (=> (= (f15 ?v0) f1) (= (f3 (f6 (f7 (f16 f20 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f3 (f6 (f7 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f3 (f6 (f7 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (= (f3 (f6 (f7 (f16 (f17 f18 ?v1) ?v0)) (f8 (f9 f10 ?v1) (f11 f12 (f16 (f17 f21 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f14 ?v0) ?v1) f1)) (= (f3 (f6 (f7 (f8 (f9 f10 ?v1) (f11 f12 (f16 (f17 f21 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (= (f3 (f14 ?v0) ?v1) f1) (= (f3 (f6 (f7 (f8 (f9 f10 ?v1) (f11 f12 (f16 (f17 f21 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 ?v2))) (=> (= (f15 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f6 ?v_0 0) ?v0) f1)) (=> (not (= (f3 (f14 ?v0) ?v1) f1)) (not (= (f3 (f6 ?v_0 (* ?v1 (f16 (f17 f22 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f3 (f6 (f7 (* ?v1 (f16 (f17 f23 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f16 f24 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f16 f24 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f16 (f17 f21 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f16 (f17 f21 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f16 (f17 f21 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f11 f12 (f8 (f9 f10 ?v0) ?v1)) (f25 (f26 f27 (f11 f12 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f9 f10 (f8 f19 ?v0)) ?v1) (f8 f19 (f25 (f26 f27 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f28 (f29 ?v0) ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S12)) (= (= (f30 ?v0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (f31 ?v0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 f19 (f25 (f26 f27 ?v0) ?v1)) (f8 (f9 f10 (f8 f19 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f25 (f26 f27 (f11 f12 ?v0)) ?v1) (f11 f12 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f9 f10 (f8 f19 ?v0)) ?v1) (f8 f19 (f25 (f26 f27 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 (f17 f22 ?v3) ?v0))) (=> (= (f3 (f6 (f7 (* ?v0 ?v1)) ?v2) ?v3) f1) (= (f3 (f6 (f7 (* (* ?v_0 ?v0) ?v1)) (* ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f16 (f17 f22 ?v2) ?v3)))) (=> (= (f3 (f6 (f7 ?v0) ?v_0) ?v2) f1) (= (f3 (f6 (f7 (* ?v0 ?v3)) (* ?v_0 ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f17 f22 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f6 (f7 ?v1) ?v2) ?v0) f1) (= (f3 (f6 (f7 (* ?v3 (f16 ?v_0 ?v1))) (* ?v3 (f16 ?v_0 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f22 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f6 (f7 ?v1) ?v2) ?v0) f1) (= (f3 (f6 (f7 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f22 ?v0) ?v1) (f8 (f9 f10 ?v1) (f11 f12 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f16 (f17 f23 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f16 (f17 f23 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f16 (f17 f23 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f15 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f16 (f17 f23 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f16 (f17 f23 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f15 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f16 (f17 f23 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f23 ?v0))) (=> (= (f15 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f16 ?v_0 (f16 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (not (= (f3 (f6 (f7 (f16 (f17 f22 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f3 (f6 (f7 (* ?v1 (f16 (f17 f22 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f22 ?v0))) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f3 (f6 (f7 (f16 ?v_0 (f16 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f22 ?v0))) (let ((?v_1 (f16 ?v_0 ?v1))) (let ((?v_2 (f16 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f3 (f6 (f7 ?v_2) (* (* ?v1 ?v_1) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f3 (f6 (f7 (* (f16 (f17 f22 ?v0) ?v1) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f22 ?v0))) (let ((?v_1 (f16 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f3 (f6 (f7 (* (* ?v1 ?v_1) (f16 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f7 ?v3)) (?v_0 (f17 f22 ?v0))) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f6 (f7 ?v2) 0) ?v0) f1)) (=> (not (= (f3 (f6 ?v_1 0) ?v0) f1)) (=> (= (f3 (f6 (f7 (* ?v1 (f16 ?v_0 ?v3))) (* ?v1 (f16 ?v_0 ?v2))) ?v0) f1) (= (f3 (f6 ?v_1 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f7 ?v1)) (?v_0 (f7 ?v2)) (?v_2 (f17 f22 ?v0))) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f6 ?v_0 0) ?v0) f1)) (=> (= (f3 (f6 ?v_0 (* ?v3 (f16 ?v_2 ?v1))) ?v0) f1) (= (f3 (f6 ?v_1 (* ?v3 (f16 ?v_2 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f7 ?v1)) (?v_0 (f17 f22 ?v0))) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f6 (f7 ?v2) 0) ?v0) f1)) (=> (= (f3 (f6 (f7 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2)) ?v0) f1) (= (f3 (f6 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 (* ?v2 ?v1)))) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (= (f3 (f6 ?v_0 (* (* ?v3 (f16 (f17 f22 ?v0) ?v1)) ?v1)) ?v0) f1) (= (f3 (f6 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f16 (f17 f22 ?v0) ?v1))) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (= (f3 (f6 (f7 (* (* ?v_0 ?v1) ?v2)) (* ?v_0 ?v3)) ?v0) f1) (= (f3 (f6 (f7 ?v2) (* ?v3 ?v_0)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f15 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f14 ?v0) ?v1) f1)) (= (f3 (f6 (f7 (f16 f20 ?v_0)) (f8 (f9 f10 ?v1) (f11 f12 (f16 (f17 f21 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f15 ?v0) f1) (=> (= (f3 (f6 (f7 ?v1) 0) ?v0) f1) (= (f3 (f6 (f7 0) (f8 (f9 f10 ?v1) (f11 f12 (f16 (f17 f21 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) (f11 f12 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f25 (f26 f27 ?v0) (f11 f12 1)) ?v0)))
(assert (forall ((?v0 S5) (?v1 Int)) (let ((?v_1 (f8 f19 ?v0)) (?v_0 (f9 f10 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f16 (f17 f21 (f8 ?v_0 ?v0)) ?v1) (f8 ?v_0 (f11 f12 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int)) (= (f16 f20 ?v0) (ite (<= ?v0 0) 1 (* ?v0 (f16 f20 (- ?v0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f6 (f32 ?v1) ?v0))) (=> (= (f15 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f28 (f29 (f16 (f17 f23 ?v0) ?v2)) ?v_1) f1) (= (f28 (f29 ?v2) ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 (f32 ?v1) ?v0))) (=> (= (f15 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f28 (f29 ?v2) ?v_0) f1) (= (f28 (f29 (f16 (f17 f23 ?v0) ?v2)) ?v_0) f1))))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (f16 (f17 f21 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f3 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int)) (= (f16 (f17 f21 0) ?v0) 0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f8 f19 (f25 (f26 f27 ?v0) ?v1))) (or (< 0 (f8 f19 ?v0)) (= ?v1 (f11 f12 0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f11 f12 (+ 0 1)))) (= (f25 (f26 f27 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f11 f12 (+ 0 1)))) (= (= (f25 (f26 f27 ?v0) ?v1) ?v_0) (or (= ?v1 (f11 f12 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f27 ?v0))) (=> (< 0 (f8 f19 ?v0)) (=> (< (f8 f19 (f25 ?v_0 ?v1)) (f8 f19 (f25 ?v_0 ?v2))) (< (f8 f19 ?v1) (f8 f19 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f8 f19 ?v0)) (<= ?v_0 (f8 f19 (f25 (f26 f27 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f28 (f29 ?v0) (f6 (f32 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 ?v1))) (=> (< 1 ?v0) (=> (= (f28 ?v_0 (f6 (f32 (- ?v0 1)) ?v2)) f1) (= (f28 ?v_0 (f6 (f32 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f15 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f28 (f29 ?v2) (f6 (f32 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f28 (f29 ?v2) (f6 (f32 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f28 (f29 ?v2) (f6 (f32 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 ?v1))) (=> (< 1 ?v0) (=> (not (= (f28 ?v_0 (f6 (f32 (- ?v0 1)) ?v2)) f1)) (=> (= (f28 ?v_0 (f6 (f32 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f16 (f17 f23 ?v2) ?v0)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f16 (f17 f21 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f16 (f17 f21 ?v1) ?v2) (f16 (f17 f21 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f16 (f17 f21 ?v0) ?v2) (f16 (f17 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f16 (f17 f21 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f21 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f16 (f17 f21 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f16 (f17 f21 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f16 (f17 f21 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f16 (f17 f21 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f16 (f17 f21 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f16 (f17 f21 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f16 (f17 f21 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f16 (f17 f21 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f16 (f17 f21 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f21 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f16 ?v_0 ?v2) (f16 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f16 (f17 f21 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f16 (f17 f21 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f16 (f17 f21 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f16 (f17 f21 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f16 (f17 f21 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f16 (f17 f21 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f21 ?v1))) (=> (< 0 ?v0) (= (f16 ?v_0 (* ?v2 ?v0)) (f16 (f17 f21 (f16 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f16 (f17 f21 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f16 (f17 f21 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f16 (f17 f21 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f16 (f17 f21 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 (f17 f21 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f21 (- ?v0)) (- ?v1)) (f16 (f17 f21 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f21 ?v0) (- ?v1)) (f16 (f17 f21 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f16 (f17 f21 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f15 ?v0) f1) (= (f33 ?v_0) (f6 (f32 ?v_0) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f8 f19 (f25 (f26 f27 ?v0) ?v1))) (or (= ?v1 (f11 f12 0)) (< 0 (f8 f19 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f11 f12 0))) (= (= (f25 (f26 f27 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f11 f12 1))) (= (= (f25 (f26 f27 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f11 f12 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 (f29 ?v0) (f33 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 (f29 ?v0) (f33 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f28 (f29 ?v1) (f33 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f28 (f29 ?v0) (f33 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f12 (+ (f8 f19 ?v1) 1)))) (= (<= (f8 f19 (f25 (f26 f27 ?v0) ?v_0)) (f8 f19 (f25 (f26 f27 ?v2) ?v_0))) (<= (f8 f19 ?v0) (f8 f19 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f12 (+ (f8 f19 ?v1) 1)))) (= (< (f8 f19 (f25 (f26 f27 ?v0) ?v_0)) (f8 f19 (f25 (f26 f27 ?v2) ?v_0))) (< (f8 f19 ?v0) (f8 f19 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f12 (+ (f8 f19 ?v1) 1)))) (= (= (f25 (f26 f27 ?v0) ?v_0) (f25 (f26 f27 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f21 ?v0))) (= (div ?v0 ?v1) (ite (<= 0 ?v1) (f16 ?v_0 ?v1) (- (f16 ?v_0 (- ?v1))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 2))) (= (f8 (f9 f10 (f16 f24 ?v0)) ?v_0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) (f11 f12 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f25 (f26 f27 ?v0) (f11 f12 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) (f11 f12 2)))) (= (f16 f24 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f28 (f34 ?v0) ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f28 (f29 ?v2) ?v1) f1) (and (= (f28 (f29 ?v3) ?v1) f1) (= (f3 (f6 (f7 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f14 ?v0) ?v1) f1)) (= (f8 f19 (f35 f36 (f37 (f38 ?v1) ?v0))) (f16 (f17 f21 (- ?v0 1)) 2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f14 ?v0) ?v1) f1)) (forall ((?v2 S2)) (=> (= (f30 ?v2 (f37 (f38 ?v1) ?v0)) f1) (= (f39 f40 ?v2) (f11 f12 2))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f14 ?v0) ?v1) f1)) (=> (not (= (f3 (f6 (f7 ?v2) 0) ?v0) f1)) (= (f39 f40 (f6 (f41 (f42 ?v1) ?v0) ?v2)) (f11 f12 2)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f23 ?v0) ?v1) (f16 (f17 f43 (f8 (f9 f10 ?v1) (f11 f12 (- ?v0 2)))) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 (f17 f43 ?v0) 2))) (= (not (= ?v_0 0)) (= ?v_0 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int) (?v7 Int)) (let ((?v_0 (f16 (f17 f21 ?v0) ?v5))) (=> (= ?v0 (+ (* ?v1 ?v2) (* ?v3 ?v4))) (=> (= ?v5 (+ (* ?v6 ?v2) (* ?v7 ?v4))) (= (f16 (f17 f43 ?v0) ?v5) (+ (* (- ?v1 (* ?v_0 ?v6)) ?v2) (* (- ?v3 (* ?v_0 ?v7)) ?v4))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- ?v0 ?v1) (+ (* ?v2 (- (f16 (f17 f21 ?v0) ?v2) (f16 (f17 f21 ?v1) ?v2))) (- (f16 (f17 f43 ?v0) ?v2) (f16 (f17 f43 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 (f17 f43 ?v0) ?v1) (f16 (f17 f43 ?v2) ?v1)) (= (f3 (f6 (f7 ?v0) ?v2) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f6 (f7 ?v0) (f16 (f17 f43 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (= (f3 (f6 (f7 ?v1) ?v2) ?v0) f1) (= (f16 (f17 f43 ?v1) ?v0) (f16 (f17 f43 ?v2) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f3 (f6 (f7 (f16 (f17 f43 ?v0) ?v2)) (f16 (f17 f43 ?v1) ?v2)) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (f16 (f17 f43 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f3 ?v0 ?v1) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v4) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v4) f1)))))))))
(assert (forall ((?v0 Int)) (= (f16 (f17 f43 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f16 (f17 f43 ?v0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f16 (f17 f43 ?v0) (- 1)) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f43 ?v0) (- ?v1)) (- (f16 (f17 f43 (- ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f43 ?v0))) (let ((?v_1 (f16 ?v_0 ?v1))) (= (f16 ?v_0 (- ?v1)) (ite (= ?v_1 0) 0 (- ?v_1 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 (f17 f43 ?v0) ?v1))) (= (f16 (f17 f43 (- ?v0)) ?v1) (ite (= ?v_0 0) 0 (- ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f43 (- ?v0)) (- ?v1)) (- (f16 (f17 f43 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f43 (- (f16 (f17 f43 ?v0) ?v1))) ?v1) (f16 (f17 f43 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 (f17 f43 ?v0) ?v1) 0) (exists ((?v2 Int)) (= ?v0 (* ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 (f17 f43 ?v0) ?v1))) (= (f16 (f17 f43 ?v_0) ?v1) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f43 (* ?v0 ?v1)) ?v2) (f16 (f17 f43 (* ?v0 (f16 (f17 f43 ?v1) ?v2))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f43 (- ?v0 (f16 (f17 f43 ?v1) ?v2))) ?v2) (f16 (f17 f43 (- ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f43 (* ?v0 (f16 (f17 f43 ?v1) ?v2))) ?v2) (f16 (f17 f43 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f43 (- (f16 (f17 f43 ?v0) ?v1) ?v2)) ?v1) (f16 (f17 f43 (- ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f43 ?v0))) (=> (not (= (f16 ?v_0 (- ?v1)) 0)) (not (= (f16 ?v_0 ?v1) 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= (f16 (f17 f43 (- ?v0)) ?v1) 0)) (not (= (f16 (f17 f43 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= 0 (f16 (f17 f43 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 (f17 f43 ?v1) ?v0))) (=> (< 0 ?v0) (and (<= 0 ?v_0) (< ?v_0 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (< (f16 (f17 f43 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (<= (f16 (f17 f43 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f16 (f17 f43 (- 1)) ?v0) (- ?v0 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f16 (f17 f43 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (+ 1 (* 2 (f16 (f17 f43 ?v1) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f16 (f17 f43 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (<= 0 (+ (* ?v2 (f16 (f17 f43 ?v3) ?v0)) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (< (+ (* ?v2 (f16 (f17 f43 ?v3) ?v0)) ?v1) (* ?v2 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f16 (f17 f43 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (< (* ?v1 ?v0) (+ (* ?v1 (f16 (f17 f43 ?v3) ?v0)) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (<= (+ (* ?v1 (f16 (f17 f43 ?v3) ?v0)) ?v2) 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ ?v0 ?v1))) (=> (< 0 ?v0) (=> (<= ?v_0 0) (= (f16 (f17 f43 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (< ?v0 (f16 (f17 f43 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (<= (f16 (f17 f43 ?v1) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f16 (f17 f43 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (- (* 2 (f16 (f17 f43 (+ ?v1 1)) ?v0)) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 (f17 f43 ?v1) ?v0))) (=> (< ?v0 0) (and (<= ?v_0 0) (< ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f16 (f17 f43 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f16 (f17 f43 ?v0) ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (< ?v0 0) (= (= (f3 (f6 ?v1 (f16 (f17 f21 ?v2) ?v0)) (f16 (f17 f43 ?v2) ?v0)) f1) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v0 ?v4) (and (<= ?v4 0) (= ?v2 (+ (* ?v0 ?v3) ?v4)))) (= (f3 (f6 ?v1 ?v3) ?v4) f1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (< 0 ?v0) (= (= (f3 (f6 ?v1 (f16 (f17 f21 ?v2) ?v0)) (f16 (f17 f43 ?v2) ?v0)) f1) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v0) (= ?v2 (+ (* ?v0 ?v3) ?v4)))) (= (f3 (f6 ?v1 ?v3) ?v4) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f43 ?v1))) (=> (< 0 ?v0) (= (f16 ?v_0 (* ?v2 ?v0)) (+ (* ?v2 (f16 (f17 f43 (f16 (f17 f21 ?v1) ?v2)) ?v0)) (f16 ?v_0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- (f16 (f17 f21 ?v1) ?v0)))) (=> (not (= ?v0 0)) (= (f16 (f17 f21 (- ?v1)) ?v0) (ite (= (f16 (f17 f43 ?v1) ?v0) 0) ?v_0 (- ?v_0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f21 ?v1))) (let ((?v_1 (- (f16 ?v_0 ?v0)))) (=> (not (= ?v0 0)) (= (f16 ?v_0 (- ?v0)) (ite (= (f16 (f17 f43 ?v1) ?v0) 0) ?v_1 (- ?v_1 1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ (* (f16 (f17 f21 ?v0) ?v1) ?v1) (f16 (f17 f43 ?v0) ?v1)) ?v2) (+ ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ (* ?v0 (f16 (f17 f21 ?v1) ?v0)) (f16 (f17 f43 ?v1) ?v0)) ?v2) (+ ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f21 (+ ?v0 ?v1)) ?v2) (+ (+ (f16 (f17 f21 ?v0) ?v2) (f16 (f17 f21 ?v1) ?v2)) (f16 (f17 f21 (+ (f16 (f17 f43 ?v0) ?v2) (f16 (f17 f43 ?v1) ?v2))) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f21 (* ?v0 ?v1)) ?v2) (+ (* ?v0 (f16 (f17 f21 ?v1) ?v2)) (f16 (f17 f21 (* ?v0 (f16 (f17 f43 ?v1) ?v2))) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f21 (f16 (f17 f43 ?v0) ?v1)) ?v1) 0)))
(assert (forall ((?v0 Int)) (and (= (f16 (f17 f21 ?v0) 0) 0) (= (f16 (f17 f43 ?v0) 0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 (f16 (f17 f21 ?v1) ?v0)) (- ?v1 (f16 (f17 f43 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f43 ?v0) ?v1) (- ?v0 (* (f16 (f17 f21 ?v0) ?v1) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= ?v0 (+ (* ?v1 (f16 (f17 f21 ?v0) ?v1)) (f16 (f17 f43 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f16 (f17 f43 (f8 (f9 f10 (f16 (f17 f43 ?v0) ?v1)) ?v2)) ?v1) (f16 (f17 f43 (f8 (f9 f10 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f43 ?v0))) (= (mod ?v0 ?v1) (ite (<= 0 ?v1) (f16 ?v_0 ?v1) (f16 ?v_0 (- ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 (f17 f43 ?v0) ?v1) 0) (exists ((?v2 Int)) (= ?v0 (* ?v1 ?v2))))))
(assert (forall ((?v0 Int)) (= (f28 (f34 ?v0) (f44 ?v0)) f1)))
(assert (forall ((?v0 S12)) (let ((?v_0 (f8 (f9 f10 (- 1)) (f35 f36 ?v0)))) (=> (= (f45 ?v0) f1) (= (* ?v_0 ?v_0) 1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 (f9 f10 (- 1)) (f39 f40 ?v0)))) (=> (= (f46 ?v0) f1) (= (* ?v_0 ?v_0) 1)))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (= (f8 f19 (f39 f40 (f44 ?v0))) (- ?v0 1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 (f17 f43 (f8 f19 ?v0)) (f8 f19 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f16 (f17 f43 (f8 f19 ?v0)) (f8 f19 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f11 f12 (f16 (f17 f43 ?v0) ?v1)) (f11 f12 (f16 (f17 f43 (f8 f19 (f11 f12 ?v0))) (f8 f19 (f11 f12 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f11 f12 (f16 (f17 f43 (f8 f19 (f11 f12 ?v0))) (f8 f19 (f11 f12 ?v1)))) (f11 f12 (f16 (f17 f43 ?v0) ?v1)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (= (f46 (f44 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (f44 ?v0) (f31 (f4 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 (f29 ?v0) (f44 ?v1)) f1) (not (= (f3 (f6 (f7 ?v0) 0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f46 (f6 (f32 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int)) (= (f46 (f33 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 0 ?v0) (=> (= (f28 (f34 ?v0) ?v1) f1) (= (f46 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f30 ?v2 (f37 (f38 ?v0) ?v1)) f1) (= (f46 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (= (f45 (f37 (f38 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S12)) (=> (not (= (f45 ?v0) f1)) (= (f35 f36 ?v0) (f11 f12 0)))))
(assert (forall ((?v0 S2)) (=> (not (= (f46 ?v0) f1)) (= (f39 f40 ?v0) (f11 f12 0)))))
(assert (forall ((?v0 S12)) (=> (< 0 (f8 f19 (f35 f36 ?v0))) (= (f45 ?v0) f1))))
(assert (forall ((?v0 S2)) (=> (< 0 (f8 f19 (f39 f40 ?v0))) (= (f46 ?v0) f1))))
(assert (forall ((?v0 S5)) (= (f11 f12 (f8 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f19 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f19 (f11 f12 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f16 (f17 f21 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f16 (f17 f43 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
