(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (Int) S2)
(declare-fun f5 () S1)
(declare-fun f6 () Int)
(declare-fun f7 (S3 Int) S2)
(declare-fun f8 (Int) S3)
(declare-fun f9 () Int)
(declare-fun f10 (Int) S1)
(declare-fun f11 (S4 Int) Int)
(declare-fun f12 (S5 Int) S4)
(declare-fun f13 () S5)
(declare-fun f14 (S6 S7) Int)
(declare-fun f15 (S8 Int) S6)
(declare-fun f16 () S8)
(declare-fun f17 (S9 Int) S7)
(declare-fun f18 () S9)
(declare-fun f19 (Int) S2)
(declare-fun f20 () S4)
(declare-fun f21 () S5)
(declare-fun f22 () S6)
(declare-fun f23 (S10 S2) S1)
(declare-fun f24 (Int) S10)
(declare-fun f25 (S2 S10) S1)
(declare-fun f26 (S2) S2)
(declare-fun f27 () S5)
(declare-fun f28 (Int) S3)
(declare-fun f29 () S5)
(declare-fun f30 (Int) S2)
(declare-fun f31 () S4)
(declare-fun f32 (S11 S7) S7)
(declare-fun f33 (S12 S7) S11)
(declare-fun f34 () S12)
(declare-fun f35 (Int) S10)
(declare-fun f36 (S13 S10) S7)
(declare-fun f37 () S13)
(declare-fun f38 (S14 Int) S10)
(declare-fun f39 (Int) S14)
(declare-fun f40 (S15 S2) S7)
(declare-fun f41 () S15)
(declare-fun f42 (S16 Int) S3)
(declare-fun f43 (Int) S16)
(declare-fun f44 () S5)
(declare-fun f45 (Int) S2)
(declare-fun f46 (S10) S1)
(declare-fun f47 (S2) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 ?v0) ?v1) f1) (and (< 0 ?v1) (< ?v1 ?v0)))))
(assert (not (= f5 f1)))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f3 (f7 (f8 f9) ?v0) ?v_0) f1))) (= f5 f1)))))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f3 (f7 (f8 f9) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f3 (f7 (f8 f9) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f3 (f7 (f8 f9) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f3 (f7 (f8 f9) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (= (f10 (+ (* 4 f6) 1)) f1))
(assert (= (f11 (f12 f13 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (= (f3 (f7 (f8 (f14 (f15 f16 f9) (f17 f18 2))) (- 1)) (+ (* 4 f6) 1)) f1))
(assert (= (f3 (f19 (+ (* 4 f6) 1)) (- 1)) f1))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f3 (f19 ?v_0) (- 1)) f1)) (not (= (f11 (f12 f13 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f3 (f7 (f8 (f14 (f15 f16 ?v0) (f17 f18 2))) (- 1)) (+ (* 4 f6) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f7 (f8 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (= (f3 (f7 (f8 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 (f8 ?v0) ?v1))) (= (= (f3 ?v_0 (- ?v2)) f1) (= (f3 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (f7 (f8 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f3 (f7 (f8 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (f3 (f7 (f8 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f7 (f8 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f7 (f8 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f7 (f8 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int)) (=> (= (f10 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f10 ?v_0) f1) (= (f11 (f12 f13 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (= (f3 (f7 (f8 (f14 (f15 f16 ?v0) ?v3)) (f14 (f15 f16 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 ?v1))) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f7 (f8 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f3 (f7 ?v_0 1) ?v0) f1) (= (f3 (f7 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f7 (f8 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f3 (f7 (f8 ?v1) 0) ?v0) f1) (= (f3 (f7 (f8 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (not (= (f3 (f7 (f8 ?v2) 0) ?v0) f1))) (not (= (f3 (f7 (f8 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (f7 (f8 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f7 (f8 ?v2) 0) ?v0) f1)) (not (= (f3 (f7 (f8 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f7 (f8 ?v3) ?v4) ?v2) f1) (= (f3 (f7 (f8 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f7 (f8 ?v3) ?v4) ?v2) f1) (= (f3 (f7 (f8 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f7 (f8 ?v3) ?v4) ?v2) f1) (= (f3 (f7 (f8 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 ?v0))) (=> (= (f3 (f7 ?v_0 ?v1) ?v2) f1) (=> (= (f3 (f7 (f8 ?v1) ?v3) ?v2) f1) (= (f3 (f7 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f8 ?v0))) (=> (= (f3 (f7 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 (f7 (f8 ?v3) ?v4) ?v2) f1) (= (f3 (f7 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (= (f3 (f7 (f8 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (= (f3 (f7 (f8 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (= (f3 (f7 (f8 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f8 ?v3))) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (= (= (f3 (f7 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f3 (f7 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f8 ?v3))) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (= (= (f3 (f7 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f3 (f7 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 ?v1))) (=> (< 2 ?v0) (=> (= (f3 (f7 ?v_0 (- 1)) ?v0) f1) (not (= (f3 (f7 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f7 (f8 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f7 (f8 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 (f7 (f8 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 (f7 (f8 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f7 (f8 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 ?v0) ?v1) (ite (= (f3 (f7 (f8 ?v0) 0) ?v1) f1) 0 (ite (= (f3 (f19 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f19 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f3 (f7 (f8 (f14 (f15 f16 ?v2) (f17 f18 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f15 f16 (- 1)))) (let ((?v_1 (f14 ?v_0 ?v1)) (?v_2 (f14 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f3 (f7 (f8 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (= (f10 ?v0) f1) (= (f3 (f7 (f8 (f11 f20 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f3 (f7 (f8 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f3 (f7 (f8 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (= (f10 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f3 (f7 (f8 (* ?v1 (f11 (f12 f21 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (<= 0 (f14 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f14 (f15 f16 ?v0) (f17 f18 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f17 f18 2))) (let ((?v_0 (f14 (f15 f16 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f14 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f21 ?v0))) (=> (= (f10 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f11 ?v_0 (f11 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f11 (f12 f21 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f11 (f12 f21 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f11 (f12 f21 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f11 (f12 f21 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f11 (f12 f21 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f11 (f12 f21 ?v0) ?v1))))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f3 (f7 (f8 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f14 (f15 f16 ?v0) (f17 f18 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f14 (f15 f16 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (= (f14 (f15 f16 ?v0) ?v_0) (f14 (f15 f16 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 2)) (?v_1 (f15 f16 ?v0))) (= (f14 (f15 f16 (f14 ?v_1 ?v_0)) ?v_0) (f14 ?v_1 (f17 f18 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f14 (f15 f16 ?v0) ?v_0) (f14 (f15 f16 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f17 f18 2)) (?v_0 (f17 f18 3)) (?v_3 (f15 f16 ?v1)) (?v_1 (f15 f16 ?v0))) (= (f14 (f15 f16 (- ?v0 ?v1)) ?v_0) (- (+ (- (f14 ?v_1 ?v_0) (* (* 3 (f14 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f14 ?v_3 ?v_2))) (f14 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f17 f18 2)) (?v_0 (f17 f18 3)) (?v_1 (f15 f16 ?v0)) (?v_3 (f15 f16 ?v1))) (= (f14 (f15 f16 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f14 ?v_1 ?v_0) (* (* 3 (f14 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f14 ?v_3 ?v_2))) (f14 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (f14 (f15 f16 (- ?v0 ?v1)) ?v_0) (+ (- (f14 (f15 f16 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f14 (f15 f16 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (f14 (f15 f16 (+ ?v0 ?v1)) ?v_0) (+ (+ (f14 (f15 f16 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f14 (f15 f16 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 3))) (= (f14 (f15 f16 (- ?v0)) ?v_0) (- (f14 (f15 f16 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (* ?v0 (f14 ?v_0 (f17 f18 2))) (f14 ?v_0 (f17 f18 3))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f17 f18 (+ (f14 f22 ?v1) (f14 f22 ?v2)))) (* (f14 ?v_0 ?v1) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (< 0 (f14 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f17 f18 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f17 f18 3))) (let ((?v_0 (f14 (f15 f16 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f14 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (= (f11 f20 ?v0) (ite (<= ?v0 0) 1 (* ?v0 (f11 f20 (- ?v0 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f23 (f24 ?v0) ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S10)) (= (= (f25 ?v0 ?v1) f1) (= (f23 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (f26 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f19 ?v0) ?v1) f1)) (= (f3 (f7 (f8 (f11 f20 ?v_0)) (f14 (f15 f16 ?v1) (f17 f18 (f11 (f12 f27 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 ?v1)) (?v_1 (f17 f18 ?v0))) (=> (< 0 ?v0) (= (f14 ?v_0 ?v_1) (* ?v1 (f14 ?v_0 (f17 f18 (- (f14 f22 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (<= 0 (f14 (f15 f16 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 (f28 ?v1) ?v0))) (=> (= (f10 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f23 (f24 ?v2) ?v_0) f1) (= (f23 (f24 (f11 (f12 f21 ?v0) ?v2)) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f7 (f28 ?v1) ?v0))) (=> (= (f10 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f23 (f24 (f11 (f12 f21 ?v0) ?v2)) ?v_1) f1) (= (f23 (f24 ?v2) ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (= (f3 (f7 (f8 (f11 (f12 f13 ?v1) ?v0)) (f14 (f15 f16 ?v1) (f17 f18 (f11 (f12 f27 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f11 (f12 f27 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 ?v1))) (=> (< 1 ?v0) (=> (= (f23 ?v_0 (f7 (f28 (- ?v0 1)) ?v2)) f1) (= (f23 ?v_0 (f7 (f28 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f11 (f12 f27 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f11 (f12 f27 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f23 (f24 ?v0) (f7 (f28 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f23 (f24 ?v2) (f7 (f28 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f23 (f24 ?v2) (f7 (f28 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f23 (f24 ?v2) (f7 (f28 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 ?v1))) (=> (< 1 ?v0) (=> (not (= (f23 ?v_0 (f7 (f28 (- ?v0 1)) ?v2)) f1)) (=> (= (f23 ?v_0 (f7 (f28 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f11 (f12 f21 ?v2) ?v0)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (= (f3 (f7 (f8 ?v1) 0) ?v0) f1) (= (f3 (f7 (f8 0) (f14 (f15 f16 ?v1) (f17 f18 (f11 (f12 f27 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f19 ?v0) ?v1) f1)) (= (f3 (f7 (f8 (f14 (f15 f16 ?v1) (f17 f18 (f11 (f12 f27 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (= (f3 (f19 ?v0) ?v1) f1) (= (f3 (f7 (f8 (f14 (f15 f16 ?v1) (f17 f18 (f11 (f12 f27 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_1 (f14 f22 ?v0)) (?v_0 (f15 f16 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f11 (f12 f27 (f14 ?v_0 ?v0)) ?v1) (f14 ?v_0 (f17 f18 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 ?v2))) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f7 ?v_0 0) ?v0) f1)) (=> (not (= (f3 (f19 ?v0) ?v1) f1)) (not (= (f3 (f7 ?v_0 (* ?v1 (f11 (f12 f29 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f10 ?v0) f1) (= (f30 ?v_0) (f7 (f28 ?v_0) ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (f11 (f12 f27 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f3 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f27 0) ?v0) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f27 ?v0))) (= (div ?v0 ?v1) (ite (<= 0 ?v1) (f11 ?v_0 ?v1) (- (f11 ?v_0 (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f23 (f24 ?v0) (f30 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f23 (f24 ?v1) (f30 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 (f24 ?v0) (f30 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 (f24 ?v0) (f30 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f7 (f8 ?v1) ?v2) ?v0) f1) (= (f3 (f7 (f8 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f7 (f8 ?v1) ?v2) ?v0) f1) (= (f3 (f7 (f8 (* ?v3 (f11 ?v_0 ?v1))) (* ?v3 (f11 ?v_0 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f11 (f12 f29 ?v2) ?v3)))) (=> (= (f3 (f7 (f8 ?v0) ?v_0) ?v2) f1) (= (f3 (f7 (f8 (* ?v0 ?v3)) (* ?v_0 ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 (f12 f29 ?v3) ?v0))) (=> (= (f3 (f7 (f8 (* ?v0 ?v1)) ?v2) ?v3) f1) (= (f3 (f7 (f8 (* (* ?v_0 ?v0) ?v1)) (* ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f29 ?v0) ?v1) (f14 (f15 f16 ?v1) (f17 f18 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 (f12 f29 ?v0) ?v1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (= (f3 (f7 (f8 (* (* ?v_0 ?v1) ?v2)) (* ?v_0 ?v3)) ?v0) f1) (= (f3 (f7 (f8 ?v2) (* ?v3 ?v_0)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 (* ?v2 ?v1)))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (= (f3 (f7 ?v_0 (* (* ?v3 (f11 (f12 f29 ?v0) ?v1)) ?v1)) ?v0) f1) (= (f3 (f7 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f8 ?v1)) (?v_0 (f12 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f7 (f8 ?v2) 0) ?v0) f1)) (=> (= (f3 (f7 (f8 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) ?v0) f1) (= (f3 (f7 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f8 ?v1)) (?v_0 (f8 ?v2)) (?v_2 (f12 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f7 ?v_0 0) ?v0) f1)) (=> (= (f3 (f7 ?v_0 (* ?v3 (f11 ?v_2 ?v1))) ?v0) f1) (= (f3 (f7 ?v_1 (* ?v3 (f11 ?v_2 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f8 ?v3)) (?v_0 (f12 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f7 (f8 ?v2) 0) ?v0) f1)) (=> (not (= (f3 (f7 ?v_1 0) ?v0) f1)) (=> (= (f3 (f7 (f8 (* ?v1 (f11 ?v_0 ?v3))) (* ?v1 (f11 ?v_0 ?v2))) ?v0) f1) (= (f3 (f7 ?v_1 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f29 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (= (f3 (f7 (f8 (* (* ?v1 ?v_1) (f11 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (= (f3 (f7 (f8 (* (f11 (f12 f29 ?v0) ?v1) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f29 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (let ((?v_2 (f11 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (= (f3 (f7 (f8 ?v_2) (* (* ?v1 ?v_1) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f29 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (= (f3 (f7 (f8 (f11 ?v_0 (f11 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (= (f3 (f7 (f8 (* ?v1 (f11 (f12 f29 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (not (= (f3 (f7 (f8 (f11 (f12 f29 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f11 (f12 f27 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f11 (f12 f27 ?v1) ?v2) (f11 (f12 f27 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f11 (f12 f27 ?v0) ?v2) (f11 (f12 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f11 (f12 f27 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f27 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f11 (f12 f27 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f11 (f12 f27 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f11 (f12 f27 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f11 (f12 f27 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f11 (f12 f27 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f11 (f12 f27 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f11 (f12 f27 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f11 (f12 f27 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f11 (f12 f27 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f27 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f11 ?v_0 ?v2) (f11 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f11 (f12 f27 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f11 (f12 f27 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f11 (f12 f27 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f11 (f12 f27 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f11 (f12 f27 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f11 (f12 f27 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f27 ?v1))) (=> (< 0 ?v0) (= (f11 ?v_0 (* ?v2 ?v0)) (f11 (f12 f27 (f11 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f11 (f12 f27 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f11 (f12 f27 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f11 (f12 f27 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f27 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f12 f27 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f27 (- ?v0)) (- ?v1)) (f11 (f12 f27 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f27 ?v0) (- ?v1)) (f11 (f12 f27 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f27 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 2))) (= (f14 (f15 f16 (f11 f31 ?v0)) ?v_0) (f14 (f15 f16 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f14 (f15 f16 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f32 (f33 f34 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f14 (f15 f16 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f32 (f33 f34 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 (f15 f16 ?v0) (f17 f18 2)))) (= (f11 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f11 f31 (f14 (f15 f16 ?v0) ?v1)) (f14 (f15 f16 (f11 f31 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f32 (f33 f34 (f17 f18 ?v0)) ?v1) (f17 f18 (f14 (f15 f16 ?v0) ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f14 (f15 f16 (f14 f22 ?v0)) ?v1) (f14 f22 (f32 (f33 f34 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f14 f22 (f32 (f33 f34 ?v0) ?v1)) (f14 (f15 f16 (f14 f22 ?v0)) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f14 (f15 f16 (f14 f22 ?v0)) ?v1) (f14 f22 (f32 (f33 f34 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f17 f18 (f14 (f15 f16 ?v0) ?v1)) (f32 (f33 f34 (f17 f18 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f23 (f35 ?v0) ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f23 (f24 ?v2) ?v1) f1) (and (= (f23 (f24 ?v3) ?v1) f1) (= (f3 (f7 (f8 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f19 ?v0) ?v1) f1)) (= (f14 f22 (f36 f37 (f38 (f39 ?v1) ?v0))) (f11 (f12 f27 (- ?v0 1)) 2))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f14 f22 ?v0)) (<= ?v_0 (f14 f22 (f32 (f33 f34 ?v0) ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f33 f34 ?v0))) (=> (< 0 (f14 f22 ?v0)) (=> (< (f14 f22 (f32 ?v_0 ?v1)) (f14 f22 (f32 ?v_0 ?v2))) (< (f14 f22 ?v1) (f14 f22 ?v2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f17 f18 (+ 0 1)))) (= (= (f32 (f33 f34 ?v0) ?v1) ?v_0) (or (= ?v1 (f17 f18 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f17 f18 (+ 0 1)))) (= (f32 (f33 f34 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f14 f22 (f32 (f33 f34 ?v0) ?v1))) (or (< 0 (f14 f22 ?v0)) (= ?v1 (f17 f18 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f19 ?v0) ?v1) f1)) (forall ((?v2 S2)) (=> (= (f25 ?v2 (f38 (f39 ?v1) ?v0)) f1) (= (f40 f41 ?v2) (f17 f18 2))))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 (+ (f14 f22 ?v1) 1)))) (= (<= (f14 f22 (f32 (f33 f34 ?v0) ?v_0)) (f14 f22 (f32 (f33 f34 ?v2) ?v_0))) (<= (f14 f22 ?v0) (f14 f22 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 (+ (f14 f22 ?v1) 1)))) (= (< (f14 f22 (f32 (f33 f34 ?v0) ?v_0)) (f14 f22 (f32 (f33 f34 ?v2) ?v_0))) (< (f14 f22 ?v0) (f14 f22 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f17 f18 0))) (= (= (f32 (f33 f34 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f17 f18 1))) (= (= (f32 (f33 f34 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 (+ (f14 f22 ?v1) 1)))) (= (= (f32 (f33 f34 ?v0) ?v_0) (f32 (f33 f34 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f7 (f8 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f19 ?v0) ?v1) f1)) (=> (not (= (f3 (f7 (f8 ?v2) 0) ?v0) f1)) (= (f40 f41 (f7 (f42 (f43 ?v1) ?v0) ?v2)) (f17 f18 2)))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f14 f22 (f32 (f33 f34 ?v0) ?v1))) (or (= ?v1 (f17 f18 0)) (< 0 (f14 f22 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f21 ?v0) ?v1) (f11 (f12 f44 (f14 (f15 f16 ?v1) (f17 f18 (- ?v0 2)))) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f12 f44 ?v0) 2))) (= (not (= ?v_0 0)) (= ?v_0 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int) (?v7 Int)) (let ((?v_0 (f11 (f12 f27 ?v0) ?v5))) (=> (= ?v0 (+ (* ?v1 ?v2) (* ?v3 ?v4))) (=> (= ?v5 (+ (* ?v6 ?v2) (* ?v7 ?v4))) (= (f11 (f12 f44 ?v0) ?v5) (+ (* (- ?v1 (* ?v_0 ?v6)) ?v2) (* (- ?v3 (* ?v_0 ?v7)) ?v4))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- ?v0 ?v1) (+ (* ?v2 (- (f11 (f12 f27 ?v0) ?v2) (f11 (f12 f27 ?v1) ?v2))) (- (f11 (f12 f44 ?v0) ?v2) (f11 (f12 f44 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (= (f3 (f7 (f8 ?v1) ?v2) ?v0) f1) (= (f11 (f12 f44 ?v1) ?v0) (f11 (f12 f44 ?v2) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f7 (f8 ?v0) ?v1) ?v2) f1) (= (f3 (f7 (f8 (f11 (f12 f44 ?v0) ?v2)) (f11 (f12 f44 ?v1) ?v2)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 (f12 f44 ?v0) ?v1) (f11 (f12 f44 ?v2) ?v1)) (= (f3 (f7 (f8 ?v0) ?v2) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f7 (f8 ?v0) (f11 (f12 f44 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (f11 (f12 f44 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f3 ?v0 ?v1) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v4) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v4) f1)))))))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f44 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f11 (f12 f44 ?v0) ?v0) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f44 ?v0))) (= (mod ?v0 ?v1) (ite (<= 0 ?v1) (f11 ?v_0 ?v1) (f11 ?v_0 (- ?v1)))))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f44 ?v0) (- 1)) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f44 ?v0) (- ?v1)) (- (f11 (f12 f44 (- ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f44 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (- ?v1)) (ite (= ?v_1 0) 0 (- ?v_1 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f44 ?v0) ?v1))) (= (f11 (f12 f44 (- ?v0)) ?v1) (ite (= ?v_0 0) 0 (- ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f44 (- ?v0)) (- ?v1)) (- (f11 (f12 f44 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f44 (- (f11 (f12 f44 ?v0) ?v1))) ?v1) (f11 (f12 f44 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f12 f44 ?v0) ?v1) 0) (exists ((?v2 Int)) (= ?v0 (* ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f44 ?v0) ?v1))) (= (f11 (f12 f44 ?v_0) ?v1) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f44 (* ?v0 ?v1)) ?v2) (f11 (f12 f44 (* ?v0 (f11 (f12 f44 ?v1) ?v2))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f44 (- ?v0 (f11 (f12 f44 ?v1) ?v2))) ?v2) (f11 (f12 f44 (- ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f44 (* ?v0 (f11 (f12 f44 ?v1) ?v2))) ?v2) (f11 (f12 f44 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f44 (- (f11 (f12 f44 ?v0) ?v1) ?v2)) ?v1) (f11 (f12 f44 (- ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f44 ?v0))) (=> (not (= (f11 ?v_0 (- ?v1)) 0)) (not (= (f11 ?v_0 ?v1) 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= (f11 (f12 f44 (- ?v0)) ?v1) 0)) (not (= (f11 (f12 f44 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= 0 (f11 (f12 f44 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f44 ?v1) ?v0))) (=> (< 0 ?v0) (and (<= 0 ?v_0) (< ?v_0 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (< (f11 (f12 f44 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (<= (f11 (f12 f44 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f11 (f12 f44 (- 1)) ?v0) (- ?v0 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f11 (f12 f44 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (+ 1 (* 2 (f11 (f12 f44 ?v1) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f11 (f12 f44 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (<= 0 (+ (* ?v2 (f11 (f12 f44 ?v3) ?v0)) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (< (+ (* ?v2 (f11 (f12 f44 ?v3) ?v0)) ?v1) (* ?v2 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f11 (f12 f44 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (< (* ?v1 ?v0) (+ (* ?v1 (f11 (f12 f44 ?v3) ?v0)) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (<= (+ (* ?v1 (f11 (f12 f44 ?v3) ?v0)) ?v2) 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ ?v0 ?v1))) (=> (< 0 ?v0) (=> (<= ?v_0 0) (= (f11 (f12 f44 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (< ?v0 (f11 (f12 f44 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (<= (f11 (f12 f44 ?v1) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f11 (f12 f44 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (- (* 2 (f11 (f12 f44 (+ ?v1 1)) ?v0)) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f44 ?v1) ?v0))) (=> (< ?v0 0) (and (<= ?v_0 0) (< ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f11 (f12 f44 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f11 (f12 f44 ?v0) ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (< ?v0 0) (= (= (f3 (f7 ?v1 (f11 (f12 f27 ?v2) ?v0)) (f11 (f12 f44 ?v2) ?v0)) f1) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v0 ?v4) (and (<= ?v4 0) (= ?v2 (+ (* ?v0 ?v3) ?v4)))) (= (f3 (f7 ?v1 ?v3) ?v4) f1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (< 0 ?v0) (= (= (f3 (f7 ?v1 (f11 (f12 f27 ?v2) ?v0)) (f11 (f12 f44 ?v2) ?v0)) f1) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v0) (= ?v2 (+ (* ?v0 ?v3) ?v4)))) (= (f3 (f7 ?v1 ?v3) ?v4) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f44 ?v1))) (=> (< 0 ?v0) (= (f11 ?v_0 (* ?v2 ?v0)) (+ (* ?v2 (f11 (f12 f44 (f11 (f12 f27 ?v1) ?v2)) ?v0)) (f11 ?v_0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- (f11 (f12 f27 ?v1) ?v0)))) (=> (not (= ?v0 0)) (= (f11 (f12 f27 (- ?v1)) ?v0) (ite (= (f11 (f12 f44 ?v1) ?v0) 0) ?v_0 (- ?v_0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f27 ?v1))) (let ((?v_1 (- (f11 ?v_0 ?v0)))) (=> (not (= ?v0 0)) (= (f11 ?v_0 (- ?v0)) (ite (= (f11 (f12 f44 ?v1) ?v0) 0) ?v_1 (- ?v_1 1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ (* (f11 (f12 f27 ?v0) ?v1) ?v1) (f11 (f12 f44 ?v0) ?v1)) ?v2) (+ ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ (* ?v0 (f11 (f12 f27 ?v1) ?v0)) (f11 (f12 f44 ?v1) ?v0)) ?v2) (+ ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f27 (+ ?v0 ?v1)) ?v2) (+ (+ (f11 (f12 f27 ?v0) ?v2) (f11 (f12 f27 ?v1) ?v2)) (f11 (f12 f27 (+ (f11 (f12 f44 ?v0) ?v2) (f11 (f12 f44 ?v1) ?v2))) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f27 (* ?v0 ?v1)) ?v2) (+ (* ?v0 (f11 (f12 f27 ?v1) ?v2)) (f11 (f12 f27 (* ?v0 (f11 (f12 f44 ?v1) ?v2))) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f27 (f11 (f12 f44 ?v0) ?v1)) ?v1) 0)))
(assert (forall ((?v0 Int)) (and (= (f11 (f12 f27 ?v0) 0) 0) (= (f11 (f12 f44 ?v0) 0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 (f11 (f12 f27 ?v1) ?v0)) (- ?v1 (f11 (f12 f44 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f44 ?v0) ?v1) (- ?v0 (* (f11 (f12 f27 ?v0) ?v1) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= ?v0 (+ (* ?v1 (f11 (f12 f27 ?v0) ?v1)) (f11 (f12 f44 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f11 (f12 f44 (f14 (f15 f16 (f11 (f12 f44 ?v0) ?v1)) ?v2)) ?v1) (f11 (f12 f44 (f14 (f15 f16 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 (f12 f44 ?v0) ?v1) 0) (exists ((?v2 Int)) (= ?v0 (* ?v1 ?v2))))))
(assert (forall ((?v0 Int)) (= (f23 (f35 ?v0) (f45 ?v0)) f1)))
(assert (forall ((?v0 S10)) (let ((?v_0 (f14 (f15 f16 (- 1)) (f36 f37 ?v0)))) (=> (= (f46 ?v0) f1) (= (* ?v_0 ?v_0) 1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f14 (f15 f16 (- 1)) (f40 f41 ?v0)))) (=> (= (f47 ?v0) f1) (= (* ?v_0 ?v_0) 1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f11 (f12 f44 (f14 f22 ?v0)) (f14 f22 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f11 (f12 f44 (f14 f22 ?v0)) (f14 f22 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f17 f18 (f11 (f12 f44 ?v0) ?v1)) (f17 f18 (f11 (f12 f44 (f14 f22 (f17 f18 ?v0))) (f14 f22 (f17 f18 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f17 f18 (f11 (f12 f44 (f14 f22 (f17 f18 ?v0))) (f14 f22 (f17 f18 ?v1)))) (f17 f18 (f11 (f12 f44 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f25 ?v2 (f38 (f39 ?v0) ?v1)) f1) (= (f47 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (= (f46 (f38 (f39 ?v1) ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 0 ?v0) (=> (= (f23 (f35 ?v0) ?v1) f1) (= (f47 ?v1) f1)))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (= (f47 (f45 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (f45 ?v0) (f26 (f4 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 (f24 ?v0) (f45 ?v1)) f1) (not (= (f3 (f7 (f8 ?v0) 0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (f47 (f30 ?v0)) f1)))
(assert (forall ((?v0 S7)) (= (f17 f18 (f14 f22 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f22 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f22 (f17 f18 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f11 (f12 f27 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f11 (f12 f44 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
