(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 (S4 Int) S3)
(declare-fun f6 (S5 Int) S4)
(declare-fun f7 () S5)
(declare-fun f8 () Int)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 (S6 S7) Int)
(declare-fun f12 (S8 Int) S6)
(declare-fun f13 () S8)
(declare-fun f14 (S9 Int) S7)
(declare-fun f15 () S9)
(declare-fun f16 (Int) S1)
(declare-fun f17 (S10 Int) Int)
(declare-fun f18 (S11 Int) S10)
(declare-fun f19 () S11)
(declare-fun f20 (S12 Int) S1)
(declare-fun f21 (Int) S12)
(declare-fun f22 (S13 Int) S12)
(declare-fun f23 (Int) S13)
(declare-fun f24 () Int)
(declare-fun f25 (Int) S12)
(declare-fun f26 (Int) S1)
(declare-fun f27 (S14 S3) S1)
(declare-fun f28 () S6)
(declare-fun f29 () S10)
(declare-fun f30 () S11)
(declare-fun f31 () S10)
(declare-fun f32 () S11)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 (f6 f7 f8) 1)) (* (+ (* 4 f9) 1) f10))))
(assert (= (+ (f11 (f12 f13 f8) (f14 f15 2)) 1) (* (+ (* 4 f9) 1) f10)))
(assert (< 0 (+ (* 4 f9) 1)))
(assert (= (+ (f11 (f12 f13 f8) (f14 f15 2)) 1) (* (+ (* 4 f9) 1) f10)))
(assert (let ((?v_0 (f11 (f12 f13 f8) (f14 f15 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f16 (+ (* 4 f9) 1)) f1))
(assert (= (f17 (f18 f19 (- 1)) (+ (* 4 f9) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f11 (f12 f13 f8) (f14 f15 2)) 1) (* (+ (* 4 f9) 1) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f3 f4 (f5 (f6 f7 ?v0) ?v1)) (f3 f4 (f5 (f6 f7 ?v2) ?v3))) (f3 f4 (f5 (f6 f7 (+ (* ?v0 ?v2) (* ?v1 ?v3))) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (= (f20 (f21 (+ (* 4 f9) 1)) (- 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (and (<= 0 f8) (and (< f8 ?v_0) (= (f20 (f22 (f23 f24) f8) ?v_0) f1)))))
(assert (= (f20 (f25 (+ (* 4 f9) 1)) (+ (f11 (f12 f13 f8) (f14 f15 2)) 1)) f1))
(assert (= (f20 (f25 (+ (* 4 f9) 1)) (- (f11 (f12 f13 f8) (f14 f15 2)) (- 1))) f1))
(assert (= (f20 (f22 (f23 (f11 (f12 f13 f8) (f14 f15 2))) (- 1)) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (=> (not (= (f20 (f21 ?v_0) (- 1)) f1)) (not (= (f17 (f18 f19 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (= (= (f26 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f3 f4 (f5 (f6 f7 ?v1) ?v2)) ?v0)))))
(assert (forall ((?v0 S14)) (= (forall ((?v1 S3)) (= (f27 ?v0 ?v1) f1)) (forall ((?v1 Int) (?v2 Int)) (= (f27 ?v0 (f5 (f6 f7 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v2) ?v3)) (=> (=> (= ?v0 ?v2) (=> (= ?v1 ?v3) false)) false))))
(assert (let ((?v_0 (f14 f15 2))) (= (f20 (f22 (f23 (f11 (f12 f13 f8) ?v_0)) (f11 (f12 f13 f24) ?v_0)) (+ (* 4 f9) 1)) f1)))
(assert (= (f20 (f22 (f23 (f11 (f12 f13 f24) (f14 f15 2))) (- 1)) (+ (* 4 f9) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f20 (f22 (f23 (f11 (f12 f13 ?v0) (f14 f15 2))) (- 1)) (+ (* 4 f9) 1)) f1) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 (f22 (f23 f24) ?v0) ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 (f22 (f23 f24) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f20 (f22 (f23 f24) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f16 ?v_0) f1) (= (f17 (f18 f19 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0) f1) (=> (= (f26 ?v1) f1) (= (f26 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f20 (f25 ?v0) ?v1) f1)) (= (f20 (f22 (f23 (f11 (f12 f13 ?v1) (f14 f15 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 (f18 f19 ?v0) ?v1) (ite (= (f20 (f22 (f23 ?v0) 0) ?v1) f1) 0 (ite (= (f20 (f21 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 (f21 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f20 (f22 (f23 (f11 (f12 f13 ?v2) (f14 f15 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int)) (let ((?v_0 (f25 (f11 (f12 f13 ?v0) ?v2)))) (=> (= (f16 ?v0) f1) (=> (not (= (f20 (f25 ?v0) ?v1) f1)) (=> (= (f20 ?v_0 (* ?v1 ?v3)) f1) (= (f20 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int)) (let ((?v_0 (f25 (f11 (f12 f13 ?v0) ?v2)))) (=> (= (f16 ?v0) f1) (=> (not (= (f20 (f25 ?v0) ?v1) f1)) (=> (= (f20 ?v_0 (* ?v3 ?v1)) f1) (= (f20 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (let ((?v_0 (f25 ?v0))) (=> (= (f16 ?v0) f1) (=> (= (f20 ?v_0 (f11 (f12 f13 ?v1) ?v2)) f1) (= (f20 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (let ((?v_0 (f25 ?v0))) (=> (= (f16 ?v0) f1) (=> (= (f20 ?v_0 (f11 (f12 f13 ?v1) ?v2)) f1) (=> (< 0 (f11 f28 ?v2)) (= (f20 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f20 (f22 (f23 ?v0) 0) ?v1) f1)) (=> (= (f20 (f22 (f23 (f11 (f12 f13 ?v2) (f14 f15 2))) ?v0) ?v1) f1) (not (= (f20 (f25 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f16 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f20 (f25 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f25 ?v0))) (=> (= (f16 ?v0) f1) (=> (= (f20 ?v_0 (* ?v1 ?v2)) f1) (or (= (f20 ?v_0 ?v1) f1) (= (f20 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (=> (= (f20 (f22 (f23 ?v3) ?v4) ?v2) f1) (= (f20 (f22 (f23 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (=> (= (f20 (f22 (f23 ?v3) ?v4) ?v2) f1) (= (f20 (f22 (f23 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (=> (= (f20 (f22 (f23 ?v3) ?v4) ?v2) f1) (= (f20 (f22 (f23 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f23 ?v0))) (=> (= (f20 (f22 ?v_0 ?v1) ?v2) f1) (=> (= (f20 (f22 (f23 ?v1) ?v3) ?v2) f1) (= (f20 (f22 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f23 ?v0))) (=> (= (f20 (f22 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f20 (f22 (f23 ?v3) ?v4) ?v2) f1) (= (f20 (f22 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (= (f20 (f22 (f23 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (= (f20 (f22 (f23 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (= (f20 (f22 (f23 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f23 ?v3))) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (= (= (f20 (f22 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f20 (f22 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f23 ?v3))) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (= (= (f20 (f22 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f20 (f22 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f23 ?v1))) (=> (< 2 ?v0) (=> (= (f20 (f22 ?v_0 (- 1)) ?v0) f1) (not (= (f20 (f22 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f20 (f22 (f23 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f20 (f22 (f23 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f20 (f22 (f23 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f20 (f22 (f23 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f20 (f22 (f23 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f20 (f22 (f23 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 (f22 (f23 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 (f22 (f23 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int)) (= (f20 (f22 (f23 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 (f23 ?v0) ?v1))) (= (= (f20 ?v_0 (- ?v2)) f1) (= (f20 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (= (f20 (f22 (f23 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 (f22 (f23 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 (f25 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f11 (f12 f13 ?v0) (f14 f15 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 ?v1)) (?v_1 (f14 f15 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (* ?v1 (f11 ?v_0 (f14 f15 (- (f11 f28 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (= (f11 (f12 f13 ?v0) ?v_0) (f11 (f12 f13 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 2)) (?v_1 (f12 f13 ?v0))) (= (f11 (f12 f13 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f14 f15 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f11 (f12 f13 ?v0) ?v_0) (f11 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f14 f15 2)) (?v_0 (f14 f15 3)) (?v_3 (f12 f13 ?v1)) (?v_1 (f12 f13 ?v0))) (= (f11 (f12 f13 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f14 f15 2)) (?v_0 (f14 f15 3)) (?v_1 (f12 f13 ?v0)) (?v_3 (f12 f13 ?v1))) (= (f11 (f12 f13 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f11 (f12 f13 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f12 f13 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f11 (f12 f13 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f12 f13 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 3))) (= (f11 (f12 f13 (- ?v0)) ?v_0) (- (f11 (f12 f13 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (* ?v0 (f11 ?v_0 (f14 f15 2))) (f11 ?v_0 (f14 f15 3))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f14 f15 3))) (let ((?v_0 (f11 (f12 f13 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f14 f15 2))) (let ((?v_0 (f11 (f12 f13 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f12 f13 ?v0) (f14 f15 2)))))
(assert (= (f16 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (= (f20 (f25 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 (f22 (f23 ?v0) 0) ?v1) f1) (= (f20 (f25 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 (f22 (f23 ?v0) 0) ?v1) f1) (= (f20 (f25 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f20 (f22 (f23 ?v0) ?v1) ?v2) f1) (= (f20 (f22 (f23 (f11 (f12 f13 ?v0) ?v3)) (f11 (f12 f13 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 S7) (?v1 Int) (?v2 Int)) (let ((?v_0 (f25 ?v1))) (=> (< 0 (f11 f28 ?v0)) (=> (= (f20 ?v_0 ?v2) f1) (= (f20 ?v_0 (f11 (f12 f13 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f23 ?v1))) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f20 (f22 (f23 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f20 (f22 ?v_0 1) ?v0) f1) (= (f20 (f22 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f20 (f22 (f23 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f20 (f22 (f23 ?v1) 0) ?v0) f1) (= (f20 (f22 (f23 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f20 (f22 (f23 ?v1) 0) ?v0) f1)) (not (= (f20 (f22 (f23 ?v2) 0) ?v0) f1))) (not (= (f20 (f22 (f23 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f20 (f22 (f23 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f20 (f22 (f23 ?v1) 0) ?v0) f1)) (=> (not (= (f20 (f22 (f23 ?v2) 0) ?v0) f1)) (not (= (f20 (f22 (f23 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f25 ?v1))) (=> (<= 0 ?v0) (=> (= (f16 ?v1) f1) (=> (= (f20 ?v_0 (* ?v0 ?v2)) f1) (or (= (f20 ?v_0 ?v0) f1) (= (f20 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f16 ?v1) f1) (= (f20 (f25 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int)) (=> (= (f20 (f25 (f11 (f12 f13 ?v0) ?v1)) (f11 (f12 f13 ?v2) ?v1)) f1) (=> (not (= ?v1 (f14 f15 0))) (= (f20 (f25 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f14 f15 0))) (= (= (f20 (f25 (f11 (f12 f13 ?v1) ?v0)) (f11 (f12 f13 ?v2) ?v0)) f1) (= (f20 (f25 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f12 f13 (- 1)))) (let ((?v_1 (f11 ?v_0 ?v1)) (?v_2 (f11 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f20 (f22 (f23 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S7)) (let ((?v_0 (f12 f13 ?v0))) (=> (= (f20 (f25 (f11 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f28 ?v3) (f11 f28 ?v1)) (= (f20 (f25 (f11 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 S7)) (=> (= (f20 (f25 ?v0) ?v1) f1) (=> (<= (f11 f28 ?v2) (f11 f28 ?v3)) (= (f20 (f25 (f11 (f12 f13 ?v0) ?v2)) (f11 (f12 f13 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (=> (<= (f11 f28 ?v0) (f11 f28 ?v1)) (= (f20 (f25 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (= (f20 (f25 ?v0) ?v1) f1) (= (f20 (f25 (f11 (f12 f13 ?v0) ?v2)) (f11 (f12 f13 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f17 f29 (f11 (f12 f13 ?v0) ?v1)) (f11 (f12 f13 (f17 f29 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f20 (f22 (f23 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f11 (f12 f13 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f20 (f22 (f23 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f20 (f22 (f23 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f16 ?v0) f1) (= (f20 (f22 (f23 (f17 (f18 f19 ?v1) ?v0)) (f11 (f12 f13 ?v1) (f14 f15 (f17 (f18 f30 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 Int) (?v2 Int)) (=> (= ?v0 (f5 (f6 f7 ?v1) ?v2)) false)) false)))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 Int) (?v2 Int)) (=> (= ?v0 (f5 (f6 f7 ?v1) ?v2)) false)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f17 (f18 f30 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f17 (f18 f30 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f17 (f18 f30 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f16 ?v0) f1) (=> (= (f20 (f22 (f23 ?v1) 0) ?v0) f1) (= (f20 (f22 (f23 0) (f11 (f12 f13 ?v1) (f14 f15 (f17 (f18 f30 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f16 ?v0) f1) (=> (not (= (f20 (f22 (f23 ?v1) 0) ?v0) f1)) (=> (= (f20 (f21 ?v0) ?v1) f1) (= (f20 (f22 (f23 (f11 (f12 f13 ?v1) (f14 f15 (f17 (f18 f30 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f16 ?v0) f1) (=> (not (= (f20 (f22 (f23 ?v1) 0) ?v0) f1)) (=> (not (= (f20 (f21 ?v0) ?v1) f1)) (= (f20 (f22 (f23 (f11 (f12 f13 ?v1) (f14 f15 (f17 (f18 f30 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f16 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f20 (f22 (f23 ?v1) 0) ?v0) f1)) (=> (not (= (f20 (f21 ?v0) ?v1) f1)) (= (f20 (f22 (f23 (f17 f31 ?v_0)) (f11 (f12 f13 ?v1) (f14 f15 (f17 (f18 f30 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (= (f20 (f25 ?v0) ?v1) f1) (= (f11 (f12 f13 (f17 (f18 f30 ?v1) ?v0)) ?v2) (f17 (f18 f30 (f11 (f12 f13 ?v1) ?v2)) (f11 (f12 f13 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f14 f15 (f17 (f18 f30 (f11 f28 (f14 f15 ?v0))) (f11 f28 (f14 f15 ?v1)))) (f14 f15 (f17 (f18 f30 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f17 (f18 f30 ?v0) ?v1)) (f14 f15 (f17 (f18 f30 (f11 f28 (f14 f15 ?v0))) (f11 f28 (f14 f15 ?v1))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f17 (f18 f30 (f11 f28 ?v0)) (f11 f28 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f17 (f18 f30 (f11 f28 ?v0)) (f11 f28 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S12) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 (f17 (f18 f30 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f20 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f20 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f20 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int)) (= (f17 (f18 f30 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f17 (f18 f30 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 (f18 f30 ?v0) (- ?v1)) (f17 (f18 f30 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 (f18 f30 (- ?v0)) (- ?v1)) (f17 (f18 f30 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 (f18 f30 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 S7)) (= (f14 f15 (f11 f28 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f28 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f28 (f14 f15 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f17 (f18 f30 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f17 (f18 f32 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
