(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 (S4 Int) S3)
(declare-fun f6 (S5 Int) S4)
(declare-fun f7 () S5)
(declare-fun f8 () Int)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 (S6 S7) Int)
(declare-fun f12 (S8 Int) S6)
(declare-fun f13 () S8)
(declare-fun f14 (S9 Int) S7)
(declare-fun f15 () S9)
(declare-fun f16 (Int) S1)
(declare-fun f17 (S10 Int) Int)
(declare-fun f18 (S11 Int) S10)
(declare-fun f19 () S11)
(declare-fun f20 (Int Int) S1)
(declare-fun f21 (Int Int Int) S1)
(declare-fun f22 () Int)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 (Int) S1)
(declare-fun f25 (S12 S3) S1)
(declare-fun f26 () S6)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 (f6 f7 f8) 1)) (* (+ (* 4 f9) 1) f10))))
(assert (= (+ (f11 (f12 f13 f8) (f14 f15 2)) 1) (* (+ (* 4 f9) 1) f10)))
(assert (< 0 (+ (* 4 f9) 1)))
(assert (= (+ (f11 (f12 f13 f8) (f14 f15 2)) 1) (* (+ (* 4 f9) 1) f10)))
(assert (let ((?v_0 (f11 (f12 f13 f8) (f14 f15 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f16 (+ (* 4 f9) 1)) f1))
(assert (= (f17 (f18 f19 (- 1)) (+ (* 4 f9) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f11 (f12 f13 f8) (f14 f15 2)) 1) (* (+ (* 4 f9) 1) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f3 f4 (f5 (f6 f7 ?v0) ?v1)) (f3 f4 (f5 (f6 f7 ?v2) ?v3))) (f3 f4 (f5 (f6 f7 (+ (* ?v0 ?v2) (* ?v1 ?v3))) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (= (f20 (+ (* 4 f9) 1) (- 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (and (<= 0 f8) (and (< f8 ?v_0) (= (f21 f22 f8 ?v_0) f1)))))
(assert (= (f23 (+ (* 4 f9) 1) (+ (f11 (f12 f13 f8) (f14 f15 2)) 1)) f1))
(assert (= (f23 (+ (* 4 f9) 1) (- (f11 (f12 f13 f8) (f14 f15 2)) (- 1))) f1))
(assert (= (f21 (f11 (f12 f13 f8) (f14 f15 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (=> (not (= (f20 ?v_0 (- 1)) f1)) (not (= (f17 (f18 f19 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (= (= (f24 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f3 f4 (f5 (f6 f7 ?v1) ?v2)) ?v0)))))
(assert (forall ((?v0 S12)) (= (forall ((?v1 S3)) (= (f25 ?v0 ?v1) f1)) (forall ((?v1 Int) (?v2 Int)) (= (f25 ?v0 (f5 (f6 f7 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v2) ?v3)) (=> (=> (= ?v0 ?v2) (=> (= ?v1 ?v3) false)) false))))
(assert (let ((?v_0 (f14 f15 2))) (= (f21 (f11 (f12 f13 f8) ?v_0) (f11 (f12 f13 f22) ?v_0) (+ (* 4 f9) 1)) f1)))
(assert (= (f21 (f11 (f12 f13 f22) (f14 f15 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f21 (f11 (f12 f13 ?v0) (f14 f15 2)) (- 1) (+ (* 4 f9) 1)) f1) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f22 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f22 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f21 f22 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f16 ?v_0) f1) (= (f17 (f18 f19 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (= (f24 ?v1) f1) (= (f24 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (= (f21 (f11 (f12 f13 ?v1) (f14 f15 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 (f18 f19 ?v0) ?v1) (ite (= (f21 ?v0 0 ?v1) f1) 0 (ite (= (f20 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f21 (f11 (f12 f13 ?v2) (f14 f15 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (=> (= (f23 ?v_0 (* ?v1 ?v3)) f1) (= (f23 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (=> (= (f23 ?v_0 (* ?v3 ?v1)) f1) (= (f23 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (= (f16 ?v0) f1) (=> (= (f23 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1) (= (f23 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (= (f16 ?v0) f1) (=> (= (f23 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1) (=> (< 0 (f11 f26 ?v2)) (= (f23 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f21 ?v0 0 ?v1) f1)) (=> (= (f21 (f11 (f12 f13 ?v2) (f14 f15 2)) ?v0 ?v1) f1) (not (= (f23 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S7)) (= (f14 f15 (f11 f26 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f26 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f26 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
