(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 () Int)
(declare-fun f5 (Int) S1)
(declare-fun f6 (S2 Int) Int)
(declare-fun f7 (S3 Int) S2)
(declare-fun f8 () S3)
(declare-fun f9 (Int) S1)
(declare-fun f10 (Int Int) S1)
(declare-fun f11 (S4 S5) Int)
(declare-fun f12 (S6 Int) S4)
(declare-fun f13 () S6)
(declare-fun f14 () Int)
(declare-fun f15 (S7 Int) S5)
(declare-fun f16 () S7)
(declare-fun f17 (S8 S9) Int)
(declare-fun f18 () S8)
(declare-fun f19 (Int Int) S9)
(declare-fun f20 (Int Int Int) S1)
(declare-fun f21 () Int)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 () S4)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ (* 4 f3) 1))) (not (< (* ?v_0 (- ?v_0 1)) (* ?v_0 f4)))))
(assert (< 0 (+ (* 4 f3) 1)))
(assert (< (- (+ (* 4 f3) 1) 1) f4))
(assert (< 0 (+ (* 4 f3) 1)))
(assert (< (- (+ (* 4 f3) 1) 1) f4))
(assert (not (< f4 (+ (* 4 f3) 1))))
(assert (= (f5 (+ (* 4 f3) 1)) f1))
(assert (= (f6 (f7 f8 (- 1)) (+ (* 4 f3) 1)) 1))
(assert (= (f9 (* (+ (* 4 f3) 1) f4)) f1))
(assert (= (f10 (+ (* 4 f3) 1) (- 1)) f1))
(assert (= (+ (f11 (f12 f13 f14) (f15 f16 2)) 1) (* (+ (* 4 f3) 1) f4)))
(assert (let ((?v_0 (+ (* 4 f3) 1))) (=> (not (= (f10 ?v_0 (- 1)) f1)) (not (= (f6 (f7 f8 (- 1)) ?v_0) 1)))))
(assert (= (f17 f18 (f19 f14 1)) (* (+ (* 4 f3) 1) f4)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f3) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f20 f21 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f3) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) false))) false))
(assert (let ((?v_0 (+ (* 4 f3) 1))) (and (<= 0 f14) (and (< f14 ?v_0) (= (f20 f21 f14 ?v_0) f1)))))
(assert (= (f20 (f11 (f12 f13 f21) (f15 f16 2)) (- 1) (+ (* 4 f3) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f11 (f12 f13 f14) (f15 f16 2)) 1) (* (+ (* 4 f3) 1) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int)) (=> (= (f20 (f11 (f12 f13 ?v0) (f15 f16 2)) (- 1) (+ (* 4 f3) 1)) f1) false)) false))
(assert (= (f22 (+ (* 4 f3) 1) (+ (f11 (f12 f13 f14) (f15 f16 2)) 1)) f1))
(assert (= (f22 (+ (* 4 f3) 1) (- (f11 (f12 f13 f14) (f15 f16 2)) (- 1))) f1))
(assert (let ((?v_0 (f11 (f12 f13 f14) (f15 f16 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f20 (f11 (f12 f13 f14) (f15 f16 2)) (- 1) (+ (* 4 f3) 1)) f1))
(assert (let ((?v_0 (f15 f16 2))) (= (f20 (f11 (f12 f13 f14) ?v_0) (f11 (f12 f13 f21) ?v_0) (+ (* 4 f3) 1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f17 f18 (f19 ?v0 ?v1)) (f17 f18 (f19 ?v2 ?v3))) (f17 f18 (f19 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f5 ?v_0) f1) (= (f6 (f7 f8 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (= (f9 ?v1) f1) (= (f9 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f9 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f17 f18 (f19 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (= (f20 (f11 (f12 f13 ?v1) (f15 f16 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (ite (= (f20 ?v0 0 ?v1) f1) 0 (ite (= (f10 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f20 (f11 (f12 f13 ?v2) (f15 f16 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v2))) (=> (= (f5 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v1 ?v3)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v2))) (=> (= (f5 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v3 ?v1)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f5 ?v0) f1) (=> (= (f22 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f5 ?v0) f1) (=> (= (f22 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1) (=> (< 0 (f11 f23 ?v2)) (= (f22 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S5)) (= (f15 f16 (f11 f23 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f23 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f23 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
