(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 () Int)
(declare-fun f5 (Int) S1)
(declare-fun f6 (S2 S3) Int)
(declare-fun f7 (S4 Int) S2)
(declare-fun f8 () S4)
(declare-fun f9 () Int)
(declare-fun f10 (S5 Int) S3)
(declare-fun f11 () S5)
(declare-fun f12 (S6 S7) Int)
(declare-fun f13 () S6)
(declare-fun f14 (Int Int) S7)
(declare-fun f15 (Int) S1)
(declare-fun f16 (S8 Int) Int)
(declare-fun f17 (S9 Int) S8)
(declare-fun f18 () S9)
(declare-fun f19 (Int Int) S1)
(declare-fun f20 (Int Int) S1)
(declare-fun f21 (Int Int Int) S1)
(declare-fun f22 () Int)
(declare-fun f23 () S2)
(assert (not (= f1 f2)))
(assert (not (<= 1 f3)))
(assert (< f3 (+ (* 4 f4) 1)))
(assert (= (f5 (* (+ (* 4 f4) 1) f3)) f1))
(assert (= (+ (f6 (f7 f8 f9) (f10 f11 2)) 1) (* (+ (* 4 f4) 1) f3)))
(assert (= (f12 f13 (f14 f9 1)) (* (+ (* 4 f4) 1) f3)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 ?v0) f1) (=> (= (f5 ?v1) f1) (= (f5 (* ?v0 ?v1)) f1)))))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (let ((?v_0 (f6 (f7 f8 f9) (f10 f11 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f15 (+ (* 4 f4) 1)) f1))
(assert (= (f16 (f17 f18 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f7 f8 f9) (f10 f11 2)) 1) (* (+ (* 4 f4) 1) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f12 f13 (f14 ?v0 ?v1)) (f12 f13 (f14 ?v2 ?v3))) (f12 f13 (f14 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (= (f19 (+ (* 4 f4) 1) (- 1)) f1))
(assert (forall ((?v0 Int)) (= (= (f5 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f12 f13 (f14 ?v1 ?v2)) ?v0)))))
(assert (= (f20 (+ (* 4 f4) 1) (+ (f6 (f7 f8 f9) (f10 f11 2)) 1)) f1))
(assert (= (f20 (+ (* 4 f4) 1) (- (f6 (f7 f8 f9) (f10 f11 2)) (- 1))) f1))
(assert (= (f21 (f6 (f7 f8 f9) (f10 f11 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f9) (and (< f9 ?v_0) (= (f21 f22 f9 ?v_0) f1)))))
(assert (= (f21 (f6 (f7 f8 f22) (f10 f11 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (f10 f11 2))) (= (f21 (f6 (f7 f8 f9) ?v_0) (f6 (f7 f8 f22) ?v_0) (+ (* 4 f4) 1)) f1)))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f19 ?v_0 (- 1)) f1)) (not (= (f16 (f17 f18 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f21 (f6 (f7 f8 ?v0) (f10 f11 2)) (- 1) (+ (* 4 f4) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f6 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f22 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f22 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f21 f22 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 (* ?v0 ?v1) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f20 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0 (- ?v1 ?v2)) f1) (=> (= (f20 ?v0 ?v2) f1) (= (f20 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1) f1) (= (= (f20 ?v0 (+ ?v2 ?v3)) f1) (= (f20 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f20 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f15 ?v_0) f1) (= (f16 (f17 f18 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 S3)) (= (f10 f11 (f6 f23 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f23 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f23 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
