(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S2) Int)
(declare-fun f7 () S4)
(declare-fun f8 () Int)
(declare-fun f9 () Int)
(declare-fun f10 (Int) S1)
(declare-fun f11 (S5 Int) S4)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 (S6 S7) Int)
(declare-fun f15 () S6)
(declare-fun f16 (Int Int) S7)
(declare-fun f17 (Int) S1)
(declare-fun f18 (S8 Int) Int)
(declare-fun f19 (S9 Int) S8)
(declare-fun f20 () S9)
(declare-fun f21 (Int Int) S1)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 (Int Int Int) S1)
(declare-fun f24 () Int)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 S2)) (=> (= ?v0 (f4 f5 (- (f6 f7 (f4 f5 f8)) 1))) (=> (< 0 (f6 f7 ?v0)) (= f3 f1)))))
(assert (< 1 f8))
(assert (< 1 f8))
(assert (<= 1 f8))
(assert (< f8 (+ (* 4 f9) 1)))
(assert (= (f10 (* (+ (* 4 f9) 1) f8)) f1))
(assert (= (+ (f6 (f11 f12 f13) (f4 f5 2)) 1) (* (+ (* 4 f9) 1) f8)))
(assert (=> (= f8 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 2))) (= (+ (f6 (f11 f12 ?v0) ?v_0) (f6 (f11 f12 ?v1) ?v_0)) (+ (* 4 f9) 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (= (f10 ?v1) f1) (= (f10 (* ?v0 ?v1)) f1)))))
(assert (= (f14 f15 (f16 f13 1)) (* (+ (* 4 f9) 1) f8)))
(assert (< 0 (+ (* 4 f9) 1)))
(assert (let ((?v_0 (f6 (f11 f12 f13) (f4 f5 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f17 (+ (* 4 f9) 1)) f1))
(assert (= (f18 (f19 f20 (- 1)) (+ (* 4 f9) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f11 f12 f13) (f4 f5 2)) 1) (* (+ (* 4 f9) 1) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f14 f15 (f16 ?v0 ?v1)) (f14 f15 (f16 ?v2 ?v3))) (f14 f15 (f16 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (= (f21 (+ (* 4 f9) 1) (- 1)) f1))
(assert (forall ((?v0 Int)) (= (= (f10 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f14 f15 (f16 ?v1 ?v2)) ?v0)))))
(assert (= (f22 (+ (* 4 f9) 1) (+ (f6 (f11 f12 f13) (f4 f5 2)) 1)) f1))
(assert (= (f22 (+ (* 4 f9) 1) (- (f6 (f11 f12 f13) (f4 f5 2)) (- 1))) f1))
(assert (= (f23 (f6 (f11 f12 f13) (f4 f5 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (and (<= 0 f13) (and (< f13 ?v_0) (= (f23 f24 f13 ?v_0) f1)))))
(assert (= (f23 (f6 (f11 f12 f24) (f4 f5 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (f4 f5 2))) (= (f23 (f6 (f11 f12 f13) ?v_0) (f6 (f11 f12 f24) ?v_0) (+ (* 4 f9) 1)) f1)))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (=> (not (= (f21 ?v_0 (- 1)) f1)) (not (= (f18 (f19 f20 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f23 (f6 (f11 f12 ?v0) (f4 f5 2)) (- 1) (+ (* 4 f9) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f6 (f11 f12 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f24 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f24 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f23 f24 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f22 (* ?v0 ?v1) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f22 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f22 ?v0 (- ?v1 ?v2)) f1) (=> (= (f22 ?v0 ?v2) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1) f1) (= (= (f22 ?v0 (+ ?v2 ?v3)) f1) (= (f22 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f22 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f17 ?v_0) f1) (= (f18 (f19 f20 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f22 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f22 (* ?v0 ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f22 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (= (= (f22 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 ?v_0 (f4 f5 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (* (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f6 (f11 f12 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f4 f5 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (= (f23 (f6 (f11 f12 ?v1) (f4 f5 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f19 f20 ?v0) ?v1) (ite (= (f23 ?v0 0 ?v1) f1) 0 (ite (= (f21 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f23 (f6 (f11 f12 ?v2) (f4 f5 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f6 (f11 f12 ?v0) ?v2))) (=> (= (f17 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v1 ?v3)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f6 (f11 f12 ?v0) ?v2))) (=> (= (f17 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v3 ?v1)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f17 ?v0) f1) (=> (= (f22 ?v0 (f6 (f11 f12 ?v1) ?v2)) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f17 ?v0) f1) (=> (= (f22 ?v0 (f6 (f11 f12 ?v1) ?v2)) f1) (=> (< 0 (f6 f7 ?v2)) (= (f22 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f23 ?v0 0 ?v1) f1)) (=> (= (f23 (f6 (f11 f12 ?v2) (f4 f5 2)) ?v0 ?v1) f1) (not (= (f22 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f17 ?v1) f1) (=> (= (f22 ?v1 (* ?v0 ?v2)) f1) (or (= (f22 ?v1 ?v0) f1) (= (f22 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (= (f22 ?v0 (* ?v1 ?v2)) f1) (or (= (f22 ?v0 ?v1) f1) (= (f22 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 ?v1 ?v2) f1) (= (f23 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 ?v1 (- ?v2)) f1) (= (f23 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f23 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f23 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f23 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f23 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f23 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f23 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f23 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 S2)) (= (f4 f5 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f4 f5 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f7 (f4 f5 ?v0)) 0))))
(check-sat)
(exit)
