(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 () Int)
(declare-fun f5 () Int)
(declare-fun f6 (Int) S1)
(declare-fun f7 (S2 Int) Int)
(declare-fun f8 (S3 Int) S2)
(declare-fun f9 () S3)
(declare-fun f10 (Int Int) S1)
(declare-fun f11 () S4)
(declare-fun f12 (S5 Int) S4)
(declare-fun f13 () S5)
(declare-fun f14 (S6 S4) Int)
(declare-fun f15 () S6)
(declare-fun f16 (Int Int Int) S1)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 (S7 Int) S6)
(declare-fun f20 () S7)
(declare-fun f21 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 0))) f1)))
(assert (< 1 f5))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (= (f6 (+ (* 4 f4) 1)) f1))
(assert (= (f7 (f8 f9 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (* ?v0 ?v1)) f1)))))
(assert (= (f10 (+ (* 4 f4) 1) (- 1)) f1))
(assert (= f11 (f12 f13 (- (f14 f15 (f12 f13 f5)) 1))))
(assert (= (f3 (* (+ (* 4 f4) 1) f5)) f1))
(assert (< f5 (+ (* 4 f4) 1)))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f10 ?v_0 (- 1)) f1)) (not (= (f7 (f8 f9 (- 1)) ?v_0) 1)))))
(assert (<= 1 f5))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f16 f17 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f16 f17 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f16 f17 ?v0 ?v_0) f1))) false))) false))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f18) (and (< f18 ?v_0) (= (f16 f17 f18 ?v_0) f1)))))
(assert (= (+ (f14 (f19 f20 f18) (f12 f13 2)) 1) (* (+ (* 4 f4) 1) f5)))
(assert (= (f16 (f14 (f19 f20 f17) (f12 f13 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f14 (f19 f20 f18) (f12 f13 2)) 1) (* (+ (* 4 f4) 1) ?v0)) false)) false))
(assert (< 0 (f14 f15 f11)))
(assert (let ((?v_0 (f14 (f19 f20 f18) (f12 f13 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S4)) (=> (= ?v0 (f12 f13 (- (f14 f15 (f12 f13 f5)) 1))) (=> (< 0 (f14 f15 ?v0)) false))) false))
(assert (= (f16 (f14 (f19 f20 f18) (f12 f13 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f16 (f14 (f19 f20 ?v0) (f12 f13 2)) (- 1) (+ (* 4 f4) 1)) f1) false)) false))
(assert (let ((?v_0 (f12 f13 2))) (= (f16 (f14 (f19 f20 f18) ?v_0) (f14 (f19 f20 f17) ?v_0) (+ (* 4 f4) 1)) f1)))
(assert (=> (= f5 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (+ (f14 (f19 f20 ?v0) ?v_0) (f14 (f19 f20 ?v1) ?v_0)) (+ (* 4 f4) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f6 ?v_0) f1) (= (f7 (f8 f9 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f9 ?v0) ?v1) (ite (= (f16 ?v0 0 ?v1) f1) 0 (ite (= (f10 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f16 (f14 (f19 f20 ?v2) (f12 f13 2)) ?v1 ?v0) f1)))))
(assert (= (f21 (+ (* 4 f4) 1) (- (f14 (f19 f20 f18) (f12 f13 2)) (- 1))) f1))
(assert (= (f21 (+ (* 4 f4) 1) (+ (f14 (f19 f20 f18) (f12 f13 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0) f1) (=> (not (= (f16 ?v1 0 ?v0) f1)) (=> (not (= (f16 ?v2 0 ?v0) f1)) (not (= (f16 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f16 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f16 ?v1 0 ?v0) f1)) (not (= (f16 ?v2 0 ?v0) f1))) (not (= (f16 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0) f1) (=> (< 0 ?v1) (=> (= (f16 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f16 ?v1 0 ?v0) f1) (= (f16 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 ?v0) f1) (=> (< 0 ?v1) (=> (= (f16 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f16 ?v1 1 ?v0) f1) (= (f16 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f20 (- 1)))) (let ((?v_1 (f14 ?v_0 ?v1)) (?v_2 (f14 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f16 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f16 ?v0 ?v1 ?v2) f1) (= (f21 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 ?v0 0 ?v1) f1) (= (f21 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 ?v0 0 ?v1) f1) (= (f21 ?v1 ?v0) f1))))
(assert (forall ((?v0 S4) (?v1 Int) (?v2 Int)) (=> (< 0 (f14 f15 ?v0)) (=> (= (f21 ?v1 ?v2) f1) (= (f21 ?v1 (f14 (f19 f20 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f6 ?v1) f1) (=> (= (f21 ?v1 (* ?v0 ?v2)) f1) (or (= (f21 ?v1 ?v0) f1) (= (f21 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0) f1) (=> (= (f21 ?v0 (* ?v1 ?v2)) f1) (or (= (f21 ?v0 ?v1) f1) (= (f21 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f6 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f21 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (=> (= (f6 ?v0) f1) (=> (= (f21 ?v0 (f14 (f19 f20 ?v1) ?v2)) f1) (=> (< 0 (f14 f15 ?v2)) (= (f21 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (=> (= (f16 ?v3 ?v4 ?v2) f1) (= (f16 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (=> (= (f16 ?v3 ?v4 ?v2) f1) (= (f16 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (=> (= (f16 ?v3 ?v4 ?v2) f1) (= (f16 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (=> (= (f16 ?v1 ?v3 ?v2) f1) (= (f16 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f16 ?v3 ?v4 ?v2) f1) (= (f16 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (= (f16 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (= (f16 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (= (f16 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (= (= (f16 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f16 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 ?v0 ?v1 ?v2) f1) (= (= (f16 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f16 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f16 ?v1 (- 1) ?v0) f1) (not (= (f16 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f16 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f16 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f16 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f16 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f16 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f16 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f16 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 S4)) (= (f12 f13 (f14 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f15 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
