(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () S2)
(declare-fun f11 () S3)
(declare-fun f12 (Int) S1)
(declare-fun f13 () Int)
(declare-fun f14 (Int) S1)
(declare-fun f15 (S6 Int) Int)
(declare-fun f16 (S7 Int) S6)
(declare-fun f17 () S7)
(declare-fun f18 (Int Int) S1)
(declare-fun f19 () S3)
(declare-fun f20 () Int)
(declare-fun f21 (Int Int Int) S1)
(declare-fun f22 () Int)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (* (+ (* 4 f9) 1) (+ 1 (f4 f10 f11)))) (= f3 f1)))))
(assert (< 0 (f4 f10 f11)))
(assert (let ((?v_0 (+ (* 4 f9) 1)) (?v_1 (+ 1 (f4 f10 f11)))) (and (< ?v_1 ?v_0) (= (f12 (* ?v_0 ?v_1)) f1))))
(assert (< 1 f13))
(assert (< 0 (f4 f10 f11)))
(assert (not (= (f12 (* (+ (* 4 f9) 1) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f9) 1)) (?v_1 (+ 1 (f4 f10 f11)))) (and (< ?v_1 ?v_0) (= (f12 (* ?v_0 ?v_1)) f1))))
(assert (< 0 (+ (* 4 f9) 1)))
(assert (let ((?v_0 (+ (* 4 f9) 1)) (?v_1 (+ 1 (f4 f10 f11)))) (not (=> (< ?v_1 ?v_0) (not (= (f12 (* ?v_0 ?v_1)) f1))))))
(assert (= (f14 (+ (* 4 f9) 1)) f1))
(assert (= (f15 (f16 f17 (- 1)) (+ (* 4 f9) 1)) 1))
(assert (= (f18 (+ (* 4 f9) 1) (- 1)) f1))
(assert (= f19 (f7 f8 (- (f4 f10 (f7 f8 f13)) 1))))
(assert (< f13 (+ (* 4 f9) 1)))
(assert (= (f12 (* (+ (* 4 f9) 1) f13)) f1))
(assert (= (+ (f4 (f5 f6 f20) (f7 f8 2)) 1) (* (+ (* 4 f9) 1) f13)))
(assert (= (f21 (f4 (f5 f6 f22) (f7 f8 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f4 (f5 f6 f20) (f7 f8 2)) 1) (* (+ (* 4 f9) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f4 (f5 f6 f20) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (=> (not (= (f18 ?v_0 (- 1)) f1)) (not (= (f15 (f16 f17 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f21 (f4 (f5 f6 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f9) 1)) f1) false)) false))
(assert (=> (= f13 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (+ (* 4 f9) 1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (< 0 (f4 f10 f19)))
(assert (<= 1 f13))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (and (<= 0 f20) (and (< f20 ?v_0) (= (f21 f22 f20 ?v_0) f1)))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f4 f10 (f7 f8 f13)) 1))) (=> (< 0 (f4 f10 ?v0)) false))) false))
(assert (= (f21 (f4 (f5 f6 f20) (f7 f8 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (f7 f8 2))) (= (f21 (f4 (f5 f6 f20) ?v_0) (f4 (f5 f6 f22) ?v_0) (+ (* 4 f9) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f22 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f22 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f21 f22 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f14 ?v_0) f1) (= (f15 (f16 f17 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 ?v0) f1) (=> (= (f12 ?v1) f1) (= (f12 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f7 f8 (+ (f4 f10 ?v1) (f4 f10 ?v2)))) (* (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f4 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f10 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f10 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
