(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 S3) Int)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 () Int)
(declare-fun f9 () S3)
(declare-fun f10 (S4 Int) S3)
(declare-fun f11 () S4)
(declare-fun f12 (S5 Int) S2)
(declare-fun f13 () S5)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 (Int) S1)
(declare-fun f17 (Int) S1)
(declare-fun f18 (S6 Int) Int)
(declare-fun f19 (S7 Int) S6)
(declare-fun f20 () S7)
(declare-fun f21 () Int)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 (Int Int Int) S1)
(declare-fun f24 () Int)
(declare-fun f25 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f5 f6 f7)))) (=> (and (= ?v0 (- f4 (* ?v1 ?v_0))) (<= (* 2 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_0)) (= f3 f1)))))
(assert (< 0 (+ 1 (f5 f6 f7))))
(assert (< 1 f8))
(assert (< 0 (+ 1 (f5 f6 f7))))
(assert (< 0 (f5 f6 f7)))
(assert (= f9 (f10 f11 (- (f5 f6 (f10 f11 f8)) 1))))
(assert (let ((?v_0 (f10 f11 2))) (= (+ (f5 (f12 f13 f4) ?v_0) (f5 (f12 f13 f14) ?v_0)) (* (+ (* 4 f15) 1) (+ 1 (f5 f6 f7))))))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f15) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f16 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f15) 1))) (and (< ?v_1 ?v_0) (= (f16 (* ?v_0 ?v_1)) f1))))
(assert (<= 1 f8))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (=> (= (+ (f5 (f12 f13 ?v0) ?v_0) (f5 (f12 f13 ?v1) ?v_0)) (* (+ (* 4 f15) 1) (+ 1 (f5 f6 f7)))) false))) false))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f10 f11 (- (f5 f6 (f10 f11 f8)) 1))) (=> (< 0 (f5 f6 ?v0)) false))) false))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (= (f16 ?v1) f1) (= (f16 (* ?v0 ?v1)) f1)))))
(assert (not (= (f16 (* (+ (* 4 f15) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f15) 1)))
(assert (< 0 (f5 f6 f9)))
(assert (< f8 (+ (* 4 f15) 1)))
(assert (= (f16 (* (+ (* 4 f15) 1) f8)) f1))
(assert (= (f17 (+ (* 4 f15) 1)) f1))
(assert (= (f18 (f19 f20 (- 1)) (+ (* 4 f15) 1)) 1))
(assert (= (+ (f5 (f12 f13 f21) (f10 f11 2)) 1) (* (+ (* 4 f15) 1) f8)))
(assert (=> (= f8 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (+ (f5 (f12 f13 ?v0) ?v_0) (f5 (f12 f13 ?v1) ?v_0)) (+ (* 4 f15) 1))))))
(assert (= (f22 (+ (* 4 f15) 1) (- 1)) f1))
(assert (= (f23 (f5 (f12 f13 f24) (f10 f11 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f5 (f12 f13 f21) (f10 f11 2)) 1) (* (+ (* 4 f15) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f5 (f12 f13 f21) (f10 f11 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (=> (not (= (f22 ?v_0 (- 1)) f1)) (not (= (f18 (f19 f20 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f23 (f5 (f12 f13 ?v0) (f10 f11 2)) (- 1) (+ (* 4 f15) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f5 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f5 (f12 f13 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 2))) (let ((?v_0 (f5 (f12 f13 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 3))) (let ((?v_0 (f5 (f12 f13 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f5 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f10 f11 0))))))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (and (<= 0 f21) (and (< f21 ?v_0) (= (f23 f24 f21 ?v_0) f1)))))
(assert (= (f23 (f5 (f12 f13 f21) (f10 f11 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (let ((?v_0 (f10 f11 2))) (= (f23 (f5 (f12 f13 f21) ?v_0) (f5 (f12 f13 f24) ?v_0) (+ (* 4 f15) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f24 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f24 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f23 f24 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f17 ?v_0) f1) (= (f18 (f19 f20 (- 1)) ?v_0) 1)))))
(assert (= (f17 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f5 (f12 f13 ?v0) (f10 f11 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (= (f5 (f12 f13 ?v0) ?v_0) (f5 (f12 f13 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2)) (?v_1 (f12 f13 ?v0))) (= (f5 (f12 f13 (f5 ?v_1 ?v_0)) ?v_0) (f5 ?v_1 (f10 f11 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f5 (f12 f13 ?v0) ?v_0) (f5 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_3 (f12 f13 ?v1)) (?v_1 (f12 f13 ?v0))) (= (f5 (f12 f13 (- ?v0 ?v1)) ?v_0) (- (+ (- (f5 ?v_1 ?v_0) (* (* 3 (f5 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f5 ?v_3 ?v_2))) (f5 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_1 (f12 f13 ?v0)) (?v_3 (f12 f13 ?v1))) (= (f5 (f12 f13 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f5 ?v_1 ?v_0) (* (* 3 (f5 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f5 ?v_3 ?v_2))) (f5 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f5 (f12 f13 (- ?v0 ?v1)) ?v_0) (+ (- (f5 (f12 f13 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f5 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f5 (f12 f13 (+ ?v0 ?v1)) ?v_0) (+ (+ (f5 (f12 f13 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f5 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 3))) (= (f5 (f12 f13 (- ?v0)) ?v_0) (- (f5 (f12 f13 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (* ?v0 (f5 ?v_0 (f10 f11 2))) (f5 ?v_0 (f10 f11 3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 ?v0))) (= (f5 ?v_0 (f10 f11 (+ (f5 f6 ?v1) (f5 f6 ?v2)))) (* (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f19 f20 ?v0) ?v1) (ite (= (f23 ?v0 0 ?v1) f1) 0 (ite (= (f22 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f23 (f5 (f12 f13 ?v2) (f10 f11 2)) ?v1 ?v0) f1)))))
(assert (= (f25 (+ (* 4 f15) 1) (- (f5 (f12 f13 f21) (f10 f11 2)) (- 1))) f1))
(assert (= (f25 (+ (* 4 f15) 1) (+ (f5 (f12 f13 f21) (f10 f11 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (= (f23 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f23 ?v1 1 ?v0) f1) (= (f23 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (= (f23 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f23 ?v1 0 ?v0) f1) (= (f23 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f23 ?v1 0 ?v0) f1)) (not (= (f23 ?v2 0 ?v0) f1))) (not (= (f23 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f23 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (not (= (f23 ?v1 0 ?v0) f1)) (=> (not (= (f23 ?v2 0 ?v0) f1)) (not (= (f23 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f25 (* ?v0 ?v1) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f25 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f25 ?v0 (- ?v1 ?v2)) f1) (=> (= (f25 ?v0 ?v2) f1) (= (f25 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f25 ?v0 ?v1) f1) (=> (= (f25 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f25 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1) f1) (= (= (f25 ?v0 (+ ?v2 ?v3)) f1) (= (f25 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 S3)) (= (f10 f11 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
