(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 S3) Int)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 () Int)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () S3)
(declare-fun f13 (S4 Int) S3)
(declare-fun f14 () S4)
(declare-fun f15 () Int)
(declare-fun f16 (Int) S1)
(declare-fun f17 (S5 Int) S2)
(declare-fun f18 () S5)
(declare-fun f19 (Int) S1)
(declare-fun f20 (S6 Int) Int)
(declare-fun f21 (S7 Int) S6)
(declare-fun f22 () S7)
(declare-fun f23 () Int)
(declare-fun f24 (Int Int) S1)
(declare-fun f25 (Int Int Int) S1)
(declare-fun f26 () Int)
(declare-fun f27 (Int Int) S1)
(declare-fun f28 (S8 S9) Int)
(declare-fun f29 () S8)
(declare-fun f30 (Int Int) S9)
(declare-fun f31 (S3 S3) S1)
(declare-fun f32 (S10 S3) S3)
(declare-fun f33 (S11 S3) S10)
(declare-fun f34 () S11)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f5 f6 f7)))) (=> (and (= ?v0 (- f4 (* ?v1 ?v_0))) (<= (* 2 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_0)) (= f3 f1)))))
(assert (< 0 (+ 1 (f5 f6 f7))))
(assert (< 1 f8))
(assert (< 0 (+ 1 (f5 f6 f7))))
(assert (< 0 (f5 f6 f7)))
(assert (let ((?v_0 (+ 1 (f5 f6 f7)))) (and (= f9 (- f10 (* f11 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (= f12 (f13 f14 (- (f5 f6 (f13 f14 f8)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f5 f6 f7)))) (=> (and (= ?v1 (- f10 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f15) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f16 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f5 (f17 f18 f10) ?v_0) (f5 (f17 f18 f4) ?v_0)) (* (+ (* 4 f15) 1) (+ 1 (f5 f6 f7))))))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f15) 1))) (and (< ?v_1 ?v_0) (= (f16 (* ?v_0 ?v_1)) f1))))
(assert (<= 1 f8))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f5 (f17 f18 ?v0) ?v_0) (f5 (f17 f18 ?v1) ?v_0)) (* (+ (* 4 f15) 1) (+ 1 (f5 f6 f7)))) false))) false))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f13 f14 (- (f5 f6 (f13 f14 f8)) 1))) (=> (< 0 (f5 f6 ?v0)) false))) false))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (= (f16 ?v1) f1) (= (f16 (* ?v0 ?v1)) f1)))))
(assert (not (= (f16 (* (+ (* 4 f15) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f15) 1)))
(assert (< 0 (f5 f6 f12)))
(assert (< f8 (+ (* 4 f15) 1)))
(assert (= (f16 (* (+ (* 4 f15) 1) f8)) f1))
(assert (= (f19 (+ (* 4 f15) 1)) f1))
(assert (= (f20 (f21 f22 (- 1)) (+ (* 4 f15) 1)) 1))
(assert (= (+ (f5 (f17 f18 f23) (f13 f14 2)) 1) (* (+ (* 4 f15) 1) f8)))
(assert (=> (= f8 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f5 (f17 f18 ?v0) ?v_0) (f5 (f17 f18 ?v1) ?v_0)) (+ (* 4 f15) 1))))))
(assert (= (f24 (+ (* 4 f15) 1) (- 1)) f1))
(assert (= (f25 (f5 (f17 f18 f26) (f13 f14 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f5 (f17 f18 f23) (f13 f14 2)) 1) (* (+ (* 4 f15) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f5 (f17 f18 f23) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (=> (not (= (f24 ?v_0 (- 1)) f1)) (not (= (f20 (f21 f22 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f25 (f5 (f17 f18 ?v0) (f13 f14 2)) (- 1) (+ (* 4 f15) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f5 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f5 (f17 f18 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f5 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f5 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (and (<= 0 f23) (and (< f23 ?v_0) (= (f25 f26 f23 ?v_0) f1)))))
(assert (= (f25 (f5 (f17 f18 f23) (f13 f14 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (let ((?v_0 (f13 f14 2))) (= (f25 (f5 (f17 f18 f23) ?v_0) (f5 (f17 f18 f26) ?v_0) (+ (* 4 f15) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f25 f26 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f15) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f25 f26 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f25 f26 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f19 ?v_0) f1) (= (f20 (f21 f22 (- 1)) ?v_0) 1)))))
(assert (= (f19 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f5 (f17 f18 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (= (f5 (f17 f18 ?v0) ?v_0) (f5 (f17 f18 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2)) (?v_1 (f17 f18 ?v0))) (= (f5 (f17 f18 (f5 ?v_1 ?v_0)) ?v_0) (f5 ?v_1 (f13 f14 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f5 (f17 f18 ?v0) ?v_0) (f5 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0))) (= (f5 (f17 f18 (- ?v0 ?v1)) ?v_0) (- (+ (- (f5 ?v_1 ?v_0) (* (* 3 (f5 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f5 ?v_3 ?v_2))) (f5 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f17 f18 ?v0)) (?v_3 (f17 f18 ?v1))) (= (f5 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f5 ?v_1 ?v_0) (* (* 3 (f5 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f5 ?v_3 ?v_2))) (f5 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f5 (f17 f18 (- ?v0 ?v1)) ?v_0) (+ (- (f5 (f17 f18 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f5 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f5 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (f5 (f17 f18 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f5 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 3))) (= (f5 (f17 f18 (- ?v0)) ?v_0) (- (f5 (f17 f18 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (* ?v0 (f5 ?v_0 (f13 f14 2))) (f5 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (f5 ?v_0 (f13 f14 (+ (f5 f6 ?v1) (f5 f6 ?v2)))) (* (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f5 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 (f21 f22 ?v0) ?v1) (ite (= (f25 ?v0 0 ?v1) f1) 0 (ite (= (f24 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f25 (f5 (f17 f18 ?v2) (f13 f14 2)) ?v1 ?v0) f1)))))
(assert (= (f27 (+ (* 4 f15) 1) (- (f5 (f17 f18 f23) (f13 f14 2)) (- 1))) f1))
(assert (= (f27 (+ (* 4 f15) 1) (+ (f5 (f17 f18 f23) (f13 f14 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0) f1) (=> (< 0 ?v1) (=> (= (f25 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f25 ?v1 1 ?v0) f1) (= (f25 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f19 ?v0) f1) (=> (< 0 ?v1) (=> (= (f25 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f25 ?v1 0 ?v0) f1) (= (f25 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f19 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f25 ?v1 0 ?v0) f1)) (not (= (f25 ?v2 0 ?v0) f1))) (not (= (f25 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f25 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f19 ?v0) f1) (=> (not (= (f25 ?v1 0 ?v0) f1)) (=> (not (= (f25 ?v2 0 ?v0) f1)) (not (= (f25 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 (* ?v0 ?v1) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f27 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 ?v0 (- ?v1 ?v2)) f1) (=> (= (f27 ?v0 ?v2) f1) (= (f27 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 ?v1) f1) (=> (= (f27 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 ?v0 ?v1) f1) (= (= (f27 ?v0 (+ ?v2 ?v3)) f1) (= (f27 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f27 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f27 ?v0 ?v1) f1) (=> (= (f27 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f27 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f27 (* ?v0 ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f27 ?v0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f27 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (= (= (f27 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 ?v0 0 ?v1) f1) (= (f27 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 ?v0 0 ?v1) f1) (= (f27 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f25 ?v0 ?v1 ?v2) f1) (= (f27 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f5 f6 ?v0)) (=> (= (f27 ?v1 ?v2) f1) (= (f27 ?v1 (f5 (f17 f18 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f19 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f27 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f19 ?v0) f1) (=> (= (f27 ?v0 (* ?v1 ?v2)) f1) (or (= (f27 ?v0 ?v1) f1) (= (f27 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f19 ?v1) f1) (=> (= (f27 ?v1 (* ?v0 ?v2)) f1) (or (= (f27 ?v1 ?v0) f1) (= (f27 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f19 ?v0) f1) (=> (= (f27 ?v0 (f5 (f17 f18 ?v1) ?v2)) f1) (=> (< 0 (f5 f6 ?v2)) (= (f27 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f19 ?v0) f1) (=> (= (f27 ?v0 (f5 (f17 f18 ?v1) ?v2)) f1) (= (f27 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f5 (f17 f18 ?v0) ?v2))) (=> (= (f19 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (=> (= (f27 ?v_0 (* ?v3 ?v1)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f5 (f17 f18 ?v0) ?v2))) (=> (= (f19 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (=> (= (f27 ?v_0 (* ?v1 ?v3)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f25 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f25 ?v0 ?v1 ?v2) f1) (= (f25 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f25 ?v0 ?v1 (- ?v2)) f1) (= (f25 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f25 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f25 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f25 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f25 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f25 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f25 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f25 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f25 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f25 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f25 ?v1 (- 1) ?v0) f1) (not (= (f25 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (= (= (f25 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f25 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (= (= (f25 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f25 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (= (f25 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (= (f25 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (= (f25 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f25 ?v3 ?v4 ?v2) f1) (= (f25 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= (f25 ?v1 ?v3 ?v2) f1) (= (f25 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= (f25 ?v3 ?v4 ?v2) f1) (= (f25 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= (f25 ?v3 ?v4 ?v2) f1) (= (f25 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= (f25 ?v3 ?v4 ?v2) f1) (= (f25 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (= (f25 (f5 (f17 f18 ?v0) ?v3) (f5 (f17 f18 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (= (f25 (f5 (f17 f18 ?v1) (f13 f14 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f25 ?v0 0 ?v1) f1)) (=> (= (f25 (f5 (f17 f18 ?v2) (f13 f14 2)) ?v0 ?v1) f1) (not (= (f27 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f19 ?v1) f1) (= (f27 ?v1 ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f13 f14 0))) (= (= (f27 (f5 (f17 f18 ?v1) ?v0) (f5 (f17 f18 ?v2) ?v0)) f1) (= (f27 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f27 (f5 (f17 f18 ?v0) ?v1) (f5 (f17 f18 ?v2) ?v1)) f1) (=> (not (= ?v1 (f13 f14 0))) (= (f27 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 (- 1)))) (let ((?v_1 (f5 ?v_0 ?v1)) (?v_2 (f5 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f25 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (= (f28 f29 (f30 f23 1)) (* (+ (* 4 f15) 1) f8)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f28 f29 (f30 ?v0 ?v1)) (f28 f29 (f30 ?v2 ?v3))) (f28 f29 (f30 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f25 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f13 f14 ?v0))) (=> (< 0 ?v0) (= (f5 ?v_0 ?v_1) (* ?v1 (f5 ?v_0 (f13 f14 (- (f5 f6 ?v_1) 1)))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 (f17 f18 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int)) (= (= (f16 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f28 f29 (f30 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f31 ?v0 ?v1) f1) (= (f31 (f32 (f33 f34 ?v0) ?v2) (f32 (f33 f34 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f27 ?v0 ?v1) f1) (= (f27 (f5 (f17 f18 ?v0) ?v2) (f5 (f17 f18 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f33 f34 ?v2))) (=> (<= (f5 f6 ?v0) (f5 f6 ?v1)) (= (f31 (f32 ?v_0 ?v0) (f32 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f17 f18 ?v2))) (=> (<= (f5 f6 ?v0) (f5 f6 ?v1)) (= (f27 (f5 ?v_0 ?v0) (f5 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f31 ?v0 ?v1) f1) (=> (<= (f5 f6 ?v2) (f5 f6 ?v3)) (= (f31 (f32 (f33 f34 ?v0) ?v2) (f32 (f33 f34 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f27 ?v0 ?v1) f1) (=> (<= (f5 f6 ?v2) (f5 f6 ?v3)) (= (f27 (f5 (f17 f18 ?v0) ?v2) (f5 (f17 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f13 f14 (f5 (f17 f18 ?v0) ?v1)) (f32 (f33 f34 (f13 f14 ?v0)) ?v1)))))
(assert (forall ((?v0 S3)) (= (f13 f14 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
