(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 S3) Int)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 () Int)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () S3)
(declare-fun f13 (S4 Int) S3)
(declare-fun f14 () S4)
(declare-fun f15 () Int)
(declare-fun f16 (Int) S1)
(declare-fun f17 (S5 Int) S2)
(declare-fun f18 () S5)
(declare-fun f19 (Int) S1)
(declare-fun f20 (S6 Int) Int)
(declare-fun f21 (S7 Int) S6)
(declare-fun f22 () S7)
(declare-fun f23 () Int)
(declare-fun f24 (Int Int) S1)
(declare-fun f25 (Int Int Int) S1)
(declare-fun f26 () Int)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f5 f6 f7)))) (=> (and (= ?v0 (- f4 (* ?v1 ?v_0))) (<= (* 2 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_0)) (= f3 f1)))))
(assert (< 0 (+ 1 (f5 f6 f7))))
(assert (< 1 f8))
(assert (< 0 (+ 1 (f5 f6 f7))))
(assert (< 0 (f5 f6 f7)))
(assert (let ((?v_0 (+ 1 (f5 f6 f7)))) (and (= f9 (- f10 (* f11 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (= f12 (f13 f14 (- (f5 f6 (f13 f14 f8)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f5 f6 f7)))) (=> (and (= ?v1 (- f10 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f15) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f16 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f5 (f17 f18 f10) ?v_0) (f5 (f17 f18 f4) ?v_0)) (* (+ (* 4 f15) 1) (+ 1 (f5 f6 f7))))))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f15) 1))) (and (< ?v_1 ?v_0) (= (f16 (* ?v_0 ?v_1)) f1))))
(assert (<= 1 f8))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f5 (f17 f18 ?v0) ?v_0) (f5 (f17 f18 ?v1) ?v_0)) (* (+ (* 4 f15) 1) (+ 1 (f5 f6 f7)))) false))) false))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f13 f14 (- (f5 f6 (f13 f14 f8)) 1))) (=> (< 0 (f5 f6 ?v0)) false))) false))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (= (f16 ?v1) f1) (= (f16 (* ?v0 ?v1)) f1)))))
(assert (not (= (f16 (* (+ (* 4 f15) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f15) 1)))
(assert (< 0 (f5 f6 f12)))
(assert (< f8 (+ (* 4 f15) 1)))
(assert (= (f16 (* (+ (* 4 f15) 1) f8)) f1))
(assert (= (f19 (+ (* 4 f15) 1)) f1))
(assert (= (f20 (f21 f22 (- 1)) (+ (* 4 f15) 1)) 1))
(assert (= (+ (f5 (f17 f18 f23) (f13 f14 2)) 1) (* (+ (* 4 f15) 1) f8)))
(assert (=> (= f8 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f5 (f17 f18 ?v0) ?v_0) (f5 (f17 f18 ?v1) ?v_0)) (+ (* 4 f15) 1))))))
(assert (= (f24 (+ (* 4 f15) 1) (- 1)) f1))
(assert (= (f25 (f5 (f17 f18 f26) (f13 f14 2)) (- 1) (+ (* 4 f15) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f5 (f17 f18 f23) (f13 f14 2)) 1) (* (+ (* 4 f15) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f5 (f17 f18 f23) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (=> (not (= (f24 ?v_0 (- 1)) f1)) (not (= (f20 (f21 f22 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f25 (f5 (f17 f18 ?v0) (f13 f14 2)) (- 1) (+ (* 4 f15) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f5 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f5 (f17 f18 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f5 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f5 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 S3)) (= (f13 f14 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
