(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () S2)
(declare-fun f13 () S3)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () S3)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 (Int) S1)
(declare-fun f22 (S6 Int) Int)
(declare-fun f23 (S7 Int) S6)
(declare-fun f24 () S7)
(declare-fun f25 (Int Int) S1)
(declare-fun f26 (Int Int) S1)
(declare-fun f27 (Int Int Int) S1)
(declare-fun f28 () Int)
(declare-fun f29 (S8 S9) Int)
(declare-fun f30 () S8)
(declare-fun f31 (Int Int) S9)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f12 f13)))) (not (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (f3 (f4 f5 (- f10 (* f11 ?v_1))) ?v_0) (f3 (f4 f5 (- f14 (* f15 ?v_1))) ?v_0))))))
(assert (let ((?v_0 (+ 1 (f3 f12 f13)))) (and (= f6 (- f10 (* f11 ?v_0))) (<= (* 2 (ite (< f6 0) (- f6) f6)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f12 f13)))) (and (= f9 (- f14 (* f15 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (< 1 f16))
(assert (< 0 (f3 f12 f13)))
(assert (< 0 (+ 1 (f3 f12 f13))))
(assert (let ((?v_0 (+ 1 (f3 f12 f13)))) (and (= f6 (- f10 (* f11 ?v_0))) (<= (* 2 (ite (< f6 0) (- f6) f6)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f12 f13)))) (and (= f9 (- f14 (* f15 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f12 f13)))) (=> (and (= ?v1 (- f10 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f12 f13)))) (=> (and (= ?v1 (- f14 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f14) ?v_0)) (* (+ (* 4 f17) 1) (+ 1 (f3 f12 f13))))))
(assert (= f18 (f7 f8 (- (f3 f12 (f7 f8 f16)) 1))))
(assert (let ((?v_0 (f3 (f4 f5 f19) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_1 (+ 1 (f3 f12 f13))) (?v_0 (+ (* 4 f17) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (* ?v_0 ?v_1)) f1))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f17) 1) (+ 1 (f3 f12 f13)))) false))) false))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f12 ?v1) (f3 f12 ?v2)))) (* (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (* ?v0 (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (< 0 (f3 f12 f18)))
(assert (not (= (f20 (* (+ (* 4 f17) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f17) 1)))
(assert (<= 1 f16))
(assert (= (+ (f3 (f4 f5 f19) (f7 f8 2)) 1) (* (+ (* 4 f17) 1) f16)))
(assert (< f16 (+ (* 4 f17) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f12 (f7 f8 f16)) 1))) (=> (< 0 (f3 f12 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f3 f12 f13))) (?v_0 (+ (* 4 f17) 1))) (and (< ?v_1 ?v_0) (= (f20 (* ?v_0 ?v_1)) f1))))
(assert (= (f20 (* (+ (* 4 f17) 1) f16)) f1))
(assert (= (f21 (+ (* 4 f17) 1)) f1))
(assert (= (f22 (f23 f24 (- 1)) (+ (* 4 f17) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f19) (f7 f8 2)) 1) (* (+ (* 4 f17) 1) ?v0)) false)) false))
(assert (=> (= f16 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f17) 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (= (f20 ?v1) f1) (= (f20 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (= (f25 (+ (* 4 f17) 1) (- 1)) f1))
(assert (= (f26 (+ (* 4 f17) 1) (- (f3 (f4 f5 f19) (f7 f8 2)) (- 1))) f1))
(assert (= (f26 (+ (* 4 f17) 1) (+ (f3 (f4 f5 f19) (f7 f8 2)) 1)) f1))
(assert (= (f27 (f3 (f4 f5 f19) (f7 f8 2)) (- 1) (+ (* 4 f17) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f17) 1))) (and (<= 0 f19) (and (< f19 ?v_0) (= (f27 f28 f19 ?v_0) f1)))))
(assert (= (f29 f30 (f31 f19 1)) (* (+ (* 4 f17) 1) f16)))
(assert (= (f27 (f3 (f4 f5 f28) (f7 f8 2)) (- 1) (+ (* 4 f17) 1)) f1))
(assert (let ((?v_0 (f7 f8 2))) (= (f27 (f3 (f4 f5 f19) ?v_0) (f3 (f4 f5 f28) ?v_0) (+ (* 4 f17) 1)) f1)))
(assert (let ((?v_0 (+ (* 4 f17) 1))) (=> (not (= (f25 ?v_0 (- 1)) f1)) (not (= (f22 (f23 f24 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f27 (f3 (f4 f5 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f17) 1)) f1) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f17) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f27 f28 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f17) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f27 f28 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f27 f28 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (= (f21 2) f1))
(assert (forall ((?v0 Int)) (= (= (f26 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f26 ?v0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f26 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f26 (* ?v0 ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f26 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f26 ?v0 ?v1) f1) (=> (= (f26 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f26 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f26 ?v0 ?v1) f1) (= (= (f26 ?v0 (+ ?v2 ?v3)) f1) (= (f26 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f12 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f12 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
