(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (S4 Int) S2)
(declare-fun f8 () S4)
(declare-fun f9 (S5 Int) S3)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 () S3)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (not (<= (* (* ?v_0 f6) 4) (* (* ?v_0 ?v_0) 2)))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (let ((?v_1 (f3 (f7 f8 ?v_0) (f9 f10 2)))) (<= (* (* 4 ?v_0) f6) (+ ?v_1 ?v_1)))))
(assert (< 1 f11))
(assert (< 0 (f3 f4 f5)))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (let ((?v_1 (f3 (f7 f8 ?v_0) (f9 f10 2)))) (<= (* (* 4 ?v_0) f6) (+ ?v_1 ?v_1)))))
(assert (< 0 (+ 1 (f3 f4 f5))))
(assert (not (< f6 (+ 1 (f3 f4 f5)))))
(assert (<= (- (+ 1 (f3 f4 f5)) f6) 0))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (< (* ?v_0 (- (* 2 ?v_0) (* 4 f6))) 0)))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (< (* ?v_0 (- (* 2 ?v_0) (* 4 f6))) (* ?v_0 0))))
(assert (< (- (* 2 (+ 1 (f3 f4 f5))) (* 4 f6)) 0))
(assert (<= (- (* 4 (+ 1 (f3 f4 f5))) (* 4 f6)) 0))
(assert (= f12 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f13 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f14 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f15 (- f13 (* f16 ?v_0))) (<= (* 2 (ite (< f15 0) (- f15) f15)) ?v_0))))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f7 f8 f15) ?v_0) (f3 (f7 f8 f17) ?v_0)) (* (+ 1 (f3 f4 f5)) f6))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f17 (- f14 (* f18 ?v_0))) (<= (* 2 (ite (< f17 0) (- f17) f17)) ?v_0))))
(assert (let ((?v_0 (f9 f10 2))) (let ((?v_1 (f3 (f7 f8 (+ 1 (f3 f4 f5))) ?v_0))) (<= (+ ?v_1 (f3 (f7 f8 (* 2 (ite (< f17 0) (- f17) f17))) ?v_0)) (+ ?v_1 ?v_1)))))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f19) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (f9 f10 2))) (= (* (* 4 (+ 1 (f3 f4 f5))) f6) (+ (* 4 (f3 (f7 f8 f15) ?v_0)) (* 4 (f3 (f7 f8 f17) ?v_0))))))
(assert (<= 1 f11))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f19) 1))) (and (< ?v_1 ?v_0) (= (f20 (* ?v_0 ?v_1)) f1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f3 (f7 f8 ?v0) ?v_0) (f3 (f7 f8 ?v1) ?v_0)) (* (+ (* 4 f19) 1) (+ 1 (f3 f4 f5)))) false))) false))
(assert (< 0 (f3 f4 f12)))
(assert (not (= (f20 (* (+ (* 4 f19) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f19) 1)))
(assert (< f11 (+ (* 4 f19) 1)))
(assert (and (<= 0 (* 2 (ite (< f15 0) (- f15) f15))) (<= 0 (* 2 (ite (< f17 0) (- f17) f17)))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f7 f8 f13) ?v_0) (f3 (f7 f8 f14) ?v_0)) (* (+ (* 4 f19) 1) (+ 1 (f3 f4 f5))))))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (* 4 (f3 (f7 f8 f15) ?v_0)) (* 4 (f3 (f7 f8 f17) ?v_0))) (+ (f3 (f7 f8 (* 2 (ite (< f15 0) (- f15) f15))) ?v_0) (f3 (f7 f8 (* 2 (ite (< f17 0) (- f17) f17))) ?v_0)))))
(assert (= (f20 (* (+ (* 4 f19) 1) f11)) f1))
(assert (let ((?v_0 (f9 f10 2))) (let ((?v_1 (f3 (f7 f8 (* 2 (ite (< f17 0) (- f17) f17))) ?v_0))) (<= (+ (f3 (f7 f8 (* 2 (ite (< f15 0) (- f15) f15))) ?v_0) ?v_1) (+ (f3 (f7 f8 (+ 1 (f3 f4 f5))) ?v_0) ?v_1)))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
