(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 () Int)
(declare-fun f8 () Int)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 (S5 Int) S3)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () S2)
(declare-fun f16 () S3)
(declare-fun f17 (Int) S1)
(declare-fun f18 (Int) S1)
(declare-fun f19 (S6 Int) Int)
(declare-fun f20 (S7 Int) S6)
(declare-fun f21 () S7)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 () S3)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 (Int Int Int) S1)
(declare-fun f28 () Int)
(declare-fun f29 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f11 f12 2))) (not (= (+ (f3 (f4 f5 (+ (+ (* f6 f7) (* f8 f9)) f10)) ?v_0) (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_0)) (* (+ (* 4 f13) 1) f10)))))
(assert (< 1 f14))
(assert (< 0 (f3 f15 f16)))
(assert (not (= (f17 (* (+ (* 4 f13) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f13) 1)))
(assert (= (f18 (+ (* 4 f13) 1)) f1))
(assert (= (f19 (f20 f21 (- 1)) (+ (* 4 f13) 1)) 1))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f15 f16)) f10))))
(assert (= (f22 (+ (* 4 f13) 1) (- 1)) f1))
(assert (= f23 (f11 f12 (- (f3 f15 (f11 f12 f14)) 1))))
(assert (let ((?v_0 (+ 1 (f3 f15 f16)))) (and (= f7 (- f24 (* f6 ?v_0))) (<= (* 2 (ite (< f7 0) (- f7) f7)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f15 f16)))) (and (= f9 (- f25 (* f8 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (< f14 (+ (* 4 f13) 1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f11 f12 2))) (=> (= (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f15 f16)) ?v0)) false))) false))
(assert (< f10 (+ 1 (f3 f15 f16))))
(assert (= (+ (f3 (f4 f5 f26) (f11 f12 2)) 1) (* (+ (* 4 f13) 1) f14)))
(assert (= (f27 (f3 (f4 f5 f28) (f11 f12 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f26) (f11 f12 2)) 1) (* (+ (* 4 f13) 1) ?v0)) false)) false))
(assert (let ((?v_0 (+ (* 4 f13) 1)) (?v_1 (+ 1 (f3 f15 f16)))) (not (=> (< ?v_1 ?v_0) (not (= (f17 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (f3 (f4 f5 f26) (f11 f12 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (< 0 (f3 f15 f23)))
(assert (< 0 (+ 1 (f3 f15 f16))))
(assert (<= 1 f14))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (and (<= 0 f26) (and (< f26 ?v_0) (= (f27 f28 f26 ?v_0) f1)))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f11 f12 (- (f3 f15 (f11 f12 f14)) 1))) (=> (< 0 (f3 f15 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (=> (not (= (f22 ?v_0 (- 1)) f1)) (not (= (f19 (f20 f21 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (+ (* 4 f13) 1)) (?v_1 (+ 1 (f3 f15 f16)))) (and (< ?v_1 ?v_0) (= (f17 (* ?v_0 ?v_1)) f1))))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f3 (f4 f5 f24) ?v_0) (f3 (f4 f5 f25) ?v_0)) (* (+ (* 4 f13) 1) (+ 1 (f3 f15 f16))))))
(assert (= (f17 (* (+ (* 4 f13) 1) f14)) f1))
(assert (= (f27 (f3 (f4 f5 f26) (f11 f12 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f27 (f3 (f4 f5 ?v0) (f11 f12 2)) (- 1) (+ (* 4 f13) 1)) f1) false)) false))
(assert (let ((?v_0 (f11 f12 2))) (= (f27 (f3 (f4 f5 f26) ?v_0) (f3 (f4 f5 f28) ?v_0) (+ (* 4 f13) 1)) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f15 f16)))) (=> (and (= ?v1 (- f24 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f15 f16)))) (=> (and (= ?v1 (- f25 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f13) 1) (+ 1 (f3 f15 f16)))) false))) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f27 f28 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f27 f28 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f27 f28 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (= f14 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f13) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f18 ?v_0) f1) (= (f19 (f20 f21 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (= (f17 ?v1) f1) (= (f17 (* ?v0 ?v1)) f1)))))
(assert (let ((?v_0 (f11 f12 2))) (= (f29 (+ 1 (f3 f15 f16)) (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 (f20 f21 ?v0) ?v1) (ite (= (f27 ?v0 0 ?v1) f1) 0 (ite (= (f22 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f27 (f3 (f4 f5 ?v2) (f11 f12 2)) ?v1 ?v0) f1)))))
(assert (= (f29 (+ (* 4 f13) 1) (- (f3 (f4 f5 f26) (f11 f12 2)) (- 1))) f1))
(assert (= (f29 (+ (* 4 f13) 1) (+ (f3 (f4 f5 f26) (f11 f12 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (not (= (f27 ?v1 0 ?v0) f1)) (=> (not (= (f27 ?v2 0 ?v0) f1)) (not (= (f27 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f27 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f27 ?v1 0 ?v0) f1)) (not (= (f27 ?v2 0 ?v0) f1))) (not (= (f27 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (= (f27 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f27 ?v1 0 ?v0) f1) (= (f27 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (= (f27 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f27 ?v1 1 ?v0) f1) (= (f27 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f27 ?v0 ?v1 ?v2) f1) (= (f29 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f27 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f27 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f15 ?v0)) (=> (= (f29 ?v1 ?v2) f1) (= (f29 ?v1 (f3 (f4 f5 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f18 ?v1) f1) (=> (= (f29 ?v1 (* ?v0 ?v2)) f1) (or (= (f29 ?v1 ?v0) f1) (= (f29 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (= (f29 ?v0 (* ?v1 ?v2)) f1) (or (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f18 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f29 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f18 ?v0) f1) (=> (= (f29 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f15 ?v2)) (= (f29 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 ?v0 ?v1 ?v2) f1) (=> (= (f27 ?v3 ?v4 ?v2) f1) (= (f27 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 ?v0 ?v1 ?v2) f1) (=> (= (f27 ?v3 ?v4 ?v2) f1) (= (f27 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 ?v0 ?v1 ?v2) f1) (=> (= (f27 ?v3 ?v4 ?v2) f1) (= (f27 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f27 ?v0 ?v1 ?v2) f1) (=> (= (f27 ?v1 ?v3 ?v2) f1) (= (f27 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f27 ?v3 ?v4 ?v2) f1) (= (f27 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 S3)) (= (f11 f12 (f3 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f15 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f15 (f11 f12 ?v0)) 0))))
(check-sat)
(exit)
