(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 () Int)
(declare-fun f8 () Int)
(declare-fun f9 () Int)
(declare-fun f10 (S5 Int) S3)
(declare-fun f11 () S5)
(declare-fun f12 () Int)
(declare-fun f13 () S2)
(declare-fun f14 () S3)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () S3)
(declare-fun f20 (Int Int) S1)
(declare-fun f21 () Int)
(declare-fun f22 (Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f10 f11 2)) (?v_1 (+ 1 (f3 f13 f14)))) (let ((?v_2 (+ (* f12 ?v_1) f7)) (?v_3 (+ (* f15 ?v_1) f9))) (not (= (+ (f3 (f4 f5 (+ (* f6 f7) (* f8 f9))) ?v_0) (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_0)) (+ (f3 (f4 f5 (+ (* ?v_2 f7) (* ?v_3 f9))) ?v_0) (f3 (f4 f5 (- (* ?v_2 f9) (* ?v_3 f7))) ?v_0)))))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f7 (- f6 (* f12 ?v_0))) (<= (* 2 (ite (< f7 0) (- f7) f7)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f9 (- f8 (* f15 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (let ((?v_0 (f10 f11 2))) (= (* (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f8) ?v_0)) (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0))) (+ (f3 (f4 f5 (+ (* f6 f7) (* f8 f9))) ?v_0) (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_0)))))
(assert (< 1 f16))
(assert (< 0 (f3 f13 f14)))
(assert (< 0 (+ 1 (f3 f13 f14))))
(assert (let ((?v_0 (f10 f11 2))) (= (* (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f8) ?v_0)) (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0))) (+ (f3 (f4 f5 (+ (* f6 f7) (* f8 f9))) ?v_0) (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_0)))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f7 (- f6 (* f12 ?v_0))) (<= (* 2 (ite (< f7 0) (- f7) f7)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f9 (- f8 (* f15 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (let ((?v_0 (f10 f11 2))) (= (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f13 f14)) f17))))
(assert (< f17 (+ 1 (f3 f13 f14))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f13 f14)))) (=> (and (= ?v1 (- f6 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f13 f14)))) (=> (and (= ?v1 (- f8 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2))) (=> (= (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f13 f14)) ?v0)) false))) false))
(assert (let ((?v_0 (f10 f11 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f8) ?v_0)) (* (+ (* 4 f18) 1) (+ 1 (f3 f13 f14))))))
(assert (= f19 (f10 f11 (- (f3 f13 (f10 f11 f16)) 1))))
(assert (let ((?v_0 (f10 f11 2))) (let ((?v_1 (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0)))) (= (* (* (+ (* 4 f18) 1) (+ 1 (f3 f13 f14))) ?v_1) (* (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f8) ?v_0)) ?v_1)))))
(assert (let ((?v_0 (f10 f11 2))) (= (* (* (+ (* 4 f18) 1) (+ 1 (f3 f13 f14))) (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0))) (+ (f3 (f4 f5 (+ (* f6 f7) (* f8 f9))) ?v_0) (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_0)))))
(assert (let ((?v_0 (f10 f11 2))) (= (f20 (+ 1 (f3 f13 f14)) (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0))) f1)))
(assert (let ((?v_0 (f3 (f4 f5 f21) (f10 f11 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_1 (+ 1 (f3 f13 f14))) (?v_0 (+ (* 4 f18) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f22 (* ?v_0 ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f10 f11 0))))))
(assert (< 0 (f3 f13 f19)))
(assert (not (= (f22 (* (+ (* 4 f18) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f18) 1)))
(assert (<= 1 f16))
(assert (= (+ (f3 (f4 f5 f21) (f10 f11 2)) 1) (* (+ (* 4 f18) 1) f16)))
(assert (< f16 (+ (* 4 f18) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f10 f11 (- (f3 f13 (f10 f11 f16)) 1))) (=> (< 0 (f3 f13 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f3 f13 f14))) (?v_0 (+ (* 4 f18) 1))) (and (< ?v_1 ?v_0) (= (f22 (* ?v_0 ?v_1)) f1))))
(assert (= (f22 (* (+ (* 4 f18) 1) f16)) f1))
(assert (forall ((?v0 S3)) (= (f10 f11 (f3 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f13 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f13 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
