(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 () S2)
(declare-fun f8 () S3)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 (S5 Int) S3)
(declare-fun f13 () S5)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () S3)
(declare-fun f19 () Int)
(declare-fun f20 (Int Int) S1)
(declare-fun f21 () Int)
(declare-fun f22 (Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ 1 (f3 f7 f8)))) (let ((?v_1 (+ (* f6 ?v_0) f9)) (?v_2 (+ (* f10 ?v_0) f11)) (?v_3 (f12 f13 2))) (not (= (+ (f3 (f4 f5 (+ (* ?v_1 f9) (* ?v_2 f11))) ?v_3) (f3 (f4 f5 (- (* ?v_1 f11) (* ?v_2 f9))) ?v_3)) (+ (f3 (f4 f5 (+ (+ (* ?v_0 (* f6 f9)) (* ?v_0 (* f10 f11))) (+ (f3 (f4 f5 f9) ?v_3) (f3 (f4 f5 f11) ?v_3)))) ?v_3) (f3 (f4 f5 (- (* ?v_0 (* f6 f11)) (* ?v_0 (* f10 f9)))) ?v_3)))))))
(assert (< 1 f14))
(assert (< 0 (f3 f7 f8)))
(assert (< 0 (+ 1 (f3 f7 f8))))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0)) (* (+ 1 (f3 f7 f8)) f15))))
(assert (< f15 (+ 1 (f3 f7 f8))))
(assert (let ((?v_0 (+ 1 (f3 f7 f8)))) (and (= f9 (- f16 (* f6 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f7 f8)))) (and (= f11 (- f17 (* f10 ?v_0))) (<= (* 2 (ite (< f11 0) (- f11) f11)) ?v_0))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2))) (=> (= (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0)) (* (+ 1 (f3 f7 f8)) ?v0)) false))) false))
(assert (= f18 (f12 f13 (- (f3 f7 (f12 f13 f14)) 1))))
(assert (let ((?v_1 (+ 1 (f3 f7 f8)))) (let ((?v_2 (+ (* f6 ?v_1) f9)) (?v_3 (+ (* f10 ?v_1) f11)) (?v_0 (f12 f13 2))) (= (* (* (+ (* 4 f19) 1) ?v_1) (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0))) (+ (f3 (f4 f5 (+ (* ?v_2 f9) (* ?v_3 f11))) ?v_0) (f3 (f4 f5 (- (* ?v_2 f11) (* ?v_3 f9))) ?v_0))))))
(assert (let ((?v_0 (f12 f13 2))) (= (f20 (+ 1 (f3 f7 f8)) (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0))) f1)))
(assert (let ((?v_1 (+ 1 (f3 f7 f8)))) (let ((?v_2 (+ (* f6 ?v_1) f9)) (?v_3 (+ (* f10 ?v_1) f11)) (?v_0 (f12 f13 2))) (= (+ (f3 (f4 f5 (+ (* f16 f9) (* f17 f11))) ?v_0) (f3 (f4 f5 (- (* f16 f11) (* f17 f9))) ?v_0)) (+ (f3 (f4 f5 (+ (* ?v_2 f9) (* ?v_3 f11))) ?v_0) (f3 (f4 f5 (- (* ?v_2 f11) (* ?v_3 f9))) ?v_0))))))
(assert (let ((?v_0 (f12 f13 2))) (= (* (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f17) ?v_0)) (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0))) (+ (f3 (f4 f5 (+ (* f16 f9) (* f17 f11))) ?v_0) (f3 (f4 f5 (- (* f16 f11) (* f17 f9))) ?v_0)))))
(assert (let ((?v_0 (f3 (f4 f5 f21) (f12 f13 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f7 f8)))) (=> (and (= ?v1 (- f16 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f7 f8)))) (=> (and (= ?v1 (- f17 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_1 (+ 1 (f3 f7 f8))) (?v_0 (+ (* 4 f19) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f22 (* ?v_0 ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f12 f13 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (< 0 (f3 f7 f18)))
(assert (not (= (f22 (* (+ (* 4 f19) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f19) 1)))
(assert (<= 1 f14))
(assert (= (+ (f3 (f4 f5 f21) (f12 f13 2)) 1) (* (+ (* 4 f19) 1) f14)))
(assert (< f14 (+ (* 4 f19) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f12 f13 (- (f3 f7 (f12 f13 f14)) 1))) (=> (< 0 (f3 f7 ?v0)) false))) false))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f17) ?v_0)) (* (+ (* 4 f19) 1) (+ 1 (f3 f7 f8))))))
(assert (let ((?v_1 (+ 1 (f3 f7 f8))) (?v_0 (+ (* 4 f19) 1))) (and (< ?v_1 ?v_0) (= (f22 (* ?v_0 ?v_1)) f1))))
(assert (= (f22 (* (+ (* 4 f19) 1) f14)) f1))
(assert (= (f20 (+ (* 4 f19) 1) (- (f3 (f4 f5 f21) (f12 f13 2)) (- 1))) f1))
(assert (= (f20 (+ (* 4 f19) 1) (+ (f3 (f4 f5 f21) (f12 f13 2)) 1)) f1))
(assert (forall ((?v0 S3)) (= (f12 f13 (f3 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f7 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f7 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
