(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 Int) S8)
(declare-fun f14 () S9)
(declare-fun f15 () S2)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 (Int) S1)
(declare-fun f24 (Int) S1)
(declare-fun f25 () S7)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 (S10 Int) S1)
(declare-fun f29 (Int) S10)
(declare-fun f30 () S2)
(declare-fun f31 (Int) S10)
(declare-fun f32 () Int)
(declare-fun f33 (S11 Int) S10)
(declare-fun f34 (Int) S11)
(declare-fun f35 () Int)
(declare-fun f36 (Int S10) S1)
(declare-fun f37 (S12 S13) Int)
(declare-fun f38 () S12)
(declare-fun f39 (Int Int) S13)
(declare-fun f40 (S2 S2) S1)
(declare-fun f41 () S4)
(declare-fun f42 () S6)
(declare-fun f43 () S6)
(declare-fun f44 () S4)
(declare-fun f45 () S7)
(declare-fun f46 () S7)
(declare-fun f47 () S5)
(declare-fun f48 (Int) S11)
(declare-fun f49 (Int) S10)
(declare-fun f50 () S7)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (let ((?v_0 (f6 f7 2))) (not (= (* (f11 (f13 f14 (+ 1 (f11 f12 f15))) ?v_0) (- (- (* (+ (* 4 f16) 1) f17) (f11 (f13 f14 (+ (+ (* f18 f19) (* f20 f21)) f17)) ?v_0)) (f11 (f13 f14 (- (* f18 f21) (* f20 f19))) ?v_0))) 0))))
(assert (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f11 (f13 f14 (+ 1 (f11 f12 f15))) ?v_1))) (= (* ?v_0 (* (+ (* 4 f16) 1) f17)) (* ?v_0 (+ (f11 (f13 f14 (+ (+ (* f18 f19) (* f20 f21)) f17)) ?v_1) (f11 (f13 f14 (- (* f18 f21) (* f20 f19))) ?v_1)))))))
(assert (< 1 f22))
(assert (< 0 (f11 f12 f15)))
(assert (not (= (f23 (* (+ (* 4 f16) 1) (+ 1 0))) f1)))
(assert (< 0 (+ 1 (f11 f12 f15))))
(assert (< 0 (+ (* 4 f16) 1)))
(assert (let ((?v_1 (+ 1 (f11 f12 f15))) (?v_0 (+ (* 4 f16) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f23 (* ?v_0 ?v_1)) f1))))))
(assert (< f17 (+ 1 (f11 f12 f15))))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f13 f14 f19) ?v_0) (f11 (f13 f14 f21) ?v_0)) (* (+ 1 (f11 f12 f15)) f17))))
(assert (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f11 (f13 f14 (+ 1 (f11 f12 f15))) ?v_1))) (= (* ?v_0 (* (+ (* 4 f16) 1) f17)) (* ?v_0 (+ (f11 (f13 f14 (+ (+ (* f18 f19) (* f20 f21)) f17)) ?v_1) (f11 (f13 f14 (- (* f18 f21) (* f20 f19))) ?v_1)))))))
(assert (= (f24 (+ (* 4 f16) 1)) f1))
(assert (= (f8 (f9 f25 (- 1)) (+ (* 4 f16) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (+ (f11 (f13 f14 ?v0) ?v_0) (f11 (f13 f14 ?v1) ?v_0)) (* (+ (* 4 f16) 1) (+ 1 (f11 f12 f15)))) false))) false))
(assert (let ((?v_0 (+ 1 (f11 f12 f15)))) (and (= f19 (- f26 (* f18 ?v_0))) (<= (* 2 (ite (< f19 0) (- f19) f19)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f11 f12 f15)))) (and (= f21 (- f27 (* f20 ?v_0))) (<= (* 2 (ite (< f21 0) (- f21) f21)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f11 f12 f15))) (?v_3 (f6 f7 2))) (let ((?v_1 (+ (* f18 ?v_0) f19)) (?v_2 (+ (* f20 ?v_0) f21))) (= (+ (f11 (f13 f14 (+ (* ?v_1 f19) (* ?v_2 f21))) ?v_3) (f11 (f13 f14 (- (* ?v_1 f21) (* ?v_2 f19))) ?v_3)) (+ (f11 (f13 f14 (+ (+ (* ?v_0 (* f18 f19)) (* ?v_0 (* f20 f21))) (+ (f11 (f13 f14 f19) ?v_3) (f11 (f13 f14 f21) ?v_3)))) ?v_3) (f11 (f13 f14 (- (* ?v_0 (* f18 f21)) (* ?v_0 (* f20 f19)))) ?v_3))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (+ (f11 (f13 f14 f19) ?v_0) (f11 (f13 f14 f21) ?v_0)) (* (+ 1 (f11 f12 f15)) ?v0)) false))) false))
(assert (let ((?v_0 (+ 1 (f11 f12 f15))) (?v_1 (f6 f7 2))) (let ((?v_2 (+ (* ?v_0 (* f18 f19)) (* ?v_0 (* f20 f21)))) (?v_3 (f11 (f13 f14 (- (* ?v_0 (* f18 f21)) (* ?v_0 (* f20 f19)))) ?v_1))) (= (+ (f11 (f13 f14 (+ ?v_2 (+ (f11 (f13 f14 f19) ?v_1) (f11 (f13 f14 f21) ?v_1)))) ?v_1) ?v_3) (+ (f11 (f13 f14 (+ ?v_2 (* ?v_0 f17))) ?v_1) ?v_3)))))
(assert (let ((?v_1 (+ 1 (f11 f12 f15))) (?v_0 (f6 f7 2))) (let ((?v_2 (f11 (f13 f14 ?v_1) ?v_0))) (= (* (* (+ (* 4 f16) 1) ?v_1) (+ (f11 (f13 f14 f19) ?v_0) (f11 (f13 f14 f21) ?v_0))) (+ (* ?v_2 (f11 (f13 f14 (+ (+ (* f18 f19) (* f20 f21)) f17)) ?v_0)) (* ?v_2 (f11 (f13 f14 (- (* f18 f21) (* f20 f19))) ?v_0)))))))
(assert (let ((?v_1 (+ 1 (f11 f12 f15))) (?v_0 (f6 f7 2))) (= (* (* (+ (* 4 f16) 1) ?v_1) (+ (f11 (f13 f14 f19) ?v_0) (f11 (f13 f14 f21) ?v_0))) (+ (f11 (f13 f14 (+ (+ (* ?v_1 (* f18 f19)) (* ?v_1 (* f20 f21))) (* ?v_1 f17))) ?v_0) (f11 (f13 f14 (- (* ?v_1 (* f18 f21)) (* ?v_1 (* f20 f19)))) ?v_0)))))
(assert (let ((?v_1 (+ 1 (f11 f12 f15))) (?v_0 (+ (* 4 f16) 1))) (and (< ?v_1 ?v_0) (= (f23 (* ?v_0 ?v_1)) f1))))
(assert (= (f28 (f29 (+ (* 4 f16) 1)) (- 1)) f1))
(assert (= f30 (f6 f7 (- (f11 f12 (f6 f7 f22)) 1))))
(assert (let ((?v_0 (f6 f7 2))) (= (f28 (f31 (+ 1 (f11 f12 f15))) (+ (f11 (f13 f14 f19) ?v_0) (f11 (f13 f14 f21) ?v_0))) f1)))
(assert (< f22 (+ (* 4 f16) 1)))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f13 f14 f26) ?v_0) (f11 (f13 f14 f27) ?v_0)) (* (+ (* 4 f16) 1) (+ 1 (f11 f12 f15))))))
(assert (let ((?v_1 (+ 1 (f11 f12 f15))) (?v_0 (f6 f7 2))) (let ((?v_2 (+ (* f18 ?v_1) f19)) (?v_3 (+ (* f20 ?v_1) f21))) (= (+ (f11 (f13 f14 (+ (* f26 f19) (* f27 f21))) ?v_0) (f11 (f13 f14 (- (* f26 f21) (* f27 f19))) ?v_0)) (+ (f11 (f13 f14 (+ (* ?v_2 f19) (* ?v_3 f21))) ?v_0) (f11 (f13 f14 (- (* ?v_2 f21) (* ?v_3 f19))) ?v_0))))))
(assert (let ((?v_0 (f6 f7 2))) (let ((?v_1 (+ (f11 (f13 f14 f19) ?v_0) (f11 (f13 f14 f21) ?v_0)))) (= (* (* (+ (* 4 f16) 1) (+ 1 (f11 f12 f15))) ?v_1) (* (+ (f11 (f13 f14 f26) ?v_0) (f11 (f13 f14 f27) ?v_0)) ?v_1)))))
(assert (= (+ (f11 (f13 f14 f32) (f6 f7 2)) 1) (* (+ (* 4 f16) 1) f22)))
(assert (= (f28 (f33 (f34 (f11 (f13 f14 f35) (f6 f7 2))) (- 1)) (+ (* 4 f16) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f11 (f13 f14 f32) (f6 f7 2)) 1) (* (+ (* 4 f16) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f11 (f13 f14 f32) (f6 f7 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (f6 f7 2))) (= (* (+ (f11 (f13 f14 f26) ?v_0) (f11 (f13 f14 f27) ?v_0)) (+ (f11 (f13 f14 f19) ?v_0) (f11 (f13 f14 f21) ?v_0))) (+ (f11 (f13 f14 (+ (* f26 f19) (* f27 f21))) ?v_0) (f11 (f13 f14 (- (* f26 f21) (* f27 f19))) ?v_0)))))
(assert (< 0 (f11 f12 f30)))
(assert (<= 1 f22))
(assert (let ((?v_0 (+ (* 4 f16) 1))) (and (<= 0 f32) (and (< f32 ?v_0) (= (f28 (f33 (f34 f35) f32) ?v_0) f1)))))
(assert (=> (forall ((?v0 S2)) (=> (= ?v0 (f6 f7 (- (f11 f12 (f6 f7 f22)) 1))) (=> (< 0 (f11 f12 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f16) 1))) (=> (not (= (f28 (f29 ?v_0) (- 1)) f1)) (not (= (f8 (f9 f25 (- 1)) ?v_0) 1)))))
(assert (= (f23 (* (+ (* 4 f16) 1) f22)) f1))
(assert (= (f28 (f33 (f34 (f11 (f13 f14 f32) (f6 f7 2))) (- 1)) (+ (* 4 f16) 1)) f1))
(assert (= (f28 (f31 (+ (* 4 f16) 1)) (- (f11 (f13 f14 f32) (f6 f7 2)) (- 1))) f1))
(assert (= (f28 (f31 (+ (* 4 f16) 1)) (+ (f11 (f13 f14 f32) (f6 f7 2)) 1)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f15)))) (=> (and (= ?v1 (- f27 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f15)))) (=> (and (= ?v1 (- f26 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int)) (=> (= (f28 (f33 (f34 (f11 (f13 f14 ?v0) (f6 f7 2))) (- 1)) (+ (* 4 f16) 1)) f1) false)) false))
(assert (let ((?v_0 (f6 f7 2))) (= (f28 (f33 (f34 (f11 (f13 f14 f32) ?v_0)) (f11 (f13 f14 f35) ?v_0)) (+ (* 4 f16) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f16) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 (f33 (f34 f35) ?v0) ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f16) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 (f33 (f34 f35) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f28 (f33 (f34 f35) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (= f22 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f13 f14 ?v0) ?v_0) (f11 (f13 f14 ?v1) ?v_0)) (+ (* 4 f16) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f24 ?v_0) f1) (= (f8 (f9 f25 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0) f1) (=> (= (f23 ?v1) f1) (= (f23 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f31 ?v0) ?v1) f1)) (= (f28 (f33 (f34 (f11 (f13 f14 ?v1) (f6 f7 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f25 ?v0) ?v1) (ite (= (f28 (f33 (f34 ?v0) 0) ?v1) f1) 0 (ite (= (f28 (f29 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 (f29 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f28 (f33 (f34 (f11 (f13 f14 ?v2) (f6 f7 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f31 (f11 (f13 f14 ?v0) ?v2)))) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f31 ?v0) ?v1) f1)) (=> (= (f28 ?v_0 (* ?v1 ?v3)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f31 (f11 (f13 f14 ?v0) ?v2)))) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f31 ?v0) ?v1) f1)) (=> (= (f28 ?v_0 (* ?v3 ?v1)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f31 ?v0))) (=> (= (f24 ?v0) f1) (=> (= (f28 ?v_0 (f11 (f13 f14 ?v1) ?v2)) f1) (= (f28 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f31 ?v0))) (=> (= (f24 ?v0) f1) (=> (= (f28 ?v_0 (f11 (f13 f14 ?v1) ?v2)) f1) (=> (< 0 (f11 f12 ?v2)) (= (f28 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f28 (f33 (f34 ?v0) 0) ?v1) f1)) (=> (= (f28 (f33 (f34 (f11 (f13 f14 ?v2) (f6 f7 2))) ?v0) ?v1) f1) (not (= (f28 (f31 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f24 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f28 (f31 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f13 f14 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f11 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f11 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (* ?v0 (f11 ?v_0 (f6 f7 2))) (f11 ?v_0 (f6 f7 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f11 (f13 f14 (- ?v0)) ?v_0) (- (f11 (f13 f14 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f13 f14 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f13 f14 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f13 f14 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_1 (f13 f14 ?v0)) (?v_3 (f13 f14 ?v1))) (= (f11 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_3 (f13 f14 ?v1)) (?v_1 (f13 f14 ?v0))) (= (f11 (f13 f14 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f11 (f13 f14 ?v0) ?v_0) (f11 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f13 f14 ?v0))) (= (f11 (f13 f14 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f11 (f13 f14 ?v0) ?v_0) (f11 (f13 f14 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 ?v1)) (?v_1 (f6 f7 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (* ?v1 (f11 ?v_0 (f6 f7 (- (f11 f12 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (=> (= (f11 (f13 f14 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (=> (= (f28 (f33 (f34 ?v3) ?v4) ?v2) f1) (= (f28 (f33 (f34 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (=> (= (f28 (f33 (f34 ?v3) ?v4) ?v2) f1) (= (f28 (f33 (f34 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f36 ?v0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (=> (= (f28 (f33 (f34 ?v3) ?v4) ?v2) f1) (= (f28 (f33 (f34 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f34 ?v0))) (=> (= (f28 (f33 ?v_0 ?v1) ?v2) f1) (=> (= (f28 (f33 (f34 ?v1) ?v3) ?v2) f1) (= (f28 (f33 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f34 ?v0))) (=> (= (f28 (f33 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f28 (f33 (f34 ?v3) ?v4) ?v2) f1) (= (f28 (f33 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (= (f28 (f33 (f34 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (= (f28 (f33 (f34 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (= (f28 (f33 (f34 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f34 ?v3))) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (= (= (f28 (f33 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f28 (f33 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f34 ?v3))) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (= (= (f28 (f33 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f28 (f33 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f34 ?v1))) (=> (< 2 ?v0) (=> (= (f28 (f33 ?v_0 (- 1)) ?v0) f1) (not (= (f28 (f33 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f28 (f33 (f34 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f28 (f33 (f34 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f28 (f33 (f34 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f28 (f33 (f34 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f28 (f33 (f34 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f28 (f33 (f34 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f28 (f33 (f34 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f28 (f33 (f34 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int)) (= (f28 (f33 (f34 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f33 (f34 ?v0) ?v1))) (= (= (f28 ?v_0 (- ?v2)) f1) (= (f28 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (= (f28 (f33 (f34 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 (f33 (f34 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 (f31 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (= (f24 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (= (f28 (f33 (f34 (f11 (f13 f14 ?v0) ?v3)) (f11 (f13 f14 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 ?v1))) (=> (< 0 (f11 f12 ?v0)) (=> (= (f28 ?v_0 ?v2) f1) (= (f28 ?v_0 (f11 (f13 f14 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 (f33 (f34 ?v0) ?v1) ?v2) f1) (= (f28 (f31 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 (f33 (f34 ?v0) 0) ?v1) f1) (= (f28 (f31 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 (f33 (f34 ?v0) 0) ?v1) f1) (= (f28 (f31 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f34 ?v1))) (=> (= (f24 ?v0) f1) (=> (< 0 ?v1) (=> (= (f28 (f33 (f34 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f28 (f33 ?v_0 1) ?v0) f1) (= (f28 (f33 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0) f1) (=> (< 0 ?v1) (=> (= (f28 (f33 (f34 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f28 (f33 (f34 ?v1) 0) ?v0) f1) (= (f28 (f33 (f34 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (not (= (f28 (f33 (f34 ?v2) 0) ?v0) f1))) (not (= (f28 (f33 (f34 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f28 (f33 (f34 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (=> (not (= (f28 (f33 (f34 ?v2) 0) ?v0) f1)) (not (= (f28 (f33 (f34 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 ?v1))) (=> (<= 0 ?v0) (=> (= (f24 ?v1) f1) (=> (= (f28 ?v_0 (* ?v0 ?v2)) f1) (or (= (f28 ?v_0 ?v0) f1) (= (f28 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 ?v0))) (=> (= (f24 ?v0) f1) (=> (= (f28 ?v_0 (* ?v1 ?v2)) f1) (or (= (f28 ?v_0 ?v1) f1) (= (f28 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f24 ?v1) f1) (= (f28 (f31 ?v1) ?v0) f1))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f28 (f31 (f11 (f13 f14 ?v1) ?v0)) (f11 (f13 f14 ?v2) ?v0)) f1) (= (f28 (f31 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (=> (= (f28 (f31 (f11 (f13 f14 ?v0) ?v1)) (f11 (f13 f14 ?v2) ?v1)) f1) (=> (not (= ?v1 (f6 f7 0))) (= (f28 (f31 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 (- 1)))) (let ((?v_1 (f11 ?v_0 ?v1)) (?v_2 (f11 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f28 (f33 (f34 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (= (f37 f38 (f39 f32 1)) (* (+ (* 4 f16) 1) f22)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f28 (f31 ?v0) ?v1) f1) (= (f28 (f31 (f11 (f13 f14 ?v0) ?v2)) (f11 (f13 f14 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f3 (f4 f41 ?v0) ?v2) (f3 (f4 f41 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f13 f14 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f28 (f31 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f41 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f40 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f37 f38 (f39 ?v0 ?v1)) (f37 f38 (f39 ?v2 ?v3))) (f37 f38 (f39 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int)) (= (f11 (f13 f14 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f41 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f42 (f11 (f13 f14 ?v0) ?v1)) (f11 (f13 f14 (f8 f42 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 (f13 f14 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f28 (f33 (f34 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f13 f14 ?v0))) (=> (= (f28 (f31 (f11 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f28 (f31 (f11 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f41 ?v0))) (=> (= (f40 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f40 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 S2)) (=> (= (f28 (f31 ?v0) ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f28 (f31 (f11 (f13 f14 ?v0) ?v2)) (f11 (f13 f14 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f40 ?v0 ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f40 (f3 (f4 f41 ?v0) ?v2) (f3 (f4 f41 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f37 f38 (f39 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f28 (f33 (f34 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f28 (f33 (f34 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (= (f28 (f33 (f34 (f8 (f9 f25 ?v1) ?v0)) (f11 (f13 f14 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (=> (not (= (f28 (f29 ?v0) ?v1) f1)) (= (f28 (f33 (f34 (f11 (f13 f14 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f8 (f9 f10 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f8 (f9 f10 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f8 (f9 f10 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (= (f28 (f33 (f34 ?v1) 0) ?v0) f1) (= (f28 (f33 (f34 0) (f11 (f13 f14 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (=> (= (f28 (f29 ?v0) ?v1) f1) (= (f28 (f33 (f34 (f11 (f13 f14 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f24 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (=> (not (= (f28 (f29 ?v0) ?v1) f1)) (= (f28 (f33 (f34 (f8 f43 ?v_0)) (f11 (f13 f14 ?v1) (f6 f7 (f8 (f9 f10 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f28 (f31 ?v0) ?v1) f1) (= (f11 (f13 f14 (f8 (f9 f10 ?v1) ?v0)) ?v2) (f8 (f9 f10 (f11 (f13 f14 ?v1) ?v2)) (f11 (f13 f14 ?v0) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f40 ?v0 ?v1) f1) (= (f3 (f4 f41 (f3 (f4 f44 ?v1) ?v0)) ?v2) (f3 (f4 f44 (f3 (f4 f41 ?v1) ?v2)) (f3 (f4 f41 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 (f31 ?v0) ?v1) f1) (= (* ?v0 (f8 (f9 f10 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v1) ?v0))) (=> (= (f28 (f31 ?v0) ?v1) f1) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)) (ite (< ?v0 0) (- ?v0) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1)))) (f6 f7 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S10) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f28 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f28 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f28 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) (- ?v1)) (f8 (f9 f10 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) (- ?v1)) (f8 (f9 f10 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f8 (f9 f10 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f8 (f9 f10 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f8 (f9 f10 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f8 (f9 f10 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v1))) (=> (< 0 ?v0) (= (f8 ?v_0 (* ?v2 ?v0)) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f8 (f9 f10 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f8 (f9 f10 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f8 (f9 f10 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f8 (f9 f10 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f8 (f9 f10 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f8 ?v_0 ?v2) (f8 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f8 (f9 f10 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f8 (f9 f10 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f8 (f9 f10 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f8 (f9 f10 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f8 (f9 f10 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f8 (f9 f10 ?v1) ?v2) (f8 (f9 f10 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f8 (f9 f10 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f31 ?v0))) (=> (= (f28 ?v_0 ?v1) f1) (=> (= (f28 ?v_0 ?v2) f1) (= (= (f28 (f31 (f8 (f9 f10 ?v1) ?v0)) (f8 (f9 f10 ?v2) ?v0)) f1) (= (f28 (f31 ?v1) ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 ?v0 ?v2) f1) (= (= (f40 (f3 (f4 f44 ?v1) ?v0) (f3 (f4 f44 ?v2) ?v0)) f1) (= (f40 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f13 f14 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f8 (f9 f10 (f11 ?v_0 ?v0)) ?v1) (f11 ?v_0 (f6 f7 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int)) (=> (= (f24 ?v0) f1) (= (f28 (f33 (f34 (f8 f43 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (f8 f43 ?v0) (ite (<= ?v0 0) 1 (* ?v0 (f8 f43 (- ?v0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f34 ?v2))) (=> (= (f24 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (=> (not (= (f28 (f33 ?v_0 0) ?v0) f1)) (=> (not (= (f28 (f29 ?v0) ?v1) f1)) (not (= (f28 (f33 ?v_0 (* ?v1 (f8 (f9 f45 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0))) (=> (< ?v_0 ?v_1) (= (f6 f7 (f8 (f9 f10 ?v_0) ?v_1)) (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f9 f10 (f11 f12 ?v2)))) (=> (< 0 ?v_0) (=> (<= ?v_0 ?v_1) (<= (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (=> (<= ?v_0 ?v_1) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (=> (< 1 ?v_1) (=> (< 0 ?v_0) (< (f8 (f9 f10 ?v_0) ?v_1) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (=> (not (< ?v_1 ?v_0)) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (ite (< ?v_1 ?v_0) (f6 f7 0) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (< 0 (f8 (f9 f10 (+ ?v_0 1)) 2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 1 ?v_0) (< 0 (f8 (f9 f10 ?v_0) 2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_0)) 2)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ (+ (+ ?v_0 1) 1) 1)) ?v_1)) (f6 f7 (f8 (f9 f10 (+ 3 ?v_0)) ?v_1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (f8 (f9 f10 (+ (+ ?v_0 1) 1)) 2)) (f6 f7 (+ (f8 (f9 f10 ?v_0) 2) 1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (+ (+ (+ ?v_1 1) 1) 1))) (f6 f7 (f8 ?v_0 (+ 3 ?v_1)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (+ 0 1))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= (f8 (f9 f10 ?v_0) (f11 f12 ?v1)) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f28 (f33 (f34 ?v1) ?v2) ?v0) f1) (= (f28 (f33 (f34 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f28 (f33 (f34 ?v1) ?v2) ?v0) f1) (= (f28 (f33 (f34 (* ?v3 (f8 ?v_0 ?v1))) (* ?v3 (f8 ?v_0 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f8 (f9 f45 ?v2) ?v3)))) (=> (= (f28 (f33 (f34 ?v0) ?v_0) ?v2) f1) (= (f28 (f33 (f34 (* ?v0 ?v3)) (* ?v_0 ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 (f9 f45 ?v3) ?v0))) (=> (= (f28 (f33 (f34 (* ?v0 ?v1)) ?v2) ?v3) f1) (= (f28 (f33 (f34 (* (* ?v_0 ?v0) ?v1)) (* ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f45 ?v0) ?v1) (f11 (f13 f14 ?v1) (f6 f7 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 (f9 f45 ?v0) ?v1))) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (=> (= (f28 (f33 (f34 (* (* ?v_0 ?v1) ?v2)) (* ?v_0 ?v3)) ?v0) f1) (= (f28 (f33 (f34 ?v2) (* ?v3 ?v_0)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f34 (* ?v2 ?v1)))) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (=> (= (f28 (f33 ?v_0 (* (* ?v3 (f8 (f9 f45 ?v0) ?v1)) ?v1)) ?v0) f1) (= (f28 (f33 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f34 ?v1)) (?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 ?v_1 0) ?v0) f1)) (=> (not (= (f28 (f33 (f34 ?v2) 0) ?v0) f1)) (=> (= (f28 (f33 (f34 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) ?v0) f1) (= (f28 (f33 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f34 ?v1)) (?v_0 (f34 ?v2)) (?v_2 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 ?v_1 0) ?v0) f1)) (=> (not (= (f28 (f33 ?v_0 0) ?v0) f1)) (=> (= (f28 (f33 ?v_0 (* ?v3 (f8 ?v_2 ?v1))) ?v0) f1) (= (f28 (f33 ?v_1 (* ?v3 (f8 ?v_2 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f34 ?v3)) (?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (=> (not (= (f28 (f33 (f34 ?v2) 0) ?v0) f1)) (=> (not (= (f28 (f33 ?v_1 0) ?v0) f1)) (=> (= (f28 (f33 (f34 (* ?v1 (f8 ?v_0 ?v3))) (* ?v1 (f8 ?v_0 ?v2))) ?v0) f1) (= (f28 (f33 ?v_1 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f45 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (= (f28 (f33 (f34 (* (* ?v1 ?v_1) (f8 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (= (f28 (f33 (f34 (* (f8 (f9 f45 ?v0) ?v1) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f45 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (let ((?v_2 (f8 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (= (f28 (f33 (f34 ?v_2) (* (* ?v1 ?v_1) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (= (f28 (f33 (f34 (f8 ?v_0 (f8 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (= (f28 (f33 (f34 (* ?v1 (f8 (f9 f45 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f24 ?v0) f1) (=> (not (= (f28 (f33 (f34 ?v1) 0) ?v0) f1)) (not (= (f28 (f33 (f34 (f8 (f9 f45 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f28 (f33 (f34 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f28 (f33 (f34 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f24 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f28 (f33 (f34 (* ?v1 (f8 (f9 f46 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (=> (= (f24 ?v0) f1) (= (f6 f47 ?v0) (f6 f7 (- ?v0 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (div ?v0 ?v1) (ite (<= 0 ?v1) (f8 ?v_0 ?v1) (- (f8 ?v_0 (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f8 (f9 f46 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f46 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f46 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f24 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f8 (f9 f46 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f8 (f9 f46 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f24 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f8 (f9 f46 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f46 ?v0))) (=> (= (f24 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f8 ?v_0 (f8 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f33 (f48 ?v1) ?v0))) (=> (= (f24 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f36 (f8 (f9 f46 ?v0) ?v2) ?v_1) f1) (= (f36 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f33 (f48 ?v1) ?v0))) (=> (= (f24 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f36 ?v2 ?v_0) f1) (= (f36 (f8 (f9 f46 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (not (= (f36 ?v1 (f33 (f48 (- ?v0 1)) ?v2)) f1)) (=> (= (f36 ?v1 (f33 (f48 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f8 (f9 f46 ?v2) ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f36 ?v0 (f33 (f48 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f36 ?v1 (f33 (f48 (- ?v0 1)) ?v2)) f1) (= (f36 ?v1 (f33 (f48 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f24 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f36 ?v2 (f33 (f48 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f36 ?v2 (f33 (f48 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f24 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f36 ?v2 (f33 (f48 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f24 ?v0) f1) (= (f49 ?v_0) (f33 (f48 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 (f31 ?v0) ?v1) f1) (= (f28 (f31 (- ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f36 ?v0 (f49 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f36 ?v0 (f49 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f36 ?v1 (f49 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f36 ?v0 (f49 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 0)) (= (= (f28 (f31 ?v1) ?v2) f1) (= (f28 (f31 (* ?v0 ?v1)) (* ?v0 ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f31 ?v0))) (= (= (f28 ?v_0 ?v1) f1) (= (f28 ?v_0 (- ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f40 (f6 f7 ?v0) (f6 f7 ?v1)) f1) (= (f28 (f31 ?v0) ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f28 (f31 (f11 f12 ?v0)) (f11 f12 ?v1)) f1) (= (f40 ?v0 ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f41 ?v0))) (=> (= (f40 (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) f1) (=> (< 1 (f11 f12 ?v0)) (<= (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (=> (= (f40 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (< 0 (f11 f12 ?v0)) (=> (= (f40 ?v1 ?v0) f1) (< 0 (f11 f12 ?v1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (=> (= (f40 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f40 (f3 (f4 f41 ?v1) ?v0) (f3 (f4 f41 ?v2) ?v0)) f1) (= (f40 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f40 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f40 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (= (not (= ?v0 ?v_0)) (and (= (f40 ?v0 ?v_0) f1) (not (= (f40 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (not (= ?v0 ?v_0)) (and (= (f40 ?v_0 ?v0) f1) (not (= (f40 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S2)) (= (f40 ?v0 (f6 f7 0)) f1)))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f8 (f9 f10 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f8 (f9 f50 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
