(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 () Int)
(declare-fun f8 () Int)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 (S5 Int) S3)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 () S2)
(declare-fun f15 () S3)
(declare-fun f16 () Int)
(declare-fun f17 (Int) S1)
(declare-fun f18 (Int) S1)
(declare-fun f19 (S6 Int) Int)
(declare-fun f20 (S7 Int) S6)
(declare-fun f21 () S7)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 (Int Int) S1)
(declare-fun f25 () S3)
(declare-fun f26 (Int Int) S1)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int Int) S1)
(declare-fun f29 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f11 f12 2))) (not (= (+ (f3 (f4 f5 (+ (+ (* f6 f7) (* f8 f9)) f10)) ?v_0) (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_0)) (* (+ (* 4 f13) 1) f10)))))
(assert (let ((?v_0 (f11 f12 2))) (= (* (f3 (f4 f5 (+ 1 (f3 f14 f15))) ?v_0) (- (- (* (+ (* 4 f13) 1) f10) (f3 (f4 f5 (+ (+ (* f6 f7) (* f8 f9)) f10)) ?v_0)) (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_0))) 0)))
(assert (not (= (f3 (f4 f5 (+ 1 (f3 f14 f15))) (f11 f12 2)) 0)))
(assert (< 1 f16))
(assert (not (= (f3 (f4 f5 (+ 1 (f3 f14 f15))) (f11 f12 2)) 0)))
(assert (< 0 (+ 1 (f3 f14 f15))))
(assert (not (= (f17 (* (+ (* 4 f13) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f13) 1)))
(assert (let ((?v_0 (+ (* 4 f13) 1)) (?v_1 (+ 1 (f3 f14 f15)))) (not (=> (< ?v_1 ?v_0) (not (= (f17 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f14 f15)) f10))))
(assert (< f10 (+ 1 (f3 f14 f15))))
(assert (let ((?v_0 (f11 f12 2))) (= (* (f3 (f4 f5 (+ 1 (f3 f14 f15))) ?v_0) (- (- (* (+ (* 4 f13) 1) f10) (f3 (f4 f5 (+ (+ (* f6 f7) (* f8 f9)) f10)) ?v_0)) (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_0))) 0)))
(assert (= (f18 (+ (* 4 f13) 1)) f1))
(assert (= (f19 (f20 f21 (- 1)) (+ (* 4 f13) 1)) 1))
(assert (let ((?v_3 (f11 f12 2)) (?v_0 (+ 1 (f3 f14 f15)))) (let ((?v_1 (+ (* f6 ?v_0) f7)) (?v_2 (+ (* f8 ?v_0) f9))) (= (+ (f3 (f4 f5 (+ (* ?v_1 f7) (* ?v_2 f9))) ?v_3) (f3 (f4 f5 (- (* ?v_1 f9) (* ?v_2 f7))) ?v_3)) (+ (f3 (f4 f5 (+ (+ (* ?v_0 (* f6 f7)) (* ?v_0 (* f8 f9))) (+ (f3 (f4 f5 f7) ?v_3) (f3 (f4 f5 f9) ?v_3)))) ?v_3) (f3 (f4 f5 (- (* ?v_0 (* f6 f9)) (* ?v_0 (* f8 f7)))) ?v_3))))))
(assert (let ((?v_1 (f11 f12 2)) (?v_0 (+ 1 (f3 f14 f15)))) (let ((?v_2 (+ (* ?v_0 (* f6 f7)) (* ?v_0 (* f8 f9)))) (?v_3 (f3 (f4 f5 (- (* ?v_0 (* f6 f9)) (* ?v_0 (* f8 f7)))) ?v_1))) (= (+ (f3 (f4 f5 (+ ?v_2 (+ (f3 (f4 f5 f7) ?v_1) (f3 (f4 f5 f9) ?v_1)))) ?v_1) ?v_3) (+ (f3 (f4 f5 (+ ?v_2 (* ?v_0 f10))) ?v_1) ?v_3)))))
(assert (let ((?v_1 (f11 f12 2))) (let ((?v_0 (f3 (f4 f5 (+ 1 (f3 f14 f15))) ?v_1))) (= (* ?v_0 (* (+ (* 4 f13) 1) f10)) (* ?v_0 (+ (f3 (f4 f5 (+ (+ (* f6 f7) (* f8 f9)) f10)) ?v_1) (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_1)))))))
(assert (let ((?v_0 (f11 f12 2)) (?v_1 (+ 1 (f3 f14 f15)))) (let ((?v_2 (f3 (f4 f5 ?v_1) ?v_0))) (= (* (* (+ (* 4 f13) 1) ?v_1) (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0))) (+ (* ?v_2 (f3 (f4 f5 (+ (+ (* f6 f7) (* f8 f9)) f10)) ?v_0)) (* ?v_2 (f3 (f4 f5 (- (* f6 f9) (* f8 f7))) ?v_0)))))))
(assert (let ((?v_0 (f11 f12 2)) (?v_1 (+ 1 (f3 f14 f15)))) (= (* (* (+ (* 4 f13) 1) ?v_1) (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0))) (+ (f3 (f4 f5 (+ (+ (* ?v_1 (* f6 f7)) (* ?v_1 (* f8 f9))) (* ?v_1 f10))) ?v_0) (f3 (f4 f5 (- (* ?v_1 (* f6 f9)) (* ?v_1 (* f8 f7)))) ?v_0)))))
(assert (let ((?v_0 (+ 1 (f3 f14 f15)))) (and (= f7 (- f22 (* f6 ?v_0))) (<= (* 2 (ite (< f7 0) (- f7) f7)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f14 f15)))) (and (= f9 (- f23 (* f8 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f11 f12 2))) (=> (= (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f14 f15)) ?v0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f13) 1) (+ 1 (f3 f14 f15)))) false))) false))
(assert (= (f24 (+ (* 4 f13) 1) (- 1)) f1))
(assert (= f25 (f11 f12 (- (f3 f14 (f11 f12 f16)) 1))))
(assert (< f16 (+ (* 4 f13) 1)))
(assert (let ((?v_0 (+ (* 4 f13) 1)) (?v_1 (+ 1 (f3 f14 f15)))) (and (< ?v_1 ?v_0) (= (f17 (* ?v_0 ?v_1)) f1))))
(assert (let ((?v_0 (f11 f12 2)) (?v_1 (+ 1 (f3 f14 f15)))) (let ((?v_2 (+ (* f6 ?v_1) f7)) (?v_3 (+ (* f8 ?v_1) f9))) (= (+ (f3 (f4 f5 (+ (* f22 f7) (* f23 f9))) ?v_0) (f3 (f4 f5 (- (* f22 f9) (* f23 f7))) ?v_0)) (+ (f3 (f4 f5 (+ (* ?v_2 f7) (* ?v_3 f9))) ?v_0) (f3 (f4 f5 (- (* ?v_2 f9) (* ?v_3 f7))) ?v_0))))))
(assert (let ((?v_0 (f11 f12 2))) (= (f26 (+ 1 (f3 f14 f15)) (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0))) f1)))
(assert (= (+ (f3 (f4 f5 f27) (f11 f12 2)) 1) (* (+ (* 4 f13) 1) f16)))
(assert (= (f28 (f3 (f4 f5 f29) (f11 f12 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f27) (f11 f12 2)) 1) (* (+ (* 4 f13) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f3 (f4 f5 f27) (f11 f12 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (< 0 (f3 f14 f15)))
(assert (< 0 (f3 f14 f25)))
(assert (<= 1 f16))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f28 f29 f27 ?v_0) f1)))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f11 f12 (- (f3 f14 (f11 f12 f16)) 1))) (=> (< 0 (f3 f14 ?v0)) false))) false))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f3 (f4 f5 f22) ?v_0) (f3 (f4 f5 f23) ?v_0)) (* (+ (* 4 f13) 1) (+ 1 (f3 f14 f15))))))
(assert (let ((?v_0 (+ (* 4 f13) 1))) (=> (not (= (f24 ?v_0 (- 1)) f1)) (not (= (f19 (f20 f21 (- 1)) ?v_0) 1)))))
(assert (= (f17 (* (+ (* 4 f13) 1) f16)) f1))
(assert (= (f28 (f3 (f4 f5 f27) (f11 f12 2)) (- 1) (+ (* 4 f13) 1)) f1))
(assert (= (f26 (+ (* 4 f13) 1) (- (f3 (f4 f5 f27) (f11 f12 2)) (- 1))) f1))
(assert (= (f26 (+ (* 4 f13) 1) (+ (f3 (f4 f5 f27) (f11 f12 2)) 1)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f14 f15)))) (=> (and (= ?v1 (- f22 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f14 f15)))) (=> (and (= ?v1 (- f23 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int)) (=> (= (f28 (f3 (f4 f5 ?v0) (f11 f12 2)) (- 1) (+ (* 4 f13) 1)) f1) false)) false))
(assert (let ((?v_0 (f11 f12 2))) (= (f28 (f3 (f4 f5 f27) ?v_0) (f3 (f4 f5 f29) ?v_0) (+ (* 4 f13) 1)) f1)))
(assert (let ((?v_0 (f11 f12 2))) (= (* (+ (f3 (f4 f5 f22) ?v_0) (f3 (f4 f5 f23) ?v_0)) (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0))) (+ (f3 (f4 f5 (+ (* f22 f7) (* f23 f9))) ?v_0) (f3 (f4 f5 (- (* f22 f9) (* f23 f7))) ?v_0)))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f29 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f13) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f29 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f28 f29 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (let ((?v_0 (f11 f12 2))) (let ((?v_1 (+ (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f9) ?v_0)))) (= (* (* (+ (* 4 f13) 1) (+ 1 (f3 f14 f15))) ?v_1) (* (+ (f3 (f4 f5 f22) ?v_0) (f3 (f4 f5 f23) ?v_0)) ?v_1)))))
(assert (=> (= f16 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f13) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f18 ?v_0) f1) (= (f19 (f20 f21 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (= (f17 ?v1) f1) (= (f17 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 ?v0) f1) (=> (not (= (f26 ?v0 ?v1) f1)) (= (f28 (f3 (f4 f5 ?v1) (f11 f12 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 (f20 f21 ?v0) ?v1) (ite (= (f28 ?v0 0 ?v1) f1) 0 (ite (= (f24 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f24 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f28 (f3 (f4 f5 ?v2) (f11 f12 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f18 ?v0) f1) (=> (not (= (f26 ?v0 ?v1) f1)) (=> (= (f26 ?v_0 (* ?v1 ?v3)) f1) (= (f26 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f18 ?v0) f1) (=> (not (= (f26 ?v0 ?v1) f1)) (=> (= (f26 ?v_0 (* ?v3 ?v1)) f1) (= (f26 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f18 ?v0) f1) (=> (= (f26 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f26 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f18 ?v0) f1) (=> (= (f26 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f14 ?v2)) (= (f26 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f28 ?v0 0 ?v1) f1)) (=> (= (f28 (f3 (f4 f5 ?v2) (f11 f12 2)) ?v0 ?v1) f1) (not (= (f26 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f18 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f26 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f11 f12 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f11 f12 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 S3)) (= (f11 f12 (f3 f14 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f14 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f14 (f11 f12 ?v0)) 0))))
(check-sat)
(exit)
