(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () S2)
(declare-fun f12 () S3)
(declare-fun f13 () S3)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (Int Int) S1)
(declare-fun f22 (Int) S1)
(declare-fun f23 (Int) S1)
(declare-fun f24 (S6 Int) Int)
(declare-fun f25 (S7 Int) S6)
(declare-fun f26 () S7)
(assert (not (= f1 f2)))
(assert (not (<= 0 (f3 (f4 f5 f6) (f7 f8 2)))))
(assert (< 1 f9))
(assert (not (= f10 0)))
(assert (< 0 (f3 f11 f12)))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f6) ?v_0)) 0)))
(assert (= f13 (f7 f8 (- (f3 f11 (f7 f8 f9)) 1))))
(assert (< 0 (f3 (f4 f5 f10) (f7 f8 2))))
(assert (let ((?v_0 (f3 (f4 f5 f14) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f11 ?v1) (f3 f11 ?v2)))) (* (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (* ?v0 (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (< 0 (f3 f11 f13)))
(assert (< 0 (+ 1 (f3 f11 f12))))
(assert (<= 1 f9))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f11 (f7 f8 f9)) 1))) (=> (< 0 (f3 f11 ?v0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f6) ?v_0)) (* (+ 1 (f3 f11 f12)) f15))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f10 (- f16 (* f17 ?v_0))) (<= (* 2 (ite (< f10 0) (- f10) f10)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f6 (- f18 (* f19 ?v_0))) (<= (* 2 (ite (< f6 0) (- f6) f6)) ?v_0))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f6) ?v_0)) (* (+ 1 (f3 f11 f12)) ?v0)) false))) false))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (< f15 (+ 1 (f3 f11 f12))))
(assert (= (+ (f3 (f4 f5 f14) (f7 f8 2)) 1) (* (+ (* 4 f20) 1) f9)))
(assert (let ((?v_0 (f7 f8 2))) (= (f21 (+ 1 (f3 f11 f12)) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f6) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f16 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f18 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (< f9 (+ (* 4 f20) 1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f14) (f7 f8 2)) 1) (* (+ (* 4 f20) 1) ?v0)) false)) false))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f20) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f22 (* ?v_0 ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (* ?v1 (f3 ?v_0 (f7 f8 (- (f3 f11 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f4 f5 ?v0) ?v1)))))
(assert (not (= (f22 (* (+ (* 4 f20) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f20) 1)))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f20) 1))) (and (< ?v_1 ?v_0) (= (f22 (* ?v_0 ?v_1)) f1))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f18) ?v_0)) (* (+ (* 4 f20) 1) (+ 1 (f3 f11 f12))))))
(assert (= (f22 (* (+ (* 4 f20) 1) f9)) f1))
(assert (= (f22 (* (+ (* 4 f20) 1) f15)) f1))
(assert (= (f21 (+ (* 4 f20) 1) (+ (f3 (f4 f5 f14) (f7 f8 2)) 1)) f1))
(assert (= (f21 (+ (* 4 f20) 1) (- (f3 (f4 f5 f14) (f7 f8 2)) (- 1))) f1))
(assert (= (f23 (+ (* 4 f20) 1)) f1))
(assert (= (f24 (f25 f26 (- 1)) (+ (* 4 f20) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f20) 1) (+ 1 (f3 f11 f12)))) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 (+ (+ (* f17 f10) (* f19 f6)) f15)) ?v_0) (f3 (f4 f5 (- (* f17 f6) (* f19 f10))) ?v_0)) (* (+ (* 4 f20) 1) f15))))
(assert (=> (= f9 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f20) 1))))))
(assert (forall ((?v0 Int)) (= (= (f21 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f21 ?v0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f21 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f21 (* ?v0 ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f21 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f21 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f21 ?v0 ?v1) f1) (= (= (f21 ?v0 (+ ?v2 ?v3)) f1) (= (f21 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f11 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f11 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f11 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
