(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int Int) S1)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 () S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 (S4 Int) S2)
(declare-fun f9 () S4)
(declare-fun f10 () Int)
(declare-fun f11 (S5 Int) S3)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 (Int) S1)
(declare-fun f16 (Int) S1)
(declare-fun f17 (S6 Int) Int)
(declare-fun f18 (S7 Int) S6)
(declare-fun f19 () S7)
(declare-fun f20 () Int)
(declare-fun f21 (Int Int) S1)
(declare-fun f22 () S3)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int Int) S1)
(declare-fun f29 () Int)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ 1 (f4 f5 f6)))) (not (= (f3 (* ?v_0 ?v_0) (* ?v_0 (+ (* 4 f7) 1))) f1))))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f4 (f8 f9 f10) ?v_0) (f4 (f8 f9 f13) ?v_0)) (* (+ (* 4 f7) 1) (+ 1 (f4 f5 f6))))))
(assert (let ((?v_0 (f11 f12 2))) (= (f3 (f4 (f8 f9 (+ 1 (f4 f5 f6))) ?v_0) (+ (f4 (f8 f9 f10) ?v_0) (f4 (f8 f9 f13) ?v_0))) f1)))
(assert (< 1 f14))
(assert (< 0 (f4 f5 f6)))
(assert (let ((?v_0 (f11 f12 2))) (= (f3 (f4 (f8 f9 (+ 1 (f4 f5 f6))) ?v_0) (+ (f4 (f8 f9 f10) ?v_0) (f4 (f8 f9 f13) ?v_0))) f1)))
(assert (not (= (f15 (* (+ (* 4 f7) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f7) 1)))
(assert (< 0 (+ 1 (f4 f5 f6))))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f4 (f8 f9 f10) ?v_0) (f4 (f8 f9 f13) ?v_0)) (* (+ (* 4 f7) 1) (+ 1 (f4 f5 f6))))))
(assert (let ((?v_1 (+ 1 (f4 f5 f6))) (?v_0 (+ (* 4 f7) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f15 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f4 f5 f6)))) (and (= (f3 ?v_0 f10) f1) (= (f3 ?v_0 f13) f1))))
(assert (= (f16 (+ (* 4 f7) 1)) f1))
(assert (= (f17 (f18 f19 (- 1)) (+ (* 4 f7) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f5 f6)))) (=> (and (= ?v1 (- f10 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f5 f6)))) (=> (and (= ?v1 (- f13 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_1 (+ 1 (f4 f5 f6))) (?v_0 (+ (* 4 f7) 1))) (and (< ?v_1 ?v_0) (= (f15 (* ?v_0 ?v_1)) f1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (=> (= (+ (f4 (f8 f9 ?v0) ?v_0) (f4 (f8 f9 ?v1) ?v_0)) (* (+ (* 4 f7) 1) (+ 1 (f4 f5 f6)))) false))) false))
(assert (let ((?v_0 (f11 f12 2))) (let ((?v_1 (f4 (f8 f9 (+ 1 (f4 f5 f6))) ?v_0))) (and (= (f3 ?v_1 (f4 (f8 f9 f10) ?v_0)) f1) (= (f3 ?v_1 (f4 (f8 f9 f13) ?v_0)) f1)))))
(assert (< f20 (+ 1 (f4 f5 f6))))
(assert (= (f21 (+ (* 4 f7) 1) (- 1)) f1))
(assert (= f22 (f11 f12 (- (f4 f5 (f11 f12 f14)) 1))))
(assert (< f14 (+ (* 4 f7) 1)))
(assert (let ((?v_0 (+ 1 (f4 f5 f6)))) (and (= f23 (- f10 (* f24 ?v_0))) (<= (* 2 (ite (< f23 0) (- f23) f23)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f4 f5 f6)))) (and (= f25 (- f13 (* f26 ?v_0))) (<= (* 2 (ite (< f25 0) (- f25) f25)) ?v_0))))
(assert (= (f3 (+ (* 4 f7) 1) (+ (f4 (f8 f9 f27) (f11 f12 2)) 1)) f1))
(assert (= (f3 (+ (* 4 f7) 1) (- (f4 (f8 f9 f27) (f11 f12 2)) (- 1))) f1))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (=> (not (= (f21 ?v_0 (- 1)) f1)) (not (= (f17 (f18 f19 (- 1)) ?v_0) 1)))))
(assert (= (f15 (* (+ (* 4 f7) 1) f20)) f1))
(assert (forall ((?v0 Int)) (= (f3 ?v0 (ite (< ?v0 0) (- ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (= (f3 (ite (< ?v0 0) (- ?v0) ?v0) ?v0) f1)))
(assert (< 0 (f4 f5 f22)))
(assert (<= 1 f14))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f4 (f8 f9 f23) ?v_0) (f4 (f8 f9 f25) ?v_0)) 0)))
(assert (let ((?v_0 (f4 (f8 f9 f27) (f11 f12 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (+ (f4 (f8 f9 f27) (f11 f12 2)) 1) (* (+ (* 4 f7) 1) f14)))
(assert (and (= f23 0) (= f25 0)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f11 f12 (- (f4 f5 (f11 f12 f14)) 1))) (=> (< 0 (f4 f5 ?v0)) false))) false))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f4 (f8 f9 f23) ?v_0) (f4 (f8 f9 f25) ?v_0)) (* (+ 1 (f4 f5 f6)) f20))))
(assert (let ((?v_0 (f11 f12 2))) (=> (not (= f23 0)) (< 0 (+ (f4 (f8 f9 f23) ?v_0) (f4 (f8 f9 f25) ?v_0))))))
(assert (let ((?v_0 (f11 f12 2))) (=> (not (= f25 0)) (< 0 (+ (f4 (f8 f9 f23) ?v_0) (f4 (f8 f9 f25) ?v_0))))))
(assert (= (f15 (* (+ (* 4 f7) 1) f14)) f1))
(assert (let ((?v_0 (f11 f12 2))) (= (f3 (+ 1 (f4 f5 f6)) (+ (f4 (f8 f9 f23) ?v_0) (f4 (f8 f9 f25) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f4 (f8 f9 f27) (f11 f12 2)) 1) (* (+ (* 4 f7) 1) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f11 f12 2))) (=> (= (+ (f4 (f8 f9 f23) ?v_0) (f4 (f8 f9 f25) ?v_0)) (* (+ 1 (f4 f5 f6)) ?v0)) false))) false))
(assert (let ((?v_0 (f11 f12 2))) (= (+ (f4 (f8 f9 (+ (+ (* f24 f23) (* f26 f25)) f20)) ?v_0) (f4 (f8 f9 (- (* f24 f25) (* f26 f23))) ?v_0)) (* (+ (* 4 f7) 1) f20))))
(assert (=> (= f14 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (+ (f4 (f8 f9 ?v0) ?v_0) (f4 (f8 f9 ?v1) ?v_0)) (+ (* 4 f7) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f16 ?v_0) f1) (= (f17 (f18 f19 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (= (f15 ?v1) f1) (= (f15 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f16 ?v0) f1) (=> (= (f3 ?v0 (f4 (f8 f9 ?v1) ?v2)) f1) (=> (< 0 (f4 f5 ?v2)) (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f16 ?v0) f1) (=> (= (f3 ?v0 (f4 (f8 f9 ?v1) ?v2)) f1) (= (f3 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f8 f9 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 ?v_0 (* ?v3 ?v1)) f1) (= (f3 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f8 f9 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 ?v_0 (* ?v1 ?v3)) f1) (= (f3 ?v_0 ?v3) f1)))))))
(assert (= (f28 (f4 (f8 f9 f27) (f11 f12 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f28 f29 f27 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f16 ?v1) f1) (=> (= (f3 ?v1 (* ?v0 ?v2)) f1) (or (= (f3 ?v1 ?v0) f1) (= (f3 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (= (f3 ?v0 (* ?v1 ?v2)) f1) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f16 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f3 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (= (f28 (f4 (f8 f9 f29) (f11 f12 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f28 (f4 (f8 f9 ?v0) (f11 f12 2)) (- 1) (+ (* 4 f7) 1)) f1) false)) false))
(assert (let ((?v_0 (f11 f12 2))) (= (f28 (f4 (f8 f9 f27) ?v_0) (f4 (f8 f9 f29) ?v_0) (+ (* 4 f7) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f29 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f28 f29 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f29 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (=> (= (f28 ?v3 ?v4 ?v2) f1) (= (f28 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (=> (= (f28 ?v3 ?v4 ?v2) f1) (= (f28 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (=> (= (f28 ?v3 ?v4 ?v2) f1) (= (f28 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (=> (= (f28 ?v1 ?v3 ?v2) f1) (= (f28 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f28 ?v3 ?v4 ?v2) f1) (= (f28 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (= (f28 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (= (f28 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (= (f28 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (= (= (f28 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f28 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (= (= (f28 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f28 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f28 ?v1 (- 1) ?v0) f1) (not (= (f28 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f28 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f28 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f28 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f28 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f28 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f28 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f28 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f28 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f28 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int)) (= (f28 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 ?v1 (- ?v2)) f1) (= (f28 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 ?v1 ?v2) f1) (= (f28 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 ?v1 ?v2) f1) (= (f3 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f28 ?v0 ?v1 ?v2) f1) (= (f28 (f4 (f8 f9 ?v0) ?v3) (f4 (f8 f9 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f28 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f28 ?v1 1 ?v0) f1) (= (f28 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f28 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f28 ?v1 0 ?v0) f1) (= (f28 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f28 ?v1 0 ?v0) f1)) (not (= (f28 ?v2 0 ?v0) f1))) (not (= (f28 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f28 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f28 ?v1 0 ?v0) f1)) (=> (not (= (f28 ?v2 0 ?v0) f1)) (not (= (f28 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f4 (f8 f9 ?v0) (f11 f12 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (= (f4 (f8 f9 ?v0) ?v_0) (f4 (f8 f9 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 2)) (?v_1 (f8 f9 ?v0))) (= (f4 (f8 f9 (f4 ?v_1 ?v_0)) ?v_0) (f4 ?v_1 (f11 f12 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f4 (f8 f9 ?v0) ?v_0) (f4 (f8 f9 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f11 f12 2)) (?v_0 (f11 f12 3)) (?v_3 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (f4 (f8 f9 (- ?v0 ?v1)) ?v_0) (- (+ (- (f4 ?v_1 ?v_0) (* (* 3 (f4 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f4 ?v_3 ?v_2))) (f4 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f11 f12 2)) (?v_0 (f11 f12 3)) (?v_1 (f8 f9 ?v0)) (?v_3 (f8 f9 ?v1))) (= (f4 (f8 f9 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f4 ?v_1 ?v_0) (* (* 3 (f4 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f4 ?v_3 ?v_2))) (f4 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (f4 (f8 f9 (- ?v0 ?v1)) ?v_0) (+ (- (f4 (f8 f9 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f4 (f8 f9 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 2))) (= (f4 (f8 f9 (+ ?v0 ?v1)) ?v_0) (+ (+ (f4 (f8 f9 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f4 (f8 f9 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 3))) (= (f4 (f8 f9 (- ?v0)) ?v_0) (- (f4 (f8 f9 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 ?v0))) (= (* ?v0 (f4 ?v_0 (f11 f12 2))) (f4 ?v_0 (f11 f12 3))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f11 f12 3))) (let ((?v_0 (f4 (f8 f9 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f4 (f8 f9 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f11 f12 2))) (let ((?v_0 (f4 (f8 f9 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f4 (f8 f9 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f4 (f8 f9 ?v0) (f11 f12 2)))))
(assert (= (f16 2) f1))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f4 f5 ?v0)) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v1 (f4 (f8 f9 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f3 ?v0 ?v1) f1)) (= (f28 (f4 (f8 f9 ?v1) (f11 f12 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 (f18 f19 ?v0) ?v1) (ite (= (f28 ?v0 0 ?v1) f1) 0 (ite (= (f21 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f28 (f4 (f8 f9 ?v2) (f11 f12 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f28 ?v0 0 ?v1) f1)) (=> (= (f28 (f4 (f8 f9 ?v2) (f11 f12 2)) ?v0 ?v1) f1) (not (= (f3 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f16 ?v1) f1) (= (f3 ?v1 ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f11 f12 0))) (= (= (f3 (f4 (f8 f9 ?v1) ?v0) (f4 (f8 f9 ?v2) ?v0)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f3 (f4 (f8 f9 ?v0) ?v1) (f4 (f8 f9 ?v2) ?v1)) f1) (=> (not (= ?v1 (f11 f12 0))) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f11 f12 ?v0))) (=> (< 0 ?v0) (= (f4 ?v_0 ?v_1) (* ?v1 (f4 ?v_0 (f11 f12 (- (f4 f5 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f8 f9 (- 1)))) (let ((?v_1 (f4 ?v_0 ?v1)) (?v_2 (f4 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f28 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (= (f30 f31 (f32 f27 1)) (* (+ (* 4 f7) 1) f14)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f3 (f4 ?v_0 ?v1) ?v2) f1) (=> (<= (f4 f5 ?v3) (f4 f5 ?v1)) (= (f3 (f4 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f3 ?v0 ?v1) f1) (=> (<= (f4 f5 ?v2) (f4 f5 ?v3)) (= (f3 (f4 (f8 f9 ?v0) ?v2) (f4 (f8 f9 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f30 f31 (f32 ?v0 ?v1)) (f30 f31 (f32 ?v2 ?v3))) (f30 f31 (f32 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int)) (= (f4 (f8 f9 ?v0) (f11 f12 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f11 f12 (f4 f5 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f5 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f5 (f11 f12 ?v0)) 0))))
(check-sat)
(exit)
