(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 () S2)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () S2)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 (S9 Int) S1)
(declare-fun f26 (Int) S9)
(declare-fun f27 (S10 Int) S8)
(declare-fun f28 () S10)
(declare-fun f29 (Int) S1)
(declare-fun f30 () S7)
(declare-fun f31 () Int)
(declare-fun f32 (Int) S9)
(declare-fun f33 (S2 S2) S1)
(declare-fun f34 () S4)
(declare-fun f35 () S6)
(declare-fun f36 (S11 Int) S9)
(declare-fun f37 (Int) S11)
(declare-fun f38 () Int)
(declare-fun f39 (S12 S13) Int)
(declare-fun f40 () S12)
(declare-fun f41 (Int Int) S13)
(declare-fun f42 (Int S9) S1)
(declare-fun f43 () S6)
(declare-fun f44 () S4)
(declare-fun f45 () S7)
(declare-fun f46 () S7)
(declare-fun f47 () S5)
(declare-fun f48 (Int) S11)
(declare-fun f49 (Int) S9)
(declare-fun f50 () S7)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (not (not (= (+ 1 (f11 f12 f13)) 0))))
(assert (< 0 (+ 1 (f11 f12 f13))))
(assert (< 1 f14))
(assert (< 0 (+ 1 (f11 f12 f13))))
(assert (< 0 (f11 f12 f13)))
(assert (< f15 (+ 1 (f11 f12 f13))))
(assert (= f16 (f6 f7 (- (f11 f12 (f6 f7 f14)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f13)))) (=> (and (= ?v1 (- f17 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f13)))) (=> (and (= ?v1 (- f18 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_1 (+ 1 (f11 f12 f13))) (?v_0 (+ (* 4 f19) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (and (= f21 (- f17 (* f22 ?v_0))) (<= (* 2 (ite (< f21 0) (- f21) f21)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (and (= f23 (- f18 (* f24 ?v_0))) (<= (* 2 (ite (< f23 0) (- f23) f23)) ?v_0))))
(assert (<= 1 f14))
(assert (let ((?v_1 (+ 1 (f11 f12 f13))) (?v_0 (+ (* 4 f19) 1))) (and (< ?v_1 ?v_0) (= (f20 (* ?v_0 ?v_1)) f1))))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (= (f25 (f26 (* ?v_0 ?v_0)) (* ?v_0 (+ (* 4 f19) 1))) f1)))
(assert (let ((?v_0 (f26 (+ 1 (f11 f12 f13))))) (and (= (f25 ?v_0 f17) f1) (= (f25 ?v_0 f18) f1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (+ (f11 (f27 f28 ?v0) ?v_0) (f11 (f27 f28 ?v1) ?v_0)) (* (+ (* 4 f19) 1) (+ 1 (f11 f12 f13)))) false))) false))
(assert (not (= (f20 (* (+ (* 4 f19) 1) (+ 1 0))) f1)))
(assert (< 0 (f11 f12 f16)))
(assert (< 0 (+ (* 4 f19) 1)))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f27 f28 f21) ?v_0) (f11 (f27 f28 f23) ?v_0)) 0)))
(assert (< f14 (+ (* 4 f19) 1)))
(assert (and (= f21 0) (= f23 0)))
(assert (=> (forall ((?v0 S2)) (=> (= ?v0 (f6 f7 (- (f11 f12 (f6 f7 f14)) 1))) (=> (< 0 (f11 f12 ?v0)) false))) false))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f27 f28 f17) ?v_0) (f11 (f27 f28 f18) ?v_0)) (* (+ (* 4 f19) 1) (+ 1 (f11 f12 f13))))))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f27 f28 f21) ?v_0) (f11 (f27 f28 f23) ?v_0)) (* (+ 1 (f11 f12 f13)) f15))))
(assert (let ((?v_0 (f6 f7 2))) (=> (not (= f21 0)) (< 0 (+ (f11 (f27 f28 f21) ?v_0) (f11 (f27 f28 f23) ?v_0))))))
(assert (let ((?v_0 (f6 f7 2))) (=> (not (= f23 0)) (< 0 (+ (f11 (f27 f28 f21) ?v_0) (f11 (f27 f28 f23) ?v_0))))))
(assert (= (f20 (* (+ (* 4 f19) 1) f14)) f1))
(assert (= (f20 (* (+ (* 4 f19) 1) f15)) f1))
(assert (= (f29 (+ (* 4 f19) 1)) f1))
(assert (= (f8 (f9 f30 (- 1)) (+ (* 4 f19) 1)) 1))
(assert (let ((?v_0 (f6 f7 2))) (= (f25 (f26 (+ 1 (f11 f12 f13))) (+ (f11 (f27 f28 f21) ?v_0) (f11 (f27 f28 f23) ?v_0))) f1)))
(assert (let ((?v_0 (f6 f7 2))) (let ((?v_1 (f26 (f11 (f27 f28 (+ 1 (f11 f12 f13))) ?v_0)))) (and (= (f25 ?v_1 (f11 (f27 f28 f17) ?v_0)) f1) (= (f25 ?v_1 (f11 (f27 f28 f18) ?v_0)) f1)))))
(assert (let ((?v_0 (f6 f7 2))) (= (f25 (f26 (f11 (f27 f28 (+ 1 (f11 f12 f13))) ?v_0)) (+ (f11 (f27 f28 f17) ?v_0) (f11 (f27 f28 f18) ?v_0))) f1)))
(assert (= (+ (f11 (f27 f28 f31) (f6 f7 2)) 1) (* (+ (* 4 f19) 1) f14)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (+ (f11 (f27 f28 f21) ?v_0) (f11 (f27 f28 f23) ?v_0)) (* (+ 1 (f11 f12 f13)) ?v0)) false))) false))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f27 f28 (+ (+ (* f22 f21) (* f24 f23)) f15)) ?v_0) (f11 (f27 f28 (- (* f22 f23) (* f24 f21))) ?v_0)) (* (+ (* 4 f19) 1) f15))))
(assert (=> (= f14 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f27 f28 ?v0) ?v_0) (f11 (f27 f28 ?v1) ?v_0)) (+ (* 4 f19) 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (= (f20 ?v1) f1) (= (f20 (* ?v0 ?v1)) f1)))))
(assert (= (f25 (f32 (+ (* 4 f19) 1)) (- 1)) f1))
(assert (= (f25 (f26 (+ (* 4 f19) 1)) (+ (f11 (f27 f28 f31) (f6 f7 2)) 1)) f1))
(assert (= (f25 (f26 (+ (* 4 f19) 1)) (- (f11 (f27 f28 f31) (f6 f7 2)) (- 1))) f1))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f25 (f26 (f11 (f27 f28 ?v1) ?v0)) (f11 (f27 f28 ?v2) ?v0)) f1) (= (f25 (f26 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 ?v1))) (=> (< 0 (f11 f12 ?v0)) (=> (= (f25 ?v_0 ?v2) f1) (= (f25 ?v_0 (f11 (f27 f28 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (=> (= (f25 (f26 (f11 (f27 f28 ?v0) ?v1)) (f11 (f27 f28 ?v2) ?v1)) f1) (=> (not (= ?v1 (f6 f7 0))) (= (f25 (f26 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f25 (f26 ?v0) ?v1) f1) (= (f25 (f26 (f11 (f27 f28 ?v0) ?v2)) (f11 (f27 f28 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f33 ?v0 ?v1) f1) (= (f33 (f3 (f4 f34 ?v0) ?v2) (f3 (f4 f34 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f25 (f26 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f33 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 S2)) (=> (= (f25 (f26 ?v0) ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f25 (f26 (f11 (f27 f28 ?v0) ?v2)) (f11 (f27 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f33 ?v0 ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f33 (f3 (f4 f34 ?v0) ?v2) (f3 (f4 f34 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f27 f28 ?v0))) (=> (= (f25 (f26 (f11 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f25 (f26 (f11 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f33 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f33 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (let ((?v_0 (f11 (f27 f28 f31) (f6 f7 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (=> (not (= (f25 (f32 ?v_0) (- 1)) f1)) (not (= (f8 (f9 f30 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f11 (f27 f28 f31) (f6 f7 2)) 1) (* (+ (* 4 f19) 1) ?v0)) false)) false))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f29 ?v_0) f1) (= (f8 (f9 f30 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 ?v0))) (=> (= (f29 ?v0) f1) (=> (= (f25 ?v_0 (* ?v1 ?v2)) f1) (or (= (f25 ?v_0 ?v1) f1) (= (f25 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f26 ?v0))) (=> (= (f29 ?v0) f1) (=> (= (f25 ?v_0 (f11 (f27 f28 ?v1) ?v2)) f1) (=> (< 0 (f11 f12 ?v2)) (= (f25 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int)) (= (f11 (f27 f28 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f34 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f35 (f11 (f27 f28 ?v0) ?v1)) (f11 (f27 f28 (f8 f35 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f25 (f26 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f26 ?v0))) (=> (= (f29 ?v0) f1) (=> (= (f25 ?v_0 (f11 (f27 f28 ?v1) ?v2)) f1) (= (f25 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f26 (f11 (f27 f28 ?v0) ?v2)))) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f26 ?v0) ?v1) f1)) (=> (= (f25 ?v_0 (* ?v3 ?v1)) f1) (= (f25 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f26 (f11 (f27 f28 ?v0) ?v2)))) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f26 ?v0) ?v1) f1)) (=> (= (f25 ?v_0 (* ?v1 ?v3)) f1) (= (f25 ?v_0 ?v3) f1)))))))
(assert (= (f25 (f36 (f37 (f11 (f27 f28 f31) (f6 f7 2))) (- 1)) (+ (* 4 f19) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (and (<= 0 f31) (and (< f31 ?v_0) (= (f25 (f36 (f37 f38) f31) ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 ?v1))) (=> (<= 0 ?v0) (=> (= (f29 ?v1) f1) (=> (= (f25 ?v_0 (* ?v0 ?v2)) f1) (or (= (f25 ?v_0 ?v0) f1) (= (f25 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int)) (= (= (f29 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f25 (f26 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (= (f39 f40 (f41 f31 1)) (* (+ (* 4 f19) 1) f14)))
(assert (= (f25 (f36 (f37 (f11 (f27 f28 f38) (f6 f7 2))) (- 1)) (+ (* 4 f19) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f25 (f36 (f37 (f11 (f27 f28 ?v0) (f6 f7 2))) (- 1)) (+ (* 4 f19) 1)) f1) false)) false))
(assert (let ((?v_0 (f6 f7 2))) (= (f25 (f36 (f37 (f11 (f27 f28 f31) ?v_0)) (f11 (f27 f28 f38) ?v_0)) (+ (* 4 f19) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f25 (f36 (f37 f38) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f25 (f36 (f37 f38) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f25 (f36 (f37 f38) ?v0) ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f37 ?v0))) (=> (= (f25 (f36 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f25 (f36 (f37 ?v3) ?v4) ?v2) f1) (= (f25 (f36 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (= (f25 (f36 (f37 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f37 ?v3))) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (= (= (f25 (f36 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f25 (f36 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f37 ?v3))) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (= (= (f25 (f36 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f25 (f36 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f37 ?v1))) (=> (< 2 ?v0) (=> (= (f25 (f36 ?v_0 (- 1)) ?v0) f1) (not (= (f25 (f36 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f42 ?v0 ?v1) f1) (= (f25 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f25 (f36 (f37 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f25 (f36 (f37 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f37 ?v1))) (=> (= (f29 ?v0) f1) (=> (< 0 ?v1) (=> (= (f25 (f36 (f37 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f25 (f36 ?v_0 1) ?v0) f1) (= (f25 (f36 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f25 (f36 (f37 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int)) (= (f25 (f36 (f37 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (= (f25 (f26 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f39 f40 (f41 ?v0 ?v1)) (f39 f40 (f41 ?v2 ?v3))) (f39 f40 (f41 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 (f36 (f37 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (= (f25 (f36 (f37 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f36 (f37 ?v0) ?v1))) (= (= (f25 ?v_0 (- ?v2)) f1) (= (f25 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f25 (f36 (f37 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f25 (f36 (f37 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f25 (f36 (f37 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f25 (f36 (f37 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f25 (f36 (f37 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f25 (f36 (f37 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (= (f25 (f36 (f37 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (= (f25 (f36 (f37 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f37 ?v0))) (=> (= (f25 (f36 ?v_0 ?v1) ?v2) f1) (=> (= (f25 (f36 (f37 ?v1) ?v3) ?v2) f1) (= (f25 (f36 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (=> (= (f25 (f36 (f37 ?v3) ?v4) ?v2) f1) (= (f25 (f36 (f37 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (=> (= (f25 (f36 (f37 ?v3) ?v4) ?v2) f1) (= (f25 (f36 (f37 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (=> (= (f25 (f36 (f37 ?v3) ?v4) ?v2) f1) (= (f25 (f36 (f37 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 (f36 (f37 ?v0) 0) ?v1) f1) (= (f25 (f26 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 (f36 (f37 ?v0) 0) ?v1) f1) (= (f25 (f26 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f25 (f36 (f37 ?v0) ?v1) ?v2) f1) (= (f25 (f36 (f37 (f11 (f27 f28 ?v0) ?v3)) (f11 (f27 f28 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (=> (not (= (f25 (f36 (f37 ?v2) 0) ?v0) f1)) (not (= (f25 (f36 (f37 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (not (= (f25 (f36 (f37 ?v2) 0) ?v0) f1))) (not (= (f25 (f36 (f37 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0) f1) (=> (< 0 ?v1) (=> (= (f25 (f36 (f37 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f25 (f36 (f37 ?v1) 0) ?v0) f1) (= (f25 (f36 (f37 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f27 f28 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f11 (f27 f28 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f27 f28 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f11 (f27 f28 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f27 f28 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (* ?v0 (f11 ?v_0 (f6 f7 2))) (f11 ?v_0 (f6 f7 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f11 (f27 f28 (- ?v0)) ?v_0) (- (f11 (f27 f28 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f27 f28 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f27 f28 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f27 f28 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f27 f28 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f27 f28 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f27 f28 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_1 (f27 f28 ?v0)) (?v_3 (f27 f28 ?v1))) (= (f11 (f27 f28 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_3 (f27 f28 ?v1)) (?v_1 (f27 f28 ?v0))) (= (f11 (f27 f28 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f11 (f27 f28 ?v0) ?v_0) (f11 (f27 f28 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f27 f28 ?v0))) (= (f11 (f27 f28 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f11 (f27 f28 ?v0) ?v_0) (f11 (f27 f28 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (=> (= (f11 (f27 f28 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f29 2) f1))
(assert (forall ((?v0 Int)) (= (= (f20 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f39 f40 (f41 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f26 ?v0) ?v1) f1)) (= (f25 (f36 (f37 (f11 (f27 f28 ?v1) (f6 f7 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f30 ?v0) ?v1) (ite (= (f25 (f36 (f37 ?v0) 0) ?v1) f1) 0 (ite (= (f25 (f32 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 (f32 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f25 (f36 (f37 (f11 (f27 f28 ?v2) (f6 f7 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f25 (f36 (f37 ?v0) 0) ?v1) f1)) (=> (= (f25 (f36 (f37 (f11 (f27 f28 ?v2) (f6 f7 2))) ?v0) ?v1) f1) (not (= (f25 (f26 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f29 ?v1) f1) (= (f25 (f26 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f27 f28 (- 1)))) (let ((?v_1 (f11 ?v_0 ?v1)) (?v_2 (f11 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f25 (f36 (f37 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f25 (f36 (f37 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f27 f28 ?v1)) (?v_1 (f6 f7 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (* ?v1 (f11 ?v_0 (f6 f7 (- (f11 f12 ?v_1) 1)))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 (f27 f28 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f25 (f36 (f37 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f25 (f36 (f37 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (= (f25 (f36 (f37 (f8 (f9 f30 ?v1) ?v0)) (f11 (f27 f28 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (=> (not (= (f25 (f32 ?v0) ?v1) f1)) (= (f25 (f36 (f37 (f11 (f27 f28 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (=> (= (f25 (f32 ?v0) ?v1) f1) (= (f25 (f36 (f37 (f11 (f27 f28 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f8 (f9 f10 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f8 (f9 f10 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f8 (f9 f10 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (= (f25 (f36 (f37 ?v1) 0) ?v0) f1) (= (f25 (f36 (f37 0) (f11 (f27 f28 ?v1) (f6 f7 (f8 (f9 f10 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f29 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (=> (not (= (f25 (f32 ?v0) ?v1) f1)) (= (f25 (f36 (f37 (f8 f43 ?v_0)) (f11 (f27 f28 ?v1) (f6 f7 (f8 (f9 f10 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f25 (f26 ?v0) ?v1) f1) (= (f11 (f27 f28 (f8 (f9 f10 ?v1) ?v0)) ?v2) (f8 (f9 f10 (f11 (f27 f28 ?v1) ?v2)) (f11 (f27 f28 ?v0) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f33 ?v0 ?v1) f1) (= (f3 (f4 f34 (f3 (f4 f44 ?v1) ?v0)) ?v2) (f3 (f4 f44 (f3 (f4 f34 ?v1) ?v2)) (f3 (f4 f34 ?v0) ?v2))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f27 f28 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f8 (f9 f10 (f11 ?v_0 ?v0)) ?v1) (f11 ?v_0 (f6 f7 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f25 (f26 ?v0) ?v1) f1) (= (* ?v0 (f8 (f9 f10 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1)))) (f6 f7 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f8 (f9 f10 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f8 (f9 f10 ?v1) ?v2) (f8 (f9 f10 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f8 (f9 f10 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f8 (f9 f10 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f8 (f9 f10 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f8 (f9 f10 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f8 (f9 f10 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f8 (f9 f10 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f8 ?v_0 ?v2) (f8 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f8 (f9 f10 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f8 (f9 f10 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f8 (f9 f10 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f8 (f9 f10 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f8 (f9 f10 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v1))) (=> (< 0 ?v0) (= (f8 ?v_0 (* ?v2 ?v0)) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f8 (f9 f10 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f8 (f9 f10 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f8 (f9 f10 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f8 (f9 f10 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) (- ?v1)) (f8 (f9 f10 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) (- ?v1)) (f8 (f9 f10 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 0) ?v0) 0)))
(assert (forall ((?v0 S9) (?v1 Int) (?v2 Int)) (= (= (f25 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f25 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f25 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f25 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 ?v0))) (=> (= (f25 ?v_0 ?v1) f1) (=> (= (f25 ?v_0 ?v2) f1) (= (= (f25 (f26 (f8 (f9 f10 ?v1) ?v0)) (f8 (f9 f10 ?v2) ?v0)) f1) (= (f25 (f26 ?v1) ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f33 ?v0 ?v1) f1) (=> (= (f33 ?v0 ?v2) f1) (= (= (f33 (f3 (f4 f44 ?v1) ?v0) (f3 (f4 f44 ?v2) ?v0)) f1) (= (f33 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v1) ?v0))) (=> (= (f25 (f26 ?v0) ?v1) f1) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)) (ite (< ?v0 0) (- ?v0) ?v0)))))))
(assert (forall ((?v0 Int)) (=> (= (f29 ?v0) f1) (= (f25 (f36 (f37 (f8 f43 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (f8 f43 ?v0) (ite (<= ?v0 0) 1 (* ?v0 (f8 f43 (- ?v0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f37 ?v2))) (=> (= (f29 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (=> (not (= (f25 (f36 ?v_0 0) ?v0) f1)) (=> (not (= (f25 (f32 ?v0) ?v1) f1)) (not (= (f25 (f36 ?v_0 (* ?v1 (f8 (f9 f45 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= (f8 (f9 f10 ?v_0) (f11 f12 ?v1)) ?v_0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (+ 0 1))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (+ (+ (+ ?v_1 1) 1) 1))) (f6 f7 (f8 ?v_0 (+ 3 ?v_1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (f8 (f9 f10 (+ (+ ?v_0 1) 1)) 2)) (f6 f7 (+ (f8 (f9 f10 ?v_0) 2) 1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ (+ (+ ?v_0 1) 1) 1)) ?v_1)) (f6 f7 (f8 (f9 f10 (+ 3 ?v_0)) ?v_1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_0)) 2)) ?v0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 1 ?v_0) (< 0 (f8 (f9 f10 ?v_0) 2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (< 0 (f8 (f9 f10 (+ ?v_0 1)) 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (ite (< ?v_1 ?v_0) (f6 f7 0) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (=> (not (< ?v_1 ?v_0)) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (=> (< 1 ?v_1) (=> (< 0 ?v_0) (< (f8 (f9 f10 ?v_0) ?v_1) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (=> (<= ?v_0 ?v_1) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f9 f10 (f11 f12 ?v2)))) (=> (< 0 ?v_0) (=> (<= ?v_0 ?v_1) (<= (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0))) (=> (< ?v_0 ?v_1) (= (f6 f7 (f8 (f9 f10 ?v_0) ?v_1)) (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f25 (f36 (f37 ?v1) ?v2) ?v0) f1) (= (f25 (f36 (f37 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f25 (f36 (f37 ?v1) ?v2) ?v0) f1) (= (f25 (f36 (f37 (* ?v3 (f8 ?v_0 ?v1))) (* ?v3 (f8 ?v_0 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f8 (f9 f45 ?v2) ?v3)))) (=> (= (f25 (f36 (f37 ?v0) ?v_0) ?v2) f1) (= (f25 (f36 (f37 (* ?v0 ?v3)) (* ?v_0 ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 (f9 f45 ?v3) ?v0))) (=> (= (f25 (f36 (f37 (* ?v0 ?v1)) ?v2) ?v3) f1) (= (f25 (f36 (f37 (* (* ?v_0 ?v0) ?v1)) (* ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f45 ?v0) ?v1) (f11 (f27 f28 ?v1) (f6 f7 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 (f9 f45 ?v0) ?v1))) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (=> (= (f25 (f36 (f37 (* (* ?v_0 ?v1) ?v2)) (* ?v_0 ?v3)) ?v0) f1) (= (f25 (f36 (f37 ?v2) (* ?v3 ?v_0)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f37 (* ?v2 ?v1)))) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (=> (= (f25 (f36 ?v_0 (* (* ?v3 (f8 (f9 f45 ?v0) ?v1)) ?v1)) ?v0) f1) (= (f25 (f36 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f37 ?v1)) (?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 ?v_1 0) ?v0) f1)) (=> (not (= (f25 (f36 (f37 ?v2) 0) ?v0) f1)) (=> (= (f25 (f36 (f37 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) ?v0) f1) (= (f25 (f36 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f37 ?v1)) (?v_0 (f37 ?v2)) (?v_2 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 ?v_1 0) ?v0) f1)) (=> (not (= (f25 (f36 ?v_0 0) ?v0) f1)) (=> (= (f25 (f36 ?v_0 (* ?v3 (f8 ?v_2 ?v1))) ?v0) f1) (= (f25 (f36 ?v_1 (* ?v3 (f8 ?v_2 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f37 ?v3)) (?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (=> (not (= (f25 (f36 (f37 ?v2) 0) ?v0) f1)) (=> (not (= (f25 (f36 ?v_1 0) ?v0) f1)) (=> (= (f25 (f36 (f37 (* ?v1 (f8 ?v_0 ?v3))) (* ?v1 (f8 ?v_0 ?v2))) ?v0) f1) (= (f25 (f36 ?v_1 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f45 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (= (f25 (f36 (f37 (* (* ?v1 ?v_1) (f8 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (= (f25 (f36 (f37 (* (f8 (f9 f45 ?v0) ?v1) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f45 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (let ((?v_2 (f8 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (= (f25 (f36 (f37 ?v_2) (* (* ?v1 ?v_1) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f45 ?v0))) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (= (f25 (f36 (f37 (f8 ?v_0 (f8 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (= (f25 (f36 (f37 (* ?v1 (f8 (f9 f45 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v0) f1) (=> (not (= (f25 (f36 (f37 ?v1) 0) ?v0) f1)) (not (= (f25 (f36 (f37 (f8 (f9 f45 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f25 (f36 (f37 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f25 (f36 (f37 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f29 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f25 (f36 (f37 (* ?v1 (f8 (f9 f46 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (=> (= (f29 ?v0) f1) (= (f6 f47 ?v0) (f6 f7 (- ?v0 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f46 ?v0))) (=> (= (f29 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f8 ?v_0 (f8 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f29 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f8 (f9 f46 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f8 (f9 f46 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f29 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f8 (f9 f46 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f46 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f8 (f9 f46 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f8 (f9 f46 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f36 (f48 ?v1) ?v0))) (=> (= (f29 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f42 ?v2 ?v_0) f1) (= (f42 (f8 (f9 f46 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f36 (f48 ?v1) ?v0))) (=> (= (f29 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f42 (f8 (f9 f46 ?v0) ?v2) ?v_1) f1) (= (f42 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (not (= (f42 ?v1 (f36 (f48 (- ?v0 1)) ?v2)) f1)) (=> (= (f42 ?v1 (f36 (f48 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f8 (f9 f46 ?v2) ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f42 ?v1 (f36 (f48 (- ?v0 1)) ?v2)) f1) (= (f42 ?v1 (f36 (f48 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f42 ?v0 (f36 (f48 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f42 ?v2 (f36 (f48 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f42 ?v2 (f36 (f48 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f29 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f42 ?v2 (f36 (f48 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f29 ?v0) f1) (= (f49 ?v_0) (f36 (f48 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (div ?v0 ?v1) (ite (<= 0 ?v1) (f8 ?v_0 ?v1) (- (f8 ?v_0 (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f42 ?v0 (f49 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f42 ?v1 (f49 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f42 ?v0 (f49 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f42 ?v0 (f49 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f3 (f4 f34 (f6 f7 ?v0)) ?v1) (f6 f7 (f11 (f27 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f27 f28 ?v0) ?v1)) (f3 (f4 f34 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f34 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f34 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f34 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f33 (f3 (f4 f34 ?v1) ?v0) (f3 (f4 f34 ?v2) ?v0)) f1) (= (f33 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f3 ?v_0 ?v1)) (f11 f12 (f3 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f3 (f4 f34 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f33 (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) f1) (=> (< 1 (f11 f12 ?v0)) (<= (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 Int)) (= (= (f25 (f26 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 ?v0))) (= (= (f25 ?v_0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f25 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f25 (f26 (* ?v0 ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f25 (f26 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f8 (f9 f10 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f8 (f9 f50 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
