(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 S3) Int)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 (S4 Int) S3)
(declare-fun f9 () S4)
(assert (not (= f1 f2)))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f4) 1)) (?v_1 (+ 1 (f5 f6 f7)))) (and (< ?v_1 ?v_0) (= (f3 (* ?v_0 ?v_1)) f1))))
(assert (let ((?v_0 (+ 1 (f5 f6 f7)))) (or (= ?v_0 1) (= ?v_0 (+ (* 4 f4) 1)))))
(assert (forall ((?v0 S3)) (= (f8 f9 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f8 f9 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f8 f9 ?v0)) 0))))
(check-sat)
(exit)
