(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () S2)
(declare-fun f12 () S3)
(declare-fun f13 () S3)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 (Int Int) S1)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 (S3 S3) S1)
(declare-fun f23 (S6 S3) S3)
(declare-fun f24 (S7 S3) S6)
(declare-fun f25 () S7)
(declare-fun f26 (Int) S1)
(declare-fun f27 (Int) S1)
(declare-fun f28 (S8 Int) Int)
(declare-fun f29 (S9 Int) S8)
(declare-fun f30 () S9)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S1)
(declare-fun f33 (Int Int Int) S1)
(declare-fun f34 () Int)
(declare-fun f35 (S10 S11) Int)
(declare-fun f36 () S10)
(declare-fun f37 (Int Int) S11)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 2))) (not (and (<= 0 (f3 (f4 f5 f6) ?v_0)) (<= 0 (f3 (f4 f5 f9) ?v_0))))))
(assert (< 1 f10))
(assert (< 0 (f3 f11 f12)))
(assert (let ((?v_0 (f7 f8 2))) (not (= (+ (f3 (f4 f5 f6) ?v_0) (* 1 (f3 (f4 f5 f9) ?v_0))) 0))))
(assert (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) 0) false)))
(assert (= f13 (f7 f8 (- (f3 f11 (f7 f8 f10)) 1))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f11 f12)) f14))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f11 f12)) ?v0)) false))) false))
(assert (let ((?v_0 (f3 (f4 f5 f15) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (f7 f8 2))) (= (f16 (+ 1 (f3 f11 f12)) (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f11 ?v1) (f3 f11 ?v2)))) (* (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (* ?v0 (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (< 0 (f3 f11 f13)))
(assert (< 0 (+ 1 (f3 f11 f12))))
(assert (<= 1 f10))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f11 (f7 f8 f10)) 1))) (=> (< 0 (f3 f11 ?v0)) false))) false))
(assert (< f14 (+ 1 (f3 f11 f12))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f9 (- f17 (* f18 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f6 (- f19 (* f20 ?v_0))) (<= (* 2 (ite (< f6 0) (- f6) f6)) ?v_0))))
(assert (forall ((?v0 Int)) (= (= (f16 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f16 ?v0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f16 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f16 (* ?v0 ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f16 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f16 ?v0 ?v1) f1) (=> (= (f16 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f16 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 ?v0 ?v1) f1) (= (= (f16 ?v0 (+ ?v2 ?v3)) f1) (= (f16 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0 ?v1) f1) (=> (= (f16 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0 (- ?v1 ?v2)) f1) (=> (= (f16 ?v0 ?v2) f1) (= (f16 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 (* ?v0 ?v1) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f16 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (= (+ (f3 (f4 f5 f15) (f7 f8 2)) 1) (* (+ (* 4 f21) 1) f10)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f19 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f17 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f16 (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f16 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f11 ?v0)) (=> (= (f16 ?v1 ?v2) f1) (= (f16 ?v1 (f3 (f4 f5 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f16 (f3 (f4 f5 ?v1) ?v0) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f16 ?v1 ?v2) f1)))))
(assert (= (f16 (+ (* 4 f21) 1) (- (f3 (f4 f5 f15) (f7 f8 2)) (- 1))) f1))
(assert (= (f16 (+ (* 4 f21) 1) (+ (f3 (f4 f5 f15) (f7 f8 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f16 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f11 ?v3) (f3 f11 ?v1)) (= (f16 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f24 f25 ?v0))) (=> (= (f22 (f23 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f11 ?v3) (f3 f11 ?v1)) (= (f22 (f23 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f16 ?v0 ?v1) f1) (=> (<= (f3 f11 ?v2) (f3 f11 ?v3)) (= (f16 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f22 ?v0 ?v1) f1) (=> (<= (f3 f11 ?v2) (f3 f11 ?v3)) (= (f22 (f23 (f24 f25 ?v0) ?v2) (f23 (f24 f25 ?v1) ?v3)) f1)))))
(assert (not (= (f26 (* (+ (* 4 f21) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f21) 1)))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f21) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f26 (* ?v_0 ?v_1)) f1))))))
(assert (< f10 (+ (* 4 f21) 1)))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f19) ?v_0) (f3 (f4 f5 f17) ?v_0)) (* (+ (* 4 f21) 1) (+ 1 (f3 f11 f12))))))
(assert (= (f27 (+ (* 4 f21) 1)) f1))
(assert (= (f28 (f29 f30 (- 1)) (+ (* 4 f21) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f21) 1) (+ 1 (f3 f11 f12)))) false))) false))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f15) (f7 f8 2)) 1) (* (+ (* 4 f21) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 (+ (+ (* f20 f6) (* f18 f9)) f14)) ?v_0) (f3 (f4 f5 (- (* f20 f9) (* f18 f6))) ?v_0)) (* (+ (* 4 f21) 1) f14))))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f21) 1))) (and (< ?v_1 ?v_0) (= (f26 (* ?v_0 ?v_1)) f1))))
(assert (= (f26 (* (+ (* 4 f21) 1) f10)) f1))
(assert (= (f26 (* (+ (* 4 f21) 1) f14)) f1))
(assert (=> (= f10 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f21) 1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f11 (f23 (f24 f25 ?v0) ?v1)) (f3 (f4 f5 (f3 f11 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f11 ?v0)) ?v1) (f3 f11 (f23 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f7 f8 (f3 (f4 f5 ?v0) ?v1)) (f23 (f24 f25 (f7 f8 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f22 (f7 f8 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f16 ?v0 (f3 f11 ?v1)) f1) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f16 (f3 f11 ?v0) ?v1) f1) (= (f22 ?v0 (f7 f8 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f16 ?v0 (f3 f11 ?v1)) f1) (= (f22 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f22 ?v0 ?v1) f1) (= (f16 (f3 f11 ?v0) (f3 f11 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f28 f31 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f28 f31 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f23 (f24 f25 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f16 ?v0 ?v1) f1) (= (f16 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f22 ?v0 ?v1) f1) (= (f22 (f23 (f24 f25 ?v0) ?v2) (f23 (f24 f25 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (<= (f3 f11 ?v0) (f3 f11 ?v1)) (= (f16 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f24 f25 ?v2))) (=> (<= (f3 f11 ?v0) (f3 f11 ?v1)) (= (f22 (f23 ?v_0 ?v0) (f23 ?v_0 ?v1)) f1)))))
(assert (= (f32 (+ (* 4 f21) 1) (- 1)) f1))
(assert (= (f33 (f3 (f4 f5 f15) (f7 f8 2)) (- 1) (+ (* 4 f21) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f21) 1))) (and (<= 0 f15) (and (< f15 ?v_0) (= (f33 f34 f15 ?v_0) f1)))))
(assert (= (f35 f36 (f37 f15 1)) (* (+ (* 4 f21) 1) f10)))
(assert (= (f33 (f3 (f4 f5 f34) (f7 f8 2)) (- 1) (+ (* 4 f21) 1)) f1))
(assert (let ((?v_0 (f7 f8 2))) (= (f33 (f3 (f4 f5 f15) ?v_0) (f3 (f4 f5 f34) ?v_0) (+ (* 4 f21) 1)) f1)))
(assert (let ((?v_0 (+ (* 4 f21) 1))) (=> (not (= (f32 ?v_0 (- 1)) f1)) (not (= (f28 (f29 f30 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f33 (f3 (f4 f5 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f21) 1)) f1) false)) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f21) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f33 f34 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f33 f34 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f21) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f33 f34 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (not (and (= (f22 ?v_0 ?v0) f1) (not (= (f22 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (not (and (= (f22 ?v0 ?v_0) f1) (not (= (f22 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S3)) (= (f22 (f7 f8 1) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f22 ?v0 (f7 f8 0)) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (not (= ?v0 ?v_0)) (and (= (f22 ?v_0 ?v0) f1) (not (= (f22 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (= (not (= ?v0 ?v_0)) (and (= (f22 ?v0 ?v_0) f1) (not (= (f22 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (= (= (f22 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (= (f22 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f22 (f23 (f24 f25 ?v1) ?v0) (f23 (f24 f25 ?v2) ?v0)) f1) (= (f22 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (=> (= (f22 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f3 f11 ?v0)) (=> (= (f22 ?v1 ?v0) f1) (< 0 (f3 f11 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (=> (= (f22 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f24 f25 ?v0))) (=> (= (f22 (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) f1) (=> (< 1 (f3 f11 ?v0)) (<= (f3 f11 ?v1) (f3 f11 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f33 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f33 ?v3 ?v4 ?v2) f1) (= (f33 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f33 ?v0 ?v1 ?v2) f1) (= (f33 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f33 ?v0 ?v1 ?v2) f1) (= (= (f33 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f33 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f33 ?v0 ?v1 ?v2) f1) (= (= (f33 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f33 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f33 ?v1 (- 1) ?v0) f1) (not (= (f33 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f11 ?v0)) (<= ?v_0 (f3 f11 (f23 (f24 f25 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 0 (f3 f11 ?v0)) (=> (< (f3 f11 (f23 ?v_0 ?v1)) (f3 f11 (f23 ?v_0 ?v2))) (< (f3 f11 ?v1) (f3 f11 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f33 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f33 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f33 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 ?v0) f1) (=> (< 0 ?v1) (=> (= (f33 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f33 ?v1 0 ?v0) f1) (= (f33 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f33 ?v1 0 ?v0) f1)) (not (= (f33 ?v2 0 ?v0) f1))) (not (= (f33 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 ?v0) f1) (=> (not (= (f33 ?v1 0 ?v0) f1)) (=> (not (= (f33 ?v2 0 ?v0) f1)) (not (= (f33 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int)) (= (f33 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (= (f23 (f24 f25 ?v0) ?v1) ?v_0) (or (= ?v1 (f7 f8 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (f23 (f24 f25 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f11 (f23 (f24 f25 ?v0) ?v1))) (or (< 0 (f3 f11 ?v0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0) f1) (=> (= (f26 ?v1) f1) (= (f26 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f35 f36 (f37 ?v0 ?v1)) (f35 f36 (f37 ?v2 ?v3))) (f35 f36 (f37 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f27 ?v_0) f1) (= (f28 (f29 f30 (- 1)) ?v_0) 1)))))
(assert (= (f27 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f33 ?v0 0 ?v1) f1) (= (f16 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f33 ?v0 0 ?v1) f1) (= (f16 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f11 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f11 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f11 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
