(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () S2)
(declare-fun f12 () S3)
(declare-fun f13 () S3)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (S6 Int) S1)
(declare-fun f22 (S7 Int) S6)
(declare-fun f23 () S7)
(declare-fun f24 () S6)
(declare-fun f25 () S6)
(declare-fun f26 (S8 Int) Int)
(declare-fun f27 (S9 Int) S8)
(declare-fun f28 () S9)
(declare-fun f29 () S7)
(declare-fun f30 (S10 Int) S7)
(declare-fun f31 () S10)
(declare-fun f32 () Int)
(declare-fun f33 (S11 S12) Int)
(declare-fun f34 () S11)
(declare-fun f35 (Int Int) S12)
(declare-fun f36 (S13 S3) S1)
(declare-fun f37 (S14 S3) S13)
(declare-fun f38 () S14)
(declare-fun f39 (S15 S3) S3)
(declare-fun f40 (S16 S3) S15)
(declare-fun f41 () S16)
(declare-fun f42 () S8)
(declare-fun f43 () S9)
(declare-fun f44 () S8)
(declare-fun f45 () S16)
(declare-fun f46 () S9)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 2))) (not (<= 0 (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0))))))
(assert (let ((?v_0 (f7 f8 2))) (and (<= 0 (f3 (f4 f5 f6) ?v_0)) (<= 0 (f3 (f4 f5 f9) ?v_0)))))
(assert (< 1 f10))
(assert (< 0 (f3 f11 f12)))
(assert (let ((?v_0 (f7 f8 2))) (and (<= 0 (f3 (f4 f5 f6) ?v_0)) (<= 0 (f3 (f4 f5 f9) ?v_0)))))
(assert (let ((?v_0 (f7 f8 2))) (not (= (+ (f3 (f4 f5 f6) ?v_0) (* 1 (f3 (f4 f5 f9) ?v_0))) 0))))
(assert (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) 0) false)))
(assert (= f13 (f7 f8 (- (f3 f11 (f7 f8 f10)) 1))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f11 f12)) f14))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ 1 (f3 f11 f12)) ?v0)) false))) false))
(assert (let ((?v_0 (f3 (f4 f5 f15) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f11 ?v1) (f3 f11 ?v2)))) (* (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (* ?v0 (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (< 0 (f3 f11 f13)))
(assert (< 0 (+ 1 (f3 f11 f12))))
(assert (<= 1 f10))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f11 (f7 f8 f10)) 1))) (=> (< 0 (f3 f11 ?v0)) false))) false))
(assert (< f14 (+ 1 (f3 f11 f12))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f9 (- f16 (* f17 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f6 (- f18 (* f19 ?v_0))) (<= (* 2 (ite (< f6 0) (- f6) f6)) ?v_0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (= (+ (f3 (f4 f5 f15) (f7 f8 2)) 1) (* (+ (* 4 f20) 1) f10)))
(assert (let ((?v_0 (f7 f8 2))) (= (f21 (f22 f23 (+ 1 (f3 f11 f12))) (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f18 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f16 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 (+ (+ (* f19 f6) (* f17 f9)) f14)) ?v_0) (f3 (f4 f5 (- (* f19 f9) (* f17 f6))) ?v_0)) (* (+ (* 4 f20) 1) f14))))
(assert (< f10 (+ (* 4 f20) 1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f15) (f7 f8 2)) 1) (* (+ (* 4 f20) 1) ?v0)) false)) false))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f20) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f21 f24 (* ?v_0 ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (* ?v1 (f3 ?v_0 (f7 f8 (- (f3 f11 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f4 f5 ?v0) ?v1)))))
(assert (not (= (f21 f24 (* (+ (* 4 f20) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f20) 1)))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f20) 1))) (and (< ?v_1 ?v_0) (= (f21 f24 (* ?v_0 ?v_1)) f1))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f18) ?v_0) (f3 (f4 f5 f16) ?v_0)) (* (+ (* 4 f20) 1) (+ 1 (f3 f11 f12))))))
(assert (= (f21 f24 (* (+ (* 4 f20) 1) f10)) f1))
(assert (= (f21 f24 (* (+ (* 4 f20) 1) f14)) f1))
(assert (= (f21 (f22 f23 (+ (* 4 f20) 1)) (+ (f3 (f4 f5 f15) (f7 f8 2)) 1)) f1))
(assert (= (f21 (f22 f23 (+ (* 4 f20) 1)) (- (f3 (f4 f5 f15) (f7 f8 2)) (- 1))) f1))
(assert (= (f21 f25 (+ (* 4 f20) 1)) f1))
(assert (= (f26 (f27 f28 (- 1)) (+ (* 4 f20) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f20) 1) (+ 1 (f3 f11 f12)))) false))) false))
(assert (=> (= f10 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f20) 1))))))
(assert (forall ((?v0 Int)) (= (= (f21 (f22 f23 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (= (f21 ?v_0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f21 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f21 (f22 f23 (* ?v0 ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f21 (f22 f23 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (= (f21 (f22 f23 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f21 (f22 f23 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 ?v1) f1) (= (= (f21 ?v_0 (+ ?v2 ?v3)) f1) (= (f21 ?v_0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (= (f21 (f22 f23 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f21 ?v_0 ?v2) f1) (= (f21 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 (f22 f23 (* ?v0 ?v1)) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f21 (f22 f23 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 f24 ?v0) f1) (=> (= (f21 f24 ?v1) f1) (= (f21 f24 (* ?v0 ?v1)) f1)))))
(assert (= (f21 (f22 f29 (+ (* 4 f20) 1)) (- 1)) f1))
(assert (= (f21 (f22 (f30 f31 (f3 (f4 f5 f15) (f7 f8 2))) (- 1)) (+ (* 4 f20) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f20) 1))) (and (<= 0 f15) (and (< f15 ?v_0) (= (f21 (f22 (f30 f31 f32) f15) ?v_0) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f21 (f22 f23 (f3 (f4 f5 ?v1) ?v0)) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f21 (f22 f23 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v1))) (=> (< 0 (f3 f11 ?v0)) (=> (= (f21 ?v_0 ?v2) f1) (= (f21 ?v_0 (f3 (f4 f5 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f21 (f22 f23 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f21 (f22 f23 ?v0) ?v2) f1)))))
(assert (= (f33 f34 (f35 f15 1)) (* (+ (* 4 f20) 1) f10)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (= (f21 (f22 f23 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f36 (f37 f38 (f39 (f40 f41 ?v0) ?v2)) (f39 (f40 f41 ?v1) ?v2)) f1))))
(assert (= (f21 (f22 (f30 f31 (f3 (f4 f5 f32) (f7 f8 2))) (- 1)) (+ (* 4 f20) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f20) 1))) (=> (not (= (f21 (f22 f29 ?v_0) (- 1)) f1)) (not (= (f26 (f27 f28 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f21 (f22 (f30 f31 (f3 (f4 f5 ?v0) (f7 f8 2))) (- 1)) (+ (* 4 f20) 1)) f1) false)) false))
(assert (let ((?v_0 (f7 f8 2))) (= (f21 (f22 (f30 f31 (f3 (f4 f5 f15) ?v_0)) (f3 (f4 f5 f32) ?v_0)) (+ (* 4 f20) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f20) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 (f22 (f30 f31 f32) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f21 (f22 (f30 f31 f32) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f20) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 (f22 (f30 f31 f32) ?v0) ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 f25 ?v0) f1) (=> (= (f21 ?v_0 (* ?v1 ?v2)) f1) (or (= (f21 ?v_0 ?v1) f1) (= (f21 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 (f22 (f30 f31 ?v0) 0) ?v1) f1) (= (f21 (f22 f23 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 (f22 (f30 f31 ?v0) 0) ?v1) f1) (= (f21 (f22 f23 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f21 (f22 (f30 f31 (f3 (f4 f5 ?v0) ?v3)) (f3 (f4 f5 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f33 f34 (f35 ?v0 ?v1)) (f33 f34 (f35 ?v2 ?v3))) (f33 f34 (f35 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int)) (= (f21 (f22 (f30 f31 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 f25 ?v0) f1) (=> (not (= (f21 (f22 (f30 f31 ?v1) 0) ?v0) f1)) (=> (not (= (f21 (f22 (f30 f31 ?v2) 0) ?v0) f1)) (not (= (f21 (f22 (f30 f31 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 f25 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f21 (f22 (f30 f31 ?v1) 0) ?v0) f1)) (not (= (f21 (f22 (f30 f31 ?v2) 0) ?v0) f1))) (not (= (f21 (f22 (f30 f31 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 f25 ?v0) f1) (=> (< 0 ?v1) (=> (= (f21 (f22 (f30 f31 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f21 (f22 (f30 f31 ?v1) 0) ?v0) f1) (= (f21 (f22 (f30 f31 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f21 f25 ?v_0) f1) (= (f26 (f27 f28 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f21 (f22 (f30 f31 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f21 (f22 (f30 f31 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f30 f31 ?v1))) (=> (< 2 ?v0) (=> (= (f21 (f22 ?v_0 (- 1)) ?v0) f1) (not (= (f21 (f22 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f30 f31 ?v3))) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (= (= (f21 (f22 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f21 (f22 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f30 f31 ?v3))) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (= (= (f21 (f22 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f21 (f22 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f21 (f22 (f30 f31 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f21 (f22 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f21 (f22 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f21 (f22 ?v_0 ?v4) ?v2) f1)))))))
(assert (= (f21 f25 2) f1))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f7 f8 (f3 (f4 f5 ?v0) ?v1)) (f39 (f40 f41 (f7 f8 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f11 ?v0)) ?v1) (f3 f11 (f39 (f40 f41 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f11 (f39 (f40 f41 ?v0) ?v1)) (f3 (f4 f5 (f3 f11 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f39 (f40 f41 (f7 f8 ?v0)) ?v1) (f7 f8 (f3 (f4 f5 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f11 ?v0)) ?v1) (f3 f11 (f39 (f40 f41 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f21 (f22 f23 (f3 f11 ?v0)) (f3 f11 ?v1)) f1) (= (f36 (f37 f38 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f36 (f37 f38 (f7 f8 ?v0)) (f7 f8 ?v1)) f1) (= (f21 (f22 f23 ?v0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f36 (f37 f38 (f7 f8 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f21 (f22 f23 ?v0) (f3 f11 ?v1)) f1) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f21 (f22 f23 (f3 f11 ?v0)) ?v1) f1) (= (f36 (f37 f38 ?v0) (f7 f8 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f21 (f22 f23 ?v0) (f3 f11 ?v1)) f1) (= (f36 (f37 f38 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f21 (f22 f23 (f3 f11 ?v0)) (f3 f11 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 f25 ?v0) f1) (=> (= (f21 ?v_0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f11 ?v2)) (= (f21 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f21 (f22 (f30 f31 ?v0) 0) ?v1) f1)) (=> (= (f21 (f22 (f30 f31 (f3 (f4 f5 ?v2) (f7 f8 2))) ?v0) ?v1) f1) (not (= (f21 (f22 f23 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f22 f23 (f3 (f4 f5 ?v0) ?v2)))) (=> (= (f21 f25 ?v0) f1) (=> (not (= (f21 (f22 f23 ?v0) ?v1) f1)) (=> (= (f21 ?v_0 (* ?v1 ?v3)) f1) (= (f21 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f22 f23 (f3 (f4 f5 ?v0) ?v2)))) (=> (= (f21 f25 ?v0) f1) (=> (not (= (f21 (f22 f23 ?v0) ?v1) f1)) (=> (= (f21 ?v_0 (* ?v3 ?v1)) f1) (= (f21 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (= (f21 f25 ?v0) f1) (=> (= (f21 ?v_0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f21 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f39 (f40 f41 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f26 f42 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f26 f42 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f21 (f22 f23 (f3 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f11 ?v3) (f3 f11 ?v1)) (= (f21 (f22 f23 (f3 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f40 f41 ?v0))) (=> (= (f36 (f37 f38 (f39 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f11 ?v3) (f3 f11 ?v1)) (= (f36 (f37 f38 (f39 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (=> (<= (f3 f11 ?v2) (f3 f11 ?v3)) (= (f21 (f22 f23 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (<= (f3 f11 ?v2) (f3 f11 ?v3)) (= (f36 (f37 f38 (f39 (f40 f41 ?v0) ?v2)) (f39 (f40 f41 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (<= (f3 f11 ?v0) (f3 f11 ?v1)) (= (f21 (f22 f23 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f40 f41 ?v2))) (=> (<= (f3 f11 ?v0) (f3 f11 ?v1)) (= (f36 (f37 f38 (f39 ?v_0 ?v0)) (f39 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f21 f24 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f33 f34 (f35 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 f25 ?v0) f1) (=> (not (= (f21 (f22 f23 ?v0) ?v1) f1)) (= (f21 (f22 (f30 f31 (f3 (f4 f5 ?v1) (f7 f8 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 (f27 f28 ?v0) ?v1) (ite (= (f21 (f22 (f30 f31 ?v0) 0) ?v1) f1) 0 (ite (= (f21 (f22 f29 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 (f22 f29 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f21 (f22 (f30 f31 (f3 (f4 f5 ?v2) (f7 f8 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f21 f25 ?v1) f1) (= (f21 (f22 f23 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 f23 ?v1))) (=> (<= 0 ?v0) (=> (= (f21 f25 ?v1) f1) (=> (= (f21 ?v_0 (* ?v0 ?v2)) f1) (or (= (f21 ?v_0 ?v0) f1) (= (f21 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f40 f41 ?v0))) (=> (= (f36 (f37 f38 (f39 ?v_0 ?v1)) (f39 ?v_0 ?v2)) f1) (=> (< 1 (f3 f11 ?v0)) (<= (f3 f11 ?v1) (f3 f11 ?v2)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (=> (= (f36 (f37 f38 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f3 f11 ?v0)) (=> (= (f36 (f37 f38 ?v1) ?v0) f1) (< 0 (f3 f11 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (=> (= (f36 (f37 f38 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f36 (f37 f38 (f39 (f40 f41 ?v1) ?v0)) (f39 (f40 f41 ?v2) ?v0)) f1) (= (f36 (f37 f38 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (= (f36 (f37 f38 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (= (= (f36 (f37 f38 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (= (not (= ?v0 ?v_0)) (and (= (f36 (f37 f38 ?v0) ?v_0) f1) (not (= (f36 (f37 f38 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (not (= ?v0 ?v_0)) (and (= (f36 (f37 f38 ?v_0) ?v0) f1) (not (= (f36 (f37 f38 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 ?v0) (f7 f8 0)) f1)))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 (f7 f8 1)) ?v0) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (not (and (= (f36 (f37 f38 ?v0) ?v_0) f1) (not (= (f36 (f37 f38 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (not (and (= (f36 (f37 f38 ?v_0) ?v0) f1) (not (= (f36 (f37 f38 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f11 (f39 (f40 f41 ?v0) ?v1))) (or (< 0 (f3 f11 ?v0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (f39 (f40 f41 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (= (f39 (f40 f41 ?v0) ?v1) ?v_0) (or (= ?v1 (f7 f8 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f40 f41 ?v0))) (=> (< 0 (f3 f11 ?v0)) (=> (< (f3 f11 (f39 ?v_0 ?v1)) (f3 f11 (f39 ?v_0 ?v2))) (< (f3 f11 ?v1) (f3 f11 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f11 ?v0)) (<= ?v_0 (f3 f11 (f39 (f40 f41 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (= (f21 (f22 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f21 (f22 (f30 f31 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (= (f21 (f22 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f21 (f22 (f30 f31 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (= (f21 (f22 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f21 (f22 (f30 f31 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f21 (f22 ?v_0 ?v1) ?v2) f1) (=> (= (f21 (f22 (f30 f31 ?v1) ?v3) ?v2) f1) (= (f21 (f22 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f21 (f22 (f30 f31 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f21 (f22 (f30 f31 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f21 (f22 (f30 f31 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f21 (f22 (f30 f31 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f21 (f22 (f30 f31 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f21 (f22 (f30 f31 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 (f22 (f30 f31 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 (f22 (f30 f31 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f22 (f30 f31 ?v0) ?v1))) (= (= (f21 ?v_0 (- ?v2)) f1) (= (f21 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f21 (f22 (f30 f31 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 (f22 (f30 f31 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f21 (f22 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f21 (f22 f23 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f30 f31 ?v1))) (=> (= (f21 f25 ?v0) f1) (=> (< 0 ?v1) (=> (= (f21 (f22 (f30 f31 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f21 (f22 ?v_0 1) ?v0) f1) (= (f21 (f22 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 f25 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f21 (f22 (f30 f31 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int)) (= (= (f21 f25 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f21 (f22 f23 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 (f7 f8 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f21 (f22 (f30 f31 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f36 (f37 f38 (f39 (f40 f41 ?v0) ?v1)) (f39 (f40 f41 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f36 (f37 f38 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (= (f36 (f37 f38 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f36 (f37 f38 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (= (f36 (f37 f38 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f38 ?v0))) (= (= (f36 ?v_0 (f7 f8 (+ (f3 f11 ?v1) (f3 f11 ?v0)))) f1) (= (f36 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (and (= (f36 (f37 f38 ?v0) ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (and (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f36 (f37 f38 ?v1) ?v0) f1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f11 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f3 f11 ?v1)) (not (= (f36 (f37 f38 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f36 (f37 f38 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (or (= ?v1 (f7 f8 0)) (<= (f3 f11 ?v0) (f3 f11 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (= (= (f36 (f37 f38 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f11 ?v1))) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f3 f11 ?v0) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f36 (f37 f38 ?v1) ?v2) f1) (= (f36 (f37 f38 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (= (f36 (f37 f38 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (= (f36 (f37 f38 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= (f36 (f37 f38 ?v1) ?v2) f1) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= (f36 ?v_0 ?v2) f1) (= (f36 ?v_0 (f7 f8 (- (f3 f11 ?v1) (f3 f11 ?v2)))) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= (f36 ?v_0 (f7 f8 (+ (f3 f11 ?v1) (f3 f11 ?v2)))) f1) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f36 (f37 f38 ?v1) ?v2) f1) (not (= (f36 ?v_0 ?v1) f1))) (and (= (f36 (f37 f38 ?v0) ?v2) f1) (not (= (f36 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f37 f38 ?v2))) (=> (= (f36 ?v_0 ?v1) f1) (=> (and (= (f36 (f37 f38 ?v1) ?v2) f1) (not (= (f36 ?v_1 ?v1) f1))) (and (= (f36 ?v_0 ?v2) f1) (not (= (f36 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f3 f11 ?v2)) (?v_2 (f3 f11 ?v1))) (=> (= (f36 ?v_0 (f7 f8 (- ?v_2 ?v_1))) f1) (=> (= (f36 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f36 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f3 f11 ?v2)) (?v_2 (f3 f11 ?v1))) (=> (= (f36 ?v_0 (f7 f8 (- ?v_2 ?v_1))) f1) (=> (= (f36 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f36 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f36 (f37 f38 ?v0) ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f36 (f37 f38 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f36 (f37 f38 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f36 (f37 f38 ?v0) ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f36 (f37 f38 ?v0) ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (and (= (f36 ?v_0 ?v1) f1) (not (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f36 ?v_0 ?v2) f1) (not (= (f36 (f37 f38 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f37 f38 ?v0)) (?v_0 (f37 f38 ?v1))) (=> (and (= (f36 ?v_1 ?v1) f1) (not (= (f36 ?v_0 ?v0) f1))) (=> (= (f36 ?v_0 ?v2) f1) (and (= (f36 ?v_1 ?v2) f1) (not (= (f36 (f37 f38 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f37 f38 ?v0)) (?v_0 (f37 f38 ?v1)) (?v_2 (f37 f38 ?v2))) (=> (and (= (f36 ?v_1 ?v1) f1) (not (= (f36 ?v_0 ?v0) f1))) (=> (and (= (f36 ?v_0 ?v2) f1) (not (= (f36 ?v_2 ?v1) f1))) (and (= (f36 ?v_1 ?v2) f1) (not (= (f36 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f36 (f37 f38 ?v0) ?v1) f1)) (?v_0 (= (f36 (f37 f38 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f21 (f22 (f30 f31 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f4 f5 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 (+ (f3 f11 ?v1) 1)))) (= (<= (f3 f11 (f39 (f40 f41 ?v0) ?v_0)) (f3 f11 (f39 (f40 f41 ?v2) ?v_0))) (<= (f3 f11 ?v0) (f3 f11 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 (+ (f3 f11 ?v1) 1)))) (= (< (f3 f11 (f39 (f40 f41 ?v0) ?v_0)) (f3 f11 (f39 (f40 f41 ?v2) ?v_0))) (< (f3 f11 ?v0) (f3 f11 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 (+ (f3 f11 ?v1) 1)))) (= (= (f39 (f40 f41 ?v0) ?v_0) (f39 (f40 f41 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 1))) (= (= (f39 (f40 f41 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f7 f8 0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 0))) (= (= (f39 (f40 f41 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f7 f8 0))) (=> (= (f36 (f37 f38 (f39 (f40 f41 ?v1) ?v0)) ?v2) f1) (= (f36 (f37 f38 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (= (f36 ?v_0 (f39 (f40 f41 ?v1) (f7 f8 (+ (f3 f11 ?v2) 1)))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f36 (f37 f38 (f39 (f40 f41 ?v0) ?v2)) (f39 (f40 f41 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f21 (f22 (f30 f31 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f21 (f22 (f30 f31 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 S15) (?v1 S3) (?v2 S3)) (=> (forall ((?v3 S3)) (= (f36 (f37 f38 (f39 ?v0 ?v3)) (f39 ?v0 (f7 f8 (+ (f3 f11 ?v3) 1)))) f1)) (=> (<= (f3 f11 ?v1) (f3 f11 ?v2)) (= (f36 (f37 f38 (f39 ?v0 ?v1)) (f39 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 S15) (?v1 S3) (?v2 S3)) (let ((?v_1 (f39 ?v0 ?v1)) (?v_0 (f39 ?v0 ?v2))) (=> (forall ((?v3 S3)) (let ((?v_3 (f39 ?v0 ?v3)) (?v_2 (f39 ?v0 (f7 f8 (+ (f3 f11 ?v3) 1))))) (and (= (f36 (f37 f38 ?v_3) ?v_2) f1) (not (= (f36 (f37 f38 ?v_2) ?v_3) f1))))) (= (and (= (f36 (f37 f38 ?v_1) ?v_0) f1) (not (= (f36 (f37 f38 ?v_0) ?v_1) f1))) (< (f3 f11 ?v1) (f3 f11 ?v2)))))))
(assert (forall ((?v0 S15) (?v1 S3) (?v2 S3)) (let ((?v_1 (f39 ?v0 ?v1)) (?v_0 (f39 ?v0 ?v2))) (=> (forall ((?v3 S3)) (let ((?v_3 (f39 ?v0 ?v3)) (?v_2 (f39 ?v0 (f7 f8 (+ (f3 f11 ?v3) 1))))) (and (= (f36 (f37 f38 ?v_3) ?v_2) f1) (not (= (f36 (f37 f38 ?v_2) ?v_3) f1))))) (=> (< (f3 f11 ?v1) (f3 f11 ?v2)) (and (= (f36 (f37 f38 ?v_1) ?v_0) f1) (not (= (f36 (f37 f38 ?v_0) ?v_1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f21 f25 ?v0) f1) (= (f21 (f22 (f30 f31 (f26 (f27 f28 ?v1) ?v0)) (f3 (f4 f5 ?v1) (f7 f8 (f26 (f27 f43 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f26 (f27 f43 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f26 (f27 f43 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f26 (f27 f43 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f21 f25 ?v0) f1) (=> (= (f21 (f22 (f30 f31 ?v1) 0) ?v0) f1) (= (f21 (f22 (f30 f31 0) (f3 (f4 f5 ?v1) (f7 f8 (f26 (f27 f43 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f21 f25 ?v0) f1) (=> (not (= (f21 (f22 (f30 f31 ?v1) 0) ?v0) f1)) (=> (= (f21 (f22 f29 ?v0) ?v1) f1) (= (f21 (f22 (f30 f31 (f3 (f4 f5 ?v1) (f7 f8 (f26 (f27 f43 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f21 f25 ?v0) f1) (=> (not (= (f21 (f22 (f30 f31 ?v1) 0) ?v0) f1)) (=> (not (= (f21 (f22 f29 ?v0) ?v1) f1)) (= (f21 (f22 (f30 f31 (f3 (f4 f5 ?v1) (f7 f8 (f26 (f27 f43 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f21 f25 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f21 (f22 (f30 f31 ?v1) 0) ?v0) f1)) (=> (not (= (f21 (f22 f29 ?v0) ?v1) f1)) (= (f21 (f22 (f30 f31 (f26 f44 ?v_0)) (f3 (f4 f5 ?v1) (f7 f8 (f26 (f27 f43 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f1) (= (f3 (f4 f5 (f26 (f27 f43 ?v1) ?v0)) ?v2) (f26 (f27 f43 (f3 (f4 f5 ?v1) ?v2)) (f3 (f4 f5 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f39 (f40 f41 (f39 (f40 f45 ?v1) ?v0)) ?v2) (f39 (f40 f45 (f39 (f40 f41 ?v1) ?v2)) (f39 (f40 f41 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 (f27 f43 (f3 f11 ?v0)) (f3 f11 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 (f27 f43 (f3 f11 ?v0)) (f3 f11 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f26 (f27 f43 ?v0) ?v1)) (f7 f8 (f26 (f27 f43 (f3 f11 (f7 f8 ?v0))) (f3 f11 (f7 f8 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f7 f8 (f26 (f27 f43 (f3 f11 (f7 f8 ?v0))) (f3 f11 (f7 f8 ?v1)))) (f7 f8 (f26 (f27 f43 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f26 (f27 f43 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f26 (f27 f43 ?v1) ?v2) (f26 (f27 f43 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f26 (f27 f43 ?v0) ?v2) (f26 (f27 f43 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f26 (f27 f43 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f43 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f26 ?v_0 ?v1) (f26 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f26 (f27 f43 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f26 (f27 f43 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f26 (f27 f43 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f26 (f27 f43 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f26 (f27 f43 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f26 (f27 f43 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f26 (f27 f43 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f26 (f27 f43 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f26 (f27 f43 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f43 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f26 ?v_0 ?v2) (f26 ?v_0 ?v1))))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f11 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f11 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f11 (f7 f8 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f26 (f27 f43 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f26 (f27 f46 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
