(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 S3) Int)
(declare-fun f6 () S2)
(declare-fun f7 (S4 Int) S3)
(declare-fun f8 () S4)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () S3)
(declare-fun f12 (Int) S1)
(declare-fun f13 (S5 Int) Int)
(declare-fun f14 (S6 Int) S5)
(declare-fun f15 () S6)
(declare-fun f16 (Int Int) S1)
(declare-fun f17 () S3)
(declare-fun f18 (Int Int Int) S1)
(declare-fun f19 () Int)
(declare-fun f20 (S7 Int) S2)
(declare-fun f21 () S7)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 () Int)
(declare-fun f29 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 (f5 f6 (f7 f8 (- (f5 f6 (f7 f8 f9)) 1)))))) f1)))
(assert (= (f3 (* (+ (* 4 f4) 1) f9)) f1))
(assert (= (+ 1 (f5 f6 (f7 f8 (- (f5 f6 (f7 f8 f9)) 1)))) f9))
(assert (< 1 f10))
(assert (= (+ 1 (f5 f6 (f7 f8 (- (f5 f6 (f7 f8 f9)) 1)))) f9))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 0))) f1)))
(assert (< 0 (f5 f6 f11)))
(assert (= (f3 (* (+ (* 4 f4) 1) f9)) f1))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (< 0 f9))
(assert (= (f12 (+ (* 4 f4) 1)) f1))
(assert (= (f13 (f14 f15 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (let ((?v_0 (+ (* 4 f4) 1)) (?v_1 (+ 1 (f5 f6 f11)))) (not (=> (< ?v_1 ?v_0) (not (= (f3 (* ?v_0 ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (* ?v0 ?v1)) f1)))))
(assert (= (f16 (+ (* 4 f4) 1) (- 1)) f1))
(assert (= f17 (f7 f8 (- (f5 f6 (f7 f8 f10)) 1))))
(assert (= (f3 (* (+ (* 4 f4) 1) f10)) f1))
(assert (< f10 (+ (* 4 f4) 1)))
(assert (let ((?v_0 (+ (* 4 f4) 1)) (?v_1 (+ 1 (f5 f6 f11)))) (and (< ?v_1 ?v_0) (= (f3 (* ?v_0 ?v_1)) f1))))
(assert (< f9 (+ 1 (f5 f6 f11))))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f16 ?v_0 (- 1)) f1)) (not (= (f13 (f14 f15 (- 1)) ?v_0) 1)))))
(assert (<= 1 f10))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f18 f19 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f18 f19 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f18 f19 ?v0 ?v_0) f1))) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f5 (f20 f21 (+ (+ (* f22 f23) (* f24 f25)) f9)) ?v_0) (f5 (f20 f21 (- (* f22 f25) (* f24 f23))) ?v_0)) (* (+ (* 4 f4) 1) f9))))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f26) (and (< f26 ?v_0) (= (f18 f19 f26 ?v_0) f1)))))
(assert (< 0 (f5 f6 f17)))
(assert (< 0 (+ 1 (f5 f6 f11))))
(assert (let ((?v_0 (f5 (f20 f21 f26) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f18 (f5 (f20 f21 f19) (f7 f8 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (= (+ (f5 (f20 f21 f26) (f7 f8 2)) 1) (* (+ (* 4 f4) 1) f10)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f5 f6 (f7 f8 f10)) 1))) (=> (< 0 (f5 f6 ?v0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f5 (f20 f21 f23) ?v_0) (f5 (f20 f21 f25) ?v_0)) (* (+ 1 (f5 f6 f11)) f9))))
(assert (= (f18 (f5 (f20 f21 f26) (f7 f8 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (+ 1 (f5 f6 f11)))) (and (= f23 (- f27 (* f22 ?v_0))) (<= (* 2 (ite (< f23 0) (- f23) f23)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f5 f6 f11)))) (and (= f25 (- f28 (* f24 ?v_0))) (<= (* 2 (ite (< f25 0) (- f25) f25)) ?v_0))))
(assert (=> (forall ((?v0 Int)) (=> (= (f18 (f5 (f20 f21 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f4) 1)) f1) false)) false))
(assert (let ((?v_0 (f7 f8 2))) (= (f18 (f5 (f20 f21 f26) ?v_0) (f5 (f20 f21 f19) ?v_0) (+ (* 4 f4) 1)) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f5 (f20 f21 ?v0) ?v_0) (f5 (f20 f21 ?v1) ?v_0)) (* (+ (* 4 f4) 1) (+ 1 (f5 f6 f11)))) false))) false))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f5 (f20 f21 f26) (f7 f8 2)) 1) (* (+ (* 4 f4) 1) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f5 (f20 f21 f23) ?v_0) (f5 (f20 f21 f25) ?v_0)) (* (+ 1 (f5 f6 f11)) ?v0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f5 (f20 f21 f27) ?v_0) (f5 (f20 f21 f28) ?v_0)) (* (+ (* 4 f4) 1) (+ 1 (f5 f6 f11))))))
(assert (=> (= f10 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f5 (f20 f21 ?v0) ?v_0) (f5 (f20 f21 ?v1) ?v_0)) (+ (* 4 f4) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f12 ?v_0) f1) (= (f13 (f14 f15 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (f7 f8 2))) (= (f29 (+ 1 (f5 f6 f11)) (+ (f5 (f20 f21 f23) ?v_0) (f5 (f20 f21 f25) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f5 f6 f11)))) (=> (and (= ?v1 (- f27 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f5 f6 f11)))) (=> (and (= ?v1 (- f28 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 (f14 f15 ?v0) ?v1) (ite (= (f18 ?v0 0 ?v1) f1) 0 (ite (= (f16 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f18 (f5 (f20 f21 ?v2) (f7 f8 2)) ?v1 ?v0) f1)))))
(assert (= (f29 (+ (* 4 f4) 1) (- (f5 (f20 f21 f26) (f7 f8 2)) (- 1))) f1))
(assert (= (f29 (+ (* 4 f4) 1) (+ (f5 (f20 f21 f26) (f7 f8 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f12 ?v0) f1) (=> (not (= (f18 ?v1 0 ?v0) f1)) (=> (not (= (f18 ?v2 0 ?v0) f1)) (not (= (f18 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f18 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f12 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f18 ?v1 0 ?v0) f1)) (not (= (f18 ?v2 0 ?v0) f1))) (not (= (f18 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f18 ?v0 ?v1 ?v2) f1) (= (f29 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f5 f6 ?v0)) (=> (= (f29 ?v1 ?v2) f1) (= (f29 ?v1 (f5 (f20 f21 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f12 ?v1) f1) (=> (= (f29 ?v1 (* ?v0 ?v2)) f1) (or (= (f29 ?v1 ?v0) f1) (= (f29 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f12 ?v0) f1) (=> (= (f29 ?v0 (* ?v1 ?v2)) f1) (or (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f12 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f29 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f12 ?v0) f1) (=> (= (f29 ?v0 (f5 (f20 f21 ?v1) ?v2)) f1) (=> (< 0 (f5 f6 ?v2)) (= (f29 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f18 ?v0 ?v1 ?v2) f1) (=> (= (f18 ?v3 ?v4 ?v2) f1) (= (f18 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f18 ?v0 ?v1 ?v2) f1) (=> (= (f18 ?v3 ?v4 ?v2) f1) (= (f18 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f18 ?v0 ?v1 ?v2) f1) (=> (= (f18 ?v3 ?v4 ?v2) f1) (= (f18 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
