(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () S3)
(declare-fun f7 (S4 Int) S3)
(declare-fun f8 () S4)
(declare-fun f9 () Int)
(declare-fun f10 (S5 Int) S1)
(declare-fun f11 () S5)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () S3)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () S5)
(declare-fun f22 (S6 Int) Int)
(declare-fun f23 (S7 Int) S6)
(declare-fun f24 () S7)
(declare-fun f25 (S8 Int) S2)
(declare-fun f26 () S8)
(declare-fun f27 () Int)
(declare-fun f28 (S9 Int) S5)
(declare-fun f29 () S9)
(declare-fun f30 () S9)
(declare-fun f31 (S10 Int) S9)
(declare-fun f32 () S10)
(declare-fun f33 () Int)
(declare-fun f34 (S11 S12) Int)
(declare-fun f35 () S11)
(declare-fun f36 (Int Int) S12)
(declare-fun f37 (S13 S3) S1)
(declare-fun f38 (S14 S3) S13)
(declare-fun f39 () S14)
(declare-fun f40 (S15 S3) S3)
(declare-fun f41 (S16 S3) S15)
(declare-fun f42 () S16)
(declare-fun f43 () S6)
(declare-fun f44 () S6)
(declare-fun f45 () S7)
(declare-fun f46 () S16)
(declare-fun f47 () S7)
(assert (not (= f1 f2)))
(assert (not (< (f3 f4 f5) (f3 f4 f6))))
(assert (and (= f5 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))) (= (f10 f11 (* (+ (* 4 f12) 1) (+ 1 (f3 f4 f5)))) f1)))
(assert (< f9 (+ 1 (f3 f4 f6))))
(assert (< 0 f9))
(assert (= (+ 1 (f3 f4 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1)))) f9))
(assert (< 1 f13))
(assert (< 0 (+ (* 4 f12) 1)))
(assert (< f9 (+ 1 (f3 f4 f6))))
(assert (< 0 (f3 f4 f6)))
(assert (let ((?v_0 (+ (* 4 f12) 1)) (?v_1 (+ 1 (f3 f4 f6)))) (not (=> (< ?v_1 ?v_0) (not (= (f10 f11 (* ?v_0 ?v_1)) f1))))))
(assert (and (= f5 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))) (= (f10 f11 (* (+ (* 4 f12) 1) (+ 1 (f3 f4 f5)))) f1)))
(assert (< 0 (+ 1 (f3 f4 f6))))
(assert (let ((?v_0 (+ (* 4 f12) 1)) (?v_1 (+ 1 (f3 f4 f6)))) (and (< ?v_1 ?v_0) (= (f10 f11 (* ?v_0 ?v_1)) f1))))
(assert (= f14 (f7 f8 (- (f3 f4 (f7 f8 f13)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f6)))) (=> (and (= ?v1 (- f15 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f6)))) (=> (and (= ?v1 (- f16 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (= (f10 f11 (* (+ (* 4 f12) 1) f9)) f1))
(assert (= (f10 f11 (* (+ (* 4 f12) 1) (+ 1 (f3 f4 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1)))))) f1))
(assert (let ((?v_0 (+ 1 (f3 f4 f6)))) (and (= f17 (- f15 (* f18 ?v_0))) (<= (* 2 (ite (< f17 0) (- f17) f17)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f4 f6)))) (and (= f19 (- f16 (* f20 ?v_0))) (<= (* 2 (ite (< f19 0) (- f19) f19)) ?v_0))))
(assert (= (f10 f21 (+ (* 4 f12) 1)) f1))
(assert (= (f22 (f23 f24 (- 1)) (+ (* 4 f12) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 f11 ?v0) f1) (=> (= (f10 f11 ?v1) f1) (= (f10 f11 (* ?v0 ?v1)) f1)))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f25 f26 ?v0) ?v_0) (f3 (f25 f26 ?v1) ?v_0)) (* (+ (* 4 f12) 1) (+ 1 (f3 f4 f6)))) false))) false))
(assert (<= 1 f13))
(assert (< 0 f9))
(assert (not (= (f10 f11 (* (+ (* 4 f12) 1) (+ 1 0))) f1)))
(assert (< 0 (f3 f4 f14)))
(assert (< f13 (+ (* 4 f12) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f4 (f7 f8 f13)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f25 f26 f17) ?v_0) (f3 (f25 f26 f19) ?v_0)) (* (+ 1 (f3 f4 f6)) f9))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f25 f26 f15) ?v_0) (f3 (f25 f26 f16) ?v_0)) (* (+ (* 4 f12) 1) (+ 1 (f3 f4 f6))))))
(assert (= (f10 f11 (* (+ (* 4 f12) 1) f13)) f1))
(assert (=> (forall ((?v0 S3)) (=> (and (= ?v0 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))) (= (f10 f11 (* (+ (* 4 f12) 1) (+ 1 (f3 f4 ?v0)))) f1)) false)) false))
(assert (= (+ (f3 (f25 f26 f27) (f7 f8 2)) 1) (* (+ (* 4 f12) 1) f13)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f25 f26 f17) ?v_0) (f3 (f25 f26 f19) ?v_0)) (* (+ 1 (f3 f4 f6)) ?v0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f25 f26 (+ (+ (* f18 f17) (* f20 f19)) f9)) ?v_0) (f3 (f25 f26 (- (* f18 f19) (* f20 f17))) ?v_0)) (* (+ (* 4 f12) 1) f9))))
(assert (=> (= f13 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f25 f26 ?v0) ?v_0) (f3 (f25 f26 ?v1) ?v_0)) (+ (* 4 f12) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f10 f21 ?v_0) f1) (= (f22 (f23 f24 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (+ (* 4 f12) 1))) (=> (not (= (f10 (f28 f29 ?v_0) (- 1)) f1)) (not (= (f22 (f23 f24 (- 1)) ?v_0) 1)))))
(assert (= (f10 (f28 f29 (+ (* 4 f12) 1)) (- 1)) f1))
(assert (let ((?v_0 (f7 f8 2))) (= (f10 (f28 f30 (+ 1 (f3 f4 f6))) (+ (f3 (f25 f26 f17) ?v_0) (f3 (f25 f26 f19) ?v_0))) f1)))
(assert (= (f10 (f28 (f31 f32 (f3 (f25 f26 f33) (f7 f8 2))) (- 1)) (+ (* 4 f12) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f25 f26 f27) (f7 f8 2)) 1) (* (+ (* 4 f12) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f3 (f25 f26 f27) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (f10 (f28 (f31 f32 (f3 (f25 f26 ?v0) (f7 f8 2))) (- 1)) (+ (* 4 f12) 1)) f1) false)) false))
(assert (= (f10 f21 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f10 f21 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (let ((?v_0 (+ (* 4 f12) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f10 (f28 (f31 f32 f33) f27) ?v_0) f1)))))
(assert (= (f10 (f28 (f31 f32 (f3 (f25 f26 f27) (f7 f8 2))) (- 1)) (+ (* 4 f12) 1)) f1))
(assert (= (f10 (f28 f30 (+ (* 4 f12) 1)) (- (f3 (f25 f26 f27) (f7 f8 2)) (- 1))) f1))
(assert (= (f10 (f28 f30 (+ (* 4 f12) 1)) (+ (f3 (f25 f26 f27) (f7 f8 2)) 1)) f1))
(assert (let ((?v_0 (f7 f8 2))) (= (f10 (f28 (f31 f32 (f3 (f25 f26 f27) ?v_0)) (f3 (f25 f26 f33) ?v_0)) (+ (* 4 f12) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f12) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f10 (f28 (f31 f32 f33) ?v0) ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f12) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f10 (f28 (f31 f32 f33) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f10 (f28 (f31 f32 f33) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 (f28 f30 (* ?v0 ?v1)) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f10 (f28 f30 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f30 ?v0))) (=> (= (f10 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f10 ?v_0 ?v2) f1) (= (f10 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f28 f30 ?v0) ?v1) f1) (=> (= (f10 (f28 f30 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f28 f30 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f28 f30 ?v0))) (=> (= (f10 ?v_0 ?v1) f1) (= (= (f10 ?v_0 (+ ?v2 ?v3)) f1) (= (f10 ?v_0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f10 (f28 f30 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f10 (f28 f30 ?v0) ?v1) f1) (=> (= (f10 (f28 f30 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f10 (f28 f30 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f10 (f28 f30 (* ?v0 ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f10 (f28 (f31 f32 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f10 (f28 (f31 f32 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f30 ?v0))) (= (= (f10 ?v_0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f10 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (= (f10 (f28 f30 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f28 f30 ?v0))) (=> (= (f10 f21 ?v0) f1) (=> (= (f10 ?v_0 (f3 (f25 f26 ?v1) ?v2)) f1) (= (f10 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f28 f30 (f3 (f25 f26 ?v0) ?v2)))) (=> (= (f10 f21 ?v0) f1) (=> (not (= (f10 (f28 f30 ?v0) ?v1) f1)) (=> (= (f10 ?v_0 (* ?v3 ?v1)) f1) (= (f10 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f28 f30 (f3 (f25 f26 ?v0) ?v2)))) (=> (= (f10 f21 ?v0) f1) (=> (not (= (f10 (f28 f30 ?v0) ?v1) f1)) (=> (= (f10 ?v_0 (* ?v1 ?v3)) f1) (= (f10 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f25 f26 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f25 f26 ?v0) ?v_0) (f3 (f25 f26 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f25 f26 ?v0))) (= (f3 (f25 f26 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f25 f26 ?v0) ?v_0) (f3 (f25 f26 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f25 f26 ?v1)) (?v_1 (f25 f26 ?v0))) (= (f3 (f25 f26 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f25 f26 ?v0)) (?v_3 (f25 f26 ?v1))) (= (f3 (f25 f26 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f25 f26 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f25 f26 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f25 f26 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f25 f26 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f25 f26 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f25 f26 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f25 f26 (- ?v0)) ?v_0) (- (f3 (f25 f26 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f25 f26 ?v0))) (= (* ?v0 (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (* (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f25 f26 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f25 f26 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f25 f26 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 f21 ?v0) f1) (=> (not (= (f10 (f28 f30 ?v0) ?v1) f1)) (= (f10 (f28 (f31 f32 (f3 (f25 f26 ?v1) (f7 f8 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 (f23 f24 ?v0) ?v1) (ite (= (f10 (f28 (f31 f32 ?v0) 0) ?v1) f1) 0 (ite (= (f10 (f28 f29 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f28 f29 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f10 (f28 (f31 f32 (f3 (f25 f26 ?v2) (f7 f8 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f28 f30 ?v0))) (=> (= (f10 f21 ?v0) f1) (=> (= (f10 ?v_0 (f3 (f25 f26 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f10 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f10 (f28 (f31 f32 ?v0) 0) ?v1) f1)) (=> (= (f10 (f28 (f31 f32 (f3 (f25 f26 ?v2) (f7 f8 2))) ?v0) ?v1) f1) (not (= (f10 (f28 f30 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f10 f21 ?v1) f1) (= (f10 (f28 f30 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f30 ?v1))) (=> (<= 0 ?v0) (=> (= (f10 f21 ?v1) f1) (=> (= (f10 ?v_0 (* ?v0 ?v2)) f1) (or (= (f10 ?v_0 ?v0) f1) (= (f10 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f30 ?v0))) (=> (= (f10 f21 ?v0) f1) (=> (= (f10 ?v_0 (* ?v1 ?v2)) f1) (or (= (f10 ?v_0 ?v1) f1) (= (f10 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f28 (f31 f32 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (= (f10 (f28 (f31 f32 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 (f31 f32 ?v0) ?v1))) (= (= (f10 ?v_0 (- ?v2)) f1) (= (f10 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f10 (f28 (f31 f32 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f28 (f31 f32 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f28 (f31 f32 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f28 (f31 f32 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f10 (f28 (f31 f32 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f10 (f28 (f31 f32 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f10 (f28 (f31 f32 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f10 (f28 (f31 f32 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f10 (f28 (f31 f32 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f31 f32 ?v1))) (=> (< 2 ?v0) (=> (= (f10 (f28 ?v_0 (- 1)) ?v0) f1) (not (= (f10 (f28 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f31 f32 ?v3))) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (= (= (f10 (f28 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f10 (f28 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f31 f32 ?v3))) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (= (= (f10 (f28 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f10 (f28 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (= (f10 (f28 (f31 f32 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (= (f10 (f28 (f31 f32 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (= (f10 (f28 (f31 f32 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f31 f32 ?v0))) (=> (= (f10 (f28 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f10 (f28 (f31 f32 ?v3) ?v4) ?v2) f1) (= (f10 (f28 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f31 f32 ?v0))) (=> (= (f10 (f28 ?v_0 ?v1) ?v2) f1) (=> (= (f10 (f28 (f31 f32 ?v1) ?v3) ?v2) f1) (= (f10 (f28 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (=> (= (f10 (f28 (f31 f32 ?v3) ?v4) ?v2) f1) (= (f10 (f28 (f31 f32 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (=> (= (f10 (f28 (f31 f32 ?v3) ?v4) ?v2) f1) (= (f10 (f28 (f31 f32 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (=> (= (f10 (f28 (f31 f32 ?v3) ?v4) ?v2) f1) (= (f10 (f28 (f31 f32 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f28 f30 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f25 f26 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (* ?v1 (f3 ?v_0 (f7 f8 (- (f3 f4 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f28 (f31 f32 ?v0) 0) ?v1) f1) (= (f10 (f28 f30 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f28 (f31 f32 ?v0) 0) ?v1) f1) (= (f10 (f28 f30 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (= (f10 (f28 f30 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f10 (f28 (f31 f32 ?v0) ?v1) ?v2) f1) (= (f10 (f28 (f31 f32 (f3 (f25 f26 ?v0) ?v3)) (f3 (f25 f26 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f30 ?v1))) (=> (< 0 (f3 f4 ?v0)) (=> (= (f10 ?v_0 ?v2) f1) (= (f10 ?v_0 (f3 (f25 f26 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 f21 ?v0) f1) (=> (not (= (f10 (f28 (f31 f32 ?v1) 0) ?v0) f1)) (=> (not (= (f10 (f28 (f31 f32 ?v2) 0) ?v0) f1)) (not (= (f10 (f28 (f31 f32 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 f21 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f10 (f28 (f31 f32 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 f21 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f10 (f28 (f31 f32 ?v1) 0) ?v0) f1)) (not (= (f10 (f28 (f31 f32 ?v2) 0) ?v0) f1))) (not (= (f10 (f28 (f31 f32 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 f21 ?v0) f1) (=> (< 0 ?v1) (=> (= (f10 (f28 (f31 f32 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f10 (f28 (f31 f32 ?v1) 0) ?v0) f1) (= (f10 (f28 (f31 f32 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f31 f32 ?v1))) (=> (= (f10 f21 ?v0) f1) (=> (< 0 ?v1) (=> (= (f10 (f28 (f31 f32 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f10 (f28 ?v_0 1) ?v0) f1) (= (f10 (f28 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int)) (= (= (f10 f21 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f10 (f28 f30 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f10 (f28 f30 (f3 (f25 f26 ?v1) ?v0)) (f3 (f25 f26 ?v2) ?v0)) f1) (= (f10 (f28 f30 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f10 (f28 f30 (f3 (f25 f26 ?v0) ?v1)) (f3 (f25 f26 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f10 (f28 f30 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f10 (f28 (f31 f32 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (= (f34 f35 (f36 f27 1)) (* (+ (* 4 f12) 1) f13)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f10 (f28 f30 ?v0) ?v1) f1) (= (f10 (f28 f30 (f3 (f25 f26 ?v0) ?v2)) (f3 (f25 f26 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f37 (f38 f39 (f40 (f41 f42 ?v0) ?v2)) (f40 (f41 f42 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f34 f35 (f36 ?v0 ?v1)) (f34 f35 (f36 ?v2 ?v3))) (f34 f35 (f36 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f7 f8 (f3 (f25 f26 ?v0) ?v1)) (f40 (f41 f42 (f7 f8 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f25 f26 (f3 f4 ?v0)) ?v1) (f3 f4 (f40 (f41 f42 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f40 (f41 f42 ?v0) ?v1)) (f3 (f25 f26 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f37 (f38 f39 (f7 f8 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f10 (f28 f30 ?v0) (f3 f4 ?v1)) f1) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f10 (f28 f30 (f3 f4 ?v0)) ?v1) f1) (= (f37 (f38 f39 ?v0) (f7 f8 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f10 (f28 f30 ?v0) (f3 f4 ?v1)) f1) (= (f37 (f38 f39 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f10 (f28 f30 (f3 f4 ?v0)) (f3 f4 ?v1)) f1))))
(assert (forall ((?v0 Int)) (= (f3 (f25 f26 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f40 (f41 f42 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f22 f43 (f3 (f25 f26 ?v0) ?v1)) (f3 (f25 f26 (f22 f43 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f10 (f28 (f31 f32 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f25 f26 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f10 (f28 f30 (f3 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f10 (f28 f30 (f3 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f37 (f38 f39 (f40 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f37 (f38 f39 (f40 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f10 (f28 f30 ?v0) ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f10 (f28 f30 (f3 (f25 f26 ?v0) ?v2)) (f3 (f25 f26 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f37 (f38 f39 (f40 (f41 f42 ?v0) ?v2)) (f40 (f41 f42 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f25 f26 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f10 (f28 f30 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f37 (f38 f39 (f40 ?v_0 ?v0)) (f40 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f10 f11 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f34 f35 (f36 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int)) (=> (= (f10 f21 ?v0) f1) (= (f10 (f28 (f31 f32 (f22 f44 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f10 (f28 (f31 f32 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f10 (f28 (f31 f32 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 f21 ?v0) f1) (= (f10 (f28 (f31 f32 (f22 (f23 f24 ?v1) ?v0)) (f3 (f25 f26 ?v1) (f7 f8 (f22 (f23 f45 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f4 (f40 (f41 f42 ?v0) ?v1))) (or (< 0 (f3 f4 ?v0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (f40 (f41 f42 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (= (f40 (f41 f42 ?v0) ?v1) ?v_0) (or (= ?v1 (f7 f8 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (< 0 (f3 f4 ?v0)) (=> (< (f3 f4 (f40 ?v_0 ?v1)) (f3 f4 (f40 ?v_0 ?v2))) (< (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f4 ?v0)) (<= ?v_0 (f3 f4 (f40 (f41 f42 ?v0) ?v1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (not (and (= (f37 (f38 f39 ?v_0) ?v0) f1) (not (= (f37 (f38 f39 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (not (and (= (f37 (f38 f39 ?v0) ?v_0) f1) (not (= (f37 (f38 f39 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (= (f37 (f38 f39 (f7 f8 1)) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f37 (f38 f39 ?v0) (f7 f8 0)) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (not (= ?v0 ?v_0)) (and (= (f37 (f38 f39 ?v_0) ?v0) f1) (not (= (f37 (f38 f39 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (= (not (= ?v0 ?v_0)) (and (= (f37 (f38 f39 ?v0) ?v_0) f1) (not (= (f37 (f38 f39 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (= (= (f37 (f38 f39 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (= (f37 (f38 f39 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (=> (= (f37 (f38 f39 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f37 (f38 f39 ?v1) ?v0) f1) (< 0 (f3 f4 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (=> (= (f37 (f38 f39 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f37 (f38 f39 (f40 ?v_0 ?v1)) (f40 ?v_0 ?v2)) f1) (=> (< 1 (f3 f4 ?v0)) (<= (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f37 (f38 f39 (f40 (f41 f42 ?v1) ?v0)) (f40 (f41 f42 ?v2) ?v0)) f1) (= (f37 (f38 f39 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f22 (f23 f45 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f22 (f23 f45 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f22 (f23 f45 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 f21 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f10 (f28 (f31 f32 ?v1) 0) ?v0) f1)) (=> (not (= (f10 (f28 f29 ?v0) ?v1) f1)) (= (f10 (f28 (f31 f32 (f22 f44 ?v_0)) (f3 (f25 f26 ?v1) (f7 f8 (f22 (f23 f45 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 f21 ?v0) f1) (=> (= (f10 (f28 (f31 f32 ?v1) 0) ?v0) f1) (= (f10 (f28 (f31 f32 0) (f3 (f25 f26 ?v1) (f7 f8 (f22 (f23 f45 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 f21 ?v0) f1) (=> (not (= (f10 (f28 (f31 f32 ?v1) 0) ?v0) f1)) (=> (not (= (f10 (f28 f29 ?v0) ?v1) f1)) (= (f10 (f28 (f31 f32 (f3 (f25 f26 ?v1) (f7 f8 (f22 (f23 f45 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 f21 ?v0) f1) (=> (not (= (f10 (f28 (f31 f32 ?v1) 0) ?v0) f1)) (=> (= (f10 (f28 f29 ?v0) ?v1) f1) (= (f10 (f28 (f31 f32 (f3 (f25 f26 ?v1) (f7 f8 (f22 (f23 f45 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f10 (f28 f30 ?v0) ?v1) f1) (= (f3 (f25 f26 (f22 (f23 f45 ?v1) ?v0)) ?v2) (f22 (f23 f45 (f3 (f25 f26 ?v1) ?v2)) (f3 (f25 f26 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f40 (f41 f42 (f40 (f41 f46 ?v1) ?v0)) ?v2) (f40 (f41 f46 (f40 (f41 f42 ?v1) ?v2)) (f40 (f41 f42 ?v0) ?v2))))))
(assert (forall ((?v0 S3)) (= (f37 (f38 f39 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f37 (f38 f39 (f7 f8 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 (f23 f45 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 (f23 f45 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f22 (f23 f45 ?v0) ?v1)) (f7 f8 (f22 (f23 f45 (f3 f4 (f7 f8 ?v0))) (f3 f4 (f7 f8 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f7 f8 (f22 (f23 f45 (f3 f4 (f7 f8 ?v0))) (f3 f4 (f7 f8 ?v1)))) (f7 f8 (f22 (f23 f45 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f38 f39 ?v0)) (?v_0 (f38 f39 ?v1)) (?v_2 (f38 f39 ?v2))) (=> (and (= (f37 ?v_1 ?v1) f1) (not (= (f37 ?v_0 ?v0) f1))) (=> (and (= (f37 ?v_0 ?v2) f1) (not (= (f37 ?v_2 ?v1) f1))) (and (= (f37 ?v_1 ?v2) f1) (not (= (f37 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f38 f39 ?v0)) (?v_0 (f38 f39 ?v1))) (=> (and (= (f37 ?v_1 ?v1) f1) (not (= (f37 ?v_0 ?v0) f1))) (=> (= (f37 ?v_0 ?v2) f1) (and (= (f37 ?v_1 ?v2) f1) (not (= (f37 (f38 f39 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (and (= (f37 ?v_0 ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f37 ?v_0 ?v2) f1) (not (= (f37 (f38 f39 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f37 (f38 f39 ?v0) ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f37 (f38 f39 ?v0) ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f37 (f38 f39 ?v0) ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0)) (?v_1 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (=> (= (f37 ?v_0 (f7 f8 (- ?v_2 ?v_1))) f1) (=> (= (f37 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f37 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0)) (?v_1 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (=> (= (f37 ?v_0 (f7 f8 (- ?v_2 ?v_1))) f1) (=> (= (f37 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f37 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0)) (?v_1 (f38 f39 ?v2))) (=> (= (f37 ?v_0 ?v1) f1) (=> (and (= (f37 (f38 f39 ?v1) ?v2) f1) (not (= (f37 ?v_1 ?v1) f1))) (and (= (f37 ?v_0 ?v2) f1) (not (= (f37 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f37 (f38 f39 ?v1) ?v2) f1) (not (= (f37 ?v_0 ?v1) f1))) (and (= (f37 (f38 f39 ?v0) ?v2) f1) (not (= (f37 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f37 ?v_0 ?v1) f1) (=> (= (f37 ?v_0 ?v2) f1) (= (f37 ?v_0 (f7 f8 (- (f3 f4 ?v1) (f3 f4 ?v2)))) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f37 ?v_0 ?v1) f1) (=> (= (f37 (f38 f39 ?v1) ?v2) f1) (= (f37 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (=> (= (f37 (f38 f39 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (=> (= (f37 (f38 f39 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f37 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f37 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f37 (f38 f39 ?v1) ?v2) f1) (= (f37 (f38 f39 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f4 ?v1))) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f3 f4 ?v0) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (= (= (f37 (f38 f39 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f37 (f38 f39 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f4 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f3 f4 ?v1)) (not (= (f37 (f38 f39 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (and (= (f37 (f38 f39 ?v0) ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f38 f39 ?v0))) (= (= (f37 ?v_0 (f7 f8 (+ (f3 f4 ?v1) (f3 f4 ?v0)))) f1) (= (f37 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (= (f37 (f38 f39 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f37 (f38 f39 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (= (f37 (f38 f39 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f22 (f23 f45 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f22 (f23 f45 ?v1) ?v2) (f22 (f23 f45 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f22 (f23 f45 ?v0) ?v2) (f22 (f23 f45 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f22 (f23 f45 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f45 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f22 ?v_0 ?v1) (f22 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f22 (f23 f45 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f22 (f23 f45 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f22 (f23 f45 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f22 (f23 f45 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f22 (f23 f45 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f22 (f23 f45 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f22 (f23 f45 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f22 (f23 f45 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f22 (f23 f45 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f45 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f22 ?v_0 ?v2) (f22 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f22 (f23 f45 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f22 (f23 f45 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f22 (f23 f45 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f22 (f23 f45 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f22 (f23 f45 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f22 (f23 f45 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f45 ?v1))) (=> (< 0 ?v0) (= (f22 ?v_0 (* ?v2 ?v0)) (f22 (f23 f45 (f22 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f22 (f23 f45 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f22 (f23 f45 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f22 (f23 f45 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f22 (f23 f45 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 (f23 f45 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 (f23 f45 (- ?v0)) (- ?v1)) (f22 (f23 f45 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 (f23 f45 ?v0) (- ?v1)) (f22 (f23 f45 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f22 (f23 f45 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int)) (= (f22 (f23 f45 0) ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f7 f8 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f22 (f23 f45 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f22 (f23 f47 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
