(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 () S3)
(declare-fun f8 (Int) S1)
(declare-fun f9 (S4 Int) S3)
(declare-fun f10 () S4)
(assert (not (= f1 f2)))
(assert (not (< (+ 1 (f3 f4 f5)) (+ (* 4 f6) 1))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f7)))) (and (< ?v_1 ?v_0) (= (f8 (* ?v_0 ?v_1)) f1))))
(assert (< (f3 f4 f5) (f3 f4 f7)))
(assert (< (f3 f4 f5) (f3 f4 f7)))
(assert (forall ((?v0 S3)) (= (f9 f10 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
