(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) Int)
(declare-fun f4 () S3)
(declare-fun f5 () S2)
(declare-fun f6 () Int)
(declare-fun f7 (Int) S1)
(declare-fun f8 () S2)
(declare-fun f9 (S4 Int) S2)
(declare-fun f10 () S4)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 (Int) S1)
(declare-fun f14 (S5 Int) Int)
(declare-fun f15 (S6 Int) S5)
(declare-fun f16 () S6)
(declare-fun f17 (Int Int) S1)
(declare-fun f18 () S2)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (S7 Int) S3)
(declare-fun f22 () S7)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 () Int)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 S2)) (let ((?v_0 (f3 f4 ?v0)) (?v_1 (+ (* 4 f6) 1))) (let ((?v_2 (+ 1 ?v_0))) (and (< ?v_0 (f3 f4 f5)) (not (=> (< ?v_2 ?v_1) (not (= (f7 (* ?v_1 ?v_2)) f1))))))))))
(assert (and (= f8 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1))) (= (f7 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f8)))) f1)))
(assert (< (f3 f4 f8) (f3 f4 f5)))
(assert (< (+ 1 (f3 f4 f8)) (+ (* 4 f6) 1)))
(assert (< 0 f11))
(assert (= (+ 1 (f3 f4 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1)))) f11))
(assert (< 1 f12))
(assert (< (+ 1 (f3 f4 f8)) (+ (* 4 f6) 1)))
(assert (< (f3 f4 f8) (f3 f4 f5)))
(assert (< 0 (f3 f4 f5)))
(assert (and (= f8 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1))) (= (f7 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f8)))) f1)))
(assert (not (= (f7 (* (+ (* 4 f6) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (< 0 (+ 1 (f3 f4 f5))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f5)))) (not (=> (< ?v_1 ?v_0) (not (= (f7 (* ?v_0 ?v_1)) f1))))))
(assert (< f11 (+ 1 (f3 f4 f5))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f5)))) (and (< ?v_1 ?v_0) (= (f7 (* ?v_0 ?v_1)) f1))))
(assert (= (f7 (* (+ (* 4 f6) 1) f11)) f1))
(assert (= (f7 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1)))))) f1))
(assert (= (f13 (+ (* 4 f6) 1)) f1))
(assert (= (f14 (f15 f16 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (=> (forall ((?v0 S2)) (=> (and (= ?v0 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1))) (= (f7 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 ?v0)))) f1)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (= (f7 ?v1) f1) (= (f7 (* ?v0 ?v1)) f1)))))
(assert (= (f17 (+ (* 4 f6) 1) (- 1)) f1))
(assert (= f18 (f9 f10 (- (f3 f4 (f9 f10 f12)) 1))))
(assert (= (f7 (* (+ (* 4 f6) 1) f12)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f19 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f20 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (< f12 (+ (* 4 f6) 1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f3 (f21 f22 ?v0) ?v_0) (f3 (f21 f22 ?v1) ?v_0)) (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f5)))) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f21 f22 f19) ?v_0) (f3 (f21 f22 f20) ?v_0)) (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f5))))))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f17 ?v_0 (- 1)) f1)) (not (= (f14 (f15 f16 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f23 (- f19 (* f24 ?v_0))) (<= (* 2 (ite (< f23 0) (- f23) f23)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f25 (- f20 (* f26 ?v_0))) (<= (* 2 (ite (< f25 0) (- f25) f25)) ?v_0))))
(assert (<= 1 f12))
(assert (< 0 (f3 f4 f18)))
(assert (=> (forall ((?v0 S2)) (=> (= ?v0 (f9 f10 (- (f3 f4 (f9 f10 f12)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f21 f22 f23) ?v_0) (f3 (f21 f22 f25) ?v_0)) (* (+ 1 (f3 f4 f5)) f11))))
(assert (= (+ (f3 (f21 f22 f27) (f9 f10 2)) 1) (* (+ (* 4 f6) 1) f12)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f3 (f21 f22 f23) ?v_0) (f3 (f21 f22 f25) ?v_0)) (* (+ 1 (f3 f4 f5)) ?v0)) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f21 f22 (+ (+ (* f24 f23) (* f26 f25)) f11)) ?v_0) (f3 (f21 f22 (- (* f24 f25) (* f26 f23))) ?v_0)) (* (+ (* 4 f6) 1) f11))))
(assert (=> (= f12 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f21 f22 ?v0) ?v_0) (f3 (f21 f22 ?v1) ?v_0)) (+ (* 4 f6) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f13 ?v_0) f1) (= (f14 (f15 f16 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (f9 f10 2))) (= (f28 (+ 1 (f3 f4 f5)) (+ (f3 (f21 f22 f23) ?v_0) (f3 (f21 f22 f25) ?v_0))) f1)))
(assert (= (f29 (f3 (f21 f22 f30) (f9 f10 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f21 f22 f27) (f9 f10 2)) 1) (* (+ (* 4 f6) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f3 (f21 f22 f27) (f9 f10 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f3 (f21 f22 ?v0) (f9 f10 2)) (- 1) (+ (* 4 f6) 1)) f1) false)) false))
(assert (= (f13 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f13 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f3 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f21 f22 ?v0) (f9 f10 2)))))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f29 f30 f27 ?v_0) f1)))))
(assert (= (f29 (f3 (f21 f22 f27) (f9 f10 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (= (f28 (+ (* 4 f6) 1) (+ (f3 (f21 f22 f27) (f9 f10 2)) 1)) f1))
(assert (= (f28 (+ (* 4 f6) 1) (- (f3 (f21 f22 f27) (f9 f10 2)) (- 1))) f1))
(assert (let ((?v_0 (f9 f10 2))) (= (f29 (f3 (f21 f22 f27) ?v_0) (f3 (f21 f22 f30) ?v_0) (+ (* 4 f6) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f30 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f30 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f30 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 (* ?v0 ?v1) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f28 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 (- ?v1 ?v2)) f1) (=> (= (f28 ?v0 ?v2) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (= (f28 ?v0 (+ ?v2 ?v3)) f1) (= (f28 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f28 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f28 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f28 (* ?v0 ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f29 (* ?v0 ?v_0) 1 ?v1) f1) (= (f29 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (= (= (f28 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f13 ?v0) f1) (=> (= (f28 ?v0 (f3 (f21 f22 ?v1) ?v2)) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f3 (f21 f22 ?v0) ?v2))) (=> (= (f13 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (* ?v3 ?v1)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f3 (f21 f22 ?v0) ?v2))) (=> (= (f13 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (* ?v1 ?v3)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f21 f22 ?v0) (f9 f10 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (= (f3 (f21 f22 ?v0) ?v_0) (f3 (f21 f22 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2)) (?v_1 (f21 f22 ?v0))) (= (f3 (f21 f22 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f9 f10 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f21 f22 ?v0) ?v_0) (f3 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_3 (f21 f22 ?v1)) (?v_1 (f21 f22 ?v0))) (= (f3 (f21 f22 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f9 f10 2)) (?v_0 (f9 f10 3)) (?v_1 (f21 f22 ?v0)) (?v_3 (f21 f22 ?v1))) (= (f3 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f3 (f21 f22 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f21 f22 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (f3 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f21 f22 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 3))) (= (f3 (f21 f22 (- ?v0)) ?v_0) (- (f3 (f21 f22 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (* ?v0 (f3 ?v_0 (f9 f10 2))) (f3 ?v_0 (f9 f10 3))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f3 ?v_0 (f9 f10 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (* (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f3 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 3))) (let ((?v_0 (f3 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 2))) (let ((?v_0 (f3 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f13 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (= (f29 (f3 (f21 f22 ?v1) (f9 f10 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 (f15 f16 ?v0) ?v1) (ite (= (f29 ?v0 0 ?v1) f1) 0 (ite (= (f17 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f29 (f3 (f21 f22 ?v2) (f9 f10 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f13 ?v0) f1) (=> (= (f28 ?v0 (f3 (f21 f22 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f28 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f29 ?v0 0 ?v1) f1)) (=> (= (f29 (f3 (f21 f22 ?v2) (f9 f10 2)) ?v0 ?v1) f1) (not (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f13 ?v1) f1) (= (f28 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f13 ?v1) f1) (=> (= (f28 ?v1 (* ?v0 ?v2)) f1) (or (= (f28 ?v1 ?v0) f1) (= (f28 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 ?v0) f1) (=> (= (f28 ?v0 (* ?v1 ?v2)) f1) (or (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 (- ?v2)) f1) (= (f29 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f29 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f29 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f29 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f29 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v1 (- 1) ?v0) f1) (not (= (f29 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f29 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f29 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v1 ?v3 ?v2) f1) (= (f29 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 ?v1)) (?v_1 (f9 f10 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (* ?v1 (f3 ?v_0 (f9 f10 (- (f3 f4 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f28 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f3 (f21 f22 ?v0) ?v3) (f3 (f21 f22 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f28 ?v1 ?v2) f1) (= (f28 ?v1 (f3 (f21 f22 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f13 ?v0) f1) (=> (not (= (f29 ?v1 0 ?v0) f1)) (=> (not (= (f29 ?v2 0 ?v0) f1)) (not (= (f29 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 S2)) (= (f9 f10 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
