(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 S3) Int)
(declare-fun f6 () S2)
(declare-fun f7 (S4 Int) S3)
(declare-fun f8 () S4)
(declare-fun f9 () Int)
(declare-fun f10 () S3)
(declare-fun f11 (Int) S1)
(declare-fun f12 (S5 Int) Int)
(declare-fun f13 (S6 Int) S5)
(declare-fun f14 () S6)
(declare-fun f15 (S7 Int) S1)
(declare-fun f16 (Int) S7)
(declare-fun f17 (S8 Int) S2)
(declare-fun f18 () S8)
(declare-fun f19 () Int)
(declare-fun f20 (S9 S10) Int)
(declare-fun f21 () S9)
(declare-fun f22 (Int Int) S10)
(declare-fun f23 (S11 Int) S7)
(declare-fun f24 (Int) S11)
(declare-fun f25 () Int)
(declare-fun f26 (Int) S7)
(declare-fun f27 () S5)
(declare-fun f28 () S6)
(declare-fun f29 () S5)
(declare-fun f30 () S6)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 (f5 f6 (f7 f8 (- (f5 f6 (f7 f8 f9)) 1)))))) f1))))
(assert (let ((?v_0 (+ (* 4 f4) 1)) (?v_1 (+ 1 (f5 f6 f10)))) (=> (< ?v_1 ?v_0) (not (= (f3 (* ?v_0 ?v_1)) f1)))))
(assert (and (< (+ 1 (f5 f6 f10)) (+ (* 4 f4) 1)) (= f10 (f7 f8 (- (f5 f6 (f7 f8 f9)) 1)))))
(assert (< 1 f9))
(assert (let ((?v_0 (+ (* 4 f4) 1)) (?v_1 (+ 1 (f5 f6 f10)))) (=> (< ?v_1 ?v_0) (not (= (f3 (* ?v_0 ?v_1)) f1)))))
(assert (= f10 (f7 f8 (- (f5 f6 (f7 f8 f9)) 1))))
(assert (and (< (+ 1 (f5 f6 f10)) (+ (* 4 f4) 1)) (= f10 (f7 f8 (- (f5 f6 (f7 f8 f9)) 1)))))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (<= 1 f9))
(assert (< f9 (+ (* 4 f4) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f5 f6 (f7 f8 f9)) 1))) (=> (< 0 (f5 f6 ?v0)) false))) false))
(assert (= (f3 (* (+ (* 4 f4) 1) f9)) f1))
(assert (= (f11 (+ (* 4 f4) 1)) f1))
(assert (= (f12 (f13 f14 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (* ?v0 ?v1)) f1)))))
(assert (= (f15 (f16 (+ (* 4 f4) 1)) (- 1)) f1))
(assert (= (+ (f5 (f17 f18 f19) (f7 f8 2)) 1) (* (+ (* 4 f4) 1) f9)))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f15 (f16 ?v_0) (- 1)) f1)) (not (= (f12 (f13 f14 (- 1)) ?v_0) 1)))))
(assert (=> (= f9 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f5 (f17 f18 ?v0) ?v_0) (f5 (f17 f18 ?v1) ?v_0)) (+ (* 4 f4) 1))))))
(assert (= (f20 f21 (f22 f19 1)) (* (+ (* 4 f4) 1) f9)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f15 (f23 (f24 f25) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f15 (f23 (f24 f25) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f15 (f23 (f24 f25) ?v0) ?v_0) f1))) false))) false))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f19) (and (< f19 ?v_0) (= (f15 (f23 (f24 f25) f19) ?v_0) f1)))))
(assert (= (f15 (f23 (f24 (f5 (f17 f18 f25) (f7 f8 2))) (- 1)) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f5 (f17 f18 f19) (f7 f8 2)) 1) (* (+ (* 4 f4) 1) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int)) (=> (= (f15 (f23 (f24 (f5 (f17 f18 ?v0) (f7 f8 2))) (- 1)) (+ (* 4 f4) 1)) f1) false)) false))
(assert (forall ((?v0 Int)) (= (= (f3 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f20 f21 (f22 ?v1 ?v2)) ?v0)))))
(assert (< 0 (f5 f6 f10)))
(assert (let ((?v_0 (f5 (f17 f18 f19) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f15 (f23 (f24 (f5 (f17 f18 f19) (f7 f8 2))) (- 1)) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (f7 f8 2))) (= (f15 (f23 (f24 (f5 (f17 f18 f19) ?v_0)) (f5 (f17 f18 f25) ?v_0)) (+ (* 4 f4) 1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f20 f21 (f22 ?v0 ?v1)) (f20 f21 (f22 ?v2 ?v3))) (f20 f21 (f22 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f11 ?v_0) f1) (= (f12 (f13 f14 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 ?v0) ?v1) (ite (= (f15 (f23 (f24 ?v0) 0) ?v1) f1) 0 (ite (= (f15 (f16 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f16 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f15 (f23 (f24 (f5 (f17 f18 ?v2) (f7 f8 2))) ?v1) ?v0) f1)))))
(assert (= (f15 (f26 (+ (* 4 f4) 1)) (- (f5 (f17 f18 f19) (f7 f8 2)) (- 1))) f1))
(assert (= (f15 (f26 (+ (* 4 f4) 1)) (+ (f5 (f17 f18 f19) (f7 f8 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (not (= (f15 (f23 (f24 ?v1) 0) ?v0) f1)) (=> (not (= (f15 (f23 (f24 ?v2) 0) ?v0) f1)) (not (= (f15 (f23 (f24 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f15 (f23 (f24 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f15 (f23 (f24 ?v1) 0) ?v0) f1)) (not (= (f15 (f23 (f24 ?v2) 0) ?v0) f1))) (not (= (f15 (f23 (f24 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (< 0 ?v1) (=> (= (f15 (f23 (f24 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f15 (f23 (f24 ?v1) 0) ?v0) f1) (= (f15 (f23 (f24 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f24 ?v1))) (=> (= (f11 ?v0) f1) (=> (< 0 ?v1) (=> (= (f15 (f23 (f24 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f15 (f23 ?v_0 1) ?v0) f1) (= (f15 (f23 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 (- 1)))) (let ((?v_1 (f5 ?v_0 ?v1)) (?v_2 (f5 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f15 (f23 (f24 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 (f26 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (= (f15 (f26 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f23 (f24 ?v0) 0) ?v1) f1) (= (f15 (f26 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f23 (f24 ?v0) 0) ?v1) f1) (= (f15 (f26 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 ?v1))) (=> (< 0 (f5 f6 ?v0)) (=> (= (f15 ?v_0 ?v2) f1) (= (f15 ?v_0 (f5 (f17 f18 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 ?v1))) (=> (<= 0 ?v0) (=> (= (f11 ?v1) f1) (=> (= (f15 ?v_0 (* ?v0 ?v2)) f1) (or (= (f15 ?v_0 ?v0) f1) (= (f15 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 ?v0))) (=> (= (f11 ?v0) f1) (=> (= (f15 ?v_0 (* ?v1 ?v2)) f1) (or (= (f15 ?v_0 ?v1) f1) (= (f15 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f11 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f15 (f26 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f26 ?v0))) (=> (= (f11 ?v0) f1) (=> (= (f15 ?v_0 (f5 (f17 f18 ?v1) ?v2)) f1) (=> (< 0 (f5 f6 ?v2)) (= (f15 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (=> (= (f15 (f23 (f24 ?v3) ?v4) ?v2) f1) (= (f15 (f23 (f24 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (=> (= (f15 (f23 (f24 ?v3) ?v4) ?v2) f1) (= (f15 (f23 (f24 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (=> (= (f15 (f23 (f24 ?v3) ?v4) ?v2) f1) (= (f15 (f23 (f24 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 ?v0))) (=> (= (f15 (f23 ?v_0 ?v1) ?v2) f1) (=> (= (f15 (f23 (f24 ?v1) ?v3) ?v2) f1) (= (f15 (f23 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f24 ?v0))) (=> (= (f15 (f23 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f15 (f23 (f24 ?v3) ?v4) ?v2) f1) (= (f15 (f23 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (= (f15 (f23 (f24 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (= (f15 (f23 (f24 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (= (f15 (f23 (f24 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f24 ?v3))) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (= (= (f15 (f23 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f15 (f23 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f24 ?v3))) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (= (= (f15 (f23 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f15 (f23 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f24 ?v1))) (=> (< 2 ?v0) (=> (= (f15 (f23 ?v_0 (- 1)) ?v0) f1) (not (= (f15 (f23 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f15 (f23 (f24 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f15 (f23 (f24 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f15 (f23 (f24 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f15 (f23 (f24 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f15 (f23 (f24 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f15 (f23 (f24 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f15 (f23 (f24 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f23 (f24 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f23 (f24 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int)) (= (f15 (f23 (f24 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 (f24 ?v0) ?v1))) (= (= (f15 ?v_0 (- ?v2)) f1) (= (f15 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (= (f15 (f23 (f24 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f23 (f24 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 (f17 f18 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f15 (f23 (f24 ?v0) ?v1) ?v2) f1) (= (f15 (f23 (f24 (f5 (f17 f18 ?v0) ?v3)) (f5 (f17 f18 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (not (= (f15 (f26 ?v0) ?v1) f1)) (= (f15 (f23 (f24 (f5 (f17 f18 ?v1) (f7 f8 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f26 ?v0))) (=> (= (f11 ?v0) f1) (=> (= (f15 ?v_0 (f5 (f17 f18 ?v1) ?v2)) f1) (= (f15 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f26 (f5 (f17 f18 ?v0) ?v2)))) (=> (= (f11 ?v0) f1) (=> (not (= (f15 (f26 ?v0) ?v1) f1)) (=> (= (f15 ?v_0 (* ?v3 ?v1)) f1) (= (f15 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f26 (f5 (f17 f18 ?v0) ?v2)))) (=> (= (f11 ?v0) f1) (=> (not (= (f15 (f26 ?v0) ?v1) f1)) (=> (= (f15 ?v_0 (* ?v1 ?v3)) f1) (= (f15 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f15 (f23 (f24 ?v0) 0) ?v1) f1)) (=> (= (f15 (f23 (f24 (f5 (f17 f18 ?v2) (f7 f8 2))) ?v0) ?v1) f1) (not (= (f15 (f26 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f15 (f26 (f5 (f17 f18 ?v0) ?v1)) (f5 (f17 f18 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f15 (f26 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f15 (f26 (f5 (f17 f18 ?v1) ?v0)) (f5 (f17 f18 ?v2) ?v0)) f1) (= (f15 (f26 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f15 (f26 ?v0) ?v1) f1) (= (f15 (f26 (f5 (f17 f18 ?v0) ?v2)) (f5 (f17 f18 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f12 f27 (f5 (f17 f18 ?v0) ?v1)) (f5 (f17 f18 (f12 f27 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f5 (f17 f18 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 Int)) (<= ?v0 (f5 (f17 f18 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f5 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f5 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f5 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (* ?v0 (f5 ?v_0 (f7 f8 2))) (f5 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f5 (f17 f18 (- ?v0)) ?v_0) (- (f5 (f17 f18 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f5 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (f5 (f17 f18 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f5 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f5 (f17 f18 (- ?v0 ?v1)) ?v_0) (+ (- (f5 (f17 f18 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f5 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f17 f18 ?v0)) (?v_3 (f17 f18 ?v1))) (= (f5 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f5 ?v_1 ?v_0) (* (* 3 (f5 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f5 ?v_3 ?v_2))) (f5 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0))) (= (f5 (f17 f18 (- ?v0 ?v1)) ?v_0) (- (+ (- (f5 ?v_1 ?v_0) (* (* 3 (f5 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f5 ?v_3 ?v_2))) (f5 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f5 (f17 f18 ?v0) ?v_0) (f5 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f17 f18 ?v0))) (= (f5 (f17 f18 (f5 ?v_1 ?v_0)) ?v_0) (f5 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f5 (f17 f18 ?v0) ?v_0) (f5 (f17 f18 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f5 ?v_0 ?v_1) (* ?v1 (f5 ?v_0 (f7 f8 (- (f5 f6 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (=> (= (f5 (f17 f18 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f11 2) f1))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f15 (f26 (f5 ?v_0 ?v1)) ?v2) f1) (=> (<= (f5 f6 ?v3) (f5 f6 ?v1)) (= (f15 (f26 (f5 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f15 (f26 ?v0) ?v1) f1) (=> (<= (f5 f6 ?v2) (f5 f6 ?v3)) (= (f15 (f26 (f5 (f17 f18 ?v0) ?v2)) (f5 (f17 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f17 f18 ?v2))) (=> (<= (f5 f6 ?v0) (f5 f6 ?v1)) (= (f15 (f26 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f11 ?v1) f1) (= (f15 (f26 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f15 (f23 (f24 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f15 (f23 (f24 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (= (f15 (f23 (f24 (f12 (f13 f14 ?v1) ?v0)) (f5 (f17 f18 ?v1) (f7 f8 (f12 (f13 f28 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f15 (f23 (f24 ?v1) 0) ?v0) f1)) (=> (not (= (f15 (f16 ?v0) ?v1) f1)) (= (f15 (f23 (f24 (f5 (f17 f18 ?v1) (f7 f8 (f12 (f13 f28 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f15 (f23 (f24 ?v1) 0) ?v0) f1)) (=> (= (f15 (f16 ?v0) ?v1) f1) (= (f15 (f23 (f24 (f5 (f17 f18 ?v1) (f7 f8 (f12 (f13 f28 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f12 (f13 f28 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f12 (f13 f28 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f12 (f13 f28 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (= (f15 (f23 (f24 ?v1) 0) ?v0) f1) (= (f15 (f23 (f24 0) (f5 (f17 f18 ?v1) (f7 f8 (f12 (f13 f28 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f11 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f15 (f23 (f24 ?v1) 0) ?v0) f1)) (=> (not (= (f15 (f16 ?v0) ?v1) f1)) (= (f15 (f23 (f24 (f12 f29 ?v_0)) (f5 (f17 f18 ?v1) (f7 f8 (f12 (f13 f28 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f15 (f26 ?v0) ?v1) f1) (= (f5 (f17 f18 (f12 (f13 f28 ?v1) ?v0)) ?v2) (f12 (f13 f28 (f5 (f17 f18 ?v1) ?v2)) (f5 (f17 f18 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_1 (f5 f6 ?v0)) (?v_0 (f17 f18 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f12 (f13 f28 (f5 ?v_0 ?v0)) ?v1) (f5 ?v_0 (f7 f8 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 (f26 ?v0) ?v1) f1) (= (* ?v0 (f12 (f13 f28 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f7 f8 (f12 (f13 f28 (f5 f6 (f7 f8 ?v0))) (f5 f6 (f7 f8 ?v1)))) (f7 f8 (f12 (f13 f28 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f12 (f13 f28 ?v0) ?v1)) (f7 f8 (f12 (f13 f28 (f5 f6 (f7 f8 ?v0))) (f5 f6 (f7 f8 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f12 (f13 f28 (f5 f6 ?v0)) (f5 f6 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f12 (f13 f28 (f5 f6 ?v0)) (f5 f6 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S7) (?v1 Int) (?v2 Int)) (= (= (f15 ?v0 (f12 (f13 f28 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f15 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f15 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f15 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f7 f8 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f12 (f13 f28 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f12 (f13 f30 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
