(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 (S4 Int) S3)
(declare-fun f6 () S4)
(declare-fun f7 () Int)
(declare-fun f8 () S3)
(declare-fun f9 () Int)
(declare-fun f10 (Int) S1)
(declare-fun f11 (S5 Int) S2)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 (S6 S7) Int)
(declare-fun f15 () S6)
(declare-fun f16 (Int Int) S7)
(declare-fun f17 (Int) S1)
(declare-fun f18 (S8 Int) Int)
(declare-fun f19 (S9 Int) S8)
(declare-fun f20 () S9)
(declare-fun f21 (Int Int) S1)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 (Int Int Int) S1)
(declare-fun f24 () Int)
(declare-fun f25 () S8)
(declare-fun f26 () S9)
(declare-fun f27 () S9)
(declare-fun f28 () S9)
(assert (not (= f1 f2)))
(assert (not (= (+ 1 (f3 f4 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1)))) f7)))
(assert (<= 1 f7))
(assert (< 0 (f3 f4 f8)))
(assert (<= 1 f7))
(assert (< 1 f7))
(assert (= f8 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (< f7 (+ (* 4 f9) 1)))
(assert (not (= (f10 (* (+ (* 4 f9) 1) (+ 1 (f3 f4 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1)))))) f1)))
(assert (= (f10 (* (+ (* 4 f9) 1) f7)) f1))
(assert (and (< (+ 1 (f3 f4 f8)) (+ (* 4 f9) 1)) (= f8 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1)))))
(assert (= (+ (f3 (f11 f12 f13) (f5 f6 2)) 1) (* (+ (* 4 f9) 1) f7)))
(assert (=> (= f7 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 f6 2))) (= (+ (f3 (f11 f12 ?v0) ?v_0) (f3 (f11 f12 ?v1) ?v_0)) (+ (* 4 f9) 1))))))
(assert (= (f14 f15 (f16 f13 1)) (* (+ (* 4 f9) 1) f7)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (= (f10 ?v1) f1) (= (f10 (* ?v0 ?v1)) f1)))))
(assert (not (= (f10 (* (+ (* 4 f9) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f9) 1)))
(assert (let ((?v_0 (f3 (f11 f12 f13) (f5 f6 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f9) 1)) (?v_1 (+ 1 (f3 f4 f8)))) (=> (< ?v_1 ?v_0) (not (= (f10 (* ?v_0 ?v_1)) f1)))))
(assert (= (f17 (+ (* 4 f9) 1)) f1))
(assert (= (f18 (f19 f20 (- 1)) (+ (* 4 f9) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f11 f12 f13) (f5 f6 2)) 1) (* (+ (* 4 f9) 1) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f14 f15 (f16 ?v0 ?v1)) (f14 f15 (f16 ?v2 ?v3))) (f14 f15 (f16 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (= (f21 (+ (* 4 f9) 1) (- 1)) f1))
(assert (forall ((?v0 Int)) (= (= (f10 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f14 f15 (f16 ?v1 ?v2)) ?v0)))))
(assert (= (f22 (+ (* 4 f9) 1) (+ (f3 (f11 f12 f13) (f5 f6 2)) 1)) f1))
(assert (= (f22 (+ (* 4 f9) 1) (- (f3 (f11 f12 f13) (f5 f6 2)) (- 1))) f1))
(assert (= (f23 (f3 (f11 f12 f13) (f5 f6 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (and (<= 0 f13) (and (< f13 ?v_0) (= (f23 f24 f13 ?v_0) f1)))))
(assert (= (f23 (f3 (f11 f12 f24) (f5 f6 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (f5 f6 2))) (= (f23 (f3 (f11 f12 f13) ?v_0) (f3 (f11 f12 f24) ?v_0) (+ (* 4 f9) 1)) f1)))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (=> (not (= (f21 ?v_0 (- 1)) f1)) (not (= (f18 (f19 f20 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f23 (f3 (f11 f12 ?v0) (f5 f6 2)) (- 1) (+ (* 4 f9) 1)) f1) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f24 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f24 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f23 f24 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f17 ?v_0) f1) (= (f18 (f19 f20 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (= (f23 (f3 (f11 f12 ?v1) (f5 f6 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f19 f20 ?v0) ?v1) (ite (= (f23 ?v0 0 ?v1) f1) 0 (ite (= (f21 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f23 (f3 (f11 f12 ?v2) (f5 f6 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f11 f12 ?v0) ?v2))) (=> (= (f17 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v1 ?v3)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f11 f12 ?v0) ?v2))) (=> (= (f17 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v3 ?v1)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f17 ?v0) f1) (=> (= (f22 ?v0 (f3 (f11 f12 ?v1) ?v2)) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f17 ?v0) f1) (=> (= (f22 ?v0 (f3 (f11 f12 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f22 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f23 ?v0 0 ?v1) f1)) (=> (= (f23 (f3 (f11 f12 ?v2) (f5 f6 2)) ?v0 ?v1) f1) (not (= (f22 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f17 ?v1) f1) (=> (= (f22 ?v1 (* ?v0 ?v2)) f1) (or (= (f22 ?v1 ?v0) f1) (= (f22 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 ?v1 ?v2) f1) (= (f23 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 ?v1 (- ?v2)) f1) (= (f23 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f23 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f23 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f23 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f23 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f23 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f23 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f23 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f23 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f23 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f23 ?v1 (- 1) ?v0) f1) (not (= (f23 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (= (= (f23 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f23 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (= (= (f23 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f23 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (= (f23 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (= (f23 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (= (f23 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f23 ?v3 ?v4 ?v2) f1) (= (f23 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (= (f23 ?v1 ?v3 ?v2) f1) (= (f23 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (= (f23 ?v3 ?v4 ?v2) f1) (= (f23 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (= (f23 ?v3 ?v4 ?v2) f1) (= (f23 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (= (f23 ?v3 ?v4 ?v2) f1) (= (f23 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f11 f12 ?v0) (f5 f6 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f5 f6 2))) (let ((?v_0 (f3 (f11 f12 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f11 f12 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f5 f6 3))) (let ((?v_0 (f3 (f11 f12 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f11 f12 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (* ?v0 (f3 ?v_0 (f5 f6 2))) (f3 ?v_0 (f5 f6 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 3))) (= (f3 (f11 f12 (- ?v0)) ?v_0) (- (f3 (f11 f12 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 f6 2))) (= (f3 (f11 f12 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f11 f12 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f11 f12 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 f6 2))) (= (f3 (f11 f12 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f11 f12 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f11 f12 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f5 f6 2)) (?v_0 (f5 f6 3)) (?v_1 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v1))) (= (f3 (f11 f12 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f5 f6 2)) (?v_0 (f5 f6 3)) (?v_3 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (f3 (f11 f12 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 f6 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f11 f12 ?v0) ?v_0) (f3 (f11 f12 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 2)) (?v_1 (f11 f12 ?v0))) (= (f3 (f11 f12 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f5 f6 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 f6 2))) (= (= (f3 (f11 f12 ?v0) ?v_0) (f3 (f11 f12 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f5 f6 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (* ?v1 (f3 ?v_0 (f5 f6 (- (f3 f4 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f11 f12 ?v0) (f5 f6 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f17 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 ?v0 0 ?v1) f1) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 ?v0 0 ?v1) f1) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 ?v1 ?v2) f1) (= (f22 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (= (f23 (f3 (f11 f12 ?v0) ?v3) (f3 (f11 f12 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f22 ?v1 ?v2) f1) (= (f22 ?v1 (f3 (f11 f12 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (not (= (f23 ?v1 0 ?v0) f1)) (=> (not (= (f23 ?v2 0 ?v0) f1)) (not (= (f23 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f23 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f23 ?v1 0 ?v0) f1)) (not (= (f23 ?v2 0 ?v0) f1))) (not (= (f23 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (= (f23 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f23 ?v1 0 ?v0) f1) (= (f23 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (= (f23 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f23 ?v1 1 ?v0) f1) (= (f23 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f17 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f22 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (= (f22 ?v0 (* ?v1 ?v2)) f1) (or (= (f22 ?v0 ?v1) f1) (= (f22 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f17 ?v1) f1) (= (f22 ?v1 ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f5 f6 0))) (= (= (f22 (f3 (f11 f12 ?v1) ?v0) (f3 (f11 f12 ?v2) ?v0)) f1) (= (f22 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f22 (f3 (f11 f12 ?v0) ?v1) (f3 (f11 f12 ?v2) ?v1)) f1) (=> (not (= ?v1 (f5 f6 0))) (= (f22 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 f12 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f23 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f22 ?v0 ?v1) f1) (= (f22 (f3 (f11 f12 ?v0) ?v2) (f3 (f11 f12 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f11 f12 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f22 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f22 ?v0 ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f22 (f3 (f11 f12 ?v0) ?v2) (f3 (f11 f12 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f22 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f22 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (f3 (f11 f12 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f18 f25 (f3 (f11 f12 ?v0) ?v1)) (f3 (f11 f12 (f18 f25 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f23 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f11 f12 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f23 ?v1 ?v2 ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f23 ?v1 ?v3 ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (= (f23 (f18 (f19 f20 ?v1) ?v0) (f3 (f11 f12 ?v1) (f5 f6 (f18 (f19 f26 (- ?v0 1)) 2))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f23 ?v1 0 ?v0) f1)) (=> (not (= (f21 ?v0 ?v1) f1)) (= (f23 (f3 (f11 f12 ?v1) (f5 f6 (f18 (f19 f26 (- ?v0 1)) 2))) (- 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f23 ?v1 0 ?v0) f1)) (=> (= (f21 ?v0 ?v1) f1) (= (f23 (f3 (f11 f12 ?v1) (f5 f6 (f18 (f19 f26 (- ?v0 1)) 2))) 1 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f23 ?v1 0 ?v0) f1)) (=> (not (= (f23 ?v2 0 ?v0) f1)) (=> (not (= (f21 ?v0 ?v1) f1)) (not (= (f23 ?v2 (* ?v1 (f18 (f19 f27 ?v0) ?v2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f18 (f19 f26 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f18 (f19 f26 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f18 (f19 f26 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f19 f27 ?v0))) (=> (< 2 ?v0) (=> (= (f23 ?v1 ?v2 ?v0) f1) (= (f23 (f18 ?v_0 ?v1) (f18 ?v_0 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f19 f27 ?v0))) (=> (< 2 ?v0) (=> (= (f23 ?v1 ?v2 ?v0) f1) (= (f23 (* ?v3 (f18 ?v_0 ?v1)) (* ?v3 (f18 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f18 (f19 f27 ?v2) ?v3)))) (=> (= (f23 ?v0 ?v_0 ?v2) f1) (= (f23 (* ?v0 ?v3) (* ?v_0 ?v3) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f18 (f19 f27 ?v3) ?v0))) (=> (= (f23 (* ?v0 ?v1) ?v2 ?v3) f1) (= (f23 (* (* ?v_0 ?v0) ?v1) (* ?v_0 ?v2) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f19 f27 ?v0) ?v1) (f3 (f11 f12 ?v1) (f5 f6 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f23 ?v1 0 ?v0) f1)) (not (= (f23 (f18 (f19 f27 ?v0) ?v1) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f23 ?v1 0 ?v0) f1)) (= (f23 (* ?v1 (f18 (f19 f27 ?v0) ?v1)) 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f27 ?v0))) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f23 ?v1 0 ?v0) f1)) (= (f23 (f18 ?v_0 (f18 ?v_0 ?v1)) ?v1 ?v0) f1)))))))
(assert (forall ((?v0 S3)) (= (f5 f6 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f5 f6 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f18 (f19 f26 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f18 (f19 f28 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
