(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 () Int)
(declare-fun f5 () Int)
(declare-fun f6 (S2 S3) Int)
(declare-fun f7 () S2)
(declare-fun f8 (S4 Int) S3)
(declare-fun f9 () S4)
(declare-fun f10 () S3)
(declare-fun f11 (Int) S1)
(declare-fun f12 (S5 Int) Int)
(declare-fun f13 (S6 Int) S5)
(declare-fun f14 () S6)
(declare-fun f15 (Int Int) S1)
(declare-fun f16 (S7 Int) S2)
(declare-fun f17 () S7)
(declare-fun f18 () Int)
(declare-fun f19 (S8 S9) Int)
(declare-fun f20 () S8)
(declare-fun f21 (Int Int) S9)
(declare-fun f22 (Int Int Int) S1)
(declare-fun f23 () Int)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (* (+ (* 4 f4) 1) f5)) f1))))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 (f6 f7 (f8 f9 (- (f6 f7 (f8 f9 f5)) 1)))))) f1)))
(assert (= (+ 1 (f6 f7 (f8 f9 (- (f6 f7 (f8 f9 f5)) 1)))) f5))
(assert (< 0 (f6 f7 f10)))
(assert (= (+ 1 (f6 f7 (f8 f9 (- (f6 f7 (f8 f9 f5)) 1)))) f5))
(assert (< 1 f5))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 0))) f1)))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 (f6 f7 (f8 f9 (- (f6 f7 (f8 f9 f5)) 1)))))) f1)))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (<= 1 f5))
(assert (= f10 (f8 f9 (- (f6 f7 (f8 f9 f5)) 1))))
(assert (< f5 (+ (* 4 f4) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f8 f9 (- (f6 f7 (f8 f9 f5)) 1))) (=> (< 0 (f6 f7 ?v0)) false))) false))
(assert (= (f3 (* (+ (* 4 f4) 1) f5)) f1))
(assert (= (f11 (+ (* 4 f4) 1)) f1))
(assert (= (f12 (f13 f14 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (* ?v0 ?v1)) f1)))))
(assert (= (f15 (+ (* 4 f4) 1) (- 1)) f1))
(assert (and (< (+ 1 (f6 f7 f10)) (+ (* 4 f4) 1)) (= f10 (f8 f9 (- (f6 f7 (f8 f9 f5)) 1)))))
(assert (let ((?v_0 (+ (* 4 f4) 1)) (?v_1 (+ 1 (f6 f7 f10)))) (=> (< ?v_1 ?v_0) (not (= (f3 (* ?v_0 ?v_1)) f1)))))
(assert (= (+ (f6 (f16 f17 f18) (f8 f9 2)) 1) (* (+ (* 4 f4) 1) f5)))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f15 ?v_0 (- 1)) f1)) (not (= (f12 (f13 f14 (- 1)) ?v_0) 1)))))
(assert (=> (= f5 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (= (+ (f6 (f16 f17 ?v0) ?v_0) (f6 (f16 f17 ?v1) ?v_0)) (+ (* 4 f4) 1))))))
(assert (= (f19 f20 (f21 f18 1)) (* (+ (* 4 f4) 1) f5)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f22 f23 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f22 f23 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f22 f23 ?v0 ?v_0) f1))) false))) false))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f18) (and (< f18 ?v_0) (= (f22 f23 f18 ?v_0) f1)))))
(assert (= (f22 (f6 (f16 f17 f23) (f8 f9 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f16 f17 f18) (f8 f9 2)) 1) (* (+ (* 4 f4) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f6 (f16 f17 f18) (f8 f9 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f22 (f6 (f16 f17 f18) (f8 f9 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f22 (f6 (f16 f17 ?v0) (f8 f9 2)) (- 1) (+ (* 4 f4) 1)) f1) false)) false))
(assert (let ((?v_0 (f8 f9 2))) (= (f22 (f6 (f16 f17 f18) ?v_0) (f6 (f16 f17 f23) ?v_0) (+ (* 4 f4) 1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f19 f20 (f21 ?v0 ?v1)) (f19 f20 (f21 ?v2 ?v3))) (f19 f20 (f21 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f11 ?v_0) f1) (= (f12 (f13 f14 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 S3)) (= (f8 f9 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 f9 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f7 (f8 f9 ?v0)) 0))))
(check-sat)
(exit)
