(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    Spec# benchmarks.  Contributed by Leonardo de Moura and Michal Moskal.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun System_String () Int)
(declare-fun inv () Int)
(declare-fun BaseClass (Int) Int)
(declare-fun localinv () Int)
(declare-fun IsHeap (Int) Int)
(declare-fun System_IEquatable_1___System_String () Int)
(declare-fun AsInterface (Int) Int)
(declare-fun IsMemberlessType (Int) Int)
(declare-fun System_Object () Int)
(declare-fun System_Collections_IEnumerable () Int)
(declare-fun System_Collections_Generic_IEnumerable_1___System_Char () Int)
(declare-fun System_IComparable_1___System_String () Int)
(declare-fun System_IConvertible () Int)
(declare-fun System_ICloneable () Int)
(declare-fun System_IComparable () Int)
(declare-fun AsImmutable (Int) Int)
(declare-fun IsImmutable (Int) Int)
(declare-fun AsDirectSubClass (Int Int) Int)
(declare-fun System_Array () Int)
(declare-fun System_Collections_ICollection () Int)
(declare-fun System_Collections_IList () Int)
(declare-fun AsMutable (Int) Int)
(declare-fun C () Int)
(declare-fun System_String_Equals_System_String_System_String (Int Int Int) Int)
(declare-fun System_String_IsInterned_System_String_notnull (Int Int) Int)
(declare-fun nullObject () Int)
(declare-fun StringEquals (Int Int) Int)
(declare-fun System_String_Equals_System_String (Int Int Int) Int)
(declare-fun max (Int Int) Int)
(declare-fun min (Int Int) Int)
(declare-fun shr (Int Int) Int)
(declare-fun x_1 (Int Int) Int)
(declare-fun shl (Int Int) Int)
(declare-fun int_2147483647 () Int)
(declare-fun or_1 (Int Int) Int)
(declare-fun and_1 (Int Int) Int)
(declare-fun x_2 (Int Int) Int)
(declare-fun IfThenElse (Int Int Int) Int)
(declare-fun IntToInt (Int Int Int) Int)
(declare-fun InRange (Int Int) Int)
(declare-fun System_Char () Int)
(declare-fun int_18446744073709551615 () Int)
(declare-fun System_UInt64 () Int)
(declare-fun int_9223372036854775807 () Int)
(declare-fun int_m9223372036854775808 () Int)
(declare-fun System_Int64 () Int)
(declare-fun int_4294967295 () Int)
(declare-fun System_UInt32 () Int)
(declare-fun int_m2147483648 () Int)
(declare-fun System_Int32 () Int)
(declare-fun System_UInt16 () Int)
(declare-fun System_Int16 () Int)
(declare-fun System_Byte () Int)
(declare-fun System_SByte () Int)
(declare-fun IsValueType (Int) Int)
(declare-fun System_IntPtr () Int)
(declare-fun System_UIntPtr () Int)
(declare-fun BoxTester (Int Int) Int)
(declare-fun Box (Int Int) Int)
(declare-fun Unbox (Int) Int)
(declare-fun UnboxedType (Int) Int)
(declare-fun typeof (Int) Int)
(declare-fun BoxFunc (Int Int Int Int) Int)
(declare-fun FirstConsistentOwner () Int)
(declare-fun ownerFrame () Int)
(declare-fun ownerRef () Int)
(declare-fun PeerGroupPlaceholder () Int)
(declare-fun allocated () Int)
(declare-fun AsPureObject (Int) Int)
(declare-fun FieldDependsOnFCO (Int Int Int) Int)
(declare-fun exposeVersion () Int)
(declare-fun AsElementsPeerField (Int Int) Int)
(declare-fun ElementProxy (Int Int) Int)
(declare-fun AsElementsRepField (Int Int Int) Int)
(declare-fun AsPeerField (Int) Int)
(declare-fun AsRepField (Int Int) Int)
(declare-fun StringLength (Int) Int)
(declare-fun AsOwner (Int Int) Int)
(declare-fun BeingConstructed () Int)
(declare-fun AsRangeField (Int Int) Int)
(declare-fun AsNonNullRefField (Int Int) Int)
(declare-fun NonNullFieldsAreInitialized () Int)
(declare-fun AsRefField (Int Int) Int)
(declare-fun Is (Int Int) Int)
(declare-fun DeclType (Int) Int)
(declare-fun ClassRepr (Int) Int)
(declare-fun IsAllocated (Int Int) Int)
(declare-fun ValueArrayGet (Int Int) Int)
(declare-fun RefArrayGet (Int Int) Int)
(declare-fun StructGet (Int Int) Int)
(declare-fun As (Int Int) Int)
(declare-fun IsNotNull (Int Int) Int)
(declare-fun TypeObject (Int) Int)
(declare-fun TypeName (Int) Int)
(declare-fun System_Type () Int)
(declare-fun System_Boolean () Int)
(declare-fun OneClassDown (Int Int) Int)
(declare-fun StructSet (Int Int Int) Int)
(declare-fun ElementProxyStruct (Int Int) Int)
(declare-fun elements () Int)
(declare-fun IntArray (Int Int) Int)
(declare-fun ValueArray (Int Int) Int)
(declare-fun NonNullRefArray (Int Int) Int)
(declare-fun ElementType (Int) Int)
(declare-fun RefArray (Int Int) Int)
(declare-fun NonNullRefArrayRaw (Int Int Int) Int)
(declare-fun Rank (Int) Int)
(declare-fun ArrayCategoryNonNullRef () Int)
(declare-fun ArrayCategory (Int) Int)
(declare-fun ArrayCategoryRef () Int)
(declare-fun ArrayCategoryInt () Int)
(declare-fun ArrayCategoryValue () Int)
(declare-fun UBound (Int Int) Int)
(declare-fun DimLength (Int Int) Int)
(declare-fun LBound (Int Int) Int)
(declare-fun Length (Int) Int)
(declare-fun IntArrayGet (Int Int) Int)
(declare-fun ArrayIndex (Int Int Int Int) Int)
(declare-fun ArrayIndexInvY (Int) Int)
(declare-fun ArrayIndexInvX (Int) Int)
(declare-fun RefArraySet (Int Int Int) Int)
(declare-fun IntArraySet (Int Int Int) Int)
(declare-fun ValueArraySet (Int Int Int) Int)
(declare-fun IncludedInModifiesStar (Int) Int)
(declare-fun IsStaticField (Int) Int)
(declare-fun IncludeInMainFrameCondition (Int) Int)
(declare-fun ClassReprInv (Int) Int)
(declare-fun SharingMode_LockProtected () Int)
(declare-fun SharingMode_Unshared () Int)
(declare-fun sharingMode () Int)
(declare-fun Heap () Int)
(declare-fun HeapSucc (Int Int) Int)
(declare-fun key_in () Int)
(declare-fun a_in () Int)
(declare-fun high_1 () Int)
(declare-fun low_1 () Int)
(declare-fun stack0i_8 () Int)
(declare-fun stack0i_12 () Int)
(declare-fun stack0i_11 () Int)
(declare-fun high_0 () Int)
(declare-fun midVal_1 () Int)
(declare-fun low_0 () Int)
(declare-fun stack0i_10 () Int)
(declare-fun result_0 () Int)
(declare-fun return_value_0 () Int)
(declare-fun SS_Display_Return_Local_0 () Int)
(declare-fun return_value_1 () Int)
(declare-fun stack1i_1 () Int)
(declare-fun stack1i_2 () Int)
(declare-fun midVal_2 () Int)
(declare-fun midVal_3 () Int)
(declare-fun stack0i_13 () Int)
(declare-fun mid_1 () Int)
(declare-fun mid_2 () Int)
(declare-fun high_2 () Int)
(declare-fun stack0o_1 () Int)
(declare-fun stack0o_2 () Int)
(declare-fun low_2 () Int)
(declare-fun stack0i_9 () Int)
(declare-fun stack0i_7 () Int)
(declare-fun stack0i_6 () Int)
(declare-fun stack0o_0 () Int)
(declare-fun stack1i_0 () Int)
(declare-fun mid_0 () Int)
(declare-fun stack0i_5 () Int)
(declare-fun midVal_0 () Int)
(declare-fun stack0i_4 () Int)
(declare-fun stack0i_2 () Int)
(declare-fun stack0i_1 () Int)
(declare-fun stack0i_0 () Int)
(declare-fun PurityAxiomsCanBeAssumed () Int)
(declare-fun midVal () Int)
(declare-fun mid () Int)
(declare-fun SS_Display_Return_Local () Int)
(declare-fun return_value () Int)
(declare-fun high () Int)
(declare-fun low () Int)
(declare-fun key () Int)
(declare-fun a () Int)
(declare-fun result () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolIff ?x_3 ?y) true_1) (= (= ?x_3 true_1) (= ?y true_1))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolImplies ?x_3 ?y) true_1) (=> (= ?x_3 true_1) (= ?y true_1))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolAnd ?x_3 ?y) true_1) (not (or (not (= ?x_3 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolOr ?x_3 ?y) true_1) (or (= ?x_3 true_1) (= ?y true_1))))) (not (forall ((?x_3 Int)) (! (= (= (boolNot ?x_3) true_1) (not (= ?x_3 true_1))) :pattern ((boolNot ?x_3)) ))) (not (forall ((?x_3 Int) (?y Int)) (= (= (anyEqual ?x_3 ?y) true_1) (= ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (! (= (= (anyNeq ?x_3 ?y) true_1) (not (= ?x_3 ?y))) :pattern ((anyNeq ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intLess ?x_3 ?y) true_1) (< ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intAtMost ?x_3 ?y) true_1) (<= ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intAtLeast ?x_3 ?y) true_1) (>= ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intGreater ?x_3 ?y) true_1) (> ?x_3 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (let ((?v_2 (BaseClass System_String)) (?v_1 (BaseClass System_Array)) (?v_0 (BaseClass C))) (not (or (not (distinct allocated elements inv localinv exposeVersion sharingMode SharingMode_Unshared SharingMode_LockProtected ownerRef ownerFrame PeerGroupPlaceholder ArrayCategoryValue ArrayCategoryInt ArrayCategoryRef ArrayCategoryNonNullRef System_Array System_Boolean System_Object System_Type NonNullFieldsAreInitialized System_String FirstConsistentOwner System_SByte System_Byte System_Int16 System_UInt16 System_Int32 System_UInt32 System_Int64 System_UInt64 System_Char System_UIntPtr System_IntPtr System_IComparable_1___System_String System_Collections_Generic_IEnumerable_1___System_Char System_IEquatable_1___System_String System_Collections_IList System_Collections_ICollection System_ICloneable System_IConvertible System_Collections_IEnumerable System_IComparable C)) (not (= (DeclType elements) System_Object)) (not (= (DeclType exposeVersion) System_Object)) (not (forall ((?c Int)) (! (= (ClassReprInv (ClassRepr ?c)) ?c) :pattern ((ClassRepr ?c)) ))) (not (forall ((?T Int)) (not (= (x (typeof (ClassRepr ?T)) System_Object) true_1)))) (not (forall ((?T Int)) (not (= (ClassRepr ?T) nullObject)))) (not (forall ((?T Int) (?h_1 Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (select2 ?h_1 (ClassRepr ?T) ownerFrame) PeerGroupPlaceholder)) :pattern ((select2 ?h_1 (ClassRepr ?T) ownerFrame)) ))) (not (= (IncludeInMainFrameCondition allocated) true_1)) (not (= (IncludeInMainFrameCondition elements) true_1)) (not (not (= (IncludeInMainFrameCondition inv) true_1))) (not (not (= (IncludeInMainFrameCondition localinv) true_1))) (not (= (IncludeInMainFrameCondition ownerRef) true_1)) (not (= (IncludeInMainFrameCondition ownerFrame) true_1)) (not (= (IncludeInMainFrameCondition exposeVersion) true_1)) (not (not (= (IncludeInMainFrameCondition FirstConsistentOwner) true_1))) (not (not (= (IsStaticField allocated) true_1))) (not (not (= (IsStaticField elements) true_1))) (not (not (= (IsStaticField inv) true_1))) (not (not (= (IsStaticField localinv) true_1))) (not (not (= (IsStaticField exposeVersion) true_1))) (not (not (= (IncludedInModifiesStar ownerRef) true_1))) (not (not (= (IncludedInModifiesStar ownerFrame) true_1))) (not (= (IncludedInModifiesStar exposeVersion) true_1)) (not (= (IncludedInModifiesStar elements) true_1)) (not (forall ((?A Int) (?i Int) (?x_3 Int)) (= (ValueArrayGet (ValueArraySet ?A ?i ?x_3) ?i) ?x_3))) (not (forall ((?A Int) (?i Int) (?j Int) (?x_3 Int)) (=> (not (= ?i ?j)) (= (ValueArrayGet (ValueArraySet ?A ?i ?x_3) ?j) (ValueArrayGet ?A ?j))))) (not (forall ((?A Int) (?i Int) (?x_3 Int)) (= (IntArrayGet (IntArraySet ?A ?i ?x_3) ?i) ?x_3))) (not (forall ((?A Int) (?i Int) (?j Int) (?x_3 Int)) (=> (not (= ?i ?j)) (= (IntArrayGet (IntArraySet ?A ?i ?x_3) ?j) (IntArrayGet ?A ?j))))) (not (forall ((?A Int) (?i Int) (?x_3 Int)) (= (RefArrayGet (RefArraySet ?A ?i ?x_3) ?i) ?x_3))) (not (forall ((?A Int) (?i Int) (?j Int) (?x_3 Int)) (=> (not (= ?i ?j)) (= (RefArrayGet (RefArraySet ?A ?i ?x_3) ?j) (RefArrayGet ?A ?j))))) (not (forall ((?a Int) (?d Int) (?x_3 Int) (?y Int)) (! (= (ArrayIndexInvX (ArrayIndex ?a ?d ?x_3 ?y)) ?x_3) :pattern ((ArrayIndex ?a ?d ?x_3 ?y)) ))) (not (forall ((?a Int) (?d Int) (?x_3 Int) (?y Int)) (! (= (ArrayIndexInvY (ArrayIndex ?a ?d ?x_3 ?y)) ?y) :pattern ((ArrayIndex ?a ?d ?x_3 ?y)) ))) (not (forall ((?a Int) (?i Int) (?heap Int)) (! (=> (= (IsHeap ?heap) true_1) (= (InRange (IntArrayGet (select2 ?heap ?a elements) ?i) (ElementType (typeof ?a))) true_1)) :pattern ((IntArrayGet (select2 ?heap ?a elements) ?i)) ))) (not (forall ((?a Int) (?i Int) (?heap Int)) (! (let ((?v_3 (RefArrayGet (select2 ?heap ?a elements) ?i))) (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (not (= ?v_3 nullObject))))) (= (x (typeof ?v_3) (ElementType (typeof ?a))) true_1))) :pattern ((typeof (RefArrayGet (select2 ?heap ?a elements) ?i))) ))) (not (forall ((?a Int) (?T Int) (?i Int) (?r Int) (?heap Int)) (! (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (= (x (typeof ?a) (NonNullRefArray ?T ?r)) true_1)))) (not (= (RefArrayGet (select2 ?heap ?a elements) ?i) nullObject))) :pattern ((x (typeof ?a) (NonNullRefArray ?T ?r)) (RefArrayGet (select2 ?heap ?a elements) ?i)) ))) (not (forall ((?a Int)) (<= 1 (Rank ?a)))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (RefArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (RefArray ?T ?r))) ))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (NonNullRefArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (NonNullRefArray ?T ?r))) ))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (ValueArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (ValueArray ?T ?r))) ))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (IntArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (IntArray ?T ?r))) ))) (not (forall ((?a Int)) (! (let ((?v_4 (Length ?a))) (not (or (not (<= 0 ?v_4)) (not (<= ?v_4 int_2147483647))))) :pattern ((Length ?a)) ))) (not (forall ((?a Int) (?i Int)) (<= 0 (DimLength ?a ?i)))) (not (forall ((?a Int)) (! (=> (= (Rank ?a) 1) (= (DimLength ?a 0) (Length ?a))) :pattern ((DimLength ?a 0)) ))) (not (forall ((?a Int) (?i Int)) (! (= (LBound ?a ?i) 0) :pattern ((LBound ?a ?i)) ))) (not (forall ((?a Int) (?i Int)) (! (= (UBound ?a ?i) (- (DimLength ?a ?i) 1)) :pattern ((UBound ?a ?i)) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (ValueArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryValue)) :pattern ((x ?T (ValueArray ?ET ?r))) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (IntArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryInt)) :pattern ((x ?T (IntArray ?ET ?r))) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (RefArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryRef)) :pattern ((x ?T (RefArray ?ET ?r))) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (NonNullRefArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryNonNullRef)) :pattern ((x ?T (NonNullRefArray ?ET ?r))) ))) (not (= (x System_Array System_Object) true_1)) (not (forall ((?T Int) (?r Int)) (! (let ((?v_5 (ValueArray ?T ?r))) (not (or (not (= (x ?v_5 ?v_5) true_1)) (not (= (x ?v_5 System_Array) true_1))))) :pattern ((ValueArray ?T ?r)) ))) (not (forall ((?T Int) (?r Int)) (! (let ((?v_6 (IntArray ?T ?r))) (not (or (not (= (x ?v_6 ?v_6) true_1)) (not (= (x ?v_6 System_Array) true_1))))) :pattern ((IntArray ?T ?r)) ))) (not (forall ((?T Int) (?r Int)) (! (let ((?v_7 (RefArray ?T ?r))) (not (or (not (= (x ?v_7 ?v_7) true_1)) (not (= (x ?v_7 System_Array) true_1))))) :pattern ((RefArray ?T ?r)) ))) (not (forall ((?T Int) (?r Int)) (! (let ((?v_8 (NonNullRefArray ?T ?r))) (not (or (not (= (x ?v_8 ?v_8) true_1)) (not (= (x ?v_8 System_Array) true_1))))) :pattern ((NonNullRefArray ?T ?r)) ))) (not (forall ((?array Int) (?elementType Int) (?rank Int)) (! (let ((?v_9 (typeof ?array))) (=> (= (NonNullRefArrayRaw ?array ?elementType ?rank) true_1) (not (or (not (= (x ?v_9 System_Array) true_1)) (not (= (Rank ?array) ?rank)) (not (= (x ?elementType (ElementType ?v_9)) true_1)))))) :pattern ((NonNullRefArrayRaw ?array ?elementType ?rank)) ))) (not (forall ((?T Int) (?U_1 Int) (?r Int)) (=> (= (x ?U_1 ?T) true_1) (= (x (RefArray ?U_1 ?r) (RefArray ?T ?r)) true_1)))) (not (forall ((?T Int) (?U_1 Int) (?r Int)) (=> (= (x ?U_1 ?T) true_1) (= (x (NonNullRefArray ?U_1 ?r) (NonNullRefArray ?T ?r)) true_1)))) (not (forall ((?A Int) (?r Int)) (= (ElementType (ValueArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int)) (= (ElementType (IntArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int)) (= (ElementType (RefArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int)) (= (ElementType (NonNullRefArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_10 (ElementType ?T))) (=> (= (x ?T (RefArray ?A ?r)) true_1) (not (or (not (not (= ?T ?A))) (not (= ?T (RefArray ?v_10 ?r))) (not (= (x ?v_10 ?A) true_1)))))) :pattern ((x ?T (RefArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_11 (ElementType ?T))) (=> (= (x ?T (NonNullRefArray ?A ?r)) true_1) (not (or (not (not (= ?T ?A))) (not (= ?T (NonNullRefArray ?v_11 ?r))) (not (= (x ?v_11 ?A) true_1)))))) :pattern ((x ?T (NonNullRefArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_12 (ValueArray ?A ?r))) (=> (= (x ?T ?v_12) true_1) (= ?T ?v_12))) :pattern ((x ?T (ValueArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_13 (IntArray ?A ?r))) (=> (= (x ?T ?v_13) true_1) (= ?T ?v_13))) :pattern ((x ?T (IntArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_14 (ElementType ?T))) (=> (= (x (RefArray ?A ?r) ?T) true_1) (or (= (x System_Array ?T) true_1) (not (or (not (= ?T (RefArray ?v_14 ?r))) (not (= (x ?A ?v_14) true_1))))))) :pattern ((x (RefArray ?A ?r) ?T)) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_15 (ElementType ?T))) (=> (= (x (NonNullRefArray ?A ?r) ?T) true_1) (or (= (x System_Array ?T) true_1) (not (or (not (= ?T (NonNullRefArray ?v_15 ?r))) (not (= (x ?A ?v_15) true_1))))))) :pattern ((x (NonNullRefArray ?A ?r) ?T)) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_16 (ValueArray ?A ?r))) (=> (= (x ?v_16 ?T) true_1) (or (= (x System_Array ?T) true_1) (= ?T ?v_16)))) :pattern ((x (ValueArray ?A ?r) ?T)) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_17 (IntArray ?A ?r))) (=> (= (x ?v_17 ?T) true_1) (or (= (x System_Array ?T) true_1) (= ?T ?v_17)))) :pattern ((x (IntArray ?A ?r) ?T)) ))) (not (forall ((?a Int) (?i Int) (?heap Int)) (! (let ((?v_19 (ElementProxy ?a (- 0 1))) (?v_18 (RefArrayGet (select2 ?heap ?a elements) ?i))) (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (= (x (typeof ?a) System_Array) true_1)))) (or (= ?v_18 nullObject) (= (IsImmutable (typeof ?v_18)) true_1) (not (or (not (= (select2 ?heap ?v_18 ownerRef) (select2 ?heap ?v_19 ownerRef))) (not (= (select2 ?heap ?v_18 ownerFrame) (select2 ?heap ?v_19 ownerFrame)))))))) :pattern ((select2 ?heap (RefArrayGet (select2 ?heap ?a elements) ?i) ownerRef))  :pattern ((select2 ?heap (RefArrayGet (select2 ?heap ?a elements) ?i) ownerFrame)) ))) (not (forall ((?a Int) (?heap Int)) (! (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (= (IsAllocated ?heap ?a) true_1)) (not (= (x (typeof ?a) System_Array) true_1)))) (= (IsAllocated ?heap (ElementProxy ?a (- 0 1))) true_1)) :pattern ((IsAllocated ?heap ?a)) ))) (not (forall ((?o Int) (?pos Int)) (! (= (typeof (ElementProxy ?o ?pos)) System_Object) :pattern ((typeof (ElementProxy ?o ?pos))) ))) (not (forall ((?o Int) (?pos Int)) (! (= (typeof (ElementProxyStruct ?o ?pos)) System_Object) :pattern ((typeof (ElementProxyStruct ?o ?pos))) ))) (not (forall ((?s Int) (?f Int) (?x_3 Int)) (= (StructGet (StructSet ?s ?f ?x_3) ?f) ?x_3))) (not (forall ((?s Int) (?f Int) (|?f'| Int) (?x_3 Int)) (=> (not (= ?f |?f'|)) (= (StructGet (StructSet ?s ?f ?x_3) |?f'|) (StructGet ?s |?f'|))))) (not (forall ((?T Int)) (! (let ((?v_20 (BaseClass ?T))) (not (or (not (= (x ?T ?v_20) true_1)) (not (=> (not (= ?T System_Object)) (not (= ?T ?v_20))))))) :pattern ((BaseClass ?T)) ))) (not (forall ((?A Int) (?B Int) (?C Int)) (! (=> (= (x ?C (AsDirectSubClass ?B ?A)) true_1) (= (OneClassDown ?C ?A) ?B)) :pattern ((x ?C (AsDirectSubClass ?B ?A))) ))) (not (forall ((?T Int)) (=> (= (IsValueType ?T) true_1) (not (or (not (forall ((?U_1 Int)) (=> (= (x ?T ?U_1) true_1) (= ?T ?U_1)))) (not (forall ((?U_1 Int)) (=> (= (x ?U_1 ?T) true_1) (= ?T ?U_1))))))))) (not (= (IsValueType System_Boolean) true_1)) (not (= (x System_Type System_Object) true_1)) (not (forall ((?T Int)) (! (= (IsNotNull (TypeObject ?T) System_Type) true_1) :pattern ((TypeObject ?T)) ))) (not (forall ((?T Int)) (! (= (TypeName (TypeObject ?T)) ?T) :pattern ((TypeObject ?T)) ))) (not (forall ((?o Int) (?T Int)) (! (= (= (Is ?o ?T) true_1) (or (= ?o nullObject) (= (x (typeof ?o) ?T) true_1))) :pattern ((Is ?o ?T)) ))) (not (forall ((?o Int) (?T Int)) (! (= (= (IsNotNull ?o ?T) true_1) (not (or (not (not (= ?o nullObject))) (not (= (Is ?o ?T) true_1))))) :pattern ((IsNotNull ?o ?T)) ))) (not (forall ((?o Int) (?T Int)) (=> (= (Is ?o ?T) true_1) (= (As ?o ?T) ?o)))) (not (forall ((?o Int) (?T Int)) (=> (not (= (Is ?o ?T) true_1)) (= (As ?o ?T) nullObject)))) (not (forall ((?h_1 Int) (?o Int)) (! (let ((?v_21 (typeof ?o))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (= (x ?v_21 System_Array) true_1)))) (not (or (not (= (select2 ?h_1 ?o inv) ?v_21)) (not (= (select2 ?h_1 ?o localinv) ?v_21)))))) :pattern ((x (typeof ?o) System_Array) (select2 ?h_1 ?o inv)) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int)) (! (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (= (select2 ?h_1 ?o allocated) true_1)))) (= (IsAllocated ?h_1 (select2 ?h_1 ?o ?f)) true_1)) :pattern ((IsAllocated ?h_1 (select2 ?h_1 ?o ?f))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int)) (! (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (= (select2 ?h_1 ?o allocated) true_1)))) (= (select2 ?h_1 (select2 ?h_1 ?o ?f) allocated) true_1)) :pattern ((select2 ?h_1 (select2 ?h_1 ?o ?f) allocated)) ))) (not (forall ((?h_1 Int) (?s Int) (?f Int)) (! (=> (= (IsAllocated ?h_1 ?s) true_1) (= (IsAllocated ?h_1 (StructGet ?s ?f)) true_1)) :pattern ((IsAllocated ?h_1 (StructGet ?s ?f))) ))) (not (forall ((?h_1 Int) (?e Int) (?i Int)) (! (=> (= (IsAllocated ?h_1 ?e) true_1) (= (IsAllocated ?h_1 (RefArrayGet ?e ?i)) true_1)) :pattern ((IsAllocated ?h_1 (RefArrayGet ?e ?i))) ))) (not (forall ((?h_1 Int) (?e Int) (?i Int)) (! (=> (= (IsAllocated ?h_1 ?e) true_1) (= (IsAllocated ?h_1 (ValueArrayGet ?e ?i)) true_1)) :pattern ((IsAllocated ?h_1 (ValueArrayGet ?e ?i))) ))) (not (forall ((?h_1 Int) (?o Int)) (! (=> (= (IsAllocated ?h_1 ?o) true_1) (= (select2 ?h_1 ?o allocated) true_1)) :pattern ((select2 ?h_1 ?o allocated)) ))) (not (forall ((?h_1 Int) (?c Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (select2 ?h_1 (ClassRepr ?c) allocated) true_1)) :pattern ((select2 ?h_1 (ClassRepr ?c) allocated)) ))) (not (= (DeclType NonNullFieldsAreInitialized) System_Object)) (not (forall ((?f Int) (?T Int)) (! (=> (= (AsNonNullRefField ?f ?T) ?f) (= (AsRefField ?f ?T) ?f)) :pattern ((AsNonNullRefField ?f ?T)) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (Is (select2 ?h_1 ?o (AsRefField ?f ?T)) ?T) true_1)) :pattern ((select2 ?h_1 ?o (AsRefField ?f ?T))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (or (not (= ?o BeingConstructed)) (= (= (select2 ?h_1 BeingConstructed NonNullFieldsAreInitialized) true_1) true))))) (not (= (select2 ?h_1 ?o (AsNonNullRefField ?f ?T)) nullObject))) :pattern ((select2 ?h_1 ?o (AsNonNullRefField ?f ?T))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (InRange (select2 ?h_1 ?o (AsRangeField ?f ?T)) ?T) true_1)) :pattern ((select2 ?h_1 ?o (AsRangeField ?f ?T))) ))) (not (forall ((?o Int)) (! (not (= (IsMemberlessType (typeof ?o)) true_1)) :pattern ((IsMemberlessType (typeof ?o))) ))) (not (forall ((?J Int) (?s Int) (?b Int)) (! (let ((?v_23 (AsInterface ?J)) (?v_22 (Box ?s ?b))) (=> (not (or (not (= ?v_23 ?J)) (not (= ?v_22 ?b)) (not (= (x (UnboxedType ?v_22) ?v_23) true_1)))) (= (x (typeof ?b) ?J) true_1))) :pattern ((x (UnboxedType (Box ?s ?b)) (AsInterface ?J))) ))) (not (not (= (IsImmutable System_Object) true_1))) (not (forall ((?T Int) (?U_1 Int)) (! (=> (= (x ?U_1 (AsImmutable ?T)) true_1) (not (or (not (= (IsImmutable ?U_1) true_1)) (not (= (AsImmutable ?U_1) ?U_1))))) :pattern ((x ?U_1 (AsImmutable ?T))) ))) (not (forall ((?T Int) (?U_1 Int)) (! (=> (= (x ?U_1 (AsMutable ?T)) true_1) (not (or (not (not (= (IsImmutable ?U_1) true_1))) (not (= (AsMutable ?U_1) ?U_1))))) :pattern ((x ?U_1 (AsMutable ?T))) ))) (not (forall ((?o Int) (?T Int)) (! (=> (not (or (not (not (= ?o nullObject))) (not (not (= ?o BeingConstructed))) (not (= (x (typeof ?o) (AsImmutable ?T)) true_1)))) (forall ((?h_1 Int)) (! (let ((?v_24 (typeof ?o))) (=> (= (IsHeap ?h_1) true_1) (not (or (not (= (select2 ?h_1 ?o inv) ?v_24)) (not (= (select2 ?h_1 ?o localinv) ?v_24)) (not (= (select2 ?h_1 ?o ownerFrame) PeerGroupPlaceholder)) (not (= (AsOwner ?o (select2 ?h_1 ?o ownerRef)) ?o)) (not (forall ((?t Int)) (! (=> (= (AsOwner ?o (select2 ?h_1 ?t ownerRef)) ?o) (or (= ?t ?o) (not (= (select2 ?h_1 ?t ownerFrame) PeerGroupPlaceholder)))) :pattern ((AsOwner ?o (select2 ?h_1 ?t ownerRef))) ))))))) :pattern ((IsHeap ?h_1)) ))) :pattern ((x (typeof ?o) (AsImmutable ?T))) ))) (not (forall ((?s Int)) (! (<= 0 (StringLength ?s)) :pattern ((StringLength ?s)) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (let ((?v_25 (select2 ?h_1 ?o (AsRepField ?f ?T)))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_25 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_25 ownerRef) ?o)) (not (= (select2 ?h_1 ?v_25 ownerFrame) ?T)))))) :pattern ((select2 ?h_1 ?o (AsRepField ?f ?T))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int)) (! (let ((?v_26 (select2 ?h_1 ?o (AsPeerField ?f)))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_26 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_26 ownerRef) (select2 ?h_1 ?o ownerRef))) (not (= (select2 ?h_1 ?v_26 ownerFrame) (select2 ?h_1 ?o ownerFrame))))))) :pattern ((select2 ?h_1 ?o (AsPeerField ?f))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int) (?i Int)) (! (let ((?v_27 (select2 ?h_1 ?o (AsElementsRepField ?f ?T ?i)))) (let ((?v_28 (ElementProxy ?v_27 ?i))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_27 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_28 ownerRef) ?o)) (not (= (select2 ?h_1 ?v_28 ownerFrame) ?T))))))) :pattern ((select2 ?h_1 ?o (AsElementsRepField ?f ?T ?i))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?i Int)) (! (let ((?v_29 (select2 ?h_1 ?o (AsElementsPeerField ?f ?i)))) (let ((?v_30 (ElementProxy ?v_29 ?i))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_29 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_30 ownerRef) (select2 ?h_1 ?o ownerRef))) (not (= (select2 ?h_1 ?v_30 ownerFrame) (select2 ?h_1 ?o ownerFrame)))))))) :pattern ((select2 ?h_1 ?o (AsElementsPeerField ?f ?i))) ))) (not (forall ((?h_1 Int) (?o Int)) (! (let ((?v_33 (typeof ?o)) (?v_31 (select2 ?h_1 ?o ownerFrame)) (?v_32 (select2 ?h_1 ?o ownerRef))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_31 PeerGroupPlaceholder))) (not (= (x (select2 ?h_1 ?v_32 inv) ?v_31) true_1)) (not (not (= (select2 ?h_1 ?v_32 localinv) (BaseClass ?v_31)))))) (not (or (not (= (select2 ?h_1 ?o inv) ?v_33)) (not (= (select2 ?h_1 ?o localinv) ?v_33)))))) :pattern ((x (select2 ?h_1 (select2 ?h_1 ?o ownerRef) inv) (select2 ?h_1 ?o ownerFrame))) ))) (not (forall ((?o Int) (?f Int) (?h_1 Int)) (! (let ((?v_34 (select2 ?h_1 ?o ownerFrame)) (?v_35 (select2 ?h_1 ?o ownerRef))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (= (= (select2 ?h_1 ?o allocated) true_1) true)) (not (= (AsPureObject ?o) ?o)) (not (not (= ?v_34 PeerGroupPlaceholder))) (not (= (x (select2 ?h_1 ?v_35 inv) ?v_34) true_1)) (not (not (= (select2 ?h_1 ?v_35 localinv) (BaseClass ?v_34)))))) (= (select2 ?h_1 ?o ?f) (FieldDependsOnFCO ?o ?f (select2 ?h_1 (select2 ?h_1 ?o FirstConsistentOwner) exposeVersion))))) :pattern ((select2 ?h_1 (AsPureObject ?o) ?f)) ))) (not (forall ((?o Int) (?h_1 Int)) (! (let ((?v_38 (select2 ?h_1 ?o FirstConsistentOwner))) (let ((?v_39 (select2 ?h_1 ?v_38 ownerFrame)) (?v_40 (select2 ?h_1 ?v_38 ownerRef)) (?v_36 (select2 ?h_1 ?o ownerFrame)) (?v_37 (select2 ?h_1 ?o ownerRef))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (= (= (select2 ?h_1 ?o allocated) true_1) true)) (not (not (= ?v_36 PeerGroupPlaceholder))) (not (= (x (select2 ?h_1 ?v_37 inv) ?v_36) true_1)) (not (not (= (select2 ?h_1 ?v_37 localinv) (BaseClass ?v_36)))))) (not (or (not (not (= ?v_38 nullObject))) (not (= (= (select2 ?h_1 ?v_38 allocated) true_1) true)) (not (or (= ?v_39 PeerGroupPlaceholder) (not (= (x (select2 ?h_1 ?v_40 inv) ?v_39) true_1)) (= (select2 ?h_1 ?v_40 localinv) (BaseClass ?v_39))))))))) :pattern ((select2 ?h_1 ?o FirstConsistentOwner)) ))) (not (forall ((?value Int) (?typ Int) (?occurrence Int) (?activity Int)) (! (let ((?v_41 (BoxFunc ?value ?typ ?occurrence ?activity))) (not (or (not (= (Box ?value ?v_41) ?v_41)) (not (= (UnboxedType ?v_41) ?typ))))) :pattern ((BoxFunc ?value ?typ ?occurrence ?activity)) ))) (not (forall ((?x_3 Int) (?typ Int) (?occurrence Int) (?activity Int)) (=> (not (= (IsValueType (UnboxedType ?x_3)) true_1)) (= (BoxFunc ?x_3 ?typ ?occurrence ?activity) ?x_3)))) (not (forall ((?x_3 Int) (?p Int)) (! (= (Unbox (Box ?x_3 ?p)) ?x_3) :pattern ((Unbox (Box ?x_3 ?p))) ))) (not (forall ((?p Int)) (! (=> (= (IsValueType (UnboxedType ?p)) true_1) (forall ((?heap Int) (?x_3 Int)) (! (let ((?v_42 (Box ?x_3 ?p))) (let ((?v_43 (typeof ?v_42))) (=> (= (IsHeap ?heap) true_1) (not (or (not (= (select2 ?heap ?v_42 inv) ?v_43)) (not (= (select2 ?heap ?v_42 localinv) ?v_43))))))) :pattern ((select2 ?heap (Box ?x_3 ?p) inv)) ))) :pattern ((IsValueType (UnboxedType ?p))) ))) (not (forall ((?x_3 Int) (?p Int)) (! (let ((?v_44 (Box ?x_3 ?p))) (=> (not (or (not (= (x (UnboxedType ?v_44) System_Object) true_1)) (not (= ?v_44 ?p)))) (= ?x_3 ?p))) :pattern ((x (UnboxedType (Box ?x_3 ?p)) System_Object)) ))) (not (forall ((?p Int) (?typ Int)) (! (= (= (UnboxedType ?p) ?typ) (not (= (BoxTester ?p ?typ) nullObject))) :pattern ((BoxTester ?p ?typ)) ))) (not (forall ((?p Int) (?typ Int)) (! (=> (not (= (BoxTester ?p ?typ) nullObject)) (= (Box (Unbox ?p) ?p) ?p)) :pattern ((BoxTester ?p ?typ)) ))) (not (= (IsValueType System_SByte) true_1)) (not (= (IsValueType System_Byte) true_1)) (not (= (IsValueType System_Int16) true_1)) (not (= (IsValueType System_UInt16) true_1)) (not (= (IsValueType System_Int32) true_1)) (not (= (IsValueType System_UInt32) true_1)) (not (= (IsValueType System_Int64) true_1)) (not (= (IsValueType System_UInt64) true_1)) (not (= (IsValueType System_Char) true_1)) (not (= (IsValueType System_UIntPtr) true_1)) (not (= (IsValueType System_IntPtr) true_1)) (not (< int_m9223372036854775808 int_m2147483648)) (not (< int_m2147483648 (- 0 100000))) (not (< 100000 int_2147483647)) (not (< int_2147483647 int_4294967295)) (not (< int_4294967295 int_9223372036854775807)) (not (< int_9223372036854775807 int_18446744073709551615)) (not (= (+ int_m9223372036854775808 1) (- 0 int_9223372036854775807))) (not (= (+ int_m2147483648 1) (- 0 int_2147483647))) (not (forall ((?i Int)) (= (= (InRange ?i System_SByte) true_1) (not (or (not (<= (- 0 128) ?i)) (not (< ?i 128))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Byte) true_1) (not (or (not (<= 0 ?i)) (not (< ?i 256))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Int16) true_1) (not (or (not (<= (- 0 32768) ?i)) (not (< ?i 32768))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_UInt16) true_1) (not (or (not (<= 0 ?i)) (not (< ?i 65536))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Int32) true_1) (not (or (not (<= int_m2147483648 ?i)) (not (<= ?i int_2147483647))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_UInt32) true_1) (not (or (not (<= 0 ?i)) (not (<= ?i int_4294967295))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Int64) true_1) (not (or (not (<= int_m9223372036854775808 ?i)) (not (<= ?i int_9223372036854775807))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_UInt64) true_1) (not (or (not (<= 0 ?i)) (not (<= ?i int_18446744073709551615))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Char) true_1) (not (or (not (<= 0 ?i)) (not (< ?i 65536))))))) (not (forall ((?z Int) (?B Int) (?C Int)) (=> (= (InRange ?z ?C) true_1) (= (IntToInt ?z ?B ?C) ?z)))) (not (forall ((?b Int) (?x_3 Int) (?y Int)) (! (=> (= ?b true_1) (= (IfThenElse ?b ?x_3 ?y) ?x_3)) :pattern ((IfThenElse ?b ?x_3 ?y)) ))) (not (forall ((?b Int) (?x_3 Int) (?y Int)) (! (=> (not (= ?b true_1)) (= (IfThenElse ?b ?x_3 ?y) ?y)) :pattern ((IfThenElse ?b ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (= (x_2 ?x_3 ?y) (- ?x_3 (* (x_1 ?x_3 ?y) ?y))) :pattern ((x_2 ?x_3 ?y))  :pattern ((x_1 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_45 (x_2 ?x_3 ?y))) (=> (not (or (not (<= 0 ?x_3)) (not (< 0 ?y)))) (not (or (not (<= 0 ?v_45)) (not (< ?v_45 ?y)))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_46 (x_2 ?x_3 ?y))) (=> (not (or (not (<= 0 ?x_3)) (not (< ?y 0)))) (not (or (not (<= 0 ?v_46)) (not (< ?v_46 (- 0 ?y))))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_47 (x_2 ?x_3 ?y))) (=> (not (or (not (<= ?x_3 0)) (not (< 0 ?y)))) (not (or (not (< (- 0 ?y) ?v_47)) (not (<= ?v_47 0)))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_48 (x_2 ?x_3 ?y))) (=> (not (or (not (<= ?x_3 0)) (not (< ?y 0)))) (not (or (not (< ?y ?v_48)) (not (<= ?v_48 0)))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (=> (not (or (not (<= 0 ?x_3)) (not (<= 0 ?y)))) (= (x_2 (+ ?x_3 ?y) ?y) (x_2 ?x_3 ?y))) :pattern ((x_2 (+ ?x_3 ?y) ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (=> (not (or (not (<= 0 ?x_3)) (not (<= 0 ?y)))) (= (x_2 (+ ?y ?x_3) ?y) (x_2 ?x_3 ?y))) :pattern ((x_2 (+ ?y ?x_3) ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_49 (- ?x_3 ?y))) (=> (not (or (not (<= 0 ?v_49)) (not (<= 0 ?y)))) (= (x_2 ?v_49 ?y) (x_2 ?x_3 ?y)))) :pattern ((x_2 (- ?x_3 ?y) ?y)) ))) (not (forall ((?a Int) (?b Int) (?d Int)) (! (=> (not (or (not (<= 2 ?d)) (not (= (x_2 ?a ?d) (x_2 ?b ?d))) (not (< ?a ?b)))) (<= (+ ?a ?d) ?b)) :pattern ((x_2 ?a ?d) (x_2 ?b ?d)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (=> (or (<= 0 ?x_3) (<= 0 ?y)) (<= 0 (and_1 ?x_3 ?y))) :pattern ((and_1 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_50 (or_1 ?x_3 ?y))) (=> (not (or (not (<= 0 ?x_3)) (not (<= 0 ?y)))) (not (or (not (<= 0 ?v_50)) (not (<= ?v_50 (+ ?x_3 ?y))))))) :pattern ((or_1 ?x_3 ?y)) ))) (not (forall ((?i Int)) (! (= (shl ?i 0) ?i) :pattern ((shl ?i 0)) ))) (not (forall ((?i Int) (?j Int)) (! (=> (<= 1 ?j) (= (shl ?i ?j) (* (shl ?i (- ?j 1)) 2))) :pattern ((shl ?i ?j)) ))) (not (forall ((?i Int) (?j Int)) (! (let ((?v_51 (shl ?i ?j))) (=> (not (or (not (<= 0 ?i)) (not (< ?i 32768)) (not (<= 0 ?j)) (not (<= ?j 16)))) (not (or (not (<= 0 ?v_51)) (not (<= ?v_51 int_2147483647)))))) :pattern ((shl ?i ?j)) ))) (not (forall ((?i Int)) (! (= (shr ?i 0) ?i) :pattern ((shr ?i 0)) ))) (not (forall ((?i Int) (?j Int)) (! (=> (<= 1 ?j) (= (shr ?i ?j) (x_1 (shr ?i (- ?j 1)) 2))) :pattern ((shr ?i ?j)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_52 (min ?x_3 ?y))) (not (or (not (or (= ?v_52 ?x_3) (= ?v_52 ?y))) (not (<= ?v_52 ?x_3)) (not (<= ?v_52 ?y))))) :pattern ((min ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_53 (max ?x_3 ?y))) (not (or (not (or (= ?v_53 ?x_3) (= ?v_53 ?y))) (not (<= ?x_3 ?v_53)) (not (<= ?y ?v_53))))) :pattern ((max ?x_3 ?y)) ))) (not (forall ((?h_1 Int) (?a Int) (?b Int)) (! (= (= (System_String_Equals_System_String ?h_1 ?a ?b) true_1) (= (System_String_Equals_System_String_System_String ?h_1 ?a ?b) true_1)) :pattern ((System_String_Equals_System_String ?h_1 ?a ?b)) ))) (not (forall ((?h_1 Int) (?a Int) (?b Int)) (! (let ((?v_55 (= (StringEquals ?a ?b) true_1)) (?v_54 (= (System_String_Equals_System_String_System_String ?h_1 ?a ?b) true_1))) (not (or (not (= ?v_54 ?v_55)) (not (= ?v_54 (= (StringEquals ?b ?a) true_1))) (not (=> (= ?a ?b) ?v_55))))) :pattern ((System_String_Equals_System_String_System_String ?h_1 ?a ?b)) ))) (not (forall ((?a Int) (?b Int) (?c Int)) (=> (not (or (not (= (StringEquals ?a ?b) true_1)) (not (= (StringEquals ?b ?c) true_1)))) (= (StringEquals ?a ?c) true_1)))) (not (forall ((?h_1 Int) (?a Int) (?b Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (not (= ?b nullObject))) (not (= (System_String_Equals_System_String_System_String ?h_1 ?a ?b) true_1)))) (= (System_String_IsInterned_System_String_notnull ?h_1 ?a) (System_String_IsInterned_System_String_notnull ?h_1 ?b))) :pattern ((System_String_Equals_System_String_System_String ?h_1 ?a ?b)) ))) (not (= (x C C) true_1)) (not (= ?v_0 System_Object)) (not (= (AsDirectSubClass C ?v_0) C)) (not (not (= (IsImmutable C) true_1))) (not (= (AsMutable C) C)) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) C) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_0))))) true) :pattern ((x (select2 ?h ?oi inv) C)) ))) (not (= (x System_Array System_Array) true_1)) (not (= ?v_1 System_Object)) (not (= (AsDirectSubClass System_Array ?v_1) System_Array)) (not (not (= (IsImmutable System_Array) true_1))) (not (= (AsMutable System_Array) System_Array)) (not (= (x System_ICloneable System_ICloneable) true_1)) (not (= (x System_ICloneable System_Object) true_1)) (not (= (IsMemberlessType System_ICloneable) true_1)) (not (= (AsInterface System_ICloneable) System_ICloneable)) (not (= (x System_Array System_ICloneable) true_1)) (not (= (x System_Collections_IList System_Collections_IList) true_1)) (not (= (x System_Collections_IList System_Object) true_1)) (not (= (x System_Collections_ICollection System_Collections_ICollection) true_1)) (not (= (x System_Collections_ICollection System_Object) true_1)) (not (= (x System_Collections_IEnumerable System_Collections_IEnumerable) true_1)) (not (= (x System_Collections_IEnumerable System_Object) true_1)) (not (= (IsMemberlessType System_Collections_IEnumerable) true_1)) (not (= (AsInterface System_Collections_IEnumerable) System_Collections_IEnumerable)) (not (= (x System_Collections_ICollection System_Collections_IEnumerable) true_1)) (not (= (IsMemberlessType System_Collections_ICollection) true_1)) (not (= (AsInterface System_Collections_ICollection) System_Collections_ICollection)) (not (= (x System_Collections_IList System_Collections_ICollection) true_1)) (not (= (x System_Collections_IList System_Collections_IEnumerable) true_1)) (not (= (IsMemberlessType System_Collections_IList) true_1)) (not (= (AsInterface System_Collections_IList) System_Collections_IList)) (not (= (x System_Array System_Collections_IList) true_1)) (not (= (x System_Array System_Collections_ICollection) true_1)) (not (= (x System_Array System_Collections_IEnumerable) true_1)) (not (= (IsMemberlessType System_Array) true_1)) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) System_Array) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_1))))) true) :pattern ((x (select2 ?h ?oi inv) System_Array)) ))) (not (= (x System_String System_String) true_1)) (not (= ?v_2 System_Object)) (not (= (AsDirectSubClass System_String ?v_2) System_String)) (not (= (IsImmutable System_String) true_1)) (not (= (AsImmutable System_String) System_String)) (not (= (x System_IComparable System_IComparable) true_1)) (not (= (x System_IComparable System_Object) true_1)) (not (= (IsMemberlessType System_IComparable) true_1)) (not (= (AsInterface System_IComparable) System_IComparable)) (not (= (x System_String System_IComparable) true_1)) (not (= (x System_String System_ICloneable) true_1)) (not (= (x System_IConvertible System_IConvertible) true_1)) (not (= (x System_IConvertible System_Object) true_1)) (not (= (IsMemberlessType System_IConvertible) true_1)) (not (= (AsInterface System_IConvertible) System_IConvertible)) (not (= (x System_String System_IConvertible) true_1)) (not (= (x System_IComparable_1___System_String System_IComparable_1___System_String) true_1)) (not (= (x System_IComparable_1___System_String System_Object) true_1)) (not (= (IsMemberlessType System_IComparable_1___System_String) true_1)) (not (= (AsInterface System_IComparable_1___System_String) System_IComparable_1___System_String)) (not (= (x System_String System_IComparable_1___System_String) true_1)) (not (= (x System_Collections_Generic_IEnumerable_1___System_Char System_Collections_Generic_IEnumerable_1___System_Char) true_1)) (not (= (x System_Collections_Generic_IEnumerable_1___System_Char System_Object) true_1)) (not (= (x System_Collections_Generic_IEnumerable_1___System_Char System_Collections_IEnumerable) true_1)) (not (= (IsMemberlessType System_Collections_Generic_IEnumerable_1___System_Char) true_1)) (not (= (AsInterface System_Collections_Generic_IEnumerable_1___System_Char) System_Collections_Generic_IEnumerable_1___System_Char)) (not (= (x System_String System_Collections_Generic_IEnumerable_1___System_Char) true_1)) (not (= (x System_String System_Collections_IEnumerable) true_1)) (not (= (x System_IEquatable_1___System_String System_IEquatable_1___System_String) true_1)) (not (= (x System_IEquatable_1___System_String System_Object) true_1)) (not (= (IsMemberlessType System_IEquatable_1___System_String) true_1)) (not (= (AsInterface System_IEquatable_1___System_String) System_IEquatable_1___System_String)) (not (= (x System_String System_IEquatable_1___System_String) true_1)) (not (forall ((?U Int)) (! (=> (= (x ?U System_String) true_1) (= ?U System_String)) :pattern ((x ?U System_String)) ))) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) System_String) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_2))))) true) :pattern ((x (select2 ?h ?oi inv) System_String)) )))))))
(assert (let ((?v_24 (forall ((?o_1 Int)) (! (let ((?v_104 (select2 Heap ?o_1 ownerFrame)) (?v_103 (select2 Heap ?o_1 ownerRef))) (=> (not (or (not (not (= ?o_1 nullObject))) (not (= (select2 Heap ?o_1 allocated) true_1)))) (not (or (not (= ?v_103 ?v_103)) (not (= ?v_104 ?v_104)))))) :pattern ((select2 Heap ?o_1 ownerFrame))  :pattern ((select2 Heap ?o_1 ownerRef)) )))) (let ((?v_94 (not ?v_24)) (?v_29 (= (HeapSucc Heap Heap) true_1)) (?v_23 (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_108 (select2 Heap ?o_1 ?f_1)) (?v_107 (not true)) (?v_105 (select2 Heap ?o_1 ownerFrame)) (?v_106 (select2 Heap ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap ?o_1 allocated) true_1)) (not (or (= ?v_105 PeerGroupPlaceholder) (not (= (x (select2 Heap ?v_106 inv) ?v_105) true_1)) (= (select2 Heap ?v_106 localinv) (BaseClass ?v_105)))) ?v_107 ?v_107)) (= ?v_108 ?v_108))) :pattern ((select2 Heap ?o_1 ?f_1)) )))) (let ((?v_51 (not ?v_23)) (?v_28 (forall ((?o_1 Int)) (let ((?v_110 (typeof ?o_1)) (?v_109 (not (= (select2 Heap ?o_1 allocated) true_1)))) (=> (not (or (not ?v_109) ?v_109)) (not (or (not (= (select2 Heap ?o_1 inv) ?v_110)) (not (= (select2 Heap ?o_1 localinv) ?v_110)))))))) (?v_27 (forall ((?o_1 Int)) (! (let ((?v_112 (select2 Heap ?o_1 localinv)) (?v_111 (select2 Heap ?o_1 inv))) (=> (= (select2 Heap ?o_1 allocated) true_1) (not (or (not (= ?v_111 ?v_111)) (not (= ?v_112 ?v_112)))))) :pattern ((select2 Heap ?o_1 localinv))  :pattern ((select2 Heap ?o_1 inv)) ))) (?v_22 (= (select2 Heap BeingConstructed NonNullFieldsAreInitialized) true_1))) (let ((?v_26 (not (or (not (forall ((?o_1 Int)) (! (let ((?v_113 (= (select2 Heap ?o_1 allocated) true_1))) (=> ?v_113 ?v_113)) :pattern ((select2 Heap ?o_1 allocated)) ))) (not (forall ((?ot Int)) (! (let ((?v_115 (select2 Heap ?ot ownerFrame)) (?v_114 (select2 Heap ?ot ownerRef))) (=> (not (or (not (= (select2 Heap ?ot allocated) true_1)) (not (not (= ?v_115 PeerGroupPlaceholder))))) (not (or (not (= ?v_114 ?v_114)) (not (= ?v_115 ?v_115)))))) :pattern ((select2 Heap ?ot ownerFrame))  :pattern ((select2 Heap ?ot ownerRef)) ))) (not (= ?v_22 ?v_22))))) (?v_71 (select2 Heap a_in elements)) (?v_9 (Length a_in)) (?v_88 (+ high_1 1))) (let ((?v_93 (forall ((?i_1 Int)) (=> (not (or (not (<= ?v_88 ?i_1)) (not (<= ?i_1 (- ?v_9 1))))) (not (= (IntArrayGet ?v_71 ?i_1) key_in))))) (?v_92 (forall ((?i_1 Int)) (=> (not (or (not (<= 0 ?i_1)) (not (<= ?i_1 (- low_1 1))))) (not (= (IntArrayGet ?v_71 ?i_1) key_in))))) (?v_91 (<= ?v_88 ?v_9)) (?v_90 (<= low_1 ?v_88)) (?v_89 (<= ?v_88 int_2147483647)) (?v_87 (<= int_m2147483648 ?v_88)) (?v_6 (not (= a_in a_in))) (?v_5 (not (= key_in key_in))) (?v_14 (not (= Heap Heap))) (?v_69 (<= 0 stack0i_8))) (let ((?v_72 (not ?v_69)) (?v_73 (not (= stack0i_8 stack0i_8))) (?v_97 (+ stack0i_8 1)) (?v_41 (x_1 1 2))) (let ((?v_85 (* ?v_41 stack0i_8)) (?v_84 (* ?v_41 stack0i_12))) (let ((?v_86 (not (or ?v_72 (not (<= ?v_84 (+ (+ high_1 ?v_85) ?v_41))) (not (<= (+ (+ ?v_84 ?v_85) ?v_41) (+ low_1 stack0i_8))) (not (<= stack0i_12 (+ high_1 low_1))) (not (<= stack0i_12 ?v_97)) (not (<= stack0i_8 (+ stack0i_12 1))) ?v_73 ?v_6 ?v_14 ?v_5 ?v_6)))) (let ((?v_102 (=> true (=> ?v_86 (=> ?v_86 (=> true (=> (not (or ?v_72 ?v_14 ?v_6 (not (<= 0 low_1)) ?v_5 ?v_6)) (not (or (not ?v_87) (not (=> ?v_87 (not (or (not ?v_89) (not (=> ?v_89 (not (or (not ?v_90) (not (=> ?v_90 (not (or (not ?v_91) (not (=> ?v_91 (not (or (not ?v_92) (not (=> ?v_92 (not (or (not ?v_93) (not (=> ?v_93 (=> ?v_26 (=> ?v_27 (=> ?v_28 (not (or ?v_51 (not (=> ?v_23 (=> ?v_29 (not (or ?v_94 (not (=> ?v_24 (=> false true))))))))))))))))))))))))))))))))))))))))))) (?v_101 (not (<= (+ midVal_1 1) key_in))) (?v_100 (= stack0i_11 ?v_97)) (?v_33 (not (<= 0 low_0))) (?v_54 (<= low_0 high_0))) (let ((?v_55 (not ?v_54))) (let ((?v_96 (not (or ?v_101 ?v_72 ?v_55 ?v_73 ?v_6 ?v_73 ?v_33 ?v_14 ?v_5 ?v_6))) (?v_99 (<= ?v_97 int_2147483647)) (?v_98 (<= int_m2147483648 ?v_97)) (?v_95 (not (or ?v_72 ?v_55 ?v_73 ?v_6 ?v_73 ?v_33 ?v_14 ?v_5 ?v_6))) (?v_83 (not (<= (+ key_in 1) midVal_1))) (?v_81 (- stack0i_8 1))) (let ((?v_79 (not (or ?v_83 ?v_72 ?v_55 ?v_73 ?v_6 ?v_73 ?v_33 ?v_14 ?v_5 ?v_6))) (?v_82 (<= ?v_81 int_2147483647)) (?v_80 (<= int_m2147483648 ?v_81)) (?v_74 (not (or (not (<= key_in midVal_1)) ?v_72 ?v_55 ?v_73 ?v_6 ?v_73 ?v_33 ?v_14 ?v_5 ?v_6))) (?v_53 (=> (<= 0 result_0) (= (IntArrayGet ?v_71 result_0) key_in))) (?v_52 (=> (< result_0 0) (forall ((?i_1 Int)) (=> (not (or (not (<= 0 ?i_1)) (not (<= ?i_1 (- ?v_9 1))))) (not (= (IntArrayGet ?v_71 ?i_1) key_in)))))) (?v_77 (= stack0o_1 a_in))) (let ((?v_50 (not ?v_77)) (?v_25 (+ high_0 1))) (let ((?v_30 (<= low_0 ?v_25))) (let ((?v_34 (not ?v_30)) (?v_49 (not (<= 0 stack1i_1))) (?v_48 (not (<= low_0 (+ high_0 stack1i_1)))) (?v_47 (not (= return_value_0 return_value_0))) (?v_46 (* ?v_41 return_value_0)) (?v_45 (* ?v_41 low_0)) (?v_42 (* ?v_41 stack1i_1))) (let ((?v_44 (+ high_0 ?v_42)) (?v_43 (* ?v_41 stack0i_9))) (let ((?v_78 (=> true (=> (not (or ?v_48 (not (<= 0 (+ (+ low_0 stack0i_9) stack1i_1))) ?v_49 ?v_34 (not (<= (+ low_0 ?v_43) ?v_44)) (not (<= ?v_42 (+ (+ ?v_45 ?v_43) 1))) ?v_33 (not (<= stack0i_9 stack1i_1)) (not (= return_value_0 stack0i_9)) ?v_14 ?v_50 ?v_5 ?v_6)) (=> (not (or ?v_47 (not (<= (+ low_0 ?v_46) ?v_44)) (not (<= return_value_0 stack1i_1)) (not (<= 0 (+ (+ low_0 return_value_0) stack1i_1))) (not (<= ?v_42 (+ (+ ?v_45 ?v_46) 1))) ?v_47 ?v_47 ?v_48 ?v_49 ?v_34 ?v_33 ?v_14 ?v_50 ?v_5 ?v_6)) (=> true (=> (= low_2 low_0) (=> (= stack0o_2 stack0o_1) (=> (= high_2 high_0) (=> (= mid_2 mid_1) (=> (= stack0i_13 return_value_0) (=> (= midVal_3 midVal_2) (=> (= stack1i_2 stack1i_1) (=> (= result_0 return_value_0) (=> (= return_value_1 return_value_0) (=> (= SS_Display_Return_Local_0 return_value_0) (=> true (not (or ?v_51 (not (=> ?v_23 (not (or (not ?v_52) (not (=> ?v_52 (not (or (not ?v_53) (not (=> ?v_53 true)))))))))))))))))))))))))))) (?v_76 (not (= key_in midVal_1))) (?v_75 (not (= midVal_1 key_in))) (?v_70 (< stack0i_8 ?v_9)) (?v_8 (not (= a_in nullObject)))) (let ((?v_68 (not ?v_8)) (?v_67 (not (= 2 0))) (?v_57 (- high_0 low_0)) (?v_32 (not (= stack0o_0 a_in))) (?v_31 (not (<= 0 stack1i_0)))) (let ((?v_60 (not (or ?v_55 ?v_31 ?v_33 ?v_14 ?v_32 ?v_5 ?v_6))) (?v_62 (x_1 ?v_57 2))) (let ((?v_65 (+ low_0 ?v_62))) (let ((?v_66 (<= ?v_65 int_2147483647)) (?v_64 (<= int_m2147483648 ?v_65)) (?v_63 (<= ?v_62 int_2147483647)) (?v_61 (<= int_m2147483648 ?v_62)) (?v_59 (not (or ?v_55 ?v_33 ?v_31 ?v_14 ?v_32 ?v_5 ?v_6))) (?v_58 (<= ?v_57 int_2147483647)) (?v_56 (<= int_m2147483648 ?v_57)) (?v_35 (not (or ?v_34 ?v_31 ?v_33 ?v_14 ?v_32 ?v_5 ?v_6))) (?v_37 (not (= low_0 ?v_25))) (?v_36 (not (= ?v_25 low_0))) (?v_13 (not (= 1 1))) (?v_40 (- 0 low_0))) (let ((?v_39 (not (or ?v_31 ?v_36 ?v_37 ?v_33 ?v_14 ?v_32 ?v_5 ?v_6))) (?v_38 (<= int_m2147483648 (- ?v_40 1))) (?v_16 (+ stack0i_2 1))) (let ((?v_21 (forall ((?i_1 Int)) (=> (not (or (not (<= ?v_16 ?i_1)) (not (<= ?i_1 (- ?v_9 1))))) (not (= (IntArrayGet ?v_71 ?i_1) key_in))))) (?v_20 (forall ((?i_1 Int)) (=> (not (or (not (<= 0 ?i_1)) (not (<= ?i_1 (- 0 1))))) (not (= (IntArrayGet ?v_71 ?i_1) key_in))))) (?v_19 (<= ?v_16 ?v_9)) (?v_18 (<= 0 ?v_16)) (?v_17 (<= ?v_16 int_2147483647)) (?v_15 (<= int_m2147483648 ?v_16)) (?v_10 (not (= 0 0))) (?v_12 (not (= stack0i_2 stack0i_2)))) (let ((?v_11 (not (or ?v_12 ?v_13 ?v_6 ?v_10 ?v_5 ?v_6))) (?v_7 (not (or ?v_10 ?v_5 ?v_6))) (?v_4 (<= int_m2147483648 (- ?v_9 1))) (?v_3 (not (or ?v_5 ?v_6))) (?v_1 (select2 Heap a_in ownerFrame)) (?v_2 (select2 Heap a_in ownerRef)) (?v_0 (IntArray System_Int32 1))) (not (=> true (=> (= (IsHeap Heap) true_1) (=> (not (or (not (= (IsNotNull a_in ?v_0) true_1)) (not (= (select2 Heap a_in allocated) true_1)))) (=> (= (InRange key_in System_Int32) true_1) (=> (= (InRange result System_Int32) true_1) (=> (not (or (not (= (IsNotNull a ?v_0) true_1)) (not (= (select2 Heap a allocated) true_1)))) (=> (= (InRange key System_Int32) true_1) (=> (= (InRange low System_Int32) true_1) (=> (= (InRange high System_Int32) true_1) (=> (= (InRange return_value System_Int32) true_1) (=> (= (InRange SS_Display_Return_Local System_Int32) true_1) (=> (= (InRange mid System_Int32) true_1) (=> (= (InRange midVal System_Int32) true_1) (=> (= PurityAxiomsCanBeAssumed true_1) (=> (= BeingConstructed nullObject) (=> (or (= ?v_1 PeerGroupPlaceholder) (not (= (x (select2 Heap ?v_2 inv) ?v_1) true_1)) (= (select2 Heap ?v_2 localinv) (BaseClass ?v_1))) (=> (forall ((?pc Int)) (! (let ((?v_116 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap ?pc allocated) true_1)) (not (= (select2 Heap ?pc ownerRef) ?v_2)) (not (= (select2 Heap ?pc ownerFrame) ?v_1)))) (not (or (not (= (select2 Heap ?pc inv) ?v_116)) (not (= (select2 Heap ?pc localinv) ?v_116)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap ?pc localinv))  :pattern ((select2 Heap ?pc inv))  :pattern ((select2 Heap ?pc ownerFrame))  :pattern ((select2 Heap ?pc ownerRef)) )) (=> (forall ((?j_1 Int) (?i_1 Int)) (let ((?v_117 (- ?v_9 1))) (=> (not (or (not (<= 0 ?i_1)) (not (<= ?i_1 ?v_117)))) (=> (not (or (not (<= ?i_1 ?j_1)) (not (<= ?j_1 ?v_117)))) (<= (IntArrayGet ?v_71 ?i_1) (IntArrayGet ?v_71 ?j_1)))))) (=> true (=> ?v_3 (=> true (=> ?v_3 (=> ?v_3 (=> true (=> ?v_3 (not (or (not ?v_4) (not (=> ?v_4 (=> ?v_7 (=> true (=> ?v_7 (not (or ?v_68 (not (=> ?v_8 (=> (= stack0i_0 ?v_9) (=> (= stack0i_1 (IntToInt stack0i_0 System_UIntPtr System_Int32)) (=> (= stack0i_2 (- stack0i_1 1)) (=> ?v_11 (=> true (=> ?v_11 (=> (not (or ?v_14 ?v_12 ?v_13 ?v_6 ?v_10 ?v_5 ?v_6)) (=> (not (or (not (<= 0 1)) ?v_14 ?v_6 (not (<= 0 0)) ?v_5 ?v_6)) (not (or (not ?v_15) (not (=> ?v_15 (not (or (not ?v_17) (not (=> ?v_17 (not (or (not ?v_18) (not (=> ?v_18 (not (or (not ?v_19) (not (=> ?v_19 (not (or (not ?v_20) (not (=> ?v_20 (not (or (not ?v_21) (not (=> ?v_21 (=> ?v_26 (=> ?v_27 (=> ?v_28 (not (or ?v_51 (not (=> ?v_23 (=> ?v_29 (not (or ?v_94 (not (=> ?v_24 (=> true (=> (= (InRange mid_0 System_Int32) true_1) (=> (= (InRange midVal_0 System_Int32) true_1) (=> (= (InRange low_0 System_Int32) true_1) (=> (= (InRange high_0 System_Int32) true_1) (=> (not (or ?v_31 ?v_14 ?v_32 ?v_33 ?v_5 ?v_6)) (=> (<= int_m2147483648 ?v_25) (=> (<= ?v_25 int_2147483647) (=> ?v_30 (=> (<= ?v_25 ?v_9) (=> (forall ((?i_1 Int)) (=> (not (or (not (<= 0 ?i_1)) (not (<= ?i_1 (- low_0 1))))) (not (= (IntArrayGet ?v_71 ?i_1) key_in)))) (=> (forall ((?i_1 Int)) (=> (not (or (not (<= ?v_25 ?i_1)) (not (<= ?i_1 (- ?v_9 1))))) (not (= (IntArrayGet ?v_71 ?i_1) key_in)))) (=> ?v_26 (=> ?v_27 (=> ?v_28 (=> ?v_23 (=> ?v_29 (=> ?v_24 (=> (not (or ?v_34 ?v_31 ?v_14 ?v_32 ?v_33 ?v_5 ?v_6)) (=> true (=> ?v_35 (=> ?v_35 (not (or (not (=> true (=> ?v_35 (=> (> low_0 high_0) (=> (not (or ?v_36 ?v_37 ?v_31 ?v_33 ?v_14 ?v_32 ?v_5 ?v_6)) (=> true (=> ?v_39 (not (or (not ?v_38) (not (=> ?v_38 (=> ?v_39 (=> true (=> ?v_39 (=> (= stack0i_4 ?v_40) (=> (= stack0i_5 (- stack0i_4 1)) (=> (not (or (not (= stack0i_5 stack0i_5)) (not (= 0 (+ (+ low_0 stack0i_5) 1))) ?v_13 ?v_36 ?v_37 ?v_33 ?v_14 ?v_32 ?v_5 ?v_6)) (=> true (=> (= midVal_2 midVal_0) (=> (= stack0i_9 stack0i_5) (=> (= stack0o_1 stack0o_0) (=> (= return_value_0 stack0i_5) (=> (= stack1i_1 1) (=> (= mid_1 mid_0) ?v_78)))))))))))))))))))))))) (not (=> true (=> ?v_35 (=> ?v_54 (=> ?v_60 (=> true (=> ?v_59 (not (or (not ?v_56) (not (=> ?v_56 (not (or (not ?v_58) (not (=> ?v_58 (=> ?v_59 (=> true (=> ?v_60 (not (or (not ?v_61) (not (=> ?v_61 (not (or (not ?v_63) (not (=> ?v_63 (=> ?v_60 (=> true (=> ?v_60 (not (or (not ?v_64) (not (=> ?v_64 (not (or (not ?v_66) (not (=> ?v_66 (=> ?v_60 (=> true (=> ?v_60 (=> (= stack0i_6 ?v_57) (not (or (not ?v_67) (not (=> ?v_67 (=> (= stack0i_7 (x_1 stack0i_6 2)) (=> (= stack0i_8 (+ low_0 stack0i_7)) (not (or ?v_68 (not (=> ?v_8 (not (or ?v_72 (not (=> ?v_69 (not (or (not ?v_70) (not (=> ?v_70 (=> (= midVal_1 (IntArrayGet ?v_71 stack0i_8)) (=> (not (or ?v_72 ?v_73 ?v_6 ?v_73 ?v_55 ?v_33 ?v_14 ?v_5 ?v_6)) (not (or (not (=> true (=> ?v_95 (=> (>= midVal_1 key_in) (=> ?v_74 (=> true (=> ?v_74 (=> ?v_74 (not (or (not (=> true (=> ?v_74 (=> (>= key_in midVal_1) (=> (not (or ?v_75 ?v_76 ?v_72 ?v_55 ?v_73 ?v_6 ?v_73 ?v_33 ?v_14 ?v_5 ?v_6)) (=> true (=> (not (or ?v_72 ?v_55 ?v_75 ?v_76 ?v_73 ?v_6 ?v_73 ?v_33 ?v_14 ?v_5 ?v_6)) (=> (not (or ?v_73 ?v_72 ?v_55 ?v_75 ?v_76 ?v_73 ?v_6 ?v_73 ?v_33 ?v_14 ?v_5 ?v_6)) (=> true (=> (= midVal_2 midVal_1) (=> (= stack0i_9 stack0i_8) (=> ?v_77 (=> (= return_value_0 stack0i_8) (=> (= stack1i_1 stack0i_8) (=> (= mid_1 stack0i_8) ?v_78))))))))))))))) (not (=> true (=> ?v_74 (=> (< key_in midVal_1) (=> ?v_79 (=> true (=> ?v_79 (not (or (not ?v_80) (not (=> ?v_80 (not (or (not ?v_82) (not (=> ?v_82 (=> ?v_79 (=> true (=> ?v_79 (=> (= stack0i_10 ?v_81) (=> (not (or (not (= stack0i_10 stack0i_10)) (not (= stack0i_8 (+ stack0i_10 1))) ?v_83 ?v_72 ?v_73 ?v_6 ?v_33 ?v_14 ?v_5 ?v_6)) (=> true (=> (= high_1 stack0i_10) (=> (= stack0i_12 stack0i_10) (=> (= low_1 low_0) ?v_102)))))))))))))))))))))))))))))))))) (not (=> true (=> ?v_95 (=> (< midVal_1 key_in) (=> ?v_96 (=> true (=> ?v_96 (not (or (not ?v_98) (not (=> ?v_98 (not (or (not ?v_99) (not (=> ?v_99 (=> ?v_96 (=> true (=> ?v_96 (=> ?v_100 (=> (not (or (not (<= 0 high_0)) (not (= stack0i_11 stack0i_11)) (not ?v_100) ?v_101 ?v_72 ?v_73 ?v_6 ?v_14 ?v_5 ?v_6)) (=> true (=> (= high_1 high_0) (=> (= stack0i_12 stack0i_11) (=> (= low_1 stack0i_11) ?v_102)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
