(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    Spec# benchmarks.  Contributed by Leonardo de Moura and Michal Moskal.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun Microsoft_Contracts_ICheckedException () Int)
(declare-fun AsInterface (Int) Int)
(declare-fun IsMemberlessType (Int) Int)
(declare-fun System_Object () Int)
(declare-fun System_Type () Int)
(declare-fun inv () Int)
(declare-fun BaseClass (Int) Int)
(declare-fun localinv () Int)
(declare-fun IsHeap (Int) Int)
(declare-fun System_Reflection_IReflect () Int)
(declare-fun System_Runtime_InteropServices__Type () Int)
(declare-fun AsImmutable (Int) Int)
(declare-fun IsImmutable (Int) Int)
(declare-fun AsDirectSubClass (Int Int) Int)
(declare-fun System_Reflection_MemberInfo () Int)
(declare-fun System_Runtime_InteropServices__MemberInfo () Int)
(declare-fun System_Reflection_ICustomAttributeProvider () Int)
(declare-fun Microsoft_Contracts_ObjectInvariantException () Int)
(declare-fun AsMutable (Int) Int)
(declare-fun Microsoft_Contracts_GuardException () Int)
(declare-fun System_Exception () Int)
(declare-fun System_Runtime_InteropServices__Exception () Int)
(declare-fun System_Runtime_Serialization_ISerializable () Int)
(declare-fun Node () Int)
(declare-fun Node_parent () Int)
(declare-fun Node_left () Int)
(declare-fun nullObject () Int)
(declare-fun Node_right () Int)
(declare-fun Node_data () Int)
(declare-fun Node_large () Int)
(declare-fun Node_small () Int)
(declare-fun AsRefField (Int Int) Int)
(declare-fun DeclType (Int) Int)
(declare-fun IncludedInModifiesStar (Int) Int)
(declare-fun IncludeInMainFrameCondition (Int) Int)
(declare-fun IsStaticField (Int) Int)
(declare-fun AsRepField (Int Int) Int)
(declare-fun AsRangeField (Int Int) Int)
(declare-fun System_Int32 () Int)
(declare-fun System_String_Equals_System_String_System_String (Int Int Int) Int)
(declare-fun System_String_IsInterned_System_String_notnull (Int Int) Int)
(declare-fun StringEquals (Int Int) Int)
(declare-fun System_String_Equals_System_String (Int Int Int) Int)
(declare-fun max (Int Int) Int)
(declare-fun min (Int Int) Int)
(declare-fun shr (Int Int) Int)
(declare-fun x_1 (Int Int) Int)
(declare-fun shl (Int Int) Int)
(declare-fun int_2147483647 () Int)
(declare-fun or_1 (Int Int) Int)
(declare-fun and_1 (Int Int) Int)
(declare-fun x_2 (Int Int) Int)
(declare-fun IfThenElse (Int Int Int) Int)
(declare-fun IntToInt (Int Int Int) Int)
(declare-fun InRange (Int Int) Int)
(declare-fun System_Char () Int)
(declare-fun int_18446744073709551615 () Int)
(declare-fun System_UInt64 () Int)
(declare-fun int_9223372036854775807 () Int)
(declare-fun int_m9223372036854775808 () Int)
(declare-fun System_Int64 () Int)
(declare-fun int_4294967295 () Int)
(declare-fun System_UInt32 () Int)
(declare-fun int_m2147483648 () Int)
(declare-fun System_UInt16 () Int)
(declare-fun System_Int16 () Int)
(declare-fun System_Byte () Int)
(declare-fun System_SByte () Int)
(declare-fun IsValueType (Int) Int)
(declare-fun System_IntPtr () Int)
(declare-fun System_UIntPtr () Int)
(declare-fun BoxTester (Int Int) Int)
(declare-fun Box (Int Int) Int)
(declare-fun Unbox (Int) Int)
(declare-fun UnboxedType (Int) Int)
(declare-fun typeof (Int) Int)
(declare-fun BoxFunc (Int Int Int Int) Int)
(declare-fun FirstConsistentOwner () Int)
(declare-fun ownerFrame () Int)
(declare-fun ownerRef () Int)
(declare-fun PeerGroupPlaceholder () Int)
(declare-fun allocated () Int)
(declare-fun AsPureObject (Int) Int)
(declare-fun FieldDependsOnFCO (Int Int Int) Int)
(declare-fun exposeVersion () Int)
(declare-fun AsElementsPeerField (Int Int) Int)
(declare-fun ElementProxy (Int Int) Int)
(declare-fun AsElementsRepField (Int Int Int) Int)
(declare-fun AsPeerField (Int) Int)
(declare-fun StringLength (Int) Int)
(declare-fun AsOwner (Int Int) Int)
(declare-fun BeingConstructed () Int)
(declare-fun AsNonNullRefField (Int Int) Int)
(declare-fun NonNullFieldsAreInitialized () Int)
(declare-fun Is (Int Int) Int)
(declare-fun ClassRepr (Int) Int)
(declare-fun IsAllocated (Int Int) Int)
(declare-fun ValueArrayGet (Int Int) Int)
(declare-fun RefArrayGet (Int Int) Int)
(declare-fun StructGet (Int Int) Int)
(declare-fun System_Array () Int)
(declare-fun As (Int Int) Int)
(declare-fun IsNotNull (Int Int) Int)
(declare-fun TypeObject (Int) Int)
(declare-fun TypeName (Int) Int)
(declare-fun System_Boolean () Int)
(declare-fun OneClassDown (Int Int) Int)
(declare-fun StructSet (Int Int Int) Int)
(declare-fun ElementProxyStruct (Int Int) Int)
(declare-fun elements () Int)
(declare-fun IntArray (Int Int) Int)
(declare-fun ValueArray (Int Int) Int)
(declare-fun NonNullRefArray (Int Int) Int)
(declare-fun ElementType (Int) Int)
(declare-fun RefArray (Int Int) Int)
(declare-fun NonNullRefArrayRaw (Int Int Int) Int)
(declare-fun Rank (Int) Int)
(declare-fun ArrayCategoryNonNullRef () Int)
(declare-fun ArrayCategory (Int) Int)
(declare-fun ArrayCategoryRef () Int)
(declare-fun ArrayCategoryInt () Int)
(declare-fun ArrayCategoryValue () Int)
(declare-fun UBound (Int Int) Int)
(declare-fun DimLength (Int Int) Int)
(declare-fun LBound (Int Int) Int)
(declare-fun Length (Int) Int)
(declare-fun IntArrayGet (Int Int) Int)
(declare-fun ArrayIndex (Int Int Int Int) Int)
(declare-fun ArrayIndexInvY (Int) Int)
(declare-fun ArrayIndexInvX (Int) Int)
(declare-fun RefArraySet (Int Int Int) Int)
(declare-fun IntArraySet (Int Int Int) Int)
(declare-fun ValueArraySet (Int Int Int) Int)
(declare-fun ClassReprInv (Int) Int)
(declare-fun System_String () Int)
(declare-fun SharingMode_LockProtected () Int)
(declare-fun SharingMode_Unshared () Int)
(declare-fun sharingMode () Int)
(declare-fun return_value_0 () Int)
(declare-fun this () Int)
(declare-fun Heap () Int)
(declare-fun Heap_51 () Int)
(declare-fun temp9_1 () Int)
(declare-fun temp9_2 () Int)
(declare-fun temp15_1 () Int)
(declare-fun temp15_2 () Int)
(declare-fun Heap_50 () Int)
(declare-fun stack2o_2 () Int)
(declare-fun stack2o_3 () Int)
(declare-fun temp16_2 () Int)
(declare-fun temp16_3 () Int)
(declare-fun temp2_0 () Int)
(declare-fun temp2_1 () Int)
(declare-fun temp13_2 () Int)
(declare-fun temp13_3 () Int)
(declare-fun temp19_2 () Int)
(declare-fun temp19_3 () Int)
(declare-fun temp11_2 () Int)
(declare-fun temp11_3 () Int)
(declare-fun stack1i_22 () Int)
(declare-fun stack1i_23 () Int)
(declare-fun temp17_2 () Int)
(declare-fun temp17_3 () Int)
(declare-fun temp1_2 () Int)
(declare-fun temp1_3 () Int)
(declare-fun ActivityIndicator_6 () Int)
(declare-fun ActivityIndicator_7 () Int)
(declare-fun stack0o_21 () Int)
(declare-fun stack0o_22 () Int)
(declare-fun temp3_1 () Int)
(declare-fun temp3_2 () Int)
(declare-fun temp18_2 () Int)
(declare-fun temp18_3 () Int)
(declare-fun temp10_2 () Int)
(declare-fun temp10_3 () Int)
(declare-fun temp4_1 () Int)
(declare-fun temp4_2 () Int)
(declare-fun local14_0 () Int)
(declare-fun local14_1 () Int)
(declare-fun stack0i_6 () Int)
(declare-fun stack0i_7 () Int)
(declare-fun temp7_2 () Int)
(declare-fun temp7_3 () Int)
(declare-fun temp0_1 () Int)
(declare-fun temp0_2 () Int)
(declare-fun temp6_2 () Int)
(declare-fun temp6_3 () Int)
(declare-fun temp8_1 () Int)
(declare-fun temp8_2 () Int)
(declare-fun local10_1 () Int)
(declare-fun local10_2 () Int)
(declare-fun temp5_2 () Int)
(declare-fun temp5_3 () Int)
(declare-fun stack0s_10 () Int)
(declare-fun stack0s_11 () Int)
(declare-fun temp14_2 () Int)
(declare-fun temp14_3 () Int)
(declare-fun stack1o_25 () Int)
(declare-fun stack1o_26 () Int)
(declare-fun temp12_2 () Int)
(declare-fun temp12_3 () Int)
(declare-fun stack1s_6 () Int)
(declare-fun stack1s_7 () Int)
(declare-fun local7_1 () Int)
(declare-fun local7_2 () Int)
(declare-fun local17_1 () Int)
(declare-fun local17_2 () Int)
(declare-fun temp9 () Int)
(declare-fun temp15 () Int)
(declare-fun Heap_47 () Int)
(declare-fun stack2o_0 () Int)
(declare-fun temp16_1 () Int)
(declare-fun temp2 () Int)
(declare-fun temp13 () Int)
(declare-fun temp11_1 () Int)
(declare-fun stack1i_20 () Int)
(declare-fun temp17 () Int)
(declare-fun ActivityIndicator_4 () Int)
(declare-fun stack0o_18 () Int)
(declare-fun temp3 () Int)
(declare-fun temp18_1 () Int)
(declare-fun temp10 () Int)
(declare-fun temp4_0 () Int)
(declare-fun temp1_1 () Int)
(declare-fun stack0i_5 () Int)
(declare-fun temp7_1 () Int)
(declare-fun temp0_0 () Int)
(declare-fun temp6_1 () Int)
(declare-fun temp8 () Int)
(declare-fun local10_0 () Int)
(declare-fun temp5_1 () Int)
(declare-fun temp19_1 () Int)
(declare-fun local14 () Int)
(declare-fun stack0s_7 () Int)
(declare-fun temp14_1 () Int)
(declare-fun stack1o_23 () Int)
(declare-fun temp12_1 () Int)
(declare-fun stack1s_4 () Int)
(declare-fun local7_0 () Int)
(declare-fun local17 () Int)
(declare-fun temp18_0 () Int)
(declare-fun temp11 () Int)
(declare-fun stack1s_0 () Int)
(declare-fun temp4 () Int)
(declare-fun temp7_0 () Int)
(declare-fun stack0i_2 () Int)
(declare-fun ActivityIndicator_0 () Int)
(declare-fun stack1i_6 () Int)
(declare-fun stack0s_6 () Int)
(declare-fun Heap_46 () Int)
(declare-fun temp6_0 () Int)
(declare-fun local10 () Int)
(declare-fun temp14_0 () Int)
(declare-fun stack0o_17 () Int)
(declare-fun temp5 () Int)
(declare-fun temp12 () Int)
(declare-fun temp1_0 () Int)
(declare-fun temp16 () Int)
(declare-fun temp19 () Int)
(declare-fun stack1o_6 () Int)
(declare-fun stack0s () Int)
(declare-fun Heap_11 () Int)
(declare-fun stack0s_0 () Int)
(declare-fun Heap_20 () Int)
(declare-fun stack0o_6 () Int)
(declare-fun IsTokenForType (Int Int) Int)
(declare-fun Heap_10 () Int)
(declare-fun Heap_9 () Int)
(declare-fun stack1o_4 () Int)
(declare-fun stack1i_5 () Int)
(declare-fun stack1o_5 () Int)
(declare-fun stack1i_4 () Int)
(declare-fun stack1i_3 () Int)
(declare-fun Heap_8 () Int)
(declare-fun Heap_7 () Int)
(declare-fun stack1o_1 () Int)
(declare-fun stack1o_3 () Int)
(declare-fun stack1i_2 () Int)
(declare-fun stack1o_2 () Int)
(declare-fun stack1i_1 () Int)
(declare-fun call14516formal__result_0 () Int)
(declare-fun Heap_6 () Int)
(declare-fun Heap_5 () Int)
(declare-fun HeapSucc (Int Int) Int)
(declare-fun Heap_4 () Int)
(declare-fun Heap_3 () Int)
(declare-fun stack0o_3 () Int)
(declare-fun call14516formal__result () Int)
(declare-fun stack1i_0 () Int)
(declare-fun Heap_2 () Int)
(declare-fun Heap_1 () Int)
(declare-fun stack0o_2 () Int)
(declare-fun Heap_0 () Int)
(declare-fun stack1o_0 () Int)
(declare-fun stack0o_0 () Int)
(declare-fun temp18 () Int)
(declare-fun temp11_0 () Int)
(declare-fun temp0 () Int)
(declare-fun stack1s_1 () Int)
(declare-fun temp7 () Int)
(declare-fun stack0i_3 () Int)
(declare-fun ActivityIndicator_1 () Int)
(declare-fun stack1i_13 () Int)
(declare-fun stack0s_2 () Int)
(declare-fun Heap_26 () Int)
(declare-fun local7 () Int)
(declare-fun temp6 () Int)
(declare-fun temp14 () Int)
(declare-fun stack0o_8 () Int)
(declare-fun temp5_0 () Int)
(declare-fun temp12_0 () Int)
(declare-fun temp1 () Int)
(declare-fun temp16_0 () Int)
(declare-fun temp19_0 () Int)
(declare-fun stack1o_13 () Int)
(declare-fun Heap_24 () Int)
(declare-fun stack0s_1 () Int)
(declare-fun Heap_25 () Int)
(declare-fun stack0o_7 () Int)
(declare-fun Heap_23 () Int)
(declare-fun Heap_22 () Int)
(declare-fun stack1o_11 () Int)
(declare-fun stack1i_12 () Int)
(declare-fun stack1o_12 () Int)
(declare-fun stack1i_11 () Int)
(declare-fun stack1i_10 () Int)
(declare-fun Heap_21 () Int)
(declare-fun Heap_19 () Int)
(declare-fun stack1o_8 () Int)
(declare-fun stack1o_10 () Int)
(declare-fun stack1i_9 () Int)
(declare-fun stack1o_9 () Int)
(declare-fun stack1i_8 () Int)
(declare-fun call16100formal__result_0 () Int)
(declare-fun Heap_18 () Int)
(declare-fun Heap_17 () Int)
(declare-fun Heap_16 () Int)
(declare-fun Heap_15 () Int)
(declare-fun stack0o_5 () Int)
(declare-fun call16100formal__result () Int)
(declare-fun stack1i_7 () Int)
(declare-fun Heap_14 () Int)
(declare-fun Heap_13 () Int)
(declare-fun stack0o_4 () Int)
(declare-fun Heap_12 () Int)
(declare-fun stack1o_7 () Int)
(declare-fun stack0o_1 () Int)
(declare-fun stack2o () Int)
(declare-fun stack1i () Int)
(declare-fun ActivityIndicator () Int)
(declare-fun stack0i_0 () Int)
(declare-fun stack1s () Int)
(declare-fun d_in () Int)
(declare-fun temp15_0 () Int)
(declare-fun Heap_45 () Int)
(declare-fun stack1i_16 () Int)
(declare-fun ActivityIndicator_2 () Int)
(declare-fun stack0o_16 () Int)
(declare-fun temp3_0 () Int)
(declare-fun stack0i_1 () Int)
(declare-fun temp8_0 () Int)
(declare-fun stack0s_5 () Int)
(declare-fun stack1o_17 () Int)
(declare-fun stack1s_2 () Int)
(declare-fun Heap_34 () Int)
(declare-fun stack0s_4 () Int)
(declare-fun Heap_44 () Int)
(declare-fun stack0o_15 () Int)
(declare-fun Heap_33 () Int)
(declare-fun Heap_32 () Int)
(declare-fun stack1o_15 () Int)
(declare-fun stack1i_15 () Int)
(declare-fun stack1o_16 () Int)
(declare-fun stack1i_14 () Int)
(declare-fun call15066formal__result_0 () Int)
(declare-fun Heap_31 () Int)
(declare-fun Heap_30 () Int)
(declare-fun Heap_29 () Int)
(declare-fun Heap_28 () Int)
(declare-fun stack0o_10 () Int)
(declare-fun call15066formal__result () Int)
(declare-fun Heap_27 () Int)
(declare-fun stack1o_14 () Int)
(declare-fun stack0o_9 () Int)
(declare-fun temp9_0 () Int)
(declare-fun Heap_49 () Int)
(declare-fun stack2o_1 () Int)
(declare-fun temp13_1 () Int)
(declare-fun stack1i_21 () Int)
(declare-fun temp17_1 () Int)
(declare-fun ActivityIndicator_5 () Int)
(declare-fun stack0o_20 () Int)
(declare-fun temp10_1 () Int)
(declare-fun stack0i_4 () Int)
(declare-fun stack0s_9 () Int)
(declare-fun stack1o_24 () Int)
(declare-fun stack1s_5 () Int)
(declare-fun local17_0 () Int)
(declare-fun stack0s_8 () Int)
(declare-fun temp10_0 () Int)
(declare-fun stack1i_19 () Int)
(declare-fun stack1s_3 () Int)
(declare-fun temp13_0 () Int)
(declare-fun temp17_0 () Int)
(declare-fun stack0o_19 () Int)
(declare-fun ActivityIndicator_3 () Int)
(declare-fun stack1o_22 () Int)
(declare-fun Heap_48 () Int)
(declare-fun Heap_42 () Int)
(declare-fun stack0s_3 () Int)
(declare-fun Heap_43 () Int)
(declare-fun stack0o_14 () Int)
(declare-fun Heap_41 () Int)
(declare-fun Heap_40 () Int)
(declare-fun stack1o_20 () Int)
(declare-fun stack1i_18 () Int)
(declare-fun stack1o_21 () Int)
(declare-fun stack1i_17 () Int)
(declare-fun call16754formal__result_0 () Int)
(declare-fun Heap_39 () Int)
(declare-fun Heap_38 () Int)
(declare-fun Heap_37 () Int)
(declare-fun Heap_36 () Int)
(declare-fun stack0o_13 () Int)
(declare-fun call16754formal__result () Int)
(declare-fun Heap_35 () Int)
(declare-fun stack1o_19 () Int)
(declare-fun stack0o_12 () Int)
(declare-fun stack0o_11 () Int)
(declare-fun stack1o_18 () Int)
(declare-fun stack1o () Int)
(declare-fun stack0o () Int)
(declare-fun PurityAxiomsCanBeAssumed () Int)
(declare-fun SS_Display_Return_Local () Int)
(declare-fun return_value () Int)
(declare-fun d () Int)
(declare-fun result () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolIff ?x_3 ?y) true_1) (= (= ?x_3 true_1) (= ?y true_1))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolImplies ?x_3 ?y) true_1) (=> (= ?x_3 true_1) (= ?y true_1))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolAnd ?x_3 ?y) true_1) (not (or (not (= ?x_3 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolOr ?x_3 ?y) true_1) (or (= ?x_3 true_1) (= ?y true_1))))) (not (forall ((?x_3 Int)) (! (= (= (boolNot ?x_3) true_1) (not (= ?x_3 true_1))) :pattern ((boolNot ?x_3)) ))) (not (forall ((?x_3 Int) (?y Int)) (= (= (anyEqual ?x_3 ?y) true_1) (= ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (! (= (= (anyNeq ?x_3 ?y) true_1) (not (= ?x_3 ?y))) :pattern ((anyNeq ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intLess ?x_3 ?y) true_1) (< ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intAtMost ?x_3 ?y) true_1) (<= ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intAtLeast ?x_3 ?y) true_1) (>= ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intGreater ?x_3 ?y) true_1) (> ?x_3 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (let ((?v_5 (BaseClass System_Type)) (?v_4 (BaseClass System_Reflection_MemberInfo)) (?v_3 (BaseClass Microsoft_Contracts_ObjectInvariantException)) (?v_2 (BaseClass Microsoft_Contracts_GuardException)) (?v_1 (BaseClass System_Exception)) (?v_0 (BaseClass Node))) (not (or (not (distinct allocated elements inv localinv exposeVersion sharingMode SharingMode_Unshared SharingMode_LockProtected ownerRef ownerFrame PeerGroupPlaceholder ArrayCategoryValue ArrayCategoryInt ArrayCategoryRef ArrayCategoryNonNullRef System_Array System_Boolean System_Object System_Type NonNullFieldsAreInitialized System_String FirstConsistentOwner System_SByte System_Byte System_Int16 System_UInt16 System_Int32 System_UInt32 System_Int64 System_UInt64 System_Char System_UIntPtr System_IntPtr Node_data Node_small Node_right Node_large Node_parent Node_left Microsoft_Contracts_ICheckedException System_Reflection_IReflect System_Runtime_Serialization_ISerializable System_Reflection_MemberInfo Microsoft_Contracts_GuardException System_Runtime_InteropServices__MemberInfo Microsoft_Contracts_ObjectInvariantException System_Runtime_InteropServices__Exception System_Reflection_ICustomAttributeProvider System_Exception Node System_Runtime_InteropServices__Type)) (not (= (DeclType elements) System_Object)) (not (= (DeclType exposeVersion) System_Object)) (not (forall ((?c Int)) (! (= (ClassReprInv (ClassRepr ?c)) ?c) :pattern ((ClassRepr ?c)) ))) (not (forall ((?T Int)) (not (= (x (typeof (ClassRepr ?T)) System_Object) true_1)))) (not (forall ((?T Int)) (not (= (ClassRepr ?T) nullObject)))) (not (forall ((?T Int) (?h_1 Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (select2 ?h_1 (ClassRepr ?T) ownerFrame) PeerGroupPlaceholder)) :pattern ((select2 ?h_1 (ClassRepr ?T) ownerFrame)) ))) (not (= (IncludeInMainFrameCondition allocated) true_1)) (not (= (IncludeInMainFrameCondition elements) true_1)) (not (not (= (IncludeInMainFrameCondition inv) true_1))) (not (not (= (IncludeInMainFrameCondition localinv) true_1))) (not (= (IncludeInMainFrameCondition ownerRef) true_1)) (not (= (IncludeInMainFrameCondition ownerFrame) true_1)) (not (= (IncludeInMainFrameCondition exposeVersion) true_1)) (not (not (= (IncludeInMainFrameCondition FirstConsistentOwner) true_1))) (not (not (= (IsStaticField allocated) true_1))) (not (not (= (IsStaticField elements) true_1))) (not (not (= (IsStaticField inv) true_1))) (not (not (= (IsStaticField localinv) true_1))) (not (not (= (IsStaticField exposeVersion) true_1))) (not (not (= (IncludedInModifiesStar ownerRef) true_1))) (not (not (= (IncludedInModifiesStar ownerFrame) true_1))) (not (= (IncludedInModifiesStar exposeVersion) true_1)) (not (= (IncludedInModifiesStar elements) true_1)) (not (forall ((?A Int) (?i Int) (?x_3 Int)) (= (ValueArrayGet (ValueArraySet ?A ?i ?x_3) ?i) ?x_3))) (not (forall ((?A Int) (?i Int) (?j Int) (?x_3 Int)) (=> (not (= ?i ?j)) (= (ValueArrayGet (ValueArraySet ?A ?i ?x_3) ?j) (ValueArrayGet ?A ?j))))) (not (forall ((?A Int) (?i Int) (?x_3 Int)) (= (IntArrayGet (IntArraySet ?A ?i ?x_3) ?i) ?x_3))) (not (forall ((?A Int) (?i Int) (?j Int) (?x_3 Int)) (=> (not (= ?i ?j)) (= (IntArrayGet (IntArraySet ?A ?i ?x_3) ?j) (IntArrayGet ?A ?j))))) (not (forall ((?A Int) (?i Int) (?x_3 Int)) (= (RefArrayGet (RefArraySet ?A ?i ?x_3) ?i) ?x_3))) (not (forall ((?A Int) (?i Int) (?j Int) (?x_3 Int)) (=> (not (= ?i ?j)) (= (RefArrayGet (RefArraySet ?A ?i ?x_3) ?j) (RefArrayGet ?A ?j))))) (not (forall ((?a Int) (?d Int) (?x_3 Int) (?y Int)) (! (= (ArrayIndexInvX (ArrayIndex ?a ?d ?x_3 ?y)) ?x_3) :pattern ((ArrayIndex ?a ?d ?x_3 ?y)) ))) (not (forall ((?a Int) (?d Int) (?x_3 Int) (?y Int)) (! (= (ArrayIndexInvY (ArrayIndex ?a ?d ?x_3 ?y)) ?y) :pattern ((ArrayIndex ?a ?d ?x_3 ?y)) ))) (not (forall ((?a Int) (?i Int) (?heap Int)) (! (=> (= (IsHeap ?heap) true_1) (= (InRange (IntArrayGet (select2 ?heap ?a elements) ?i) (ElementType (typeof ?a))) true_1)) :pattern ((IntArrayGet (select2 ?heap ?a elements) ?i)) ))) (not (forall ((?a Int) (?i Int) (?heap Int)) (! (let ((?v_6 (RefArrayGet (select2 ?heap ?a elements) ?i))) (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (not (= ?v_6 nullObject))))) (= (x (typeof ?v_6) (ElementType (typeof ?a))) true_1))) :pattern ((typeof (RefArrayGet (select2 ?heap ?a elements) ?i))) ))) (not (forall ((?a Int) (?T Int) (?i Int) (?r Int) (?heap Int)) (! (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (= (x (typeof ?a) (NonNullRefArray ?T ?r)) true_1)))) (not (= (RefArrayGet (select2 ?heap ?a elements) ?i) nullObject))) :pattern ((x (typeof ?a) (NonNullRefArray ?T ?r)) (RefArrayGet (select2 ?heap ?a elements) ?i)) ))) (not (forall ((?a Int)) (<= 1 (Rank ?a)))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (RefArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (RefArray ?T ?r))) ))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (NonNullRefArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (NonNullRefArray ?T ?r))) ))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (ValueArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (ValueArray ?T ?r))) ))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (IntArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (IntArray ?T ?r))) ))) (not (forall ((?a Int)) (! (let ((?v_7 (Length ?a))) (not (or (not (<= 0 ?v_7)) (not (<= ?v_7 int_2147483647))))) :pattern ((Length ?a)) ))) (not (forall ((?a Int) (?i Int)) (<= 0 (DimLength ?a ?i)))) (not (forall ((?a Int)) (! (=> (= (Rank ?a) 1) (= (DimLength ?a 0) (Length ?a))) :pattern ((DimLength ?a 0)) ))) (not (forall ((?a Int) (?i Int)) (! (= (LBound ?a ?i) 0) :pattern ((LBound ?a ?i)) ))) (not (forall ((?a Int) (?i Int)) (! (= (UBound ?a ?i) (- (DimLength ?a ?i) 1)) :pattern ((UBound ?a ?i)) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (ValueArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryValue)) :pattern ((x ?T (ValueArray ?ET ?r))) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (IntArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryInt)) :pattern ((x ?T (IntArray ?ET ?r))) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (RefArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryRef)) :pattern ((x ?T (RefArray ?ET ?r))) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (NonNullRefArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryNonNullRef)) :pattern ((x ?T (NonNullRefArray ?ET ?r))) ))) (not (= (x System_Array System_Object) true_1)) (not (forall ((?T Int) (?r Int)) (! (let ((?v_8 (ValueArray ?T ?r))) (not (or (not (= (x ?v_8 ?v_8) true_1)) (not (= (x ?v_8 System_Array) true_1))))) :pattern ((ValueArray ?T ?r)) ))) (not (forall ((?T Int) (?r Int)) (! (let ((?v_9 (IntArray ?T ?r))) (not (or (not (= (x ?v_9 ?v_9) true_1)) (not (= (x ?v_9 System_Array) true_1))))) :pattern ((IntArray ?T ?r)) ))) (not (forall ((?T Int) (?r Int)) (! (let ((?v_10 (RefArray ?T ?r))) (not (or (not (= (x ?v_10 ?v_10) true_1)) (not (= (x ?v_10 System_Array) true_1))))) :pattern ((RefArray ?T ?r)) ))) (not (forall ((?T Int) (?r Int)) (! (let ((?v_11 (NonNullRefArray ?T ?r))) (not (or (not (= (x ?v_11 ?v_11) true_1)) (not (= (x ?v_11 System_Array) true_1))))) :pattern ((NonNullRefArray ?T ?r)) ))) (not (forall ((?array Int) (?elementType Int) (?rank Int)) (! (let ((?v_12 (typeof ?array))) (=> (= (NonNullRefArrayRaw ?array ?elementType ?rank) true_1) (not (or (not (= (x ?v_12 System_Array) true_1)) (not (= (Rank ?array) ?rank)) (not (= (x ?elementType (ElementType ?v_12)) true_1)))))) :pattern ((NonNullRefArrayRaw ?array ?elementType ?rank)) ))) (not (forall ((?T Int) (?U Int) (?r Int)) (=> (= (x ?U ?T) true_1) (= (x (RefArray ?U ?r) (RefArray ?T ?r)) true_1)))) (not (forall ((?T Int) (?U Int) (?r Int)) (=> (= (x ?U ?T) true_1) (= (x (NonNullRefArray ?U ?r) (NonNullRefArray ?T ?r)) true_1)))) (not (forall ((?A Int) (?r Int)) (= (ElementType (ValueArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int)) (= (ElementType (IntArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int)) (= (ElementType (RefArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int)) (= (ElementType (NonNullRefArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_13 (ElementType ?T))) (=> (= (x ?T (RefArray ?A ?r)) true_1) (not (or (not (not (= ?T ?A))) (not (= ?T (RefArray ?v_13 ?r))) (not (= (x ?v_13 ?A) true_1)))))) :pattern ((x ?T (RefArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_14 (ElementType ?T))) (=> (= (x ?T (NonNullRefArray ?A ?r)) true_1) (not (or (not (not (= ?T ?A))) (not (= ?T (NonNullRefArray ?v_14 ?r))) (not (= (x ?v_14 ?A) true_1)))))) :pattern ((x ?T (NonNullRefArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_15 (ValueArray ?A ?r))) (=> (= (x ?T ?v_15) true_1) (= ?T ?v_15))) :pattern ((x ?T (ValueArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_16 (IntArray ?A ?r))) (=> (= (x ?T ?v_16) true_1) (= ?T ?v_16))) :pattern ((x ?T (IntArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_17 (ElementType ?T))) (=> (= (x (RefArray ?A ?r) ?T) true_1) (or (= (x System_Array ?T) true_1) (not (or (not (= ?T (RefArray ?v_17 ?r))) (not (= (x ?A ?v_17) true_1))))))) :pattern ((x (RefArray ?A ?r) ?T)) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_18 (ElementType ?T))) (=> (= (x (NonNullRefArray ?A ?r) ?T) true_1) (or (= (x System_Array ?T) true_1) (not (or (not (= ?T (NonNullRefArray ?v_18 ?r))) (not (= (x ?A ?v_18) true_1))))))) :pattern ((x (NonNullRefArray ?A ?r) ?T)) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_19 (ValueArray ?A ?r))) (=> (= (x ?v_19 ?T) true_1) (or (= (x System_Array ?T) true_1) (= ?T ?v_19)))) :pattern ((x (ValueArray ?A ?r) ?T)) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_20 (IntArray ?A ?r))) (=> (= (x ?v_20 ?T) true_1) (or (= (x System_Array ?T) true_1) (= ?T ?v_20)))) :pattern ((x (IntArray ?A ?r) ?T)) ))) (not (forall ((?a Int) (?i Int) (?heap Int)) (! (let ((?v_22 (ElementProxy ?a (- 0 1))) (?v_21 (RefArrayGet (select2 ?heap ?a elements) ?i))) (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (= (x (typeof ?a) System_Array) true_1)))) (or (= ?v_21 nullObject) (= (IsImmutable (typeof ?v_21)) true_1) (not (or (not (= (select2 ?heap ?v_21 ownerRef) (select2 ?heap ?v_22 ownerRef))) (not (= (select2 ?heap ?v_21 ownerFrame) (select2 ?heap ?v_22 ownerFrame)))))))) :pattern ((select2 ?heap (RefArrayGet (select2 ?heap ?a elements) ?i) ownerRef))  :pattern ((select2 ?heap (RefArrayGet (select2 ?heap ?a elements) ?i) ownerFrame)) ))) (not (forall ((?a Int) (?heap Int)) (! (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (= (IsAllocated ?heap ?a) true_1)) (not (= (x (typeof ?a) System_Array) true_1)))) (= (IsAllocated ?heap (ElementProxy ?a (- 0 1))) true_1)) :pattern ((IsAllocated ?heap ?a)) ))) (not (forall ((?o Int) (?pos Int)) (! (= (typeof (ElementProxy ?o ?pos)) System_Object) :pattern ((typeof (ElementProxy ?o ?pos))) ))) (not (forall ((?o Int) (?pos Int)) (! (= (typeof (ElementProxyStruct ?o ?pos)) System_Object) :pattern ((typeof (ElementProxyStruct ?o ?pos))) ))) (not (forall ((?s Int) (?f Int) (?x_3 Int)) (= (StructGet (StructSet ?s ?f ?x_3) ?f) ?x_3))) (not (forall ((?s Int) (?f Int) (|?f'| Int) (?x_3 Int)) (=> (not (= ?f |?f'|)) (= (StructGet (StructSet ?s ?f ?x_3) |?f'|) (StructGet ?s |?f'|))))) (not (forall ((?T Int)) (! (let ((?v_23 (BaseClass ?T))) (not (or (not (= (x ?T ?v_23) true_1)) (not (=> (not (= ?T System_Object)) (not (= ?T ?v_23))))))) :pattern ((BaseClass ?T)) ))) (not (forall ((?A Int) (?B Int) (?C Int)) (! (=> (= (x ?C (AsDirectSubClass ?B ?A)) true_1) (= (OneClassDown ?C ?A) ?B)) :pattern ((x ?C (AsDirectSubClass ?B ?A))) ))) (not (forall ((?T Int)) (=> (= (IsValueType ?T) true_1) (not (or (not (forall ((?U Int)) (=> (= (x ?T ?U) true_1) (= ?T ?U)))) (not (forall ((?U Int)) (=> (= (x ?U ?T) true_1) (= ?T ?U))))))))) (not (= (IsValueType System_Boolean) true_1)) (not (= (x System_Type System_Object) true_1)) (not (forall ((?T Int)) (! (= (IsNotNull (TypeObject ?T) System_Type) true_1) :pattern ((TypeObject ?T)) ))) (not (forall ((?T Int)) (! (= (TypeName (TypeObject ?T)) ?T) :pattern ((TypeObject ?T)) ))) (not (forall ((?o Int) (?T Int)) (! (= (= (Is ?o ?T) true_1) (or (= ?o nullObject) (= (x (typeof ?o) ?T) true_1))) :pattern ((Is ?o ?T)) ))) (not (forall ((?o Int) (?T Int)) (! (= (= (IsNotNull ?o ?T) true_1) (not (or (not (not (= ?o nullObject))) (not (= (Is ?o ?T) true_1))))) :pattern ((IsNotNull ?o ?T)) ))) (not (forall ((?o Int) (?T Int)) (=> (= (Is ?o ?T) true_1) (= (As ?o ?T) ?o)))) (not (forall ((?o Int) (?T Int)) (=> (not (= (Is ?o ?T) true_1)) (= (As ?o ?T) nullObject)))) (not (forall ((?h_1 Int) (?o Int)) (! (let ((?v_24 (typeof ?o))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (= (x ?v_24 System_Array) true_1)))) (not (or (not (= (select2 ?h_1 ?o inv) ?v_24)) (not (= (select2 ?h_1 ?o localinv) ?v_24)))))) :pattern ((x (typeof ?o) System_Array) (select2 ?h_1 ?o inv)) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int)) (! (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (= (select2 ?h_1 ?o allocated) true_1)))) (= (IsAllocated ?h_1 (select2 ?h_1 ?o ?f)) true_1)) :pattern ((IsAllocated ?h_1 (select2 ?h_1 ?o ?f))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int)) (! (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (= (select2 ?h_1 ?o allocated) true_1)))) (= (select2 ?h_1 (select2 ?h_1 ?o ?f) allocated) true_1)) :pattern ((select2 ?h_1 (select2 ?h_1 ?o ?f) allocated)) ))) (not (forall ((?h_1 Int) (?s Int) (?f Int)) (! (=> (= (IsAllocated ?h_1 ?s) true_1) (= (IsAllocated ?h_1 (StructGet ?s ?f)) true_1)) :pattern ((IsAllocated ?h_1 (StructGet ?s ?f))) ))) (not (forall ((?h_1 Int) (?e Int) (?i Int)) (! (=> (= (IsAllocated ?h_1 ?e) true_1) (= (IsAllocated ?h_1 (RefArrayGet ?e ?i)) true_1)) :pattern ((IsAllocated ?h_1 (RefArrayGet ?e ?i))) ))) (not (forall ((?h_1 Int) (?e Int) (?i Int)) (! (=> (= (IsAllocated ?h_1 ?e) true_1) (= (IsAllocated ?h_1 (ValueArrayGet ?e ?i)) true_1)) :pattern ((IsAllocated ?h_1 (ValueArrayGet ?e ?i))) ))) (not (forall ((?h_1 Int) (?o Int)) (! (=> (= (IsAllocated ?h_1 ?o) true_1) (= (select2 ?h_1 ?o allocated) true_1)) :pattern ((select2 ?h_1 ?o allocated)) ))) (not (forall ((?h_1 Int) (?c Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (select2 ?h_1 (ClassRepr ?c) allocated) true_1)) :pattern ((select2 ?h_1 (ClassRepr ?c) allocated)) ))) (not (= (DeclType NonNullFieldsAreInitialized) System_Object)) (not (forall ((?f Int) (?T Int)) (! (=> (= (AsNonNullRefField ?f ?T) ?f) (= (AsRefField ?f ?T) ?f)) :pattern ((AsNonNullRefField ?f ?T)) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (Is (select2 ?h_1 ?o (AsRefField ?f ?T)) ?T) true_1)) :pattern ((select2 ?h_1 ?o (AsRefField ?f ?T))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (or (not (= ?o BeingConstructed)) (= (= (select2 ?h_1 BeingConstructed NonNullFieldsAreInitialized) true_1) true))))) (not (= (select2 ?h_1 ?o (AsNonNullRefField ?f ?T)) nullObject))) :pattern ((select2 ?h_1 ?o (AsNonNullRefField ?f ?T))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (InRange (select2 ?h_1 ?o (AsRangeField ?f ?T)) ?T) true_1)) :pattern ((select2 ?h_1 ?o (AsRangeField ?f ?T))) ))) (not (forall ((?o Int)) (! (not (= (IsMemberlessType (typeof ?o)) true_1)) :pattern ((IsMemberlessType (typeof ?o))) ))) (not (forall ((?J Int) (?s Int) (?b Int)) (! (let ((?v_26 (AsInterface ?J)) (?v_25 (Box ?s ?b))) (=> (not (or (not (= ?v_26 ?J)) (not (= ?v_25 ?b)) (not (= (x (UnboxedType ?v_25) ?v_26) true_1)))) (= (x (typeof ?b) ?J) true_1))) :pattern ((x (UnboxedType (Box ?s ?b)) (AsInterface ?J))) ))) (not (not (= (IsImmutable System_Object) true_1))) (not (forall ((?T Int) (?U Int)) (! (=> (= (x ?U (AsImmutable ?T)) true_1) (not (or (not (= (IsImmutable ?U) true_1)) (not (= (AsImmutable ?U) ?U))))) :pattern ((x ?U (AsImmutable ?T))) ))) (not (forall ((?T Int) (?U Int)) (! (=> (= (x ?U (AsMutable ?T)) true_1) (not (or (not (not (= (IsImmutable ?U) true_1))) (not (= (AsMutable ?U) ?U))))) :pattern ((x ?U (AsMutable ?T))) ))) (not (forall ((?o Int) (?T Int)) (! (=> (not (or (not (not (= ?o nullObject))) (not (not (= ?o BeingConstructed))) (not (= (x (typeof ?o) (AsImmutable ?T)) true_1)))) (forall ((?h_1 Int)) (! (let ((?v_27 (typeof ?o))) (=> (= (IsHeap ?h_1) true_1) (not (or (not (= (select2 ?h_1 ?o inv) ?v_27)) (not (= (select2 ?h_1 ?o localinv) ?v_27)) (not (= (select2 ?h_1 ?o ownerFrame) PeerGroupPlaceholder)) (not (= (AsOwner ?o (select2 ?h_1 ?o ownerRef)) ?o)) (not (forall ((?t Int)) (! (=> (= (AsOwner ?o (select2 ?h_1 ?t ownerRef)) ?o) (or (= ?t ?o) (not (= (select2 ?h_1 ?t ownerFrame) PeerGroupPlaceholder)))) :pattern ((AsOwner ?o (select2 ?h_1 ?t ownerRef))) ))))))) :pattern ((IsHeap ?h_1)) ))) :pattern ((x (typeof ?o) (AsImmutable ?T))) ))) (not (forall ((?s Int)) (! (<= 0 (StringLength ?s)) :pattern ((StringLength ?s)) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (let ((?v_28 (select2 ?h_1 ?o (AsRepField ?f ?T)))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_28 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_28 ownerRef) ?o)) (not (= (select2 ?h_1 ?v_28 ownerFrame) ?T)))))) :pattern ((select2 ?h_1 ?o (AsRepField ?f ?T))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int)) (! (let ((?v_29 (select2 ?h_1 ?o (AsPeerField ?f)))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_29 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_29 ownerRef) (select2 ?h_1 ?o ownerRef))) (not (= (select2 ?h_1 ?v_29 ownerFrame) (select2 ?h_1 ?o ownerFrame))))))) :pattern ((select2 ?h_1 ?o (AsPeerField ?f))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int) (?i Int)) (! (let ((?v_30 (select2 ?h_1 ?o (AsElementsRepField ?f ?T ?i)))) (let ((?v_31 (ElementProxy ?v_30 ?i))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_30 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_31 ownerRef) ?o)) (not (= (select2 ?h_1 ?v_31 ownerFrame) ?T))))))) :pattern ((select2 ?h_1 ?o (AsElementsRepField ?f ?T ?i))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?i Int)) (! (let ((?v_32 (select2 ?h_1 ?o (AsElementsPeerField ?f ?i)))) (let ((?v_33 (ElementProxy ?v_32 ?i))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_32 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_33 ownerRef) (select2 ?h_1 ?o ownerRef))) (not (= (select2 ?h_1 ?v_33 ownerFrame) (select2 ?h_1 ?o ownerFrame)))))))) :pattern ((select2 ?h_1 ?o (AsElementsPeerField ?f ?i))) ))) (not (forall ((?h_1 Int) (?o Int)) (! (let ((?v_36 (typeof ?o)) (?v_34 (select2 ?h_1 ?o ownerFrame)) (?v_35 (select2 ?h_1 ?o ownerRef))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_34 PeerGroupPlaceholder))) (not (= (x (select2 ?h_1 ?v_35 inv) ?v_34) true_1)) (not (not (= (select2 ?h_1 ?v_35 localinv) (BaseClass ?v_34)))))) (not (or (not (= (select2 ?h_1 ?o inv) ?v_36)) (not (= (select2 ?h_1 ?o localinv) ?v_36)))))) :pattern ((x (select2 ?h_1 (select2 ?h_1 ?o ownerRef) inv) (select2 ?h_1 ?o ownerFrame))) ))) (not (forall ((?o Int) (?f Int) (?h_1 Int)) (! (let ((?v_37 (select2 ?h_1 ?o ownerFrame)) (?v_38 (select2 ?h_1 ?o ownerRef))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (= (= (select2 ?h_1 ?o allocated) true_1) true)) (not (= (AsPureObject ?o) ?o)) (not (not (= ?v_37 PeerGroupPlaceholder))) (not (= (x (select2 ?h_1 ?v_38 inv) ?v_37) true_1)) (not (not (= (select2 ?h_1 ?v_38 localinv) (BaseClass ?v_37)))))) (= (select2 ?h_1 ?o ?f) (FieldDependsOnFCO ?o ?f (select2 ?h_1 (select2 ?h_1 ?o FirstConsistentOwner) exposeVersion))))) :pattern ((select2 ?h_1 (AsPureObject ?o) ?f)) ))) (not (forall ((?o Int) (?h_1 Int)) (! (let ((?v_41 (select2 ?h_1 ?o FirstConsistentOwner))) (let ((?v_42 (select2 ?h_1 ?v_41 ownerFrame)) (?v_43 (select2 ?h_1 ?v_41 ownerRef)) (?v_39 (select2 ?h_1 ?o ownerFrame)) (?v_40 (select2 ?h_1 ?o ownerRef))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (= (= (select2 ?h_1 ?o allocated) true_1) true)) (not (not (= ?v_39 PeerGroupPlaceholder))) (not (= (x (select2 ?h_1 ?v_40 inv) ?v_39) true_1)) (not (not (= (select2 ?h_1 ?v_40 localinv) (BaseClass ?v_39)))))) (not (or (not (not (= ?v_41 nullObject))) (not (= (= (select2 ?h_1 ?v_41 allocated) true_1) true)) (not (or (= ?v_42 PeerGroupPlaceholder) (not (= (x (select2 ?h_1 ?v_43 inv) ?v_42) true_1)) (= (select2 ?h_1 ?v_43 localinv) (BaseClass ?v_42))))))))) :pattern ((select2 ?h_1 ?o FirstConsistentOwner)) ))) (not (forall ((?value Int) (?typ Int) (?occurrence Int) (?activity Int)) (! (let ((?v_44 (BoxFunc ?value ?typ ?occurrence ?activity))) (not (or (not (= (Box ?value ?v_44) ?v_44)) (not (= (UnboxedType ?v_44) ?typ))))) :pattern ((BoxFunc ?value ?typ ?occurrence ?activity)) ))) (not (forall ((?x_3 Int) (?typ Int) (?occurrence Int) (?activity Int)) (=> (not (= (IsValueType (UnboxedType ?x_3)) true_1)) (= (BoxFunc ?x_3 ?typ ?occurrence ?activity) ?x_3)))) (not (forall ((?x_3 Int) (?p Int)) (! (= (Unbox (Box ?x_3 ?p)) ?x_3) :pattern ((Unbox (Box ?x_3 ?p))) ))) (not (forall ((?p Int)) (! (=> (= (IsValueType (UnboxedType ?p)) true_1) (forall ((?heap Int) (?x_3 Int)) (! (let ((?v_45 (Box ?x_3 ?p))) (let ((?v_46 (typeof ?v_45))) (=> (= (IsHeap ?heap) true_1) (not (or (not (= (select2 ?heap ?v_45 inv) ?v_46)) (not (= (select2 ?heap ?v_45 localinv) ?v_46))))))) :pattern ((select2 ?heap (Box ?x_3 ?p) inv)) ))) :pattern ((IsValueType (UnboxedType ?p))) ))) (not (forall ((?x_3 Int) (?p Int)) (! (let ((?v_47 (Box ?x_3 ?p))) (=> (not (or (not (= (x (UnboxedType ?v_47) System_Object) true_1)) (not (= ?v_47 ?p)))) (= ?x_3 ?p))) :pattern ((x (UnboxedType (Box ?x_3 ?p)) System_Object)) ))) (not (forall ((?p Int) (?typ Int)) (! (= (= (UnboxedType ?p) ?typ) (not (= (BoxTester ?p ?typ) nullObject))) :pattern ((BoxTester ?p ?typ)) ))) (not (forall ((?p Int) (?typ Int)) (! (=> (not (= (BoxTester ?p ?typ) nullObject)) (= (Box (Unbox ?p) ?p) ?p)) :pattern ((BoxTester ?p ?typ)) ))) (not (= (IsValueType System_SByte) true_1)) (not (= (IsValueType System_Byte) true_1)) (not (= (IsValueType System_Int16) true_1)) (not (= (IsValueType System_UInt16) true_1)) (not (= (IsValueType System_Int32) true_1)) (not (= (IsValueType System_UInt32) true_1)) (not (= (IsValueType System_Int64) true_1)) (not (= (IsValueType System_UInt64) true_1)) (not (= (IsValueType System_Char) true_1)) (not (= (IsValueType System_UIntPtr) true_1)) (not (= (IsValueType System_IntPtr) true_1)) (not (< int_m9223372036854775808 int_m2147483648)) (not (< int_m2147483648 (- 0 100000))) (not (< 100000 int_2147483647)) (not (< int_2147483647 int_4294967295)) (not (< int_4294967295 int_9223372036854775807)) (not (< int_9223372036854775807 int_18446744073709551615)) (not (= (+ int_m9223372036854775808 1) (- 0 int_9223372036854775807))) (not (= (+ int_m2147483648 1) (- 0 int_2147483647))) (not (forall ((?i Int)) (= (= (InRange ?i System_SByte) true_1) (not (or (not (<= (- 0 128) ?i)) (not (< ?i 128))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Byte) true_1) (not (or (not (<= 0 ?i)) (not (< ?i 256))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Int16) true_1) (not (or (not (<= (- 0 32768) ?i)) (not (< ?i 32768))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_UInt16) true_1) (not (or (not (<= 0 ?i)) (not (< ?i 65536))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Int32) true_1) (not (or (not (<= int_m2147483648 ?i)) (not (<= ?i int_2147483647))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_UInt32) true_1) (not (or (not (<= 0 ?i)) (not (<= ?i int_4294967295))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Int64) true_1) (not (or (not (<= int_m9223372036854775808 ?i)) (not (<= ?i int_9223372036854775807))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_UInt64) true_1) (not (or (not (<= 0 ?i)) (not (<= ?i int_18446744073709551615))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Char) true_1) (not (or (not (<= 0 ?i)) (not (< ?i 65536))))))) (not (forall ((?z Int) (?B Int) (?C Int)) (=> (= (InRange ?z ?C) true_1) (= (IntToInt ?z ?B ?C) ?z)))) (not (forall ((?b Int) (?x_3 Int) (?y Int)) (! (=> (= ?b true_1) (= (IfThenElse ?b ?x_3 ?y) ?x_3)) :pattern ((IfThenElse ?b ?x_3 ?y)) ))) (not (forall ((?b Int) (?x_3 Int) (?y Int)) (! (=> (not (= ?b true_1)) (= (IfThenElse ?b ?x_3 ?y) ?y)) :pattern ((IfThenElse ?b ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (= (x_2 ?x_3 ?y) (- ?x_3 (* (x_1 ?x_3 ?y) ?y))) :pattern ((x_2 ?x_3 ?y))  :pattern ((x_1 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_48 (x_2 ?x_3 ?y))) (=> (not (or (not (<= 0 ?x_3)) (not (< 0 ?y)))) (not (or (not (<= 0 ?v_48)) (not (< ?v_48 ?y)))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_49 (x_2 ?x_3 ?y))) (=> (not (or (not (<= 0 ?x_3)) (not (< ?y 0)))) (not (or (not (<= 0 ?v_49)) (not (< ?v_49 (- 0 ?y))))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_50 (x_2 ?x_3 ?y))) (=> (not (or (not (<= ?x_3 0)) (not (< 0 ?y)))) (not (or (not (< (- 0 ?y) ?v_50)) (not (<= ?v_50 0)))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_51 (x_2 ?x_3 ?y))) (=> (not (or (not (<= ?x_3 0)) (not (< ?y 0)))) (not (or (not (< ?y ?v_51)) (not (<= ?v_51 0)))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (=> (not (or (not (<= 0 ?x_3)) (not (<= 0 ?y)))) (= (x_2 (+ ?x_3 ?y) ?y) (x_2 ?x_3 ?y))) :pattern ((x_2 (+ ?x_3 ?y) ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (=> (not (or (not (<= 0 ?x_3)) (not (<= 0 ?y)))) (= (x_2 (+ ?y ?x_3) ?y) (x_2 ?x_3 ?y))) :pattern ((x_2 (+ ?y ?x_3) ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_52 (- ?x_3 ?y))) (=> (not (or (not (<= 0 ?v_52)) (not (<= 0 ?y)))) (= (x_2 ?v_52 ?y) (x_2 ?x_3 ?y)))) :pattern ((x_2 (- ?x_3 ?y) ?y)) ))) (not (forall ((?a Int) (?b Int) (?d Int)) (! (=> (not (or (not (<= 2 ?d)) (not (= (x_2 ?a ?d) (x_2 ?b ?d))) (not (< ?a ?b)))) (<= (+ ?a ?d) ?b)) :pattern ((x_2 ?a ?d) (x_2 ?b ?d)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (=> (or (<= 0 ?x_3) (<= 0 ?y)) (<= 0 (and_1 ?x_3 ?y))) :pattern ((and_1 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_53 (or_1 ?x_3 ?y))) (=> (not (or (not (<= 0 ?x_3)) (not (<= 0 ?y)))) (not (or (not (<= 0 ?v_53)) (not (<= ?v_53 (+ ?x_3 ?y))))))) :pattern ((or_1 ?x_3 ?y)) ))) (not (forall ((?i Int)) (! (= (shl ?i 0) ?i) :pattern ((shl ?i 0)) ))) (not (forall ((?i Int) (?j Int)) (! (=> (<= 1 ?j) (= (shl ?i ?j) (* (shl ?i (- ?j 1)) 2))) :pattern ((shl ?i ?j)) ))) (not (forall ((?i Int) (?j Int)) (! (let ((?v_54 (shl ?i ?j))) (=> (not (or (not (<= 0 ?i)) (not (< ?i 32768)) (not (<= 0 ?j)) (not (<= ?j 16)))) (not (or (not (<= 0 ?v_54)) (not (<= ?v_54 int_2147483647)))))) :pattern ((shl ?i ?j)) ))) (not (forall ((?i Int)) (! (= (shr ?i 0) ?i) :pattern ((shr ?i 0)) ))) (not (forall ((?i Int) (?j Int)) (! (=> (<= 1 ?j) (= (shr ?i ?j) (x_1 (shr ?i (- ?j 1)) 2))) :pattern ((shr ?i ?j)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_55 (min ?x_3 ?y))) (not (or (not (or (= ?v_55 ?x_3) (= ?v_55 ?y))) (not (<= ?v_55 ?x_3)) (not (<= ?v_55 ?y))))) :pattern ((min ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_56 (max ?x_3 ?y))) (not (or (not (or (= ?v_56 ?x_3) (= ?v_56 ?y))) (not (<= ?x_3 ?v_56)) (not (<= ?y ?v_56))))) :pattern ((max ?x_3 ?y)) ))) (not (forall ((?h_1 Int) (?a Int) (?b Int)) (! (= (= (System_String_Equals_System_String ?h_1 ?a ?b) true_1) (= (System_String_Equals_System_String_System_String ?h_1 ?a ?b) true_1)) :pattern ((System_String_Equals_System_String ?h_1 ?a ?b)) ))) (not (forall ((?h_1 Int) (?a Int) (?b Int)) (! (let ((?v_58 (= (StringEquals ?a ?b) true_1)) (?v_57 (= (System_String_Equals_System_String_System_String ?h_1 ?a ?b) true_1))) (not (or (not (= ?v_57 ?v_58)) (not (= ?v_57 (= (StringEquals ?b ?a) true_1))) (not (=> (= ?a ?b) ?v_58))))) :pattern ((System_String_Equals_System_String_System_String ?h_1 ?a ?b)) ))) (not (forall ((?a Int) (?b Int) (?c Int)) (=> (not (or (not (= (StringEquals ?a ?b) true_1)) (not (= (StringEquals ?b ?c) true_1)))) (= (StringEquals ?a ?c) true_1)))) (not (forall ((?h_1 Int) (?a Int) (?b Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (not (= ?b nullObject))) (not (= (System_String_Equals_System_String_System_String ?h_1 ?a ?b) true_1)))) (= (System_String_IsInterned_System_String_notnull ?h_1 ?a) (System_String_IsInterned_System_String_notnull ?h_1 ?b))) :pattern ((System_String_Equals_System_String_System_String ?h_1 ?a ?b)) ))) (not (not (= (IsStaticField Node_small) true_1))) (not (= (IncludeInMainFrameCondition Node_small) true_1)) (not (= (IncludedInModifiesStar Node_small) true_1)) (not (= (DeclType Node_small) Node)) (not (= (AsRangeField Node_small System_Int32) Node_small)) (not (not (= (IsStaticField Node_data) true_1))) (not (= (IncludeInMainFrameCondition Node_data) true_1)) (not (= (IncludedInModifiesStar Node_data) true_1)) (not (= (DeclType Node_data) Node)) (not (= (AsRangeField Node_data System_Int32) Node_data)) (not (not (= (IsStaticField Node_large) true_1))) (not (= (IncludeInMainFrameCondition Node_large) true_1)) (not (= (IncludedInModifiesStar Node_large) true_1)) (not (= (DeclType Node_large) Node)) (not (= (AsRangeField Node_large System_Int32) Node_large)) (not (not (= (IsStaticField Node_left) true_1))) (not (= (IncludeInMainFrameCondition Node_left) true_1)) (not (= (IncludedInModifiesStar Node_left) true_1)) (not (= (AsRepField Node_left Node) Node_left)) (not (= (DeclType Node_left) Node)) (not (= (AsRefField Node_left Node) Node_left)) (not (not (= (IsStaticField Node_right) true_1))) (not (= (IncludeInMainFrameCondition Node_right) true_1)) (not (= (IncludedInModifiesStar Node_right) true_1)) (not (= (AsRepField Node_right Node) Node_right)) (not (= (DeclType Node_right) Node)) (not (= (AsRefField Node_right Node) Node_right)) (not (not (= (IsStaticField Node_parent) true_1))) (not (= (IncludeInMainFrameCondition Node_parent) true_1)) (not (= (IncludedInModifiesStar Node_parent) true_1)) (not (= (DeclType Node_parent) Node)) (not (= (AsRefField Node_parent Node) Node_parent)) (not (= (x Node Node) true_1)) (not (= ?v_0 System_Object)) (not (= (AsDirectSubClass Node ?v_0) Node)) (not (not (= (IsImmutable Node) true_1))) (not (= (AsMutable Node) Node)) (not (forall ((?oi Int) (?h Int)) (! (let ((?v_61 (select2 ?h ?oi Node_left))) (let ((?v_62 (= ?v_61 nullObject))) (let ((?v_67 (not ?v_62)) (?v_64 (select2 ?h ?oi Node_right))) (let ((?v_65 (= ?v_64 nullObject))) (let ((?v_66 (not ?v_65)) (?v_59 (select2 ?h ?oi Node_data)) (?v_63 (select2 ?h ?oi Node_large)) (?v_60 (select2 ?h ?oi Node_small))) (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) Node) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_0))))) (not (or (not (<= ?v_60 ?v_59)) (not (<= ?v_59 ?v_63)) (not (=> ?v_67 (not (or (not (= ?v_60 (select2 ?h ?v_61 Node_small))) (not (<= (select2 ?h ?v_61 Node_large) ?v_59)))))) (not (=> ?v_62 (= ?v_60 ?v_59))) (not (=> ?v_66 (not (or (not (= ?v_63 (select2 ?h ?v_64 Node_large))) (not (<= ?v_59 (select2 ?h ?v_64 Node_small))))))) (not (=> ?v_65 (= ?v_63 ?v_59))) (not (or ?v_65 (not (= ?v_61 ?v_64)))) (not (=> ?v_66 (= (select2 ?h ?v_64 Node_parent) ?oi))) (not (=> ?v_67 (= (select2 ?h ?v_61 Node_parent) ?oi))))))))))) :pattern ((x (select2 ?h ?oi inv) Node)) ))) (not (= (x Microsoft_Contracts_ObjectInvariantException Microsoft_Contracts_ObjectInvariantException) true_1)) (not (= (x Microsoft_Contracts_GuardException Microsoft_Contracts_GuardException) true_1)) (not (= (x System_Exception System_Exception) true_1)) (not (= ?v_1 System_Object)) (not (= (AsDirectSubClass System_Exception ?v_1) System_Exception)) (not (not (= (IsImmutable System_Exception) true_1))) (not (= (AsMutable System_Exception) System_Exception)) (not (= (x System_Runtime_Serialization_ISerializable System_Runtime_Serialization_ISerializable) true_1)) (not (= (x System_Runtime_Serialization_ISerializable System_Object) true_1)) (not (= (IsMemberlessType System_Runtime_Serialization_ISerializable) true_1)) (not (= (AsInterface System_Runtime_Serialization_ISerializable) System_Runtime_Serialization_ISerializable)) (not (= (x System_Exception System_Runtime_Serialization_ISerializable) true_1)) (not (= (x System_Runtime_InteropServices__Exception System_Runtime_InteropServices__Exception) true_1)) (not (= (x System_Runtime_InteropServices__Exception System_Object) true_1)) (not (= (IsMemberlessType System_Runtime_InteropServices__Exception) true_1)) (not (= (AsInterface System_Runtime_InteropServices__Exception) System_Runtime_InteropServices__Exception)) (not (= (x System_Exception System_Runtime_InteropServices__Exception) true_1)) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) System_Exception) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_1))))) true) :pattern ((x (select2 ?h ?oi inv) System_Exception)) ))) (not (= ?v_2 System_Exception)) (not (= (AsDirectSubClass Microsoft_Contracts_GuardException ?v_2) Microsoft_Contracts_GuardException)) (not (not (= (IsImmutable Microsoft_Contracts_GuardException) true_1))) (not (= (AsMutable Microsoft_Contracts_GuardException) Microsoft_Contracts_GuardException)) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) Microsoft_Contracts_GuardException) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_2))))) true) :pattern ((x (select2 ?h ?oi inv) Microsoft_Contracts_GuardException)) ))) (not (= ?v_3 Microsoft_Contracts_GuardException)) (not (= (AsDirectSubClass Microsoft_Contracts_ObjectInvariantException ?v_3) Microsoft_Contracts_ObjectInvariantException)) (not (not (= (IsImmutable Microsoft_Contracts_ObjectInvariantException) true_1))) (not (= (AsMutable Microsoft_Contracts_ObjectInvariantException) Microsoft_Contracts_ObjectInvariantException)) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) Microsoft_Contracts_ObjectInvariantException) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_3))))) true) :pattern ((x (select2 ?h ?oi inv) Microsoft_Contracts_ObjectInvariantException)) ))) (not (= (x System_Type System_Type) true_1)) (not (= (x System_Reflection_MemberInfo System_Reflection_MemberInfo) true_1)) (not (= ?v_4 System_Object)) (not (= (AsDirectSubClass System_Reflection_MemberInfo ?v_4) System_Reflection_MemberInfo)) (not (= (IsImmutable System_Reflection_MemberInfo) true_1)) (not (= (AsImmutable System_Reflection_MemberInfo) System_Reflection_MemberInfo)) (not (= (x System_Reflection_ICustomAttributeProvider System_Reflection_ICustomAttributeProvider) true_1)) (not (= (x System_Reflection_ICustomAttributeProvider System_Object) true_1)) (not (= (IsMemberlessType System_Reflection_ICustomAttributeProvider) true_1)) (not (= (AsInterface System_Reflection_ICustomAttributeProvider) System_Reflection_ICustomAttributeProvider)) (not (= (x System_Reflection_MemberInfo System_Reflection_ICustomAttributeProvider) true_1)) (not (= (x System_Runtime_InteropServices__MemberInfo System_Runtime_InteropServices__MemberInfo) true_1)) (not (= (x System_Runtime_InteropServices__MemberInfo System_Object) true_1)) (not (= (IsMemberlessType System_Runtime_InteropServices__MemberInfo) true_1)) (not (= (AsInterface System_Runtime_InteropServices__MemberInfo) System_Runtime_InteropServices__MemberInfo)) (not (= (x System_Reflection_MemberInfo System_Runtime_InteropServices__MemberInfo) true_1)) (not (= (IsMemberlessType System_Reflection_MemberInfo) true_1)) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) System_Reflection_MemberInfo) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_4))))) true) :pattern ((x (select2 ?h ?oi inv) System_Reflection_MemberInfo)) ))) (not (= ?v_5 System_Reflection_MemberInfo)) (not (= (AsDirectSubClass System_Type ?v_5) System_Type)) (not (= (IsImmutable System_Type) true_1)) (not (= (AsImmutable System_Type) System_Type)) (not (= (x System_Runtime_InteropServices__Type System_Runtime_InteropServices__Type) true_1)) (not (= (x System_Runtime_InteropServices__Type System_Object) true_1)) (not (= (IsMemberlessType System_Runtime_InteropServices__Type) true_1)) (not (= (AsInterface System_Runtime_InteropServices__Type) System_Runtime_InteropServices__Type)) (not (= (x System_Type System_Runtime_InteropServices__Type) true_1)) (not (= (x System_Reflection_IReflect System_Reflection_IReflect) true_1)) (not (= (x System_Reflection_IReflect System_Object) true_1)) (not (= (IsMemberlessType System_Reflection_IReflect) true_1)) (not (= (AsInterface System_Reflection_IReflect) System_Reflection_IReflect)) (not (= (x System_Type System_Reflection_IReflect) true_1)) (not (= (IsMemberlessType System_Type) true_1)) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) System_Type) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_5))))) true) :pattern ((x (select2 ?h ?oi inv) System_Type)) ))) (not (= (x Microsoft_Contracts_ICheckedException Microsoft_Contracts_ICheckedException) true_1)) (not (= (x Microsoft_Contracts_ICheckedException System_Object) true_1)) (not (= (IsMemberlessType Microsoft_Contracts_ICheckedException) true_1)) (not (= (AsInterface Microsoft_Contracts_ICheckedException) Microsoft_Contracts_ICheckedException))))))
(assert (let ((?v_51 (BaseClass Node)) (?v_9 (= return_value_0 nullObject)) (?v_12 (= return_value_0 this))) (let ((?v_19 (or ?v_12 ?v_9)) (?v_17 (select2 Heap this Node_large)) (?v_16 (select2 Heap_51 this Node_small)) (?v_15 (select2 Heap this Node_small))) (let ((?v_18 (=> ?v_12 (not (or (not (<= ?v_15 ?v_16)) (not (<= ?v_16 ?v_17)))))) (?v_13 (select2 Heap_51 this Node_large))) (let ((?v_14 (=> ?v_12 (not (or (not (<= ?v_15 ?v_13)) (not (<= ?v_13 ?v_17)))))) (?v_11 (= (select2 Heap_51 this Node_parent) (select2 Heap this Node_parent))) (?v_6 (select2 Heap_51 return_value_0 ownerFrame)) (?v_7 (select2 Heap_51 return_value_0 ownerRef))) (let ((?v_10 (or ?v_9 (forall ((?pc Int)) (! (let ((?v_497 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap_51 ?pc allocated) true_1)) (not (= (select2 Heap_51 ?pc ownerRef) ?v_7)) (not (= (select2 Heap_51 ?pc ownerFrame) ?v_6)))) (not (or (not (= (select2 Heap_51 ?pc inv) ?v_497)) (not (= (select2 Heap_51 ?pc localinv) ?v_497)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap_51 ?pc localinv))  :pattern ((select2 Heap_51 ?pc inv))  :pattern ((select2 Heap_51 ?pc ownerFrame))  :pattern ((select2 Heap_51 ?pc ownerRef)) )))) (?v_8 (or ?v_9 (= ?v_6 PeerGroupPlaceholder) (not (= (x (select2 Heap_51 ?v_7 inv) ?v_6) true_1)) (= (select2 Heap_51 ?v_7 localinv) (BaseClass ?v_6)))) (?v_108 (typeof this))) (let ((?v_5 (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_500 (not (= ?o_1 this))) (?v_498 (select2 Heap ?o_1 ownerFrame)) (?v_499 (select2 Heap ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap ?o_1 allocated) true_1)) (not (or (= ?v_498 PeerGroupPlaceholder) (not (= (x (select2 Heap ?v_499 inv) ?v_498) true_1)) (= (select2 Heap ?v_499 localinv) (BaseClass ?v_498)))) (not (or ?v_500 (not (= (x ?v_108 (DeclType ?f_1)) true_1)) (not (= (IncludedInModifiesStar ?f_1) true_1)))) (not (or ?v_500 (not (= ?f_1 exposeVersion)))))) (= (select2 Heap ?o_1 ?f_1) (select2 Heap_51 ?o_1 ?f_1)))) :pattern ((select2 Heap_51 ?o_1 ?f_1)) )))) (let ((?v_222 (=> true (=> true (=> true (=> true (not (or (not ?v_5) (not (=> ?v_5 (not (or (not ?v_8) (not (=> ?v_8 (not (or (not ?v_10) (not (=> ?v_10 (not (or (not ?v_11) (not (=> ?v_11 (not (or (not ?v_14) (not (=> ?v_14 (not (or (not ?v_18) (not (=> ?v_18 (not (or (not ?v_19) (not (=> ?v_19 true)))))))))))))))))))))))))))))))))) (let ((?v_212 (=> true (=> true (=> true (=> true (=> (= local17_2 local17_1) (=> (= local7_2 local7_1) (=> (= stack1s_7 stack1s_6) (=> (= temp12_3 temp12_2) (=> (= stack1o_26 stack1o_25) (=> (= temp14_3 temp14_2) (=> (= stack0s_11 stack0s_10) (=> ?v_12 (=> (= temp5_3 temp5_2) (=> (= local10_2 local10_1) (=> (= temp8_2 temp8_1) (=> (= temp6_3 temp6_2) (=> (= temp0_2 temp0_1) (=> (= temp7_3 temp7_2) (=> (= stack0i_7 stack0i_6) (=> (= local14_1 local14_0) (=> (= temp4_2 temp4_1) (=> (= temp10_3 temp10_2) (=> (= temp18_3 temp18_2) (=> (= temp3_2 temp3_1) (=> (= stack0o_22 stack0o_21) (=> (= ActivityIndicator_7 ActivityIndicator_6) (=> (= temp1_3 temp1_2) (=> (= temp17_3 temp17_2) (=> (= stack1i_23 stack1i_22) (=> (= temp11_3 temp11_2) (=> (= temp19_3 temp19_2) (=> (= temp13_3 temp13_2) (=> (= temp2_1 temp2_0) (=> (= temp16_3 temp16_2) (=> (= stack2o_3 stack2o_2) (=> (= Heap_51 Heap_50) (=> (= temp15_2 temp15_1) (=> (= temp9_2 temp9_1) ?v_222)))))))))))))))))))))))))))))))))))))))) (let ((?v_357 (=> (= temp9_1 temp9) ?v_212)) (?v_356 (= temp15_1 temp15)) (?v_355 (= temp2_0 temp2)) (?v_354 (= temp13_2 temp13)) (?v_353 (= temp17_2 temp17)) (?v_352 (= temp3_1 temp3)) (?v_351 (= temp10_2 temp10)) (?v_350 (= temp8_1 temp8)) (?v_349 (= local14_0 local14)) (?v_348 (= local17_1 local17))) (let ((?v_490 (=> true (=> true (=> true (=> true (=> ?v_348 (=> (= local7_1 local7_0) (=> (= stack1s_6 stack1s_4) (=> (= temp12_2 temp12_1) (=> (= stack1o_25 stack1o_23) (=> (= temp14_2 temp14_1) (=> (= stack0s_10 stack0s_7) (=> ?v_349 (=> (= temp19_2 temp19_1) (=> (= temp5_2 temp5_1) (=> (= local10_1 local10_0) (=> ?v_350 (=> (= temp6_2 temp6_1) (=> (= temp0_1 temp0_0) (=> (= temp7_2 temp7_1) (=> (= stack0i_6 stack0i_5) (=> (= temp1_2 temp1_1) (=> (= temp4_1 temp4_0) (=> ?v_351 (=> (= temp18_2 temp18_1) (=> ?v_352 (=> (= stack0o_21 stack0o_18) (=> (= ActivityIndicator_6 ActivityIndicator_4) (=> ?v_353 (=> (= stack1i_22 stack1i_20) (=> (= temp11_2 temp11_1) (=> ?v_354 (=> ?v_355 (=> (= temp16_2 temp16_1) (=> (= stack2o_2 stack2o_0) (=> (= Heap_50 Heap_47) (=> ?v_356 ?v_357))))))))))))))))))))))))))))))))))))) (?v_489 (= stack2o_0 nullObject))) (let ((?v_492 (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> (= stack1o_23 stack1o_6) (=> (= temp19_1 temp19) (=> (= temp16_1 temp16) (=> (= temp1_1 temp1_0) (=> (= temp12_1 temp12) (=> (= temp5_1 temp5) (=> (= stack0o_18 stack0o_17) (=> (= temp14_1 temp14_0) (=> (= local10_0 local10) (=> (= temp6_1 temp6_0) (=> (= local7_0 nullObject) (=> (= Heap_47 Heap_46) (=> ?v_489 (=> (= stack0s_7 stack0s_6) (=> (= stack1i_20 stack1i_6) (=> (= ActivityIndicator_4 ActivityIndicator_0) (=> (= stack0i_5 stack0i_2) (=> (= temp7_1 temp7_0) (=> (= temp4_0 temp4) (=> (= stack1s_4 stack1s_0) (=> (= temp0_0 this) (=> (= temp11_1 temp11) (=> (= temp18_1 temp18_0) ?v_490))))))))))))))))))))))))))))))) (?v_112 (= (As nullObject Microsoft_Contracts_ICheckedException) nullObject)) (?v_488 (forall ((?p_1 Int)) (let ((?v_501 (typeof ?p_1))) (=> (not (or (not (not (= ?p_1 nullObject))) (not (= (select2 Heap_11 ?p_1 allocated) true_1)) (not (= (select2 Heap_11 ?p_1 ownerRef) this)) (not (= (select2 Heap_11 ?p_1 ownerFrame) Node)))) (not (or (not (= (select2 Heap_11 ?p_1 inv) ?v_501)) (not (= (select2 Heap_11 ?p_1 localinv) ?v_501)))))))) (?v_462 (select2 Heap_11 this Node_left))) (let ((?v_464 (= ?v_462 nullObject))) (let ((?v_474 (not ?v_464))) (let ((?v_487 (=> ?v_474 (= (select2 Heap_11 ?v_462 Node_parent) this))) (?v_467 (select2 Heap_11 this Node_right))) (let ((?v_469 (= ?v_467 nullObject))) (let ((?v_472 (not ?v_469))) (let ((?v_486 (=> ?v_472 (= (select2 Heap_11 ?v_467 Node_parent) this))) (?v_484 (not (= ?v_462 ?v_467)))) (let ((?v_485 (or ?v_469 ?v_484)) (?v_459 (select2 Heap_11 this Node_data)) (?v_466 (select2 Heap_11 this Node_large))) (let ((?v_483 (=> ?v_469 (= ?v_466 ?v_459))) (?v_482 (=> ?v_472 (not (or (not (= ?v_466 (select2 Heap_11 ?v_467 Node_large))) (not (<= ?v_459 (select2 Heap_11 ?v_467 Node_small))))))) (?v_461 (select2 Heap_11 this Node_small))) (let ((?v_481 (=> ?v_464 (= ?v_461 ?v_459))) (?v_480 (=> ?v_474 (not (or (not (= ?v_461 (select2 Heap_11 ?v_462 Node_small))) (not (<= (select2 Heap_11 ?v_462 Node_large) ?v_459)))))) (?v_479 (<= ?v_459 ?v_466)) (?v_478 (<= ?v_461 ?v_459)) (?v_476 (select2 Heap_11 this localinv))) (let ((?v_477 (= ?v_476 System_Object)) (?v_2 (not (= this nullObject)))) (let ((?v_3 (not ?v_2)) (?v_94 (TypeObject Node))) (let ((?v_491 (=> true (=> true (=> true (=> (= (IsTokenForType stack0s_0 Node) true_1) (=> (= stack0o_6 ?v_94) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_477) (not (=> ?v_477 (not (or (not ?v_478) (not (=> ?v_478 (not (or (not ?v_479) (not (=> ?v_479 (not (or (not ?v_480) (not (=> ?v_480 (not (or (not ?v_481) (not (=> ?v_481 (not (or (not ?v_482) (not (=> ?v_482 (not (or (not ?v_483) (not (=> ?v_483 (not (or (not ?v_485) (not (=> ?v_485 (not (or (not ?v_486) (not (=> ?v_486 (not (or (not ?v_487) (not (=> ?v_487 (not (or (not ?v_488) (not (=> ?v_488 (=> (= Heap_20 (store2 Heap_11 this localinv ?v_108)) (=> (= (IsHeap Heap_20) true_1) (=> true (=> true (=> (= stack0o_17 stack0o_6) (=> (= Heap_46 Heap_20) (=> (= stack0s_6 stack0s_0) ?v_492))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_214 (not ?v_112)) (?v_110 (= nullObject nullObject))) (let ((?v_213 (not ?v_110)) (?v_458 (not (not (or (not (= (x (select2 Heap_11 this inv) Node) true_1)) (not (not (= ?v_476 ?v_51)))))))) (let ((?v_475 (or ?v_458 ?v_487)) (?v_473 (or ?v_458 ?v_486)) (?v_471 (or ?v_458 ?v_469 ?v_484)) (?v_470 (or ?v_458 ?v_483)) (?v_468 (or ?v_458 ?v_482)) (?v_465 (or ?v_458 ?v_481)) (?v_463 (or ?v_458 ?v_480)) (?v_460 (or ?v_458 ?v_479)) (?v_457 (or ?v_458 ?v_478)) (?v_454 (select2 Heap_9 this ownerFrame)) (?v_455 (select2 Heap_9 this ownerRef))) (let ((?v_456 (or (= ?v_454 PeerGroupPlaceholder) (not (= (x (select2 Heap_9 ?v_455 inv) ?v_454) true_1)) (= (select2 Heap_9 ?v_455 localinv) (BaseClass ?v_454))))) (let ((?v_494 (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_456) (not (=> ?v_456 (=> (= Heap_10 (store2 Heap_9 this exposeVersion temp18_0)) (=> (= Heap_11 (store2 Heap_10 this Node_large stack1i_6)) (not (or (not ?v_457) (not (=> ?v_457 (not (or (not ?v_460) (not (=> ?v_460 (not (or (not ?v_463) (not (=> ?v_463 (not (or (not ?v_465) (not (=> ?v_465 (not (or (not ?v_468) (not (=> ?v_468 (not (or (not ?v_470) (not (=> ?v_470 (not (or (not ?v_471) (not (=> ?v_471 (not (or (not ?v_473) (not (=> ?v_473 (not (or (not ?v_475) (not (=> ?v_475 (=> (= (IsHeap Heap_11) true_1) (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> ?v_110 ?v_491)))) (not (=> true (=> true (=> ?v_213 (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> ?v_214 ?v_491)))) (not (=> true (=> true (=> ?v_112 (=> true (=> true (=> true (=> true (=> true (=> (= stack0o_17 nullObject) (=> (= Heap_46 Heap_11) (=> (= stack0s_6 stack0s) ?v_492)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_436 (select2 Heap_9 this Node_data)) (?v_493 (= stack1o_4 nullObject)) (?v_453 (not (= stack1o_5 nullObject))) (?v_444 (select2 Heap_9 this Node_right)) (?v_439 (select2 Heap_9 this Node_left))) (let ((?v_441 (= ?v_439 nullObject))) (let ((?v_451 (not ?v_441)) (?v_435 (not (not (or (not (= (x (select2 Heap_9 this inv) Node) true_1)) (not (not (= (select2 Heap_9 this localinv) ?v_51)))))))) (let ((?v_452 (or ?v_435 (=> ?v_451 (= (select2 Heap_9 ?v_439 Node_parent) this)))) (?v_446 (= ?v_444 nullObject))) (let ((?v_449 (not ?v_446))) (let ((?v_450 (or ?v_435 (=> ?v_449 (= (select2 Heap_9 ?v_444 Node_parent) this)))) (?v_448 (or ?v_435 ?v_446 (not (= ?v_439 ?v_444)))) (?v_443 (select2 Heap_9 this Node_large))) (let ((?v_447 (or ?v_435 (=> ?v_446 (= ?v_443 ?v_436)))) (?v_445 (or ?v_435 (=> ?v_449 (not (or (not (= ?v_443 (select2 Heap_9 ?v_444 Node_large))) (not (<= ?v_436 (select2 Heap_9 ?v_444 Node_small)))))))) (?v_438 (select2 Heap_9 this Node_small))) (let ((?v_442 (or ?v_435 (=> ?v_441 (= ?v_438 ?v_436)))) (?v_440 (or ?v_435 (=> ?v_451 (not (or (not (= ?v_438 (select2 Heap_9 ?v_439 Node_small))) (not (<= (select2 Heap_9 ?v_439 Node_large) ?v_436))))))) (?v_437 (or ?v_435 (<= ?v_436 ?v_443))) (?v_434 (or ?v_435 (<= ?v_438 ?v_436))) (?v_431 (select2 Heap_7 this ownerFrame)) (?v_432 (select2 Heap_7 this ownerRef))) (let ((?v_433 (or (= ?v_431 PeerGroupPlaceholder) (not (= (x (select2 Heap_7 ?v_432 inv) ?v_431) true_1)) (= (select2 Heap_7 ?v_432 localinv) (BaseClass ?v_431))))) (let ((?v_496 (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_433) (not (=> ?v_433 (=> (= Heap_8 (store2 Heap_7 this exposeVersion temp14_0)) (=> (= Heap_9 (store2 Heap_8 this Node_small stack1i_3)) (not (or (not ?v_434) (not (=> ?v_434 (not (or (not ?v_437) (not (=> ?v_437 (not (or (not ?v_440) (not (=> ?v_440 (not (or (not ?v_442) (not (=> ?v_442 (not (or (not ?v_445) (not (=> ?v_445 (not (or (not ?v_447) (not (=> ?v_447 (not (or (not ?v_448) (not (=> ?v_448 (not (or (not ?v_450) (not (=> ?v_450 (not (or (not ?v_452) (not (=> ?v_452 (=> (= (IsHeap Heap_9) true_1) (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_4 ?v_444) (=> true (not (or (not (=> true (=> true (=> (not ?v_493) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_5 ?v_444) (not (or (not ?v_453) (not (=> ?v_453 (=> (= stack1i_4 (select2 Heap_9 stack1o_5 Node_large)) (=> true (=> true (=> (= stack1i_6 stack1i_4) (=> (= stack1o_6 stack1o_5) ?v_494))))))))))))))))))))) (not (=> true (=> true (=> ?v_493 (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1i_5 ?v_436) (=> true (=> true (=> (= stack1i_6 stack1i_5) (=> (= stack1o_6 stack1o_4) ?v_494)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_413 (select2 Heap_7 this Node_data)) (?v_495 (= stack1o_1 nullObject)) (?v_430 (not (= stack1o_2 nullObject))) (?v_416 (select2 Heap_7 this Node_left))) (let ((?v_418 (= ?v_416 nullObject))) (let ((?v_428 (not ?v_418)) (?v_412 (not (not (or (not (= (x (select2 Heap_7 this inv) Node) true_1)) (not (not (= (select2 Heap_7 this localinv) ?v_51)))))))) (let ((?v_429 (or ?v_412 (=> ?v_428 (= (select2 Heap_7 ?v_416 Node_parent) this)))) (?v_421 (select2 Heap_7 this Node_right))) (let ((?v_423 (= ?v_421 nullObject))) (let ((?v_426 (not ?v_423))) (let ((?v_427 (or ?v_412 (=> ?v_426 (= (select2 Heap_7 ?v_421 Node_parent) this)))) (?v_425 (or ?v_412 ?v_423 (not (= ?v_416 ?v_421)))) (?v_420 (select2 Heap_7 this Node_large))) (let ((?v_424 (or ?v_412 (=> ?v_423 (= ?v_420 ?v_413)))) (?v_422 (or ?v_412 (=> ?v_426 (not (or (not (= ?v_420 (select2 Heap_7 ?v_421 Node_large))) (not (<= ?v_413 (select2 Heap_7 ?v_421 Node_small)))))))) (?v_415 (select2 Heap_7 this Node_small))) (let ((?v_419 (or ?v_412 (=> ?v_418 (= ?v_415 ?v_413)))) (?v_417 (or ?v_412 (=> ?v_428 (not (or (not (= ?v_415 (select2 Heap_7 ?v_416 Node_small))) (not (<= (select2 Heap_7 ?v_416 Node_large) ?v_413))))))) (?v_414 (or ?v_412 (<= ?v_413 ?v_420))) (?v_411 (or ?v_412 (<= ?v_415 ?v_413))) (?v_399 (select2 Heap_4 call14516formal__result_0 ownerFrame)) (?v_400 (select2 Heap_4 call14516formal__result_0 ownerRef)) (?v_398 (= call14516formal__result_0 nullObject))) (let ((?v_410 (not ?v_398)) (?v_401 (select2 Heap_4 this ownerFrame)) (?v_402 (select2 Heap_4 this ownerRef)) (?v_404 (= ?v_399 PeerGroupPlaceholder))) (let ((?v_408 (not (or (not ?v_410) (not ?v_404) (not (= (x (select2 Heap_4 this inv) Node) true_1)) (not (not (= (select2 Heap_4 this localinv) ?v_51))))))) (let ((?v_409 (=> ?v_408 (or (not (= ?v_402 ?v_400)) (not (= ?v_401 ?v_399))))) (?v_406 (forall ((?pc Int)) (! (let ((?v_502 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap_4 ?pc allocated) true_1)) (not (= (select2 Heap_4 ?pc ownerRef) ?v_400)) (not (= (select2 Heap_4 ?pc ownerFrame) ?v_399)))) (not (or (not (= (select2 Heap_4 ?pc inv) ?v_502)) (not (= (select2 Heap_4 ?pc localinv) ?v_502)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap_4 ?pc localinv))  :pattern ((select2 Heap_4 ?pc inv))  :pattern ((select2 Heap_4 ?pc ownerFrame))  :pattern ((select2 Heap_4 ?pc ownerRef)) )))) (let ((?v_407 (=> ?v_408 ?v_406)) (?v_405 (or ?v_398 (not (or (not (= ?v_400 this)) (not (= ?v_399 Node)))) ?v_404)) (?v_403 (or (= ?v_401 PeerGroupPlaceholder) (not (= (x (select2 Heap_4 ?v_402 inv) ?v_401) true_1)) (= (select2 Heap_4 ?v_402 localinv) (BaseClass ?v_401)))) (?v_397 (select2 Heap_3 stack0o_3 Node_large)) (?v_396 (select2 Heap_4 stack0o_3 Node_large)) (?v_395 (select2 Heap_3 stack0o_3 Node_small)) (?v_393 (= call14516formal__result_0 stack0o_3)) (?v_394 (select2 Heap_4 stack0o_3 Node_small)) (?v_390 (select2 Heap_3 stack0o_3 ownerFrame)) (?v_391 (select2 Heap_3 stack0o_3 ownerRef))) (let ((?v_392 (or (= ?v_390 PeerGroupPlaceholder) (not (= (x (select2 Heap_3 ?v_391 inv) ?v_390) true_1)) (= (select2 Heap_3 ?v_391 localinv) (BaseClass ?v_390)))) (?v_389 (forall ((?pc Int)) (! (let ((?v_503 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap_3 ?pc allocated) true_1)) (not (= (select2 Heap_3 ?pc ownerRef) ?v_391)) (not (= (select2 Heap_3 ?pc ownerFrame) ?v_390)))) (not (or (not (= (select2 Heap_3 ?pc inv) ?v_503)) (not (= (select2 Heap_3 ?pc localinv) ?v_503)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap_3 ?pc localinv))  :pattern ((select2 Heap_3 ?pc inv))  :pattern ((select2 Heap_3 ?pc ownerFrame))  :pattern ((select2 Heap_3 ?pc ownerRef)) ))) (?v_388 (not (= stack0o_3 nullObject))) (?v_371 (select2 Heap_3 this Node_data)) (?v_374 (select2 Heap_3 this Node_left))) (let ((?v_376 (= ?v_374 nullObject))) (let ((?v_386 (not ?v_376)) (?v_370 (not (not (or (not (= (x (select2 Heap_3 this inv) Node) true_1)) (not (not (= (select2 Heap_3 this localinv) ?v_51)))))))) (let ((?v_387 (or ?v_370 (=> ?v_386 (= (select2 Heap_3 ?v_374 Node_parent) this)))) (?v_379 (select2 Heap_3 this Node_right))) (let ((?v_381 (= ?v_379 nullObject))) (let ((?v_384 (not ?v_381))) (let ((?v_385 (or ?v_370 (=> ?v_384 (= (select2 Heap_3 ?v_379 Node_parent) this)))) (?v_383 (or ?v_370 ?v_381 (not (= ?v_374 ?v_379)))) (?v_378 (select2 Heap_3 this Node_large))) (let ((?v_382 (or ?v_370 (=> ?v_381 (= ?v_378 ?v_371)))) (?v_380 (or ?v_370 (=> ?v_384 (not (or (not (= ?v_378 (select2 Heap_3 ?v_379 Node_large))) (not (<= ?v_371 (select2 Heap_3 ?v_379 Node_small)))))))) (?v_373 (select2 Heap_3 this Node_small))) (let ((?v_377 (or ?v_370 (=> ?v_376 (= ?v_373 ?v_371)))) (?v_375 (or ?v_370 (=> ?v_386 (not (or (not (= ?v_373 (select2 Heap_3 ?v_374 Node_small))) (not (<= (select2 Heap_3 ?v_374 Node_large) ?v_371))))))) (?v_372 (or ?v_370 (<= ?v_371 ?v_378))) (?v_369 (or ?v_370 (<= ?v_373 ?v_371))) (?v_366 (select2 Heap_1 this ownerFrame)) (?v_367 (select2 Heap_1 this ownerRef))) (let ((?v_368 (or (= ?v_366 PeerGroupPlaceholder) (not (= (x (select2 Heap_1 ?v_367 inv) ?v_366) true_1)) (= (select2 Heap_1 ?v_367 localinv) (BaseClass ?v_366)))) (?v_365 (not (= stack0o_2 nullObject))) (?v_119 (store2 Heap this localinv System_Object)) (?v_0 (select2 Heap this ownerFrame)) (?v_1 (select2 Heap this ownerRef))) (let ((?v_26 (or (= ?v_0 PeerGroupPlaceholder) (not (= (x (select2 Heap ?v_1 inv) ?v_0) true_1)) (= (select2 Heap ?v_1 localinv) (BaseClass ?v_0))))) (let ((?v_27 (not (or (not ?v_26) (not (= (x (select2 Heap this inv) Node) true_1)) (not (= (select2 Heap this localinv) ?v_108)))))) (let ((?v_118 (not ?v_27)) (?v_364 (= stack0o_0 nullObject)) (?v_359 (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> (= stack1o_23 stack1o_13) (=> (= temp19_1 temp19_0) (=> (= temp16_1 temp16_0) (=> (= temp1_1 temp1) (=> (= temp12_1 temp12_0) (=> (= temp5_1 temp5_0) (=> (= stack0o_18 stack0o_8) (=> (= temp14_1 temp14) (=> (= local10_0 nullObject) (=> (= temp6_1 temp6) (=> (= local7_0 local7) (=> (= Heap_47 Heap_26) (=> ?v_489 (=> (= stack0s_7 stack0s_2) (=> (= stack1i_20 stack1i_13) (=> (= ActivityIndicator_4 ActivityIndicator_1) (=> (= stack0i_5 stack0i_3) (=> (= temp7_1 temp7) (=> (= temp4_0 this) (=> (= stack1s_4 stack1s_1) (=> (= temp0_0 temp0) (=> (= temp11_1 temp11_0) (=> (= temp18_1 temp18) ?v_490))))))))))))))))))))))))))))))) (?v_347 (forall ((?p_1 Int)) (let ((?v_504 (typeof ?p_1))) (=> (not (or (not (not (= ?p_1 nullObject))) (not (= (select2 Heap_24 ?p_1 allocated) true_1)) (not (= (select2 Heap_24 ?p_1 ownerRef) this)) (not (= (select2 Heap_24 ?p_1 ownerFrame) Node)))) (not (or (not (= (select2 Heap_24 ?p_1 inv) ?v_504)) (not (= (select2 Heap_24 ?p_1 localinv) ?v_504)))))))) (?v_321 (select2 Heap_24 this Node_left))) (let ((?v_323 (= ?v_321 nullObject))) (let ((?v_333 (not ?v_323))) (let ((?v_346 (=> ?v_333 (= (select2 Heap_24 ?v_321 Node_parent) this))) (?v_326 (select2 Heap_24 this Node_right))) (let ((?v_328 (= ?v_326 nullObject))) (let ((?v_331 (not ?v_328))) (let ((?v_345 (=> ?v_331 (= (select2 Heap_24 ?v_326 Node_parent) this))) (?v_343 (not (= ?v_321 ?v_326)))) (let ((?v_344 (or ?v_328 ?v_343)) (?v_318 (select2 Heap_24 this Node_data)) (?v_325 (select2 Heap_24 this Node_large))) (let ((?v_342 (=> ?v_328 (= ?v_325 ?v_318))) (?v_341 (=> ?v_331 (not (or (not (= ?v_325 (select2 Heap_24 ?v_326 Node_large))) (not (<= ?v_318 (select2 Heap_24 ?v_326 Node_small))))))) (?v_320 (select2 Heap_24 this Node_small))) (let ((?v_340 (=> ?v_323 (= ?v_320 ?v_318))) (?v_339 (=> ?v_333 (not (or (not (= ?v_320 (select2 Heap_24 ?v_321 Node_small))) (not (<= (select2 Heap_24 ?v_321 Node_large) ?v_318)))))) (?v_338 (<= ?v_318 ?v_325)) (?v_337 (<= ?v_320 ?v_318)) (?v_335 (select2 Heap_24 this localinv))) (let ((?v_336 (= ?v_335 System_Object))) (let ((?v_358 (=> true (=> true (=> true (=> (= (IsTokenForType stack0s_1 Node) true_1) (=> (= stack0o_7 ?v_94) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_336) (not (=> ?v_336 (not (or (not ?v_337) (not (=> ?v_337 (not (or (not ?v_338) (not (=> ?v_338 (not (or (not ?v_339) (not (=> ?v_339 (not (or (not ?v_340) (not (=> ?v_340 (not (or (not ?v_341) (not (=> ?v_341 (not (or (not ?v_342) (not (=> ?v_342 (not (or (not ?v_344) (not (=> ?v_344 (not (or (not ?v_345) (not (=> ?v_345 (not (or (not ?v_346) (not (=> ?v_346 (not (or (not ?v_347) (not (=> ?v_347 (=> (= Heap_25 (store2 Heap_24 this localinv ?v_108)) (=> (= (IsHeap Heap_25) true_1) (=> true (=> true (=> (= stack0o_8 stack0o_7) (=> (= Heap_26 Heap_25) (=> (= stack0s_2 stack0s_1) ?v_359))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_317 (not (not (or (not (= (x (select2 Heap_24 this inv) Node) true_1)) (not (not (= ?v_335 ?v_51)))))))) (let ((?v_334 (or ?v_317 ?v_346)) (?v_332 (or ?v_317 ?v_345)) (?v_330 (or ?v_317 ?v_328 ?v_343)) (?v_329 (or ?v_317 ?v_342)) (?v_327 (or ?v_317 ?v_341)) (?v_324 (or ?v_317 ?v_340)) (?v_322 (or ?v_317 ?v_339)) (?v_319 (or ?v_317 ?v_338)) (?v_316 (or ?v_317 ?v_337)) (?v_313 (select2 Heap_22 this ownerFrame)) (?v_314 (select2 Heap_22 this ownerRef))) (let ((?v_315 (or (= ?v_313 PeerGroupPlaceholder) (not (= (x (select2 Heap_22 ?v_314 inv) ?v_313) true_1)) (= (select2 Heap_22 ?v_314 localinv) (BaseClass ?v_313))))) (let ((?v_361 (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_315) (not (=> ?v_315 (=> (= Heap_23 (store2 Heap_22 this exposeVersion temp19_0)) (=> (= Heap_24 (store2 Heap_23 this Node_small stack1i_13)) (not (or (not ?v_316) (not (=> ?v_316 (not (or (not ?v_319) (not (=> ?v_319 (not (or (not ?v_322) (not (=> ?v_322 (not (or (not ?v_324) (not (=> ?v_324 (not (or (not ?v_327) (not (=> ?v_327 (not (or (not ?v_329) (not (=> ?v_329 (not (or (not ?v_330) (not (=> ?v_330 (not (or (not ?v_332) (not (=> ?v_332 (not (or (not ?v_334) (not (=> ?v_334 (=> (= (IsHeap Heap_24) true_1) (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> ?v_110 ?v_358)))) (not (=> true (=> true (=> ?v_213 (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> ?v_214 ?v_358)))) (not (=> true (=> true (=> ?v_112 (=> true (=> true (=> true (=> true (=> true (=> (= stack0o_8 nullObject) (=> (= Heap_26 Heap_24) (=> (= stack0s_2 stack0s) ?v_359)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_295 (select2 Heap_22 this Node_data)) (?v_360 (= stack1o_11 nullObject)) (?v_312 (not (= stack1o_12 nullObject))) (?v_298 (select2 Heap_22 this Node_left))) (let ((?v_300 (= ?v_298 nullObject))) (let ((?v_310 (not ?v_300)) (?v_294 (not (not (or (not (= (x (select2 Heap_22 this inv) Node) true_1)) (not (not (= (select2 Heap_22 this localinv) ?v_51)))))))) (let ((?v_311 (or ?v_294 (=> ?v_310 (= (select2 Heap_22 ?v_298 Node_parent) this)))) (?v_303 (select2 Heap_22 this Node_right))) (let ((?v_305 (= ?v_303 nullObject))) (let ((?v_308 (not ?v_305))) (let ((?v_309 (or ?v_294 (=> ?v_308 (= (select2 Heap_22 ?v_303 Node_parent) this)))) (?v_307 (or ?v_294 ?v_305 (not (= ?v_298 ?v_303)))) (?v_302 (select2 Heap_22 this Node_large))) (let ((?v_306 (or ?v_294 (=> ?v_305 (= ?v_302 ?v_295)))) (?v_304 (or ?v_294 (=> ?v_308 (not (or (not (= ?v_302 (select2 Heap_22 ?v_303 Node_large))) (not (<= ?v_295 (select2 Heap_22 ?v_303 Node_small)))))))) (?v_297 (select2 Heap_22 this Node_small))) (let ((?v_301 (or ?v_294 (=> ?v_300 (= ?v_297 ?v_295)))) (?v_299 (or ?v_294 (=> ?v_310 (not (or (not (= ?v_297 (select2 Heap_22 ?v_298 Node_small))) (not (<= (select2 Heap_22 ?v_298 Node_large) ?v_295))))))) (?v_296 (or ?v_294 (<= ?v_295 ?v_302))) (?v_293 (or ?v_294 (<= ?v_297 ?v_295))) (?v_290 (select2 Heap_19 this ownerFrame)) (?v_291 (select2 Heap_19 this ownerRef))) (let ((?v_292 (or (= ?v_290 PeerGroupPlaceholder) (not (= (x (select2 Heap_19 ?v_291 inv) ?v_290) true_1)) (= (select2 Heap_19 ?v_291 localinv) (BaseClass ?v_290))))) (let ((?v_363 (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_292) (not (=> ?v_292 (=> (= Heap_21 (store2 Heap_19 this exposeVersion temp16_0)) (=> (= Heap_22 (store2 Heap_21 this Node_large stack1i_10)) (not (or (not ?v_293) (not (=> ?v_293 (not (or (not ?v_296) (not (=> ?v_296 (not (or (not ?v_299) (not (=> ?v_299 (not (or (not ?v_301) (not (=> ?v_301 (not (or (not ?v_304) (not (=> ?v_304 (not (or (not ?v_306) (not (=> ?v_306 (not (or (not ?v_307) (not (=> ?v_307 (not (or (not ?v_309) (not (=> ?v_309 (not (or (not ?v_311) (not (=> ?v_311 (=> (= (IsHeap Heap_22) true_1) (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_11 ?v_298) (=> true (not (or (not (=> true (=> true (=> (not ?v_360) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_12 ?v_298) (not (or (not ?v_312) (not (=> ?v_312 (=> (= stack1i_11 (select2 Heap_22 stack1o_12 Node_small)) (=> true (=> true (=> (= stack1i_13 stack1i_11) (=> (= stack1o_13 stack1o_12) ?v_361))))))))))))))))))))) (not (=> true (=> true (=> ?v_360 (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1i_12 ?v_295) (=> true (=> true (=> (= stack1i_13 stack1i_12) (=> (= stack1o_13 stack1o_11) ?v_361)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_272 (select2 Heap_19 this Node_data)) (?v_362 (= stack1o_8 nullObject)) (?v_289 (not (= stack1o_9 nullObject))) (?v_280 (select2 Heap_19 this Node_right)) (?v_275 (select2 Heap_19 this Node_left))) (let ((?v_277 (= ?v_275 nullObject))) (let ((?v_287 (not ?v_277)) (?v_271 (not (not (or (not (= (x (select2 Heap_19 this inv) Node) true_1)) (not (not (= (select2 Heap_19 this localinv) ?v_51)))))))) (let ((?v_288 (or ?v_271 (=> ?v_287 (= (select2 Heap_19 ?v_275 Node_parent) this)))) (?v_282 (= ?v_280 nullObject))) (let ((?v_285 (not ?v_282))) (let ((?v_286 (or ?v_271 (=> ?v_285 (= (select2 Heap_19 ?v_280 Node_parent) this)))) (?v_284 (or ?v_271 ?v_282 (not (= ?v_275 ?v_280)))) (?v_279 (select2 Heap_19 this Node_large))) (let ((?v_283 (or ?v_271 (=> ?v_282 (= ?v_279 ?v_272)))) (?v_281 (or ?v_271 (=> ?v_285 (not (or (not (= ?v_279 (select2 Heap_19 ?v_280 Node_large))) (not (<= ?v_272 (select2 Heap_19 ?v_280 Node_small)))))))) (?v_274 (select2 Heap_19 this Node_small))) (let ((?v_278 (or ?v_271 (=> ?v_277 (= ?v_274 ?v_272)))) (?v_276 (or ?v_271 (=> ?v_287 (not (or (not (= ?v_274 (select2 Heap_19 ?v_275 Node_small))) (not (<= (select2 Heap_19 ?v_275 Node_large) ?v_272))))))) (?v_273 (or ?v_271 (<= ?v_272 ?v_279))) (?v_270 (or ?v_271 (<= ?v_274 ?v_272))) (?v_258 (select2 Heap_16 call16100formal__result_0 ownerFrame)) (?v_259 (select2 Heap_16 call16100formal__result_0 ownerRef)) (?v_257 (= call16100formal__result_0 nullObject))) (let ((?v_269 (not ?v_257)) (?v_260 (select2 Heap_16 this ownerFrame)) (?v_261 (select2 Heap_16 this ownerRef)) (?v_263 (= ?v_258 PeerGroupPlaceholder))) (let ((?v_267 (not (or (not ?v_269) (not ?v_263) (not (= (x (select2 Heap_16 this inv) Node) true_1)) (not (not (= (select2 Heap_16 this localinv) ?v_51))))))) (let ((?v_268 (=> ?v_267 (or (not (= ?v_261 ?v_259)) (not (= ?v_260 ?v_258))))) (?v_265 (forall ((?pc Int)) (! (let ((?v_505 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap_16 ?pc allocated) true_1)) (not (= (select2 Heap_16 ?pc ownerRef) ?v_259)) (not (= (select2 Heap_16 ?pc ownerFrame) ?v_258)))) (not (or (not (= (select2 Heap_16 ?pc inv) ?v_505)) (not (= (select2 Heap_16 ?pc localinv) ?v_505)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap_16 ?pc localinv))  :pattern ((select2 Heap_16 ?pc inv))  :pattern ((select2 Heap_16 ?pc ownerFrame))  :pattern ((select2 Heap_16 ?pc ownerRef)) )))) (let ((?v_266 (=> ?v_267 ?v_265)) (?v_264 (or ?v_257 (not (or (not (= ?v_259 this)) (not (= ?v_258 Node)))) ?v_263)) (?v_262 (or (= ?v_260 PeerGroupPlaceholder) (not (= (x (select2 Heap_16 ?v_261 inv) ?v_260) true_1)) (= (select2 Heap_16 ?v_261 localinv) (BaseClass ?v_260)))) (?v_256 (select2 Heap_15 stack0o_5 Node_large)) (?v_255 (select2 Heap_16 stack0o_5 Node_large)) (?v_254 (select2 Heap_15 stack0o_5 Node_small)) (?v_252 (= call16100formal__result_0 stack0o_5)) (?v_253 (select2 Heap_16 stack0o_5 Node_small)) (?v_249 (select2 Heap_15 stack0o_5 ownerFrame)) (?v_250 (select2 Heap_15 stack0o_5 ownerRef))) (let ((?v_251 (or (= ?v_249 PeerGroupPlaceholder) (not (= (x (select2 Heap_15 ?v_250 inv) ?v_249) true_1)) (= (select2 Heap_15 ?v_250 localinv) (BaseClass ?v_249)))) (?v_248 (forall ((?pc Int)) (! (let ((?v_506 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap_15 ?pc allocated) true_1)) (not (= (select2 Heap_15 ?pc ownerRef) ?v_250)) (not (= (select2 Heap_15 ?pc ownerFrame) ?v_249)))) (not (or (not (= (select2 Heap_15 ?pc inv) ?v_506)) (not (= (select2 Heap_15 ?pc localinv) ?v_506)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap_15 ?pc localinv))  :pattern ((select2 Heap_15 ?pc inv))  :pattern ((select2 Heap_15 ?pc ownerFrame))  :pattern ((select2 Heap_15 ?pc ownerRef)) ))) (?v_247 (not (= stack0o_5 nullObject))) (?v_230 (select2 Heap_15 this Node_data)) (?v_238 (select2 Heap_15 this Node_right)) (?v_233 (select2 Heap_15 this Node_left))) (let ((?v_235 (= ?v_233 nullObject))) (let ((?v_245 (not ?v_235)) (?v_229 (not (not (or (not (= (x (select2 Heap_15 this inv) Node) true_1)) (not (not (= (select2 Heap_15 this localinv) ?v_51)))))))) (let ((?v_246 (or ?v_229 (=> ?v_245 (= (select2 Heap_15 ?v_233 Node_parent) this)))) (?v_240 (= ?v_238 nullObject))) (let ((?v_243 (not ?v_240))) (let ((?v_244 (or ?v_229 (=> ?v_243 (= (select2 Heap_15 ?v_238 Node_parent) this)))) (?v_242 (or ?v_229 ?v_240 (not (= ?v_233 ?v_238)))) (?v_237 (select2 Heap_15 this Node_large))) (let ((?v_241 (or ?v_229 (=> ?v_240 (= ?v_237 ?v_230)))) (?v_239 (or ?v_229 (=> ?v_243 (not (or (not (= ?v_237 (select2 Heap_15 ?v_238 Node_large))) (not (<= ?v_230 (select2 Heap_15 ?v_238 Node_small)))))))) (?v_232 (select2 Heap_15 this Node_small))) (let ((?v_236 (or ?v_229 (=> ?v_235 (= ?v_232 ?v_230)))) (?v_234 (or ?v_229 (=> ?v_245 (not (or (not (= ?v_232 (select2 Heap_15 ?v_233 Node_small))) (not (<= (select2 Heap_15 ?v_233 Node_large) ?v_230))))))) (?v_231 (or ?v_229 (<= ?v_230 ?v_237))) (?v_228 (or ?v_229 (<= ?v_232 ?v_230))) (?v_225 (select2 Heap_13 this ownerFrame)) (?v_226 (select2 Heap_13 this ownerRef))) (let ((?v_227 (or (= ?v_225 PeerGroupPlaceholder) (not (= (x (select2 Heap_13 ?v_226 inv) ?v_225) true_1)) (= (select2 Heap_13 ?v_226 localinv) (BaseClass ?v_225)))) (?v_224 (not (= stack0o_4 nullObject))) (?v_223 (= stack0o_1 nullObject)) (?v_221 (select2 Heap this Node_right)) (?v_220 (select2 Heap this Node_left)) (?v_219 (= d_in stack0i_0)) (?v_211 (= temp16_2 temp16)) (?v_210 (= temp11_2 temp11)) (?v_209 (= temp18_2 temp18)) (?v_208 (= temp4_1 temp4)) (?v_207 (= temp1_2 temp1)) (?v_206 (= temp7_2 temp7)) (?v_205 (= temp0_1 temp0)) (?v_204 (= temp6_2 temp6)) (?v_203 (= local10_1 local10)) (?v_202 (= temp5_2 temp5)) (?v_201 (= temp19_2 temp19)) (?v_200 (= temp14_2 temp14)) (?v_199 (= temp12_2 temp12)) (?v_198 (= local7_1 local7))) (let ((?v_216 (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> ?v_348 (=> ?v_198 (=> (= stack1s_6 stack1s_2) (=> ?v_199 (=> (= stack1o_25 stack1o_17) (=> ?v_200 (=> (= stack0s_10 stack0s_5) (=> (= local14_0 nullObject) (=> ?v_201 (=> ?v_202 (=> ?v_203 (=> (= temp8_1 temp8_0) (=> ?v_204 (=> ?v_205 (=> ?v_206 (=> (= stack0i_6 stack0i_1) (=> ?v_207 (=> ?v_208 (=> ?v_351 (=> ?v_209 (=> (= temp3_1 temp3_0) (=> (= stack0o_21 stack0o_16) (=> (= ActivityIndicator_6 ActivityIndicator_2) (=> ?v_353 (=> (= stack1i_22 stack1i_16) (=> ?v_210 (=> ?v_354 (=> (= temp2_0 this) (=> ?v_211 (=> (= stack2o_2 nullObject) (=> (= Heap_50 Heap_45) (=> (= temp15_1 temp15_0) ?v_357)))))))))))))))))))))))))))))))))))))))) (?v_197 (forall ((?p_1 Int)) (let ((?v_507 (typeof ?p_1))) (=> (not (or (not (not (= ?p_1 nullObject))) (not (= (select2 Heap_34 ?p_1 allocated) true_1)) (not (= (select2 Heap_34 ?p_1 ownerRef) this)) (not (= (select2 Heap_34 ?p_1 ownerFrame) Node)))) (not (or (not (= (select2 Heap_34 ?p_1 inv) ?v_507)) (not (= (select2 Heap_34 ?p_1 localinv) ?v_507)))))))) (?v_171 (select2 Heap_34 this Node_left))) (let ((?v_173 (= ?v_171 nullObject))) (let ((?v_183 (not ?v_173))) (let ((?v_196 (=> ?v_183 (= (select2 Heap_34 ?v_171 Node_parent) this))) (?v_176 (select2 Heap_34 this Node_right))) (let ((?v_178 (= ?v_176 nullObject))) (let ((?v_181 (not ?v_178))) (let ((?v_195 (=> ?v_181 (= (select2 Heap_34 ?v_176 Node_parent) this))) (?v_193 (not (= ?v_171 ?v_176)))) (let ((?v_194 (or ?v_178 ?v_193)) (?v_168 (select2 Heap_34 this Node_data)) (?v_175 (select2 Heap_34 this Node_large))) (let ((?v_192 (=> ?v_178 (= ?v_175 ?v_168))) (?v_191 (=> ?v_181 (not (or (not (= ?v_175 (select2 Heap_34 ?v_176 Node_large))) (not (<= ?v_168 (select2 Heap_34 ?v_176 Node_small))))))) (?v_170 (select2 Heap_34 this Node_small))) (let ((?v_190 (=> ?v_173 (= ?v_170 ?v_168))) (?v_189 (=> ?v_183 (not (or (not (= ?v_170 (select2 Heap_34 ?v_171 Node_small))) (not (<= (select2 Heap_34 ?v_171 Node_large) ?v_168)))))) (?v_188 (<= ?v_168 ?v_175)) (?v_187 (<= ?v_170 ?v_168)) (?v_185 (select2 Heap_34 this localinv))) (let ((?v_186 (= ?v_185 System_Object))) (let ((?v_215 (=> true (=> true (=> true (=> (= (IsTokenForType stack0s_4 Node) true_1) (=> (= stack0o_15 ?v_94) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_186) (not (=> ?v_186 (not (or (not ?v_187) (not (=> ?v_187 (not (or (not ?v_188) (not (=> ?v_188 (not (or (not ?v_189) (not (=> ?v_189 (not (or (not ?v_190) (not (=> ?v_190 (not (or (not ?v_191) (not (=> ?v_191 (not (or (not ?v_192) (not (=> ?v_192 (not (or (not ?v_194) (not (=> ?v_194 (not (or (not ?v_195) (not (=> ?v_195 (not (or (not ?v_196) (not (=> ?v_196 (not (or (not ?v_197) (not (=> ?v_197 (=> (= Heap_44 (store2 Heap_34 this localinv ?v_108)) (=> (= (IsHeap Heap_44) true_1) (=> true (=> true (=> (= stack0o_16 stack0o_15) (=> (= Heap_45 Heap_44) (=> (= stack0s_5 stack0s_4) ?v_216))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_167 (not (not (or (not (= (x (select2 Heap_34 this inv) Node) true_1)) (not (not (= ?v_185 ?v_51)))))))) (let ((?v_184 (or ?v_167 ?v_196)) (?v_182 (or ?v_167 ?v_195)) (?v_180 (or ?v_167 ?v_178 ?v_193)) (?v_179 (or ?v_167 ?v_192)) (?v_177 (or ?v_167 ?v_191)) (?v_174 (or ?v_167 ?v_190)) (?v_172 (or ?v_167 ?v_189)) (?v_169 (or ?v_167 ?v_188)) (?v_166 (or ?v_167 ?v_187)) (?v_163 (select2 Heap_32 this ownerFrame)) (?v_164 (select2 Heap_32 this ownerRef))) (let ((?v_165 (or (= ?v_163 PeerGroupPlaceholder) (not (= (x (select2 Heap_32 ?v_164 inv) ?v_163) true_1)) (= (select2 Heap_32 ?v_164 localinv) (BaseClass ?v_163))))) (let ((?v_218 (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_165) (not (=> ?v_165 (=> (= Heap_33 (store2 Heap_32 this exposeVersion temp15_0)) (=> (= Heap_34 (store2 Heap_33 this Node_small stack1i_16)) (not (or (not ?v_166) (not (=> ?v_166 (not (or (not ?v_169) (not (=> ?v_169 (not (or (not ?v_172) (not (=> ?v_172 (not (or (not ?v_174) (not (=> ?v_174 (not (or (not ?v_177) (not (=> ?v_177 (not (or (not ?v_179) (not (=> ?v_179 (not (or (not ?v_180) (not (=> ?v_180 (not (or (not ?v_182) (not (=> ?v_182 (not (or (not ?v_184) (not (=> ?v_184 (=> (= (IsHeap Heap_34) true_1) (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> ?v_110 ?v_215)))) (not (=> true (=> true (=> ?v_213 (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> ?v_214 ?v_215)))) (not (=> true (=> true (=> ?v_112 (=> true (=> true (=> true (=> true (=> true (=> (= stack0o_16 nullObject) (=> (= Heap_45 Heap_34) (=> (= stack0s_5 stack0s) ?v_216)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_145 (select2 Heap_32 this Node_data)) (?v_217 (= stack1o_15 nullObject)) (?v_162 (not (= stack1o_16 nullObject))) (?v_148 (select2 Heap_32 this Node_left))) (let ((?v_150 (= ?v_148 nullObject))) (let ((?v_160 (not ?v_150)) (?v_144 (not (not (or (not (= (x (select2 Heap_32 this inv) Node) true_1)) (not (not (= (select2 Heap_32 this localinv) ?v_51)))))))) (let ((?v_161 (or ?v_144 (=> ?v_160 (= (select2 Heap_32 ?v_148 Node_parent) this)))) (?v_153 (select2 Heap_32 this Node_right))) (let ((?v_155 (= ?v_153 nullObject))) (let ((?v_158 (not ?v_155))) (let ((?v_159 (or ?v_144 (=> ?v_158 (= (select2 Heap_32 ?v_153 Node_parent) this)))) (?v_157 (or ?v_144 ?v_155 (not (= ?v_148 ?v_153)))) (?v_152 (select2 Heap_32 this Node_large))) (let ((?v_156 (or ?v_144 (=> ?v_155 (= ?v_152 ?v_145)))) (?v_154 (or ?v_144 (=> ?v_158 (not (or (not (= ?v_152 (select2 Heap_32 ?v_153 Node_large))) (not (<= ?v_145 (select2 Heap_32 ?v_153 Node_small)))))))) (?v_147 (select2 Heap_32 this Node_small))) (let ((?v_151 (or ?v_144 (=> ?v_150 (= ?v_147 ?v_145)))) (?v_149 (or ?v_144 (=> ?v_160 (not (or (not (= ?v_147 (select2 Heap_32 ?v_148 Node_small))) (not (<= (select2 Heap_32 ?v_148 Node_large) ?v_145))))))) (?v_146 (or ?v_144 (<= ?v_145 ?v_152))) (?v_143 (or ?v_144 (<= ?v_147 ?v_145))) (?v_131 (select2 Heap_29 call15066formal__result_0 ownerFrame)) (?v_132 (select2 Heap_29 call15066formal__result_0 ownerRef)) (?v_130 (= call15066formal__result_0 nullObject))) (let ((?v_142 (not ?v_130)) (?v_133 (select2 Heap_29 this ownerFrame)) (?v_134 (select2 Heap_29 this ownerRef)) (?v_136 (= ?v_131 PeerGroupPlaceholder))) (let ((?v_140 (not (or (not ?v_142) (not ?v_136) (not (= (x (select2 Heap_29 this inv) Node) true_1)) (not (not (= (select2 Heap_29 this localinv) ?v_51))))))) (let ((?v_141 (=> ?v_140 (or (not (= ?v_134 ?v_132)) (not (= ?v_133 ?v_131))))) (?v_138 (forall ((?pc Int)) (! (let ((?v_508 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap_29 ?pc allocated) true_1)) (not (= (select2 Heap_29 ?pc ownerRef) ?v_132)) (not (= (select2 Heap_29 ?pc ownerFrame) ?v_131)))) (not (or (not (= (select2 Heap_29 ?pc inv) ?v_508)) (not (= (select2 Heap_29 ?pc localinv) ?v_508)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap_29 ?pc localinv))  :pattern ((select2 Heap_29 ?pc inv))  :pattern ((select2 Heap_29 ?pc ownerFrame))  :pattern ((select2 Heap_29 ?pc ownerRef)) )))) (let ((?v_139 (=> ?v_140 ?v_138)) (?v_137 (or ?v_130 (not (or (not (= ?v_132 this)) (not (= ?v_131 Node)))) ?v_136)) (?v_135 (or (= ?v_133 PeerGroupPlaceholder) (not (= (x (select2 Heap_29 ?v_134 inv) ?v_133) true_1)) (= (select2 Heap_29 ?v_134 localinv) (BaseClass ?v_133)))) (?v_129 (select2 Heap_28 stack0o_10 Node_large)) (?v_128 (select2 Heap_29 stack0o_10 Node_large)) (?v_127 (select2 Heap_28 stack0o_10 Node_small)) (?v_125 (= call15066formal__result_0 stack0o_10)) (?v_126 (select2 Heap_29 stack0o_10 Node_small)) (?v_122 (select2 Heap_28 stack0o_10 ownerFrame)) (?v_123 (select2 Heap_28 stack0o_10 ownerRef))) (let ((?v_124 (or (= ?v_122 PeerGroupPlaceholder) (not (= (x (select2 Heap_28 ?v_123 inv) ?v_122) true_1)) (= (select2 Heap_28 ?v_123 localinv) (BaseClass ?v_122)))) (?v_121 (forall ((?pc Int)) (! (let ((?v_509 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap_28 ?pc allocated) true_1)) (not (= (select2 Heap_28 ?pc ownerRef) ?v_123)) (not (= (select2 Heap_28 ?pc ownerFrame) ?v_122)))) (not (or (not (= (select2 Heap_28 ?pc inv) ?v_509)) (not (= (select2 Heap_28 ?pc localinv) ?v_509)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap_28 ?pc localinv))  :pattern ((select2 Heap_28 ?pc inv))  :pattern ((select2 Heap_28 ?pc ownerFrame))  :pattern ((select2 Heap_28 ?pc ownerRef)) ))) (?v_120 (not (= stack0o_10 nullObject))) (?v_117 (= stack0o_9 nullObject)) (?v_109 (=> true (=> true (=> true (=> true (=> (= local17_1 local17_0) (=> ?v_198 (=> (= stack1s_6 stack1s_5) (=> ?v_199 (=> (= stack1o_25 stack1o_24) (=> ?v_200 (=> (= stack0s_10 stack0s_9) (=> ?v_349 (=> ?v_201 (=> ?v_202 (=> ?v_203 (=> ?v_350 (=> ?v_204 (=> ?v_205 (=> ?v_206 (=> (= stack0i_6 stack0i_4) (=> ?v_207 (=> ?v_208 (=> (= temp10_2 temp10_1) (=> ?v_209 (=> ?v_352 (=> (= stack0o_21 stack0o_20) (=> (= ActivityIndicator_6 ActivityIndicator_5) (=> (= temp17_2 temp17_1) (=> (= stack1i_22 stack1i_21) (=> ?v_210 (=> (= temp13_2 temp13_1) (=> ?v_355 (=> ?v_211 (=> (= stack2o_2 stack2o_1) (=> (= Heap_50 Heap_49) (=> ?v_356 (=> (= temp9_1 temp9_0) ?v_212))))))))))))))))))))))))))))))))))))))) (let ((?v_113 (=> true (=> true (=> true (=> true (=> (= stack2o_1 nullObject) (=> (= Heap_49 Heap_48) (=> (= local17_0 nullObject) (=> (= stack1o_24 stack1o_22) (=> (= ActivityIndicator_5 ActivityIndicator_3) (=> (= stack0o_20 stack0o_19) (=> (= temp17_1 temp17_0) (=> (= temp13_1 temp13_0) (=> (= temp9_0 this) (=> (= stack1s_5 stack1s_3) (=> (= stack1i_21 stack1i_19) (=> (= temp10_1 temp10_0) (=> (= stack0s_9 stack0s_8) ?v_109)))))))))))))))))) (?v_107 (forall ((?p_1 Int)) (let ((?v_510 (typeof ?p_1))) (=> (not (or (not (not (= ?p_1 nullObject))) (not (= (select2 Heap_42 ?p_1 allocated) true_1)) (not (= (select2 Heap_42 ?p_1 ownerRef) this)) (not (= (select2 Heap_42 ?p_1 ownerFrame) Node)))) (not (or (not (= (select2 Heap_42 ?p_1 inv) ?v_510)) (not (= (select2 Heap_42 ?p_1 localinv) ?v_510)))))))) (?v_80 (select2 Heap_42 this Node_left))) (let ((?v_82 (= ?v_80 nullObject))) (let ((?v_92 (not ?v_82))) (let ((?v_106 (=> ?v_92 (= (select2 Heap_42 ?v_80 Node_parent) this))) (?v_85 (select2 Heap_42 this Node_right))) (let ((?v_87 (= ?v_85 nullObject))) (let ((?v_90 (not ?v_87))) (let ((?v_105 (=> ?v_90 (= (select2 Heap_42 ?v_85 Node_parent) this))) (?v_103 (not (= ?v_80 ?v_85)))) (let ((?v_104 (or ?v_87 ?v_103)) (?v_77 (select2 Heap_42 this Node_data)) (?v_84 (select2 Heap_42 this Node_large))) (let ((?v_102 (=> ?v_87 (= ?v_84 ?v_77))) (?v_101 (=> ?v_90 (not (or (not (= ?v_84 (select2 Heap_42 ?v_85 Node_large))) (not (<= ?v_77 (select2 Heap_42 ?v_85 Node_small))))))) (?v_79 (select2 Heap_42 this Node_small))) (let ((?v_100 (=> ?v_82 (= ?v_79 ?v_77))) (?v_99 (=> ?v_92 (not (or (not (= ?v_79 (select2 Heap_42 ?v_80 Node_small))) (not (<= (select2 Heap_42 ?v_80 Node_large) ?v_77)))))) (?v_98 (<= ?v_77 ?v_84)) (?v_97 (<= ?v_79 ?v_77)) (?v_95 (select2 Heap_42 this localinv))) (let ((?v_96 (= ?v_95 System_Object))) (let ((?v_111 (=> true (=> true (=> true (=> (= (IsTokenForType stack0s_3 Node) true_1) (=> (= stack0o_14 ?v_94) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_96) (not (=> ?v_96 (not (or (not ?v_97) (not (=> ?v_97 (not (or (not ?v_98) (not (=> ?v_98 (not (or (not ?v_99) (not (=> ?v_99 (not (or (not ?v_100) (not (=> ?v_100 (not (or (not ?v_101) (not (=> ?v_101 (not (or (not ?v_102) (not (=> ?v_102 (not (or (not ?v_104) (not (=> ?v_104 (not (or (not ?v_105) (not (=> ?v_105 (not (or (not ?v_106) (not (=> ?v_106 (not (or (not ?v_107) (not (=> ?v_107 (=> (= Heap_43 (store2 Heap_42 this localinv ?v_108)) (=> (= (IsHeap Heap_43) true_1) (=> true (=> true (=> (= stack0o_19 stack0o_14) (=> (= Heap_48 Heap_43) (=> (= stack0s_8 stack0s_3) ?v_113))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_76 (not (not (or (not (= (x (select2 Heap_42 this inv) Node) true_1)) (not (not (= ?v_95 ?v_51)))))))) (let ((?v_93 (or ?v_76 ?v_106)) (?v_91 (or ?v_76 ?v_105)) (?v_89 (or ?v_76 ?v_87 ?v_103)) (?v_88 (or ?v_76 ?v_102)) (?v_86 (or ?v_76 ?v_101)) (?v_83 (or ?v_76 ?v_100)) (?v_81 (or ?v_76 ?v_99)) (?v_78 (or ?v_76 ?v_98)) (?v_75 (or ?v_76 ?v_97)) (?v_72 (select2 Heap_40 this ownerFrame)) (?v_73 (select2 Heap_40 this ownerRef))) (let ((?v_74 (or (= ?v_72 PeerGroupPlaceholder) (not (= (x (select2 Heap_40 ?v_73 inv) ?v_72) true_1)) (= (select2 Heap_40 ?v_73 localinv) (BaseClass ?v_72))))) (let ((?v_115 (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_74) (not (=> ?v_74 (=> (= Heap_41 (store2 Heap_40 this exposeVersion temp17_0)) (=> (= Heap_42 (store2 Heap_41 this Node_large stack1i_19)) (not (or (not ?v_75) (not (=> ?v_75 (not (or (not ?v_78) (not (=> ?v_78 (not (or (not ?v_81) (not (=> ?v_81 (not (or (not ?v_83) (not (=> ?v_83 (not (or (not ?v_86) (not (=> ?v_86 (not (or (not ?v_88) (not (=> ?v_88 (not (or (not ?v_89) (not (=> ?v_89 (not (or (not ?v_91) (not (=> ?v_91 (not (or (not ?v_93) (not (=> ?v_93 (=> (= (IsHeap Heap_42) true_1) (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> ?v_110 ?v_111)))) (not (=> true (=> true (=> ?v_213 (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> ?v_214 ?v_111)))) (not (=> true (=> true (=> ?v_112 (=> true (=> true (=> true (=> true (=> true (=> (= stack0o_19 nullObject) (=> (= Heap_48 Heap_42) (=> (= stack0s_8 stack0s) ?v_113)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_54 (select2 Heap_40 this Node_data)) (?v_114 (= stack1o_20 nullObject)) (?v_71 (not (= stack1o_21 nullObject))) (?v_62 (select2 Heap_40 this Node_right)) (?v_57 (select2 Heap_40 this Node_left))) (let ((?v_59 (= ?v_57 nullObject))) (let ((?v_69 (not ?v_59)) (?v_53 (not (not (or (not (= (x (select2 Heap_40 this inv) Node) true_1)) (not (not (= (select2 Heap_40 this localinv) ?v_51)))))))) (let ((?v_70 (or ?v_53 (=> ?v_69 (= (select2 Heap_40 ?v_57 Node_parent) this)))) (?v_64 (= ?v_62 nullObject))) (let ((?v_67 (not ?v_64))) (let ((?v_68 (or ?v_53 (=> ?v_67 (= (select2 Heap_40 ?v_62 Node_parent) this)))) (?v_66 (or ?v_53 ?v_64 (not (= ?v_57 ?v_62)))) (?v_61 (select2 Heap_40 this Node_large))) (let ((?v_65 (or ?v_53 (=> ?v_64 (= ?v_61 ?v_54)))) (?v_63 (or ?v_53 (=> ?v_67 (not (or (not (= ?v_61 (select2 Heap_40 ?v_62 Node_large))) (not (<= ?v_54 (select2 Heap_40 ?v_62 Node_small)))))))) (?v_56 (select2 Heap_40 this Node_small))) (let ((?v_60 (or ?v_53 (=> ?v_59 (= ?v_56 ?v_54)))) (?v_58 (or ?v_53 (=> ?v_69 (not (or (not (= ?v_56 (select2 Heap_40 ?v_57 Node_small))) (not (<= (select2 Heap_40 ?v_57 Node_large) ?v_54))))))) (?v_55 (or ?v_53 (<= ?v_54 ?v_61))) (?v_52 (or ?v_53 (<= ?v_56 ?v_54))) (?v_39 (select2 Heap_37 call16754formal__result_0 ownerFrame)) (?v_40 (select2 Heap_37 call16754formal__result_0 ownerRef)) (?v_38 (= call16754formal__result_0 nullObject))) (let ((?v_50 (not ?v_38)) (?v_41 (select2 Heap_37 this ownerFrame)) (?v_42 (select2 Heap_37 this ownerRef)) (?v_44 (= ?v_39 PeerGroupPlaceholder))) (let ((?v_48 (not (or (not ?v_50) (not ?v_44) (not (= (x (select2 Heap_37 this inv) Node) true_1)) (not (not (= (select2 Heap_37 this localinv) ?v_51))))))) (let ((?v_49 (=> ?v_48 (or (not (= ?v_42 ?v_40)) (not (= ?v_41 ?v_39))))) (?v_46 (forall ((?pc Int)) (! (let ((?v_511 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap_37 ?pc allocated) true_1)) (not (= (select2 Heap_37 ?pc ownerRef) ?v_40)) (not (= (select2 Heap_37 ?pc ownerFrame) ?v_39)))) (not (or (not (= (select2 Heap_37 ?pc inv) ?v_511)) (not (= (select2 Heap_37 ?pc localinv) ?v_511)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap_37 ?pc localinv))  :pattern ((select2 Heap_37 ?pc inv))  :pattern ((select2 Heap_37 ?pc ownerFrame))  :pattern ((select2 Heap_37 ?pc ownerRef)) )))) (let ((?v_47 (=> ?v_48 ?v_46)) (?v_45 (or ?v_38 (not (or (not (= ?v_40 this)) (not (= ?v_39 Node)))) ?v_44)) (?v_43 (or (= ?v_41 PeerGroupPlaceholder) (not (= (x (select2 Heap_37 ?v_42 inv) ?v_41) true_1)) (= (select2 Heap_37 ?v_42 localinv) (BaseClass ?v_41)))) (?v_37 (select2 Heap_36 stack0o_13 Node_large)) (?v_36 (select2 Heap_37 stack0o_13 Node_large)) (?v_35 (select2 Heap_36 stack0o_13 Node_small)) (?v_33 (= call16754formal__result_0 stack0o_13)) (?v_34 (select2 Heap_37 stack0o_13 Node_small)) (?v_30 (select2 Heap_36 stack0o_13 ownerFrame)) (?v_31 (select2 Heap_36 stack0o_13 ownerRef))) (let ((?v_32 (or (= ?v_30 PeerGroupPlaceholder) (not (= (x (select2 Heap_36 ?v_31 inv) ?v_30) true_1)) (= (select2 Heap_36 ?v_31 localinv) (BaseClass ?v_30)))) (?v_29 (forall ((?pc Int)) (! (let ((?v_512 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap_36 ?pc allocated) true_1)) (not (= (select2 Heap_36 ?pc ownerRef) ?v_31)) (not (= (select2 Heap_36 ?pc ownerFrame) ?v_30)))) (not (or (not (= (select2 Heap_36 ?pc inv) ?v_512)) (not (= (select2 Heap_36 ?pc localinv) ?v_512)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap_36 ?pc localinv))  :pattern ((select2 Heap_36 ?pc inv))  :pattern ((select2 Heap_36 ?pc ownerFrame))  :pattern ((select2 Heap_36 ?pc ownerRef)) ))) (?v_28 (not (= stack0o_13 nullObject))) (?v_25 (= stack0o_12 nullObject)) (?v_24 (=> (= temp17_1 temp17) (=> (= temp13_1 temp13) (=> (= temp9_0 temp9) (=> (= stack1s_5 stack1s) (=> (= stack1i_21 stack1i) (=> (= temp10_1 temp10) (=> (= stack0s_9 stack0s) ?v_109)))))))) (?v_23 (= ActivityIndicator_5 ActivityIndicator)) (?v_22 (= local17_0 local17)) (?v_21 (= Heap_49 Heap)) (?v_20 (= stack2o_1 stack2o)) (?v_4 (select2 Heap this Node_data))) (let ((?v_116 (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0i_4 ?v_4) (=> true (not (or (not (=> true (=> true (=> (<= d_in stack0i_4) (=> true (=> true (=> ?v_20 (=> ?v_21 (=> ?v_22 (=> (= stack1o_24 stack1o_18) (=> ?v_23 (=> (= stack0o_20 stack0o_11) ?v_24)))))))))))) (not (=> true (=> true (=> (> d_in stack0i_4) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_12 ?v_221) (=> true (not (or (not (=> true (=> true (=> ?v_25 (=> true (=> true (=> ?v_20 (=> ?v_21 (=> ?v_22 (=> (= stack1o_24 nullObject) (=> ?v_23 (=> (= stack0o_20 stack0o_12) ?v_24)))))))))))) (not (=> true (=> true (=> (not ?v_25) (=> true (=> true (=> true (=> (= (IsTokenForType stack1s_3 Node) true_1) (=> (= stack1o_19 ?v_94) (not (or ?v_3 (not (=> ?v_2 (not (or ?v_118 (not (=> ?v_27 (=> (= Heap_35 ?v_119) (=> (= Heap_36 (store2 Heap_35 this exposeVersion temp10_0)) (=> (= (IsHeap Heap_36) true_1) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_13 (select2 Heap_36 this Node_right)) (not (or (not ?v_28) (not (=> ?v_28 (=> (not (or (not (= (Is call16754formal__result Node) true_1)) (not (= (select2 Heap call16754formal__result allocated) true_1)))) (not (or (not ?v_29) (not (=> ?v_29 (not (or (not ?v_32) (not (=> ?v_32 (=> (= (IsHeap Heap_37) true_1) (=> (not (or (not (= (Is call16754formal__result_0 Node) true_1)) (not (= (select2 Heap_37 call16754formal__result_0 allocated) true_1)))) (=> (or ?v_33 ?v_38) (=> (=> ?v_33 (not (or (not (<= ?v_35 ?v_34)) (not (<= ?v_34 ?v_37))))) (=> (=> ?v_33 (not (or (not (<= ?v_35 ?v_36)) (not (<= ?v_36 ?v_37))))) (=> (= (select2 Heap_37 stack0o_13 Node_parent) (select2 Heap_36 stack0o_13 Node_parent)) (=> (or ?v_38 ?v_46) (=> (or ?v_38 ?v_44 (not (= (x (select2 Heap_37 ?v_40 inv) ?v_39) true_1)) (= (select2 Heap_37 ?v_40 localinv) (BaseClass ?v_39))) (=> (forall ((?o_1 Int)) (! (let ((?v_513 (typeof ?o_1))) (=> (not (or (not (not (= ?o_1 nullObject))) (not (not (= (select2 Heap_36 ?o_1 allocated) true_1))) (not (= (select2 Heap_37 ?o_1 allocated) true_1)))) (not (or (not (= (select2 Heap_37 ?o_1 inv) ?v_513)) (not (= (select2 Heap_37 ?o_1 localinv) ?v_513)))))) :pattern ((select2 Heap_37 ?o_1 localinv))  :pattern ((select2 Heap_37 ?o_1 inv)) )) (=> (forall ((?o_1 Int)) (! (let ((?v_514 (select2 Heap_36 ?o_1 FirstConsistentOwner))) (=> (= (select2 Heap_36 ?v_514 exposeVersion) (select2 Heap_37 ?v_514 exposeVersion)) (= ?v_514 (select2 Heap_37 ?o_1 FirstConsistentOwner)))) :pattern ((select2 Heap_37 ?o_1 FirstConsistentOwner)) )) (=> (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_517 (not (= ?o_1 stack0o_13))) (?v_515 (select2 Heap_36 ?o_1 ownerFrame)) (?v_516 (select2 Heap_36 ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap_36 ?o_1 allocated) true_1)) (not (or (= ?v_515 PeerGroupPlaceholder) (not (= (x (select2 Heap_36 ?v_516 inv) ?v_515) true_1)) (= (select2 Heap_36 ?v_516 localinv) (BaseClass ?v_515)))) (not (or ?v_517 (not (= (x (typeof stack0o_13) (DeclType ?f_1)) true_1)) (not (= (IncludedInModifiesStar ?f_1) true_1)))) (not (or ?v_517 (not (= ?f_1 exposeVersion)))))) (= (select2 Heap_36 ?o_1 ?f_1) (select2 Heap_37 ?o_1 ?f_1)))) :pattern ((select2 Heap_37 ?o_1 ?f_1)) )) (=> (= (HeapSucc Heap_36 Heap_37) true_1) (=> (forall ((?o_1 Int)) (! (=> (= (select2 Heap_36 ?o_1 allocated) true_1) (not (or (not (= (select2 Heap_36 ?o_1 inv) (select2 Heap_37 ?o_1 inv))) (not (= (select2 Heap_36 ?o_1 localinv) (select2 Heap_37 ?o_1 localinv)))))) :pattern ((select2 Heap_37 ?o_1 localinv))  :pattern ((select2 Heap_37 ?o_1 inv)) )) (=> (not (or (not (forall ((?o_1 Int)) (! (=> (= (select2 Heap_36 ?o_1 allocated) true_1) (= (select2 Heap_37 ?o_1 allocated) true_1)) :pattern ((select2 Heap_37 ?o_1 allocated)) ))) (not (forall ((?ot Int)) (! (let ((?v_518 (select2 Heap_36 ?ot ownerFrame))) (=> (not (or (not (= (select2 Heap_36 ?ot allocated) true_1)) (not (not (= ?v_518 PeerGroupPlaceholder))))) (not (or (not (= (select2 Heap_37 ?ot ownerRef) (select2 Heap_36 ?ot ownerRef))) (not (= (select2 Heap_37 ?ot ownerFrame) ?v_518)))))) :pattern ((select2 Heap_37 ?ot ownerFrame))  :pattern ((select2 Heap_37 ?ot ownerRef)) ))) (not (= (= (select2 Heap_36 BeingConstructed NonNullFieldsAreInitialized) true_1) (= (select2 Heap_37 BeingConstructed NonNullFieldsAreInitialized) true_1))))) (=> (forall ((?o_1 Int)) (! (= (select2 Heap_36 ?o_1 sharingMode) (select2 Heap_37 ?o_1 sharingMode)) :pattern ((select2 Heap_37 ?o_1 sharingMode)) )) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_43) (not (=> ?v_43 (not (or (not ?v_45) (not (=> ?v_45 (not (or (not ?v_47) (not (=> ?v_47 (not (or (not ?v_49) (not (=> ?v_49 (=> (= (IsHeap Heap_38) true_1) (=> (forall ((?p Int) (?F Int)) (! (=> (or (not (or (not (not (= ?F ownerRef))) (not (not (= ?F ownerFrame))))) (not (= (select2 Heap_37 ?p ownerRef) ?v_40)) (not (= (select2 Heap_37 ?p ownerFrame) ?v_39))) (= (select2 Heap_37 ?p ?F) (select2 Heap_38 ?p ?F))) :pattern ((select2 Heap_38 ?p ?F)) )) (=> (=> ?v_38 (= Heap_38 Heap_37)) (=> (=> ?v_50 (forall ((?p Int)) (! (=> (not (or (not (= (select2 Heap_37 ?p ownerRef) ?v_40)) (not (= (select2 Heap_37 ?p ownerFrame) ?v_39)))) (not (or (not (= (select2 Heap_38 ?p ownerRef) this)) (not (= (select2 Heap_38 ?p ownerFrame) Node))))) :pattern ((select2 Heap_38 ?p ownerRef))  :pattern ((select2 Heap_38 ?p ownerFrame)) ))) (=> (= (HeapSucc Heap_37 Heap_38) true_1) (=> (= Heap_39 (store2 Heap_38 this exposeVersion temp13_0)) (=> (= Heap_40 (store2 Heap_39 this Node_right call16754formal__result_0)) (not (or (not ?v_52) (not (=> ?v_52 (not (or (not ?v_55) (not (=> ?v_55 (not (or (not ?v_58) (not (=> ?v_58 (not (or (not ?v_60) (not (=> ?v_60 (not (or (not ?v_63) (not (=> ?v_63 (not (or (not ?v_65) (not (=> ?v_65 (not (or (not ?v_66) (not (=> ?v_66 (not (or (not ?v_68) (not (=> ?v_68 (not (or (not ?v_70) (not (=> ?v_70 (=> (= (IsHeap Heap_40) true_1) (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_20 ?v_62) (=> true (not (or (not (=> true (=> true (=> (not ?v_114) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_21 ?v_62) (not (or (not ?v_71) (not (=> ?v_71 (=> (= stack1i_17 (select2 Heap_40 stack1o_21 Node_large)) (=> true (=> true (=> (= stack1i_19 stack1i_17) (=> (= stack1o_22 stack1o_21) ?v_115))))))))))))))))))))) (not (=> true (=> true (=> ?v_114 (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1i_18 ?v_54) (=> true (=> true (=> (= stack1i_19 stack1i_18) (=> (= stack1o_22 stack1o_20) ?v_115))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> (= (IsHeap Heap) true_1) (=> (not (or (not (= (IsNotNull this Node) true_1)) (not (= (select2 Heap this allocated) true_1)))) (=> (= (InRange d_in System_Int32) true_1) (=> (not (or (not (= (Is result Node) true_1)) (not (= (select2 Heap result allocated) true_1)))) (=> (= (InRange d System_Int32) true_1) (=> (not (or (not (= (Is local7 System_Exception) true_1)) (not (= (select2 Heap local7 allocated) true_1)))) (=> (not (or (not (= (Is local14 System_Exception) true_1)) (not (= (select2 Heap local14 allocated) true_1)))) (=> (not (or (not (= (Is local10 System_Exception) true_1)) (not (= (select2 Heap local10 allocated) true_1)))) (=> (not (or (not (= (Is return_value Node) true_1)) (not (= (select2 Heap return_value allocated) true_1)))) (=> (not (or (not (= (Is local17 System_Exception) true_1)) (not (= (select2 Heap local17 allocated) true_1)))) (=> (not (or (not (= (Is SS_Display_Return_Local Node) true_1)) (not (= (select2 Heap SS_Display_Return_Local allocated) true_1)))) (=> (= PurityAxiomsCanBeAssumed true_1) (=> (= BeingConstructed nullObject) (=> ?v_26 (=> (forall ((?pc Int)) (! (let ((?v_519 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap ?pc allocated) true_1)) (not (= (select2 Heap ?pc ownerRef) ?v_1)) (not (= (select2 Heap ?pc ownerFrame) ?v_0)))) (not (or (not (= (select2 Heap ?pc inv) ?v_519)) (not (= (select2 Heap ?pc localinv) ?v_519)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap ?pc localinv))  :pattern ((select2 Heap ?pc inv))  :pattern ((select2 Heap ?pc ownerFrame))  :pattern ((select2 Heap ?pc ownerRef)) )) (=> true (=> true (=> true (=> true (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0i_0 ?v_4) (=> true (not (or (not (=> true (=> true (=> (not ?v_219) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0i_1 ?v_4) (=> true (not (or (not (=> true (=> true (=> (>= d_in stack0i_1) (=> true (=> true (=> (= stack0o_11 stack0o) (=> (= stack1o_18 stack1o) ?v_116)))))))) (not (=> true (=> true (=> (< d_in stack0i_1) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_9 ?v_220) (=> true (not (or (not (=> true (=> true (=> ?v_117 (=> true (=> true (=> (= stack0o_11 stack0o_9) (=> (= stack1o_18 nullObject) ?v_116)))))))) (not (=> true (=> true (=> (not ?v_117) (=> true (=> true (=> true (=> (= (IsTokenForType stack1s_2 Node) true_1) (=> (= stack1o_14 ?v_94) (not (or ?v_3 (not (=> ?v_2 (not (or ?v_118 (not (=> ?v_27 (=> (= Heap_27 ?v_119) (=> (= Heap_28 (store2 Heap_27 this exposeVersion temp3_0)) (=> (= (IsHeap Heap_28) true_1) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_10 (select2 Heap_28 this Node_left)) (not (or (not ?v_120) (not (=> ?v_120 (=> (not (or (not (= (Is call15066formal__result Node) true_1)) (not (= (select2 Heap call15066formal__result allocated) true_1)))) (not (or (not ?v_121) (not (=> ?v_121 (not (or (not ?v_124) (not (=> ?v_124 (=> (= (IsHeap Heap_29) true_1) (=> (not (or (not (= (Is call15066formal__result_0 Node) true_1)) (not (= (select2 Heap_29 call15066formal__result_0 allocated) true_1)))) (=> (or ?v_125 ?v_130) (=> (=> ?v_125 (not (or (not (<= ?v_127 ?v_126)) (not (<= ?v_126 ?v_129))))) (=> (=> ?v_125 (not (or (not (<= ?v_127 ?v_128)) (not (<= ?v_128 ?v_129))))) (=> (= (select2 Heap_29 stack0o_10 Node_parent) (select2 Heap_28 stack0o_10 Node_parent)) (=> (or ?v_130 ?v_138) (=> (or ?v_130 ?v_136 (not (= (x (select2 Heap_29 ?v_132 inv) ?v_131) true_1)) (= (select2 Heap_29 ?v_132 localinv) (BaseClass ?v_131))) (=> (forall ((?o_1 Int)) (! (let ((?v_520 (typeof ?o_1))) (=> (not (or (not (not (= ?o_1 nullObject))) (not (not (= (select2 Heap_28 ?o_1 allocated) true_1))) (not (= (select2 Heap_29 ?o_1 allocated) true_1)))) (not (or (not (= (select2 Heap_29 ?o_1 inv) ?v_520)) (not (= (select2 Heap_29 ?o_1 localinv) ?v_520)))))) :pattern ((select2 Heap_29 ?o_1 localinv))  :pattern ((select2 Heap_29 ?o_1 inv)) )) (=> (forall ((?o_1 Int)) (! (let ((?v_521 (select2 Heap_28 ?o_1 FirstConsistentOwner))) (=> (= (select2 Heap_28 ?v_521 exposeVersion) (select2 Heap_29 ?v_521 exposeVersion)) (= ?v_521 (select2 Heap_29 ?o_1 FirstConsistentOwner)))) :pattern ((select2 Heap_29 ?o_1 FirstConsistentOwner)) )) (=> (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_524 (not (= ?o_1 stack0o_10))) (?v_522 (select2 Heap_28 ?o_1 ownerFrame)) (?v_523 (select2 Heap_28 ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap_28 ?o_1 allocated) true_1)) (not (or (= ?v_522 PeerGroupPlaceholder) (not (= (x (select2 Heap_28 ?v_523 inv) ?v_522) true_1)) (= (select2 Heap_28 ?v_523 localinv) (BaseClass ?v_522)))) (not (or ?v_524 (not (= (x (typeof stack0o_10) (DeclType ?f_1)) true_1)) (not (= (IncludedInModifiesStar ?f_1) true_1)))) (not (or ?v_524 (not (= ?f_1 exposeVersion)))))) (= (select2 Heap_28 ?o_1 ?f_1) (select2 Heap_29 ?o_1 ?f_1)))) :pattern ((select2 Heap_29 ?o_1 ?f_1)) )) (=> (= (HeapSucc Heap_28 Heap_29) true_1) (=> (forall ((?o_1 Int)) (! (=> (= (select2 Heap_28 ?o_1 allocated) true_1) (not (or (not (= (select2 Heap_28 ?o_1 inv) (select2 Heap_29 ?o_1 inv))) (not (= (select2 Heap_28 ?o_1 localinv) (select2 Heap_29 ?o_1 localinv)))))) :pattern ((select2 Heap_29 ?o_1 localinv))  :pattern ((select2 Heap_29 ?o_1 inv)) )) (=> (not (or (not (forall ((?o_1 Int)) (! (=> (= (select2 Heap_28 ?o_1 allocated) true_1) (= (select2 Heap_29 ?o_1 allocated) true_1)) :pattern ((select2 Heap_29 ?o_1 allocated)) ))) (not (forall ((?ot Int)) (! (let ((?v_525 (select2 Heap_28 ?ot ownerFrame))) (=> (not (or (not (= (select2 Heap_28 ?ot allocated) true_1)) (not (not (= ?v_525 PeerGroupPlaceholder))))) (not (or (not (= (select2 Heap_29 ?ot ownerRef) (select2 Heap_28 ?ot ownerRef))) (not (= (select2 Heap_29 ?ot ownerFrame) ?v_525)))))) :pattern ((select2 Heap_29 ?ot ownerFrame))  :pattern ((select2 Heap_29 ?ot ownerRef)) ))) (not (= (= (select2 Heap_28 BeingConstructed NonNullFieldsAreInitialized) true_1) (= (select2 Heap_29 BeingConstructed NonNullFieldsAreInitialized) true_1))))) (=> (forall ((?o_1 Int)) (! (= (select2 Heap_28 ?o_1 sharingMode) (select2 Heap_29 ?o_1 sharingMode)) :pattern ((select2 Heap_29 ?o_1 sharingMode)) )) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_135) (not (=> ?v_135 (not (or (not ?v_137) (not (=> ?v_137 (not (or (not ?v_139) (not (=> ?v_139 (not (or (not ?v_141) (not (=> ?v_141 (=> (= (IsHeap Heap_30) true_1) (=> (forall ((?p Int) (?F Int)) (! (=> (or (not (or (not (not (= ?F ownerRef))) (not (not (= ?F ownerFrame))))) (not (= (select2 Heap_29 ?p ownerRef) ?v_132)) (not (= (select2 Heap_29 ?p ownerFrame) ?v_131))) (= (select2 Heap_29 ?p ?F) (select2 Heap_30 ?p ?F))) :pattern ((select2 Heap_30 ?p ?F)) )) (=> (=> ?v_130 (= Heap_30 Heap_29)) (=> (=> ?v_142 (forall ((?p Int)) (! (=> (not (or (not (= (select2 Heap_29 ?p ownerRef) ?v_132)) (not (= (select2 Heap_29 ?p ownerFrame) ?v_131)))) (not (or (not (= (select2 Heap_30 ?p ownerRef) this)) (not (= (select2 Heap_30 ?p ownerFrame) Node))))) :pattern ((select2 Heap_30 ?p ownerRef))  :pattern ((select2 Heap_30 ?p ownerFrame)) ))) (=> (= (HeapSucc Heap_29 Heap_30) true_1) (=> (= Heap_31 (store2 Heap_30 this exposeVersion temp8_0)) (=> (= Heap_32 (store2 Heap_31 this Node_left call15066formal__result_0)) (not (or (not ?v_143) (not (=> ?v_143 (not (or (not ?v_146) (not (=> ?v_146 (not (or (not ?v_149) (not (=> ?v_149 (not (or (not ?v_151) (not (=> ?v_151 (not (or (not ?v_154) (not (=> ?v_154 (not (or (not ?v_156) (not (=> ?v_156 (not (or (not ?v_157) (not (=> ?v_157 (not (or (not ?v_159) (not (=> ?v_159 (not (or (not ?v_161) (not (=> ?v_161 (=> (= (IsHeap Heap_32) true_1) (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_15 ?v_148) (=> true (not (or (not (=> true (=> true (=> (not ?v_217) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_16 ?v_148) (not (or (not ?v_162) (not (=> ?v_162 (=> (= stack1i_14 (select2 Heap_32 stack1o_16 Node_small)) (=> true (=> true (=> (= stack1i_16 stack1i_14) (=> (= stack1o_17 stack1o_16) ?v_218))))))))))))))))))))) (not (=> true (=> true (=> ?v_217 (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1i_15 ?v_145) (=> true (=> true (=> (= stack1i_16 stack1i_15) (=> (= stack1o_17 stack1o_15) ?v_218)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> ?v_219 (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_0 ?v_220) (=> true (not (or (not (=> true (=> true (=> ?v_364 (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_1 ?v_221) (=> true (not (or (not (=> true (=> true (=> ?v_223 (=> true (=> true (=> true (=> true (=> true (=> (= local17_2 local17) (=> (= local7_2 local7) (=> (= stack1s_7 stack1s) (=> (= temp12_3 temp12) (=> (= stack1o_26 nullObject) (=> (= temp14_3 temp14) (=> (= stack0s_11 stack0s) (=> ?v_9 (=> (= temp5_3 temp5) (=> (= local10_2 local10) (=> (= temp8_2 temp8) (=> (= temp6_3 temp6) (=> (= temp0_2 temp0) (=> (= temp7_3 temp7) (=> (= stack0i_7 stack0i_0) (=> (= local14_1 local14) (=> (= temp4_2 temp4) (=> (= temp10_3 temp10) (=> (= temp18_3 temp18) (=> (= temp3_2 temp3) (=> (= stack0o_22 stack0o_1) (=> (= ActivityIndicator_7 ActivityIndicator) (=> (= temp1_3 temp1) (=> (= temp17_3 temp17) (=> (= stack1i_23 stack1i) (=> (= temp11_3 temp11) (=> (= temp19_3 temp19) (=> (= temp13_3 temp13) (=> (= temp2_1 temp2) (=> (= temp16_3 temp16) (=> (= stack2o_3 stack2o) (=> (= Heap_51 Heap) (=> (= temp15_2 temp15) (=> (= temp9_2 temp9) ?v_222))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> (not ?v_223) (=> true (=> true (=> true (=> (= (IsTokenForType stack1s_1 Node) true_1) (=> (= stack1o_7 ?v_94) (not (or ?v_3 (not (=> ?v_2 (not (or ?v_118 (not (=> ?v_27 (=> (= Heap_12 ?v_119) (=> (= Heap_13 (store2 Heap_12 this exposeVersion temp5_0)) (=> (= (IsHeap Heap_13) true_1) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_4 (select2 Heap_13 this Node_right)) (not (or (not ?v_224) (not (=> ?v_224 (=> (= stack0i_3 (select2 Heap_13 stack0o_4 Node_small)) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_227) (not (=> ?v_227 (=> (= Heap_14 (store2 Heap_13 this exposeVersion temp11_0)) (=> (= Heap_15 (store2 Heap_14 this Node_data stack0i_3)) (not (or (not ?v_228) (not (=> ?v_228 (not (or (not ?v_231) (not (=> ?v_231 (not (or (not ?v_234) (not (=> ?v_234 (not (or (not ?v_236) (not (=> ?v_236 (not (or (not ?v_239) (not (=> ?v_239 (not (or (not ?v_241) (not (=> ?v_241 (not (or (not ?v_242) (not (=> ?v_242 (not (or (not ?v_244) (not (=> ?v_244 (not (or (not ?v_246) (not (=> ?v_246 (=> (= (IsHeap Heap_15) true_1) (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_5 ?v_238) (not (or ?v_3 (not (=> ?v_2 (=> (= stack1i_7 ?v_230) (not (or (not ?v_247) (not (=> ?v_247 (=> (not (or (not (= (Is call16100formal__result Node) true_1)) (not (= (select2 Heap call16100formal__result allocated) true_1)))) (not (or (not ?v_248) (not (=> ?v_248 (not (or (not ?v_251) (not (=> ?v_251 (=> (= (IsHeap Heap_16) true_1) (=> (not (or (not (= (Is call16100formal__result_0 Node) true_1)) (not (= (select2 Heap_16 call16100formal__result_0 allocated) true_1)))) (=> (or ?v_252 ?v_257) (=> (=> ?v_252 (not (or (not (<= ?v_254 ?v_253)) (not (<= ?v_253 ?v_256))))) (=> (=> ?v_252 (not (or (not (<= ?v_254 ?v_255)) (not (<= ?v_255 ?v_256))))) (=> (= (select2 Heap_16 stack0o_5 Node_parent) (select2 Heap_15 stack0o_5 Node_parent)) (=> (or ?v_257 ?v_265) (=> (or ?v_257 ?v_263 (not (= (x (select2 Heap_16 ?v_259 inv) ?v_258) true_1)) (= (select2 Heap_16 ?v_259 localinv) (BaseClass ?v_258))) (=> (forall ((?o_1 Int)) (! (let ((?v_526 (typeof ?o_1))) (=> (not (or (not (not (= ?o_1 nullObject))) (not (not (= (select2 Heap_15 ?o_1 allocated) true_1))) (not (= (select2 Heap_16 ?o_1 allocated) true_1)))) (not (or (not (= (select2 Heap_16 ?o_1 inv) ?v_526)) (not (= (select2 Heap_16 ?o_1 localinv) ?v_526)))))) :pattern ((select2 Heap_16 ?o_1 localinv))  :pattern ((select2 Heap_16 ?o_1 inv)) )) (=> (forall ((?o_1 Int)) (! (let ((?v_527 (select2 Heap_15 ?o_1 FirstConsistentOwner))) (=> (= (select2 Heap_15 ?v_527 exposeVersion) (select2 Heap_16 ?v_527 exposeVersion)) (= ?v_527 (select2 Heap_16 ?o_1 FirstConsistentOwner)))) :pattern ((select2 Heap_16 ?o_1 FirstConsistentOwner)) )) (=> (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_530 (not (= ?o_1 stack0o_5))) (?v_528 (select2 Heap_15 ?o_1 ownerFrame)) (?v_529 (select2 Heap_15 ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap_15 ?o_1 allocated) true_1)) (not (or (= ?v_528 PeerGroupPlaceholder) (not (= (x (select2 Heap_15 ?v_529 inv) ?v_528) true_1)) (= (select2 Heap_15 ?v_529 localinv) (BaseClass ?v_528)))) (not (or ?v_530 (not (= (x (typeof stack0o_5) (DeclType ?f_1)) true_1)) (not (= (IncludedInModifiesStar ?f_1) true_1)))) (not (or ?v_530 (not (= ?f_1 exposeVersion)))))) (= (select2 Heap_15 ?o_1 ?f_1) (select2 Heap_16 ?o_1 ?f_1)))) :pattern ((select2 Heap_16 ?o_1 ?f_1)) )) (=> (= (HeapSucc Heap_15 Heap_16) true_1) (=> (forall ((?o_1 Int)) (! (=> (= (select2 Heap_15 ?o_1 allocated) true_1) (not (or (not (= (select2 Heap_15 ?o_1 inv) (select2 Heap_16 ?o_1 inv))) (not (= (select2 Heap_15 ?o_1 localinv) (select2 Heap_16 ?o_1 localinv)))))) :pattern ((select2 Heap_16 ?o_1 localinv))  :pattern ((select2 Heap_16 ?o_1 inv)) )) (=> (not (or (not (forall ((?o_1 Int)) (! (=> (= (select2 Heap_15 ?o_1 allocated) true_1) (= (select2 Heap_16 ?o_1 allocated) true_1)) :pattern ((select2 Heap_16 ?o_1 allocated)) ))) (not (forall ((?ot Int)) (! (let ((?v_531 (select2 Heap_15 ?ot ownerFrame))) (=> (not (or (not (= (select2 Heap_15 ?ot allocated) true_1)) (not (not (= ?v_531 PeerGroupPlaceholder))))) (not (or (not (= (select2 Heap_16 ?ot ownerRef) (select2 Heap_15 ?ot ownerRef))) (not (= (select2 Heap_16 ?ot ownerFrame) ?v_531)))))) :pattern ((select2 Heap_16 ?ot ownerFrame))  :pattern ((select2 Heap_16 ?ot ownerRef)) ))) (not (= (= (select2 Heap_15 BeingConstructed NonNullFieldsAreInitialized) true_1) (= (select2 Heap_16 BeingConstructed NonNullFieldsAreInitialized) true_1))))) (=> (forall ((?o_1 Int)) (! (= (select2 Heap_15 ?o_1 sharingMode) (select2 Heap_16 ?o_1 sharingMode)) :pattern ((select2 Heap_16 ?o_1 sharingMode)) )) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_262) (not (=> ?v_262 (not (or (not ?v_264) (not (=> ?v_264 (not (or (not ?v_266) (not (=> ?v_266 (not (or (not ?v_268) (not (=> ?v_268 (=> (= (IsHeap Heap_17) true_1) (=> (forall ((?p Int) (?F Int)) (! (=> (or (not (or (not (not (= ?F ownerRef))) (not (not (= ?F ownerFrame))))) (not (= (select2 Heap_16 ?p ownerRef) ?v_259)) (not (= (select2 Heap_16 ?p ownerFrame) ?v_258))) (= (select2 Heap_16 ?p ?F) (select2 Heap_17 ?p ?F))) :pattern ((select2 Heap_17 ?p ?F)) )) (=> (=> ?v_257 (= Heap_17 Heap_16)) (=> (=> ?v_269 (forall ((?p Int)) (! (=> (not (or (not (= (select2 Heap_16 ?p ownerRef) ?v_259)) (not (= (select2 Heap_16 ?p ownerFrame) ?v_258)))) (not (or (not (= (select2 Heap_17 ?p ownerRef) this)) (not (= (select2 Heap_17 ?p ownerFrame) Node))))) :pattern ((select2 Heap_17 ?p ownerRef))  :pattern ((select2 Heap_17 ?p ownerFrame)) ))) (=> (= (HeapSucc Heap_16 Heap_17) true_1) (=> (= Heap_18 (store2 Heap_17 this exposeVersion temp12_0)) (=> (= Heap_19 (store2 Heap_18 this Node_right call16100formal__result_0)) (not (or (not ?v_270) (not (=> ?v_270 (not (or (not ?v_273) (not (=> ?v_273 (not (or (not ?v_276) (not (=> ?v_276 (not (or (not ?v_278) (not (=> ?v_278 (not (or (not ?v_281) (not (=> ?v_281 (not (or (not ?v_283) (not (=> ?v_283 (not (or (not ?v_284) (not (=> ?v_284 (not (or (not ?v_286) (not (=> ?v_286 (not (or (not ?v_288) (not (=> ?v_288 (=> (= (IsHeap Heap_19) true_1) (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_8 ?v_280) (=> true (not (or (not (=> true (=> true (=> (not ?v_362) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_9 ?v_280) (not (or (not ?v_289) (not (=> ?v_289 (=> (= stack1i_8 (select2 Heap_19 stack1o_9 Node_large)) (=> true (=> true (=> (= stack1i_10 stack1i_8) (=> (= stack1o_10 stack1o_9) ?v_363))))))))))))))))))))) (not (=> true (=> true (=> ?v_362 (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1i_9 ?v_272) (=> true (=> true (=> (= stack1i_10 stack1i_9) (=> (= stack1o_10 stack1o_8) ?v_363))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> (not ?v_364) (=> true (=> true (=> true (=> (= (IsTokenForType stack1s_0 Node) true_1) (=> (= stack1o_0 ?v_94) (not (or ?v_3 (not (=> ?v_2 (not (or ?v_118 (not (=> ?v_27 (=> (= Heap_0 ?v_119) (=> (= Heap_1 (store2 Heap_0 this exposeVersion temp1_0)) (=> (= (IsHeap Heap_1) true_1) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_2 (select2 Heap_1 this Node_left)) (not (or (not ?v_365) (not (=> ?v_365 (=> (= stack0i_2 (select2 Heap_1 stack0o_2 Node_large)) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_368) (not (=> ?v_368 (=> (= Heap_2 (store2 Heap_1 this exposeVersion temp6_0)) (=> (= Heap_3 (store2 Heap_2 this Node_data stack0i_2)) (not (or (not ?v_369) (not (=> ?v_369 (not (or (not ?v_372) (not (=> ?v_372 (not (or (not ?v_375) (not (=> ?v_375 (not (or (not ?v_377) (not (=> ?v_377 (not (or (not ?v_380) (not (=> ?v_380 (not (or (not ?v_382) (not (=> ?v_382 (not (or (not ?v_383) (not (=> ?v_383 (not (or (not ?v_385) (not (=> ?v_385 (not (or (not ?v_387) (not (=> ?v_387 (=> (= (IsHeap Heap_3) true_1) (not (or ?v_3 (not (=> ?v_2 (=> (= stack0o_3 ?v_374) (not (or ?v_3 (not (=> ?v_2 (=> (= stack1i_0 ?v_371) (not (or (not ?v_388) (not (=> ?v_388 (=> (not (or (not (= (Is call14516formal__result Node) true_1)) (not (= (select2 Heap call14516formal__result allocated) true_1)))) (not (or (not ?v_389) (not (=> ?v_389 (not (or (not ?v_392) (not (=> ?v_392 (=> (= (IsHeap Heap_4) true_1) (=> (not (or (not (= (Is call14516formal__result_0 Node) true_1)) (not (= (select2 Heap_4 call14516formal__result_0 allocated) true_1)))) (=> (or ?v_393 ?v_398) (=> (=> ?v_393 (not (or (not (<= ?v_395 ?v_394)) (not (<= ?v_394 ?v_397))))) (=> (=> ?v_393 (not (or (not (<= ?v_395 ?v_396)) (not (<= ?v_396 ?v_397))))) (=> (= (select2 Heap_4 stack0o_3 Node_parent) (select2 Heap_3 stack0o_3 Node_parent)) (=> (or ?v_398 ?v_406) (=> (or ?v_398 ?v_404 (not (= (x (select2 Heap_4 ?v_400 inv) ?v_399) true_1)) (= (select2 Heap_4 ?v_400 localinv) (BaseClass ?v_399))) (=> (forall ((?o_1 Int)) (! (let ((?v_532 (typeof ?o_1))) (=> (not (or (not (not (= ?o_1 nullObject))) (not (not (= (select2 Heap_3 ?o_1 allocated) true_1))) (not (= (select2 Heap_4 ?o_1 allocated) true_1)))) (not (or (not (= (select2 Heap_4 ?o_1 inv) ?v_532)) (not (= (select2 Heap_4 ?o_1 localinv) ?v_532)))))) :pattern ((select2 Heap_4 ?o_1 localinv))  :pattern ((select2 Heap_4 ?o_1 inv)) )) (=> (forall ((?o_1 Int)) (! (let ((?v_533 (select2 Heap_3 ?o_1 FirstConsistentOwner))) (=> (= (select2 Heap_3 ?v_533 exposeVersion) (select2 Heap_4 ?v_533 exposeVersion)) (= ?v_533 (select2 Heap_4 ?o_1 FirstConsistentOwner)))) :pattern ((select2 Heap_4 ?o_1 FirstConsistentOwner)) )) (=> (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_536 (not (= ?o_1 stack0o_3))) (?v_534 (select2 Heap_3 ?o_1 ownerFrame)) (?v_535 (select2 Heap_3 ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap_3 ?o_1 allocated) true_1)) (not (or (= ?v_534 PeerGroupPlaceholder) (not (= (x (select2 Heap_3 ?v_535 inv) ?v_534) true_1)) (= (select2 Heap_3 ?v_535 localinv) (BaseClass ?v_534)))) (not (or ?v_536 (not (= (x (typeof stack0o_3) (DeclType ?f_1)) true_1)) (not (= (IncludedInModifiesStar ?f_1) true_1)))) (not (or ?v_536 (not (= ?f_1 exposeVersion)))))) (= (select2 Heap_3 ?o_1 ?f_1) (select2 Heap_4 ?o_1 ?f_1)))) :pattern ((select2 Heap_4 ?o_1 ?f_1)) )) (=> (= (HeapSucc Heap_3 Heap_4) true_1) (=> (forall ((?o_1 Int)) (! (=> (= (select2 Heap_3 ?o_1 allocated) true_1) (not (or (not (= (select2 Heap_3 ?o_1 inv) (select2 Heap_4 ?o_1 inv))) (not (= (select2 Heap_3 ?o_1 localinv) (select2 Heap_4 ?o_1 localinv)))))) :pattern ((select2 Heap_4 ?o_1 localinv))  :pattern ((select2 Heap_4 ?o_1 inv)) )) (=> (not (or (not (forall ((?o_1 Int)) (! (=> (= (select2 Heap_3 ?o_1 allocated) true_1) (= (select2 Heap_4 ?o_1 allocated) true_1)) :pattern ((select2 Heap_4 ?o_1 allocated)) ))) (not (forall ((?ot Int)) (! (let ((?v_537 (select2 Heap_3 ?ot ownerFrame))) (=> (not (or (not (= (select2 Heap_3 ?ot allocated) true_1)) (not (not (= ?v_537 PeerGroupPlaceholder))))) (not (or (not (= (select2 Heap_4 ?ot ownerRef) (select2 Heap_3 ?ot ownerRef))) (not (= (select2 Heap_4 ?ot ownerFrame) ?v_537)))))) :pattern ((select2 Heap_4 ?ot ownerFrame))  :pattern ((select2 Heap_4 ?ot ownerRef)) ))) (not (= (= (select2 Heap_3 BeingConstructed NonNullFieldsAreInitialized) true_1) (= (select2 Heap_4 BeingConstructed NonNullFieldsAreInitialized) true_1))))) (=> (forall ((?o_1 Int)) (! (= (select2 Heap_3 ?o_1 sharingMode) (select2 Heap_4 ?o_1 sharingMode)) :pattern ((select2 Heap_4 ?o_1 sharingMode)) )) (not (or ?v_3 (not (=> ?v_2 (not (or (not ?v_403) (not (=> ?v_403 (not (or (not ?v_405) (not (=> ?v_405 (not (or (not ?v_407) (not (=> ?v_407 (not (or (not ?v_409) (not (=> ?v_409 (=> (= (IsHeap Heap_5) true_1) (=> (forall ((?p Int) (?F Int)) (! (=> (or (not (or (not (not (= ?F ownerRef))) (not (not (= ?F ownerFrame))))) (not (= (select2 Heap_4 ?p ownerRef) ?v_400)) (not (= (select2 Heap_4 ?p ownerFrame) ?v_399))) (= (select2 Heap_4 ?p ?F) (select2 Heap_5 ?p ?F))) :pattern ((select2 Heap_5 ?p ?F)) )) (=> (=> ?v_398 (= Heap_5 Heap_4)) (=> (=> ?v_410 (forall ((?p Int)) (! (=> (not (or (not (= (select2 Heap_4 ?p ownerRef) ?v_400)) (not (= (select2 Heap_4 ?p ownerFrame) ?v_399)))) (not (or (not (= (select2 Heap_5 ?p ownerRef) this)) (not (= (select2 Heap_5 ?p ownerFrame) Node))))) :pattern ((select2 Heap_5 ?p ownerRef))  :pattern ((select2 Heap_5 ?p ownerFrame)) ))) (=> (= (HeapSucc Heap_4 Heap_5) true_1) (=> (= Heap_6 (store2 Heap_5 this exposeVersion temp7_0)) (=> (= Heap_7 (store2 Heap_6 this Node_left call14516formal__result_0)) (not (or (not ?v_411) (not (=> ?v_411 (not (or (not ?v_414) (not (=> ?v_414 (not (or (not ?v_417) (not (=> ?v_417 (not (or (not ?v_419) (not (=> ?v_419 (not (or (not ?v_422) (not (=> ?v_422 (not (or (not ?v_424) (not (=> ?v_424 (not (or (not ?v_425) (not (=> ?v_425 (not (or (not ?v_427) (not (=> ?v_427 (not (or (not ?v_429) (not (=> ?v_429 (=> (= (IsHeap Heap_7) true_1) (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_1 ?v_416) (=> true (not (or (not (=> true (=> true (=> (not ?v_495) (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1o_2 ?v_416) (not (or (not ?v_430) (not (=> ?v_430 (=> (= stack1i_1 (select2 Heap_7 stack1o_2 Node_small)) (=> true (=> true (=> (= stack1i_3 stack1i_1) (=> (= stack1o_3 stack1o_2) ?v_496))))))))))))))))))))) (not (=> true (=> true (=> ?v_495 (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_2 (=> (= stack1i_2 ?v_413) (=> true (=> true (=> (= stack1i_3 stack1i_2) (=> (= stack1o_3 stack1o_1) ?v_496)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
