(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    Spec# benchmarks.  Contributed by Leonardo de Moura and Michal Moskal.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun System_String_IsInterned_System_String_notnull (Int Int) Int)
(declare-fun stringLiteral18 () Int)
(declare-fun IsHeap (Int) Int)
(declare-fun allocated () Int)
(declare-fun StringLength (Int) Int)
(declare-fun IsNotNull (Int Int) Int)
(declare-fun System_String () Int)
(declare-fun System_Random () Int)
(declare-fun inv () Int)
(declare-fun BaseClass (Int) Int)
(declare-fun localinv () Int)
(declare-fun AsMutable (Int) Int)
(declare-fun IsImmutable (Int) Int)
(declare-fun AsDirectSubClass (Int Int) Int)
(declare-fun System_Object () Int)
(declare-fun System_IEquatable_1___System_String () Int)
(declare-fun AsInterface (Int) Int)
(declare-fun IsMemberlessType (Int) Int)
(declare-fun System_Collections_IEnumerable () Int)
(declare-fun System_Collections_Generic_IEnumerable_1___System_Char () Int)
(declare-fun System_IComparable_1___System_String () Int)
(declare-fun System_IConvertible () Int)
(declare-fun System_ICloneable () Int)
(declare-fun System_IComparable () Int)
(declare-fun AsImmutable (Int) Int)
(declare-fun System_Array () Int)
(declare-fun System_Collections_ICollection () Int)
(declare-fun System_Collections_IList () Int)
(declare-fun Sorting () Int)
(declare-fun System_String_Equals_System_String_System_String (Int Int Int) Int)
(declare-fun nullObject () Int)
(declare-fun StringEquals (Int Int) Int)
(declare-fun System_String_Equals_System_String (Int Int Int) Int)
(declare-fun max (Int Int) Int)
(declare-fun min (Int Int) Int)
(declare-fun shr (Int Int) Int)
(declare-fun x_1 (Int Int) Int)
(declare-fun shl (Int Int) Int)
(declare-fun int_2147483647 () Int)
(declare-fun or_1 (Int Int) Int)
(declare-fun and_1 (Int Int) Int)
(declare-fun x_2 (Int Int) Int)
(declare-fun IfThenElse (Int Int Int) Int)
(declare-fun IntToInt (Int Int Int) Int)
(declare-fun InRange (Int Int) Int)
(declare-fun System_Char () Int)
(declare-fun int_18446744073709551615 () Int)
(declare-fun System_UInt64 () Int)
(declare-fun int_9223372036854775807 () Int)
(declare-fun int_m9223372036854775808 () Int)
(declare-fun System_Int64 () Int)
(declare-fun int_4294967295 () Int)
(declare-fun System_UInt32 () Int)
(declare-fun int_m2147483648 () Int)
(declare-fun System_Int32 () Int)
(declare-fun System_UInt16 () Int)
(declare-fun System_Int16 () Int)
(declare-fun System_Byte () Int)
(declare-fun System_SByte () Int)
(declare-fun IsValueType (Int) Int)
(declare-fun System_IntPtr () Int)
(declare-fun System_UIntPtr () Int)
(declare-fun BoxTester (Int Int) Int)
(declare-fun Box (Int Int) Int)
(declare-fun Unbox (Int) Int)
(declare-fun UnboxedType (Int) Int)
(declare-fun typeof (Int) Int)
(declare-fun BoxFunc (Int Int Int Int) Int)
(declare-fun FirstConsistentOwner () Int)
(declare-fun ownerFrame () Int)
(declare-fun ownerRef () Int)
(declare-fun PeerGroupPlaceholder () Int)
(declare-fun AsPureObject (Int) Int)
(declare-fun FieldDependsOnFCO (Int Int Int) Int)
(declare-fun exposeVersion () Int)
(declare-fun AsElementsPeerField (Int Int) Int)
(declare-fun ElementProxy (Int Int) Int)
(declare-fun AsElementsRepField (Int Int Int) Int)
(declare-fun AsPeerField (Int) Int)
(declare-fun AsRepField (Int Int) Int)
(declare-fun AsOwner (Int Int) Int)
(declare-fun BeingConstructed () Int)
(declare-fun AsRangeField (Int Int) Int)
(declare-fun AsNonNullRefField (Int Int) Int)
(declare-fun NonNullFieldsAreInitialized () Int)
(declare-fun AsRefField (Int Int) Int)
(declare-fun Is (Int Int) Int)
(declare-fun DeclType (Int) Int)
(declare-fun ClassRepr (Int) Int)
(declare-fun IsAllocated (Int Int) Int)
(declare-fun ValueArrayGet (Int Int) Int)
(declare-fun RefArrayGet (Int Int) Int)
(declare-fun StructGet (Int Int) Int)
(declare-fun As (Int Int) Int)
(declare-fun TypeObject (Int) Int)
(declare-fun TypeName (Int) Int)
(declare-fun System_Type () Int)
(declare-fun System_Boolean () Int)
(declare-fun OneClassDown (Int Int) Int)
(declare-fun StructSet (Int Int Int) Int)
(declare-fun ElementProxyStruct (Int Int) Int)
(declare-fun elements () Int)
(declare-fun IntArray (Int Int) Int)
(declare-fun ValueArray (Int Int) Int)
(declare-fun NonNullRefArray (Int Int) Int)
(declare-fun ElementType (Int) Int)
(declare-fun RefArray (Int Int) Int)
(declare-fun NonNullRefArrayRaw (Int Int Int) Int)
(declare-fun Rank (Int) Int)
(declare-fun ArrayCategoryNonNullRef () Int)
(declare-fun ArrayCategory (Int) Int)
(declare-fun ArrayCategoryRef () Int)
(declare-fun ArrayCategoryInt () Int)
(declare-fun ArrayCategoryValue () Int)
(declare-fun UBound (Int Int) Int)
(declare-fun DimLength (Int Int) Int)
(declare-fun LBound (Int Int) Int)
(declare-fun Length (Int) Int)
(declare-fun IntArrayGet (Int Int) Int)
(declare-fun ArrayIndex (Int Int Int Int) Int)
(declare-fun ArrayIndexInvY (Int) Int)
(declare-fun ArrayIndexInvX (Int) Int)
(declare-fun RefArraySet (Int Int Int) Int)
(declare-fun IntArraySet (Int Int Int) Int)
(declare-fun ValueArraySet (Int Int Int) Int)
(declare-fun IncludedInModifiesStar (Int) Int)
(declare-fun IsStaticField (Int) Int)
(declare-fun IncludeInMainFrameCondition (Int) Int)
(declare-fun ClassReprInv (Int) Int)
(declare-fun SharingMode_LockProtected () Int)
(declare-fun SharingMode_Unshared () Int)
(declare-fun sharingMode () Int)
(declare-fun Heap_5 () Int)
(declare-fun Heap_1 () Int)
(declare-fun HeapSucc (Int Int) Int)
(declare-fun A_in () Int)
(declare-fun Heap () Int)
(declare-fun pv_in () Int)
(declare-fun r_in () Int)
(declare-fun j_1 () Int)
(declare-fun i_1 () Int)
(declare-fun l_in () Int)
(declare-fun stack3i_0 () Int)
(declare-fun stack3i_2 () Int)
(declare-fun j_0 () Int)
(declare-fun i_0 () Int)
(declare-fun local9_1 () Int)
(declare-fun tmp_1 () Int)
(declare-fun tmp_3 () Int)
(declare-fun stack1i_3 () Int)
(declare-fun stack0i_8 () Int)
(declare-fun stack2i_1 () Int)
(declare-fun stack2i_3 () Int)
(declare-fun stack2o_0 () Int)
(declare-fun stack2o_1 () Int)
(declare-fun stack0i_4 () Int)
(declare-fun local10_0 () Int)
(declare-fun local10_1 () Int)
(declare-fun Heap_2 () Int)
(declare-fun local12_0 () Int)
(declare-fun local12_1 () Int)
(declare-fun local13_0 () Int)
(declare-fun local13_1 () Int)
(declare-fun stack0i_2 () Int)
(declare-fun stack0i_5 () Int)
(declare-fun local9_0 () Int)
(declare-fun stack1i_1 () Int)
(declare-fun stack0i_3 () Int)
(declare-fun stack3i_1 () Int)
(declare-fun stack0i_7 () Int)
(declare-fun tmp_2 () Int)
(declare-fun stack1i_2 () Int)
(declare-fun stack2i_2 () Int)
(declare-fun stack0i_6 () Int)
(declare-fun Heap_4 () Int)
(declare-fun Heap_3 () Int)
(declare-fun result_0 () Int)
(declare-fun Heap_6 () Int)
(declare-fun tmp_4 () Int)
(declare-fun j_2 () Int)
(declare-fun i_2 () Int)
(declare-fun SS_Display_Return_Local_0 () Int)
(declare-fun stack2i_4 () Int)
(declare-fun local13_2 () Int)
(declare-fun stack0o_0 () Int)
(declare-fun stack0o_1 () Int)
(declare-fun local9_2 () Int)
(declare-fun stack1i_0 () Int)
(declare-fun stack1i_4 () Int)
(declare-fun local12_2 () Int)
(declare-fun local10_2 () Int)
(declare-fun stack0i_9 () Int)
(declare-fun stack3i_3 () Int)
(declare-fun stack2o_2 () Int)
(declare-fun return_value_0 () Int)
(declare-fun stack0i_0 () Int)
(declare-fun tmp_0 () Int)
(declare-fun Heap_0 () Int)
(declare-fun stack2i_0 () Int)
(declare-fun PurityAxiomsCanBeAssumed () Int)
(declare-fun local13 () Int)
(declare-fun local12 () Int)
(declare-fun SS_Display_Return_Local () Int)
(declare-fun local10 () Int)
(declare-fun return_value () Int)
(declare-fun local9 () Int)
(declare-fun tmp () Int)
(declare-fun j () Int)
(declare-fun i () Int)
(declare-fun pv () Int)
(declare-fun r () Int)
(declare-fun l () Int)
(declare-fun A () Int)
(declare-fun result () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolIff ?x_3 ?y) true_1) (= (= ?x_3 true_1) (= ?y true_1))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolImplies ?x_3 ?y) true_1) (=> (= ?x_3 true_1) (= ?y true_1))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolAnd ?x_3 ?y) true_1) (not (or (not (= ?x_3 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_3 Int) (?y Int)) (= (= (boolOr ?x_3 ?y) true_1) (or (= ?x_3 true_1) (= ?y true_1))))) (not (forall ((?x_3 Int)) (! (= (= (boolNot ?x_3) true_1) (not (= ?x_3 true_1))) :pattern ((boolNot ?x_3)) ))) (not (forall ((?x_3 Int) (?y Int)) (= (= (anyEqual ?x_3 ?y) true_1) (= ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (! (= (= (anyNeq ?x_3 ?y) true_1) (not (= ?x_3 ?y))) :pattern ((anyNeq ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intLess ?x_3 ?y) true_1) (< ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intAtMost ?x_3 ?y) true_1) (<= ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intAtLeast ?x_3 ?y) true_1) (>= ?x_3 ?y)))) (not (forall ((?x_3 Int) (?y Int)) (= (= (intGreater ?x_3 ?y) true_1) (> ?x_3 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (let ((?v_3 (BaseClass System_Random)) (?v_2 (BaseClass System_String)) (?v_1 (BaseClass System_Array)) (?v_0 (BaseClass Sorting))) (not (or (not (distinct allocated elements inv localinv exposeVersion sharingMode SharingMode_Unshared SharingMode_LockProtected ownerRef ownerFrame PeerGroupPlaceholder ArrayCategoryValue ArrayCategoryInt ArrayCategoryRef ArrayCategoryNonNullRef System_Array System_Boolean System_Object System_Type NonNullFieldsAreInitialized System_String FirstConsistentOwner System_SByte System_Byte System_Int16 System_UInt16 System_Int32 System_UInt32 System_Int64 System_UInt64 System_Char System_UIntPtr System_IntPtr System_Random System_Collections_ICollection System_ICloneable System_Collections_IList System_IEquatable_1___System_String System_IComparable_1___System_String System_Collections_IEnumerable System_IConvertible System_Collections_Generic_IEnumerable_1___System_Char Sorting System_IComparable stringLiteral18)) (not (= (DeclType elements) System_Object)) (not (= (DeclType exposeVersion) System_Object)) (not (forall ((?c Int)) (! (= (ClassReprInv (ClassRepr ?c)) ?c) :pattern ((ClassRepr ?c)) ))) (not (forall ((?T Int)) (not (= (x (typeof (ClassRepr ?T)) System_Object) true_1)))) (not (forall ((?T Int)) (not (= (ClassRepr ?T) nullObject)))) (not (forall ((?T Int) (?h_1 Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (select2 ?h_1 (ClassRepr ?T) ownerFrame) PeerGroupPlaceholder)) :pattern ((select2 ?h_1 (ClassRepr ?T) ownerFrame)) ))) (not (= (IncludeInMainFrameCondition allocated) true_1)) (not (= (IncludeInMainFrameCondition elements) true_1)) (not (not (= (IncludeInMainFrameCondition inv) true_1))) (not (not (= (IncludeInMainFrameCondition localinv) true_1))) (not (= (IncludeInMainFrameCondition ownerRef) true_1)) (not (= (IncludeInMainFrameCondition ownerFrame) true_1)) (not (= (IncludeInMainFrameCondition exposeVersion) true_1)) (not (not (= (IncludeInMainFrameCondition FirstConsistentOwner) true_1))) (not (not (= (IsStaticField allocated) true_1))) (not (not (= (IsStaticField elements) true_1))) (not (not (= (IsStaticField inv) true_1))) (not (not (= (IsStaticField localinv) true_1))) (not (not (= (IsStaticField exposeVersion) true_1))) (not (not (= (IncludedInModifiesStar ownerRef) true_1))) (not (not (= (IncludedInModifiesStar ownerFrame) true_1))) (not (= (IncludedInModifiesStar exposeVersion) true_1)) (not (= (IncludedInModifiesStar elements) true_1)) (not (forall ((?A Int) (?i Int) (?x_3 Int)) (= (ValueArrayGet (ValueArraySet ?A ?i ?x_3) ?i) ?x_3))) (not (forall ((?A Int) (?i Int) (?j Int) (?x_3 Int)) (=> (not (= ?i ?j)) (= (ValueArrayGet (ValueArraySet ?A ?i ?x_3) ?j) (ValueArrayGet ?A ?j))))) (not (forall ((?A Int) (?i Int) (?x_3 Int)) (= (IntArrayGet (IntArraySet ?A ?i ?x_3) ?i) ?x_3))) (not (forall ((?A Int) (?i Int) (?j Int) (?x_3 Int)) (=> (not (= ?i ?j)) (= (IntArrayGet (IntArraySet ?A ?i ?x_3) ?j) (IntArrayGet ?A ?j))))) (not (forall ((?A Int) (?i Int) (?x_3 Int)) (= (RefArrayGet (RefArraySet ?A ?i ?x_3) ?i) ?x_3))) (not (forall ((?A Int) (?i Int) (?j Int) (?x_3 Int)) (=> (not (= ?i ?j)) (= (RefArrayGet (RefArraySet ?A ?i ?x_3) ?j) (RefArrayGet ?A ?j))))) (not (forall ((?a Int) (?d Int) (?x_3 Int) (?y Int)) (! (= (ArrayIndexInvX (ArrayIndex ?a ?d ?x_3 ?y)) ?x_3) :pattern ((ArrayIndex ?a ?d ?x_3 ?y)) ))) (not (forall ((?a Int) (?d Int) (?x_3 Int) (?y Int)) (! (= (ArrayIndexInvY (ArrayIndex ?a ?d ?x_3 ?y)) ?y) :pattern ((ArrayIndex ?a ?d ?x_3 ?y)) ))) (not (forall ((?a Int) (?i Int) (?heap Int)) (! (=> (= (IsHeap ?heap) true_1) (= (InRange (IntArrayGet (select2 ?heap ?a elements) ?i) (ElementType (typeof ?a))) true_1)) :pattern ((IntArrayGet (select2 ?heap ?a elements) ?i)) ))) (not (forall ((?a Int) (?i Int) (?heap Int)) (! (let ((?v_4 (RefArrayGet (select2 ?heap ?a elements) ?i))) (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (not (= ?v_4 nullObject))))) (= (x (typeof ?v_4) (ElementType (typeof ?a))) true_1))) :pattern ((typeof (RefArrayGet (select2 ?heap ?a elements) ?i))) ))) (not (forall ((?a Int) (?T Int) (?i Int) (?r Int) (?heap Int)) (! (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (= (x (typeof ?a) (NonNullRefArray ?T ?r)) true_1)))) (not (= (RefArrayGet (select2 ?heap ?a elements) ?i) nullObject))) :pattern ((x (typeof ?a) (NonNullRefArray ?T ?r)) (RefArrayGet (select2 ?heap ?a elements) ?i)) ))) (not (forall ((?a Int)) (<= 1 (Rank ?a)))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (RefArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (RefArray ?T ?r))) ))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (NonNullRefArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (NonNullRefArray ?T ?r))) ))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (ValueArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (ValueArray ?T ?r))) ))) (not (forall ((?a Int) (?T Int) (?r Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (= (x (typeof ?a) (IntArray ?T ?r)) true_1)))) (= (Rank ?a) ?r)) :pattern ((x (typeof ?a) (IntArray ?T ?r))) ))) (not (forall ((?a Int)) (! (let ((?v_5 (Length ?a))) (not (or (not (<= 0 ?v_5)) (not (<= ?v_5 int_2147483647))))) :pattern ((Length ?a)) ))) (not (forall ((?a Int) (?i Int)) (<= 0 (DimLength ?a ?i)))) (not (forall ((?a Int)) (! (=> (= (Rank ?a) 1) (= (DimLength ?a 0) (Length ?a))) :pattern ((DimLength ?a 0)) ))) (not (forall ((?a Int) (?i Int)) (! (= (LBound ?a ?i) 0) :pattern ((LBound ?a ?i)) ))) (not (forall ((?a Int) (?i Int)) (! (= (UBound ?a ?i) (- (DimLength ?a ?i) 1)) :pattern ((UBound ?a ?i)) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (ValueArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryValue)) :pattern ((x ?T (ValueArray ?ET ?r))) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (IntArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryInt)) :pattern ((x ?T (IntArray ?ET ?r))) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (RefArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryRef)) :pattern ((x ?T (RefArray ?ET ?r))) ))) (not (forall ((?T Int) (?ET Int) (?r Int)) (! (=> (= (x ?T (NonNullRefArray ?ET ?r)) true_1) (= (ArrayCategory ?T) ArrayCategoryNonNullRef)) :pattern ((x ?T (NonNullRefArray ?ET ?r))) ))) (not (= (x System_Array System_Object) true_1)) (not (forall ((?T Int) (?r Int)) (! (let ((?v_6 (ValueArray ?T ?r))) (not (or (not (= (x ?v_6 ?v_6) true_1)) (not (= (x ?v_6 System_Array) true_1))))) :pattern ((ValueArray ?T ?r)) ))) (not (forall ((?T Int) (?r Int)) (! (let ((?v_7 (IntArray ?T ?r))) (not (or (not (= (x ?v_7 ?v_7) true_1)) (not (= (x ?v_7 System_Array) true_1))))) :pattern ((IntArray ?T ?r)) ))) (not (forall ((?T Int) (?r Int)) (! (let ((?v_8 (RefArray ?T ?r))) (not (or (not (= (x ?v_8 ?v_8) true_1)) (not (= (x ?v_8 System_Array) true_1))))) :pattern ((RefArray ?T ?r)) ))) (not (forall ((?T Int) (?r Int)) (! (let ((?v_9 (NonNullRefArray ?T ?r))) (not (or (not (= (x ?v_9 ?v_9) true_1)) (not (= (x ?v_9 System_Array) true_1))))) :pattern ((NonNullRefArray ?T ?r)) ))) (not (forall ((?array Int) (?elementType Int) (?rank Int)) (! (let ((?v_10 (typeof ?array))) (=> (= (NonNullRefArrayRaw ?array ?elementType ?rank) true_1) (not (or (not (= (x ?v_10 System_Array) true_1)) (not (= (Rank ?array) ?rank)) (not (= (x ?elementType (ElementType ?v_10)) true_1)))))) :pattern ((NonNullRefArrayRaw ?array ?elementType ?rank)) ))) (not (forall ((?T Int) (?U_1 Int) (?r Int)) (=> (= (x ?U_1 ?T) true_1) (= (x (RefArray ?U_1 ?r) (RefArray ?T ?r)) true_1)))) (not (forall ((?T Int) (?U_1 Int) (?r Int)) (=> (= (x ?U_1 ?T) true_1) (= (x (NonNullRefArray ?U_1 ?r) (NonNullRefArray ?T ?r)) true_1)))) (not (forall ((?A Int) (?r Int)) (= (ElementType (ValueArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int)) (= (ElementType (IntArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int)) (= (ElementType (RefArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int)) (= (ElementType (NonNullRefArray ?A ?r)) ?A))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_11 (ElementType ?T))) (=> (= (x ?T (RefArray ?A ?r)) true_1) (not (or (not (not (= ?T ?A))) (not (= ?T (RefArray ?v_11 ?r))) (not (= (x ?v_11 ?A) true_1)))))) :pattern ((x ?T (RefArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_12 (ElementType ?T))) (=> (= (x ?T (NonNullRefArray ?A ?r)) true_1) (not (or (not (not (= ?T ?A))) (not (= ?T (NonNullRefArray ?v_12 ?r))) (not (= (x ?v_12 ?A) true_1)))))) :pattern ((x ?T (NonNullRefArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_13 (ValueArray ?A ?r))) (=> (= (x ?T ?v_13) true_1) (= ?T ?v_13))) :pattern ((x ?T (ValueArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_14 (IntArray ?A ?r))) (=> (= (x ?T ?v_14) true_1) (= ?T ?v_14))) :pattern ((x ?T (IntArray ?A ?r))) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_15 (ElementType ?T))) (=> (= (x (RefArray ?A ?r) ?T) true_1) (or (= (x System_Array ?T) true_1) (not (or (not (= ?T (RefArray ?v_15 ?r))) (not (= (x ?A ?v_15) true_1))))))) :pattern ((x (RefArray ?A ?r) ?T)) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_16 (ElementType ?T))) (=> (= (x (NonNullRefArray ?A ?r) ?T) true_1) (or (= (x System_Array ?T) true_1) (not (or (not (= ?T (NonNullRefArray ?v_16 ?r))) (not (= (x ?A ?v_16) true_1))))))) :pattern ((x (NonNullRefArray ?A ?r) ?T)) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_17 (ValueArray ?A ?r))) (=> (= (x ?v_17 ?T) true_1) (or (= (x System_Array ?T) true_1) (= ?T ?v_17)))) :pattern ((x (ValueArray ?A ?r) ?T)) ))) (not (forall ((?A Int) (?r Int) (?T Int)) (! (let ((?v_18 (IntArray ?A ?r))) (=> (= (x ?v_18 ?T) true_1) (or (= (x System_Array ?T) true_1) (= ?T ?v_18)))) :pattern ((x (IntArray ?A ?r) ?T)) ))) (not (forall ((?a Int) (?i Int) (?heap Int)) (! (let ((?v_20 (ElementProxy ?a (- 0 1))) (?v_19 (RefArrayGet (select2 ?heap ?a elements) ?i))) (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (= (x (typeof ?a) System_Array) true_1)))) (or (= ?v_19 nullObject) (= (IsImmutable (typeof ?v_19)) true_1) (not (or (not (= (select2 ?heap ?v_19 ownerRef) (select2 ?heap ?v_20 ownerRef))) (not (= (select2 ?heap ?v_19 ownerFrame) (select2 ?heap ?v_20 ownerFrame)))))))) :pattern ((select2 ?heap (RefArrayGet (select2 ?heap ?a elements) ?i) ownerRef))  :pattern ((select2 ?heap (RefArrayGet (select2 ?heap ?a elements) ?i) ownerFrame)) ))) (not (forall ((?a Int) (?heap Int)) (! (=> (not (or (not (= (IsHeap ?heap) true_1)) (not (= (IsAllocated ?heap ?a) true_1)) (not (= (x (typeof ?a) System_Array) true_1)))) (= (IsAllocated ?heap (ElementProxy ?a (- 0 1))) true_1)) :pattern ((IsAllocated ?heap ?a)) ))) (not (forall ((?o Int) (?pos Int)) (! (= (typeof (ElementProxy ?o ?pos)) System_Object) :pattern ((typeof (ElementProxy ?o ?pos))) ))) (not (forall ((?o Int) (?pos Int)) (! (= (typeof (ElementProxyStruct ?o ?pos)) System_Object) :pattern ((typeof (ElementProxyStruct ?o ?pos))) ))) (not (forall ((?s Int) (?f Int) (?x_3 Int)) (= (StructGet (StructSet ?s ?f ?x_3) ?f) ?x_3))) (not (forall ((?s Int) (?f Int) (|?f'| Int) (?x_3 Int)) (=> (not (= ?f |?f'|)) (= (StructGet (StructSet ?s ?f ?x_3) |?f'|) (StructGet ?s |?f'|))))) (not (forall ((?T Int)) (! (let ((?v_21 (BaseClass ?T))) (not (or (not (= (x ?T ?v_21) true_1)) (not (=> (not (= ?T System_Object)) (not (= ?T ?v_21))))))) :pattern ((BaseClass ?T)) ))) (not (forall ((?A Int) (?B Int) (?C Int)) (! (=> (= (x ?C (AsDirectSubClass ?B ?A)) true_1) (= (OneClassDown ?C ?A) ?B)) :pattern ((x ?C (AsDirectSubClass ?B ?A))) ))) (not (forall ((?T Int)) (=> (= (IsValueType ?T) true_1) (not (or (not (forall ((?U_1 Int)) (=> (= (x ?T ?U_1) true_1) (= ?T ?U_1)))) (not (forall ((?U_1 Int)) (=> (= (x ?U_1 ?T) true_1) (= ?T ?U_1))))))))) (not (= (IsValueType System_Boolean) true_1)) (not (= (x System_Type System_Object) true_1)) (not (forall ((?T Int)) (! (= (IsNotNull (TypeObject ?T) System_Type) true_1) :pattern ((TypeObject ?T)) ))) (not (forall ((?T Int)) (! (= (TypeName (TypeObject ?T)) ?T) :pattern ((TypeObject ?T)) ))) (not (forall ((?o Int) (?T Int)) (! (= (= (Is ?o ?T) true_1) (or (= ?o nullObject) (= (x (typeof ?o) ?T) true_1))) :pattern ((Is ?o ?T)) ))) (not (forall ((?o Int) (?T Int)) (! (= (= (IsNotNull ?o ?T) true_1) (not (or (not (not (= ?o nullObject))) (not (= (Is ?o ?T) true_1))))) :pattern ((IsNotNull ?o ?T)) ))) (not (forall ((?o Int) (?T Int)) (=> (= (Is ?o ?T) true_1) (= (As ?o ?T) ?o)))) (not (forall ((?o Int) (?T Int)) (=> (not (= (Is ?o ?T) true_1)) (= (As ?o ?T) nullObject)))) (not (forall ((?h_1 Int) (?o Int)) (! (let ((?v_22 (typeof ?o))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (= (x ?v_22 System_Array) true_1)))) (not (or (not (= (select2 ?h_1 ?o inv) ?v_22)) (not (= (select2 ?h_1 ?o localinv) ?v_22)))))) :pattern ((x (typeof ?o) System_Array) (select2 ?h_1 ?o inv)) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int)) (! (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (= (select2 ?h_1 ?o allocated) true_1)))) (= (IsAllocated ?h_1 (select2 ?h_1 ?o ?f)) true_1)) :pattern ((IsAllocated ?h_1 (select2 ?h_1 ?o ?f))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int)) (! (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (= (select2 ?h_1 ?o allocated) true_1)))) (= (select2 ?h_1 (select2 ?h_1 ?o ?f) allocated) true_1)) :pattern ((select2 ?h_1 (select2 ?h_1 ?o ?f) allocated)) ))) (not (forall ((?h_1 Int) (?s Int) (?f Int)) (! (=> (= (IsAllocated ?h_1 ?s) true_1) (= (IsAllocated ?h_1 (StructGet ?s ?f)) true_1)) :pattern ((IsAllocated ?h_1 (StructGet ?s ?f))) ))) (not (forall ((?h_1 Int) (?e Int) (?i Int)) (! (=> (= (IsAllocated ?h_1 ?e) true_1) (= (IsAllocated ?h_1 (RefArrayGet ?e ?i)) true_1)) :pattern ((IsAllocated ?h_1 (RefArrayGet ?e ?i))) ))) (not (forall ((?h_1 Int) (?e Int) (?i Int)) (! (=> (= (IsAllocated ?h_1 ?e) true_1) (= (IsAllocated ?h_1 (ValueArrayGet ?e ?i)) true_1)) :pattern ((IsAllocated ?h_1 (ValueArrayGet ?e ?i))) ))) (not (forall ((?h_1 Int) (?o Int)) (! (=> (= (IsAllocated ?h_1 ?o) true_1) (= (select2 ?h_1 ?o allocated) true_1)) :pattern ((select2 ?h_1 ?o allocated)) ))) (not (forall ((?h_1 Int) (?c Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (select2 ?h_1 (ClassRepr ?c) allocated) true_1)) :pattern ((select2 ?h_1 (ClassRepr ?c) allocated)) ))) (not (= (DeclType NonNullFieldsAreInitialized) System_Object)) (not (forall ((?f Int) (?T Int)) (! (=> (= (AsNonNullRefField ?f ?T) ?f) (= (AsRefField ?f ?T) ?f)) :pattern ((AsNonNullRefField ?f ?T)) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (Is (select2 ?h_1 ?o (AsRefField ?f ?T)) ?T) true_1)) :pattern ((select2 ?h_1 ?o (AsRefField ?f ?T))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (or (not (= ?o BeingConstructed)) (= (= (select2 ?h_1 BeingConstructed NonNullFieldsAreInitialized) true_1) true))))) (not (= (select2 ?h_1 ?o (AsNonNullRefField ?f ?T)) nullObject))) :pattern ((select2 ?h_1 ?o (AsNonNullRefField ?f ?T))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (=> (= (IsHeap ?h_1) true_1) (= (InRange (select2 ?h_1 ?o (AsRangeField ?f ?T)) ?T) true_1)) :pattern ((select2 ?h_1 ?o (AsRangeField ?f ?T))) ))) (not (forall ((?o Int)) (! (not (= (IsMemberlessType (typeof ?o)) true_1)) :pattern ((IsMemberlessType (typeof ?o))) ))) (not (forall ((?J Int) (?s Int) (?b Int)) (! (let ((?v_24 (AsInterface ?J)) (?v_23 (Box ?s ?b))) (=> (not (or (not (= ?v_24 ?J)) (not (= ?v_23 ?b)) (not (= (x (UnboxedType ?v_23) ?v_24) true_1)))) (= (x (typeof ?b) ?J) true_1))) :pattern ((x (UnboxedType (Box ?s ?b)) (AsInterface ?J))) ))) (not (not (= (IsImmutable System_Object) true_1))) (not (forall ((?T Int) (?U_1 Int)) (! (=> (= (x ?U_1 (AsImmutable ?T)) true_1) (not (or (not (= (IsImmutable ?U_1) true_1)) (not (= (AsImmutable ?U_1) ?U_1))))) :pattern ((x ?U_1 (AsImmutable ?T))) ))) (not (forall ((?T Int) (?U_1 Int)) (! (=> (= (x ?U_1 (AsMutable ?T)) true_1) (not (or (not (not (= (IsImmutable ?U_1) true_1))) (not (= (AsMutable ?U_1) ?U_1))))) :pattern ((x ?U_1 (AsMutable ?T))) ))) (not (forall ((?o Int) (?T Int)) (! (=> (not (or (not (not (= ?o nullObject))) (not (not (= ?o BeingConstructed))) (not (= (x (typeof ?o) (AsImmutable ?T)) true_1)))) (forall ((?h_1 Int)) (! (let ((?v_25 (typeof ?o))) (=> (= (IsHeap ?h_1) true_1) (not (or (not (= (select2 ?h_1 ?o inv) ?v_25)) (not (= (select2 ?h_1 ?o localinv) ?v_25)) (not (= (select2 ?h_1 ?o ownerFrame) PeerGroupPlaceholder)) (not (= (AsOwner ?o (select2 ?h_1 ?o ownerRef)) ?o)) (not (forall ((?t Int)) (! (=> (= (AsOwner ?o (select2 ?h_1 ?t ownerRef)) ?o) (or (= ?t ?o) (not (= (select2 ?h_1 ?t ownerFrame) PeerGroupPlaceholder)))) :pattern ((AsOwner ?o (select2 ?h_1 ?t ownerRef))) ))))))) :pattern ((IsHeap ?h_1)) ))) :pattern ((x (typeof ?o) (AsImmutable ?T))) ))) (not (forall ((?s Int)) (! (<= 0 (StringLength ?s)) :pattern ((StringLength ?s)) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int)) (! (let ((?v_26 (select2 ?h_1 ?o (AsRepField ?f ?T)))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_26 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_26 ownerRef) ?o)) (not (= (select2 ?h_1 ?v_26 ownerFrame) ?T)))))) :pattern ((select2 ?h_1 ?o (AsRepField ?f ?T))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int)) (! (let ((?v_27 (select2 ?h_1 ?o (AsPeerField ?f)))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_27 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_27 ownerRef) (select2 ?h_1 ?o ownerRef))) (not (= (select2 ?h_1 ?v_27 ownerFrame) (select2 ?h_1 ?o ownerFrame))))))) :pattern ((select2 ?h_1 ?o (AsPeerField ?f))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?T Int) (?i Int)) (! (let ((?v_28 (select2 ?h_1 ?o (AsElementsRepField ?f ?T ?i)))) (let ((?v_29 (ElementProxy ?v_28 ?i))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_28 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_29 ownerRef) ?o)) (not (= (select2 ?h_1 ?v_29 ownerFrame) ?T))))))) :pattern ((select2 ?h_1 ?o (AsElementsRepField ?f ?T ?i))) ))) (not (forall ((?h_1 Int) (?o Int) (?f Int) (?i Int)) (! (let ((?v_30 (select2 ?h_1 ?o (AsElementsPeerField ?f ?i)))) (let ((?v_31 (ElementProxy ?v_30 ?i))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_30 nullObject))))) (not (or (not (= (select2 ?h_1 ?v_31 ownerRef) (select2 ?h_1 ?o ownerRef))) (not (= (select2 ?h_1 ?v_31 ownerFrame) (select2 ?h_1 ?o ownerFrame)))))))) :pattern ((select2 ?h_1 ?o (AsElementsPeerField ?f ?i))) ))) (not (forall ((?h_1 Int) (?o Int)) (! (let ((?v_34 (typeof ?o)) (?v_32 (select2 ?h_1 ?o ownerFrame)) (?v_33 (select2 ?h_1 ?o ownerRef))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?v_32 PeerGroupPlaceholder))) (not (= (x (select2 ?h_1 ?v_33 inv) ?v_32) true_1)) (not (not (= (select2 ?h_1 ?v_33 localinv) (BaseClass ?v_32)))))) (not (or (not (= (select2 ?h_1 ?o inv) ?v_34)) (not (= (select2 ?h_1 ?o localinv) ?v_34)))))) :pattern ((x (select2 ?h_1 (select2 ?h_1 ?o ownerRef) inv) (select2 ?h_1 ?o ownerFrame))) ))) (not (forall ((?o Int) (?f Int) (?h_1 Int)) (! (let ((?v_35 (select2 ?h_1 ?o ownerFrame)) (?v_36 (select2 ?h_1 ?o ownerRef))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (= (= (select2 ?h_1 ?o allocated) true_1) true)) (not (= (AsPureObject ?o) ?o)) (not (not (= ?v_35 PeerGroupPlaceholder))) (not (= (x (select2 ?h_1 ?v_36 inv) ?v_35) true_1)) (not (not (= (select2 ?h_1 ?v_36 localinv) (BaseClass ?v_35)))))) (= (select2 ?h_1 ?o ?f) (FieldDependsOnFCO ?o ?f (select2 ?h_1 (select2 ?h_1 ?o FirstConsistentOwner) exposeVersion))))) :pattern ((select2 ?h_1 (AsPureObject ?o) ?f)) ))) (not (forall ((?o Int) (?h_1 Int)) (! (let ((?v_39 (select2 ?h_1 ?o FirstConsistentOwner))) (let ((?v_40 (select2 ?h_1 ?v_39 ownerFrame)) (?v_41 (select2 ?h_1 ?v_39 ownerRef)) (?v_37 (select2 ?h_1 ?o ownerFrame)) (?v_38 (select2 ?h_1 ?o ownerRef))) (=> (not (or (not (= (IsHeap ?h_1) true_1)) (not (not (= ?o nullObject))) (not (= (= (select2 ?h_1 ?o allocated) true_1) true)) (not (not (= ?v_37 PeerGroupPlaceholder))) (not (= (x (select2 ?h_1 ?v_38 inv) ?v_37) true_1)) (not (not (= (select2 ?h_1 ?v_38 localinv) (BaseClass ?v_37)))))) (not (or (not (not (= ?v_39 nullObject))) (not (= (= (select2 ?h_1 ?v_39 allocated) true_1) true)) (not (or (= ?v_40 PeerGroupPlaceholder) (not (= (x (select2 ?h_1 ?v_41 inv) ?v_40) true_1)) (= (select2 ?h_1 ?v_41 localinv) (BaseClass ?v_40))))))))) :pattern ((select2 ?h_1 ?o FirstConsistentOwner)) ))) (not (forall ((?value Int) (?typ Int) (?occurrence Int) (?activity Int)) (! (let ((?v_42 (BoxFunc ?value ?typ ?occurrence ?activity))) (not (or (not (= (Box ?value ?v_42) ?v_42)) (not (= (UnboxedType ?v_42) ?typ))))) :pattern ((BoxFunc ?value ?typ ?occurrence ?activity)) ))) (not (forall ((?x_3 Int) (?typ Int) (?occurrence Int) (?activity Int)) (=> (not (= (IsValueType (UnboxedType ?x_3)) true_1)) (= (BoxFunc ?x_3 ?typ ?occurrence ?activity) ?x_3)))) (not (forall ((?x_3 Int) (?p Int)) (! (= (Unbox (Box ?x_3 ?p)) ?x_3) :pattern ((Unbox (Box ?x_3 ?p))) ))) (not (forall ((?p Int)) (! (=> (= (IsValueType (UnboxedType ?p)) true_1) (forall ((?heap Int) (?x_3 Int)) (! (let ((?v_43 (Box ?x_3 ?p))) (let ((?v_44 (typeof ?v_43))) (=> (= (IsHeap ?heap) true_1) (not (or (not (= (select2 ?heap ?v_43 inv) ?v_44)) (not (= (select2 ?heap ?v_43 localinv) ?v_44))))))) :pattern ((select2 ?heap (Box ?x_3 ?p) inv)) ))) :pattern ((IsValueType (UnboxedType ?p))) ))) (not (forall ((?x_3 Int) (?p Int)) (! (let ((?v_45 (Box ?x_3 ?p))) (=> (not (or (not (= (x (UnboxedType ?v_45) System_Object) true_1)) (not (= ?v_45 ?p)))) (= ?x_3 ?p))) :pattern ((x (UnboxedType (Box ?x_3 ?p)) System_Object)) ))) (not (forall ((?p Int) (?typ Int)) (! (= (= (UnboxedType ?p) ?typ) (not (= (BoxTester ?p ?typ) nullObject))) :pattern ((BoxTester ?p ?typ)) ))) (not (forall ((?p Int) (?typ Int)) (! (=> (not (= (BoxTester ?p ?typ) nullObject)) (= (Box (Unbox ?p) ?p) ?p)) :pattern ((BoxTester ?p ?typ)) ))) (not (= (IsValueType System_SByte) true_1)) (not (= (IsValueType System_Byte) true_1)) (not (= (IsValueType System_Int16) true_1)) (not (= (IsValueType System_UInt16) true_1)) (not (= (IsValueType System_Int32) true_1)) (not (= (IsValueType System_UInt32) true_1)) (not (= (IsValueType System_Int64) true_1)) (not (= (IsValueType System_UInt64) true_1)) (not (= (IsValueType System_Char) true_1)) (not (= (IsValueType System_UIntPtr) true_1)) (not (= (IsValueType System_IntPtr) true_1)) (not (< int_m9223372036854775808 int_m2147483648)) (not (< int_m2147483648 (- 0 100000))) (not (< 100000 int_2147483647)) (not (< int_2147483647 int_4294967295)) (not (< int_4294967295 int_9223372036854775807)) (not (< int_9223372036854775807 int_18446744073709551615)) (not (= (+ int_m9223372036854775808 1) (- 0 int_9223372036854775807))) (not (= (+ int_m2147483648 1) (- 0 int_2147483647))) (not (forall ((?i Int)) (= (= (InRange ?i System_SByte) true_1) (not (or (not (<= (- 0 128) ?i)) (not (< ?i 128))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Byte) true_1) (not (or (not (<= 0 ?i)) (not (< ?i 256))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Int16) true_1) (not (or (not (<= (- 0 32768) ?i)) (not (< ?i 32768))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_UInt16) true_1) (not (or (not (<= 0 ?i)) (not (< ?i 65536))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Int32) true_1) (not (or (not (<= int_m2147483648 ?i)) (not (<= ?i int_2147483647))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_UInt32) true_1) (not (or (not (<= 0 ?i)) (not (<= ?i int_4294967295))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Int64) true_1) (not (or (not (<= int_m9223372036854775808 ?i)) (not (<= ?i int_9223372036854775807))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_UInt64) true_1) (not (or (not (<= 0 ?i)) (not (<= ?i int_18446744073709551615))))))) (not (forall ((?i Int)) (= (= (InRange ?i System_Char) true_1) (not (or (not (<= 0 ?i)) (not (< ?i 65536))))))) (not (forall ((?z Int) (?B Int) (?C Int)) (=> (= (InRange ?z ?C) true_1) (= (IntToInt ?z ?B ?C) ?z)))) (not (forall ((?b Int) (?x_3 Int) (?y Int)) (! (=> (= ?b true_1) (= (IfThenElse ?b ?x_3 ?y) ?x_3)) :pattern ((IfThenElse ?b ?x_3 ?y)) ))) (not (forall ((?b Int) (?x_3 Int) (?y Int)) (! (=> (not (= ?b true_1)) (= (IfThenElse ?b ?x_3 ?y) ?y)) :pattern ((IfThenElse ?b ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (= (x_2 ?x_3 ?y) (- ?x_3 (* (x_1 ?x_3 ?y) ?y))) :pattern ((x_2 ?x_3 ?y))  :pattern ((x_1 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_46 (x_2 ?x_3 ?y))) (=> (not (or (not (<= 0 ?x_3)) (not (< 0 ?y)))) (not (or (not (<= 0 ?v_46)) (not (< ?v_46 ?y)))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_47 (x_2 ?x_3 ?y))) (=> (not (or (not (<= 0 ?x_3)) (not (< ?y 0)))) (not (or (not (<= 0 ?v_47)) (not (< ?v_47 (- 0 ?y))))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_48 (x_2 ?x_3 ?y))) (=> (not (or (not (<= ?x_3 0)) (not (< 0 ?y)))) (not (or (not (< (- 0 ?y) ?v_48)) (not (<= ?v_48 0)))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_49 (x_2 ?x_3 ?y))) (=> (not (or (not (<= ?x_3 0)) (not (< ?y 0)))) (not (or (not (< ?y ?v_49)) (not (<= ?v_49 0)))))) :pattern ((x_2 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (=> (not (or (not (<= 0 ?x_3)) (not (<= 0 ?y)))) (= (x_2 (+ ?x_3 ?y) ?y) (x_2 ?x_3 ?y))) :pattern ((x_2 (+ ?x_3 ?y) ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (=> (not (or (not (<= 0 ?x_3)) (not (<= 0 ?y)))) (= (x_2 (+ ?y ?x_3) ?y) (x_2 ?x_3 ?y))) :pattern ((x_2 (+ ?y ?x_3) ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_50 (- ?x_3 ?y))) (=> (not (or (not (<= 0 ?v_50)) (not (<= 0 ?y)))) (= (x_2 ?v_50 ?y) (x_2 ?x_3 ?y)))) :pattern ((x_2 (- ?x_3 ?y) ?y)) ))) (not (forall ((?a Int) (?b Int) (?d Int)) (! (=> (not (or (not (<= 2 ?d)) (not (= (x_2 ?a ?d) (x_2 ?b ?d))) (not (< ?a ?b)))) (<= (+ ?a ?d) ?b)) :pattern ((x_2 ?a ?d) (x_2 ?b ?d)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (=> (or (<= 0 ?x_3) (<= 0 ?y)) (<= 0 (and_1 ?x_3 ?y))) :pattern ((and_1 ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_51 (or_1 ?x_3 ?y))) (=> (not (or (not (<= 0 ?x_3)) (not (<= 0 ?y)))) (not (or (not (<= 0 ?v_51)) (not (<= ?v_51 (+ ?x_3 ?y))))))) :pattern ((or_1 ?x_3 ?y)) ))) (not (forall ((?i Int)) (! (= (shl ?i 0) ?i) :pattern ((shl ?i 0)) ))) (not (forall ((?i Int) (?j Int)) (! (=> (<= 1 ?j) (= (shl ?i ?j) (* (shl ?i (- ?j 1)) 2))) :pattern ((shl ?i ?j)) ))) (not (forall ((?i Int) (?j Int)) (! (let ((?v_52 (shl ?i ?j))) (=> (not (or (not (<= 0 ?i)) (not (< ?i 32768)) (not (<= 0 ?j)) (not (<= ?j 16)))) (not (or (not (<= 0 ?v_52)) (not (<= ?v_52 int_2147483647)))))) :pattern ((shl ?i ?j)) ))) (not (forall ((?i Int)) (! (= (shr ?i 0) ?i) :pattern ((shr ?i 0)) ))) (not (forall ((?i Int) (?j Int)) (! (=> (<= 1 ?j) (= (shr ?i ?j) (x_1 (shr ?i (- ?j 1)) 2))) :pattern ((shr ?i ?j)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_53 (min ?x_3 ?y))) (not (or (not (or (= ?v_53 ?x_3) (= ?v_53 ?y))) (not (<= ?v_53 ?x_3)) (not (<= ?v_53 ?y))))) :pattern ((min ?x_3 ?y)) ))) (not (forall ((?x_3 Int) (?y Int)) (! (let ((?v_54 (max ?x_3 ?y))) (not (or (not (or (= ?v_54 ?x_3) (= ?v_54 ?y))) (not (<= ?x_3 ?v_54)) (not (<= ?y ?v_54))))) :pattern ((max ?x_3 ?y)) ))) (not (forall ((?h_1 Int) (?a Int) (?b Int)) (! (= (= (System_String_Equals_System_String ?h_1 ?a ?b) true_1) (= (System_String_Equals_System_String_System_String ?h_1 ?a ?b) true_1)) :pattern ((System_String_Equals_System_String ?h_1 ?a ?b)) ))) (not (forall ((?h_1 Int) (?a Int) (?b Int)) (! (let ((?v_56 (= (StringEquals ?a ?b) true_1)) (?v_55 (= (System_String_Equals_System_String_System_String ?h_1 ?a ?b) true_1))) (not (or (not (= ?v_55 ?v_56)) (not (= ?v_55 (= (StringEquals ?b ?a) true_1))) (not (=> (= ?a ?b) ?v_56))))) :pattern ((System_String_Equals_System_String_System_String ?h_1 ?a ?b)) ))) (not (forall ((?a Int) (?b Int) (?c Int)) (=> (not (or (not (= (StringEquals ?a ?b) true_1)) (not (= (StringEquals ?b ?c) true_1)))) (= (StringEquals ?a ?c) true_1)))) (not (forall ((?h_1 Int) (?a Int) (?b Int)) (! (=> (not (or (not (not (= ?a nullObject))) (not (not (= ?b nullObject))) (not (= (System_String_Equals_System_String_System_String ?h_1 ?a ?b) true_1)))) (= (System_String_IsInterned_System_String_notnull ?h_1 ?a) (System_String_IsInterned_System_String_notnull ?h_1 ?b))) :pattern ((System_String_Equals_System_String_System_String ?h_1 ?a ?b)) ))) (not (= (x Sorting Sorting) true_1)) (not (= ?v_0 System_Object)) (not (= (AsDirectSubClass Sorting ?v_0) Sorting)) (not (not (= (IsImmutable Sorting) true_1))) (not (= (AsMutable Sorting) Sorting)) (not (= (IsMemberlessType Sorting) true_1)) (not (forall ((?U Int)) (! (=> (= (x ?U Sorting) true_1) (= ?U Sorting)) :pattern ((x ?U Sorting)) ))) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) Sorting) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_0))))) true) :pattern ((x (select2 ?h ?oi inv) Sorting)) ))) (not (= (x System_Array System_Array) true_1)) (not (= ?v_1 System_Object)) (not (= (AsDirectSubClass System_Array ?v_1) System_Array)) (not (not (= (IsImmutable System_Array) true_1))) (not (= (AsMutable System_Array) System_Array)) (not (= (x System_ICloneable System_ICloneable) true_1)) (not (= (x System_ICloneable System_Object) true_1)) (not (= (IsMemberlessType System_ICloneable) true_1)) (not (= (AsInterface System_ICloneable) System_ICloneable)) (not (= (x System_Array System_ICloneable) true_1)) (not (= (x System_Collections_IList System_Collections_IList) true_1)) (not (= (x System_Collections_IList System_Object) true_1)) (not (= (x System_Collections_ICollection System_Collections_ICollection) true_1)) (not (= (x System_Collections_ICollection System_Object) true_1)) (not (= (x System_Collections_IEnumerable System_Collections_IEnumerable) true_1)) (not (= (x System_Collections_IEnumerable System_Object) true_1)) (not (= (IsMemberlessType System_Collections_IEnumerable) true_1)) (not (= (AsInterface System_Collections_IEnumerable) System_Collections_IEnumerable)) (not (= (x System_Collections_ICollection System_Collections_IEnumerable) true_1)) (not (= (IsMemberlessType System_Collections_ICollection) true_1)) (not (= (AsInterface System_Collections_ICollection) System_Collections_ICollection)) (not (= (x System_Collections_IList System_Collections_ICollection) true_1)) (not (= (x System_Collections_IList System_Collections_IEnumerable) true_1)) (not (= (IsMemberlessType System_Collections_IList) true_1)) (not (= (AsInterface System_Collections_IList) System_Collections_IList)) (not (= (x System_Array System_Collections_IList) true_1)) (not (= (x System_Array System_Collections_ICollection) true_1)) (not (= (x System_Array System_Collections_IEnumerable) true_1)) (not (= (IsMemberlessType System_Array) true_1)) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) System_Array) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_1))))) true) :pattern ((x (select2 ?h ?oi inv) System_Array)) ))) (not (= (x System_String System_String) true_1)) (not (= ?v_2 System_Object)) (not (= (AsDirectSubClass System_String ?v_2) System_String)) (not (= (IsImmutable System_String) true_1)) (not (= (AsImmutable System_String) System_String)) (not (= (x System_IComparable System_IComparable) true_1)) (not (= (x System_IComparable System_Object) true_1)) (not (= (IsMemberlessType System_IComparable) true_1)) (not (= (AsInterface System_IComparable) System_IComparable)) (not (= (x System_String System_IComparable) true_1)) (not (= (x System_String System_ICloneable) true_1)) (not (= (x System_IConvertible System_IConvertible) true_1)) (not (= (x System_IConvertible System_Object) true_1)) (not (= (IsMemberlessType System_IConvertible) true_1)) (not (= (AsInterface System_IConvertible) System_IConvertible)) (not (= (x System_String System_IConvertible) true_1)) (not (= (x System_IComparable_1___System_String System_IComparable_1___System_String) true_1)) (not (= (x System_IComparable_1___System_String System_Object) true_1)) (not (= (IsMemberlessType System_IComparable_1___System_String) true_1)) (not (= (AsInterface System_IComparable_1___System_String) System_IComparable_1___System_String)) (not (= (x System_String System_IComparable_1___System_String) true_1)) (not (= (x System_Collections_Generic_IEnumerable_1___System_Char System_Collections_Generic_IEnumerable_1___System_Char) true_1)) (not (= (x System_Collections_Generic_IEnumerable_1___System_Char System_Object) true_1)) (not (= (x System_Collections_Generic_IEnumerable_1___System_Char System_Collections_IEnumerable) true_1)) (not (= (IsMemberlessType System_Collections_Generic_IEnumerable_1___System_Char) true_1)) (not (= (AsInterface System_Collections_Generic_IEnumerable_1___System_Char) System_Collections_Generic_IEnumerable_1___System_Char)) (not (= (x System_String System_Collections_Generic_IEnumerable_1___System_Char) true_1)) (not (= (x System_String System_Collections_IEnumerable) true_1)) (not (= (x System_IEquatable_1___System_String System_IEquatable_1___System_String) true_1)) (not (= (x System_IEquatable_1___System_String System_Object) true_1)) (not (= (IsMemberlessType System_IEquatable_1___System_String) true_1)) (not (= (AsInterface System_IEquatable_1___System_String) System_IEquatable_1___System_String)) (not (= (x System_String System_IEquatable_1___System_String) true_1)) (not (forall ((?U Int)) (! (=> (= (x ?U System_String) true_1) (= ?U System_String)) :pattern ((x ?U System_String)) ))) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) System_String) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_2))))) true) :pattern ((x (select2 ?h ?oi inv) System_String)) ))) (not (= (x System_Random System_Random) true_1)) (not (= ?v_3 System_Object)) (not (= (AsDirectSubClass System_Random ?v_3) System_Random)) (not (not (= (IsImmutable System_Random) true_1))) (not (= (AsMutable System_Random) System_Random)) (not (forall ((?oi Int) (?h Int)) (! (=> (not (or (not (= (IsHeap ?h) true_1)) (not (= (x (select2 ?h ?oi inv) System_Random) true_1)) (not (not (= (select2 ?h ?oi localinv) ?v_3))))) true) :pattern ((x (select2 ?h ?oi inv) System_Random)) ))) (not (= (IsNotNull stringLiteral18 System_String) true_1)) (not (= (StringLength stringLiteral18) 4)) (not (forall ((?heap Int)) (! (=> (= (IsHeap ?heap) true_1) (= (select2 ?heap stringLiteral18 allocated) true_1)) :pattern ((select2 ?heap stringLiteral18 allocated)) ))) (not (forall ((?heap Int)) (! (=> (= (IsHeap ?heap) true_1) (= (System_String_IsInterned_System_String_notnull ?heap stringLiteral18) stringLiteral18)) :pattern ((System_String_IsInterned_System_String_notnull ?heap stringLiteral18)) )))))))
(assert (let ((?v_62 (forall ((?o_1 Int)) (! (=> (not (or (not (not (= ?o_1 nullObject))) (not (= (select2 Heap_1 ?o_1 allocated) true_1)))) (not (or (not (= (select2 Heap_5 ?o_1 ownerRef) (select2 Heap_1 ?o_1 ownerRef))) (not (= (select2 Heap_5 ?o_1 ownerFrame) (select2 Heap_1 ?o_1 ownerFrame)))))) :pattern ((select2 Heap_5 ?o_1 ownerFrame))  :pattern ((select2 Heap_5 ?o_1 ownerRef)) ))) (?v_61 (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_77 (not (= ?o_1 A_in))) (?v_75 (select2 Heap ?o_1 ownerFrame)) (?v_76 (select2 Heap ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap ?o_1 allocated) true_1)) (not (or (= ?v_75 PeerGroupPlaceholder) (not (= (x (select2 Heap ?v_76 inv) ?v_75) true_1)) (= (select2 Heap ?v_76 localinv) (BaseClass ?v_75)))) (not (or ?v_77 (not (= (x (typeof A_in) (DeclType ?f_1)) true_1)) (not (= (IncludedInModifiesStar ?f_1) true_1)))) (not (or ?v_77 (not (= ?f_1 exposeVersion)))))) (= (select2 Heap_1 ?o_1 ?f_1) (select2 Heap_5 ?o_1 ?f_1)))) :pattern ((select2 Heap_5 ?o_1 ?f_1)) ))) (?v_25 (= (select2 Heap_1 BeingConstructed NonNullFieldsAreInitialized) true_1)) (?v_60 (forall ((?k Int)) (=> (not (or (not (<= j_1 ?k)) (not (<= ?k (- r_in 1))))) (<= pv_in (IntArrayGet (select2 Heap_5 A_in elements) ?k))))) (?v_59 (forall ((?k Int)) (=> (not (or (not (<= l_in ?k)) (not (<= ?k (- i_1 1))))) (<= (IntArrayGet (select2 Heap_5 A_in elements) ?k) pv_in)))) (?v_58 (< j_1 r_in)) (?v_57 (<= i_1 j_1)) (?v_56 (<= l_in i_1))) (let ((?v_65 (=> true (=> true (=> true (=> true (=> true (not (or (not ?v_56) (not (=> ?v_56 (not (or (not ?v_57) (not (=> ?v_57 (not (or (not ?v_58) (not (=> ?v_58 (not (or (not ?v_59) (not (=> ?v_59 (not (or (not ?v_60) (not (=> ?v_60 (=> (not (or (not (forall ((?o_1 Int)) (! (=> (= (select2 Heap_1 ?o_1 allocated) true_1) (= (select2 Heap_5 ?o_1 allocated) true_1)) :pattern ((select2 Heap_5 ?o_1 allocated)) ))) (not (forall ((?ot Int)) (! (let ((?v_78 (select2 Heap_1 ?ot ownerFrame))) (=> (not (or (not (= (select2 Heap_1 ?ot allocated) true_1)) (not (not (= ?v_78 PeerGroupPlaceholder))))) (not (or (not (= (select2 Heap_5 ?ot ownerRef) (select2 Heap_1 ?ot ownerRef))) (not (= (select2 Heap_5 ?ot ownerFrame) ?v_78)))))) :pattern ((select2 Heap_5 ?ot ownerFrame))  :pattern ((select2 Heap_5 ?ot ownerRef)) ))) (not (= ?v_25 (= (select2 Heap_5 BeingConstructed NonNullFieldsAreInitialized) true_1))))) (=> (forall ((?o_1 Int)) (! (=> (= (select2 Heap_1 ?o_1 allocated) true_1) (not (or (not (= (select2 Heap_1 ?o_1 inv) (select2 Heap_5 ?o_1 inv))) (not (= (select2 Heap_1 ?o_1 localinv) (select2 Heap_5 ?o_1 localinv)))))) :pattern ((select2 Heap_5 ?o_1 localinv))  :pattern ((select2 Heap_5 ?o_1 inv)) )) (=> (forall ((?o_1 Int)) (let ((?v_79 (typeof ?o_1))) (=> (not (or (not (not (= (select2 Heap_1 ?o_1 allocated) true_1))) (not (= (select2 Heap_5 ?o_1 allocated) true_1)))) (not (or (not (= (select2 Heap_5 ?o_1 inv) ?v_79)) (not (= (select2 Heap_5 ?o_1 localinv) ?v_79))))))) (not (or (not ?v_61) (not (=> ?v_61 (=> (= (HeapSucc Heap_1 Heap_5) true_1) (not (or (not ?v_62) (not (=> ?v_62 (=> false true)))))))))))))))))))))))))))))))))))))))) (let ((?v_74 (=> (= stack3i_2 stack3i_0) ?v_65)) (?v_73 (= tmp_3 tmp_1)) (?v_72 (= stack2i_3 stack2i_1)) (?v_71 (= stack2o_1 stack2o_0)) (?v_70 (= local10_1 local10_0)) (?v_69 (= Heap_5 Heap_2)) (?v_68 (= local12_1 local12_0)) (?v_67 (= local13_1 local13_0)) (?v_66 (+ i_0 1)) (?v_64 (= local9_1 local9_0)) (?v_63 (= stack0i_8 j_0)) (?v_42 (- j_0 1)) (?v_54 (select2 Heap_4 A_in elements))) (let ((?v_55 (< pv_in (IntArrayGet ?v_54 ?v_42))) (?v_53 (< (IntArrayGet ?v_54 i_0) pv_in)) (?v_50 (select2 Heap_3 A_in ownerFrame)) (?v_51 (select2 Heap_3 A_in ownerRef))) (let ((?v_52 (or (= ?v_50 PeerGroupPlaceholder) (not (= (x (select2 Heap_3 ?v_51 inv) ?v_50) true_1)) (= (select2 Heap_3 ?v_51 localinv) (BaseClass ?v_50)))) (?v_5 (Length A_in))) (let ((?v_49 (< stack1i_2 ?v_5)) (?v_48 (<= 0 stack1i_2)) (?v_3 (not (= A_in nullObject)))) (let ((?v_8 (not ?v_3)) (?v_38 (select2 Heap_2 A_in elements)) (?v_45 (select2 Heap_2 A_in ownerFrame)) (?v_46 (select2 Heap_2 A_in ownerRef))) (let ((?v_47 (or (= ?v_45 PeerGroupPlaceholder) (not (= (x (select2 Heap_2 ?v_46 inv) ?v_45) true_1)) (= (select2 Heap_2 ?v_46 localinv) (BaseClass ?v_45)))) (?v_35 (< i_0 ?v_5))) (let ((?v_40 (not ?v_35)) (?v_34 (<= 0 i_0))) (let ((?v_39 (not ?v_34)) (?v_44 (< stack3i_1 ?v_5)) (?v_43 (<= 0 stack3i_1)) (?v_41 (IntArrayGet ?v_38 i_0)) (?v_37 (< stack1i_1 ?v_5)) (?v_36 (<= 0 stack1i_1)) (?v_33 (<= l_in result_0)) (?v_32 (< result_0 r_in)) (?v_31 (forall ((?k Int)) (=> (not (or (not (<= l_in ?k)) (not (<= ?k (- result_0 1))))) (<= (IntArrayGet (select2 Heap_6 A_in elements) ?k) pv_in)))) (?v_30 (forall ((?k Int)) (=> (not (or (not (<= result_0 ?k)) (not (<= ?k (- r_in 1))))) (<= pv_in (IntArrayGet (select2 Heap_6 A_in elements) ?k))))) (?v_29 (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_82 (not (= ?o_1 A_in))) (?v_80 (select2 Heap ?o_1 ownerFrame)) (?v_81 (select2 Heap ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap ?o_1 allocated) true_1)) (not (or (= ?v_80 PeerGroupPlaceholder) (not (= (x (select2 Heap ?v_81 inv) ?v_80) true_1)) (= (select2 Heap ?v_81 localinv) (BaseClass ?v_80)))) (not (or ?v_82 (not (= (x (typeof A_in) (DeclType ?f_1)) true_1)) (not (= (IncludedInModifiesStar ?f_1) true_1)))) (not (or ?v_82 (not (= ?f_1 exposeVersion)))))) (= (select2 Heap ?o_1 ?f_1) (select2 Heap_6 ?o_1 ?f_1)))) :pattern ((select2 Heap_6 ?o_1 ?f_1)) ))) (?v_28 (= i_0 j_0)) (?v_27 (forall ((?o_1 Int)) (! (let ((?v_84 (select2 Heap_1 ?o_1 ownerFrame)) (?v_83 (select2 Heap_1 ?o_1 ownerRef))) (=> (not (or (not (not (= ?o_1 nullObject))) (not (= (select2 Heap_1 ?o_1 allocated) true_1)))) (not (or (not (= ?v_83 ?v_83)) (not (= ?v_84 ?v_84)))))) :pattern ((select2 Heap_1 ?o_1 ownerFrame))  :pattern ((select2 Heap_1 ?o_1 ownerRef)) ))) (?v_26 (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_88 (select2 Heap_1 ?o_1 ?f_1)) (?v_87 (not (= ?o_1 A_in))) (?v_85 (select2 Heap ?o_1 ownerFrame)) (?v_86 (select2 Heap ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap ?o_1 allocated) true_1)) (not (or (= ?v_85 PeerGroupPlaceholder) (not (= (x (select2 Heap ?v_86 inv) ?v_85) true_1)) (= (select2 Heap ?v_86 localinv) (BaseClass ?v_85)))) (not (or ?v_87 (not (= (x (typeof A_in) (DeclType ?f_1)) true_1)) (not (= (IncludedInModifiesStar ?f_1) true_1)))) (not (or ?v_87 (not (= ?f_1 exposeVersion)))))) (= ?v_88 ?v_88))) :pattern ((select2 Heap_1 ?o_1 ?f_1)) ))) (?v_24 (forall ((?k Int)) (=> (not (or (not (<= stack0i_0 ?k)) (not (<= ?k (- r_in 1))))) (<= pv_in (IntArrayGet (select2 Heap_1 A_in elements) ?k))))) (?v_23 (forall ((?k Int)) (=> (not (or (not (<= l_in ?k)) (not (<= ?k (- l_in 1))))) (<= (IntArrayGet (select2 Heap_1 A_in elements) ?k) pv_in)))) (?v_22 (< stack0i_0 r_in)) (?v_21 (<= l_in stack0i_0)) (?v_20 (<= l_in l_in)) (?v_17 (select2 Heap_0 A_in ownerFrame)) (?v_18 (select2 Heap_0 A_in ownerRef))) (let ((?v_19 (or (= ?v_17 PeerGroupPlaceholder) (not (= (x (select2 Heap_0 ?v_18 inv) ?v_17) true_1)) (= (select2 Heap_0 ?v_18 localinv) (BaseClass ?v_17)))) (?v_10 (< stack0i_0 ?v_5))) (let ((?v_16 (not ?v_10)) (?v_9 (<= 0 stack0i_0))) (let ((?v_15 (not ?v_9)) (?v_11 (select2 Heap A_in elements)) (?v_1 (select2 Heap A_in ownerFrame)) (?v_2 (select2 Heap A_in ownerRef))) (let ((?v_14 (or (= ?v_1 PeerGroupPlaceholder) (not (= (x (select2 Heap ?v_2 inv) ?v_1) true_1)) (= (select2 Heap ?v_2 localinv) (BaseClass ?v_1)))) (?v_6 (< l_in ?v_5))) (let ((?v_13 (not ?v_6)) (?v_4 (<= 0 l_in))) (let ((?v_12 (not ?v_4)) (?v_7 (IntArrayGet ?v_11 l_in)) (?v_0 (IntArray System_Int32 1))) (not (=> true (=> (= (IsHeap Heap) true_1) (=> (not (or (not (= (IsNotNull A_in ?v_0) true_1)) (not (= (select2 Heap A_in allocated) true_1)))) (=> (= (InRange l_in System_Int32) true_1) (=> (= (InRange r_in System_Int32) true_1) (=> (= (InRange pv_in System_Int32) true_1) (=> (= (InRange result System_Int32) true_1) (=> (not (or (not (= (IsNotNull A ?v_0) true_1)) (not (= (select2 Heap A allocated) true_1)))) (=> (= (InRange l System_Int32) true_1) (=> (= (InRange r System_Int32) true_1) (=> (= (InRange pv System_Int32) true_1) (=> (= (InRange i System_Int32) true_1) (=> (= (InRange j System_Int32) true_1) (=> (= (InRange tmp System_Int32) true_1) (=> (= (InRange local9 System_Int32) true_1) (=> (= (InRange return_value System_Int32) true_1) (=> (= (InRange local10 System_Int32) true_1) (=> (= (InRange SS_Display_Return_Local System_Int32) true_1) (=> (= (InRange local12 System_Int32) true_1) (=> (= (InRange local13 System_Int32) true_1) (=> (= PurityAxiomsCanBeAssumed true_1) (=> (= BeingConstructed nullObject) (=> ?v_14 (=> (forall ((?pc Int)) (! (let ((?v_89 (typeof ?pc))) (=> (not (or (not (not (= ?pc nullObject))) (not (= (select2 Heap ?pc allocated) true_1)) (not (= (select2 Heap ?pc ownerRef) ?v_2)) (not (= (select2 Heap ?pc ownerFrame) ?v_1)))) (not (or (not (= (select2 Heap ?pc inv) ?v_89)) (not (= (select2 Heap ?pc localinv) ?v_89)))))) :pattern ((typeof ?pc))  :pattern ((select2 Heap ?pc localinv))  :pattern ((select2 Heap ?pc inv))  :pattern ((select2 Heap ?pc ownerFrame))  :pattern ((select2 Heap ?pc ownerRef)) )) (=> (<= r_in ?v_5) (=> (<= (+ l_in 2) r_in) (=> ?v_4 (=> (= pv_in ?v_7) (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> (= stack0i_0 (- r_in 1)) (not (or ?v_8 (not (=> ?v_3 (not (or ?v_12 (not (=> ?v_4 (not (or ?v_13 (not (=> ?v_6 (=> (= tmp_0 ?v_7) (not (or ?v_8 (not (=> ?v_3 (not (or ?v_15 (not (=> ?v_9 (not (or ?v_16 (not (=> ?v_10 (=> (= stack2i_0 (IntArrayGet ?v_11 stack0i_0)) (not (or ?v_8 (not (=> ?v_3 (not (or ?v_12 (not (=> ?v_4 (not (or ?v_13 (not (=> ?v_6 (not (or (not ?v_14) (not (=> ?v_14 (=> (= Heap_0 (store2 Heap A_in elements (IntArraySet ?v_11 l_in stack2i_0))) (=> (= (IsHeap Heap_0) true_1) (not (or ?v_8 (not (=> ?v_3 (not (or ?v_15 (not (=> ?v_9 (not (or ?v_16 (not (=> ?v_10 (not (or (not ?v_19) (not (=> ?v_19 (=> (= Heap_1 (store2 Heap_0 A_in elements (IntArraySet (select2 Heap_0 A_in elements) stack0i_0 tmp_0))) (=> (= (IsHeap Heap_1) true_1) (=> true (=> true (=> true (=> true (=> true (not (or (not ?v_20) (not (=> ?v_20 (not (or (not ?v_21) (not (=> ?v_21 (not (or (not ?v_22) (not (=> ?v_22 (not (or (not ?v_23) (not (=> ?v_23 (not (or (not ?v_24) (not (=> ?v_24 (=> (not (or (not (forall ((?o_1 Int)) (! (let ((?v_90 (= (select2 Heap_1 ?o_1 allocated) true_1))) (=> ?v_90 ?v_90)) :pattern ((select2 Heap_1 ?o_1 allocated)) ))) (not (forall ((?ot Int)) (! (let ((?v_92 (select2 Heap_1 ?ot ownerFrame)) (?v_91 (select2 Heap_1 ?ot ownerRef))) (=> (not (or (not (= (select2 Heap_1 ?ot allocated) true_1)) (not (not (= ?v_92 PeerGroupPlaceholder))))) (not (or (not (= ?v_91 ?v_91)) (not (= ?v_92 ?v_92)))))) :pattern ((select2 Heap_1 ?ot ownerFrame))  :pattern ((select2 Heap_1 ?ot ownerRef)) ))) (not (= ?v_25 ?v_25)))) (=> (forall ((?o_1 Int)) (! (let ((?v_94 (select2 Heap_1 ?o_1 localinv)) (?v_93 (select2 Heap_1 ?o_1 inv))) (=> (= (select2 Heap_1 ?o_1 allocated) true_1) (not (or (not (= ?v_93 ?v_93)) (not (= ?v_94 ?v_94)))))) :pattern ((select2 Heap_1 ?o_1 localinv))  :pattern ((select2 Heap_1 ?o_1 inv)) )) (=> (forall ((?o_1 Int)) (let ((?v_96 (typeof ?o_1)) (?v_95 (not (= (select2 Heap_1 ?o_1 allocated) true_1)))) (=> (not (or (not ?v_95) ?v_95)) (not (or (not (= (select2 Heap_1 ?o_1 inv) ?v_96)) (not (= (select2 Heap_1 ?o_1 localinv) ?v_96))))))) (not (or (not ?v_26) (not (=> ?v_26 (=> (= (HeapSucc Heap_1 Heap_1) true_1) (not (or (not ?v_27) (not (=> ?v_27 (=> true (=> (= (InRange local12_0 System_Int32) true_1) (=> (= (InRange i_0 System_Int32) true_1) (=> (= (InRange local13_0 System_Int32) true_1) (=> (= (InRange j_0 System_Int32) true_1) (=> (= (InRange local9_0 System_Int32) true_1) (=> (= (InRange local10_0 System_Int32) true_1) (=> (= (InRange tmp_1 System_Int32) true_1) (=> (= (IsHeap Heap_2) true_1) (=> true (=> (<= l_in i_0) (=> (<= i_0 j_0) (=> (< j_0 r_in) (=> (forall ((?k Int)) (=> (not (or (not (<= l_in ?k)) (not (<= ?k (- i_0 1))))) (<= (IntArrayGet ?v_38 ?k) pv_in))) (=> (forall ((?k Int)) (=> (not (or (not (<= j_0 ?k)) (not (<= ?k (- r_in 1))))) (<= pv_in (IntArrayGet ?v_38 ?k)))) (=> (not (or (not (forall ((?o_1 Int)) (! (=> (= (select2 Heap_1 ?o_1 allocated) true_1) (= (select2 Heap_2 ?o_1 allocated) true_1)) :pattern ((select2 Heap_2 ?o_1 allocated)) ))) (not (forall ((?ot Int)) (! (let ((?v_97 (select2 Heap_1 ?ot ownerFrame))) (=> (not (or (not (= (select2 Heap_1 ?ot allocated) true_1)) (not (not (= ?v_97 PeerGroupPlaceholder))))) (not (or (not (= (select2 Heap_2 ?ot ownerRef) (select2 Heap_1 ?ot ownerRef))) (not (= (select2 Heap_2 ?ot ownerFrame) ?v_97)))))) :pattern ((select2 Heap_2 ?ot ownerFrame))  :pattern ((select2 Heap_2 ?ot ownerRef)) ))) (not (= ?v_25 (= (select2 Heap_2 BeingConstructed NonNullFieldsAreInitialized) true_1))))) (=> (forall ((?o_1 Int)) (! (=> (= (select2 Heap_1 ?o_1 allocated) true_1) (not (or (not (= (select2 Heap_1 ?o_1 inv) (select2 Heap_2 ?o_1 inv))) (not (= (select2 Heap_1 ?o_1 localinv) (select2 Heap_2 ?o_1 localinv)))))) :pattern ((select2 Heap_2 ?o_1 localinv))  :pattern ((select2 Heap_2 ?o_1 inv)) )) (=> (forall ((?o_1 Int)) (let ((?v_98 (typeof ?o_1))) (=> (not (or (not (not (= (select2 Heap_1 ?o_1 allocated) true_1))) (not (= (select2 Heap_2 ?o_1 allocated) true_1)))) (not (or (not (= (select2 Heap_2 ?o_1 inv) ?v_98)) (not (= (select2 Heap_2 ?o_1 localinv) ?v_98))))))) (=> (forall ((?o_1 Int) (?f_1 Int)) (! (let ((?v_101 (not (= ?o_1 A_in))) (?v_99 (select2 Heap ?o_1 ownerFrame)) (?v_100 (select2 Heap ?o_1 ownerRef))) (=> (not (or (not (= (IncludeInMainFrameCondition ?f_1) true_1)) (not (not (= ?o_1 nullObject))) (not (= (select2 Heap ?o_1 allocated) true_1)) (not (or (= ?v_99 PeerGroupPlaceholder) (not (= (x (select2 Heap ?v_100 inv) ?v_99) true_1)) (= (select2 Heap ?v_100 localinv) (BaseClass ?v_99)))) (not (or ?v_101 (not (= (x (typeof A_in) (DeclType ?f_1)) true_1)) (not (= (IncludedInModifiesStar ?f_1) true_1)))) (not (or ?v_101 (not (= ?f_1 exposeVersion)))))) (= (select2 Heap_1 ?o_1 ?f_1) (select2 Heap_2 ?o_1 ?f_1)))) :pattern ((select2 Heap_2 ?o_1 ?f_1)) )) (=> (= (HeapSucc Heap_1 Heap_2) true_1) (=> (forall ((?o_1 Int)) (! (=> (not (or (not (not (= ?o_1 nullObject))) (not (= (select2 Heap_1 ?o_1 allocated) true_1)))) (not (or (not (= (select2 Heap_2 ?o_1 ownerRef) (select2 Heap_1 ?o_1 ownerRef))) (not (= (select2 Heap_2 ?o_1 ownerFrame) (select2 Heap_1 ?o_1 ownerFrame)))))) :pattern ((select2 Heap_2 ?o_1 ownerFrame))  :pattern ((select2 Heap_2 ?o_1 ownerRef)) )) (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> (>= i_0 j_0) (=> true (=> true (=> true (not (or (not ?v_28) (not (=> ?v_28 (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> (= Heap_6 Heap_2) (=> (= return_value_0 i_0) (=> (= stack2o_2 stack2o_0) (=> (= result_0 i_0) (=> (= stack3i_3 stack3i_0) (=> (= stack0i_9 i_0) (=> (= local10_2 local10_0) (=> (= local12_2 local12_0) (=> (= stack1i_4 stack1i_0) (=> (= local9_2 local9_0) (=> (= stack0o_1 stack0o_0) (=> (= local13_2 local13_0) (=> (= stack2i_4 stack2i_1) (=> (= SS_Display_Return_Local_0 i_0) (=> (= i_2 i_0) (=> (= j_2 j_0) (=> (= tmp_4 tmp_1) (=> true (not (or (not ?v_29) (not (=> ?v_29 (not (or (not ?v_30) (not (=> ?v_30 (not (or (not ?v_31) (not (=> ?v_31 (not (or (not ?v_32) (not (=> ?v_32 (not (or (not ?v_33) (not (=> ?v_33 true))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> (< i_0 j_0) (=> true (=> true (=> true (not (or ?v_8 (not (=> ?v_3 (not (or ?v_39 (not (=> ?v_34 (not (or ?v_40 (not (=> ?v_35 (=> (= stack0i_2 ?v_41) (=> true (not (or (not (=> true (=> true (=> (> stack0i_2 pv_in) (=> true (=> true (=> true (=> (= stack1i_1 ?v_42) (not (or ?v_8 (not (=> ?v_3 (not (or (not ?v_36) (not (=> ?v_36 (not (or (not ?v_37) (not (=> ?v_37 (=> (= stack0i_3 (IntArrayGet ?v_38 stack1i_1)) (=> true (not (or (not (=> true (=> true (=> (> pv_in stack0i_3) (=> true (=> true (=> true (not (or ?v_8 (not (=> ?v_3 (not (or ?v_39 (not (=> ?v_34 (not (or ?v_40 (not (=> ?v_35 (=> (= tmp_2 ?v_41) (=> (= stack3i_1 ?v_42) (not (or ?v_8 (not (=> ?v_3 (not (or (not ?v_43) (not (=> ?v_43 (not (or (not ?v_44) (not (=> ?v_44 (=> (= stack2i_2 (IntArrayGet ?v_38 stack3i_1)) (not (or ?v_8 (not (=> ?v_3 (not (or ?v_39 (not (=> ?v_34 (not (or ?v_40 (not (=> ?v_35 (not (or (not ?v_47) (not (=> ?v_47 (=> (= Heap_3 (store2 Heap_2 A_in elements (IntArraySet ?v_38 i_0 stack2i_2))) (=> (= (IsHeap Heap_3) true_1) (=> (= stack1i_2 ?v_42) (not (or ?v_8 (not (=> ?v_3 (not (or (not ?v_48) (not (=> ?v_48 (not (or (not ?v_49) (not (=> ?v_49 (not (or (not ?v_52) (not (=> ?v_52 (=> (= Heap_4 (store2 Heap_3 A_in elements (IntArraySet (select2 Heap_3 A_in elements) stack1i_2 tmp_2))) (=> (= (IsHeap Heap_4) true_1) (not (or (not ?v_53) (not (=> ?v_53 (not (or (not ?v_55) (not (=> ?v_55 (=> true (=> true (=> true (=> (= stack0i_6 ?v_66) (=> (= stack0i_7 ?v_42) (=> true (=> true (=> (= local13_1 j_0) (=> (= local12_1 i_0) (=> (= Heap_5 Heap_4) (=> ?v_70 (=> (= i_1 stack0i_6) (=> (= stack2o_1 A_in) (=> (= stack2i_3 stack2i_2) (=> ?v_63 (=> (= stack1i_3 stack1i_2) (=> (= tmp_3 tmp_2) (=> ?v_64 (=> (= j_1 stack0i_7) (=> (= stack3i_2 stack3i_1) ?v_65))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> (<= pv_in stack0i_3) (=> true (=> true (=> true (=> (= stack0i_5 ?v_42) (=> true (=> true (=> ?v_67 (=> ?v_68 (=> ?v_69 (=> (= local10_1 j_0) (=> (= i_1 i_0) (=> ?v_71 (=> ?v_72 (=> ?v_63 (=> (= stack1i_3 stack1i_1) (=> ?v_73 (=> ?v_64 (=> (= j_1 stack0i_5) ?v_74)))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> (<= stack0i_2 pv_in) (=> true (=> true (=> true (=> (= stack0i_4 ?v_66) (=> true (=> true (=> ?v_67 (=> ?v_68 (=> ?v_69 (=> ?v_70 (=> (= i_1 stack0i_4) (=> ?v_71 (=> ?v_72 (=> (= stack0i_8 i_0) (=> (= stack1i_3 i_0) (=> ?v_73 (=> (= local9_1 i_0) (=> (= j_1 j_0) ?v_74)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
