(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun y () Int)
(declare-fun x_1 () Int)
(declare-fun NULL_CHECK (Int) Int)
(declare-fun LIFT (Int) Int)
(declare-fun BIT_BAND (Int Int) Int)
(declare-fun POW2 (Int) Int)
(declare-fun choose (Int Int Int) Int)
(declare-fun DIV (Int Int) Int)
(declare-fun MULT (Int Int) Int)
(declare-fun PLUS (Int Int Int) Int)
(declare-fun MINUS_LEFT_PTR (Int Int Int) Int)
(declare-fun MINUS_BOTH_PTR_OR_BOTH_INT (Int Int Int) Int)
(declare-fun b_FooInv (Int) Int)
(declare-fun b_Foo (Int) Int)
(declare-fun S_b_FooInv (Int) Int)
(declare-fun S_b_Foo (Int) Int)
(declare-fun a_FooInv (Int) Int)
(declare-fun a_Foo (Int) Int)
(declare-fun S_a_FooInv (Int) Int)
(declare-fun S_a_Foo (Int) Int)
(declare-fun Match (Int Int) Int)
(declare-fun INT4_name () Int)
(declare-fun HasType (Int Int) Int)
(declare-fun PINT4_name () Int)
(declare-fun Field (Int) Int)
(declare-fun Foo_name () Int)
(declare-fun PFoo_name () Int)
(declare-fun b_Foo_name () Int)
(declare-fun a_Foo_name () Int)
(declare-fun Values (Int) Int)
(declare-fun Unified (Int) Int)
(declare-fun Disjoint (Int Int) Int)
(declare-fun Subset (Int Int) Int)
(declare-fun Equal (Int Int) Int)
(declare-fun Inverse (Int Int) Int)
(declare-fun Difference (Int Int) Int)
(declare-fun Singleton (Int) Int)
(declare-fun Union (Int Int) Int)
(declare-fun Dereference (Int Int) Int)
(declare-fun Intersection (Int Int) Int)
(declare-fun Empty () Int)
(declare-fun HavocArray (Int Int Int) Int)
(declare-fun AtLeast (Int Int) Int)
(declare-fun Rep (Int Int) Int)
(declare-fun FourBytesToInt (Int Int Int Int) Int)
(declare-fun TwoBytesToInt (Int Int) Int)
(declare-fun OneByteToInt (Int) Int)
(declare-fun BYTE () Int)
(declare-fun FREED () Int)
(declare-fun ALLOCATED () Int)
(declare-fun UNALLOCATED () Int)
(declare-fun p1 () Int)
(declare-fun Mem () Int)
(declare-fun Mem_3 () Int)
(declare-fun Base (Int) Int)
(declare-fun alloc_1 () Int)
(declare-fun alloc () Int)
(declare-fun call5045formal_new_0 () Int)
(declare-fun alloc_0 () Int)
(declare-fun Mem_2 () Int)
(declare-fun Mem_1 () Int)
(declare-fun Mem_0 () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct UNALLOCATED ALLOCATED FREED BYTE a_Foo_name b_Foo_name Foo_name INT4_name PFoo_name PINT4_name x_1 y)) (not (forall ((?b0 Int) (?c0 Int)) (! (=> (= (OneByteToInt ?b0) (OneByteToInt ?c0)) (= ?b0 ?c0)) :pattern ((OneByteToInt ?b0) (OneByteToInt ?c0)) ))) (not (forall ((?b0 Int) (?b1 Int) (?c0 Int) (?c1 Int)) (! (=> (= (TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1))))) :pattern ((TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) ))) (not (forall ((?b0 Int) (?b1 Int) (?b2 Int) (?b3 Int) (?c0 Int) (?c1 Int) (?c2 Int) (?c3 Int)) (! (=> (= (FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1)) (not (= ?b2 ?c2)) (not (= ?b3 ?c3))))) :pattern ((FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (= (select1 (AtLeast ?n ?x_1) ?y) true_1) (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y)))))) :pattern ((select1 (AtLeast ?n ?x_1) ?y)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y))))) (= (select1 (AtLeast ?n ?x_1) ?y) true_1)) :pattern ((AtLeast ?n ?x_1) (Rep ?n ?x_1) (Rep ?n ?y)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (= (select1 (AtLeast ?n ?x_1) ?x_1) true_1) :pattern ((AtLeast ?n ?x_1)) ))) (not (forall ((?n Int) (?x_1 Int) (?z Int)) (! (= (Rep ?n ?x_1) (Rep ?n (PLUS ?x_1 ?n ?z))) :pattern ((PLUS ?x_1 ?n ?z)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (exists ((?k Int)) (= (- (Rep ?n ?x_1) ?x_1) (* ?n ?k))) :pattern ((Rep ?n ?x_1)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (<= ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) Empty) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (> ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) (Difference (AtLeast ?n ?x_1) (AtLeast ?n (PLUS ?x_1 ?n ?z)))) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int)) (not (= (select1 Empty ?x_1) true_1)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (select1 (Singleton ?y) ?x_1) true_1) (= ?x_1 ?y)) :pattern ((select1 (Singleton ?y) ?x_1)) ))) (not (forall ((?y Int)) (! (= (select1 (Singleton ?y) ?y) true_1) :pattern ((Singleton ?y)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Union ?S ?T) ?x_1) true_1) (or (= (select1 ?S ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((select1 (Union ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?T ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Intersection ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 (Intersection ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Difference ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((select1 (Difference ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (or (= (select1 (Difference ?S ?T) ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((Difference ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 (Dereference ?S ?M) ?x_1) true_1) (exists ((?y Int)) (not (or (not (= ?x_1 (select1 ?M ?y))) (not (= (select1 ?S ?y) true_1)))))) :pattern ((select1 (Dereference ?S ?M) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Dereference ?S ?M) (select1 ?M ?x_1)) true_1)) :pattern ((select1 ?M ?x_1) (select1 ?S ?x_1) (Dereference ?S ?M)) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (= (select1 ?S ?x_1) true_1)) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Dereference ?S ?M)) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (let ((?v_0 (select1 ?M ?x_1))) (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Equal (Intersection (Inverse ?M ?v_0) ?S) (Singleton ?x_1)) true_1)))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Difference (Dereference ?S ?M) (Singleton ?v_0)) (Singleton ?y))) true_1))) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (Equal (Intersection (Inverse ?M (select1 ?M ?x_1)) ?S) (Singleton ?x_1)) true_1))))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Dereference ?S ?M) (Singleton ?y))) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?f Int) (?x_1 Int)) (! (= (select1 (Inverse ?f (select1 ?f ?x_1)) ?x_1) true_1) :pattern ((Inverse ?f (select1 ?f ?x_1))) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int)) (! (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?y) (Union (Inverse ?f ?y) (Singleton ?x_1))) true_1) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?y)) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int) (?z Int)) (! (or (= ?y ?z) (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?z) (Difference (Inverse ?f ?z) (Singleton ?x_1))) true_1)) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?z)) ))) (not (forall ((?S Int) (?T Int)) (! (= (= (Equal ?S ?T) true_1) (not (or (not (= (Subset ?S ?T) true_1)) (not (= (Subset ?T ?S) true_1))))) :pattern ((Equal ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Subset ?S ?T) true_1)))) (= (select1 ?T ?x_1) true_1)) :pattern ((select1 ?S ?x_1) (Subset ?S ?T)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Subset ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1))))))) :pattern ((Subset ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (not (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Disjoint ?S ?T) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 ?S ?x_1) (Disjoint ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Disjoint ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((Disjoint ?S ?T)) ))) (not (forall ((?M Int) (?x_1 Int)) (! (= (select1 (Unified ?M) ?x_1) (select1 (select1 ?M (Field ?x_1)) ?x_1)) :pattern ((select1 (Unified ?M) ?x_1)) ))) (not (forall ((?M Int) (?x_1 Int) (?y Int)) (! (let ((?v_1 (Field ?x_1))) (= (Unified (store1 ?M ?v_1 (store1 (select1 ?M ?v_1) ?x_1 ?y))) (store1 (Unified ?M) ?x_1 ?y))) :pattern ((Unified (store1 ?M (Field ?x_1) (store1 (select1 ?M (Field ?x_1)) ?x_1 ?y)))) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (select1 (Values ?t) ?v) true_1) (= (HasType ?v ?t) true_1)) :pattern ((select1 (Values ?t) ?v)) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (HasType ?v ?t) true_1) (= (select1 (Values ?t) ?v) true_1)) :pattern ((HasType ?v ?t) (Values ?t)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a a_Foo_name) true_1) (= (Field ?a) a_Foo_name)) :pattern ((Match ?a a_Foo_name)) ))) (not (forall ((?v Int)) (= (HasType ?v a_Foo_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a b_Foo_name) true_1) (= (Field ?a) b_Foo_name)) :pattern ((Match ?a b_Foo_name)) ))) (not (forall ((?v Int)) (= (HasType ?v b_Foo_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a Foo_name) true_1) (not (or (not true) (not (= (Match (a_Foo ?a) a_Foo_name) true_1)) (not (= (Match (b_Foo ?a) b_Foo_name) true_1))))) :pattern ((Match ?a Foo_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a INT4_name) true_1) (= (Field ?a) INT4_name)) :pattern ((Match ?a INT4_name)) ))) (not (forall ((?v Int)) (= (HasType ?v INT4_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a PFoo_name) true_1) (= (Field ?a) PFoo_name)) :pattern ((Match ?a PFoo_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PFoo_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v Foo_name) true_1)))))) :pattern ((HasType ?v PFoo_name))  :pattern ((Match ?v Foo_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PINT4_name) true_1) (= (Field ?a) PINT4_name)) :pattern ((Match ?a PINT4_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PINT4_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v INT4_name) true_1)))))) :pattern ((HasType ?v PINT4_name))  :pattern ((Match ?v INT4_name)) ))) (not (forall ((?x_1 Int)) (! (= (a_FooInv (a_Foo ?x_1)) ?x_1) :pattern ((a_Foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (a_Foo (a_FooInv ?x_1)) ?x_1) :pattern ((a_FooInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_a_Foo ?S) ?x_1) true_1) (= (select1 ?S (a_FooInv ?x_1)) true_1)) :pattern ((select1 (S_a_Foo ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_a_FooInv ?S) ?x_1) true_1) (= (select1 ?S (a_Foo ?x_1)) true_1)) :pattern ((select1 (S_a_FooInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_a_Foo ?S) (a_Foo ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_a_Foo ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_a_FooInv ?S) (a_FooInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_a_FooInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (a_Foo ?x_1) (+ ?x_1 0)) :pattern ((a_Foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (a_FooInv ?x_1) (- ?x_1 0)) :pattern ((a_FooInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1) (a_FooInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 0) (a_FooInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 0)) ))) (not (forall ((?x_1 Int)) (! (= (b_FooInv (b_Foo ?x_1)) ?x_1) :pattern ((b_Foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (b_Foo (b_FooInv ?x_1)) ?x_1) :pattern ((b_FooInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_b_Foo ?S) ?x_1) true_1) (= (select1 ?S (b_FooInv ?x_1)) true_1)) :pattern ((select1 (S_b_Foo ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_b_FooInv ?S) ?x_1) true_1) (= (select1 ?S (b_Foo ?x_1)) true_1)) :pattern ((select1 (S_b_FooInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_b_Foo ?S) (b_Foo ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_b_Foo ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_b_FooInv ?S) (b_FooInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_b_FooInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (b_Foo ?x_1) (+ ?x_1 4)) :pattern ((b_Foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (b_FooInv ?x_1) (- ?x_1 4)) :pattern ((b_FooInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1) (b_FooInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 4) (b_FooInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 4)) ))) (not (forall ((?a Int) (?b Int) (?size Int)) (! (let ((?v_3 (MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) (?v_2 (- ?a ?b))) (not (or (not (<= (* ?size ?v_3) ?v_2)) (not (< ?v_2 (* ?size (+ ?v_3 1))))))) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (MINUS_LEFT_PTR ?a ?a_size ?b) (- ?a (* ?a_size ?b))) :pattern ((MINUS_LEFT_PTR ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (PLUS ?a ?a_size ?b) (+ ?a (* ?a_size ?b))) :pattern ((PLUS ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (MULT ?a ?b) (* ?a ?b)) :pattern ((MULT ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_4 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (> ?b 0)))) (not (or (not (<= (* ?b ?v_4) ?a)) (not (< ?a (* ?b (+ ?v_4 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_5 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (< ?b 0)))) (not (or (not (<= (* ?b ?v_5) ?a)) (not (< ?a (* ?b (- ?v_5 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_6 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (> ?b 0)))) (not (or (not (>= (* ?b ?v_6) ?a)) (not (> ?a (* ?b (- ?v_6 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_7 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (< ?b 0)))) (not (or (not (>= (* ?b ?v_7) ?a)) (not (> ?a (* ?b (+ ?v_7 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (= (POW2 1) true_1)) (not (= (POW2 2) true_1)) (not (= (POW2 4) true_1)) (not (= (POW2 8) true_1)) (not (= (POW2 16) true_1)) (not (= (POW2 32) true_1)) (not (= (POW2 64) true_1)) (not (= (POW2 128) true_1)) (not (= (POW2 256) true_1)) (not (= (POW2 512) true_1)) (not (= (POW2 1024) true_1)) (not (= (POW2 2048) true_1)) (not (= (POW2 4096) true_1)) (not (= (POW2 8192) true_1)) (not (= (POW2 16384) true_1)) (not (= (POW2 32768) true_1)) (not (= (POW2 65536) true_1)) (not (= (POW2 131072) true_1)) (not (= (POW2 262144) true_1)) (not (= (POW2 524288) true_1)) (not (= (POW2 1048576) true_1)) (not (= (POW2 2097152) true_1)) (not (= (POW2 4194304) true_1)) (not (= (POW2 8388608) true_1)) (not (= (POW2 16777216) true_1)) (not (= (POW2 33554432) true_1)) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (= ?a true_1) (= (choose ?a ?b ?c) ?b)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (not (= ?a true_1)) (= (choose ?a ?b ?c) ?c)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= ?a ?b) (= (BIT_BAND ?a ?b) ?a)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (not (or (not (= (POW2 ?a) true_1)) (not (= (POW2 ?b) true_1)) (not (not (= ?a ?b))))) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (or (= ?a 0) (= ?b 0)) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int)) (! (= (= ?a true_1) (not (= (LIFT ?a) 0))) :pattern ((LIFT ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (boolNot ?a) 0))) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (boolNot ?a) 0)) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (NULL_CHECK ?a) 0))) :pattern ((NULL_CHECK ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (NULL_CHECK ?a) 0)) :pattern ((NULL_CHECK ?a)) ))) (not (not (= x_1 0))) (not (not (= y 0))))))
(assert (let ((?v_10 (b_Foo p1))) (let ((?v_29 (Field ?v_10))) (let ((?v_32 (select1 (select1 Mem ?v_29) ?v_10)) (?v_12 (b_Foo y))) (let ((?v_13 (Field ?v_12))) (let ((?v_33 (= (select1 (select1 Mem_3 ?v_13) ?v_12) ?v_32)) (?v_1 (a_Foo p1))) (let ((?v_26 (Field ?v_1))) (let ((?v_27 (select1 (select1 Mem ?v_26) ?v_1)) (?v_3 (a_Foo y))) (let ((?v_11 (Field ?v_3))) (let ((?v_31 (= (select1 (select1 Mem_3 ?v_11) ?v_3) ?v_27)) (?v_30 (= (select1 (select1 Mem_3 ?v_29) ?v_10) ?v_32)) (?v_28 (= (select1 (select1 Mem_3 ?v_26) ?v_1) ?v_27)) (?v_25 (forall ((?f Int)) (! (let ((?v_35 (Base ?f))) (let ((?v_34 (select1 alloc ?v_35))) (or (= ?v_34 UNALLOCATED) (= ?v_34 (select1 alloc_1 ?v_35))))) :pattern ((select1 alloc_1 (Base ?f))) ))) (?v_24 (forall ((?f Int) (?m Int)) (! (or (not (or (not (= ?m ?v_3)) (not (= ?f ?v_11)))) (not (or (not (= ?m ?v_12)) (not (= ?f ?v_13)))) (= (select1 (select1 Mem_3 ?f) ?m) (select1 (select1 Mem ?f) ?m))) :pattern ((select1 (select1 Mem_3 ?f) ?m)) ))) (?v_14 (forall ((?a Int)) (! (let ((?v_36 (Field ?a))) (= (HasType (select1 (select1 Mem_3 ?v_36) ?a) ?v_36) true_1)) :pattern ((select1 (select1 Mem_3 (Field ?a)) ?a)) )))) (let ((?v_23 (not ?v_14)) (?v_16 (= (HasType x_1 PFoo_name) true_1))) (let ((?v_22 (not ?v_16)) (?v_17 (= (HasType y PFoo_name) true_1))) (let ((?v_21 (not ?v_17)) (?v_20 (= (select1 alloc_0 call5045formal_new_0) ALLOCATED))) (let ((?v_19 (not ?v_20)) (?v_18 (= (Base call5045formal_new_0) call5045formal_new_0)) (?v_15 (= (HasType call5045formal_new_0 PFoo_name) true_1)) (?v_9 (b_Foo call5045formal_new_0))) (let ((?v_8 (Field ?v_9)) (?v_7 (a_Foo call5045formal_new_0))) (let ((?v_6 (Field ?v_7)) (?v_5 (>= 8 0)) (?v_2 (Base ?v_3)) (?v_4 (Base ?v_12)) (?v_0 (Base ?v_1))) (not (=> true (=> ?v_17 (=> ?v_16 (=> (= (HasType p1 PFoo_name) true_1) (=> (forall ((?a Int)) (! (let ((?v_37 (Field ?a))) (= (HasType (select1 (select1 Mem ?v_37) ?a) ?v_37) true_1)) :pattern ((select1 (select1 Mem (Field ?a)) ?a)) )) (=> (= (Base ?v_10) ?v_0) (=> (= ?v_4 ?v_2) (=> (= ?v_0 ?v_1) (=> (= ?v_2 ?v_3) (=> (= (select1 alloc ?v_4) ALLOCATED) (=> (= (select1 alloc ?v_2) ALLOCATED) (=> true (not (or (not ?v_5) (not (=> ?v_5 (=> (> call5045formal_new_0 0) (=> (forall ((?x_1 Int)) (! (=> (not (or (not (<= call5045formal_new_0 ?x_1)) (not (< ?x_1 (+ call5045formal_new_0 8))))) (= (Base ?x_1) call5045formal_new_0)) :pattern ((Base ?x_1)) )) (=> (forall ((?x_1 Int)) (! (or (= ?x_1 call5045formal_new_0) (= (select1 alloc ?x_1) (select1 alloc_0 ?x_1))) :pattern ((select1 alloc_0 ?x_1)) )) (=> (not (or (not (= (select1 alloc call5045formal_new_0) UNALLOCATED)) ?v_19)) (=> ?v_15 (=> (not (or (not (= (Subset Empty (HavocArray call5045formal_new_0 8 1)) true_1)) (not (forall ((?x_2 Int)) (! (=> (= (select1 (HavocArray call5045formal_new_0 8 1) ?x_2) true_1) (= (Match ?x_2 Foo_name) true_1)) :pattern ((select1 (HavocArray call5045formal_new_0 8 1) ?x_2)) ))))) (=> (= (Match call5045formal_new_0 Foo_name) true_1) (=> (= (Base p1) p1) (=> (= Mem_0 (store1 Mem ?v_6 (store1 (select1 Mem ?v_6) ?v_7 ?v_27))) (=> (= Mem_1 (store1 Mem_0 ?v_8 (store1 (select1 Mem_0 ?v_8) ?v_9 (select1 (select1 Mem_0 ?v_29) ?v_10)))) (=> true (=> true (=> true (=> (= Mem_2 (store1 Mem_1 ?v_11 (store1 (select1 Mem_1 ?v_11) ?v_3 (select1 (select1 Mem_1 ?v_6) ?v_7)))) (=> (= Mem_3 (store1 Mem_2 ?v_13 (store1 (select1 Mem_2 ?v_13) ?v_12 (select1 (select1 Mem_2 ?v_8) ?v_9)))) (not (or ?v_23 (not (=> ?v_14 (not (or (not ?v_15) (not (=> ?v_15 (not (or ?v_22 (not (=> ?v_16 (not (or ?v_21 (not (=> ?v_17 (=> true (=> true (=> true (not (or (not ?v_18) (not (=> ?v_18 (not (or ?v_19 (not (=> ?v_20 (=> (forall ((?x_1 Int)) (! (or (= ?x_1 call5045formal_new_0) (= (select1 alloc_0 ?x_1) (select1 alloc_1 ?x_1))) :pattern ((select1 alloc_1 ?x_1)) )) (=> (= (select1 alloc_1 call5045formal_new_0) FREED) (=> (forall ((?m Int)) (! (let ((?v_39 (Field ?m)) (?v_38 (Base ?m))) (=> (not (or (not (not (= (select1 alloc_1 ?v_38) ALLOCATED))) (not (not (= (select1 alloc ?v_38) ALLOCATED))))) (= (select1 (select1 Mem_3 ?v_39) ?m) (select1 (select1 Mem ?v_39) ?m)))) :pattern ((select1 (select1 Mem_3 (Field ?m)) ?m)) )) (=> true (=> true (not (or ?v_21 (not (=> ?v_17 (not (or ?v_22 (not (=> ?v_16 (not (or ?v_23 (not (=> ?v_14 (not (or (not ?v_24) (not (=> ?v_24 (not (or (not ?v_25) (not (=> ?v_25 (not (or (not ?v_28) (not (=> ?v_28 (not (or (not ?v_30) (not (=> ?v_30 (not (or (not ?v_31) (not (=> ?v_31 (not (or (not ?v_33) (not (=> ?v_33 true))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
