(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun Length (Int Int Int) Int)
(declare-fun mutable () Int)
(declare-fun status_tag () Int)
(declare-fun good_meta (Int) Int)
(declare-fun dot (Int Int) Int)
(declare-fun ArrayList_length () Int)
(declare-fun inv (Int Int Int Int) Int)
(declare-fun ArrayList () Int)
(declare-fun consistent () Int)
(declare-fun ValidArrayList (Int Int Int) Int)
(declare-fun ArrayList_capacity () Int)
(declare-fun typed (Int Int) Int)
(declare-fun ptr (Int Int) Int)
(declare-fun ref (Int) Int)
(declare-fun ArrayList_array () Int)
(declare-fun array (Int Int) Int)
(declare-fun int () Int)
(declare-fun set_eq (Int Int) Int)
(declare-fun set_singleton (Int) Int)
(declare-fun owned_tag () Int)
(declare-fun is (Int Int) Int)
(declare-fun ptr_to (Int) Int)
(declare-fun ts_is_array_elt (Int) Int)
(declare-fun ts_tag () Int)
(declare-fun ts_path (Int) Int)
(declare-fun emb (Int Int) Int)
(declare-fun field_offset (Int) Int)
(declare-fun in_extent_of (Int Int Int) Int)
(declare-fun in_full_extent_of (Int Int) Int)
(declare-fun ptr_level (Int) Int)
(declare-fun kind_composite () Int)
(declare-fun kind_of (Int) Int)
(declare-fun sizeof (Int) Int)
(declare-fun set_in (Int Int) Int)
(declare-fun array_range (Int Int Int) Int)
(declare-fun idx (Int Int Int) Int)
(declare-fun is_array (Int Int Int Int) Int)
(declare-fun kind_array () Int)
(declare-fun array_length (Int) Int)
(declare-fun element_type (Int) Int)
(declare-fun set_disjoint (Int Int) Int)
(declare-fun dont_instantiate (Int) Int)
(declare-fun set_subset (Int Int) Int)
(declare-fun set_subtraction (Int Int) Int)
(declare-fun set_union (Int Int) Int)
(declare-fun set_empty () Int)
(declare-fun full_extent (Int) Int)
(declare-fun is_primitive (Int) Int)
(declare-fun good_state (Int) Int)
(declare-fun typ (Int) Int)
(declare-fun ts_typed (Int) Int)
(declare-fun ts_emb (Int) Int)
(declare-fun dont_instantiate_int (Int) Int)
(declare-fun void () Int)
(declare-fun null () Int)
(declare-fun kind_primitive () Int)
(declare-fun map_t (Int Int) Int)
(declare-fun map_range (Int) Int)
(declare-fun map_domain (Int) Int)
(declare-fun unptr_to (Int) Int)
(declare-fun hasowner_tag () Int)
(declare-fun committed () Int)
(declare-fun ptrset () Int)
(declare-fun meta_3 () Int)
(declare-fun meta_4 () Int)
(declare-fun i_0 () Int)
(declare-fun i_2 () Int)
(declare-fun state_3 () Int)
(declare-fun state_4 () Int)
(declare-fun result_0 () Int)
(declare-fun meta_1 () Int)
(declare-fun call9385formal__result_0 () Int)
(declare-fun state_1 () Int)
(declare-fun instantiate_int (Int) Int)
(declare-fun meta () Int)
(declare-fun state () Int)
(declare-fun i_1 () Int)
(declare-fun state_2 () Int)
(declare-fun meta_2 () Int)
(declare-fun state_0 () Int)
(declare-fun meta_0 () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct int void ptrset kind_composite kind_primitive kind_array mutable consistent committed status_tag ts_tag owned_tag hasowner_tag ArrayList ArrayList_capacity ArrayList_length ArrayList_array)) (not (= (sizeof int) 4)) (not (= (ptr_level int) 0)) (not (= (ptr_level void) 0)) (not (forall ((?n Int)) (! (= (unptr_to (ptr_to ?n)) ?n) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (ptr_level (ptr_to ?n)) (+ (ptr_level ?n) 2)) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (sizeof (ptr_to ?n)) 8) :pattern ((ptr_to ?n)) ))) (not (forall ((?r Int) (?d Int)) (! (= (ptr_level (map_t ?r ?d)) (+ (ptr_level ?r) 3)) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_domain (map_t ?r ?d)) ?d) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_range (map_t ?r ?d)) ?r) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (is_primitive (map_t ?r ?d)) true_1) :pattern ((map_t ?r ?d)) ))) (not (forall ((?t Int)) (! (= (= (is_primitive ?t) true_1) (= (kind_of ?t) kind_primitive)) :pattern ((is_primitive ?t)) ))) (not (forall ((?n Int)) (! (= (is_primitive (ptr_to ?n)) true_1) :pattern ((ptr_to ?n)) ))) (not (= (is_primitive int) true_1)) (not (forall ((?t_1 Int) (?b Int)) (= (typ (ptr ?t_1 ?b)) ?t_1))) (not (forall ((?t_1 Int) (?b Int)) (= (ref (ptr ?t_1 ?b)) ?b))) (not (= null (ptr void 0))) (not (forall ((?p_1 Int) (?t_1 Int)) (= (= (is ?p_1 ?t_1) true_1) (= (typ ?p_1) ?t_1)))) (not (forall ((?p_1 Int) (?t_1 Int)) (! (=> (= (is ?p_1 ?t_1) true_1) (exists ((?r Int)) (! (= ?p_1 (ptr ?t_1 ?r)) :pattern ((dont_instantiate_int ?r)) ))) :pattern ((is ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (= (emb ?m ?p_1) (ts_emb (select2 ?m ?p_1 ts_tag))) :pattern ((emb ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (= (good_meta ?m) true_1) (= (= (typed ?m ?p_1) true_1) (= (ts_typed (select2 ?m ?p_1 ts_tag)) true_1))) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (typed ?m ?p_1) true_1)))) (> (ref ?p_1) 0)) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?s Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array))) (not (= (typ ?p_1) ?t_1)))) (= (= (inv ?m ?s ?p_1 ?t_1) true_1) true)) :pattern ((inv ?m ?s ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?r Int) (?t_1 Int)) (! (=> (= (good_meta ?m) true_1) (=> (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array)) (= (select2 ?m (ptr ?t_1 ?r) owned_tag) set_empty))) :pattern ((select2 ?m (ptr ?t_1 ?r) owned_tag)) ))) (not (forall ((?m Int) (?s Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (good_state ?s) true_1)) (not (= (select2 ?m ?p_1 status_tag) consistent)))) (= (inv ?m ?s ?p_1 ?t_1) true_1)) :pattern ((inv ?m ?s ?p_1 ?t_1)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?r_1 Int) (?p Int)) (! (let ((?v_0 (ptr ?T ?r_1))) (= (= (in_full_extent_of ?p ?v_0) true_1) (= ?p ?v_0))) :pattern ((in_full_extent_of ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?M Int) (?r_1 Int) (?p Int)) (! (let ((?v_1 (ptr ?T ?r_1))) (= (= (in_extent_of ?M ?p ?v_1) true_1) (= ?p ?v_1))) :pattern ((in_extent_of ?M ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?p_1 Int) (?l Int)) (! (= (= (set_in ?p_1 (full_extent ?l)) true_1) (= (in_full_extent_of ?p_1 ?l) true_1)) :pattern ((set_in ?p_1 (full_extent ?l))) ))) (not (forall ((?o_1 Int)) (! (not (= (set_in ?o_1 set_empty) true_1)) :pattern ((set_in ?o_1 set_empty)) ))) (not (forall ((?r Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_singleton ?r)) true_1) (= ?r ?o_1)) :pattern ((set_in ?o_1 (set_singleton ?r))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_union ?a ?b)) true_1) (or (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 (set_union ?a ?b))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_subtraction ?a ?b)) true_1) (not (or (not (= (set_in ?o_1 ?a) true_1)) (not (not (= (set_in ?o_1 ?b) true_1)))))) :pattern ((set_in ?o_1 (set_subtraction ?a ?b))) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_subset ?a ?b) true_1) (forall ((?o_1 Int)) (! (=> (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_subset ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (forall ((?o_1 Int)) (! (= (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((dont_instantiate ?o_1)) )) (= (set_eq ?a ?b) true_1)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= (set_eq ?a ?b) true_1) (= ?a ?b)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_disjoint ?a ?b) true_1) (forall ((?o_1 Int)) (! (or (not (= (set_in ?o_1 ?a) true_1)) (not (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_disjoint ?a ?b)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (element_type (array ?T ?s_1)) ?T) :pattern ((array ?T ?s_1)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (array_length (array ?T ?s_1)) ?s_1) :pattern ((array ?T ?s_1)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (ptr_level (array ?T ?s_1)) 0) :pattern ((array ?T ?s_1)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (kind_of (array ?T ?s_1)) kind_array) :pattern ((array ?T ?s_1)) ))) (not (forall ((?p_1 Int) (?i_3 Int) (?t_1 Int)) (! (= (idx ?p_1 ?i_3 ?t_1) (ptr ?t_1 (+ (ref ?p_1) (* ?i_3 (sizeof ?t_1))))) :pattern ((idx ?p_1 ?i_3 ?t_1)) ))) (not (forall ((?p Int) (?i Int) (?j Int) (?T Int)) (! (=> (not (= ?i 0)) (= (idx (idx ?p ?i ?T) ?j ?T) (idx ?p (+ ?i ?j) ?T))) :pattern ((idx (idx ?p ?i ?T) ?j ?T)) ))) (not (forall ((?M Int) (?p Int) (?T Int) (?sz Int)) (! (= (= (is_array ?M ?p ?T ?sz) true_1) (not (or (not (= (is ?p ?T) true_1)) (not (forall ((?i Int)) (! (let ((?v_2 (idx ?p ?i ?T))) (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (not (or (not (= (ts_is_array_elt (select2 ?M ?v_2 ts_tag)) true_1)) (not (= (typed ?M ?v_2) true_1)))))) :pattern ((idx ?p ?i ?T)) )))))) :pattern ((is_array ?M ?p ?T ?sz)) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_3 (ptr (array ?T ?sz) ?r))) (= (= (in_full_extent_of ?p ?v_3) true_1) (or (= ?p ?v_3) (exists ((?i_3 Int)) (! (not (or (not (<= 0 ?i_3)) (not (< ?i_3 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_3 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_3 ?T)) ))))) :pattern ((in_full_extent_of ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_4 (ptr (array ?T ?sz) ?r))) (= (= (in_extent_of ?M ?p ?v_4) true_1) (or (= ?p ?v_4) (exists ((?i_3 Int)) (! (not (or (not (<= 0 ?i_3)) (not (< ?i_3 ?sz)) (not (= (in_extent_of ?M ?p (idx (ptr ?T ?r) ?i_3 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_3 ?T)) ))))) :pattern ((in_extent_of ?M ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?r Int) (?T Int) (?sz Int)) (! (=> (= (typed ?M (ptr (array ?T ?sz) ?r)) true_1) (not (or (not (= (is_array ?M (ptr ?T ?r) ?T ?sz) true_1)) (not (forall ((?i Int)) (! (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (= (emb ?M (idx (ptr ?T ?r) ?i ?T)) (ptr (array ?T ?sz) ?r))) :pattern ((idx (ptr ?T ?r) ?i ?T)) )))))) :pattern ((typed ?M (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (= (= (set_in ?p (array_range (ptr ?T ?r) ?T ?sz)) true_1) (exists ((?i_3 Int)) (! (not (or (not (<= 0 ?i_3)) (not (< ?i_3 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_3 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_3 ?T)) ))) :pattern ((set_in ?p (array_range (ptr ?T ?r) ?T ?sz))) ))) (not (= (sizeof ArrayList) 16)) (not (= (kind_of ArrayList) kind_composite)) (not (= (ptr_level ArrayList) 0)) (not (forall ((?r Int) (?q Int)) (! (let ((?v_5 (ptr ArrayList ?r))) (= (= (in_full_extent_of ?q ?v_5) true_1) (or (= ?q ?v_5) (= ?q (dot ?v_5 ArrayList_capacity)) (= ?q (dot ?v_5 ArrayList_length)) (= ?q (dot ?v_5 ArrayList_array))))) :pattern ((in_full_extent_of ?q (ptr ArrayList ?r))) ))) (not (forall ((?m Int) (?r Int) (?q Int)) (! (let ((?v_6 (ptr ArrayList ?r))) (= (= (in_extent_of ?m ?q ?v_6) true_1) (or (= ?q ?v_6) (= ?q (dot ?v_6 ArrayList_capacity)) (= ?q (dot ?v_6 ArrayList_length)) (= ?q (dot ?v_6 ArrayList_array))))) :pattern ((in_extent_of ?m ?q (ptr ArrayList ?r))) ))) (not (= (field_offset ArrayList_capacity) 0)) (not (forall ((?p_1 Int)) (! (=> (= (is ?p_1 ArrayList) true_1) (= (dot ?p_1 ArrayList_capacity) (ptr int (+ (ref ?p_1) 0)))) :pattern ((dot ?p_1 ArrayList_capacity)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_7 (dot ?p_1 ArrayList_capacity))) (let ((?v_8 (select2 ?m ?v_7 ts_tag))) (=> (not (or (not (= (is ?p_1 ArrayList) true_1)) (not (= (typed ?m ?p_1) true_1)))) (not (or (not (= (typed ?m ?v_7) true_1)) (not (= (emb ?m ?v_7) ?p_1)) (not (= (ts_path ?v_8) ArrayList_capacity)) (not (not (= (ts_is_array_elt ?v_8) true_1)))))))) :pattern ((typed ?m (dot ?p_1 ArrayList_capacity)))  :pattern ((dot ?p_1 ArrayList_capacity) (typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_11 (dot ?p_1 ArrayList_capacity)) (?v_10 (not (= (typed ?m ?p_1) true_1))) (?v_9 (not (= (is ?p_1 ArrayList) true_1)))) (=> (not (or ?v_9 ?v_10 ?v_9 ?v_10 (not (= (select2 ?m ?p_1 status_tag) mutable)))) (not (or (not (= (is ?v_11 int) true_1)) (not (= (typed ?m ?v_11) true_1)) (not (= (select2 ?m ?v_11 status_tag) mutable)))))) :pattern ((select2 ?m (dot ?p_1 ArrayList_capacity) status_tag)) ))) (not (= (field_offset ArrayList_length) 4)) (not (forall ((?p_1 Int)) (! (=> (= (is ?p_1 ArrayList) true_1) (= (dot ?p_1 ArrayList_length) (ptr int (+ (ref ?p_1) 4)))) :pattern ((dot ?p_1 ArrayList_length)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_12 (dot ?p_1 ArrayList_length))) (let ((?v_13 (select2 ?m ?v_12 ts_tag))) (=> (not (or (not (= (is ?p_1 ArrayList) true_1)) (not (= (typed ?m ?p_1) true_1)))) (not (or (not (= (typed ?m ?v_12) true_1)) (not (= (emb ?m ?v_12) ?p_1)) (not (= (ts_path ?v_13) ArrayList_length)) (not (not (= (ts_is_array_elt ?v_13) true_1)))))))) :pattern ((typed ?m (dot ?p_1 ArrayList_length)))  :pattern ((dot ?p_1 ArrayList_length) (typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_16 (dot ?p_1 ArrayList_length)) (?v_15 (not (= (typed ?m ?p_1) true_1))) (?v_14 (not (= (is ?p_1 ArrayList) true_1)))) (=> (not (or ?v_14 ?v_15 ?v_14 ?v_15 (not (= (select2 ?m ?p_1 status_tag) mutable)))) (not (or (not (= (is ?v_16 int) true_1)) (not (= (typed ?m ?v_16) true_1)) (not (= (select2 ?m ?v_16 status_tag) mutable)))))) :pattern ((select2 ?m (dot ?p_1 ArrayList_length) status_tag)) ))) (not (= (field_offset ArrayList_array) 8)) (not (forall ((?p_1 Int)) (! (=> (= (is ?p_1 ArrayList) true_1) (= (dot ?p_1 ArrayList_array) (ptr (ptr_to int) (+ (ref ?p_1) 8)))) :pattern ((dot ?p_1 ArrayList_array)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_17 (dot ?p_1 ArrayList_array))) (let ((?v_18 (select2 ?m ?v_17 ts_tag))) (=> (not (or (not (= (is ?p_1 ArrayList) true_1)) (not (= (typed ?m ?p_1) true_1)))) (not (or (not (= (typed ?m ?v_17) true_1)) (not (= (emb ?m ?v_17) ?p_1)) (not (= (ts_path ?v_18) ArrayList_array)) (not (not (= (ts_is_array_elt ?v_18) true_1)))))))) :pattern ((typed ?m (dot ?p_1 ArrayList_array)))  :pattern ((dot ?p_1 ArrayList_array) (typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_21 (dot ?p_1 ArrayList_array)) (?v_20 (not (= (typed ?m ?p_1) true_1))) (?v_19 (not (= (is ?p_1 ArrayList) true_1)))) (=> (not (or ?v_19 ?v_20 ?v_19 ?v_20 (not (= (select2 ?m ?p_1 status_tag) mutable)))) (not (or (not (= (is ?v_21 (ptr_to int)) true_1)) (not (= (typed ?m ?v_21) true_1)) (not (= (select2 ?m ?v_21 status_tag) mutable)))))) :pattern ((select2 ?m (dot ?p_1 ArrayList_array) status_tag)) ))) (not (forall ((?s Int) (?m Int)) (forall ((?A Int)) (= (= (inv ?m ?s ?A ArrayList) true_1) (= (ValidArrayList ?m ?s ?A) true_1))))) (not (forall ((?m Int) (?s Int) (?A Int)) (! (let ((?v_22 (select1 ?s (dot ?A ArrayList_capacity))) (?v_24 (select1 ?s (dot ?A ArrayList_length)))) (let ((?v_23 (ptr (array int ?v_22) (ref (select1 ?s (dot ?A ArrayList_array)))))) (= (= (ValidArrayList ?m ?s ?A) true_1) (not (or (not (= (is ?A ArrayList) true_1)) (not (= (typed ?m ?A) true_1)) (not (>= ?v_22 0)) (not (= (set_eq (select2 ?m ?A owned_tag) (set_singleton ?v_23)) true_1)) (not (= (typed ?m ?v_23) true_1)) (not (>= ?v_24 0)) (not (<= ?v_24 ?v_22))))))) :pattern ((ValidArrayList ?m ?s ?A)) ))) (not (forall ((?m1 Int) (?s1 Int) (?m2 Int) (?s2 Int) (?A Int)) (! (=> (not (or (not (= (good_meta ?m1) true_1)) (not (= (good_meta ?m2) true_1)) (not (= (select1 ?s1 ?A) (select1 ?s2 ?A))) (not (or (not (= (select2 ?m1 ?A status_tag) mutable)) (not (= (select2 ?m2 ?A status_tag) mutable)))))) (= (= (ValidArrayList ?m1 ?s1 ?A) true_1) (= (ValidArrayList ?m2 ?s2 ?A) true_1))) :pattern ((ValidArrayList ?m1 ?s1 ?A) (ValidArrayList ?m2 ?s2 ?A)) ))) (not (forall ((?m Int) (?s Int) (?A Int)) (! (=> (not (or (not (= (select2 ?m ?A status_tag) consistent)) (not (= (inv ?m ?s ?A ArrayList) true_1)))) (= (Length ?m ?s ?A) (select1 ?s (dot ?A ArrayList_length)))) :pattern ((Length ?m ?s ?A)) ))) (not (forall ((?m1 Int) (?s1 Int) (?m2 Int) (?s2 Int) (?A Int)) (! (=> (not (or (not (= (good_meta ?m1) true_1)) (not (= (good_meta ?m2) true_1)) (not (= (select1 ?s1 ?A) (select1 ?s2 ?A))) (not (or (not (= (select2 ?m1 ?A status_tag) mutable)) (not (= (select2 ?m2 ?A status_tag) mutable)))))) (= (Length ?m1 ?s1 ?A) (Length ?m2 ?s2 ?A))) :pattern ((Length ?m1 ?s1 ?A) (Length ?m2 ?s2 ?A)) ))))))
(assert (let ((?v_2 (not (<= 1 1))) (?v_12 (not (<= 0 i_0))) (?v_1 (not (<= 0 0)))) (let ((?v_13 (not (or ?v_1 ?v_1 ?v_12 ?v_2 ?v_2))) (?v_11 (= (is call9385formal__result_0 ArrayList) true_1))) (let ((?v_10 (not ?v_11)) (?v_6 (select2 meta_1 call9385formal__result_0 status_tag))) (let ((?v_7 (= ?v_6 consistent))) (let ((?v_9 (not (or (not ?v_7) (not (= (inv meta_1 state_1 call9385formal__result_0 ArrayList) true_1)))))) (let ((?v_16 (not ?v_9)) (?v_8 (not (or (not (or (= (select2 meta call9385formal__result_0 status_tag) committed) (= (instantiate_int ?v_6) true_1))) (not (or (= ?v_6 mutable) ?v_7)))))) (let ((?v_15 (not ?v_8)) (?v_14 (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta ?p_1 status_tag) committed) (= (select1 state ?p_1) (select1 state_1 ?p_1))) :pattern ((select1 state_1 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta ?pm status_tag) committed) (= (select2 meta ?pm ?t_1) (select2 meta_1 ?pm ?t_1))) :pattern ((select2 meta_1 ?pm ?t_1)) )))))) (?v_5 (not (or ?v_12 ?v_2 ?v_2)))) (let ((?v_19 (=> ?v_5 (=> true (=> ?v_5 (=> ?v_14 (not (or ?v_15 (not (=> ?v_8 (not (or ?v_16 (not (=> ?v_9 (not (or ?v_10 (not (=> ?v_11 (=> (= (good_state state_3) true_1) (=> (= (good_meta meta_3) true_1) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_1 ?p_1 status_tag) committed) (= ?p_1 call9385formal__result_0) (= (select1 state_1 ?p_1) (select1 state_3 ?p_1))) :pattern ((select1 state_3 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta_1 ?pm status_tag) committed) (= ?pm call9385formal__result_0) (= (select2 meta_1 ?pm ?t_1) (select2 meta_3 ?pm ?t_1))) :pattern ((select2 meta_3 ?pm ?t_1)) ))))) (=> ?v_13 (=> true (=> ?v_13 (=> ?v_13 (=> true (=> (= result_0 0) (=> (= state_4 state_3) (=> (= i_2 i_0) (=> (= meta_4 meta_3) true))))))))))))))))))))))))))))) (?v_18 (not (or (not (<= 0 i_1)) ?v_2 ?v_2))) (?v_17 (not (or (not (= (select2 meta_2 call9385formal__result_0 status_tag) consistent)) (not (= (inv meta_2 state_2 call9385formal__result_0 ArrayList) true_1))))) (?v_4 (not (or ?v_1 ?v_2 ?v_2))) (?v_3 (not (or (not (= (select2 meta_0 call9385formal__result_0 status_tag) consistent)) (not (= (inv meta_0 state_0 call9385formal__result_0 ArrayList) true_1))))) (?v_0 (< 0 1))) (not (=> true (=> (= (good_meta meta) true_1) (=> (= (good_state state) true_1) (=> true (not (or (not ?v_0) (not (=> ?v_0 (=> (= (good_state state_0) true_1) (=> (= (good_meta meta_0) true_1) (=> ?v_3 (=> (not (= (select2 meta_0 call9385formal__result_0 hasowner_tag) true_1)) (=> (not (not (or ?v_10 (not (= (typed meta call9385formal__result_0) true_1))))) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta ?p_1 status_tag) committed) (= (select1 state ?p_1) (select1 state_0 ?p_1))) :pattern ((select1 state_0 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta ?pm status_tag) committed) (= (select2 meta ?pm ?t_1) (select2 meta_0 ?pm ?t_1))) :pattern ((select2 meta_0 ?pm ?t_1)) ))))) (=> (not (or ?v_1 ?v_1 ?v_2 ?v_2)) (=> ?v_4 (not (or (not ?v_3) (not (=> ?v_3 (=> ?v_4 (=> true (=> (= (good_state state_1) true_1) (=> (= (good_meta meta_1) true_1) (=> ?v_5 (=> ?v_9 (=> ?v_5 (not (or (not (=> true (=> ?v_5 (=> (not true) ?v_19)))) (not (=> true (=> ?v_5 (=> true (=> ?v_14 (=> ?v_5 (not (or (not (=> true (=> ?v_5 (=> (< i_0 1) (not (or ?v_15 (not (=> ?v_8 (not (or ?v_16 (not (=> ?v_9 (not (or ?v_10 (not (=> ?v_11 (=> (= (good_state state_2) true_1) (=> (= (good_meta meta_2) true_1) (=> ?v_17 (=> (= (Length meta_2 state_2 call9385formal__result_0) (+ (Length meta_1 state_1 call9385formal__result_0) 1)) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_1 ?p_1 status_tag) committed) (= ?p_1 call9385formal__result_0) (= (select1 state_1 ?p_1) (select1 state_2 ?p_1))) :pattern ((select1 state_2 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta_1 ?pm status_tag) committed) (= ?pm call9385formal__result_0) (= (select2 meta_1 ?pm ?t_1) (select2 meta_2 ?pm ?t_1))) :pattern ((select2 meta_2 ?pm ?t_1)) ))))) (=> (= i_1 (+ i_0 1)) (=> (not (or (not (<= 1 i_1)) ?v_2 ?v_2)) (=> true (=> ?v_18 (not (or (not ?v_17) (not (=> ?v_17 (=> ?v_18 (=> false true))))))))))))))))))))))))))))))) (not (=> true (=> ?v_5 (=> (>= i_0 1) ?v_19)))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
