(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun set_in (Int Int) Int)
(declare-fun array_range (Int Int Int) Int)
(declare-fun ptr (Int Int) Int)
(declare-fun idx (Int Int Int) Int)
(declare-fun in_full_extent_of (Int Int) Int)
(declare-fun typed (Int Int) Int)
(declare-fun array (Int Int) Int)
(declare-fun emb (Int Int) Int)
(declare-fun is_array (Int Int Int Int) Int)
(declare-fun in_extent_of (Int Int Int) Int)
(declare-fun ts_is_array_elt (Int) Int)
(declare-fun ts_tag () Int)
(declare-fun is (Int Int) Int)
(declare-fun sizeof (Int) Int)
(declare-fun ref (Int) Int)
(declare-fun kind_array () Int)
(declare-fun kind_of (Int) Int)
(declare-fun ptr_level (Int) Int)
(declare-fun array_length (Int) Int)
(declare-fun element_type (Int) Int)
(declare-fun set_disjoint (Int Int) Int)
(declare-fun set_eq (Int Int) Int)
(declare-fun dont_instantiate (Int) Int)
(declare-fun set_subset (Int Int) Int)
(declare-fun set_subtraction (Int Int) Int)
(declare-fun set_union (Int Int) Int)
(declare-fun set_singleton (Int) Int)
(declare-fun set_empty () Int)
(declare-fun full_extent (Int) Int)
(declare-fun is_primitive (Int) Int)
(declare-fun inv (Int Int Int Int) Int)
(declare-fun consistent () Int)
(declare-fun status_tag () Int)
(declare-fun good_state (Int) Int)
(declare-fun good_meta (Int) Int)
(declare-fun owned_tag () Int)
(declare-fun typ (Int) Int)
(declare-fun ts_typed (Int) Int)
(declare-fun ts_emb (Int) Int)
(declare-fun dont_instantiate_int (Int) Int)
(declare-fun void () Int)
(declare-fun null () Int)
(declare-fun int () Int)
(declare-fun ptr_to (Int) Int)
(declare-fun kind_primitive () Int)
(declare-fun map_t (Int Int) Int)
(declare-fun map_range (Int) Int)
(declare-fun map_domain (Int) Int)
(declare-fun unptr_to (Int) Int)
(declare-fun hasowner_tag () Int)
(declare-fun committed () Int)
(declare-fun mutable () Int)
(declare-fun kind_composite () Int)
(declare-fun ptrset () Int)
(declare-fun sum_0 () Int)
(declare-fun sum_2 () Int)
(declare-fun i_0 () Int)
(declare-fun i_2 () Int)
(declare-fun result_0 () Int)
(declare-fun meta () Int)
(declare-fun state () Int)
(declare-fun sz () Int)
(declare-fun i_1 () Int)
(declare-fun p () Int)
(declare-fun sum_1 () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct int void ptrset kind_composite kind_primitive kind_array mutable consistent committed status_tag ts_tag owned_tag hasowner_tag)) (not (= (sizeof int) 4)) (not (= (ptr_level int) 0)) (not (= (ptr_level void) 0)) (not (forall ((?n Int)) (! (= (unptr_to (ptr_to ?n)) ?n) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (ptr_level (ptr_to ?n)) (+ (ptr_level ?n) 2)) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (sizeof (ptr_to ?n)) 8) :pattern ((ptr_to ?n)) ))) (not (forall ((?r Int) (?d Int)) (! (= (ptr_level (map_t ?r ?d)) (+ (ptr_level ?r) 3)) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_domain (map_t ?r ?d)) ?d) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_range (map_t ?r ?d)) ?r) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (is_primitive (map_t ?r ?d)) true_1) :pattern ((map_t ?r ?d)) ))) (not (forall ((?t Int)) (! (= (= (is_primitive ?t) true_1) (= (kind_of ?t) kind_primitive)) :pattern ((is_primitive ?t)) ))) (not (forall ((?n Int)) (! (= (is_primitive (ptr_to ?n)) true_1) :pattern ((ptr_to ?n)) ))) (not (= (is_primitive int) true_1)) (not (forall ((?t_1 Int) (?b Int)) (= (typ (ptr ?t_1 ?b)) ?t_1))) (not (forall ((?t_1 Int) (?b Int)) (= (ref (ptr ?t_1 ?b)) ?b))) (not (= null (ptr void 0))) (not (forall ((?p_1 Int) (?t_1 Int)) (= (= (is ?p_1 ?t_1) true_1) (= (typ ?p_1) ?t_1)))) (not (forall ((?p_1 Int) (?t_1 Int)) (! (=> (= (is ?p_1 ?t_1) true_1) (exists ((?r Int)) (! (= ?p_1 (ptr ?t_1 ?r)) :pattern ((dont_instantiate_int ?r)) ))) :pattern ((is ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (= (emb ?m ?p_1) (ts_emb (select2 ?m ?p_1 ts_tag))) :pattern ((emb ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (= (good_meta ?m) true_1) (= (= (typed ?m ?p_1) true_1) (= (ts_typed (select2 ?m ?p_1 ts_tag)) true_1))) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (typed ?m ?p_1) true_1)))) (> (ref ?p_1) 0)) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?s_1 Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array))) (not (= (typ ?p_1) ?t_1)))) (= (= (inv ?m ?s_1 ?p_1 ?t_1) true_1) true)) :pattern ((inv ?m ?s_1 ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?r Int) (?t_1 Int)) (! (=> (= (good_meta ?m) true_1) (=> (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array)) (= (select2 ?m (ptr ?t_1 ?r) owned_tag) set_empty))) :pattern ((select2 ?m (ptr ?t_1 ?r) owned_tag)) ))) (not (forall ((?m Int) (?s_1 Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (good_state ?s_1) true_1)) (not (= (select2 ?m ?p_1 status_tag) consistent)))) (= (inv ?m ?s_1 ?p_1 ?t_1) true_1)) :pattern ((inv ?m ?s_1 ?p_1 ?t_1)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?r_1 Int) (?p Int)) (! (let ((?v_0 (ptr ?T ?r_1))) (= (= (in_full_extent_of ?p ?v_0) true_1) (= ?p ?v_0))) :pattern ((in_full_extent_of ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?M Int) (?r_1 Int) (?p Int)) (! (let ((?v_1 (ptr ?T ?r_1))) (= (= (in_extent_of ?M ?p ?v_1) true_1) (= ?p ?v_1))) :pattern ((in_extent_of ?M ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?p_1 Int) (?l Int)) (! (= (= (set_in ?p_1 (full_extent ?l)) true_1) (= (in_full_extent_of ?p_1 ?l) true_1)) :pattern ((set_in ?p_1 (full_extent ?l))) ))) (not (forall ((?o_1 Int)) (! (not (= (set_in ?o_1 set_empty) true_1)) :pattern ((set_in ?o_1 set_empty)) ))) (not (forall ((?r Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_singleton ?r)) true_1) (= ?r ?o_1)) :pattern ((set_in ?o_1 (set_singleton ?r))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_union ?a ?b)) true_1) (or (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 (set_union ?a ?b))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_subtraction ?a ?b)) true_1) (not (or (not (= (set_in ?o_1 ?a) true_1)) (not (not (= (set_in ?o_1 ?b) true_1)))))) :pattern ((set_in ?o_1 (set_subtraction ?a ?b))) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_subset ?a ?b) true_1) (forall ((?o_1 Int)) (! (=> (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_subset ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (forall ((?o_1 Int)) (! (= (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((dont_instantiate ?o_1)) )) (= (set_eq ?a ?b) true_1)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= (set_eq ?a ?b) true_1) (= ?a ?b)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_disjoint ?a ?b) true_1) (forall ((?o_1 Int)) (! (or (not (= (set_in ?o_1 ?a) true_1)) (not (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_disjoint ?a ?b)) ))) (not (forall ((?T Int) (?s Int)) (! (= (element_type (array ?T ?s)) ?T) :pattern ((array ?T ?s)) ))) (not (forall ((?T Int) (?s Int)) (! (= (array_length (array ?T ?s)) ?s) :pattern ((array ?T ?s)) ))) (not (forall ((?T Int) (?s Int)) (! (= (ptr_level (array ?T ?s)) 0) :pattern ((array ?T ?s)) ))) (not (forall ((?T Int) (?s Int)) (! (= (kind_of (array ?T ?s)) kind_array) :pattern ((array ?T ?s)) ))) (not (forall ((?p_1 Int) (?i_3 Int) (?t_1 Int)) (! (= (idx ?p_1 ?i_3 ?t_1) (ptr ?t_1 (+ (ref ?p_1) (* ?i_3 (sizeof ?t_1))))) :pattern ((idx ?p_1 ?i_3 ?t_1)) ))) (not (forall ((?p Int) (?i Int) (?j Int) (?T Int)) (! (=> (not (= ?i 0)) (= (idx (idx ?p ?i ?T) ?j ?T) (idx ?p (+ ?i ?j) ?T))) :pattern ((idx (idx ?p ?i ?T) ?j ?T)) ))) (not (forall ((?M Int) (?p Int) (?T Int) (?sz Int)) (! (= (= (is_array ?M ?p ?T ?sz) true_1) (not (or (not (= (is ?p ?T) true_1)) (not (forall ((?i Int)) (! (let ((?v_2 (idx ?p ?i ?T))) (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (not (or (not (= (ts_is_array_elt (select2 ?M ?v_2 ts_tag)) true_1)) (not (= (typed ?M ?v_2) true_1)))))) :pattern ((idx ?p ?i ?T)) )))))) :pattern ((is_array ?M ?p ?T ?sz)) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_3 (ptr (array ?T ?sz) ?r))) (= (= (in_full_extent_of ?p ?v_3) true_1) (or (= ?p ?v_3) (exists ((?i_3 Int)) (! (not (or (not (<= 0 ?i_3)) (not (< ?i_3 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_3 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_3 ?T)) ))))) :pattern ((in_full_extent_of ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_4 (ptr (array ?T ?sz) ?r))) (= (= (in_extent_of ?M ?p ?v_4) true_1) (or (= ?p ?v_4) (exists ((?i_3 Int)) (! (not (or (not (<= 0 ?i_3)) (not (< ?i_3 ?sz)) (not (= (in_extent_of ?M ?p (idx (ptr ?T ?r) ?i_3 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_3 ?T)) ))))) :pattern ((in_extent_of ?M ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?r Int) (?T Int) (?sz Int)) (! (=> (= (typed ?M (ptr (array ?T ?sz) ?r)) true_1) (not (or (not (= (is_array ?M (ptr ?T ?r) ?T ?sz) true_1)) (not (forall ((?i Int)) (! (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (= (emb ?M (idx (ptr ?T ?r) ?i ?T)) (ptr (array ?T ?sz) ?r))) :pattern ((idx (ptr ?T ?r) ?i ?T)) )))))) :pattern ((typed ?M (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (= (= (set_in ?p (array_range (ptr ?T ?r) ?T ?sz)) true_1) (exists ((?i_3 Int)) (! (not (or (not (<= 0 ?i_3)) (not (< ?i_3 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_3 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_3 ?T)) ))) :pattern ((set_in ?p (array_range (ptr ?T ?r) ?T ?sz))) ))))))
(assert (let ((?v_3 (<= 0 i_0)) (?v_4 (not (or (not (forall ((?p_1 Int)) (! (let ((?v_10 (select1 state ?p_1))) (or (= (select2 meta ?p_1 status_tag) committed) (= ?v_10 ?v_10))) :pattern ((select1 state ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (let ((?v_11 (select2 meta ?pm ?t_1))) (or (= (select2 meta ?pm status_tag) committed) (= ?v_11 ?v_11))) :pattern ((select2 meta ?pm ?t_1)) ))))))) (let ((?v_9 (=> ?v_3 (=> true (=> ?v_3 (=> ?v_4 (=> ?v_3 (=> true (=> ?v_3 (=> ?v_3 (=> true (=> (= result_0 sum_0) (=> (= i_2 i_0) (=> (= sum_2 sum_0) true))))))))))))) (?v_8 (<= 0 i_1)) (?v_7 (>= i_1 0)) (?v_5 (idx p i_0 int))) (let ((?v_6 (not (or (not (= (is ?v_5 int) true_1)) (not (= (typed meta ?v_5) true_1))))) (?v_1 (<= 0 0)) (?v_2 (>= 0 0))) (let ((?v_0 (not ?v_1))) (not (=> true (=> (= (good_meta meta) true_1) (=> (= (good_state state) true_1) (=> (= (is p int) true_1) (=> (= (is_array meta p int sz) true_1) (=> true (=> (not (or ?v_0 ?v_0 ?v_0 ?v_0)) (=> ?v_1 (not (or (not ?v_2) (not (=> ?v_2 (=> ?v_1 (=> true (=> ?v_3 (=> (>= i_0 0) (=> ?v_3 (not (or (not (=> true (=> ?v_3 (=> (not true) ?v_9)))) (not (=> true (=> ?v_3 (=> true (=> ?v_4 (=> ?v_3 (not (or (not (=> true (=> ?v_3 (=> (< i_0 sz) (not (or (not ?v_6) (not (=> ?v_6 (=> (= sum_1 (+ sum_0 (select1 state ?v_5))) (=> (= i_1 (+ i_0 1)) (=> (<= 1 i_1) (=> true (=> ?v_8 (not (or (not ?v_7) (not (=> ?v_7 (=> ?v_8 (=> false true))))))))))))))))))) (not (=> true (=> ?v_3 (=> (>= i_0 sz) ?v_9)))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
