(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 (S4 Int) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S3)
(declare-fun f8 (S5 S3) S3)
(declare-fun f9 (S6 S3) S5)
(declare-fun f10 () S6)
(declare-fun f11 () S3)
(declare-fun f12 (S7 Int) Int)
(declare-fun f13 () S7)
(declare-fun f14 (S8 Int) S2)
(declare-fun f15 () S8)
(declare-fun f16 () S5)
(declare-fun f17 () S7)
(declare-fun f18 (S9 S3) S1)
(declare-fun f19 (S10 S3) S9)
(declare-fun f20 () S10)
(declare-fun f21 (S11 S3) S12)
(declare-fun f22 (S13 S11) S11)
(declare-fun f23 (S3) S13)
(declare-fun f24 (S3) S13)
(declare-fun f25 () S6)
(declare-fun f26 () S4)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f3 f4 (f8 (f9 f10 (f5 f6 2)) f11)))) (not (< (f3 f4 (f5 f6 (- (f3 f4 f7) ?v_0))) ?v_0))))
(assert (< (f3 f4 f7) (f3 f4 (f8 (f9 f10 (f5 f6 2)) (f5 f6 (+ (f3 f4 f11) 1))))))
(assert (< (f3 f4 f7) (f3 f4 (f8 (f9 f10 (f5 f6 2)) (f5 f6 (+ (f3 f4 f11) 1))))))
(assert (not (< (f3 f4 f7) (f3 f4 (f8 (f9 f10 (f5 f6 2)) f11)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f4 (f8 (f9 f10 ?v0) ?v1))) (or (< 0 (f3 f4 ?v0)) (= ?v1 (f5 f6 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f4 (f8 (f9 f10 ?v0) ?v1))) (or (= ?v1 (f5 f6 0)) (< 0 (f3 f4 ?v0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 f6 (+ 0 1)))) (= (f8 (f9 f10 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f5 f6 (+ 0 1)))) (= (= (f8 (f9 f10 ?v0) ?v1) ?v_0) (or (= ?v1 (f5 f6 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f9 f10 ?v0))) (=> (< 0 (f3 f4 ?v0)) (=> (< (f3 f4 (f8 ?v_0 ?v1)) (f3 f4 (f8 ?v_0 ?v2))) (< (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f4 ?v0)) (<= ?v_0 (f3 f4 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f12 f13 (f3 (f14 f15 ?v0) ?v1)) (f3 (f14 f15 (f12 f13 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f14 f15 ?v0) (f5 f6 2)))) (= (f12 f13 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f3 (f14 f15 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f8 (f9 f10 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f3 (f14 f15 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f8 (f9 f10 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 2))) (= (f3 (f14 f15 (f12 f13 ?v0)) ?v_0) (f3 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f8 (f9 f10 ?v0) ?v1)) (f3 (f14 f15 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f8 f16 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f16 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f8 (f9 f10 (f5 f6 ?v0)) ?v1) (f5 f6 (f3 (f14 f15 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f5 f6 (f3 (f14 f15 ?v0) ?v1)) (f8 (f9 f10 (f5 f6 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f14 f15 (f3 f4 ?v0)) ?v1) (f3 f4 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f14 f15 (f3 f4 ?v0)) ?v1) (f3 f4 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f8 (f9 f10 ?v0) ?v1)) (f3 (f14 f15 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f4 ?v0))) (= (f12 f13 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 f4 ?v0) (f3 f4 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f8 f16 ?v0) (f8 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 ?v1) (ite (= ?v1 (f5 f6 0)) (f5 f6 1) (f5 f6 (* (f3 f4 ?v0) (f3 f4 (f8 ?v_0 (f5 f6 (- (f3 f4 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f5 f6 (f12 f17 ?v1)))) (= (< 0 (f3 f4 (f8 (f9 f10 ?v0) ?v_0))) (or (= ?v_0 (f5 f6 0)) (< 0 (f3 f4 ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f18 (f19 f20 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) f1) (=> (< 1 (f3 f4 ?v0)) (<= (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S11)) (let ((?v_0 (f8 (f9 f10 (f5 f6 2)) f11))) (=> (< (f3 f4 ?v0) (f3 f4 ?v_0)) (= (f21 (f22 (f23 ?v_0) ?v1) ?v0) (f21 (f22 (f24 f11) ?v1) ?v0))))))
(assert (forall ((?v0 S3)) (= (f18 (f19 f20 (f5 f6 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f18 (f19 f20 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (* (f3 f4 ?v0) (f3 f4 ?v1)))) (= (f3 f4 (f5 f6 ?v_0)) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f8 f16 (f5 f6 (* (f3 f4 ?v0) (f3 f4 ?v1)))) (f8 (f9 f25 (f8 f16 ?v0)) (f8 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f5 f6 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f8 (f9 f25 ?v0) ?v1) (f8 (f9 f25 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f5 f6 0)) (?v_2 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v1))) (= (f5 f6 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f5 f6 (+ ?v_1 (* (f3 f4 (f5 f6 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f4 ?v0))) (= (f5 f6 (* ?v_0 2)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f9 f25 ?v0)) (?v_0 (f9 f25 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f9 f25 ?v0))) (= (f8 ?v_0 (f8 (f9 f25 ?v1) ?v2)) (f8 (f9 f25 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (* (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f4 ?v0))) (= (f5 f6 (* 2 ?v_0)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f3 (f14 f15 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f5 f6 (* (f3 f4 ?v1) (f3 f4 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f9 f25 ?v0))) (= (f8 (f9 f25 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f9 f25 ?v0))) (= (f8 (f9 f25 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f25 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f9 f25 ?v0)) (?v_1 (f8 (f9 f25 ?v2) ?v3))) (= (f8 (f9 f25 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f9 f25 (f8 (f9 f25 ?v0) ?v1))) (?v_0 (f9 f25 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f9 f25 ?v0))) (= (f8 (f9 f25 (f8 ?v_0 ?v1)) (f8 (f9 f25 ?v2) ?v3)) (f8 (f9 f25 (f8 ?v_0 ?v2)) (f8 (f9 f25 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f14 f15 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f4 (f5 f26 ?v0)))) (=> (< 0 ?v_0) (= (f5 f6 (f12 f17 ?v0)) (f5 f6 (+ (f3 f4 (f5 f6 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v0))) (=> (= (f18 (f19 f20 (f5 f6 (* ?v_0 (f3 f4 ?v1)))) (f5 f6 (* ?v_0 (f3 f4 ?v2)))) f1) (=> (< 0 ?v_0) (= (f18 (f19 f20 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f18 (f19 f20 ?v0) ?v1) f1)) (?v_0 (= (f18 (f19 f20 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f19 f20 ?v0)) (?v_0 (f19 f20 ?v1)) (?v_2 (f19 f20 ?v2))) (=> (and (= (f18 ?v_1 ?v1) f1) (not (= (f18 ?v_0 ?v0) f1))) (=> (and (= (f18 ?v_0 ?v2) f1) (not (= (f18 ?v_2 ?v1) f1))) (and (= (f18 ?v_1 ?v2) f1) (not (= (f18 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f18 (f19 f20 ?v0) ?v1) f1)) (?v_0 (= (f18 (f19 f20 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f19 f20 ?v0)) (?v_0 (f19 f20 ?v1))) (=> (and (= (f18 ?v_1 ?v1) f1) (not (= (f18 ?v_0 ?v0) f1))) (=> (= (f18 ?v_0 ?v2) f1) (and (= (f18 ?v_1 ?v2) f1) (not (= (f18 (f19 f20 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f19 f20 ?v0))) (=> (and (= (f18 ?v_0 ?v1) f1) (not (= (f18 (f19 f20 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f18 ?v_0 ?v2) f1) (not (= (f18 (f19 f20 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (let ((?v_1 (= (f18 (f19 f20 ?v0) ?v1) f1)) (?v_0 (= (f18 (f19 f20 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f18 (f19 f20 ?v0) ?v1) f1) (not (= (f18 (f19 f20 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f18 (f19 f20 ?v0) ?v1) f1) (not (= (f18 (f19 f20 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f18 (f19 f20 ?v0) ?v1) f1)) (?v_0 (= (f18 (f19 f20 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f18 (f19 f20 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f18 (f19 f20 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f18 (f19 f20 ?v0) ?v1) f1)) (?v_0 (= (f18 (f19 f20 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f18 (f19 f20 ?v0) ?v1) f1) (not (= (f18 (f19 f20 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_2 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f19 f20 ?v0)) (?v_1 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (=> (= (f18 ?v_0 (f5 f6 (- ?v_2 ?v_1))) f1) (=> (= (f18 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f18 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f19 f20 ?v0)) (?v_1 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (=> (= (f18 ?v_0 (f5 f6 (- ?v_2 ?v_1))) f1) (=> (= (f18 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f18 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S3)) (= (f5 f6 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
