(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S4)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 Int) S4)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S4) Int)
(declare-fun f12 () S8)
(declare-fun f13 () S4)
(declare-fun f14 () S4)
(declare-fun f15 () S2)
(declare-fun f16 () S6)
(declare-fun f17 (S4 S9) S1)
(declare-fun f18 (S9 S4) S1)
(declare-fun f19 (Int S10) S1)
(declare-fun f20 (S10 Int) S1)
(declare-fun f21 () S10)
(declare-fun f22 () S9)
(declare-fun f23 (S11 Int) S5)
(declare-fun f24 () S11)
(declare-fun f25 (S12 Int) S8)
(declare-fun f26 () S12)
(declare-fun f27 () S6)
(declare-fun f28 () S2)
(declare-fun f29 () S5)
(declare-fun f30 (S13 S8) S8)
(declare-fun f31 () S13)
(declare-fun f32 () S3)
(declare-fun f33 () S3)
(declare-fun f34 () S4)
(declare-fun f35 (S14 S3) S12)
(declare-fun f36 (S15 Int) S14)
(declare-fun f37 () S15)
(declare-fun f38 (S16 S6) S6)
(declare-fun f39 (S17 S4) S16)
(declare-fun f40 () S17)
(declare-fun f41 (S4) S9)
(declare-fun f42 () S6)
(declare-fun f43 () S6)
(declare-fun f44 () S4)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 ?v0) ?v1) (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))))))
(assert (not (exists ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (and (< ?v_0 (f11 f12 f13)) (= f14 (f9 f10 (* 2 ?v_0))))))))
(assert (< (f11 f12 f14) (* 2 (f11 f12 f13))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< ?v_0 (f11 f12 f13)) (not (= f14 (f9 f10 (+ (* 2 ?v_0) 1))))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f9 f10 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f9 f10 (* (f11 f12 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0))) (f11 f12 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* 0 (f11 f12 ?v0))) (f9 f10 0))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 1))) (= (= ?v_0 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* (f11 f12 ?v0) 0)) (f9 f10 0))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f9 f10 (* ?v_1 ?v_0)) (f9 f10 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f9 f10 (+ ?v_1 (* (f11 f12 (f9 f10 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_2 (f11 f12 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= ?v0 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (or (= ?v1 (f9 f10 1)) (= ?v0 (f9 f10 0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f11 f12 (f9 f10 (- ?v0))) (f11 f12 (f9 f10 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f11 f12 (f9 f10 ?v0)) (f11 f12 (f9 f10 ?v1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f9 f10 (* (f11 f12 ?v0) ?v_0)) (f9 f10 (* (f11 f12 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f9 f10 (* (f11 f12 (f9 f10 (- ?v_0 ?v_2))) ?v_1)) (f9 f10 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f9 f10 (* (+ ?v_0 ?v_2) ?v_1)) (f9 f10 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f9 f10 (* (* ?v_0 ?v_1) ?v_2)) (f9 f10 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 0))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 1))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* 2 ?v_0)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f9 f10 (* (+ ?v_1 1) ?v_0)) (f9 f10 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_0 (f11 f12 (f9 f10 (- ?v_1 ?v_2))))) (f9 f10 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f9 f10 (* ?v_0 (+ ?v_1 ?v_2))) (f9 f10 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* ?v_0 2)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_0 (+ ?v_1 1))) (f9 f10 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (f9 f10 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f9 f10 (- (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f9 f10 (+ (* ?v_0 ?v_2) ?v_3)) (f9 f10 (+ (* ?v_1 ?v_2) (f11 f12 ?v4)))) (= (f9 f10 (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= ?v_3 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< ?v_3 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (f9 f10 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f9 f10 (- ?v_3 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f9 f10 (+ (* ?v_0 ?v_2) (f11 f12 ?v3))) (f9 f10 (+ (* ?v_1 ?v_2) ?v_3))) (= ?v3 (f9 f10 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f9 f10 (* (f11 f12 (f9 f10 ?v0)) (f11 f12 (f9 f10 ?v1)))) (f9 f10 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (or (= ?v0 (f9 f10 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (= (f9 f10 (+ (* ?v_1 ?v_0) (+ (* ?v_2 ?v_0) ?v_3))) (f9 f10 (+ (* (+ ?v_1 ?v_2) ?v_0) ?v_3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f9 f10 0))) (= (f9 f10 (+ (+ (f11 f12 (f9 f10 (- ?v_0 2))) 1) 1)) (f9 f10 ?v_0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (* 4 (f11 f12 ?v0)))) (=> (not (= ?v0 (f9 f10 0))) (= (f9 f10 (+ (+ (f11 f12 (f9 f10 (- ?v_0 2))) 1) 1)) (f9 f10 ?v_0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f9 f10 0))) (= (f9 f10 (+ (f11 f12 (f9 f10 (- ?v_0 1))) 1)) (f9 f10 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f15 (* ?v0 ?v1)) (* (f3 f15 ?v0) (f3 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f16 ?v0) ?v1) (f6 (f7 f16 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 (f7 f16 (f6 ?v_0 ?v1)) (f6 (f7 f16 ?v2) ?v3)) (f6 (f7 f16 (f6 ?v_0 ?v2)) (f6 (f7 f16 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f7 f16 (f6 (f7 f16 ?v0) ?v1))) (?v_0 (f7 f16 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f16 ?v0)) (?v_1 (f6 (f7 f16 ?v2) ?v3))) (= (f6 (f7 f16 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f16 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 (f7 f16 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f16 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 (f7 f16 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f16 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f15 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 ?v_0 (f6 (f7 f16 ?v1) ?v2)) (f6 (f7 f16 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S9)) (= (= (f17 ?v0 ?v1) f1) (= (f18 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f19 ?v0 ?v1) f1) (= (f20 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f7 f16 ?v0)) (?v_0 (f7 f16 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 (f7 f16 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f16 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0 f21) f1) (=> (= (f19 ?v1 f21) f1) (= (f19 (* ?v0 ?v1) f21) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f17 ?v0 f22) f1) (=> (= (f17 ?v1 f22) f1) (= (f17 (f6 (f7 f16 ?v0) ?v1) f22) f1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (f6 (f23 f24 ?v0) ?v1) (f9 f10 (+ (f11 f12 (f9 f10 ?v0)) (f11 f12 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f6 (f7 f16 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f6 (f7 f16 ?v0) (f6 (f7 f16 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f27 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f25 f26 ?v0) (f9 f10 2)))) (= (f3 f15 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (= (f11 (f25 f26 (f3 f15 ?v0)) ?v_0) (f11 (f25 f26 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f27 ?v0) (f9 f10 2)) (f6 (f7 f16 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f27 ?v0) (f9 f10 3)) (f6 (f7 f16 (f6 (f7 f16 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 (f7 f16 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (= (f11 (f25 f26 (* ?v0 ?v1)) ?v2) (* (f11 (f25 f26 ?v0) ?v2) (f11 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f27 (f6 (f7 f16 ?v0) ?v1)) ?v2) (f6 (f7 f16 (f6 (f7 f27 ?v0) ?v2)) (f6 (f7 f27 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (* (f11 ?v_0 ?v1) ?v0) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 (f7 f16 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (* ?v0 (f11 ?v_0 ?v1)) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 (f7 f16 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* ?v0 (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f16 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f11 (f25 f26 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) ?v0) (f6 (f7 f27 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f11 (f25 f26 (f11 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f6 (f7 f27 (f6 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 (f25 f26 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 (f7 f27 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 ?v1) (ite (= ?v1 (f9 f10 0)) (f9 f10 1) (f9 f10 (* (f11 f12 ?v0) (f11 f12 (f6 ?v_0 (f9 f10 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 (f25 f26 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (* ?v0 (f11 (f25 f26 (f11 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f6 (f7 f16 ?v0) (f6 (f7 f27 (f6 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f11 (f25 f26 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f6 (f7 f27 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* ?v0 (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f16 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* (f11 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f16 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f6 (f7 f16 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f11 (f25 f26 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f6 (f7 f27 ?v0) ?v1))) (= (f6 (f7 f16 ?v_0) ?v0) (f6 (f7 f16 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (= (f11 (f25 f26 (* ?v0 ?v1)) ?v2) (* (f11 (f25 f26 ?v0) ?v2) (f11 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f27 (f6 (f7 f16 ?v0) ?v1)) ?v2) (f6 (f7 f16 (f6 (f7 f27 ?v0) ?v2)) (f6 (f7 f27 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S4)) (<= 0 (f11 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 f12 (f6 (f7 f27 ?v0) ?v1)) (f11 (f25 f26 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (< 0 (f11 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 (f25 f26 (f11 f12 ?v0)) ?v1) (f11 f12 (f6 (f7 f27 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (= (f9 f10 (f11 (f25 f26 ?v0) ?v1)) (f6 (f7 f27 (f9 f10 ?v0)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f6 (f7 f27 ?v0) ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f27 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f6 ?v_0 ?v1)) (f11 f12 (f6 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f6 (f7 f27 ?v0) ?v1) ?v_0) (or (= ?v1 (f9 f10 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (f6 (f7 f27 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (< 0 (f11 f12 (f6 (f7 f27 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 (f25 f26 (f11 f12 ?v0)) ?v1) (f11 f12 (f6 (f7 f27 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (<= 0 (f11 (f25 f26 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (= (f6 (f7 f27 (f9 f10 ?v0)) ?v1) (f9 f10 (f11 (f25 f26 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (f3 f15 (f11 (f25 f26 ?v0) ?v1)) (f11 (f25 f26 (f3 f15 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f27 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f25 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (* (f11 ?v_2 (f9 f10 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f7 f27 ?v2))) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f16 (f6 ?v_2 (f9 f10 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f25 f26 ?v1))) (=> (< 0 ?v_0) (= (* (f11 ?v_1 (f9 f10 (- ?v_0 1))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f7 f27 ?v1))) (=> (< 0 ?v_0) (= (f6 (f7 f16 (f6 ?v_1 (f9 f10 (- ?v_0 1)))) ?v1) (f6 ?v_1 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (< 0 (f11 f12 (f6 (f7 f27 ?v0) ?v1))) (or (= ?v1 (f9 f10 0)) (< 0 (f11 f12 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (f3 f28 (f11 (f25 f26 ?v0) ?v1)) (f11 (f25 f26 (f3 f28 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 f12 (f6 (f7 f27 ?v0) ?v1)) (f11 (f25 f26 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 f29 (f6 (f7 f27 ?v0) ?v1)) (f6 (f7 f27 (f6 f29 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f28 (* ?v0 ?v1)) (* (f3 f28 ?v0) (f3 f28 ?v1)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f3 f15 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f3 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 f28 ?v0) (f3 f28 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f11 f12 ?v0) (f11 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 f29 ?v0) (f6 f29 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f9 f10 ?v0)) (f3 f28 ?v0)))))
(assert (forall ((?v0 S4)) (= (f19 (f11 f12 ?v0) f21) f1)))
(assert (forall ((?v0 S4)) (= (f17 (f6 f29 ?v0) f22) f1)))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= (f11 f12 (f9 f10 ?v_0)) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 f29 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (f6 (f7 f16 (f6 f29 ?v0)) (f6 f29 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f19 ?v0 f21) f1) (=> (forall ((?v1 S4)) (=> (= ?v0 (f11 f12 ?v1)) false)) false))))
(assert (forall ((?v0 S4)) (=> (= (f17 ?v0 f22) f1) (=> (forall ((?v1 S4)) (=> (= ?v0 (f6 f29 ?v1)) false)) false))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (= (f19 ?v0 f21) f1) (=> (forall ((?v2 S4)) (= (f20 ?v1 (f11 f12 ?v2)) f1)) (= (f20 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S4) (?v1 S9)) (=> (= (f17 ?v0 f22) f1) (=> (forall ((?v2 S4)) (= (f18 ?v1 (f6 f29 ?v2)) f1)) (= (f18 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S8) (?v1 S4)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))) (= (f11 (f30 f31 ?v0) ?v1) (* (f11 f12 ?v_0) (f11 ?v0 ?v_0))))))
(assert (forall ((?v0 Int)) (= (f3 f28 ?v0) (ite (< ?v0 0) (- (f11 f12 (f9 f10 (- ?v0)))) (f11 f12 (f9 f10 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 (+ (+ 0 1) 1)))) (= (= (f11 (f25 f26 ?v0) ?v_0) (f11 (f25 f26 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (- ?v1)))))))
(assert (forall ((?v0 Int)) (= (f3 f28 (- ?v0)) (- (f3 f28 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 (f4 f32 ?v0) ?v1)) (f3 (f4 f33 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 (f4 f33 ?v0) ?v1)) (f3 (f4 f32 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int)) (= (f3 f15 (- ?v0)) (f3 f15 ?v0))))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (= (f11 (f25 f26 (- ?v0)) ?v_0) (f11 (f25 f26 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v0) (* ?v1 ?v1)) (or (= ?v0 ?v1) (= ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (- ?v0) (- ?v1)) (* ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (- ?v0) ?v1) (* ?v0 (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (* ?v0 ?v1)) (* (- ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (* ?v0 ?v1)) (* ?v0 (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (f3 f15 (f11 (f25 f26 (- ?v0)) ?v1)) (f3 f15 (f11 (f25 f26 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f9 f10 (* 2 (f11 f12 ?v1))))) (= (f11 (f25 f26 (- ?v0)) ?v_0) (f11 (f25 f26 ?v0) ?v_0)))))
(assert (forall ((?v0 S4)) (= (f11 (f25 f26 (- 1)) (f9 f10 (* 2 (f11 f12 ?v0)))) 1)))
(assert (forall ((?v0 S4)) (= (f11 (f25 f26 (- 1)) (f9 f10 (+ (* 2 (f11 f12 ?v0)) 1))) (- 1))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (f11 (f25 f26 (- ?v0)) ?v1) (* (f11 (f25 f26 (- 1)) ?v1) (f11 (f25 f26 ?v0) ?v1)))))
(assert (= (f3 f28 1) 1))
(assert (= (f11 f12 (f9 f10 1)) 1))
(assert (= (f6 f29 (f9 f10 1)) f34))
(assert (= (f19 1 f21) f1))
(assert (= (f17 f34 f22) f1))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S4)) (= (= f34 ?v0) (= ?v0 f34))))
(assert (= (f3 f15 1) 1))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 0)) 1)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f27 ?v0) (f9 f10 0)) f34)))
(assert (= (f11 (f25 f26 1) (f9 f10 2)) 1))
(assert (= (f6 (f7 f27 f34) (f9 f10 2)) f34))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 f34) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 f34) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) f34) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) f34) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) f34) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 f34) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f11 (f25 f26 1) ?v0) 1)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f27 f34) ?v0) f34)))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 0)) 1)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f27 ?v0) (f9 f10 0)) f34)))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 ?v1) (ite (= ?v1 (f9 f10 0)) 1 (* ?v0 (f11 ?v_0 (f9 f10 (- (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f27 ?v0))) (= (f6 ?v_0 ?v1) (ite (= ?v1 (f9 f10 0)) f34 (f6 (f7 f16 ?v0) (f6 ?v_0 (f9 f10 (- (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 Int)) (= (= (* ?v0 ?v0) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int)) (= (- ?v0) (* (- 1) ?v0))))
(assert (forall ((?v0 Int)) (= (= (f11 (f25 f26 ?v0) (f9 f10 2)) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (= f26 (f35 (f36 f37 1) f5)))
(assert (= f27 (f38 (f39 f40 f34) f16)))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f11 (f25 f26 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (* ?v0 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f6 (f7 f27 ?v0) ?v1))) (=> (= (f18 (f41 f34) ?v0) f1) (= (f18 (f41 ?v_0) (f6 (f7 f16 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (< 1 ?v0) (< 1 (* ?v0 (f11 (f25 f26 ?v0) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f41 f34))) (=> (= (f18 ?v_0 ?v0) f1) (= (f18 ?v_0 (f6 (f7 f16 ?v0) (f6 (f7 f27 ?v0) ?v1))) f1)))))
(assert (forall ((?v0 S4) (?v1 S6) (?v2 S4)) (= (f6 (f7 (f38 (f39 f40 ?v0) ?v1) ?v2) (f9 f10 0)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (= (f11 (f25 (f35 (f36 f37 ?v0) ?v1) ?v2) (f9 f10 0)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S6) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 (f38 (f39 f40 ?v0) ?v1) ?v2))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v3) 1))) (f6 (f7 ?v1 ?v2) (f6 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S4)) (let ((?v_0 (f25 (f35 (f36 f37 ?v0) ?v1) ?v2))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v3) 1))) (f3 (f4 ?v1 ?v2) (f11 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 f15 ?v0)) (?v_1 (f3 f15 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f3 (f4 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f41 ?v0))) (=> (= (f18 ?v_0 ?v1) f1) (= (f18 ?v_0 (f6 (f7 f42 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f3 (f4 f33 ?v2) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f41 ?v0))) (=> (= (f18 ?v_0 ?v1) f1) (= (f18 ?v_0 (f6 (f7 f42 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f3 (f4 f32 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f18 (f41 ?v0) ?v1) f1) (= (f18 (f41 (f6 (f7 f43 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f3 (f4 f32 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f18 (f41 ?v0) ?v1) f1) (= (f18 (f41 (f6 (f7 f43 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (< (f11 f12 ?v0) (f11 f12 ?v1)))) (=> ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f18 (f41 (f6 f29 ?v0)) (f6 f29 ?v1)) f1) (< (f11 f12 ?v0) (f11 f12 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (< (f11 f12 ?v0) (f11 f12 ?v1)))) (=> ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (< (f11 f12 ?v0) (f11 f12 ?v1)) (= (f18 (f41 (f6 f29 ?v0)) (f6 f29 ?v1)) f1))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (< (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f18 (f41 (f6 f29 ?v0)) (f6 f29 ?v1)) f1) (< (f11 f12 ?v0) (f11 f12 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f28 ?v0) (f3 f28 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f15 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f41 f34))) (=> (= (f18 ?v_0 ?v0) f1) (=> (= (f18 ?v_0 ?v1) f1) (= (f18 ?v_0 (f6 (f7 f16 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 Int)) (let ((?v_0 (f25 f26 ?v2))) (=> (< (f11 f12 ?v0) (f11 f12 ?v1)) (=> (< 1 ?v2) (< (f11 ?v_0 ?v0) (f11 ?v_0 ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f27 ?v2))) (=> (< (f11 f12 ?v0) (f11 f12 ?v1)) (=> (= (f18 (f41 f34) ?v2) f1) (= (f18 (f41 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (=> (< 1 ?v0) (=> (< (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f27 ?v0))) (=> (= (f18 (f41 f34) ?v0) f1) (=> (= (f18 (f41 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (< 1 ?v0) (=> (< 0 (f11 f12 ?v1)) (< 1 (f11 (f25 f26 ?v0) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f41 f34))) (=> (= (f18 ?v_0 ?v0) f1) (=> (< 0 (f11 f12 ?v1)) (= (f18 ?v_0 (f6 (f7 f27 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (=> (< 1 ?v0) (= (< (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f27 ?v0))) (=> (= (f18 (f41 f34) ?v0) f1) (= (= (f18 (f41 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (=> (< 1 ?v0) (= (= (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f27 ?v0))) (=> (= (f18 (f41 f34) ?v0) f1) (= (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (< 1 ?v0) (< 1 (f11 (f25 f26 ?v0) (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f41 f34))) (=> (= (f18 ?v_0 ?v0) f1) (= (f18 ?v_0 (f6 (f7 f27 ?v0) (f9 f10 (+ (f11 f12 ?v1) 1)))) f1)))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S4)) (=> (forall ((?v3 S4)) (< (f11 ?v0 ?v3) (f11 ?v0 (f9 f10 (+ (f11 f12 ?v3) 1))))) (= (< (f11 ?v0 ?v1) (f11 ?v0 ?v2)) (< (f11 f12 ?v1) (f11 f12 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S4) (?v2 S4)) (=> (forall ((?v3 S4)) (= (f18 (f41 (f6 ?v0 ?v3)) (f6 ?v0 (f9 f10 (+ (f11 f12 ?v3) 1)))) f1)) (= (= (f18 (f41 (f6 ?v0 ?v1)) (f6 ?v0 ?v2)) f1) (< (f11 f12 ?v1) (f11 f12 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S4)) (=> (forall ((?v3 S4)) (< (f11 ?v0 ?v3) (f11 ?v0 (f9 f10 (+ (f11 f12 ?v3) 1))))) (=> (< (f11 f12 ?v1) (f11 f12 ?v2)) (< (f11 ?v0 ?v1) (f11 ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S4) (?v2 S4)) (=> (forall ((?v3 S4)) (= (f18 (f41 (f6 ?v0 ?v3)) (f6 ?v0 (f9 f10 (+ (f11 f12 ?v3) 1)))) f1)) (=> (< (f11 f12 ?v1) (f11 f12 ?v2)) (= (f18 (f41 (f6 ?v0 ?v1)) (f6 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f11 (f25 f26 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f6 (f7 f27 ?v0) ?v1))) (=> (= (f18 (f41 f44) ?v0) f1) (=> (= (f18 (f41 ?v0) f34) f1) (= (f18 (f41 (f6 (f7 f16 ?v0) ?v_0)) ?v_0) f1))))))
(assert (not (= 0 1)))
(assert (not (= f44 f34)))
(assert (not (= 1 0)))
(assert (not (= f34 f44)))
(assert (= (f19 0 f21) f1))
(assert (= (f17 f44 f22) f1))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (not (= ?v0 0)) (not (= (f11 (f25 f26 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (= (f11 (f25 f26 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 (f7 f27 ?v0) ?v1) f44) (and (= ?v0 f44) (not (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S4)) (= (f11 (f25 f26 0) (f9 f10 (+ (f11 f12 ?v0) 1))) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f27 f44) (f9 f10 (+ (f11 f12 ?v0) 1))) f44)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 f44) ?v0) f44)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 f44) ?v0) f44)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) f44) f44)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) f44) f44)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f44)) (=> (not (= ?v1 f44)) (not (= (f6 (f7 f16 ?v0) ?v1) f44))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 (f7 f16 ?v0) ?v1) f44) (or (= ?v0 f44) (= ?v1 f44)))))
(assert (forall ((?v0 Int)) (= (= (f11 (f25 f26 ?v0) (f9 f10 2)) 0) (= ?v0 0))))
(assert (= (f11 (f25 f26 0) (f9 f10 2)) 0))
(assert (= (f6 (f7 f27 f44) (f9 f10 2)) f44))
(assert (= (f3 f15 0) 0))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= f44 ?v0) (= ?v0 f44))))
(assert (forall ((?v0 Int)) (= (= (f3 f15 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f3 f28 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= 0 (f3 f28 ?v0)) (= ?v0 0))))
(assert (= (f11 f12 (f9 f10 0)) 0))
(assert (= (f6 f29 (f9 f10 0)) f44))
(assert (= (f3 f28 0) 0))
(assert (= 0 0))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (f9 f10 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
