(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) Int)
(declare-fun f8 () S5)
(declare-fun f9 () S3)
(declare-fun f10 (S6 Int) Int)
(declare-fun f11 (S7 Int) S6)
(declare-fun f12 () S7)
(declare-fun f13 (S8 S2) S3)
(declare-fun f14 () S8)
(declare-fun f15 () S8)
(declare-fun f16 () S8)
(declare-fun f17 () S3)
(declare-fun f18 (S3 S9) S1)
(declare-fun f19 () S9)
(declare-fun f20 (S2 S9) S1)
(declare-fun f21 (Int S10) S1)
(declare-fun f22 (S10 Int) S1)
(declare-fun f23 (S9 S2) S1)
(declare-fun f24 () S8)
(declare-fun f25 () S6)
(declare-fun f26 (S3) S1)
(declare-fun f27 () S10)
(declare-fun f28 () S9)
(declare-fun f29 (S11 Int) S3)
(declare-fun f30 () S11)
(declare-fun f31 () S8)
(declare-fun f32 (S12 Int) S5)
(declare-fun f33 () S12)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 f6 (* 2 (f7 f8 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 f9 ?v0) (f5 f6 (+ (f7 f8 ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 ?v0) ?v1) (* ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f13 f14 ?v0) ?v1) (f5 f6 (* (f7 f8 ?v0) (f7 f8 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f13 f15 ?v0) ?v1) (f5 f6 (- (f7 f8 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f13 f16 ?v0) ?v1) (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 f17 ?v0) ?v0)))
(assert (not (= (f18 f4 f19) f1)))
(assert (forall ((?v0 S2) (?v1 S9)) (= (f18 (f13 f16 ?v0) ?v1) f1)))
(assert (forall ((?v0 S9)) (= (f18 f9 ?v0) f1)))
(assert (forall ((?v0 S9)) (= (f18 f17 ?v0) f1)))
(assert (forall ((?v0 S9) (?v1 S2)) (=> (forall ((?v2 S2)) (=> (= (f20 ?v2 ?v0) f1) (<= (f7 f8 ?v1) (f7 f8 ?v2)))) (= (f18 (f13 f15 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S9)) (= (= (f18 ?v0 ?v1) f1) (forall ((?v2 S2)) (=> (= (f20 ?v2 ?v1) f1) (forall ((?v3 S2)) (=> (= (f20 ?v3 ?v1) f1) (=> (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)) (= ?v2 ?v3)))))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f18 ?v0 ?v1) f1) (=> (not (= ?v2 ?v3)) (=> (= (f20 ?v2 ?v1) f1) (=> (= (f20 ?v3 ?v1) f1) (not (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)))))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f18 ?v0 ?v1) f1) (=> (= (f20 ?v2 ?v1) f1) (=> (= (f20 ?v3 ?v1) f1) (= (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)) (= ?v2 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f18 ?v0 ?v1) f1) (=> (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)) (=> (= (f20 ?v2 ?v1) f1) (=> (= (f20 ?v3 ?v1) f1) (= ?v2 ?v3)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f5 f6 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f5 f6 (* (f7 f8 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0))) (f7 f8 (f5 f6 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f7 f8 ?v0) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f7 f8 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f5 f6 (* (f7 f8 ?v0) (f7 f8 ?v1)))) (or (= ?v1 (f5 f6 1)) (= ?v0 (f5 f6 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_3 (f7 f8 ?v3)) (?v_1 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f5 f6 (* ?v0 ?v1)) (f5 f6 (* (f7 f8 (f5 f6 (- ?v0))) (f7 f8 (f5 f6 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f5 f6 (* ?v0 ?v1)) (f5 f6 (* (f7 f8 (f5 f6 ?v0)) (f7 f8 (f5 f6 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f7 f8 ?v0) 1)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f7 f8 ?v0) 1)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f7 f8 ?v0) 1))) (= (= (f5 f6 (* ?v_0 (f7 f8 ?v1))) (f5 f6 (* ?v_0 (f7 f8 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v1))) (= (= (f5 f6 (* (f7 f8 ?v0) ?v_0)) (f5 f6 (* (f7 f8 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f5 f6 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f5 f6 (* ?v_0 (f7 f8 ?v1))) (f5 f6 (* ?v_0 (f7 f8 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f5 f6 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v2)) (?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v2)) (?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 (+ 0 1)))) (= (= (f5 f6 (* (f7 f8 ?v0) (f7 f8 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (= (f5 f6 (* (f7 f8 (f5 f6 (- ?v_0 ?v_2))) ?v_1)) (f5 f6 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v2))) (= (f5 f6 (* (+ ?v_0 ?v_2) ?v_1)) (f5 f6 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1)) (?v_2 (f7 f8 ?v2))) (= (f5 f6 (* (* ?v_0 ?v_1) ?v_2)) (f5 f6 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 0))) (= (= (f5 f6 (* (f7 f8 ?v0) (f7 f8 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 1))) (= (= (f5 f6 (* (f7 f8 ?v0) (f7 f8 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f7 f8 ?v0) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f5 f6 (* (+ ?v_1 1) ?v_0)) (f5 f6 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (f5 f6 (* ?v_0 (f7 f8 (f5 f6 (- ?v_1 ?v_2))))) (f5 f6 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1)) (?v_2 (f7 f8 ?v2))) (= (f5 f6 (* ?v_0 (+ ?v_1 ?v_2))) (f5 f6 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (= (f5 f6 (* ?v_0 (+ ?v_1 1))) (f5 f6 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f5 f6 (* ?v_1 ?v_0)) (f5 f6 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* (f7 f8 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 f6 (* (f7 f8 ?v0) 0)) (f5 f6 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 1))) (= (= ?v_0 (f5 f6 (* (f7 f8 ?v0) (f7 f8 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* 1 (f7 f8 ?v0))) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 f6 (* 0 (f7 f8 ?v0))) (f5 f6 0))))
(assert (forall ((?v0 S9) (?v1 S3) (?v2 S3)) (=> (forall ((?v3 S2)) (=> (= (f20 ?v3 ?v0) f1) (= (f3 ?v1 (f3 ?v2 ?v3)) ?v3))) (= (f18 ?v2 ?v0) f1))))
(assert (forall ((?v0 S9) (?v1 S3) (?v2 S3)) (=> (forall ((?v3 S2)) (=> (= (f20 ?v3 ?v0) f1) (= (f3 ?v1 ?v3) (f3 ?v2 ?v3)))) (= (= (f18 ?v1 ?v0) f1) (= (f18 ?v2 ?v0) f1)))))
(assert (forall ((?v0 S9) (?v1 S3)) (=> (forall ((?v2 S2) (?v3 S2)) (=> (= (f20 ?v2 ?v0) f1) (=> (= (f20 ?v3 ?v0) f1) (=> (= (f3 ?v1 ?v2) (f3 ?v1 ?v3)) (= ?v2 ?v3))))) (= (f18 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= (+ (* (f7 f8 (f5 f6 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< (+ (* (f7 f8 (f5 f6 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_1 ?v_0) (= (f5 f6 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f5 f6 (- (+ (* (f7 f8 (f5 f6 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f5 f6 (+ (* ?v_0 ?v_2) ?v_3)) (f5 f6 (+ (* ?v_1 ?v_2) (f7 f8 ?v4)))) (= (f5 f6 (+ (* (f7 f8 (f5 f6 (- ?v_0 ?v_1))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= ?v_3 (+ (* (f7 f8 (f5 f6 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< ?v_3 (+ (* (f7 f8 (f5 f6 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_0 ?v_1) (= (f5 f6 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f5 f6 (- ?v_3 (+ (* (f7 f8 (f5 f6 (- ?v_1 ?v_0))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_3 (f7 f8 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f5 f6 (+ (* ?v_0 ?v_2) (f7 f8 ?v3))) (f5 f6 (+ (* ?v_1 ?v_2) ?v_3))) (= ?v3 (f5 f6 (+ (* (f7 f8 (f5 f6 (- ?v_1 ?v_0))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f5 f6 (* ?v_0 (f7 f8 ?v1))) (f5 f6 (* ?v_0 (f7 f8 ?v2)))) (or (= ?v0 (f5 f6 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1)) (?v_2 (f7 f8 ?v2)) (?v_3 (f7 f8 ?v3))) (= (f5 f6 (+ (* ?v_1 ?v_0) (+ (* ?v_2 ?v_0) ?v_3))) (f5 f6 (+ (* (+ ?v_1 ?v_2) ?v_0) ?v_3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (=> (< 0 ?v_0) (= (= (f5 f6 (* ?v_0 (f7 f8 ?v1))) (f5 f6 (* ?v_0 (f7 f8 ?v2)))) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (=> (< 0 ?v_0) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (=> (< 0 ?v_0) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 0)) (?v_2 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (= (f5 f6 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f5 f6 (+ ?v_1 (* (f7 f8 (f5 f6 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (f5 f6 (* ?v_0 2)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f7 f8 ?v0) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (f5 f6 (* 2 ?v_0)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f7 f8 ?v0)))) (=> (not (= ?v0 (f5 f6 0))) (= (f5 f6 (+ (+ (f7 f8 (f5 f6 (- ?v_0 2))) 1) 1)) (f5 f6 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 4 (f7 f8 ?v0)))) (=> (not (= ?v0 (f5 f6 0))) (= (f5 f6 (+ (+ (f7 f8 (f5 f6 (- ?v_0 2))) 1) 1)) (f5 f6 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f7 f8 ?v0)))) (=> (not (= ?v0 (f5 f6 0))) (= (f5 f6 (+ (f7 f8 (f5 f6 (- ?v_0 1))) 1)) (f5 f6 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f5 f6 (* (f7 f8 (f5 f6 ?v0)) (f7 f8 (f5 f6 ?v1)))) (f5 f6 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f21 ?v0 ?v1) f1) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S9)) (= (= (f20 ?v0 ?v1) f1) (= (f23 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f13 f24 ?v0))) (= (f3 (f13 f24 (f3 ?v_0 ?v1)) (f3 (f13 f24 ?v2) ?v3)) (f3 (f13 f24 (f3 ?v_0 ?v2)) (f3 (f13 f24 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f13 f24 (f3 (f13 f24 ?v0) ?v1))) (?v_0 (f13 f24 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f13 f24 ?v0)) (?v_1 (f3 (f13 f24 ?v2) ?v3))) (= (f3 (f13 f24 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f13 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f24 ?v0))) (= (f3 (f13 f24 (f3 ?v_0 ?v1)) ?v2) (f3 (f13 f24 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f24 ?v0))) (= (f3 (f13 f24 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f13 f24 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f24 ?v0))) (= (f3 (f13 f24 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f13 f24 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f13 f24 ?v0) ?v1) (f3 (f13 f24 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f13 f24 ?v0)) (?v_0 (f13 f24 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f24 ?v0))) (= (f3 ?v_0 (f3 (f13 f24 ?v1) ?v2)) (f3 (f13 f24 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 f25 (* ?v0 ?v1)) (* (f10 f25 ?v0) (f10 f25 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f25 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S9)) (=> (= (f26 ?v0) f1) (= (f18 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 f27) f1) (=> (= (f21 ?v1 f27) f1) (= (f21 (* ?v0 ?v1) f27) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f20 ?v0 f28) f1) (=> (= (f20 ?v1 f28) f1) (= (f20 (f3 (f13 f24 ?v0) ?v1) f28) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f3 (f29 f30 ?v0) ?v1) (f5 f6 (+ (f7 f8 (f5 f6 ?v0)) (f7 f8 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (* 2 (f7 f8 ?v1)) 1))) (f3 (f13 f24 ?v0) (f3 (f13 f31 (f3 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (* 2 (f7 f8 ?v1)) 1))) (* ?v0 (f7 (f32 f33 (f7 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 S2)) (= (f3 (f13 f31 ?v0) (f5 f6 2)) (f3 (f13 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f7 (f32 f33 ?v0) (f5 f6 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f13 f31 ?v0) (f5 f6 3)) (f3 (f13 f24 (f3 (f13 f24 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f7 (f32 f33 ?v0) (f5 f6 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f13 f24 ?v0) ?v0) (f3 (f13 f31 ?v0) (f5 f6 2)))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f7 (f32 f33 ?v0) (f5 f6 2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (f3 (f13 f24 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (* ?v0 (f7 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 (f13 f24 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (* ?v0 (f7 ?v_0 ?v1)) (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 (f13 f24 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (* (f7 ?v_0 ?v1) ?v0) (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f13 f31 (f3 (f13 f24 ?v0) ?v1)) ?v2) (f3 (f13 f24 (f3 (f13 f31 ?v0) ?v2)) (f3 (f13 f31 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f7 (f32 f33 (* ?v0 ?v1)) ?v2) (* (f7 (f32 f33 ?v0) ?v2) (f7 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 (f13 f24 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (* (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v2))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 (f32 f33 ?v0) (f5 f6 2)))) (= (f10 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 2))) (= (f7 (f32 f33 (f10 f25 ?v0)) ?v_0) (f7 (f32 f33 ?v0) ?v_0)))))
(assert (forall ((?v0 S2)) (= (f3 (f13 f31 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f7 (f32 f33 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 (f13 f31 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f5 f6 (* (f7 f8 ?v1) (f7 f8 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f7 (f32 f33 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f5 f6 (* (f7 f8 ?v1) (f7 f8 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 ?v_0 (f5 f6 (* 2 (f7 f8 ?v1)))) (f3 (f13 f31 (f3 ?v_0 ?v1)) (f5 f6 2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f7 ?v_0 (f5 f6 (* 2 (f7 f8 ?v1)))) (f7 (f32 f33 (f7 ?v_0 ?v1)) (f5 f6 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f5 f6 0)) (f5 f6 1) (f5 f6 (* (f7 f8 ?v0) (f7 f8 (f3 ?v_0 (f5 f6 (- (f7 f8 ?v1) 1)))))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f7 (f32 f33 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f5 f6 (* (f7 f8 ?v1) (f7 f8 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f5 f6 (+ (* 2 (f7 f8 ?v1)) 1))) (f3 (f13 f24 ?v0) (f3 (f13 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f32 f33 ?v0))) (let ((?v_1 (f7 ?v_0 ?v1))) (= (f7 ?v_0 (f5 f6 (+ (* 2 (f7 f8 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f5 f6 (* 2 (f7 f8 ?v1)))) (f3 (f13 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f32 f33 ?v0))) (let ((?v_1 (f7 ?v_0 ?v1))) (= (f7 ?v_0 (f5 f6 (* 2 (f7 f8 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 ?v_0 (f5 f6 (* (f7 f8 ?v1) (f7 f8 ?v2)))) (f3 (f13 f31 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f7 ?v_0 (f5 f6 (* (f7 f8 ?v1) (f7 f8 ?v2)))) (f7 (f32 f33 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (f3 (f13 f24 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (* ?v0 (f7 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (f3 (f13 f24 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (* (f7 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f31 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v2)))) (f3 (f13 f24 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v2)))) (* (f7 ?v_0 ?v1) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f13 f31 ?v0) ?v1))) (= (f3 (f13 f24 ?v_0) ?v0) (f3 (f13 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f7 (f32 f33 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f7 (f32 f33 (f7 f8 ?v0)) ?v1) (f7 f8 (f3 (f13 f31 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f7 (f32 f33 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f3 (f13 f31 (f5 f6 ?v0)) ?v1) (f5 f6 (f7 (f32 f33 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f7 (f32 f33 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (= (f5 f6 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
