(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S4)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 Int) S4)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S4) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 S4) S10)
(declare-fun f14 (S11 S10) S9)
(declare-fun f15 () S11)
(declare-fun f16 () S9)
(declare-fun f17 () S4)
(declare-fun f18 () S4)
(declare-fun f19 () S4)
(declare-fun f20 (S12 S10) S10)
(declare-fun f21 (S13 S10) S12)
(declare-fun f22 () S13)
(declare-fun f23 () S6)
(declare-fun f24 () S6)
(declare-fun f25 (S14 Int) S8)
(declare-fun f26 () S14)
(declare-fun f27 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 ?v0) ?v1) (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))))))
(assert (let ((?v_0 (* (f11 f12 f18) (f11 f12 f19)))) (not (= (f13 (f14 f15 (f13 f16 (f9 f10 (* 2 (f11 f12 f17))))) (f9 f10 (* 2 ?v_0))) (f13 (f14 f15 (f13 f16 f17)) (f9 f10 ?v_0))))))
(assert (let ((?v_0 (f14 f15 (f13 f16 (f9 f10 (* 2 (f11 f12 f17)))))) (?v_1 (f11 f12 f18)) (?v_2 (f11 f12 f19))) (= (f13 ?v_0 (f9 f10 (* ?v_1 (* 2 ?v_2)))) (f13 ?v_0 (f9 f10 (* 2 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (f13 (f14 f15 (f13 f16 (f9 f10 (* ?v_0 (f11 f12 ?v1))))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (f13 (f14 f15 (f13 f16 ?v1)) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f20 (f21 f22 ?v0) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f6 (f7 f24 ?v0) (f6 (f7 f23 (f6 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (* ?v0 (f11 (f25 f26 (f11 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f20 (f21 f22 ?v0) (f20 (f21 f22 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f6 (f7 f24 ?v0) (f6 (f7 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f20 (f21 f22 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f6 (f7 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S4) (?v2 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f6 (f7 f23 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f11 (f25 f26 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f6 (f7 f23 (f6 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f11 (f25 f26 (f11 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S10) (?v1 S4) (?v2 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 (f7 f23 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 (f25 f26 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S10)) (= (f20 (f21 f22 ?v0) ?v0) (f13 (f14 f15 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f24 ?v0) ?v0) (f6 (f7 f23 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f11 (f25 f26 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f20 (f21 f22 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f24 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* ?v0 (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f20 (f21 f22 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f24 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* ?v0 (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f20 (f21 f22 (f13 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* (f11 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f9 f10 2)) (f20 (f21 f22 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f23 ?v0) (f9 f10 2)) (f6 (f7 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f9 f10 3)) (f20 (f21 f22 (f20 (f21 f22 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f23 ?v0) (f9 f10 3)) (f6 (f7 f24 (f6 (f7 f24 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 ?v_0 ?v1) (ite (= ?v1 (f9 f10 0)) (f9 f10 1) (f9 f10 (* (f11 f12 ?v0) (f11 f12 (f6 ?v_0 (f9 f10 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f24 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) (f6 (f7 f24 ?v2) ?v3)) (f6 (f7 f24 (f6 ?v_0 ?v2)) (f6 (f7 f24 ?v1) ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) (f20 (f21 f22 ?v2) ?v3)) (f20 (f21 f22 (f20 ?v_0 ?v2)) (f20 (f21 f22 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f7 f24 (f6 (f7 f24 ?v0) ?v1))) (?v_0 (f7 f24 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_1 (f21 f22 (f20 (f21 f22 ?v0) ?v1))) (?v_0 (f21 f22 ?v2))) (= (f20 ?v_1 (f20 ?v_0 ?v3)) (f20 ?v_0 (f20 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f24 ?v0)) (?v_1 (f6 (f7 f24 ?v2) ?v3))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f21 f22 ?v0)) (?v_1 (f20 (f21 f22 ?v2) ?v3))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v_1) (f20 ?v_0 (f20 (f21 f22 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f24 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f24 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2) (f20 (f21 f22 (f20 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f24 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f21 f22 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f24 ?v0))) (= (f6 ?v_0 (f6 (f7 f24 ?v1) ?v2)) (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f20 (f21 f22 ?v1) ?v2)) (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f7 f24 ?v0)) (?v_0 (f7 f24 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_1 (f21 f22 ?v0)) (?v_0 (f21 f22 ?v1))) (= (f20 ?v_1 (f20 ?v_0 ?v2)) (f20 ?v_0 (f20 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f24 ?v0) ?v1) (f6 (f7 f24 ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f20 (f21 f22 ?v0) ?v1) (f20 (f21 f22 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (= (f11 (f25 f26 (f3 f27 ?v0)) ?v_0) (f11 (f25 f26 ?v0) ?v_0)))))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f23 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f23 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f25 f26 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f25 f26 ?v0) (f9 f10 2)))) (= (f3 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (f3 f27 (f11 (f25 f26 ?v0) ?v1)) (f11 (f25 f26 (f3 f27 ?v0)) ?v1))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* 2 ?v_0)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* ?v_0 2)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f9 f10 (+ ?v_1 (* (f11 f12 (f9 f10 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S10) (?v1 S4) (?v2 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f20 (f21 f22 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2)) (f13 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S4)) (= (f13 (f14 f15 (f20 (f21 f22 ?v0) ?v1)) ?v2) (f20 (f21 f22 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f23 (f6 (f7 f24 ?v0) ?v1)) ?v2) (f6 (f7 f24 (f6 (f7 f23 ?v0) ?v2)) (f6 (f7 f23 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (= (f11 (f25 f26 (* ?v0 ?v1)) ?v2) (* (f11 (f25 f26 ?v0) ?v2) (f11 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S4)) (= (f13 (f14 f15 (f20 (f21 f22 ?v0) ?v1)) ?v2) (f20 (f21 f22 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f23 (f6 (f7 f24 ?v0) ?v1)) ?v2) (f6 (f7 f24 (f6 (f7 f23 ?v0) ?v2)) (f6 (f7 f23 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (= (f11 (f25 f26 (* ?v0 ?v1)) ?v2) (* (f11 (f25 f26 ?v0) ?v2) (f11 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f13 (f14 f15 ?v0) ?v1))) (= (f20 (f21 f22 ?v_0) ?v0) (f20 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f6 (f7 f23 ?v0) ?v1))) (= (f6 (f7 f24 ?v_0) ?v0) (f6 (f7 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f11 (f25 f26 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f20 (f21 f22 (f13 ?v_0 ?v1)) ?v0) (f13 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (* (f11 ?v_0 ?v1) ?v0) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S4) (?v2 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f20 (f21 f22 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f6 (f7 f24 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0))) (= (f20 (f21 f22 ?v0) (f13 ?v_0 ?v1)) (f13 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f23 ?v0))) (= (f6 (f7 f24 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (* ?v0 (f11 ?v_0 ?v1)) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S10)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f14 f15 ?v2))) (=> (<= ?v_1 ?v_0) (= (f13 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (f20 (f21 f22 (f13 ?v_2 (f9 f10 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f7 f23 ?v2))) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f24 (f6 ?v_2 (f9 f10 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f25 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (* (f11 ?v_2 (f9 f10 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f14 f15 ?v1))) (=> (< 0 ?v_0) (= (f20 (f21 f22 (f13 ?v_1 (f9 f10 (- ?v_0 1)))) ?v1) (f13 ?v_1 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f7 f23 ?v1))) (=> (< 0 ?v_0) (= (f6 (f7 f24 (f6 ?v_1 (f9 f10 (- ?v_0 1)))) ?v1) (f6 ?v_1 ?v0))))))
(assert (forall ((?v0 S4) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f25 f26 ?v1))) (=> (< 0 ?v_0) (= (* (f11 ?v_1 (f9 f10 (- ?v_0 1))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 (f25 f26 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_2 (f11 f12 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= ?v0 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (or (= ?v1 (f9 f10 1)) (= ?v0 (f9 f10 0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 Int) (?v1 S4)) (<= 0 (f11 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 f12 (f6 (f7 f23 ?v0) ?v1)) (f11 (f25 f26 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (< 0 (f11 f12 (f6 (f7 f23 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (< 0 (f11 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (f6 (f7 f23 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 (f25 f26 (f11 f12 ?v0)) ?v1) (f11 f12 (f6 (f7 f23 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f6 (f7 f23 ?v0) ?v1) ?v_0) (or (= ?v1 (f9 f10 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (= (f9 f10 (f11 (f25 f26 ?v0) ?v1)) (f6 (f7 f23 (f9 f10 ?v0)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f23 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f6 ?v_0 ?v1)) (f11 f12 (f6 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f6 (f7 f23 ?v0) ?v1)))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f9 f10 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f9 f10 (* (f11 f12 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0))) (f11 f12 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* 0 (f11 f12 ?v0))) (f9 f10 0))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 1))) (= (= ?v_0 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* (f11 f12 ?v0) 0)) (f9 f10 0))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f9 f10 (* ?v_1 ?v_0)) (f9 f10 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_0 (+ ?v_1 1))) (f9 f10 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f9 f10 (* ?v_0 (+ ?v_1 ?v_2))) (f9 f10 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_0 (f11 f12 (f9 f10 (- ?v_1 ?v_2))))) (f9 f10 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f9 f10 (* (+ ?v_1 1) ?v_0)) (f9 f10 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 1))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 0))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f9 f10 (* (* ?v_0 ?v_1) ?v_2)) (f9 f10 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f9 f10 (* (+ ?v_0 ?v_2) ?v_1)) (f9 f10 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f9 f10 (* (f11 f12 (f9 f10 (- ?v_0 ?v_2))) ?v_1)) (f9 f10 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (or (= ?v0 (f9 f10 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f9 f10 (* (f11 f12 ?v0) ?v_0)) (f9 f10 (* (f11 f12 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (= (f9 f10 (+ (* ?v_1 ?v_0) (+ (* ?v_2 ?v_0) ?v_3))) (f9 f10 (+ (* (+ ?v_1 ?v_2) ?v_0) ?v_3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f11 f12 (f9 f10 ?v0)) (f11 f12 (f9 f10 ?v1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f11 f12 (f9 f10 (- ?v0))) (f11 f12 (f9 f10 (- ?v1)))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f9 f10 (+ (* ?v_0 ?v_2) (f11 f12 ?v3))) (f9 f10 (+ (* ?v_1 ?v_2) ?v_3))) (= ?v3 (f9 f10 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (f9 f10 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f9 f10 (- ?v_3 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< ?v_3 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= ?v_3 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f9 f10 (+ (* ?v_0 ?v_2) ?v_3)) (f9 f10 (+ (* ?v_1 ?v_2) (f11 f12 ?v4)))) (= (f9 f10 (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (f9 f10 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f9 f10 (- (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 (f25 f26 (f11 f12 ?v0)) ?v1) (f11 f12 (f6 (f7 f23 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (= (f6 (f7 f23 (f9 f10 ?v0)) ?v1) (f9 f10 (f11 (f25 f26 ?v0) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (< 0 (f11 f12 (f6 (f7 f23 ?v0) ?v1))) (or (= ?v1 (f9 f10 0)) (< 0 (f11 f12 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (<= 0 (f11 (f25 f26 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f9 f10 0))) (= (f9 f10 (+ (+ (f11 f12 (f9 f10 (- ?v_0 2))) 1) 1)) (f9 f10 ?v_0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (* 4 (f11 f12 ?v0)))) (=> (not (= ?v0 (f9 f10 0))) (= (f9 f10 (+ (+ (f11 f12 (f9 f10 (- ?v_0 2))) 1) 1)) (f9 f10 ?v_0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f9 f10 0))) (= (f9 f10 (+ (f11 f12 (f9 f10 (- ?v_0 1))) 1)) (f9 f10 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f9 f10 (* (f11 f12 (f9 f10 ?v0)) (f11 f12 (f9 f10 ?v1)))) (f9 f10 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f24 ?v0))) (= (f6 (f7 f24 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f21 f22 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f27 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f27 (* ?v0 ?v1)) (* (f3 f27 ?v0) (f3 f27 ?v1)))))
(assert (forall ((?v0 S4)) (= (f9 f10 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
