(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S6)
(declare-fun f7 (S7 S6) S4)
(declare-fun f8 () S7)
(declare-fun f9 (S8 S6) S6)
(declare-fun f10 () S8)
(declare-fun f11 () S6)
(declare-fun f12 (S9 Int) S5)
(declare-fun f13 () S9)
(declare-fun f14 (S10 S5) Int)
(declare-fun f15 () S10)
(declare-fun f16 () S5)
(declare-fun f17 () S5)
(declare-fun f18 (S11 S6) S8)
(declare-fun f19 () S11)
(declare-fun f20 () S6)
(declare-fun f21 () S2)
(declare-fun f22 (S12 Int) S10)
(declare-fun f23 () S12)
(declare-fun f24 () S6)
(declare-fun f25 () S11)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (let ((?v_0 (f7 f8 f11))) (not (= (f6 (f7 f8 (f9 f10 f11)) (f12 f13 (- (f14 f15 f16) (f14 f15 f17)))) (f9 (f18 f19 (f6 ?v_0 f17)) (f6 ?v_0 f16))))))
(assert (<= (f14 f15 f17) (f14 f15 f16)))
(assert (not (= f11 f20)))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f3 f21 (f14 (f22 f23 ?v0) ?v1)) (f14 (f22 f23 (f3 f21 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 (f22 f23 ?v0) (f12 f13 2)))) (= (f3 f21 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f14 (f22 f23 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f14 (f22 f23 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S6) (?v1 S5)) (=> (not (= ?v0 f20)) (not (= (f6 (f7 f8 ?v0) ?v1) f20)))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (not (= ?v0 0)) (not (= (f14 (f22 f23 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S6)) (= (= (f6 (f7 f8 ?v0) (f12 f13 2)) f20) (= ?v0 f20))))
(assert (forall ((?v0 Int)) (= (= (f14 (f22 f23 ?v0) (f12 f13 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S6) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f20) (and (= ?v0 f20) (not (= ?v1 (f12 f13 0)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (= (f14 (f22 f23 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f12 f13 0)))))))
(assert (= (f6 (f7 f8 f20) (f12 f13 2)) f20))
(assert (= (f14 (f22 f23 0) (f12 f13 2)) 0))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f20) (f12 f13 (+ (f14 f15 ?v0) 1))) f20)))
(assert (forall ((?v0 S5)) (= (f14 (f22 f23 0) (f12 f13 (+ (f14 f15 ?v0) 1))) 0)))
(assert (forall ((?v0 S6)) (= (f9 (f18 f19 f20) ?v0) f20)))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f9 f10 ?v0) (f9 f10 ?v1)) (=> (not (= ?v0 f20)) (=> (not (= ?v1 f20)) (= ?v0 ?v1))))))
(assert (forall ((?v0 S6)) (=> (= (f9 f10 ?v0) f20) (= ?v0 f20))))
(assert (forall ((?v0 S6)) (=> (not (= ?v0 f20)) (= (f9 f10 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 S6)) (=> (not (= ?v0 f20)) (not (= (f9 f10 ?v0) f20)))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S5)) (let ((?v_0 (f14 f15 ?v2)) (?v_1 (f14 f15 ?v1)) (?v_2 (f7 f8 ?v0))) (=> (not (= ?v0 f20)) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f12 f13 (- ?v_0 ?v_1))) (f9 (f18 f19 (f6 ?v_2 ?v2)) (f6 ?v_2 ?v1))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S5)) (=> (not (= ?v0 f20)) (= (f6 (f7 f8 (f9 (f18 f19 ?v1) ?v0)) ?v2) (f9 (f18 f19 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 ?v0) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S5)) (=> (not (= ?v0 f20)) (= (f9 f10 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f9 f10 ?v0)) ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2))) (= (f14 (f22 f23 (f3 f21 ?v0)) ?v_0) (f14 (f22 f23 ?v0) ?v_0)))))
(assert (= (f3 f21 0) 0))
(assert (forall ((?v0 S6)) (= (= f20 ?v0) (= ?v0 f20))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f3 f21 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S6)) (=> (not (= ?v0 f20)) (= (f9 f10 ?v0) (f9 (f18 f19 f24) ?v0)))))
(assert (forall ((?v0 S6)) (= (f9 f10 ?v0) (f9 (f18 f19 f24) ?v0))))
(assert (forall ((?v0 S6)) (= (f9 f10 ?v0) (f9 (f18 f19 f24) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f9 (f18 f19 ?v0) ?v1) (f9 (f18 f25 ?v0) (f9 f10 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f9 (f18 f19 ?v0) ?v1) (f9 (f18 f25 ?v0) (f9 f10 ?v1)))))
(assert (= (f3 f21 1) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f21 (* ?v0 ?v1)) (* (f3 f21 ?v0) (f3 f21 ?v1)))))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 f24) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 ?v0) f24) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f9 (f18 f25 ?v0) ?v1) (f9 (f18 f25 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f18 f25 ?v0)) (?v_0 (f18 f25 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f18 f25 ?v0))) (= (f9 ?v_0 (f9 (f18 f25 ?v1) ?v2)) (f9 (f18 f25 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f21 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f18 f25 ?v0))) (= (f9 (f18 f25 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f18 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f18 f25 ?v0))) (= (f9 (f18 f25 (f9 ?v_0 ?v1)) ?v2) (f9 (f18 f25 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f18 f25 ?v0)) (?v_1 (f9 (f18 f25 ?v2) ?v3))) (= (f9 (f18 f25 (f9 ?v_0 ?v1)) ?v_1) (f9 ?v_0 (f9 (f18 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f18 f25 (f9 (f18 f25 ?v0) ?v1))) (?v_0 (f18 f25 ?v2))) (= (f9 ?v_1 (f9 ?v_0 ?v3)) (f9 ?v_0 (f9 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f18 f25 ?v0))) (= (f9 (f18 f25 (f9 ?v_0 ?v1)) (f9 (f18 f25 ?v2) ?v3)) (f9 (f18 f25 (f9 ?v_0 ?v2)) (f9 (f18 f25 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v0 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v1 ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f21 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f18 f25 ?v0))) (= (f9 (f18 f25 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f18 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 ?v0) f24) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 ?v0) f24) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S6)) (= (= f24 ?v0) (= ?v0 f24))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 f24) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 f24) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f21 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f3 f21 (* ?v0 ?v1)) (* (f3 f21 ?v0) (f3 f21 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f3 f21 ?v1) ?v0) (f3 f21 (* ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (<= 0 1))
(assert (not (<= 1 0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f22 f23 ?v2))) (=> (<= (f14 f15 ?v0) (f14 f15 ?v1)) (=> (<= 1 ?v2) (<= (f14 ?v_0 ?v0) (f14 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 1 ?v0) (<= 1 (f14 (f22 f23 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f14 ?v_0 ?v1))) (= (f14 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (f9 (f18 f25 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f14 ?v_0 ?v1))) (= (f14 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (f9 (f18 f25 ?v0) (f9 (f18 f25 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f22 f23 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (* ?v0 (f14 (f22 f23 (f14 ?v_0 ?v1)) (f12 f13 2)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (f9 (f18 f25 ?v0) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f12 f13 2)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f9 (f18 f25 ?v0) ?v1) f24) (= (f9 f10 ?v0) ?v1))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f21 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f3 f21 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (<= 0 (f3 f21 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f22 f23 ?v2))) (=> (<= (f14 f15 ?v0) (f14 f15 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f14 ?v_0 ?v1) (f14 ?v_0 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 (f14 (f22 f23 ?v0) (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1)))) (<= 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f14 (f22 f23 ?v0) (f12 f13 (* 2 (f14 f15 ?v1)))))))
(assert (forall ((?v0 S6)) (=> (not (= ?v0 f20)) (= (f9 (f18 f25 (f9 f10 ?v0)) ?v0) f24))))
(assert (forall ((?v0 S6)) (=> (not (= ?v0 f20)) (= (f9 (f18 f25 (f9 f10 ?v0)) ?v0) f24))))
(assert (forall ((?v0 S6)) (=> (not (= ?v0 f20)) (= (f9 (f18 f25 ?v0) (f9 f10 ?v0)) f24))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f9 (f18 f25 ?v0) ?v1) f20) (or (= ?v0 f20) (= ?v1 f20)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f20)) (=> (not (= ?v1 f20)) (not (= (f9 (f18 f25 ?v0) ?v1) f20))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f9 (f18 f25 ?v0) ?v1) f20) (or (= ?v0 f20) (= ?v1 f20)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 ?v0) f20) f20)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 ?v0) f20) f20)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 f20) ?v0) f20)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 f20) ?v0) f20)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (not (= f20 f24)))
(assert (not (= 0 1)))
(assert (not (= f24 f20)))
(assert (not (= 1 0)))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f14 (f22 f23 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 S6)) (= (f9 (f18 f25 ?v0) ?v0) (f6 (f7 f8 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f22 f23 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (* ?v0 (f14 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f9 (f18 f25 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f22 f23 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (* ?v0 (f14 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f9 (f18 f25 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f22 f23 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (* (f14 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f9 (f18 f25 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f14 (f22 f23 ?v0) (f12 f13 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f12 f13 2)) (f9 (f18 f25 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f14 (f22 f23 ?v0) (f12 f13 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f6 (f7 f8 ?v0) (f12 f13 3)) (f9 (f18 f25 (f9 (f18 f25 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f22 f23 ?v0))) (= (* ?v0 (f14 ?v_0 ?v1)) (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f9 (f18 f25 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1)))))))
(assert (forall ((?v0 S5)) (= (f12 f13 (f14 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f15 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
