(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S4)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 Int) S4)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S4) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 S4) S10)
(declare-fun f14 (S11 S9) S9)
(declare-fun f15 (S4) S11)
(declare-fun f16 () S6)
(declare-fun f17 () S9)
(declare-fun f18 () S4)
(declare-fun f19 (S4) S11)
(declare-fun f20 () S2)
(declare-fun f21 (S12 Int) S8)
(declare-fun f22 () S12)
(declare-fun f23 () S5)
(declare-fun f24 () S2)
(declare-fun f25 (S13 S4) S1)
(declare-fun f26 (S14 S4) S13)
(declare-fun f27 () S14)
(declare-fun f28 () S13)
(declare-fun f29 () S6)
(declare-fun f30 () S7)
(declare-fun f31 (S15 Int) S1)
(declare-fun f32 (S16 Int) S15)
(declare-fun f33 () S16)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 ?v0) ?v1) (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))))))
(assert (let ((?v_0 (f9 f10 0))) (not (= (f13 (f14 (f15 (f6 (f7 f16 (f9 f10 2)) ?v_0)) f17) f18) (f13 (f14 (f19 ?v_0) f17) f18)))))
(assert (< (f11 f12 f18) (f11 f12 (f6 (f7 f16 (f9 f10 2)) (f9 f10 0)))))
(assert (< (f11 f12 f18) (f11 f12 (f6 (f7 f16 (f9 f10 2)) (f9 f10 0)))))
(assert (forall ((?v0 S9)) (= (f14 (f19 (f9 f10 0)) ?v0) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (< 0 (f11 f12 (f6 (f7 f16 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (< 0 (f11 f12 (f6 (f7 f16 ?v0) ?v1))) (or (= ?v1 (f9 f10 0)) (< 0 (f11 f12 ?v0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (f6 (f7 f16 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f6 (f7 f16 ?v0) ?v1) ?v_0) (or (= ?v1 (f9 f10 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f6 ?v_0 ?v1)) (f11 f12 (f6 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f6 (f7 f16 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (f3 f20 (f11 (f21 f22 ?v0) ?v1)) (f11 (f21 f22 (f3 f20 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f21 f22 ?v0) (f9 f10 2)))) (= (f3 f20 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f9 f10 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (= (f11 (f21 f22 (f3 f20 ?v0)) ?v_0) (f11 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 f23 (f6 (f7 f16 ?v0) ?v1)) (f6 (f7 f16 (f6 f23 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 f12 (f6 (f7 f16 ?v0) ?v1)) (f11 (f21 f22 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (= (f6 (f7 f16 (f9 f10 ?v0)) ?v1) (f9 f10 (f11 (f21 f22 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (= (f9 f10 (f11 (f21 f22 ?v0) ?v1)) (f6 (f7 f16 (f9 f10 ?v0)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 (f21 f22 (f11 f12 ?v0)) ?v1) (f11 f12 (f6 (f7 f16 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 (f21 f22 (f11 f12 ?v0)) ?v1) (f11 f12 (f6 (f7 f16 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f11 f12 (f6 (f7 f16 ?v0) ?v1)) (f11 (f21 f22 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f3 f20 ?v_0) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 f23 ?v0) (f6 f23 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f11 f12 ?v0) (f11 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 ?v_0 ?v1) (ite (= ?v1 (f9 f10 0)) (f9 f10 1) (f9 f10 (* (f11 f12 ?v0) (f11 f12 (f6 ?v_0 (f9 f10 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 S4) (?v1 Int)) (let ((?v_0 (f9 f10 (f3 f24 ?v1)))) (= (< 0 (f11 f12 (f6 (f7 f16 ?v0) ?v_0))) (or (= ?v_0 (f9 f10 0)) (< 0 (f11 f12 ?v0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (=> (= (f25 (f26 f27 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (=> (< 1 (f11 f12 ?v0)) (<= (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f25 f28 (f6 (f7 f16 ?v0) ?v1)) f1) (and (= (f25 f28 ?v0) f1) (< 0 (f11 f12 ?v1))))))
(assert (forall ((?v0 S4)) (= (f25 (f26 f27 (f9 f10 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S4)) (= (f25 (f26 f27 ?v0) ?v0) f1)))
(assert (= (f25 f28 (f9 f10 0)) f1))
(assert (not (= (f25 f28 (f9 f10 1)) f1)))
(assert (forall ((?v0 Int) (?v1 S4)) (<= 0 (f11 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S4)) (= (= (f25 f28 ?v0) f1) (exists ((?v1 S4)) (= ?v0 (f9 f10 (* (+ (+ 0 1) 1) (f11 f12 ?v1))))))))
(assert (forall ((?v0 S4)) (= (= (f25 f28 ?v0) f1) (exists ((?v1 S4)) (= ?v0 (f9 f10 (* 2 (f11 f12 ?v1))))))))
(assert (forall ((?v0 S4)) (= (= (f25 f28 ?v0) f1) (= (f25 (f26 f27 (f9 f10 2)) ?v0) f1))))
(assert (forall ((?v0 S4)) (= (not (= (f25 f28 ?v0) f1)) (exists ((?v1 S4)) (= ?v0 (f9 f10 (+ (* (+ (+ 0 1) 1) (f11 f12 ?v1)) 1)))))))
(assert (forall ((?v0 S4)) (= (not (= (f25 f28 ?v0) f1)) (exists ((?v1 S4)) (= ?v0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1)))))))
(assert (forall ((?v0 S4)) (= (= (f25 f28 (f9 f10 (+ (f11 f12 ?v0) 1))) f1) (not (= (f25 f28 ?v0) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (not (= (f25 f28 (f9 f10 (+ (f11 f12 ?v0) (f11 f12 ?v1)))) f1)) (not (= (not (= (f25 f28 ?v0) f1)) (not (= (f25 f28 ?v1) f1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f25 f28 (f9 f10 (+ (f11 f12 ?v0) (f11 f12 ?v1)))) f1) (= (= (f25 f28 ?v0) f1) (= (f25 f28 ?v1) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f25 f28 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) f1) (or (= (f25 f28 ?v0) f1) (= (f25 f28 ?v1) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 f23 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (f6 (f7 f29 (f6 f23 ?v0)) (f6 f23 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= (f11 f12 (f9 f10 ?v_0)) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (= (f25 f28 ?v0) f1)) (?v_3 (= (f25 f28 ?v1) f1))) (= (= (f25 f28 (f9 f10 (- ?v_0 ?v_1))) f1) (or (< ?v_0 ?v_1) (or (and ?v_2 ?v_3) (and (not ?v_2) (not ?v_3))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (= (f25 f28 ?v0) f1)) (?v_1 (= (f25 f28 ?v1) f1))) (= (= (f25 f28 (f9 f10 (+ (f11 f12 ?v0) (f11 f12 ?v1)))) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (< 0 (f11 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f29 ?v0) ?v1) (f6 (f7 f29 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f9 f10 (+ ?v_1 (* (f11 f12 (f9 f10 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* ?v_0 2)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f7 f29 ?v0)) (?v_0 (f7 f29 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f29 ?v0))) (= (f6 ?v_0 (f6 (f7 f29 ?v1) ?v2)) (f6 (f7 f29 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f9 f10 (* 2 ?v_0)) (f9 f10 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 (f21 f22 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f29 ?v0))) (= (f6 (f7 f29 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f29 ?v0))) (= (f6 (f7 f29 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f29 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f29 ?v0)) (?v_1 (f6 (f7 f29 ?v2) ?v3))) (= (f6 (f7 f29 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f7 f29 (f6 (f7 f29 ?v0) ?v1))) (?v_0 (f7 f29 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f29 ?v0))) (= (f6 (f7 f29 (f6 ?v_0 ?v1)) (f6 (f7 f29 ?v2) ?v3)) (f6 (f7 f29 (f6 ?v_0 ?v2)) (f6 (f7 f29 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S4)) (=> (not (= (f25 f28 ?v0) f1)) (< 0 (f11 f12 ?v0)))))
(assert (forall ((?v0 Int) (?v1 S4)) (=> (<= 0 ?v0) (<= 0 (f11 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (= (f25 f28 ?v0) f1) (not (= (f25 f28 (f9 f10 (- ?v_0 1))) f1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 (f9 f30 ?v0)))) (=> (< 0 ?v_0) (= (f9 f10 (f3 f24 ?v0)) (f9 f10 (+ (f11 f12 (f9 f10 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f25 (f26 f27 (f9 f10 (* ?v_0 (f11 f12 ?v1)))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) f1) (=> (< 0 ?v_0) (= (f25 (f26 f27 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (= (f25 (f26 f27 ?v0) ?v1) f1)) (?v_0 (= (f25 (f26 f27 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f26 f27 ?v0)) (?v_0 (f26 f27 ?v1)) (?v_2 (f26 f27 ?v2))) (=> (and (= (f25 ?v_1 ?v1) f1) (not (= (f25 ?v_0 ?v0) f1))) (=> (and (= (f25 ?v_0 ?v2) f1) (not (= (f25 ?v_2 ?v1) f1))) (and (= (f25 ?v_1 ?v2) f1) (not (= (f25 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (= (f25 (f26 f27 ?v0) ?v1) f1)) (?v_0 (= (f25 (f26 f27 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f26 f27 ?v0)) (?v_0 (f26 f27 ?v1))) (=> (and (= (f25 ?v_1 ?v1) f1) (not (= (f25 ?v_0 ?v0) f1))) (=> (= (f25 ?v_0 ?v2) f1) (and (= (f25 ?v_1 ?v2) f1) (not (= (f25 (f26 f27 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (=> (and (= (f25 ?v_0 ?v1) f1) (not (= (f25 (f26 f27 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f25 ?v_0 ?v2) f1) (not (= (f25 (f26 f27 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S1)) (let ((?v_1 (= (f25 (f26 f27 ?v0) ?v1) f1)) (?v_0 (= (f25 (f26 f27 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (and (= (f25 (f26 f27 ?v0) ?v1) f1) (not (= (f25 (f26 f27 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (and (= (f25 (f26 f27 ?v0) ?v1) f1) (not (= (f25 (f26 f27 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (= (f25 (f26 f27 ?v0) ?v1) f1)) (?v_0 (= (f25 (f26 f27 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (= (f25 (f26 f27 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f25 (f26 f27 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (= (f25 (f26 f27 ?v0) ?v1) f1)) (?v_0 (= (f25 (f26 f27 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (and (= (f25 (f26 f27 ?v0) ?v1) f1) (not (= (f25 (f26 f27 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (= (f25 ?v_0 (f9 f10 (- ?v_2 ?v_1))) f1) (=> (= (f25 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f25 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (= (f25 ?v_0 (f9 f10 (- ?v_2 ?v_1))) f1) (=> (= (f25 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f25 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= ?v0 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (or (= ?v1 (f9 f10 1)) (= ?v0 (f9 f10 0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f26 f27 ?v2))) (=> (= (f25 ?v_0 ?v1) f1) (=> (and (= (f25 (f26 f27 ?v1) ?v2) f1) (not (= (f25 ?v_1 ?v1) f1))) (and (= (f25 ?v_0 ?v2) f1) (not (= (f25 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f25 (f26 f27 ?v1) ?v2) f1) (not (= (f25 ?v_0 ?v1) f1))) (and (= (f25 (f26 f27 ?v0) ?v2) f1) (not (= (f25 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f25 ?v_0 ?v1) f1) (=> (= (f25 ?v_0 ?v2) f1) (= (f25 ?v_0 (f9 f10 (- (f11 f12 ?v1) (f11 f12 ?v2)))) f1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f25 ?v_0 ?v1) f1) (=> (= (f25 (f26 f27 ?v1) ?v2) f1) (= (f25 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (=> (= (f25 (f26 f27 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (=> (= (f25 (f26 f27 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f25 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f25 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= ?v0 ?v1) (=> (= (f25 (f26 f27 ?v1) ?v2) f1) (= (f25 (f26 f27 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v1))) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f11 f12 ?v0) ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (= (f25 (f26 f27 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f25 (f26 f27 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (= (f25 (f26 f27 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f25 (f26 f27 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (= (= (f25 (f26 f27 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= ?v0 ?v1) (= (f25 (f26 f27 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f11 f12 (f9 f10 (- ?v0))) (f11 f12 (f9 f10 (- ?v1)))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f11 f12 ?v1)) (not (= (f25 (f26 f27 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f9 f10 (* (f11 f12 (f9 f10 ?v0)) (f11 f12 (f9 f10 ?v1)))) (f9 f10 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (= (f25 (f26 f27 (f9 f10 (* (f11 f12 ?v1) ?v_0))) ?v0) f1) (= ?v1 (f9 f10 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (= (f25 (f26 f27 (f9 f10 (* ?v_0 (f11 f12 ?v1)))) ?v0) f1) (= ?v1 (f9 f10 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f9 f10 (* ?v0 ?v1)) (f9 f10 (* (f11 f12 (f9 f10 ?v0)) (f11 f12 (f9 f10 ?v1))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (= (f25 (f26 f27 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f25 (f26 f27 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (+ (f11 f12 ?v0) 1))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f9 f10 (* (f11 f12 ?v0) ?v_0)) (f9 f10 (* (f11 f12 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f9 f10 0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (and (= (f25 (f26 f27 ?v0) ?v1) f1) (not (= (f25 (f26 f27 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (= (f25 (f26 f27 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f25 (f26 f27 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f9 f10 (* (f11 f12 (f9 f10 (- ?v_0 ?v_2))) ?v_1)) (f9 f10 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f9 f10 (* (+ ?v_0 ?v_2) ?v_1)) (f9 f10 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f9 f10 (* (* ?v_0 ?v_1) ?v_2)) (f9 f10 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 0))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 1))) (= (= (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (f3 f24 ?v0) (* (f3 f24 ?v1) ?v2)) (* (f3 f24 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 f24 ?v0) (f3 f24 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f3 f24 ?v0) (f3 f24 ?v1)) (f3 f24 (* ?v0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f9 f10 (* (+ ?v_1 1) ?v_0)) (f9 f10 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 f24 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f9 f30 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_0 (f11 f12 (f9 f10 (- ?v_1 ?v_2))))) (f9 f10 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f9 f10 (* ?v_0 (+ ?v_1 ?v_2))) (f9 f10 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f26 f27 ?v0))) (= (= (f25 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v0)))) f1) (= (f25 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f9 f10 (* ?v_0 (+ ?v_1 1))) (f9 f10 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 (+ 0 1)))) (= (= (f25 (f26 f27 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (= (f25 (f26 f27 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f25 (f26 f27 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 ?v1) (and (= (f25 (f26 f27 ?v0) ?v1) f1) (= (f25 (f26 f27 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f9 f10 (* ?v_1 ?v_0)) (f9 f10 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 1))) (= (= (f25 (f26 f27 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f9 f10 (* (f11 f12 ?v0) 0)) (f9 f10 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f9 f10 1))) (= (= ?v_0 (f9 f10 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S4)) (= (f9 f10 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S4)) (= (f9 f10 (* 0 (f11 f12 ?v0))) (f9 f10 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (* (f11 f12 ?v0) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f24 (* ?v0 ?v1)) (* (f3 f24 ?v0) (f3 f24 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f9 f10 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f9 f10 (* (f11 f12 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0))) (f11 f12 (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (= (f25 (f26 f27 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 (f3 f24 ?v0)))) (=> (= (f25 f28 ?v_0) f1) (= (f11 (f21 f22 (f3 f20 ?v1)) ?v_0) (f11 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f30 ?v0))) (= (f6 (f7 f16 ?v_0) (f9 f10 2)) (f6 (f7 f29 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f24 ?v0))) (= (f11 (f21 f22 ?v_0) (f9 f10 2)) (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f6 (f7 f29 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f6 (f7 f29 ?v0) (f6 (f7 f29 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (f6 (f7 f29 ?v0) (f6 (f7 f16 (f6 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (* 2 (f11 f12 ?v1)) 1))) (* ?v0 (f11 (f21 f22 (f11 ?v_0 ?v1)) (f9 f10 2)))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (f3 f24 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (= (f9 f30 (f11 f12 ?v0)) (f6 f23 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (= (f25 (f26 f27 (f6 (f7 f16 ?v0) ?v2)) (f6 (f7 f16 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (=> (= (f31 (f32 f33 ?v0) ?v1) f1) (= (f31 (f32 f33 (f11 (f21 f22 ?v0) ?v2)) (f11 (f21 f22 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f25 (f26 f27 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f31 (f32 f33 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f25 (f26 f27 (f6 (f7 f16 ?v0) ?v2)) (f6 (f7 f16 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4) (?v3 S4)) (=> (= (f31 (f32 f33 ?v0) ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f31 (f32 f33 (f11 (f21 f22 ?v0) ?v2)) (f11 (f21 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f16 ?v0))) (=> (= (f25 (f26 f27 (f6 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f25 (f26 f27 (f6 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 Int) (?v3 S4)) (let ((?v_0 (f21 f22 ?v0))) (=> (= (f31 (f32 f33 (f11 ?v_0 ?v1)) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f31 (f32 f33 (f11 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S4) (?v1 Int)) (=> (= (f25 f28 ?v0) f1) (= (f11 (f21 f22 (f3 f20 ?v1)) ?v0) (f11 (f21 f22 ?v1) ?v0)))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f29 ?v0) ?v0) (f6 (f7 f16 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f11 (f21 f22 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f29 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* ?v0 (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f29 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* ?v0 (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (f6 (f7 f29 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1))) (* (f11 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) (f9 f10 2)) (f6 (f7 f29 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f9 f10 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f16 ?v0) (f9 f10 3)) (f6 (f7 f29 (f6 (f7 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f9 f10 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 (f7 f29 ?v0) (f6 ?v_0 ?v1)) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (* ?v0 (f11 ?v_0 ?v1)) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f6 (f7 f29 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 (f7 f29 (f6 ?v_0 ?v1)) ?v0) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (* (f11 ?v_0 ?v1) ?v0) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f6 (f7 f16 ?v0) ?v1))) (= (f6 (f7 f29 ?v_0) ?v0) (f6 (f7 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f11 (f21 f22 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f16 (f6 (f7 f29 ?v0) ?v1)) ?v2) (f6 (f7 f29 (f6 (f7 f16 ?v0) ?v2)) (f6 (f7 f16 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (= (f11 (f21 f22 (* ?v0 ?v1)) ?v2) (* (f11 (f21 f22 ?v0) ?v2) (f11 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f16 (f6 (f7 f29 ?v0) ?v1)) ?v2) (f6 (f7 f29 (f6 (f7 f16 ?v0) ?v2)) (f6 (f7 f16 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (= (f11 (f21 f22 (* ?v0 ?v1)) ?v2) (* (f11 (f21 f22 ?v0) ?v2) (f11 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 (f7 f29 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) (f6 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (f11 ?v_0 (f9 f10 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f6 (f7 f16 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2)))) (f11 (f21 f22 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f6 (f7 f16 (f6 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f9 f10 (* 2 (f11 f12 ?v1)))) (f11 (f21 f22 (f11 ?v_0 ?v1)) (f9 f10 2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f16 ?v0))) (= (f6 (f7 f16 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 (f21 f22 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f9 f10 (* (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f25 (f26 f27 (f6 (f7 f16 ?v1) ?v0)) (f6 (f7 f16 ?v2) ?v0)) f1) (= (f25 (f26 f27 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f25 (f26 f27 (f6 (f7 f16 ?v0) ?v1)) (f6 (f7 f16 ?v2) ?v1)) f1) (=> (not (= ?v1 (f9 f10 0))) (= (f25 (f26 f27 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (= (f25 (f26 f27 (f9 f10 (* ?v_0 (f11 f12 ?v1)))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) f1) (= (f25 (f26 f27 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f25 (f26 f27 (f9 f10 (* ?v_0 (f11 f12 ?v1)))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) f1) (or (= ?v0 (f9 f10 0)) (= (f25 (f26 f27 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f25 (f26 f27 (f6 (f7 f29 ?v0) ?v1)) ?v2) f1) (= (f25 (f26 f27 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f31 (f32 f33 (* ?v0 ?v1)) ?v2) f1) (= (f31 (f32 f33 ?v1) ?v2) f1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f25 (f26 f27 (f6 (f7 f29 ?v0) ?v1)) ?v2) f1) (= (f25 (f26 f27 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f31 (f32 f33 (* ?v0 ?v1)) ?v2) f1) (= (f31 (f32 f33 ?v0) ?v2) f1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= ?v0 (f6 (f7 f29 ?v1) ?v2)) (= (f25 (f26 f27 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (* ?v1 ?v2)) (= (f31 (f32 f33 ?v1) ?v0) f1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (=> (= (f25 (f26 f27 ?v2) ?v3) f1) (= (f25 (f26 f27 (f6 (f7 f29 ?v0) ?v2)) (f6 (f7 f29 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f31 (f32 f33 ?v0) ?v1) f1) (=> (= (f31 (f32 f33 ?v2) ?v3) f1) (= (f31 (f32 f33 (* ?v0 ?v2)) (* ?v1 ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f25 ?v_0 ?v1) f1) (= (f25 ?v_0 (f6 (f7 f29 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f33 ?v0))) (=> (= (f31 ?v_0 ?v1) f1) (= (f31 ?v_0 (* ?v2 ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f25 ?v_0 ?v1) f1) (= (f25 ?v_0 (f6 (f7 f29 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f33 ?v0))) (=> (= (f31 ?v_0 ?v1) f1) (= (f31 ?v_0 (* ?v1 ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 S4) (?v2 Int)) (=> (= (f31 (f32 f33 (f11 (f21 f22 ?v0) ?v1)) (f11 (f21 f22 ?v2) ?v1)) f1) (=> (not (= ?v1 (f9 f10 0))) (= (f31 (f32 f33 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f31 (f32 f33 (f11 (f21 f22 ?v1) ?v0)) (f11 (f21 f22 ?v2) ?v0)) f1) (= (f31 (f32 f33 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f25 (f26 f27 ?v0) ?v1) f1) (= (f31 (f32 f33 (f11 f12 ?v0)) (f11 f12 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (= (f31 (f32 f33 ?v0) (f11 f12 ?v1)) f1) (= (f25 (f26 f27 (f9 f10 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S4) (?v1 Int)) (= (= (f31 (f32 f33 (f11 f12 ?v0)) ?v1) f1) (= (f25 (f26 f27 ?v0) (f9 f10 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (= (f25 (f26 f27 (f9 f10 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f31 (f32 f33 ?v0) (f11 f12 ?v1)) f1) (= ?v1 (f9 f10 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f31 (f32 f33 (f11 f12 ?v0)) (f11 f12 ?v1)) f1) (= (f25 (f26 f27 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f25 (f26 f27 (f9 f10 ?v0)) (f9 f10 ?v1)) f1) (= (f31 (f32 f33 ?v0) ?v1) f1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 (f3 f24 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 (f3 f24 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f20 (* ?v0 ?v1)) (* (f3 f20 ?v0) (f3 f20 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f20 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S4)) (= (f25 (f26 f27 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (= (f31 (f32 f33 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f32 f33 ?v0))) (= (= (f31 ?v_0 (f3 f20 ?v1)) f1) (= (f31 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f31 (f32 f33 (f3 f20 ?v0)) ?v1) f1) (= (f31 (f32 f33 ?v0) ?v1) f1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f25 ?v_0 ?v1) f1) (=> (= (f25 (f26 f27 ?v1) ?v2) f1) (= (f25 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f33 ?v0))) (=> (= (f31 ?v_0 ?v1) f1) (=> (= (f31 (f32 f33 ?v1) ?v2) f1) (= (f31 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 f20 ?v0) (f3 f20 ?v1)) (= (f31 (f32 f33 ?v0) ?v1) f1))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 0))) (not (and (= (f25 (f26 f27 ?v_0) ?v0) f1) (not (= (f25 (f26 f27 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 1))) (not (and (= (f25 (f26 f27 ?v0) ?v_0) f1) (not (= (f25 (f26 f27 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S4)) (= (f25 (f26 f27 (f9 f10 1)) ?v0) f1)))
(assert (forall ((?v0 S4)) (= (f25 (f26 f27 ?v0) (f9 f10 0)) f1)))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 1))) (= (not (= ?v0 ?v_0)) (and (= (f25 (f26 f27 ?v_0) ?v0) f1) (not (= (f25 (f26 f27 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 0))) (= (not (= ?v0 ?v_0)) (and (= (f25 (f26 f27 ?v0) ?v_0) f1) (not (= (f25 (f26 f27 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 0))) (= (= (f25 (f26 f27 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 1))) (= (= (f25 (f26 f27 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 0))) (=> (= (f25 (f26 f27 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (< 0 (f11 f12 ?v0)) (=> (= (f25 (f26 f27 ?v1) ?v0) f1) (< 0 (f11 f12 ?v1))))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f9 f10 1))) (=> (= (f25 (f26 f27 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (or (= ?v0 (f9 f10 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (= (f9 f10 (+ (* ?v_1 ?v_0) (+ (* ?v_2 ?v_0) ?v_3))) (f9 f10 (+ (* (+ ?v_1 ?v_2) ?v_0) ?v_3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (= (f9 f10 (* ?v_0 (f11 f12 ?v1))) (f9 f10 (* ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f9 f10 (+ (* ?v_0 ?v_2) (f11 f12 ?v3))) (f9 f10 (+ (* ?v_1 ?v_2) ?v_3))) (= ?v3 (f9 f10 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (f9 f10 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f9 f10 (- ?v_3 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< ?v_3 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= ?v_3 (+ (* (f11 f12 (f9 f10 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f9 f10 (+ (* ?v_0 ?v_2) ?v_3)) (f9 f10 (+ (* ?v_1 ?v_2) (f11 f12 ?v4)))) (= (f9 f10 (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (f9 f10 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f9 f10 (- (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= (+ (* (f11 f12 (f9 f10 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f25 (f26 f27 ?v0) (f6 (f7 f29 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f31 (f32 f33 ?v0) (* ?v0 ?v1)) f1)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f25 (f26 f27 ?v0) (f6 (f7 f29 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f31 (f32 f33 ?v0) (* ?v1 ?v0)) f1)))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f25 (f26 f27 ?v0) ?v1) f1) (=> (forall ((?v2 S4)) (=> (= ?v1 (f6 (f7 f29 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f31 (f32 f33 ?v0) ?v1) f1) (=> (forall ((?v2 Int)) (=> (= ?v1 (* ?v0 ?v2)) false)) false))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f7 f16 ?v2))) (=> (<= ?v_1 ?v_0) (= (f6 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f29 (f6 ?v_2 (f9 f10 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f21 f22 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f9 f10 (- (+ ?v_0 1) ?v_1))) (* (f11 ?v_2 (f9 f10 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f31 (f32 f33 (* ?v0 ?v1)) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f31 (f32 f33 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f33 ?v0))) (=> (= (f31 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f31 ?v_0 ?v2) f1) (= (f31 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f31 (f32 f33 ?v0) ?v1) f1) (=> (= (f31 (f32 f33 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f31 (f32 f33 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f32 f33 ?v0))) (=> (= (f31 ?v_0 ?v1) f1) (= (= (f31 ?v_0 (+ ?v2 ?v3)) f1) (= (f31 ?v_0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f31 (f32 f33 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f31 (f32 f33 ?v0) ?v1) f1) (=> (= (f31 (f32 f33 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f31 (f32 f33 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f31 (f32 f33 (* ?v0 ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 S4) (?v1 Int)) (let ((?v_0 (f3 f24 ?v1))) (= (= (f11 f12 ?v0) ?v_0) (and (= ?v0 (f9 f10 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f3 f24 ?v0) (f3 f24 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f3 f24 ?v0) (f3 f24 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 f24 ?v0) (f3 f24 ?v1)) (f3 f24 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f3 f24 ?v0) (f3 f24 ?v1)) (f3 f24 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f3 f24 ?v0) (f3 f24 ?v1)) (f3 f24 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f32 f33 ?v0))) (= (= (f31 ?v_0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f31 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (= (f31 (f32 f33 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int)) (= (- (f3 f24 ?v0)) (f3 f24 (- ?v0)))))
(assert (forall ((?v0 S4)) (= (f9 f10 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
