(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S3)
(declare-fun f8 () S2)
(declare-fun f9 (S5 S6) S2)
(declare-fun f10 () S5)
(declare-fun f11 () S6)
(declare-fun f12 (S7 S6) S6)
(declare-fun f13 (S8 S6) S7)
(declare-fun f14 () S8)
(declare-fun f15 () S6)
(declare-fun f16 () S6)
(declare-fun f17 () S4)
(declare-fun f18 () S6)
(declare-fun f19 () S9)
(declare-fun f20 () S9)
(declare-fun f21 () S8)
(declare-fun f22 () S3)
(declare-fun f23 () S4)
(declare-fun f24 (S10 S9) S9)
(declare-fun f25 (S11 S9) S10)
(declare-fun f26 () S11)
(declare-fun f27 () S11)
(declare-fun f28 () S9)
(declare-fun f29 () S2)
(declare-fun f30 () S8)
(declare-fun f31 () S4)
(declare-fun f32 (S12 Int) Int)
(declare-fun f33 (S13 Int) S12)
(declare-fun f34 () S13)
(declare-fun f35 () S4)
(declare-fun f36 () S13)
(declare-fun f37 () S12)
(declare-fun f38 (S14 S6) S10)
(declare-fun f39 () S14)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 (f4 f7 f8)) (f9 f10 f11)) (f9 f10 (f12 (f13 f14 f15) f16))) f1)))
(assert (= (f3 (f4 (f5 f17 (f4 (f5 f6 (f4 f7 f8)) (f9 f10 f11))) (f9 f10 f16)) (f9 f10 f15)) f1))
(assert (not (= f16 f18)))
(assert (not (= f16 f18)))
(assert (= (f3 (f4 (f5 f17 (f4 (f5 f6 (f4 f7 f8)) (f9 f10 f11))) (f9 f10 f16)) (f9 f10 f15)) f1))
(assert (not (= f19 f20)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f3 (f9 f10 (f12 (f13 f21 ?v0) ?v1)) (f4 (f5 f6 (f9 f10 ?v0)) (f9 f10 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f22 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f22 ?v0)) (f4 f22 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f22 (f4 (f5 f23 ?v0) ?v1)) (f4 (f5 f23 (f4 f22 ?v0)) (f4 f22 ?v1))) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f3 (f9 f10 (f12 (f13 f14 ?v0) ?v1)) (f4 (f5 f23 (f9 f10 ?v0)) (f9 f10 ?v1))) f1)))
(assert (forall ((?v0 S2)) (= (f3 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f22 (f4 (f5 f23 ?v0) ?v1)) (f4 (f5 f23 (f4 f22 ?v0)) (f4 f22 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f9 f10 (f12 (f13 f14 ?v0) ?v1)) (f4 (f5 f23 (f9 f10 ?v0)) (f9 f10 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f12 (f13 f21 ?v1) ?v2)) (f12 (f13 f21 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f12 (f13 f21 ?v1) ?v2)) (f12 (f13 f21 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f24 (f25 f27 ?v1) ?v2)) (f24 (f25 f27 (f24 ?v_0 ?v1)) (f24 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (+ ?v1 ?v2)) (+ (* ?v0 ?v1) (* ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f12 (f13 f21 ?v1) ?v2)) (f12 (f13 f21 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f13 f14 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f12 (f13 f21 (f12 ?v_0 ?v2)) (f12 ?v_1 ?v3)) (f12 (f13 f21 (f12 ?v_0 ?v3)) (f12 ?v_1 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f23 ?v0)) (?v_1 (f5 f23 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f4 (f5 f6 (f4 ?v_0 ?v2)) (f4 ?v_1 ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v3)) (f4 ?v_1 ?v2))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f25 f26 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f24 (f25 f27 (f24 ?v_0 ?v2)) (f24 ?v_1 ?v3)) (f24 (f25 f27 (f24 ?v_0 ?v3)) (f24 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (* ?v0 ?v2) (* ?v1 ?v3)) (+ (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f12 (f13 f14 (f12 (f13 f21 ?v0) ?v1)) ?v2) (f12 (f13 f21 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f23 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f23 ?v0) ?v2)) (f4 (f5 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f24 (f25 f26 (f24 (f25 f27 ?v0) ?v1)) ?v2) (f24 (f25 f27 (f24 (f25 f26 ?v0) ?v2)) (f24 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f12 (f13 f14 (f12 (f13 f21 ?v0) ?v1)) ?v2) (f12 (f13 f21 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f23 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f23 ?v0) ?v2)) (f4 (f5 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f24 (f25 f26 (f24 (f25 f27 ?v0) ?v1)) ?v2) (f24 (f25 f27 (f24 (f25 f26 ?v0) ?v2)) (f24 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (not (not (= f28 f20))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f17 f29) ?v0) f29)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f30 f18) ?v0) f18)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f17 f29) ?v0) f29)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f30 f18) ?v0) f18)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f17 ?v0) f29) f29)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f30 ?v0) f18) f18)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f23 ?v0) ?v1) (f4 (f5 f23 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v0))) (= (f4 (f5 f23 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S2)) (= (= (f4 f22 ?v0) f29) (= ?v0 f29))))
(assert (forall ((?v0 S6)) (= (= (f9 f10 ?v0) f29) (= ?v0 f18))))
(assert (= (f4 f22 f29) f29))
(assert (= (f9 f10 f18) f29))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f23 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f23 ?v0) ?v2)) (f4 (f5 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f29)) (= (f4 f22 (f4 (f5 f17 ?v1) ?v0)) (f4 (f5 f17 (f4 f22 ?v1)) (f4 f22 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f18)) (= (f9 f10 (f12 (f13 f30 ?v1) ?v0)) (f4 (f5 f17 (f9 f10 ?v1)) (f9 f10 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f29)) (=> (= (f4 (f5 f23 ?v1) ?v0) ?v2) (= ?v1 (f4 (f5 f17 ?v2) ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f18)) (=> (= (f12 (f13 f14 ?v1) ?v0) ?v2) (= ?v1 (f12 (f13 f30 ?v2) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f29)) (=> (= ?v1 (f4 (f5 f23 ?v2) ?v0)) (= (f4 (f5 f17 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f18)) (=> (= ?v1 (f12 (f13 f14 ?v2) ?v0)) (= (f12 (f13 f30 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f29)) (= (= (f4 (f5 f17 ?v1) ?v0) ?v2) (= ?v1 (f4 (f5 f23 ?v2) ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f18)) (= (= (f12 (f13 f30 ?v1) ?v0) ?v2) (= ?v1 (f12 (f13 f14 ?v2) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f29)) (= (= ?v1 (f4 (f5 f17 ?v2) ?v0)) (= (f4 (f5 f23 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f18)) (= (= ?v1 (f12 (f13 f30 ?v2) ?v0)) (= (f12 (f13 f14 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f9 f10 (f12 (f13 f30 ?v0) ?v1)) (f4 (f5 f17 (f9 f10 ?v0)) (f9 f10 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f22 (f4 (f5 f17 ?v0) ?v1)) (f4 (f5 f17 (f4 f22 ?v0)) (f4 f22 ?v1)))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f22 ?v0) f29) f1) (= ?v0 f29))))
(assert (forall ((?v0 S6)) (= (= (f3 (f9 f10 ?v0) f29) f1) (= ?v0 f18))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v0))) (= (f4 ?v_0 (f4 (f5 f17 ?v1) ?v2)) (f4 (f5 f17 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f12 (f13 f30 ?v1) ?v2)) (f12 (f13 f30 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f12 (f13 f30 (f12 (f13 f21 ?v0) ?v1)) ?v2) (f12 (f13 f21 (f12 (f13 f30 ?v0) ?v2)) (f12 (f13 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f17 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f17 ?v0) ?v2)) (f4 (f5 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f12 (f13 f30 (f12 (f13 f21 ?v0) ?v1)) ?v2) (f12 (f13 f21 (f12 (f13 f30 ?v0) ?v2)) (f12 (f13 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f17 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f17 ?v0) ?v2)) (f4 (f5 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f23 ?v0) ?v1) f29) (or (= ?v0 f29) (= ?v1 f29)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f24 (f25 f26 ?v0) ?v1) f20) (or (= ?v0 f20) (= ?v1 f20)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f12 (f13 f14 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f29)) (=> (not (= ?v1 f29)) (not (= (f4 (f5 f23 ?v0) ?v1) f29))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (not (= ?v0 f20)) (=> (not (= ?v1 f20)) (not (= (f24 (f25 f26 ?v0) ?v1) f20))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f18)) (=> (not (= ?v1 f18)) (not (= (f12 (f13 f14 ?v0) ?v1) f18))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f23 ?v0) ?v1) f29) (or (= ?v0 f29) (= ?v1 f29)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f24 (f25 f26 ?v0) ?v1) f20) (or (= ?v0 f20) (= ?v1 f20)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f12 (f13 f14 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f23 ?v0) f29) f29)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f14 ?v0) f18) f18)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f23 ?v0) f29) f29)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f14 ?v0) f18) f18)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f23 ?v0) f29) f29)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 ?v0) f20) f20)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f14 ?v0) f18) f18)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f23 ?v0) f29) f29)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 ?v0) f20) f20)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f14 ?v0) f18) f18)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f23 f29) ?v0) f29)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f14 f18) ?v0) f18)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f23 f29) ?v0) f29)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f14 f18) ?v0) f18)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f23 f29) ?v0) f29)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 f20) ?v0) f20)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f14 f18) ?v0) f18)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f23 f29) ?v0) f29)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 f20) ?v0) f20)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f14 f18) ?v0) f18)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= ?v0 (f12 (f13 f21 ?v0) ?v1)) (= ?v1 f18))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 (f4 (f5 f6 ?v0) ?v1)) (= ?v1 f29))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= ?v0 (f24 (f25 f27 ?v0) ?v1)) (= ?v1 f20))))
(assert (forall ((?v0 S6)) (= (f12 (f13 f21 ?v0) f18) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f29) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f27 ?v0) f20) ?v0)))
(assert (forall ((?v0 S6)) (= (f12 (f13 f21 f18) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f29) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f27 f20) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 ?v0) f1) (= (f3 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= ?v0 ?v2) (= (f3 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f3 ?v2 ?v1) f1) (= (f3 ?v2 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (= (= (f3 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 ?v1) (= (f3 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 (f5 f31 ?v0) ?v1) ?v2) f1) (or (= (f3 ?v0 ?v2) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f32 (f33 f34 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 ?v0 (f4 (f5 f35 ?v1) ?v2)) f1) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f32 (f33 f36 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 ?v1) (and (= (f3 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f3 (f9 f10 ?v0) (f4 (f5 f6 (f9 f10 (f12 (f13 f21 ?v0) ?v1))) (f9 f10 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f23 ?v0))) (= (f4 (f5 f23 (f4 ?v_0 ?v1)) (f4 (f5 f23 ?v2) ?v3)) (f4 (f5 f23 (f4 ?v_0 ?v2)) (f4 (f5 f23 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) (f12 (f13 f14 ?v2) ?v3)) (f12 (f13 f14 (f12 ?v_0 ?v2)) (f12 (f13 f14 ?v1) ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 (f25 f26 (f24 ?v_0 ?v1)) (f24 (f25 f26 ?v2) ?v3)) (f24 (f25 f26 (f24 ?v_0 ?v2)) (f24 (f25 f26 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f5 f23 (f4 (f5 f23 ?v0) ?v1))) (?v_0 (f5 f23 ?v2))) (= (f4 ?v_1 (f4 ?v_0 ?v3)) (f4 ?v_0 (f4 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f13 f14 (f12 (f13 f14 ?v0) ?v1))) (?v_0 (f13 f14 ?v2))) (= (f12 ?v_1 (f12 ?v_0 ?v3)) (f12 ?v_0 (f12 ?v_1 ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_1 (f25 f26 (f24 (f25 f26 ?v0) ?v1))) (?v_0 (f25 f26 ?v2))) (= (f24 ?v_1 (f24 ?v_0 ?v3)) (f24 ?v_0 (f24 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f23 ?v0)) (?v_1 (f4 (f5 f23 ?v2) ?v3))) (= (f4 (f5 f23 (f4 ?v_0 ?v1)) ?v_1) (f4 ?v_0 (f4 (f5 f23 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f12 (f13 f14 ?v2) ?v3))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v_1) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v_1))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f24 (f25 f26 ?v2) ?v3))) (= (f24 (f25 f26 (f24 ?v_0 ?v1)) ?v_1) (f24 ?v_0 (f24 (f25 f26 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v0))) (= (f4 (f5 f23 (f4 ?v_0 ?v1)) ?v2) (f4 (f5 f23 (f4 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 (f13 f14 (f12 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 (f25 f26 (f24 ?v_0 ?v1)) ?v2) (f24 (f25 f26 (f24 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v0))) (= (f4 (f5 f23 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 (f25 f26 (f24 ?v_0 ?v1)) ?v2) (f24 ?v_0 (f24 (f25 f26 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f7 ?v0))) (= (f4 (f5 f23 ?v_0) ?v_0) (f4 (f5 f23 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f32 f37 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v0))) (= (f4 ?v_0 (f4 (f5 f23 ?v1) ?v2)) (f4 (f5 f23 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2)) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f25 f26 ?v0))) (= (f24 ?v_0 (f24 (f25 f26 ?v1) ?v2)) (f24 (f25 f26 (f24 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f5 f23 ?v0)) (?v_0 (f5 f23 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f13 f14 ?v0)) (?v_0 (f13 f14 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_1 (f25 f26 ?v0)) (?v_0 (f25 f26 ?v1))) (= (f24 ?v_1 (f24 ?v_0 ?v2)) (f24 ?v_0 (f24 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f23 ?v0) ?v1) (f4 (f5 f23 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f12 (f13 f14 ?v0) ?v1) (f12 (f13 f14 ?v1) ?v0))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f24 (f25 f26 ?v0) ?v1) (f24 (f25 f26 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f7 (f4 (f5 f23 ?v0) ?v1)) (f4 (f5 f23 (f4 f7 ?v0)) (f4 f7 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f32 f37 (* ?v0 ?v1)) (* (f32 f37 ?v0) (f32 f37 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f13 f21 ?v0))) (= (f12 (f13 f21 (f12 ?v_0 ?v1)) (f12 (f13 f21 ?v2) ?v3)) (f12 (f13 f21 (f12 ?v_0 ?v2)) (f12 (f13 f21 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 (f5 f6 ?v2) ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v2)) (f4 (f5 f6 ?v1) ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f25 f27 ?v0))) (= (f24 (f25 f27 (f24 ?v_0 ?v1)) (f24 (f25 f27 ?v2) ?v3)) (f24 (f25 f27 (f24 ?v_0 ?v2)) (f24 (f25 f27 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f21 ?v0))) (= (f12 (f13 f21 (f12 ?v_0 ?v1)) ?v2) (f12 (f13 f21 (f12 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 (f5 f6 (f4 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f25 f27 ?v0))) (= (f24 (f25 f27 (f24 ?v_0 ?v1)) ?v2) (f24 (f25 f27 (f24 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f21 ?v0))) (= (f12 (f13 f21 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f21 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f25 f27 ?v0))) (= (f24 (f25 f27 (f24 ?v_0 ?v1)) ?v2) (f24 ?v_0 (f24 (f25 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f13 f21 ?v0))) (= (f12 ?v_0 (f12 (f13 f21 ?v1) ?v2)) (f12 (f13 f21 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f25 f27 ?v0))) (= (f24 ?v_0 (f24 (f25 f27 ?v1) ?v2)) (f24 (f25 f27 (f24 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f13 f21 ?v0)) (?v_0 (f13 f21 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f5 f6 ?v0)) (?v_0 (f5 f6 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_1 (f25 f27 ?v0)) (?v_0 (f25 f27 ?v1))) (= (f24 ?v_1 (f24 ?v_0 ?v2)) (f24 ?v_0 (f24 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f12 (f13 f21 ?v0) ?v1) (f12 (f13 f21 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f24 (f25 f27 ?v0) ?v1) (f24 (f25 f27 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (f3 ?v0 ?v0) f1)))
(assert (forall ((?v0 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f4 f7 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f22 ?v0))) (= (f4 f7 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (or (and (= (f3 f29 ?v0) f1) (= (f3 ?v1 f29) f1)) (and (= (f3 ?v0 f29) f1) (= (f3 f29 ?v1) f1))) (= (f3 (f4 (f5 f23 ?v0) ?v1) f29) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (or (= (f3 f29 ?v0) f1) (= (f3 ?v0 f29) f1)) (or (= (f3 f29 ?v1) f1) (= (f3 ?v1 f29) f1))) (= (f4 f7 (f4 (f5 f23 ?v0) ?v1)) (f4 (f5 f23 (f4 f7 ?v0)) (f4 f7 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f32 f37 (* ?v0 ?v1)) (* (f32 f37 ?v0) (f32 f37 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (or (and (= (f3 f29 ?v0) f1) (= (f3 f29 ?v1) f1)) (and (= (f3 ?v0 f29) f1) (= (f3 ?v1 f29) f1))) (= (f3 f29 (f4 (f5 f23 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 ?v3) f1) (=> (= (f3 f29 ?v1) f1) (=> (= (f3 f29 ?v2) f1) (= (f3 (f4 (f5 f23 ?v0) ?v2) (f4 (f5 f23 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 ?v3) f1) (=> (= (f3 f29 ?v0) f1) (=> (= (f3 f29 ?v2) f1) (= (f3 (f4 (f5 f23 ?v0) ?v2) (f4 (f5 f23 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v2))) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 f29) f1) (= (f3 (f4 ?v_0 ?v1) (f4 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 f29) f1) (= (f3 (f4 (f5 f23 ?v1) ?v2) (f4 (f5 f23 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v2))) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 f29 ?v2) f1) (= (f3 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v2))) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 f29 ?v2) f1) (= (f3 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 f29 ?v2) f1) (= (f3 (f4 (f5 f23 ?v0) ?v2) (f4 (f5 f23 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 f29) f1) (=> (= (f3 ?v1 f29) f1) (= (f3 f29 (f4 (f5 f23 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 f29) f1) (=> (= (f3 f29 ?v1) f1) (= (f3 (f4 (f5 f23 ?v0) ?v1) f29) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f29 ?v0) f1) (=> (= (f3 ?v1 f29) f1) (= (f3 (f4 (f5 f23 ?v1) ?v0) f29) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f29 ?v0) f1) (=> (= (f3 ?v1 f29) f1) (= (f3 (f4 (f5 f23 ?v0) ?v1) f29) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f29 ?v0) f1) (=> (= (f3 f29 ?v1) f1) (= (f3 f29 (f4 (f5 f23 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f29 ?v0) f1) (= (f4 (f5 f23 (f4 f7 ?v1)) ?v0) (f4 f7 (f4 (f5 f23 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f32 f37 ?v1) ?v0) (f32 f37 (* ?v1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 (f5 f23 ?v0) ?v1) f29) f1) (or (and (= (f3 f29 ?v0) f1) (= (f3 ?v1 f29) f1)) (and (= (f3 ?v0 f29) f1) (= (f3 f29 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f29 (f4 (f5 f23 ?v0) ?v1)) f1) (or (and (= (f3 f29 ?v0) f1) (= (f3 f29 ?v1) f1)) (and (= (f3 ?v0 f29) f1) (= (f3 ?v1 f29) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S2)) (= (f3 f29 (f4 (f5 f23 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6) (?v4 S6)) (let ((?v_0 (f13 f14 ?v0))) (=> (not (= ?v0 f18)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f12 (f13 f21 ?v1) (f12 ?v_0 ?v3)) (f12 (f13 f21 ?v2) (f12 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f5 f23 ?v0))) (=> (not (= ?v0 f29)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f4 (f5 f6 ?v1) (f4 ?v_0 ?v3)) (f4 (f5 f6 ?v2) (f4 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (* ?v0 ?v3)) (+ ?v2 (* ?v0 ?v4))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S9)) (let ((?v_0 (f25 f26 ?v0))) (=> (not (= ?v0 f20)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f24 (f25 f27 ?v1) (f24 ?v_0 ?v3)) (f24 (f25 f27 ?v2) (f24 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f13 f14 ?v2))) (= (= (f12 (f13 f21 (f12 ?v_0 ?v1)) (f12 ?v_1 ?v3)) (f12 (f13 f21 (f12 ?v_0 ?v3)) (f12 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f23 ?v0)) (?v_1 (f5 f23 ?v2))) (= (= (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_1 ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v3)) (f4 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f25 f26 ?v2))) (= (= (f24 (f25 f27 (f24 ?v_0 ?v1)) (f24 ?v_1 ?v3)) (f24 (f25 f27 (f24 ?v_0 ?v3)) (f24 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (+ (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 ?v3) (* ?v2 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (= (f12 (f13 f21 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f21 (f12 (f13 f14 ?v2) ?v1)) ?v3)) (f12 (f13 f21 (f12 (f13 f14 (f12 (f13 f21 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f4 (f5 f6 (f4 (f5 f23 ?v0) ?v1)) (f4 (f5 f6 (f4 (f5 f23 ?v2) ?v1)) ?v3)) (f4 (f5 f6 (f4 (f5 f23 (f4 (f5 f6 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (= (f24 (f25 f27 (f24 (f25 f26 ?v0) ?v1)) (f24 (f25 f27 (f24 (f25 f26 ?v2) ?v1)) ?v3)) (f24 (f25 f27 (f24 (f25 f26 (f24 (f25 f27 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f12 (f13 f21 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 ?v2) ?v1)) (f12 (f13 f14 (f12 (f13 f21 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f23 ?v0) ?v1)) (f4 (f5 f23 ?v2) ?v1)) (f4 (f5 f23 (f4 (f5 f6 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f24 (f25 f27 (f24 (f25 f26 ?v0) ?v1)) (f24 (f25 f26 ?v2) ?v1)) (f24 (f25 f26 (f24 (f25 f27 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (* ?v0 ?v1) (* ?v2 ?v1)) (* (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f12 (f13 f14 (f12 (f13 f21 ?v0) ?v1)) ?v2) (f12 (f13 f21 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f23 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f23 ?v0) ?v2)) (f4 (f5 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f12 (f13 f14 (f12 (f13 f21 ?v0) ?v1)) ?v2) (f12 (f13 f21 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f23 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f23 ?v0) ?v2)) (f4 (f5 f23 ?v1) ?v2)))))
(assert (= f28 f20))
(assert (forall ((?v0 S6)) (exists ((?v1 S2)) (forall ((?v2 S6)) (= (f3 (f9 f10 (f12 (f13 f30 ?v2) ?v0)) (f4 (f5 f23 (f9 f10 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (= (f3 (f4 f22 (f4 (f5 f17 ?v2) ?v0)) (f4 (f5 f23 (f4 f22 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (= (f3 (f4 f22 (f4 (f5 f23 ?v2) ?v0)) (f4 (f5 f23 (f4 f22 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S6)) (exists ((?v1 S2)) (forall ((?v2 S6)) (= (f3 (f9 f10 (f12 (f13 f14 ?v2) ?v0)) (f4 (f5 f23 (f9 f10 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (= (f3 (f4 f22 (f4 (f5 f23 ?v0) ?v2)) (f4 (f5 f23 (f4 f22 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S6)) (exists ((?v1 S2)) (forall ((?v2 S6)) (= (f3 (f9 f10 (f12 (f13 f14 ?v0) ?v2)) (f4 (f5 f23 (f9 f10 ?v2)) ?v1)) f1)))))
(assert (exists ((?v0 S2)) (forall ((?v1 S2) (?v2 S2)) (= (f3 (f4 f22 (f4 (f5 f23 ?v1) ?v2)) (f4 (f5 f23 (f4 (f5 f23 (f4 f22 ?v1)) (f4 f22 ?v2))) ?v0)) f1))))
(assert (exists ((?v0 S2)) (forall ((?v1 S6) (?v2 S6)) (= (f3 (f9 f10 (f12 (f13 f14 ?v1) ?v2)) (f4 (f5 f23 (f4 (f5 f23 (f9 f10 ?v1)) (f9 f10 ?v2))) ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 f29) f1) (=> (= (f3 (f4 f22 ?v1) (f4 (f5 f23 ?v0) (f4 f22 ?v2))) f1) (= ?v1 f29)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (=> (= (f3 ?v0 f29) f1) (=> (= (f3 (f9 f10 ?v1) (f4 (f5 f23 ?v0) (f9 f10 ?v2))) f1) (= ?v1 f18)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (not (= ?v0 f18)) (=> (not (= ?v1 f18)) (= (f12 (f13 f21 (f12 (f13 f30 ?v2) ?v0)) (f12 (f13 f30 ?v3) ?v1)) (f12 (f13 f30 (f12 (f13 f21 (f12 (f13 f14 ?v2) ?v1)) (f12 (f13 f14 ?v3) ?v0))) (f12 (f13 f14 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (not (= ?v0 f29)) (=> (not (= ?v1 f29)) (= (f4 (f5 f6 (f4 (f5 f17 ?v2) ?v0)) (f4 (f5 f17 ?v3) ?v1)) (f4 (f5 f17 (f4 (f5 f6 (f4 (f5 f23 ?v2) ?v1)) (f4 (f5 f23 ?v3) ?v0))) (f4 (f5 f23 ?v0) ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f18)) (= (f12 (f13 f21 (f12 (f13 f30 ?v1) ?v0)) ?v2) (f12 (f13 f30 (f12 (f13 f21 ?v1) (f12 (f13 f14 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f29)) (= (f4 (f5 f6 (f4 (f5 f17 ?v1) ?v0)) ?v2) (f4 (f5 f17 (f4 (f5 f6 ?v1) (f4 (f5 f23 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f18)) (= (f12 (f13 f21 (f12 (f13 f30 ?v1) ?v0)) ?v2) (f12 (f13 f30 (f12 (f13 f21 ?v1) (f12 (f13 f14 ?v2) ?v0))) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f29)) (= (f4 (f5 f6 (f4 (f5 f17 ?v1) ?v0)) ?v2) (f4 (f5 f17 (f4 (f5 f6 ?v1) (f4 (f5 f23 ?v2) ?v0))) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f18)) (= (f12 (f13 f21 ?v1) (f12 (f13 f30 ?v2) ?v0)) (f12 (f13 f30 (f12 (f13 f21 (f12 (f13 f14 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f29)) (= (f4 (f5 f6 ?v1) (f4 (f5 f17 ?v2) ?v0)) (f4 (f5 f17 (f4 (f5 f6 (f4 (f5 f23 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f18)) (= (f12 (f13 f21 ?v1) (f12 (f13 f30 ?v2) ?v0)) (f12 (f13 f30 (f12 (f13 f21 ?v2) (f12 (f13 f14 ?v1) ?v0))) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f29)) (= (f4 (f5 f6 ?v1) (f4 (f5 f17 ?v2) ?v0)) (f4 (f5 f17 (f4 (f5 f6 ?v2) (f4 (f5 f23 ?v1) ?v0))) ?v0)))))
(assert (not (= (f24 (f38 f39 f16) f28) f20)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f23 ?v0))) (=> (not (= ?v0 f29)) (= (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2))))))
(check-sat)
(exit)
