(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S4)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S8) S4)
(declare-fun f10 (S9 S4) S7)
(declare-fun f11 () S9)
(declare-fun f12 (S10 Int) S8)
(declare-fun f13 () S10)
(declare-fun f14 (S11 S8) Int)
(declare-fun f15 () S11)
(declare-fun f16 () S8)
(declare-fun f17 () S4)
(declare-fun f18 () S4)
(declare-fun f19 (S12 Int) S11)
(declare-fun f20 () S12)
(declare-fun f21 (S13 S8) S14)
(declare-fun f22 () S13)
(declare-fun f23 (S14 S8) S8)
(declare-fun f24 () S13)
(declare-fun f25 () S2)
(declare-fun f26 () S8)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (not (exists ((?v0 S4) (?v1 S4)) (let ((?v_0 (f12 f13 (- (f14 f15 f16) (+ 0 1))))) (not (= (f6 (f7 f8 ?v0) (f9 (f10 f11 ?v0) ?v_0)) (f6 (f7 f8 ?v1) (f9 (f10 f11 ?v1) ?v_0))))))))
(assert (not (= f17 f18)))
(assert (not (= f16 (f12 f13 0))))
(assert (not (= f17 f18)))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f14 (f19 f20 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) ?v0) (f9 (f10 f11 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 S8)) (= (f23 (f21 f22 ?v0) ?v0) (f23 (f21 f24 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (* ?v0 (f14 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f6 (f7 f8 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f23 (f21 f22 ?v0) (f23 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (* ?v0 (f14 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f6 (f7 f8 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f23 (f21 f22 ?v0) (f23 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (* (f14 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f6 (f7 f8 (f9 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f23 (f21 f22 (f23 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f14 (f19 f20 ?v0) (f12 f13 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S4)) (= (f9 (f10 f11 ?v0) (f12 f13 2)) (f6 (f7 f8 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f23 (f21 f24 ?v0) (f12 f13 2)) (f23 (f21 f22 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f14 (f19 f20 ?v0) (f12 f13 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f9 (f10 f11 ?v0) (f12 f13 3)) (f6 (f7 f8 (f6 (f7 f8 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S8)) (= (f23 (f21 f24 ?v0) (f12 f13 3)) (f23 (f21 f22 (f23 (f21 f22 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (* ?v0 (f14 (f19 f20 (f14 ?v_0 ?v1)) (f12 f13 2)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (f6 (f7 f8 ?v0) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f12 f13 2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (f23 (f21 f22 ?v0) (f23 (f21 f24 (f23 ?v_0 ?v1)) (f12 f13 2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (let ((?v_1 (f14 ?v_0 ?v1))) (= (f14 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (f6 (f7 f8 ?v0) (f6 (f7 f8 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (let ((?v_1 (f23 ?v_0 ?v1))) (= (f23 ?v_0 (f12 f13 (+ (* 2 (f14 f15 ?v1)) 1))) (f23 (f21 f22 ?v0) (f23 (f21 f22 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (* ?v0 (f14 ?v_0 ?v1)) (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f6 (f7 f8 ?v0) (f9 ?v_0 ?v1)) (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 (f21 f22 ?v0) (f23 ?v_0 ?v1)) (f23 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) (f14 f15 ?v2)))) (* (f14 ?v_0 ?v1) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) (f14 f15 ?v2)))) (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 ?v_0 (f12 f13 (+ (f14 f15 ?v1) (f14 f15 ?v2)))) (f23 (f21 f22 (f23 ?v_0 ?v1)) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (let ((?v_1 (f14 ?v_0 ?v1))) (= (f14 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (f6 (f7 f8 ?v_1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (let ((?v_1 (f23 ?v_0 ?v1))) (= (f23 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (f23 (f21 f22 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (* (f14 ?v_0 ?v1) ?v0) (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f6 (f7 f8 (f9 ?v_0 ?v1)) ?v0) (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 (f21 f22 (f23 ?v_0 ?v1)) ?v0) (f23 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 ?v_0 ?v1) (ite (= ?v1 (f12 f13 0)) (f12 f13 1) (f12 f13 (* (f14 f15 ?v0) (f14 f15 (f23 ?v_0 (f12 f13 (- (f14 f15 ?v1) 1)))))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f12 f13 0)) (?v_2 (f14 f15 ?v0)) (?v_1 (f14 f15 ?v1))) (= (f12 f13 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f12 f13 (+ ?v_1 (* (f14 f15 (f12 f13 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f14 f15 ?v0))) (= (f12 f13 (* ?v_0 2)) (f12 f13 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f14 f15 ?v0))) (= (f12 f13 (* 2 ?v_0)) (f12 f13 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f14 (f19 f20 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f12 f13 (* (f14 f15 ?v1) (f14 f15 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f12 f13 (* (f14 f15 ?v1) (f14 f15 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 (f21 f24 (f23 ?v_0 ?v1)) ?v2) (f23 ?v_0 (f12 f13 (* (f14 f15 ?v1) (f14 f15 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f14 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (f14 (f19 f20 (f14 ?v_0 ?v1)) (f12 f13 2))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f12 f13 2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (f23 (f21 f24 (f23 ?v_0 ?v1)) (f12 f13 2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (f14 ?v_0 (f12 f13 (* (f14 f15 ?v1) (f14 f15 ?v2)))) (f14 (f19 f20 (f14 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (* (f14 f15 ?v1) (f14 f15 ?v2)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 ?v_0 (f12 f13 (* (f14 f15 ?v1) (f14 f15 ?v2)))) (f23 (f21 f24 (f23 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f23 (f21 f22 (f23 ?v_0 ?v1)) (f23 (f21 f22 ?v2) ?v3)) (f23 (f21 f22 (f23 ?v_0 ?v2)) (f23 (f21 f22 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 (f7 f8 ?v2) ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v2)) (f6 (f7 f8 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_1 (f21 f22 (f23 (f21 f22 ?v0) ?v1))) (?v_0 (f21 f22 ?v2))) (= (f23 ?v_1 (f23 ?v_0 ?v3)) (f23 ?v_0 (f23 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f7 f8 (f6 (f7 f8 ?v0) ?v1))) (?v_0 (f7 f8 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f21 f22 ?v0)) (?v_1 (f23 (f21 f22 ?v2) ?v3))) (= (f23 (f21 f22 (f23 ?v_0 ?v1)) ?v_1) (f23 ?v_0 (f23 (f21 f22 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f6 (f7 f8 ?v2) ?v3))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f23 (f21 f22 (f23 ?v_0 ?v1)) ?v2) (f23 (f21 f22 (f23 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f8 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f23 (f21 f22 (f23 ?v_0 ?v1)) ?v2) (f23 ?v_0 (f23 (f21 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f23 ?v_0 (f23 (f21 f22 ?v1) ?v2)) (f23 (f21 f22 (f23 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f21 f22 ?v0)) (?v_0 (f21 f22 ?v1))) (= (f23 ?v_1 (f23 ?v_0 ?v2)) (f23 ?v_0 (f23 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f23 (f21 f22 ?v0) ?v1) (f23 (f21 f22 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2))) (= (f14 (f19 f20 (f3 f25 ?v0)) ?v_0) (f14 (f19 f20 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f14 (f19 f20 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f11 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f23 (f21 f24 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f14 (f19 f20 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f11 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f23 (f21 f24 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 (f19 f20 ?v0) (f12 f13 2)))) (= (f3 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f25 (f14 (f19 f20 ?v0) ?v1)) (f14 (f19 f20 (f3 f25 ?v0)) ?v1))))
(assert (forall ((?v0 S8)) (= (f23 (f21 f22 ?v0) f26) f26)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f23 (f21 f22 f26) ?v0) f26)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 f18) ?v0) f18)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f14 (f19 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (not (= ?v0 f18)) (not (= (f9 (f10 f11 ?v0) ?v1) f18)))))
(assert (forall ((?v0 Int)) (= (= (f14 (f19 f20 ?v0) (f12 f13 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= (f9 (f10 f11 ?v0) (f12 f13 2)) f18) (= ?v0 f18))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f23 (f21 f24 ?v0) ?v1) f26) (and (= ?v0 f26) (not (= ?v1 (f12 f13 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f14 (f19 f20 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f12 f13 0)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (= (f9 (f10 f11 ?v0) ?v1) f18) (and (= ?v0 f18) (not (= ?v1 (f12 f13 0)))))))
(assert (= (f23 (f21 f24 f26) (f12 f13 2)) f26))
(assert (= (f14 (f19 f20 0) (f12 f13 2)) 0))
(assert (= (f9 (f10 f11 f18) (f12 f13 2)) f18))
(assert (forall ((?v0 S8)) (= (f23 (f21 f24 f26) (f12 f13 (+ (f14 f15 ?v0) 1))) f26)))
(assert (forall ((?v0 S8)) (= (f14 (f19 f20 0) (f12 f13 (+ (f14 f15 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f18) (f12 f13 (+ (f14 f15 ?v0) 1))) f18)))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f19 f20 ?v0))) (= (* (f14 ?v_0 ?v1) (f14 ?v_0 ?v2)) (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) (f14 f15 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) (f14 f15 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f24 ?v0))) (= (f23 (f21 f22 (f23 ?v_0 ?v1)) (f23 ?v_0 ?v2)) (f23 ?v_0 (f12 f13 (+ (f14 f15 ?v1) (f14 f15 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f14 (f19 f20 (* ?v0 ?v1)) ?v2) (* (f14 (f19 f20 ?v0) ?v2) (f14 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f9 (f10 f11 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f23 (f21 f24 (f23 (f21 f22 ?v0) ?v1)) ?v2) (f23 (f21 f22 (f23 (f21 f24 ?v0) ?v2)) (f23 (f21 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f14 (f19 f20 (* ?v0 ?v1)) ?v2) (* (f14 (f19 f20 ?v0) ?v2) (f14 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f9 (f10 f11 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f23 (f21 f24 (f23 (f21 f22 ?v0) ?v1)) ?v2) (f23 (f21 f22 (f23 (f21 f24 ?v0) ?v2)) (f23 (f21 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f14 (f19 f20 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (= (f6 (f7 f8 ?v_0) ?v0) (f6 (f7 f8 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 (f21 f24 ?v0) ?v1))) (= (f23 (f21 f22 ?v_0) ?v0) (f23 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f14 f15 ?v1)) (?v_1 (f14 f15 ?v0)) (?v_2 (f19 f20 ?v2))) (=> (<= ?v_1 ?v_0) (= (f14 ?v_2 (f12 f13 (- (+ ?v_0 1) ?v_1))) (* (f14 ?v_2 (f12 f13 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f14 f15 ?v1)) (?v_1 (f14 f15 ?v0)) (?v_2 (f10 f11 ?v2))) (=> (<= ?v_1 ?v_0) (= (f9 ?v_2 (f12 f13 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f8 (f9 ?v_2 (f12 f13 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f14 f15 ?v1)) (?v_1 (f14 f15 ?v0)) (?v_2 (f21 f24 ?v2))) (=> (<= ?v_1 ?v_0) (= (f23 ?v_2 (f12 f13 (- (+ ?v_0 1) ?v_1))) (f23 (f21 f22 (f23 ?v_2 (f12 f13 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f19 f20 ?v1))) (=> (< 0 ?v_0) (= (* (f14 ?v_1 (f12 f13 (- ?v_0 1))) ?v1) (f14 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S4)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f10 f11 ?v1))) (=> (< 0 ?v_0) (= (f6 (f7 f8 (f9 ?v_1 (f12 f13 (- ?v_0 1)))) ?v1) (f9 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f21 f24 ?v1))) (=> (< 0 ?v_0) (= (f23 (f21 f22 (f23 ?v_1 (f12 f13 (- ?v_0 1)))) ?v1) (f23 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f23 (f21 f22 ?v0) ?v1) f26) (or (= ?v0 f26) (= ?v1 f26)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 (f7 f8 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f26)) (=> (not (= ?v1 f26)) (not (= (f23 (f21 f22 ?v0) ?v1) f26))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f18)) (=> (not (= ?v1 f18)) (not (= (f6 (f7 f8 ?v0) ?v1) f18))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 (f7 f8 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) f18) f18)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f23 (f21 f22 ?v0) f26) f26)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) f18) f18)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 f18) ?v0) f18)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f23 (f21 f22 f26) ?v0) f26)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 f18) ?v0) f18)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (< 0 (f14 f15 (f23 (f21 f24 ?v0) ?v1))) (or (< 0 (f14 f15 ?v0)) (= ?v1 (f12 f13 0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f12 f13 (+ 0 1)))) (= (f23 (f21 f24 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f12 f13 (+ 0 1)))) (= (= (f23 (f21 f24 ?v0) ?v1) ?v_0) (or (= ?v1 (f12 f13 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f24 ?v0))) (=> (< 0 (f14 f15 ?v0)) (=> (< (f14 f15 (f23 ?v_0 ?v1)) (f14 f15 (f23 ?v_0 ?v2))) (< (f14 f15 ?v1) (f14 f15 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f14 f15 ?v0)) (<= ?v_0 (f14 f15 (f23 (f21 f24 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f25 (* ?v0 ?v1)) (* (f3 f25 ?v0) (f3 f25 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f25 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S8)) (= (f12 f13 (f14 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f15 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
