(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () S1)
(declare-fun f7 (S5 S4) S4)
(declare-fun f8 (S6 S4) S5)
(declare-fun f9 () S6)
(declare-fun f10 () S4)
(declare-fun f11 () S6)
(declare-fun f12 (S7 S8) S4)
(declare-fun f13 (S9 S4) S7)
(declare-fun f14 () S9)
(declare-fun f15 () S8)
(declare-fun f16 () S4)
(declare-fun f17 () S4)
(declare-fun f18 (S10 Int) S8)
(declare-fun f19 () S10)
(declare-fun f20 (S11 S8) Int)
(declare-fun f21 () S11)
(declare-fun f22 (S12 S8) S8)
(declare-fun f23 (S13 S8) S12)
(declare-fun f24 () S13)
(declare-fun f25 () S8)
(declare-fun f26 () S13)
(declare-fun f27 (S14 Int) S11)
(declare-fun f28 () S14)
(declare-fun f29 () S8)
(declare-fun f30 () S13)
(declare-fun f31 () S2)
(declare-fun f32 (S15 S13) S13)
(declare-fun f33 (S16 S8) S15)
(declare-fun f34 () S16)
(declare-fun f35 (S17 S6) S9)
(declare-fun f36 (S18 S4) S17)
(declare-fun f37 () S18)
(declare-fun f38 (S19 S3) S14)
(declare-fun f39 (S20 Int) S19)
(declare-fun f40 () S20)
(declare-fun f41 () S3)
(declare-fun f42 () S3)
(declare-fun f43 () S5)
(declare-fun f44 (S8 S8) S1)
(declare-fun f45 (S8 S8) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (not (= f6 f1)))
(assert (forall ((?v0 S4)) (=> (= (f7 (f8 f9 f10) (f7 (f8 f11 (f12 (f13 f14 ?v0) f15)) f16)) f17) (= f6 f1))))
(assert (exists ((?v0 S4)) (= (f7 (f8 f9 f10) (f7 (f8 f11 ?v0) (f7 (f8 f11 f16) (f12 (f13 f14 ?v0) (f18 f19 (- (f20 f21 f15) 1)))))) f17)))
(assert (not (= f15 (f18 f19 0))))
(assert (not (= f15 (f18 f19 0))))
(assert (not (= f16 f17)))
(assert (exists ((?v0 S4)) (= (f7 (f8 f9 f10) (f7 (f8 f11 ?v0) (f7 (f8 f11 f16) (f12 (f13 f14 ?v0) (f18 f19 (- (f20 f21 f15) 1)))))) f17)))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f18 f19 0)) f25 (f22 (f23 f26 ?v0) (f22 ?v_0 (f18 f19 (- (f20 f21 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 ?v1) (ite (= ?v1 (f18 f19 0)) f10 (f7 (f8 f11 ?v0) (f12 ?v_0 (f18 f19 (- (f20 f21 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f20 ?v_0 ?v1) (ite (= ?v1 (f18 f19 0)) 1 (* ?v0 (f20 ?v_0 (f18 f19 (- (f20 f21 ?v1) 1)))))))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 f29) ?v0) (ite (= ?v0 (f18 f19 0)) f25 f29))))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f17) ?v0) (ite (= ?v0 (f18 f19 0)) f10 f17))))
(assert (forall ((?v0 S8)) (= (f20 (f27 f28 0) ?v0) (ite (= ?v0 (f18 f19 0)) 1 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (= (= (+ (f20 (f27 f28 ?v0) ?v_0) (f20 (f27 f28 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f30 ?v0) ?v0) (f22 (f23 f26 (f22 (f23 f30 f25) f25)) ?v0))))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 ?v0) ?v0) (f7 (f8 f11 (f7 (f8 f9 f10) f10)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (* (+ 1 1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f22 (f23 f30 ?v0) (f22 (f23 f26 ?v1) ?v0)) (f22 (f23 f26 (f22 (f23 f30 ?v1) f25)) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f7 (f8 f9 ?v0) (f7 (f8 f11 ?v1) ?v0)) (f7 (f8 f11 (f7 (f8 f9 ?v1) f10)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (* ?v1 ?v0)) (* (+ ?v1 1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f22 (f23 f30 (f22 (f23 f26 ?v0) ?v1)) ?v1) (f22 (f23 f26 (f22 (f23 f30 ?v0) f25)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f7 (f8 f9 (f7 (f8 f11 ?v0) ?v1)) ?v1) (f7 (f8 f11 (f7 (f8 f9 ?v0) f10)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (* ?v0 ?v1) ?v1) (* (+ ?v0 1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8) (?v4 S8)) (let ((?v_0 (f23 f26 ?v0))) (=> (not (= ?v0 f29)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f22 (f23 f30 ?v1) (f22 ?v_0 ?v3)) (f22 (f23 f30 ?v2) (f22 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f8 f11 ?v0))) (=> (not (= ?v0 f17)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f7 (f8 f9 ?v1) (f7 ?v_0 ?v3)) (f7 (f8 f9 ?v2) (f7 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (* ?v0 ?v3)) (+ ?v2 (* ?v0 ?v4))))))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 f25) ?v0) f25)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f10) ?v0) f10)))
(assert (forall ((?v0 S8)) (= (f20 (f27 f28 1) ?v0) 1)))
(assert (= (f22 (f23 f24 f25) (f18 f19 2)) f25))
(assert (= (f12 (f13 f14 f10) (f18 f19 2)) f10))
(assert (= (f20 (f27 f28 1) (f18 f19 2)) 1))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 ?v0) (f18 f19 0)) f25)))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f18 f19 0)) f10)))
(assert (forall ((?v0 Int)) (= (f20 (f27 f28 ?v0) (f18 f19 0)) 1)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 ?v0) (f18 f19 0)) f25)))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f18 f19 0)) f10)))
(assert (forall ((?v0 Int)) (= (f20 (f27 f28 ?v0) (f18 f19 0)) 1)))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f18 f19 (* (f20 f21 ?v1) (f20 f21 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f18 f19 (* (f20 f21 ?v1) (f20 f21 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f20 (f27 f28 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f18 f19 (* (f20 f21 ?v1) (f20 f21 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f18 f19 (* 2 (f20 f21 ?v1)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f18 f19 2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f18 f19 (* 2 (f20 f21 ?v1)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f18 f19 2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f20 ?v_0 (f18 f19 (* 2 (f20 f21 ?v1)))) (f20 (f27 f28 (f20 ?v_0 ?v1)) (f18 f19 2))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f18 f19 (* (f20 f21 ?v1) (f20 f21 ?v2)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f18 f19 (* (f20 f21 ?v1) (f20 f21 ?v2)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f20 ?v_0 (f18 f19 (* (f20 f21 ?v1) (f20 f21 ?v2)))) (f20 (f27 f28 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f23 f26 ?v0))) (= (f22 (f23 f26 (f22 ?v_0 ?v1)) (f22 (f23 f26 ?v2) ?v3)) (f22 (f23 f26 (f22 ?v_0 ?v2)) (f22 (f23 f26 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f8 f11 ?v0))) (= (f7 (f8 f11 (f7 ?v_0 ?v1)) (f7 (f8 f11 ?v2) ?v3)) (f7 (f8 f11 (f7 ?v_0 ?v2)) (f7 (f8 f11 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_1 (f23 f26 (f22 (f23 f26 ?v0) ?v1))) (?v_0 (f23 f26 ?v2))) (= (f22 ?v_1 (f22 ?v_0 ?v3)) (f22 ?v_0 (f22 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f8 f11 (f7 (f8 f11 ?v0) ?v1))) (?v_0 (f8 f11 ?v2))) (= (f7 ?v_1 (f7 ?v_0 ?v3)) (f7 ?v_0 (f7 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f23 f26 ?v0)) (?v_1 (f22 (f23 f26 ?v2) ?v3))) (= (f22 (f23 f26 (f22 ?v_0 ?v1)) ?v_1) (f22 ?v_0 (f22 (f23 f26 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f8 f11 ?v0)) (?v_1 (f7 (f8 f11 ?v2) ?v3))) (= (f7 (f8 f11 (f7 ?v_0 ?v1)) ?v_1) (f7 ?v_0 (f7 (f8 f11 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f26 ?v0))) (= (f22 (f23 f26 (f22 ?v_0 ?v1)) ?v2) (f22 (f23 f26 (f22 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f11 ?v0))) (= (f7 (f8 f11 (f7 ?v_0 ?v1)) ?v2) (f7 (f8 f11 (f7 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f26 ?v0))) (= (f22 (f23 f26 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f23 f26 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f11 ?v0))) (= (f7 (f8 f11 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f11 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f26 ?v0))) (= (f22 ?v_0 (f22 (f23 f26 ?v1) ?v2)) (f22 (f23 f26 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f11 ?v0))) (= (f7 ?v_0 (f7 (f8 f11 ?v1) ?v2)) (f7 (f8 f11 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f23 f26 ?v0)) (?v_0 (f23 f26 ?v1))) (= (f22 ?v_1 (f22 ?v_0 ?v2)) (f22 ?v_0 (f22 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f8 f11 ?v0)) (?v_0 (f8 f11 ?v1))) (= (f7 ?v_1 (f7 ?v_0 ?v2)) (f7 ?v_0 (f7 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f22 (f23 f26 ?v0) ?v1) (f22 (f23 f26 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f7 (f8 f11 ?v0) ?v1) (f7 (f8 f11 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 (f8 f9 ?v2) ?v3)) (f7 (f8 f9 (f7 ?v_0 ?v2)) (f7 (f8 f9 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 (f8 f9 (f7 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f7 ?v_1 (f7 ?v_0 ?v2)) (f7 ?v_0 (f7 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f19 2))) (= (f20 (f27 f28 (f3 f31 ?v0)) ?v_0) (f20 (f27 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f20 (f27 f28 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f20 (f27 f28 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 (f27 f28 ?v0) (f18 f19 2)))) (= (f3 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f31 (f20 (f27 f28 ?v0) ?v1)) (f20 (f27 f28 (f3 f31 ?v0)) ?v1))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 ?v0) f29) f29)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) f17) f17)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 f29) ?v0) f29)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 f17) ?v0) f17)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= ?v0 (f22 (f23 f30 ?v0) ?v1)) (= ?v1 f29))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 (f7 (f8 f9 ?v0) ?v1)) (= ?v1 f17))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f30 ?v0) f29) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 ?v0) f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f30 f29) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 f17) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f23 f26 ?v0)) (?v_1 (f23 f26 ?v2))) (= (= (f22 (f23 f30 (f22 ?v_0 ?v1)) (f22 ?v_1 ?v3)) (f22 (f23 f30 (f22 ?v_0 ?v3)) (f22 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f8 f11 ?v0)) (?v_1 (f8 f11 ?v2))) (= (= (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 ?v_1 ?v3)) (f7 (f8 f9 (f7 ?v_0 ?v3)) (f7 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (+ (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 ?v3) (* ?v2 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f22 (f23 f30 (f22 (f23 f26 ?v0) ?v1)) (f22 (f23 f26 ?v2) ?v1)) (f22 (f23 f26 (f22 (f23 f30 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f7 (f8 f9 (f7 (f8 f11 ?v0) ?v1)) (f7 (f8 f11 ?v2) ?v1)) (f7 (f8 f11 (f7 (f8 f9 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (* ?v0 ?v1) (* ?v2 ?v1)) (* (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f22 (f23 f26 (f22 (f23 f30 ?v0) ?v1)) ?v2) (f22 (f23 f30 (f22 (f23 f26 ?v0) ?v2)) (f22 (f23 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f7 (f8 f11 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f7 (f8 f11 ?v0) ?v2)) (f7 (f8 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f23 f26 ?v0)) (?v_1 (f23 f26 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f22 (f23 f30 (f22 ?v_0 ?v2)) (f22 ?v_1 ?v3)) (f22 (f23 f30 (f22 ?v_0 ?v3)) (f22 ?v_1 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f8 f11 ?v0)) (?v_1 (f8 f11 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f7 (f8 f9 (f7 ?v_0 ?v2)) (f7 ?v_1 ?v3)) (f7 (f8 f9 (f7 ?v_0 ?v3)) (f7 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (* ?v0 ?v2) (* ?v1 ?v3)) (+ (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f26 ?v0))) (= (f22 ?v_0 (f22 (f23 f30 ?v1) ?v2)) (f22 (f23 f30 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f11 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (+ ?v1 ?v2)) (+ (* ?v0 ?v1) (* ?v0 ?v2)))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 ?v0) f25) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) f10) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 f25) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 f10) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (not (= ?v0 f17)) (not (= (f12 (f13 f14 ?v0) ?v1) f17)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f20 (f27 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4)) (= (= (f12 (f13 f14 ?v0) (f18 f19 2)) f17) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= (f20 (f27 f28 ?v0) (f18 f19 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f22 (f23 f24 ?v0) ?v1) f29) (and (= ?v0 f29) (not (= ?v1 (f18 f19 0)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (= (f12 (f13 f14 ?v0) ?v1) f17) (and (= ?v0 f17) (not (= ?v1 (f18 f19 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f20 (f27 f28 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f18 f19 0)))))))
(assert (= (f22 (f23 f24 f29) (f18 f19 2)) f29))
(assert (= (f12 (f13 f14 f17) (f18 f19 2)) f17))
(assert (= (f20 (f27 f28 0) (f18 f19 2)) 0))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 f29) (f18 f19 (+ (f20 f21 ?v0) 1))) f29)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f17) (f18 f19 (+ (f20 f21 ?v0) 1))) f17)))
(assert (forall ((?v0 S8)) (= (f20 (f27 f28 0) (f18 f19 (+ (f20 f21 ?v0) 1))) 0)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f20 f21 ?v0)) (?v_2 (f13 f14 ?v2))) (=> (<= ?v_1 ?v_0) (= (f12 ?v_2 (f18 f19 (- (+ ?v_0 1) ?v_1))) (f7 (f8 f11 (f12 ?v_2 (f18 f19 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f20 f21 ?v0)) (?v_2 (f23 f24 ?v2))) (=> (<= ?v_1 ?v_0) (= (f22 ?v_2 (f18 f19 (- (+ ?v_0 1) ?v_1))) (f22 (f23 f26 (f22 ?v_2 (f18 f19 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f20 f21 ?v0)) (?v_2 (f27 f28 ?v2))) (=> (<= ?v_1 ?v_0) (= (f20 ?v_2 (f18 f19 (- (+ ?v_0 1) ?v_1))) (* (f20 ?v_2 (f18 f19 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f7 (f8 f11 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) (f12 ?v_0 (f18 f19 (+ (f20 f21 ?v1) (f20 f21 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f26 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2)) (f22 ?v_0 (f18 f19 (+ (f20 f21 ?v1) (f20 f21 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (* (f20 ?v_0 ?v1) (f20 ?v_0 ?v2)) (f20 ?v_0 (f18 f19 (+ (f20 f21 ?v1) (f20 f21 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f12 (f13 f14 (f7 (f8 f11 ?v0) ?v1)) ?v2) (f7 (f8 f11 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f22 (f23 f24 (f22 (f23 f26 ?v0) ?v1)) ?v2) (f22 (f23 f26 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f20 (f27 f28 (* ?v0 ?v1)) ?v2) (* (f20 (f27 f28 ?v0) ?v2) (f20 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f12 (f13 f14 (f7 (f8 f11 ?v0) ?v1)) ?v2) (f7 (f8 f11 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f22 (f23 f24 (f22 (f23 f26 ?v0) ?v1)) ?v2) (f22 (f23 f26 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f20 (f27 f28 (* ?v0 ?v1)) ?v2) (* (f20 (f27 f28 ?v0) ?v2) (f20 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f7 (f8 f11 ?v_0) ?v0) (f7 (f8 f11 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f22 (f23 f24 ?v0) ?v1))) (= (f22 (f23 f26 ?v_0) ?v0) (f22 (f23 f26 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f20 (f27 f28 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f7 (f8 f11 (f12 ?v_0 ?v1)) ?v0) (f12 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f26 (f22 ?v_0 ?v1)) ?v0) (f22 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (* (f20 ?v_0 ?v1) ?v0) (f20 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f18 f19 (* 2 (f20 f21 ?v1)))) (f7 (f8 f11 ?v_1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f18 f19 (* 2 (f20 f21 ?v1)))) (f22 (f23 f26 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f20 ?v_0 ?v1))) (= (f20 ?v_0 (f18 f19 (* 2 (f20 f21 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f18 f19 (+ (f20 f21 ?v1) (f20 f21 ?v2)))) (f7 (f8 f11 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f18 f19 (+ (f20 f21 ?v1) (f20 f21 ?v2)))) (f22 (f23 f26 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f20 ?v_0 (f18 f19 (+ (f20 f21 ?v1) (f20 f21 ?v2)))) (* (f20 ?v_0 ?v1) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f7 (f8 f11 ?v0) (f12 ?v_0 ?v1)) (f12 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f26 ?v0) (f22 ?v_0 ?v1)) (f22 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (* ?v0 (f20 ?v_0 ?v1)) (f20 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f18 f19 (+ (* 2 (f20 f21 ?v1)) 1))) (f7 (f8 f11 ?v0) (f7 (f8 f11 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f18 f19 (+ (* 2 (f20 f21 ?v1)) 1))) (f22 (f23 f26 ?v0) (f22 (f23 f26 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f20 ?v_0 ?v1))) (= (f20 ?v_0 (f18 f19 (+ (* 2 (f20 f21 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f18 f19 (+ (* 2 (f20 f21 ?v1)) 1))) (f7 (f8 f11 ?v0) (f12 (f13 f14 (f12 ?v_0 ?v1)) (f18 f19 2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f18 f19 (+ (* 2 (f20 f21 ?v1)) 1))) (f22 (f23 f26 ?v0) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f18 f19 2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f20 ?v_0 (f18 f19 (+ (* 2 (f20 f21 ?v1)) 1))) (* ?v0 (f20 (f27 f28 (f20 ?v_0 ?v1)) (f18 f19 2)))))))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f18 f19 3)) (f7 (f8 f11 (f7 (f8 f11 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 ?v0) (f18 f19 3)) (f22 (f23 f26 (f22 (f23 f26 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f20 (f27 f28 ?v0) (f18 f19 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f18 f19 2)) (f7 (f8 f11 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 ?v0) (f18 f19 2)) (f22 (f23 f26 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f20 (f27 f28 ?v0) (f18 f19 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1))) (f7 (f8 f11 (f12 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1))) (f22 (f23 f26 (f22 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f20 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1))) (* (f20 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1))) (f7 (f8 f11 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1))) (f22 (f23 f26 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f20 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1))) (* ?v0 (f20 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1))) (f7 (f8 f11 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1))) (f22 (f23 f26 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f20 ?v_0 (f18 f19 (+ (f20 f21 ?v1) 1))) (* ?v0 (f20 ?v_0 ?v1))))))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) ?v0) (f12 (f13 f14 ?v0) (f18 f19 2)))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 ?v0) ?v0) (f22 (f23 f24 ?v0) (f18 f19 2)))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f20 (f27 f28 ?v0) (f18 f19 2)))))
(assert (= f24 (f32 (f33 f34 f25) f26)))
(assert (= f14 (f35 (f36 f37 f10) f11)))
(assert (= f28 (f38 (f39 f40 1) f5)))
(assert (forall ((?v0 S8) (?v1 S4)) (let ((?v_0 (f20 f21 ?v0)) (?v_1 (f13 f14 ?v1))) (=> (< 0 ?v_0) (= (f7 (f8 f11 (f12 ?v_1 (f18 f19 (- ?v_0 1)))) ?v1) (f12 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f20 f21 ?v0)) (?v_1 (f23 f24 ?v1))) (=> (< 0 ?v_0) (= (f22 (f23 f26 (f22 ?v_1 (f18 f19 (- ?v_0 1)))) ?v1) (f22 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f20 f21 ?v0)) (?v_1 (f27 f28 ?v1))) (=> (< 0 ?v_0) (= (* (f20 ?v_1 (f18 f19 (- ?v_0 1))) ?v1) (f20 ?v_1 ?v0))))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 ?v0) f25) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) f10) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 ?v0) f25) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) f10) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 f25) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 f10) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 f25) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 f10) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f22 (f23 f30 (f22 (f23 f26 ?v0) ?v1)) (f22 (f23 f30 (f22 (f23 f26 ?v2) ?v1)) ?v3)) (f22 (f23 f30 (f22 (f23 f26 (f22 (f23 f30 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f7 (f8 f9 (f7 (f8 f11 ?v0) ?v1)) (f7 (f8 f9 (f7 (f8 f11 ?v2) ?v1)) ?v3)) (f7 (f8 f9 (f7 (f8 f11 (f7 (f8 f9 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f7 (f8 f11 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f7 (f8 f11 ?v0) ?v2)) (f7 (f8 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f7 (f8 f11 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f7 (f8 f11 ?v0) ?v2)) (f7 (f8 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f22 (f23 f26 (f22 (f23 f30 ?v0) ?v1)) ?v2) (f22 (f23 f30 (f22 (f23 f26 ?v0) ?v2)) (f22 (f23 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f7 (f8 f11 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f7 (f8 f11 ?v0) ?v2)) (f7 (f8 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f18 f19 0)) (f18 f19 1) (f18 f19 (* (f20 f21 ?v0) (f20 f21 (f22 ?v_0 (f18 f19 (- (f20 f21 ?v1) 1)))))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f18 f19 0)) (?v_2 (f20 f21 ?v0)) (?v_1 (f20 f21 ?v1))) (= (f18 f19 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f18 f19 (+ ?v_1 (* (f20 f21 (f18 f19 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f20 f21 ?v0))) (= (f18 f19 (* ?v_0 2)) (f18 f19 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f20 f21 ?v0))) (= (f18 f19 (* 2 ?v_0)) (f18 f19 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S8)) (let ((?v_0 (f27 (f38 (f39 f40 ?v0) ?v1) ?v2))) (= (f20 ?v_0 (f18 f19 (+ (f20 f21 ?v3) 1))) (f3 (f4 ?v1 ?v2) (f20 ?v_0 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S6) (?v2 S4) (?v3 S8)) (let ((?v_0 (f13 (f35 (f36 f37 ?v0) ?v1) ?v2))) (= (f12 ?v_0 (f18 f19 (+ (f20 f21 ?v3) 1))) (f7 (f8 ?v1 ?v2) (f12 ?v_0 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S13) (?v2 S8) (?v3 S8)) (let ((?v_0 (f23 (f32 (f33 f34 ?v0) ?v1) ?v2))) (= (f22 ?v_0 (f18 f19 (+ (f20 f21 ?v3) 1))) (f22 (f23 ?v1 ?v2) (f22 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (= (f20 (f27 (f38 (f39 f40 ?v0) ?v1) ?v2) (f18 f19 0)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S6) (?v2 S4)) (= (f12 (f13 (f35 (f36 f37 ?v0) ?v1) ?v2) (f18 f19 0)) ?v0)))
(assert (forall ((?v0 S8) (?v1 S13) (?v2 S8)) (= (f22 (f23 (f32 (f33 f34 ?v0) ?v1) ?v2) (f18 f19 0)) ?v0)))
(assert (= (f3 f31 0) 0))
(assert (forall ((?v0 S8)) (= (= f29 ?v0) (= ?v0 f29))))
(assert (forall ((?v0 S4)) (= (= f17 ?v0) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f3 f31 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f31 (* ?v0 ?v1)) (* (f3 f31 ?v0) (f3 f31 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f31 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f26 ?v0))) (= (f22 (f23 f26 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f23 f26 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f11 ?v0))) (= (f7 (f8 f11 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f11 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f3 f31 ?v0) (f3 f31 ?v1)))) (= (f3 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f41 ?v0) ?v1) ?v2) (f3 (f4 f41 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f42 ?v0) ?v1) ?v2) (f3 (f4 f42 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (= (f3 f31 1) 1))
(assert (forall ((?v0 S8)) (= (= f25 ?v0) (= ?v0 f25))))
(assert (forall ((?v0 S4)) (= (= f10 ?v0) (= ?v0 f10))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 f29) ?v0) f29)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 f17) ?v0) f17)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 f17) ?v0) f17)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 f17) ?v0) f17)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f26 ?v0) f29) f29)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) f17) f17)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) f17) f17)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) f17) f17)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f7 (f8 f11 ?v0) ?v1) f17) (or (= ?v0 f17) (= ?v1 f17)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f29)) (=> (not (= ?v1 f29)) (not (= (f22 (f23 f26 ?v0) ?v1) f29))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f17)) (=> (not (= ?v1 f17)) (not (= (f7 (f8 f11 ?v0) ?v1) f17))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f22 (f23 f26 ?v0) ?v1) f29) (or (= ?v0 f29) (= ?v1 f29)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f7 (f8 f11 ?v0) ?v1) f17) (or (= ?v0 f17) (= ?v1 f17)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f30 f29) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 f17) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f30 f29) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 f17) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f30 ?v0) f29) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 ?v0) f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f30 ?v0) f29) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 ?v0) f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (not (= f25 f29)))
(assert (not (= f10 f17)))
(assert (not (= 1 0)))
(assert (not (= f29 f25)))
(assert (not (= f17 f10)))
(assert (not (= 0 1)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f11 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f11 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 (f7 f43 ?v0)) (f18 f19 2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (<= (+ (* ?v3 ?v0) (* ?v4 ?v2)) ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f22 (f23 f24 ?v0) ?v1))) (=> (= (f44 f29 ?v0) f1) (=> (= (f44 ?v0 f25) f1) (= (f44 (f22 (f23 f26 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f20 (f27 f28 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f20 f21 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f20 f21 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f45 ?v2 ?v3) f1) (= (f44 (f22 (f23 f30 ?v0) ?v2) (f22 (f23 f30 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f45 ?v0 ?v1) f1) (=> (= (f44 ?v2 ?v3) f1) (= (f44 (f22 (f23 f30 ?v0) ?v2) (f22 (f23 f30 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f31 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f31 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (<= (* ?v0 ?v1) (* ?v0 ?v2)) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f44 ?v2 ?v3) f1) (=> (= (f44 f29 ?v1) f1) (=> (= (f45 f29 ?v2) f1) (= (f44 (f22 (f23 f26 ?v0) ?v2) (f22 (f23 f26 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f44 ?v2 ?v3) f1) (=> (= (f45 f29 ?v0) f1) (=> (= (f45 f29 ?v2) f1) (= (f44 (f22 (f23 f26 ?v0) ?v2) (f22 (f23 f26 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f45 ?v2 ?v3) f1) (=> (= (f45 f29 ?v0) f1) (=> (= (f44 f29 ?v2) f1) (= (f44 (f22 (f23 f26 ?v0) ?v2) (f22 (f23 f26 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f45 ?v0 ?v1) f1) (=> (= (f44 ?v2 ?v3) f1) (=> (= (f44 f29 ?v0) f1) (=> (= (f45 f29 ?v2) f1) (= (f44 (f22 (f23 f26 ?v0) ?v2) (f22 (f23 f26 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f44 (f22 (f23 f26 ?v0) ?v1) (f22 (f23 f26 ?v2) ?v1)) f1) (=> (= (f45 f29 ?v1) f1) (= (f44 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f44 (f22 (f23 f26 ?v0) ?v1) (f22 (f23 f26 ?v2) ?v1)) f1) (=> (= (f45 f29 ?v1) f1) (= (f44 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v2 ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f26 ?v0))) (=> (= (f44 (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) f1) (=> (= (f45 f29 ?v0) f1) (= (f44 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f26 ?v0))) (=> (= (f44 (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) f1) (=> (= (f45 f29 ?v0) f1) (= (f44 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (* ?v0 ?v1) (* ?v0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f45 (f22 (f23 f26 ?v0) ?v1) (f22 (f23 f26 ?v2) ?v1)) f1) (=> (= (f44 f29 ?v1) f1) (= (f45 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v2 ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f26 ?v0))) (=> (= (f45 (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) f1) (=> (= (f44 f29 ?v0) f1) (= (f45 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (* ?v0 ?v1) (* ?v0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f44 f29 ?v0) f1) (=> (= (f45 f29 ?v1) f1) (= (f44 f29 (f22 (f23 f30 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f45 f29 ?v0) f1) (=> (= (f44 f29 ?v1) f1) (= (f44 f29 (f22 (f23 f30 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f44 f29 ?v0) f1) (=> (= (f45 ?v1 ?v2) f1) (= (f44 ?v1 (f22 (f23 f30 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (<= ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f45 f29 ?v0) f1) (=> (= (f44 ?v1 ?v2) f1) (= (f44 ?v1 (f22 (f23 f30 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f44 ?v0 f29) f1) (=> (= (f45 ?v1 f29) f1) (= (f44 (f22 (f23 f30 ?v0) ?v1) f29) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (<= ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f45 ?v0 f29) f1) (=> (= (f44 ?v1 f29) f1) (= (f44 (f22 (f23 f30 ?v0) ?v1) f29) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f45 f29 ?v0) f1) (=> (< 0 (f20 f21 ?v2)) (= (f44 (f22 (f23 f24 ?v0) ?v2) (f22 (f23 f24 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f20 f21 ?v2)) (< (f20 (f27 f28 ?v0) ?v2) (f20 (f27 f28 ?v1) ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f44 (f22 (f23 f24 ?v0) ?v1) (f22 (f23 f24 ?v2) ?v1)) f1) (=> (= (f45 f29 ?v2) f1) (= (f44 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (< (f20 (f27 f28 ?v0) ?v1) (f20 (f27 f28 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f18 f19 2))) (=> (= (f44 (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v1) ?v_0)) f1) (=> (= (f45 f29 ?v1) f1) (= (f44 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (=> (< (f20 (f27 f28 ?v0) ?v_0) (f20 (f27 f28 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f44 f25 ?v0) f1) (= (= (f45 (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) f1) (<= (f20 f21 ?v1) (f20 f21 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 1 ?v0) (= (<= (f20 ?v_0 ?v1) (f20 ?v_0 ?v2)) (<= (f20 f21 ?v1) (f20 f21 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f44 f25 ?v0) f1) (=> (= (f45 (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) f1) (<= (f20 f21 ?v1) (f20 f21 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 1 ?v0) (=> (<= (f20 ?v_0 ?v1) (f20 ?v_0 ?v2)) (<= (f20 f21 ?v1) (f20 f21 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f20 f21 ?v0)) (<= ?v_0 (f20 f21 (f22 (f23 f24 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (=> (< 0 (f20 f21 ?v0)) (=> (< (f20 f21 (f22 ?v_0 ?v1)) (f20 f21 (f22 ?v_0 ?v2))) (< (f20 f21 ?v1) (f20 f21 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (= (f18 f19 (f20 (f27 f28 ?v0) ?v1)) (f22 (f23 f24 (f18 f19 ?v0)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f18 f19 (+ 0 1)))) (= (= (f22 (f23 f24 ?v0) ?v1) ?v_0) (or (= ?v1 (f18 f19 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f20 (f27 f28 (f20 f21 ?v0)) ?v1) (f20 f21 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f18 f19 (+ 0 1)))) (= (f22 (f23 f24 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (< 0 (f20 f21 (f22 (f23 f24 ?v0) ?v1))) (or (< 0 (f20 f21 ?v0)) (= ?v1 (f18 f19 0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f20 f21 (f22 (f23 f24 ?v0) ?v1)) (f20 (f27 f28 (f20 f21 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 f31 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f3 f31 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f3 f31 ?v0) 0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f31 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f3 f31 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (<= 0 (f3 f31 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 f31 ?v0)) (?v_1 (f3 f31 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f30 ?v0))) (=> (= (f44 (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) f1) (= (f44 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f31 (+ ?v0 ?v1)) (+ (f3 f31 ?v0) (f3 f31 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (< (+ (* ?v3 ?v0) (* ?v4 ?v2)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (< 0 (+ ?v0 ?v0)) (< 0 ?v0))))
(assert (< 0 1))
(assert (not (< 1 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f3 f31 (* ?v0 ?v1)) (* (f3 f31 ?v0) (f3 f31 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f3 f31 ?v1) ?v0) (f3 f31 (* ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 Int)) (= (<= (+ ?v0 ?v0) 0) (<= ?v0 0))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (< 0 (f20 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f44 f29 ?v0) f1) (= (f44 f29 (f22 (f23 f24 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (f20 (f27 f28 ?v0) (f18 f19 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f20 (f27 f28 ?v0) (f18 f19 2)) 0))))
(assert (<= 0 1))
(assert (not (<= 1 0)))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (=> (= (f20 (f27 f28 ?v0) ?v_0) (f20 (f27 f28 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f18 f19 2))) (=> (= (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v1) ?v_0)) (=> (= (f45 f29 ?v0) f1) (=> (= (f45 f29 ?v1) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (=> (<= (f20 (f27 f28 ?v0) ?v_0) (f20 (f27 f28 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f18 f19 2))) (=> (= (f45 (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v1) ?v_0)) f1) (=> (= (f45 f29 ?v1) f1) (= (f45 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (let ((?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))) (=> (= (f20 (f27 f28 ?v0) ?v_0) (f20 (f27 f28 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))) (=> (= (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v2) ?v_0)) (=> (= (f45 f29 ?v0) f1) (=> (= (f45 f29 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (let ((?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))) (=> (<= (f20 (f27 f28 ?v0) ?v_0) (f20 (f27 f28 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f18 f19 (+ (f20 f21 ?v1) 1)))) (=> (= (f45 (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v2) ?v_0)) f1) (=> (= (f45 f29 ?v2) f1) (= (f45 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S8)) (= (f18 f19 (f20 f21 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f20 f21 (f18 f19 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f20 f21 (f18 f19 ?v0)) 0))))
(check-sat)
(exit)
