(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () S3)
(declare-fun f7 (S4 S5) S5)
(declare-fun f8 (S6 S5) S4)
(declare-fun f9 () S6)
(declare-fun f10 (S7 S8) S5)
(declare-fun f11 (S9 S5) S7)
(declare-fun f12 () S9)
(declare-fun f13 () S5)
(declare-fun f14 () S8)
(declare-fun f15 () S5)
(declare-fun f16 () S4)
(declare-fun f17 () S5)
(declare-fun f18 () S6)
(declare-fun f19 () S6)
(declare-fun f20 () S5)
(declare-fun f21 (S10 Int) S8)
(declare-fun f22 () S10)
(declare-fun f23 (S11 S8) Int)
(declare-fun f24 (S12 Int) S11)
(declare-fun f25 () S12)
(declare-fun f26 (S13 S8) S8)
(declare-fun f27 (S14 S8) S13)
(declare-fun f28 () S14)
(declare-fun f29 () S8)
(declare-fun f30 () S14)
(declare-fun f31 () S11)
(declare-fun f32 () S2)
(declare-fun f33 () S14)
(declare-fun f34 () S8)
(declare-fun f35 () S3)
(declare-fun f36 () S3)
(declare-fun f37 (S15 S3) S12)
(declare-fun f38 (S16 Int) S15)
(declare-fun f39 () S16)
(declare-fun f40 (S17 S6) S9)
(declare-fun f41 (S18 S5) S17)
(declare-fun f42 () S18)
(declare-fun f43 (S19 S14) S14)
(declare-fun f44 (S20 S8) S19)
(declare-fun f45 () S20)
(declare-fun f46 () S4)
(declare-fun f47 () S4)
(declare-fun f48 () S5)
(declare-fun f49 (Int S21) S1)
(declare-fun f50 () S21)
(declare-fun f51 (S5 S22) S1)
(declare-fun f52 () S22)
(declare-fun f53 (S8 S8) S1)
(declare-fun f54 (S8 S8) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f6 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= (f7 (f8 f9 (f10 (f11 f12 f13) f14)) f15) (f7 f16 f17))))
(assert (= (f7 (f8 f18 (f7 (f8 f19 f17) (f7 (f8 f9 (f10 (f11 f12 f13) f14)) f15))) f17) (f7 (f8 f18 f20) f17)))
(assert (not (= f14 (f21 f22 0))))
(assert (not (= f15 f20)))
(assert (not (= f13 f20)))
(assert (= (f7 (f8 f18 (f7 (f8 f19 f17) (f7 (f8 f9 (f10 (f11 f12 f13) f14)) f15))) f17) (f7 (f8 f18 f20) f17)))
(assert (= (f7 (f8 f19 f17) (f7 (f8 f9 (f10 (f11 f12 f13) f14)) f15)) f20))
(assert (=> (forall ((?v0 S5)) (=> (= (f7 (f8 f19 f17) (f7 (f8 f9 (f10 (f11 f12 ?v0) f14)) f15)) f20) false)) false))
(assert (forall ((?v0 S5) (?v1 S8)) (= (f10 (f11 f12 (f7 f16 ?v0)) ?v1) (f7 (f8 f9 (f10 (f11 f12 (f7 f16 f17)) ?v1)) (f10 (f11 f12 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f23 (f24 f25 (- ?v0)) ?v1) (* (f23 (f24 f25 (- 1)) ?v1) (f23 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S5)) (= (= (f10 (f11 f12 ?v0) (f21 f22 2)) f17) (or (= ?v0 f17) (= ?v0 (f7 f16 f17))))))
(assert (forall ((?v0 Int)) (= (= (f23 (f24 f25 ?v0) (f21 f22 2)) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 ?v1) (ite (= ?v1 (f21 f22 0)) f29 (f26 (f27 f30 ?v0) (f26 ?v_0 (f21 f22 (- (f23 f31 ?v1) 1)))))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 ?v1) (ite (= ?v1 (f21 f22 0)) f17 (f7 (f8 f9 ?v0) (f10 ?v_0 (f21 f22 (- (f23 f31 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 ?v1) (ite (= ?v1 (f21 f22 0)) 1 (* ?v0 (f23 ?v_0 (f21 f22 (- (f23 f31 ?v1) 1)))))))))
(assert (forall ((?v0 S5)) (= (f7 f16 ?v0) (f7 (f8 f9 (f7 f16 f17)) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0) (* (- 1) ?v0))))
(assert (forall ((?v0 S5)) (= (= (f7 (f8 f9 ?v0) ?v0) f17) (or (= ?v0 f17) (= ?v0 (f7 f16 f17))))))
(assert (forall ((?v0 Int)) (= (= (* ?v0 ?v0) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f32 (f23 (f24 f25 (- ?v0)) ?v1)) (f3 f32 (f23 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f21 f22 2))) (= (f10 (f11 f12 (f7 f16 ?v0)) ?v_0) (f10 (f11 f12 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 2))) (= (f23 (f24 f25 (- ?v0)) ?v_0) (f23 (f24 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 (+ (+ 0 1) 1)))) (= (= (f10 (f11 f12 ?v0) ?v_0) (f10 (f11 f12 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (f7 f16 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 (+ (+ 0 1) 1)))) (= (= (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (- ?v1)))))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 f29) ?v0) f29)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 f17) ?v0) f17)))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 1) ?v0) 1)))
(assert (= (f26 (f27 f28 f29) (f21 f22 2)) f29))
(assert (= (f10 (f11 f12 f17) (f21 f22 2)) f17))
(assert (= (f23 (f24 f25 1) (f21 f22 2)) 1))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f21 f22 0)) f29)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f21 f22 0)) f17)))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f21 f22 0)) 1)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f33 f34) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 f20) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f33 ?v0) f34) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 ?v0) f20) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f19 ?v0) ?v1) (f7 (f8 f19 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= ?v0 (f26 (f27 f33 ?v0) ?v1)) (= ?v1 f34))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f7 (f8 f19 ?v0) ?v1)) (= ?v1 f20))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f8 f19 ?v0)) (?v_0 (f8 f19 ?v1))) (= (f7 ?v_1 (f7 ?v_0 ?v2)) (f7 ?v_0 (f7 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f19 ?v0))) (= (f7 ?v_0 (f7 (f8 f19 ?v1) ?v2)) (f7 (f8 f19 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f19 ?v0))) (= (f7 (f8 f19 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f19 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f19 ?v0))) (= (f7 (f8 f19 (f7 ?v_0 ?v1)) ?v2) (f7 (f8 f19 (f7 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f8 f19 ?v0))) (= (f7 (f8 f19 (f7 ?v_0 ?v1)) (f7 (f8 f19 ?v2) ?v3)) (f7 (f8 f19 (f7 ?v_0 ?v2)) (f7 (f8 f19 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f21 f22 (* (f23 f31 ?v1) (f23 f31 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f21 f22 (* (f23 f31 ?v1) (f23 f31 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2) (f23 ?v_0 (f21 f22 (* (f23 f31 ?v1) (f23 f31 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f21 f22 (* 2 (f23 f31 ?v1)))) (f10 (f11 f12 (f10 ?v_0 ?v1)) (f21 f22 2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f21 f22 (* 2 (f23 f31 ?v1)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) (f21 f22 2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f21 f22 (* 2 (f23 f31 ?v1)))) (f23 (f24 f25 (f23 ?v_0 ?v1)) (f21 f22 2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f21 f22 (* (f23 f31 ?v1) (f23 f31 ?v2)))) (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f21 f22 (* (f23 f31 ?v1) (f23 f31 ?v2)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f21 f22 (* (f23 f31 ?v1) (f23 f31 ?v2)))) (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (= (= (f7 (f8 f19 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f19 (f7 (f8 f9 ?v3) ?v1)) ?v4)) (= (f7 (f8 f19 (f7 (f8 f9 (f7 (f8 f18 ?v0) ?v3)) ?v1)) ?v2) ?v4))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (= (+ (* (- ?v0 ?v3) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (= (= (f7 (f8 f19 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f19 (f7 (f8 f9 ?v3) ?v1)) ?v4)) (= ?v2 (f7 (f8 f19 (f7 (f8 f9 (f7 (f8 f18 ?v3) ?v0)) ?v1)) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (= ?v2 (+ (* (- ?v3 ?v0) ?v1) ?v4)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f18 (f7 ?v_0 ?v1)) (f7 (f8 f9 ?v2) ?v3)) (f7 (f8 f19 (f7 ?v_0 (f7 (f8 f18 ?v1) ?v3))) (f7 (f8 f9 (f7 (f8 f18 ?v0) ?v2)) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 (- ?v1 ?v3)) (* (- ?v0 ?v2) ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f18 ?v0) ?v1) (f7 (f8 f19 ?v0) (f7 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8) (?v4 S8)) (let ((?v_0 (f27 f30 ?v0))) (=> (not (= ?v0 f34)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f26 (f27 f33 ?v1) (f26 ?v_0 ?v3)) (f26 (f27 f33 ?v2) (f26 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (let ((?v_0 (f8 f9 ?v0))) (=> (not (= ?v0 f20)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f7 (f8 f19 ?v1) (f7 ?v_0 ?v3)) (f7 (f8 f19 ?v2) (f7 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (* ?v0 ?v3)) (+ ?v2 (* ?v0 ?v4))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f7 (f8 f19 ?v0) ?v1) f20) (= ?v1 (f7 f16 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ ?v0 ?v1) 0) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 2))) (= (= (+ (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f21 f22 (* 2 (f23 f31 ?v1))))) (= (f10 (f11 f12 (f7 f16 ?v0)) ?v_0) (f10 (f11 f12 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 (* 2 (f23 f31 ?v1))))) (= (f23 (f24 f25 (- ?v0)) ?v_0) (f23 (f24 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f27 f30 ?v0)) (?v_1 (f27 f30 ?v2))) (= (= (f26 (f27 f33 (f26 ?v_0 ?v1)) (f26 ?v_1 ?v3)) (f26 (f27 f33 (f26 ?v_0 ?v3)) (f26 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (= (= (f7 (f8 f19 (f7 ?v_0 ?v1)) (f7 ?v_1 ?v3)) (f7 (f8 f19 (f7 ?v_0 ?v3)) (f7 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (+ (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 ?v3) (* ?v2 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f26 (f27 f33 (f26 (f27 f30 ?v0) ?v1)) (f26 (f27 f33 (f26 (f27 f30 ?v2) ?v1)) ?v3)) (f26 (f27 f33 (f26 (f27 f30 (f26 (f27 f33 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f7 (f8 f19 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f19 (f7 (f8 f9 ?v2) ?v1)) ?v3)) (f7 (f8 f19 (f7 (f8 f9 (f7 (f8 f19 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f33 (f26 (f27 f30 ?v0) ?v1)) (f26 (f27 f30 ?v2) ?v1)) (f26 (f27 f30 (f26 (f27 f33 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f7 (f8 f19 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 ?v2) ?v1)) (f7 (f8 f9 (f7 (f8 f19 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (* ?v0 ?v1) (* ?v2 ?v1)) (* (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f30 (f26 (f27 f33 ?v0) ?v1)) ?v2) (f26 (f27 f33 (f26 (f27 f30 ?v0) ?v2)) (f26 (f27 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f7 (f8 f9 (f7 (f8 f19 ?v0) ?v1)) ?v2) (f7 (f8 f19 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f30 (f26 (f27 f33 ?v0) ?v1)) ?v2) (f26 (f27 f33 (f26 (f27 f30 ?v0) ?v2)) (f26 (f27 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f7 (f8 f9 (f7 (f8 f19 ?v0) ?v1)) ?v2) (f7 (f8 f19 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f27 f30 ?v0)) (?v_1 (f27 f30 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f26 (f27 f33 (f26 ?v_0 ?v2)) (f26 ?v_1 ?v3)) (f26 (f27 f33 (f26 ?v_0 ?v3)) (f26 ?v_1 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f7 (f8 f19 (f7 ?v_0 ?v2)) (f7 ?v_1 ?v3)) (f7 (f8 f19 (f7 ?v_0 ?v3)) (f7 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (* ?v0 ?v2) (* ?v1 ?v3)) (+ (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f30 ?v0))) (= (f26 ?v_0 (f26 (f27 f33 ?v1) ?v2)) (f26 (f27 f33 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f19 ?v1) ?v2)) (f7 (f8 f19 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (+ ?v1 ?v2)) (+ (* ?v0 ?v1) (* ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f26 (f27 f30 ?v0) ?v1) f34) (or (= ?v0 f34) (= ?v1 f34)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f7 (f8 f9 ?v0) ?v1) f20) (or (= ?v0 f20) (= ?v1 f20)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f34)) (=> (not (= ?v1 f34)) (not (= (f26 (f27 f30 ?v0) ?v1) f34))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f20)) (=> (not (= ?v1 f20)) (not (= (f7 (f8 f9 ?v0) ?v1) f20))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f7 (f8 f9 ?v0) ?v1) f20) (or (= ?v0 f20) (= ?v1 f20)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 ?v0) f34) f34)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 ?v0) f20) f20)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 ?v0) f34) f34)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 ?v0) f20) f20)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 f34) ?v0) f34)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 f20) ?v0) f20)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 f34) ?v0) f34)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 f20) ?v0) f20)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (not (= 0 1)))
(assert (not (= f20 f17)))
(assert (not (= 1 0)))
(assert (not (= f17 f20)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f23 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (not (= ?v0 f20)) (not (= (f10 (f11 f12 ?v0) ?v1) f20)))))
(assert (forall ((?v0 Int)) (= (= (f23 (f24 f25 ?v0) (f21 f22 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f10 (f11 f12 ?v0) (f21 f22 2)) f20) (= ?v0 f20))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f23 (f24 f25 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f21 f22 0)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (= (f10 (f11 f12 ?v0) ?v1) f20) (and (= ?v0 f20) (not (= ?v1 (f21 f22 0)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f26 (f27 f28 ?v0) ?v1) f34) (and (= ?v0 f34) (not (= ?v1 (f21 f22 0)))))))
(assert (= (f23 (f24 f25 0) (f21 f22 2)) 0))
(assert (= (f10 (f11 f12 f20) (f21 f22 2)) f20))
(assert (= (f26 (f27 f28 f34) (f21 f22 2)) f34))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 0) (f21 f22 (+ (f23 f31 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 f20) (f21 f22 (+ (f23 f31 ?v0) 1))) f20)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 f34) (f21 f22 (+ (f23 f31 ?v0) 1))) f34)))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 (- 1)) (f21 f22 (* 2 (f23 f31 ?v0)))) 1)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 (f7 f16 f17)) (f21 f22 (* 2 (f23 f31 ?v0)))) f17)))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 (- 1)) (f21 f22 (+ (* 2 (f23 f31 ?v0)) 1))) (- 1))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f7 f16 f17))) (= (f10 (f11 f12 ?v_0) (f21 f22 (+ (* 2 (f23 f31 ?v0)) 1))) ?v_0))))
(assert (forall ((?v0 Int)) (= (- (* ?v0 ?v0) 1) (* (+ ?v0 1) (- ?v0 1)))))
(assert (forall ((?v0 S5)) (= (f7 (f8 f18 (f7 (f8 f9 ?v0) ?v0)) f17) (f7 (f8 f9 (f7 (f8 f19 ?v0) f17)) (f7 (f8 f18 ?v0) f17)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 (+ (+ 0 1) 1)))) (= (- (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0)) (* (- ?v0 ?v1) (+ ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f21 f22 (+ (+ 0 1) 1)))) (= (f7 (f8 f18 (f10 (f11 f12 ?v0) ?v_0)) (f10 (f11 f12 ?v1) ?v_0)) (f7 (f8 f9 (f7 (f8 f18 ?v0) ?v1)) (f7 (f8 f19 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 (f8 f9 ?v2) ?v3)) (f7 (f8 f9 (f7 ?v_0 ?v2)) (f7 (f8 f9 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f8 f9 (f7 (f8 f9 ?v0) ?v1))) (?v_0 (f8 f9 ?v2))) (= (f7 ?v_1 (f7 ?v_0 ?v3)) (f7 ?v_0 (f7 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f7 (f8 f9 ?v2) ?v3))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v_1) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 (f8 f9 (f7 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f32 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f7 ?v_1 (f7 ?v_0 ?v2)) (f7 ?v_0 (f7 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f32 (* ?v0 ?v1)) (* (f3 f32 ?v0) (f3 f32 ?v1)))))
(assert (= (f3 f32 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 2))) (= (f23 (f24 f25 (f3 f32 ?v0)) ?v_0) (f23 (f24 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f21 f22 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f23 (f24 f25 ?v0) (f21 f22 2)))) (= (f3 f32 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f32 (f23 (f24 f25 ?v0) ?v1)) (f23 (f24 f25 (f3 f32 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (* ?v0 ?v1) ?v1) (* (+ ?v0 1) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f19 (f7 (f8 f9 ?v0) ?v1)) ?v1) (f7 (f8 f9 (f7 (f8 f19 ?v0) f17)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (* ?v1 ?v0)) (* (+ ?v1 1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f19 ?v0) (f7 (f8 f9 ?v1) ?v0)) (f7 (f8 f9 (f7 (f8 f19 ?v1) f17)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (* (+ 1 1) ?v0))))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 ?v0) ?v0) (f7 (f8 f9 (f7 (f8 f19 f17) f17)) ?v0))))
(assert (forall ((?v0 S8)) (= (f23 (f24 f25 0) ?v0) (ite (= ?v0 (f21 f22 0)) 1 0))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 f20) ?v0) (ite (= ?v0 (f21 f22 0)) f17 f20))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 f34) ?v0) (ite (= ?v0 (f21 f22 0)) f29 f34))))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 ?v0) f17) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 f17) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v0) (* ?v1 ?v1)) (or (= ?v0 ?v1) (= ?v0 (- ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f7 (f8 f9 ?v0) ?v0) (f7 (f8 f9 ?v1) ?v1)) (or (= ?v0 ?v1) (= ?v0 (f7 f16 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (- ?v0) (- ?v1)) (* ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f9 (f7 f16 ?v0)) (f7 f16 ?v1)) (f7 (f8 f9 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (- ?v0) ?v1) (* ?v0 (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f9 (f7 f16 ?v0)) ?v1) (f7 (f8 f9 ?v0) (f7 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (* ?v0 ?v1)) (* (- ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 f16 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 (f7 f16 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (* ?v0 ?v1)) (* ?v0 (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 f16 (f7 ?v_0 ?v1)) (f7 ?v_0 (f7 f16 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f23 f31 ?v1)) (?v_1 (f23 f31 ?v0)) (?v_2 (f24 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f23 ?v_2 (f21 f22 (- (+ ?v_0 1) ?v_1))) (* (f23 ?v_2 (f21 f22 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f31 ?v1)) (?v_1 (f23 f31 ?v0)) (?v_2 (f27 f28 ?v2))) (=> (<= ?v_1 ?v_0) (= (f26 ?v_2 (f21 f22 (- (+ ?v_0 1) ?v_1))) (f26 (f27 f30 (f26 ?v_2 (f21 f22 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S5)) (let ((?v_0 (f23 f31 ?v1)) (?v_1 (f23 f31 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_1 ?v_0) (= (f10 ?v_2 (f21 f22 (- (+ ?v_0 1) ?v_1))) (f7 (f8 f9 (f10 ?v_2 (f21 f22 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f23 f31 ?v0)) (?v_1 (f24 f25 ?v1))) (=> (< 0 ?v_0) (= (* (f23 ?v_1 (f21 f22 (- ?v_0 1))) ?v1) (f23 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f23 f31 ?v0)) (?v_1 (f27 f28 ?v1))) (=> (< 0 ?v_0) (= (f26 (f27 f30 (f26 ?v_1 (f21 f22 (- ?v_0 1)))) ?v1) (f26 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S5)) (let ((?v_0 (f23 f31 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (f7 (f8 f9 (f10 ?v_1 (f21 f22 (- ?v_0 1)))) ?v1) (f10 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (* (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) (f23 ?v_0 (f21 f22 (+ (f23 f31 ?v1) (f23 f31 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f30 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2)) (f26 ?v_0 (f21 f22 (+ (f23 f31 ?v1) (f23 f31 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f7 (f8 f9 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) (f10 ?v_0 (f21 f22 (+ (f23 f31 ?v1) (f23 f31 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f23 (f24 f25 (* ?v0 ?v1)) ?v2) (* (f23 (f24 f25 ?v0) ?v2) (f23 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f28 (f26 (f27 f30 ?v0) ?v1)) ?v2) (f26 (f27 f30 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f10 (f11 f12 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f23 (f24 f25 (* ?v0 ?v1)) ?v2) (* (f23 (f24 f25 ?v0) ?v2) (f23 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f28 (f26 (f27 f30 ?v0) ?v1)) ?v2) (f26 (f27 f30 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f10 (f11 f12 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 (f24 f25 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 (f27 f28 ?v0) ?v1))) (= (f26 (f27 f30 ?v_0) ?v0) (f26 (f27 f30 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 (f11 f12 ?v0) ?v1))) (= (f7 (f8 f9 ?v_0) ?v0) (f7 (f8 f9 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (* (f23 ?v_0 ?v1) ?v0) (f23 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f30 (f26 ?v_0 ?v1)) ?v0) (f26 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f7 (f8 f9 (f10 ?v_0 ?v1)) ?v0) (f10 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f23 ?v_0 ?v1))) (= (f23 ?v_0 (f21 f22 (* 2 (f23 f31 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f26 ?v_0 ?v1))) (= (f26 ?v_0 (f21 f22 (* 2 (f23 f31 ?v1)))) (f26 (f27 f30 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f21 f22 (* 2 (f23 f31 ?v1)))) (f7 (f8 f9 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f21 f22 (+ (f23 f31 ?v1) (f23 f31 ?v2)))) (* (f23 ?v_0 ?v1) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f21 f22 (+ (f23 f31 ?v1) (f23 f31 ?v2)))) (f26 (f27 f30 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f21 f22 (+ (f23 f31 ?v1) (f23 f31 ?v2)))) (f7 (f8 f9 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (* ?v0 (f23 ?v_0 ?v1)) (f23 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f30 ?v0) (f26 ?v_0 ?v1)) (f26 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f7 (f8 f9 ?v0) (f10 ?v_0 ?v1)) (f10 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f23 ?v_0 ?v1))) (= (f23 ?v_0 (f21 f22 (+ (* 2 (f23 f31 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f26 ?v_0 ?v1))) (= (f26 ?v_0 (f21 f22 (+ (* 2 (f23 f31 ?v1)) 1))) (f26 (f27 f30 ?v0) (f26 (f27 f30 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (= (f10 ?v_0 (f21 f22 (+ (* 2 (f23 f31 ?v1)) 1))) (f7 (f8 f9 ?v0) (f7 (f8 f9 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f21 f22 (+ (* 2 (f23 f31 ?v1)) 1))) (* ?v0 (f23 (f24 f25 (f23 ?v_0 ?v1)) (f21 f22 2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f21 f22 (+ (* 2 (f23 f31 ?v1)) 1))) (f26 (f27 f30 ?v0) (f26 (f27 f28 (f26 ?v_0 ?v1)) (f21 f22 2)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f21 f22 (+ (* 2 (f23 f31 ?v1)) 1))) (f7 (f8 f9 ?v0) (f10 (f11 f12 (f10 ?v_0 ?v1)) (f21 f22 2)))))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f21 f22 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f21 f22 3)) (f26 (f27 f30 (f26 (f27 f30 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f21 f22 3)) (f7 (f8 f9 (f7 (f8 f9 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f21 f22 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f21 f22 2)) (f26 (f27 f30 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f21 f22 2)) (f7 (f8 f9 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1))) (* (f23 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1))) (f26 (f27 f30 (f26 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1))) (f7 (f8 f9 (f10 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1))) (* ?v0 (f23 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1))) (f26 (f27 f30 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1))) (f7 (f8 f9 ?v0) (f10 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1))) (* ?v0 (f23 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1))) (f26 (f27 f30 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (f21 f22 (+ (f23 f31 ?v1) 1))) (f7 (f8 f9 ?v0) (f10 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f23 (f24 f25 ?v0) (f21 f22 2)))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 ?v0) ?v0) (f26 (f27 f28 ?v0) (f21 f22 2)))))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 ?v0) ?v0) (f10 (f11 f12 ?v0) (f21 f22 2)))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f21 f22 0)) 1)))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 ?v0) (f21 f22 0)) f17)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f21 f22 0)) f29)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f18 ?v0) ?v1) (f7 (f8 f19 ?v0) (f7 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 (- ?v1)) (+ ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f18 ?v0) (f7 f16 ?v1)) (f7 (f8 f19 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f18 ?v0) ?v1) (f7 (f8 f19 ?v0) (f7 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f18 ?v0) ?v1) (f7 (f8 f19 ?v0) (f7 f16 ?v1)))))
(assert (forall ((?v0 Int)) (= (- 0 ?v0) (- ?v0))))
(assert (forall ((?v0 S5)) (= (f7 (f8 f18 f20) ?v0) (f7 f16 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f8 f9 ?v2)) (?v_0 (f8 f9 (f7 (f8 f18 ?v0) ?v2))) (?v_2 (f7 (f8 f18 ?v1) ?v3))) (= (f7 (f8 f18 (f7 (f8 f9 ?v0) ?v1)) (f7 ?v_1 ?v3)) (f7 (f8 f19 (f7 (f8 f19 (f7 ?v_0 ?v_2)) (f7 ?v_0 ?v3))) (f7 ?v_1 ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (+ ?v0 ?v1) 0) (= (- ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f7 (f8 f19 ?v0) ?v1) f20) (= (f7 f16 ?v0) ?v1))))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 (f7 f16 ?v0)) ?v0) f20)))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 (f7 f16 ?v0)) ?v0) f20)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= (+ ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f7 f16 ?v1)) (= (f7 (f8 f19 ?v0) ?v1) f20))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 ?v1) (ite (= ?v1 (f21 f22 0)) (f21 f22 1) (f21 f22 (* (f23 f31 ?v0) (f23 f31 (f26 ?v_0 (f21 f22 (- (f23 f31 ?v1) 1)))))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f22 0)) (?v_2 (f23 f31 ?v0)) (?v_1 (f23 f31 ?v1))) (= (f21 f22 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f21 f22 (+ ?v_1 (* (f23 f31 (f21 f22 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f23 f31 ?v0))) (= (f21 f22 (* ?v_0 2)) (f21 f22 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f23 f31 ?v0))) (= (f21 f22 (* 2 ?v_0)) (f21 f22 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int)) (= (= (f3 f32 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f20 ?v0) (= ?v0 f20))))
(assert (= (f3 f32 0) 0))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f7 (f8 f19 ?v0) ?v1) (f7 (f8 f19 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f19 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f19 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f7 (f8 f19 ?v0) ?v1) (f7 (f8 f19 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f19 ?v0))) (= (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f35 ?v0) ?v1) ?v2) (f3 (f4 f35 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f36 ?v0) ?v1) ?v2) (f3 (f4 f36 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f19 ?v0))) (= (f7 (f8 f19 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f19 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f3 f32 ?v0) (f3 f32 ?v1)))) (= (f3 f32 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S5)) (= (= f17 ?v0) (= ?v0 f17))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f7 (f8 f18 ?v0) ?v1) (f7 (f8 f18 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f35 ?v0) ?v1) ?v2) (f3 (f4 f35 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f36 ?v0) ?v1) ?v2) (f3 (f4 f36 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f32 (- ?v0 ?v1)) (f3 f32 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 f16 (f7 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (f3 f32 (- ?v0)) (f3 f32 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 (f4 f36 ?v0) ?v1)) (f3 (f4 f35 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 (f4 f35 ?v0) ?v1)) (f3 (f4 f36 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f7 f16 ?v1)) (= ?v1 (f7 f16 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f7 f16 ?v0) ?v1) (= (f7 f16 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f7 f16 ?v0) (f7 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 f20) ?v0) f20)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 f20) ?v0) f20)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 ?v0) f20) f20)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 ?v0) f20) f20)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 ?v0) f20) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 ?v0) f20) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 f20) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 f20) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f7 (f8 f18 ?v0) ?v1) f20) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f7 (f8 f18 ?v0) ?v1) f20))))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f18 ?v0) ?v0) f20)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f18 ?v0) f20) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f19 ?v1) ?v2)) (f7 (f8 f19 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f19 ?v1) ?v2)) (f7 (f8 f19 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f7 (f8 f9 (f7 (f8 f19 ?v0) ?v1)) ?v2) (f7 (f8 f19 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f7 (f8 f9 (f7 (f8 f19 ?v0) ?v1)) ?v2) (f7 (f8 f19 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 f17) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 f17) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 ?v0) f17) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f9 ?v0) f17) ?v0)))
(assert (= 0 0))
(assert (= (f7 f16 f20) f20))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 S5)) (= (= f20 (f7 f16 ?v0)) (= f20 ?v0))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f7 f16 ?v0) f20) (= ?v0 f20))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f18 ?v1) ?v2)) (f7 (f8 f18 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 (f8 f18 ?v1) ?v2)) (f7 (f8 f18 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f7 (f8 f9 (f7 (f8 f18 ?v0) ?v1)) ?v2) (f7 (f8 f18 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f7 (f8 f9 (f7 (f8 f18 ?v0) ?v1)) ?v2) (f7 (f8 f18 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f18 (f7 (f8 f19 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f19 (f7 (f8 f18 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 f16 ?v1)) (f7 f16 (f7 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 ?v_0 (f7 f16 ?v1)) (f7 f16 (f7 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f9 (f7 f16 ?v0)) ?v1) (f7 f16 (f7 (f8 f9 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f9 (f7 f16 ?v0)) ?v1) (f7 f16 (f7 (f8 f9 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v0) (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 f16 (f7 (f8 f19 ?v0) ?v1)) (f7 (f8 f19 (f7 f16 ?v0)) (f7 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 f16 (f7 (f8 f19 ?v0) ?v1)) (f7 (f8 f19 (f7 f16 ?v1)) (f7 f16 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (+ (- ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f19 ?v0) (f7 (f8 f19 (f7 f16 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0) (+ ?v0 ?v1)) ?v1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f19 (f7 f16 ?v0)) (f7 (f8 f19 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (- ?v0 ?v1)) (- ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 f16 (f7 (f8 f18 ?v0) ?v1)) (f7 (f8 f18 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 (- ?v0)) 0)))
(assert (forall ((?v0 S5)) (= (f7 (f8 f19 ?v0) (f7 f16 ?v0)) f20)))
(assert (= f25 (f37 (f38 f39 1) f5)))
(assert (= f12 (f40 (f41 f42 f17) f9)))
(assert (= f28 (f43 (f44 f45 f29) f30)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (- ?v0) (- ?v1)) (- (- ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 (f8 f18 (f7 f16 ?v0)) (f7 f16 ?v1)) (f7 f16 (f7 (f8 f18 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f7 (f8 f18 (f7 (f8 f19 ?v0) ?v1)) (f7 (f8 f19 ?v2) ?v3)) (f7 (f8 f19 (f7 (f8 f18 ?v0) ?v2)) (f7 (f8 f18 ?v1) ?v3)))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f23 f31 ?v0)) (<= ?v_0 (f23 f31 (f26 (f27 f28 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 0 (f23 f31 ?v0)) (=> (< (f23 f31 (f26 ?v_0 ?v1)) (f23 f31 (f26 ?v_0 ?v2))) (< (f23 f31 ?v1) (f23 f31 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (= (f21 f22 (f23 (f24 f25 ?v0) ?v1)) (f26 (f27 f28 (f21 f22 ?v0)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f22 (+ 0 1)))) (= (= (f26 (f27 f28 ?v0) ?v1) ?v_0) (or (= ?v1 (f21 f22 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f23 (f24 f25 (f23 f31 ?v0)) ?v1) (f23 f31 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f21 f22 (+ 0 1)))) (= (f26 (f27 f28 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (< 0 (f23 f31 (f26 (f27 f28 ?v0) ?v1))) (or (< 0 (f23 f31 ?v0)) (= ?v1 (f21 f22 0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f23 f31 (f26 (f27 f28 ?v0) ?v1)) (f23 (f24 f25 (f23 f31 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f21 f22 (* ?v0 ?v1)) (f21 f22 (* (f23 f31 (f21 f22 (- ?v0))) (f23 f31 (f21 f22 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f21 f22 (* ?v0 ?v1)) (f21 f22 (* (f23 f31 (f21 f22 ?v0)) (f23 f31 (f21 f22 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2) (f23 ?v_0 (f21 f22 (* (f23 f31 ?v1) (f23 f31 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (* (f23 f31 ?v0) (f23 f31 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (* (f23 f31 ?v0) (f23 f31 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f21 f22 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f21 f22 (* (f23 f31 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0))) (f23 f31 (f21 f22 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5)) (= (f10 (f11 f12 (f7 f46 ?v0)) (f21 f22 2)) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f7 f47 (f7 (f8 f19 ?v0) ?v1)) (f7 (f8 f9 (f7 f47 ?v0)) (f7 f47 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f21 f22 (+ (f23 f31 ?v1) (f23 f31 ?v2)))) (* (f23 ?v_0 ?v1) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (< 0 (f23 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f21 f22 0))))))
(assert (forall ((?v0 Int) (?v1 S8)) (<= 0 (f23 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (= (f7 f47 f20) f17))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f23 (f24 f25 (f23 f31 ?v0)) ?v1) (f23 f31 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (= (f26 (f27 f28 (f21 f22 ?v0)) ?v1) (f21 f22 (f23 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f21 f22 (* (f23 f31 (f21 f22 ?v0)) (f23 f31 (f21 f22 ?v1)))) (f21 f22 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (* (f23 f31 ?v0) (f23 f31 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (<= 0 (f23 (f24 f25 ?v0) ?v1)))))
(assert (= (f7 (f8 f9 f48) f48) (f7 f16 f17)))
(assert (forall ((?v0 Int)) (=> (= (f49 ?v0 f50) f1) (not (= (+ (+ 1 ?v0) ?v0) 0)))))
(assert (forall ((?v0 S5)) (=> (= (f51 ?v0 f52) f1) (not (= (f7 (f8 f19 (f7 (f8 f19 f17) ?v0)) ?v0) f20)))))
(assert (forall ((?v0 Int)) (=> (= (f49 ?v0 f50) f1) (= (= (+ ?v0 ?v0) 0) (= ?v0 0)))))
(assert (forall ((?v0 S5)) (=> (= (f51 ?v0 f52) f1) (= (= (f7 (f8 f19 ?v0) ?v0) f20) (= ?v0 f20)))))
(assert (= (f49 0 f50) f1))
(assert (= (f51 f20 f52) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f49 ?v0 f50) f1) (=> (= (f49 ?v1 f50) f1) (= (f49 (* ?v0 ?v1) f50) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f51 ?v0 f52) f1) (=> (= (f51 ?v1 f52) f1) (= (f51 (f7 (f8 f9 ?v0) ?v1) f52) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f49 ?v0 f50) f1) (=> (= (f49 ?v1 f50) f1) (= (f49 (+ ?v0 ?v1) f50) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f51 ?v0 f52) f1) (=> (= (f51 ?v1 f52) f1) (= (f51 (f7 (f8 f19 ?v0) ?v1) f52) f1)))))
(assert (= (f49 1 f50) f1))
(assert (= (f51 f17 f52) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f49 ?v0 f50) f1) (=> (= (f49 ?v1 f50) f1) (= (f49 (- ?v0 ?v1) f50) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f51 ?v0 f52) f1) (=> (= (f51 ?v1 f52) f1) (= (f51 (f7 (f8 f18 ?v0) ?v1) f52) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f49 ?v0 f50) f1) (= (f49 (- ?v0) f50) f1))))
(assert (forall ((?v0 S5)) (=> (= (f51 ?v0 f52) f1) (= (f51 (f7 f16 ?v0) f52) f1))))
(assert (not (= f48 f20)))
(assert (not (= f48 f17)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (= (f49 ?v0 f50) f1) (= (f49 (f23 (f24 f25 ?v0) ?v1) f50) f1))))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (= (f51 ?v0 f52) f1) (= (f51 (f10 (f11 f12 ?v0) ?v1) f52) f1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f8 f9 f48))) (= (f7 ?v_0 (f7 ?v_0 ?v0)) (f7 f16 ?v0)))))
(assert (forall ((?v0 Int)) (=> (= (f49 ?v0 f50) f1) (= (< (+ (+ 1 ?v0) ?v0) 0) (< ?v0 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (<= (+ (* ?v3 ?v0) (* ?v4 ?v2)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< 0 (+ (* ?v0 ?v0) (* ?v1 ?v1))) (or (not (= ?v0 0)) (not (= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (not (< (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0))))
(assert (< 0 (+ 1 1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= 0 (+ (* ?v0 ?v0) (* ?v1 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (< (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (< (+ (* (- ?v0 ?v3) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (< (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (< ?v2 (+ (* (- ?v3 ?v0) ?v1) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 2))) (= (< 0 (+ (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0))) (or (not (= ?v0 0)) (not (= ?v1 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 2))) (not (< (+ (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0)) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 2))) (=> (< (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f22 2))) (=> (= (f53 (f26 (f27 f28 ?v0) ?v_0) (f26 (f27 f28 ?v1) ?v_0)) f1) (=> (= (f54 f34 ?v1) f1) (= (f53 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (< (f23 (f24 f25 ?v0) ?v1) (f23 (f24 f25 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f53 (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) f1) (=> (= (f54 f34 ?v2) f1) (= (f53 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f23 f31 ?v2)) (< (f23 (f24 f25 ?v0) ?v2) (f23 (f24 f25 ?v1) ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f53 ?v0 ?v1) f1) (=> (= (f54 f34 ?v0) f1) (=> (< 0 (f23 f31 ?v2)) (= (f53 (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 S8)) (= (f21 f22 (f23 f31 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f23 f31 (f21 f22 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f23 f31 (f21 f22 ?v0)) 0))))
(check-sat)
(exit)
