(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S3) S3)
(declare-fun f7 (S6 S3) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S3)
(declare-fun f10 (S7 S8) S3)
(declare-fun f11 () S7)
(declare-fun f12 () S8)
(declare-fun f13 () S3)
(declare-fun f14 () S4)
(declare-fun f15 () S5)
(declare-fun f16 (S9 S8) S8)
(declare-fun f17 (S10 S8) S9)
(declare-fun f18 () S10)
(declare-fun f19 () S8)
(declare-fun f20 () S3)
(declare-fun f21 () S6)
(declare-fun f22 (S11 Int) Int)
(declare-fun f23 (S12 Int) S11)
(declare-fun f24 () S12)
(declare-fun f25 () S6)
(declare-fun f26 () S12)
(declare-fun f27 () S5)
(declare-fun f28 () S11)
(declare-fun f29 (S13 Int) S3)
(declare-fun f30 (S14 S3) Int)
(declare-fun f31 () S3)
(declare-fun f32 () S8)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f10 f11 f12))) (not (= (f3 (f4 f5 (f6 (f7 f8 f9) ?v_0)) (f6 (f7 f8 f13) ?v_0)) f1))))
(assert (= (f3 (f4 f14 f9) f13) f1))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f6 f15 (f6 (f7 f8 ?v0) ?v1))) (f6 (f7 f8 (f6 f15 ?v0)) (f6 f15 ?v1))) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f3 (f4 f5 (f10 f11 (f16 (f17 f18 ?v0) ?v1))) (f6 (f7 f8 (f10 f11 ?v0)) (f10 f11 ?v1))) f1)))
(assert (= (f6 f15 f13) f13))
(assert (= (f10 f11 f19) f13))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f15 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f6 f15 ?v0)) (f6 f15 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 f11 (f16 (f17 f18 ?v0) ?v1)) (f6 (f7 f8 (f10 f11 ?v0)) (f10 f11 ?v1)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f13) ?v0) ?v0)))
(assert (exists ((?v0 S3)) (forall ((?v1 S3) (?v2 S3)) (= (f3 (f4 f5 (f6 f15 (f6 (f7 f8 ?v1) ?v2))) (f6 (f7 f8 (f6 (f7 f8 (f6 f15 ?v1)) (f6 f15 ?v2))) ?v0)) f1))))
(assert (exists ((?v0 S3)) (forall ((?v1 S8) (?v2 S8)) (= (f3 (f4 f5 (f10 f11 (f16 (f17 f18 ?v1) ?v2))) (f6 (f7 f8 (f6 (f7 f8 (f10 f11 ?v1)) (f10 f11 ?v2))) ?v0)) f1))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (f3 (f4 f5 (f6 f15 (f6 (f7 f8 ?v0) ?v2))) (f6 (f7 f8 (f6 f15 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S8)) (exists ((?v1 S3)) (forall ((?v2 S8)) (= (f3 (f4 f5 (f10 f11 (f16 (f17 f18 ?v0) ?v2))) (f6 (f7 f8 (f10 f11 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (f3 (f4 f5 (f6 f15 (f6 (f7 f8 ?v2) ?v0))) (f6 (f7 f8 (f6 f15 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S8)) (exists ((?v1 S3)) (forall ((?v2 S8)) (= (f3 (f4 f5 (f10 f11 (f16 (f17 f18 ?v2) ?v0))) (f6 (f7 f8 (f10 f11 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f13) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f16 (f17 f18 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f13) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f16 (f17 f18 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f13) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f16 (f17 f18 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) f13) ?v0)))
(assert (forall ((?v0 S8)) (= (f16 (f17 f18 ?v0) f19) ?v0)))
(assert (= (f3 (f4 f14 f20) f9) f1))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f14 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f14 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f14 ?v0) ?v1) f1)) (or (= (f3 (f4 f14 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f14 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f14 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f21 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f22 (f23 f24 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f25 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f22 (f23 f26 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f14 (f6 (f7 f21 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f14 ?v0) ?v2) f1) (= (f3 (f4 f14 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f22 (f23 f24 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f14 (f6 (f7 f25 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f14 ?v0) ?v2) f1) (= (f3 (f4 f14 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f22 (f23 f26 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f14 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f14 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f14 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f14 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (not (= (f3 (f4 f14 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (not (= (f3 (f4 f14 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f14 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f14 ?v1) ?v2) f1) (= (f3 (f4 f14 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f14 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v2))) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f14 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f14 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f14 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v2) f1) (= (f3 (f4 f14 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v0) f1) (= (f3 (f4 f14 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f3 (f4 f14 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f3 (f4 f14 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f14 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f14 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f14 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= (f3 (f4 f14 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f14 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f14 ?v0) ?v1) f1)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f14 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f14 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f14 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f14 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f14 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f14 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f14 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f14 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f14 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f14 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f14 (f6 f15 ?v0)) ?v1) f1) (=> (= (f3 (f4 f14 (f6 f15 ?v2)) ?v3) f1) (= (f3 (f4 f14 (f6 f15 (f6 (f7 f8 ?v0) ?v2))) (f6 (f7 f8 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S8) (?v1 S3) (?v2 S8) (?v3 S3)) (=> (= (f3 (f4 f14 (f10 f11 ?v0)) ?v1) f1) (=> (= (f3 (f4 f14 (f10 f11 ?v2)) ?v3) f1) (= (f3 (f4 f14 (f10 f11 (f16 (f17 f18 ?v0) ?v2))) (f6 (f7 f8 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 (f6 f27 ?v0)) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f22 f28 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f6 (f7 f25 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f22 (f23 f26 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f21 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f22 (f23 f24 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) (f6 f27 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f22 f28 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 (f7 f8 ?v2) ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v2)) (f6 (f7 f8 ?v1) ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) (f16 (f17 f18 ?v2) ?v3)) (f16 (f17 f18 (f16 ?v_0 ?v2)) (f16 (f17 f18 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f7 f8 (f6 (f7 f8 ?v0) ?v1))) (?v_0 (f7 f8 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_1 (f17 f18 (f16 (f17 f18 ?v0) ?v1))) (?v_0 (f17 f18 ?v2))) (= (f16 ?v_1 (f16 ?v_0 ?v3)) (f16 ?v_0 (f16 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f6 (f7 f8 ?v2) ?v3))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f16 (f17 f18 ?v2) ?v3))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v_1) (f16 ?v_0 (f16 (f17 f18 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f8 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 (f17 f18 (f16 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f18 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f18 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f16 (f17 f18 ?v1) ?v2)) (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f17 f18 ?v1))) (= (f16 ?v_1 (f16 ?v_0 ?v2)) (f16 ?v_0 (f16 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3)) (= (= f13 ?v0) (= ?v0 f13))))
(assert (forall ((?v0 S8)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f6 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f15 ?v0))) (= (f6 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) f13) ?v0)))
(assert (forall ((?v0 S8)) (= (f16 (f17 f18 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) f13) ?v0)))
(assert (forall ((?v0 S8)) (= (f16 (f17 f18 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14 f13))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S13) (?v1 Int) (?v2 S3) (?v3 Int)) (=> (= (f3 (f4 f5 (f29 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f3 (f4 f14 (f29 ?v0 ?v5)) (f29 ?v0 ?v4)) f1))) (= (f3 (f4 f14 (f29 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S14) (?v1 S3) (?v2 Int) (?v3 S3)) (=> (<= (f30 ?v0 ?v1) ?v2) (=> (= (f3 (f4 f14 ?v3) ?v1) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f14 ?v5) ?v4) f1) (< (f30 ?v0 ?v5) (f30 ?v0 ?v4)))) (< (f30 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S13) (?v1 Int) (?v2 S3) (?v3 Int)) (=> (= (f3 (f4 f14 (f29 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f3 (f4 f5 (f29 ?v0 ?v5)) (f29 ?v0 ?v4)) f1))) (= (f3 (f4 f14 (f29 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S14) (?v1 S3) (?v2 Int) (?v3 S3)) (=> (< (f30 ?v0 ?v1) ?v2) (=> (= (f3 (f4 f5 ?v3) ?v1) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (<= (f30 ?v0 ?v5) (f30 ?v0 ?v4)))) (< (f30 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S13) (?v2 Int) (?v3 Int)) (=> (= (f3 (f4 f5 ?v0) (f29 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f14 (f29 ?v1 ?v4)) (f29 ?v1 ?v5)) f1))) (= (f3 (f4 f14 ?v0) (f29 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S3) (?v3 S3)) (=> (<= ?v0 (f30 ?v1 ?v2)) (=> (= (f3 (f4 f14 ?v2) ?v3) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f14 ?v4) ?v5) f1) (< (f30 ?v1 ?v4) (f30 ?v1 ?v5)))) (< ?v0 (f30 ?v1 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S13) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f14 ?v0))) (=> (= (f3 ?v_0 (f29 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f3 (f4 f5 (f29 ?v1 ?v4)) (f29 ?v1 ?v5)) f1))) (= (f3 ?v_0 (f29 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S3) (?v3 S3)) (=> (< ?v0 (f30 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (<= (f30 ?v1 ?v4) (f30 ?v1 ?v5)))) (< ?v0 (f30 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 S3)) (=> (<= ?v0 ?v1) (=> (= (f3 (f4 f14 (f29 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f3 (f4 f5 (f29 ?v2 ?v4)) (f29 ?v2 ?v5)) f1))) (= (f3 (f4 f14 (f29 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S14) (?v3 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (< (f30 ?v2 ?v1) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (<= (f30 ?v2 ?v4) (f30 ?v2 ?v5)))) (< (f30 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 S3)) (=> (< ?v0 ?v1) (=> (= (f3 (f4 f5 (f29 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f14 (f29 ?v2 ?v4)) (f29 ?v2 ?v5)) f1))) (= (f3 (f4 f14 (f29 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S14) (?v3 Int)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (<= (f30 ?v2 ?v1) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f14 ?v4) ?v5) f1) (< (f30 ?v2 ?v4) (f30 ?v2 ?v5)))) (< (f30 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S13)) (let ((?v_0 (f4 f14 ?v2))) (=> (<= ?v0 ?v1) (=> (= (f3 ?v_0 (f29 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f3 (f4 f5 (f29 ?v3 ?v5)) (f29 ?v3 ?v4)) f1))) (= (f3 ?v_0 (f29 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int) (?v3 S14)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (< ?v2 (f30 ?v3 ?v0)) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (<= (f30 ?v3 ?v5) (f30 ?v3 ?v4)))) (< ?v2 (f30 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S13)) (=> (< ?v0 ?v1) (=> (= (f3 (f4 f5 ?v2) (f29 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f3 (f4 f14 (f29 ?v3 ?v5)) (f29 ?v3 ?v4)) f1))) (= (f3 (f4 f14 ?v2) (f29 ?v3 ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int) (?v3 S14)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (<= ?v2 (f30 ?v3 ?v0)) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f14 ?v5) ?v4) f1) (< (f30 ?v3 ?v5) (f30 ?v3 ?v4)))) (< ?v2 (f30 ?v3 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (forall ((?v3 S3)) (=> (= (f3 (f4 f14 ?v0) ?v3) f1) (=> (= (f3 (f4 f14 ?v3) ?v1) f1) (= (f3 (f4 f5 ?v3) ?v2) f1)))) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (forall ((?v2 S3)) (=> (= (f3 (f4 f14 ?v2) ?v0) f1) (= (f3 (f4 f5 ?v2) ?v1) f1))) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (= (f3 (f4 f14 f20) f31) f1))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f14 f20) ?v0) f1) (exists ((?v1 S3)) (let ((?v_0 (f4 f14 ?v1))) (and (= (f3 (f4 f14 f20) ?v1) f1) (and (= (f3 ?v_0 f13) f1) (= (f3 ?v_0 ?v0) f1))))))))
(assert (= (f6 f27 f20) f20))
(assert (= (f22 f28 0) 0))
(assert (forall ((?v0 S3)) (= (= f20 ?v0) (= ?v0 f20))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S8)) (= (= f32 ?v0) (= ?v0 f32))))
(assert (forall ((?v0 S3)) (= (= (f6 f27 ?v0) f20) (= ?v0 f20))))
(assert (forall ((?v0 Int)) (= (= (f22 f28 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f6 f15 ?v0) f20) (= ?v0 f20))))
(assert (forall ((?v0 S8)) (= (= (f10 f11 ?v0) f20) (= ?v0 f32))))
(assert (= (f6 f15 f20) f20))
(assert (= (f10 f11 f32) f20))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f20) ?v0) f20)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8)) (= (f16 (f17 f18 f32) ?v0) f32)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) f20) f20)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f16 (f17 f18 ?v0) f32) f32)))
(check-sat)
(exit)
