(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 (S5 S6) S2)
(declare-fun f9 (S7 S2) S5)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S9) S2)
(declare-fun f12 () S8)
(declare-fun f13 () S9)
(declare-fun f14 (S10 Int) S6)
(declare-fun f15 () S10)
(declare-fun f16 (S11 S6) Int)
(declare-fun f17 () S11)
(declare-fun f18 () S6)
(declare-fun f19 () S2)
(declare-fun f20 () S2)
(declare-fun f21 () S2)
(declare-fun f22 () S3)
(declare-fun f23 (S2 S2) S1)
(declare-fun f24 (S12 Int) S11)
(declare-fun f25 () S12)
(declare-fun f26 (S13 S9) S9)
(declare-fun f27 (S14 S9) S13)
(declare-fun f28 () S14)
(declare-fun f29 () S3)
(declare-fun f30 () S9)
(declare-fun f31 () S3)
(declare-fun f32 (S15 S6) S9)
(declare-fun f33 (S16 S9) S15)
(declare-fun f34 () S16)
(declare-fun f35 () S9)
(declare-fun f36 () S13)
(declare-fun f37 (S17 Int) Int)
(declare-fun f38 () S17)
(declare-fun f39 () S9)
(declare-fun f40 () S14)
(declare-fun f41 () S4)
(declare-fun f42 () S14)
(declare-fun f43 () S13)
(declare-fun f44 () S4)
(declare-fun f45 () S3)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 f7) (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19)) f20) f1)))
(assert (= (f3 f21 (f8 (f9 f10 f7) f18)) f1))
(assert (= (f3 (f4 (f5 f6 f7) (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19)) f20) f1))
(assert (not (= f18 (f14 f15 0))))
(assert (= (f3 f21 f7) f1))
(assert (= (f3 f7 f20) f1))
(assert (= (f3 f21 f19) f1))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (and (= (f3 ?v1 f20) f1) (= (f3 ?v1 ?v0) f1)))))))
(assert (= (f3 f21 (f8 (f9 f10 f7) f18)) f1))
(assert (= (f3 (f4 (f5 f6 f7) (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19)) f20) f1))
(assert (= (f3 f7 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (= (f3 f21 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (let ((?v_0 (f11 f12 f13))) (= (f23 (f4 (f5 f6 f7) ?v_0) (f4 (f5 f6 f20) ?v_0)) f1)))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (= (f3 (f4 (f5 f6 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f16 (f24 f25 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (=> (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (=> (= (f3 ?v0 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1) false)))) false))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S9) (?v3 S2)) (=> (= (f3 (f11 f12 ?v0) ?v1) f1) (=> (= (f3 (f11 f12 ?v2) ?v3) f1) (= (f3 (f11 f12 (f26 (f27 f28 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v2) ?v3) f1) (= (f3 (f4 f29 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S9)) (= (= (f3 f21 (f11 f12 ?v0)) f1) (not (= ?v0 f30)))))
(assert (forall ((?v0 S2)) (= (= (f3 f21 (f4 f29 ?v0)) f1) (not (= ?v0 f21)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f20 ?v0) f1) (= (f3 f20 (f4 (f5 f6 ?v0) (f8 (f9 f10 ?v0) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 1 ?v0) (< 1 (* ?v0 (f16 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (f3 f20 ?v0) f1) (= (f3 ?v_0 (f4 (f5 f6 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f16 (f24 f25 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (* ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (= (f3 (f8 (f9 f10 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) f20) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f16 (f24 f25 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) 1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f3 f21 ?v2) f1) (=> (= (f3 ?v2 f20) f1) (= (f3 (f8 ?v_0 ?v1) (f8 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v0))))))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f31 ?v0) f20) f1) (= (f3 (f8 (f9 f10 ?v0) (f14 f15 2)) f20) f1))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f11 f12 (f32 (f33 f34 ?v0) ?v1)) (f8 (f9 f10 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f29 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f29 ?v0)) ?v1))))
(assert (not (= f35 f30)))
(assert (not (= f13 f30)))
(assert (forall ((?v0 S9)) (= (f11 f12 (f26 f36 ?v0)) (f4 f22 (f11 f12 ?v0)))))
(assert (forall ((?v0 S2)) (= (f4 f29 (f4 f22 ?v0)) (f4 f22 (f4 f29 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f26 f36 (f32 (f33 f34 ?v0) ?v1)) (f32 (f33 f34 (f26 f36 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f22 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f22 ?v0)) ?v1))))
(assert (forall ((?v0 S9) (?v1 S6) (?v2 S6)) (let ((?v_0 (f33 f34 ?v0))) (= (f32 ?v_0 (f14 f15 (* (f16 f17 ?v1) (f16 f17 ?v2)))) (f32 (f33 f34 (f32 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (* (f16 f17 ?v1) (f16 f17 ?v2)))) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f30)) (= (f11 f12 (f26 f36 ?v0)) (f4 f22 (f11 f12 ?v0))))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 f29 (f4 f22 ?v0)) (f4 f22 (f4 f29 ?v0))))))
(assert (forall ((?v0 S9) (?v1 S6)) (=> (not (= ?v0 f30)) (= (f26 f36 (f32 (f33 f34 ?v0) ?v1)) (f32 (f33 f34 (f26 f36 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (not (= ?v0 f21)) (= (f4 f22 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f22 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f16 (f24 f25 ?v0) ?v_0) (f16 (f24 f25 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v2) ?v_0)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (<= (f16 (f24 f25 ?v0) ?v_0) (f16 (f24 f25 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f23 (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v2) ?v_0)) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (=> (= (f16 (f24 f25 ?v0) ?v1) (f16 (f24 f25 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f16 f17 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (=> (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v2) f1) (=> (< 0 (f16 f17 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f16 (f24 f25 ?v0) ?v2) (f16 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 f21 ?v0) f1) (= (f23 (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 0 ?v0) (<= 0 (f16 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f23 f21 ?v0) f1) (= (f23 f21 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f23 f21 (f8 (f9 f10 (f4 f31 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S6)) (<= 0 (f16 (f24 f25 (f37 f38 ?v0)) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f23 f20 ?v2) f1) (= (f23 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (<= 1 ?v2) (<= (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f23 f20 ?v0) f1) (= (f23 f20 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 1 ?v0) (<= 1 (f16 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S9)) (= (f23 f21 (f11 f12 ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 f21 ?v1) f1) (=> (= (f3 (f4 (f5 f6 ?v1) ?v2) (f4 (f5 f6 ?v0) ?v3)) f1) (= (f3 (f4 (f5 f6 (f4 f22 ?v0)) ?v2) (f4 (f5 f6 (f4 f22 ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 f21 ?v1) f1) (=> (= (f3 (f4 (f5 f6 ?v1) ?v2) (f4 (f5 f6 ?v0) ?v3)) f1) (= (f3 (f4 (f5 f6 ?v2) (f4 f22 ?v0)) (f4 (f5 f6 ?v3) (f4 f22 ?v1))) f1))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (=> (< (f16 (f24 f25 ?v0) ?v1) (f16 (f24 f25 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (=> (= (f3 (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1)) f1) (=> (= (f23 f21 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f16 f17 ?v2)) (< (f16 (f24 f25 ?v0) ?v2) (f16 (f24 f25 ?v1) ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f23 f21 ?v0) f1) (=> (< 0 (f16 f17 ?v2)) (= (f3 (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f23 f21 ?v2) f1) (=> (= (f23 ?v2 f20) f1) (= (f23 (f8 ?v_0 ?v1) (f8 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v0))))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (=> (= (f23 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (=> (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (= (= (f23 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (= (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S9)) (= (= (f23 (f11 f12 ?v0) f21) f1) (= ?v0 f30))))
(assert (forall ((?v0 S2)) (= (= (f23 (f4 f29 ?v0) f21) f1) (= ?v0 f21))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v0) ?v1)) (f4 (f5 f6 (f11 f12 ?v0)) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f29 ?v0)) (f4 f29 ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f23 (f11 f12 (f32 (f33 f34 ?v0) ?v1)) (f8 (f9 f10 (f11 f12 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f23 (f4 f29 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f29 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 S9)) (= (f32 (f33 f34 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f31 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f31 ?v0)) ?v1))))
(assert (forall ((?v0 S9)) (let ((?v_0 (f11 f12 ?v0))) (= (f4 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 S9)) (= (f26 (f27 f28 ?v0) f30) f30)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f21) f21)))
(assert (forall ((?v0 S9)) (= (f26 (f27 f28 ?v0) f30) f30)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f21) f21)))
(assert (forall ((?v0 S9)) (= (f26 (f27 f28 f30) ?v0) f30)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f21) ?v0) f21)))
(assert (forall ((?v0 S9)) (= (f26 (f27 f28 f30) ?v0) f30)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f21) ?v0) f21)))
(assert (forall ((?v0 S9) (?v1 S6)) (=> (not (= ?v0 f30)) (not (= (f32 (f33 f34 ?v0) ?v1) f30)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (not (= ?v0 0)) (not (= (f16 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (not (= ?v0 f21)) (not (= (f8 (f9 f10 ?v0) ?v1) f21)))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (= (f32 (f33 f34 ?v0) ?v1) f30) (and (= ?v0 f30) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f16 (f24 f25 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (= (f8 (f9 f10 ?v0) ?v1) f21) (and (= ?v0 f21) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S6)) (= (f32 (f33 f34 f30) (f14 f15 (+ (f16 f17 ?v0) 1))) f30)))
(assert (forall ((?v0 S6)) (= (f16 (f24 f25 0) (f14 f15 (+ (f16 f17 ?v0) 1))) 0)))
(assert (forall ((?v0 S6)) (= (f8 (f9 f10 f21) (f14 f15 (+ (f16 f17 ?v0) 1))) f21)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S9)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f33 f34 ?v2))) (=> (<= ?v_1 ?v_0) (= (f32 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f26 (f27 f28 (f32 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f9 f10 ?v2))) (=> (<= ?v_1 ?v_0) (= (f8 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f4 (f5 f6 (f8 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f24 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f16 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (* (f16 ?v_2 (f14 f15 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S6)) (= (f32 (f33 f34 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f28 (f32 (f33 f34 ?v0) ?v2)) (f32 (f33 f34 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (= (f8 (f9 f10 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f8 (f9 f10 ?v0) ?v2)) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f16 (f24 f25 (* ?v0 ?v1)) ?v2) (* (f16 (f24 f25 ?v0) ?v2) (f16 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f32 (f33 f34 ?v0) ?v1))) (= (f26 (f27 f28 ?v_0) ?v0) (f26 (f27 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f4 (f5 f6 ?v_0) ?v0) (f4 (f5 f6 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f16 (f24 f25 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S9) (?v1 S6) (?v2 S6)) (let ((?v_0 (f33 f34 ?v0))) (= (f32 ?v_0 (f14 f15 (+ (f16 f17 ?v1) (f16 f17 ?v2)))) (f26 (f27 f28 (f32 ?v_0 ?v1)) (f32 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (+ (f16 f17 ?v1) (f16 f17 ?v2)))) (f4 (f5 f6 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f16 ?v_0 (f14 f15 (+ (f16 f17 ?v1) (f16 f17 ?v2)))) (* (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f33 f34 ?v0))) (= (f32 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f26 (f27 f28 (f32 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f4 (f5 f6 (f8 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f16 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (* (f16 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f33 f34 ?v0))) (= (f32 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f26 (f27 f28 ?v0) (f32 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (f4 (f5 f6 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f16 ?v_0 (f14 f15 (+ (f16 f17 ?v1) 1))) (* ?v0 (f16 ?v_0 ?v1))))))
(assert (forall ((?v0 S9)) (= (f32 (f33 f34 ?v0) (f14 f15 0)) f39)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) (f14 f15 0)) f20)))
(assert (forall ((?v0 Int)) (= (f16 (f24 f25 ?v0) (f14 f15 0)) 1)))
(assert (forall ((?v0 S6)) (= (f32 (f33 f34 f39) ?v0) f39)))
(assert (forall ((?v0 S6)) (= (f8 (f9 f10 f20) ?v0) f20)))
(assert (forall ((?v0 S6)) (= (f16 (f24 f25 1) ?v0) 1)))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 0 ?v0) (< 0 (f16 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f21 ?v0) f1) (= (f3 f21 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S6)) (= (f32 (f33 f34 f30) ?v0) (ite (= ?v0 (f14 f15 0)) f39 f30))))
(assert (forall ((?v0 S6)) (= (f8 (f9 f10 f21) ?v0) (ite (= ?v0 (f14 f15 0)) f20 f21))))
(assert (forall ((?v0 S6)) (= (f16 (f24 f25 0) ?v0) (ite (= ?v0 (f14 f15 0)) 1 0))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f3 f20 ?v2) f1) (= (f3 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (< 1 ?v2) (< (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (=> (= (f3 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (=> (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f20 ?v0) f1) (=> (< 0 (f16 f17 ?v1)) (= (f3 f20 (f8 (f9 f10 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 1 ?v0) (=> (< 0 (f16 f17 ?v1)) (< 1 (f16 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (= (= (f3 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (= (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (< (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (= (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (= (= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f20 ?v0) f1) (= (f3 f20 (f8 (f9 f10 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 1 ?v0) (< 1 (f16 (f24 f25 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1)))))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f33 f34 ?v0))) (= (f32 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) f39 (f26 (f27 f28 ?v0) (f32 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) f20 (f4 (f5 f6 ?v0) (f8 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f16 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) 1 (* ?v0 (f16 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 S9)) (= (= (f11 f12 ?v0) f21) (= ?v0 f30))))
(assert (forall ((?v0 S2)) (= (= (f4 f29 ?v0) f21) (= ?v0 f21))))
(assert (= (f11 f12 f30) f21))
(assert (= (f4 f29 f21) f21))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f11 f12 (f26 (f27 f28 ?v0) ?v1)) (f4 (f5 f6 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f29 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f29 ?v0)) (f4 f29 ?v1)))))
(assert (forall ((?v0 S9)) (not (= (f3 (f11 f12 ?v0) f21) f1))))
(assert (= (f11 f12 f39) f20))
(assert (= (f4 f29 f20) f20))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (forall ((?v2 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v2) ?v0)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (forall ((?v2 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v2) ?v0)) (f4 (f5 f6 (f4 f29 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (forall ((?v2 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v0) ?v2)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (forall ((?v2 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 (f4 f29 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S2)) (and (= (f3 f21 ?v0) f1) (forall ((?v1 S9) (?v2 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f11 f12 ?v1)) (f11 f12 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S2)) (and (= (f3 f21 ?v0) f1) (forall ((?v1 S2) (?v2 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f4 f29 ?v1)) (f4 f29 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S9)) (=> (= (f23 ?v0 (f11 f12 ?v1)) f1) (=> (= (f3 f21 ?v0) f1) (= (f23 (f11 f12 (f26 f36 ?v1)) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 (f4 f29 ?v1)) f1) (=> (= (f3 f21 ?v0) f1) (= (f23 (f4 f29 (f4 f22 ?v1)) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (and (= (f23 f21 ?v1) f1) (forall ((?v2 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v2) ?v0)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (and (= (f23 f21 ?v1) f1) (forall ((?v2 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v2) ?v0)) (f4 (f5 f6 (f4 f29 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (and (= (f23 f21 ?v1) f1) (forall ((?v2 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v0) ?v2)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (and (= (f23 f21 ?v1) f1) (forall ((?v2 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 (f4 f29 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S2)) (and (= (f23 f21 ?v0) f1) (forall ((?v1 S9) (?v2 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f11 f12 ?v1)) (f11 f12 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S2)) (and (= (f23 f21 ?v0) f1) (forall ((?v1 S2) (?v2 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f4 f29 ?v1)) (f4 f29 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S9) (?v2 S9)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 (f11 f12 ?v1) (f4 (f5 f6 ?v0) (f11 f12 ?v2))) f1) (= ?v1 f30)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 (f4 f29 ?v1) (f4 (f5 f6 ?v0) (f4 f29 ?v2))) f1) (= ?v1 f21)))))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f23 ?v0 f20) f1) (= (f23 f20 (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f22 ?v0) f20) f1) (or (= (f23 ?v0 f21) f1) (= (f3 f20 ?v0) f1)))))
(assert (= (f26 (f27 f40 f39) (f26 (f27 f28 (f32 (f33 f34 f13) f18)) f35)) f30))
(assert (forall ((?v0 S2)) (= (f4 f31 (f4 f22 ?v0)) (f4 f22 (f4 f31 ?v0)))))
(assert (= (f26 f36 f30) f30))
(assert (= (f4 f22 f21) f21))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 f31 (f4 f22 ?v0)) (f4 f22 (f4 f31 ?v0))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f26 f36 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f36 ?v0)) (f26 f36 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f22 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f22 ?v0)) (f4 f22 ?v1)))))
(assert (forall ((?v0 S9)) (= (= (f26 f36 ?v0) f39) (= ?v0 f39))))
(assert (forall ((?v0 S2)) (= (= (f4 f22 ?v0) f20) (= ?v0 f20))))
(assert (forall ((?v0 S2)) (= (= (f23 (f4 f22 ?v0) f21) f1) (= (f23 ?v0 f21) f1))))
(assert (forall ((?v0 S2)) (= (= (f23 f21 (f4 f22 ?v0)) f1) (= (f23 f21 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (= (f3 f21 (f4 f22 ?v0)) f1) (= (f3 f21 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f22 ?v0) f21) f1) (= (f3 ?v0 f21) f1))))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (= (f3 f21 (f4 f22 ?v0)) f1))))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 (f4 f22 ?v0)) f1) (=> (not (= ?v0 f21)) (= (f3 f21 ?v0) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0 f21) f1) (= (f3 (f4 f22 ?v0) f21) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 f21 ?v0) f1) (= (f3 (f4 f22 ?v1) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 f21) f1) (= (f3 (f4 f22 ?v1) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f22 ?v0) f21) f1) (=> (not (= ?v0 f21)) (= (f3 ?v0 f21) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (=> (= (f3 f21 ?v0) f1) (= (f3 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (=> (= (f3 ?v1 f21) f1) (= (f3 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 (f4 f31 ?v1) (f4 (f5 f6 ?v0) (f4 f31 ?v2))) f1) (= ?v1 f21)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f3 f21 ?v0) f1) (= (f23 (f4 f22 ?v1) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f3 ?v1 f21) f1) (= (f23 (f4 f22 ?v1) (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (=> (= (f3 f21 ?v0) f1) (= (f23 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (=> (= (f3 ?v1 f21) f1) (= (f23 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f23 (f4 f22 ?v0) f20) f1) (or (= (f23 ?v0 f21) f1) (= (f23 f20 ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f20 (f4 f22 ?v0)) f1) (and (= (f3 f21 ?v0) f1) (= (f3 ?v0 f20) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (= (f3 f20 (f4 f22 ?v0)) f1)))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f30)) (= (f26 (f27 f28 (f26 f36 ?v0)) ?v0) f39))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 (f5 f6 (f4 f22 ?v0)) ?v0) f20))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (= (= (f3 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (and (=> (= (f3 f21 ?v_0) f1) (= (f3 ?v1 ?v0) f1)) (=> (= (f23 ?v_0 f21) f1) (= (f3 ?v0 ?v1) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (= (= (f23 (f4 f22 ?v0) (f4 f22 ?v1)) f1) (and (=> (= (f3 f21 ?v_0) f1) (= (f23 ?v1 ?v0) f1)) (=> (= (f23 ?v_0 f21) f1) (= (f23 ?v0 ?v1) f1)))))))
(assert (forall ((?v0 S2)) (= (= (f23 f20 (f4 f22 ?v0)) f1) (and (= (f3 f21 ?v0) f1) (= (f23 ?v0 f20) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (forall ((?v2 S2)) (=> (= (f3 f21 ?v2) f1) (=> (= (f3 ?v2 f20) f1) (= (f23 (f4 (f5 f6 ?v2) ?v0) ?v1) f1)))) (= (f23 ?v0 ?v1) f1))))
(assert (exists ((?v0 S2)) (forall ((?v1 S9) (?v2 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f11 f12 ?v1)) (f11 f12 ?v2))) ?v0)) f1))))
(assert (exists ((?v0 S2)) (forall ((?v1 S2) (?v2 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 (f5 f6 (f4 f29 ?v1)) (f4 f29 ?v2))) ?v0)) f1))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (forall ((?v2 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v0) ?v2)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 (f4 f29 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S9)) (exists ((?v1 S2)) (forall ((?v2 S9)) (= (f23 (f11 f12 (f26 (f27 f28 ?v2) ?v0)) (f4 (f5 f6 (f11 f12 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (= (f23 (f4 f29 (f4 (f5 f6 ?v2) ?v0)) (f4 (f5 f6 (f4 f29 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 (f5 f6 (f4 f22 ?v0)) ?v0) f20))))
(assert (=> (forall ((?v0 S9)) (=> (= (f26 (f27 f40 f39) (f26 (f27 f28 (f32 (f33 f34 ?v0) f18)) f35)) f30) false)) false))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 (f4 f29 (f4 (f5 f41 ?v0) ?v1)) (f4 (f5 f41 (f4 f29 ?v0)) (f4 f29 ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f23 (f11 f12 (f26 (f27 f40 ?v0) ?v1)) (f4 (f5 f41 (f11 f12 ?v0)) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v2) ?v3) f1) (= (f3 (f4 f29 (f4 (f5 f41 ?v0) ?v2)) (f4 (f5 f41 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S9) (?v3 S2)) (=> (= (f3 (f11 f12 ?v0) ?v1) f1) (=> (= (f3 (f11 f12 ?v2) ?v3) f1) (= (f3 (f11 f12 (f26 (f27 f40 ?v0) ?v2)) (f4 (f5 f41 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f41 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f26 (f27 f28 (f26 (f27 f40 ?v0) ?v1)) ?v2) (f26 (f27 f40 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f41 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f26 (f27 f28 (f26 (f27 f40 ?v0) ?v1)) ?v2) (f26 (f27 f40 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f41 ?v1) ?v2)) (f4 (f5 f41 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f40 ?v1) ?v2)) (f26 (f27 f40 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f41 ?v1) ?v2)) (f4 (f5 f41 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f40 ?v1) ?v2)) (f26 (f27 f40 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f22 ?v0)) (?v_1 (f4 f22 ?v1))) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (= (f4 (f5 f41 ?v_0) ?v_1) (f4 (f5 f6 (f4 (f5 f6 (f4 (f5 f41 ?v0) ?v1)) ?v_0)) ?v_1)))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f26 f36 ?v0)) (?v_1 (f26 f36 ?v1))) (=> (not (= ?v0 f30)) (=> (not (= ?v1 f30)) (= (f26 (f27 f40 ?v_0) ?v_1) (f26 (f27 f28 (f26 (f27 f28 (f26 (f27 f40 ?v0) ?v1)) ?v_0)) ?v_1)))))))
(assert (forall ((?v0 S2)) (= (f23 ?v0 ?v0) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f23 ?v0 ?v1) f1) (= (f23 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v2) f1) (= (f23 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S9)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f33 f34 ?v1))) (=> (< 0 ?v_0) (= (f26 (f27 f28 (f32 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f32 ?v_1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S2)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f9 f10 ?v1))) (=> (< 0 ?v_0) (= (f4 (f5 f6 (f8 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f8 ?v_1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 Int)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f24 f25 ?v1))) (=> (< 0 ?v_0) (= (* (f16 ?v_1 (f14 f15 (- ?v_0 1))) ?v1) (f16 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f23 ?v0 ?v1) f1) (or (= (f3 ?v0 ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 ?v0 ?v1) f1) (and (= (f23 ?v0 ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (not (= ?v0 f21)) (= (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (= (= (f4 (f5 f6 ?v1) ?v0) (f4 (f5 f6 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (not (= f21 f20)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f20) ?v0) ?v0)))
(assert (= (f4 f22 f21) f21))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 f21 ?v1) f1) (= (f3 f21 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f21 ?v0) f1) (= (= (f3 (f4 (f5 f6 ?v1) ?v0) (f4 (f5 f6 ?v2) ?v0)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 ?v0 f20) f1) (= (f23 (f8 (f9 f10 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 0 ?v0) (=> (<= ?v0 1) (<= (f16 (f24 f25 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f3 f21 ?v0) f1) (= (= (f23 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (= (f23 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f21 ?v0) f1) (= (= (f23 (f4 (f5 f6 ?v1) ?v0) (f4 (f5 f6 ?v2) ?v0)) f1) (= (f23 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S9) (?v1 S6)) (=> (not (= ?v0 f30)) (=> (not (= ?v1 (f14 f15 0))) (exists ((?v2 S9)) (= (f3 (f11 f12 (f26 (f27 f40 f39) (f26 (f27 f28 ?v0) (f32 (f33 f34 ?v2) ?v1)))) f20) f1))))))
(assert (= (f26 (f27 f42 (f26 (f27 f40 f39) (f26 (f27 f28 (f32 (f33 f34 f13) f18)) f35))) f39) (f26 (f27 f42 f30) f39)))
(assert (= (f26 (f27 f28 (f32 (f33 f34 f13) f18)) f35) (f26 f43 f39)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 ?v1) f1) (=> (= (f23 f21 ?v3) f1) (=> (= (f23 f21 ?v4) f1) (=> (= (f4 (f5 f41 ?v3) ?v4) f20) (= (f3 (f4 (f5 f41 (f4 (f5 f6 ?v3) ?v0)) (f4 (f5 f6 ?v4) ?v2)) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (< (+ (* ?v3 ?v0) (* ?v4 ?v2)) ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v3) ?v1)) ?v4)) (= ?v2 (f4 (f5 f41 (f4 (f5 f6 (f4 (f5 f44 ?v3) ?v0)) ?v1)) ?v4)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S9)) (= (= (f26 (f27 f40 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f40 (f26 (f27 f28 ?v3) ?v1)) ?v4)) (= ?v2 (f26 (f27 f40 (f26 (f27 f28 (f26 (f27 f42 ?v3) ?v0)) ?v1)) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (= ?v2 (+ (* (- ?v3 ?v0) ?v1) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v3) ?v1)) ?v4)) (= (f4 (f5 f41 (f4 (f5 f6 (f4 (f5 f44 ?v0) ?v3)) ?v1)) ?v2) ?v4))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S9)) (= (= (f26 (f27 f40 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f40 (f26 (f27 f28 ?v3) ?v1)) ?v4)) (= (f26 (f27 f40 (f26 (f27 f28 (f26 (f27 f42 ?v0) ?v3)) ?v1)) ?v2) ?v4))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (= (+ (* (- ?v0 ?v3) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (* ?v0 ?v1)) (* ?v0 (- ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 f43 (f26 ?v_0 ?v1)) (f26 ?v_0 (f26 f43 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 f45 (f4 ?v_0 ?v1)) (f4 ?v_0 (f4 f45 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (* ?v0 ?v1)) (* (- ?v0) ?v1))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f26 f43 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f43 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f45 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f45 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (- ?v0) ?v1) (* ?v0 (- ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f26 (f27 f28 (f26 f43 ?v0)) ?v1) (f26 (f27 f28 ?v0) (f26 f43 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 (f4 f45 ?v0)) ?v1) (f4 (f5 f6 ?v0) (f4 f45 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (- ?v0) (- ?v1)) (* ?v0 ?v1))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f26 (f27 f28 (f26 f43 ?v0)) (f26 f43 ?v1)) (f26 (f27 f28 ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 (f4 f45 ?v0)) (f4 f45 ?v1)) (f4 (f5 f6 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v0) (* ?v1 ?v1)) (or (= ?v0 ?v1) (= ?v0 (- ?v1))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f26 (f27 f28 ?v0) ?v0) (f26 (f27 f28 ?v1) ?v1)) (or (= ?v0 ?v1) (= ?v0 (f26 f43 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f6 ?v0) ?v0) (f4 (f5 f6 ?v1) ?v1)) (or (= ?v0 ?v1) (= ?v0 (f4 f45 ?v1))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f14 f15 (+ (+ 0 1) 1)))) (= (= (f32 (f33 f34 ?v0) ?v_0) (f32 (f33 f34 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (f26 f43 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 (+ (+ 0 1) 1)))) (= (= (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (f4 f45 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f41 ?v2))) (=> (= (f23 ?v0 ?v1) f1) (= (f23 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f41 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 (f4 f29 (f4 (f5 f44 ?v0) ?v1)) (f4 (f5 f41 (f4 f29 ?v0)) (f4 f29 ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f23 (f11 f12 (f26 (f27 f42 ?v0) ?v1)) (f4 (f5 f41 (f11 f12 ?v0)) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f44 ?v1) ?v2)) (f4 (f5 f44 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f42 ?v1) ?v2)) (f26 (f27 f42 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f44 ?v1) ?v2)) (f4 (f5 f44 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f42 ?v1) ?v2)) (f26 (f27 f42 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f44 ?v0) ?v1)) ?v2) (f4 (f5 f44 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f26 (f27 f28 (f26 (f27 f42 ?v0) ?v1)) ?v2) (f26 (f27 f42 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f44 ?v0) ?v1)) ?v2) (f4 (f5 f44 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f26 (f27 f28 (f26 (f27 f42 ?v0) ?v1)) ?v2) (f26 (f27 f42 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f26 (f27 f28 (f26 f43 ?v0)) ?v1) (f26 f43 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 (f4 f45 ?v0)) ?v1) (f4 f45 (f4 (f5 f6 ?v0) ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f26 (f27 f28 (f26 f43 ?v0)) ?v1) (f26 f43 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 (f4 f45 ?v0)) ?v1) (f4 f45 (f4 (f5 f6 ?v0) ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 f43 ?v1)) (f26 f43 (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 f45 ?v1)) (f4 f45 (f4 ?v_0 ?v1))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 f43 ?v1)) (f26 f43 (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 f45 ?v1)) (f4 f45 (f4 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f31 (f8 (f9 f10 (f4 f45 ?v0)) ?v1)) (f4 f31 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f29 (f4 (f5 f44 ?v0) ?v1)) (f4 f29 (f4 (f5 f44 ?v1) ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f11 f12 (f26 (f27 f42 ?v0) ?v1)) (f11 f12 (f26 (f27 f42 ?v1) ?v0)))))
(assert (forall ((?v0 S9)) (= (f11 f12 (f26 f43 ?v0)) (f11 f12 ?v0))))
(assert (forall ((?v0 Int)) (= (< ?v0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f3 ?v0 (f4 f45 ?v0)) f1) (= (f3 ?v0 f21) f1))))
(assert (forall ((?v0 S9)) (= (= (f26 (f27 f28 ?v0) ?v0) f39) (or (= ?v0 f39) (= ?v0 (f26 f43 f39))))))
(assert (forall ((?v0 S2)) (= (= (f4 (f5 f6 ?v0) ?v0) f20) (or (= ?v0 f20) (= ?v0 (f4 f45 f20))))))
(assert (forall ((?v0 Int)) (= (= (* ?v0 ?v0) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f30)) (= (f26 f36 (f26 f43 ?v0)) (f26 f43 (f26 f36 ?v0))))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 f22 (f4 f45 ?v0)) (f4 f45 (f4 f22 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 (f4 f31 (f4 (f5 f44 (f4 f29 ?v0)) (f4 f29 ?v1))) (f4 f29 (f4 (f5 f44 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f23 (f4 f31 (f4 (f5 f44 (f11 f12 ?v0)) (f11 f12 ?v1))) (f11 f12 (f26 (f27 f42 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 (f4 (f5 f44 (f4 f29 ?v0)) (f4 f29 ?v1)) (f4 f29 (f4 (f5 f44 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f23 (f4 (f5 f44 (f11 f12 ?v0)) (f11 f12 ?v1)) (f11 f12 (f26 (f27 f42 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S9)) (= (f26 f36 (f26 f43 ?v0)) (f26 f43 (f26 f36 ?v0)))))
(assert (forall ((?v0 S2)) (= (f4 f22 (f4 f45 ?v0)) (f4 f45 (f4 f22 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f31 ?v0) ?v1) f1) (and (= (f3 ?v0 ?v1) f1) (= (f3 (f4 f45 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f37 f38 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f23 (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v3) ?v1)) ?v4)) f1) (= (f23 ?v2 (f4 (f5 f41 (f4 (f5 f6 (f4 (f5 f44 ?v3) ?v0)) ?v1)) ?v4)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (<= (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (<= ?v2 (+ (* (- ?v3 ?v0) ?v1) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f23 (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v3) ?v1)) ?v4)) f1) (= (f23 (f4 (f5 f41 (f4 (f5 f6 (f4 (f5 f44 ?v0) ?v3)) ?v1)) ?v2) ?v4) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (<= (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (<= (+ (* (- ?v0 ?v3) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f3 (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v3) ?v1)) ?v4)) f1) (= (f3 (f4 (f5 f41 (f4 (f5 f6 (f4 (f5 f44 ?v0) ?v3)) ?v1)) ?v2) ?v4) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (< (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (< (+ (* (- ?v0 ?v3) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (= (= (f3 (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v3) ?v1)) ?v4)) f1) (= (f3 ?v2 (f4 (f5 f41 (f4 (f5 f6 (f4 (f5 f44 ?v3) ?v0)) ?v1)) ?v4)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (< (+ (* ?v0 ?v1) ?v2) (+ (* ?v3 ?v1) ?v4)) (< ?v2 (+ (* (- ?v3 ?v0) ?v1) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f5 f6 ?v2)) (?v_0 (f5 f6 (f4 (f5 f44 ?v0) ?v2))) (?v_2 (f4 (f5 f44 ?v1) ?v3))) (= (f4 (f5 f44 (f4 (f5 f6 ?v0) ?v1)) (f4 ?v_1 ?v3)) (f4 (f5 f41 (f4 (f5 f41 (f4 ?v_0 ?v_2)) (f4 ?v_0 ?v3))) (f4 ?v_1 ?v_2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_1 (f27 f28 ?v2)) (?v_0 (f27 f28 (f26 (f27 f42 ?v0) ?v2))) (?v_2 (f26 (f27 f42 ?v1) ?v3))) (= (f26 (f27 f42 (f26 (f27 f28 ?v0) ?v1)) (f26 ?v_1 ?v3)) (f26 (f27 f40 (f26 (f27 f40 (f26 ?v_0 ?v_2)) (f26 ?v_0 ?v3))) (f26 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f44 (f4 ?v_0 ?v1)) (f4 (f5 f6 ?v2) ?v3)) (f4 (f5 f41 (f4 ?v_0 (f4 (f5 f44 ?v1) ?v3))) (f4 (f5 f6 (f4 (f5 f44 ?v0) ?v2)) ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f42 (f26 ?v_0 ?v1)) (f26 (f27 f28 ?v2) ?v3)) (f26 (f27 f40 (f26 ?v_0 (f26 (f27 f42 ?v1) ?v3))) (f26 (f27 f28 (f26 (f27 f42 ?v0) ?v2)) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 (- ?v1 ?v3)) (* (- ?v0 ?v2) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f41 ?v0) ?v1) f21) (= ?v1 (f4 f45 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f26 (f27 f40 ?v0) ?v1) f30) (= ?v1 (f26 f43 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ ?v0 ?v1) 0) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f26 f36 ?v0)) (?v_1 (f26 f36 ?v1))) (=> (not (= ?v0 f30)) (=> (not (= ?v1 f30)) (= (f26 (f27 f42 ?v_0) ?v_1) (f26 (f27 f28 (f26 (f27 f28 ?v_0) (f26 (f27 f42 ?v1) ?v0))) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f22 ?v0)) (?v_1 (f4 f22 ?v1))) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (= (f4 (f5 f44 ?v_0) ?v_1) (f4 (f5 f6 (f4 (f5 f6 ?v_0) (f4 (f5 f44 ?v1) ?v0))) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v0)) (f4 (f5 f6 ?v1) ?v1)) f21) (and (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 2))) (= (= (f4 (f5 f41 (f8 (f9 f10 ?v0) ?v_0)) (f8 (f9 f10 ?v1) ?v_0)) f21) (and (= ?v0 f21) (= ?v1 f21))))))
(assert (forall ((?v0 S2)) (not (= (f3 (f4 (f5 f41 (f4 f31 ?v0)) f20) ?v0) f1))))
(assert (forall ((?v0 S9)) (= (f26 (f27 f42 (f26 (f27 f28 ?v0) ?v0)) f39) (f26 (f27 f28 (f26 (f27 f40 ?v0) f39)) (f26 (f27 f42 ?v0) f39)))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f44 (f4 (f5 f6 ?v0) ?v0)) f20) (f4 (f5 f6 (f4 (f5 f41 ?v0) f20)) (f4 (f5 f44 ?v0) f20)))))
(assert (forall ((?v0 Int)) (= (- (* ?v0 ?v0) 1) (* (+ ?v0 1) (- ?v0 1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f14 f15 (+ (+ 0 1) 1)))) (= (f4 (f5 f44 (f8 (f9 f10 ?v0) ?v_0)) (f8 (f9 f10 ?v1) ?v_0)) (f4 (f5 f6 (f4 (f5 f44 ?v0) ?v1)) (f4 (f5 f41 ?v0) ?v1))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f14 f15 (+ (+ 0 1) 1)))) (= (f26 (f27 f42 (f32 (f33 f34 ?v0) ?v_0)) (f32 (f33 f34 ?v1) ?v_0)) (f26 (f27 f28 (f26 (f27 f42 ?v0) ?v1)) (f26 (f27 f40 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 (+ (+ 0 1) 1)))) (= (- (f16 (f24 f25 ?v0) ?v_0) (f16 (f24 f25 ?v1) ?v_0)) (* (- ?v0 ?v1) (+ ?v0 ?v1))))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f32 (f33 f34 (f26 f43 ?v0)) ?v1) (f26 (f27 f28 (f32 (f33 f34 (f26 f43 f39)) ?v1)) (f32 (f33 f34 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f8 (f9 f10 (f4 f45 ?v0)) ?v1) (f4 (f5 f6 (f8 (f9 f10 (f4 f45 f20)) ?v1)) (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (f16 (f24 f25 (- ?v0)) ?v1) (* (f16 (f24 f25 (- 1)) ?v1) (f16 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f23 (f4 f29 (f4 (f5 f44 (f4 (f5 f41 ?v0) ?v1)) (f4 (f5 f41 ?v2) ?v3))) (f4 (f5 f41 (f4 f29 (f4 (f5 f44 ?v0) ?v2))) (f4 f29 (f4 (f5 f44 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (= (f23 (f11 f12 (f26 (f27 f42 (f26 (f27 f40 ?v0) ?v1)) (f26 (f27 f40 ?v2) ?v3))) (f4 (f5 f41 (f11 f12 (f26 (f27 f42 ?v0) ?v2))) (f11 f12 (f26 (f27 f42 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 S2)) (= (f3 f21 (f4 (f5 f41 f20) (f4 f31 ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f31 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f31 ?v0)) (f4 f31 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f37 f38 (* ?v0 ?v1)) (* (f37 f38 ?v0) (f37 f38 ?v1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f31 ?v0))) (= (f4 (f5 f6 ?v_0) ?v_0) (f4 (f5 f6 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f37 f38 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (= (f4 f31 f20) f20))
(assert (= (f37 f38 1) 1))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f23 (f11 f12 ?v0) (f4 (f5 f41 (f11 f12 (f26 (f27 f40 ?v0) ?v1))) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 f22 ?v0) (f4 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 f22 ?v0) (f4 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2)) (= (f4 f22 (f4 f22 ?v0)) ?v0)))
(assert (forall ((?v0 S9)) (= (f26 (f27 f28 f30) ?v0) f30)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f21) ?v0) f21)))
(assert (forall ((?v0 S9)) (= (f26 (f27 f28 ?v0) f30) f30)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f21) f21)))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f26 (f27 f28 ?v0) ?v1) f30) (or (= ?v0 f30) (= ?v1 f30)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f6 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (not (= ?v0 f30)) (=> (not (= ?v1 f30)) (not (= (f26 (f27 f28 ?v0) ?v1) f30))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (not (= (f4 (f5 f6 ?v0) ?v1) f21))))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f26 (f27 f28 ?v0) ?v1) f30) (or (= ?v0 f30) (= ?v1 f30)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f31 ?v0)) (?v_1 (f4 f31 ?v2))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_1 ?v3) f1) (= (f3 (f4 (f5 f6 ?v_0) ?v_1) (f4 (f5 f6 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f37 f38 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (not (= f39 f30)))
(assert (not (= f20 f21)))
(assert (not (= 1 0)))
(assert (not (= f30 f39)))
(assert (not (= f21 f20)))
(assert (not (= 0 1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f41 (f4 (f5 f6 ?v2) ?v1)) ?v3)) (f4 (f5 f41 (f4 (f5 f6 (f4 (f5 f41 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (= (f26 (f27 f40 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f40 (f26 (f27 f28 ?v2) ?v1)) ?v3)) (f26 (f27 f40 (f26 (f27 f28 (f26 (f27 f40 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f41 ?v0) ?v1)) ?v2) (f4 (f5 f41 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f26 (f27 f28 (f26 (f27 f40 ?v0) ?v1)) ?v2) (f26 (f27 f40 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (= (f26 f36 f30) f30))
(assert (= (f4 f22 f21) f21))
(assert (forall ((?v0 S9)) (= (= (f26 f36 ?v0) f30) (= ?v0 f30))))
(assert (forall ((?v0 S2)) (= (= (f4 f22 ?v0) f21) (= ?v0 f21))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f30)) (not (= (f26 f36 ?v0) f30)))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (not (= (f4 f22 ?v0) f21)))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f30)) (= (f26 f36 (f26 f36 ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 f22 (f4 f22 ?v0)) ?v0))))
(assert (forall ((?v0 S9)) (=> (= (f26 f36 ?v0) f30) (= ?v0 f30))))
(assert (forall ((?v0 S2)) (=> (= (f4 f22 ?v0) f21) (= ?v0 f21))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f26 f36 ?v0) (f26 f36 ?v1)) (=> (not (= ?v0 f30)) (=> (not (= ?v1 f30)) (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 f22 ?v0) (f4 f22 ?v1)) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (= ?v0 ?v1))))))
(assert (= (f26 f36 f39) f39))
(assert (= (f4 f22 f20) f20))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f23 f21 (f4 (f5 f6 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f23 f21 (f4 (f5 f6 ?v0) ?v1)) f1) (or (and (= (f23 f21 ?v0) f1) (= (f23 f21 ?v1) f1)) (and (= (f23 ?v0 f21) f1) (= (f23 ?v1 f21) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f23 (f4 (f5 f6 ?v0) ?v1) f21) f1) (or (and (= (f23 f21 ?v0) f1) (= (f23 ?v1 f21) f1)) (and (= (f23 ?v0 f21) f1) (= (f23 f21 ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 f21 ?v0) f1) (= (f4 (f5 f6 (f4 f31 ?v1)) ?v0) (f4 f31 (f4 (f5 f6 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f37 f38 ?v1) ?v0) (f37 f38 (* ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v1) f1) (= (f23 f21 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 ?v1 f21) f1) (= (f23 (f4 (f5 f6 ?v0) ?v1) f21) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 ?v1 f21) f1) (= (f23 (f4 (f5 f6 ?v1) ?v0) f21) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 f21 ?v1) f1) (= (f23 (f4 (f5 f6 ?v0) ?v1) f21) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f23 ?v0 f21) f1) (=> (= (f23 ?v1 f21) f1) (= (f23 f21 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v2 f21) f1) (= (f23 (f4 (f5 f6 ?v1) ?v2) (f4 (f5 f6 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v2))) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v2 f21) f1) (= (f23 (f4 ?v_0 ?v1) (f4 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v2 ?v3) f1) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v2 ?v3) f1) (=> (= (f23 f21 ?v1) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (or (and (= (f23 f21 ?v0) f1) (= (f23 f21 ?v1) f1)) (and (= (f23 ?v0 f21) f1) (= (f23 ?v1 f21) f1))) (= (f23 f21 (f4 (f5 f6 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (and (or (= (f23 f21 ?v0) f1) (= (f23 ?v0 f21) f1)) (or (= (f23 f21 ?v1) f1) (= (f23 ?v1 f21) f1))) (= (f4 f31 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f31 ?v0)) (f4 f31 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f37 f38 (* ?v0 ?v1)) (* (f37 f38 ?v0) (f37 f38 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (or (and (= (f23 f21 ?v0) f1) (= (f23 ?v1 f21) f1)) (and (= (f23 ?v0 f21) f1) (= (f23 f21 ?v1) f1))) (= (f23 (f4 (f5 f6 ?v0) ?v1) f21) f1))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 S2)) (not (= (f3 (f4 (f5 f6 ?v0) ?v0) f21) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1)) f1) (or (and (= (f3 f21 ?v1) f1) (= (f3 ?v0 ?v2) f1)) (and (= (f3 ?v1 f21) f1) (= (f3 ?v2 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (= (f3 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (or (and (= (f3 f21 ?v0) f1) (= (f3 ?v1 ?v2) f1)) (and (= (f3 ?v0 f21) f1) (= (f3 ?v2 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f3 f21 ?v0) f1) (= (= (f3 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (= (f3 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 f21 ?v1) f1) (= (f3 f21 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S6)) (= (f14 f15 (f16 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f17 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
