(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () S4)
(declare-fun f7 () S4)
(declare-fun f8 () S4)
(declare-fun f9 () S4)
(declare-fun f10 (S5 S4) S4)
(declare-fun f11 (S6 S4) S5)
(declare-fun f12 () S6)
(declare-fun f13 () S6)
(declare-fun f14 () S4)
(declare-fun f15 () S2)
(declare-fun f16 () S3)
(declare-fun f17 () S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (=> (= f6 f7) (=> (not (= f8 f7)) (= (= f9 f7) (= (f10 (f11 f12 (f10 (f11 f13 f8) f9)) (f10 (f11 f13 f14) f6)) f7))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f13 ?v0))) (= (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f13 ?v0))) (= (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f10 (f11 f13 (f10 (f11 f12 ?v0) ?v1)) ?v2) (f10 (f11 f12 (f10 (f11 f13 ?v0) ?v2)) (f10 (f11 f13 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f10 (f11 f13 (f10 (f11 f12 ?v0) ?v1)) ?v2) (f10 (f11 f12 (f10 (f11 f13 ?v0) ?v2)) (f10 (f11 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S4)) (= (f10 (f11 f12 ?v0) f7) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f10 (f11 f12 ?v0) ?v0) f7)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 ?v1) (= (f10 (f11 f12 ?v0) ?v1) f7))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f10 (f11 f12 ?v0) ?v1) f7) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f10 (f11 f13 f7) ?v0) f7)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f10 (f11 f13 f7) ?v0) f7)))
(assert (forall ((?v0 S4)) (= (f10 (f11 f13 f7) ?v0) f7)))
(assert (forall ((?v0 S4)) (= (f10 (f11 f13 f7) ?v0) f7)))
(assert (forall ((?v0 Int)) (= (= (f3 f15 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= f7 ?v0) (= ?v0 f7))))
(assert (= (f3 f15 0) 0))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f11 f13 ?v0))) (= (f10 (f11 f13 (f10 ?v_0 ?v1)) (f10 (f11 f13 ?v2) ?v3)) (f10 (f11 f13 (f10 ?v_0 ?v2)) (f10 (f11 f13 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f11 f13 (f10 (f11 f13 ?v0) ?v1))) (?v_0 (f11 f13 ?v2))) (= (f10 ?v_1 (f10 ?v_0 ?v3)) (f10 ?v_0 (f10 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f11 f13 ?v0)) (?v_1 (f10 (f11 f13 ?v2) ?v3))) (= (f10 (f11 f13 (f10 ?v_0 ?v1)) ?v_1) (f10 ?v_0 (f10 (f11 f13 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f13 ?v0))) (= (f10 (f11 f13 (f10 ?v_0 ?v1)) ?v2) (f10 (f11 f13 (f10 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f13 ?v0))) (= (f10 (f11 f13 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f13 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f13 ?v0))) (= (f10 (f11 f13 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f13 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f15 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f11 f13 ?v0))) (= (f10 ?v_0 (f10 (f11 f13 ?v1) ?v2)) (f10 (f11 f13 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f11 f13 ?v0)) (?v_0 (f11 f13 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f10 (f11 f13 ?v0) ?v1) (f10 (f11 f13 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f15 (* ?v0 ?v1)) (* (f3 f15 ?v0) (f3 f15 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f16 ?v0) ?v1) ?v2) (f3 (f4 f16 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f17 ?v0) ?v1) ?v2) (f3 (f4 f17 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f15 (- ?v0 ?v1)) (f3 f15 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f10 (f11 f13 ?v0) ?v1) f7) (or (= ?v0 f7) (= ?v1 f7)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f7)) (=> (not (= ?v1 f7)) (not (= (f10 (f11 f13 ?v0) ?v1) f7))))))
(check-sat)
(exit)
