(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 (S7 S8) S8)
(declare-fun f11 (S9 S8) S7)
(declare-fun f12 () S9)
(declare-fun f13 (S10 S2) S8)
(declare-fun f14 (S11 S8) S10)
(declare-fun f15 () S11)
(declare-fun f16 () S8)
(declare-fun f17 (S12 Int) S8)
(declare-fun f18 () S12)
(declare-fun f19 (S13 Int) Int)
(declare-fun f20 () S13)
(declare-fun f21 () S13)
(declare-fun f22 () Int)
(declare-fun f23 () S13)
(declare-fun f24 () S5)
(declare-fun f25 (S14 Int) S6)
(declare-fun f26 () S14)
(declare-fun f27 () S4)
(declare-fun f28 () S13)
(declare-fun f29 () S7)
(declare-fun f30 (S8) S1)
(declare-fun f31 (Int) S1)
(declare-fun f32 (S8 S15) S1)
(declare-fun f33 () S15)
(declare-fun f34 (Int S16) S1)
(declare-fun f35 () S16)
(declare-fun f36 () S9)
(declare-fun f37 () S9)
(declare-fun f38 () S8)
(declare-fun f39 (S2 S17) S1)
(declare-fun f40 (S17 S2) S1)
(declare-fun f41 (S16 Int) S1)
(declare-fun f42 (S15 S8) S1)
(declare-fun f43 () S4)
(declare-fun f44 () S4)
(declare-fun f45 () S17)
(declare-fun f46 () S7)
(declare-fun f47 () S8)
(declare-fun f48 () S2)
(declare-fun f49 (S2) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))))))
(assert (let ((?v_1 (f6 f7 2)) (?v_0 (f19 f20 (f19 f21 f22)))) (not (= (f10 (f11 f12 (f13 (f14 f15 f16) ?v_1)) (f17 f18 (f19 f20 ?v_0))) (f13 (f14 f15 (f10 (f11 f12 f16) (f17 f18 ?v_0))) ?v_1)))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 ?v0) (f17 f18 (f19 f21 f22))) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 ?v0) (f17 f18 (f19 f21 f22))) ?v0)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S2)) (= (f13 (f14 f15 (f10 (f11 f12 ?v0) ?v1)) ?v2) (f10 (f11 f12 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (= (f19 f20 f22) f22))
(assert (forall ((?v0 Int)) (= (- f22 (f19 f20 ?v0)) (f19 f20 (- f22 ?v0)))))
(assert (forall ((?v0 Int)) (= (= f22 (f19 f20 ?v0)) (= f22 ?v0))))
(assert (forall ((?v0 Int)) (= (< f22 (f19 f20 ?v0)) (< f22 ?v0))))
(assert (forall ((?v0 Int)) (= (<= f22 (f19 f20 ?v0)) (<= f22 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f19 f20 ?v0) f22) (= ?v0 f22))))
(assert (forall ((?v0 Int)) (= (< (f19 f20 ?v0) f22) (< ?v0 f22))))
(assert (forall ((?v0 Int)) (= (<= (f19 f20 ?v0) f22) (<= ?v0 f22))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f19 f21 ?v0) ?v1) (+ (f19 f20 (* ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 f18 ?v0) (f17 f18 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f19 f23 ?v0) (f19 f23 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f6 f24 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f17 f18 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f23 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f21 ?v0) (f19 f21 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f21 ?v0) (f19 f21 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f21 ?v0) (f19 f21 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f21 ?v0) (f19 f21 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f19 f21 ?v0) (f19 f21 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f19 f21 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f19 f21 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f22) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f22) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f22 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* f22 ?v0) f22)))
(assert (= (<= f22 f22) true))
(assert (= (< f22 0) false))
(assert (= (< f22 f22) false))
(assert (= (= f22 f22) true))
(assert (= (- f22) f22))
(assert (= f22 0))
(assert (forall ((?v0 Int)) (= (f8 (f25 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f27 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f13 (f14 f15 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f19 f28 (f8 (f25 f26 ?v0) ?v1)) (f8 (f25 f26 (f19 f28 ?v0)) ?v1))))
(assert (forall ((?v0 S8) (?v1 S2)) (= (f10 f29 (f13 (f14 f15 ?v0) ?v1)) (f13 (f14 f15 (f10 f29 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f20 ?v0) (f19 f20 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f20 ?v0) (f19 f20 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f20 ?v0) (f19 f20 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f20 ?v0) (f19 f20 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f19 f20 ?v0) (f19 f20 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f19 f20 ?v0) (f19 f20 ?v1)) (f19 f20 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f19 f20 ?v0) (f19 f20 ?v1)) (f19 f20 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f19 f20 ?v0) ?v1) (f19 f20 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f19 f20 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f19 f20 ?v0)) (f19 f20 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f19 f20 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f19 f21 ?v0) f22) (< ?v0 f22))))
(assert (forall ((?v0 Int)) (= (< (f19 f21 ?v0) f22) (< ?v0 f22))))
(assert (forall ((?v0 Int)) (= (= (f19 f21 ?v0) f22) false)))
(assert (forall ((?v0 Int)) (= (<= f22 (f19 f21 ?v0)) (<= f22 ?v0))))
(assert (forall ((?v0 Int)) (= (< f22 (f19 f21 ?v0)) (<= f22 ?v0))))
(assert (forall ((?v0 Int)) (= (= f22 (f19 f21 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f21 ?v0) (f19 f20 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f21 ?v0) (f19 f20 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f20 ?v0) (f19 f21 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f20 ?v0) (f19 f21 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f21 ?v0) (f19 f20 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f21 ?v0) (f19 f20 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f20 ?v0) (f19 f21 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f20 ?v0) (f19 f21 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f19 f21 ?v0) (f19 f21 ?v1)) (f19 f20 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f19 f21 ?v0) (f19 f20 ?v1)) (f19 f21 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f19 f21 ?v0) (f19 f20 ?v1)) (f19 f21 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f19 f20 ?v0) (f19 f21 ?v1)) (f19 f21 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f19 f21 ?v0) (f19 f20 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f19 f20 ?v0) (f19 f21 ?v1)) false)))
(assert (forall ((?v0 Int)) (=> (<= 0 (f19 f23 ?v0)) (and (<= 0 (f19 f23 (f19 f20 ?v0))) (<= 0 (f19 f23 (f19 f21 ?v0)))))))
(assert (not (= (f30 (f17 f18 (f19 f21 f22))) f1)))
(assert (not (= (f31 1) f1)))
(assert (forall ((?v0 Int)) (=> (<= f22 ?v0) (= (f32 (f17 f18 ?v0) f33) f1))))
(assert (forall ((?v0 Int)) (=> (<= f22 ?v0) (= (f34 (f19 f23 ?v0) f35) f1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f36 (f17 f18 (f19 f20 (f19 f21 f22)))))) (= (= ?v0 (f10 ?v_1 (f10 ?v_0 ?v2))) (= (f10 ?v_0 ?v0) (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 S8)) (let ((?v_1 (f6 f7 2)) (?v_0 (f19 f20 (f19 f21 f22)))) (= (f10 (f11 f36 (f17 f18 (f19 f20 ?v_0))) (f13 (f14 f15 ?v0) ?v_1)) (f13 (f14 f15 (f10 (f11 f36 (f17 f18 ?v_0)) ?v0)) ?v_1)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f10 (f11 f12 ?v0) (f17 f18 (f19 f20 (f19 f21 f22)))))) (= (f10 (f11 f37 ?v_0) ?v_0) ?v0))))
(assert (let ((?v_0 (f17 f18 (f19 f20 (f19 f21 f22))))) (not (= (f10 (f11 f12 f38) ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= (f30 (f17 f18 (f19 f20 ?v0))) f1) (= (f30 (f17 f18 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (= (f31 (f19 f23 (f19 f20 ?v0))) f1) (= (f31 (f19 f23 ?v0)) f1))))
(assert (= (f30 (f17 f18 f22)) f1))
(assert (= (f31 0) f1))
(assert (forall ((?v0 Int)) (not (= (f30 (f17 f18 (f19 f21 ?v0))) f1))))
(assert (forall ((?v0 Int)) (not (= (f31 (f19 f23 (f19 f21 ?v0))) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 f29 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 (f10 f29 ?v0)) (f10 f29 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S17)) (= (= (f39 ?v0 ?v1) f1) (= (f40 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S16)) (= (= (f34 ?v0 ?v1) f1) (= (f41 ?v1 ?v0) f1))))
(assert (forall ((?v0 S8) (?v1 S15)) (= (= (f32 ?v0 ?v1) f1) (= (f42 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int)) (= (f19 f23 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (- (f19 f23 ?v0)) (f19 f23 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f19 f23 ?v0) (f19 f23 ?v1)) (f19 f23 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f19 f23 ?v0) (f19 f23 ?v1)) (f19 f23 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f19 f23 ?v0) (f19 f23 ?v1)) (f19 f23 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f23 ?v0) (f19 f23 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f23 ?v0) (f19 f23 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f19 f23 ?v1))) (= (= (f8 f9 ?v0) ?v_0) (and (= ?v0 (f6 f7 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f17 f18 ?v2))) (= (f10 (f11 f36 (f10 (f11 f37 ?v0) ?v1)) ?v_0) (f10 (f11 f37 (f10 (f11 f36 ?v0) ?v_0)) (f10 (f11 f36 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f19 f23 ?v2))) (= (* (+ ?v0 ?v1) ?v_0) (+ (* ?v0 ?v_0) (* ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f6 f24 ?v2))) (= (f3 (f4 f43 (f3 (f4 f44 ?v0) ?v1)) ?v_0) (f3 (f4 f44 (f3 (f4 f43 ?v0) ?v_0)) (f3 (f4 f43 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f36 (f17 f18 ?v0)))) (= (f10 ?v_0 (f10 (f11 f37 ?v1) ?v2)) (f10 (f11 f37 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f19 f23 ?v0))) (= (* ?v_0 (+ ?v1 ?v2)) (+ (* ?v_0 ?v1) (* ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f43 (f6 f24 ?v0)))) (= (f3 ?v_0 (f3 (f4 f44 ?v1) ?v2)) (f3 (f4 f44 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f25 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f8 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (* (f8 ?v_2 (f6 f7 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f4 f27 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f43 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S8)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f14 f15 ?v2))) (=> (<= ?v_1 ?v_0) (= (f13 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f10 (f11 f36 (f13 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f10 (f11 f36 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 ?v2) ?v3)) (f10 (f11 f12 (f10 (f11 f36 ?v0) ?v2)) (f10 (f11 f36 ?v1) ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f11 f36 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v0)) (f10 (f11 f12 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 f18 (+ ?v0 ?v1)) (f10 (f11 f37 (f17 f18 ?v0)) (f17 f18 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 f23 (+ ?v0 ?v1)) (+ (f19 f23 ?v0) (f19 f23 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f37 (f17 f18 ?v0)) (f17 f18 ?v1)) (f17 f18 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f19 f23 ?v0) (f19 f23 ?v1)) (f19 f23 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f10 (f11 f37 (f17 f18 ?v0)) (f10 (f11 f37 (f17 f18 ?v1)) ?v2)) (f10 (f11 f37 (f17 f18 (+ ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f19 f23 ?v0) (+ (f19 f23 ?v1) ?v2)) (+ (f19 f23 (+ ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 f18 (* ?v0 ?v1)) (f10 (f11 f36 (f17 f18 ?v0)) (f17 f18 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 f23 (* ?v0 ?v1)) (* (f19 f23 ?v0) (f19 f23 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f36 (f17 f18 ?v0)) (f17 f18 ?v1)) (f17 f18 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f19 f23 ?v0) (f19 f23 ?v1)) (f19 f23 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f10 (f11 f36 (f17 f18 ?v0)) (f10 (f11 f36 (f17 f18 ?v1)) ?v2)) (f10 (f11 f36 (f17 f18 (* ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (f19 f23 ?v0) (* (f19 f23 ?v1) ?v2)) (* (f19 f23 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (* ?v0 (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f3 (f4 f43 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f10 (f11 f36 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (* (f8 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f3 (f4 f43 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f10 (f11 f36 (f13 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (* (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f3 (f4 f43 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f10 (f11 f36 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f8 (f25 f26 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f27 ?v0) ?v1))) (= (f3 (f4 f43 ?v_0) ?v0) (f3 (f4 f43 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f13 (f14 f15 ?v0) ?v1))) (= (f10 (f11 f36 ?v_0) ?v0) (f10 (f11 f36 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f8 (f25 f26 (* ?v0 ?v1)) ?v2) (* (f8 (f25 f26 ?v0) ?v2) (f8 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f27 (f3 (f4 f43 ?v0) ?v1)) ?v2) (f3 (f4 f43 (f3 (f4 f27 ?v0) ?v2)) (f3 (f4 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S2)) (= (f13 (f14 f15 (f10 (f11 f36 ?v0) ?v1)) ?v2) (f10 (f11 f36 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f36 ?v0) (f17 f18 (f19 f20 (f19 f21 f22)))) (f10 (f11 f37 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f36 ?v0) (f17 f18 (f19 f20 (f19 f21 f22)))) (f10 (f11 f37 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f43 ?v0) (f6 f24 (f19 f20 (f19 f21 f22)))) (f3 (f4 f44 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f36 (f17 f18 (f19 f20 (f19 f21 f22)))) ?v0) (f10 (f11 f37 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f36 (f17 f18 (f19 f20 (f19 f21 f22)))) ?v0) (f10 (f11 f37 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f43 (f6 f24 (f19 f20 (f19 f21 f22)))) ?v0) (f3 (f4 f44 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 f18 ?v0) (f17 f18 ?v1)) (= (f30 (f17 f18 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f19 f23 ?v0) (f19 f23 ?v1)) (= (f31 (f19 f23 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f37 ?v0) (f17 f18 f22)) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f37 (f17 f18 f22)) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f36 ?v0) (f17 f18 (f19 f21 f22))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f36 (f17 f18 (f19 f21 f22))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (= (f13 (f14 f15 (f10 (f11 f37 ?v0) ?v1)) ?v_0) (f10 (f11 f37 (f10 (f11 f37 (f13 (f14 f15 ?v0) ?v_0)) (f13 (f14 f15 ?v1) ?v_0))) (f10 (f11 f36 (f10 (f11 f36 (f17 f18 (f19 f20 (f19 f21 f22)))) ?v0)) ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (= (f13 (f14 f15 (f10 (f11 f37 ?v0) ?v1)) ?v_0) (f10 (f11 f37 (f10 (f11 f37 (f13 (f14 f15 ?v0) ?v_0)) (f13 (f14 f15 ?v1) ?v_0))) (f10 (f11 f36 (f10 (f11 f36 (f17 f18 (f19 f20 (f19 f21 f22)))) ?v0)) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f25 f26 (+ ?v0 ?v1)) ?v_0) (+ (+ (f8 (f25 f26 ?v0) ?v_0) (f8 (f25 f26 ?v1) ?v_0)) (* (* 2 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 2))) (= (f3 (f4 f27 (f3 (f4 f44 ?v0) ?v1)) ?v_0) (f3 (f4 f44 (f3 (f4 f44 (f3 (f4 f27 ?v0) ?v_0)) (f3 (f4 f27 ?v1) ?v_0))) (f3 (f4 f43 (f3 (f4 f43 (f6 f24 (f19 f20 (f19 f21 f22)))) ?v0)) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f22 ?v0) (=> (<= f22 ?v1) (= (f10 (f11 f37 (f17 f18 ?v0)) (f17 f18 ?v1)) (f17 f18 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f22 ?v0) (=> (<= f22 ?v1) (= (+ (f19 f23 ?v0) (f19 f23 ?v1)) (f19 f23 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f22 ?v0) (=> (<= f22 ?v1) (= (f3 (f4 f44 (f6 f24 ?v0)) (f6 f24 ?v1)) (f6 f24 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f23 ?v0))) (= (f8 (f25 f26 ?v_0) (f6 f7 2)) (* ?v_0 ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f24 ?v0))) (= (f3 (f4 f27 ?v_0) (f6 f7 2)) (f3 (f4 f43 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f13 (f14 f15 ?v_0) (f6 f7 2)) (f10 (f11 f36 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f22 ?v0) (=> (<= f22 ?v1) (= (f10 (f11 f36 (f17 f18 ?v0)) (f17 f18 ?v1)) (f17 f18 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f22 ?v0) (=> (<= f22 ?v1) (= (* (f19 f23 ?v0) (f19 f23 ?v1)) (f19 f23 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f22 ?v0) (=> (<= f22 ?v1) (= (f3 (f4 f43 (f6 f24 ?v0)) (f6 f24 ?v1)) (f6 f24 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f32 ?v0 f33) f1) (=> (= (f32 ?v1 f33) f1) (= (f32 (f10 (f11 f37 ?v0) ?v1) f33) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f34 ?v0 f35) f1) (=> (= (f34 ?v1 f35) f1) (= (f34 (+ ?v0 ?v1) f35) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f39 ?v0 f45) f1) (=> (= (f39 ?v1 f45) f1) (= (f39 (f3 (f4 f44 ?v0) ?v1) f45) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f8 f9 ?v2))) (= (f6 f7 (* (f8 f9 (f6 f24 ?v0)) (* (f8 f9 (f6 f24 ?v1)) ?v_0))) (ite (< ?v0 f22) (f6 f7 0) (f6 f7 (* (f8 f9 (f6 f24 (* ?v0 ?v1))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f7 (* (f8 f9 (f6 f24 ?v0)) (f8 f9 (f6 f24 ?v1)))) (ite (< ?v0 f22) (f6 f7 0) (f6 f7 (f19 f23 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f8 (f25 f26 (f8 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f3 (f4 f27 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2)))) (f8 (f25 f26 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f3 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2)))) (f3 (f4 f27 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f9 (f6 f24 ?v0)) (f8 f9 (f6 f24 ?v1))) (ite (< ?v0 ?v1) (< f22 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f9 (f6 f24 ?v0)) (f8 f9 (f6 f24 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f22)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f7 (+ (f8 f9 (f6 f24 ?v0)) (f8 f9 (f6 f24 ?v1)))) (ite (< ?v0 f22) (f6 f7 (f19 f23 ?v1)) (ite (< ?v1 f22) (f6 f7 (f19 f23 ?v0)) (f6 f7 (f19 f23 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f6 f7 (f19 f23 ?v0)) (f6 f7 0)) (<= ?v0 f22))))
(assert (forall ((?v0 Int)) (= (= (f6 f7 0) (f6 f7 (f19 f23 ?v0))) (<= ?v0 f22))))
(assert (forall ((?v0 Int)) (= (< 0 (f8 f9 (f6 f24 ?v0))) (< f22 ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f25 f26 (f19 f28 ?v0)) ?v_0) (f8 (f25 f26 ?v0) ?v_0)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f6 f7 2))) (= (f13 (f14 f15 (f10 f29 ?v0)) ?v_0) (f13 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 (f25 f26 ?v0) (f6 f7 2)))) (= (f19 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f13 (f14 f15 ?v0) (f6 f7 2)))) (= (f10 f29 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f19 f23 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f19 f23 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (= (f8 (f25 f26 ?v0) (f6 f7 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f27 ?v0) (f6 f7 3)) (f3 (f4 f43 (f3 (f4 f43 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S8)) (= (f13 (f14 f15 ?v0) (f6 f7 3)) (f10 (f11 f36 (f10 (f11 f36 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f25 f26 ?v0) (f6 f7 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f27 ?v0) (f6 f7 2)) (f3 (f4 f43 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f13 (f14 f15 ?v0) (f6 f7 2)) (f10 (f11 f36 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (* ?v0 (f8 (f25 f26 (f8 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f3 (f4 f43 ?v0) (f3 (f4 f27 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f10 (f11 f36 ?v0) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f32 ?v0 f33) f1) (=> (= (f32 ?v1 f33) f1) (= (f32 (f10 (f11 f36 ?v0) ?v1) f33) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f34 ?v0 f35) f1) (=> (= (f34 ?v1 f35) f1) (= (f34 (* ?v0 ?v1) f35) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f39 ?v0 f45) f1) (=> (= (f39 ?v1 f45) f1) (= (f39 (f3 (f4 f43 ?v0) ?v1) f45) f1)))))
(assert (forall ((?v0 S8)) (= (f10 f46 (f10 (f11 f37 ?v0) (f10 (f11 f36 (f17 f18 (f19 f20 (f19 f21 f22)))) f38))) (f10 f46 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f10 (f11 f36 (f10 (f11 f37 ?v0) ?v1)) ?v2) (f10 (f11 f37 (f10 (f11 f36 ?v0) ?v2)) (f10 (f11 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f10 (f11 f12 (f10 (f11 f37 ?v0) ?v1)) ?v2) (f10 (f11 f37 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f10 (f11 f12 (f10 (f11 f37 ?v0) ?v1)) ?v2) (f10 (f11 f37 (f10 (f11 f12 ?v0) ?v2)) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (* (f8 f9 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0))) (f8 f9 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 (f3 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 (f25 f26 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 ?v0)) (f8 f9 (f6 f7 ?v1))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 (f6 f24 ?v0)))) (=> (< 0 ?v_0) (= (f6 f7 (f19 f23 ?v0)) (f6 f7 (+ (f8 f9 (f6 f7 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 (- ?v0))) (f8 f9 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f8 f9 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_3 (f8 f9 ?v3)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1))) (= (= (f6 f7 (* (f8 f9 ?v0) ?v_0)) (f6 f7 (* (f8 f9 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (f8 f9 (f6 f7 (- ?v_0 ?v_2))) ?v_1)) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (+ ?v_0 ?v_2) ?v_1)) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* (* ?v_0 ?v_1) ?v_2)) (f6 f7 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* (+ ?v_1 1) ?v_0)) (f6 f7 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (f8 f9 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (+ ?v_1 1))) (f6 f7 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (* (f8 f9 (f6 f7 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* ?v_1 ?v_0)) (f6 f7 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f8 f9 ?v0))) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f8 f9 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S8)) (= (f10 f46 (f10 (f11 f37 ?v0) f38)) (f10 f46 ?v0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f10 f29 ?v0))) (= (f10 (f11 f36 ?v_0) ?v_0) (f10 (f11 f36 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f28 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 f29 (f10 (f11 f36 ?v0) ?v1)) (f10 (f11 f36 (f10 f29 ?v0)) (f10 f29 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 f28 (* ?v0 ?v1)) (* (f19 f28 ?v0) (f19 f28 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f36 ?v0))) (= (f10 (f11 f36 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f36 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 (f11 f36 ?v0) ?v1) (f10 (f11 f36 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 Int)) (= (f10 f46 (f10 (f11 f37 ?v0) (f10 (f11 f36 (f17 f18 ?v1)) f38))) (f10 f46 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f10 (f11 f37 (f10 (f11 f36 ?v0) ?v1)) (f10 (f11 f37 (f10 (f11 f36 ?v2) ?v1)) ?v3)) (f10 (f11 f37 (f10 (f11 f36 (f10 (f11 f37 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f3 (f4 f44 (f3 (f4 f43 ?v0) ?v1)) (f3 (f4 f44 (f3 (f4 f43 ?v2) ?v1)) ?v3)) (f3 (f4 f44 (f3 (f4 f43 (f3 (f4 f44 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f10 (f11 f36 (f10 (f11 f37 ?v0) ?v1)) ?v2) (f10 (f11 f37 (f10 (f11 f36 ?v0) ?v2)) (f10 (f11 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f10 (f11 f36 (f10 (f11 f37 ?v0) ?v1)) ?v2) (f10 (f11 f37 (f10 (f11 f36 ?v0) ?v2)) (f10 (f11 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f10 (f11 f36 (f10 (f11 f37 ?v0) ?v1)) ?v2) (f10 (f11 f37 (f10 (f11 f36 ?v0) ?v2)) (f10 (f11 f36 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f43 (f3 (f4 f44 ?v0) ?v1)) ?v2) (f3 (f4 f44 (f3 (f4 f43 ?v0) ?v2)) (f3 (f4 f43 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f36 ?v0))) (= (f10 ?v_0 (f10 (f11 f37 ?v1) ?v2)) (f10 (f11 f37 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f36 ?v0))) (= (f10 ?v_0 (f10 (f11 f37 ?v1) ?v2)) (f10 (f11 f37 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f25 f26 ?v1))) (=> (< 0 ?v_0) (= (* (f8 ?v_1 (f6 f7 (- ?v_0 1))) ?v1) (f8 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f4 f27 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f43 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f14 f15 ?v1))) (=> (< 0 ?v_0) (= (f10 (f11 f36 (f13 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f13 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f36 ?v0))) (= (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2)) (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f27 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f3 (f4 f43 ?v0) (f3 (f4 f43 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f10 (f11 f36 ?v0) (f10 (f11 f36 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f27 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f3 (f4 f43 ?v_1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f10 (f11 f36 ?v_1) ?v_1))))))
(assert (= (f10 f46 (f10 (f11 f12 f38) (f17 f18 (f19 f20 (f19 f20 (f19 f21 f22)))))) f47))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 (f25 f26 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f3 (f4 f27 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S8)) (= (f10 (f11 f36 ?v0) f47) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f43 ?v0) f48) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f36 f47) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f36 f47) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f43 f48) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f11 f37 ?v0) ?v0) (f10 (f11 f36 (f10 (f11 f37 f47) f47)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (* (+ 1 1) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f44 ?v0) ?v0) (f3 (f4 f43 (f3 (f4 f44 f48) f48)) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 (f11 f37 ?v0) (f10 (f11 f36 ?v1) ?v0)) (f10 (f11 f36 (f10 (f11 f37 ?v1) f47)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (* ?v1 ?v0)) (* (+ ?v1 1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f44 ?v0) (f3 (f4 f43 ?v1) ?v0)) (f3 (f4 f43 (f3 (f4 f44 ?v1) f48)) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 (f11 f37 (f10 (f11 f36 ?v0) ?v1)) ?v1) (f10 (f11 f36 (f10 (f11 f37 ?v0) f47)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (* ?v0 ?v1) ?v1) (* (+ ?v0 1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f44 (f3 (f4 f43 ?v0) ?v1)) ?v1) (f3 (f4 f43 (f3 (f4 f44 ?v0) f48)) ?v1))))
(assert (= (f10 f29 f47) f47))
(assert (= (f19 f28 1) 1))
(assert (forall ((?v0 S8)) (= (f10 (f11 f12 ?v0) f47) ?v0)))
(assert (not (= (f30 f47) f1)))
(assert (not (= (f31 1) f1)))
(assert (not (= (f49 f48) f1)))
(assert (= (f32 f47 f33) f1))
(assert (= (f34 1 f35) f1))
(assert (= (f39 f48 f45) f1))
(assert (forall ((?v0 S8)) (= (f13 (f14 f15 ?v0) (f6 f7 0)) f47)))
(assert (forall ((?v0 Int)) (= (f8 (f25 f26 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f27 ?v0) (f6 f7 0)) f48)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f8 f9 ?v0)) (<= ?v_0 (f8 f9 (f3 (f4 f27 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f27 ?v0))) (=> (< 0 (f8 f9 ?v0)) (=> (< (f8 f9 (f3 ?v_0 ?v1)) (f8 f9 (f3 ?v_0 ?v2))) (< (f8 f9 ?v1) (f8 f9 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f25 f26 ?v0) ?v1)) (f3 (f4 f27 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f27 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f25 f26 (f8 f9 ?v0)) ?v1) (f8 f9 (f3 (f4 f27 ?v0) ?v1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f27 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (* (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f8 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f8 f9 (f3 (f4 f27 ?v0) ?v1))) (or (< 0 (f8 f9 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 f9 (f3 (f4 f27 ?v0) ?v1)) (f8 (f25 f26 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f8 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 f47) ?v0) f47)))
(assert (forall ((?v0 S2)) (= (f8 (f25 f26 1) ?v0) 1)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f27 f48) ?v0) f48)))
(assert (forall ((?v0 S8)) (= (f13 (f14 f15 ?v0) (f6 f7 0)) f47)))
(assert (forall ((?v0 Int)) (= (f8 (f25 f26 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f27 ?v0) (f6 f7 0)) f48)))
(assert (= (f13 (f14 f15 f47) (f6 f7 2)) f47))
(assert (= (f8 (f25 f26 1) (f6 f7 2)) 1))
(assert (= (f3 (f4 f27 f48) (f6 f7 2)) f48))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f47 (f10 (f11 f36 ?v0) (f13 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) 1 (* ?v0 (f8 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f48 (f3 (f4 f43 ?v0) (f3 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f11 f12 f47))) (= (f10 ?v_0 (f13 (f14 f15 ?v0) ?v1)) (f13 (f14 f15 (f10 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f17 f18 (f19 f21 ?v0)) (f10 (f11 f37 (f10 (f11 f37 f47) ?v_0)) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f23 ?v0))) (= (f19 f23 (f19 f21 ?v0)) (+ (+ 1 ?v_0) ?v_0)))))
(assert (= f47 (f17 f18 (f19 f21 f22))))
(assert (= 1 1))
(assert (= (f17 f18 (f19 f21 f22)) f47))
(assert (= 1 1))
(assert (= (f6 f24 (f19 f21 f22)) f48))
(assert (= (f17 f18 (f19 f21 f22)) f47))
(assert (= 1 1))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 (f11 f36 ?v0) ?v1) (f10 (f11 f36 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f43 ?v0) ?v1) (f3 (f4 f43 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f11 f36 ?v0)) (?v_0 (f11 f36 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f43 ?v0)) (?v_0 (f4 f43 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f36 ?v0))) (= (f10 ?v_0 (f10 (f11 f36 ?v1) ?v2)) (f10 (f11 f36 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f43 ?v0))) (= (f3 ?v_0 (f3 (f4 f43 ?v1) ?v2)) (f3 (f4 f43 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f36 ?v0))) (= (f10 (f11 f36 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f36 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f43 ?v0))) (= (f3 (f4 f43 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f43 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f36 ?v0))) (= (f10 (f11 f36 (f10 ?v_0 ?v1)) ?v2) (f10 (f11 f36 (f10 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f43 ?v0))) (= (f3 (f4 f43 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f43 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f11 f36 ?v0)) (?v_1 (f10 (f11 f36 ?v2) ?v3))) (= (f10 (f11 f36 (f10 ?v_0 ?v1)) ?v_1) (f10 ?v_0 (f10 (f11 f36 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f43 ?v0)) (?v_1 (f3 (f4 f43 ?v2) ?v3))) (= (f3 (f4 f43 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f43 ?v1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_1 (f11 f36 (f10 (f11 f36 ?v0) ?v1))) (?v_0 (f11 f36 ?v2))) (= (f10 ?v_1 (f10 ?v_0 ?v3)) (f10 ?v_0 (f10 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f43 (f3 (f4 f43 ?v0) ?v1))) (?v_0 (f4 f43 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f11 f36 ?v0))) (= (f10 (f11 f36 (f10 ?v_0 ?v1)) (f10 (f11 f36 ?v2) ?v3)) (f10 (f11 f36 (f10 ?v_0 ?v2)) (f10 (f11 f36 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f43 ?v0))) (= (f3 (f4 f43 (f3 ?v_0 ?v1)) (f3 (f4 f43 ?v2) ?v3)) (f3 (f4 f43 (f3 ?v_0 ?v2)) (f3 (f4 f43 ?v1) ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 (f11 f37 ?v0) ?v1) (f10 (f11 f37 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f44 ?v0) ?v1) (f3 (f4 f44 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f11 f37 ?v0)) (?v_0 (f11 f37 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f44 ?v0)) (?v_0 (f4 f44 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f37 ?v0))) (= (f10 ?v_0 (f10 (f11 f37 ?v1) ?v2)) (f10 (f11 f37 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 ?v_0 (f3 (f4 f44 ?v1) ?v2)) (f3 (f4 f44 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f37 ?v0))) (= (f10 (f11 f37 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f37 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 (f4 f44 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f44 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f11 f37 ?v0))) (= (f10 (f11 f37 (f10 ?v_0 ?v1)) ?v2) (f10 (f11 f37 (f10 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 (f4 f44 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f44 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f11 f37 ?v0))) (= (f10 (f11 f37 (f10 ?v_0 ?v1)) (f10 (f11 f37 ?v2) ?v3)) (f10 (f11 f37 (f10 ?v_0 ?v2)) (f10 (f11 f37 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f44 ?v0))) (= (f3 (f4 f44 (f3 ?v_0 ?v1)) (f3 (f4 f44 ?v2) ?v3)) (f3 (f4 f44 (f3 ?v_0 ?v2)) (f3 (f4 f44 ?v1) ?v3))))))
(assert (forall ((?v0 Int)) (= (f8 (f25 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f27 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f13 (f14 f15 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
