(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S3)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S6) S3)
(declare-fun f7 (S7 S3) S5)
(declare-fun f8 () S7)
(declare-fun f9 () S3)
(declare-fun f10 (S8 Int) S6)
(declare-fun f11 () S8)
(declare-fun f12 (S9 Int) S3)
(declare-fun f13 () S9)
(declare-fun f14 (S10 Int) Int)
(declare-fun f15 () S10)
(declare-fun f16 () S10)
(declare-fun f17 () Int)
(declare-fun f18 () S10)
(declare-fun f19 () S2)
(declare-fun f20 (S11 S6) Int)
(declare-fun f21 () S11)
(assert (not (= f1 f2)))
(assert (let ((?v_1 (f10 f11 2)) (?v_0 (f14 f15 (f14 f16 f17)))) (not (= (f3 (f4 f5 (f6 (f7 f8 f9) ?v_1)) (f12 f13 (f14 f15 ?v_0))) (f6 (f7 f8 (f3 (f4 f5 f9) (f12 f13 ?v_0))) ?v_1)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S6)) (= (f6 (f7 f8 (f3 (f4 f5 ?v0) ?v1)) ?v2) (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (= (f14 f15 f17) f17))
(assert (forall ((?v0 Int)) (= (- f17 (f14 f15 ?v0)) (f14 f15 (- f17 ?v0)))))
(assert (forall ((?v0 Int)) (= (= f17 (f14 f15 ?v0)) (= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (< f17 (f14 f15 ?v0)) (< f17 ?v0))))
(assert (forall ((?v0 Int)) (= (<= f17 (f14 f15 ?v0)) (<= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f14 f15 ?v0) f17) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (< (f14 f15 ?v0) f17) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (<= (f14 f15 ?v0) f17) (<= ?v0 f17))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f14 f16 ?v0) ?v1) (+ (f14 f15 (* ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f18 ?v0) (f14 f18 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 f13 ?v0) (f12 f13 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f18 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f12 f13 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f16 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f16 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f16 ?v0) (f14 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f14 f16 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f14 f16 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f17 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* f17 ?v0) f17)))
(assert (= (<= f17 f17) true))
(assert (= (< f17 0) false))
(assert (= (< f17 f17) false))
(assert (= (= f17 f17) true))
(assert (= (- f17) f17))
(assert (= f17 0))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S6)) (= (f3 f19 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f3 f19 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f15 ?v0) (f14 f15 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f15 ?v0) (f14 f15 ?v1)) (f14 f15 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f15 ?v0) (f14 f15 ?v1)) (f14 f15 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f14 f15 ?v0) ?v1) (f14 f15 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f14 f15 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f14 f15 ?v0)) (f14 f15 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f14 f15 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f14 f16 ?v0) f17) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (< (f14 f16 ?v0) f17) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= (f14 f16 ?v0) f17) false)))
(assert (forall ((?v0 Int)) (= (<= f17 (f14 f16 ?v0)) (<= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (< f17 (f14 f16 ?v0)) (<= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (= f17 (f14 f16 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f16 ?v0) (f14 f16 ?v1)) (f14 f15 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f16 ?v0) (f14 f15 ?v1)) (f14 f16 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f16 ?v0) (f14 f15 ?v1)) (f14 f16 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f15 ?v0) (f14 f16 ?v1)) (f14 f16 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f16 ?v0) (f14 f15 ?v1)) false)))
(assert (forall ((?v0 S6)) (= (f10 f11 (f20 f21 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f20 f21 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f20 f21 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
