(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 (S7 S8) S8)
(declare-fun f11 () S7)
(declare-fun f12 (S9 Int) S8)
(declare-fun f13 () S9)
(declare-fun f14 (S10 Int) Int)
(declare-fun f15 () S10)
(declare-fun f16 () S10)
(declare-fun f17 () Int)
(declare-fun f18 (S11 S2) S8)
(declare-fun f19 (S12 S8) S11)
(declare-fun f20 () S12)
(declare-fun f21 (S13 S8) S7)
(declare-fun f22 () S13)
(declare-fun f23 () S7)
(declare-fun f24 () S10)
(declare-fun f25 () S5)
(declare-fun f26 () S13)
(declare-fun f27 (Int) S1)
(declare-fun f28 (S8) S1)
(declare-fun f29 (Int S14) S1)
(declare-fun f30 () S14)
(declare-fun f31 (S8 S15) S1)
(declare-fun f32 () S15)
(declare-fun f33 () S13)
(declare-fun f34 () S8)
(declare-fun f35 (S15 S8) S1)
(declare-fun f36 (S8) S15)
(declare-fun f37 (S2 S16) S1)
(declare-fun f38 (S16 S2) S1)
(declare-fun f39 (S14 Int) S1)
(declare-fun f40 () S4)
(declare-fun f41 () S4)
(declare-fun f42 () S4)
(declare-fun f43 (S17 Int) S6)
(declare-fun f44 () S17)
(declare-fun f45 () S10)
(declare-fun f46 () S7)
(declare-fun f47 () S16)
(declare-fun f48 () S8)
(declare-fun f49 () S8)
(declare-fun f50 () S2)
(declare-fun f51 (S2) S1)
(declare-fun f52 (S2) S16)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))))))
(assert (let ((?v_0 (f14 f15 (f14 f16 f17)))) (not (= (f10 f11 (f12 f13 (f14 f15 ?v_0))) (f10 f11 (f18 (f19 f20 (f12 f13 ?v_0)) (f6 f7 2)))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f14 f15 (f14 f16 f17))) (?v_1 (f6 f7 2))) (= (f10 (f21 f22 (f18 (f19 f20 ?v0) ?v_1)) (f12 f13 (f14 f15 ?v_0))) (f18 (f19 f20 (f10 (f21 f22 ?v0) (f12 f13 ?v_0))) ?v_1)))))
(assert (forall ((?v0 S8) (?v1 S2)) (= (f10 f11 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f20 (f10 f11 ?v0)) ?v1))))
(assert (forall ((?v0 S8)) (= (f10 f11 (f18 (f19 f20 ?v0) (f6 f7 2))) (f10 f23 ?v0))))
(assert (= (f14 f15 f17) f17))
(assert (forall ((?v0 Int)) (= (- f17 (f14 f15 ?v0)) (f14 f15 (- f17 ?v0)))))
(assert (forall ((?v0 Int)) (= (= f17 (f14 f15 ?v0)) (= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (< f17 (f14 f15 ?v0)) (< f17 ?v0))))
(assert (forall ((?v0 Int)) (= (<= f17 (f14 f15 ?v0)) (<= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f14 f15 ?v0) f17) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (< (f14 f15 ?v0) f17) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (<= (f14 f15 ?v0) f17) (<= ?v0 f17))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f14 f16 ?v0) ?v1) (+ (f14 f15 (* ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 f11 (f10 (f21 f22 ?v0) ?v1)) (f10 (f21 f22 (f10 f11 ?v0)) (f10 f11 ?v1)))))
(assert (forall ((?v0 S8)) (= (f10 (f21 f22 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f21 f22 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f24 ?v0) (f14 f24 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 f13 ?v0) (f12 f13 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f6 f25 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f24 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f12 f13 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f16 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f16 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f16 ?v0) (f14 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f14 f16 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f14 f16 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f17 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* f17 ?v0) f17)))
(assert (= (<= f17 f17) true))
(assert (= (< f17 0) false))
(assert (= (< f17 f17) false))
(assert (= (= f17 f17) true))
(assert (= (- f17) f17))
(assert (= f17 0))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f15 ?v0) (f14 f15 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f15 ?v0) (f14 f15 ?v1)) (f14 f15 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f15 ?v0) (f14 f15 ?v1)) (f14 f15 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f14 f15 ?v0) ?v1) (f14 f15 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f14 f15 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f14 f15 ?v0)) (f14 f15 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f14 f15 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f10 f11 ?v0) (f10 f11 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (<= (f14 f16 ?v0) f17) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (< (f14 f16 ?v0) f17) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= (f14 f16 ?v0) f17) false)))
(assert (forall ((?v0 Int)) (= (<= f17 (f14 f16 ?v0)) (<= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (< f17 (f14 f16 ?v0)) (<= f17 ?v0))))
(assert (forall ((?v0 Int)) (= (= f17 (f14 f16 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f16 ?v0) (f14 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f15 ?v0) (f14 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f16 ?v0) (f14 f16 ?v1)) (f14 f15 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f14 f16 ?v0) (f14 f15 ?v1)) (f14 f16 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f16 ?v0) (f14 f15 ?v1)) (f14 f16 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f15 ?v0) (f14 f16 ?v1)) (f14 f16 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f16 ?v0) (f14 f15 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f15 ?v0) (f14 f16 ?v1)) false)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S2)) (= (f18 (f19 f20 (f10 (f21 f22 ?v0) ?v1)) ?v2) (f10 (f21 f22 (f18 (f19 f20 ?v0) ?v2)) (f18 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f14 f15 (f14 f16 f17))) (?v_1 (f6 f7 2))) (= (f10 (f21 f26 (f12 f13 (f14 f15 ?v_0))) (f18 (f19 f20 ?v0) ?v_1)) (f18 (f19 f20 (f10 (f21 f26 (f12 f13 ?v_0)) ?v0)) ?v_1)))))
(assert (not (= (f27 1) f1)))
(assert (not (= (f28 (f12 f13 (f14 f16 f17))) f1)))
(assert (forall ((?v0 Int)) (=> (<= f17 ?v0) (= (f29 (f14 f24 ?v0) f30) f1))))
(assert (forall ((?v0 Int)) (=> (<= f17 ?v0) (= (f31 (f12 f13 ?v0) f32) f1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f26 (f12 f13 (f14 f15 (f14 f16 f17))))) (?v_1 (f21 f22 ?v1))) (= (= ?v0 (f10 ?v_1 (f10 ?v_0 ?v2))) (= (f10 ?v_0 ?v0) (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f10 (f21 f22 ?v0) (f12 f13 (f14 f15 (f14 f16 f17)))))) (= (f10 (f21 f33 ?v_0) ?v_0) ?v0))))
(assert (let ((?v_0 (f12 f13 (f14 f15 (f14 f16 f17))))) (not (= (f10 (f21 f22 f34) ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= (f27 (f14 f24 (f14 f15 ?v0))) f1) (= (f27 (f14 f24 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (= (f28 (f12 f13 (f14 f15 ?v0))) f1) (= (f28 (f12 f13 ?v0)) f1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f6 f7 2)) (?v_0 (f10 (f21 f22 ?v1) (f10 f11 (f12 f13 (f14 f15 (f14 f16 f17))))))) (=> (= (f35 (f36 (f10 f23 ?v0)) ?v_0) f1) (=> (= (f35 (f36 (f10 f23 ?v2)) ?v_0) f1) (= (f35 (f36 (f10 f11 (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_1)) (f18 (f19 f20 ?v2) ?v_1)))) ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S16)) (= (= (f37 ?v0 ?v1) f1) (= (f38 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S14)) (= (= (f29 ?v0 ?v1) f1) (= (f39 ?v1 ?v0) f1))))
(assert (forall ((?v0 S8) (?v1 S15)) (= (= (f31 ?v0 ?v1) f1) (= (f35 ?v1 ?v0) f1))))
(assert (= (f27 0) f1))
(assert (= (f28 (f12 f13 f17)) f1))
(assert (forall ((?v0 Int)) (not (= (f27 (f14 f24 (f14 f16 ?v0))) f1))))
(assert (forall ((?v0 Int)) (not (= (f28 (f12 f13 (f14 f16 ?v0))) f1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (= (f10 (f21 f26 (f10 (f21 f33 ?v0) ?v1)) ?v_0) (f10 (f21 f33 (f10 (f21 f26 ?v0) ?v_0)) (f10 (f21 f26 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f24 ?v2))) (= (* (+ ?v0 ?v1) ?v_0) (+ (* ?v0 ?v_0) (* ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f6 f25 ?v2))) (= (f3 (f4 f40 (f3 (f4 f41 ?v0) ?v1)) ?v_0) (f3 (f4 f41 (f3 (f4 f40 ?v0) ?v_0)) (f3 (f4 f40 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f26 (f12 f13 ?v0)))) (= (f10 ?v_0 (f10 (f21 f33 ?v1) ?v2)) (f10 (f21 f33 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f14 f24 ?v0))) (= (* ?v_0 (+ ?v1 ?v2)) (+ (* ?v_0 ?v1) (* ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f40 (f6 f25 ?v0)))) (= (f3 ?v_0 (f3 (f4 f41 ?v1) ?v2)) (f3 (f4 f41 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f42 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f3 (f4 f40 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f43 f44 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (* ?v0 (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f10 (f21 f26 ?v0) (f18 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f42 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f3 (f4 f40 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f43 f44 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (* (f8 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f10 (f21 f26 (f18 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f42 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f3 (f4 f40 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (* (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f10 (f21 f26 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f42 ?v0) ?v1))) (= (f3 (f4 f40 ?v_0) ?v0) (f3 (f4 f40 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f8 (f43 f44 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f18 (f19 f20 ?v0) ?v1))) (= (f10 (f21 f26 ?v_0) ?v0) (f10 (f21 f26 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f42 (f3 (f4 f40 ?v0) ?v1)) ?v2) (f3 (f4 f40 (f3 (f4 f42 ?v0) ?v2)) (f3 (f4 f42 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f8 (f43 f44 (* ?v0 ?v1)) ?v2) (* (f8 (f43 f44 ?v0) ?v2) (f8 (f43 f44 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S2)) (= (f18 (f19 f20 (f10 (f21 f26 ?v0) ?v1)) ?v2) (f10 (f21 f26 (f18 (f19 f20 ?v0) ?v2)) (f18 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f4 f42 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f40 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f43 f44 ?v2))) (=> (<= ?v_1 ?v_0) (= (f8 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (* (f8 ?v_2 (f6 f7 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S8)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f19 f20 ?v2))) (=> (<= ?v_1 ?v_0) (= (f18 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f10 (f21 f26 (f18 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f6 f7 2))) (let ((?v_1 (f10 (f21 f26 (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_0)) (f18 (f19 f20 ?v1) ?v_0))) (f10 (f21 f33 (f18 (f19 f20 ?v2) ?v_0)) (f18 (f19 f20 ?v3) ?v_0))))) (= (f18 (f19 f20 (f10 f11 ?v_1)) ?v_0) ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 f13 (+ ?v0 ?v1)) (f10 (f21 f33 (f12 f13 ?v0)) (f12 f13 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 f24 (+ ?v0 ?v1)) (+ (f14 f24 ?v0) (f14 f24 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f21 f33 (f12 f13 ?v0)) (f12 f13 ?v1)) (f12 f13 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f14 f24 ?v0) (f14 f24 ?v1)) (f14 f24 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f10 (f21 f33 (f12 f13 ?v0)) (f10 (f21 f33 (f12 f13 ?v1)) ?v2)) (f10 (f21 f33 (f12 f13 (+ ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f14 f24 ?v0) (+ (f14 f24 ?v1) ?v2)) (+ (f14 f24 (+ ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f35 (f36 (f12 f13 ?v0)) (f12 f13 ?v1)) f1) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f14 f24 ?v0) (f14 f24 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 f13 (* ?v0 ?v1)) (f10 (f21 f26 (f12 f13 ?v0)) (f12 f13 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f14 f24 (* ?v0 ?v1)) (* (f14 f24 ?v0) (f14 f24 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f21 f26 (f12 f13 ?v0)) (f12 f13 ?v1)) (f12 f13 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f14 f24 ?v0) (f14 f24 ?v1)) (f14 f24 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f10 (f21 f26 (f12 f13 ?v0)) (f10 (f21 f26 (f12 f13 ?v1)) ?v2)) (f10 (f21 f26 (f12 f13 (* ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (f14 f24 ?v0) (* (f14 f24 ?v1) ?v2)) (* (f14 f24 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f21 f26 ?v0))) (= (f10 (f21 f22 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v0)) (f10 (f21 f22 ?v1) ?v0)))))
(assert (forall ((?v0 S8)) (= (f10 f11 (f10 (f21 f26 ?v0) ?v0)) (f10 f23 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 f11 (f10 (f21 f26 ?v0) ?v1)) (f10 (f21 f26 (f10 f11 ?v0)) (f10 f11 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f35 (f36 (f10 f11 ?v0)) (f10 f11 ?v1)) f1) (= (f35 (f36 ?v0) ?v1) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f35 (f36 ?v0) ?v1) f1) (= (f35 (f36 (f10 f11 ?v0)) (f10 f11 ?v1)) f1))))
(assert (= (f35 (f36 f34) (f12 f13 (f14 f15 (f14 f15 (f14 f16 f17))))) f1))
(assert (forall ((?v0 S8)) (= (f10 (f21 f26 ?v0) (f12 f13 (f14 f15 (f14 f16 f17)))) (f10 (f21 f33 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S8)) (= (f10 (f21 f26 ?v0) (f12 f13 (f14 f15 (f14 f16 f17)))) (f10 (f21 f33 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f40 ?v0) (f6 f25 (f14 f15 (f14 f16 f17)))) (f3 (f4 f41 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f10 (f21 f26 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0) (f10 (f21 f33 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S8)) (= (f10 (f21 f26 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0) (f10 (f21 f33 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f40 (f6 f25 (f14 f15 (f14 f16 f17)))) ?v0) (f3 (f4 f41 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 f24 ?v0) (f14 f24 ?v1)) (= (f27 (f14 f24 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 f13 ?v0) (f12 f13 ?v1)) (= (f28 (f12 f13 (+ ?v0 (- ?v1)))) f1))))
(assert (let ((?v_0 (f12 f13 (f14 f15 (f14 f16 f17))))) (= (f35 (f36 (f10 (f21 f22 f34) ?v_0)) ?v_0) f1)))
(assert (forall ((?v0 S8)) (= (f10 (f21 f33 ?v0) (f12 f13 f17)) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f21 f33 (f12 f13 f17)) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f21 f26 ?v0) (f12 f13 (f14 f16 f17))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f10 (f21 f26 (f12 f13 (f14 f16 f17))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8) (?v1 S2)) (= (f10 f23 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f20 (f10 f23 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f14 f45 (f8 (f43 f44 ?v0) ?v1)) (f8 (f43 f44 (f14 f45 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f42 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 (f43 f44 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f18 (f19 f20 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (= (f18 (f19 f20 (f10 (f21 f33 ?v0) ?v1)) ?v_0) (f10 (f21 f33 (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_0)) (f18 (f19 f20 ?v1) ?v_0))) (f10 (f21 f26 (f10 (f21 f26 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0)) ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f36 ?v0))) (=> (= (f35 ?v_0 ?v1) f1) (= (f35 ?v_0 (f10 (f21 f22 (f10 (f21 f33 ?v0) ?v1)) (f12 f13 (f14 f15 (f14 f16 f17))))) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f35 (f36 ?v0) ?v1) f1) (= (f35 (f36 (f10 (f21 f22 (f10 (f21 f33 ?v0) ?v1)) (f12 f13 (f14 f15 (f14 f16 f17))))) ?v1) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (= (f18 (f19 f20 (f10 (f21 f33 ?v0) ?v1)) ?v_0) (f10 (f21 f33 (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_0)) (f18 (f19 f20 ?v1) ?v_0))) (f10 (f21 f26 (f10 (f21 f26 (f12 f13 (f14 f15 (f14 f16 f17)))) ?v0)) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f43 f44 (+ ?v0 ?v1)) ?v_0) (+ (+ (f8 (f43 f44 ?v0) ?v_0) (f8 (f43 f44 ?v1) ?v_0)) (* (* 2 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 2))) (= (f3 (f4 f42 (f3 (f4 f41 ?v0) ?v1)) ?v_0) (f3 (f4 f41 (f3 (f4 f41 (f3 (f4 f42 ?v0) ?v_0)) (f3 (f4 f42 ?v1) ?v_0))) (f3 (f4 f40 (f3 (f4 f40 (f6 f25 (f14 f15 (f14 f16 f17)))) ?v0)) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (f10 (f21 f33 (f12 f13 ?v0)) (f12 f13 ?v1)) (f12 f13 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (+ (f14 f24 ?v0) (f14 f24 ?v1)) (f14 f24 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (f3 (f4 f41 (f6 f25 ?v0)) (f6 f25 ?v1)) (f6 f25 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f25 ?v0))) (= (f3 (f4 f42 ?v_0) (f6 f7 2)) (f3 (f4 f40 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f24 ?v0))) (= (f8 (f43 f44 ?v_0) (f6 f7 2)) (* ?v_0 ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f18 (f19 f20 ?v_0) (f6 f7 2)) (f10 (f21 f26 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f8 f9 ?v2))) (= (f6 f7 (* (f8 f9 (f6 f25 ?v0)) (* (f8 f9 (f6 f25 ?v1)) ?v_0))) (ite (< ?v0 f17) (f6 f7 0) (f6 f7 (* (f8 f9 (f6 f25 (* ?v0 ?v1))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f7 (* (f8 f9 (f6 f25 ?v0)) (f8 f9 (f6 f25 ?v1)))) (ite (< ?v0 f17) (f6 f7 0) (f6 f7 (f14 f24 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f42 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f3 (f4 f42 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f43 f44 ?v0))) (= (f8 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f8 (f43 f44 (f8 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f18 (f19 f20 (f18 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f42 ?v0))) (= (f3 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2)))) (f3 (f4 f42 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0))) (= (f8 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2)))) (f8 (f43 f44 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2)))) (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f9 (f6 f25 ?v0)) (f8 f9 (f6 f25 ?v1))) (ite (< ?v0 ?v1) (< f17 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f9 (f6 f25 ?v0)) (f8 f9 (f6 f25 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f17)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f7 (+ (f8 f9 (f6 f25 ?v0)) (f8 f9 (f6 f25 ?v1)))) (ite (< ?v0 f17) (f6 f7 (f14 f24 ?v1)) (ite (< ?v1 f17) (f6 f7 (f14 f24 ?v0)) (f6 f7 (f14 f24 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f6 f7 (f14 f24 ?v0)) (f6 f7 0)) (<= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= (f6 f7 0) (f6 f7 (f14 f24 ?v0))) (<= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (< 0 (f8 f9 (f6 f25 ?v0))) (< f17 ?v0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f6 f7 2))) (= (f18 (f19 f20 (f10 f23 ?v0)) ?v_0) (f18 (f19 f20 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f43 f44 (f14 f45 ?v0)) ?v_0) (f8 (f43 f44 ?v0) ?v_0)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f18 (f19 f20 ?v0) (f6 f7 2)))) (= (f10 f23 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 (f43 f44 ?v0) (f6 f7 2)))) (= (f14 f45 ?v_0) ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f10 (f21 f26 ?v0) ?v1) (f10 (f21 f26 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f26 ?v0))) (= (f10 (f21 f26 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f21 f26 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f4 f42 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f40 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f43 f44 ?v1))) (=> (< 0 ?v_0) (= (* (f8 ?v_1 (f6 f7 (- ?v_0 1))) ?v1) (f8 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f19 f20 ?v1))) (=> (< 0 ?v_0) (= (f10 (f21 f26 (f18 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f18 ?v_1 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f42 ?v0) (f6 f7 3)) (f3 (f4 f40 (f3 (f4 f40 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f43 f44 ?v0) (f6 f7 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f18 (f19 f20 ?v0) (f6 f7 3)) (f10 (f21 f26 (f10 (f21 f26 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f42 ?v0) (f6 f7 2)) (f3 (f4 f40 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f43 f44 ?v0) (f6 f7 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S8)) (= (f18 (f19 f20 ?v0) (f6 f7 2)) (f10 (f21 f26 ?v0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f42 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f3 (f4 f40 ?v0) (f3 (f4 f42 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f43 f44 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (* ?v0 (f8 (f43 f44 (f8 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f10 (f21 f26 ?v0) (f18 (f19 f20 (f18 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f10 (f21 f26 (f10 (f21 f33 ?v0) ?v1)) ?v2) (f10 (f21 f33 (f10 (f21 f26 ?v0) ?v2)) (f10 (f21 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (f10 (f21 f26 (f12 f13 ?v0)) (f12 f13 ?v1)) (f12 f13 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (* (f14 f24 ?v0) (f14 f24 ?v1)) (f14 f24 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f17 ?v0) (=> (<= f17 ?v1) (= (f3 (f4 f40 (f6 f25 ?v0)) (f6 f25 ?v1)) (f6 f25 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S8)) (= (f35 (f36 (f10 f46 ?v0)) (f10 (f21 f22 f34) (f12 f13 (f14 f15 (f14 f16 f17))))) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f31 ?v0 f32) f1) (=> (= (f31 ?v1 f32) f1) (= (f31 (f10 (f21 f33 ?v0) ?v1) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 f30) f1) (=> (= (f29 ?v1 f30) f1) (= (f29 (+ ?v0 ?v1) f30) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f37 ?v0 f47) f1) (=> (= (f37 ?v1 f47) f1) (= (f37 (f3 (f4 f41 ?v0) ?v1) f47) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f31 ?v0 f32) f1) (=> (= (f31 ?v1 f32) f1) (= (f31 (f10 (f21 f26 ?v0) ?v1) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 f30) f1) (=> (= (f29 ?v1 f30) f1) (= (f29 (* ?v0 ?v1) f30) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f37 ?v0 f47) f1) (=> (= (f37 ?v1 f47) f1) (= (f37 (f3 (f4 f40 ?v0) ?v1) f47) f1)))))
(assert (forall ((?v0 S8)) (=> (= (f35 (f36 f48) ?v0) f1) (= (f35 (f36 (f10 (f21 f22 ?v0) (f10 f11 (f12 f13 (f14 f15 (f14 f16 f17)))))) ?v0) f1))))
(assert (not (= f49 f48)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (* (f8 f9 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0))) (f8 f9 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f43 f44 ?v0))) (= (f8 (f43 f44 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f6 f7 (* (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 ?v0)) (f8 f9 (f6 f7 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 (- ?v0))) (f8 f9 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f8 f9 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_3 (f8 f9 ?v3)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f9 (f6 f25 ?v0)))) (=> (< 0 ?v_0) (= (f6 f7 (f14 f24 ?v0)) (f6 f7 (+ (f8 f9 (f6 f7 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f26 ?v0))) (=> (not (= ?v0 f48)) (= (= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f48)) (= (= (f10 (f21 f26 ?v1) ?v0) (f10 (f21 f26 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1))) (= (= (f6 f7 (* (f8 f9 ?v0) ?v_0)) (f6 f7 (* (f8 f9 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (f8 f9 (f6 f7 (- ?v_0 ?v_2))) ?v_1)) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (+ ?v_0 ?v_2) ?v_1)) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* (* ?v_0 ?v_1) ?v_2)) (f6 f7 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* (+ ?v_1 1) ?v_0)) (f6 f7 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (f8 f9 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (+ ?v_1 1))) (f6 f7 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (* (f8 f9 (f6 f7 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f42 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 (f3 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* ?v_1 ?v_0)) (f6 f7 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f8 f9 ?v0))) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f8 f9 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f14 f24 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f14 f24 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (= (f18 (f19 f20 f48) (f6 f7 2)) f48))
(assert (= (f8 (f43 f44 0) (f6 f7 2)) 0))
(assert (= (f3 (f4 f42 f50) (f6 f7 2)) f50))
(assert (forall ((?v0 S8)) (= (= (f18 (f19 f20 ?v0) (f6 f7 2)) f48) (= ?v0 f48))))
(assert (forall ((?v0 Int)) (= (= (f8 (f43 f44 ?v0) (f6 f7 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S8)) (= (= (f10 (f21 f33 ?v0) ?v0) f48) (= ?v0 f48))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S2)) (=> (not (= ?v0 f48)) (not (= (f18 (f19 f20 ?v0) ?v1) f48)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (not (= ?v0 0)) (not (= (f8 (f43 f44 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S8) (?v1 S2)) (= (= (f18 (f19 f20 ?v0) ?v1) f48) (and (= ?v0 f48) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f8 (f43 f44 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f42 ?v0) ?v1) f50) (and (= ?v0 f50) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2)) (= (f18 (f19 f20 f48) (f6 f7 (+ (f8 f9 ?v0) 1))) f48)))
(assert (forall ((?v0 S2)) (= (f8 (f43 f44 0) (f6 f7 (+ (f8 f9 ?v0) 1))) 0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f42 f50) (f6 f7 (+ (f8 f9 ?v0) 1))) f50)))
(assert (not (= f34 f48)))
(assert (forall ((?v0 S8)) (= (= (f10 f11 ?v0) f48) (= ?v0 f48))))
(assert (= (f10 f11 f48) f48))
(assert (= (f31 f48 f32) f1))
(assert (= (f29 0 f30) f1))
(assert (= (f37 f50 f47) f1))
(assert (= (f10 f46 f48) f48))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f35 (f36 ?v0) ?v1) f1) (= (f35 (f36 (f10 f46 ?v0)) (f10 f46 ?v1)) f1))))
(assert (= (f28 f48) f1))
(assert (= (f27 0) f1))
(assert (= (f51 f50) f1))
(assert (forall ((?v0 S8)) (= (= (f28 ?v0) f1) (= ?v0 f48))))
(assert (forall ((?v0 Int)) (= (= (f27 ?v0) f1) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f51 ?v0) f1) (= ?v0 f50))))
(assert (forall ((?v0 S8)) (= (= (f35 (f36 (f10 (f21 f33 ?v0) ?v0)) f48) f1) (= (f35 (f36 ?v0) f48) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f10 (f21 f33 (f10 (f21 f26 ?v0) ?v0)) (f10 (f21 f26 ?v1) ?v1)) f48) (and (= ?v0 f48) (= ?v1 f48)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8) (?v1 S2)) (let ((?v_0 (f36 f48))) (=> (= (f35 ?v_0 ?v0) f1) (= (f35 ?v_0 (f18 (f19 f20 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 0 ?v0) (< 0 (f8 (f43 f44 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f52 f50))) (=> (= (f38 ?v_0 ?v0) f1) (= (f38 ?v_0 (f3 (f4 f42 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S8)) (= (= (f35 (f36 f48) (f18 (f19 f20 ?v0) (f6 f7 2))) f1) (not (= ?v0 f48)))))
(assert (forall ((?v0 Int)) (= (< 0 (f8 (f43 f44 ?v0) (f6 f7 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 S8)) (not (= (f35 (f36 (f18 (f19 f20 ?v0) (f6 f7 2))) f48) f1))))
(assert (forall ((?v0 Int)) (not (< (f8 (f43 f44 ?v0) (f6 f7 2)) 0))))
(assert (forall ((?v0 S8) (?v1 S2)) (=> (= (f35 (f36 ?v0) f48) f1) (= (f35 (f36 (f18 (f19 f20 ?v0) (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1)))) f48) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< ?v0 0) (< (f8 (f43 f44 ?v0) (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (= (= (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_0)) (f18 (f19 f20 ?v1) ?v_0)) f48) (and (= ?v0 f48) (= ?v1 f48))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (+ (f8 (f43 f44 ?v0) ?v_0) (f8 (f43 f44 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (= (f12 f13 f17) f48))
(assert (= 0 0))
(assert (= (f12 f13 f17) f48))
(assert (= 0 0))
(assert (= (f6 f25 f17) f50))
(assert (= f48 (f12 f13 f17)))
(assert (= 0 0))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1)) (?v_2 (f19 f20 ?v0))) (=> (not (= ?v0 f48)) (=> (<= ?v_1 ?v_0) (= (f18 ?v_2 (f6 f7 (- ?v_0 ?v_1))) (f10 (f21 f22 (f18 ?v_2 ?v2)) (f18 ?v_2 ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S2)) (=> (not (= ?v0 f48)) (= (f18 (f19 f20 (f10 (f21 f22 ?v1) ?v0)) ?v2) (f10 (f21 f22 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 ?v0) ?v2))))))
(assert (forall ((?v0 S8)) (= (not (= (f35 (f36 f48) (f10 (f21 f26 ?v0) ?v0)) f1)) (= ?v0 f48))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f26 ?v0))) (=> (= (f35 (f36 f48) ?v0) f1) (=> (= (f35 (f36 ?v1) ?v2) f1) (= (f35 (f36 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f36 f48))) (=> (= (f35 ?v_0 ?v0) f1) (=> (= (f35 ?v_0 ?v1) f1) (= (f35 ?v_0 (f10 (f21 f26 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f35 (f36 f48) ?v0) f1) (= (= (f35 (f36 (f10 (f21 f26 ?v1) ?v0)) (f10 (f21 f26 ?v2) ?v0)) f1) (= (f35 (f36 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f10 (f21 f33 (f10 (f21 f26 ?v0) ?v0)) (f10 (f21 f26 ?v1) ?v1)) f48) (and (= ?v0 f48) (= ?v1 f48)))))
(assert (= (f35 (f36 f48) f34) f1))
(assert (not (= (f35 (f36 f34) f48) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (= (= (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_0)) (f18 (f19 f20 ?v1) ?v_0)) f48) (and (= ?v0 f48) (= ?v1 f48))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f36 f48))) (=> (= (f35 ?v_0 ?v0) f1) (= (f35 ?v_0 (f10 f11 ?v0)) f1)))))
(assert (forall ((?v0 S8)) (=> (= (f35 (f36 f48) ?v0) f1) (not (= (f10 f11 ?v0) f48)))))
(assert (forall ((?v0 S8)) (= (= (f35 (f36 (f10 f11 ?v0)) f48) f1) (= (f35 (f36 ?v0) f48) f1))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f36 f48))) (= (= (f35 ?v_0 (f10 f11 ?v0)) f1) (= (f35 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f35 (f36 f48) (f10 (f21 f33 (f10 (f21 f26 ?v0) ?v0)) (f10 (f21 f26 ?v1) ?v1))) f1) (or (not (= ?v0 f48)) (not (= ?v1 f48))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< 0 (+ (* ?v0 ?v0) (* ?v1 ?v1))) (or (not (= ?v0 0)) (not (= ?v1 0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (not (= (f35 (f36 (f10 (f21 f33 (f10 (f21 f26 ?v0) ?v0)) (f10 (f21 f26 ?v1) ?v1))) f48) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (not (< (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (= (= (f35 (f36 f48) (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_0)) (f18 (f19 f20 ?v1) ?v_0))) f1) (or (not (= ?v0 f48)) (not (= ?v1 f48)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (< 0 (+ (f8 (f43 f44 ?v0) ?v_0) (f8 (f43 f44 ?v1) ?v_0))) (or (not (= ?v0 0)) (not (= ?v1 0)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (not (= (f35 (f36 (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_0)) (f18 (f19 f20 ?v1) ?v_0))) f48) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (not (< (+ (f8 (f43 f44 ?v0) ?v_0) (f8 (f43 f44 ?v1) ?v_0)) 0)))))
(assert (forall ((?v0 Int)) (= (= (f35 (f36 f48) (f12 f13 ?v0)) f1) (< f17 ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f14 f24 ?v0)) (< f17 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f35 (f36 (f12 f13 ?v0)) f48) f1) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (= (< (f14 f24 ?v0) 0) (< ?v0 f17))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f12 f13 (f14 f15 ?v0)) (f10 (f21 f33 (f10 (f21 f33 f48) ?v_0)) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f24 ?v0))) (= (f14 f24 (f14 f15 ?v0)) (+ (+ 0 ?v_0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 Int) (?v2 S8)) (let ((?v_0 (f12 f13 ?v1))) (= (= (f10 (f21 f22 ?v0) ?v_0) ?v2) (ite (not (= ?v_0 f48)) (= ?v0 (f10 (f21 f26 ?v2) ?v_0)) (= ?v2 f48))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (= (= (f10 (f21 f22 ?v0) ?v1) ?v_0) (ite (not (= ?v1 f48)) (= ?v0 (f10 (f21 f26 ?v_0) ?v1)) (= ?v_0 f48))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f13 ?v0))) (= (= ?v_0 (f10 (f21 f22 ?v1) ?v2)) (ite (not (= ?v2 f48)) (= (f10 (f21 f26 ?v_0) ?v2) ?v1) (= ?v_0 f48))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (= (= ?v0 (f10 (f21 f22 ?v1) ?v_0)) (ite (not (= ?v_0 f48)) (= (f10 (f21 f26 ?v0) ?v_0) ?v1) (= ?v0 f48))))))
(assert (forall ((?v0 S8)) (= (f10 (f21 f22 ?v0) (f12 f13 f17)) f48)))
(assert (forall ((?v0 S8)) (let ((?v_0 (f36 f48))) (=> (= (f35 ?v_0 ?v0) f1) (= (f35 ?v_0 (f18 (f19 f20 (f10 f11 ?v0)) (f6 f7 2))) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (=> (= (f10 f11 (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_0)) (f18 (f19 f20 ?v1) ?v_0))) ?v0) (= ?v1 f48)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f6 f7 2))) (=> (= (f10 f11 (f10 (f21 f33 (f18 (f19 f20 ?v0) ?v_0)) (f18 (f19 f20 ?v1) ?v_0))) ?v1) (= ?v0 f48)))))
(assert (forall ((?v0 Int)) (= (= f48 (f12 f13 ?v0)) (= (f28 (f12 f13 (+ f17 (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= 0 (f14 f24 ?v0)) (= (f27 (f14 f24 (+ f17 (- ?v0)))) f1))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
