(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S3)
(declare-fun f4 () S2)
(declare-fun f5 (S4 Int) S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 Int) Int)
(declare-fun f8 () S5)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 (S6 S7) S3)
(declare-fun f12 (S8 S3) S6)
(declare-fun f13 () S8)
(declare-fun f14 (S9 Int) S7)
(declare-fun f15 () S9)
(declare-fun f16 () S5)
(declare-fun f17 (S10 S7) Int)
(declare-fun f18 () S10)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 (f7 f9 f10)))) (not (= (f3 f4 (f5 f6 (f7 f8 ?v_0))) (f5 f6 ?v_0)))))
(assert (let ((?v_0 (f7 f8 (f7 f9 f10)))) (= (f3 f4 (f5 f6 (f7 f8 ?v_0))) (f3 f4 (f11 (f12 f13 (f5 f6 ?v_0)) (f14 f15 2))))))
(assert (let ((?v_0 (f7 f8 (f7 f9 f10)))) (= (f3 f4 (f5 f6 (f7 f8 ?v_0))) (f3 f4 (f11 (f12 f13 (f5 f6 ?v_0)) (f14 f15 2))))))
(assert (= (f7 f8 f10) f10))
(assert (forall ((?v0 Int)) (= (- f10 (f7 f8 ?v0)) (f7 f8 (- f10 ?v0)))))
(assert (forall ((?v0 Int)) (= (= f10 (f7 f8 ?v0)) (= f10 ?v0))))
(assert (forall ((?v0 Int)) (= (< f10 (f7 f8 ?v0)) (< f10 ?v0))))
(assert (forall ((?v0 Int)) (= (<= f10 (f7 f8 ?v0)) (<= f10 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f7 f8 ?v0) f10) (= ?v0 f10))))
(assert (forall ((?v0 Int)) (= (< (f7 f8 ?v0) f10) (< ?v0 f10))))
(assert (forall ((?v0 Int)) (= (<= (f7 f8 ?v0) f10) (<= ?v0 f10))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f7 f9 ?v0) ?v1) (+ (f7 f8 (* ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f8 ?v0) (f7 f9 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f9 ?v0) (f7 f8 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f7 f8 ?v0) (f7 f9 ?v1)) (f7 f9 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f16 ?v0) (f7 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 f6 ?v0) (f5 f6 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f16 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f9 ?v0) (f7 f9 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f7 f9 ?v0) (f7 f9 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f9 ?v0) (f7 f9 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f7 f9 ?v0) (f7 f9 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 f9 ?v0) (f7 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f7 f9 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f7 f9 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f10) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f10) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f10 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* f10 ?v0) f10)))
(assert (= (<= f10 f10) true))
(assert (= (< f10 0) false))
(assert (= (< f10 f10) false))
(assert (= (= f10 f10) true))
(assert (= (- f10) f10))
(assert (= f10 0))
(assert (forall ((?v0 S7)) (= (f14 f15 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
