(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S2) S3)
(declare-fun f7 () S4)
(declare-fun f8 (S5 Int) S2)
(declare-fun f9 () S5)
(declare-fun f10 (S6 Int) Int)
(declare-fun f11 () S6)
(declare-fun f12 () S6)
(declare-fun f13 () Int)
(declare-fun f14 () S2)
(declare-fun f15 () S2)
(declare-fun f16 () Int)
(declare-fun f17 () S2)
(declare-fun f18 () S6)
(declare-fun f19 (S7 Int) S8)
(declare-fun f20 () S7)
(declare-fun f21 () S8)
(declare-fun f22 (S9 S8) S8)
(declare-fun f23 (S10 S8) S9)
(declare-fun f24 () S10)
(declare-fun f25 () S7)
(declare-fun f26 (S11 S8) Int)
(declare-fun f27 () S11)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14)) f15) f1)))
(assert (= (f3 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14) f15) f1))
(assert (= (f3 (f8 f9 f16) (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14)) f1))
(assert (= (f3 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f17) f15) f1))
(assert (= (f3 (f8 f9 f16) (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f17)) f1))
(assert (= (f3 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f17) f15) f1))
(assert (= (f3 (f8 f9 f16) (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f17)) f1))
(assert (= (f3 (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14) f15) f1))
(assert (= (f3 (f8 f9 f16) (f4 (f6 f7 (f8 f9 (f10 f11 (f10 f12 f13)))) f14)) f1))
(assert (forall ((?v0 Int)) (= (= (f3 f15 (f8 f9 ?v0)) f1) (<= (f10 f12 f13) ?v0))))
(assert (forall ((?v0 Int)) (= (<= 1 (f10 f18 ?v0)) (<= (f10 f12 f13) ?v0))))
(assert (forall ((?v0 Int)) (= (= (f3 (f8 f9 ?v0) f15) f1) (<= ?v0 (f10 f12 f13)))))
(assert (forall ((?v0 Int)) (= (<= (f10 f18 ?v0) 1) (<= ?v0 (f10 f12 f13)))))
(assert (= f15 (f8 f9 (f10 f12 f13))))
(assert (= 1 1))
(assert (= (f8 f9 (f10 f12 f13)) f15))
(assert (= 1 1))
(assert (= (f19 f20 (f10 f12 f13)) f21))
(assert (= (f8 f9 (f10 f12 f13)) f15))
(assert (= 1 1))
(assert (forall ((?v0 S2)) (= (f4 (f6 f7 ?v0) (f8 f9 (f10 f12 f13))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f6 f7 (f8 f9 (f10 f12 f13))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f13 ?v0) (=> (<= f13 ?v1) (= (f22 (f23 f24 (f19 f20 ?v0)) (f19 f20 ?v1)) (f19 f20 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f13 ?v0) (=> (<= f13 ?v1) (= (f4 (f6 f7 (f8 f9 ?v0)) (f8 f9 ?v1)) (f8 f9 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f13 ?v0) (=> (<= f13 ?v1) (= (* (f10 f18 ?v0) (f10 f18 ?v1)) (f10 f18 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S2)) (= (f3 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f6 f7 f15) ?v0) ?v0)))
(assert (= (f10 f11 f13) f13))
(assert (forall ((?v0 Int)) (= (- f13 (f10 f11 ?v0)) (f10 f11 (- f13 ?v0)))))
(assert (= f16 (- 1)))
(assert (= (= f16 f16) true))
(assert (= (< f16 f16) false))
(assert (= (< f16 0) true))
(assert (= (<= f16 f16) true))
(assert (forall ((?v0 Int)) (= (* f16 ?v0) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 f25 (* (f26 f27 (f19 f20 ?v0)) (f26 f27 (f19 f20 ?v1)))) (ite (< ?v0 f13) (f19 f25 0) (f19 f25 (f10 f18 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (let ((?v_0 (f26 f27 ?v2))) (= (f19 f25 (* (f26 f27 (f19 f20 ?v0)) (* (f26 f27 (f19 f20 ?v1)) ?v_0))) (ite (< ?v0 f13) (f19 f25 0) (f19 f25 (* (f26 f27 (f19 f20 (* ?v0 ?v1))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f26 f27 (f19 f20 ?v0)) (f26 f27 (f19 f20 ?v1))) (ite (< ?v0 ?v1) (< f13 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f26 f27 (f19 f20 ?v0)) (f26 f27 (f19 f20 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f13)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 f25 (+ (f26 f27 (f19 f20 ?v0)) (f26 f27 (f19 f20 ?v1)))) (ite (< ?v0 f13) (f19 f25 (f10 f18 ?v1)) (ite (< ?v1 f13) (f19 f25 (f10 f18 ?v0)) (f19 f25 (f10 f18 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f19 f25 (f10 f18 ?v0)) (f19 f25 0)) (<= ?v0 f13))))
(assert (forall ((?v0 Int)) (= (= (f19 f25 0) (f19 f25 (f10 f18 ?v0))) (<= ?v0 f13))))
(assert (forall ((?v0 Int)) (= (< 0 (f26 f27 (f19 f20 ?v0))) (< f13 ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f10 f12 ?v0) f16) (<= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (< (f10 f12 ?v0) f16) (< ?v0 f16))))
(assert (forall ((?v0 S8)) (= (f19 f25 (f26 f27 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f26 f27 (f19 f25 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f26 f27 (f19 f25 ?v0)) 0))))
(check-sat)
(exit)
