(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S5) S1)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S4) S4)
(declare-fun f10 (S8 S4) S7)
(declare-fun f11 () S8)
(declare-fun f12 () S4)
(declare-fun f13 () S8)
(declare-fun f14 () S4)
(declare-fun f15 (S9 S10) S4)
(declare-fun f16 (S11 S4) S9)
(declare-fun f17 () S11)
(declare-fun f18 () S10)
(declare-fun f19 () S5)
(declare-fun f20 (S12 Int) S10)
(declare-fun f21 () S12)
(declare-fun f22 () S4)
(declare-fun f23 (S13 S10) Int)
(declare-fun f24 (S14 Int) S13)
(declare-fun f25 () S14)
(declare-fun f26 (S15 S5) S5)
(declare-fun f27 (S16 S5) S15)
(declare-fun f28 () S16)
(declare-fun f29 (S17 S10) S5)
(declare-fun f30 (S18 S5) S17)
(declare-fun f31 () S18)
(declare-fun f32 (S10 S10) S1)
(declare-fun f33 () S10)
(declare-fun f34 (S19 S10) S10)
(declare-fun f35 (S20 S10) S19)
(declare-fun f36 () S20)
(declare-fun f37 () S20)
(declare-fun f38 () S15)
(declare-fun f39 () S16)
(declare-fun f40 () S13)
(declare-fun f41 () S5)
(declare-fun f42 () S10)
(declare-fun f43 () S15)
(declare-fun f44 () S2)
(declare-fun f45 () S7)
(declare-fun f46 (S5 S5) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (not (exists ((?v0 S4)) (= (f6 (f7 f8 (f9 (f10 f11 f12) (f9 (f10 f13 f14) (f15 (f16 f17 ?v0) f18)))) f19) f1))))
(assert (not (= f18 (f20 f21 0))))
(assert (not (= f18 (f20 f21 0))))
(assert (not (= f14 f22)))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 1 ?v0) (< 1 (* ?v0 (f23 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 S5) (?v1 S10)) (=> (= (f6 f19 ?v0) f1) (= (f6 f19 (f26 (f27 f28 ?v0) (f29 (f30 f31 ?v0) ?v1))) f1))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f32 f33 ?v0) f1) (= (f32 f33 (f34 (f35 f36 ?v0) (f34 (f35 f37 ?v0) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f23 (f24 f25 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (* ?v0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f29 (f30 f31 ?v0) ?v1))) (=> (= (f6 f19 ?v0) f1) (= (f6 ?v_0 (f26 (f27 f28 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f34 (f35 f37 ?v0) ?v1))) (=> (= (f32 f33 ?v0) f1) (= (f32 ?v_0 (f34 (f35 f36 ?v0) ?v_0)) f1)))))
(assert (= (f26 f38 f19) f19))
(assert (= (f7 f8 f12) f19))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f26 f38 ?v0) ?v1) f1) (=> (= (f6 (f26 f38 ?v2) ?v3) f1) (= (f6 (f26 f38 (f26 (f27 f39 ?v0) ?v2)) (f26 (f27 f39 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S4) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f8 (f9 (f10 f11 ?v0) ?v2)) (f26 (f27 f39 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f26 f38 ?v0) ?v1) f1) (=> (= (f6 (f26 f38 ?v2) ?v3) f1) (= (f6 (f26 f38 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S4) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f8 (f9 (f10 f13 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) 1 (* ?v0 (f23 ?v_0 (f20 f21 (- (f23 f40 ?v1) 1)))))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f19 (f26 (f27 f28 ?v0) (f29 ?v_0 (f20 f21 (- (f23 f40 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f12 (f9 (f10 f13 ?v0) (f15 ?v_0 (f20 f21 (- (f23 f40 ?v1) 1)))))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f33 (f34 (f35 f36 ?v0) (f34 ?v_0 (f20 f21 (- (f23 f40 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 1 ?v0) (< 1 (f23 (f24 f25 ?v0) (f20 f21 (+ (f23 f40 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S10)) (=> (= (f6 f19 ?v0) f1) (= (f6 f19 (f29 (f30 f31 ?v0) (f20 f21 (+ (f23 f40 ?v1) 1)))) f1))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f32 f33 ?v0) f1) (= (f32 f33 (f34 (f35 f37 ?v0) (f20 f21 (+ (f23 f40 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (= (= (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S10) (?v2 S10)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f6 f19 ?v0) f1) (= (= (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v0))) (=> (= (f32 f33 ?v0) f1) (= (= (f34 ?v_0 ?v1) (f34 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (= (< (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) (< (f23 f40 ?v1) (f23 f40 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S10) (?v2 S10)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f6 f19 ?v0) f1) (= (= (f6 (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) f1) (< (f23 f40 ?v1) (f23 f40 ?v2)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v0))) (=> (= (f32 f33 ?v0) f1) (= (= (f32 (f34 ?v_0 ?v1) (f34 ?v_0 ?v2)) f1) (< (f23 f40 ?v1) (f23 f40 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 1 ?v0) (=> (< 0 (f23 f40 ?v1)) (< 1 (f23 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 S5) (?v1 S10)) (=> (= (f6 f19 ?v0) f1) (=> (< 0 (f23 f40 ?v1)) (= (f6 f19 (f29 (f30 f31 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f32 f33 ?v0) f1) (=> (< 0 (f23 f40 ?v1)) (= (f32 f33 (f34 (f35 f37 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (=> (< (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) (< (f23 f40 ?v1) (f23 f40 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S10) (?v2 S10)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f6 f19 ?v0) f1) (=> (= (f6 (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) f1) (< (f23 f40 ?v1) (f23 f40 ?v2)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v0))) (=> (= (f32 f33 ?v0) f1) (=> (= (f32 (f34 ?v_0 ?v1) (f34 ?v_0 ?v2)) f1) (< (f23 f40 ?v1) (f23 f40 ?v2)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (< (f23 f40 ?v0) (f23 f40 ?v1)) (=> (< 1 ?v2) (< (f23 ?v_0 ?v0) (f23 ?v_0 ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S5)) (let ((?v_0 (f30 f31 ?v2))) (=> (< (f23 f40 ?v0) (f23 f40 ?v1)) (=> (= (f6 f19 ?v2) f1) (= (f6 (f29 ?v_0 ?v0) (f29 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v2))) (=> (< (f23 f40 ?v0) (f23 f40 ?v1)) (=> (= (f32 f33 ?v2) f1) (= (f32 (f34 ?v_0 ?v0) (f34 ?v_0 ?v1)) f1))))))
(assert (= (f26 f38 f41) f41))
(assert (= (f7 f8 f22) f41))
(assert (forall ((?v0 S5)) (= (= (f26 f38 ?v0) f41) (= ?v0 f41))))
(assert (forall ((?v0 S4)) (= (= (f7 f8 ?v0) f41) (= ?v0 f22))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f20 f21 (* (f23 f40 ?v1) (f23 f40 ?v2)))) (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 ?v_0 (f20 f21 (* (f23 f40 ?v1) (f23 f40 ?v2)))) (f34 (f35 f37 (f34 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S10) (?v2 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f20 f21 (* (f23 f40 ?v1) (f23 f40 ?v2)))) (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f20 f21 (* (f23 f40 ?v1) (f23 f40 ?v2)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 ?v0) f41) f41)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 ?v0) f22) f22)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 ?v0) f41) f41)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 ?v0) f22) f22)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 f41) ?v0) f41)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 f22) ?v0) f22)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 f41) ?v0) f41)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 f22) ?v0) f22)))
(assert (forall ((?v0 S5) (?v1 S10)) (=> (not (= ?v0 f41)) (not (= (f29 (f30 f31 ?v0) ?v1) f41)))))
(assert (forall ((?v0 S4) (?v1 S10)) (=> (not (= ?v0 f22)) (not (= (f15 (f16 f17 ?v0) ?v1) f22)))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (not (= ?v0 0)) (not (= (f23 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S10)) (= (= (f29 (f30 f31 ?v0) ?v1) f41) (and (= ?v0 f41) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 S4) (?v1 S10)) (= (= (f15 (f16 f17 ?v0) ?v1) f22) (and (= ?v0 f22) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f23 (f24 f25 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f34 (f35 f37 ?v0) ?v1) f42) (and (= ?v0 f42) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 S10)) (= (f29 (f30 f31 f41) (f20 f21 (+ (f23 f40 ?v0) 1))) f41)))
(assert (forall ((?v0 S10)) (= (f15 (f16 f17 f22) (f20 f21 (+ (f23 f40 ?v0) 1))) f22)))
(assert (forall ((?v0 S10)) (= (f23 (f24 f25 0) (f20 f21 (+ (f23 f40 ?v0) 1))) 0)))
(assert (forall ((?v0 S10)) (= (f34 (f35 f37 f42) (f20 f21 (+ (f23 f40 ?v0) 1))) f42)))
(assert (forall ((?v0 S5)) (= (= (f6 f41 (f26 f38 ?v0)) f1) (not (= ?v0 f41)))))
(assert (forall ((?v0 S4)) (= (= (f6 f41 (f7 f8 ?v0)) f1) (not (= ?v0 f22)))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f26 f43 ?v0) f19) f1) (= (f6 (f29 (f30 f31 ?v0) (f20 f21 2)) f19) f1))))
(assert (forall ((?v0 S5) (?v1 S10)) (=> (= (f6 f41 ?v0) f1) (= (f6 f41 (f29 (f30 f31 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 0 ?v0) (< 0 (f23 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f32 f42 ?v0) f1) (= (f32 f42 (f34 (f35 f37 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S10)) (= (f23 (f24 f25 0) ?v0) (ite (= ?v0 (f20 f21 0)) 1 0))))
(assert (forall ((?v0 S10)) (= (f29 (f30 f31 f41) ?v0) (ite (= ?v0 (f20 f21 0)) f19 f41))))
(assert (forall ((?v0 S10)) (= (f15 (f16 f17 f22) ?v0) (ite (= ?v0 (f20 f21 0)) f12 f22))))
(assert (forall ((?v0 S10)) (= (f34 (f35 f37 f42) ?v0) (ite (= ?v0 (f20 f21 0)) f33 f42))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (< (f23 f40 ?v0) (f23 f40 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f23 ?v_0 ?v1) (f23 ?v_0 ?v0))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S5)) (let ((?v_0 (f30 f31 ?v2))) (=> (< (f23 f40 ?v0) (f23 f40 ?v1)) (=> (= (f6 f41 ?v2) f1) (=> (= (f6 ?v2 f19) f1) (= (f6 (f29 ?v_0 ?v1) (f29 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v2))) (=> (< (f23 f40 ?v0) (f23 f40 ?v1)) (=> (= (f32 f42 ?v2) f1) (=> (= (f32 ?v2 f33) f1) (= (f32 (f34 ?v_0 ?v1) (f34 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f23 (f24 f25 ?v0) (f20 f21 (+ (f23 f40 ?v1) 1))) 1)))))
(assert (forall ((?v0 S5) (?v1 S10)) (=> (= (f6 f41 ?v0) f1) (=> (= (f6 ?v0 f19) f1) (= (f6 (f29 (f30 f31 ?v0) (f20 f21 (+ (f23 f40 ?v1) 1))) f19) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f32 f42 ?v0) f1) (=> (= (f32 ?v0 f33) f1) (= (f32 (f34 (f35 f37 ?v0) (f20 f21 (+ (f23 f40 ?v1) 1))) f33) f1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f23 (f24 f25 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f29 (f30 f31 ?v0) ?v1))) (=> (= (f6 f41 ?v0) f1) (=> (= (f6 ?v0 f19) f1) (= (f6 (f26 (f27 f28 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f34 (f35 f37 ?v0) ?v1))) (=> (= (f32 f42 ?v0) f1) (=> (= (f32 ?v0 f33) f1) (= (f32 (f34 (f35 f36 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f34 (f35 f37 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f29 (f30 f31 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f15 (f16 f17 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S5) (?v1 S10)) (= (f26 f43 (f29 (f30 f31 ?v0) ?v1)) (f29 (f30 f31 (f26 f43 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f3 f44 (f23 (f24 f25 ?v0) ?v1)) (f23 (f24 f25 (f3 f44 ?v0)) ?v1))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f26 f43 ?v_0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f26 (f27 f28 (f26 (f27 f39 ?v0) ?v1)) ?v2) (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v2)) (f9 (f10 f13 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f26 (f27 f28 (f26 (f27 f39 ?v0) ?v1)) ?v2) (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v2)) (f9 (f10 f13 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f39 ?v1) ?v2)) (f26 (f27 f39 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f39 ?v1) ?v2)) (f26 (f27 f39 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (let ((?v_0 (f23 f40 ?v1)) (?v_1 (f23 f40 ?v0)) (?v_2 (f24 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f23 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (* (f23 ?v_2 (f20 f21 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f23 f40 ?v1)) (?v_1 (f23 f40 ?v0)) (?v_2 (f35 f37 ?v2))) (=> (<= ?v_1 ?v_0) (= (f34 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f34 (f35 f36 (f34 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S5)) (let ((?v_0 (f23 f40 ?v1)) (?v_1 (f23 f40 ?v0)) (?v_2 (f30 f31 ?v2))) (=> (<= ?v_1 ?v_0) (= (f29 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f26 (f27 f28 (f29 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S4)) (let ((?v_0 (f23 f40 ?v1)) (?v_1 (f23 f40 ?v0)) (?v_2 (f16 f17 ?v2))) (=> (<= ?v_1 ?v_0) (= (f15 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f9 (f10 f13 (f15 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f23 (f24 f25 (* ?v0 ?v1)) ?v2) (* (f23 (f24 f25 ?v0) ?v2) (f23 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f34 (f35 f37 (f34 (f35 f36 ?v0) ?v1)) ?v2) (f34 (f35 f36 (f34 (f35 f37 ?v0) ?v2)) (f34 (f35 f37 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S10)) (= (f29 (f30 f31 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f28 (f29 (f30 f31 ?v0) ?v2)) (f29 (f30 f31 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S10)) (= (f15 (f16 f17 (f9 (f10 f13 ?v0) ?v1)) ?v2) (f9 (f10 f13 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f23 (f24 f25 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f34 (f35 f37 ?v0) ?v1))) (= (f34 (f35 f36 ?v_0) ?v0) (f34 (f35 f36 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f29 (f30 f31 ?v0) ?v1))) (= (f26 (f27 f28 ?v_0) ?v0) (f26 (f27 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v1))) (= (f9 (f10 f13 ?v_0) ?v0) (f9 (f10 f13 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f20 f21 (+ (f23 f40 ?v1) (f23 f40 ?v2)))) (* (f23 ?v_0 ?v1) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 ?v_0 (f20 f21 (+ (f23 f40 ?v1) (f23 f40 ?v2)))) (f34 (f35 f36 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S10) (?v2 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f20 f21 (+ (f23 f40 ?v1) (f23 f40 ?v2)))) (f26 (f27 f28 (f29 ?v_0 ?v1)) (f29 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f20 f21 (+ (f23 f40 ?v1) (f23 f40 ?v2)))) (f9 (f10 f13 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (* (f23 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (f26 (f27 f28 (f29 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (f9 (f10 f13 (f15 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (* ?v0 (f23 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (f34 (f35 f36 ?v0) (f34 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (f26 (f27 f28 ?v0) (f29 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (f9 (f10 f13 ?v0) (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f20 f21 0)) 1)))
(assert (forall ((?v0 S5)) (= (f29 (f30 f31 ?v0) (f20 f21 0)) f19)))
(assert (forall ((?v0 S4)) (= (f15 (f16 f17 ?v0) (f20 f21 0)) f12)))
(assert (forall ((?v0 S10)) (= (f34 (f35 f37 ?v0) (f20 f21 0)) f33)))
(assert (forall ((?v0 S10)) (= (f23 (f24 f25 1) ?v0) 1)))
(assert (forall ((?v0 S10)) (= (f29 (f30 f31 f19) ?v0) f19)))
(assert (forall ((?v0 S10)) (= (f15 (f16 f17 f12) ?v0) f12)))
(assert (forall ((?v0 S10)) (= (f34 (f35 f37 f33) ?v0) f33)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f26 f38 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f38 ?v0)) (f26 f38 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f7 f8 (f9 (f10 f13 ?v0) ?v1)) (f26 (f27 f28 (f7 f8 ?v0)) (f7 f8 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S10)) (= (f26 f38 (f29 (f30 f31 ?v0) ?v1)) (f29 (f30 f31 (f26 f38 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S10)) (= (f7 f8 (f15 (f16 f17 ?v0) ?v1)) (f29 (f30 f31 (f7 f8 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 2))) (= (< 0 (+ (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0))) (or (not (= ?v0 0)) (not (= ?v1 0)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f20 f21 2))) (= (= (f6 f41 (f26 (f27 f39 (f29 (f30 f31 ?v0) ?v_0)) (f29 (f30 f31 ?v1) ?v_0))) f1) (or (not (= ?v0 f41)) (not (= ?v1 f41)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 2))) (not (< (+ (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0)) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f20 f21 2))) (not (= (f6 (f26 (f27 f39 (f29 (f30 f31 ?v0) ?v_0)) (f29 (f30 f31 ?v1) ?v_0)) f41) f1)))))
(assert (< 0 (+ 1 1)))
(assert (= (f6 f41 (f26 (f27 f39 f19) f19)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< 0 (+ (* ?v0 ?v0) (* ?v1 ?v1))) (or (not (= ?v0 0)) (not (= ?v1 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 f41 (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v0)) (f26 (f27 f28 ?v1) ?v1))) f1) (or (not (= ?v0 f41)) (not (= ?v1 f41))))))
(assert (forall ((?v0 Int) (?v1 Int)) (not (< (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (not (= (f6 (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v0)) (f26 (f27 f28 ?v1) ?v1)) f41) f1))))
(assert (forall ((?v0 S5)) (not (= (f6 (f26 (f27 f39 (f26 f43 ?v0)) f19) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 2))) (= (= (+ (f23 (f24 f25 ?v0) ?v_0) (f23 (f24 f25 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f20 f21 2))) (= (= (f26 (f27 f39 (f29 (f30 f31 ?v0) ?v_0)) (f29 (f30 f31 ?v1) ?v_0)) f41) (and (= ?v0 f41) (= ?v1 f41))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (* ?v0 ?v1) ?v1) (* (+ ?v0 1) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v1)) ?v1) (f26 (f27 f28 (f26 (f27 f39 ?v0) f19)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v1)) ?v1) (f9 (f10 f13 (f9 (f10 f11 ?v0) f12)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (* ?v1 ?v0)) (* (+ ?v1 1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f26 (f27 f39 ?v0) (f26 (f27 f28 ?v1) ?v0)) (f26 (f27 f28 (f26 (f27 f39 ?v1) f19)) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f9 (f10 f11 ?v0) (f9 (f10 f13 ?v1) ?v0)) (f9 (f10 f13 (f9 (f10 f11 ?v1) f12)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (* (+ 1 1) ?v0))))
(assert (forall ((?v0 S5)) (= (f26 (f27 f39 ?v0) ?v0) (f26 (f27 f28 (f26 (f27 f39 f19) f19)) ?v0))))
(assert (forall ((?v0 S4)) (= (f9 (f10 f11 ?v0) ?v0) (f9 (f10 f13 (f9 (f10 f11 f12) f12)) ?v0))))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S5)) (= (f6 ?v0 (f26 (f27 f39 ?v0) f19)) f1)))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) (f20 f21 1) (f20 f21 (* (f23 f40 ?v0) (f23 f40 (f34 ?v_0 (f20 f21 (- (f23 f40 ?v1) 1)))))))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f20 f21 0)) (?v_2 (f23 f40 ?v0)) (?v_1 (f23 f40 ?v1))) (= (f20 f21 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f20 f21 (+ ?v_1 (* (f23 f40 (f20 f21 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f23 f40 ?v0))) (= (f20 f21 (* ?v_0 2)) (f20 f21 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f23 f40 ?v0))) (= (f20 f21 (* 2 ?v_0)) (f20 f21 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (=> (not (= ?v0 f41)) (= (= (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f41)) (= (= (f26 (f27 f28 ?v1) ?v0) (f26 (f27 f28 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (not (= f41 f19)))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f20 f21 2))) (= (= (f26 (f27 f39 (f29 (f30 f31 ?v0) ?v_0)) (f29 (f30 f31 ?v1) ?v_0)) f41) (and (= ?v0 f41) (= ?v1 f41))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (=> (= (f6 f41 ?v0) f1) (=> (= (f6 ?v1 ?v2) f1) (= (f6 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 f41 ?v0) f1) (=> (= (f6 f41 ?v1) f1) (= (f6 f41 (f26 (f27 f28 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 f41 ?v0) f1) (= (= (f6 (f26 (f27 f28 ?v1) ?v0) (f26 (f27 f28 ?v2) ?v0)) f1) (= (f6 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v0)) (f26 (f27 f28 ?v1) ?v1)) f41) (and (= ?v0 f41) (= ?v1 f41)))))
(assert (forall ((?v0 S5)) (= (f6 f41 (f26 (f27 f39 f19) (f26 f43 ?v0))) f1)))
(assert (forall ((?v0 S4)) (not (= (f6 (f7 f8 ?v0) f41) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 ?v0 ?v1) f1) false) (=> (=> (= (f6 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f26 f43 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f43 ?v0)) (f26 f43 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f44 (* ?v0 ?v1)) (* (f3 f44 ?v0) (f3 f44 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f9 (f10 f13 ?v0) ?v1) (f9 (f10 f13 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f27 f28 ?v0)) (?v_0 (f27 f28 ?v1))) (= (f26 ?v_1 (f26 ?v_0 ?v2)) (f26 ?v_0 (f26 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f10 f13 ?v0)) (?v_0 (f10 f13 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2)) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 ?v_0 (f9 (f10 f13 ?v1) ?v2)) (f9 (f10 f13 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f26 f43 ?v0))) (= (f26 (f27 f28 ?v_0) ?v_0) (f26 (f27 f28 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f44 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 (f10 f13 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f13 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f28 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 (f10 f13 (f9 ?v_0 ?v1)) ?v2) (f9 (f10 f13 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f26 (f27 f28 ?v2) ?v3))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v_1) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f10 f13 ?v0)) (?v_1 (f9 (f10 f13 ?v2) ?v3))) (= (f9 (f10 f13 (f9 ?v_0 ?v1)) ?v_1) (f9 ?v_0 (f9 (f10 f13 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f27 f28 (f26 (f27 f28 ?v0) ?v1))) (?v_0 (f27 f28 ?v2))) (= (f26 ?v_1 (f26 ?v_0 ?v3)) (f26 ?v_0 (f26 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f10 f13 (f9 (f10 f13 ?v0) ?v1))) (?v_0 (f10 f13 ?v2))) (= (f9 ?v_1 (f9 ?v_0 ?v3)) (f9 ?v_0 (f9 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) (f26 (f27 f28 ?v2) ?v3)) (f26 (f27 f28 (f26 ?v_0 ?v2)) (f26 (f27 f28 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 (f10 f13 (f9 ?v_0 ?v1)) (f9 (f10 f13 ?v2) ?v3)) (f9 (f10 f13 (f9 ?v_0 ?v2)) (f9 (f10 f13 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f26 (f27 f39 ?v0) ?v1) (f26 (f27 f39 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f27 f39 ?v0)) (?v_0 (f27 f39 ?v1))) (= (f26 ?v_1 (f26 ?v_0 ?v2)) (f26 ?v_0 (f26 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f10 f11 ?v0)) (?v_0 (f10 f11 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f39 ?v0))) (= (f26 ?v_0 (f26 (f27 f39 ?v1) ?v2)) (f26 (f27 f39 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f39 ?v0))) (= (f26 (f27 f39 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f39 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f39 ?v0))) (= (f26 (f27 f39 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f39 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 (f10 f11 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f27 f39 ?v0))) (= (f26 (f27 f39 (f26 ?v_0 ?v1)) (f26 (f27 f39 ?v2) ?v3)) (f26 (f27 f39 (f26 ?v_0 ?v2)) (f26 (f27 f39 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 (f10 f11 ?v2) ?v3)) (f9 (f10 f11 (f9 ?v_0 ?v2)) (f9 (f10 f11 ?v1) ?v3))))))
(assert (= (f26 f43 f19) f19))
(assert (= (f3 f44 1) 1))
(assert (forall ((?v0 S5)) (let ((?v_0 (f29 (f30 f31 ?v0) (f20 f21 2)))) (= (f26 f43 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f23 (f24 f25 ?v0) (f20 f21 2)))) (= (f3 f44 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f34 (f35 f37 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f29 (f30 f31 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f15 (f16 f17 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S5)) (let ((?v_0 (f20 f21 2))) (= (f29 (f30 f31 (f26 f43 ?v0)) ?v_0) (f29 (f30 f31 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 2))) (= (f23 (f24 f25 (f3 f44 ?v0)) ?v_0) (f23 (f24 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f20 f21 (* 2 (f23 f40 ?v1)))) (f23 (f24 f25 (f23 ?v_0 ?v1)) (f20 f21 2))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 ?v_0 (f20 f21 (* 2 (f23 f40 ?v1)))) (f34 (f35 f37 (f34 ?v_0 ?v1)) (f20 f21 2))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f20 f21 (* 2 (f23 f40 ?v1)))) (f29 (f30 f31 (f29 ?v_0 ?v1)) (f20 f21 2))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f20 f21 (* 2 (f23 f40 ?v1)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) (f20 f21 2))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2) (f23 ?v_0 (f20 f21 (* (f23 f40 ?v1) (f23 f40 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 (f35 f37 (f34 ?v_0 ?v1)) ?v2) (f34 ?v_0 (f20 f21 (* (f23 f40 ?v1) (f23 f40 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S10) (?v2 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2) (f29 ?v_0 (f20 f21 (* (f23 f40 ?v1) (f23 f40 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f20 f21 (* (f23 f40 ?v1) (f23 f40 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v1) ?v0))))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 f41) ?v0) f41)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 f22) ?v0) f22)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 f41) ?v0) f41)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 f22) ?v0) f22)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 ?v0) f41) f41)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 ?v0) f22) f22)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 ?v0) f41) f41)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 ?v0) f22) f22)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f26 (f27 f28 ?v0) ?v1) f41) (or (= ?v0 f41) (= ?v1 f41)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f9 (f10 f13 ?v0) ?v1) f22) (or (= ?v0 f22) (= ?v1 f22)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f41)) (=> (not (= ?v1 f41)) (not (= (f26 (f27 f28 ?v0) ?v1) f41))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f22)) (=> (not (= ?v1 f22)) (not (= (f9 (f10 f13 ?v0) ?v1) f22))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f26 (f27 f28 ?v0) ?v1) f41) (or (= ?v0 f41) (= ?v1 f41)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f9 (f10 f13 ?v0) ?v1) f22) (or (= ?v0 f22) (= ?v1 f22)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f39 f41) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f11 f22) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f39 ?v0) f41) ?v0)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f11 ?v0) f22) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f26 (f27 f39 ?v0) ?v1)) (= ?v1 f41))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 (f9 (f10 f11 ?v0) ?v1)) (= ?v1 f22))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f26 f43 ?v0)) (?v_1 (f26 f43 ?v2))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 ?v_1 ?v3) f1) (= (f6 (f26 (f27 f28 ?v_0) ?v_1) (f26 (f27 f28 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 f44 ?v0)) (?v_1 (f3 f44 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (not (= 1 0)))
(assert (not (= f19 f41)))
(assert (not (= f12 f22)))
(assert (not (= 0 1)))
(assert (not (= f41 f19)))
(assert (not (= f22 f12)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (+ ?v1 ?v2)) (+ (* ?v0 ?v1) (* ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f39 ?v1) ?v2)) (f26 (f27 f39 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (* ?v0 ?v2) (* ?v1 ?v3)) (+ (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f27 f28 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f26 (f27 f39 (f26 ?v_0 ?v2)) (f26 ?v_1 ?v3)) (f26 (f27 f39 (f26 ?v_0 ?v3)) (f26 ?v_1 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f10 f13 ?v0)) (?v_1 (f10 f13 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f9 (f10 f11 (f9 ?v_0 ?v2)) (f9 ?v_1 ?v3)) (f9 (f10 f11 (f9 ?v_0 ?v3)) (f9 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f26 (f27 f28 (f26 (f27 f39 ?v0) ?v1)) ?v2) (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v2)) (f9 (f10 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f26 (f27 f28 (f26 (f27 f39 ?v0) ?v1)) ?v2) (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v2)) (f9 (f10 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (* ?v0 ?v1) (* ?v2 ?v1)) (* (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 ?v2) ?v1)) (f26 (f27 f28 (f26 (f27 f39 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v1)) (f9 (f10 f13 ?v2) ?v1)) (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f39 (f26 (f27 f28 ?v2) ?v1)) ?v3)) (f26 (f27 f39 (f26 (f27 f28 (f26 (f27 f39 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v1)) (f9 (f10 f11 (f9 (f10 f13 ?v2) ?v1)) ?v3)) (f9 (f10 f11 (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (+ (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 ?v3) (* ?v2 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f27 f28 ?v2))) (= (= (f26 (f27 f39 (f26 ?v_0 ?v1)) (f26 ?v_1 ?v3)) (f26 (f27 f39 (f26 ?v_0 ?v3)) (f26 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f10 f13 ?v0)) (?v_1 (f10 f13 ?v2))) (= (= (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 ?v_1 ?v3)) (f9 (f10 f11 (f9 ?v_0 ?v3)) (f9 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 f19) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 f12) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 ?v0) f19) ?v0)))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 ?v0) f12) ?v0)))
(assert (= (f29 (f30 f31 f41) (f20 f21 2)) f41))
(assert (= (f15 (f16 f17 f22) (f20 f21 2)) f22))
(assert (= (f23 (f24 f25 0) (f20 f21 2)) 0))
(assert (= (f34 (f35 f37 f42) (f20 f21 2)) f42))
(assert (forall ((?v0 S5)) (= (= (f29 (f30 f31 ?v0) (f20 f21 2)) f41) (= ?v0 f41))))
(assert (forall ((?v0 S4)) (= (= (f15 (f16 f17 ?v0) (f20 f21 2)) f22) (= ?v0 f22))))
(assert (forall ((?v0 Int)) (= (= (f23 (f24 f25 ?v0) (f20 f21 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f23 (f24 f25 ?v0) (f20 f21 2)))))
(assert (forall ((?v0 S10)) (= (f34 (f35 f36 ?v0) ?v0) (f34 (f35 f37 ?v0) (f20 f21 2)))))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 ?v0) ?v0) (f29 (f30 f31 ?v0) (f20 f21 2)))))
(assert (forall ((?v0 S4)) (= (f9 (f10 f13 ?v0) ?v0) (f15 (f16 f17 ?v0) (f20 f21 2)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (* ?v0 (f23 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (f34 (f35 f36 ?v0) (f34 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (f26 (f27 f28 ?v0) (f29 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1))) (f9 (f10 f13 ?v0) (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f20 f21 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S10)) (= (f34 (f35 f37 ?v0) (f20 f21 2)) (f34 (f35 f36 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f29 (f30 f31 ?v0) (f20 f21 2)) (f26 (f27 f28 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f15 (f16 f17 ?v0) (f20 f21 2)) (f9 (f10 f13 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f20 f21 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S10)) (= (f34 (f35 f37 ?v0) (f20 f21 3)) (f34 (f35 f36 (f34 (f35 f36 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (= (f29 (f30 f31 ?v0) (f20 f21 3)) (f26 (f27 f28 (f26 (f27 f28 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S4)) (= (f15 (f16 f17 ?v0) (f20 f21 3)) (f9 (f10 f13 (f9 (f10 f13 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f20 f21 (+ (* 2 (f23 f40 ?v1)) 1))) (* ?v0 (f23 (f24 f25 (f23 ?v_0 ?v1)) (f20 f21 2)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 ?v_0 (f20 f21 (+ (* 2 (f23 f40 ?v1)) 1))) (f34 (f35 f36 ?v0) (f34 (f35 f37 (f34 ?v_0 ?v1)) (f20 f21 2)))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f20 f21 (+ (* 2 (f23 f40 ?v1)) 1))) (f26 (f27 f28 ?v0) (f29 (f30 f31 (f29 ?v_0 ?v1)) (f20 f21 2)))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f20 f21 (+ (* 2 (f23 f40 ?v1)) 1))) (f9 (f10 f13 ?v0) (f15 (f16 f17 (f15 ?v_0 ?v1)) (f20 f21 2)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f23 ?v_0 ?v1))) (= (f23 ?v_0 (f20 f21 (+ (* 2 (f23 f40 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (let ((?v_1 (f34 ?v_0 ?v1))) (= (f34 ?v_0 (f20 f21 (+ (* 2 (f23 f40 ?v1)) 1))) (f34 (f35 f36 ?v0) (f34 (f35 f36 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (let ((?v_1 (f29 ?v_0 ?v1))) (= (f29 ?v_0 (f20 f21 (+ (* 2 (f23 f40 ?v1)) 1))) (f26 (f27 f28 ?v0) (f26 (f27 f28 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 (f20 f21 (+ (* 2 (f23 f40 ?v1)) 1))) (f9 (f10 f13 ?v0) (f9 (f10 f13 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (* ?v0 (f23 ?v_0 ?v1)) (f23 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 (f35 f36 ?v0) (f34 ?v_0 ?v1)) (f34 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f26 (f27 f28 ?v0) (f29 ?v_0 ?v1)) (f29 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f10 f13 ?v0) (f15 ?v_0 ?v1)) (f15 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f23 ?v_0 ?v1))) (= (f23 ?v_0 (f20 f21 (* 2 (f23 f40 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (let ((?v_1 (f34 ?v_0 ?v1))) (= (f34 ?v_0 (f20 f21 (* 2 (f23 f40 ?v1)))) (f34 (f35 f36 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (let ((?v_1 (f29 ?v_0 ?v1))) (= (f29 ?v_0 (f20 f21 (* 2 (f23 f40 ?v1)))) (f26 (f27 f28 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 (f20 f21 (* 2 (f23 f40 ?v1)))) (f9 (f10 f13 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (* (f23 ?v_0 ?v1) ?v0) (f23 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v0) (f34 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f26 (f27 f28 (f29 ?v_0 ?v1)) ?v0) (f29 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f10 f13 (f15 ?v_0 ?v1)) ?v0) (f15 ?v_0 (f20 f21 (+ (f23 f40 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f23 (f24 f25 (* ?v0 ?v1)) ?v2) (* (f23 (f24 f25 ?v0) ?v2) (f23 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f34 (f35 f37 (f34 (f35 f36 ?v0) ?v1)) ?v2) (f34 (f35 f36 (f34 (f35 f37 ?v0) ?v2)) (f34 (f35 f37 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S10)) (= (f29 (f30 f31 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f28 (f29 (f30 f31 ?v0) ?v2)) (f29 (f30 f31 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S10)) (= (f15 (f16 f17 (f9 (f10 f13 ?v0) ?v1)) ?v2) (f9 (f10 f13 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (* (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) (f23 ?v_0 (f20 f21 (+ (f23 f40 ?v1) (f23 f40 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v0))) (= (f34 (f35 f36 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2)) (f34 ?v_0 (f20 f21 (+ (f23 f40 ?v1) (f23 f40 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S10) (?v2 S10)) (let ((?v_0 (f30 f31 ?v0))) (= (f26 (f27 f28 (f29 ?v_0 ?v1)) (f29 ?v_0 ?v2)) (f29 ?v_0 (f20 f21 (+ (f23 f40 ?v1) (f23 f40 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f10 f13 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) (f15 ?v_0 (f20 f21 (+ (f23 f40 ?v1) (f23 f40 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 Int)) (let ((?v_0 (f23 f40 ?v0)) (?v_1 (f24 f25 ?v1))) (=> (< 0 ?v_0) (= (* (f23 ?v_1 (f20 f21 (- ?v_0 1))) ?v1) (f23 ?v_1 ?v0))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f23 f40 ?v0)) (?v_1 (f35 f37 ?v1))) (=> (< 0 ?v_0) (= (f34 (f35 f36 (f34 ?v_1 (f20 f21 (- ?v_0 1)))) ?v1) (f34 ?v_1 ?v0))))))
(assert (forall ((?v0 S10) (?v1 S5)) (let ((?v_0 (f23 f40 ?v0)) (?v_1 (f30 f31 ?v1))) (=> (< 0 ?v_0) (= (f26 (f27 f28 (f29 ?v_1 (f20 f21 (- ?v_0 1)))) ?v1) (f29 ?v_1 ?v0))))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f23 f40 ?v0)) (?v_1 (f16 f17 ?v1))) (=> (< 0 ?v_0) (= (f9 (f10 f13 (f15 ?v_1 (f20 f21 (- ?v_0 1)))) ?v1) (f15 ?v_1 ?v0))))))
(assert (= (f23 (f24 f25 1) (f20 f21 2)) 1))
(assert (= (f29 (f30 f31 f19) (f20 f21 2)) f19))
(assert (= (f15 (f16 f17 f12) (f20 f21 2)) f12))
(assert (= (f34 (f35 f37 f33) (f20 f21 2)) f33))
(assert (forall ((?v0 Int)) (= (f23 (f24 f25 ?v0) (f20 f21 0)) 1)))
(assert (forall ((?v0 S5)) (= (f29 (f30 f31 ?v0) (f20 f21 0)) f19)))
(assert (forall ((?v0 S4)) (= (f15 (f16 f17 ?v0) (f20 f21 0)) f12)))
(assert (forall ((?v0 S10)) (= (f34 (f35 f37 ?v0) (f20 f21 0)) f33)))
(assert (forall ((?v0 S5)) (= (f26 (f27 f28 f19) ?v0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f26 (f27 f28 (f26 (f27 f39 ?v0) ?v1)) ?v2) (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S5)) (not (= (f6 (f26 (f27 f28 ?v0) ?v0) f41) f1))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) f1) (or (and (= (f6 f41 ?v1) f1) (= (f6 ?v0 ?v2) f1)) (and (= (f6 ?v1 f41) f1) (= (f6 ?v2 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (= (= (f6 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1) (or (and (= (f6 f41 ?v0) f1) (= (f6 ?v1 ?v2) f1)) (and (= (f6 ?v0 f41) f1) (= (f6 ?v2 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (=> (= (f6 f41 ?v0) f1) (= (= (f6 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1) (= (f6 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 f41 ?v0) f1) (=> (= (f6 f41 ?v1) f1) (= (f6 f41 (f26 (f27 f28 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 f41 ?v0) f1) (=> (= (f6 ?v1 f41) f1) (= (f6 (f26 (f27 f28 ?v0) ?v1) f41) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 f41 ?v0) f1) (=> (= (f6 ?v1 f41) f1) (= (f6 (f26 (f27 f28 ?v1) ?v0) f41) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 f41 (f26 (f27 f28 ?v0) ?v1)) f1) (=> (= (f6 f41 ?v0) f1) (= (f6 f41 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 f41 (f26 (f27 f28 ?v0) ?v1)) f1) (=> (= (f6 f41 ?v1) f1) (= (f6 f41 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (=> (= (f6 ?v0 f41) f1) (= (= (f6 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1) (= (f6 ?v2 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 ?v0 f41) f1) (=> (= (f6 f41 ?v1) f1) (= (f6 (f26 (f27 f28 ?v0) ?v1) f41) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 ?v0 f41) f1) (=> (= (f6 ?v1 f41) f1) (= (f6 f41 (f26 (f27 f28 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 f41 ?v2) f1) (= (f6 (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v2))) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 f41 ?v2) f1) (= (f6 (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v2))) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 f41 ?v2) f1) (= (f6 (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v2 f41) f1) (= (f6 (f26 (f27 f28 ?v1) ?v2) (f26 (f27 f28 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v2))) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v2 f41) f1) (= (f6 (f26 ?v_0 ?v1) (f26 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 f41 ?v0) f1) (=> (= (f6 ?v1 ?v2) f1) (= (f6 ?v1 (f26 (f27 f39 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f26 (f27 f39 (f26 (f27 f28 ?v0) ?v0)) (f26 (f27 f28 ?v1) ?v1)) f41) (and (= ?v0 f41) (= ?v1 f41)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (* ?v0 ?v3)) (+ ?v2 (* ?v0 ?v4))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (let ((?v_0 (f27 f28 ?v0))) (=> (not (= ?v0 f41)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f26 (f27 f39 ?v1) (f26 ?v_0 ?v3)) (f26 (f27 f39 ?v2) (f26 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f10 f13 ?v0))) (=> (not (= ?v0 f22)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f9 (f10 f11 ?v1) (f9 ?v_0 ?v3)) (f9 (f10 f11 ?v2) (f9 ?v_0 ?v4)))))))))
(assert (not (< 1 0)))
(assert (not (= (f6 f19 f41) f1)))
(assert (< 0 1))
(assert (= (f6 f41 f19) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 f19 ?v0) f1) (=> (= (f6 f19 ?v1) f1) (= (f6 f19 (f26 (f27 f28 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5)) (not (= (f6 (f29 (f30 f31 ?v0) (f20 f21 2)) f41) f1))))
(assert (forall ((?v0 Int)) (not (< (f23 (f24 f25 ?v0) (f20 f21 2)) 0))))
(assert (forall ((?v0 S5)) (= (= (f6 f41 (f29 (f30 f31 ?v0) (f20 f21 2))) f1) (not (= ?v0 f41)))))
(assert (forall ((?v0 Int)) (= (< 0 (f23 (f24 f25 ?v0) (f20 f21 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 S5)) (= (not (= (f6 f41 (f26 (f27 f28 ?v0) ?v0)) f1)) (= ?v0 f41))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 f41 ?v0) f1) (=> (= (f6 f41 ?v1) f1) (exists ((?v2 S5)) (and (= (f6 f41 ?v2) f1) (and (= (f6 ?v2 ?v0) f1) (= (f6 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f23 f40 (f34 (f35 f37 ?v0) ?v1)) (f23 (f24 f25 (f23 f40 ?v0)) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (< 0 (f23 f40 (f34 (f35 f37 ?v0) ?v1))) (or (< 0 (f23 f40 ?v0)) (= ?v1 (f20 f21 0))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f20 f21 (+ 0 1)))) (= (f34 (f35 f37 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f23 (f24 f25 (f23 f40 ?v0)) ?v1) (f23 f40 (f34 (f35 f37 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f20 f21 (+ 0 1)))) (= (= (f34 (f35 f37 ?v0) ?v1) ?v_0) (or (= ?v1 (f20 f21 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (<= 0 ?v0) (= (f20 f21 (f23 (f24 f25 ?v0) ?v1)) (f34 (f35 f37 (f20 f21 ?v0)) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f37 ?v0))) (=> (< 0 (f23 f40 ?v0)) (=> (< (f23 f40 (f34 ?v_0 ?v1)) (f23 f40 (f34 ?v_0 ?v2))) (< (f23 f40 ?v1) (f23 f40 ?v2)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f23 f40 ?v0)) (<= ?v_0 (f23 f40 (f34 (f35 f37 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f20 f21 (* ?v0 ?v1)) (f20 f21 (* (f23 f40 (f20 f21 (- ?v0))) (f23 f40 (f20 f21 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f20 f21 (* ?v0 ?v1)) (f20 f21 (* (f23 f40 (f20 f21 ?v0)) (f23 f40 (f20 f21 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 (f24 f25 (f23 ?v_0 ?v1)) ?v2) (f23 ?v_0 (f20 f21 (* (f23 f40 ?v1) (f23 f40 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (* (f23 f40 ?v0) (f23 f40 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (* (f23 f40 ?v0) (f23 f40 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f20 f21 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f20 f21 (* (f23 f40 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0))) (f23 f40 (f20 f21 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5) (?v1 S10)) (=> (= (f6 f41 ?v0) f1) (exists ((?v2 S5)) (and (= (f6 f41 ?v2) f1) (= (f29 (f30 f31 ?v2) (f20 f21 (+ (f23 f40 ?v1) 1))) ?v0))))))
(assert (forall ((?v0 S10) (?v1 S5)) (=> (< 0 (f23 f40 ?v0)) (=> (= (f6 f41 ?v1) f1) (exists ((?v2 S5)) (and (= (f6 f41 ?v2) f1) (= (f29 (f30 f31 ?v2) ?v0) ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S5)) (=> (< 0 (f23 f40 ?v0)) (=> (= (f6 f41 ?v1) f1) (exists ((?v2 S5)) (and (and (= (f6 f41 ?v2) f1) (= (f29 (f30 f31 ?v2) ?v0) ?v1)) (forall ((?v3 S5)) (=> (and (= (f6 f41 ?v3) f1) (= (f29 (f30 f31 ?v3) ?v0) ?v1)) (= ?v3 ?v2)))))))))
(assert (forall ((?v0 Int) (?v1 S10)) (<= 0 (f23 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (< 0 (f23 (f24 f25 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f20 f21 0))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f20 f21 (+ (f23 f40 ?v1) (f23 f40 ?v2)))) (* (f23 ?v_0 ?v1) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (<= 0 ?v0) (= (f34 (f35 f37 (f20 f21 ?v0)) ?v1) (f20 f21 (f23 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f23 (f24 f25 (f23 f40 ?v0)) ?v1) (f23 f40 (f34 (f35 f37 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f20 f21 (* (f23 f40 (f20 f21 ?v0)) (f23 f40 (f20 f21 ?v1)))) (f20 f21 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (* (f23 f40 ?v0) (f23 f40 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (<= 0 ?v0) (<= 0 (f23 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S4)) (= (f15 (f16 f17 (f9 f45 ?v0)) (f20 f21 2)) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f27 f28 ?v0))) (=> (= (f6 f41 ?v0) f1) (= (= (f46 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1) (= (f46 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 f41 ?v0) f1) (= (= (f46 (f26 (f27 f28 ?v1) ?v0) (f26 (f27 f28 ?v2) ?v0)) f1) (= (f46 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S10)) (= (f20 f21 (f23 f40 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f23 f40 (f20 f21 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f23 f40 (f20 f21 ?v0)) 0))))
(check-sat)
(exit)
