(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S3) S1)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S2) S2)
(declare-fun f7 (S6 S2) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S2)
(declare-fun f10 () S6)
(declare-fun f11 () S2)
(declare-fun f12 (S7 S8) S2)
(declare-fun f13 (S9 S2) S7)
(declare-fun f14 () S9)
(declare-fun f15 () S8)
(declare-fun f16 () S3)
(declare-fun f17 (S10 Int) S8)
(declare-fun f18 () S10)
(declare-fun f19 () S2)
(declare-fun f20 (S11 S8) Int)
(declare-fun f21 (S12 Int) S11)
(declare-fun f22 () S12)
(declare-fun f23 (S13 S3) S3)
(declare-fun f24 (S14 S3) S13)
(declare-fun f25 () S14)
(declare-fun f26 (S15 S8) S3)
(declare-fun f27 (S16 S3) S15)
(declare-fun f28 () S16)
(declare-fun f29 (S8 S8) S1)
(declare-fun f30 () S8)
(declare-fun f31 (S17 S8) S8)
(declare-fun f32 (S18 S8) S17)
(declare-fun f33 () S18)
(declare-fun f34 () S18)
(declare-fun f35 () S13)
(declare-fun f36 () S14)
(declare-fun f37 () S11)
(declare-fun f38 () S3)
(declare-fun f39 () S8)
(declare-fun f40 () S13)
(declare-fun f41 (S19 Int) Int)
(declare-fun f42 () S19)
(declare-fun f43 () S18)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 S2)) (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 ?v0) f15)))) f16) f1))))
(assert (not (= f15 (f17 f18 0))))
(assert (not (= f15 (f17 f18 0))))
(assert (not (= f11 f19)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (* ?v0 (f20 (f21 f22 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f16 ?v0) f1) (= (f3 f16 (f23 (f24 f25 ?v0) (f26 (f27 f28 ?v0) ?v1))) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f29 f30 ?v0) f1) (= (f29 f30 (f31 (f32 f33 ?v0) (f31 (f32 f34 ?v0) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f20 (f21 f22 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (* ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f26 (f27 f28 ?v0) ?v1))) (=> (= (f3 f16 ?v0) f1) (= (f3 ?v_0 (f23 (f24 f25 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f31 (f32 f34 ?v0) ?v1))) (=> (= (f29 f30 ?v0) f1) (= (f29 ?v_0 (f31 (f32 f33 ?v0) ?v_0)) f1)))))
(assert (= (f23 f35 f16) f16))
(assert (= (f4 f5 f9) f16))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f23 f35 ?v0) ?v1) f1) (=> (= (f3 (f23 f35 ?v2) ?v3) f1) (= (f3 (f23 f35 (f23 (f24 f36 ?v0) ?v2)) (f23 (f24 f36 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f23 (f24 f36 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f23 f35 ?v0) ?v1) f1) (=> (= (f3 (f23 f35 ?v2) ?v3) f1) (= (f3 (f23 f35 (f23 (f24 f25 ?v0) ?v2)) (f23 (f24 f25 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f10 ?v0) ?v2)) (f23 (f24 f25 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) 1 (* ?v0 (f20 ?v_0 (f17 f18 (- (f20 f37 ?v1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) f16 (f23 (f24 f25 ?v0) (f26 ?v_0 (f17 f18 (- (f20 f37 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) f9 (f6 (f7 f10 ?v0) (f12 ?v_0 (f17 f18 (- (f20 f37 ?v1) 1)))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f32 f34 ?v0))) (= (f31 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) f30 (f31 (f32 f33 ?v0) (f31 ?v_0 (f17 f18 (- (f20 f37 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (f20 (f21 f22 ?v0) (f17 f18 (+ (f20 f37 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f16 ?v0) f1) (= (f3 f16 (f26 (f27 f28 ?v0) (f17 f18 (+ (f20 f37 ?v1) 1)))) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f29 f30 ?v0) f1) (= (f29 f30 (f31 (f32 f34 ?v0) (f17 f18 (+ (f20 f37 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (= (f20 ?v_0 ?v1) (f20 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (= (f3 f16 ?v0) f1) (= (= (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f34 ?v0))) (=> (= (f29 f30 ?v0) f1) (= (= (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (< (f20 ?v_0 ?v1) (f20 ?v_0 ?v2)) (< (f20 f37 ?v1) (f20 f37 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (= (f3 f16 ?v0) f1) (= (= (f3 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1) (< (f20 f37 ?v1) (f20 f37 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f34 ?v0))) (=> (= (f29 f30 ?v0) f1) (= (= (f29 (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) f1) (< (f20 f37 ?v1) (f20 f37 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (=> (< 0 (f20 f37 ?v1)) (< 1 (f20 (f21 f22 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f16 ?v0) f1) (=> (< 0 (f20 f37 ?v1)) (= (f3 f16 (f26 (f27 f28 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f29 f30 ?v0) f1) (=> (< 0 (f20 f37 ?v1)) (= (f29 f30 (f31 (f32 f34 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (=> (< (f20 ?v_0 ?v1) (f20 ?v_0 ?v2)) (< (f20 f37 ?v1) (f20 f37 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (= (f3 f16 ?v0) f1) (=> (= (f3 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1) (< (f20 f37 ?v1) (f20 f37 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f34 ?v0))) (=> (= (f29 f30 ?v0) f1) (=> (= (f29 (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) f1) (< (f20 f37 ?v1) (f20 f37 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (< (f20 f37 ?v0) (f20 f37 ?v1)) (=> (< 1 ?v2) (< (f20 ?v_0 ?v0) (f20 ?v_0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S3)) (let ((?v_0 (f27 f28 ?v2))) (=> (< (f20 f37 ?v0) (f20 f37 ?v1)) (=> (= (f3 f16 ?v2) f1) (= (f3 (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f34 ?v2))) (=> (< (f20 f37 ?v0) (f20 f37 ?v1)) (=> (= (f29 f30 ?v2) f1) (= (f29 (f31 ?v_0 ?v0) (f31 ?v_0 ?v1)) f1))))))
(assert (= (f23 f35 f38) f38))
(assert (= (f4 f5 f19) f38))
(assert (forall ((?v0 S3)) (= (= (f23 f35 ?v0) f38) (= ?v0 f38))))
(assert (forall ((?v0 S2)) (= (= (f4 f5 ?v0) f38) (= ?v0 f19))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f34 ?v0))) (= (f31 ?v_0 (f17 f18 (* (f20 f37 ?v1) (f20 f37 ?v2)))) (f31 (f32 f34 (f31 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f17 f18 (* (f20 f37 ?v1) (f20 f37 ?v2)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f17 f18 (* (f20 f37 ?v1) (f20 f37 ?v2)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f17 f18 (* (f20 f37 ?v1) (f20 f37 ?v2)))) (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3)) (= (f23 (f24 f25 ?v0) f38) f38)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f10 ?v0) f19) f19)))
(assert (forall ((?v0 S3)) (= (f23 (f24 f25 ?v0) f38) f38)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f10 ?v0) f19) f19)))
(assert (forall ((?v0 S3)) (= (f23 (f24 f25 f38) ?v0) f38)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f10 f19) ?v0) f19)))
(assert (forall ((?v0 S3)) (= (f23 (f24 f25 f38) ?v0) f38)))
(assert (forall ((?v0 S2)) (= (f6 (f7 f10 f19) ?v0) f19)))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (not (= ?v0 f38)) (not (= (f26 (f27 f28 ?v0) ?v1) f38)))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (not (= ?v0 f19)) (not (= (f12 (f13 f14 ?v0) ?v1) f19)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f20 (f21 f22 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S8)) (= (= (f26 (f27 f28 ?v0) ?v1) f38) (and (= ?v0 f38) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S2) (?v1 S8)) (= (= (f12 (f13 f14 ?v0) ?v1) f19) (and (= ?v0 f19) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f20 (f21 f22 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f31 (f32 f34 ?v0) ?v1) f39) (and (= ?v0 f39) (not (= ?v1 (f17 f18 0)))))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 f38) (f17 f18 (+ (f20 f37 ?v0) 1))) f38)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f19) (f17 f18 (+ (f20 f37 ?v0) 1))) f19)))
(assert (forall ((?v0 S8)) (= (f20 (f21 f22 0) (f17 f18 (+ (f20 f37 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f31 (f32 f34 f39) (f17 f18 (+ (f20 f37 ?v0) 1))) f39)))
(assert (forall ((?v0 S3)) (= (= (f3 f38 (f23 f35 ?v0)) f1) (not (= ?v0 f38)))))
(assert (forall ((?v0 S2)) (= (= (f3 f38 (f4 f5 ?v0)) f1) (not (= ?v0 f19)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f23 f40 ?v0) f16) f1) (= (f3 (f26 (f27 f28 ?v0) (f17 f18 2)) f16) f1))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f38 ?v0) f1) (= (f3 f38 (f26 (f27 f28 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (< 0 (f20 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f29 f39 ?v0) f1) (= (f29 f39 (f31 (f32 f34 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S8)) (= (f20 (f21 f22 0) ?v0) (ite (= ?v0 (f17 f18 0)) 1 0))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 f38) ?v0) (ite (= ?v0 (f17 f18 0)) f16 f38))))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f19) ?v0) (ite (= ?v0 (f17 f18 0)) f9 f19))))
(assert (forall ((?v0 S8)) (= (f31 (f32 f34 f39) ?v0) (ite (= ?v0 (f17 f18 0)) f30 f39))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (< (f20 f37 ?v0) (f20 f37 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f20 ?v_0 ?v1) (f20 ?v_0 ?v0))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S3)) (let ((?v_0 (f27 f28 ?v2))) (=> (< (f20 f37 ?v0) (f20 f37 ?v1)) (=> (= (f3 f38 ?v2) f1) (=> (= (f3 ?v2 f16) f1) (= (f3 (f26 ?v_0 ?v1) (f26 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f34 ?v2))) (=> (< (f20 f37 ?v0) (f20 f37 ?v1)) (=> (= (f29 f39 ?v2) f1) (=> (= (f29 ?v2 f30) f1) (= (f29 (f31 ?v_0 ?v1) (f31 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f20 (f21 f22 ?v0) (f17 f18 (+ (f20 f37 ?v1) 1))) 1)))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f3 f38 ?v0) f1) (=> (= (f3 ?v0 f16) f1) (= (f3 (f26 (f27 f28 ?v0) (f17 f18 (+ (f20 f37 ?v1) 1))) f16) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f29 f39 ?v0) f1) (=> (= (f29 ?v0 f30) f1) (= (f29 (f31 (f32 f34 ?v0) (f17 f18 (+ (f20 f37 ?v1) 1))) f30) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f20 (f21 f22 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f26 (f27 f28 ?v0) ?v1))) (=> (= (f3 f38 ?v0) f1) (=> (= (f3 ?v0 f16) f1) (= (f3 (f23 (f24 f25 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f31 (f32 f34 ?v0) ?v1))) (=> (= (f29 f39 ?v0) f1) (=> (= (f29 ?v0 f30) f1) (= (f29 (f31 (f32 f33 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S8)) (= (f31 (f32 f34 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f26 (f27 f28 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f12 (f13 f14 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f20 (f21 f22 ?v0) (f17 f18 1)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S8)) (= (f23 f40 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f23 f40 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f41 f42 (f20 (f21 f22 ?v0) ?v1)) (f20 (f21 f22 (f41 f42 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f5 ?v0))) (= (f23 f40 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f23 f35 ?v0))) (= (f23 f40 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f23 (f24 f25 (f23 (f24 f36 ?v0) ?v1)) ?v2) (f23 (f24 f36 (f23 (f24 f25 ?v0) ?v2)) (f23 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f6 (f7 f10 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f10 ?v0) ?v2)) (f6 (f7 f10 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f23 (f24 f25 (f23 (f24 f36 ?v0) ?v1)) ?v2) (f23 (f24 f36 (f23 (f24 f25 ?v0) ?v2)) (f23 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f6 (f7 f10 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f10 ?v0) ?v2)) (f6 (f7 f10 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f23 (f24 f36 ?v1) ?v2)) (f23 (f24 f36 (f23 ?v_0 ?v1)) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f24 f25 ?v0))) (= (f23 ?v_0 (f23 (f24 f36 ?v1) ?v2)) (f23 (f24 f36 (f23 ?v_0 ?v1)) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f20 f37 ?v1)) (?v_1 (f20 f37 ?v0)) (?v_2 (f32 f34 ?v2))) (=> (<= ?v_1 ?v_0) (= (f31 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (f31 (f32 f33 (f31 ?v_2 (f17 f18 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S3)) (let ((?v_0 (f20 f37 ?v1)) (?v_1 (f20 f37 ?v0)) (?v_2 (f27 f28 ?v2))) (=> (<= ?v_1 ?v_0) (= (f26 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (f23 (f24 f25 (f26 ?v_2 (f17 f18 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S2)) (let ((?v_0 (f20 f37 ?v1)) (?v_1 (f20 f37 ?v0)) (?v_2 (f13 f14 ?v2))) (=> (<= ?v_1 ?v_0) (= (f12 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f10 (f12 ?v_2 (f17 f18 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f20 f37 ?v1)) (?v_1 (f20 f37 ?v0)) (?v_2 (f21 f22 ?v2))) (=> (<= ?v_1 ?v_0) (= (f20 ?v_2 (f17 f18 (- (+ ?v_0 1) ?v_1))) (* (f20 ?v_2 (f17 f18 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f31 (f32 f34 (f31 (f32 f33 ?v0) ?v1)) ?v2) (f31 (f32 f33 (f31 (f32 f34 ?v0) ?v2)) (f31 (f32 f34 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S8)) (= (f26 (f27 f28 (f23 (f24 f25 ?v0) ?v1)) ?v2) (f23 (f24 f25 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S8)) (= (f12 (f13 f14 (f6 (f7 f10 ?v0) ?v1)) ?v2) (f6 (f7 f10 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f20 (f21 f22 (* ?v0 ?v1)) ?v2) (* (f20 (f21 f22 ?v0) ?v2) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f31 (f32 f34 ?v0) ?v1))) (= (f31 (f32 f33 ?v_0) ?v0) (f31 (f32 f33 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f26 (f27 f28 ?v0) ?v1))) (= (f23 (f24 f25 ?v_0) ?v0) (f23 (f24 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f6 (f7 f10 ?v_0) ?v0) (f6 (f7 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f20 (f21 f22 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f32 f34 ?v0))) (= (f31 ?v_0 (f17 f18 (+ (f20 f37 ?v1) (f20 f37 ?v2)))) (f31 (f32 f33 (f31 ?v_0 ?v1)) (f31 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f17 f18 (+ (f20 f37 ?v1) (f20 f37 ?v2)))) (f23 (f24 f25 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f17 f18 (+ (f20 f37 ?v1) (f20 f37 ?v2)))) (f6 (f7 f10 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f17 f18 (+ (f20 f37 ?v1) (f20 f37 ?v2)))) (* (f20 ?v_0 ?v1) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f32 f34 ?v0))) (= (f31 ?v_0 (f17 f18 (+ (f20 f37 ?v1) 1))) (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f17 f18 (+ (f20 f37 ?v1) 1))) (f23 (f24 f25 (f26 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f17 f18 (+ (f20 f37 ?v1) 1))) (f6 (f7 f10 (f12 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f17 f18 (+ (f20 f37 ?v1) 1))) (* (f20 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f32 f34 ?v0))) (= (f31 ?v_0 (f17 f18 (+ (f20 f37 ?v1) 1))) (f31 (f32 f33 ?v0) (f31 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f17 f18 (+ (f20 f37 ?v1) 1))) (f23 (f24 f25 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f17 f18 (+ (f20 f37 ?v1) 1))) (f6 (f7 f10 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 ?v_0 (f17 f18 (+ (f20 f37 ?v1) 1))) (* ?v0 (f20 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f20 (f21 f22 ?v0) (f17 f18 0)) 1)))
(assert (forall ((?v0 S3)) (= (f26 (f27 f28 ?v0) (f17 f18 0)) f16)))
(assert (forall ((?v0 S2)) (= (f12 (f13 f14 ?v0) (f17 f18 0)) f9)))
(assert (forall ((?v0 S8)) (= (f31 (f32 f34 ?v0) (f17 f18 0)) f30)))
(assert (forall ((?v0 S8)) (= (f20 (f21 f22 1) ?v0) 1)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 f16) ?v0) f16)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f9) ?v0) f9)))
(assert (forall ((?v0 S8)) (= (f31 (f32 f34 f30) ?v0) f30)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f23 f35 (f23 (f24 f25 ?v0) ?v1)) (f23 (f24 f25 (f23 f35 ?v0)) (f23 f35 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f5 (f6 (f7 f10 ?v0) ?v1)) (f23 (f24 f25 (f4 f5 ?v0)) (f4 f5 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S8)) (= (f23 f35 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f23 f35 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S8)) (= (f4 f5 (f12 (f13 f14 ?v0) ?v1)) (f26 (f27 f28 (f4 f5 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (< 0 (+ (f20 (f21 f22 ?v0) ?v_0) (f20 (f21 f22 ?v1) ?v_0))) (or (not (= ?v0 0)) (not (= ?v1 0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 2))) (= (= (f3 f38 (f23 (f24 f36 (f26 (f27 f28 ?v0) ?v_0)) (f26 (f27 f28 ?v1) ?v_0))) f1) (or (not (= ?v0 f38)) (not (= ?v1 f38)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (not (< (+ (f20 (f21 f22 ?v0) ?v_0) (f20 (f21 f22 ?v1) ?v_0)) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 2))) (not (= (f3 (f23 (f24 f36 (f26 (f27 f28 ?v0) ?v_0)) (f26 (f27 f28 ?v1) ?v_0)) f38) f1)))))
(assert (< 0 (+ 1 1)))
(assert (= (f3 f38 (f23 (f24 f36 f16) f16)) f1))
(assert (= (f29 f39 (f31 (f32 f43 f30) f30)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< 0 (+ (* ?v0 ?v0) (* ?v1 ?v1))) (or (not (= ?v0 0)) (not (= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 f38 (f23 (f24 f36 (f23 (f24 f25 ?v0) ?v0)) (f23 (f24 f25 ?v1) ?v1))) f1) (or (not (= ?v0 f38)) (not (= ?v1 f38))))))
(assert (forall ((?v0 Int) (?v1 Int)) (not (< (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (not (= (f3 (f23 (f24 f36 (f23 (f24 f25 ?v0) ?v0)) (f23 (f24 f25 ?v1) ?v1)) f38) f1))))
(assert (forall ((?v0 S3)) (not (= (f3 (f23 (f24 f36 (f23 f40 ?v0)) f16) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 2))) (= (= (+ (f20 (f21 f22 ?v0) ?v_0) (f20 (f21 f22 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 2))) (= (= (f23 (f24 f36 (f26 (f27 f28 ?v0) ?v_0)) (f26 (f27 f28 ?v1) ?v_0)) f38) (and (= ?v0 f38) (= ?v1 f38))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (* ?v0 ?v1) ?v1) (* (+ ?v0 1) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f23 (f24 f36 (f23 (f24 f25 ?v0) ?v1)) ?v1) (f23 (f24 f25 (f23 (f24 f36 ?v0) f16)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f6 (f7 f8 (f6 (f7 f10 ?v0) ?v1)) ?v1) (f6 (f7 f10 (f6 (f7 f8 ?v0) f9)) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f31 (f32 f43 (f31 (f32 f33 ?v0) ?v1)) ?v1) (f31 (f32 f33 (f31 (f32 f43 ?v0) f30)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (* ?v1 ?v0)) (* (+ ?v1 1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f23 (f24 f36 ?v0) (f23 (f24 f25 ?v1) ?v0)) (f23 (f24 f25 (f23 (f24 f36 ?v1) f16)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f6 (f7 f8 ?v0) (f6 (f7 f10 ?v1) ?v0)) (f6 (f7 f10 (f6 (f7 f8 ?v1) f9)) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f31 (f32 f43 ?v0) (f31 (f32 f33 ?v1) ?v0)) (f31 (f32 f33 (f31 (f32 f43 ?v1) f30)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (* (+ 1 1) ?v0))))
(assert (forall ((?v0 S3)) (= (f23 (f24 f36 ?v0) ?v0) (f23 (f24 f25 (f23 (f24 f36 f16) f16)) ?v0))))
(assert (forall ((?v0 S2)) (= (f6 (f7 f8 ?v0) ?v0) (f6 (f7 f10 (f6 (f7 f8 f9) f9)) ?v0))))
(assert (forall ((?v0 S8)) (= (f31 (f32 f43 ?v0) ?v0) (f31 (f32 f33 (f31 (f32 f43 f30) f30)) ?v0))))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S3)) (= (f3 ?v0 (f23 (f24 f36 ?v0) f16)) f1)))
(assert (forall ((?v0 S8)) (= (f29 ?v0 (f31 (f32 f43 ?v0) f30)) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f32 f34 ?v0))) (= (f31 ?v_0 ?v1) (ite (= ?v1 (f17 f18 0)) (f17 f18 1) (f17 f18 (* (f20 f37 ?v0) (f20 f37 (f31 ?v_0 (f17 f18 (- (f20 f37 ?v1) 1)))))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f17 f18 0)) (?v_2 (f20 f37 ?v0)) (?v_1 (f20 f37 ?v1))) (= (f17 f18 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f17 f18 (+ ?v_1 (* (f20 f37 (f17 f18 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f20 f37 ?v0))) (= (f17 f18 (* ?v_0 2)) (f17 f18 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f20 f37 ?v0))) (= (f17 f18 (* 2 ?v_0)) (f17 f18 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8)) (= (f17 f18 (f20 f37 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f20 f37 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f20 f37 (f17 f18 ?v0)) 0))))
(check-sat)
(exit)
