(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 () S4)
(declare-fun f11 (S7 Int) Int)
(declare-fun f12 (S8 Int) S7)
(declare-fun f13 () S8)
(declare-fun f14 () S1)
(declare-fun f15 () S2)
(declare-fun f16 (S2) S1)
(declare-fun f17 (Int S9) S1)
(declare-fun f18 (S9 Int) S1)
(declare-fun f19 (S10 S11) S1)
(declare-fun f20 (S11 S10) S1)
(declare-fun f21 (S12 S10) S10)
(declare-fun f22 (S13 S10) S12)
(declare-fun f23 () S13)
(declare-fun f24 () S7)
(declare-fun f25 () S10)
(declare-fun f26 () S10)
(declare-fun f27 () S11)
(declare-fun f28 () S9)
(declare-fun f29 (S14 Int) S3)
(declare-fun f30 () S14)
(declare-fun f31 (S15 S2) S1)
(declare-fun f32 () S13)
(declare-fun f33 () S8)
(declare-fun f34 () S8)
(declare-fun f35 () S10)
(declare-fun f36 () S11)
(declare-fun f37 () S9)
(declare-fun f38 () S8)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f10 ?v0) ?v1) (f6 f7 (f11 (f12 f13 (f8 f9 ?v0)) (f8 f9 ?v1))))))
(assert (not (= f14 f1)))
(assert (forall ((?v0 S2)) (=> (= f15 (f6 f7 (* 2 (f8 f9 ?v0)))) (= f14 f1))))
(assert (exists ((?v0 S2)) (= f15 (f6 f7 (* 2 (f8 f9 ?v0))))))
(assert (not (= f15 (f6 f7 0))))
(assert (exists ((?v0 S2)) (= f15 (f6 f7 (* 2 (f8 f9 ?v0))))))
(assert (= (f16 f15) f1))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (* (f8 f9 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0))) (f8 f9 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f8 f9 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f8 f9 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* ?v_1 ?v_0)) (f6 f7 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (* (f8 f9 (f6 f7 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f8 f9 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_3 (f8 f9 ?v3)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (<= (* ?v_1 ?v_0) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_1) (<= (* ?v_0 ?v_2) (* ?v_1 ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 (- ?v0))) (f8 f9 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (* ?v0 ?v1)) (f6 f7 (* (f8 f9 (f6 f7 ?v0)) (f8 f9 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (+ (f8 f9 ?v0) 1))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1))) (= (= (f6 f7 (* (f8 f9 ?v0) ?v_0)) (f6 f7 (* (f8 f9 ?v2) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (<= (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0))) (= (< (* ?v_1 ?v_0) (* ?v_2 ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (f8 f9 (f6 f7 (- ?v_0 ?v_2))) ?v_1)) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v2))) (= (f6 f7 (* (+ ?v_0 ?v_2) ?v_1)) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* (* ?v_0 ?v_1) ?v_2)) (f6 f7 (* ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* (+ ?v_1 1) ?v_0)) (f6 f7 (+ ?v_0 (* ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (= (<= ?v_0 (* ?v_1 ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (f8 f9 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (+ ?v_1 1))) (f6 f7 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f16 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) f1) (or (= (f16 ?v0) f1) (= (f16 ?v1) f1)))))
(assert (forall ((?v0 S2)) (= (not (= (f16 ?v0) f1)) (exists ((?v1 S2)) (= ?v0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1)))))))
(assert (forall ((?v0 S2)) (= (not (= (f16 ?v0) f1)) (exists ((?v1 S2)) (= ?v0 (f6 f7 (+ (* (+ (+ 0 1) 1) (f8 f9 ?v1)) 1)))))))
(assert (forall ((?v0 S2)) (= (= (f16 ?v0) f1) (exists ((?v1 S2)) (= ?v0 (f6 f7 (* 2 (f8 f9 ?v1))))))))
(assert (forall ((?v0 S2)) (= (= (f16 ?v0) f1) (exists ((?v1 S2)) (= ?v0 (f6 f7 (* (+ (+ 0 1) 1) (f8 f9 ?v1))))))))
(assert (= (f16 (f6 f7 0)) f1))
(assert (not (= (f16 (f6 f7 1)) f1)))
(assert (forall ((?v0 S2)) (= (= (f16 (f6 f7 (+ (f8 f9 ?v0) 1))) f1) (not (= (f16 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= (f16 (f6 f7 (+ (f8 f9 ?v0) (f8 f9 ?v1)))) f1)) (not (= (not (= (f16 ?v0) f1)) (not (= (f16 ?v1) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f16 (f6 f7 (+ (f8 f9 ?v0) (f8 f9 ?v1)))) f1) (= (= (f16 ?v0) f1) (= (f16 ?v1) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (= (= (f16 ?v0) f1) (not (= (f16 (f6 f7 (- ?v_0 1))) f1)))))))
(assert (forall ((?v0 S2)) (=> (not (= (f16 ?v0) f1)) (< 0 (f8 f9 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f16 ?v0) f1)) (?v_1 (= (f16 ?v1) f1))) (= (= (f16 (f6 f7 (+ (f8 f9 ?v0) (f8 f9 ?v1)))) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (= (f16 ?v0) f1)) (?v_3 (= (f16 ?v1) f1))) (= (= (f16 (f6 f7 (- ?v_0 ?v_1))) f1) (or (< ?v_0 ?v_1) (or (and ?v_2 ?v_3) (and (not ?v_2) (not ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (or (= ?v0 (f6 f7 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2)) (?v_3 (f8 f9 ?v3))) (= (f6 f7 (+ (* ?v_1 ?v_0) (+ (* ?v_2 ?v_0) ?v_3))) (f6 f7 (+ (* (+ ?v_1 ?v_2) ?v_0) ?v_3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (= (= (f6 f7 (* ?v_0 (f8 f9 ?v1))) (f6 f7 (* ?v_0 (f8 f9 ?v2)))) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (=> (< 0 ?v_0) (= (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (=> (< 0 ?v_0) (= (<= (* ?v_0 ?v_1) (* ?v_0 ?v_2)) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (* (f8 f9 (f6 f7 ?v0)) (f8 f9 (f6 f7 ?v1)))) (f6 f7 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (f6 f7 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f6 f7 (- (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f6 f7 (+ (* ?v_0 ?v_2) ?v_3)) (f6 f7 (+ (* ?v_1 ?v_2) (f8 f9 ?v4)))) (= (f6 f7 (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= ?v_3 (+ (* (f8 f9 (f6 f7 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f17 ?v0 ?v1) f1) (= (f18 ?v1 ?v0) f1))))
(assert (forall ((?v0 S10) (?v1 S11)) (= (= (f19 ?v0 ?v1) f1) (= (f20 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< ?v_3 (+ (* (f8 f9 (f6 f7 (- ?v_1 ?v_0))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_0 ?v_1) (= (f6 f7 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f6 f7 (- ?v_3 (+ (* (f8 f9 (f6 f7 (- ?v_1 ?v_0))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_3 (f8 f9 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f6 f7 (+ (* ?v_0 ?v_2) (f8 f9 ?v3))) (f6 f7 (+ (* ?v_1 ?v_2) ?v_3))) (= ?v3 (f6 f7 (+ (* (f8 f9 (f6 f7 (- ?v_1 ?v_0))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) (f21 (f22 f23 ?v2) ?v3)) (f21 (f22 f23 (f21 ?v_0 ?v2)) (f21 (f22 f23 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_1 (f22 f23 (f21 (f22 f23 ?v0) ?v1))) (?v_0 (f22 f23 ?v2))) (= (f21 ?v_1 (f21 ?v_0 ?v3)) (f21 ?v_0 (f21 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f21 (f22 f23 ?v2) ?v3))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v_1) (f21 ?v_0 (f21 (f22 f23 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2) (f21 (f22 f23 (f21 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f22 f23 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f22 f23 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f21 (f22 f23 ?v0) ?v1) (f21 (f22 f23 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_1 (f22 f23 ?v0)) (?v_0 (f22 f23 ?v1))) (= (f21 ?v_1 (f21 ?v_0 ?v2)) (f21 ?v_0 (f21 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f21 (f22 f23 ?v1) ?v2)) (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 f24 (* ?v0 ?v1)) (* (f11 f24 ?v0) (f11 f24 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f24 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (not (= f25 f26)))
(assert (forall ((?v0 S2)) (let ((?v_0 (+ (+ 0 1) 1))) (=> (= (f16 ?v0) f1) (= (f6 f7 (* ?v_0 (f11 (f12 f13 (f8 f9 ?v0)) ?v_0))) ?v0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (+ (+ 0 1) 1))) (=> (not (= (f16 ?v0) f1)) (= (f6 f7 (+ (* ?v_0 (f11 (f12 f13 (f8 f9 ?v0)) ?v_0)) 1)) ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f19 ?v0 f27) f1) (=> (= (f19 ?v1 f27) f1) (= (f19 (f21 (f22 f23 ?v0) ?v1) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0 f28) f1) (=> (= (f17 ?v1 f28) f1) (= (f17 (* ?v0 ?v1) f28) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f3 (f29 f30 ?v0) ?v1) (f6 f7 (+ (f8 f9 (f6 f7 ?v0)) (f8 f9 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f6 f7 0)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1)) (?v_3 (f8 f9 ?v2))) (= (f6 f7 (f11 (f12 f13 (* ?v_0 ?v_2)) (* ?v_0 ?v_3))) (ite (= ?v0 ?v_1) ?v_1 (f6 f7 (f11 (f12 f13 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (=> (< 0 ?v_0) (= (f6 f7 (f11 (f12 f13 (* ?v_0 ?v_1)) (* ?v_0 ?v_2))) (f6 f7 (f11 (f12 f13 ?v_1) ?v_2)))))))
(assert (= (f17 0 f28) f1))
(assert (= (f19 f26 f27) f1))
(assert (= (f11 f24 0) 0))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S10)) (= (= f26 ?v0) (= ?v0 f26))))
(assert (forall ((?v0 Int)) (= (= (f11 f24 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (not (= (f16 ?v0) f1)) (= (f6 f7 (f11 (f12 f13 (+ ?v_0 1)) 2)) (f6 f7 (+ (f11 (f12 f13 ?v_0) 2) 1)))))))
(assert (forall ((?v0 S2)) (let ((?v_1 (+ (+ 0 1) 1)) (?v_0 (f8 f9 ?v0))) (=> (not (= (f16 ?v0) f1)) (= (f6 f7 (f11 (f12 f13 (+ ?v_0 1)) ?v_1)) (f6 f7 (+ (f11 (f12 f13 ?v_0) ?v_1) 1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f16 ?v0) f1) (= (f6 f7 (f11 (f12 f13 (+ ?v_0 1)) 2)) (f6 f7 (f11 (f12 f13 ?v_0) 2)))))))
(assert (forall ((?v0 S2)) (let ((?v_1 (+ (+ 0 1) 1)) (?v_0 (f8 f9 ?v0))) (=> (= (f16 ?v0) f1) (= (f6 f7 (f11 (f12 f13 (+ ?v_0 1)) ?v_1)) (f6 f7 (f11 (f12 f13 ?v_0) ?v_1)))))))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 ?v0) f26) f26)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 f26) ?v0) f26)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 f26) ?v0) f26)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 ?v0) f26) f26)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f21 (f22 f23 ?v0) ?v1) f26) (or (= ?v0 f26) (= ?v1 f26)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (not (= ?v0 f26)) (=> (not (= ?v1 f26)) (not (= (f21 (f22 f23 ?v0) ?v1) f26))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f21 (f22 f23 ?v0) ?v1) f26) (or (= ?v0 f26) (= ?v1 f26)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f13 (* ?v0 ?v1)) (* ?v0 ?v2)) (ite (= ?v0 0) 0 (f11 (f12 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 (* ?v1 ?v0)) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 (* ?v0 ?v1)) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 (* ?v1 ?v0)) (* ?v2 ?v0)) (f11 (f12 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 (* ?v0 ?v1)) (* ?v0 ?v2)) (f11 (f12 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f11 (f12 f13 (f8 f9 (f6 f7 ?v0))) (f8 f9 (f6 f7 ?v1)))) (f6 f7 (f11 (f12 f13 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f12 f13 ?v0) ?v1)) (f6 f7 (f11 (f12 f13 (f8 f9 (f6 f7 ?v0))) (f8 f9 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 (f12 f13 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 (f12 f13 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= (f11 (f12 f13 ?v_0) (f8 f9 ?v1)) ?v_0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 (f12 f13 (f8 f9 ?v0)) (+ 0 1))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f12 f13 (f8 f9 ?v0))) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (f11 ?v_0 (+ (+ (+ ?v_1 1) 1) 1))) (f6 f7 (f11 ?v_0 (+ 3 ?v_1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (f11 (f12 f13 (+ (+ ?v_0 1) 1)) 2)) (f6 f7 (+ (f11 (f12 f13 ?v_0) 2) 1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (f11 (f12 f13 (+ (+ (+ ?v_0 1) 1) 1)) ?v_1)) (f6 f7 (f11 (f12 f13 (+ 3 ?v_0)) ?v_1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (f11 (f12 f13 (+ ?v_0 ?v_0)) 2)) ?v0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 1 ?v_0) (< 0 (f11 (f12 f13 ?v_0) 2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (< 0 (f11 (f12 f13 (+ ?v_0 1)) 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (=> (< 0 ?v_0) (= (f6 f7 (f11 (f12 f13 ?v_1) ?v_0)) (ite (< ?v_1 ?v_0) (f6 f7 0) (f6 f7 (+ (f11 (f12 f13 (f8 f9 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (=> (< 0 ?v_0) (=> (not (< ?v_1 ?v_0)) (= (f6 f7 (f11 (f12 f13 ?v_1) ?v_0)) (f6 f7 (+ (f11 (f12 f13 (f8 f9 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (=> (< 1 ?v_1) (=> (< 0 ?v_0) (< (f11 (f12 f13 ?v_0) ?v_1) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (=> (< 0 ?v_0) (=> (<= ?v_0 ?v_1) (= (f6 f7 (f11 (f12 f13 ?v_1) ?v_0)) (f6 f7 (+ (f11 (f12 f13 (f8 f9 (f6 f7 (- ?v_1 ?v_0)))) ?v_0) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f12 f13 (f8 f9 ?v2)))) (=> (< 0 ?v_0) (=> (<= ?v_0 ?v_1) (<= (f11 ?v_2 ?v_1) (f11 ?v_2 ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0))) (=> (< ?v_0 ?v_1) (= (f6 f7 (f11 (f12 f13 ?v_0) ?v_1)) (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f11 (f12 f13 ?v_0) ?v_2) (f11 (f12 f13 ?v_1) ?v_2))))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) 0) 0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2)) (?v_2 (f8 f9 ?v1))) (=> (< 0 ?v_0) (= (and (<= (* ?v_0 ?v_2) ?v_1) (< ?v_1 (* ?v_0 (+ ?v_2 1)))) (= ?v1 (f6 f7 (f11 (f12 f13 ?v_1) ?v_0))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (= (f6 f7 (f11 (f12 f13 (* ?v_0 (f8 f9 ?v1))) ?v_0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (= (f6 f7 (f11 (f12 f13 (* (f8 f9 ?v1) ?v_0)) ?v_0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f12 f13 (f8 f9 ?v0))) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (f11 ?v_0 (* ?v_1 ?v_2))) (f6 f7 (f11 (f12 f13 (f11 ?v_0 ?v_1)) ?v_2))))))
(assert (forall ((?v0 S15) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 0))) (let ((?v_1 (= ?v2 ?v_0))) (= (= (f31 ?v0 (f6 f7 (f11 (f12 f13 (f8 f9 ?v1)) (f8 f9 ?v2)))) f1) (and (=> ?v_1 (= (f31 ?v0 ?v_0) f1)) (=> (not ?v_1) (forall ((?v3 S2) (?v4 S2)) (let ((?v_2 (f8 f9 ?v2)) (?v_3 (f8 f9 ?v4))) (=> (< ?v_3 ?v_2) (=> (= ?v1 (f6 f7 (+ (* ?v_2 (f8 f9 ?v3)) ?v_3))) (= (f31 ?v0 ?v3) f1))))))))))))
(assert (forall ((?v0 S15) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f31 ?v0 (f6 f7 (f11 (f12 f13 (f8 f9 ?v1)) (f8 f9 ?v2)))) f1) (or (and (= ?v2 ?v_0) (= (f31 ?v0 ?v_0) f1)) (exists ((?v3 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2)) (?v_3 (f8 f9 ?v3))) (and (and (<= (* ?v_2 ?v_3) ?v_1) (< ?v_1 (* ?v_2 (+ ?v_3 1)))) (= (f31 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 ?v0) f26) f26)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 ?v0) f26) f26)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 f26) ?v0) f26)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 f26) ?v0) f26)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f11 (f12 f13 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f11 (f12 f13 ?v1) ?v2) (f11 (f12 f13 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f11 (f12 f13 ?v0) ?v2) (f11 (f12 f13 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f11 (f12 f13 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f11 (f12 f13 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f11 (f12 f13 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f11 (f12 f13 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f11 (f12 f13 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f11 (f12 f13 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f11 (f12 f13 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f11 (f12 f13 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f11 (f12 f13 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f11 (f12 f13 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f11 ?v_0 ?v2) (f11 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f11 (f12 f13 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f11 (f12 f13 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f11 (f12 f13 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f11 (f12 f13 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f11 (f12 f13 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f11 (f12 f13 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v1))) (=> (< 0 ?v0) (= (f11 ?v_0 (* ?v2 ?v0)) (f11 (f12 f13 (f11 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f11 (f12 f13 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f11 (f12 f13 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f11 (f12 f13 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f12 f13 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 (- ?v0)) (- ?v1)) (f11 (f12 f13 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 ?v0) (- ?v1)) (f11 (f12 f13 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 0) ?v0) 0)))
(assert (forall ((?v0 S9) (?v1 Int) (?v2 Int)) (= (= (f18 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f18 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f18 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f18 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (div ?v0 ?v1) (ite (<= 0 ?v1) (f11 ?v_0 ?v1) (- (f11 ?v_0 (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 (+ ?v1 (* ?v0 ?v2))) ?v0) (+ ?v2 (f11 (f12 f13 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 (+ ?v1 (* ?v2 ?v0))) ?v0) (+ ?v2 (f11 (f12 f13 ?v1) ?v0))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f21 (f22 f32 ?v1) ?v2)) (f21 (f22 f32 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f21 (f22 f32 ?v1) ?v2)) (f21 (f22 f32 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f21 (f22 f23 (f21 (f22 f32 ?v0) ?v1)) ?v2) (f21 (f22 f32 (f21 (f22 f23 ?v0) ?v2)) (f21 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f21 (f22 f23 (f21 (f22 f32 ?v0) ?v1)) ?v2) (f21 (f22 f32 (f21 (f22 f23 ?v0) ?v2)) (f21 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f19 ?v0 f27) f1) (=> (= (f19 ?v1 f27) f1) (= (f19 (f21 (f22 f32 ?v0) ?v1) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0 f28) f1) (=> (= (f17 ?v1 f28) f1) (= (f17 (+ ?v0 ?v1) f28) f1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (=> (= (f21 (f22 f32 ?v0) ?v1) (f21 (f22 f32 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f32 ?v0))) (=> (= (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f32 ?v0))) (=> (= (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f22 f32 ?v0))) (= (f21 (f22 f32 (f21 ?v_0 ?v1)) (f21 (f22 f32 ?v2) ?v3)) (f21 (f22 f32 (f21 ?v_0 ?v2)) (f21 (f22 f32 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (= (f21 (f22 f32 ?v0) ?v1) (f21 (f22 f32 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f32 ?v0))) (= (= (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f11 (f12 f33 ?v0) ?v1) ?v2) (f11 (f12 f33 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f11 (f12 f34 ?v0) ?v1) ?v2) (f11 (f12 f34 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f32 ?v0))) (= (f21 (f22 f32 (f21 ?v_0 ?v1)) ?v2) (f21 (f22 f32 (f21 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f32 ?v0))) (= (f21 (f22 f32 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f22 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f32 ?v0))) (= (f21 (f22 f32 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f22 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f32 ?v0))) (= (f21 ?v_0 (f21 (f22 f32 ?v1) ?v2)) (f21 (f22 f32 (f21 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_1 (f22 f32 ?v0)) (?v_0 (f22 f32 ?v1))) (= (f21 ?v_1 (f21 ?v_0 ?v2)) (f21 ?v_0 (f21 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f21 (f22 f32 ?v0) ?v1) (f21 (f22 f32 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f11 f24 ?v0) (f11 f24 ?v1)))) (= (f11 f24 ?v_0) ?v_0))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f22 f23 ?v2))) (= (= (f21 (f22 f32 (f21 ?v_0 ?v1)) (f21 ?v_1 ?v3)) (f21 (f22 f32 (f21 ?v_0 ?v3)) (f21 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (+ (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 ?v3) (* ?v2 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f21 (f22 f32 (f21 (f22 f23 ?v0) ?v1)) (f21 (f22 f23 ?v2) ?v1)) (f21 (f22 f23 (f21 (f22 f32 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (* ?v0 ?v1) (* ?v2 ?v1)) (* (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f21 (f22 f23 (f21 (f22 f32 ?v0) ?v1)) ?v2) (f21 (f22 f32 (f21 (f22 f23 ?v0) ?v2)) (f21 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f22 f23 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f21 (f22 f32 (f21 ?v_0 ?v2)) (f21 ?v_1 ?v3)) (f21 (f22 f32 (f21 ?v_0 ?v3)) (f21 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (* ?v0 ?v2) (* ?v1 ?v3)) (+ (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f21 (f22 f32 ?v1) ?v2)) (f21 (f22 f32 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (+ ?v1 ?v2)) (+ (* ?v0 ?v1) (* ?v0 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f21 (f22 f23 (f21 (f22 f32 ?v0) ?v1)) ?v2) (f21 (f22 f32 (f21 (f22 f23 ?v0) ?v2)) (f21 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (= (f21 (f22 f32 (f21 (f22 f23 ?v0) ?v1)) (f21 (f22 f32 (f21 (f22 f23 ?v2) ?v1)) ?v3)) (f21 (f22 f32 (f21 (f22 f23 (f21 (f22 f32 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= ?v0 (f21 (f22 f32 ?v0) ?v1)) (= ?v1 f26))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S10)) (= (f21 (f22 f32 ?v0) f26) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f32 ?v0) f26) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f32 ?v0) f26) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S10)) (= (f21 (f22 f32 f26) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f32 f26) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f32 f26) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10) (?v4 S10)) (let ((?v_0 (f22 f23 ?v0))) (=> (not (= ?v0 f26)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f21 (f22 f32 ?v1) (f21 ?v_0 ?v3)) (f21 (f22 f32 ?v2) (f21 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (* ?v0 ?v3)) (+ ?v2 (* ?v0 ?v4))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 (+ ?v0 ?v1)) ?v0) (+ (f11 (f12 f13 ?v1) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 (+ ?v1 ?v0)) ?v0) (+ (f11 (f12 f13 ?v1) ?v0) 1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f21 (f22 f32 (f21 (f22 f23 ?v0) ?v1)) ?v1) (f21 (f22 f23 (f21 (f22 f32 ?v0) f35)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (* ?v0 ?v1) ?v1) (* (+ ?v0 1) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f21 (f22 f32 ?v0) (f21 (f22 f23 ?v1) ?v0)) (f21 (f22 f23 (f21 (f22 f32 ?v1) f35)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (* ?v1 ?v0)) (* (+ ?v1 1) ?v0))))
(assert (forall ((?v0 S10)) (= (f21 (f22 f32 ?v0) ?v0) (f21 (f22 f23 (f21 (f22 f32 f35) f35)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (* (+ 1 1) ?v0))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f11 (f12 f13 ?v0) ?v0) 1))))
(assert (not (= f35 f26)))
(assert (not (= 1 0)))
(assert (not (= f26 f35)))
(assert (not (= 0 1)))
(assert (= (f11 f24 1) 1))
(assert (forall ((?v0 S10)) (= (= f35 ?v0) (= ?v0 f35))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 f35) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 f35) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 f35) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 ?v0) f35) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 ?v0) f35) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S10)) (= (f21 (f22 f23 ?v0) f35) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (= (f19 f35 f27) f1))
(assert (= (f17 1 f28) f1))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) 1) ?v0)))
(assert (forall ((?v0 S10)) (=> (= (f19 ?v0 f36) f1) (not (= (f21 (f22 f32 (f21 (f22 f32 f35) ?v0)) ?v0) f26)))))
(assert (forall ((?v0 Int)) (=> (= (f17 ?v0 f37) f1) (not (= (+ (+ 1 ?v0) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (<= (+ (* ?v3 ?v0) (* ?v4 ?v2)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v1 ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v0 ?v1) ?v0))))))
(assert (not (<= 1 0)))
(assert (<= 0 1))
(assert (= (f19 f35 f36) f1))
(assert (= (f17 1 f37) f1))
(assert (forall ((?v0 S10)) (=> (= (f19 ?v0 f36) f1) (= (= (f21 (f22 f32 ?v0) ?v0) f26) (= ?v0 f26)))))
(assert (forall ((?v0 Int)) (=> (= (f17 ?v0 f37) f1) (= (= (+ ?v0 ?v0) 0) (= ?v0 0)))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f11 (f12 f13 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f11 (f12 f38 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
