(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 () S2)
(declare-fun f11 () S2)
(declare-fun f12 (S2) S1)
(declare-fun f13 () S7)
(declare-fun f14 () S7)
(declare-fun f15 (S8 S7) S7)
(declare-fun f16 (S9 S7) S8)
(declare-fun f17 () S9)
(declare-fun f18 (S10 Int) Int)
(declare-fun f19 () S10)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1))))))
(assert (not (not (= f10 (f6 f7 0)))))
(assert (not (= f11 (f6 f7 0))))
(assert (= f11 (f6 f7 (* 2 (f8 f9 f10)))))
(assert (= f11 (f6 f7 (* 2 (f8 f9 f10)))))
(assert (= (f12 f11) f1))
(assert (exists ((?v0 S2)) (= f11 (f6 f7 (* 2 (f8 f9 ?v0))))))
(assert (=> (forall ((?v0 S2)) (=> (= f11 (f6 f7 (* 2 (f8 f9 ?v0)))) false)) false))
(assert (not (= f13 f14)))
(assert (not (= f11 (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (= (f12 ?v0) f1) (exists ((?v1 S2)) (= ?v0 (f6 f7 (* (+ (+ 0 1) 1) (f8 f9 ?v1))))))))
(assert (forall ((?v0 S2)) (= (= (f12 ?v0) f1) (exists ((?v1 S2)) (= ?v0 (f6 f7 (* 2 (f8 f9 ?v1))))))))
(assert (forall ((?v0 S2)) (= (not (= (f12 ?v0) f1)) (exists ((?v1 S2)) (= ?v0 (f6 f7 (+ (* (+ (+ 0 1) 1) (f8 f9 ?v1)) 1)))))))
(assert (forall ((?v0 S2)) (= (not (= (f12 ?v0) f1)) (exists ((?v1 S2)) (= ?v0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f12 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) f1) (or (= (f12 ?v0) f1) (= (f12 ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 f14) ?v0) f14)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 f14) ?v0) f14)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 ?v0) f14) f14)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 ?v0) f14) f14)))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) (f15 (f16 f17 ?v2) ?v3)) (f15 (f16 f17 (f15 ?v_0 ?v2)) (f15 (f16 f17 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_1 (f16 f17 (f15 (f16 f17 ?v0) ?v1))) (?v_0 (f16 f17 ?v2))) (= (f15 ?v_1 (f15 ?v_0 ?v3)) (f15 ?v_0 (f15 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f15 (f16 f17 ?v2) ?v3))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v_1) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 (f16 f17 (f15 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f19 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f15 (f16 f17 ?v1) ?v2)) (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f16 f17 ?v0)) (?v_0 (f16 f17 ?v1))) (= (f15 ?v_1 (f15 ?v_0 ?v2)) (f15 ?v_0 (f15 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 f19 (* ?v0 ?v1)) (* (f18 f19 ?v0) (f18 f19 ?v1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (= (= (f12 ?v0) f1) (not (= (f12 (f6 f7 (- ?v_0 1))) f1)))))))
(assert (forall ((?v0 S2)) (=> (not (= (f12 ?v0) f1)) (< 0 (f8 f9 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (= (f12 ?v0) f1)) (?v_1 (= (f12 ?v1) f1))) (= (= (f12 (f6 f7 (+ (f8 f9 ?v0) (f8 f9 ?v1)))) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_2 (= (f12 ?v0) f1)) (?v_3 (= (f12 ?v1) f1))) (= (= (f12 (f6 f7 (- ?v_0 ?v_1))) f1) (or (< ?v_0 ?v_1) (or (and ?v_2 ?v_3) (and (not ?v_2) (not ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f12 (f6 f7 (+ (f8 f9 ?v0) (f8 f9 ?v1)))) f1) (= (= (f12 ?v0) f1) (= (f12 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= (f12 (f6 f7 (+ (f8 f9 ?v0) (f8 f9 ?v1)))) f1)) (not (= (not (= (f12 ?v0) f1)) (not (= (f12 ?v1) f1)))))))
(assert (forall ((?v0 S2)) (= (= (f12 (f6 f7 (+ (f8 f9 ?v0) 1))) f1) (not (= (f12 ?v0) f1)))))
(assert (not (= (f12 (f6 f7 1)) f1)))
(assert (= (f12 (f6 f7 0)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f15 (f16 f17 ?v0) ?v1) f14) (or (= ?v0 f14) (= ?v1 f14)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 f14)) (=> (not (= ?v1 f14)) (not (= (f15 (f16 f17 ?v0) ?v1) f14))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f15 (f16 f17 ?v0) ?v1) f14) (or (= ?v0 f14) (= ?v1 f14)))))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f15 (f16 f17 ?v0) f14) f14)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_3 (f8 f9 ?v3)) (?v_1 (f8 f9 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (* ?v_0 ?v_1) (* ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v2))) (=> (< ?v_1 ?v_2) (=> (< 0 ?v_0) (< (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f8 f9 ?v1)) (?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (* ?v_0 ?v_1) (* ?v_2 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (<= (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4)) (< (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_4 (f8 f9 ?v4)) (?v_3 (f8 f9 ?v3))) (=> (<= ?v_1 ?v_0) (= (f6 f7 (- (+ (* ?v_0 ?v_2) ?v_3) (+ (* ?v_1 ?v_2) ?v_4))) (f6 f7 (- (+ (* (f8 f9 (f6 f7 (- ?v_0 ?v_1))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (<= ?v_0 (* ?v_0 (* ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f8 f9 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f8 f9 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (< 0 (* ?v_0 ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (* (f8 f9 ?v0) (f8 f9 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f8 f9 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f8 f9 ?v0)) (?v_0 (f8 f9 ?v1))) (= (f6 f7 (* ?v_1 ?v_0)) (f6 f7 (* ?v_0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (+ ?v_1 1))) (f6 f7 (+ ?v_0 (* ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1)) (?v_2 (f8 f9 ?v2))) (= (f6 f7 (* ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_2 (f8 f9 ?v2)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (* ?v_0 (f8 f9 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (* ?v_0 ?v_1) (* ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
