(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S4) S1)
(declare-fun f7 (S5 S6) S4)
(declare-fun f8 () S5)
(declare-fun f9 (S7 S6) S6)
(declare-fun f10 (S8 S6) S7)
(declare-fun f11 () S8)
(declare-fun f12 () S6)
(declare-fun f13 () S8)
(declare-fun f14 () S6)
(declare-fun f15 (S9 S10) S6)
(declare-fun f16 (S11 S6) S9)
(declare-fun f17 () S11)
(declare-fun f18 () S7)
(declare-fun f19 () S6)
(declare-fun f20 () S10)
(declare-fun f21 () S4)
(declare-fun f22 () S10)
(declare-fun f23 (S12 Int) S10)
(declare-fun f24 () S12)
(declare-fun f25 (S13 S10) Int)
(declare-fun f26 () S13)
(declare-fun f27 () S6)
(declare-fun f28 (S10) S1)
(declare-fun f29 (S14 Int) S13)
(declare-fun f30 () S14)
(declare-fun f31 (S15 S4) S4)
(declare-fun f32 (S16 S4) S15)
(declare-fun f33 () S16)
(declare-fun f34 (S17 S10) S4)
(declare-fun f35 (S18 S4) S17)
(declare-fun f36 () S18)
(declare-fun f37 (S10 S10) S1)
(declare-fun f38 () S10)
(declare-fun f39 (S19 S10) S10)
(declare-fun f40 (S20 S10) S19)
(declare-fun f41 () S20)
(declare-fun f42 () S20)
(declare-fun f43 () S15)
(declare-fun f44 () S16)
(declare-fun f45 () S4)
(declare-fun f46 () S10)
(declare-fun f47 () S15)
(declare-fun f48 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (* ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 (f9 (f10 f11 f12) (f9 (f10 f13 f14) (f15 (f16 f17 (f9 f18 f19)) f20)))) f21) f1)))
(assert (= (f6 (f7 f8 (f9 (f10 f11 f12) (f9 (f10 f13 f14) (f15 (f16 f17 f19) f22)))) f21) f1))
(assert (not (= f22 (f23 f24 0))))
(assert (not (= f20 (f23 f24 0))))
(assert (< (f25 f26 f22) (f25 f26 f20)))
(assert (= (f6 (f7 f8 (f9 (f10 f11 f12) (f9 (f10 f13 f14) (f15 (f16 f17 f19) f22)))) f21) f1))
(assert (not (= f14 f27)))
(assert (forall ((?v0 S10)) (=> (< (f25 f26 ?v0) (f25 f26 f20)) (=> (not (= ?v0 (f23 f24 0))) (exists ((?v1 S6)) (= (f6 (f7 f8 (f9 (f10 f11 f12) (f9 (f10 f13 f14) (f15 (f16 f17 ?v1) ?v0)))) f21) f1))))))
(assert (= (f28 f20) f1))
(assert (=> (forall ((?v0 S6)) (=> (= (f6 (f7 f8 (f9 (f10 f11 f12) (f9 (f10 f13 f14) (f15 (f16 f17 ?v0) f22)))) f21) f1) false)) false))
(assert (=> (< (f25 f26 f22) (f25 f26 f20)) (=> (not (= f22 (f23 f24 0))) (exists ((?v0 S6)) (= (f6 (f7 f8 (f9 (f10 f11 f12) (f9 (f10 f13 f14) (f15 (f16 f17 ?v0) f22)))) f21) f1)))))
(assert (forall ((?v0 S6)) (= (f15 (f16 f17 (f9 f18 ?v0)) (f23 f24 2)) ?v0)))
(assert (= f20 (f23 f24 (* 2 (f25 f26 f22)))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 1 ?v0) (< 1 (* ?v0 (f25 (f29 f30 ?v0) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S10)) (=> (= (f6 f21 ?v0) f1) (= (f6 f21 (f31 (f32 f33 ?v0) (f34 (f35 f36 ?v0) ?v1))) f1))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f37 f38 ?v0) f1) (= (f37 f38 (f39 (f40 f41 ?v0) (f39 (f40 f42 ?v0) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f25 (f29 f30 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (* ?v0 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f34 (f35 f36 ?v0) ?v1))) (=> (= (f6 f21 ?v0) f1) (= (f6 ?v_0 (f31 (f32 f33 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f39 (f40 f42 ?v0) ?v1))) (=> (= (f37 f38 ?v0) f1) (= (f37 ?v_0 (f39 (f40 f41 ?v0) ?v_0)) f1)))))
(assert (= (f31 f43 f21) f21))
(assert (= (f7 f8 f12) f21))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f6 (f31 f43 ?v0) ?v1) f1) (=> (= (f6 (f31 f43 ?v2) ?v3) f1) (= (f6 (f31 f43 (f31 (f32 f44 ?v0) ?v2)) (f31 (f32 f44 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S6) (?v1 S4) (?v2 S6) (?v3 S4)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f8 (f9 (f10 f11 ?v0) ?v2)) (f31 (f32 f44 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f6 (f31 f43 ?v0) ?v1) f1) (=> (= (f6 (f31 f43 ?v2) ?v3) f1) (= (f6 (f31 f43 (f31 (f32 f33 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S6) (?v1 S4) (?v2 S6) (?v3 S4)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (= (f6 (f7 f8 (f9 (f10 f13 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (f25 ?v_0 ?v1) (ite (= ?v1 (f23 f24 0)) 1 (* ?v0 (f25 ?v_0 (f23 f24 (- (f25 f26 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 ?v1) (ite (= ?v1 (f23 f24 0)) f21 (f31 (f32 f33 ?v0) (f34 ?v_0 (f23 f24 (- (f25 f26 ?v1) 1)))))))))
(assert (forall ((?v0 S6) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 ?v1) (ite (= ?v1 (f23 f24 0)) f12 (f9 (f10 f13 ?v0) (f15 ?v_0 (f23 f24 (- (f25 f26 ?v1) 1)))))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 ?v1) (ite (= ?v1 (f23 f24 0)) f38 (f39 (f40 f41 ?v0) (f39 ?v_0 (f23 f24 (- (f25 f26 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 1 ?v0) (< 1 (f25 (f29 f30 ?v0) (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S10)) (=> (= (f6 f21 ?v0) f1) (= (f6 f21 (f34 (f35 f36 ?v0) (f23 f24 (+ (f25 f26 ?v1) 1)))) f1))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f37 f38 ?v0) f1) (= (f37 f38 (f39 (f40 f42 ?v0) (f23 f24 (+ (f25 f26 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 1 ?v0) (= (= (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f36 ?v0))) (=> (= (f6 f21 ?v0) f1) (= (= (f34 ?v_0 ?v1) (f34 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v0))) (=> (= (f37 f38 ?v0) f1) (= (= (f39 ?v_0 ?v1) (f39 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 1 ?v0) (= (< (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) (< (f25 f26 ?v1) (f25 f26 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f36 ?v0))) (=> (= (f6 f21 ?v0) f1) (= (= (f6 (f34 ?v_0 ?v1) (f34 ?v_0 ?v2)) f1) (< (f25 f26 ?v1) (f25 f26 ?v2)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v0))) (=> (= (f37 f38 ?v0) f1) (= (= (f37 (f39 ?v_0 ?v1) (f39 ?v_0 ?v2)) f1) (< (f25 f26 ?v1) (f25 f26 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 1 ?v0) (=> (< 0 (f25 f26 ?v1)) (< 1 (f25 (f29 f30 ?v0) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S10)) (=> (= (f6 f21 ?v0) f1) (=> (< 0 (f25 f26 ?v1)) (= (f6 f21 (f34 (f35 f36 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f37 f38 ?v0) f1) (=> (< 0 (f25 f26 ?v1)) (= (f37 f38 (f39 (f40 f42 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 1 ?v0) (=> (< (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) (< (f25 f26 ?v1) (f25 f26 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f36 ?v0))) (=> (= (f6 f21 ?v0) f1) (=> (= (f6 (f34 ?v_0 ?v1) (f34 ?v_0 ?v2)) f1) (< (f25 f26 ?v1) (f25 f26 ?v2)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v0))) (=> (= (f37 f38 ?v0) f1) (=> (= (f37 (f39 ?v_0 ?v1) (f39 ?v_0 ?v2)) f1) (< (f25 f26 ?v1) (f25 f26 ?v2)))))))
(assert (=> (forall ((?v0 S10)) (=> (= f20 (f23 f24 (* 2 (f25 f26 ?v0)))) false)) false))
(assert (exists ((?v0 S10)) (= f20 (f23 f24 (* 2 (f25 f26 ?v0))))))
(assert (= (f31 f43 f45) f45))
(assert (= (f7 f8 f27) f45))
(assert (forall ((?v0 S4)) (= (= (f31 f43 ?v0) f45) (= ?v0 f45))))
(assert (forall ((?v0 S6)) (= (= (f7 f8 ?v0) f45) (= ?v0 f27))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (f25 ?v_0 (f23 f24 (* (f25 f26 ?v1) (f25 f26 ?v2)))) (f25 (f29 f30 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f23 f24 (* (f25 f26 ?v1) (f25 f26 ?v2)))) (f39 (f40 f42 (f39 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f23 f24 (* (f25 f26 ?v1) (f25 f26 ?v2)))) (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S10) (?v2 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f23 f24 (* (f25 f26 ?v1) (f25 f26 ?v2)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 ?v0) f45) f45)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 ?v0) f27) f27)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 ?v0) f45) f45)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 ?v0) f27) f27)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 f45) ?v0) f45)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 f27) ?v0) f27)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 f45) ?v0) f45)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 f27) ?v0) f27)))
(assert (forall ((?v0 S4) (?v1 S10)) (=> (not (= ?v0 f45)) (not (= (f34 (f35 f36 ?v0) ?v1) f45)))))
(assert (forall ((?v0 S6) (?v1 S10)) (=> (not (= ?v0 f27)) (not (= (f15 (f16 f17 ?v0) ?v1) f27)))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (not (= ?v0 0)) (not (= (f25 (f29 f30 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S10)) (= (= (f34 (f35 f36 ?v0) ?v1) f45) (and (= ?v0 f45) (not (= ?v1 (f23 f24 0)))))))
(assert (forall ((?v0 S6) (?v1 S10)) (= (= (f15 (f16 f17 ?v0) ?v1) f27) (and (= ?v0 f27) (not (= ?v1 (f23 f24 0)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f25 (f29 f30 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f23 f24 0)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f39 (f40 f42 ?v0) ?v1) f46) (and (= ?v0 f46) (not (= ?v1 (f23 f24 0)))))))
(assert (forall ((?v0 S10)) (= (f34 (f35 f36 f45) (f23 f24 (+ (f25 f26 ?v0) 1))) f45)))
(assert (forall ((?v0 S10)) (= (f15 (f16 f17 f27) (f23 f24 (+ (f25 f26 ?v0) 1))) f27)))
(assert (forall ((?v0 S10)) (= (f25 (f29 f30 0) (f23 f24 (+ (f25 f26 ?v0) 1))) 0)))
(assert (forall ((?v0 S10)) (= (f39 (f40 f42 f46) (f23 f24 (+ (f25 f26 ?v0) 1))) f46)))
(assert (forall ((?v0 S4)) (= (= (f6 f45 (f31 f43 ?v0)) f1) (not (= ?v0 f45)))))
(assert (forall ((?v0 S6)) (= (= (f6 f45 (f7 f8 ?v0)) f1) (not (= ?v0 f27)))))
(assert (forall ((?v0 S4)) (=> (= (f6 (f31 f47 ?v0) f21) f1) (= (f6 (f34 (f35 f36 ?v0) (f23 f24 2)) f21) f1))))
(assert (forall ((?v0 S4) (?v1 S10)) (=> (= (f6 f45 ?v0) f1) (= (f6 f45 (f34 (f35 f36 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 0 ?v0) (< 0 (f25 (f29 f30 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f37 f46 ?v0) f1) (= (f37 f46 (f39 (f40 f42 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S10)) (= (f25 (f29 f30 0) ?v0) (ite (= ?v0 (f23 f24 0)) 1 0))))
(assert (forall ((?v0 S10)) (= (f34 (f35 f36 f45) ?v0) (ite (= ?v0 (f23 f24 0)) f21 f45))))
(assert (forall ((?v0 S10)) (= (f15 (f16 f17 f27) ?v0) (ite (= ?v0 (f23 f24 0)) f12 f27))))
(assert (forall ((?v0 S10)) (= (f39 (f40 f42 f46) ?v0) (ite (= ?v0 (f23 f24 0)) f38 f46))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (let ((?v_0 (f29 f30 ?v2))) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f25 ?v_0 ?v1) (f25 ?v_0 ?v0))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S4)) (let ((?v_0 (f35 f36 ?v2))) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (=> (= (f6 f45 ?v2) f1) (=> (= (f6 ?v2 f21) f1) (= (f6 (f34 ?v_0 ?v1) (f34 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v2))) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (=> (= (f37 f46 ?v2) f1) (=> (= (f37 ?v2 f38) f1) (= (f37 (f39 ?v_0 ?v1) (f39 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f25 (f29 f30 ?v0) (f23 f24 (+ (f25 f26 ?v1) 1))) 1)))))
(assert (forall ((?v0 S4) (?v1 S10)) (=> (= (f6 f45 ?v0) f1) (=> (= (f6 ?v0 f21) f1) (= (f6 (f34 (f35 f36 ?v0) (f23 f24 (+ (f25 f26 ?v1) 1))) f21) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f37 f46 ?v0) f1) (=> (= (f37 ?v0 f38) f1) (= (f37 (f39 (f40 f42 ?v0) (f23 f24 (+ (f25 f26 ?v1) 1))) f38) f1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f25 (f29 f30 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f34 (f35 f36 ?v0) ?v1))) (=> (= (f6 f45 ?v0) f1) (=> (= (f6 ?v0 f21) f1) (= (f6 (f31 (f32 f33 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f39 (f40 f42 ?v0) ?v1))) (=> (= (f37 f46 ?v0) f1) (=> (= (f37 ?v0 f38) f1) (= (f37 (f39 (f40 f41 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 Int)) (= (f25 (f29 f30 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f39 (f40 f42 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f34 (f35 f36 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f15 (f16 f17 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S10)) (= (f31 f47 (f34 (f35 f36 ?v0) ?v1)) (f34 (f35 f36 (f31 f47 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f3 f48 (f25 (f29 f30 ?v0) ?v1)) (f25 (f29 f30 (f3 f48 ?v0)) ?v1))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f31 f47 ?v_0) ?v_0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f31 (f32 f33 (f31 (f32 f44 ?v0) ?v1)) ?v2) (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v2)) (f9 (f10 f13 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f31 (f32 f33 (f31 (f32 f44 ?v0) ?v1)) ?v2) (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v2)) (f9 (f10 f13 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f31 (f32 f44 ?v1) ?v2)) (f31 (f32 f44 (f31 ?v_0 ?v1)) (f31 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f31 (f32 f44 ?v1) ?v2)) (f31 (f32 f44 (f31 ?v_0 ?v1)) (f31 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (let ((?v_0 (f25 f26 ?v1)) (?v_1 (f25 f26 ?v0)) (?v_2 (f29 f30 ?v2))) (=> (<= ?v_1 ?v_0) (= (f25 ?v_2 (f23 f24 (- (+ ?v_0 1) ?v_1))) (* (f25 ?v_2 (f23 f24 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f25 f26 ?v1)) (?v_1 (f25 f26 ?v0)) (?v_2 (f40 f42 ?v2))) (=> (<= ?v_1 ?v_0) (= (f39 ?v_2 (f23 f24 (- (+ ?v_0 1) ?v_1))) (f39 (f40 f41 (f39 ?v_2 (f23 f24 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S4)) (let ((?v_0 (f25 f26 ?v1)) (?v_1 (f25 f26 ?v0)) (?v_2 (f35 f36 ?v2))) (=> (<= ?v_1 ?v_0) (= (f34 ?v_2 (f23 f24 (- (+ ?v_0 1) ?v_1))) (f31 (f32 f33 (f34 ?v_2 (f23 f24 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S6)) (let ((?v_0 (f25 f26 ?v1)) (?v_1 (f25 f26 ?v0)) (?v_2 (f16 f17 ?v2))) (=> (<= ?v_1 ?v_0) (= (f15 ?v_2 (f23 f24 (- (+ ?v_0 1) ?v_1))) (f9 (f10 f13 (f15 ?v_2 (f23 f24 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f25 (f29 f30 (* ?v0 ?v1)) ?v2) (* (f25 (f29 f30 ?v0) ?v2) (f25 (f29 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f39 (f40 f42 (f39 (f40 f41 ?v0) ?v1)) ?v2) (f39 (f40 f41 (f39 (f40 f42 ?v0) ?v2)) (f39 (f40 f42 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S10)) (= (f34 (f35 f36 (f31 (f32 f33 ?v0) ?v1)) ?v2) (f31 (f32 f33 (f34 (f35 f36 ?v0) ?v2)) (f34 (f35 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S10)) (= (f15 (f16 f17 (f9 (f10 f13 ?v0) ?v1)) ?v2) (f9 (f10 f13 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f25 (f29 f30 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f39 (f40 f42 ?v0) ?v1))) (= (f39 (f40 f41 ?v_0) ?v0) (f39 (f40 f41 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f34 (f35 f36 ?v0) ?v1))) (= (f31 (f32 f33 ?v_0) ?v0) (f31 (f32 f33 ?v0) ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S10)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v1))) (= (f9 (f10 f13 ?v_0) ?v0) (f9 (f10 f13 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (f25 ?v_0 (f23 f24 (+ (f25 f26 ?v1) (f25 f26 ?v2)))) (* (f25 ?v_0 ?v1) (f25 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f23 f24 (+ (f25 f26 ?v1) (f25 f26 ?v2)))) (f39 (f40 f41 (f39 ?v_0 ?v1)) (f39 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f23 f24 (+ (f25 f26 ?v1) (f25 f26 ?v2)))) (f31 (f32 f33 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S10) (?v2 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f23 f24 (+ (f25 f26 ?v1) (f25 f26 ?v2)))) (f9 (f10 f13 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (f25 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (* (f25 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f39 (f40 f41 (f39 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f31 (f32 f33 (f34 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f9 (f10 f13 (f15 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (f25 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (* ?v0 (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f39 (f40 f41 ?v0) (f39 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f31 (f32 f33 ?v0) (f34 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f9 (f10 f13 ?v0) (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f25 (f29 f30 ?v0) (f23 f24 0)) 1)))
(assert (forall ((?v0 S4)) (= (f34 (f35 f36 ?v0) (f23 f24 0)) f21)))
(assert (forall ((?v0 S6)) (= (f15 (f16 f17 ?v0) (f23 f24 0)) f12)))
(assert (forall ((?v0 S10)) (= (f39 (f40 f42 ?v0) (f23 f24 0)) f38)))
(assert (forall ((?v0 S10)) (= (f25 (f29 f30 1) ?v0) 1)))
(assert (forall ((?v0 S10)) (= (f34 (f35 f36 f21) ?v0) f21)))
(assert (forall ((?v0 S10)) (= (f15 (f16 f17 f12) ?v0) f12)))
(assert (forall ((?v0 S10)) (= (f39 (f40 f42 f38) ?v0) f38)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f31 f43 (f31 (f32 f33 ?v0) ?v1)) (f31 (f32 f33 (f31 f43 ?v0)) (f31 f43 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f7 f8 (f9 (f10 f13 ?v0) ?v1)) (f31 (f32 f33 (f7 f8 ?v0)) (f7 f8 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S10)) (= (f31 f43 (f34 (f35 f36 ?v0) ?v1)) (f34 (f35 f36 (f31 f43 ?v0)) ?v1))))
(assert (forall ((?v0 S6) (?v1 S10)) (= (f7 f8 (f15 (f16 f17 ?v0) ?v1)) (f34 (f35 f36 (f7 f8 ?v0)) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 Int)) (let ((?v_0 (f29 f30 ?v2))) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (=> (< 1 ?v2) (< (f25 ?v_0 ?v0) (f25 ?v_0 ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S4)) (let ((?v_0 (f35 f36 ?v2))) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (=> (= (f6 f21 ?v2) f1) (= (f6 (f34 ?v_0 ?v0) (f34 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v2))) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (=> (= (f37 f38 ?v2) f1) (= (f37 (f39 ?v_0 ?v0) (f39 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S4) (?v1 S10)) (= (= (f6 (f34 (f35 f36 ?v0) ?v1) f45) f1) (and (not (= (f28 ?v1) f1)) (= (f6 ?v0 f45) f1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (< (f25 (f29 f30 ?v0) ?v1) 0) (and (not (= (f28 ?v1) f1)) (< ?v0 0)))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (= (f28 ?v1) f1))) (= (= (f6 f45 (f34 (f35 f36 ?v0) ?v1)) f1) (or (= ?v1 (f23 f24 0)) (or (and ?v_0 (not (= ?v0 f45))) (and (not ?v_0) (= (f6 f45 ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (= (f28 ?v1) f1))) (= (< 0 (f25 (f29 f30 ?v0) ?v1)) (or (= ?v1 (f23 f24 0)) (or (and ?v_0 (not (= ?v0 0))) (and (not ?v_0) (< 0 ?v0))))))))
(assert (forall ((?v0 S4) (?v1 S10)) (=> (= (f6 ?v0 f45) f1) (= (f6 (f34 (f35 f36 ?v0) (f23 f24 (+ (* 2 (f25 f26 ?v1)) 1))) f45) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (< ?v0 0) (< (f25 (f29 f30 ?v0) (f23 f24 (+ (* 2 (f25 f26 ?v1)) 1))) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f23 f24 2))) (= (< 0 (+ (f25 (f29 f30 ?v0) ?v_0) (f25 (f29 f30 ?v1) ?v_0))) (or (not (= ?v0 0)) (not (= ?v1 0)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f23 f24 2))) (= (= (f6 f45 (f31 (f32 f44 (f34 (f35 f36 ?v0) ?v_0)) (f34 (f35 f36 ?v1) ?v_0))) f1) (or (not (= ?v0 f45)) (not (= ?v1 f45)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f23 f24 2))) (not (< (+ (f25 (f29 f30 ?v0) ?v_0) (f25 (f29 f30 ?v1) ?v_0)) 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f23 f24 2))) (not (= (f6 (f31 (f32 f44 (f34 (f35 f36 ?v0) ?v_0)) (f34 (f35 f36 ?v1) ?v_0)) f45) f1)))))
(assert (< 0 (+ 1 1)))
(assert (= (f6 f45 (f31 (f32 f44 f21) f21)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< 0 (+ (* ?v0 ?v0) (* ?v1 ?v1))) (or (not (= ?v0 0)) (not (= ?v1 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 f45 (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v0)) (f31 (f32 f33 ?v1) ?v1))) f1) (or (not (= ?v0 f45)) (not (= ?v1 f45))))))
(assert (forall ((?v0 Int) (?v1 Int)) (not (< (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f6 (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v0)) (f31 (f32 f33 ?v1) ?v1)) f45) f1))))
(assert (forall ((?v0 S4)) (not (= (f6 (f31 (f32 f44 (f31 f47 ?v0)) f21) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f29 f30 ?v0))) (let ((?v_1 (f25 ?v_0 ?v1))) (= (f25 ?v_0 (f23 f24 (* 2 (f25 f26 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f40 f42 ?v0))) (let ((?v_1 (f39 ?v_0 ?v1))) (= (f39 ?v_0 (f23 f24 (* 2 (f25 f26 ?v1)))) (f39 (f40 f41 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f35 f36 ?v0))) (let ((?v_1 (f34 ?v_0 ?v1))) (= (f34 ?v_0 (f23 f24 (* 2 (f25 f26 ?v1)))) (f31 (f32 f33 ?v_1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (let ((?v_1 (f15 ?v_0 ?v1))) (= (f15 ?v_0 (f23 f24 (* 2 (f25 f26 ?v1)))) (f9 (f10 f13 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (=> (not (= ?v0 f45)) (= (= (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f45)) (= (= (f31 (f32 f33 ?v1) ?v0) (f31 (f32 f33 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (not (= f45 f21)))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f23 f24 2))) (= (= (f31 (f32 f44 (f34 (f35 f36 ?v0) ?v_0)) (f34 (f35 f36 ?v1) ?v_0)) f45) (and (= ?v0 f45) (= ?v1 f45))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (=> (= (f6 f45 ?v0) f1) (=> (= (f6 ?v1 ?v2) f1) (= (f6 (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f45 ?v0) f1) (=> (= (f6 f45 ?v1) f1) (= (f6 f45 (f31 (f32 f33 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 f45 ?v0) f1) (= (= (f6 (f31 (f32 f33 ?v1) ?v0) (f31 (f32 f33 ?v2) ?v0)) f1) (= (f6 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v0)) (f31 (f32 f33 ?v1) ?v1)) f45) (and (= ?v0 f45) (= ?v1 f45)))))
(assert (forall ((?v0 S4)) (= (f6 f45 (f31 (f32 f44 f21) (f31 f47 ?v0))) f1)))
(assert (forall ((?v0 S6)) (not (= (f6 (f7 f8 ?v0) f45) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 ?v0 ?v1) f1) false) (=> (=> (= (f6 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f31 f47 (f31 (f32 f33 ?v0) ?v1)) (f31 (f32 f33 (f31 f47 ?v0)) (f31 f47 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f48 (* ?v0 ?v1)) (* (f3 f48 ?v0) (f3 f48 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f31 (f32 f33 ?v0) ?v1) (f31 (f32 f33 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f9 (f10 f13 ?v0) ?v1) (f9 (f10 f13 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f32 f33 ?v0)) (?v_0 (f32 f33 ?v1))) (= (f31 ?v_1 (f31 ?v_0 ?v2)) (f31 ?v_0 (f31 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f10 f13 ?v0)) (?v_0 (f10 f13 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f31 (f32 f33 ?v1) ?v2)) (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 ?v_0 (f9 (f10 f13 ?v1) ?v2)) (f9 (f10 f13 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f31 f47 ?v0))) (= (f31 (f32 f33 ?v_0) ?v_0) (f31 (f32 f33 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f48 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2) (f31 ?v_0 (f31 (f32 f33 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 (f10 f13 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f13 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2) (f31 (f32 f33 (f31 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 (f10 f13 (f9 ?v_0 ?v1)) ?v2) (f9 (f10 f13 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f32 f33 ?v0)) (?v_1 (f31 (f32 f33 ?v2) ?v3))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v_1) (f31 ?v_0 (f31 (f32 f33 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f10 f13 ?v0)) (?v_1 (f9 (f10 f13 ?v2) ?v3))) (= (f9 (f10 f13 (f9 ?v_0 ?v1)) ?v_1) (f9 ?v_0 (f9 (f10 f13 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f32 f33 (f31 (f32 f33 ?v0) ?v1))) (?v_0 (f32 f33 ?v2))) (= (f31 ?v_1 (f31 ?v_0 ?v3)) (f31 ?v_0 (f31 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f10 f13 (f9 (f10 f13 ?v0) ?v1))) (?v_0 (f10 f13 ?v2))) (= (f9 ?v_1 (f9 ?v_0 ?v3)) (f9 ?v_0 (f9 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) (f31 (f32 f33 ?v2) ?v3)) (f31 (f32 f33 (f31 ?v_0 ?v2)) (f31 (f32 f33 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 (f10 f13 (f9 ?v_0 ?v1)) (f9 (f10 f13 ?v2) ?v3)) (f9 (f10 f13 (f9 ?v_0 ?v2)) (f9 (f10 f13 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f31 (f32 f44 ?v0) ?v1) (f31 (f32 f44 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f32 f44 ?v0)) (?v_0 (f32 f44 ?v1))) (= (f31 ?v_1 (f31 ?v_0 ?v2)) (f31 ?v_0 (f31 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f10 f11 ?v0)) (?v_0 (f10 f11 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f44 ?v0))) (= (f31 ?v_0 (f31 (f32 f44 ?v1) ?v2)) (f31 (f32 f44 (f31 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f44 ?v0))) (= (f31 (f32 f44 (f31 ?v_0 ?v1)) ?v2) (f31 ?v_0 (f31 (f32 f44 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f44 ?v0))) (= (f31 (f32 f44 (f31 ?v_0 ?v1)) ?v2) (f31 (f32 f44 (f31 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 (f10 f11 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f32 f44 ?v0))) (= (f31 (f32 f44 (f31 ?v_0 ?v1)) (f31 (f32 f44 ?v2) ?v3)) (f31 (f32 f44 (f31 ?v_0 ?v2)) (f31 (f32 f44 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 (f10 f11 ?v2) ?v3)) (f9 (f10 f11 (f9 ?v_0 ?v2)) (f9 (f10 f11 ?v1) ?v3))))))
(assert (= (f31 f47 f21) f21))
(assert (= (f3 f48 1) 1))
(assert (forall ((?v0 S4)) (let ((?v_0 (f34 (f35 f36 ?v0) (f23 f24 2)))) (= (f31 f47 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f25 (f29 f30 ?v0) (f23 f24 2)))) (= (f3 f48 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f25 (f29 f30 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f39 (f40 f42 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f34 (f35 f36 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f15 (f16 f17 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S4)) (let ((?v_0 (f23 f24 2))) (= (f34 (f35 f36 (f31 f47 ?v0)) ?v_0) (f34 (f35 f36 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f23 f24 2))) (= (f25 (f29 f30 (f3 f48 ?v0)) ?v_0) (f25 (f29 f30 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2) (f31 ?v_0 (f31 (f32 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f31 (f32 f33 ?v0) ?v1) (f31 (f32 f33 ?v1) ?v0))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f25 f26 ?v0))) (= (f23 f24 (* 2 ?v_0)) (f23 f24 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f25 f26 ?v0))) (= (f23 f24 (* ?v_0 2)) (f23 f24 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f23 f24 0)) (?v_2 (f25 f26 ?v0)) (?v_1 (f25 f26 ?v1))) (= (f23 f24 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f23 f24 (+ ?v_1 (* (f25 f26 (f23 f24 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 ?v1) (ite (= ?v1 (f23 f24 0)) (f23 f24 1) (f23 f24 (* (f25 f26 ?v0) (f25 f26 (f39 ?v_0 (f23 f24 (- (f25 f26 ?v1) 1)))))))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f25 f26 ?v0))) (=> (< 0 ?v_0) (= (= (f28 ?v0) f1) (not (= (f28 (f23 f24 (- ?v_0 1))) f1)))))))
(assert (forall ((?v0 S10)) (=> (not (= (f28 ?v0) f1)) (< 0 (f25 f26 ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (= (f28 ?v0) f1)) (?v_1 (= (f28 ?v1) f1))) (= (= (f28 (f23 f24 (+ (f25 f26 ?v0) (f25 f26 ?v1)))) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_1 (f25 f26 ?v1)) (?v_0 (f25 f26 ?v0)) (?v_2 (= (f28 ?v0) f1)) (?v_3 (= (f28 ?v1) f1))) (= (= (f28 (f23 f24 (- ?v_0 ?v_1))) f1) (or (< ?v_0 ?v_1) (or (and ?v_2 ?v_3) (and (not ?v_2) (not ?v_3))))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f28 (f39 (f40 f42 ?v0) ?v1)) f1) (and (= (f28 ?v0) f1) (< 0 (f25 f26 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f28 (f23 f24 (+ (f25 f26 ?v0) (f25 f26 ?v1)))) f1) (= (= (f28 ?v0) f1) (= (f28 ?v1) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (not (= (f28 (f23 f24 (+ (f25 f26 ?v0) (f25 f26 ?v1)))) f1)) (not (= (not (= (f28 ?v0) f1)) (not (= (f28 ?v1) f1)))))))
(assert (forall ((?v0 S10)) (= (= (f28 (f23 f24 (+ (f25 f26 ?v0) 1))) f1) (not (= (f28 ?v0) f1)))))
(assert (not (= (f28 (f23 f24 1)) f1)))
(assert (= (f28 (f23 f24 0)) f1))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 f45) ?v0) f45)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 f27) ?v0) f27)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 f45) ?v0) f45)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 f27) ?v0) f27)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 ?v0) f45) f45)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 ?v0) f27) f27)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 ?v0) f45) f45)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 ?v0) f27) f27)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f31 (f32 f33 ?v0) ?v1) f45) (or (= ?v0 f45) (= ?v1 f45)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f9 (f10 f13 ?v0) ?v1) f27) (or (= ?v0 f27) (= ?v1 f27)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f45)) (=> (not (= ?v1 f45)) (not (= (f31 (f32 f33 ?v0) ?v1) f45))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f27)) (=> (not (= ?v1 f27)) (not (= (f9 (f10 f13 ?v0) ?v1) f27))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f31 (f32 f33 ?v0) ?v1) f45) (or (= ?v0 f45) (= ?v1 f45)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f9 (f10 f13 ?v0) ?v1) f27) (or (= ?v0 f27) (= ?v1 f27)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f44 f45) ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f27) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f44 ?v0) f45) ?v0)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 ?v0) f27) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 (f31 (f32 f44 ?v0) ?v1)) (= ?v1 f45))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= ?v0 (f9 (f10 f11 ?v0) ?v1)) (= ?v1 f27))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f31 f47 ?v0)) (?v_1 (f31 f47 ?v2))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 ?v_1 ?v3) f1) (= (f6 (f31 (f32 f33 ?v_0) ?v_1) (f31 (f32 f33 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 f48 ?v0)) (?v_1 (f3 f48 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (not (= 1 0)))
(assert (not (= f21 f45)))
(assert (not (= f12 f27)))
(assert (not (= 0 1)))
(assert (not (= f45 f21)))
(assert (not (= f27 f12)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (+ ?v1 ?v2)) (+ (* ?v0 ?v1) (* ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f31 (f32 f44 ?v1) ?v2)) (f31 (f32 f44 (f31 ?v_0 ?v1)) (f31 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f13 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (* ?v0 ?v2) (* ?v1 ?v3)) (+ (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f32 f33 ?v0)) (?v_1 (f32 f33 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f31 (f32 f44 (f31 ?v_0 ?v2)) (f31 ?v_1 ?v3)) (f31 (f32 f44 (f31 ?v_0 ?v3)) (f31 ?v_1 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f10 f13 ?v0)) (?v_1 (f10 f13 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f9 (f10 f11 (f9 ?v_0 ?v2)) (f9 ?v_1 ?v3)) (f9 (f10 f11 (f9 ?v_0 ?v3)) (f9 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f31 (f32 f33 (f31 (f32 f44 ?v0) ?v1)) ?v2) (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v2)) (f9 (f10 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f31 (f32 f33 (f31 (f32 f44 ?v0) ?v1)) ?v2) (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v2)) (f9 (f10 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (* ?v0 ?v1) (* ?v2 ?v1)) (* (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v1)) (f31 (f32 f33 ?v2) ?v1)) (f31 (f32 f33 (f31 (f32 f44 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v1)) (f9 (f10 f13 ?v2) ?v1)) (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v1)) (f31 (f32 f44 (f31 (f32 f33 ?v2) ?v1)) ?v3)) (f31 (f32 f44 (f31 (f32 f33 (f31 (f32 f44 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (= (f9 (f10 f11 (f9 (f10 f13 ?v0) ?v1)) (f9 (f10 f11 (f9 (f10 f13 ?v2) ?v1)) ?v3)) (f9 (f10 f11 (f9 (f10 f13 (f9 (f10 f11 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (+ (* ?v0 ?v1) (* ?v2 ?v3)) (+ (* ?v0 ?v3) (* ?v2 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f32 f33 ?v0)) (?v_1 (f32 f33 ?v2))) (= (= (f31 (f32 f44 (f31 ?v_0 ?v1)) (f31 ?v_1 ?v3)) (f31 (f32 f44 (f31 ?v_0 ?v3)) (f31 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f10 f13 ?v0)) (?v_1 (f10 f13 ?v2))) (= (= (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 ?v_1 ?v3)) (f9 (f10 f11 (f9 ?v_0 ?v3)) (f9 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 f21) ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 f12) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 ?v0) f21) ?v0)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 ?v0) f12) ?v0)))
(assert (= (f34 (f35 f36 f45) (f23 f24 2)) f45))
(assert (= (f15 (f16 f17 f27) (f23 f24 2)) f27))
(assert (= (f25 (f29 f30 0) (f23 f24 2)) 0))
(assert (= (f39 (f40 f42 f46) (f23 f24 2)) f46))
(assert (forall ((?v0 S4)) (= (= (f34 (f35 f36 ?v0) (f23 f24 2)) f45) (= ?v0 f45))))
(assert (forall ((?v0 S6)) (= (= (f15 (f16 f17 ?v0) (f23 f24 2)) f27) (= ?v0 f27))))
(assert (forall ((?v0 Int)) (= (= (f25 (f29 f30 ?v0) (f23 f24 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (* ?v0 ?v0) (f25 (f29 f30 ?v0) (f23 f24 2)))))
(assert (forall ((?v0 S10)) (= (f39 (f40 f41 ?v0) ?v0) (f39 (f40 f42 ?v0) (f23 f24 2)))))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 ?v0) ?v0) (f34 (f35 f36 ?v0) (f23 f24 2)))))
(assert (forall ((?v0 S6)) (= (f9 (f10 f13 ?v0) ?v0) (f15 (f16 f17 ?v0) (f23 f24 2)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (f25 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (* ?v0 (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f39 (f40 f41 ?v0) (f39 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f31 (f32 f33 ?v0) (f34 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f9 (f10 f13 ?v0) (f15 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f25 (f29 f30 ?v0) (f23 f24 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S10)) (= (f39 (f40 f42 ?v0) (f23 f24 2)) (f39 (f40 f41 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f34 (f35 f36 ?v0) (f23 f24 2)) (f31 (f32 f33 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f15 (f16 f17 ?v0) (f23 f24 2)) (f9 (f10 f13 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f25 (f29 f30 ?v0) (f23 f24 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S10)) (= (f39 (f40 f42 ?v0) (f23 f24 3)) (f39 (f40 f41 (f39 (f40 f41 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S4)) (= (f34 (f35 f36 ?v0) (f23 f24 3)) (f31 (f32 f33 (f31 (f32 f33 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S6)) (= (f15 (f16 f17 ?v0) (f23 f24 3)) (f9 (f10 f13 (f9 (f10 f13 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (* ?v0 (f25 ?v_0 ?v1)) (f25 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 (f40 f41 ?v0) (f39 ?v_0 ?v1)) (f39 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f31 (f32 f33 ?v0) (f34 ?v_0 ?v1)) (f34 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f10 f13 ?v0) (f15 ?v_0 ?v1)) (f15 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (* (f25 ?v_0 ?v1) ?v0) (f25 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 (f40 f41 (f39 ?v_0 ?v1)) ?v0) (f39 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f31 (f32 f33 (f34 ?v_0 ?v1)) ?v0) (f34 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f10 f13 (f15 ?v_0 ?v1)) ?v0) (f15 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f25 (f29 f30 (* ?v0 ?v1)) ?v2) (* (f25 (f29 f30 ?v0) ?v2) (f25 (f29 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (= (f39 (f40 f42 (f39 (f40 f41 ?v0) ?v1)) ?v2) (f39 (f40 f41 (f39 (f40 f42 ?v0) ?v2)) (f39 (f40 f42 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S10)) (= (f34 (f35 f36 (f31 (f32 f33 ?v0) ?v1)) ?v2) (f31 (f32 f33 (f34 (f35 f36 ?v0) ?v2)) (f34 (f35 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S10)) (= (f15 (f16 f17 (f9 (f10 f13 ?v0) ?v1)) ?v2) (f9 (f10 f13 (f15 (f16 f17 ?v0) ?v2)) (f15 (f16 f17 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (* (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) (f25 ?v_0 (f23 f24 (+ (f25 f26 ?v1) (f25 f26 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 (f40 f41 (f39 ?v_0 ?v1)) (f39 ?v_0 ?v2)) (f39 ?v_0 (f23 f24 (+ (f25 f26 ?v1) (f25 f26 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f31 (f32 f33 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2)) (f34 ?v_0 (f23 f24 (+ (f25 f26 ?v1) (f25 f26 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S10) (?v2 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f9 (f10 f13 (f15 ?v_0 ?v1)) (f15 ?v_0 ?v2)) (f15 ?v_0 (f23 f24 (+ (f25 f26 ?v1) (f25 f26 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 Int)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f29 f30 ?v1))) (=> (< 0 ?v_0) (= (* (f25 ?v_1 (f23 f24 (- ?v_0 1))) ?v1) (f25 ?v_1 ?v0))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f40 f42 ?v1))) (=> (< 0 ?v_0) (= (f39 (f40 f41 (f39 ?v_1 (f23 f24 (- ?v_0 1)))) ?v1) (f39 ?v_1 ?v0))))))
(assert (forall ((?v0 S10) (?v1 S4)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f35 f36 ?v1))) (=> (< 0 ?v_0) (= (f31 (f32 f33 (f34 ?v_1 (f23 f24 (- ?v_0 1)))) ?v1) (f34 ?v_1 ?v0))))))
(assert (forall ((?v0 S10) (?v1 S6)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f16 f17 ?v1))) (=> (< 0 ?v_0) (= (f9 (f10 f13 (f15 ?v_1 (f23 f24 (- ?v_0 1)))) ?v1) (f15 ?v_1 ?v0))))))
(assert (= (f25 (f29 f30 1) (f23 f24 2)) 1))
(assert (= (f34 (f35 f36 f21) (f23 f24 2)) f21))
(assert (= (f15 (f16 f17 f12) (f23 f24 2)) f12))
(assert (= (f39 (f40 f42 f38) (f23 f24 2)) f38))
(assert (forall ((?v0 Int)) (= (f25 (f29 f30 ?v0) (f23 f24 0)) 1)))
(assert (forall ((?v0 S4)) (= (f34 (f35 f36 ?v0) (f23 f24 0)) f21)))
(assert (forall ((?v0 S6)) (= (f15 (f16 f17 ?v0) (f23 f24 0)) f12)))
(assert (forall ((?v0 S10)) (= (f39 (f40 f42 ?v0) (f23 f24 0)) f38)))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (f25 ?v_0 (f23 f24 (* 2 (f25 f26 ?v1)))) (f25 (f29 f30 (f25 ?v_0 ?v1)) (f23 f24 2))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f23 f24 (* 2 (f25 f26 ?v1)))) (f39 (f40 f42 (f39 ?v_0 ?v1)) (f23 f24 2))))))
(assert (forall ((?v0 S4) (?v1 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f23 f24 (* 2 (f25 f26 ?v1)))) (f34 (f35 f36 (f34 ?v_0 ?v1)) (f23 f24 2))))))
(assert (forall ((?v0 S6) (?v1 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 ?v_0 (f23 f24 (* 2 (f25 f26 ?v1)))) (f15 (f16 f17 (f15 ?v_0 ?v1)) (f23 f24 2))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (f25 (f29 f30 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f23 f24 (* (f25 f26 ?v1) (f25 f26 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 (f40 f42 (f39 ?v_0 ?v1)) ?v2) (f39 ?v_0 (f23 f24 (* (f25 f26 ?v1) (f25 f26 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v2) (f34 ?v_0 (f23 f24 (* (f25 f26 ?v1) (f25 f26 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S10) (?v2 S10)) (let ((?v_0 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_0 ?v1)) ?v2) (f15 ?v_0 (f23 f24 (* (f25 f26 ?v1) (f25 f26 ?v2))))))))
(assert (forall ((?v0 S4)) (= (f31 (f32 f33 f21) ?v0) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f31 (f32 f33 (f31 (f32 f44 ?v0) ?v1)) ?v2) (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S4)) (=> (= (f28 ?v0) f1) (= (f34 (f35 f36 (f31 f47 ?v1)) ?v0) (f34 (f35 f36 ?v1) ?v0)))))
(assert (forall ((?v0 S10) (?v1 Int)) (=> (= (f28 ?v0) f1) (= (f25 (f29 f30 (f3 f48 ?v1)) ?v0) (f25 (f29 f30 ?v1) ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f28 (f23 f24 (* (f25 f26 ?v0) (f25 f26 ?v1)))) f1) (or (= (f28 ?v0) f1) (= (f28 ?v1) f1)))))
(assert (forall ((?v0 S10)) (= (not (= (f28 ?v0) f1)) (exists ((?v1 S10)) (= ?v0 (f23 f24 (+ (* 2 (f25 f26 ?v1)) 1)))))))
(assert (forall ((?v0 S10)) (= (not (= (f28 ?v0) f1)) (exists ((?v1 S10)) (= ?v0 (f23 f24 (+ (* (+ (+ 0 1) 1) (f25 f26 ?v1)) 1)))))))
(assert (forall ((?v0 S10)) (= (= (f28 ?v0) f1) (exists ((?v1 S10)) (= ?v0 (f23 f24 (* 2 (f25 f26 ?v1))))))))
(assert (forall ((?v0 S10)) (= (= (f28 ?v0) f1) (exists ((?v1 S10)) (= ?v0 (f23 f24 (* (+ (+ 0 1) 1) (f25 f26 ?v1))))))))
(assert (forall ((?v0 S4)) (not (= (f6 (f31 (f32 f33 ?v0) ?v0) f45) f1))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f6 (f31 (f32 f33 ?v0) ?v1) (f31 (f32 f33 ?v2) ?v1)) f1) (or (and (= (f6 f45 ?v1) f1) (= (f6 ?v0 ?v2) f1)) (and (= (f6 ?v1 f45) f1) (= (f6 ?v2 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (= (= (f6 (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) f1) (or (and (= (f6 f45 ?v0) f1) (= (f6 ?v1 ?v2) f1)) (and (= (f6 ?v0 f45) f1) (= (f6 ?v2 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (=> (= (f6 f45 ?v0) f1) (= (= (f6 (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) f1) (= (f6 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f45 ?v0) f1) (=> (= (f6 f45 ?v1) f1) (= (f6 f45 (f31 (f32 f33 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f45 ?v0) f1) (=> (= (f6 ?v1 f45) f1) (= (f6 (f31 (f32 f33 ?v0) ?v1) f45) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f45 ?v0) f1) (=> (= (f6 ?v1 f45) f1) (= (f6 (f31 (f32 f33 ?v1) ?v0) f45) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f45 (f31 (f32 f33 ?v0) ?v1)) f1) (=> (= (f6 f45 ?v0) f1) (= (f6 f45 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f45 (f31 (f32 f33 ?v0) ?v1)) f1) (=> (= (f6 f45 ?v1) f1) (= (f6 f45 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v0))) (=> (= (f6 ?v0 f45) f1) (= (= (f6 (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) f1) (= (f6 ?v2 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 ?v0 f45) f1) (=> (= (f6 f45 ?v1) f1) (= (f6 (f31 (f32 f33 ?v0) ?v1) f45) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 ?v0 f45) f1) (=> (= (f6 ?v1 f45) f1) (= (f6 f45 (f31 (f32 f33 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 f45 ?v2) f1) (= (f6 (f31 (f32 f33 ?v0) ?v2) (f31 (f32 f33 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v2))) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 f45 ?v2) f1) (= (f6 (f31 ?v_0 ?v0) (f31 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v2))) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 f45 ?v2) f1) (= (f6 (f31 ?v_0 ?v0) (f31 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v2 f45) f1) (= (f6 (f31 (f32 f33 ?v1) ?v2) (f31 (f32 f33 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f32 f33 ?v2))) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v2 f45) f1) (= (f6 (f31 ?v_0 ?v1) (f31 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 f45 ?v0) f1) (=> (= (f6 ?v1 ?v2) f1) (= (f6 ?v1 (f31 (f32 f44 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v0)) (f31 (f32 f33 ?v1) ?v1)) f45) (and (= ?v0 f45) (= ?v1 f45)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (* ?v0 ?v3)) (+ ?v2 (* ?v0 ?v4))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4) (?v4 S4)) (let ((?v_0 (f32 f33 ?v0))) (=> (not (= ?v0 f45)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f31 (f32 f44 ?v1) (f31 ?v_0 ?v3)) (f31 (f32 f44 ?v2) (f31 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6) (?v4 S6)) (let ((?v_0 (f10 f13 ?v0))) (=> (not (= ?v0 f27)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f9 (f10 f11 ?v1) (f9 ?v_0 ?v3)) (f9 (f10 f11 ?v2) (f9 ?v_0 ?v4)))))))))
(assert (not (< 1 0)))
(assert (not (= (f6 f21 f45) f1)))
(assert (< 0 1))
(assert (= (f6 f45 f21) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f21 ?v0) f1) (=> (= (f6 f21 ?v1) f1) (= (f6 f21 (f31 (f32 f33 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4)) (not (= (f6 (f34 (f35 f36 ?v0) (f23 f24 2)) f45) f1))))
(assert (forall ((?v0 Int)) (not (< (f25 (f29 f30 ?v0) (f23 f24 2)) 0))))
(assert (forall ((?v0 Int)) (= (< 0 (f25 (f29 f30 ?v0) (f23 f24 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 S4)) (= (not (= (f6 f45 (f31 (f32 f33 ?v0) ?v0)) f1)) (= ?v0 f45))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f25 f26 (f39 (f40 f42 ?v0) ?v1)) (f25 (f29 f30 (f25 f26 ?v0)) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (< 0 (f25 f26 (f39 (f40 f42 ?v0) ?v1))) (or (< 0 (f25 f26 ?v0)) (= ?v1 (f23 f24 0))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (< 0 (f25 f26 (f39 (f40 f42 ?v0) ?v1))) (or (= ?v1 (f23 f24 0)) (< 0 (f25 f26 ?v0))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f23 f24 (+ 0 1)))) (= (f39 (f40 f42 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f25 (f29 f30 (f25 f26 ?v0)) ?v1) (f25 f26 (f39 (f40 f42 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f23 f24 (+ 0 1)))) (= (= (f39 (f40 f42 ?v0) ?v1) ?v_0) (or (= ?v1 (f23 f24 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (<= 0 ?v0) (= (f23 f24 (f25 (f29 f30 ?v0) ?v1)) (f39 (f40 f42 (f23 f24 ?v0)) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f40 f42 ?v0))) (=> (< 0 (f25 f26 ?v0)) (=> (< (f25 f26 (f39 ?v_0 ?v1)) (f25 f26 (f39 ?v_0 ?v2))) (< (f25 f26 ?v1) (f25 f26 ?v2)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f25 f26 ?v0)) (<= ?v_0 (f25 f26 (f39 (f40 f42 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f23 f24 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f23 f24 (* (f25 f26 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0))) (f25 f26 (f23 f24 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (* (f25 f26 ?v0) (f25 f26 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (* (f25 f26 ?v0) (f25 f26 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f29 f30 ?v0))) (= (f25 (f29 f30 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f23 f24 (* (f25 f26 ?v1) (f25 f26 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f23 f24 (* ?v0 ?v1)) (f23 f24 (* (f25 f26 (f23 f24 ?v0)) (f25 f26 (f23 f24 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f23 f24 (* ?v0 ?v1)) (f23 f24 (* (f25 f26 (f23 f24 (- ?v0))) (f25 f26 (f23 f24 (- ?v1)))))))))
(assert (forall ((?v0 S10) (?v1 S4)) (=> (< 0 (f25 f26 ?v0)) (=> (= (f6 f45 ?v1) f1) (exists ((?v2 S4)) (and (and (= (f6 f45 ?v2) f1) (= (f34 (f35 f36 ?v2) ?v0) ?v1)) (forall ((?v3 S4)) (=> (and (= (f6 f45 ?v3) f1) (= (f34 (f35 f36 ?v3) ?v0) ?v1)) (= ?v3 ?v2)))))))))
(assert (forall ((?v0 S10) (?v1 S4)) (=> (< 0 (f25 f26 ?v0)) (=> (= (f6 f45 ?v1) f1) (exists ((?v2 S4)) (and (= (f6 f45 ?v2) f1) (= (f34 (f35 f36 ?v2) ?v0) ?v1)))))))
(assert (forall ((?v0 S10)) (= (f23 f24 (f25 f26 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f25 f26 (f23 f24 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f25 f26 (f23 f24 ?v0)) 0))))
(check-sat)
(exit)
