(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S3 S3) S1)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) S2)
(declare-fun f8 (S6 S2) S5)
(declare-fun f9 () S6)
(declare-fun f10 () S6)
(declare-fun f11 (S7 S3) S2)
(declare-fun f12 () S7)
(declare-fun f13 () S2)
(declare-fun f14 (S8 S9) S2)
(declare-fun f15 (S10 S2) S8)
(declare-fun f16 () S10)
(declare-fun f17 () S9)
(declare-fun f18 () S3)
(declare-fun f19 (S11 Int) S9)
(declare-fun f20 () S11)
(declare-fun f21 () S2)
(declare-fun f22 (S9) S1)
(declare-fun f23 (S12 S9) Int)
(declare-fun f24 () S12)
(declare-fun f25 () S9)
(declare-fun f26 (S13 S3) S3)
(declare-fun f27 (S14 S3) S13)
(declare-fun f28 () S14)
(declare-fun f29 () S14)
(declare-fun f30 () S2)
(declare-fun f31 () S13)
(declare-fun f32 () S13)
(declare-fun f33 (S15 S9) S3)
(declare-fun f34 (S16 S3) S15)
(declare-fun f35 () S16)
(declare-fun f36 (S17 Int) S12)
(declare-fun f37 () S17)
(declare-fun f38 (S9 S9) S1)
(declare-fun f39 () S9)
(declare-fun f40 (S18 S9) S9)
(declare-fun f41 (S19 S9) S18)
(declare-fun f42 () S19)
(declare-fun f43 () S3)
(declare-fun f44 () S14)
(declare-fun f45 () S6)
(declare-fun f46 () S19)
(declare-fun f47 () S9)
(declare-fun f48 () S13)
(declare-fun f49 (S20 Int) Int)
(declare-fun f50 () S20)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 S2)) (=> (= (f4 (f5 f6 (f7 (f8 f9 (f7 (f8 f10 (f11 f12 (f5 f6 f13))) f13)) (f14 (f15 f16 ?v0) f17))) f18) f1) (= f3 f1))))
(assert (exists ((?v0 S2)) (= (f4 (f5 f6 (f7 (f8 f9 (f7 (f8 f10 (f11 f12 (f5 f6 f13))) f13)) (f14 (f15 f16 ?v0) f17))) f18) f1)))
(assert (not (= f17 (f19 f20 0))))
(assert (exists ((?v0 S2)) (= (f4 (f5 f6 (f7 (f8 f9 (f7 (f8 f10 (f11 f12 (f5 f6 f13))) f13)) (f14 (f15 f16 ?v0) f17))) f18) f1)))
(assert (not (= f13 f21)))
(assert (= (f5 f6 (f7 (f8 f10 (f11 f12 (f5 f6 f13))) f13)) f18))
(assert (not (= (f22 f17) f1)))
(assert (= f17 (f19 f20 (+ (* 2 (f23 f24 f25)) 1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 ?v0 ?v1) f1) (= (f4 ?v0 (f26 (f27 f28 (f26 (f27 f29 ?v0) ?v1)) (f26 (f27 f29 f18) f18))) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 ?v0 ?v1) f1) (= (f4 (f26 (f27 f28 (f26 (f27 f29 ?v0) ?v1)) (f26 (f27 f29 f18) f18)) ?v1) f1))))
(assert (= (f11 f12 f18) f30))
(assert (= (f26 f31 f18) f18))
(assert (= (f5 f6 f30) f18))
(assert (= (f26 f32 f18) f18))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f4 (f26 f32 ?v0) ?v1) f1) (=> (= (f4 (f26 f32 ?v2) ?v3) f1) (= (f4 (f26 f32 (f26 (f27 f29 ?v0) ?v2)) (f26 (f27 f29 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S3)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f4 (f5 f6 ?v2) ?v3) f1) (= (f4 (f5 f6 (f7 (f8 f9 ?v0) ?v2)) (f26 (f27 f29 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S9)) (let ((?v_0 (f8 f10 f30))) (= (f7 ?v_0 (f14 (f15 f16 ?v0) ?v1)) (f14 (f15 f16 (f7 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f27 f28 f18))) (= (f26 ?v_0 (f33 (f34 f35 ?v0) ?v1)) (f33 (f34 f35 (f26 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S9)) (=> (< 1 ?v0) (< 1 (f23 (f36 f37 ?v0) (f19 f20 (+ (f23 f24 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S9)) (=> (= (f4 f18 ?v0) f1) (= (f4 f18 (f33 (f34 f35 ?v0) (f19 f20 (+ (f23 f24 ?v1) 1)))) f1))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f38 f39 ?v0) f1) (= (f38 f39 (f40 (f41 f42 ?v0) (f19 f20 (+ (f23 f24 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S9)) (let ((?v_0 (f36 f37 ?v0))) (=> (< 1 ?v0) (= (= (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S9)) (let ((?v_0 (f34 f35 ?v0))) (=> (= (f4 f18 ?v0) f1) (= (= (f33 ?v_0 ?v1) (f33 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f38 f39 ?v0) f1) (= (= (f40 ?v_0 ?v1) (f40 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S9)) (let ((?v_0 (f36 f37 ?v0))) (=> (< 1 ?v0) (= (< (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) (< (f23 f24 ?v1) (f23 f24 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S9)) (let ((?v_0 (f34 f35 ?v0))) (=> (= (f4 f18 ?v0) f1) (= (= (f4 (f33 ?v_0 ?v1) (f33 ?v_0 ?v2)) f1) (< (f23 f24 ?v1) (f23 f24 ?v2)))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f38 f39 ?v0) f1) (= (= (f38 (f40 ?v_0 ?v1) (f40 ?v_0 ?v2)) f1) (< (f23 f24 ?v1) (f23 f24 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S9)) (=> (< 1 ?v0) (=> (< 0 (f23 f24 ?v1)) (< 1 (f23 (f36 f37 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S9)) (=> (= (f4 f18 ?v0) f1) (=> (< 0 (f23 f24 ?v1)) (= (f4 f18 (f33 (f34 f35 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f38 f39 ?v0) f1) (=> (< 0 (f23 f24 ?v1)) (= (f38 f39 (f40 (f41 f42 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S9)) (let ((?v_0 (f36 f37 ?v0))) (=> (< 1 ?v0) (=> (< (f23 ?v_0 ?v1) (f23 ?v_0 ?v2)) (< (f23 f24 ?v1) (f23 f24 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S9)) (let ((?v_0 (f34 f35 ?v0))) (=> (= (f4 f18 ?v0) f1) (=> (= (f4 (f33 ?v_0 ?v1) (f33 ?v_0 ?v2)) f1) (< (f23 f24 ?v1) (f23 f24 ?v2)))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f38 f39 ?v0) f1) (=> (= (f38 (f40 ?v_0 ?v1) (f40 ?v_0 ?v2)) f1) (< (f23 f24 ?v1) (f23 f24 ?v2)))))))
(assert (=> (forall ((?v0 S9)) (=> (= f17 (f19 f20 (+ (* 2 (f23 f24 ?v0)) 1))) false)) false))
(assert (exists ((?v0 S9)) (= f17 (f19 f20 (+ (* 2 (f23 f24 ?v0)) 1)))))
(assert (= (f11 f12 f43) f21))
(assert (= (f26 f31 f43) f43))
(assert (= (f11 f12 f43) f21))
(assert (= (f26 f31 f43) f43))
(assert (= (f26 f32 f43) f43))
(assert (= (f5 f6 f21) f43))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f11 f12 (f26 (f27 f44 ?v0) ?v1)) (f7 (f8 f45 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f26 f31 (f26 (f27 f44 ?v0) ?v1)) (f26 (f27 f44 (f26 f31 ?v0)) (f26 f31 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f26 f32 (f26 (f27 f44 ?v0) ?v1)) (f26 (f27 f44 (f26 f32 ?v0)) (f26 f32 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 f6 (f7 (f8 f45 ?v0) ?v1)) (f26 (f27 f44 (f5 f6 ?v0)) (f5 f6 ?v1)))))
(assert (forall ((?v0 S3)) (= (f26 (f27 f44 f43) ?v0) f43)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f45 f21) ?v0) f21)))
(assert (forall ((?v0 S3)) (= (f26 (f27 f44 f43) ?v0) f43)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f45 f21) ?v0) f21)))
(assert (forall ((?v0 S3)) (= (f26 (f27 f44 ?v0) f43) f43)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f45 ?v0) f21) f21)))
(assert (forall ((?v0 S3)) (= (f26 (f27 f44 ?v0) f43) f43)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f45 ?v0) f21) f21)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= ?v0 (f26 (f27 f28 ?v1) ?v2)) (ite (not (= ?v2 f43)) (= (f26 (f27 f44 ?v0) ?v2) ?v1) (= ?v0 f43)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= ?v0 (f7 (f8 f10 ?v1) ?v2)) (ite (not (= ?v2 f21)) (= (f7 (f8 f45 ?v0) ?v2) ?v1) (= ?v0 f21)))))
(assert (forall ((?v0 S3)) (= (= (f11 f12 ?v0) f21) (= ?v0 f43))))
(assert (forall ((?v0 S3)) (= (= (f26 f31 ?v0) f43) (= ?v0 f43))))
(assert (forall ((?v0 S3)) (= (= (f26 f32 ?v0) f43) (= ?v0 f43))))
(assert (forall ((?v0 S2)) (= (= (f5 f6 ?v0) f43) (= ?v0 f21))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f26 (f27 f28 ?v0) ?v1) ?v2) (ite (not (= ?v1 f43)) (= ?v0 (f26 (f27 f44 ?v2) ?v1)) (= ?v2 f43)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f7 (f8 f10 ?v0) ?v1) ?v2) (ite (not (= ?v1 f21)) (= ?v0 (f7 (f8 f45 ?v2) ?v1)) (= ?v2 f21)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (= (f26 (f27 f28 (f26 (f27 f44 ?v1) ?v0)) (f26 (f27 f44 ?v2) ?v0)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (= (f7 (f8 f10 (f7 (f8 f45 ?v1) ?v0)) (f7 (f8 f45 ?v2) ?v0)) (f7 (f8 f10 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (=> (not (= ?v0 f43)) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2)) (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f45 ?v0))) (=> (not (= ?v0 f21)) (= (f7 (f8 f10 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) (f7 (f8 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f43)) (=> (not (= ?v1 f43)) (= (= (f26 (f27 f28 ?v2) ?v0) (f26 (f27 f28 ?v3) ?v1)) (= (f26 (f27 f44 ?v2) ?v1) (f26 (f27 f44 ?v3) ?v0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (= (= (f7 (f8 f10 ?v2) ?v0) (f7 (f8 f10 ?v3) ?v1)) (= (f7 (f8 f45 ?v2) ?v1) (f7 (f8 f45 ?v3) ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f26 (f27 f44 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v2)) (f26 (f27 f44 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f7 (f8 f45 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f7 (f8 f45 ?v0) ?v2)) (f7 (f8 f45 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f26 (f27 f44 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v2)) (f26 (f27 f44 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f7 (f8 f45 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f7 (f8 f45 ?v0) ?v2)) (f7 (f8 f45 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 ?v_0 (f26 (f27 f29 ?v1) ?v2)) (f26 (f27 f29 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f45 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 ?v_0 (f26 (f27 f29 ?v1) ?v2)) (f26 (f27 f29 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f45 ?v0))) (= (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2)) (f7 (f8 f9 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f40 (f41 f42 (f40 (f41 f46 ?v0) ?v1)) ?v2) (f40 (f41 f46 (f40 (f41 f42 ?v0) ?v2)) (f40 (f41 f42 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S9)) (= (f33 (f34 f35 (f26 (f27 f44 ?v0) ?v1)) ?v2) (f26 (f27 f44 (f33 (f34 f35 ?v0) ?v2)) (f33 (f34 f35 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S9)) (= (f14 (f15 f16 (f7 (f8 f45 ?v0) ?v1)) ?v2) (f7 (f8 f45 (f14 (f15 f16 ?v0) ?v2)) (f14 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9)) (= (f23 (f36 f37 (* ?v0 ?v1)) ?v2) (* (f23 (f36 f37 ?v0) ?v2) (f23 (f36 f37 ?v1) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f40 (f41 f42 ?v0) ?v1))) (= (f40 (f41 f46 ?v_0) ?v0) (f40 (f41 f46 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f33 (f34 f35 ?v0) ?v1))) (= (f26 (f27 f44 ?v_0) ?v0) (f26 (f27 f44 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S9)) (let ((?v_0 (f14 (f15 f16 ?v0) ?v1))) (= (f7 (f8 f45 ?v_0) ?v0) (f7 (f8 f45 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (f23 (f36 f37 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f19 f20 (+ (f23 f24 ?v1) (f23 f24 ?v2)))) (f40 (f41 f46 (f40 ?v_0 ?v1)) (f40 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S9)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f19 f20 (+ (f23 f24 ?v1) (f23 f24 ?v2)))) (f26 (f27 f44 (f33 ?v_0 ?v1)) (f33 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S9) (?v2 S9)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f19 f20 (+ (f23 f24 ?v1) (f23 f24 ?v2)))) (f7 (f8 f45 (f14 ?v_0 ?v1)) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S9)) (let ((?v_0 (f36 f37 ?v0))) (= (f23 ?v_0 (f19 f20 (+ (f23 f24 ?v1) (f23 f24 ?v2)))) (* (f23 ?v_0 ?v1) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f19 f20 (+ (f23 f24 ?v1) 1))) (f40 (f41 f46 (f40 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f19 f20 (+ (f23 f24 ?v1) 1))) (f26 (f27 f44 (f33 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S9)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f19 f20 (+ (f23 f24 ?v1) 1))) (f7 (f8 f45 (f14 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (f36 f37 ?v0))) (= (f23 ?v_0 (f19 f20 (+ (f23 f24 ?v1) 1))) (* (f23 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f19 f20 (+ (f23 f24 ?v1) 1))) (f40 (f41 f46 ?v0) (f40 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f19 f20 (+ (f23 f24 ?v1) 1))) (f26 (f27 f44 ?v0) (f33 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S9)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f19 f20 (+ (f23 f24 ?v1) 1))) (f7 (f8 f45 ?v0) (f14 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (f36 f37 ?v0))) (= (f23 ?v_0 (f19 f20 (+ (f23 f24 ?v1) 1))) (* ?v0 (f23 ?v_0 ?v1))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f19 f20 (* (f23 f24 ?v1) (f23 f24 ?v2)))) (f40 (f41 f42 (f40 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S9)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f19 f20 (* (f23 f24 ?v1) (f23 f24 ?v2)))) (f33 (f34 f35 (f33 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S9) (?v2 S9)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f19 f20 (* (f23 f24 ?v1) (f23 f24 ?v2)))) (f14 (f15 f16 (f14 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f26 (f27 f44 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 ?v2) ?v3)) (f26 (f27 f28 (f26 (f27 f44 ?v0) ?v2)) (f26 (f27 f44 ?v1) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f7 (f8 f45 (f7 (f8 f10 ?v0) ?v1)) (f7 (f8 f10 ?v2) ?v3)) (f7 (f8 f10 (f7 (f8 f45 ?v0) ?v2)) (f7 (f8 f45 ?v1) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S9)) (=> (not (= ?v0 f43)) (not (= (f33 (f34 f35 ?v0) ?v1) f43)))))
(assert (forall ((?v0 S2) (?v1 S9)) (=> (not (= ?v0 f21)) (not (= (f14 (f15 f16 ?v0) ?v1) f21)))))
(assert (forall ((?v0 Int) (?v1 S9)) (=> (not (= ?v0 0)) (not (= (f23 (f36 f37 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S9)) (= (= (f33 (f34 f35 ?v0) ?v1) f43) (and (= ?v0 f43) (not (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 S2) (?v1 S9)) (= (= (f14 (f15 f16 ?v0) ?v1) f21) (and (= ?v0 f21) (not (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f23 (f36 f37 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f40 (f41 f42 ?v0) ?v1) f47) (and (= ?v0 f47) (not (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 S9)) (= (f33 (f34 f35 f43) (f19 f20 (+ (f23 f24 ?v0) 1))) f43)))
(assert (forall ((?v0 S9)) (= (f14 (f15 f16 f21) (f19 f20 (+ (f23 f24 ?v0) 1))) f21)))
(assert (forall ((?v0 S9)) (= (f23 (f36 f37 0) (f19 f20 (+ (f23 f24 ?v0) 1))) 0)))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 f47) (f19 f20 (+ (f23 f24 ?v0) 1))) f47)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f43)) (= (f26 f48 (f26 (f27 f28 ?v1) ?v0)) (f26 (f27 f28 (f26 f48 ?v1)) (f26 f48 ?v0))))))
(assert (forall ((?v0 S3)) (= (f26 (f27 f28 f43) ?v0) f43)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f10 f21) ?v0) f21)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f28 ?v2))) (=> (= (f4 ?v0 ?v1) f1) (=> (= (f4 ?v2 f43) f1) (=> (= (f4 f43 (f26 (f27 f44 ?v0) ?v1)) f1) (= (f4 (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f28 ?v2))) (=> (= (f4 ?v0 ?v1) f1) (=> (= (f4 f43 ?v2) f1) (=> (= (f4 f43 (f26 (f27 f44 ?v1) ?v0)) f1) (= (f4 (f26 ?v_0 ?v1) (f26 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 ?v0 f43) f1) (= (= (f4 (f26 (f27 f28 ?v1) ?v0) ?v2) f1) (= (f4 (f26 (f27 f44 ?v2) ?v0) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 ?v0 f43) f1) (= (= (f4 ?v1 (f26 (f27 f28 ?v2) ?v0)) f1) (= (f4 ?v2 (f26 (f27 f44 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 (f26 (f27 f44 ?v1) ?v0) ?v2) f1) (= (f4 ?v1 (f26 (f27 f28 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 ?v1 (f26 (f27 f44 ?v2) ?v0)) f1) (= (f4 (f26 (f27 f28 ?v1) ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 f43 ?v0) f1) (= (= (f4 (f26 (f27 f28 ?v1) ?v0) ?v2) f1) (= (f4 ?v1 (f26 (f27 f44 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 f43 ?v0) f1) (= (= (f4 ?v1 (f26 (f27 f28 ?v2) ?v0)) f1) (= (f4 (f26 (f27 f44 ?v1) ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 (f27 f44 ?v2) ?v1))) (= (= (f4 (f26 (f27 f28 ?v0) ?v1) ?v2) f1) (ite (= (f4 f43 ?v1) f1) (= (f4 ?v0 ?v_0) f1) (ite (= (f4 ?v1 f43) f1) (= (f4 ?v_0 ?v0) f1) (= (f4 f43 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 (f27 f44 ?v0) ?v2))) (= (= (f4 ?v0 (f26 (f27 f28 ?v1) ?v2)) f1) (ite (= (f4 f43 ?v2) f1) (= (f4 ?v_0 ?v1) f1) (ite (= (f4 ?v2 f43) f1) (= (f4 ?v1 ?v_0) f1) (= (f4 ?v0 f43) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f43)) (=> (not (= ?v1 f43)) (= (f26 (f27 f29 (f26 (f27 f28 ?v2) ?v0)) (f26 (f27 f28 ?v3) ?v1)) (f26 (f27 f28 (f26 (f27 f29 (f26 (f27 f44 ?v2) ?v1)) (f26 (f27 f44 ?v3) ?v0))) (f26 (f27 f44 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (= (f7 (f8 f9 (f7 (f8 f10 ?v2) ?v0)) (f7 (f8 f10 ?v3) ?v1)) (f7 (f8 f10 (f7 (f8 f9 (f7 (f8 f45 ?v2) ?v1)) (f7 (f8 f45 ?v3) ?v0))) (f7 (f8 f45 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (= (f26 (f27 f29 (f26 (f27 f28 ?v1) ?v0)) ?v2) (f26 (f27 f28 (f26 (f27 f29 ?v1) (f26 (f27 f44 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (= (f7 (f8 f9 (f7 (f8 f10 ?v1) ?v0)) ?v2) (f7 (f8 f10 (f7 (f8 f9 ?v1) (f7 (f8 f45 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (= (f26 (f27 f29 (f26 (f27 f28 ?v1) ?v0)) ?v2) (f26 (f27 f28 (f26 (f27 f29 ?v1) (f26 (f27 f44 ?v2) ?v0))) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (= (f7 (f8 f9 (f7 (f8 f10 ?v1) ?v0)) ?v2) (f7 (f8 f10 (f7 (f8 f9 ?v1) (f7 (f8 f45 ?v2) ?v0))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (= (f26 (f27 f29 ?v1) (f26 (f27 f28 ?v2) ?v0)) (f26 (f27 f28 (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (= (f7 (f8 f9 ?v1) (f7 (f8 f10 ?v2) ?v0)) (f7 (f8 f10 (f7 (f8 f9 (f7 (f8 f45 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (= (f26 (f27 f29 ?v1) (f26 (f27 f28 ?v2) ?v0)) (f26 (f27 f28 (f26 (f27 f29 ?v2) (f26 (f27 f44 ?v1) ?v0))) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (= (f7 (f8 f9 ?v1) (f7 (f8 f10 ?v2) ?v0)) (f7 (f8 f10 (f7 (f8 f9 ?v2) (f7 (f8 f45 ?v1) ?v0))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f4 (f26 f32 ?v0) ?v1) f1) (=> (= (f4 (f26 f32 ?v2) ?v3) f1) (= (f4 (f26 f32 (f26 (f27 f44 ?v0) ?v2)) (f26 (f27 f44 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2) (?v3 S3)) (=> (= (f4 (f5 f6 ?v0) ?v1) f1) (=> (= (f4 (f5 f6 ?v2) ?v3) f1) (= (f4 (f5 f6 (f7 (f8 f45 ?v0) ?v2)) (f26 (f27 f44 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3)) (= (= (f4 f43 (f26 f32 ?v0)) f1) (not (= ?v0 f43)))))
(assert (forall ((?v0 S2)) (= (= (f4 f43 (f5 f6 ?v0)) f1) (not (= ?v0 f21)))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (f23 (f36 f37 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f33 (f34 f35 ?v0) ?v1))) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 ?v0 f18) f1) (= (f4 (f26 (f27 f44 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f40 (f41 f42 ?v0) ?v1))) (=> (= (f38 f47 ?v0) f1) (=> (= (f38 ?v0 f39) f1) (= (f38 (f40 (f41 f46 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S3) (?v1 S9)) (=> (= (f4 f43 ?v0) f1) (= (f4 f43 (f33 (f34 f35 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S9)) (=> (< 0 ?v0) (< 0 (f23 (f36 f37 ?v0) ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f38 f47 ?v0) f1) (= (f38 f47 (f40 (f41 f42 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 ?v0 ?v1) f1) (=> (= (f4 ?v2 f43) f1) (= (f4 (f26 (f27 f28 ?v1) ?v2) (f26 (f27 f28 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 ?v0 ?v1) f1) (=> (= (f4 f43 ?v2) f1) (= (f4 (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 ?v0 f43) f1) (=> (= (f4 ?v1 f43) f1) (= (f4 f43 (f26 (f27 f28 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 ?v0 f43) f1) (=> (= (f4 f43 ?v1) f1) (= (f4 (f26 (f27 f28 ?v0) ?v1) f43) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 ?v1 f43) f1) (= (f4 (f26 (f27 f28 ?v0) ?v1) f43) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 f43 ?v1) f1) (= (f4 f43 (f26 (f27 f28 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f43 ?v0) f1) (= (f26 (f27 f28 (f26 f48 ?v1)) ?v0) (f26 f48 (f26 (f27 f28 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f4 (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) f1) (and (=> (= (f4 f43 ?v1) f1) (= (f4 ?v0 ?v2) f1)) (and (=> (= (f4 ?v1 f43) f1) (= (f4 ?v2 ?v0) f1)) (not (= ?v1 f43)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f4 (f26 (f27 f28 ?v0) ?v1) f43) f1) (or (and (= (f4 f43 ?v0) f1) (= (f4 ?v1 f43) f1)) (and (= (f4 ?v0 f43) f1) (= (f4 f43 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f4 f43 (f26 (f27 f28 ?v0) ?v1)) f1) (or (and (= (f4 f43 ?v0) f1) (= (f4 f43 ?v1) f1)) (and (= (f4 ?v0 f43) f1) (= (f4 ?v1 f43) f1))))))
(assert (forall ((?v0 S9)) (= (f14 (f15 f16 f21) ?v0) (ite (= ?v0 (f19 f20 0)) f30 f21))))
(assert (forall ((?v0 S9)) (= (f23 (f36 f37 0) ?v0) (ite (= ?v0 (f19 f20 0)) 1 0))))
(assert (forall ((?v0 S9)) (= (f33 (f34 f35 f43) ?v0) (ite (= ?v0 (f19 f20 0)) f18 f43))))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 f47) ?v0) (ite (= ?v0 (f19 f20 0)) f39 f47))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S9)) (let ((?v_0 (f23 f24 ?v2)) (?v_1 (f23 f24 ?v1)) (?v_2 (f34 f35 ?v0))) (=> (not (= ?v0 f43)) (=> (<= ?v_1 ?v_0) (= (f33 ?v_2 (f19 f20 (- ?v_0 ?v_1))) (f26 (f27 f28 (f33 ?v_2 ?v2)) (f33 ?v_2 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S9) (?v2 S9)) (let ((?v_0 (f23 f24 ?v2)) (?v_1 (f23 f24 ?v1)) (?v_2 (f15 f16 ?v0))) (=> (not (= ?v0 f21)) (=> (<= ?v_1 ?v_0) (= (f14 ?v_2 (f19 f20 (- ?v_0 ?v_1))) (f7 (f8 f10 (f14 ?v_2 ?v2)) (f14 ?v_2 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S9)) (=> (not (= ?v0 f43)) (= (f33 (f34 f35 (f26 (f27 f28 ?v1) ?v0)) ?v2) (f26 (f27 f28 (f33 (f34 f35 ?v1) ?v2)) (f33 (f34 f35 ?v0) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S9)) (=> (not (= ?v0 f21)) (= (f14 (f15 f16 (f7 (f8 f10 ?v1) ?v0)) ?v2) (f7 (f8 f10 (f14 (f15 f16 ?v1) ?v2)) (f14 (f15 f16 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f43)) (= (f26 f32 (f26 (f27 f28 ?v1) ?v0)) (f26 (f27 f28 (f26 f32 ?v1)) (f26 f32 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f21)) (= (f5 f6 (f7 (f8 f10 ?v1) ?v0)) (f26 (f27 f28 (f5 f6 ?v1)) (f5 f6 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (f23 (f36 f37 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (* ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f33 (f34 f35 ?v0) ?v1))) (=> (= (f4 f18 ?v0) f1) (= (f4 ?v_0 (f26 (f27 f44 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f40 (f41 f42 ?v0) ?v1))) (=> (= (f38 f39 ?v0) f1) (= (f38 ?v_0 (f40 (f41 f46 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S9)) (=> (< 1 ?v0) (< 1 (* ?v0 (f23 (f36 f37 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S9)) (=> (= (f4 f18 ?v0) f1) (= (f4 f18 (f26 (f27 f44 ?v0) (f33 (f34 f35 ?v0) ?v1))) f1))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f38 f39 ?v0) f1) (= (f38 f39 (f40 (f41 f46 ?v0) (f40 (f41 f42 ?v0) ?v1))) f1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 Int)) (let ((?v_0 (f36 f37 ?v2))) (=> (< (f23 f24 ?v0) (f23 f24 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f23 ?v_0 ?v1) (f23 ?v_0 ?v0))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S3)) (let ((?v_0 (f34 f35 ?v2))) (=> (< (f23 f24 ?v0) (f23 f24 ?v1)) (=> (= (f4 f43 ?v2) f1) (=> (= (f4 ?v2 f18) f1) (= (f4 (f33 ?v_0 ?v1) (f33 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f41 f42 ?v2))) (=> (< (f23 f24 ?v0) (f23 f24 ?v1)) (=> (= (f38 f47 ?v2) f1) (=> (= (f38 ?v2 f39) f1) (= (f38 (f40 ?v_0 ?v1) (f40 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S9)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f23 (f36 f37 ?v0) (f19 f20 (+ (f23 f24 ?v1) 1))) 1)))))
(assert (forall ((?v0 S3) (?v1 S9)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 ?v0 f18) f1) (= (f4 (f33 (f34 f35 ?v0) (f19 f20 (+ (f23 f24 ?v1) 1))) f18) f1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f38 f47 ?v0) f1) (=> (= (f38 ?v0 f39) f1) (= (f38 (f40 (f41 f42 ?v0) (f19 f20 (+ (f23 f24 ?v1) 1))) f39) f1)))))
(assert (forall ((?v0 S3) (?v1 S9)) (= (f14 (f15 f16 (f11 f12 ?v0)) ?v1) (f11 f12 (f33 (f34 f35 ?v0) ?v1)))))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f33 (f34 f35 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f14 (f15 f16 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S9)) (= (f26 f48 (f33 (f34 f35 ?v0) ?v1)) (f33 (f34 f35 (f26 f48 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f26 f48 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f48 ?v0)) (f26 f48 ?v1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f26 f48 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f11 f12 ?v0) (f11 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2)) (= (f14 (f15 f16 ?v0) (f19 f20 0)) f30)))
(assert (forall ((?v0 Int)) (= (f23 (f36 f37 ?v0) (f19 f20 0)) 1)))
(assert (forall ((?v0 S3)) (= (f33 (f34 f35 ?v0) (f19 f20 0)) f18)))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 ?v0) (f19 f20 0)) f39)))
(assert (forall ((?v0 S9)) (= (f14 (f15 f16 f30) ?v0) f30)))
(assert (forall ((?v0 S9)) (= (f23 (f36 f37 1) ?v0) 1)))
(assert (forall ((?v0 S9)) (= (f33 (f34 f35 f18) ?v0) f18)))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 f39) ?v0) f39)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f26 (f27 f28 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f7 (f8 f10 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f7 (f8 f10 ?v0) ?v2)) (f7 (f8 f10 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S9)) (= (f33 (f34 f35 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f28 (f33 (f34 f35 ?v0) ?v2)) (f33 (f34 f35 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S9)) (= (f14 (f15 f16 (f7 (f8 f10 ?v0) ?v1)) ?v2) (f7 (f8 f10 (f14 (f15 f16 ?v0) ?v2)) (f14 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S9)) (= (f26 f32 (f33 (f34 f35 ?v0) ?v1)) (f33 (f34 f35 (f26 f32 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S9)) (= (f5 f6 (f14 (f15 f16 ?v0) ?v1)) (f33 (f34 f35 (f5 f6 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 f6 (f7 (f8 f10 ?v0) ?v1)) (f26 (f27 f28 (f5 f6 ?v0)) (f5 f6 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f26 f32 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f32 ?v0)) (f26 f32 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f11 f12 (f26 (f27 f29 ?v0) ?v1)) (f7 (f8 f9 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f26 f31 (f26 (f27 f29 ?v0) ?v1)) (f26 (f27 f29 (f26 f31 ?v0)) (f26 f31 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f11 f12 (f26 (f27 f29 ?v0) ?v1)) (f7 (f8 f9 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f26 f31 (f26 (f27 f29 ?v0) ?v1)) (f26 (f27 f29 (f26 f31 ?v0)) (f26 f31 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S9)) (= (f11 f12 (f33 (f34 f35 ?v0) ?v1)) (f14 (f15 f16 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S9)) (= (f26 f31 (f33 (f34 f35 ?v0) ?v1)) (f33 (f34 f35 (f26 f31 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f11 f12 (f26 (f27 f28 ?v0) ?v1)) (f7 (f8 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f26 f31 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f31 ?v0)) (f26 f31 ?v1)))))
(assert (forall ((?v0 S3)) (= (f5 f6 (f11 f12 ?v0)) (f26 f48 ?v0))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 Int)) (let ((?v_0 (f36 f37 ?v2))) (=> (< (f23 f24 ?v0) (f23 f24 ?v1)) (=> (< 1 ?v2) (< (f23 ?v_0 ?v0) (f23 ?v_0 ?v1)))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S3)) (let ((?v_0 (f34 f35 ?v2))) (=> (< (f23 f24 ?v0) (f23 f24 ?v1)) (=> (= (f4 f18 ?v2) f1) (= (f4 (f33 ?v_0 ?v0) (f33 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f41 f42 ?v2))) (=> (< (f23 f24 ?v0) (f23 f24 ?v1)) (=> (= (f38 f39 ?v2) f1) (= (f38 (f40 ?v_0 ?v0) (f40 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S9)) (=> (< (f23 f24 ?v0) (f23 f24 f17)) (=> (not (= ?v0 (f19 f20 0))) (exists ((?v1 S2)) (= (f4 (f5 f6 (f7 (f8 f9 f30) (f7 (f8 f45 f13) (f14 (f15 f16 ?v1) ?v0)))) f18) f1))))))
(assert (=> (= (f22 f17) f1) (exists ((?v0 S2)) (= (f4 (f5 f6 (f7 (f8 f9 f30) (f7 (f8 f45 f13) (f14 (f15 f16 ?v0) f17)))) f18) f1))))
(assert (forall ((?v0 S3) (?v1 S9)) (= (= (f4 (f33 (f34 f35 ?v0) ?v1) f43) f1) (and (not (= (f22 ?v1) f1)) (= (f4 ?v0 f43) f1)))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (< (f23 (f36 f37 ?v0) ?v1) 0) (and (not (= (f22 ?v1) f1)) (< ?v0 0)))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (= (f22 ?v1) f1))) (= (= (f4 f43 (f33 (f34 f35 ?v0) ?v1)) f1) (or (= ?v1 (f19 f20 0)) (or (and ?v_0 (not (= ?v0 f43))) (and (not ?v_0) (= (f4 f43 ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (= (f22 ?v1) f1))) (= (< 0 (f23 (f36 f37 ?v0) ?v1)) (or (= ?v1 (f19 f20 0)) (or (and ?v_0 (not (= ?v0 0))) (and (not ?v_0) (< 0 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 S9)) (=> (= (f4 ?v0 f43) f1) (= (f4 (f33 (f34 f35 ?v0) (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) f43) f1))))
(assert (forall ((?v0 Int) (?v1 S9)) (=> (< ?v0 0) (< (f23 (f36 f37 ?v0) (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f19 f20 2))) (= (= (f4 f43 (f26 (f27 f29 (f33 (f34 f35 ?v0) ?v_0)) (f33 (f34 f35 ?v1) ?v_0))) f1) (or (not (= ?v0 f43)) (not (= ?v1 f43)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (< 0 (+ (f23 (f36 f37 ?v0) ?v_0) (f23 (f36 f37 ?v1) ?v_0))) (or (not (= ?v0 0)) (not (= ?v1 0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f19 f20 2))) (not (= (f4 (f26 (f27 f29 (f33 (f34 f35 ?v0) ?v_0)) (f33 (f34 f35 ?v1) ?v_0)) f43) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (not (< (+ (f23 (f36 f37 ?v0) ?v_0) (f23 (f36 f37 ?v1) ?v_0)) 0)))))
(assert (< 0 (+ 1 1)))
(assert (= (f4 f43 (f26 (f27 f29 f18) f18)) f1))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f4 f43 (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v0)) (f26 (f27 f44 ?v1) ?v1))) f1) (or (not (= ?v0 f43)) (not (= ?v1 f43))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< 0 (+ (* ?v0 ?v0) (* ?v1 ?v1))) (or (not (= ?v0 0)) (not (= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (not (= (f4 (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v0)) (f26 (f27 f44 ?v1) ?v1)) f43) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (not (< (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0))))
(assert (forall ((?v0 S2)) (not (= (f4 (f5 f6 ?v0) f43) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f43)) (= (f11 f12 (f26 (f27 f28 ?v1) ?v0)) (f7 (f8 f10 (f11 f12 ?v1)) (f11 f12 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f43)) (= (f26 f31 (f26 (f27 f28 ?v1) ?v0)) (f26 (f27 f28 (f26 f31 ?v1)) (f26 f31 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f4 ?v0 ?v1) f1) false) (=> (=> (= (f4 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f26 f48 ?v0))) (= (f26 (f27 f44 ?v_0) ?v_0) (f26 (f27 f44 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f49 f50 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f26 f48 (f26 (f27 f44 ?v0) ?v1)) (f26 (f27 f44 (f26 f48 ?v0)) (f26 f48 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f49 f50 (* ?v0 ?v1)) (* (f49 f50 ?v0) (f49 f50 ?v1)))))
(assert (= (f26 f48 f18) f18))
(assert (= (f49 f50 1) 1))
(assert (forall ((?v0 S3)) (let ((?v_0 (f33 (f34 f35 ?v0) (f19 f20 2)))) (= (f26 f48 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f19 f20 2))) (= (f33 (f34 f35 (f26 f48 ?v0)) ?v_0) (f33 (f34 f35 ?v0) ?v_0)))))
(assert (forall ((?v0 S9)) (let ((?v_0 (f23 f24 ?v0))) (= (f19 f20 (* 2 ?v_0)) (f19 f20 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S9)) (let ((?v_0 (f23 f24 ?v0))) (= (f19 f20 (* ?v_0 2)) (f19 f20 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f19 f20 0)) (?v_2 (f23 f24 ?v0)) (?v_1 (f23 f24 ?v1))) (= (f19 f20 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f19 f20 (+ ?v_1 (* (f23 f24 (f19 f20 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) (f19 f20 1) (f19 f20 (* (f23 f24 ?v0) (f23 f24 (f40 ?v_0 (f19 f20 (- (f23 f24 ?v1) 1)))))))))))
(assert (forall ((?v0 S9)) (let ((?v_0 (f23 f24 ?v0))) (=> (< 0 ?v_0) (= (= (f22 ?v0) f1) (not (= (f22 (f19 f20 (- ?v_0 1))) f1)))))))
(assert (forall ((?v0 S9)) (=> (not (= (f22 ?v0) f1)) (< 0 (f23 f24 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (= (f22 ?v0) f1)) (?v_1 (= (f22 ?v1) f1))) (= (= (f22 (f19 f20 (+ (f23 f24 ?v0) (f23 f24 ?v1)))) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_1 (f23 f24 ?v1)) (?v_0 (f23 f24 ?v0)) (?v_2 (= (f22 ?v0) f1)) (?v_3 (= (f22 ?v1) f1))) (= (= (f22 (f19 f20 (- ?v_0 ?v_1))) f1) (or (< ?v_0 ?v_1) (or (and ?v_2 ?v_3) (and (not ?v_2) (not ?v_3))))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f22 (f40 (f41 f42 ?v0) ?v1)) f1) (and (= (f22 ?v0) f1) (< 0 (f23 f24 ?v1))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f22 (f19 f20 (+ (f23 f24 ?v0) (f23 f24 ?v1)))) f1) (= (= (f22 ?v0) f1) (= (f22 ?v1) f1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (not (= (f22 (f19 f20 (+ (f23 f24 ?v0) (f23 f24 ?v1)))) f1)) (not (= (not (= (f22 ?v0) f1)) (not (= (f22 ?v1) f1)))))))
(assert (forall ((?v0 S9)) (= (= (f22 (f19 f20 (+ (f23 f24 ?v0) 1))) f1) (not (= (f22 ?v0) f1)))))
(assert (not (= (f22 (f19 f20 1)) f1)))
(assert (= (f22 (f19 f20 0)) f1))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f26 (f27 f44 ?v0) ?v1) f43) (or (= ?v0 f43) (= ?v1 f43)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f7 (f8 f45 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f43)) (=> (not (= ?v1 f43)) (not (= (f26 (f27 f44 ?v0) ?v1) f43))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f21)) (=> (not (= ?v1 f21)) (not (= (f7 (f8 f45 ?v0) ?v1) f21))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f26 (f27 f44 ?v0) ?v1) f43) (or (= ?v0 f43) (= ?v1 f43)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f7 (f8 f45 ?v0) ?v1) f21) (or (= ?v0 f21) (= ?v1 f21)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3)) (= (f26 (f27 f44 ?v0) f43) f43)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f45 ?v0) f21) f21)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f26 (f27 f44 f43) ?v0) f43)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f45 f21) ?v0) f21)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f26 f48 ?v0)) (?v_1 (f26 f48 ?v2))) (=> (= (f4 ?v_0 ?v1) f1) (=> (= (f4 ?v_1 ?v3) f1) (= (f4 (f26 (f27 f44 ?v_0) ?v_1) (f26 (f27 f44 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f49 f50 ?v0)) (?v_1 (f49 f50 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (not (= f30 f21)))
(assert (not (= 1 0)))
(assert (not (= f18 f43)))
(assert (not (= f21 f30)))
(assert (not (= 0 1)))
(assert (not (= f43 f18)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f26 (f27 f44 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v2)) (f26 (f27 f44 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f7 (f8 f45 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f7 (f8 f45 ?v0) ?v2)) (f7 (f8 f45 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v1)) (f26 (f27 f29 (f26 (f27 f44 ?v2) ?v1)) ?v3)) (f26 (f27 f29 (f26 (f27 f44 (f26 (f27 f29 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f7 (f8 f9 (f7 (f8 f45 ?v0) ?v1)) (f7 (f8 f9 (f7 (f8 f45 ?v2) ?v1)) ?v3)) (f7 (f8 f9 (f7 (f8 f45 (f7 (f8 f9 ?v0) ?v2)) ?v1)) ?v3))))
(assert (= (f33 (f34 f35 f43) (f19 f20 2)) f43))
(assert (= (f14 (f15 f16 f21) (f19 f20 2)) f21))
(assert (= (f23 (f36 f37 0) (f19 f20 2)) 0))
(assert (= (f40 (f41 f42 f47) (f19 f20 2)) f47))
(assert (forall ((?v0 S3)) (= (= (f33 (f34 f35 ?v0) (f19 f20 2)) f43) (= ?v0 f43))))
(assert (forall ((?v0 S2)) (= (= (f14 (f15 f16 ?v0) (f19 f20 2)) f21) (= ?v0 f21))))
(assert (forall ((?v0 Int)) (= (= (f23 (f36 f37 ?v0) (f19 f20 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (f26 (f27 f28 f43) ?v0) f43)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f10 f21) ?v0) f21)))
(assert (forall ((?v0 S3)) (= (f26 (f27 f28 ?v0) f43) f43)))
(assert (forall ((?v0 S2)) (= (f7 (f8 f10 ?v0) f21) f21)))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 ?v0) (f19 f20 2)) (f40 (f41 f46 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f33 (f34 f35 ?v0) (f19 f20 2)) (f26 (f27 f44 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f14 (f15 f16 ?v0) (f19 f20 2)) (f7 (f8 f45 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f23 (f36 f37 ?v0) (f19 f20 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S9)) (= (f40 (f41 f42 ?v0) (f19 f20 3)) (f40 (f41 f46 (f40 (f41 f46 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f33 (f34 f35 ?v0) (f19 f20 3)) (f26 (f27 f44 (f26 (f27 f44 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f14 (f15 f16 ?v0) (f19 f20 3)) (f7 (f8 f45 (f7 (f8 f45 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f23 (f36 f37 ?v0) (f19 f20 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2)) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f45 ?v0))) (= (f7 ?v_0 (f7 (f8 f10 ?v1) ?v2)) (f7 (f8 f10 (f7 ?v_0 ?v1)) ?v2)))))
(assert (= (f14 (f15 f16 f30) (f19 f20 2)) f30))
(assert (= (f23 (f36 f37 1) (f19 f20 2)) 1))
(assert (= (f33 (f34 f35 f18) (f19 f20 2)) f18))
(assert (= (f40 (f41 f42 f39) (f19 f20 2)) f39))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f26 (f27 f28 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f7 (f8 f10 (f7 (f8 f9 ?v0) ?v1)) ?v2) (f7 (f8 f9 (f7 (f8 f10 ?v0) ?v2)) (f7 (f8 f10 ?v1) ?v2)))))
(assert (forall ((?v0 S2)) (= (f7 (f8 f10 ?v0) f30) ?v0)))
(assert (forall ((?v0 S3)) (= (f26 (f27 f28 ?v0) f18) ?v0)))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f19 f20 (* 2 (f23 f24 ?v1)))) (f40 (f41 f42 (f40 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f19 f20 (* 2 (f23 f24 ?v1)))) (f33 (f34 f35 (f33 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 S2) (?v1 S9)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f19 f20 (* 2 (f23 f24 ?v1)))) (f14 (f15 f16 (f14 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 S9) (?v1 S3)) (=> (= (f22 ?v0) f1) (= (f33 (f34 f35 (f26 f48 ?v1)) ?v0) (f33 (f34 f35 ?v1) ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= (f22 (f19 f20 (* (f23 f24 ?v0) (f23 f24 ?v1)))) f1) (or (= (f22 ?v0) f1) (= (f22 ?v1) f1)))))
(assert (forall ((?v0 S9)) (= (not (= (f22 ?v0) f1)) (exists ((?v1 S9)) (= ?v0 (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1)))))))
(assert (forall ((?v0 S9)) (= (not (= (f22 ?v0) f1)) (exists ((?v1 S9)) (= ?v0 (f19 f20 (+ (* (+ (+ 0 1) 1) (f23 f24 ?v1)) 1)))))))
(assert (forall ((?v0 S9)) (= (= (f22 ?v0) f1) (exists ((?v1 S9)) (= ?v0 (f19 f20 (* 2 (f23 f24 ?v1))))))))
(assert (forall ((?v0 S9)) (= (= (f22 ?v0) f1) (exists ((?v1 S9)) (= ?v0 (f19 f20 (* (+ (+ 0 1) 1) (f23 f24 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v2))) (=> (= (f4 ?v0 ?v1) f1) (=> (= (f4 ?v2 f43) f1) (= (f4 (f26 ?v_0 ?v1) (f26 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 ?v0 ?v1) f1) (=> (= (f4 ?v2 f43) f1) (= (f4 (f26 (f27 f44 ?v1) ?v2) (f26 (f27 f44 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v2))) (=> (= (f4 ?v0 ?v1) f1) (=> (= (f4 f43 ?v2) f1) (= (f4 (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v2))) (=> (= (f4 ?v0 ?v1) f1) (=> (= (f4 f43 ?v2) f1) (= (f4 (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 ?v0 ?v1) f1) (=> (= (f4 f43 ?v2) f1) (= (f4 (f26 (f27 f44 ?v0) ?v2) (f26 (f27 f44 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 ?v0 f43) f1) (=> (= (f4 ?v1 f43) f1) (= (f4 f43 (f26 (f27 f44 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 ?v0 f43) f1) (=> (= (f4 f43 ?v1) f1) (= (f4 (f26 (f27 f44 ?v0) ?v1) f43) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (=> (= (f4 ?v0 f43) f1) (= (= (f4 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1) (= (f4 ?v2 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f43 (f26 (f27 f44 ?v0) ?v1)) f1) (=> (= (f4 f43 ?v1) f1) (= (f4 f43 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f43 (f26 (f27 f44 ?v0) ?v1)) f1) (=> (= (f4 f43 ?v0) f1) (= (f4 f43 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 ?v1 f43) f1) (= (f4 (f26 (f27 f44 ?v1) ?v0) f43) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 ?v1 f43) f1) (= (f4 (f26 (f27 f44 ?v0) ?v1) f43) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 f43 ?v1) f1) (= (f4 f43 (f26 (f27 f44 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (=> (= (f4 f43 ?v0) f1) (= (= (f4 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1) (= (f4 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (= (= (f4 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1) (or (and (= (f4 f43 ?v0) f1) (= (f4 ?v1 ?v2) f1)) (and (= (f4 ?v0 f43) f1) (= (f4 ?v2 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f4 (f26 (f27 f44 ?v0) ?v1) (f26 (f27 f44 ?v2) ?v1)) f1) (or (and (= (f4 f43 ?v1) f1) (= (f4 ?v0 ?v2) f1)) (and (= (f4 ?v1 f43) f1) (= (f4 ?v2 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S3)) (not (= (f4 (f26 (f27 f44 ?v0) ?v0) f43) f1))))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 ?v1 ?v2) f1) (= (f4 ?v1 (f26 (f27 f29 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v0)) (f26 (f27 f44 ?v1) ?v1)) f43) (and (= ?v0 f43) (= ?v1 f43)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (* ?v0 ?v0) (* ?v1 ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (not (< 1 0)))
(assert (not (= (f4 f18 f43) f1)))
(assert (< 0 1))
(assert (= (f4 f43 f18) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f18 ?v0) f1) (=> (= (f4 f18 ?v1) f1) (= (f4 f18 (f26 (f27 f44 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3)) (not (= (f4 (f33 (f34 f35 ?v0) (f19 f20 2)) f43) f1))))
(assert (forall ((?v0 Int)) (not (< (f23 (f36 f37 ?v0) (f19 f20 2)) 0))))
(assert (forall ((?v0 S3)) (= (= (f4 f43 (f33 (f34 f35 ?v0) (f19 f20 2))) f1) (not (= ?v0 f43)))))
(assert (forall ((?v0 Int)) (= (< 0 (f23 (f36 f37 ?v0) (f19 f20 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S3)) (= (f4 ?v0 (f26 (f27 f29 ?v0) f18)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f19 f20 2))) (= (= (f26 (f27 f29 (f33 (f34 f35 ?v0) ?v_0)) (f33 (f34 f35 ?v1) ?v_0)) f43) (and (= ?v0 f43) (= ?v1 f43))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (= (+ (f23 (f36 f37 ?v0) ?v_0) (f23 (f36 f37 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (=> (= (f26 (f27 f44 ?v1) ?v0) ?v2) (= ?v1 (f26 (f27 f28 ?v2) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (=> (= (f7 (f8 f45 ?v1) ?v0) ?v2) (= ?v1 (f7 (f8 f10 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (=> (= ?v1 (f26 (f27 f44 ?v2) ?v0)) (= (f26 (f27 f28 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (=> (= ?v1 (f7 (f8 f45 ?v2) ?v0)) (= (f7 (f8 f10 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (= (= (f26 (f27 f28 ?v1) ?v0) ?v2) (= ?v1 (f26 (f27 f44 ?v2) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (= (= (f7 (f8 f10 ?v1) ?v0) ?v2) (= ?v1 (f7 (f8 f45 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (= (= ?v1 (f26 (f27 f28 ?v2) ?v0)) (= (f26 (f27 f44 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f21)) (= (= ?v1 (f7 (f8 f10 ?v2) ?v0)) (= (f7 (f8 f45 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S2)) (= (f7 (f8 f10 ?v0) ?v0) (ite (= ?v0 f21) f21 f30))))
(assert (forall ((?v0 S3)) (= (f26 (f27 f28 ?v0) ?v0) (ite (= ?v0 f43) f43 f18))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f7 (f8 f10 ?v0) ?v0) f30))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f43)) (= (f26 (f27 f28 ?v0) ?v0) f18))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f21)) (= (= (f7 (f8 f10 ?v1) ?v0) f30) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f43)) (= (= (f26 (f27 f28 ?v1) ?v0) f18) (= ?v1 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) (f40 (f41 f46 ?v0) (f40 (f41 f42 (f40 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) (f26 (f27 f44 ?v0) (f33 (f34 f35 (f33 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 S2) (?v1 S9)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) (f7 (f8 f45 ?v0) (f14 (f15 f16 (f14 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (f36 f37 ?v0))) (= (f23 ?v_0 (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) (* ?v0 (f23 (f36 f37 (f23 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 S3)) (= (f4 f43 (f26 (f27 f29 f18) (f26 f48 ?v0))) f1)))
(assert (forall ((?v0 S3)) (not (= (f4 (f26 (f27 f29 (f26 f48 ?v0)) f18) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f19 f20 2))) (= (= (f26 (f27 f29 (f33 (f34 f35 ?v0) ?v_0)) (f33 (f34 f35 ?v1) ?v_0)) f43) (and (= ?v0 f43) (= ?v1 f43))))))
(assert (forall ((?v0 S3)) (=> (= (f4 (f26 f48 ?v0) f18) f1) (= (f4 (f33 (f34 f35 ?v0) (f19 f20 2)) f18) f1))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (< 0 (f23 f24 (f40 (f41 f42 ?v0) ?v1))) (or (< 0 (f23 f24 ?v0)) (= ?v1 (f19 f20 0))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (< 0 (f23 f24 (f40 (f41 f42 ?v0) ?v1))) (or (= ?v1 (f19 f20 0)) (< 0 (f23 f24 ?v0))))))
(assert (forall ((?v0 S9)) (let ((?v_0 (f19 f20 (+ 0 1)))) (= (f40 (f41 f42 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f19 f20 (+ 0 1)))) (= (= (f40 (f41 f42 ?v0) ?v1) ?v_0) (or (= ?v1 (f19 f20 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f41 f42 ?v0))) (=> (< 0 (f23 f24 ?v0)) (=> (< (f23 f24 (f40 ?v_0 ?v1)) (f23 f24 (f40 ?v_0 ?v2))) (< (f23 f24 ?v1) (f23 f24 ?v2)))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f23 f24 ?v0)) (<= ?v_0 (f23 f24 (f40 (f41 f42 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f44 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f26 (f27 f44 ?v0) ?v1) (f26 (f27 f44 ?v1) ?v0))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f23 f24 ?v1)) (?v_1 (f23 f24 ?v0)) (?v_2 (f41 f42 ?v2))) (=> (<= ?v_1 ?v_0) (= (f40 ?v_2 (f19 f20 (- (+ ?v_0 1) ?v_1))) (f40 (f41 f46 (f40 ?v_2 (f19 f20 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S3)) (let ((?v_0 (f23 f24 ?v1)) (?v_1 (f23 f24 ?v0)) (?v_2 (f34 f35 ?v2))) (=> (<= ?v_1 ?v_0) (= (f33 ?v_2 (f19 f20 (- (+ ?v_0 1) ?v_1))) (f26 (f27 f44 (f33 ?v_2 (f19 f20 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S2)) (let ((?v_0 (f23 f24 ?v1)) (?v_1 (f23 f24 ?v0)) (?v_2 (f15 f16 ?v2))) (=> (<= ?v_1 ?v_0) (= (f14 ?v_2 (f19 f20 (- (+ ?v_0 1) ?v_1))) (f7 (f8 f45 (f14 ?v_2 (f19 f20 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 Int)) (let ((?v_0 (f23 f24 ?v1)) (?v_1 (f23 f24 ?v0)) (?v_2 (f36 f37 ?v2))) (=> (<= ?v_1 ?v_0) (= (f23 ?v_2 (f19 f20 (- (+ ?v_0 1) ?v_1))) (* (f23 ?v_2 (f19 f20 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f41 f42 ?v1))) (=> (< 0 ?v_0) (= (f40 (f41 f46 (f40 ?v_1 (f19 f20 (- ?v_0 1)))) ?v1) (f40 ?v_1 ?v0))))))
(assert (forall ((?v0 S9) (?v1 S3)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f34 f35 ?v1))) (=> (< 0 ?v_0) (= (f26 (f27 f44 (f33 ?v_1 (f19 f20 (- ?v_0 1)))) ?v1) (f33 ?v_1 ?v0))))))
(assert (forall ((?v0 S9) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f15 f16 ?v1))) (=> (< 0 ?v_0) (= (f7 (f8 f45 (f14 ?v_1 (f19 f20 (- ?v_0 1)))) ?v1) (f14 ?v_1 ?v0))))))
(assert (forall ((?v0 S9) (?v1 Int)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f36 f37 ?v1))) (=> (< 0 ?v_0) (= (* (f23 ?v_1 (f19 f20 (- ?v_0 1))) ?v1) (f23 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (=> (not (= ?v0 f43)) (= (= (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f43)) (= (= (f26 (f27 f44 ?v1) ?v0) (f26 (f27 f44 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (not (= f43 f18)))
(assert (forall ((?v0 S3)) (= (f26 (f27 f44 f18) ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f26 (f27 f44 (f26 (f27 f29 ?v0) ?v1)) ?v2) (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v2)) (f26 (f27 f44 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S9)) (let ((?v_0 (f15 f16 ?v0))) (= (f14 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) f30 (f7 (f8 f45 ?v0) (f14 ?v_0 (f19 f20 (- (f23 f24 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (f36 f37 ?v0))) (= (f23 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) 1 (* ?v0 (f23 ?v_0 (f19 f20 (- (f23 f24 ?v1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) f18 (f26 (f27 f44 ?v0) (f33 ?v_0 (f19 f20 (- (f23 f24 ?v1) 1)))))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f41 f42 ?v0))) (= (f40 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) f39 (f40 (f41 f46 ?v0) (f40 ?v_0 (f19 f20 (- (f23 f24 ?v1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 ?v1 ?v2) f1) (= (f4 (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f4 f43 ?v0) f1) (=> (= (f4 f43 ?v1) f1) (= (f4 f43 (f26 (f27 f44 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f4 f43 ?v0) f1) (= (= (f4 (f26 (f27 f44 ?v1) ?v0) (f26 (f27 f44 ?v2) ?v0)) f1) (= (f4 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f26 (f27 f29 (f26 (f27 f44 ?v0) ?v0)) (f26 (f27 f44 ?v1) ?v1)) f43) (and (= ?v0 f43) (= ?v1 f43)))))
(assert (forall ((?v0 S3)) (= (not (= (f4 f43 (f26 (f27 f44 ?v0) ?v0)) f1)) (= ?v0 f43))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f41 f42 ?v0))) (let ((?v_1 (f40 ?v_0 ?v1))) (= (f40 ?v_0 (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) (f40 (f41 f46 ?v0) (f40 (f41 f46 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S9)) (let ((?v_0 (f34 f35 ?v0))) (let ((?v_1 (f33 ?v_0 ?v1))) (= (f33 ?v_0 (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) (f26 (f27 f44 ?v0) (f26 (f27 f44 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S9)) (let ((?v_0 (f15 f16 ?v0))) (let ((?v_1 (f14 ?v_0 ?v1))) (= (f14 ?v_0 (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) (f7 (f8 f45 ?v0) (f7 (f8 f45 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (f36 f37 ?v0))) (let ((?v_1 (f23 ?v_0 ?v1))) (= (f23 ?v_0 (f19 f20 (+ (* 2 (f23 f24 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) (f26 (f27 f44 ?v2) ?v3)) (f26 (f27 f44 (f26 ?v_0 ?v2)) (f26 (f27 f44 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f8 f45 ?v0))) (= (f7 (f8 f45 (f7 ?v_0 ?v1)) (f7 (f8 f45 ?v2) ?v3)) (f7 (f8 f45 (f7 ?v_0 ?v2)) (f7 (f8 f45 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f27 f44 (f26 (f27 f44 ?v0) ?v1))) (?v_0 (f27 f44 ?v2))) (= (f26 ?v_1 (f26 ?v_0 ?v3)) (f26 ?v_0 (f26 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f8 f45 (f7 (f8 f45 ?v0) ?v1))) (?v_0 (f8 f45 ?v2))) (= (f7 ?v_1 (f7 ?v_0 ?v3)) (f7 ?v_0 (f7 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f27 f44 ?v0)) (?v_1 (f26 (f27 f44 ?v2) ?v3))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v_1) (f26 ?v_0 (f26 (f27 f44 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f8 f45 ?v0)) (?v_1 (f7 (f8 f45 ?v2) ?v3))) (= (f7 (f8 f45 (f7 ?v_0 ?v1)) ?v_1) (f7 ?v_0 (f7 (f8 f45 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f44 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f45 ?v0))) (= (f7 (f8 f45 (f7 ?v_0 ?v1)) ?v2) (f7 (f8 f45 (f7 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f44 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f45 ?v0))) (= (f7 (f8 f45 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f45 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f44 ?v0))) (= (f26 ?v_0 (f26 (f27 f44 ?v1) ?v2)) (f26 (f27 f44 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f45 ?v0))) (= (f7 ?v_0 (f7 (f8 f45 ?v1) ?v2)) (f7 (f8 f45 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f8 f45 ?v0)) (?v_0 (f8 f45 ?v1))) (= (f7 ?v_1 (f7 ?v_0 ?v2)) (f7 ?v_0 (f7 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S9)) (= (f19 f20 (f23 f24 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f23 f24 (f19 f20 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f23 f24 (f19 f20 ?v0)) 0))))
(check-sat)
(exit)
