(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 () S2)
(declare-fun f5 (S5 S3) S3)
(declare-fun f6 (S6 S3) S5)
(declare-fun f7 () S6)
(declare-fun f8 (S7 S4) S3)
(declare-fun f9 () S7)
(declare-fun f10 () S3)
(declare-fun f11 () S4)
(declare-fun f12 () S3)
(declare-fun f13 () S8)
(declare-fun f14 (S9 Int) S8)
(declare-fun f15 () S9)
(declare-fun f16 (S10 S4) S4)
(declare-fun f17 () S10)
(declare-fun f18 () S3)
(declare-fun f19 () S10)
(declare-fun f20 () S10)
(declare-fun f21 (S11 S4) S10)
(declare-fun f22 () S11)
(declare-fun f23 () S4)
(declare-fun f24 (S8) S1)
(declare-fun f25 () S8)
(declare-fun f26 () S8)
(declare-fun f27 (S12 Int) Int)
(declare-fun f28 () S12)
(declare-fun f29 (S13 S8) Int)
(declare-fun f30 () S13)
(declare-fun f31 () S8)
(declare-fun f32 () S5)
(declare-fun f33 () S10)
(declare-fun f34 (S14 S8) S3)
(declare-fun f35 (S15 S3) S14)
(declare-fun f36 () S15)
(declare-fun f37 () S3)
(declare-fun f38 (S16 S8) S10)
(declare-fun f39 () S16)
(declare-fun f40 (S4 S4) S1)
(declare-fun f41 () S6)
(declare-fun f42 (S17 S8) S4)
(declare-fun f43 (S18 S4) S17)
(declare-fun f44 () S18)
(declare-fun f45 () S11)
(declare-fun f46 () S12)
(declare-fun f47 () S6)
(declare-fun f48 () S11)
(declare-fun f49 (S19 S8) S8)
(declare-fun f50 (S20 S8) S19)
(declare-fun f51 () S20)
(declare-fun f52 () S20)
(declare-fun f53 (S8 S8) S1)
(declare-fun f54 () S20)
(declare-fun f55 (S21 Int) S13)
(declare-fun f56 () S21)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 (f6 f7 (f8 f9 (f3 f4 f10))) f10)) f11)))
(assert (not (= f10 f12)))
(assert (not (= f10 f12)))
(assert (not (= f13 (f14 f15 0))))
(assert (= (f3 f4 (f5 (f6 f7 (f8 f9 (f3 f4 f10))) f10)) f11))
(assert (= (f16 f17 f11) f11))
(assert (= (f8 f9 f11) f18))
(assert (= (f16 f19 f11) f11))
(assert (= (f3 f4 f18) f11))
(assert (forall ((?v0 S4)) (= (f16 f19 (f16 f17 ?v0)) (f16 f20 ?v0))))
(assert (forall ((?v0 S4)) (= (f3 f4 (f8 f9 ?v0)) (f16 f20 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f17 (f16 (f21 f22 ?v0) ?v1)) (f16 (f21 f22 (f16 f17 ?v0)) (f16 f17 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f8 f9 (f16 (f21 f22 ?v0) ?v1)) (f5 (f6 f7 (f8 f9 ?v0)) (f8 f9 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f19 (f16 (f21 f22 ?v0) ?v1)) (f16 (f21 f22 (f16 f19 ?v0)) (f16 f19 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) (f16 (f21 f22 (f3 f4 ?v0)) (f3 f4 ?v1)))))
(assert (forall ((?v0 S4)) (= (f16 (f21 f22 ?v0) f11) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f18) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f12)) (= (f3 f4 (f5 (f6 f7 ?v1) ?v0)) (f16 (f21 f22 (f3 f4 ?v1)) (f3 f4 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f23)) (= (f16 f19 (f16 (f21 f22 ?v1) ?v0)) (f16 (f21 f22 (f16 f19 ?v1)) (f16 f19 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f16 f17 ?v0) (f16 f17 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f8 f9 ?v0) (f8 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4)) (= (f16 (f21 f22 ?v0) ?v0) (ite (= ?v0 f23) f23 f11))))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) ?v0) (ite (= ?v0 f12) f12 f18))))
(assert (forall ((?v0 S4)) (=> (not (= ?v0 f23)) (= (f16 (f21 f22 ?v0) ?v0) f11))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f12)) (= (f5 (f6 f7 ?v0) ?v0) f18))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f23)) (= (= (f16 (f21 f22 ?v1) ?v0) f11) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f12)) (= (= (f5 (f6 f7 ?v1) ?v0) f18) (= ?v1 ?v0)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f16 f19 ?v0))) (= (f16 f20 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 f4 ?v0))) (= (f16 f20 ?v_0) ?v_0))))
(assert (not (= (f24 f13) f1)))
(assert (forall ((?v0 S3)) (= (= (f3 f4 ?v0) f23) (= ?v0 f12))))
(assert (forall ((?v0 S4)) (= (= (f16 f19 ?v0) f23) (= ?v0 f23))))
(assert (= (f3 f4 f12) f23))
(assert (= (f16 f19 f23) f23))
(assert (forall ((?v0 S4)) (= (= (f16 f17 ?v0) f23) (= ?v0 f23))))
(assert (forall ((?v0 S4)) (= (= (f8 f9 ?v0) f12) (= ?v0 f23))))
(assert (= (f16 f17 f23) f23))
(assert (= (f8 f9 f23) f12))
(assert (= (f16 f17 f23) f23))
(assert (= (f8 f9 f23) f12))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f23)) (= (f16 f17 (f16 (f21 f22 ?v1) ?v0)) (f16 (f21 f22 (f16 f17 ?v1)) (f16 f17 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f23)) (= (f8 f9 (f16 (f21 f22 ?v1) ?v0)) (f5 (f6 f7 (f8 f9 ?v1)) (f8 f9 ?v0))))))
(assert (not (= f25 f26)))
(assert (not (= f23 f11)))
(assert (not (= 0 1)))
(assert (not (= f12 f18)))
(assert (not (= f26 f25)))
(assert (not (= f11 f23)))
(assert (not (= 1 0)))
(assert (not (= f18 f12)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f12) f12)))
(assert (forall ((?v0 S4)) (= (f16 (f21 f22 ?v0) f23) f23)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f12) ?v0) f12)))
(assert (forall ((?v0 S4)) (= (f16 (f21 f22 f23) ?v0) f23)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f12) ?v0) f12)))
(assert (forall ((?v0 S4)) (= (f16 (f21 f22 f23) ?v0) f23)))
(assert (= (f27 f28 1) 1))
(assert (= (f16 f20 f11) f11))
(assert (= f13 (f14 f15 (+ (* 2 (f29 f30 f31)) 1))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f23)) (= (f16 f20 (f16 (f21 f22 ?v1) ?v0)) (f16 (f21 f22 (f16 f20 ?v1)) (f16 f20 ?v0))))))
(assert (forall ((?v0 S3)) (= (f3 f4 (f5 f32 ?v0)) (ite (= ?v0 f12) f23 f11))))
(assert (forall ((?v0 S4)) (= (f16 f19 (f16 f33 ?v0)) (ite (= ?v0 f23) f23 f11))))
(assert (let ((?v_0 (f3 f4 f10))) (= (f34 (f35 f36 (f5 (f6 f7 f37) (f8 f9 (f16 (f38 f39 f13) ?v_0)))) f13) (f5 (f6 f7 (f34 (f35 f36 f37) f13)) (f8 f9 ?v_0)))))
(assert (not (= f23 f11)))
(assert (= (f40 (f3 f4 (f5 (f6 f41 (f5 (f6 f7 (f8 f9 (f3 f4 f10))) f10)) (f34 (f35 f36 f37) f13))) f11) f1))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f20 (f16 (f21 f22 ?v0) ?v1)) (f16 (f21 f22 (f16 f20 ?v0)) (f16 f20 ?v1)))))
(assert (let ((?v_0 (f3 f4 f10))) (= (f42 (f43 f44 (f16 (f38 f39 f13) ?v_0)) f13) ?v_0)))
(assert (exists ((?v0 S8)) (= f13 (f14 f15 (+ (* 2 (f29 f30 ?v0)) 1)))))
(assert (=> (forall ((?v0 S8)) (=> (= f13 (f14 f15 (+ (* 2 (f29 f30 ?v0)) 1))) false)) false))
(assert (exists ((?v0 S3)) (= (f40 (f3 f4 (f5 (f6 f41 (f5 (f6 f7 (f8 f9 (f3 f4 f10))) f10)) (f34 (f35 f36 ?v0) f13))) f11) f1)))
(assert (=> (forall ((?v0 S3)) (=> (= (f40 (f3 f4 (f5 (f6 f41 (f5 (f6 f7 (f8 f9 (f3 f4 f10))) f10)) (f34 (f35 f36 ?v0) f13))) f11) f1) false)) false))
(assert (forall ((?v0 Int)) (not (< (* ?v0 ?v0) 0))))
(assert (forall ((?v0 S4)) (not (= (f40 (f16 (f21 f45 ?v0) ?v0) f23) f1))))
(assert (forall ((?v0 Int)) (= (f27 f28 ?v0) (* ?v0 (f27 f46 ?v0)))))
(assert (forall ((?v0 S4)) (= (f16 f20 ?v0) (f16 (f21 f45 ?v0) (f16 f33 ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f27 f46 ?v0))) (= (f27 f46 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f16 f33 ?v0))) (= (f16 f33 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f27 f28 (* ?v0 ?v1)) (* (f27 f28 ?v0) (f27 f28 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f20 (f16 (f21 f45 ?v0) ?v1)) (f16 (f21 f45 (f16 f20 ?v0)) (f16 f20 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f27 f46 (* ?v0 ?v1)) (* (f27 f46 ?v0) (f27 f46 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f33 (f16 (f21 f45 ?v0) ?v1)) (f16 (f21 f45 (f16 f33 ?v0)) (f16 f33 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f32 (f5 (f6 f47 ?v0) ?v1)) (f5 (f6 f47 (f5 f32 ?v0)) (f5 f32 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f33 (f16 (f21 f45 ?v0) ?v1)) (f16 (f21 f45 (f16 f33 ?v0)) (f16 f33 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f47 ?v0))) (= (f5 ?v_0 (f5 (f6 f41 ?v1) ?v2)) (f5 (f6 f41 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (= (f16 ?v_0 (f16 (f21 f48 ?v1) ?v2)) (f16 (f21 f48 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f47 ?v0))) (= (f5 ?v_0 (f5 (f6 f41 ?v1) ?v2)) (f5 (f6 f41 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (= (f16 ?v_0 (f16 (f21 f48 ?v1) ?v2)) (f16 (f21 f48 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (= (* (f27 f46 ?v0) (f27 f28 ?v0)) ?v0)))
(assert (forall ((?v0 S4)) (= (f16 (f21 f45 (f16 f33 ?v0)) (f16 f20 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f16 f20 ?v0))) (= (f16 (f21 f45 ?v_0) ?v_0) (f16 (f21 f45 ?v0) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f49 (f50 f51 (f49 (f50 f52 ?v0) ?v1)) ?v2) (f49 (f50 f52 (f49 (f50 f51 ?v0) ?v2)) (f49 (f50 f51 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (+ ?v0 ?v1) ?v2) (+ (* ?v0 ?v2) (* ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f5 (f6 f47 (f5 (f6 f41 ?v0) ?v1)) ?v2) (f5 (f6 f41 (f5 (f6 f47 ?v0) ?v2)) (f5 (f6 f47 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f16 (f21 f45 (f16 (f21 f48 ?v0) ?v1)) ?v2) (f16 (f21 f48 (f16 (f21 f45 ?v0) ?v2)) (f16 (f21 f45 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f5 (f6 f47 (f5 (f6 f41 ?v0) ?v1)) ?v2) (f5 (f6 f41 (f5 (f6 f47 ?v0) ?v2)) (f5 (f6 f47 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f16 (f21 f45 (f16 (f21 f48 ?v0) ?v1)) ?v2) (f16 (f21 f48 (f16 (f21 f45 ?v0) ?v2)) (f16 (f21 f45 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f5 (f6 f47 (f5 (f6 f41 ?v0) ?v1)) ?v2) (f5 (f6 f41 (f5 (f6 f47 ?v0) ?v2)) (f5 (f6 f47 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f16 (f21 f45 (f16 (f21 f48 ?v0) ?v1)) ?v2) (f16 (f21 f48 (f16 (f21 f45 ?v0) ?v2)) (f16 (f21 f45 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v2 ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f40 (f16 (f21 f45 ?v0) ?v1) (f16 (f21 f45 ?v2) ?v1)) f1) (or (and (= (f40 f23 ?v1) f1) (= (f40 ?v0 ?v2) f1)) (and (= (f40 ?v1 f23) f1) (= (f40 ?v2 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (= (= (f40 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (or (and (= (f40 f23 ?v0) f1) (= (f40 ?v1 ?v2) f1)) (and (= (f40 ?v0 f23) f1) (= (f40 ?v2 ?v1) f1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f49 (f50 f52 (f49 (f50 f51 ?v0) ?v1)) (f49 (f50 f52 (f49 (f50 f51 ?v2) ?v1)) ?v3)) (f49 (f50 f52 (f49 (f50 f51 (f49 (f50 f52 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (* ?v0 ?v1) (+ (* ?v2 ?v1) ?v3)) (+ (* (+ ?v0 ?v2) ?v1) ?v3))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f5 (f6 f41 (f5 (f6 f47 ?v0) ?v1)) (f5 (f6 f41 (f5 (f6 f47 ?v2) ?v1)) ?v3)) (f5 (f6 f41 (f5 (f6 f47 (f5 (f6 f41 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f16 (f21 f48 (f16 (f21 f45 ?v0) ?v1)) (f16 (f21 f48 (f16 (f21 f45 ?v2) ?v1)) ?v3)) (f16 (f21 f48 (f16 (f21 f45 (f16 (f21 f48 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f40 ?v0 ?v1) f1) false) (=> (=> (= (f40 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (=> (= (f40 f23 ?v0) f1) (= (= (f40 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (= (f40 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f25 ?v0) f1) (=> (= (f53 f25 ?v1) f1) (= (f53 f25 (f49 (f50 f51 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 f23 ?v1) f1) (= (f40 f23 (f16 (f21 f45 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f25 ?v0) f1) (=> (= (f53 ?v1 f25) f1) (= (f53 (f49 (f50 f51 ?v0) ?v1) f25) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 ?v1 f23) f1) (= (f40 (f16 (f21 f45 ?v0) ?v1) f23) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f25 ?v0) f1) (=> (= (f53 ?v1 f25) f1) (= (f53 (f49 (f50 f51 ?v1) ?v0) f25) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 ?v1 f23) f1) (= (f40 (f16 (f21 f45 ?v1) ?v0) f23) f1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f53 f25 ?v0) f1) (=> (= (f53 ?v1 ?v2) f1) (= (f53 ?v1 (f49 (f50 f52 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 ?v1 ?v2) f1) (= (f40 ?v1 (f16 (f21 f48 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f25 (f49 (f50 f51 ?v0) ?v1)) f1) (=> (= (f53 f25 ?v0) f1) (= (f53 f25 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f23 (f16 (f21 f45 ?v0) ?v1)) f1) (=> (= (f40 f23 ?v0) f1) (= (f40 f23 ?v1) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f25 (f49 (f50 f51 ?v0) ?v1)) f1) (=> (= (f53 f25 ?v1) f1) (= (f53 f25 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f23 (f16 (f21 f45 ?v0) ?v1)) f1) (=> (= (f40 f23 ?v1) f1) (= (f40 f23 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (=> (= (f40 ?v0 f23) f1) (= (= (f40 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (= (f40 ?v2 ?v1) f1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 ?v0 f25) f1) (=> (= (f53 f25 ?v1) f1) (= (f53 (f49 (f50 f51 ?v0) ?v1) f25) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 ?v0 f23) f1) (=> (= (f40 f23 ?v1) f1) (= (f40 (f16 (f21 f45 ?v0) ?v1) f23) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 ?v0 f23) f1) (=> (= (f40 ?v1 f23) f1) (= (f40 f23 (f16 (f21 f45 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 f23 ?v2) f1) (= (f40 (f16 (f21 f45 ?v0) ?v2) (f16 (f21 f45 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v2))) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 f23 ?v2) f1) (= (f40 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v2))) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 f23 ?v2) f1) (= (f40 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 ?v2 f23) f1) (= (f40 (f16 (f21 f45 ?v1) ?v2) (f16 (f21 f45 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v2))) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 ?v2 f23) f1) (= (f40 (f16 ?v_0 ?v1) (f16 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f40 (f16 f19 ?v0) ?v1) f1) (=> (= (f40 (f16 f19 ?v2) ?v3) f1) (= (f40 (f16 f19 (f16 (f21 f48 ?v0) ?v2)) (f16 (f21 f48 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S4) (?v2 S3) (?v3 S4)) (=> (= (f40 (f3 f4 ?v0) ?v1) f1) (=> (= (f40 (f3 f4 ?v2) ?v3) f1) (= (f40 (f3 f4 (f5 (f6 f41 ?v0) ?v2)) (f16 (f21 f48 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f40 (f16 f19 ?v0) ?v1) f1) (=> (= (f40 (f16 f19 ?v2) ?v3) f1) (= (f40 (f16 f19 (f16 (f21 f45 ?v0) ?v2)) (f16 (f21 f45 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S4) (?v2 S3) (?v3 S4)) (=> (= (f40 (f3 f4 ?v0) ?v1) f1) (=> (= (f40 (f3 f4 ?v2) ?v3) f1) (= (f40 (f3 f4 (f5 (f6 f47 ?v0) ?v2)) (f16 (f21 f45 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f16 f20 ?v0)) (?v_1 (f16 f20 ?v2))) (=> (= (f40 ?v_0 ?v1) f1) (=> (= (f40 ?v_1 ?v3) f1) (= (f40 (f16 (f21 f45 ?v_0) ?v_1) (f16 (f21 f45 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f27 f28 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f29 f30 ?v0)) (?v_1 (f50 f54 ?v1))) (=> (< 0 ?v_0) (= (f49 (f50 f51 (f49 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f49 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S4)) (let ((?v_0 (f29 f30 ?v0)) (?v_1 (f43 f44 ?v1))) (=> (< 0 ?v_0) (= (f16 (f21 f45 (f42 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f42 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S3)) (let ((?v_0 (f29 f30 ?v0)) (?v_1 (f35 f36 ?v1))) (=> (< 0 ?v_0) (= (f5 (f6 f47 (f34 ?v_1 (f14 f15 (- ?v_0 1)))) ?v1) (f34 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f29 f30 ?v0)) (?v_1 (f55 f56 ?v1))) (=> (< 0 ?v_0) (= (* (f29 ?v_1 (f14 f15 (- ?v_0 1))) ?v1) (f29 ?v_1 ?v0))))))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S4)) (= (f40 ?v0 (f16 (f21 f48 ?v0) f11)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f11 ?v0) f1) (=> (= (f40 f11 ?v1) f1) (= (f40 f11 (f16 (f21 f45 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (f16 f19 (f42 (f43 f44 ?v0) ?v1)) (f42 (f43 f44 (f16 f19 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S8)) (= (f3 f4 (f34 (f35 f36 ?v0) ?v1)) (f42 (f43 f44 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f19 (f16 (f21 f45 ?v0) ?v1)) (f16 (f21 f45 (f16 f19 ?v0)) (f16 f19 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f5 (f6 f47 ?v0) ?v1)) (f16 (f21 f45 (f3 f4 ?v0)) (f3 f4 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (f8 f9 (f42 (f43 f44 ?v0) ?v1)) (f34 (f35 f36 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (f16 f17 (f42 (f43 f44 ?v0) ?v1)) (f42 (f43 f44 (f16 f17 ?v0)) ?v1))))
(assert (forall ((?v0 S4)) (= (= (f40 (f16 f33 ?v0) f23) f1) (= (f40 ?v0 f23) f1))))
(assert (forall ((?v0 Int)) (= (< (f27 f46 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S4)) (= (= (f40 f23 (f16 f33 ?v0)) f1) (= (f40 f23 ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (f27 f46 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f8 f9 (f16 (f21 f48 ?v0) ?v1)) (f5 (f6 f41 (f8 f9 ?v0)) (f8 f9 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f17 (f16 (f21 f48 ?v0) ?v1)) (f16 (f21 f48 (f16 f17 ?v0)) (f16 f17 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f8 f9 (f16 (f21 f48 ?v0) ?v1)) (f5 (f6 f41 (f8 f9 ?v0)) (f8 f9 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f17 (f16 (f21 f48 ?v0) ?v1)) (f16 (f21 f48 (f16 f17 ?v0)) (f16 f17 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f8 f9 (f16 (f21 f45 ?v0) ?v1)) (f5 (f6 f47 (f8 f9 ?v0)) (f8 f9 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 f17 (f16 (f21 f45 ?v0) ?v1)) (f16 (f21 f45 (f16 f17 ?v0)) (f16 f17 ?v1)))))
(assert (forall ((?v0 S4)) (=> (= (f40 f23 ?v0) f1) (= (f16 f33 ?v0) f11))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (f34 (f35 f36 (f8 f9 ?v0)) ?v1) (f8 f9 (f42 (f43 f44 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f16 (f21 f45 (f16 (f21 f22 ?v0) ?v1)) (f16 (f21 f22 ?v2) ?v3)) (f16 (f21 f22 (f16 (f21 f45 ?v0) ?v2)) (f16 (f21 f45 ?v1) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f5 (f6 f47 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v3)) (f5 (f6 f7 (f5 (f6 f47 ?v0) ?v2)) (f5 (f6 f47 ?v1) ?v3)))))
(assert (forall ((?v0 S4)) (= (f5 f32 (f8 f9 ?v0)) (f8 f9 (f16 f33 ?v0)))))
(assert (forall ((?v0 S4)) (= (f16 f33 (f16 f17 ?v0)) (f16 f17 (f16 f33 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (not (= ?v0 f23)) (=> (not (= ?v1 f23)) (= (f16 (f21 f48 (f16 (f21 f22 ?v2) ?v0)) (f16 (f21 f22 ?v3) ?v1)) (f16 (f21 f22 (f16 (f21 f48 (f16 (f21 f45 ?v2) ?v1)) (f16 (f21 f45 ?v3) ?v0))) (f16 (f21 f45 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f12)) (=> (not (= ?v1 f12)) (= (f5 (f6 f41 (f5 (f6 f7 ?v2) ?v0)) (f5 (f6 f7 ?v3) ?v1)) (f5 (f6 f7 (f5 (f6 f41 (f5 (f6 f47 ?v2) ?v1)) (f5 (f6 f47 ?v3) ?v0))) (f5 (f6 f47 ?v0) ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (= (f16 (f21 f48 (f16 (f21 f22 ?v1) ?v0)) ?v2) (f16 (f21 f22 (f16 (f21 f48 ?v1) (f16 (f21 f45 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f12)) (= (f5 (f6 f41 (f5 (f6 f7 ?v1) ?v0)) ?v2) (f5 (f6 f7 (f5 (f6 f41 ?v1) (f5 (f6 f47 ?v0) ?v2))) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (= (f16 (f21 f48 (f16 (f21 f22 ?v1) ?v0)) ?v2) (f16 (f21 f22 (f16 (f21 f48 ?v1) (f16 (f21 f45 ?v2) ?v0))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f12)) (= (f5 (f6 f41 (f5 (f6 f7 ?v1) ?v0)) ?v2) (f5 (f6 f7 (f5 (f6 f41 ?v1) (f5 (f6 f47 ?v2) ?v0))) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (= (f16 (f21 f48 ?v1) (f16 (f21 f22 ?v2) ?v0)) (f16 (f21 f22 (f16 (f21 f48 (f16 (f21 f45 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f12)) (= (f5 (f6 f41 ?v1) (f5 (f6 f7 ?v2) ?v0)) (f5 (f6 f7 (f5 (f6 f41 (f5 (f6 f47 ?v0) ?v1)) ?v2)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (= (f16 (f21 f48 ?v1) (f16 (f21 f22 ?v2) ?v0)) (f16 (f21 f22 (f16 (f21 f48 ?v2) (f16 (f21 f45 ?v1) ?v0))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f12)) (= (f5 (f6 f41 ?v1) (f5 (f6 f7 ?v2) ?v0)) (f5 (f6 f7 (f5 (f6 f41 ?v2) (f5 (f6 f47 ?v1) ?v0))) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f22 ?v2))) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 ?v2 f23) f1) (=> (= (f40 f23 (f16 (f21 f45 ?v0) ?v1)) f1) (= (f40 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f22 ?v2))) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 f23 ?v2) f1) (=> (= (f40 f23 (f16 (f21 f45 ?v1) ?v0)) f1) (= (f40 (f16 ?v_0 ?v1) (f16 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 ?v0 f23) f1) (= (= (f40 (f16 (f21 f22 ?v1) ?v0) ?v2) f1) (= (f40 (f16 (f21 f45 ?v2) ?v0) ?v1) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 ?v0 f23) f1) (= (= (f40 ?v1 (f16 (f21 f22 ?v2) ?v0)) f1) (= (f40 ?v2 (f16 (f21 f45 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 (f16 (f21 f45 ?v1) ?v0) ?v2) f1) (= (f40 ?v1 (f16 (f21 f22 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 ?v1 (f16 (f21 f45 ?v2) ?v0)) f1) (= (f40 (f16 (f21 f22 ?v1) ?v0) ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 f23 ?v0) f1) (= (= (f40 (f16 (f21 f22 ?v1) ?v0) ?v2) f1) (= (f40 ?v1 (f16 (f21 f45 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 f23 ?v0) f1) (= (= (f40 ?v1 (f16 (f21 f22 ?v2) ?v0)) f1) (= (f40 (f16 (f21 f45 ?v1) ?v0) ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f16 (f21 f45 ?v2) ?v1))) (= (= (f40 (f16 (f21 f22 ?v0) ?v1) ?v2) f1) (ite (= (f40 f23 ?v1) f1) (= (f40 ?v0 ?v_0) f1) (ite (= (f40 ?v1 f23) f1) (= (f40 ?v_0 ?v0) f1) (= (f40 f23 ?v2) f1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f16 (f21 f45 ?v0) ?v2))) (= (= (f40 ?v0 (f16 (f21 f22 ?v1) ?v2)) f1) (ite (= (f40 f23 ?v2) f1) (= (f40 ?v_0 ?v1) f1) (ite (= (f40 ?v2 f23) f1) (= (f40 ?v1 ?v_0) f1) (= (f40 ?v0 f23) f1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 ?v0 ?v1) f1) (= (f40 ?v0 (f16 (f21 f22 (f16 (f21 f48 ?v0) ?v1)) (f16 (f21 f48 f11) f11))) f1))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 ?v0 ?v1) f1) (= (f40 (f16 (f21 f22 (f16 (f21 f48 ?v0) ?v1)) (f16 (f21 f48 f11) f11)) ?v1) f1))))
(assert (< 0 (+ 1 1)))
(assert (= (f40 f23 (f16 (f21 f48 f11) f11)) f1))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f27 f46 ?v0) 1))))
(assert (forall ((?v0 S4)) (=> (= (f40 f23 ?v0) f1) (= (f16 f33 ?v0) f11))))
(assert (forall ((?v0 Int)) (= (= (f27 f46 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 S4)) (= (= (f16 f33 ?v0) f11) (= (f40 f23 ?v0) f1))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f16 (f21 f45 ?v0) ?v1) f23) (or (= ?v0 f23) (= ?v1 f23)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f5 (f6 f47 ?v0) ?v1) f12) (or (= ?v0 f12) (= ?v1 f12)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f23)) (=> (not (= ?v1 f23)) (not (= (f16 (f21 f45 ?v0) ?v1) f23))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f12)) (=> (not (= ?v1 f12)) (not (= (f5 (f6 f47 ?v0) ?v1) f12))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f16 (f21 f45 ?v0) ?v1) f23) (or (= ?v0 f23) (= ?v1 f23)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f5 (f6 f47 ?v0) ?v1) f12) (or (= ?v0 f12) (= ?v1 f12)))))
(assert (forall ((?v0 S4)) (= (f16 (f21 f45 ?v0) f23) f23)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f47 ?v0) f12) f12)))
(assert (forall ((?v0 S4)) (= (f16 (f21 f45 ?v0) f23) f23)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f47 ?v0) f12) f12)))
(assert (forall ((?v0 S4)) (= (f16 (f21 f45 ?v0) f23) f23)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f47 ?v0) f12) f12)))
(assert (forall ((?v0 S4)) (= (f16 (f21 f45 f23) ?v0) f23)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f47 f12) ?v0) f12)))
(assert (forall ((?v0 S4)) (= (f16 (f21 f45 f23) ?v0) f23)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f47 f12) ?v0) f12)))
(assert (forall ((?v0 S4)) (= (f16 (f21 f45 f23) ?v0) f23)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f47 f12) ?v0) f12)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f16 (f21 f22 (f16 (f21 f48 ?v0) ?v1)) ?v2) (f16 (f21 f48 (f16 (f21 f22 ?v0) ?v2)) (f16 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f5 (f6 f7 (f5 (f6 f41 ?v0) ?v1)) ?v2) (f5 (f6 f41 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f16 (f21 f22 (f16 (f21 f48 ?v0) ?v1)) ?v2) (f16 (f21 f48 (f16 (f21 f22 ?v0) ?v2)) (f16 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f5 (f6 f7 (f5 (f6 f41 ?v0) ?v1)) ?v2) (f5 (f6 f41 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (= (f16 ?v_0 (f16 (f21 f22 ?v1) ?v2)) (f16 (f21 f22 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f47 ?v0))) (= (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2)) (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3)) (not (= (f40 (f3 f4 ?v0) f23) f1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f40 f23 (f16 (f21 f22 ?v0) ?v1)) f1) (or (and (= (f40 f23 ?v0) f1) (= (f40 f23 ?v1) f1)) (and (= (f40 ?v0 f23) f1) (= (f40 ?v1 f23) f1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f40 (f16 (f21 f22 ?v0) ?v1) f23) f1) (or (and (= (f40 f23 ?v0) f1) (= (f40 ?v1 f23) f1)) (and (= (f40 ?v0 f23) f1) (= (f40 f23 ?v1) f1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f40 (f16 (f21 f22 ?v0) ?v1) (f16 (f21 f22 ?v2) ?v1)) f1) (and (=> (= (f40 f23 ?v1) f1) (= (f40 ?v0 ?v2) f1)) (and (=> (= (f40 ?v1 f23) f1) (= (f40 ?v2 ?v0) f1)) (not (= ?v1 f23)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f23 ?v0) f1) (= (f16 (f21 f22 (f16 f20 ?v1)) ?v0) (f16 f20 (f16 (f21 f22 ?v1) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 f23 ?v1) f1) (= (f40 f23 (f16 (f21 f22 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 ?v1 f23) f1) (= (f40 (f16 (f21 f22 ?v0) ?v1) f23) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 ?v0 f23) f1) (=> (= (f40 f23 ?v1) f1) (= (f40 (f16 (f21 f22 ?v0) ?v1) f23) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 ?v0 f23) f1) (=> (= (f40 ?v1 f23) f1) (= (f40 f23 (f16 (f21 f22 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 f23 ?v2) f1) (= (f40 (f16 (f21 f22 ?v0) ?v2) (f16 (f21 f22 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 ?v0 ?v1) f1) (=> (= (f40 ?v2 f23) f1) (= (f40 (f16 (f21 f22 ?v1) ?v2) (f16 (f21 f22 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= ?v0 (f16 (f21 f22 ?v1) ?v2)) (ite (not (= ?v2 f23)) (= (f16 (f21 f45 ?v0) ?v2) ?v1) (= ?v0 f23)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= ?v0 (f5 (f6 f7 ?v1) ?v2)) (ite (not (= ?v2 f12)) (= (f5 (f6 f47 ?v0) ?v2) ?v1) (= ?v0 f12)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f16 (f21 f22 ?v0) ?v1) ?v2) (ite (not (= ?v1 f23)) (= ?v0 (f16 (f21 f45 ?v2) ?v1)) (= ?v2 f23)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f5 (f6 f7 ?v0) ?v1) ?v2) (ite (not (= ?v1 f12)) (= ?v0 (f5 (f6 f47 ?v2) ?v1)) (= ?v2 f12)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (= (f16 (f21 f22 (f16 (f21 f45 ?v1) ?v0)) (f16 (f21 f45 ?v2) ?v0)) (f16 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f12)) (= (f5 (f6 f7 (f5 (f6 f47 ?v1) ?v0)) (f5 (f6 f47 ?v2) ?v0)) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (=> (not (= ?v0 f23)) (= (f16 (f21 f22 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2)) (f16 (f21 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f47 ?v0))) (=> (not (= ?v0 f12)) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (not (= ?v0 f23)) (=> (not (= ?v1 f23)) (= (= (f16 (f21 f22 ?v2) ?v0) (f16 (f21 f22 ?v3) ?v1)) (= (f16 (f21 f45 ?v2) ?v1) (f16 (f21 f45 ?v3) ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f12)) (=> (not (= ?v1 f12)) (= (= (f5 (f6 f7 ?v2) ?v0) (f5 (f6 f7 ?v3) ?v1)) (= (f5 (f6 f47 ?v2) ?v1) (f5 (f6 f47 ?v3) ?v0)))))))
(assert (forall ((?v0 S4)) (= (= (f16 f33 ?v0) f23) (= ?v0 f23))))
(assert (forall ((?v0 S3)) (= (= (f5 f32 ?v0) f12) (= ?v0 f12))))
(assert (forall ((?v0 S4)) (= (= (f16 f33 ?v0) f23) (= ?v0 f23))))
(assert (forall ((?v0 Int)) (= (= (f27 f46 ?v0) 0) (= ?v0 0))))
(assert (= (f16 f33 f23) f23))
(assert (= (f5 f32 f12) f12))
(assert (forall ((?v0 S4)) (= (f16 f33 ?v0) (f16 (f21 f22 ?v0) (f16 f20 ?v0)))))
(assert (= (f5 f32 f18) f18))
(assert (= (f16 f33 f11) f11))
(assert (not (< 1 0)))
(assert (not (= (f40 f11 f23) f1)))
(assert (< 0 1))
(assert (= (f40 f23 f11) f1))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (= (= ?v1 (f16 (f21 f22 ?v2) ?v0)) (= (f16 (f21 f45 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f12)) (= (= ?v1 (f5 (f6 f7 ?v2) ?v0)) (= (f5 (f6 f47 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (= (= (f16 (f21 f22 ?v1) ?v0) ?v2) (= ?v1 (f16 (f21 f45 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f12)) (= (= (f5 (f6 f7 ?v1) ?v0) ?v2) (= ?v1 (f5 (f6 f47 ?v2) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (=> (= ?v1 (f16 (f21 f45 ?v2) ?v0)) (= (f16 (f21 f22 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f12)) (=> (= ?v1 (f5 (f6 f47 ?v2) ?v0)) (= (f5 (f6 f7 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (=> (= (f16 (f21 f45 ?v1) ?v0) ?v2) (= ?v1 (f16 (f21 f22 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f12)) (=> (= (f5 (f6 f47 ?v1) ?v0) ?v2) (= ?v1 (f5 (f6 f7 ?v2) ?v0))))))
(assert (forall ((?v0 S4)) (= (= (f40 f23 (f16 f19 ?v0)) f1) (not (= ?v0 f23)))))
(assert (forall ((?v0 S3)) (= (= (f40 f23 (f3 f4 ?v0)) f1) (not (= ?v0 f12)))))
(assert (forall ((?v0 S8)) (=> (< (f29 f30 ?v0) (f29 f30 f13)) (=> (not (= ?v0 (f14 f15 0))) (exists ((?v1 S3)) (= (f40 (f3 f4 (f5 (f6 f41 f18) (f5 (f6 f47 f10) (f34 (f35 f36 ?v1) ?v0)))) f11) f1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f29 (f55 f56 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (* ?v0 ?v_0) ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f42 (f43 f44 ?v0) ?v1))) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 ?v0 f11) f1) (= (f40 (f16 (f21 f45 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f49 (f50 f54 ?v0) ?v1))) (=> (= (f53 f25 ?v0) f1) (=> (= (f53 ?v0 f26) f1) (= (f53 (f49 (f50 f51 ?v0) ?v_0) ?v_0) f1))))))
(assert (=> (= (f24 f13) f1) (exists ((?v0 S3)) (= (f40 (f3 f4 (f5 (f6 f41 f18) (f5 (f6 f47 f10) (f34 (f35 f36 ?v0) f13)))) f11) f1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f29 f30 ?v1)) (=> (= (f40 f23 ?v2) f1) (=> (= (f40 ?v2 f11) f1) (= (f40 (f16 (f38 f39 ?v0) ?v2) (f16 (f38 f39 ?v1) ?v2)) f1))))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f14 f15 (+ (f29 f30 ?v1) 1)))) (=> (= (f40 f23 ?v0) f1) (= (f16 (f38 f39 ?v_0) (f42 (f43 f44 ?v0) ?v_0)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (< 0 (f29 f30 ?v0)) (=> (= (f40 f23 ?v1) f1) (= (f42 (f43 f44 (f16 (f38 f39 ?v0) ?v1)) ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f29 f30 ?v0)) (?v_1 (f29 f30 ?v1))) (=> (< 0 ?v_0) (=> (< 0 ?v_1) (=> (= (f40 f23 ?v2) f1) (= (f16 (f38 f39 (f14 f15 (* ?v_0 ?v_1))) ?v2) (f16 (f38 f39 ?v0) (f16 (f38 f39 ?v1) ?v2)))))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (= (f24 ?v1) f1))) (= (= (f40 f23 (f42 (f43 f44 ?v0) ?v1)) f1) (or (= ?v1 (f14 f15 0)) (or (and ?v_0 (not (= ?v0 f23))) (and (not ?v_0) (= (f40 f23 ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (= (f24 ?v1) f1))) (= (< 0 (f29 (f55 f56 ?v0) ?v1)) (or (= ?v1 (f14 f15 0)) (or (and ?v_0 (not (= ?v0 0))) (and (not ?v_0) (< 0 ?v0))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f16 (f21 f48 (f16 (f21 f45 ?v0) ?v0)) (f16 (f21 f45 ?v1) ?v1)) f23) (and (= ?v0 f23) (= ?v1 f23)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f16 (f21 f45 (f16 (f21 f48 ?v0) ?v1)) ?v2) (f16 (f21 f48 (f16 (f21 f45 ?v0) ?v2)) (f16 (f21 f45 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (= (f16 (f21 f45 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f21 f45 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f16 (f21 f45 ?v0) ?v1) (f16 (f21 f45 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f24 (f49 (f50 f54 ?v0) ?v1)) f1) (and (= (f24 ?v0) f1) (< 0 (f29 f30 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f21 f45 ?v0))) (= (f16 (f21 f22 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v0)) (f16 (f21 f22 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S4)) (let ((?v_0 (f38 f39 ?v0))) (=> (< 0 (f29 f30 ?v0)) (= (f16 ?v_0 (f16 (f21 f45 ?v1) ?v2)) (f16 (f21 f45 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (=> (not (= ?v0 f23)) (= (= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (not (= ?v0 f23)) (= (= (f16 (f21 f45 ?v1) ?v0) (f16 (f21 f45 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4)) (= (f16 (f21 f45 f11) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (not (= (f40 f23 (f16 (f21 f45 ?v0) ?v0)) f1)) (= ?v0 f23))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f14 f15 2))) (= (= (f16 (f21 f48 (f42 (f43 f44 ?v0) ?v_0)) (f42 (f43 f44 ?v1) ?v_0)) f23) (and (= ?v0 f23) (= ?v1 f23))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f21 f45 ?v0))) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 ?v1 ?v2) f1) (= (f40 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 f23 ?v1) f1) (= (f40 f23 (f16 (f21 f45 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f40 f23 ?v0) f1) (= (= (f40 (f16 (f21 f45 ?v1) ?v0) (f16 (f21 f45 ?v2) ?v0)) f1) (= (f40 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S4)) (not (= (f40 (f16 (f21 f48 (f16 f20 ?v0)) f11) ?v0) f1))))
(assert (forall ((?v0 S4)) (= (f40 f23 (f16 (f21 f48 f11) (f16 f20 ?v0))) f1)))
(assert (forall ((?v0 S4) (?v1 S8)) (= (f16 f20 (f42 (f43 f44 ?v0) ?v1)) (f42 (f43 f44 (f16 f20 ?v0)) ?v1))))
(assert (forall ((?v0 S8)) (= (f49 (f50 f54 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f42 (f43 f44 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f34 (f35 f36 ?v0) (f14 f15 1)) ?v0)))
(assert (= (f24 (f14 f15 0)) f1))
(assert (not (= (f24 (f14 f15 1)) f1)))
(assert (forall ((?v0 S8)) (= (= (f24 (f14 f15 (+ (f29 f30 ?v0) 1))) f1) (not (= (f24 ?v0) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (not (= (f24 (f14 f15 (+ (f29 f30 ?v0) (f29 f30 ?v1)))) f1)) (not (= (not (= (f24 ?v0) f1)) (not (= (f24 ?v1) f1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f24 (f14 f15 (+ (f29 f30 ?v0) (f29 f30 ?v1)))) f1) (= (= (f24 ?v0) f1) (= (f24 ?v1) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_1 (f29 f30 ?v1)) (?v_0 (f29 f30 ?v0)) (?v_2 (= (f24 ?v0) f1)) (?v_3 (= (f24 ?v1) f1))) (= (= (f24 (f14 f15 (- ?v_0 ?v_1))) f1) (or (< ?v_0 ?v_1) (or (and ?v_2 ?v_3) (and (not ?v_2) (not ?v_3))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (= (f24 ?v0) f1)) (?v_1 (= (f24 ?v1) f1))) (= (= (f24 (f14 f15 (+ (f29 f30 ?v0) (f29 f30 ?v1)))) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 S8)) (=> (not (= (f24 ?v0) f1)) (< 0 (f29 f30 ?v0)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 0 ?v_0) (= (= (f24 ?v0) f1) (not (= (f24 (f14 f15 (- ?v_0 1))) f1)))))))
(assert (forall ((?v0 S4)) (= (f16 (f38 f39 (f14 f15 (+ 0 1))) ?v0) ?v0)))
(assert (forall ((?v0 S8) (?v1 S4)) (let ((?v_0 (f38 f39 ?v0))) (=> (< 0 (f29 f30 ?v0)) (= (f16 ?v_0 (f16 f20 ?v1)) (f16 f20 (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S4)) (let ((?v_0 (f38 f39 ?v0))) (=> (< 0 (f29 f30 ?v0)) (= (= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_1 (f38 f39 ?v0)) (?v_0 (f38 f39 ?v1))) (=> (< 0 (f29 f30 ?v0)) (=> (< 0 (f29 f30 ?v1)) (= (f16 ?v_1 (f16 ?v_0 ?v2)) (f16 ?v_0 (f16 ?v_1 ?v2))))))))
(assert (forall ((?v0 S8)) (= (f42 (f43 f44 f23) (f14 f15 (+ (f29 f30 ?v0) 1))) f23)))
(assert (forall ((?v0 S8)) (= (f29 (f55 f56 0) (f14 f15 (+ (f29 f30 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 f12) (f14 f15 (+ (f29 f30 ?v0) 1))) f12)))
(assert (forall ((?v0 S8)) (= (f49 (f50 f54 f25) (f14 f15 (+ (f29 f30 ?v0) 1))) f25)))
(assert (forall ((?v0 S4) (?v1 S8)) (= (= (f42 (f43 f44 ?v0) ?v1) f23) (and (= ?v0 f23) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f29 (f55 f56 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S3) (?v1 S8)) (= (= (f34 (f35 f36 ?v0) ?v1) f12) (and (= ?v0 f12) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f49 (f50 f54 ?v0) ?v1) f25) (and (= ?v0 f25) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (not (= ?v0 f23)) (not (= (f42 (f43 f44 ?v0) ?v1) f23)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f29 (f55 f56 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (not (= ?v0 f12)) (not (= (f34 (f35 f36 ?v0) ?v1) f12)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f50 f54 ?v0))) (= (f49 ?v_0 (f14 f15 (+ (f29 f30 ?v1) 1))) (f49 (f50 f51 ?v0) (f49 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f43 f44 ?v0))) (= (f42 ?v_0 (f14 f15 (+ (f29 f30 ?v1) 1))) (f16 (f21 f45 ?v0) (f42 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f14 f15 (+ (f29 f30 ?v1) 1))) (f5 (f6 f47 ?v0) (f34 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f29 ?v_0 (f14 f15 (+ (f29 f30 ?v1) 1))) (* ?v0 (f29 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f50 f54 ?v0))) (= (f49 ?v_0 (f14 f15 (+ (f29 f30 ?v1) 1))) (f49 (f50 f51 (f49 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f43 f44 ?v0))) (= (f42 ?v_0 (f14 f15 (+ (f29 f30 ?v1) 1))) (f16 (f21 f45 (f42 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f14 f15 (+ (f29 f30 ?v1) 1))) (f5 (f6 f47 (f34 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f29 ?v_0 (f14 f15 (+ (f29 f30 ?v1) 1))) (* (f29 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f50 f54 ?v0))) (= (f49 ?v_0 (f14 f15 (+ (f29 f30 ?v1) (f29 f30 ?v2)))) (f49 (f50 f51 (f49 ?v_0 ?v1)) (f49 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f43 f44 ?v0))) (= (f42 ?v_0 (f14 f15 (+ (f29 f30 ?v1) (f29 f30 ?v2)))) (f16 (f21 f45 (f42 ?v_0 ?v1)) (f42 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f14 f15 (+ (f29 f30 ?v1) (f29 f30 ?v2)))) (f5 (f6 f47 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f29 ?v_0 (f14 f15 (+ (f29 f30 ?v1) (f29 f30 ?v2)))) (* (f29 ?v_0 ?v1) (f29 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f49 (f50 f54 ?v0) ?v1))) (= (f49 (f50 f51 ?v_0) ?v0) (f49 (f50 f51 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f42 (f43 f44 ?v0) ?v1))) (= (f16 (f21 f45 ?v_0) ?v0) (f16 (f21 f45 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f34 (f35 f36 ?v0) ?v1))) (= (f5 (f6 f47 ?v_0) ?v0) (f5 (f6 f47 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f29 (f55 f56 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f49 (f50 f54 (f49 (f50 f51 ?v0) ?v1)) ?v2) (f49 (f50 f51 (f49 (f50 f54 ?v0) ?v2)) (f49 (f50 f54 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f42 (f43 f44 (f16 (f21 f45 ?v0) ?v1)) ?v2) (f16 (f21 f45 (f42 (f43 f44 ?v0) ?v2)) (f42 (f43 f44 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S8)) (= (f34 (f35 f36 (f5 (f6 f47 ?v0) ?v1)) ?v2) (f5 (f6 f47 (f34 (f35 f36 ?v0) ?v2)) (f34 (f35 f36 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f29 (f55 f56 (* ?v0 ?v1)) ?v2) (* (f29 (f55 f56 ?v0) ?v2) (f29 (f55 f56 ?v1) ?v2)))))
(assert (forall ((?v0 S3)) (= (f34 (f35 f36 ?v0) (f14 f15 0)) f18)))
(assert (forall ((?v0 Int)) (= (f29 (f55 f56 ?v0) (f14 f15 0)) 1)))
(assert (forall ((?v0 S4)) (= (f42 (f43 f44 ?v0) (f14 f15 0)) f11)))
(assert (forall ((?v0 S8)) (= (f49 (f50 f54 ?v0) (f14 f15 0)) f26)))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f29 (f55 f56 1) ?v0) 1)))
(assert (forall ((?v0 S8)) (= (f42 (f43 f44 f11) ?v0) f11)))
(assert (forall ((?v0 S8)) (= (f49 (f50 f54 f26) ?v0) f26)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f42 (f43 f44 (f16 (f21 f22 ?v0) ?v1)) ?v2) (f16 (f21 f22 (f42 (f43 f44 ?v0) ?v2)) (f42 (f43 f44 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S8)) (= (f34 (f35 f36 (f5 (f6 f7 ?v0) ?v1)) ?v2) (f5 (f6 f7 (f34 (f35 f36 ?v0) ?v2)) (f34 (f35 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f50 f54 ?v0))) (= (f49 ?v_0 (f14 f15 (* (f29 f30 ?v1) (f29 f30 ?v2)))) (f49 (f50 f54 (f49 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f43 f44 ?v0))) (= (f42 ?v_0 (f14 f15 (* (f29 f30 ?v1) (f29 f30 ?v2)))) (f42 (f43 f44 (f42 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f14 f15 (* (f29 f30 ?v1) (f29 f30 ?v2)))) (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (= (f24 ?v0) f1) (= (f42 (f43 f44 (f16 f20 ?v1)) ?v0) (f42 (f43 f44 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (< 0 (f29 f30 ?v0)) (= (= (f16 (f38 f39 ?v0) ?v1) f23) (= ?v1 f23)))))
(assert (forall ((?v0 S8)) (= (f16 (f38 f39 ?v0) f23) f23)))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S4)) (let ((?v_0 (f38 f39 ?v0))) (=> (< 0 (f29 f30 ?v0)) (= (= (f40 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (= (f40 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S4)) (let ((?v_0 (f38 f39 ?v0))) (=> (< 0 (f29 f30 ?v0)) (=> (= (f40 ?v1 ?v2) f1) (= (f40 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S8)) (= (= (f24 ?v0) f1) (exists ((?v1 S8)) (= ?v0 (f14 f15 (* (+ (+ 0 1) 1) (f29 f30 ?v1))))))))
(assert (forall ((?v0 S8)) (= (= (f24 ?v0) f1) (exists ((?v1 S8)) (= ?v0 (f14 f15 (* 2 (f29 f30 ?v1))))))))
(assert (forall ((?v0 S8)) (= (not (= (f24 ?v0) f1)) (exists ((?v1 S8)) (= ?v0 (f14 f15 (+ (* (+ (+ 0 1) 1) (f29 f30 ?v1)) 1)))))))
(assert (forall ((?v0 S8)) (= (not (= (f24 ?v0) f1)) (exists ((?v1 S8)) (= ?v0 (f14 f15 (+ (* 2 (f29 f30 ?v1)) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f24 (f14 f15 (* (f29 f30 ?v0) (f29 f30 ?v1)))) f1) (or (= (f24 ?v0) f1) (= (f24 ?v1) f1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f29 f30 ?v0)) (?v_1 (f29 f30 ?v1))) (=> (< 0 ?v_0) (=> (< 0 ?v_1) (= (f16 (f38 f39 (f14 f15 (* ?v_0 ?v_1))) ?v2) (f16 (f38 f39 ?v0) (f16 (f38 f39 ?v1) ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S8)) (let ((?v_0 (f38 f39 ?v0))) (=> (< 0 (f29 f30 ?v0)) (= (f16 ?v_0 (f42 (f43 f44 ?v1) ?v2)) (f42 (f43 f44 (f16 ?v_0 ?v1)) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (< 0 (f29 f30 ?v0)) (= (= (f16 (f38 f39 ?v0) ?v1) f11) (= ?v1 f11)))))
(assert (forall ((?v0 S8)) (=> (< 0 (f29 f30 ?v0)) (= (f16 (f38 f39 ?v0) f11) f11))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S4)) (let ((?v_0 (f38 f39 ?v0))) (=> (< 0 (f29 f30 ?v0)) (= (f16 ?v_0 (f16 (f21 f22 ?v1) ?v2)) (f16 (f21 f22 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (= (f40 f23 ?v0) f1) (= (f40 f23 (f42 (f43 f44 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (< 0 (f29 (f55 f56 ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f25 ?v0) f1) (= (f53 f25 (f49 (f50 f54 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 f12) ?v0) (ite (= ?v0 (f14 f15 0)) f18 f12))))
(assert (forall ((?v0 S8)) (= (f29 (f55 f56 0) ?v0) (ite (= ?v0 (f14 f15 0)) 1 0))))
(assert (forall ((?v0 S8)) (= (f42 (f43 f44 f23) ?v0) (ite (= ?v0 (f14 f15 0)) f11 f23))))
(assert (forall ((?v0 S8)) (= (f49 (f50 f54 f25) ?v0) (ite (= ?v0 (f14 f15 0)) f26 f25))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f55 f56 ?v2))) (=> (< (f29 f30 ?v0) (f29 f30 ?v1)) (=> (< 1 ?v2) (< (f29 ?v_0 ?v0) (f29 ?v_0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f43 f44 ?v2))) (=> (< (f29 f30 ?v0) (f29 f30 ?v1)) (=> (= (f40 f11 ?v2) f1) (= (f40 (f42 ?v_0 ?v0) (f42 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f50 f54 ?v2))) (=> (< (f29 f30 ?v0) (f29 f30 ?v1)) (=> (= (f53 f26 ?v2) f1) (= (f53 (f49 ?v_0 ?v0) (f49 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f55 f56 ?v0))) (=> (< 1 ?v0) (=> (< (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) (< (f29 f30 ?v1) (f29 f30 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f43 f44 ?v0))) (=> (= (f40 f11 ?v0) f1) (=> (= (f40 (f42 ?v_0 ?v1) (f42 ?v_0 ?v2)) f1) (< (f29 f30 ?v1) (f29 f30 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f50 f54 ?v0))) (=> (= (f53 f26 ?v0) f1) (=> (= (f53 (f49 ?v_0 ?v1) (f49 ?v_0 ?v2)) f1) (< (f29 f30 ?v1) (f29 f30 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (=> (< 0 (f29 f30 ?v1)) (< 1 (f29 (f55 f56 ?v0) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (= (f40 f11 ?v0) f1) (=> (< 0 (f29 f30 ?v1)) (= (f40 f11 (f42 (f43 f44 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f26 ?v0) f1) (=> (< 0 (f29 f30 ?v1)) (= (f53 f26 (f49 (f50 f54 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f55 f56 ?v0))) (=> (< 1 ?v0) (= (< (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) (< (f29 f30 ?v1) (f29 f30 ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f43 f44 ?v0))) (=> (= (f40 f11 ?v0) f1) (= (= (f40 (f42 ?v_0 ?v1) (f42 ?v_0 ?v2)) f1) (< (f29 f30 ?v1) (f29 f30 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f50 f54 ?v0))) (=> (= (f53 f26 ?v0) f1) (= (= (f53 (f49 ?v_0 ?v1) (f49 ?v_0 ?v2)) f1) (< (f29 f30 ?v1) (f29 f30 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f55 f56 ?v0))) (=> (< 1 ?v0) (= (= (f29 ?v_0 ?v1) (f29 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f43 f44 ?v0))) (=> (= (f40 f11 ?v0) f1) (= (= (f42 ?v_0 ?v1) (f42 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f50 f54 ?v0))) (=> (= (f53 f26 ?v0) f1) (= (= (f49 ?v_0 ?v1) (f49 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (f29 (f55 f56 ?v0) (f14 f15 (+ (f29 f30 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (= (f40 f11 ?v0) f1) (= (f40 f11 (f42 (f43 f44 ?v0) (f14 f15 (+ (f29 f30 ?v1) 1)))) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f26 ?v0) f1) (= (f53 f26 (f49 (f50 f54 ?v0) (f14 f15 (+ (f29 f30 ?v1) 1)))) f1))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f29 f30 ?v2)) (?v_1 (f29 f30 ?v1)) (?v_2 (f43 f44 ?v0))) (=> (not (= ?v0 f23)) (=> (<= ?v_1 ?v_0) (= (f42 ?v_2 (f14 f15 (- ?v_0 ?v_1))) (f16 (f21 f22 (f42 ?v_2 ?v2)) (f42 ?v_2 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f29 f30 ?v2)) (?v_1 (f29 f30 ?v1)) (?v_2 (f35 f36 ?v0))) (=> (not (= ?v0 f12)) (=> (<= ?v_1 ?v_0) (= (f34 ?v_2 (f14 f15 (- ?v_0 ?v_1))) (f5 (f6 f7 (f34 ?v_2 ?v2)) (f34 ?v_2 ?v1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (=> (not (= ?v0 f23)) (= (f42 (f43 f44 (f16 (f21 f22 ?v1) ?v0)) ?v2) (f16 (f21 f22 (f42 (f43 f44 ?v1) ?v2)) (f42 (f43 f44 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S8)) (=> (not (= ?v0 f12)) (= (f34 (f35 f36 (f5 (f6 f7 ?v1) ?v0)) ?v2) (f5 (f6 f7 (f34 (f35 f36 ?v1) ?v2)) (f34 (f35 f36 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f6 f7 f18))) (= (f5 ?v_0 (f34 (f35 f36 ?v0) ?v1)) (f34 (f35 f36 (f5 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f21 f22 f11))) (= (f16 ?v_0 (f42 (f43 f44 ?v0) ?v1)) (f42 (f43 f44 (f16 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (< 0 (f29 f30 ?v0)) (=> (= (f40 f23 ?v1) f1) (= (f40 f23 (f16 (f38 f39 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (< 0 (f29 f30 ?v0)) (= (= (f40 (f16 (f38 f39 ?v0) ?v1) f23) f1) (= (f40 ?v1 f23) f1)))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (< 0 (f29 f30 ?v0)) (= (= (f40 f23 (f16 (f38 f39 ?v0) ?v1)) f1) (= (f40 f23 ?v1) f1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f29 f30 ?v1)) (=> (= (f40 f11 ?v2) f1) (= (f40 (f16 (f38 f39 ?v1) ?v2) (f16 (f38 f39 ?v0) ?v2)) f1)))))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (< 0 (f29 f30 ?v0)) (= (= (f40 (f16 (f38 f39 ?v0) ?v1) f11) f1) (= (f40 ?v1 f11) f1)))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (< 0 (f29 f30 ?v0)) (= (= (f40 f11 (f16 (f38 f39 ?v0) ?v1)) f1) (= (f40 f11 ?v1) f1)))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (not (= (f24 ?v0) f1)) (= (f16 (f38 f39 ?v0) (f42 (f43 f44 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 S8) (?v1 S4)) (=> (not (= (f24 ?v0) f1)) (= (f42 (f43 f44 (f16 (f38 f39 ?v0) ?v1)) ?v0) ?v1))))
(assert (forall ((?v0 S8) (?v1 S4) (?v2 S4)) (=> (not (= (f24 ?v0) f1)) (=> (= (f42 (f43 f44 ?v1) ?v0) ?v2) (= (f16 (f38 f39 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f29 (f55 f56 ?v0) (f14 f15 (+ (f29 f30 ?v1) 1))) 1)))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (= (f40 f23 ?v0) f1) (=> (= (f40 ?v0 f11) f1) (= (f40 (f42 (f43 f44 ?v0) (f14 f15 (+ (f29 f30 ?v1) 1))) f11) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f25 ?v0) f1) (=> (= (f53 ?v0 f26) f1) (= (f53 (f49 (f50 f54 ?v0) (f14 f15 (+ (f29 f30 ?v1) 1))) f26) f1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f55 f56 ?v2))) (=> (< (f29 f30 ?v0) (f29 f30 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f29 ?v_0 ?v1) (f29 ?v_0 ?v0))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f43 f44 ?v2))) (=> (< (f29 f30 ?v0) (f29 f30 ?v1)) (=> (= (f40 f23 ?v2) f1) (=> (= (f40 ?v2 f11) f1) (= (f40 (f42 ?v_0 ?v1) (f42 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f50 f54 ?v2))) (=> (< (f29 f30 ?v0) (f29 f30 ?v1)) (=> (= (f53 f25 ?v2) f1) (=> (= (f53 ?v2 f26) f1) (= (f53 (f49 ?v_0 ?v1) (f49 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f29 (f55 f56 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (* ?v0 ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f42 (f43 f44 ?v0) ?v1))) (=> (= (f40 f11 ?v0) f1) (= (f40 ?v_0 (f16 (f21 f45 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f49 (f50 f54 ?v0) ?v1))) (=> (= (f53 f26 ?v0) f1) (= (f53 ?v_0 (f49 (f50 f51 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (* ?v0 (f29 (f55 f56 ?v0) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (= (f40 f11 ?v0) f1) (= (f40 f11 (f16 (f21 f45 ?v0) (f42 (f43 f44 ?v0) ?v1))) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f53 f26 ?v0) f1) (= (f53 f26 (f49 (f50 f51 ?v0) (f49 (f50 f54 ?v0) ?v1))) f1))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (= (f40 (f42 (f43 f44 ?v0) ?v1) f23) f1) (and (not (= (f24 ?v1) f1)) (= (f40 ?v0 f23) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (< (f29 (f55 f56 ?v0) ?v1) 0) (and (not (= (f24 ?v1) f1)) (< ?v0 0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (= (f40 ?v0 f23) f1) (= (f40 (f42 (f43 f44 ?v0) (f14 f15 (+ (* 2 (f29 f30 ?v1)) 1))) f23) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< ?v0 0) (< (f29 (f55 f56 ?v0) (f14 f15 (+ (* 2 (f29 f30 ?v1)) 1))) 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f14 f15 2))) (= (= (f40 f23 (f16 (f21 f48 (f42 (f43 f44 ?v0) ?v_0)) (f42 (f43 f44 ?v1) ?v_0))) f1) (or (not (= ?v0 f23)) (not (= ?v1 f23)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (< 0 (+ (f29 (f55 f56 ?v0) ?v_0) (f29 (f55 f56 ?v1) ?v_0))) (or (not (= ?v0 0)) (not (= ?v1 0)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f14 f15 2))) (not (= (f40 (f16 (f21 f48 (f42 (f43 f44 ?v0) ?v_0)) (f42 (f43 f44 ?v1) ?v_0)) f23) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (not (< (+ (f29 (f55 f56 ?v0) ?v_0) (f29 (f55 f56 ?v1) ?v_0)) 0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f29 f30 ?v0)) (<= ?v_0 (f29 f30 (f49 (f50 f54 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f50 f54 ?v0))) (=> (< 0 (f29 f30 ?v0)) (=> (< (f29 f30 (f49 ?v_0 ?v1)) (f29 f30 (f49 ?v_0 ?v2))) (< (f29 f30 ?v1) (f29 f30 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f14 f15 (+ 0 1)))) (= (= (f49 (f50 f54 ?v0) ?v1) ?v_0) (or (= ?v1 (f14 f15 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f14 f15 (+ 0 1)))) (= (f49 (f50 f54 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (< 0 (f29 f30 (f49 (f50 f54 ?v0) ?v1))) (or (= ?v1 (f14 f15 0)) (< 0 (f29 f30 ?v0))))))
(assert (forall ((?v0 S8)) (= (f14 f15 (f29 f30 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f29 f30 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f29 f30 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
