(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S3)
(declare-fun f7 (S5 S6) S3)
(declare-fun f8 () S5)
(declare-fun f9 (S7 S6) S6)
(declare-fun f10 (S8 S6) S7)
(declare-fun f11 () S8)
(declare-fun f12 (S9 S3) S6)
(declare-fun f13 () S9)
(declare-fun f14 () S6)
(declare-fun f15 () S3)
(declare-fun f16 () S10)
(declare-fun f17 (S11 Int) S10)
(declare-fun f18 () S11)
(declare-fun f19 () S6)
(declare-fun f20 (S12 S3) S3)
(declare-fun f21 () S12)
(declare-fun f22 () S12)
(declare-fun f23 (S13 S3) S12)
(declare-fun f24 () S13)
(declare-fun f25 (S14 S10) S1)
(declare-fun f26 () S14)
(declare-fun f27 () S6)
(declare-fun f28 () S12)
(declare-fun f29 (S15 S10) Int)
(declare-fun f30 () S15)
(declare-fun f31 () S10)
(declare-fun f32 (S16 Int) Int)
(declare-fun f33 () S16)
(declare-fun f34 () S13)
(declare-fun f35 () S8)
(declare-fun f36 (S17 Int) S16)
(declare-fun f37 () S17)
(declare-fun f38 () S13)
(declare-fun f39 () S17)
(declare-fun f40 () S13)
(declare-fun f41 () S4)
(declare-fun f42 () S12)
(declare-fun f43 () S7)
(declare-fun f44 () S16)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 f6) (f7 f8 (f9 (f10 f11 (f12 f13 (f7 f8 f14))) f14))) f1)))
(assert (= (f7 f8 (f9 (f10 f11 (f12 f13 (f7 f8 f14))) f14)) f15))
(assert (not (= f16 (f17 f18 0))))
(assert (= (f7 f8 (f9 (f10 f11 (f12 f13 (f7 f8 f14))) f14)) f15))
(assert (not (= f14 f19)))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f20 f21 ?v0)) f6) f1) (= ?v0 f6))))
(assert (forall ((?v0 S6)) (= (= (f3 (f4 f5 (f7 f8 ?v0)) f6) f1) (= ?v0 f19))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f20 f22 (f20 (f23 f24 ?v1) ?v0)) (f20 (f23 f24 (f20 f22 ?v1)) (f20 f22 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f12 f13 (f20 (f23 f24 ?v1) ?v0)) (f9 (f10 f11 (f12 f13 ?v1)) (f12 f13 ?v0))))))
(assert (= (f20 f22 f6) f6))
(assert (= (f12 f13 f6) f19))
(assert (= (f20 f22 f6) f6))
(assert (= (f12 f13 f6) f19))
(assert (forall ((?v0 S3)) (= (= (f20 f22 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S3)) (= (= (f12 f13 ?v0) f19) (= ?v0 f6))))
(assert (forall ((?v0 S6)) (= (f3 (f4 f5 f6) (f7 f8 ?v0)) f1)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f6) (f20 f21 ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f20 f21 (f20 (f23 f24 ?v1) ?v0)) (f20 (f23 f24 (f20 f21 ?v1)) (f20 f21 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f19)) (= (f7 f8 (f9 (f10 f11 ?v1) ?v0)) (f20 (f23 f24 (f7 f8 ?v1)) (f7 f8 ?v0))))))
(assert (forall ((?v0 S3)) (= (= (f20 f21 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S6)) (= (= (f7 f8 ?v0) f6) (= ?v0 f19))))
(assert (= (f20 f21 f6) f6))
(assert (= (f7 f8 f19) f6))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f20 (f23 f24 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 (f4 f5 ?v1) f6) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 (f4 f5 (f20 (f23 f24 ?v0) ?v1)) f6) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f6) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f20 (f23 f24 ?v0) ?v2)) (f20 (f23 f24 ?v1) ?v2)) f1)))))
(assert (not (= (f25 f26 f16) f1)))
(assert (= (f7 f8 f27) f15))
(assert (= (f20 f21 f15) f15))
(assert (= (f20 f22 f15) f15))
(assert (= (f12 f13 f15) f27))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f28 (f20 (f23 f24 ?v0) ?v1)) (f20 (f23 f24 (f20 f28 ?v0)) (f20 f28 ?v1)))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f7 f8 ?v0))) (= (f20 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f20 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f20 f22 ?v0) (f20 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f12 f13 ?v0) (f12 f13 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f20 f28 (f20 (f23 f24 ?v1) ?v0)) (f20 (f23 f24 (f20 f28 ?v1)) (f20 f28 ?v0))))))
(assert (forall ((?v0 S3)) (= (f20 (f23 f24 f6) ?v0) f6)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f19) ?v0) f19)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f7 f8 (f9 (f10 f11 ?v0) ?v1)) (f20 (f23 f24 (f7 f8 ?v0)) (f7 f8 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f21 (f20 (f23 f24 ?v0) ?v1)) (f20 (f23 f24 (f20 f21 ?v0)) (f20 f21 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f22 (f20 (f23 f24 ?v0) ?v1)) (f20 (f23 f24 (f20 f22 ?v0)) (f20 f22 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f12 f13 (f20 (f23 f24 ?v0) ?v1)) (f9 (f10 f11 (f12 f13 ?v0)) (f12 f13 ?v1)))))
(assert (forall ((?v0 S3)) (= (f20 f21 (f20 f22 ?v0)) (f20 f28 ?v0))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f12 f13 ?v0)) (f20 f28 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f20 (f23 f24 ?v1) ?v2)) (f20 (f23 f24 ?v0) ?v2)) f1)))))
(assert (= f16 (f17 f18 (+ (* 2 (f29 f30 f31)) 1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f20 (f23 f24 ?v0) ?v1)) f1) (and (or (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)) (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f6) f1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f19)) (= (= (f9 (f10 f11 ?v1) ?v0) f27) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (= (f20 (f23 f24 ?v1) ?v0) f15) (= ?v1 ?v0)))))
(assert (forall ((?v0 S6)) (=> (not (= ?v0 f19)) (= (f9 (f10 f11 ?v0) ?v0) f27))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f6)) (= (f20 (f23 f24 ?v0) ?v0) f15))))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 ?v0) ?v0) (ite (= ?v0 f19) f19 f27))))
(assert (forall ((?v0 S3)) (= (f20 (f23 f24 ?v0) ?v0) (ite (= ?v0 f6) f6 f15))))
(assert (= (f3 (f4 f5 f6) f15) f1))
(assert (<= 0 1))
(assert (not (= (f3 (f4 f5 f15) f6) f1)))
(assert (not (<= 1 0)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (not (= f6 f15)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 ?v0) f27) ?v0)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f24 ?v0) f15) ?v0)))
(assert (=> (forall ((?v0 S10)) (=> (= f16 (f17 f18 (+ (* 2 (f29 f30 ?v0)) 1))) false)) false))
(assert (exists ((?v0 S10)) (= f16 (f17 f18 (+ (* 2 (f29 f30 ?v0)) 1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f32 f33 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f20 f28 ?v0))) (= (f20 (f23 f34 ?v_0) ?v_0) (f20 (f23 f34 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f32 f33 (* ?v0 ?v1)) (* (f32 f33 ?v0) (f32 f33 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f28 (f20 (f23 f34 ?v0) ?v1)) (f20 (f23 f34 (f20 f28 ?v0)) (f20 f28 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f7 f8 (f9 (f10 f35 ?v0) ?v1)) (f20 (f23 f34 (f7 f8 ?v0)) (f7 f8 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f21 (f20 (f23 f34 ?v0) ?v1)) (f20 (f23 f34 (f20 f21 ?v0)) (f20 f21 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f22 (f20 (f23 f34 ?v0) ?v1)) (f20 (f23 f34 (f20 f22 ?v0)) (f20 f22 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f12 f13 (f20 (f23 f34 ?v0) ?v1)) (f9 (f10 f35 (f12 f13 ?v0)) (f12 f13 ?v1)))))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 f6) ?v0) f6)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f35 f19) ?v0) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 ?v0) f6) f6)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f35 ?v0) f19) f19)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f20 (f23 f34 ?v0) ?v1) f6) (or (= ?v0 f6) (= ?v1 f6)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f9 (f10 f35 ?v0) ?v1) f19) (or (= ?v0 f19) (= ?v1 f19)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (=> (not (= ?v1 f6)) (not (= (f20 (f23 f34 ?v0) ?v1) f6))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f19)) (=> (not (= ?v1 f19)) (not (= (f9 (f10 f35 ?v0) ?v1) f19))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f20 (f23 f34 ?v0) ?v1) f6) (or (= ?v0 f6) (= ?v1 f6)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f9 (f10 f35 ?v0) ?v1) f19) (or (= ?v0 f19) (= ?v1 f19)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f35 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v0))) (= (f20 ?v_0 (f20 (f23 f24 ?v1) ?v2)) (f20 (f23 f24 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f3 (f4 f5 (f7 f8 (f9 (f10 f35 ?v0) ?v1))) (f20 (f23 f34 (f7 f8 ?v0)) (f7 f8 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f20 f21 (f20 (f23 f34 ?v0) ?v1))) (f20 (f23 f34 (f20 f21 ?v0)) (f20 f21 ?v1))) f1)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 f6) ?v0) f6)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f35 f19) ?v0) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 f6) ?v0) f6)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f35 f19) ?v0) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 ?v0) f6) f6)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f35 ?v0) f19) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 ?v0) f6) f6)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f35 ?v0) f19) f19)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (= (f9 (f10 f35 (f9 (f10 f11 ?v0) ?v1)) (f9 (f10 f11 ?v2) ?v3)) (f9 (f10 f11 (f9 (f10 f35 ?v0) ?v2)) (f9 (f10 f35 ?v1) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f20 (f23 f34 (f20 (f23 f24 ?v0) ?v1)) (f20 (f23 f24 ?v2) ?v3)) (f20 (f23 f24 (f20 (f23 f34 ?v0) ?v2)) (f20 (f23 f34 ?v1) ?v3)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f6) (f20 (f23 f34 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f20 (f23 f34 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 (f4 f5 ?v1) f6) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 (f4 f5 (f20 (f23 f34 ?v0) ?v1)) f6) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f6) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f32 f33 ?v1) ?v0) (f32 f33 (* ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f20 (f23 f34 (f20 f28 ?v1)) ?v0) (f20 f28 (f20 (f23 f34 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f20 (f23 f34 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f20 (f23 f34 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f20 (f23 f34 ?v1) ?v0)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 (f20 (f23 f34 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 f6) (f20 (f23 f34 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f20 (f23 f34 ?v0) ?v2)) (f20 (f23 f34 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f20 (f23 f34 ?v1) ?v2)) (f20 (f23 f34 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f5 (f20 (f23 f34 ?v0) ?v2)) (f20 (f23 f34 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f5 (f20 (f23 f34 ?v0) ?v2)) (f20 (f23 f34 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 (f4 f5 ?v1) f6) f1))) (= (f3 ?v_0 (f20 (f23 f34 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f32 f33 (* ?v0 ?v1)) (* (f32 f33 ?v0) (f32 f33 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (and (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v0) f6) f1)) (or (= (f3 ?v_0 ?v1) f1) (= (f3 (f4 f5 ?v1) f6) f1))) (= (f20 f28 (f20 (f23 f34 ?v0) ?v1)) (f20 (f23 f34 (f20 f28 ?v0)) (f20 f28 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f6) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1))) (= (f3 (f4 f5 (f20 (f23 f34 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (= (= ?v1 (f20 (f23 f24 ?v2) ?v0)) (= (f20 (f23 f34 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f19)) (= (= ?v1 (f9 (f10 f11 ?v2) ?v0)) (= (f9 (f10 f35 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (= (= (f20 (f23 f24 ?v1) ?v0) ?v2) (= ?v1 (f20 (f23 f34 ?v2) ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f19)) (= (= (f9 (f10 f11 ?v1) ?v0) ?v2) (= ?v1 (f9 (f10 f35 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (=> (= ?v1 (f20 (f23 f34 ?v2) ?v0)) (= (f20 (f23 f24 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f19)) (=> (= ?v1 (f9 (f10 f35 ?v2) ?v0)) (= (f9 (f10 f11 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (=> (= (f20 (f23 f34 ?v1) ?v0) ?v2) (= ?v1 (f20 (f23 f24 ?v2) ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f19)) (=> (= (f9 (f10 f35 ?v1) ?v0) ?v2) (= ?v1 (f9 (f10 f11 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) f15) f1) (= (f3 (f4 f5 (f20 (f23 f34 ?v0) ?v1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v0 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) f15) f1) (= (f3 (f4 f5 (f20 (f23 f34 ?v1) ?v0)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v1 ?v0) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= ?v0 (f20 (f23 f24 ?v1) ?v2)) (ite (not (= ?v2 f6)) (= (f20 (f23 f34 ?v0) ?v2) ?v1) (= ?v0 f6)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (= ?v0 (f9 (f10 f11 ?v1) ?v2)) (ite (not (= ?v2 f19)) (= (f9 (f10 f35 ?v0) ?v2) ?v1) (= ?v0 f19)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f20 (f23 f24 ?v0) ?v1) ?v2) (ite (not (= ?v1 f6)) (= ?v0 (f20 (f23 f34 ?v2) ?v1)) (= ?v2 f6)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (= (f9 (f10 f11 ?v0) ?v1) ?v2) (ite (not (= ?v1 f19)) (= ?v0 (f9 (f10 f35 ?v2) ?v1)) (= ?v2 f19)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (= (f20 (f23 f24 (f20 (f23 f34 ?v1) ?v0)) (f20 (f23 f34 ?v2) ?v0)) (f20 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (not (= ?v0 f19)) (= (f9 (f10 f11 (f9 (f10 f35 ?v1) ?v0)) (f9 (f10 f35 ?v2) ?v0)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v0))) (=> (not (= ?v0 f6)) (= (f20 (f23 f24 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) (f20 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f35 ?v0))) (=> (not (= ?v0 f19)) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) (f9 (f10 f11 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f6)) (=> (not (= ?v1 f6)) (= (= (f20 (f23 f24 ?v2) ?v0) (f20 (f23 f24 ?v3) ?v1)) (= (f20 (f23 f34 ?v2) ?v1) (f20 (f23 f34 ?v3) ?v0)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (not (= ?v0 f19)) (=> (not (= ?v1 f19)) (= (= (f9 (f10 f11 ?v2) ?v0) (f9 (f10 f11 ?v3) ?v1)) (= (f9 (f10 f35 ?v2) ?v1) (f9 (f10 f35 ?v3) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f32 (f36 f37 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f20 (f23 f38 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f32 (f36 f39 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f20 (f23 f40 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false))))
(assert (= (f20 f28 f15) f15))
(assert (= (f32 f33 1) 1))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (not (= 1 0)))
(assert (not (= f15 f6)))
(assert (not (= f27 f19)))
(assert (not (= 0 1)))
(assert (not (= f6 f15)))
(assert (not (= f19 f27)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f19) ?v0) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f24 f6) ?v0) f6)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 ?v0) f19) f19)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f24 ?v0) f6) f6)))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f5 f6) ?v0) f1) (forall ((?v1 S3) (?v2 S3)) (= (f3 (f4 f5 (f20 f21 (f20 (f23 f34 ?v1) ?v2))) (f20 (f23 f34 (f20 (f23 f34 (f20 f21 ?v1)) (f20 f21 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f5 f6) ?v0) f1) (forall ((?v1 S6) (?v2 S6)) (= (f3 (f4 f5 (f7 f8 (f9 (f10 f35 ?v1) ?v2))) (f20 (f23 f34 (f20 (f23 f34 (f7 f8 ?v1)) (f7 f8 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f6) ?v1) f1) (forall ((?v2 S3)) (= (f3 (f4 f5 (f20 f21 (f20 (f23 f34 ?v0) ?v2))) (f20 (f23 f34 (f20 f21 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S6)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f6) ?v1) f1) (forall ((?v2 S6)) (= (f3 (f4 f5 (f7 f8 (f9 (f10 f35 ?v0) ?v2))) (f20 (f23 f34 (f7 f8 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f6) ?v1) f1) (forall ((?v2 S3)) (= (f3 (f4 f5 (f20 f21 (f20 (f23 f34 ?v2) ?v0))) (f20 (f23 f34 (f20 f21 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S6)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f6) ?v1) f1) (forall ((?v2 S6)) (= (f3 (f4 f5 (f7 f8 (f9 (f10 f35 ?v2) ?v0))) (f20 (f23 f34 (f7 f8 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S3)) (forall ((?v1 S3) (?v2 S3)) (= (f3 (f4 f5 (f20 f21 (f20 (f23 f34 ?v1) ?v2))) (f20 (f23 f34 (f20 (f23 f34 (f20 f21 ?v1)) (f20 f21 ?v2))) ?v0)) f1))))
(assert (exists ((?v0 S3)) (forall ((?v1 S6) (?v2 S6)) (= (f3 (f4 f5 (f7 f8 (f9 (f10 f35 ?v1) ?v2))) (f20 (f23 f34 (f20 (f23 f34 (f7 f8 ?v1)) (f7 f8 ?v2))) ?v0)) f1))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (f3 (f4 f5 (f20 f21 (f20 (f23 f34 ?v0) ?v2))) (f20 (f23 f34 (f20 f21 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S6)) (exists ((?v1 S3)) (forall ((?v2 S6)) (= (f3 (f4 f5 (f7 f8 (f9 (f10 f35 ?v0) ?v2))) (f20 (f23 f34 (f7 f8 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (f3 (f4 f5 (f20 f21 (f20 (f23 f34 ?v2) ?v0))) (f20 (f23 f34 (f20 f21 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S6)) (exists ((?v1 S3)) (forall ((?v2 S6)) (= (f3 (f4 f5 (f7 f8 (f9 (f10 f35 ?v2) ?v0))) (f20 (f23 f34 (f7 f8 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f25 f26 (f17 f18 (* (f29 f30 ?v0) (f29 f30 ?v1)))) f1) (or (= (f25 f26 ?v0) f1) (= (f25 f26 ?v1) f1)))))
(assert (forall ((?v0 S10)) (= (not (= (f25 f26 ?v0) f1)) (exists ((?v1 S10)) (= ?v0 (f17 f18 (+ (* 2 (f29 f30 ?v1)) 1)))))))
(assert (forall ((?v0 S10)) (= (not (= (f25 f26 ?v0) f1)) (exists ((?v1 S10)) (= ?v0 (f17 f18 (+ (* (+ (+ 0 1) 1) (f29 f30 ?v1)) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v0))) (= (f20 (f23 f34 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f23 f34 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 (f23 f34 ?v0) ?v1) (f20 (f23 f34 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v0))) (=> (not (= ?v0 f6)) (= (= (f20 ?v_0 ?v1) (f20 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f6)) (= (= (f20 (f23 f34 ?v1) ?v0) (f20 (f23 f34 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 f15) ?v0) ?v0)))
(assert (= (f25 f26 (f17 f18 0)) f1))
(assert (not (= (f25 f26 (f17 f18 1)) f1)))
(assert (forall ((?v0 S10)) (= (= (f25 f26 (f17 f18 (+ (f29 f30 ?v0) 1))) f1) (not (= (f25 f26 ?v0) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (not (= (f25 f26 (f17 f18 (+ (f29 f30 ?v0) (f29 f30 ?v1)))) f1)) (not (= (not (= (f25 f26 ?v0) f1)) (not (= (f25 f26 ?v1) f1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f25 f26 (f17 f18 (+ (f29 f30 ?v0) (f29 f30 ?v1)))) f1) (= (= (f25 f26 ?v0) f1) (= (f25 f26 ?v1) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_1 (f29 f30 ?v1)) (?v_0 (f29 f30 ?v0)) (?v_2 (= (f25 f26 ?v0) f1)) (?v_3 (= (f25 f26 ?v1) f1))) (= (= (f25 f26 (f17 f18 (- ?v_0 ?v_1))) f1) (or (< ?v_0 ?v_1) (or (and ?v_2 ?v_3) (and (not ?v_2) (not ?v_3))))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (= (f25 f26 ?v0) f1)) (?v_1 (= (f25 f26 ?v1) f1))) (= (= (f25 f26 (f17 f18 (+ (f29 f30 ?v0) (f29 f30 ?v1)))) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 S10)) (=> (not (= (f25 f26 ?v0) f1)) (< 0 (f29 f30 ?v0)))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 0 ?v_0) (= (= (f25 f26 ?v0) f1) (not (= (f25 f26 (f17 f18 (- ?v_0 1))) f1)))))))
(assert (forall ((?v0 S10)) (= (= (f25 f26 ?v0) f1) (exists ((?v1 S10)) (= ?v0 (f17 f18 (* (+ (+ 0 1) 1) (f29 f30 ?v1))))))))
(assert (forall ((?v0 S10)) (= (= (f25 f26 ?v0) f1) (exists ((?v1 S10)) (= ?v0 (f17 f18 (* 2 (f29 f30 ?v1))))))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f5 f6) ?v0) f1) (forall ((?v1 S3)) (= (f3 (f4 f5 (f7 f8 (f12 f13 ?v1))) (f20 (f23 f34 (f20 f21 ?v1)) ?v0)) f1)))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f5 f6) ?v0) f1) (forall ((?v1 S3)) (= (f3 (f4 f5 (f20 f21 (f20 f22 ?v1))) (f20 (f23 f34 (f20 f21 ?v1)) ?v0)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f6) ?v1) f1) (forall ((?v2 S3)) (= (f3 (f4 f5 (f20 f21 (f20 (f23 f24 ?v2) ?v0))) (f20 (f23 f34 (f20 f21 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S6)) (exists ((?v1 S3)) (and (= (f3 (f4 f5 f6) ?v1) f1) (forall ((?v2 S6)) (= (f3 (f4 f5 (f7 f8 (f9 (f10 f11 ?v2) ?v0))) (f20 (f23 f34 (f7 f8 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S6) (?v2 S6)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 (f7 f8 ?v1)) (f20 (f23 f34 ?v0) (f7 f8 ?v2))) f1) (= ?v1 f19)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 (f20 f21 ?v1)) (f20 (f23 f34 ?v0) (f20 f21 ?v2))) f1) (= ?v1 f6)))))
(assert (exists ((?v0 S3)) (forall ((?v1 S3)) (= (f3 (f4 f5 (f7 f8 (f12 f13 ?v1))) (f20 (f23 f34 (f20 f21 ?v1)) ?v0)) f1))))
(assert (exists ((?v0 S3)) (forall ((?v1 S3)) (= (f3 (f4 f5 (f20 f21 (f20 f22 ?v1))) (f20 (f23 f34 (f20 f21 ?v1)) ?v0)) f1))))
(assert (forall ((?v0 S3)) (= (f20 f21 ?v0) (f20 f28 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 (f20 f28 ?v1)) (f20 (f23 f34 ?v0) (f20 f28 ?v2))) f1) (= ?v1 f6)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (f3 (f4 f5 (f20 f21 (f20 (f23 f24 ?v2) ?v0))) (f20 (f23 f34 (f20 f21 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S6)) (exists ((?v1 S3)) (forall ((?v2 S6)) (= (f3 (f4 f5 (f7 f8 (f9 (f10 f11 ?v2) ?v0))) (f20 (f23 f34 (f7 f8 ?v2)) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f23 f34 ?v0))) (= (f20 (f23 f24 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v0)) (f20 (f23 f24 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 f15) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 f15) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 f15) ?v0) ?v0)))
(assert (= (f20 f28 f6) f6))
(assert (= (f32 f33 0) 0))
(assert (forall ((?v0 S6)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= f6 ?v0) (= ?v0 f6))))
(assert (forall ((?v0 S3)) (= (= (f20 f28 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= (f32 f33 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) (f20 f28 ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 (f20 f28 ?v0)) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f23 f34 ?v0))) (= (f20 (f23 f34 (f20 ?v_0 ?v1)) (f20 (f23 f34 ?v2) ?v3)) (f20 (f23 f34 (f20 ?v_0 ?v2)) (f20 (f23 f34 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f23 f34 (f20 (f23 f34 ?v0) ?v1))) (?v_0 (f23 f34 ?v2))) (= (f20 ?v_1 (f20 ?v_0 ?v3)) (f20 ?v_0 (f20 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f23 f34 ?v0)) (?v_1 (f20 (f23 f34 ?v2) ?v3))) (= (f20 (f23 f34 (f20 ?v_0 ?v1)) ?v_1) (f20 ?v_0 (f20 (f23 f34 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v0))) (= (f20 (f23 f34 (f20 ?v_0 ?v1)) ?v2) (f20 (f23 f34 (f20 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v0))) (= (f20 (f23 f34 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f23 f34 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v0))) (= (f20 (f23 f34 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f23 f34 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v0))) (= (f20 ?v_0 (f20 (f23 f34 ?v1) ?v2)) (f20 (f23 f34 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f23 f34 ?v0)) (?v_0 (f23 f34 ?v1))) (= (f20 ?v_1 (f20 ?v_0 ?v2)) (f20 ?v_0 (f20 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* ?v1 (* ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 (f23 f34 ?v0) ?v1) (f20 (f23 f34 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 ?v1) (* ?v1 ?v0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3)) (= (= f15 ?v0) (= ?v0 f15))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f6) (f20 f28 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f32 f33 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f20 f28 ?v0)) f6) f1) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (<= (f32 f33 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f20 f28 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f32 f33 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f9 (f10 f35 f19) ?v0) f19)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 f6) ?v0) f6)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f35 ?v0) f19) f19)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 ?v0) f6) f6)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 ?v0) f15) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 ?v0) f15) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 ?v0) f15) ?v0)))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f41 f6) ?v0) f1) (forall ((?v1 S3)) (= (f3 (f4 f5 (f7 f8 (f12 f13 ?v1))) (f20 (f23 f34 (f20 f21 ?v1)) ?v0)) f1)))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f41 f6) ?v0) f1) (forall ((?v1 S3)) (= (f3 (f4 f5 (f20 f21 (f20 f22 ?v1))) (f20 (f23 f34 (f20 f21 ?v1)) ?v0)) f1)))))
(assert (forall ((?v0 S3)) (= (f20 f21 (f20 f42 ?v0)) (ite (= ?v0 f6) f6 f15))))
(assert (forall ((?v0 S6)) (= (f7 f8 (f9 f43 ?v0)) (ite (= ?v0 f19) f6 f15))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (forall ((?v2 S3)) (= (f3 (f4 f5 ?v0) ?v2) f1)) (= (f20 (f23 f38 ?v1) ?v0) ?v1))))
(assert (= (f20 f42 f6) f6))
(assert (= (f32 f44 0) 0))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f41 f6) ?v0) f1) (= (f20 f28 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f32 f33 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f41 f6) (f20 f28 ?v0)) f1) (not (= ?v0 f6)))))
(assert (forall ((?v0 Int)) (= (< 0 (f32 f33 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f41 (f20 f28 ?v0)) f6) f1))))
(assert (forall ((?v0 Int)) (not (< (f32 f33 ?v0) 0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f41 f6))) (= (= (f3 ?v_0 (f20 f42 ?v0)) f1) (= (f3 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f32 f44 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f41 (f20 f42 ?v0)) f6) f1) (= (f3 (f4 f41 ?v0) f6) f1))))
(assert (forall ((?v0 Int)) (= (< (f32 f44 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f41 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f41 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f41 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f41 ?v2))) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f41 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f41 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f41 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f41 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f41 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f41 ?v1) ?v2) f1) (= (f3 (f4 f41 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (= (f3 (f4 f41 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (= (f3 (f4 f41 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f41 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (= (not (= (f3 (f4 f41 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (not (= (f3 (f4 f41 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f41 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f41 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f41 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f41 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f41 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f41 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f41 (f20 (f23 f40 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f41 ?v0) ?v2) f1) (= (f3 (f4 f41 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f32 (f36 f39 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f41 (f20 (f23 f38 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f41 ?v0) ?v2) f1) (= (f3 (f4 f41 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f32 (f36 f37 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f41 ?v0))) (= (= (f3 ?v_0 (f20 (f23 f40 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f32 (f36 f39 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f41 ?v0))) (= (= (f3 ?v_0 (f20 (f23 f38 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f32 (f36 f37 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f41 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f41 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f41 ?v0) ?v1) f1)) (or (= (f3 (f4 f41 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f41 ?v0) ?v1) f1) (= (f3 (f4 f41 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f20 f42 ?v0))) (= (f20 f42 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f41 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (= (f20 f42 f15) f15))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f42 (f20 (f23 f34 ?v0) ?v1)) (f20 (f23 f34 (f20 f42 ?v0)) (f20 f42 ?v1)))))
(assert (forall ((?v0 S3)) (= (f20 (f23 f34 (f20 f42 ?v0)) (f20 f28 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (* (f32 f44 ?v0) (f32 f33 ?v0)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f42 (f20 (f23 f34 ?v0) ?v1)) (f20 (f23 f34 (f20 f42 ?v0)) (f20 f42 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f32 f44 (* ?v0 ?v1)) (* (f32 f44 ?v0) (f32 f44 ?v1)))))
(assert (forall ((?v0 S3)) (= (f20 f28 ?v0) (f20 (f23 f34 ?v0) (f20 f42 ?v0)))))
(assert (forall ((?v0 Int)) (= (f32 f33 ?v0) (* ?v0 (f32 f44 ?v0)))))
(assert (forall ((?v0 S3)) (= (f20 f42 ?v0) (f20 (f23 f24 ?v0) (f20 f28 ?v0)))))
(assert (forall ((?v0 S3)) (= (= (f20 f42 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= (f32 f44 ?v0) 0) (= ?v0 0))))
(assert (= (f20 f42 f6) f6))
(assert (= (f9 f43 f19) f19))
(assert (forall ((?v0 S3)) (= (= (f20 f42 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S6)) (= (= (f9 f43 ?v0) f19) (= ?v0 f19))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f41 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f41 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f20 f28 ?v0)) (?v_1 (f20 f28 ?v2))) (=> (= (f3 (f4 f41 ?v_0) ?v1) f1) (=> (= (f3 (f4 f41 ?v_1) ?v3) f1) (= (f3 (f4 f41 (f20 (f23 f34 ?v_0) ?v_1)) (f20 (f23 f34 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f32 f33 ?v0)) (?v_1 (f32 f33 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f41 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f41 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f41 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f41 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f41 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f41 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f41 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f41 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f41 ?v0) ?v1) f1)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f41 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= (f3 (f4 f41 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f41 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f41 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f41 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f3 (f4 f41 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f3 (f4 f41 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f41 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v0) f1) (= (f3 (f4 f41 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f41 ?v1) ?v2) f1) (= (f3 (f4 f41 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f41 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f41 f6) ?v0) f1) (= (f20 f42 ?v0) f15))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f32 f44 ?v0) 1))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f41 f6) ?v0) f1) (= (f20 f42 ?v0) f15))))
(assert (forall ((?v0 Int)) (= (= (f32 f44 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f20 f42 ?v0) f15) (= (f3 (f4 f41 f6) ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f9 f43 (f12 f13 ?v0)) (f12 f13 (f20 f42 ?v0)))))
(assert (forall ((?v0 S3)) (= (f20 f42 (f20 f22 ?v0)) (f20 f22 (f20 f42 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v2))) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (= (f3 (f4 f41 ?v2) f6) f1) (= (f3 (f4 f41 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (= (f3 (f4 f41 ?v2) f6) f1) (= (f3 (f4 f41 (f20 (f23 f34 ?v1) ?v2)) (f20 (f23 f34 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v2))) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (= (f3 (f4 f41 f6) ?v2) f1) (= (f3 (f4 f41 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f23 f34 ?v2))) (=> (= (f3 (f4 f41 ?v0) ?v1) f1) (=> (= (f3 (f4 f41 f6) ?v2) f1) (= (f3 (f4 f41 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S10)) (= (f17 f18 (f29 f30 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f29 f30 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f29 f30 (f17 f18 ?v0)) 0))))
(check-sat)
(exit)
