(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S3 S2) S2)
(declare-fun f6 (S4 S2) S3)
(declare-fun f7 () S4)
(declare-fun f8 () S2)
(declare-fun f9 (S5 Int) S2)
(declare-fun f10 () S5)
(declare-fun f11 (S6 Int) Int)
(declare-fun f12 () S6)
(declare-fun f13 () S6)
(declare-fun f14 () Int)
(declare-fun f15 () S6)
(declare-fun f16 (S7 Int) S8)
(declare-fun f17 () S7)
(declare-fun f18 () S8)
(declare-fun f19 (S9 S8) Int)
(declare-fun f20 () S9)
(declare-fun f21 () S7)
(declare-fun f22 () S3)
(declare-fun f23 () S6)
(declare-fun f24 () S2)
(declare-fun f25 (Int) S1)
(declare-fun f26 (S2) S1)
(declare-fun f27 () S2)
(declare-fun f28 (S8) S1)
(declare-fun f29 () S8)
(declare-fun f30 (S8 S8) S1)
(declare-fun f31 () S3)
(declare-fun f32 () S3)
(declare-fun f33 () S3)
(declare-fun f34 () S3)
(declare-fun f35 () S3)
(declare-fun f36 () S4)
(declare-fun f37 () S4)
(declare-fun f38 (S10 Int) S6)
(declare-fun f39 () S10)
(declare-fun f40 () S10)
(declare-fun f41 (S2 S2) S1)
(declare-fun f42 () S4)
(declare-fun f43 () S2)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 (f6 f7 f8) (f9 f10 (f11 f12 (f11 f13 f14))))) f1)))
(assert (= (f3 f4 f8) f1))
(assert (= (f3 f4 f8) f1))
(assert (forall ((?v0 S2)) (= (= (f3 f4 (f5 (f6 f7 ?v0) (f9 f10 (f11 f12 (f11 f13 f14))))) f1) (= (f3 f4 ?v0) f1))))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (= (f3 f4 (f5 (f6 f7 ?v0) (f9 f10 (f11 f12 (f11 f13 f14))))) f1))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f9 f10 (f11 f13 f14))) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f9 f10 (f11 f13 f14))) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f9 f10 f14)) f4)))
(assert (forall ((?v0 Int)) (= (< 0 (f11 f15 ?v0)) (< f14 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f3 f4 (f9 f10 ?v0)) f1) (< f14 ?v0))))
(assert (forall ((?v0 Int)) (= (< (f11 f15 ?v0) 0) (< ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= (f3 (f9 f10 ?v0) f4) f1) (< ?v0 f14))))
(assert (= 0 0))
(assert (= f4 (f9 f10 f14)))
(assert (= 0 0))
(assert (= (f9 f10 f14) f4))
(assert (= 0 0))
(assert (= (f9 f10 f14) f4))
(assert (= (f16 f17 f14) f18))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) f1) (or (and (= (f3 f4 ?v0) f1) (= (f3 f4 ?v1) f1)) (and (= (f3 ?v0 f4) f1) (= (f3 ?v1 f4) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f5 (f6 f7 ?v0) ?v1) f4) f1) (or (and (= (f3 f4 ?v0) f1) (= (f3 ?v1 f4) f1)) (and (= (f3 ?v0 f4) f1) (= (f3 f4 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f19 f20 (f16 f17 ?v0)) (f19 f20 (f16 f17 ?v1))) (ite (< ?v0 ?v1) (< f14 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f19 f20 (f16 f17 ?v0)) (f19 f20 (f16 f17 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f14)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f21 (+ (f19 f20 (f16 f17 ?v0)) (f19 f20 (f16 f17 ?v1)))) (ite (< ?v0 f14) (f16 f21 (f11 f15 ?v1)) (ite (< ?v1 f14) (f16 f21 (f11 f15 ?v0)) (f16 f21 (f11 f15 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f16 f21 (f11 f15 ?v0)) (f16 f21 0)) (<= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= (f16 f21 0) (f16 f21 (f11 f15 ?v0))) (<= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (< 0 (f19 f20 (f16 f17 ?v0))) (< f14 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 f15 ?v0) (f11 f15 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 f10 ?v0) (f9 f10 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f15 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f16 f17 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f9 f10 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f13 ?v0) (f11 f13 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f13 ?v0) (f11 f13 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f13 ?v0) (f11 f13 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f13 ?v0) (f11 f13 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 f13 ?v0) (f11 f13 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f11 f13 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f11 f13 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f14) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f14) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f14 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* f14 ?v0) f14)))
(assert (= (<= f14 f14) true))
(assert (= (< f14 0) false))
(assert (= (< f14 f14) false))
(assert (= (= f14 f14) true))
(assert (= (- f14) f14))
(assert (= f14 0))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f12 ?v0) (f11 f12 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f12 ?v0) (f11 f12 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f12 ?v0) (f11 f12 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f12 ?v0) (f11 f12 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 f12 ?v0) (f11 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f11 f12 ?v0) (f11 f12 ?v1)) (f11 f12 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f11 f12 ?v0) (f11 f12 ?v1)) (f11 f12 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f11 f12 ?v0) ?v1) (f11 f12 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f11 f12 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f11 f12 ?v0)) (f11 f12 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f11 f12 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 f22 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f22 ?v0)) (f5 f22 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f15 ?v0) (f11 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f9 f10 ?v0) (f9 f10 ?v1)) f1) (< ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f4)) (= (f5 f22 (f5 (f6 f7 ?v1) ?v0)) (f5 (f6 f7 (f5 f22 ?v1)) (f5 f22 ?v0))))))
(assert (forall ((?v0 Int)) (= (<= (f11 f13 ?v0) f14) (< ?v0 f14))))
(assert (forall ((?v0 Int)) (= (< (f11 f13 ?v0) f14) (< ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= (f11 f13 ?v0) f14) false)))
(assert (forall ((?v0 Int)) (= (<= f14 (f11 f13 ?v0)) (<= f14 ?v0))))
(assert (forall ((?v0 Int)) (= (< f14 (f11 f13 ?v0)) (<= f14 ?v0))))
(assert (forall ((?v0 Int)) (= (= f14 (f11 f13 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f13 ?v0) (f11 f12 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f13 ?v0) (f11 f12 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f12 ?v0) (f11 f13 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f12 ?v0) (f11 f13 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f13 ?v0) (f11 f12 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f13 ?v0) (f11 f12 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f12 ?v0) (f11 f13 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f12 ?v0) (f11 f13 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f11 f13 ?v0) (f11 f13 ?v1)) (f11 f12 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f11 f13 ?v0) (f11 f12 ?v1)) (f11 f13 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f11 f13 ?v0) (f11 f12 ?v1)) (f11 f13 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f11 f12 ?v0) (f11 f13 ?v1)) (f11 f13 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 f13 ?v0) (f11 f12 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 f12 ?v0) (f11 f13 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f11 f13 ?v0) ?v1) (+ (f11 f12 (* ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 Int)) (= (<= (f11 f12 ?v0) f14) (<= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (< (f11 f12 ?v0) f14) (< ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= (f11 f12 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (<= f14 (f11 f12 ?v0)) (<= f14 ?v0))))
(assert (forall ((?v0 Int)) (= (< f14 (f11 f12 ?v0)) (< f14 ?v0))))
(assert (forall ((?v0 Int)) (= (= f14 (f11 f12 ?v0)) (= f14 ?v0))))
(assert (forall ((?v0 Int)) (= (- f14 (f11 f12 ?v0)) (f11 f12 (- f14 ?v0)))))
(assert (= (f11 f12 f14) f14))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v2 f4) f1) (= (f3 (f5 (f6 f7 ?v1) ?v2) (f5 (f6 f7 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 f4 ?v2) f1) (= (f3 (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 f4) f1) (=> (= (f3 ?v1 f4) f1) (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 f4) f1) (=> (= (f3 f4 ?v1) f1) (= (f3 (f5 (f6 f7 ?v0) ?v1) f4) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 ?v1 f4) f1) (= (f3 (f5 (f6 f7 ?v0) ?v1) f4) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 f4 ?v1) f1) (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f4 ?v0) f1) (= (f5 (f6 f7 (f5 f22 ?v1)) ?v0) (f5 f22 (f5 (f6 f7 ?v1) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v2) ?v1)) f1) (and (=> (= (f3 f4 ?v1) f1) (= (f3 ?v0 ?v2) f1)) (and (=> (= (f3 ?v1 f4) f1) (= (f3 ?v2 ?v0) f1)) (not (= ?v1 f4)))))))
(assert (forall ((?v0 Int)) (=> (<= 0 (f11 f15 ?v0)) (and (<= 0 (f11 f15 (f11 f12 ?v0))) (<= 0 (f11 f15 (f11 f13 ?v0)))))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) f4) f4)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 f4) ?v0) f4)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 f4) ?v0) f4)))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (= (f5 f22 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f11 f23 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (= (f3 f4 (f5 f22 ?v0)) f1) (not (= ?v0 f4)))))
(assert (forall ((?v0 Int)) (= (< 0 (f11 f23 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S2)) (not (= (f3 (f5 f22 ?v0) f4) f1))))
(assert (forall ((?v0 Int)) (not (< (f11 f23 ?v0) 0))))
(assert (= (f3 f4 (f5 (f6 f7 f24) (f9 f10 (f11 f12 (f11 f13 f14))))) f1))
(assert (not (= (f25 1) f1)))
(assert (not (= (f26 (f9 f10 (f11 f13 f14))) f1)))
(assert (= (f3 f4 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) f1))
(assert (forall ((?v0 Int)) (= (= (f11 f15 ?v0) 0) (= (f25 (f11 f15 (+ ?v0 (- f14)))) f1))))
(assert (forall ((?v0 Int)) (= (= (f9 f10 ?v0) f4) (= (f26 (f9 f10 (+ ?v0 (- f14)))) f1))))
(assert (not (= (f26 f24) f1)))
(assert (not (= (f25 1) f1)))
(assert (not (= (f28 f29) f1)))
(assert (forall ((?v0 Int)) (= (f11 f15 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f21 (f11 f15 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f21 (f11 f15 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (= (- (f11 f15 ?v0)) (f11 f15 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f11 f15 ?v0) (f11 f15 ?v1)) (f11 f15 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f11 f15 ?v0) (f11 f15 ?v1)) (f11 f15 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f11 f15 ?v0) (f11 f15 ?v1)) (f11 f15 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f15 ?v0) (f11 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f15 ?v0) (f11 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f11 f15 ?v1))) (= (= (f19 f20 ?v0) ?v_0) (and (= ?v0 (f16 f21 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 (f16 f17 ?v0)))) (=> (< 0 ?v_0) (= (f16 f21 (f11 f15 ?v0)) (f16 f21 (+ (f19 f20 (f16 f21 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 S2)) (= (= f24 ?v0) (= ?v0 f24))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S8)) (= (= f29 ?v0) (= ?v0 f29))))
(assert (= (f5 f22 f24) f24))
(assert (= (f11 f23 1) 1))
(assert (not (= f24 f4)))
(assert (not (= 1 0)))
(assert (not (= f29 f18)))
(assert (not (= f4 f24)))
(assert (not (= 0 1)))
(assert (not (= f18 f29)))
(assert (not (= f27 f4)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) f24) ?v0)))
(assert (not (= (f3 f24 f4) f1)))
(assert (not (< 1 0)))
(assert (not (= (f30 f29 f18) f1)))
(assert (= (f3 f4 f24) f1))
(assert (< 0 1))
(assert (= (f30 f18 f29) f1))
(assert (not (= (f3 f27 f4) f1)))
(assert (= (f3 f4 f27) f1))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) ?v0) (ite (= ?v0 f4) f4 f24))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f4)) (= (f5 (f6 f7 ?v0) ?v0) f24))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f4)) (= (= (f5 (f6 f7 ?v1) ?v0) f24) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int)) (= (= f24 (f9 f10 ?v0)) (= (f26 (f9 f10 (+ (f11 f13 f14) (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= 1 (f11 f15 ?v0)) (= (f25 (f11 f15 (+ (f11 f13 f14) (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= (f9 f10 ?v0) f24) (= (f26 (f9 f10 (+ ?v0 (- (f11 f13 f14))))) f1))))
(assert (forall ((?v0 Int)) (= (= (f11 f15 ?v0) 1) (= (f25 (f11 f15 (+ ?v0 (- (f11 f13 f14))))) f1))))
(assert (= (f25 0) f1))
(assert (= (f26 f4) f1))
(assert (= (f28 f18) f1))
(assert (forall ((?v0 Int)) (= (= (f25 ?v0) f1) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f26 ?v0) f1) (= ?v0 f4))))
(assert (forall ((?v0 S8)) (= (= (f28 ?v0) f1) (= ?v0 f18))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 f15 ?v0) (f11 f15 ?v1)) (= (f25 (f11 f15 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 f10 ?v0) (f9 f10 ?v1)) (= (f26 (f9 f10 (+ ?v0 (- ?v1)))) f1))))
(assert (= f24 (f9 f10 (f11 f13 f14))))
(assert (= 1 1))
(assert (= (f9 f10 (f11 f13 f14)) f24))
(assert (= 1 1))
(assert (= (f9 f10 (f11 f13 f14)) f24))
(assert (= 1 1))
(assert (= (f16 f17 (f11 f13 f14)) f29))
(assert (= (f5 f22 f4) f4))
(assert (= (f11 f23 0) 0))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= f4 ?v0) (= ?v0 f4))))
(assert (forall ((?v0 S8)) (= (= f18 ?v0) (= ?v0 f18))))
(assert (forall ((?v0 S2)) (= (= (f5 f22 ?v0) f4) (= ?v0 f4))))
(assert (forall ((?v0 Int)) (= (= (f11 f23 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 Int)) (not (= (f25 (f11 f15 (f11 f13 ?v0))) f1))))
(assert (forall ((?v0 Int)) (not (= (f26 (f9 f10 (f11 f13 ?v0))) f1))))
(assert (= (f25 0) f1))
(assert (= (f26 (f9 f10 f14)) f1))
(assert (forall ((?v0 Int)) (= (= (f25 (f11 f15 (f11 f12 ?v0))) f1) (= (f25 (f11 f15 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (= (f26 (f9 f10 (f11 f12 ?v0))) f1) (= (f26 (f9 f10 ?v0)) f1))))
(assert (= (f3 f27 (f9 f10 (f11 f12 (f11 f12 (f11 f13 f14))))) f1))
(assert (let ((?v_0 (f9 f10 (f11 f12 (f11 f13 f14))))) (not (= (f5 (f6 f7 f27) ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= (f3 f24 (f9 f10 ?v0)) f1) (< (f11 f13 f14) ?v0))))
(assert (forall ((?v0 Int)) (= (< 1 (f11 f15 ?v0)) (< (f11 f13 f14) ?v0))))
(assert (forall ((?v0 Int)) (= (= (f3 (f9 f10 ?v0) f24) f1) (< ?v0 (f11 f13 f14)))))
(assert (forall ((?v0 Int)) (= (< (f11 f15 ?v0) 1) (< ?v0 (f11 f13 f14)))))
(assert (not (= (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14)))) f4)))
(assert (let ((?v_0 (f9 f10 (f11 f12 (f11 f13 f14))))) (= (f3 (f5 (f6 f7 f27) ?v_0) ?v_0) f1)))
(assert (forall ((?v0 Int)) (= (= 0 (f11 f15 ?v0)) (= (f25 (f11 f15 (+ f14 (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= f4 (f9 f10 ?v0)) (= (f26 (f9 f10 (+ f14 (- ?v0)))) f1))))
(assert (forall ((?v0 S2)) (= (f3 (f5 f31 ?v0) (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) f1)))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 ?v0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) f1) (= (f3 f4 (f5 f32 ?v0)) f1)))))
(assert (= (f3 (f5 f33 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) f4) f1))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 ?v0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) f1) (= (f3 f4 (f5 f34 ?v0)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 ?v0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) f1) (= (f3 f4 (f5 f35 ?v0)) f1)))))
(assert (forall ((?v0 S2)) (not (= (f5 f34 (f5 f31 ?v0)) f4))))
(assert (= (f5 f34 f4) f24))
(assert (forall ((?v0 S2)) (= (f5 f32 ?v0) (f5 (f6 f7 (f5 f35 ?v0)) (f5 f34 ?v0)))))
(assert (forall ((?v0 S2)) (=> (= (f5 f34 ?v0) f24) (= (f5 f35 ?v0) f4))))
(assert (forall ((?v0 S2)) (=> (= (f5 f35 ?v0) f4) (= (f5 f22 (f5 f34 ?v0)) f24))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f5 f33 ?v0) (f5 f33 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f5 f33 ?v0) ?v1) (= (f5 f33 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 (f5 f33 ?v1)) (= ?v1 (f5 f33 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 f33 (f5 (f6 f36 ?v0) ?v1)) (f5 (f6 f37 (f5 f33 ?v0)) (f5 f33 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f11 (f38 f39 ?v0) ?v1)) (f11 (f38 f40 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 f33 (f5 (f6 f37 ?v0) ?v1)) (f5 (f6 f36 (f5 f33 ?v0)) (f5 f33 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f11 (f38 f40 ?v0) ?v1)) (f11 (f38 f39 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S2)) (= (f5 f31 (f5 f33 ?v0)) (f5 f33 (f5 f31 ?v0)))))
(assert (forall ((?v0 S2)) (= (f5 f32 (f5 f33 ?v0)) (f5 f33 (f5 f32 ?v0)))))
(assert (forall ((?v0 S2)) (= (f5 f35 (f5 f33 ?v0)) (f5 f33 (f5 f35 ?v0)))))
(assert (forall ((?v0 S2)) (= (f5 f22 (f5 f33 ?v0)) (f5 f22 ?v0))))
(assert (forall ((?v0 Int)) (= (f11 f23 (- ?v0)) (f11 f23 ?v0))))
(assert (forall ((?v0 S2)) (= (f5 f34 (f5 f33 ?v0)) (f5 f34 ?v0))))
(assert (forall ((?v0 S2)) (= (f5 f33 (f5 f33 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 f32 (f5 f31 ?v0)) ?v0)))
(assert (= 0 0))
(assert (= (f5 f33 f4) f4))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 S2)) (= (= f4 (f5 f33 ?v0)) (= f4 ?v0))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= ?v0 (f5 f33 ?v0)) (= ?v0 f4))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f5 f33 ?v0) f4) (= ?v0 f4))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f5 f33 ?v0) ?v0) (= ?v0 f4))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 ?v0 (f5 f33 ?v1)) f1) (= (f3 ?v1 (f5 f33 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f5 f33 ?v0) ?v1) f1) (= (f3 (f5 f33 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f5 f22 ?v0) ?v1) f1) (and (= (f3 ?v0 ?v1) f1) (= (f3 (f5 f33 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f23 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f5 f33 ?v0) (f5 f33 ?v1)) f1) (= (f3 ?v1 ?v0) f1))))
(assert (= (f5 f35 f4) f4))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 f33 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f33 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 (f6 f7 (f5 f33 ?v0)) ?v1) (f5 f33 (f5 (f6 f7 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (= (f5 f33 (f9 f10 ?v0)) (f9 f10 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (- (f11 f15 ?v0)) (f11 f15 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f9 f10 (- ?v0)) (f5 f33 (f9 f10 ?v0)))))
(assert (forall ((?v0 Int)) (= (f11 f15 (- ?v0)) (- (f11 f15 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 f33 (f5 ?v_0 ?v1)) (f5 ?v_0 (f5 f33 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 (f6 f7 (f5 f33 ?v0)) (f5 f33 ?v1)) (f5 (f6 f7 ?v0) ?v1))))
(assert (= (f5 f32 f4) f4))
(assert (= (f5 f31 f4) f4))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f5 f31 ?v0) (f5 f31 ?v1)) f1))))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0 f4) f1) (= (f5 f22 ?v0) (f5 f33 ?v0)))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f23 ?v0) (- ?v0)))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) ?v0) (< 0 ?v0))))
(assert (forall ((?v0 S2)) (= (= (f3 (f5 f33 ?v0) ?v0) f1) (= (f3 f4 ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) 0) (< 0 ?v0))))
(assert (forall ((?v0 S2)) (= (= (f3 (f5 f33 ?v0) f4) f1) (= (f3 f4 ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< ?v0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f3 ?v0 (f5 f33 ?v0)) f1) (= (f3 ?v0 f4) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f3 f4 (f5 f33 ?v0)) f1) (= (f3 ?v0 f4) f1))))
(assert (forall ((?v0 S2)) (= (f5 f22 ?v0) (ite (= (f3 ?v0 f4) f1) (f5 f33 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 f23 ?v0) (ite (< ?v0 0) (- ?v0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f4)) (= (f5 (f6 f7 (f5 f33 ?v1)) (f5 f33 ?v0)) (f5 (f6 f7 ?v1) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 ?v1))) (=> (not (= ?v0 f4)) (= (f5 f33 (f5 ?v_0 ?v0)) (f5 ?v_0 (f5 f33 ?v0)))))))
(assert (= (f5 f35 f27) f4))
(assert (= (f5 f32 f27) f4))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14)))))) (=> (= (f3 (f5 f33 ?v_0) ?v0) f1) (=> (= (f3 ?v0 ?v_0) f1) (= (f5 f31 (f5 f32 ?v0)) ?v0))))))
(assert (forall ((?v0 S2)) (let ((?v_1 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) (?v_0 (f5 f31 ?v0))) (and (= (f3 (f5 f33 ?v_1) ?v_0) f1) (and (= (f3 ?v_0 ?v_1) f1) (= (f5 f32 ?v_0) ?v0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f5 f22 ?v_0) (ite (= (f3 ?v_0 f4) f1) (f5 f33 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f15 ?v0))) (= (f11 f23 ?v_0) (ite (< ?v_0 0) (- ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 ?v0 f27) f1) (= (f3 f4 (f5 f35 ?v0)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14)))))) (let ((?v_1 (f5 f33 ?v_0))) (=> (= (f3 ?v_1 ?v0) f1) (=> (= (f3 ?v0 ?v_0) f1) (=> (= (f3 ?v_1 ?v1) f1) (=> (= (f3 ?v1 ?v_0) f1) (= (= (f3 ?v0 ?v1) f1) (= (f3 (f5 f32 ?v0) (f5 f32 ?v1)) f1))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14)))))) (=> (= (f3 (f5 f33 ?v_0) ?v0) f1) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 ?v1 ?v_0) f1) (= (f3 (f5 f32 ?v0) (f5 f32 ?v1)) f1)))))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f5 (f6 f7 (f5 f33 f27)) (f9 f10 (f11 f12 (f11 f13 f14)))) ?v0) f1) (=> (= (f3 ?v0 f4) f1) (= (f3 (f5 f35 ?v0) f4) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_1 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) (?v_0 (f5 f31 ?v0))) (and (= (f3 (f5 f33 ?v_1) ?v_0) f1) (= (f3 ?v_0 ?v_1) f1)))))
(assert (forall ((?v0 S2)) (= (f3 (f5 f33 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) (f5 f31 ?v0)) f1)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14)))))) (=> (= (f3 (f5 f33 ?v_0) ?v0) f1) (=> (= (f3 ?v0 ?v_0) f1) (= (f3 f4 (f5 f34 ?v0)) f1))))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f5 (f6 f7 (f5 f33 f27)) (f9 f10 (f11 f12 (f11 f13 f14)))) ?v0) f1) (=> (= (f3 ?v0 f4) f1) (= (f3 (f5 f32 ?v0) f4) f1)))))
(assert (not (= (f5 f34 (f9 f10 (f11 f12 (f11 f13 f14)))) f4)))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 ?v0 (f9 f10 (f11 f12 (f11 f13 f14)))) f1) (= (f3 f4 (f5 f35 ?v0)) f1)))))
(assert (= (f3 (f5 f34 (f9 f10 (f11 f12 (f11 f13 f14)))) f4) f1))
(assert (let ((?v_0 (f11 f13 f14))) (= (f5 f35 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 ?v_0))))) (f5 (f6 f7 f24) (f9 f10 (f11 f12 ?v_0))))))
(assert (= (f5 f35 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) f24))
(assert (let ((?v_0 (f11 f13 f14))) (= (f5 f34 (f5 (f6 f7 f27) (f9 f10 (f11 f13 ?v_0)))) (f5 (f6 f7 f24) (f9 f10 (f11 f12 ?v_0))))))
(assert (= (f5 f32 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f12 (f11 f13 f14)))))) f24))
(assert (= (f5 f34 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) f4))
(assert (= (f5 f31 f24) (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f12 (f11 f13 f14)))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (let ((?v_0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14)))))) (and (and (= (f3 (f5 f33 ?v_0) ?v1) f1) (and (= (f3 ?v1 ?v_0) f1) (= (f5 f32 ?v1) ?v0))) (forall ((?v2 S2)) (=> (and (= (f3 (f5 f33 ?v_0) ?v2) f1) (and (= (f3 ?v2 ?v_0) f1) (= (f5 f32 ?v2) ?v0))) (= ?v2 ?v1))))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (let ((?v_0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14)))))) (and (= (f3 (f5 f33 ?v_0) ?v1) f1) (and (= (f3 ?v1 ?v_0) f1) (= (f5 f32 ?v1) ?v0)))))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f5 f22 ?v0) f24) f1) (exists ((?v1 S2)) (let ((?v_0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f12 (f11 f13 f14))))))) (and (= (f3 (f5 f33 ?v_0) ?v1) f1) (and (= (f3 ?v1 ?v_0) f1) (= (f5 f32 ?v1) ?v0))))))))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (exists ((?v1 S2)) (and (= (f3 f4 ?v1) f1) (and (= (f3 ?v1 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14))))) f1) (= (f3 ?v0 (f5 f32 ?v1)) f1)))))))
(assert (forall ((?v0 S2)) (= (f5 f22 ?v0) (ite (= (f3 ?v0 f4) f1) (f5 f33 ?v0) ?v0))))
(assert (not (= f4 f24)))
(assert (forall ((?v0 S2)) (= (f5 f22 ?v0) (ite (= (f3 ?v0 f4) f1) (f5 f33 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 (f6 f7 f27) (f9 f10 (f11 f12 (f11 f13 f14)))))) (=> (= (f41 (f5 f33 ?v_0) ?v0) f1) (=> (= (f41 ?v0 ?v_0) f1) (= (f41 f4 (f5 f34 ?v0)) f1))))))
(assert (let ((?v_0 (f11 f13 f14))) (= (f5 f35 (f5 (f6 f42 (f5 (f6 f7 (f9 f10 (f11 f13 ?v_0))) (f9 f10 (f11 f12 ?v_0)))) f27)) (f5 f33 f24))))
(assert (= (f41 f4 f43) f1))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f41 (f5 f33 (f5 (f6 f42 ?v0) ?v0)) (f5 (f6 f42 ?v1) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f41 (f5 f22 ?v0) ?v1) f1) (and (= (f41 (f5 f33 ?v1) ?v0) f1) (= (f41 ?v0 ?v1) f1)))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f42 f24) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f4)) (= (= (f5 (f6 f42 ?v1) ?v0) (f5 (f6 f42 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f42 ?v0))) (=> (not (= ?v0 f4)) (= (= (f5 ?v_0 ?v1) (f5 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 ?v0 ?v1) f1) (and (= (f41 ?v0 ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f41 ?v0 ?v1) f1) (or (= (f3 ?v0 ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f4 ?v0) f1) (= (= (f41 (f5 (f6 f42 ?v1) ?v0) (f5 (f6 f42 ?v2) ?v0)) f1) (= (f41 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f42 ?v0))) (=> (= (f3 f4 ?v0) f1) (= (= (f41 (f5 ?v_0 ?v1) (f5 ?v_0 ?v2)) f1) (= (f41 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S2)) (= (f41 ?v0 ?v0) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 (f6 f42 ?v0) ?v1) (f5 (f6 f42 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f41 ?v0 ?v1) f1) (= (f41 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f42 ?v0))) (= (f5 (f6 f42 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f42 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 ?v1 ?v2) f1) (= (f41 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f41 f4 (f5 (f6 f7 ?v0) ?v1)) f1) (and (or (= (f41 ?v0 f4) f1) (= (f41 f4 ?v1) f1)) (or (= (f41 f4 ?v0) f1) (= (f41 ?v1 f4) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f4 ?v0) f1) (= (= (f3 (f5 (f6 f42 ?v1) ?v0) (f5 (f6 f42 ?v2) ?v0)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 f4 ?v1) f1) (= (f3 f4 (f5 (f6 f42 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f42 ?v0))) (=> (= (f3 f4 ?v0) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 (f5 ?v_0 ?v1) (f5 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f41 ?v0 ?v1) f1) (= (f41 (f5 f31 ?v0) (f5 f31 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 ?v2 f4) f1) (=> (= (f3 f4 (f5 (f6 f42 ?v0) ?v1)) f1) (= (f41 (f5 ?v_0 ?v0) (f5 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f41 ?v0 ?v1) f1) (=> (= (f41 f4 ?v2) f1) (=> (= (f3 f4 (f5 (f6 f42 ?v1) ?v0)) f1) (= (f41 (f5 ?v_0 ?v1) (f5 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S8)) (= (f16 f21 (f19 f20 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f19 f20 (f16 f21 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f19 f20 (f16 f21 ?v0)) 0))))
(check-sat)
(exit)
