(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S1)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S8) S5)
(declare-fun f10 () S7)
(declare-fun f11 (S9 S8) S8)
(declare-fun f12 (S10 S8) S9)
(declare-fun f13 () S10)
(declare-fun f14 () S8)
(declare-fun f15 () S8)
(declare-fun f16 () S5)
(declare-fun f17 () S6)
(declare-fun f18 () S5)
(declare-fun f19 () S5)
(declare-fun f20 (S11 S5) S5)
(declare-fun f21 (S12 S5) S11)
(declare-fun f22 () S12)
(declare-fun f23 () S5)
(declare-fun f24 () S5)
(declare-fun f25 () S5)
(declare-fun f26 () S8)
(declare-fun f27 () S11)
(declare-fun f28 () S11)
(declare-fun f29 () S12)
(declare-fun f30 () S2)
(declare-fun f31 () S8)
(declare-fun f32 () S3)
(declare-fun f33 () S12)
(declare-fun f34 () S3)
(declare-fun f35 () S12)
(declare-fun f36 () S12)
(declare-fun f37 (S13 S14) S9)
(declare-fun f38 () S13)
(declare-fun f39 () S14)
(declare-fun f40 () S10)
(declare-fun f41 (S15 S5) Int)
(declare-fun f42 (S16 Int) S5)
(declare-fun f43 () S10)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 (f9 f10 (f11 (f12 f13 f14) f15))) f16) f1)))
(assert (= (f6 (f7 f17 f18) f19) f1))
(assert (= (f6 (f7 f17 f19) f16) f1))
(assert (= (f6 (f7 f17 f19) (f20 (f21 f22 f23) f24)) f1))
(assert (not (= f14 f15)))
(assert (= (f6 (f7 f17 (f9 f10 (f11 (f12 f13 f14) f15))) f19) f1))
(assert (= (f6 (f7 f17 f18) f23) f1))
(assert (= (f6 (f7 f17 f18) f24) f1))
(assert (= (f6 (f7 f17 f19) f16) f1))
(assert (not (= f14 f15)))
(assert (= (f6 (f7 f17 f25) f16) f1))
(assert (= (f6 (f7 f17 f18) f25) f1))
(assert (= (f6 (f7 f17 (f9 f10 (f11 (f12 f13 f14) f15))) f19) f1))
(assert (= (f6 (f7 f17 f18) f16) f1))
(assert (= (f9 f10 f26) f16))
(assert (= (f20 f27 f16) f16))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f29 (f9 f10 ?v0)) (f9 f10 ?v1)))) (f9 f10 (f11 (f12 f13 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f29 (f20 f27 ?v0)) (f20 f27 ?v1)))) (f20 f27 (f20 (f21 f29 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f6 (f7 f8 (f20 (f21 f29 (f9 f10 ?v0)) (f9 f10 ?v1))) (f9 f10 (f11 (f12 f13 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 (f21 f29 (f20 f27 ?v0)) (f20 f27 ?v1))) (f20 f27 (f20 (f21 f29 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f9 f10 (f11 (f12 f13 ?v0) ?v1)) (f9 f10 (f11 (f12 f13 ?v1) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f27 (f20 (f21 f29 ?v0) ?v1)) (f20 f27 (f20 (f21 f29 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f30 (- (f3 f30 ?v0) (f3 f30 ?v1))) (f3 f30 (- ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 f28 (f20 (f21 f29 (f20 f28 ?v0)) (f20 f28 ?v1)))) (f20 f28 (f20 (f21 f29 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f30 ?v0) (f3 f30 ?v1)) (f3 f30 (- ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 (f21 f29 (f20 f28 ?v0)) (f20 f28 ?v1))) (f20 f28 (f20 (f21 f29 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f30 ?v0) (f3 f30 ?v1)) (f3 f30 (- ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 (f21 f29 (f20 f28 ?v0)) (f20 f28 ?v1))) (f20 f28 (f20 (f21 f29 ?v1) ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f20 (f21 f29 ?v0) ?v1) (f20 (f21 f29 ?v2) ?v3)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v2) ?v3) f1)))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f18) (f20 f27 ?v0)) f1)))
(assert (forall ((?v0 S8)) (= (f6 (f7 f8 f18) (f9 f10 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (<= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f20 (f21 f29 ?v0) ?v1)) f18) f1))))
(assert (not (= (f6 (f7 f8 f16) f18) f1)))
(assert (not (<= 1 0)))
(assert (= (f6 (f7 f17 f18) f19) f1))
(assert (= (f6 (f7 f17 f19) (f20 (f21 f22 f23) f24)) f1))
(assert (= (f6 (f7 f17 f25) (f20 (f21 f22 f23) f24)) f1))
(assert (= (f6 (f7 f17 f18) (f20 (f21 f22 f23) f24)) f1))
(assert (=> (forall ((?v0 S5)) (let ((?v_0 (f7 f17 ?v0))) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 ?v_0 f16) f1) (=> (= (f6 ?v_0 (f20 (f21 f22 f23) f24)) f1) false))))) false))
(assert (exists ((?v0 S5)) (let ((?v_0 (f7 f17 ?v0))) (and (= (f6 (f7 f17 f18) ?v0) f1) (and (= (f6 ?v_0 f16) f1) (= (f6 ?v_0 (f20 (f21 f22 f23) f24)) f1))))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f17 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< (f3 f30 ?v0) 0))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f17 (f20 f28 ?v0)) f18) f1))))
(assert (= (f3 f30 0) 0))
(assert (= (f20 f28 f18) f18))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= ?v0 ?v1)) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (or (= (f6 (f7 f17 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S8)) (= (= f31 ?v0) (= ?v0 f31))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f18 ?v0) (= ?v0 f18))))
(assert (forall ((?v0 Int)) (= (< 0 (f3 f30 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f17 f18) (f20 f28 ?v0)) f1) (not (= ?v0 f18)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f3 (f4 f32 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (= (= (f6 ?v_0 (f20 (f21 f33 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f3 (f4 f34 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (= (= (f6 ?v_0 (f20 (f21 f35 ?v1) ?v2)) f1) (and (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f3 f30 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f20 f28 ?v0) f18) (= ?v0 f18))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f3 (f4 f32 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f17 (f20 (f21 f33 ?v0) ?v1)) ?v2) f1) (and (= (f6 (f7 f17 ?v0) ?v2) f1) (= (f6 (f7 f17 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f3 (f4 f34 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f17 (f20 (f21 f35 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f17 ?v0) ?v2) f1) (= (f6 (f7 f17 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= (not (= (f6 (f7 f17 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f17 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 (f7 f17 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 f30 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (f20 f28 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (not (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (not (= (f6 (f7 f17 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S1)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (=> (= (f6 (f7 f17 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f17 ?v1) ?v2) f1) (= (f6 (f7 f17 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f17 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f17 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v2))) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (=> (not false) (= (f6 (f7 f17 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f17 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 (f7 f17 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 S8)) (= (= (f6 (f7 f17 f18) (f9 f10 ?v0)) f1) (not (= ?v0 f31)))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f17 f18) (f20 f27 ?v0)) f1) (not (= ?v0 f18)))))
(assert (= (f6 (f7 f17 f18) f16) f1))
(assert (< 0 1))
(assert (not (= (f6 (f7 f17 f16) f18) f1)))
(assert (not (< 1 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (< (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (= (f6 (f7 f17 (f20 (f21 f29 ?v0) ?v1)) f18) f1))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f17 (f20 f27 ?v0)) f18) f1))))
(assert (forall ((?v0 S8)) (not (= (f6 (f7 f17 (f9 f10 ?v0)) f18) f1))))
(assert (forall ((?v0 S8)) (= (= (f9 f10 ?v0) f18) (= ?v0 f31))))
(assert (forall ((?v0 S5)) (= (= (f20 f27 ?v0) f18) (= ?v0 f18))))
(assert (= (f9 f10 f31) f18))
(assert (= (f20 f27 f18) f18))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v1) ?v2) f1) (= (f6 (f7 f17 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v0) f1) (= (f6 (f7 f17 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f17 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f6 (f7 f17 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f6 (f7 f17 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= (f6 (f7 f17 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 ?v1)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f17 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f17 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= (f6 (f7 f8 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f17 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f8 ?v0) ?v1) f1)) (= (f6 (f7 f17 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (not (= (f6 (f7 f17 ?v0) ?v1) f1)) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f30 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (=> (= (f6 (f7 f8 f18) ?v0) f1) (= (f20 f28 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f3 f30 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f20 f28 ?v0)) f18) f1) (= ?v0 f18))))
(assert (forall ((?v0 Int)) (<= 0 (f3 f30 ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f18) (f20 f28 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f20 (f21 f29 ?v0) ?v1) (f20 (f21 f29 ?v2) ?v3)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (= (f6 (f7 f17 ?v2) ?v3) f1)))))
(assert (not (= f31 f26)))
(assert (not (= f18 f16)))
(assert (not (= 0 1)))
(assert (not (= f26 f31)))
(assert (not (= f16 f18)))
(assert (not (= 1 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f11 (f12 f13 ?v0) ?v1) f31) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f20 (f21 f29 ?v0) ?v1) f18) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= ?v0 ?v1) (= (f11 (f12 f13 ?v0) ?v1) f31))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f20 (f21 f29 ?v0) ?v1) f18))))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f13 ?v0) ?v0) f31)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f29 ?v0) ?v0) f18)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f13 ?v0) f31) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f29 ?v0) f18) ?v0)))
(assert (forall ((?v0 S8)) (= (= (f6 (f7 f8 (f9 f10 ?v0)) f18) f1) (= ?v0 f31))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 (f20 f27 ?v0)) f18) f1) (= ?v0 f18))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (=> (= (f6 (f7 f8 ?v0) ?v1) f1) false) (=> (=> (= (f6 (f7 f8 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f30 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 (f20 f28 ?v0)) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f6 (f7 f8 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v2))) (=> (= ?v0 ?v1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (= (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f6 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f3 (f4 f34 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f8 (f20 (f21 f35 ?v0) ?v1)) ?v2) f1) (or (= (f6 (f7 f8 ?v0) ?v2) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f3 (f4 f32 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 (f20 (f21 f33 ?v1) ?v2)) f1) (or (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f30 ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) (f20 f28 ?v0)) f1)))
(assert (forall ((?v0 S8)) (= (= f26 ?v0) (= ?v0 f26))))
(assert (forall ((?v0 S5)) (= (= f16 ?v0) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (= (f3 f30 1) 1))
(assert (= (f20 f28 f16) f16))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (=> (= (f11 (f12 f13 ?v0) ?v1) (f11 (f12 f13 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f20 (f21 f29 ?v0) ?v1) (f20 (f21 f29 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f29 (f20 (f21 f35 ?v0) ?v1)) ?v2) (f20 (f21 f35 (f20 (f21 f29 ?v0) ?v2)) (f20 (f21 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f29 (f20 (f21 f33 ?v0) ?v1)) ?v2) (f20 (f21 f33 (f20 (f21 f29 ?v0) ?v2)) (f20 (f21 f29 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f30 (- ?v0 ?v1)) (f3 f30 (- ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f28 (f20 (f21 f29 ?v0) ?v1)) (f20 f28 (f20 (f21 f29 ?v1) ?v0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f20 f27 ?v0))) (= (f20 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f9 f10 ?v0))) (= (f20 f28 ?v_0) ?v_0))))
(assert (= (f6 (f7 f8 f18) f16) f1))
(assert (<= 0 1))
(assert (= (f6 (f7 f17 (f20 (f21 f36 f25) f24)) f23) f1))
(assert (= (f6 (f7 f17 f18) (f20 (f21 f36 f25) f24)) f1))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f17 f18) ?v0) f1) (forall ((?v1 S8)) (let ((?v_1 (f11 (f12 f13 ?v1) f15))) (let ((?v_0 (f9 f10 ?v_1)) (?v_2 (f37 f38 f39))) (=> (and (= (f6 (f7 f17 f18) ?v_0) f1) (= (f6 (f7 f17 ?v_0) ?v0) f1)) (= (f6 (f7 f17 (f9 f10 (f11 (f12 f13 (f11 ?v_2 ?v_1)) (f11 ?v_2 (f11 (f12 f13 f15) f15))))) f23) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 (f20 (f21 f29 ?v0) ?v1)) f18) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f31)) (= (= (f11 (f12 f40 ?v1) ?v0) f26) (= ?v1 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f18)) (= (= (f20 (f21 f22 ?v1) ?v0) f16) (= ?v1 ?v0)))))
(assert (forall ((?v0 S8)) (=> (not (= ?v0 f31)) (= (f11 (f12 f40 ?v0) ?v0) f26))))
(assert (forall ((?v0 S5)) (=> (not (= ?v0 f18)) (= (f20 (f21 f22 ?v0) ?v0) f16))))
(assert (forall ((?v0 S8)) (= (f11 (f12 f40 ?v0) ?v0) (ite (= ?v0 f31) f31 f26))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 ?v0) ?v0) (ite (= ?v0 f18) f18 f16))))
(assert (forall ((?v0 S15) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (<= (f41 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f17 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f17 ?v5) ?v4) f1) (< (f41 ?v0 ?v5) (f41 ?v0 ?v4)))) (< (f41 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S16) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f8 (f42 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f6 (f7 f17 (f42 ?v0 ?v5)) (f42 ?v0 ?v4)) f1))) (= (f6 (f7 f17 (f42 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S15) (?v1 S5) (?v2 Int) (?v3 S5)) (=> (< (f41 ?v0 ?v1) ?v2) (=> (= (f6 (f7 f8 ?v3) ?v1) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f8 ?v5) ?v4) f1) (<= (f41 ?v0 ?v5) (f41 ?v0 ?v4)))) (< (f41 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S16) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (= (f6 (f7 f17 (f42 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f6 (f7 f8 (f42 ?v0 ?v5)) (f42 ?v0 ?v4)) f1))) (= (f6 (f7 f17 (f42 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S15) (?v2 S5) (?v3 S5)) (=> (<= ?v0 (f41 ?v1 ?v2)) (=> (= (f6 (f7 f17 ?v2) ?v3) f1) (=> (forall ((?v4 S5) (?v5 S5)) (=> (= (f6 (f7 f17 ?v4) ?v5) f1) (< (f41 ?v1 ?v4) (f41 ?v1 ?v5)))) (< ?v0 (f41 ?v1 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S16) (?v2 Int) (?v3 Int)) (=> (= (f6 (f7 f8 ?v0) (f42 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f6 (f7 f17 (f42 ?v1 ?v4)) (f42 ?v1 ?v5)) f1))) (= (f6 (f7 f17 ?v0) (f42 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 S8)) (=> (= (f6 (f7 f8 (f9 f10 ?v0)) f16) f1) (= (f6 (f7 f8 (f9 f10 (f11 (f37 f38 f39) ?v0))) f24) f1))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f17 f18) ?v0) f1) (forall ((?v1 S8)) (=> (= (f6 (f7 f8 (f9 f10 ?v1)) f16) f1) (= (f6 (f7 f8 (f9 f10 (f11 (f37 f38 f39) ?v1))) ?v0) f1))))))
(assert (=> (forall ((?v0 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (forall ((?v1 S8)) (=> (= (f6 (f7 f8 (f9 f10 ?v1)) f16) f1) (= (f6 (f7 f8 (f9 f10 (f11 (f37 f38 f39) ?v1))) ?v0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f30 (* ?v0 ?v1)) (* (f3 f30 ?v0) (f3 f30 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f28 (f20 (f21 f36 ?v0) ?v1)) (f20 (f21 f36 (f20 f28 ?v0)) (f20 f28 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f43 ?v0))) (= (f11 ?v_0 (f11 (f12 f40 ?v1) ?v2)) (f11 (f12 f40 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (= (f20 ?v_0 (f20 (f21 f22 ?v1) ?v2)) (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f30 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f20 f28 ?v0))) (= (f20 (f21 f36 ?v_0) ?v_0) (f20 (f21 f36 ?v0) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f43 ?v0))) (= (f11 (f12 f43 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f12 f43 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (= (f20 (f21 f36 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f21 f36 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (= (f20 (f21 f36 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f21 f36 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 (f21 f36 ?v0) ?v1) (f20 (f21 f36 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f9 f10 (f11 (f12 f43 ?v0) ?v1)) (f20 (f21 f36 (f9 f10 ?v0)) (f9 f10 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f27 (f20 (f21 f36 ?v0) ?v1)) (f20 (f21 f36 (f20 f27 ?v0)) (f20 f27 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (not (= ?v0 f18)) (= (= (f20 ?v_0 ?v1) (f20 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f18)) (= (= (f20 (f21 f36 ?v1) ?v0) (f20 (f21 f36 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 f16) ?v0) ?v0)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f31)) (=> (= (f11 (f12 f43 ?v1) ?v0) ?v2) (= ?v1 (f11 (f12 f40 ?v2) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f18)) (=> (= (f20 (f21 f36 ?v1) ?v0) ?v2) (= ?v1 (f20 (f21 f22 ?v2) ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f31)) (=> (= ?v1 (f11 (f12 f43 ?v2) ?v0)) (= (f11 (f12 f40 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f18)) (=> (= ?v1 (f20 (f21 f36 ?v2) ?v0)) (= (f20 (f21 f22 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f31)) (= (= (f11 (f12 f40 ?v1) ?v0) ?v2) (= ?v1 (f11 (f12 f43 ?v2) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f18)) (= (= (f20 (f21 f22 ?v1) ?v0) ?v2) (= ?v1 (f20 (f21 f36 ?v2) ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (not (= ?v0 f31)) (= (= ?v1 (f11 (f12 f40 ?v2) ?v0)) (= (f11 (f12 f43 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 f18)) (= (= ?v1 (f20 (f21 f22 ?v2) ?v0)) (= (f20 (f21 f36 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f43 ?v0) ?v1))) (f20 (f21 f36 (f9 f10 ?v0)) (f9 f10 ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f20 f27 (f20 (f21 f36 ?v0) ?v1))) (f20 (f21 f36 (f20 f27 ?v0)) (f20 f27 ?v1))) f1)))
(assert (forall ((?v0 S8) (?v1 S5) (?v2 S8) (?v3 S5)) (=> (= (f6 (f7 f17 (f9 f10 ?v0)) ?v1) f1) (=> (= (f6 (f7 f17 (f9 f10 ?v2)) ?v3) f1) (= (f6 (f7 f17 (f9 f10 (f11 (f12 f43 ?v0) ?v2))) (f20 (f21 f36 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f17 (f20 f27 ?v0)) ?v1) f1) (=> (= (f6 (f7 f17 (f20 f27 ?v2)) ?v3) f1) (= (f6 (f7 f17 (f20 f27 (f20 (f21 f36 ?v0) ?v2))) (f20 (f21 f36 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f11 (f12 f43 ?v0) ?v1) f31) (or (= ?v0 f31) (= ?v1 f31)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f20 (f21 f36 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f31)) (=> (not (= ?v1 f31)) (not (= (f11 (f12 f43 ?v0) ?v1) f31))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f18)) (=> (not (= ?v1 f18)) (not (= (f20 (f21 f36 ?v0) ?v1) f18))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f11 (f12 f43 ?v0) ?v1) f31) (or (= ?v0 f31) (= ?v1 f31)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f20 (f21 f36 ?v0) ?v1) f18) (or (= ?v0 f18) (= ?v1 f18)))))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 ?v0) f31) f31)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 ?v0) f31) f31)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 ?v0) f31) f31)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 ?v0) f18) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 f31) ?v0) f31)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 f31) ?v0) f31)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 f31) ?v0) f31)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 f18) ?v0) f18)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 f30 ?v0)) (?v_1 (f3 f30 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (* ?v_0 ?v_1) (* ?v1 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f20 f28 ?v0)) (?v_1 (f20 f28 ?v2))) (=> (= (f6 (f7 f17 ?v_0) ?v1) f1) (=> (= (f6 (f7 f17 ?v_1) ?v3) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v_0) ?v_1)) (f20 (f21 f36 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 f26) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 f26) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 ?v0) f26) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 ?v0) f16) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8)) (= (f11 (f12 f43 ?v0) f26) ?v0)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f36 ?v0) f16) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f43 ?v0))) (= (f11 ?v_0 (f11 (f12 f13 ?v1) ?v2)) (f11 (f12 f13 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (= (f20 ?v_0 (f20 (f21 f29 ?v1) ?v2)) (f20 (f21 f29 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f12 f43 ?v0))) (= (f11 ?v_0 (f11 (f12 f13 ?v1) ?v2)) (f11 (f12 f13 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (= (f20 ?v_0 (f20 (f21 f29 ?v1) ?v2)) (f20 (f21 f29 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f11 (f12 f43 (f11 (f12 f13 ?v0) ?v1)) ?v2) (f11 (f12 f13 (f11 (f12 f43 ?v0) ?v2)) (f11 (f12 f43 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f36 (f20 (f21 f29 ?v0) ?v1)) ?v2) (f20 (f21 f29 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f11 (f12 f43 (f11 (f12 f13 ?v0) ?v1)) ?v2) (f11 (f12 f13 (f11 (f12 f43 ?v0) ?v2)) (f11 (f12 f43 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f36 (f20 (f21 f29 ?v0) ?v1)) ?v2) (f20 (f21 f29 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f17 ?v1) ?v2) f1) (= (f6 (f7 f17 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f17 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f20 (f21 f36 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f17 (f20 (f21 f36 ?v1) ?v0)) (f20 (f21 f36 ?v2) ?v0)) f1) (= (f6 (f7 f17 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f18) (f20 (f21 f36 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (= (= (f6 ?v_0 (f20 (f21 f36 ?v0) ?v1)) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f8 ?v0) f18) f1) (= (f6 (f7 f8 ?v1) f18) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (= (= (f6 (f7 f8 (f20 (f21 f36 ?v0) ?v1)) f18) f1) (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v1) f18) f1)) (and (= (f6 (f7 f8 ?v0) f18) f1) (= (f6 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f3 f30 ?v1) ?v0) (f3 f30 (* ?v1 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f18) ?v0) f1) (= (f20 (f21 f36 (f20 f28 ?v1)) ?v0) (f20 f28 (f20 (f21 f36 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f20 (f21 f36 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f18) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) f18) f1) (= (f6 (f7 f8 (f20 (f21 f36 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 f18) ?v0) f1) (=> (= (f6 (f7 f8 ?v1) f18) f1) (= (f6 (f7 f8 (f20 (f21 f36 ?v1) ?v0)) f18) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f18) f1) (=> (= (f6 (f7 f8 f18) ?v1) f1) (= (f6 (f7 f8 (f20 (f21 f36 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) f18) f1) (=> (= (f6 (f7 f8 ?v1) f18) f1) (= (f6 (f7 f8 f18) (f20 (f21 f36 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f18) ?v2) f1) (= (f6 (f7 f8 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f18) ?v2) f1) (= (f6 (f7 f8 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 f18) ?v2) f1) (= (f6 (f7 f8 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) f18) f1) (= (f6 (f7 f8 (f20 (f21 f36 ?v1) ?v2)) (f20 (f21 f36 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v2))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) f18) f1) (= (f6 (f7 f8 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 f18))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 (f7 f8 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 f18))) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 (f7 f8 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (=> (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1)) (and (= (f6 (f7 f8 ?v0) f18) f1) (= (f6 (f7 f8 ?v1) f18) f1))) (= (f6 ?v_0 (f20 (f21 f36 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f3 f30 (* ?v0 ?v1)) (* (f3 f30 ?v0) (f3 f30 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (=> (and (or (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v0) f18) f1)) (or (= (f6 ?v_0 ?v1) f1) (= (f6 (f7 f8 ?v1) f18) f1))) (= (f20 f28 (f20 (f21 f36 ?v0) ?v1)) (f20 (f21 f36 (f20 f28 ?v0)) (f20 f28 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (=> (or (and (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v1) f18) f1)) (and (= (f6 (f7 f8 ?v0) f18) f1) (= (f6 ?v_0 ?v1) f1))) (= (f6 (f7 f8 (f20 (f21 f36 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v2))) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v2) f18) f1) (= (f6 (f7 f17 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v2) f18) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v1) ?v2)) (f20 (f21 f36 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v2))) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 f18) ?v2) f1) (= (f6 (f7 f17 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v2))) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 f18) ?v2) f1) (= (f6 (f7 f17 (f20 ?v_0 ?v0)) (f20 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 f18) ?v2) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) f18) f1) (=> (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f17 f18) (f20 (f21 f36 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 ?v0) f18) f1) (=> (= (f6 (f7 f17 f18) ?v1) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v2 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (= (f6 (f7 f17 ?v0) f18) f1) (= (= (f6 (f7 f17 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (= (f6 (f7 f17 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f17 f18))) (=> (= (f6 ?v_0 (f20 (f21 f36 ?v0) ?v1)) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (* ?v0 ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f17 f18))) (=> (= (f6 ?v_0 (f20 (f21 f36 ?v0) ?v1)) f1) (=> (= (f6 ?v_0 ?v0) f1) (= (f6 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v1) ?v0)) f18) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v1)) f18) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f17 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f20 (f21 f36 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (< (* ?v0 ?v1) (* ?v0 ?v2)) (< ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f17 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (= (f6 (f7 f17 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (= (= (f6 (f7 f17 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (or (and (= (f6 (f7 f17 f18) ?v0) f1) (= (f6 (f7 f17 ?v1) ?v2) f1)) (and (= (f6 (f7 f17 ?v0) f18) f1) (= (f6 (f7 f17 ?v2) ?v1) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v1)) (f20 (f21 f36 ?v2) ?v1)) f1) (or (and (= (f6 (f7 f17 f18) ?v1) f1) (= (f6 (f7 f17 ?v0) ?v2) f1)) (and (= (f6 (f7 f17 ?v1) f18) f1) (= (f6 (f7 f17 ?v2) ?v0) f1))))))
(assert (forall ((?v0 S5)) (not (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v0)) f18) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (* ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f17 f16))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (= (f6 ?v_0 (f20 (f21 f36 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f8 (f20 (f21 f36 ?v1) ?v0)) (f20 (f21 f36 ?v2) ?v0)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f8 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f9 f10 (f11 (f12 f40 ?v0) ?v1)) (f20 (f21 f22 (f9 f10 ?v0)) (f9 f10 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f20 f27 (f20 (f21 f22 ?v0) ?v1)) (f20 (f21 f22 (f20 f27 ?v0)) (f20 f27 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (= (f6 (f7 f8 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (f6 (f7 f8 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f8 (f20 (f21 f36 ?v0) ?v1)) (f20 (f21 f36 ?v2) ?v1)) f1) (=> (= (f6 (f7 f17 f18) ?v1) f1) (= (f6 (f7 f8 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (= (f6 (f7 f17 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (=> (= (f6 (f7 f8 f18) ?v0) f1) (= (f6 (f7 f17 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (= (f6 (f7 f17 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (=> (= (f6 (f7 f8 f18) ?v0) f1) (= (f6 (f7 f17 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v1)) (f20 (f21 f36 ?v2) ?v1)) f1) (=> (= (f6 (f7 f8 f18) ?v1) f1) (= (f6 (f7 f17 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v1)) (f20 (f21 f36 ?v2) ?v1)) f1) (=> (= (f6 (f7 f8 f18) ?v1) f1) (= (f6 (f7 f17 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v2) ?v3) f1) (=> (= (f6 (f7 f17 f18) ?v0) f1) (=> (= (f6 (f7 f8 f18) ?v2) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v2) ?v3) f1) (=> (= (f6 (f7 f8 f18) ?v0) f1) (=> (= (f6 (f7 f17 f18) ?v2) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 f18))) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v2) ?v3) f1) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v2) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) f1) (=> (= (f6 (f7 f17 ?v2) ?v3) f1) (=> (= (f6 (f7 f17 f18) ?v1) f1) (=> (= (f6 (f7 f8 f18) ?v2) f1) (= (f6 (f7 f17 (f20 (f21 f36 ?v0) ?v2)) (f20 (f21 f36 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (= (f6 (f7 f17 ?v0) f18) f1) (= (= (f6 (f7 f8 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v2) ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f36 ?v0))) (=> (= (f6 (f7 f17 f18) ?v0) f1) (= (= (f6 (f7 f8 (f20 ?v_0 ?v1)) (f20 ?v_0 ?v2)) f1) (= (f6 (f7 f8 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v0 ?v1) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) f16) f1) (= (f6 (f7 f8 (f20 (f21 f36 ?v0) ?v1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v1 ?v0) ?v0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (=> (= (f6 ?v_0 ?v0) f1) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) f16) f1) (= (f6 (f7 f8 (f20 (f21 f36 ?v1) ?v0)) ?v0) f1)))))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (or (= (f6 (f7 f8 ?v0) ?v1) f1) (= (f6 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v2) f1) (= (f6 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f1) (=> (= (f6 (f7 f8 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 f18))) (= (= (f6 ?v_0 (f20 (f21 f22 ?v0) ?v1)) f1) (and (or (= (f6 (f7 f8 ?v0) f18) f1) (= (f6 ?v_0 ?v1) f1)) (or (= (f6 ?v_0 ?v0) f1) (= (f6 (f7 f8 ?v1) f18) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f18)) (= (f20 f27 (f20 (f21 f22 ?v1) ?v0)) (f20 (f21 f22 (f20 f27 ?v1)) (f20 f27 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f31)) (= (f9 f10 (f11 (f12 f40 ?v1) ?v0)) (f20 (f21 f22 (f9 f10 ?v1)) (f9 f10 ?v0))))))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 ?v0) f18) f18)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 f18) ?v0) f18)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 f18) ?v0) f18)))
(assert (forall ((?v0 S5)) (= (f20 (f21 f22 ?v0) f16) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f22 (f20 (f21 f29 ?v0) ?v1)) ?v2) (f20 (f21 f29 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f11 (f12 f40 (f11 (f12 f13 ?v0) ?v1)) ?v2) (f11 (f12 f13 (f11 (f12 f40 ?v0) ?v2)) (f11 (f12 f40 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f20 (f21 f22 (f20 (f21 f29 ?v0) ?v1)) ?v2) (f20 (f21 f29 (f20 (f21 f22 ?v0) ?v2)) (f20 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f11 (f12 f40 (f11 (f12 f13 ?v0) ?v1)) ?v2) (f11 (f12 f13 (f11 (f12 f40 ?v0) ?v2)) (f11 (f12 f40 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f17 ?v0) ?v1) f1) (and (= (f6 (f7 f8 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f1) (or (= (f6 (f7 f17 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (not (= f18 f16)))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f40 ?v2) ?v0))) (f20 (f21 f36 (f9 f10 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f27 (f20 (f21 f22 ?v2) ?v0))) (f20 (f21 f36 (f20 f27 ?v2)) ?v1)) f1))))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f17 f18) ?v0) f1) (forall ((?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f20 f27 (f20 (f21 f36 ?v1) ?v2))) (f20 (f21 f36 (f20 (f21 f36 (f20 f27 ?v1)) (f20 f27 ?v2))) ?v0)) f1)))))
(assert (exists ((?v0 S5)) (and (= (f6 (f7 f17 f18) ?v0) f1) (forall ((?v1 S8) (?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f43 ?v1) ?v2))) (f20 (f21 f36 (f20 (f21 f36 (f9 f10 ?v1)) (f9 f10 ?v2))) ?v0)) f1)))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f27 (f20 (f21 f36 ?v0) ?v2))) (f20 (f21 f36 (f20 f27 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f43 ?v0) ?v2))) (f20 (f21 f36 (f9 f10 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S5)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S5)) (= (f6 (f7 f8 (f20 f27 (f20 (f21 f36 ?v2) ?v0))) (f20 (f21 f36 (f20 f27 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S8)) (exists ((?v1 S5)) (and (= (f6 (f7 f17 f18) ?v1) f1) (forall ((?v2 S8)) (= (f6 (f7 f8 (f9 f10 (f11 (f12 f43 ?v2) ?v0))) (f20 (f21 f36 (f9 f10 ?v2)) ?v1)) f1))))))
(check-sat)
(exit)
