(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-sort S26 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S3) S2)
(declare-fun f5 () S5)
(declare-fun f6 (S6 S3) S3)
(declare-fun f7 () S6)
(declare-fun f8 () S3)
(declare-fun f9 () S6)
(declare-fun f10 (S7 Int) S4)
(declare-fun f11 () S7)
(declare-fun f12 () Int)
(declare-fun f13 (S9 Int) S8)
(declare-fun f14 () S9)
(declare-fun f15 (S10 Int) Int)
(declare-fun f16 () S10)
(declare-fun f17 (S11 Int) S3)
(declare-fun f18 () S11)
(declare-fun f19 () S2)
(declare-fun f20 (S12 S4) S8)
(declare-fun f21 () S12)
(declare-fun f22 () S9)
(declare-fun f23 () S12)
(declare-fun f24 (Int) S1)
(declare-fun f25 (S3) S1)
(declare-fun f26 (S4) S1)
(declare-fun f27 () S3)
(declare-fun f28 (S13 S4) S3)
(declare-fun f29 () S13)
(declare-fun f30 () S13)
(declare-fun f31 () S6)
(declare-fun f32 () S3)
(declare-fun f33 () S10)
(declare-fun f34 (S14 S8) S8)
(declare-fun f35 (S15 Int) S14)
(declare-fun f36 () S15)
(declare-fun f37 (S16 S8) Int)
(declare-fun f38 () S16)
(declare-fun f39 () S4)
(declare-fun f40 () S4)
(declare-fun f41 () S4)
(declare-fun f42 () S13)
(declare-fun f43 (S3 S3) S1)
(declare-fun f44 (S17 S4) S4)
(declare-fun f45 (S18 S4) S17)
(declare-fun f46 () S18)
(declare-fun f47 (S19 S8) S4)
(declare-fun f48 (S20 S4) S19)
(declare-fun f49 () S20)
(declare-fun f50 () Int)
(declare-fun f51 (S21 S3) S6)
(declare-fun f52 () S21)
(declare-fun f53 (S22 Int) S16)
(declare-fun f54 () S22)
(declare-fun f55 (S23 S8) S14)
(declare-fun f56 () S23)
(declare-fun f57 () S23)
(declare-fun f58 (S24 S8) S3)
(declare-fun f59 (S25 S3) S24)
(declare-fun f60 () S25)
(declare-fun f61 () S8)
(declare-fun f62 (S8 S8) S1)
(declare-fun f63 () S8)
(declare-fun f64 () S23)
(declare-fun f65 (S26 Int) S10)
(declare-fun f66 () S26)
(declare-fun f67 () S21)
(declare-fun f68 () S23)
(declare-fun f69 () S26)
(declare-fun f70 () S21)
(declare-fun f71 () S6)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f6 f7 f8)) (f6 f9 f8)) (f10 f11 f12))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (= f12 (- 1)))
(assert (= (= f12 f12) true))
(assert (= (< f12 f12) false))
(assert (= (< f12 0) true))
(assert (= (<= f12 f12) true))
(assert (forall ((?v0 Int)) (= (* f12 ?v0) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S4)) (let ((?v_0 (f10 f11 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 f16 ?v0) (f15 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 f18 ?v0) (f17 f18 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 f11 ?v0) (f10 f11 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3)) (= (f3 f19 ?v0) (f3 (f4 f5 (f6 f7 ?v0)) (f6 f9 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f21 (f3 (f4 f5 ?v0) ?v1)) (f13 f22 0))))
(assert (= (f6 f7 f8) (f17 f18 f12)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f20 f23 (f3 (f4 f5 ?v0) ?v1)) (f13 f22 0))))
(assert (forall ((?v0 S4)) (=> (forall ((?v1 S3) (?v2 S3)) (=> (= ?v0 (f3 (f4 f5 ?v1) ?v2)) false)) false)))
(assert (not (= (f24 (- 1)) f1)))
(assert (not (= (f25 (f17 f18 f12)) f1)))
(assert (not (= (f26 (f10 f11 f12)) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) (f10 f11 ?v2)) (and (= ?v0 (f17 f18 ?v2)) (= ?v1 f27)))))
(assert (forall ((?v0 S3)) (= (f28 f29 (f3 f19 ?v0)) (f6 f9 ?v0))))
(assert (forall ((?v0 S3)) (= (f28 f30 (f3 f19 ?v0)) (f6 f7 ?v0))))
(assert (= (f6 f31 (f17 f18 f12)) f32))
(assert (= (f15 f33 (- 1)) 1))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f34 (f35 f36 ?v0) ?v1) (f13 f22 (+ (f37 f38 (f13 f22 ?v0)) (f37 f38 ?v1))))))
(assert (forall ((?v0 Int)) (not (= f39 (f10 f11 ?v0)))))
(assert (= (f26 f40) f1))
(assert (= (f25 f27) f1))
(assert (= (f24 0) f1))
(assert (not (= (f25 f32) f1)))
(assert (not (= (f26 f41) f1)))
(assert (not (= (f24 1) f1)))
(assert (not (= f39 f41)))
(assert (= f41 (f3 (f4 f5 f32) f27)))
(assert (= (f28 f29 f39) f32))
(assert (= (f28 f29 f41) f27))
(assert (= (f28 f30 f39) f27))
(assert (= (f28 f30 f41) f32))
(assert (forall ((?v0 S4)) (= (= (f26 ?v0) f1) (= ?v0 f40))))
(assert (forall ((?v0 S3)) (= (= (f25 ?v0) f1) (= ?v0 f27))))
(assert (forall ((?v0 Int)) (= (= (f24 ?v0) f1) (= ?v0 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 ?v1) (and (= (f28 f30 ?v0) (f28 f30 ?v1)) (= (f28 f29 ?v0) (f28 f29 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f41) (and (= ?v0 f32) (= ?v1 f27)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f39) (and (= ?v0 f27) (= ?v1 f32)))))
(assert (= f39 (f3 (f4 f5 f27) f32)))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f28 f30 ?v0) (f28 f30 ?v1)) (=> (= (f28 f29 ?v0) (f28 f29 ?v1)) (= ?v0 ?v1)))))
(assert (= (f6 f7 f27) f32))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 (f28 f30 ?v0)) (f28 f29 ?v0)) ?v0)))
(assert (= (f3 f19 f27) f41))
(assert (forall ((?v0 Int)) (= (f28 f29 (f10 f11 ?v0)) f27)))
(assert (not (= f8 f27)))
(assert (= (f6 f9 f27) f27))
(assert (forall ((?v0 S3)) (=> (= (f6 f7 ?v0) f32) (= (f6 f9 ?v0) f27))))
(assert (forall ((?v0 S3)) (=> (= (f6 f9 ?v0) f27) (= (f6 f31 (f6 f7 ?v0)) f32))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f28 f30 (f3 (f4 f5 ?v0) ?v1)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f28 f29 (f3 (f4 f5 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int)) (= (f28 f30 (f10 f11 ?v0)) (f17 f18 ?v0))))
(assert (= (f6 f9 f8) f27))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 f16 ?v0) (f15 f16 ?v1)) (= (f24 (f15 f16 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 f18 ?v0) (f17 f18 ?v1)) (= (f25 (f17 f18 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 f11 ?v0) (f10 f11 ?v1)) (= (f26 (f10 f11 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f27)) (= (f6 f7 (f28 f42 (f3 (f4 f5 f27) ?v0))) f27))))
(assert (not (= f27 f32)))
(assert (not (= f40 f41)))
(assert (not (= 0 1)))
(assert (not (= f32 f27)))
(assert (not (= f41 f40)))
(assert (not (= 1 0)))
(assert (forall ((?v0 S3)) (=> (= (f43 (f17 f18 f12) ?v0) f1) (=> (= (f43 ?v0 f32) f1) (exists ((?v1 S3)) (and (and (= (f43 f27 ?v1) f1) (and (= (f43 ?v1 f8) f1) (= (f6 f7 ?v1) ?v0))) (forall ((?v2 S3)) (=> (and (= (f43 f27 ?v2) f1) (and (= (f43 ?v2 f8) f1) (= (f6 f7 ?v2) ?v0))) (= ?v2 ?v1)))))))))
(assert (= (f44 (f45 f46 f39) f39) (f10 f11 f12)))
(assert (= (f47 (f48 f49 f39) (f13 f22 2)) (f10 f11 f12)))
(assert (forall ((?v0 Int)) (= (= f40 (f10 f11 ?v0)) (= (f26 (f10 f11 (+ f50 (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= f27 (f17 f18 ?v0)) (= (f25 (f17 f18 (+ f50 (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= 0 (f15 f16 ?v0)) (= (f24 (f15 f16 (+ f50 (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= (f10 f11 ?v0) f40) (= (f26 (f10 f11 (+ ?v0 (- f50)))) f1))))
(assert (forall ((?v0 Int)) (= (= (f17 f18 ?v0) f27) (= (f25 (f17 f18 (+ ?v0 (- f50)))) f1))))
(assert (forall ((?v0 Int)) (= (= (f15 f16 ?v0) 0) (= (f24 (f15 f16 (+ ?v0 (- f50)))) f1))))
(assert (forall ((?v0 S3)) (= (f43 (f17 f18 f12) (f6 f9 ?v0)) f1)))
(assert (not (= f27 f32)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (or (and (= (f43 f27 ?v0) f1) (= (f43 ?v1 f27) f1)) (and (= (f43 ?v0 f27) f1) (= (f43 f27 ?v1) f1))) (= (f43 (f6 (f51 f52 ?v0) ?v1) f27) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (* ?v0 ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (or (= (f43 f27 ?v0) f1) (= (f43 ?v0 f27) f1)) (or (= (f43 f27 ?v1) f1) (= (f43 ?v1 f27) f1))) (= (f6 f31 (f6 (f51 f52 ?v0) ?v1)) (f6 (f51 f52 (f6 f31 ?v0)) (f6 f31 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f15 f33 (* ?v0 ?v1)) (* (f15 f33 ?v0) (f15 f33 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (or (and (= (f43 f27 ?v0) f1) (= (f43 f27 ?v1) f1)) (and (= (f43 ?v0 f27) f1) (= (f43 ?v1 f27) f1))) (= (f43 f27 (f6 (f51 f52 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (* ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v2 ?v3) f1) (=> (= (f43 f27 ?v1) f1) (=> (= (f43 f27 ?v2) f1) (= (f43 (f6 (f51 f52 ?v0) ?v2) (f6 (f51 f52 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v2 ?v3) f1) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 f27 ?v2) f1) (= (f43 (f6 (f51 f52 ?v0) ?v2) (f6 (f51 f52 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f51 f52 ?v2))) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v2 f27) f1) (= (f43 (f6 ?v_0 ?v1) (f6 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v2 ?v1) (* ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v2 f27) f1) (= (f43 (f6 (f51 f52 ?v1) ?v2) (f6 (f51 f52 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (* ?v1 ?v2) (* ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f51 f52 ?v2))) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 f27 ?v2) f1) (= (f43 (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f51 f52 ?v2))) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 f27 ?v2) f1) (= (f43 (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v2 ?v0) (* ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 f27 ?v2) f1) (= (f43 (f6 (f51 f52 ?v0) ?v2) (f6 (f51 f52 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (* ?v0 ?v2) (* ?v1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f37 f38 ?v1)) (?v_1 (f37 f38 ?v0)) (?v_2 (f53 f54 ?v2))) (=> (<= ?v_1 ?v_0) (= (f37 ?v_2 (f13 f22 (- (+ ?v_0 1) ?v_1))) (* (f37 ?v_2 (f13 f22 (- ?v_0 ?v_1))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f37 f38 ?v1)) (?v_1 (f37 f38 ?v0)) (?v_2 (f55 f56 ?v2))) (=> (<= ?v_1 ?v_0) (= (f34 ?v_2 (f13 f22 (- (+ ?v_0 1) ?v_1))) (f34 (f55 f57 (f34 ?v_2 (f13 f22 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f37 f38 ?v1)) (?v_1 (f37 f38 ?v0)) (?v_2 (f48 f49 ?v2))) (=> (<= ?v_1 ?v_0) (= (f47 ?v_2 (f13 f22 (- (+ ?v_0 1) ?v_1))) (f44 (f45 f46 (f47 ?v_2 (f13 f22 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S3)) (let ((?v_0 (f37 f38 ?v1)) (?v_1 (f37 f38 ?v0)) (?v_2 (f59 f60 ?v2))) (=> (<= ?v_1 ?v_0) (= (f58 ?v_2 (f13 f22 (- (+ ?v_0 1) ?v_1))) (f6 (f51 f52 (f58 ?v_2 (f13 f22 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 ?v0 f27) f1) (=> (= (f43 ?v1 f27) f1) (= (f43 f27 (f6 (f51 f52 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 ?v0 f27) f1) (=> (= (f43 f27 ?v1) f1) (= (f43 (f6 (f51 f52 ?v0) ?v1) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 ?v1 f27) f1) (= (f43 (f6 (f51 f52 ?v1) ?v0) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v1 ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 ?v1 f27) f1) (= (f43 (f6 (f51 f52 ?v0) ?v1) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (* ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 f27 ?v1) f1) (= (f43 f27 (f6 (f51 f52 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (* ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 f27 ?v0) f1) (= (f6 (f51 f52 (f6 f31 ?v1)) ?v0) (f6 f31 (f6 (f51 f52 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (* (f15 f33 ?v1) ?v0) (f15 f33 (* ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f43 (f6 (f51 f52 ?v0) ?v1) f27) f1) (or (and (= (f43 f27 ?v0) f1) (= (f43 ?v1 f27) f1)) (and (= (f43 ?v0 f27) f1) (= (f43 f27 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (* ?v0 ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f59 f60 ?v0))) (= (f58 ?v_0 ?v1) (ite (= ?v1 (f13 f22 0)) f32 (f6 (f51 f52 ?v0) (f58 ?v_0 (f13 f22 (- (f37 f38 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f48 f49 ?v0))) (= (f47 ?v_0 ?v1) (ite (= ?v1 (f13 f22 0)) f41 (f44 (f45 f46 ?v0) (f47 ?v_0 (f13 f22 (- (f37 f38 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f53 f54 ?v0))) (= (f37 ?v_0 ?v1) (ite (= ?v1 (f13 f22 0)) 1 (* ?v0 (f37 ?v_0 (f13 f22 (- (f37 f38 ?v1) 1)))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f34 ?v_0 ?v1) (ite (= ?v1 (f13 f22 0)) f61 (f34 (f55 f57 ?v0) (f34 ?v_0 (f13 f22 (- (f37 f38 ?v1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f43 f27 (f6 (f51 f52 ?v0) ?v1)) f1) (or (and (= (f43 f27 ?v0) f1) (= (f43 f27 ?v1) f1)) (and (= (f43 ?v0 f27) f1) (= (f43 ?v1 f27) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (* ?v0 ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S3)) (= (f43 f27 (f6 (f51 f52 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (* ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f43 ?v0 ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f31 (f6 (f51 f52 ?v0) ?v1)) (f6 (f51 f52 (f6 f31 ?v0)) (f6 f31 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 f33 (* ?v0 ?v1)) (* (f15 f33 ?v0) (f15 f33 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f43 ?v0 ?v1) f1) (= (f43 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f31 ?v0))) (= (f6 (f51 f52 ?v_0) ?v_0) (f6 (f51 f52 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f33 ?v0))) (= (* ?v_0 ?v_0) (* ?v0 ?v0)))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f53 f54 ?v1))) (=> (< 0 ?v_0) (= (* (f37 ?v_1 (f13 f22 (- ?v_0 1))) ?v1) (f37 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f55 f56 ?v1))) (=> (< 0 ?v_0) (= (f34 (f55 f57 (f34 ?v_1 (f13 f22 (- ?v_0 1)))) ?v1) (f34 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S4)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f48 f49 ?v1))) (=> (< 0 ?v_0) (= (f44 (f45 f46 (f47 ?v_1 (f13 f22 (- ?v_0 1)))) ?v1) (f47 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S3)) (let ((?v_0 (f37 f38 ?v0)) (?v_1 (f59 f60 ?v1))) (=> (< 0 ?v_0) (= (f6 (f51 f52 (f58 ?v_1 (f13 f22 (- ?v_0 1)))) ?v1) (f58 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v1 ?v2) f1) (= (f43 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (- ?v0 f50) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f50) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f50 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* f50 ?v0) f50)))
(assert (= (<= f50 f50) true))
(assert (= (< f50 0) false))
(assert (= (< f50 f50) false))
(assert (= (= f50 f50) true))
(assert (= (- f50) f50))
(assert (= f50 0))
(assert (forall ((?v0 S4)) (= (f44 (f45 f46 f40) ?v0) f40)))
(assert (forall ((?v0 S3)) (= (f6 (f51 f52 f27) ?v0) f27)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f44 (f45 f46 ?v0) f40) f40)))
(assert (forall ((?v0 S3)) (= (f6 (f51 f52 ?v0) f27) f27)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f44 (f45 f46 ?v0) ?v1) f40) (or (= ?v0 f40) (= ?v1 f40)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 (f51 f52 ?v0) ?v1) f27) (or (= ?v0 f27) (= ?v1 f27)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f40)) (=> (not (= ?v1 f40)) (not (= (f44 (f45 f46 ?v0) ?v1) f40))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f27)) (=> (not (= ?v1 f27)) (not (= (f6 (f51 f52 ?v0) ?v1) f27))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (* ?v0 ?v1) 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f44 (f45 f46 ?v0) ?v1) f40) (or (= ?v0 f40) (= ?v1 f40)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f6 (f51 f52 ?v0) ?v1) f27) (or (= ?v0 f27) (= ?v1 f27)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (* ?v0 ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 ?v0 f32) f1) (= (f43 (f58 (f59 f60 ?v0) (f13 f22 (+ (f37 f38 ?v1) 1))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (=> (<= ?v0 1) (<= (f37 (f53 f54 ?v0) (f13 f22 (+ (f37 f38 ?v1) 1))) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f62 f63 ?v0) f1) (=> (= (f62 ?v0 f61) f1) (= (f62 (f34 (f55 f56 ?v0) (f13 f22 (+ (f37 f38 ?v1) 1))) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 f27 ?v1) f1) (=> (= (f43 ?v1 f32) f1) (= (f43 (f6 (f51 f52 ?v0) ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v0 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 f27 ?v1) f1) (=> (= (f43 ?v1 f32) f1) (= (f43 (f6 (f51 f52 ?v1) ?v0) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (* ?v1 ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f43 (f17 f18 ?v0) f27) f1) (<= ?v0 f50))))
(assert (forall ((?v0 Int)) (= (<= (f15 f16 ?v0) 0) (<= ?v0 f50))))
(assert (forall ((?v0 Int)) (= (= (f43 f27 (f17 f18 ?v0)) f1) (<= f50 ?v0))))
(assert (forall ((?v0 Int)) (= (<= 0 (f15 f16 ?v0)) (<= f50 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f6 (f51 f52 (f17 f18 ?v0)) (f6 (f51 f52 (f17 f18 ?v1)) ?v2)) (f6 (f51 f52 (f17 f18 (* ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S4)) (= (f44 (f45 f46 (f10 f11 ?v0)) (f44 (f45 f46 (f10 f11 ?v1)) ?v2)) (f44 (f45 f46 (f10 f11 (* ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (f15 f16 ?v0) (* (f15 f16 ?v1) ?v2)) (* (f15 f16 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f51 f52 (f17 f18 ?v0)) (f17 f18 ?v1)) (f17 f18 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f44 (f45 f46 (f10 f11 ?v0)) (f10 f11 ?v1)) (f10 f11 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f15 f16 ?v0) (f15 f16 ?v1)) (f15 f16 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 f18 (* ?v0 ?v1)) (f6 (f51 f52 (f17 f18 ?v0)) (f17 f18 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 f11 (* ?v0 ?v1)) (f44 (f45 f46 (f10 f11 ?v0)) (f10 f11 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 f16 (* ?v0 ?v1)) (* (f15 f16 ?v0) (f15 f16 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f13 f14 ?v1))) (= (f34 (f55 f64 ?v_0) ?v_1) (ite (= (f62 ?v_0 ?v_1) f1) ?v_0 ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 ?v0)) (?v_1 (f15 f16 ?v1))) (= (f15 (f65 f66 ?v_0) ?v_1) (ite (<= ?v_0 ?v_1) ?v_0 ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f17 f18 ?v1))) (= (f6 (f51 f67 ?v_0) ?v_1) (ite (= (f43 ?v_0 ?v_1) f1) ?v_0 ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f13 f14 ?v1))) (= (f34 (f55 f68 ?v_0) ?v_1) (ite (= (f62 ?v_0 ?v_1) f1) ?v_1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 ?v0)) (?v_1 (f15 f16 ?v1))) (= (f15 (f65 f69 ?v_0) ?v_1) (ite (<= ?v_0 ?v_1) ?v_1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f17 f18 ?v1))) (= (f6 (f51 f70 ?v_0) ?v_1) (ite (= (f43 ?v_0 ?v_1) f1) ?v_1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f15 f16 ?v0) (f15 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f43 (f17 f18 ?v0) (f17 f18 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3)) (= (f43 (f6 f7 ?v0) f32) f1)))
(assert (forall ((?v0 S3)) (= (f43 (f6 f31 (f6 f7 ?v0)) f32) f1)))
(assert (forall ((?v0 S3)) (= (f43 (f6 f9 ?v0) f32) f1)))
(assert (forall ((?v0 S3)) (= (f43 (f6 f31 (f6 f9 ?v0)) f32) f1)))
(assert (= (<= f50 f12) false))
(assert (= (<= f12 f50) true))
(assert (= (< f50 f12) false))
(assert (= (< f12 f50) true))
(assert (= (= f50 f12) false))
(assert (= (= f12 f50) false))
(assert (not (= (f43 f32 f27) f1)))
(assert (not (<= 1 0)))
(assert (= (f43 f27 f32) f1))
(assert (<= 0 1))
(assert (not (= f39 f40)))
(assert (= (f10 f11 f50) f40))
(assert (= (f17 f18 f50) f27))
(assert (= 0 0))
(assert (= (f10 f11 f50) f40))
(assert (= (f17 f18 f50) f27))
(assert (= 0 0))
(assert (= (f13 f14 f50) f63))
(assert (= (f43 f27 f8) f1))
(assert (= (f28 f30 f40) f27))
(assert (= (f28 f29 f40) f27))
(assert (= f40 (f3 (f4 f5 f27) f27)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f40) (and (= ?v0 f27) (= ?v1 f27)))))
(assert (= (f24 0) f1))
(assert (= (f25 (f17 f18 f50)) f1))
(assert (= (f26 (f10 f11 f50)) f1))
(assert (forall ((?v0 S8)) (= (f6 f31 (f58 (f59 f60 (f17 f18 f12)) ?v0)) f32)))
(assert (forall ((?v0 S8)) (= (f15 f33 (f37 (f53 f54 (- 1)) ?v0)) 1)))
(assert (= (f6 f31 f32) f32))
(assert (= (f15 f33 1) 1))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v1 f8) f1) (= (f43 (f6 f7 ?v1) (f6 f7 ?v0)) f1))))))
(assert (forall ((?v0 S3)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 ?v0 f8) f1) (= (f43 f27 (f6 f9 ?v0)) f1)))))
(assert (forall ((?v0 S3)) (= (f43 (f17 f18 f12) (f6 f7 ?v0)) f1)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S3)) (let ((?v_0 (f59 f60 ?v2))) (=> (<= (f37 f38 ?v0) (f37 f38 ?v1)) (=> (= (f43 f27 ?v2) f1) (=> (= (f43 ?v2 f32) f1) (= (f43 (f58 ?v_0 ?v1) (f58 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f53 f54 ?v2))) (=> (<= (f37 f38 ?v0) (f37 f38 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f37 ?v_0 ?v1) (f37 ?v_0 ?v0))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f55 f56 ?v2))) (=> (<= (f37 f38 ?v0) (f37 f38 ?v1)) (=> (= (f62 f63 ?v2) f1) (=> (= (f62 ?v2 f61) f1) (= (f62 (f34 ?v_0 ?v1) (f34 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 ?v0))) (= (f37 (f53 f54 ?v_0) (f13 f22 2)) (* ?v_0 ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f34 (f55 f56 ?v_0) (f13 f22 2)) (f34 (f55 f57 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f47 (f48 f49 ?v_0) (f13 f22 2)) (f44 (f45 f46 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f58 (f59 f60 ?v_0) (f13 f22 2)) (f6 (f51 f52 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f50 ?v0) (=> (<= f50 ?v1) (= (f6 (f51 f52 (f17 f18 ?v0)) (f17 f18 ?v1)) (f17 f18 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f50 ?v0) (=> (<= f50 ?v1) (= (f44 (f45 f46 (f10 f11 ?v0)) (f10 f11 ?v1)) (f10 f11 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f50 ?v0) (=> (<= f50 ?v1) (= (* (f15 f16 ?v0) (f15 f16 ?v1)) (f15 f16 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f50 ?v0) (=> (<= f50 ?v1) (= (f34 (f55 f57 (f13 f14 ?v0)) (f13 f14 ?v1)) (f13 f14 (* ?v0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S3)) (let ((?v_0 (f59 f60 ?v2))) (=> (<= (f37 f38 ?v0) (f37 f38 ?v1)) (=> (= (f43 f32 ?v2) f1) (= (f43 (f58 ?v_0 ?v0) (f58 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f53 f54 ?v2))) (=> (<= (f37 f38 ?v0) (f37 f38 ?v1)) (=> (<= 1 ?v2) (<= (f37 ?v_0 ?v0) (f37 ?v_0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f55 f56 ?v2))) (=> (<= (f37 f38 ?v0) (f37 f38 ?v1)) (=> (= (f62 f61 ?v2) f1) (= (f62 (f34 ?v_0 ?v0) (f34 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f43 f32 ?v0) f1) (= (f43 f32 (f58 (f59 f60 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 1 ?v0) (<= 1 (f37 (f53 f54 ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f62 f61 ?v0) f1) (= (f62 f61 (f34 (f55 f56 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S8)) (= (f58 (f59 f60 f27) ?v0) (ite (= ?v0 (f13 f22 0)) f32 f27))))
(assert (forall ((?v0 S8)) (= (f47 (f48 f49 f40) ?v0) (ite (= ?v0 (f13 f22 0)) f41 f40))))
(assert (forall ((?v0 S8)) (= (f37 (f53 f54 0) ?v0) (ite (= ?v0 (f13 f22 0)) 1 0))))
(assert (forall ((?v0 S8)) (= (f34 (f55 f56 f63) ?v0) (ite (= ?v0 (f13 f22 0)) f61 f63))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v0)))) (= (f58 (f59 f60 f27) ?v_0) (ite (= ?v_0 (f13 f22 0)) f32 f27)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v0)))) (= (f47 (f48 f49 f40) ?v_0) (ite (= ?v_0 (f13 f22 0)) f41 f40)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v0)))) (= (f37 (f53 f54 0) ?v_0) (ite (= ?v_0 (f13 f22 0)) 1 0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v0)))) (= (f34 (f55 f56 f63) ?v_0) (ite (= ?v_0 (f13 f22 0)) f61 f63)))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v1)))) (= (< 0 (f37 f38 (f34 (f55 f56 ?v0) ?v_0))) (or (= ?v_0 (f13 f22 0)) (< 0 (f37 f38 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 f22 (* (f37 f38 (f13 f14 ?v0)) (f37 f38 (f13 f14 ?v1)))) (ite (< ?v0 f50) (f13 f22 0) (f13 f22 (f15 f16 (* ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (let ((?v_0 (f37 f38 ?v2))) (= (f13 f22 (* (f37 f38 (f13 f14 ?v0)) (* (f37 f38 (f13 f14 ?v1)) ?v_0))) (ite (< ?v0 f50) (f13 f22 0) (f13 f22 (* (f37 f38 (f13 f14 (* ?v0 ?v1))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f53 f54 ?v0))) (= (f37 ?v_0 (f13 f22 (* (f37 f38 ?v1) (f37 f38 ?v2)))) (f37 (f53 f54 (f37 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f34 ?v_0 (f13 f22 (* (f37 f38 ?v1) (f37 f38 ?v2)))) (f34 (f55 f56 (f34 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f48 f49 ?v0))) (= (f47 ?v_0 (f13 f22 (* (f37 f38 ?v1) (f37 f38 ?v2)))) (f47 (f48 f49 (f47 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f53 f54 ?v0))) (= (f37 ?v_0 (f13 f22 (* 2 (f37 f38 ?v1)))) (f37 (f53 f54 (f37 ?v_0 ?v1)) (f13 f22 2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f34 ?v_0 (f13 f22 (* 2 (f37 f38 ?v1)))) (f34 (f55 f56 (f34 ?v_0 ?v1)) (f13 f22 2))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f48 f49 ?v0))) (= (f47 ?v_0 (f13 f22 (* 2 (f37 f38 ?v1)))) (f47 (f48 f49 (f47 ?v_0 ?v1)) (f13 f22 2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f37 f38 (f13 f14 ?v0)))) (=> (< 0 ?v_0) (= (f13 f22 (f15 f16 ?v0)) (f13 f22 (+ (f37 f38 (f13 f22 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f51 f52 ?v0))) (=> (not (= ?v0 f27)) (= (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f27)) (= (= (f6 (f51 f52 ?v1) ?v0) (f6 (f51 f52 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3)) (= (f6 (f51 f52 f32) ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S8)) (= (f43 f27 (f58 (f59 f60 ?v0) (f13 f22 (* 2 (f37 f38 ?v1))))) f1)))
(assert (forall ((?v0 Int) (?v1 S8)) (<= 0 (f37 (f53 f54 ?v0) (f13 f22 (* 2 (f37 f38 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f43 f27 (f58 (f59 f60 ?v0) (f13 f22 (+ (* 2 (f37 f38 ?v1)) 1)))) f1) (= (f43 f27 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 (f37 (f53 f54 ?v0) (f13 f22 (+ (* 2 (f37 f38 ?v1)) 1)))) (<= 0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f43 (f58 (f59 f60 ?v0) (f13 f22 (* 2 (f37 f38 ?v1)))) f27) f1) (= ?v0 f27))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= (f37 (f53 f54 ?v0) (f13 f22 (* 2 (f37 f38 ?v1)))) 0) (= ?v0 0))))
(assert (forall ((?v0 S8)) (= (f37 (f53 f54 (- 1)) (f13 f22 (+ (* 2 (f37 f38 ?v0)) 1))) (- 1))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f10 f11 f12))) (= (f47 (f48 f49 ?v_0) (f13 f22 (+ (* 2 (f37 f38 ?v0)) 1))) ?v_0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f17 f18 f12))) (= (f58 (f59 f60 ?v_0) (f13 f22 (+ (* 2 (f37 f38 ?v0)) 1))) ?v_0))))
(assert (forall ((?v0 S8)) (= (f58 (f59 f60 (f17 f18 f12)) (f13 f22 (* 2 (f37 f38 ?v0)))) f32)))
(assert (forall ((?v0 S8)) (= (f47 (f48 f49 (f10 f11 f12)) (f13 f22 (* 2 (f37 f38 ?v0)))) f41)))
(assert (forall ((?v0 S8)) (= (f37 (f53 f54 (- 1)) (f13 f22 (* 2 (f37 f38 ?v0)))) 1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f37 f38 (f13 f14 ?v0)) (f37 f38 (f13 f14 ?v1))) (ite (< ?v0 ?v1) (< f50 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f37 f38 (f13 f14 ?v0)) (f37 f38 (f13 f14 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f50)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f13 f22 (+ (f37 f38 (f13 f14 ?v0)) (f37 f38 (f13 f14 ?v1)))) (ite (< ?v0 f50) (f13 f22 (f15 f16 ?v1)) (ite (< ?v1 f50) (f13 f22 (f15 f16 ?v0)) (f13 f22 (f15 f16 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f13 f22 (f15 f16 ?v0)) (f13 f22 0)) (<= ?v0 f50))))
(assert (forall ((?v0 Int)) (= (= (f13 f22 0) (f13 f22 (f15 f16 ?v0))) (<= ?v0 f50))))
(assert (forall ((?v0 Int)) (= (< 0 (f37 f38 (f13 f14 ?v0))) (< f50 ?v0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f13 f22 2))) (= (f58 (f59 f60 (f6 f31 ?v0)) ?v_0) (f58 (f59 f60 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f22 2))) (= (f37 (f53 f54 (f15 f33 ?v0)) ?v_0) (f37 (f53 f54 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f37 (f53 f54 ?v0) (f13 f22 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f34 (f55 f56 ?v0) (f13 f22 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f47 (f48 f49 ?v0) (f13 f22 1)) ?v0)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f58 (f59 f60 ?v0) (f13 f22 2)))) (= (f6 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f37 (f53 f54 ?v0) (f13 f22 2)))) (= (f15 f33 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S8)) (= (f6 f31 (f58 (f59 f60 ?v0) ?v1)) (f58 (f59 f60 (f6 f31 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f15 f33 (f37 (f53 f54 ?v0) ?v1)) (f37 (f53 f54 (f15 f33 ?v0)) ?v1))))
(assert (forall ((?v0 S8)) (= (f47 (f48 f49 f40) (f13 f22 (+ (f37 f38 ?v0) 1))) f40)))
(assert (forall ((?v0 S8)) (= (f58 (f59 f60 f27) (f13 f22 (+ (f37 f38 ?v0) 1))) f27)))
(assert (forall ((?v0 S8)) (= (f37 (f53 f54 0) (f13 f22 (+ (f37 f38 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f34 (f55 f56 f63) (f13 f22 (+ (f37 f38 ?v0) 1))) f63)))
(assert (= (f47 (f48 f49 f40) (f13 f22 2)) f40))
(assert (= (f58 (f59 f60 f27) (f13 f22 2)) f27))
(assert (= (f37 (f53 f54 0) (f13 f22 2)) 0))
(assert (= (f34 (f55 f56 f63) (f13 f22 2)) f63))
(assert (forall ((?v0 S4) (?v1 S8)) (= (= (f47 (f48 f49 ?v0) ?v1) f40) (and (= ?v0 f40) (not (= ?v1 (f13 f22 0)))))))
(assert (forall ((?v0 S3) (?v1 S8)) (= (= (f58 (f59 f60 ?v0) ?v1) f27) (and (= ?v0 f27) (not (= ?v1 (f13 f22 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f37 (f53 f54 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f13 f22 0)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f34 (f55 f56 ?v0) ?v1) f63) (and (= ?v0 f63) (not (= ?v1 (f13 f22 0)))))))
(assert (forall ((?v0 S4)) (= (= (f47 (f48 f49 ?v0) (f13 f22 2)) f40) (= ?v0 f40))))
(assert (forall ((?v0 S3)) (= (= (f58 (f59 f60 ?v0) (f13 f22 2)) f27) (= ?v0 f27))))
(assert (forall ((?v0 Int)) (= (= (f37 (f53 f54 ?v0) (f13 f22 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (not (= ?v0 f40)) (not (= (f47 (f48 f49 ?v0) ?v1) f40)))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (not (= ?v0 f27)) (not (= (f58 (f59 f60 ?v0) ?v1) f27)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f37 (f53 f54 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v1)))) (= (= (f47 (f48 f49 ?v0) ?v_0) f40) (and (= ?v0 f40) (not (= ?v_0 (f13 f22 0))))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v1)))) (= (= (f58 (f59 f60 ?v0) ?v_0) f27) (and (= ?v0 f27) (not (= ?v_0 (f13 f22 0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v1)))) (= (= (f37 (f53 f54 ?v0) ?v_0) 0) (and (= ?v0 0) (not (= ?v_0 (f13 f22 0))))))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f13 f22 (f15 f16 ?v1)))) (= (= (f34 (f55 f56 ?v0) ?v_0) f63) (and (= ?v0 f63) (not (= ?v_0 (f13 f22 0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f37 (f53 f54 (* ?v0 ?v1)) ?v2) (* (f37 (f53 f54 ?v0) ?v2) (f37 (f53 f54 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f34 (f55 f56 (f34 (f55 f57 ?v0) ?v1)) ?v2) (f34 (f55 f57 (f34 (f55 f56 ?v0) ?v2)) (f34 (f55 f56 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f47 (f48 f49 (f44 (f45 f46 ?v0) ?v1)) ?v2) (f44 (f45 f46 (f47 (f48 f49 ?v0) ?v2)) (f47 (f48 f49 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S8)) (= (f58 (f59 f60 (f6 (f51 f52 ?v0) ?v1)) ?v2) (f6 (f51 f52 (f58 (f59 f60 ?v0) ?v2)) (f58 (f59 f60 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f37 (f53 f54 ?v0) ?v1))) (= (* ?v_0 ?v0) (* ?v0 ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f34 (f55 f56 ?v0) ?v1))) (= (f34 (f55 f57 ?v_0) ?v0) (f34 (f55 f57 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f47 (f48 f49 ?v0) ?v1))) (= (f44 (f45 f46 ?v_0) ?v0) (f44 (f45 f46 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f58 (f59 f60 ?v0) ?v1))) (= (f6 (f51 f52 ?v_0) ?v0) (f6 (f51 f52 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f53 f54 ?v0))) (= (f37 ?v_0 (f13 f22 (+ (f37 f38 ?v1) (f37 f38 ?v2)))) (* (f37 ?v_0 ?v1) (f37 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f34 ?v_0 (f13 f22 (+ (f37 f38 ?v1) (f37 f38 ?v2)))) (f34 (f55 f57 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f48 f49 ?v0))) (= (f47 ?v_0 (f13 f22 (+ (f37 f38 ?v1) (f37 f38 ?v2)))) (f44 (f45 f46 (f47 ?v_0 ?v1)) (f47 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S8)) (let ((?v_0 (f59 f60 ?v0))) (= (f58 ?v_0 (f13 f22 (+ (f37 f38 ?v1) (f37 f38 ?v2)))) (f6 (f51 f52 (f58 ?v_0 ?v1)) (f58 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f53 f54 ?v0))) (= (f37 ?v_0 (f13 f22 (+ (* 2 (f37 f38 ?v1)) 1))) (* ?v0 (f37 (f53 f54 (f37 ?v_0 ?v1)) (f13 f22 2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f34 ?v_0 (f13 f22 (+ (* 2 (f37 f38 ?v1)) 1))) (f34 (f55 f57 ?v0) (f34 (f55 f56 (f34 ?v_0 ?v1)) (f13 f22 2)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f48 f49 ?v0))) (= (f47 ?v_0 (f13 f22 (+ (* 2 (f37 f38 ?v1)) 1))) (f44 (f45 f46 ?v0) (f47 (f48 f49 (f47 ?v_0 ?v1)) (f13 f22 2)))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f59 f60 ?v0))) (= (f58 ?v_0 (f13 f22 (+ (* 2 (f37 f38 ?v1)) 1))) (f6 (f51 f52 ?v0) (f58 (f59 f60 (f58 ?v_0 ?v1)) (f13 f22 2)))))))
(assert (forall ((?v0 Int)) (= (f37 (f53 f54 ?v0) (f13 f22 3)) (* (* ?v0 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f34 (f55 f56 ?v0) (f13 f22 3)) (f34 (f55 f57 (f34 (f55 f57 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S4)) (= (f47 (f48 f49 ?v0) (f13 f22 3)) (f44 (f45 f46 (f44 (f45 f46 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f58 (f59 f60 ?v0) (f13 f22 3)) (f6 (f51 f52 (f6 (f51 f52 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f37 (f53 f54 ?v0) (f13 f22 2)) (* ?v0 ?v0))))
(assert (forall ((?v0 S8)) (= (f34 (f55 f56 ?v0) (f13 f22 2)) (f34 (f55 f57 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f47 (f48 f49 ?v0) (f13 f22 2)) (f44 (f45 f46 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f58 (f59 f60 ?v0) (f13 f22 2)) (f6 (f51 f52 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f53 f54 ?v0))) (= (f37 ?v_0 (f13 f22 (+ (f37 f38 ?v1) 1))) (* (f37 ?v_0 ?v1) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f34 ?v_0 (f13 f22 (+ (f37 f38 ?v1) 1))) (f34 (f55 f57 (f34 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f48 f49 ?v0))) (= (f47 ?v_0 (f13 f22 (+ (f37 f38 ?v1) 1))) (f44 (f45 f46 (f47 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f59 f60 ?v0))) (= (f58 ?v_0 (f13 f22 (+ (f37 f38 ?v1) 1))) (f6 (f51 f52 (f58 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f53 f54 ?v0))) (= (f37 ?v_0 (f13 f22 (+ (f37 f38 ?v1) 1))) (* ?v0 (f37 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f34 ?v_0 (f13 f22 (+ (f37 f38 ?v1) 1))) (f34 (f55 f57 ?v0) (f34 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f48 f49 ?v0))) (= (f47 ?v_0 (f13 f22 (+ (f37 f38 ?v1) 1))) (f44 (f45 f46 ?v0) (f47 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S8)) (let ((?v_0 (f59 f60 ?v0))) (= (f58 ?v_0 (f13 f22 (+ (f37 f38 ?v1) 1))) (f6 (f51 f52 ?v0) (f58 ?v_0 ?v1))))))
(assert (forall ((?v0 S3)) (= (f58 (f59 f60 ?v0) (f13 f22 0)) f32)))
(assert (forall ((?v0 S4)) (= (f47 (f48 f49 ?v0) (f13 f22 0)) f41)))
(assert (forall ((?v0 Int)) (= (f37 (f53 f54 ?v0) (f13 f22 0)) 1)))
(assert (forall ((?v0 S8)) (= (f34 (f55 f56 ?v0) (f13 f22 0)) f61)))
(assert (= (f58 (f59 f60 f32) (f13 f22 2)) f32))
(assert (= (f47 (f48 f49 f41) (f13 f22 2)) f41))
(assert (= (f37 (f53 f54 1) (f13 f22 2)) 1))
(assert (= (f34 (f55 f56 f61) (f13 f22 2)) f61))
(assert (forall ((?v0 S8)) (= (f58 (f59 f60 f32) ?v0) f32)))
(assert (forall ((?v0 S8)) (= (f47 (f48 f49 f41) ?v0) f41)))
(assert (forall ((?v0 S8)) (= (f37 (f53 f54 1) ?v0) 1)))
(assert (forall ((?v0 S8)) (= (f34 (f55 f56 f61) ?v0) f61)))
(assert (forall ((?v0 S3)) (= (f43 f27 (f58 (f59 f60 ?v0) (f13 f22 2))) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f37 (f53 f54 ?v0) (f13 f22 2)))))
(assert (forall ((?v0 S3) (?v1 S8)) (= (f43 f27 (f58 (f59 f60 (f6 f31 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S8)) (<= 0 (f37 (f53 f54 (f15 f33 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S8)) (=> (= (f43 f27 ?v0) f1) (= (f43 f27 (f58 (f59 f60 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (<= 0 (f37 (f53 f54 ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f62 f63 ?v0) f1) (= (f62 f63 (f34 (f55 f56 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S8)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 f27 ?v0) f1) (= (f43 (f58 (f59 f60 ?v0) ?v2) (f58 (f59 f60 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f37 (f53 f54 ?v0) ?v2) (f37 (f53 f54 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f62 ?v0 ?v1) f1) (=> (= (f62 f63 ?v0) f1) (= (f62 (f34 (f55 f56 ?v0) ?v2) (f34 (f55 f56 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S3)) (=> (= (f58 (f59 f60 ?v0) ?v1) (f58 (f59 f60 ?v2) ?v1)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 f27 ?v2) f1) (=> (< 0 (f37 f38 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (= (f37 (f53 f54 ?v0) ?v1) (f37 (f53 f54 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f37 f38 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f34 (f55 f56 ?v0) ?v1) (f34 (f55 f56 ?v2) ?v1)) (=> (= (f62 f63 ?v0) f1) (=> (= (f62 f63 ?v2) f1) (=> (< 0 (f37 f38 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S3)) (let ((?v_0 (f13 f22 (+ (f37 f38 ?v1) 1)))) (=> (= (f43 (f58 (f59 f60 ?v0) ?v_0) (f58 (f59 f60 ?v2) ?v_0)) f1) (=> (= (f43 f27 ?v2) f1) (= (f43 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (let ((?v_0 (f13 f22 (+ (f37 f38 ?v1) 1)))) (=> (<= (f37 (f53 f54 ?v0) ?v_0) (f37 (f53 f54 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f22 (+ (f37 f38 ?v1) 1)))) (=> (= (f62 (f34 (f55 f56 ?v0) ?v_0) (f34 (f55 f56 ?v2) ?v_0)) f1) (=> (= (f62 f63 ?v2) f1) (= (f62 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S3)) (let ((?v_0 (f13 f22 (+ (f37 f38 ?v1) 1)))) (=> (= (f58 (f59 f60 ?v0) ?v_0) (f58 (f59 f60 ?v2) ?v_0)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 f27 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (let ((?v_0 (f13 f22 (+ (f37 f38 ?v1) 1)))) (=> (= (f37 (f53 f54 ?v0) ?v_0) (f37 (f53 f54 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f22 (+ (f37 f38 ?v1) 1)))) (=> (= (f34 (f55 f56 ?v0) ?v_0) (f34 (f55 f56 ?v2) ?v_0)) (=> (= (f62 f63 ?v0) f1) (=> (= (f62 f63 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f22 2))) (=> (= (f43 (f58 (f59 f60 ?v0) ?v_0) (f58 (f59 f60 ?v1) ?v_0)) f1) (=> (= (f43 f27 ?v1) f1) (= (f43 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f22 2))) (=> (<= (f37 (f53 f54 ?v0) ?v_0) (f37 (f53 f54 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f13 f22 2))) (=> (= (f62 (f34 (f55 f56 ?v0) ?v_0) (f34 (f55 f56 ?v1) ?v_0)) f1) (=> (= (f62 f63 ?v1) f1) (= (f62 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f13 f22 2))) (=> (= (f58 (f59 f60 ?v0) ?v_0) (f58 (f59 f60 ?v1) ?v_0)) (=> (= (f43 f27 ?v0) f1) (=> (= (f43 f27 ?v1) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f22 2))) (=> (= (f37 (f53 f54 ?v0) ?v_0) (f37 (f53 f54 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f13 f22 2))) (=> (= (f34 (f55 f56 ?v0) ?v_0) (f34 (f55 f56 ?v1) ?v_0)) (=> (= (f62 f63 ?v0) f1) (=> (= (f62 f63 ?v1) f1) (= ?v0 ?v1)))))))
(assert (= f40 (f10 f11 f50)))
(assert (= f27 (f17 f18 f50)))
(assert (= 0 0))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f71 ?v0))) (=> (= (f43 (f17 f18 f12) ?v0) f1) (=> (= (f43 ?v0 f32) f1) (and (= (f43 f27 ?v_0) f1) (and (= (f43 ?v_0 f8) f1) (= (f6 f7 ?v_0) ?v0))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f71 ?v0))) (=> (= (f43 (f17 f18 f12) ?v0) f1) (=> (= (f43 ?v0 f32) f1) (and (= (f43 f27 ?v_0) f1) (= (f43 ?v_0 f8) f1)))))))
(assert (forall ((?v0 S3)) (= (f43 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (< 0 (f37 f38 (f34 (f55 f56 ?v0) ?v1))) (or (< 0 (f37 f38 ?v0)) (= ?v1 (f13 f22 0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (< 0 (f37 f38 (f34 (f55 f56 ?v0) ?v1))) (or (= ?v1 (f13 f22 0)) (< 0 (f37 f38 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 (f51 f52 ?v0) ?v1) (f6 (f51 f52 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f55 f56 ?v0))) (= (f34 ?v_0 ?v1) (ite (= ?v1 (f13 f22 0)) (f13 f22 1) (f13 f22 (* (f37 f38 ?v0) (f37 f38 (f34 ?v_0 (f13 f22 (- (f37 f38 ?v1) 1)))))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f13 f22 0)) (?v_2 (f37 f38 ?v0)) (?v_1 (f37 f38 ?v1))) (= (f13 f22 (* ?v_2 ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f13 f22 (+ ?v_1 (* (f37 f38 (f13 f22 (- ?v_2 1))) ?v_1))))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f37 f38 ?v0))) (= (f13 f22 (* ?v_0 2)) (f13 f22 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f13 f22 (+ 0 1)))) (= (f34 (f55 f56 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f37 f38 ?v0))) (= (f13 f22 (* 2 ?v_0)) (f13 f22 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f51 f52 ?v0))) (= (f6 (f51 f52 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f51 f52 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f13 f22 (+ 0 1)))) (= (= (f34 (f55 f56 ?v0) ?v1) ?v_0) (or (= ?v1 (f13 f22 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f55 f56 ?v0))) (=> (< 0 (f37 f38 ?v0)) (=> (< (f37 f38 (f34 ?v_0 ?v1)) (f37 f38 (f34 ?v_0 ?v2))) (< (f37 f38 ?v1) (f37 f38 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f37 f38 ?v0)) (<= ?v_0 (f37 f38 (f34 (f55 f56 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f13 f22 (* ?v0 ?v1)) (f13 f22 (* (f37 f38 (f13 f22 (- ?v0))) (f37 f38 (f13 f22 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f13 f22 (* ?v0 ?v1)) (f13 f22 (* (f37 f38 (f13 f22 ?v0)) (f37 f38 (f13 f22 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (= (f13 f22 (f37 (f53 f54 ?v0) ?v1)) (f34 (f55 f56 (f13 f22 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f53 f54 ?v0))) (= (f37 (f53 f54 (f37 ?v_0 ?v1)) ?v2) (f37 ?v_0 (f13 f22 (* (f37 f38 ?v1) (f37 f38 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (* (f37 f38 ?v0) (f37 f38 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f37 (f53 f54 (f37 f38 ?v0)) ?v1) (f37 f38 (f34 (f55 f56 ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (* (f37 f38 ?v0) (f37 f38 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f37 f38 (f34 (f55 f56 ?v0) ?v1)) (f37 (f53 f54 (f37 f38 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (f13 f22 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f13 f22 (* (f37 f38 (f13 f22 (ite (< ?v0 0) (- ?v0) ?v0))) (f37 f38 (f13 f22 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f15 f16 ?v1))) (= (= (f37 f38 ?v0) ?v_0) (and (= ?v0 (f13 f22 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f15 f16 ?v0) (f15 f16 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f15 f16 ?v0) (f15 f16 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f15 f16 ?v0) (f15 f16 ?v1)) (f15 f16 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* (f15 f16 ?v0) (f15 f16 ?v1)) (f15 f16 (* ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f15 f16 ?v0) (f15 f16 ?v1)) (f15 f16 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (- (f15 f16 ?v0)) (f15 f16 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f15 f16 ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f43 ?v0 ?v1) f1) (= (f43 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f43 ?v0 ?v1) f1) (= (f43 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f43 ?v0 (f6 (f51 f70 ?v1) ?v2)) f1) (or (= (f43 ?v0 ?v1) f1) (= (f43 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f15 (f65 f69 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f43 (f6 (f51 f67 ?v0) ?v1) ?v2) f1) (or (= (f43 ?v0 ?v2) f1) (= (f43 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f15 (f65 f66 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f43 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 ?v0 ?v1) f1) (= (= (f43 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f43 ?v1 ?v2) f1) (= (f43 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f43 ?v2 ?v1) f1) (= (f43 ?v2 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= ?v1 ?v2) (= (f43 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= ?v0 ?v2) (= (f43 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v1 ?v2) f1) (= (f43 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f43 ?v0 ?v1) f1) (=> (= (f43 ?v1 ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S8)) (= (f13 f22 (f37 f38 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f37 f38 (f13 f22 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f37 f38 (f13 f22 ?v0)) 0))))
(check-sat)
(exit)
