(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 () Int)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 (S6 S5) S4)
(declare-fun f10 () S6)
(declare-fun f11 () S5)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 (S7 S8) Int)
(declare-fun f16 () S7)
(declare-fun f17 () S8)
(declare-fun f18 () S5)
(declare-fun f19 (S9 S5) S5)
(declare-fun f20 (S10 Int) S9)
(declare-fun f21 () S10)
(declare-fun f22 (Int Int S5) S8)
(declare-fun f23 (S11 Int) S1)
(declare-fun f24 () S7)
(declare-fun f25 () S3)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f8 (f9 f10 f11) f12))) (not (= (f3 (f4 f5 (+ f6 (+ f7 ?v_0))) f13) (f3 (f4 f5 (+ f6 (+ f14 ?v_0))) f13)))))
(assert (let ((?v_0 (f15 f16 f17))) (= (f3 (f4 f5 f7) ?v_0) (f3 (f4 f5 f14) ?v_0))))
(assert (= f18 (f19 (f20 f21 1) f11)))
(assert (= f17 (f22 f13 f6 f18)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) 2))) (= (not (= ?v_0 0)) (= ?v_0 1)))))
(assert (forall ((?v0 S11) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f23 ?v0 ?v1) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f23 ?v0 ?v4) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f23 ?v0 ?v4) f1)))))))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) ?v0) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (mod ?v0 ?v1) (ite (<= 0 ?v1) (f3 ?v_0 ?v1) (f3 ?v_0 (- ?v1)))))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (- 1)) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) (- ?v1)) (- (f3 (f4 f5 (- ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (- ?v1)) (ite (= ?v_1 0) 0 (- ?v_1 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f3 (f4 f5 (- ?v0)) ?v1) (ite (= ?v_0 0) 0 (- ?v1 ?v_0))))))
(assert (= (f15 f24 f17) 1))
(assert (=> (forall ((?v0 S5)) (=> (= f18 (f19 (f20 f21 1) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f3 (f4 f5 ?v_0) ?v1) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f3 (f4 f5 ?v0) ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f3 (f4 f5 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v1) ?v0))) (=> (< ?v0 0) (and (<= ?v_0 0) (< ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f3 (f4 f5 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (- (* 2 (f3 (f4 f5 (+ ?v1 1)) ?v0)) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (<= (f3 (f4 f5 ?v1) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (< ?v0 (f3 (f4 f5 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ ?v0 ?v1))) (=> (< 0 ?v0) (=> (<= ?v_0 0) (= (f3 (f4 f5 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (<= (+ (* ?v1 (f3 (f4 f5 ?v3) ?v0)) ?v2) 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (< (* ?v1 ?v0) (+ (* ?v1 (f3 (f4 f5 ?v3) ?v0)) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f3 (f4 f5 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (< (+ (* ?v2 (f3 (f4 f5 ?v3) ?v0)) ?v1) (* ?v2 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (<= 0 (+ (* ?v2 (f3 (f4 f5 ?v3) ?v0)) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f3 (f4 f5 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f3 (f4 f5 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (+ 1 (* 2 (f3 (f4 f5 ?v1) ?v0)))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 (f4 f5 (- 1)) ?v0) (- ?v0 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (<= (f3 (f4 f5 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (< (f3 (f4 f5 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f3 (f4 f25 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f3 (f4 f5 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
