(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2 S3) S1)
(declare-fun f6 (S4) S3)
(declare-fun f7 () S4)
(declare-fun f8 (S5 S6) S3)
(declare-fun f9 (S7 S6) S5)
(declare-fun f10 (S8) S7)
(declare-fun f11 () S8)
(declare-fun f12 () S6)
(declare-fun f13 () S3)
(declare-fun f14 () S8)
(declare-fun f15 () S6)
(declare-fun f16 (S8 Int) S9)
(declare-fun f17 (S1 S8) S9)
(declare-fun f18 () S8)
(declare-fun f19 (S10 Int) S1)
(declare-fun f20 () S10)
(declare-fun f21 (S12 S11) Int)
(declare-fun f22 (S13 S11) S12)
(declare-fun f23 () S13)
(declare-fun f24 (S14 S11) S11)
(declare-fun f25 () S14)
(declare-fun f26 () S11)
(declare-fun f27 (S15 S11) S2)
(declare-fun f28 (S16 Int) S15)
(declare-fun f29 () S16)
(declare-fun f30 (S3) S3)
(declare-fun f31 (S9 S11) S1)
(declare-fun f32 (S6 Int) S8)
(declare-fun f33 (S10) S10)
(declare-fun f34 (S17 Int) Int)
(declare-fun f35 (S18 Int) S17)
(declare-fun f36 () S18)
(declare-fun f37 () Int)
(declare-fun f38 () S18)
(declare-fun f39 (S19 S10) Int)
(declare-fun f40 () S19)
(declare-fun f41 () S12)
(declare-fun f42 (S20 S4) S11)
(declare-fun f43 (S21 S22) S20)
(declare-fun f44 () S21)
(declare-fun f45 () S22)
(declare-fun f46 (S3 S4) S4)
(declare-fun f47 (S22 S2) Int)
(declare-fun f48 () S2)
(declare-fun f49 (S2 S11) S1)
(declare-fun f50 (S23 Int) S14)
(declare-fun f51 () S23)
(declare-fun f52 () S22)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 f11) f12) f12) ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f13 ?v0) f1) (and (= (f5 ?v0 (f6 f7)) f1) (= (f3 (f8 (f9 (f10 f14) f15) f15) ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (f16 f14 ?v0) (f17 f2 f18))))
(assert (forall ((?v0 Int)) (= (= (f19 f20 ?v0) f1) (exists ((?v1 S11) (?v2 Int)) (and (= ?v0 (- (f21 (f22 f23 (f24 f25 ?v1)) f26) ?v2)) (= (f5 (f27 (f28 f29 ?v2) ?v1) (f30 f13)) f1))))))
(assert (forall ((?v0 Int) (?v1 S11)) (= (= (f31 (f16 f18 ?v0) ?v1) f1) (< ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11)) (= (= (f31 (f16 (f32 f15 ?v0) ?v1) ?v2) f1) false)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S11)) (= (= (f31 (f16 (f32 f12 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S11)) (= (= (f31 (f16 f11 ?v0) ?v1) f1) false)))
(assert (forall ((?v0 S3)) (= (f30 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f33 ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S3)) (= (= (f5 ?v0 ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (let ((?v_0 (f21 f41 (f42 (f43 f44 f45) (f46 (f8 (f9 (f10 f11) f12) f12) f7))))) (let ((?v_2 (- f37 (* (+ (f34 (f35 f38 (- f37 (f39 f40 (f33 f20)))) ?v_0) 1) ?v_0))) (?v_1 (f47 f45 f48))) (not (=> (= (f34 (f35 f36 ?v_2) ?v_1) (f34 (f35 f36 f37) ?v_1)) (=> (forall ((?v0 S2)) (=> (= (f5 ?v0 (f30 f4)) f1) (= (f49 ?v0 (f24 (f50 f51 f37) f26)) f1))) (=> (forall ((?v0 S11)) (let ((?v_3 (f8 (f9 (f10 f11) f12) f12))) (=> (= (f3 ?v_3 f48) f1) (=> (= (f47 f52 f48) 1) (=> (= (f34 (f35 f36 f37) ?v_1) (f34 (f35 f36 ?v_2) ?v_1)) (= (= (f49 f48 (f24 (f50 f51 f37) ?v0)) f1) (= (f49 f48 (f24 (f50 f51 ?v_2) ?v0)) f1))))))) (=> (= (f5 f48 (f30 f4)) f1) (=> (forall ((?v0 S2)) (=> (= (f5 ?v0 (f30 f4)) f1) (= (f47 f52 ?v0) 1))) (= (f49 f48 (f24 (f50 f51 ?v_2) f26)) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f34 (f35 f38 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f34 (f35 f36 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
