(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S3 S2) S1)
(declare-fun f6 () S3)
(declare-fun f7 (S4 Int) Int)
(declare-fun f8 (S5 Int) S4)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 (Int) S1)
(declare-fun f12 (S6 Int) S7)
(declare-fun f13 () S6)
(declare-fun f14 () S6)
(declare-fun f15 () S5)
(declare-fun f16 (Int) S3)
(declare-fun f17 (S8 Int) S2)
(declare-fun f18 (Int) S8)
(declare-fun f19 (Int) S2)
(declare-fun f20 (Int) S8)
(declare-fun f21 (S2) S1)
(declare-fun f22 (S7) S1)
(declare-fun f23 (S9 S7) Int)
(declare-fun f24 () S9)
(declare-fun f25 (S10 S2) S7)
(declare-fun f26 () S10)
(declare-fun f27 (Int) S2)
(declare-fun f28 (Int) S2)
(declare-fun f29 (Int) S2)
(declare-fun f30 (S11 S2) S8)
(declare-fun f31 () S2)
(declare-fun f32 (Int) S1)
(declare-fun f33 () S2)
(declare-fun f34 () S4)
(declare-fun f35 (S3) S1)
(declare-fun f36 () S3)
(declare-fun f37 (S12 S3) S7)
(declare-fun f38 () S12)
(declare-fun f39 (S2 S3) S1)
(declare-fun f40 (S2) S2)
(declare-fun f41 (S3) S3)
(declare-fun f42 (S13 Int) S8)
(declare-fun f43 (Int) S13)
(declare-fun f44 () S1)
(declare-fun f45 (S14 S2) S2)
(declare-fun f46 (S15 Int) S3)
(declare-fun f47 (Int) S15)
(declare-fun f48 () S5)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int)) (= (= (f3 f4 ?v0) f1) false)))
(assert (forall ((?v0 S2)) (= (= (f5 f6 ?v0) f1) false)))
(assert (not (= (f7 (f8 f9 (- 1)) (+ (* 4 f10) 1)) 1)))
(assert (= (f11 (+ (* 4 f10) 1)) f1))
(assert (= (f11 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f11 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int)) (=> (= (f11 ?v0) f1) (= (f12 f13 ?v0) (f12 f14 (- ?v0 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f7 (f8 f15 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f7 (f8 f15 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f7 (f8 f15 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f11 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f7 (f8 f15 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f7 (f8 f15 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f11 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f7 (f8 f15 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f15 ?v0))) (=> (= (f11 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f7 ?v_0 (f7 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f5 (f16 ?v2) (f17 (f18 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f5 (f16 ?v2) (f17 (f18 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f5 (f16 ?v0) (f17 (f18 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 ?v1))) (=> (< 1 ?v0) (=> (not (= (f5 ?v_0 (f17 (f18 (- ?v0 1)) ?v2)) f1)) (=> (= (f5 ?v_0 (f17 (f18 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f7 (f8 f15 ?v2) ?v0)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f16 ?v1))) (=> (< 1 ?v0) (=> (= (f5 ?v_0 (f17 (f18 (- ?v0 1)) ?v2)) f1) (= (f5 ?v_0 (f17 (f18 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 (f18 ?v1) ?v0))) (=> (= (f11 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f5 (f16 ?v2) ?v_0) f1) (= (f5 (f16 (f7 (f8 f15 ?v0) ?v2)) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f17 (f18 ?v1) ?v0))) (=> (= (f11 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f5 (f16 (f7 (f8 f15 ?v0) ?v2)) ?v_1) f1) (= (f5 (f16 ?v2) ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f11 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f5 (f16 ?v2) (f17 (f18 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f11 ?v0) f1) (= (f19 ?v_0) (f17 (f18 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f3 (f17 (f20 (* ?v1 (f7 (f8 f15 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 (f17 (f18 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S7)) (=> (= (f22 ?v0) f1) (= (f11 (f23 f24 ?v0)) f1))))
(assert (forall ((?v0 Int)) (= (f12 f13 ?v0) (f25 f26 (f27 ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f11 ?v1) f1) (= (f3 (f28 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f9 ?v0) ?v1) (ite (= (f3 (f17 (f20 ?v0) 0) ?v1) f1) 0 (ite (= (f3 (f29 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 S11) (?v1 Int) (?v2 Int)) (=> (forall ((?v3 Int) (?v4 Int)) (= (f3 (f17 (f30 ?v0 f31) ?v3) ?v4) f1)) (=> (forall ((?v3 Int) (?v4 Int)) (let ((?v_0 (- ?v3 1))) (=> (< 1 ?v3) (=> (= (f3 (f17 (f30 ?v0 (f17 (f18 ?v_0) ?v4)) ?v_0) ?v4) f1) (= (f3 (f17 (f30 ?v0 (f17 (f18 ?v3) ?v4)) ?v3) ?v4) f1))))) (= (f3 (f17 (f30 ?v0 (f17 (f18 ?v1) ?v2)) ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f32 ?v0) f1) (=> (= (f32 ?v1) f1) (= (f32 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f11 ?v0) f1) (= (= (f5 (f16 ?v0) f33) f1) (< 2 ?v0)))))
(assert (forall ((?v0 Int)) (=> (= (f11 ?v0) f1) (= (f3 (f17 (f20 (f7 f34 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (f17 (f20 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f3 (f17 (f20 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 (f16 (* ?v0 ?v1)) f33) f1) (= (f5 (f16 ?v0) f33) f1))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f3 (f17 (f20 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 (+ (* 2 ?v1) 1)) (= (f5 (f16 ?v0) f33) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 (f16 ?v0) f33) f1) (=> (= (f5 (f16 ?v1) f33) f1) (= (f5 (f16 (* ?v0 ?v1)) f33) f1)))))
(assert (= (f35 f36) f1))
(assert (= (f21 f31) f1))
(assert (forall ((?v0 S2)) (= (= (f25 f26 ?v0) (f12 f14 0)) (or (= ?v0 f31) (not (= (f21 ?v0) f1))))))
(assert (forall ((?v0 S3)) (= (= (f37 f38 ?v0) (f12 f14 0)) (or (= ?v0 f36) (not (= (f35 ?v0) f1))))))
(assert (forall ((?v0 S2)) (= (< 0 (f23 f24 (f25 f26 ?v0))) (and (not (= ?v0 f31)) (= (f21 ?v0) f1)))))
(assert (forall ((?v0 S3)) (= (< 0 (f23 f24 (f37 f38 ?v0))) (and (not (= ?v0 f36)) (= (f35 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (f21 (f19 ?v0)) f1)))
(assert (forall ((?v0 S2)) (=> (= (f39 ?v0 f36) f1) false)))
(assert (forall ((?v0 Int)) (=> (= (f5 (f16 ?v0) f31) f1) false)))
(assert (forall ((?v0 Int)) (= (= (f11 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f3 (f28 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 ?v0))) (=> (= (f11 ?v0) f1) (=> (= (f3 ?v_0 (* ?v1 ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 ?v1))) (=> (<= 0 ?v0) (=> (= (f11 ?v1) f1) (=> (= (f3 ?v_0 (* ?v0 ?v2)) f1) (or (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f17 (f20 ?v2) 0) ?v0) f1)) (not (= (f3 (f17 (f20 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (= f31 (f40 f4)))
(assert (= f36 (f41 f6)))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f39 ?v1 ?v0) f1))) (= ?v0 f36))))
(assert (forall ((?v0 S2)) (= (forall ((?v1 Int)) (not (= (f5 (f16 ?v1) ?v0) f1))) (= ?v0 f31))))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (= (f39 ?v1 ?v0) f1)) (not (= ?v0 f36)))))
(assert (forall ((?v0 S2)) (= (exists ((?v1 Int)) (= (f5 (f16 ?v1) ?v0) f1)) (not (= ?v0 f31)))))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (and (= (f39 ?v1 f36) f1) (= (f5 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S2)) (= (exists ((?v1 Int)) (and (= (f5 (f16 ?v1) f31) f1) (= (f3 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (=> (= (f39 ?v1 f36) f1) (= (f5 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S2)) (= (forall ((?v1 Int)) (=> (= (f5 (f16 ?v1) f31) f1) (= (f3 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S2)) (= (= f31 (f40 ?v0)) (forall ((?v1 Int)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (= f36 (f41 ?v0)) (forall ((?v1 S2)) (not (= (f5 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f39 ?v0 f36) f1) false)))
(assert (forall ((?v0 Int)) (= (= (f5 (f16 ?v0) f31) f1) false)))
(assert (forall ((?v0 S2)) (= (= (f40 ?v0) f31) (forall ((?v1 Int)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (= (f41 ?v0) f36) (forall ((?v1 S2)) (not (= (f5 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= ?v0 f36) (not (= (f39 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 Int)) (=> (= ?v0 f31) (not (= (f5 (f16 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f17 (f20 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (= (f3 (f17 (f20 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 (f20 ?v0) ?v1))) (= (= (f3 ?v_0 (- ?v2)) f1) (= (f3 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f3 (f17 (f20 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f17 (f20 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f17 (f20 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f17 (f20 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f17 (f20 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 (f17 (f20 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 (f17 (f20 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f17 (f20 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f17 (f20 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 ?v1))) (=> (< 2 ?v0) (=> (= (f3 (f17 ?v_0 (- 1)) ?v0) f1) (not (= (f3 (f17 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f20 ?v3))) (=> (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (= (= (f3 (f17 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f3 (f17 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f20 ?v3))) (=> (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (= (= (f3 (f17 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f3 (f17 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (= (f3 (f17 (f20 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (= (f3 (f17 (f20 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (= (f3 (f17 (f20 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f20 ?v0))) (=> (= (f3 (f17 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 (f17 (f20 ?v3) ?v4) ?v2) f1) (= (f3 (f17 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (= (f39 ?v0 ?v1) f1) (= (f5 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f5 (f16 ?v0) ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f41 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f40 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f20 ?v0))) (=> (= (f3 (f17 ?v_0 ?v1) ?v2) f1) (=> (= (f3 (f17 (f20 ?v1) ?v3) ?v2) f1) (= (f3 (f17 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f17 (f20 ?v3) ?v4) ?v2) f1) (= (f3 (f17 (f20 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f17 (f20 ?v3) ?v4) ?v2) f1) (= (f3 (f17 (f20 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f17 (f20 ?v3) ?v4) ?v2) f1) (= (f3 (f17 (f20 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f28 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f5 (f16 ?v0) (f19 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f5 (f16 ?v1) (f19 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 (f16 ?v0) (f19 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 (f16 ?v0) (f19 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (f7 f34 ?v0) (ite (<= ?v0 0) 1 (* ?v0 (f7 f34 (- ?v0 1)))))))
(assert (= (f25 f26 f31) (f12 f14 0)))
(assert (= (f37 f38 f36) (f12 f14 0)))
(assert (forall ((?v0 S2)) (=> (not (= (f21 ?v0) f1)) (= (f25 f26 ?v0) (f12 f14 0)))))
(assert (forall ((?v0 S3)) (=> (not (= (f35 ?v0) f1)) (= (f37 f38 ?v0) (f12 f14 0)))))
(assert (forall ((?v0 S2)) (=> (< 0 (f23 f24 (f25 f26 ?v0))) (= (f21 ?v0) f1))))
(assert (forall ((?v0 S3)) (=> (< 0 (f23 f24 (f37 f38 ?v0))) (= (f35 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f17 (f20 ?v0) 0) ?v1) f1) (= (f3 (f28 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f17 (f20 ?v0) 0) ?v1) f1) (= (f3 (f28 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f17 (f20 ?v0) ?v1) ?v2) f1) (= (f3 (f28 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 ?v1))) (=> (= (f11 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f17 (f20 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f3 (f17 ?v_0 1) ?v0) f1) (= (f3 (f17 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f17 (f20 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f3 (f17 (f20 ?v1) 0) ?v0) f1) (= (f3 (f17 (f20 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (not (= (f3 (f17 (f20 ?v2) 0) ?v0) f1))) (not (= (f3 (f17 (f20 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (f17 (f20 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 S3)) (=> (= (f35 ?v0) f1) (=> (forall ((?v1 S2)) (=> (= (f39 ?v1 ?v0) f1) (= (f12 f14 1) (f12 f14 0)))) (= (f37 f38 ?v0) (f12 f14 0))))))
(assert (forall ((?v0 S2)) (=> (= (f21 ?v0) f1) (=> (forall ((?v1 Int)) (=> (= (f5 (f16 ?v1) ?v0) f1) (= (f12 f14 1) (f12 f14 0)))) (= (f25 f26 ?v0) (f12 f14 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f11 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f29 ?v0) ?v1) f1)) (=> (not (= (f3 (f17 (f20 ?v2) 0) ?v0) f1)) (= (f25 f26 (f17 (f42 (f43 ?v1) ?v0) ?v2)) (f12 f14 2)))))))))
(assert (forall ((?v0 S3)) (=> (not (= (f35 ?v0) f1)) (not (= ?v0 f36)))))
(assert (forall ((?v0 S2)) (=> (not (= (f21 ?v0) f1)) (not (= ?v0 f31)))))
(assert (forall ((?v0 Int)) (= (= (f3 f31 ?v0) f1) (= f44 f1))))
(assert (forall ((?v0 S2)) (= (= (f5 f36 ?v0) f1) (= f44 f1))))
(assert (forall ((?v0 Int)) (= (= (f3 f31 ?v0) f1) (= f44 f1))))
(assert (forall ((?v0 S2)) (= (= (f5 f36 ?v0) f1) (= f44 f1))))
(assert (forall ((?v0 Int)) (=> (= (f5 (f16 ?v0) f33) f1) (=> (forall ((?v1 Int)) (=> (= ?v0 (+ (* 2 ?v1) 1)) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (= (f5 (f16 ?v0) f33) f1) (exists ((?v2 Int)) (let ((?v_0 (- ?v1 (* ?v2 ?v0)))) (< (* 2 (ite (< ?v_0 0) (- ?v_0) ?v_0)) ?v0)))))))
(assert (forall ((?v0 S14) (?v1 Int)) (=> (forall ((?v2 Int)) (= (f3 (f45 ?v0 f31) ?v2) f1)) (=> (forall ((?v2 Int)) (let ((?v_0 (- ?v2 1))) (=> (< 1 ?v2) (=> (= (f3 (f45 ?v0 (f19 ?v_0)) ?v_0) f1) (= (f3 (f45 ?v0 (f19 ?v2)) ?v2) f1))))) (= (f3 (f45 ?v0 (f19 ?v1)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f29 ?v0) ?v1) f1)) (forall ((?v2 S2)) (=> (= (f39 ?v2 (f46 (f47 ?v1) ?v0)) f1) (= (f25 f26 ?v2) (f12 f14 2))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f3 (f17 (f20 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f3 (f17 (f20 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 S2)) (=> (= (f39 ?v1 ?v0) f1) false)) (= ?v0 f36))))
(assert (forall ((?v0 S2)) (=> (forall ((?v1 Int)) (=> (= (f5 (f16 ?v1) ?v0) f1) false)) (= ?v0 f31))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 ?v2))) (=> (= (f11 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f17 ?v_0 0) ?v0) f1)) (=> (not (= (f3 (f29 ?v0) ?v1) f1)) (not (= (f3 (f17 ?v_0 (* ?v1 (f7 (f8 f48 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 S7)) (=> (= (f22 ?v0) f1) (<= 2 (f23 f24 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (= (f35 (f46 (f47 ?v1) ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f48 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f17 (f20 ?v1) ?v2) ?v0) f1) (= (f3 (f17 (f20 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 f48 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f17 (f20 ?v1) ?v2) ?v0) f1) (= (f3 (f17 (f20 (* ?v3 (f7 ?v_0 ?v1))) (* ?v3 (f7 ?v_0 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f7 (f8 f48 ?v2) ?v3)))) (=> (= (f3 (f17 (f20 ?v0) ?v_0) ?v2) f1) (= (f3 (f17 (f20 (* ?v0 ?v3)) (* ?v_0 ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 (f8 f48 ?v3) ?v0))) (=> (= (f3 (f17 (f20 (* ?v0 ?v1)) ?v2) ?v3) f1) (= (f3 (f17 (f20 (* (* ?v_0 ?v0) ?v1)) (* ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f39 ?v2 (f46 (f47 ?v0) ?v1)) f1) (= (f21 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (not (= (f3 (f17 (f20 (f7 (f8 f48 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (= (f3 (f17 (f20 (* ?v1 (f7 (f8 f48 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f48 ?v0))) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (= (f3 (f17 (f20 (f7 ?v_0 (f7 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f48 ?v0))) (let ((?v_1 (f7 ?v_0 ?v1))) (let ((?v_2 (f7 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (= (f3 (f17 (f20 ?v_2) (* (* ?v1 ?v_1) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (= (f3 (f17 (f20 (* (f7 (f8 f48 ?v0) ?v1) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f48 ?v0))) (let ((?v_1 (f7 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (= (f3 (f17 (f20 (* (* ?v1 ?v_1) (f7 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f20 ?v3)) (?v_0 (f8 f48 ?v0))) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f3 (f17 (f20 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f17 (f20 ?v2) 0) ?v0) f1)) (=> (not (= (f3 (f17 ?v_1 0) ?v0) f1)) (=> (= (f3 (f17 (f20 (* ?v1 (f7 ?v_0 ?v3))) (* ?v1 (f7 ?v_0 ?v2))) ?v0) f1) (= (f3 (f17 ?v_1 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f20 ?v1)) (?v_0 (f20 ?v2)) (?v_2 (f8 f48 ?v0))) (=> (< 2 ?v0) (=> (= (f11 ?v0) f1) (=> (not (= (f3 (f17 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f17 ?v_0 0) ?v0) f1)) (=> (= (f3 (f17 ?v_0 (* ?v3 (f7 ?v_2 ?v1))) ?v0) f1) (= (f3 (f17 ?v_1 (* ?v3 (f7 ?v_2 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 S7)) (= (f12 f14 (f23 f24 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f23 f24 (f12 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f23 f24 (f12 f14 ?v0)) 0))))
(check-sat)
(exit)
