(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 (Int) S2)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 (Int) S3)
(declare-fun f7 (S4 Int) Int)
(declare-fun f8 (S5 Int) S4)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 (S6 S7) Int)
(declare-fun f12 (S8 Int) S6)
(declare-fun f13 () S8)
(declare-fun f14 (S9 Int) S7)
(declare-fun f15 () S9)
(declare-fun f16 () S5)
(declare-fun f17 (Int) S1)
(declare-fun f18 () S6)
(declare-fun f19 (S10 S2) S1)
(declare-fun f20 (Int) S10)
(declare-fun f21 (S2 S10) S1)
(declare-fun f22 (S2) S2)
(declare-fun f23 (Int) S2)
(declare-fun f24 () S4)
(declare-fun f25 () S5)
(declare-fun f26 () S5)
(declare-fun f27 (Int) S3)
(declare-fun f28 () S4)
(declare-fun f29 (S11 S7) S7)
(declare-fun f30 (S12 S7) S11)
(declare-fun f31 () S12)
(declare-fun f32 (Int) S2)
(declare-fun f33 (Int) S10)
(declare-fun f34 (S13 S10) S7)
(declare-fun f35 () S13)
(declare-fun f36 (S14 Int) S10)
(declare-fun f37 (Int) S14)
(declare-fun f38 (S15 S2) S7)
(declare-fun f39 () S15)
(declare-fun f40 (S16 Int) S3)
(declare-fun f41 (Int) S16)
(declare-fun f42 () S5)
(declare-fun f43 (Int) S2)
(declare-fun f44 (S10) S1)
(declare-fun f45 (S2) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 ?v0) ?v1) f1) (and (< 0 ?v1) (< ?v1 ?v0)))))
(assert (let ((?v_0 (+ (* 4 f10) 1))) (not (= (f3 (f5 (f6 (f7 (f8 f9 (- 1)) ?v_0)) (f11 (f12 f13 (- 1)) (f14 f15 (f7 (f8 f16 (- ?v_0 1)) 2)))) ?v_0) f1))))
(assert (= (f17 (+ (* 4 f10) 1)) f1))
(assert (< 2 (+ (* 4 f10) 1)))
(assert (< 2 (+ (* 4 f10) 1)))
(assert (= (f17 (+ (* 4 f10) 1)) f1))
(assert (<= 1 f10))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (= (f3 (f5 (f6 (f7 (f8 f9 ?v1) ?v0)) (f11 (f12 f13 ?v1) (f14 f15 (f7 (f8 f16 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_1 (f11 f18 ?v0)) (?v_0 (f12 f13 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f7 (f8 f16 (f11 ?v_0 ?v0)) ?v1) (f11 ?v_0 (f14 f15 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f12 f13 (- 1)))) (let ((?v_1 (f11 ?v_0 ?v1)) (?v_2 (f11 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f3 (f5 (f6 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f3 (f5 (f6 (f11 (f12 f13 ?v0) ?v3)) (f11 (f12 f13 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (= (f3 (f5 (f6 ?v1) 0) ?v0) f1) (= (f3 (f5 (f6 0) (f11 (f12 f13 ?v1) (f14 f15 (f7 (f8 f16 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (<= 0 (f11 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f12 f13 ?v0) (f14 f15 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f14 f15 2))) (let ((?v_0 (f11 (f12 f13 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f14 f15 3))) (let ((?v_0 (f11 (f12 f13 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (< 0 (f11 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f14 f15 0))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (f14 f15 (+ (f11 f18 ?v1) (f11 f18 ?v2)))) (* (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (* ?v0 (f11 ?v_0 (f14 f15 2))) (f11 ?v_0 (f14 f15 3))))))
(assert (= (f17 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f5 (f6 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f3 (f5 (f6 ?v1) 0) ?v0) f1) (= (f3 (f5 (f6 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (not (= (f3 (f5 (f6 ?v2) 0) ?v0) f1))) (not (= (f3 (f5 (f6 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f5 (f6 ?v2) 0) ?v0) f1)) (not (= (f3 (f5 (f6 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f6 ?v0))) (=> (= (f3 (f5 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 (f5 (f6 ?v3) ?v4) ?v2) f1) (= (f3 (f5 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f3 (f5 (f6 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f6 ?v3))) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (= (f3 (f5 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f3 (f5 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f6 ?v3))) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (= (f3 (f5 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f3 (f5 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 ?v1))) (=> (< 2 ?v0) (=> (= (f3 (f5 ?v_0 (- 1)) ?v0) f1) (not (= (f3 (f5 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f3 (f5 (f6 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f5 (f6 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 (f5 (f6 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f3 (f5 (f6 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f7 (f8 f16 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f7 (f8 f16 ?v1) ?v2) (f7 (f8 f16 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f7 (f8 f16 ?v0) ?v2) (f7 (f8 f16 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f7 (f8 f16 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f16 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f7 (f8 f16 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f7 (f8 f16 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f7 (f8 f16 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f7 (f8 f16 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f7 (f8 f16 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f7 (f8 f16 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f7 (f8 f16 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f7 (f8 f16 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f7 (f8 f16 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f7 (f8 f16 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f7 (f8 f16 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f16 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f7 ?v_0 ?v2) (f7 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f7 (f8 f16 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f7 (f8 f16 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f7 (f8 f16 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f7 (f8 f16 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f7 (f8 f16 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f7 (f8 f16 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f16 ?v1))) (=> (< 0 ?v0) (= (f7 ?v_0 (* ?v2 ?v0)) (f7 (f8 f16 (f7 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f7 (f8 f16 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f7 (f8 f16 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f7 (f8 f16 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f7 (f8 f16 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f7 (f8 f16 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 (f8 f16 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f16 (- ?v0)) (- ?v1)) (f7 (f8 f16 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f16 ?v0) (- ?v1)) (f7 (f8 f16 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f7 (f8 f16 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int)) (= (f7 (f8 f16 0) ?v0) 0)))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (f7 (f8 f16 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f3 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int)) (=> (= (f11 (f12 f13 ?v0) (f14 f15 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 ?v1)) (?v_1 (f14 f15 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (* ?v1 (f11 ?v_0 (f14 f15 (- (f11 f18 ?v_1) 1)))))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f11 (f12 f13 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (= (f11 (f12 f13 ?v0) ?v_0) (f11 (f12 f13 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 2)) (?v_1 (f12 f13 ?v0))) (= (f11 (f12 f13 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f14 f15 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f11 (f12 f13 ?v0) ?v_0) (f11 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f14 f15 2)) (?v_0 (f14 f15 3)) (?v_3 (f12 f13 ?v1)) (?v_1 (f12 f13 ?v0))) (= (f11 (f12 f13 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f14 f15 2)) (?v_0 (f14 f15 3)) (?v_1 (f12 f13 ?v0)) (?v_3 (f12 f13 ?v1))) (= (f11 (f12 f13 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f11 (f12 f13 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f12 f13 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f11 (f12 f13 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f12 f13 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 3))) (= (f11 (f12 f13 (- ?v0)) ?v_0) (- (f11 (f12 f13 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 ?v1))) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (f5 (f6 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f3 (f5 ?v_0 1) ?v0) f1) (= (f3 (f5 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (f5 (f6 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f19 (f20 ?v0) ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S10)) (= (= (f21 ?v0 ?v1) f1) (= (f19 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (f22 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (= (f3 (f23 ?v0) ?v1) f1) (= (f3 (f5 (f6 (f11 (f12 f13 ?v1) (f14 f15 (f7 (f8 f16 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f23 ?v0) ?v1) f1)) (= (f3 (f5 (f6 (f11 (f12 f13 ?v1) (f14 f15 (f7 (f8 f16 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f17 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f23 ?v0) ?v1) f1)) (= (f3 (f5 (f6 (f7 f24 ?v_0)) (f11 (f12 f13 ?v1) (f14 f15 (f7 (f8 f16 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int)) (=> (= (f17 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (<= 0 (f11 (f12 f13 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f16 ?v0))) (= (div ?v0 ?v1) (ite (<= 0 ?v1) (f7 ?v_0 ?v1) (- (f7 ?v_0 (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f5 (f6 ?v3) ?v4) ?v2) f1) (= (f3 (f5 (f6 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f5 (f6 ?v3) ?v4) ?v2) f1) (= (f3 (f5 (f6 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f17 ?v0) f1) (= (f3 (f5 (f6 (f7 f24 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f5 (f6 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f3 (f5 (f6 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 (f6 ?v0) ?v1))) (= (= (f3 ?v_0 (- ?v2)) f1) (= (f3 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (f5 (f6 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f3 (f5 (f6 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f5 (f6 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f5 (f6 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f5 (f6 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 (f5 (f6 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 (f5 (f6 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 (f5 (f6 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f3 (f5 (f6 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f3 (f5 (f6 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 ?v0))) (=> (= (f3 (f5 ?v_0 ?v1) ?v2) f1) (=> (= (f3 (f5 (f6 ?v1) ?v3) ?v2) f1) (= (f3 (f5 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f5 (f6 ?v3) ?v4) ?v2) f1) (= (f3 (f5 (f6 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f9 ?v0) ?v1) (ite (= (f3 (f5 (f6 ?v0) 0) ?v1) f1) 0 (ite (= (f3 (f23 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f23 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f3 (f5 (f6 (f11 (f12 f13 ?v2) (f14 f15 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (f7 f24 ?v0) (ite (<= ?v0 0) 1 (* ?v0 (f7 f24 (- ?v0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f3 (f5 (f6 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f3 (f5 (f6 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 ?v2))) (=> (= (f17 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f5 ?v_0 0) ?v0) f1)) (=> (not (= (f3 (f23 ?v0) ?v1) f1)) (not (= (f3 (f5 ?v_0 (* ?v1 (f7 (f8 f25 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f3 (f5 (f6 (* ?v1 (f7 (f8 f26 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 (f8 f25 ?v3) ?v0))) (=> (= (f3 (f5 (f6 (* ?v0 ?v1)) ?v2) ?v3) f1) (= (f3 (f5 (f6 (* (* ?v_0 ?v0) ?v1)) (* ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f7 (f8 f25 ?v2) ?v3)))) (=> (= (f3 (f5 (f6 ?v0) ?v_0) ?v2) f1) (= (f3 (f5 (f6 (* ?v0 ?v3)) (* ?v_0 ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 f25 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f5 (f6 ?v1) ?v2) ?v0) f1) (= (f3 (f5 (f6 (* ?v3 (f7 ?v_0 ?v1))) (* ?v3 (f7 ?v_0 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f25 ?v0))) (=> (< 2 ?v0) (=> (= (f3 (f5 (f6 ?v1) ?v2) ?v0) f1) (= (f3 (f5 (f6 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f25 ?v0) ?v1) (f11 (f12 f13 ?v1) (f14 f15 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f7 (f8 f26 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f7 (f8 f26 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f7 (f8 f26 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f7 (f8 f26 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f7 (f8 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f17 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f7 (f8 f26 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f26 ?v0))) (=> (= (f17 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f7 ?v_0 (f7 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 (f8 f25 ?v0) ?v1))) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (= (f3 (f5 (f6 (* (* ?v_0 ?v1) ?v2)) (* ?v_0 ?v3)) ?v0) f1) (= (f3 (f5 (f6 ?v2) (* ?v3 ?v_0)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 (* ?v2 ?v1)))) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (= (f3 (f5 ?v_0 (* (* ?v3 (f7 (f8 f25 ?v0) ?v1)) ?v1)) ?v0) f1) (= (f3 (f5 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f6 ?v1)) (?v_0 (f8 f25 ?v0))) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f5 (f6 ?v2) 0) ?v0) f1)) (=> (= (f3 (f5 (f6 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) ?v0) f1) (= (f3 (f5 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f6 ?v1)) (?v_0 (f6 ?v2)) (?v_2 (f8 f25 ?v0))) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 ?v_1 0) ?v0) f1)) (=> (not (= (f3 (f5 ?v_0 0) ?v0) f1)) (=> (= (f3 (f5 ?v_0 (* ?v3 (f7 ?v_2 ?v1))) ?v0) f1) (= (f3 (f5 ?v_1 (* ?v3 (f7 ?v_2 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f6 ?v3)) (?v_0 (f8 f25 ?v0))) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f5 (f6 ?v2) 0) ?v0) f1)) (=> (not (= (f3 (f5 ?v_1 0) ?v0) f1)) (=> (= (f3 (f5 (f6 (* ?v1 (f7 ?v_0 ?v3))) (* ?v1 (f7 ?v_0 ?v2))) ?v0) f1) (= (f3 (f5 ?v_1 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f25 ?v0))) (let ((?v_1 (f7 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f3 (f5 (f6 (* (* ?v1 ?v_1) (f7 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f3 (f5 (f6 (* (f7 (f8 f25 ?v0) ?v1) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f25 ?v0))) (let ((?v_1 (f7 ?v_0 ?v1))) (let ((?v_2 (f7 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f3 (f5 (f6 ?v_2) (* (* ?v1 ?v_1) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f25 ?v0))) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f3 (f5 (f6 (f7 ?v_0 (f7 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f3 (f5 (f6 (* ?v1 (f7 (f8 f25 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f17 ?v0) f1) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (not (= (f3 (f5 (f6 (f7 (f8 f25 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 (f27 ?v1) ?v0))) (=> (= (f17 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f19 (f20 ?v2) ?v_0) f1) (= (f19 (f20 (f7 (f8 f26 ?v0) ?v2)) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f5 (f27 ?v1) ?v0))) (=> (= (f17 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f19 (f20 (f7 (f8 f26 ?v0) ?v2)) ?v_1) f1) (= (f19 (f20 ?v2) ?v_1) f1))))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 2))) (= (f11 (f12 f13 (f7 f28 ?v0)) ?v_0) (f11 (f12 f13 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f29 (f30 f31 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f29 (f30 f31 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f14 f15 (f11 (f12 f13 ?v0) ?v1)) (f29 (f30 f31 (f14 f15 ?v0)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f11 (f12 f13 (f11 f18 ?v0)) ?v1) (f11 f18 (f29 (f30 f31 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f11 f18 (f29 (f30 f31 ?v0) ?v1)) (f11 (f12 f13 (f11 f18 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f29 (f30 f31 (f14 f15 ?v0)) ?v1) (f14 f15 (f11 (f12 f13 ?v0) ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f11 (f12 f13 (f11 f18 ?v0)) ?v1) (f11 f18 (f29 (f30 f31 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f19 (f20 ?v0) (f5 (f27 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 ?v1))) (=> (< 1 ?v0) (=> (= (f19 ?v_0 (f5 (f27 (- ?v0 1)) ?v2)) f1) (= (f19 ?v_0 (f5 (f27 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f17 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f19 (f20 ?v2) (f5 (f27 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f19 (f20 ?v2) (f5 (f27 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f19 (f20 ?v2) (f5 (f27 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f20 ?v1))) (=> (< 1 ?v0) (=> (not (= (f19 ?v_0 (f5 (f27 (- ?v0 1)) ?v2)) f1)) (=> (= (f19 ?v_0 (f5 (f27 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f7 (f8 f26 ?v2) ?v0)))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f7 f28 (f11 (f12 f13 ?v0) ?v1)) (f11 (f12 f13 (f7 f28 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) (f14 f15 2)))) (= (f7 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f17 ?v0) f1) (= (f32 ?v_0) (f5 (f27 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f19 (f33 ?v0) ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f19 (f20 ?v2) ?v1) f1) (and (= (f19 (f20 ?v3) ?v1) f1) (= (f3 (f5 (f6 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f23 ?v0) ?v1) f1)) (= (f11 f18 (f34 f35 (f36 (f37 ?v1) ?v0))) (f7 (f8 f16 (- ?v0 1)) 2))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f18 ?v0)) (<= ?v_0 (f11 f18 (f29 (f30 f31 ?v0) ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f30 f31 ?v0))) (=> (< 0 (f11 f18 ?v0)) (=> (< (f11 f18 (f29 ?v_0 ?v1)) (f11 f18 (f29 ?v_0 ?v2))) (< (f11 f18 ?v1) (f11 f18 ?v2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f14 f15 (+ 0 1)))) (= (= (f29 (f30 f31 ?v0) ?v1) ?v_0) (or (= ?v1 (f14 f15 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f14 f15 (+ 0 1)))) (= (f29 (f30 f31 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f11 f18 (f29 (f30 f31 ?v0) ?v1))) (or (< 0 (f11 f18 ?v0)) (= ?v1 (f14 f15 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 (f20 ?v0) (f32 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 (f20 ?v0) (f32 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f19 (f20 ?v1) (f32 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f19 (f20 ?v0) (f32 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f23 ?v0) ?v1) f1)) (forall ((?v2 S2)) (=> (= (f21 ?v2 (f36 (f37 ?v1) ?v0)) f1) (= (f38 f39 ?v2) (f14 f15 2))))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 (+ (f11 f18 ?v1) 1)))) (= (<= (f11 f18 (f29 (f30 f31 ?v0) ?v_0)) (f11 f18 (f29 (f30 f31 ?v2) ?v_0))) (<= (f11 f18 ?v0) (f11 f18 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 (+ (f11 f18 ?v1) 1)))) (= (< (f11 f18 (f29 (f30 f31 ?v0) ?v_0)) (f11 f18 (f29 (f30 f31 ?v2) ?v_0))) (< (f11 f18 ?v0) (f11 f18 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f14 f15 0))) (= (= (f29 (f30 f31 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f14 f15 1))) (= (= (f29 (f30 f31 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 (+ (f11 f18 ?v1) 1)))) (= (= (f29 (f30 f31 ?v0) ?v_0) (f29 (f30 f31 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f3 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f3 (f23 ?v0) ?v1) f1)) (=> (not (= (f3 (f5 (f6 ?v2) 0) ?v0) f1)) (= (f38 f39 (f5 (f40 (f41 ?v1) ?v0) ?v2)) (f14 f15 2)))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f11 f18 (f29 (f30 f31 ?v0) ?v1))) (or (= ?v1 (f14 f15 0)) (< 0 (f11 f18 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f26 ?v0) ?v1) (f7 (f8 f42 (f11 (f12 f13 ?v1) (f14 f15 (- ?v0 2)))) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f42 ?v0))) (= (mod ?v0 ?v1) (ite (<= 0 ?v1) (f7 ?v_0 ?v1) (f7 ?v_0 (- ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 (f8 f42 ?v0) 2))) (= (not (= ?v_0 0)) (= ?v_0 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f7 (f8 f42 ?v0) ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f7 (f8 f42 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 (f8 f42 ?v1) ?v0))) (=> (< ?v0 0) (and (<= ?v_0 0) (< ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f7 (f8 f42 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (- (* 2 (f7 (f8 f42 (+ ?v1 1)) ?v0)) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (<= (f7 (f8 f42 ?v1) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (< ?v0 (f7 (f8 f42 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ ?v0 ?v1))) (=> (< 0 ?v0) (=> (<= ?v_0 0) (= (f7 (f8 f42 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (<= (+ (* ?v1 (f7 (f8 f42 ?v3) ?v0)) ?v2) 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (=> (<= ?v2 0) (< (* ?v1 ?v0) (+ (* ?v1 (f7 (f8 f42 ?v3) ?v0)) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f7 (f8 f42 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (< (+ (* ?v2 (f7 (f8 f42 ?v3) ?v0)) ?v1) (* ?v2 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (=> (< ?v1 ?v2) (<= 0 (+ (* ?v2 (f7 (f8 f42 ?v3) ?v0)) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f7 (f8 f42 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f7 (f8 f42 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (+ 1 (* 2 (f7 (f8 f42 ?v1) ?v0)))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f7 (f8 f42 (- 1)) ?v0) (- ?v0 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (<= (f7 (f8 f42 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (< (f7 (f8 f42 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 (f8 f42 ?v1) ?v0))) (=> (< 0 ?v0) (and (<= 0 ?v_0) (< ?v_0 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= 0 (f7 (f8 f42 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= (f7 (f8 f42 (- ?v0)) ?v1) 0)) (not (= (f7 (f8 f42 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f42 ?v0))) (=> (not (= (f7 ?v_0 (- ?v1)) 0)) (not (= (f7 ?v_0 ?v1) 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f7 (f8 f42 (- (f7 (f8 f42 ?v0) ?v1) ?v2)) ?v1) (f7 (f8 f42 (- ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f7 (f8 f42 (* ?v0 (f7 (f8 f42 ?v1) ?v2))) ?v2) (f7 (f8 f42 (* ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f7 (f8 f42 (- ?v0 (f7 (f8 f42 ?v1) ?v2))) ?v2) (f7 (f8 f42 (- ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f7 (f8 f42 (* ?v0 ?v1)) ?v2) (f7 (f8 f42 (* ?v0 (f7 (f8 f42 ?v1) ?v2))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 (f8 f42 ?v0) ?v1))) (= (f7 (f8 f42 ?v_0) ?v1) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f7 (f8 f42 ?v0) ?v1) 0) (exists ((?v2 Int)) (= ?v0 (* ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f42 (- (f7 (f8 f42 ?v0) ?v1))) ?v1) (f7 (f8 f42 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f42 (- ?v0)) (- ?v1)) (- (f7 (f8 f42 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 (f8 f42 ?v0) ?v1))) (= (f7 (f8 f42 (- ?v0)) ?v1) (ite (= ?v_0 0) 0 (- ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f42 ?v0))) (let ((?v_1 (f7 ?v_0 ?v1))) (= (f7 ?v_0 (- ?v1)) (ite (= ?v_1 0) 0 (- ?v_1 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f42 ?v0) (- ?v1)) (- (f7 (f8 f42 (- ?v0)) ?v1)))))
(assert (forall ((?v0 Int)) (= (f7 (f8 f42 ?v0) (- 1)) 0)))
(assert (forall ((?v0 Int)) (= (f7 (f8 f42 ?v0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f7 (f8 f42 0) ?v0) 0)))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (f7 (f8 f42 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f3 ?v0 ?v1) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v4) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f3 ?v0 ?v4) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- ?v0 ?v1) (+ (* ?v2 (- (f7 (f8 f16 ?v0) ?v2) (f7 (f8 f16 ?v1) ?v2))) (- (f7 (f8 f42 ?v0) ?v2) (f7 (f8 f42 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int) (?v7 Int)) (let ((?v_0 (f7 (f8 f16 ?v0) ?v5))) (=> (= ?v0 (+ (* ?v1 ?v2) (* ?v3 ?v4))) (=> (= ?v5 (+ (* ?v6 ?v2) (* ?v7 ?v4))) (= (f7 (f8 f42 ?v0) ?v5) (+ (* (- ?v1 (* ?v_0 ?v6)) ?v2) (* (- ?v3 (* ?v_0 ?v7)) ?v4))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= ?v0 (+ (* ?v1 (f7 (f8 f16 ?v0) ?v1)) (f7 (f8 f42 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f42 ?v0) ?v1) (- ?v0 (* (f7 (f8 f16 ?v0) ?v1) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (* ?v0 (f7 (f8 f16 ?v1) ?v0)) (- ?v1 (f7 (f8 f42 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (and (= (f7 (f8 f16 ?v0) 0) 0) (= (f7 (f8 f42 ?v0) 0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f16 (f7 (f8 f42 ?v0) ?v1)) ?v1) 0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f7 (f8 f16 (* ?v0 ?v1)) ?v2) (+ (* ?v0 (f7 (f8 f16 ?v1) ?v2)) (f7 (f8 f16 (* ?v0 (f7 (f8 f42 ?v1) ?v2))) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f7 (f8 f16 (+ ?v0 ?v1)) ?v2) (+ (+ (f7 (f8 f16 ?v0) ?v2) (f7 (f8 f16 ?v1) ?v2)) (f7 (f8 f16 (+ (f7 (f8 f42 ?v0) ?v2) (f7 (f8 f42 ?v1) ?v2))) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ (* ?v0 (f7 (f8 f16 ?v1) ?v0)) (f7 (f8 f42 ?v1) ?v0)) ?v2) (+ ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ (* (f7 (f8 f16 ?v0) ?v1) ?v1) (f7 (f8 f42 ?v0) ?v1)) ?v2) (+ ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f16 ?v1))) (let ((?v_1 (- (f7 ?v_0 ?v0)))) (=> (not (= ?v0 0)) (= (f7 ?v_0 (- ?v0)) (ite (= (f7 (f8 f42 ?v1) ?v0) 0) ?v_1 (- ?v_1 1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- (f7 (f8 f16 ?v1) ?v0)))) (=> (not (= ?v0 0)) (= (f7 (f8 f16 (- ?v1)) ?v0) (ite (= (f7 (f8 f42 ?v1) ?v0) 0) ?v_0 (- ?v_0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f8 f42 ?v1))) (=> (< 0 ?v0) (= (f7 ?v_0 (* ?v2 ?v0)) (+ (* ?v2 (f7 (f8 f42 (f7 (f8 f16 ?v1) ?v2)) ?v0)) (f7 ?v_0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (< 0 ?v0) (= (= (f3 (f5 ?v1 (f7 (f8 f16 ?v2) ?v0)) (f7 (f8 f42 ?v2) ?v0)) f1) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v0) (= ?v2 (+ (* ?v0 ?v3) ?v4)))) (= (f3 (f5 ?v1 ?v3) ?v4) f1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (< ?v0 0) (= (= (f3 (f5 ?v1 (f7 (f8 f16 ?v2) ?v0)) (f7 (f8 f42 ?v2) ?v0)) f1) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v0 ?v4) (and (<= ?v4 0) (= ?v2 (+ (* ?v0 ?v3) ?v4)))) (= (f3 (f5 ?v1 ?v3) ?v4) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f3 (f5 (f6 (f7 (f8 f42 ?v0) ?v2)) (f7 (f8 f42 ?v1) ?v2)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (= (= (f3 (f5 (f6 ?v1) ?v2) ?v0) f1) (= (f7 (f8 f42 ?v1) ?v0) (f7 (f8 f42 ?v2) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f7 (f8 f42 ?v0) ?v1) (f7 (f8 f42 ?v2) ?v1)) (= (f3 (f5 (f6 ?v0) ?v2) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f5 (f6 ?v0) (f7 (f8 f42 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f7 (f8 f42 (f11 (f12 f13 (f7 (f8 f42 ?v0) ?v1)) ?v2)) ?v1) (f7 (f8 f42 (f11 (f12 f13 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 (f8 f42 ?v0) ?v1) 0) (exists ((?v2 Int)) (= ?v0 (* ?v1 ?v2))))))
(assert (forall ((?v0 Int)) (= (f19 (f33 ?v0) (f43 ?v0)) f1)))
(assert (forall ((?v0 S10)) (let ((?v_0 (f11 (f12 f13 (- 1)) (f34 f35 ?v0)))) (=> (= (f44 ?v0) f1) (= (* ?v_0 ?v_0) 1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 (f12 f13 (- 1)) (f38 f39 ?v0)))) (=> (= (f45 ?v0) f1) (= (* ?v_0 ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f14 f15 (f7 (f8 f42 (f11 f18 (f14 f15 ?v0))) (f11 f18 (f14 f15 ?v1)))) (f14 f15 (f7 (f8 f42 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f14 f15 (f7 (f8 f42 ?v0) ?v1)) (f14 f15 (f7 (f8 f42 (f11 f18 (f14 f15 ?v0))) (f11 f18 (f14 f15 ?v1)))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f7 (f8 f42 (f11 f18 ?v0)) (f11 f18 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f7 (f8 f42 (f11 f18 ?v0)) (f11 f18 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (= (f44 (f36 (f37 ?v1) ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f21 ?v2 (f36 (f37 ?v0) ?v1)) f1) (= (f45 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 0 ?v0) (=> (= (f19 (f33 ?v0) ?v1) f1) (= (f45 ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (f45 (f32 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 (f20 ?v0) (f43 ?v1)) f1) (not (= (f3 (f5 (f6 ?v0) 0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (f43 ?v0) (f22 (f4 ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (= (f45 (f43 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f45 (f5 (f27 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (= (f11 f18 (f38 f39 (f43 ?v0))) (- ?v0 1)))))
(assert (forall ((?v0 S10)) (=> (< 0 (f11 f18 (f34 f35 ?v0))) (= (f44 ?v0) f1))))
(assert (forall ((?v0 S2)) (=> (< 0 (f11 f18 (f38 f39 ?v0))) (= (f45 ?v0) f1))))
(assert (forall ((?v0 S10)) (=> (not (= (f44 ?v0) f1)) (= (f34 f35 ?v0) (f14 f15 0)))))
(assert (forall ((?v0 S2)) (=> (not (= (f45 ?v0) f1)) (= (f38 f39 ?v0) (f14 f15 0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f11 f18 ?v1)) (?v_1 (f11 f18 ?v0))) (=> (<= ?v_1 ?v_0) (= (f14 f15 (f7 (f8 f42 ?v_0) ?v_1)) (f14 f15 (f7 (f8 f42 (f11 f18 (f14 f15 (- ?v_0 ?v_1)))) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_1 (f11 f18 ?v1)) (?v_0 (f11 f18 ?v0))) (=> (< ?v_0 ?v_1) (= (f14 f15 (f7 (f8 f42 ?v_0) ?v_1)) ?v0)))))
(assert (forall ((?v0 S7)) (= (f14 f15 (f11 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f18 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f18 (f14 f15 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f7 (f8 f16 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f7 (f8 f42 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
