(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int Int Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 (S6 Int) S4)
(declare-fun f10 () S6)
(declare-fun f11 (S7 Int) S5)
(declare-fun f12 () S7)
(declare-fun f13 () S4)
(declare-fun f14 (Int) S1)
(declare-fun f15 () S3)
(declare-fun f16 (S8 S5) S5)
(declare-fun f17 (S9 S5) S8)
(declare-fun f18 () S9)
(declare-fun f19 () S9)
(declare-fun f20 () S3)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (not (= (f3 1 (f4 (f5 f6 (- 1)) ?v_0) ?v_0) f1))))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (= (f3 (f4 (f5 f6 (- 1)) ?v_0) (f8 (f9 f10 (- 1)) (f11 f12 (* 2 (f8 f13 (f11 f12 f7))))) ?v_0) f1)))
(assert (<= 1 f7))
(assert (< 2 (+ (* 4 f7) 1)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (= (f3 (f4 (f5 f6 (- 1)) ?v_0) (f8 (f9 f10 (- 1)) (f11 f12 (* 2 (f8 f13 (f11 f12 f7))))) ?v_0) f1)))
(assert (= (f14 (+ (* 4 f7) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (= (f3 (f4 (f5 f6 (- 1)) ?v_0) (f8 (f9 f10 (- 1)) (f11 f12 (f4 (f5 f15 (- ?v_0 1)) 2))) ?v_0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 ?v1 ?v2) f1) (= (f3 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 ?v1 (- ?v2)) f1) (= (f3 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f3 (* ?v0 ?v_0) 1 ?v1) f1) (= (f3 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (f3 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f3 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f3 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int)) (=> (= (f14 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f4 (f5 f15 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f4 (f5 f15 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f4 (f5 f15 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f13 (f11 f12 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f11 f12 (* ?v_0 ?v_0)) (f11 f12 (+ (* (f8 f13 (f11 f12 (- ?v0 1))) (f8 f13 (f11 f12 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f3 ?v1 1 ?v0) f1) (= (f3 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (= (f3 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f3 ?v1 0 ?v0) f1) (= (f3 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f3 ?v1 0 ?v0) f1)) (not (= (f3 ?v2 0 ?v0) f1))) (not (= (f3 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f3 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0) f1) (=> (not (= (f3 ?v1 0 ?v0) f1)) (=> (not (= (f3 ?v2 0 ?v0) f1)) (not (= (f3 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 (f8 ?v_0 ?v1) 1 ?v2) f1) (= (f3 (f8 ?v_0 (f11 f12 (* (f8 f13 ?v1) (f8 f13 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S5)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (= (f3 (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (=> (= (f3 ?v3 ?v4 ?v2) f1) (= (f3 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (=> (= (f3 ?v3 ?v4 ?v2) f1) (= (f3 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (=> (= (f3 ?v3 ?v4 ?v2) f1) (= (f3 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (=> (= (f3 ?v1 ?v3 ?v2) f1) (= (f3 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f3 ?v3 ?v4 ?v2) f1) (= (f3 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (= (f3 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (= (f3 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (= (f3 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (= (= (f3 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f3 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 ?v0 ?v1 ?v2) f1) (= (= (f3 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f3 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f3 ?v1 (- 1) ?v0) f1) (not (= (f3 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f3 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f3 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f3 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (= (f3 (f4 (f5 f6 ?v1) ?v0) (f8 (f9 f10 ?v1) (f11 f12 (f4 (f5 f15 (- ?v0 1)) 2))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f14 ?v0) f1) (=> (= (f3 ?v1 0 ?v0) f1) (= (f3 0 (f8 (f9 f10 ?v1) (f11 f12 (f4 (f5 f15 (- ?v0 1)) 2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f11 f12 (+ (* 2 (f8 f13 ?v1)) 1))) (* ?v0 (f8 (f9 f10 (f8 ?v_0 ?v1)) (f11 f12 2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f11 f12 (+ (* 2 (f8 f13 ?v1)) 1))) (f16 (f17 f19 ?v0) (f16 (f17 f18 (f16 ?v_0 ?v1)) (f11 f12 2)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f9 f10 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f11 f12 (+ (* 2 (f8 f13 ?v1)) 1))) (* ?v0 (* ?v_1 ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (let ((?v_1 (f16 ?v_0 ?v1))) (= (f16 ?v_0 (f11 f12 (+ (* 2 (f8 f13 ?v1)) 1))) (f16 (f17 f19 ?v0) (f16 (f17 f19 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f9 f10 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f11 f12 (* 2 (f8 f13 ?v1)))) (* ?v_1 ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (let ((?v_1 (f16 ?v_0 ?v1))) (= (f16 ?v_0 (f11 f12 (* 2 (f8 f13 ?v1)))) (f16 (f17 f19 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 Int)) (let ((?v_1 (f8 f13 ?v0)) (?v_0 (f9 f10 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f4 (f5 f15 (f8 ?v_0 ?v0)) ?v1) (f8 ?v_0 (f11 f12 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 (- 1)))) (let ((?v_1 (f8 ?v_0 ?v1)) (?v_2 (f8 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f3 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f11 f12 (* (f8 f13 ?v1) (f8 f13 ?v2))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 (f5 f15 (- ?v0 1)) 2))) (= (f11 f12 (* 2 (f8 f13 (f11 f12 ?v_0)))) (f11 f12 (* 2 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f11 f12 (* (f8 f13 ?v1) (f8 f13 ?v2)))) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f11 f12 (* (f8 f13 ?v1) (f8 f13 ?v2)))) (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 ?v1) (ite (= ?v1 (f11 f12 0)) (f11 f12 1) (f11 f12 (* (f8 f13 ?v0) (f8 f13 (f16 ?v_0 (f11 f12 (- (f8 f13 ?v1) 1)))))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f11 f12 (f8 (f9 f10 ?v0) ?v1)) (f16 (f17 f18 (f11 f12 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f9 f10 (f8 f13 ?v0)) ?v1) (f8 f13 (f16 (f17 f18 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 f13 (f16 (f17 f18 ?v0) ?v1)) (f8 (f9 f10 (f8 f13 ?v0)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f17 f19 ?v0))) (= (f16 (f17 f19 (f16 ?v_0 ?v1)) (f16 (f17 f19 ?v2) ?v3)) (f16 (f17 f19 (f16 ?v_0 ?v2)) (f16 (f17 f19 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (* ?v0 ?v1) (* ?v2 ?v3)) (* (* ?v0 ?v2) (* ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f17 f19 (f16 (f17 f19 ?v0) ?v1))) (?v_0 (f17 f19 ?v2))) (= (f16 ?v_1 (f16 ?v_0 ?v3)) (f16 ?v_0 (f16 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v0 ?v1))) (= (* ?v_0 (* ?v2 ?v3)) (* ?v2 (* ?v_0 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f17 f19 ?v0)) (?v_1 (f16 (f17 f19 ?v2) ?v3))) (= (f16 (f17 f19 (f16 ?v_0 ?v1)) ?v_1) (f16 ?v_0 (f16 (f17 f19 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v3))) (= (* (* ?v0 ?v1) ?v_0) (* ?v0 (* ?v1 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f19 ?v0))) (= (f16 (f17 f19 (f16 ?v_0 ?v1)) ?v2) (f16 (f17 f19 (f16 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* (* ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f19 ?v0))) (= (f16 (f17 f19 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f19 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* (* ?v0 ?v1) ?v2) (* ?v0 (* ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f19 ?v0))) (= (f16 ?v_0 (f16 (f17 f19 ?v1) ?v2)) (f16 (f17 f19 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (* ?v0 (* ?v1 ?v2)) (* (* ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S5)) (= (f11 f12 (f8 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f13 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f13 (f11 f12 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f4 (f5 f15 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f4 (f5 f20 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
