(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 (S2 Int) S1)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 (Int) S3)
(declare-fun f7 () Int)
(declare-fun f8 (Int) S1)
(declare-fun f9 (S4 Int) Int)
(declare-fun f10 (S5 Int) S4)
(declare-fun f11 () S5)
(declare-fun f12 (S6 S7) Int)
(declare-fun f13 (S8 Int) S6)
(declare-fun f14 () S8)
(declare-fun f15 (S9 Int) S7)
(declare-fun f16 () S9)
(declare-fun f17 (Int) S2)
(declare-fun f18 () S4)
(declare-fun f19 () S5)
(declare-fun f20 () S6)
(declare-fun f21 () S5)
(declare-fun f22 (Int S2) S1)
(declare-fun f23 (Int) S3)
(declare-fun f24 () S5)
(declare-fun f25 (Int) S2)
(declare-fun f26 () S5)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f3) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f4 (f5 (f6 f7) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f4 (f5 (f6 f7) ?v1) ?v_0) f1))) (= ?v1 ?v0))))))))
(assert (< 0 (+ (* 4 f3) 1)))
(assert (< 0 (+ (* 4 f3) 1)))
(assert (= (f8 (+ (* 4 f3) 1)) f1))
(assert (= (f9 (f10 f11 (- 1)) (+ (* 4 f3) 1)) 1))
(assert (= (f4 (f5 (f6 (f12 (f13 f14 f7) (f15 f16 2))) (- 1)) (+ (* 4 f3) 1)) f1))
(assert (= (f4 (f17 (+ (* 4 f3) 1)) (- 1)) f1))
(assert (let ((?v_0 (+ (* 4 f3) 1))) (=> (not (= (f4 (f17 ?v_0) (- 1)) f1)) (not (= (f9 (f10 f11 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f4 (f5 (f6 (f12 (f13 f14 ?v0) (f15 f16 2))) (- 1)) (+ (* 4 f3) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f4 (f5 (f6 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f4 (f5 (f6 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 (f6 ?v0) ?v1))) (= (= (f4 ?v_0 (- ?v2)) f1) (= (f4 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f4 (f5 (f6 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f4 (f5 (f6 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (f4 (f5 (f6 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 (f6 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 (f6 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 (f6 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int)) (=> (= (f8 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f8 ?v_0) f1) (= (f9 (f10 f11 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f4 (f5 (f6 (f12 (f13 f14 ?v0) ?v3)) (f12 (f13 f14 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 ?v1))) (=> (= (f8 ?v0) f1) (=> (< 0 ?v1) (=> (= (f4 (f5 (f6 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f4 (f5 ?v_0 1) ?v0) f1) (= (f4 (f5 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 ?v0) f1) (=> (< 0 ?v1) (=> (= (f4 (f5 (f6 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f4 (f5 (f6 ?v1) 0) ?v0) f1) (= (f4 (f5 (f6 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (not (= (f4 (f5 (f6 ?v2) 0) ?v0) f1))) (not (= (f4 (f5 (f6 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f4 (f5 (f6 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f4 (f5 (f6 ?v2) 0) ?v0) f1)) (not (= (f4 (f5 (f6 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (=> (= (f4 (f5 (f6 ?v3) ?v4) ?v2) f1) (= (f4 (f5 (f6 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (=> (= (f4 (f5 (f6 ?v3) ?v4) ?v2) f1) (= (f4 (f5 (f6 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (=> (= (f4 (f5 (f6 ?v3) ?v4) ?v2) f1) (= (f4 (f5 (f6 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 ?v0))) (=> (= (f4 (f5 ?v_0 ?v1) ?v2) f1) (=> (= (f4 (f5 (f6 ?v1) ?v3) ?v2) f1) (= (f4 (f5 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f6 ?v0))) (=> (= (f4 (f5 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f4 (f5 (f6 ?v3) ?v4) ?v2) f1) (= (f4 (f5 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f4 (f5 (f6 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f4 (f5 (f6 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (f4 (f5 (f6 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f6 ?v3))) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (= (f4 (f5 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f4 (f5 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f6 ?v3))) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (= (= (f4 (f5 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f4 (f5 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 ?v1))) (=> (< 2 ?v0) (=> (= (f4 (f5 ?v_0 (- 1)) ?v0) f1) (not (= (f4 (f5 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f4 (f5 (f6 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f4 (f5 (f6 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f4 (f5 (f6 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f4 (f5 (f6 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f4 (f5 (f6 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f4 (f5 (f6 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f11 ?v0) ?v1) (ite (= (f4 (f5 (f6 ?v0) 0) ?v1) f1) 0 (ite (= (f4 (f17 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f4 (f17 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f4 (f5 (f6 (f12 (f13 f14 ?v2) (f15 f16 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f14 (- 1)))) (let ((?v_1 (f12 ?v_0 ?v1)) (?v_2 (f12 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f4 (f5 (f6 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (= (f8 ?v0) f1) (= (f4 (f5 (f6 (f9 f18 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f4 (f5 (f6 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f4 (f5 (f6 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (= (f8 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f4 (f5 (f6 (* ?v1 (f9 (f10 f19 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (<= 0 (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f12 (f13 f14 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f15 f16 2))) (let ((?v_0 (f12 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f19 ?v0))) (=> (= (f8 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f9 ?v_0 (f9 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f8 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f9 (f10 f19 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f9 (f10 f19 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f8 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f9 (f10 f19 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f9 (f10 f19 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f9 (f10 f19 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f9 (f10 f19 ?v0) ?v1))))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f4 (f5 (f6 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f12 (f13 f14 ?v0) (f15 f16 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f12 (f13 f14 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (= (f12 (f13 f14 ?v0) ?v_0) (f12 (f13 f14 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2)) (?v_1 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_1 ?v_0)) ?v_0) (f12 ?v_1 (f15 f16 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f12 (f13 f14 ?v0) ?v_0) (f12 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_3 (f13 f14 ?v1)) (?v_1 (f13 f14 ?v0))) (= (f12 (f13 f14 (- ?v0 ?v1)) ?v_0) (- (+ (- (f12 ?v_1 ?v_0) (* (* 3 (f12 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f12 ?v_3 ?v_2))) (f12 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_1 (f13 f14 ?v0)) (?v_3 (f13 f14 ?v1))) (= (f12 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f12 ?v_1 ?v_0) (* (* 3 (f12 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f12 ?v_3 ?v_2))) (f12 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f12 (f13 f14 (- ?v0 ?v1)) ?v_0) (+ (- (f12 (f13 f14 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f12 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f12 (f13 f14 (+ ?v0 ?v1)) ?v_0) (+ (+ (f12 (f13 f14 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f12 (f13 f14 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 3))) (= (f12 (f13 f14 (- ?v0)) ?v_0) (- (f12 (f13 f14 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (* ?v0 (f12 ?v_0 (f15 f16 2))) (f12 ?v_0 (f15 f16 3))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f15 f16 (+ (f12 f20 ?v1) (f12 f20 ?v2)))) (* (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (< 0 (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f15 f16 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f15 f16 3))) (let ((?v_0 (f12 (f13 f14 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f12 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (= (f9 f18 ?v0) (ite (<= ?v0 0) 1 (* ?v0 (f9 f18 (- ?v0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f8 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f4 (f17 ?v0) ?v1) f1)) (= (f4 (f5 (f6 (f9 f18 ?v_0)) (f12 (f13 f14 ?v1) (f15 f16 (f9 (f10 f21 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f22 ?v0 ?v1) f1) (= (f4 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 ?v1)) (?v_1 (f15 f16 ?v0))) (=> (< 0 ?v0) (= (f12 ?v_0 ?v_1) (* ?v1 (f12 ?v_0 (f15 f16 (- (f12 f20 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (<= 0 (f12 (f13 f14 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 (f23 ?v1) ?v0))) (=> (= (f8 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f22 ?v2 ?v_0) f1) (= (f22 (f9 (f10 f19 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f5 (f23 ?v1) ?v0))) (=> (= (f8 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f22 (f9 (f10 f19 ?v0) ?v2) ?v_1) f1) (= (f22 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (= (f4 (f5 (f6 (f9 (f10 f11 ?v1) ?v0)) (f12 (f13 f14 ?v1) (f15 f16 (f9 (f10 f21 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f9 (f10 f21 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f22 ?v1 (f5 (f23 (- ?v0 1)) ?v2)) f1) (= (f22 ?v1 (f5 (f23 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f9 (f10 f21 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f9 (f10 f21 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f22 ?v0 (f5 (f23 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f22 ?v2 (f5 (f23 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f22 ?v2 (f5 (f23 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f8 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f22 ?v2 (f5 (f23 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (not (= (f22 ?v1 (f5 (f23 (- ?v0 1)) ?v2)) f1)) (=> (= (f22 ?v1 (f5 (f23 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f9 (f10 f19 ?v2) ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (= (f4 (f5 (f6 ?v1) 0) ?v0) f1) (= (f4 (f5 (f6 0) (f12 (f13 f14 ?v1) (f15 f16 (f9 (f10 f21 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f4 (f17 ?v0) ?v1) f1)) (= (f4 (f5 (f6 (f12 (f13 f14 ?v1) (f15 f16 (f9 (f10 f21 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (= (f4 (f17 ?v0) ?v1) f1) (= (f4 (f5 (f6 (f12 (f13 f14 ?v1) (f15 f16 (f9 (f10 f21 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_1 (f12 f20 ?v0)) (?v_0 (f13 f14 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f9 (f10 f21 (f12 ?v_0 ?v0)) ?v1) (f12 ?v_0 (f15 f16 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 ?v2))) (=> (= (f8 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f4 (f5 ?v_0 0) ?v0) f1)) (=> (not (= (f4 (f17 ?v0) ?v1) f1)) (not (= (f4 (f5 ?v_0 (* ?v1 (f9 (f10 f24 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f8 ?v0) f1) (= (f25 ?v_0) (f5 (f23 ?v_0) ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f4 ?v0 (f9 (f10 f21 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f4 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f4 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f4 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int)) (= (f9 (f10 f21 0) ?v0) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f21 ?v0))) (= (div ?v0 ?v1) (ite (<= 0 ?v1) (f9 ?v_0 ?v1) (- (f9 ?v_0 (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f22 ?v0 (f25 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f22 ?v1 (f25 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 (f25 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 (f25 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f24 ?v0))) (=> (< 2 ?v0) (=> (= (f4 (f5 (f6 ?v1) ?v2) ?v0) f1) (= (f4 (f5 (f6 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f24 ?v0))) (=> (< 2 ?v0) (=> (= (f4 (f5 (f6 ?v1) ?v2) ?v0) f1) (= (f4 (f5 (f6 (* ?v3 (f9 ?v_0 ?v1))) (* ?v3 (f9 ?v_0 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f9 (f10 f24 ?v2) ?v3)))) (=> (= (f4 (f5 (f6 ?v0) ?v_0) ?v2) f1) (= (f4 (f5 (f6 (* ?v0 ?v3)) (* ?v_0 ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 (f10 f24 ?v3) ?v0))) (=> (= (f4 (f5 (f6 (* ?v0 ?v1)) ?v2) ?v3) f1) (= (f4 (f5 (f6 (* (* ?v_0 ?v0) ?v1)) (* ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f24 ?v0) ?v1) (f12 (f13 f14 ?v1) (f15 f16 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 (f10 f24 ?v0) ?v1))) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (= (f4 (f5 (f6 (* (* ?v_0 ?v1) ?v2)) (* ?v_0 ?v3)) ?v0) f1) (= (f4 (f5 (f6 ?v2) (* ?v3 ?v_0)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 (* ?v2 ?v1)))) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (= (f4 (f5 ?v_0 (* (* ?v3 (f9 (f10 f24 ?v0) ?v1)) ?v1)) ?v0) f1) (= (f4 (f5 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f6 ?v1)) (?v_0 (f10 f24 ?v0))) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 ?v_1 0) ?v0) f1)) (=> (not (= (f4 (f5 (f6 ?v2) 0) ?v0) f1)) (=> (= (f4 (f5 (f6 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) ?v0) f1) (= (f4 (f5 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f6 ?v1)) (?v_0 (f6 ?v2)) (?v_2 (f10 f24 ?v0))) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 ?v_1 0) ?v0) f1)) (=> (not (= (f4 (f5 ?v_0 0) ?v0) f1)) (=> (= (f4 (f5 ?v_0 (* ?v3 (f9 ?v_2 ?v1))) ?v0) f1) (= (f4 (f5 ?v_1 (* ?v3 (f9 ?v_2 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f6 ?v3)) (?v_0 (f10 f24 ?v0))) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (=> (not (= (f4 (f5 (f6 ?v2) 0) ?v0) f1)) (=> (not (= (f4 (f5 ?v_1 0) ?v0) f1)) (=> (= (f4 (f5 (f6 (* ?v1 (f9 ?v_0 ?v3))) (* ?v1 (f9 ?v_0 ?v2))) ?v0) f1) (= (f4 (f5 ?v_1 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f24 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f4 (f5 (f6 (* (* ?v1 ?v_1) (f9 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f4 (f5 (f6 (* (f9 (f10 f24 ?v0) ?v1) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f24 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (let ((?v_2 (f9 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f4 (f5 (f6 ?v_2) (* (* ?v1 ?v_1) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f24 ?v0))) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f4 (f5 (f6 (f9 ?v_0 (f9 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (= (f4 (f5 (f6 (* ?v1 (f9 (f10 f24 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 ?v0) f1) (=> (not (= (f4 (f5 (f6 ?v1) 0) ?v0) f1)) (not (= (f4 (f5 (f6 (f9 (f10 f24 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f9 (f10 f21 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f9 (f10 f21 ?v1) ?v2) (f9 (f10 f21 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f9 (f10 f21 ?v0) ?v2) (f9 (f10 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f9 (f10 f21 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f21 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2))))))))
(assert (forall ((?v0 S7)) (= (f15 f16 (f12 f20 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f20 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f20 (f15 f16 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f9 (f10 f21 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f9 (f10 f26 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
