(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 () Int)
(declare-fun f5 () Int)
(declare-fun f6 (S2 S3) Int)
(declare-fun f7 () S2)
(declare-fun f8 (Int Int) S3)
(declare-fun f9 () Int)
(declare-fun f10 (Int) S1)
(declare-fun f11 (S4 Int) Int)
(declare-fun f12 (S5 Int) S4)
(declare-fun f13 () S5)
(declare-fun f14 (Int Int) S1)
(declare-fun f15 (S6 S7) Int)
(declare-fun f16 (S8 Int) S6)
(declare-fun f17 () S8)
(declare-fun f18 (S9 Int) S7)
(declare-fun f19 () S9)
(declare-fun f20 (Int Int Int) S1)
(declare-fun f21 () Int)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 () S6)
(declare-fun f24 () S4)
(declare-fun f25 () S5)
(declare-fun f26 () S5)
(declare-fun f27 () S4)
(declare-fun f28 () S5)
(assert (not (= f1 f2)))
(assert (not (= (f3 (* (+ (* 4 f4) 1) f5)) f1)))
(assert (= (f6 f7 (f8 f9 1)) (* (+ (* 4 f4) 1) f5)))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (= (f6 f7 (f8 f9 1)) (* (+ (* 4 f4) 1) f5)))
(assert (= (f10 (+ (* 4 f4) 1)) f1))
(assert (= (f11 (f12 f13 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (* ?v0 ?v1)) f1)))))
(assert (= (f14 (+ (* 4 f4) 1) (- 1)) f1))
(assert (= (+ (f15 (f16 f17 f9) (f18 f19 2)) 1) (* (+ (* 4 f4) 1) f5)))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f14 ?v_0 (- 1)) f1)) (not (= (f11 (f12 f13 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (= (= (f3 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f6 f7 (f8 ?v1 ?v2)) ?v0)))))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f9) (and (< f9 ?v_0) (= (f20 f21 f9 ?v_0) f1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f15 (f16 f17 f9) (f18 f19 2)) 1) (* (+ (* 4 f4) 1) ?v0)) false)) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f20 f21 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) false))) false))
(assert (= (f20 (f15 (f16 f17 f21) (f18 f19 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (= (f22 (+ (* 4 f4) 1) (+ (f15 (f16 f17 f9) (f18 f19 2)) 1)) f1))
(assert (= (f22 (+ (* 4 f4) 1) (- (f15 (f16 f17 f9) (f18 f19 2)) (- 1))) f1))
(assert (= (f20 (f15 (f16 f17 f9) (f18 f19 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (f15 (f16 f17 f9) (f18 f19 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (f20 (f15 (f16 f17 ?v0) (f18 f19 2)) (- 1) (+ (* 4 f4) 1)) f1) false)) false))
(assert (let ((?v_0 (f18 f19 2))) (= (f20 (f15 (f16 f17 f9) ?v_0) (f15 (f16 f17 f21) ?v_0) (+ (* 4 f4) 1)) f1)))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f10 ?v_0) f1) (= (f11 (f12 f13 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f6 f7 (f8 ?v0 ?v1)) (f6 f7 (f8 ?v2 ?v3))) (f6 f7 (f8 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (= (f20 (f15 (f16 f17 ?v1) (f18 f19 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 ?v0) ?v1) (ite (= (f20 ?v0 0 ?v1) f1) 0 (ite (= (f14 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f20 (f15 (f16 f17 ?v2) (f18 f19 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v2))) (=> (= (f10 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v1 ?v3)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int)) (let ((?v_0 (f15 (f16 f17 ?v0) ?v2))) (=> (= (f10 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v3 ?v1)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (= (f10 ?v0) f1) (=> (= (f22 ?v0 (f15 (f16 f17 ?v1) ?v2)) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (= (f10 ?v0) f1) (=> (= (f22 ?v0 (f15 (f16 f17 ?v1) ?v2)) f1) (=> (< 0 (f15 f23 ?v2)) (= (f22 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f20 ?v0 0 ?v1) f1)) (=> (= (f20 (f15 (f16 f17 ?v2) (f18 f19 2)) ?v0 ?v1) f1) (not (= (f22 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f10 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f22 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (= (f22 ?v0 (* ?v1 ?v2)) f1) (or (= (f22 ?v0 ?v1) f1) (= (f22 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= (f20 ?v3 ?v4 ?v2) f1) (= (f20 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= (f20 ?v3 ?v4 ?v2) f1) (= (f20 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= (f20 ?v3 ?v4 ?v2) f1) (= (f20 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= (f20 ?v1 ?v3 ?v2) f1) (= (f20 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f20 ?v3 ?v4 ?v2) f1) (= (f20 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (= (f20 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f20 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (= (f20 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f20 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f20 ?v1 (- 1) ?v0) f1) (not (= (f20 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f20 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f20 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f20 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f20 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f20 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f20 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int)) (= (f20 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 ?v1 (- ?v2)) f1) (= (f20 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f15 (f16 f17 ?v0) (f18 f19 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f18 f19 ?v0))) (=> (< 0 ?v0) (= (f15 ?v_0 ?v_1) (* ?v1 (f15 ?v_0 (f18 f19 (- (f15 f23 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (= (= (f15 (f16 f17 ?v0) ?v_0) (f15 (f16 f17 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f19 2)) (?v_1 (f16 f17 ?v0))) (= (f15 (f16 f17 (f15 ?v_1 ?v_0)) ?v_0) (f15 ?v_1 (f18 f19 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f15 (f16 f17 ?v0) ?v_0) (f15 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f18 f19 2)) (?v_0 (f18 f19 3)) (?v_3 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0))) (= (f15 (f16 f17 (- ?v0 ?v1)) ?v_0) (- (+ (- (f15 ?v_1 ?v_0) (* (* 3 (f15 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f15 ?v_3 ?v_2))) (f15 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f18 f19 2)) (?v_0 (f18 f19 3)) (?v_1 (f16 f17 ?v0)) (?v_3 (f16 f17 ?v1))) (= (f15 (f16 f17 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f15 ?v_1 ?v_0) (* (* 3 (f15 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f15 ?v_3 ?v_2))) (f15 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (= (f15 (f16 f17 (- ?v0 ?v1)) ?v_0) (+ (- (f15 (f16 f17 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f15 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f19 2))) (= (f15 (f16 f17 (+ ?v0 ?v1)) ?v_0) (+ (+ (f15 (f16 f17 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f15 (f16 f17 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f19 3))) (= (f15 (f16 f17 (- ?v0)) ?v_0) (- (f15 (f16 f17 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 ?v0))) (= (* ?v0 (f15 ?v_0 (f18 f19 2))) (f15 ?v_0 (f18 f19 3))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f18 f19 3))) (let ((?v_0 (f15 (f16 f17 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f15 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f18 f19 2))) (let ((?v_0 (f15 (f16 f17 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f15 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f15 (f16 f17 ?v0) (f18 f19 2)))))
(assert (= (f10 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 ?v1 ?v2) f1) (= (f22 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 ?v0 0 ?v1) f1) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 ?v0 0 ?v1) f1) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 (f15 (f16 f17 ?v0) ?v3) (f15 (f16 f17 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S7) (?v1 Int) (?v2 Int)) (=> (< 0 (f15 f23 ?v0)) (=> (= (f22 ?v1 ?v2) f1) (= (f22 ?v1 (f15 (f16 f17 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (= (f20 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f20 ?v1 1 ?v0) f1) (= (f20 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (= (f20 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f20 ?v1 0 ?v0) f1) (= (f20 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f20 ?v1 0 ?v0) f1)) (not (= (f20 ?v2 0 ?v0) f1))) (not (= (f20 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f20 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (not (= (f20 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f10 ?v1) f1) (=> (= (f22 ?v1 (* ?v0 ?v2)) f1) (or (= (f22 ?v1 ?v0) f1) (= (f22 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f10 ?v1) f1) (= (f22 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int)) (=> (= (f22 (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v2) ?v1)) f1) (=> (not (= ?v1 (f18 f19 0))) (= (f22 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f18 f19 0))) (= (= (f22 (f15 (f16 f17 ?v1) ?v0) (f15 (f16 f17 ?v2) ?v0)) f1) (= (f22 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 (- 1)))) (let ((?v_1 (f15 ?v_0 ?v1)) (?v_2 (f15 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f20 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S7)) (let ((?v_0 (f16 f17 ?v0))) (=> (= (f22 (f15 ?v_0 ?v1) ?v2) f1) (=> (<= (f15 f23 ?v3) (f15 f23 ?v1)) (= (f22 (f15 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 S7)) (=> (= (f22 ?v0 ?v1) f1) (=> (<= (f15 f23 ?v2) (f15 f23 ?v3)) (= (f22 (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (=> (<= (f15 f23 ?v0) (f15 f23 ?v1)) (= (f22 (f15 ?v_0 ?v0) (f15 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (= (f22 ?v0 ?v1) f1) (= (f22 (f15 (f16 f17 ?v0) ?v2) (f15 (f16 f17 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f20 ?v1 ?v2 ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f20 ?v1 ?v3 ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f11 f24 (f15 (f16 f17 ?v0) ?v1)) (f15 (f16 f17 (f11 f24 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f15 (f16 f17 ?v0) (f18 f19 1)) ?v0)))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f20 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f15 (f16 f17 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (= (f20 (f11 (f12 f13 ?v1) ?v0) (f15 (f16 f17 ?v1) (f18 f19 (f11 (f12 f25 (- ?v0 1)) 2))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f14 ?v0 ?v1) f1)) (= (f20 (f15 (f16 f17 ?v1) (f18 f19 (f11 (f12 f25 (- ?v0 1)) 2))) (- 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (= (f14 ?v0 ?v1) f1) (= (f20 (f15 (f16 f17 ?v1) (f18 f19 (f11 (f12 f25 (- ?v0 1)) 2))) 1 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (=> (not (= (f14 ?v0 ?v1) f1)) (not (= (f20 ?v2 (* ?v1 (f11 (f12 f26 ?v0) ?v2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int)) (=> (= (f10 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f11 (f12 f25 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f11 (f12 f25 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f11 (f12 f25 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 (f12 f26 ?v3) ?v0))) (=> (= (f20 (* ?v0 ?v1) ?v2 ?v3) f1) (= (f20 (* (* ?v_0 ?v0) ?v1) (* ?v_0 ?v2) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f11 (f12 f26 ?v2) ?v3)))) (=> (= (f20 ?v0 ?v_0 ?v2) f1) (= (f20 (* ?v0 ?v3) (* ?v_0 ?v3) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f20 ?v1 ?v2 ?v0) f1) (= (f20 (* ?v3 (f11 ?v_0 ?v1)) (* ?v3 (f11 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f20 ?v1 ?v2 ?v0) f1) (= (f20 (f11 ?v_0 ?v1) (f11 ?v_0 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f26 ?v0) ?v1) (f15 (f16 f17 ?v1) (f18 f19 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 (f12 f26 ?v0) ?v1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (= (f20 (* (* ?v_0 ?v1) ?v2) (* ?v_0 ?v3) ?v0) f1) (= (f20 ?v2 (* ?v3 ?v_0) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (= (f20 ?v_0 (* (* ?v3 (f11 (f12 f26 ?v0) ?v1)) ?v1) ?v0) f1) (= (f20 ?v_0 ?v3 ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (=> (= (f20 (f11 ?v_0 ?v1) (f11 ?v_0 ?v2) ?v0) f1) (= (f20 ?v1 ?v2 ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (=> (= (f20 ?v2 (* ?v3 (f11 ?v_0 ?v1)) ?v0) f1) (= (f20 ?v1 (* ?v3 (f11 ?v_0 ?v2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (=> (not (= (f20 ?v3 0 ?v0) f1)) (=> (= (f20 (* ?v1 (f11 ?v_0 ?v3)) (* ?v1 (f11 ?v_0 ?v2)) ?v0) f1) (= (f20 ?v3 ?v2 ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f26 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (= (f20 (* (* ?v1 ?v_1) (f11 ?v_0 ?v_1)) ?v1 ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (= (f20 (* (f11 (f12 f26 ?v0) ?v1) ?v1) 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f26 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (let ((?v_2 (f11 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (= (f20 ?v_2 (* (* ?v1 ?v_1) ?v_2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (= (f20 (f11 ?v_0 (f11 ?v_0 ?v1)) ?v1 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (= (f20 (* ?v1 (f11 (f12 f26 ?v0) ?v1)) 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (not (= (f20 (f11 (f12 f26 ?v0) ?v1) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f10 ?v0) f1) (=> (= (f20 ?v1 0 ?v0) f1) (= (f20 0 (f15 (f16 f17 ?v1) (f18 f19 (f11 (f12 f25 (- ?v0 1)) 2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f20 (* ?v0 ?v_0) 1 ?v1) f1) (= (f20 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f10 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f14 ?v0 ?v1) f1)) (= (f20 (f11 f27 ?v_0) (f15 (f16 f17 ?v1) (f18 f19 (f11 (f12 f25 ?v_0) 2))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (= (f22 ?v0 ?v1) f1) (= (f15 (f16 f17 (f11 (f12 f25 ?v1) ?v0)) ?v2) (f11 (f12 f25 (f15 (f16 f17 ?v1) ?v2)) (f15 (f16 f17 ?v0) ?v2))))))
(assert (forall ((?v0 S7)) (= (f18 f19 (f15 f23 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f15 f23 (f18 f19 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f15 f23 (f18 f19 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f11 (f12 f25 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f11 (f12 f28 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
