(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 () Int)
(declare-fun f5 (Int) S1)
(declare-fun f6 (S2 Int) Int)
(declare-fun f7 (S3 Int) S2)
(declare-fun f8 () S3)
(declare-fun f9 (Int) S1)
(declare-fun f10 (Int Int) S1)
(declare-fun f11 (S4 S5) Int)
(declare-fun f12 (S6 Int) S4)
(declare-fun f13 () S6)
(declare-fun f14 () Int)
(declare-fun f15 (S7 Int) S5)
(declare-fun f16 () S7)
(declare-fun f17 (S8 S9) Int)
(declare-fun f18 () S8)
(declare-fun f19 (Int Int) S9)
(declare-fun f20 (Int Int Int) S1)
(declare-fun f21 () Int)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 () S4)
(declare-fun f24 () S2)
(declare-fun f25 () S3)
(declare-fun f26 () S3)
(declare-fun f27 () S3)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ (* 4 f3) 1))) (not (< (* ?v_0 f4) (* ?v_0 0)))))
(assert (< 0 (+ (* 4 f3) 1)))
(assert (< f4 0))
(assert (< 0 (+ (* 4 f3) 1)))
(assert (< f4 0))
(assert (not (<= 1 f4)))
(assert (< f4 1))
(assert (< f4 (+ (* 4 f3) 1)))
(assert (= (f5 (+ (* 4 f3) 1)) f1))
(assert (= (f6 (f7 f8 (- 1)) (+ (* 4 f3) 1)) 1))
(assert (= (f9 (* (+ (* 4 f3) 1) f4)) f1))
(assert (= (f10 (+ (* 4 f3) 1) (- 1)) f1))
(assert (= (+ (f11 (f12 f13 f14) (f15 f16 2)) 1) (* (+ (* 4 f3) 1) f4)))
(assert (let ((?v_0 (+ (* 4 f3) 1))) (=> (not (= (f10 ?v_0 (- 1)) f1)) (not (= (f6 (f7 f8 (- 1)) ?v_0) 1)))))
(assert (= (f17 f18 (f19 f14 1)) (* (+ (* 4 f3) 1) f4)))
(assert (=> (= f4 0) (= (+ (f11 (f12 f13 f14) (f15 f16 2)) 1) 0)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f3) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f20 f21 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f3) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) false))) false))
(assert (let ((?v_0 (+ (* 4 f3) 1))) (and (<= 0 f14) (and (< f14 ?v_0) (= (f20 f21 f14 ?v_0) f1)))))
(assert (= (f20 (f11 (f12 f13 f21) (f15 f16 2)) (- 1) (+ (* 4 f3) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f11 (f12 f13 f14) (f15 f16 2)) 1) (* (+ (* 4 f3) 1) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int)) (=> (= (f20 (f11 (f12 f13 ?v0) (f15 f16 2)) (- 1) (+ (* 4 f3) 1)) f1) false)) false))
(assert (= (f22 (+ (* 4 f3) 1) (+ (f11 (f12 f13 f14) (f15 f16 2)) 1)) f1))
(assert (let ((?v_0 (f11 (f12 f13 f14) (f15 f16 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f20 (f11 (f12 f13 f14) (f15 f16 2)) (- 1) (+ (* 4 f3) 1)) f1))
(assert (= (f22 (+ (* 4 f3) 1) (- (f11 (f12 f13 f14) (f15 f16 2)) (- 1))) f1))
(assert (let ((?v_0 (f15 f16 2))) (= (f20 (f11 (f12 f13 f14) ?v_0) (f11 (f12 f13 f21) ?v_0) (+ (* 4 f3) 1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f17 f18 (f19 ?v0 ?v1)) (f17 f18 (f19 ?v2 ?v3))) (f17 f18 (f19 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f5 ?v_0) f1) (= (f6 (f7 f8 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (= (f9 ?v1) f1) (= (f9 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f9 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f17 f18 (f19 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (= (f20 (f11 (f12 f13 ?v1) (f15 f16 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (ite (= (f20 ?v0 0 ?v1) f1) 0 (ite (= (f10 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f20 (f11 (f12 f13 ?v2) (f15 f16 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v2))) (=> (= (f5 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v1 ?v3)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v2))) (=> (= (f5 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (* ?v3 ?v1)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f5 ?v0) f1) (=> (= (f22 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f5 ?v0) f1) (=> (= (f22 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1) (=> (< 0 (f11 f23 ?v2)) (= (f22 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f20 ?v0 0 ?v1) f1)) (=> (= (f20 (f11 (f12 f13 ?v2) (f15 f16 2)) ?v0 ?v1) f1) (not (= (f22 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f5 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f22 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= (f20 ?v3 ?v4 ?v2) f1) (= (f20 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= (f20 ?v3 ?v4 ?v2) f1) (= (f20 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= (f20 ?v3 ?v4 ?v2) f1) (= (f20 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= (f20 ?v1 ?v3 ?v2) f1) (= (f20 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f20 ?v3 ?v4 ?v2) f1) (= (f20 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (= (f20 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f20 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (= (f20 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f20 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f20 ?v1 (- 1) ?v0) f1) (not (= (f20 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f20 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f20 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f20 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f20 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f20 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f20 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f20 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int)) (= (f20 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 ?v1 (- ?v2)) f1) (= (f20 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f11 (f12 f13 ?v0) (f15 f16 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 ?v1)) (?v_1 (f15 f16 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (* ?v1 (f11 ?v_0 (f15 f16 (- (f11 f23 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (= (f11 (f12 f13 ?v0) ?v_0) (f11 (f12 f13 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2)) (?v_1 (f12 f13 ?v0))) (= (f11 (f12 f13 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f15 f16 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f11 (f12 f13 ?v0) ?v_0) (f11 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_3 (f12 f13 ?v1)) (?v_1 (f12 f13 ?v0))) (= (f11 (f12 f13 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_1 (f12 f13 ?v0)) (?v_3 (f12 f13 ?v1))) (= (f11 (f12 f13 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (* (* 3 (f11 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f11 (f12 f13 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f12 f13 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f11 (f12 f13 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f12 f13 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f11 (f12 f13 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 3))) (= (f11 (f12 f13 (- ?v0)) ?v_0) (- (f11 (f12 f13 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (* ?v0 (f11 ?v_0 (f15 f16 2))) (f11 ?v_0 (f15 f16 3))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f15 f16 3))) (let ((?v_0 (f11 (f12 f13 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f15 f16 2))) (let ((?v_0 (f11 (f12 f13 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f12 f13 ?v0) (f15 f16 2)))))
(assert (= (f5 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 ?v1 ?v2) f1) (= (f22 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 ?v0 0 ?v1) f1) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 ?v0 0 ?v1) f1) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S5)) (=> (= (f20 ?v0 ?v1 ?v2) f1) (= (f20 (f11 (f12 f13 ?v0) ?v3) (f11 (f12 f13 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (< 0 (f11 f23 ?v0)) (=> (= (f22 ?v1 ?v2) f1) (= (f22 ?v1 (f11 (f12 f13 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 ?v0) f1) (=> (< 0 ?v1) (=> (= (f20 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f20 ?v1 1 ?v0) f1) (= (f20 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f5 ?v0) f1) (=> (< 0 ?v1) (=> (= (f20 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f20 ?v1 0 ?v0) f1) (= (f20 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f5 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f20 ?v1 0 ?v0) f1)) (not (= (f20 ?v2 0 ?v0) f1))) (not (= (f20 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f20 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (not (= (f20 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f5 ?v1) f1) (=> (= (f22 ?v1 (* ?v0 ?v2)) f1) (or (= (f22 ?v1 ?v0) f1) (= (f22 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f5 ?v0) f1) (=> (= (f22 ?v0 (* ?v1 ?v2)) f1) (or (= (f22 ?v0 ?v1) f1) (= (f22 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f5 ?v1) f1) (= (f22 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f22 (f11 (f12 f13 ?v0) ?v1) (f11 (f12 f13 ?v2) ?v1)) f1) (=> (not (= ?v1 (f15 f16 0))) (= (f22 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f15 f16 0))) (= (= (f22 (f11 (f12 f13 ?v1) ?v0) (f11 (f12 f13 ?v2) ?v0)) f1) (= (f22 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f12 f13 (- 1)))) (let ((?v_1 (f11 ?v_0 ?v1)) (?v_2 (f11 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f20 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f12 f13 ?v0))) (=> (= (f22 (f11 ?v_0 ?v1) ?v2) f1) (=> (<= (f11 f23 ?v3) (f11 f23 ?v1)) (= (f22 (f11 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S5)) (=> (= (f22 ?v0 ?v1) f1) (=> (<= (f11 f23 ?v2) (f11 f23 ?v3)) (= (f22 (f11 (f12 f13 ?v0) ?v2) (f11 (f12 f13 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (=> (<= (f11 f23 ?v0) (f11 f23 ?v1)) (= (f22 (f11 ?v_0 ?v0) (f11 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f22 ?v0 ?v1) f1) (= (f22 (f11 (f12 f13 ?v0) ?v2) (f11 (f12 f13 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f20 ?v1 ?v2 ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f20 ?v1 ?v3 ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f6 f24 (f11 (f12 f13 ?v0) ?v1)) (f11 (f12 f13 (f6 f24 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f20 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f11 (f12 f13 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (= (f20 (f6 (f7 f8 ?v1) ?v0) (f11 (f12 f13 ?v1) (f15 f16 (f6 (f7 f25 (- ?v0 1)) 2))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f10 ?v0 ?v1) f1)) (= (f20 (f11 (f12 f13 ?v1) (f15 f16 (f6 (f7 f25 (- ?v0 1)) 2))) (- 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (= (f10 ?v0 ?v1) f1) (= (f20 (f11 (f12 f13 ?v1) (f15 f16 (f6 (f7 f25 (- ?v0 1)) 2))) 1 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f5 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (=> (not (= (f10 ?v0 ?v1) f1)) (not (= (f20 ?v2 (* ?v1 (f6 (f7 f26 ?v0) ?v2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int)) (=> (= (f5 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f6 (f7 f25 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f6 (f7 f25 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f6 (f7 f25 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 (f7 f26 ?v3) ?v0))) (=> (= (f20 (* ?v0 ?v1) ?v2 ?v3) f1) (= (f20 (* (* ?v_0 ?v0) ?v1) (* ?v_0 ?v2) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v1 (f6 (f7 f26 ?v2) ?v3)))) (=> (= (f20 ?v0 ?v_0 ?v2) f1) (= (f20 (* ?v0 ?v3) (* ?v_0 ?v3) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f20 ?v1 ?v2 ?v0) f1) (= (f20 (* ?v3 (f6 ?v_0 ?v1)) (* ?v3 (f6 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f20 ?v1 ?v2 ?v0) f1) (= (f20 (f6 ?v_0 ?v1) (f6 ?v_0 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f26 ?v0) ?v1) (f11 (f12 f13 ?v1) (f15 f16 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f6 (f7 f26 ?v0) ?v1))) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (= (f20 (* (* ?v_0 ?v1) ?v2) (* ?v_0 ?v3) ?v0) f1) (= (f20 ?v2 (* ?v3 ?v_0) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (* ?v2 ?v1))) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (= (f20 ?v_0 (* (* ?v3 (f6 (f7 f26 ?v0) ?v1)) ?v1) ?v0) f1) (= (f20 ?v_0 ?v3 ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (=> (= (f20 (f6 ?v_0 ?v1) (f6 ?v_0 ?v2) ?v0) f1) (= (f20 ?v1 ?v2 ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (=> (= (f20 ?v2 (* ?v3 (f6 ?v_0 ?v1)) ?v0) f1) (= (f20 ?v1 (* ?v3 (f6 ?v_0 ?v2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (=> (not (= (f20 ?v2 0 ?v0) f1)) (=> (not (= (f20 ?v3 0 ?v0) f1)) (=> (= (f20 (* ?v1 (f6 ?v_0 ?v3)) (* ?v1 (f6 ?v_0 ?v2)) ?v0) f1) (= (f20 ?v3 ?v2 ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f26 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (= (f20 (* (* ?v1 ?v_1) (f6 ?v_0 ?v_1)) ?v1 ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (= (f20 (* (f6 (f7 f26 ?v0) ?v1) ?v1) 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f26 ?v0))) (let ((?v_1 (f6 ?v_0 ?v1))) (let ((?v_2 (f6 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (= (f20 ?v_2 (* (* ?v1 ?v_1) ?v_2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f26 ?v0))) (=> (< 2 ?v0) (=> (= (f5 ?v0) f1) (=> (not (= (f20 ?v1 0 ?v0) f1)) (= (f20 (f6 ?v_0 (f6 ?v_0 ?v1)) ?v1 ?v0) f1)))))))
(assert (forall ((?v0 S5)) (= (f15 f16 (f11 f23 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f23 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f23 (f15 f16 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f6 (f7 f25 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f6 (f7 f27 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
