(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 () Int)
(declare-fun f5 () Int)
(declare-fun f6 (Int) S1)
(declare-fun f7 (S2 Int) Int)
(declare-fun f8 (S3 Int) S2)
(declare-fun f9 () S3)
(declare-fun f10 (S4 Int) S1)
(declare-fun f11 (Int) S4)
(declare-fun f12 () S5)
(declare-fun f13 (S6 Int) S5)
(declare-fun f14 () S6)
(declare-fun f15 (S7 S5) Int)
(declare-fun f16 () S7)
(declare-fun f17 (S8 Int) S4)
(declare-fun f18 (Int) S8)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (S9 Int) S7)
(declare-fun f22 () S9)
(declare-fun f23 (Int) S4)
(declare-fun f24 (S10 S11) Int)
(declare-fun f25 () S10)
(declare-fun f26 (Int Int) S11)
(declare-fun f27 () S2)
(declare-fun f28 () S3)
(declare-fun f29 () S2)
(declare-fun f30 () S3)
(assert (not (= f1 f2)))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 0))) f1)))
(assert (< 1 f5))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (= (f6 (+ (* 4 f4) 1)) f1))
(assert (= (f7 (f8 f9 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (* ?v0 ?v1)) f1)))))
(assert (= (f10 (f11 (+ (* 4 f4) 1)) (- 1)) f1))
(assert (= f12 (f13 f14 (- (f15 f16 (f13 f14 f5)) 1))))
(assert (= (f3 (* (+ (* 4 f4) 1) f5)) f1))
(assert (< f5 (+ (* 4 f4) 1)))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f10 (f11 ?v_0) (- 1)) f1)) (not (= (f7 (f8 f9 (- 1)) ?v_0) 1)))))
(assert (<= 1 f5))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f10 (f17 (f18 f19) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f10 (f17 (f18 f19) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f10 (f17 (f18 f19) ?v0) ?v_0) f1))) false))) false))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f20) (and (< f20 ?v_0) (= (f10 (f17 (f18 f19) f20) ?v_0) f1)))))
(assert (= (+ (f15 (f21 f22 f20) (f13 f14 2)) 1) (* (+ (* 4 f4) 1) f5)))
(assert (= (f10 (f17 (f18 (f15 (f21 f22 f19) (f13 f14 2))) (- 1)) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f15 (f21 f22 f20) (f13 f14 2)) 1) (* (+ (* 4 f4) 1) ?v0)) false)) false))
(assert (< 0 (f15 f16 f12)))
(assert (let ((?v_0 (f15 (f21 f22 f20) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f13 f14 (- (f15 f16 (f13 f14 f5)) 1))) (=> (< 0 (f15 f16 ?v0)) false))) false))
(assert (= (f10 (f17 (f18 (f15 (f21 f22 f20) (f13 f14 2))) (- 1)) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f10 (f17 (f18 (f15 (f21 f22 ?v0) (f13 f14 2))) (- 1)) (+ (* 4 f4) 1)) f1) false)) false))
(assert (let ((?v_0 (f13 f14 2))) (= (f10 (f17 (f18 (f15 (f21 f22 f20) ?v_0)) (f15 (f21 f22 f19) ?v_0)) (+ (* 4 f4) 1)) f1)))
(assert (=> (= f5 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f15 (f21 f22 ?v0) ?v_0) (f15 (f21 f22 ?v1) ?v_0)) (+ (* 4 f4) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f6 ?v_0) f1) (= (f7 (f8 f9 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f7 (f8 f9 ?v0) ?v1) (ite (= (f10 (f17 (f18 ?v0) 0) ?v1) f1) 0 (ite (= (f10 (f11 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f11 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f10 (f17 (f18 (f15 (f21 f22 ?v2) (f13 f14 2))) ?v1) ?v0) f1)))))
(assert (= (f10 (f23 (+ (* 4 f4) 1)) (- (f15 (f21 f22 f20) (f13 f14 2)) (- 1))) f1))
(assert (= (f10 (f23 (+ (* 4 f4) 1)) (+ (f15 (f21 f22 f20) (f13 f14 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0) f1) (=> (not (= (f10 (f17 (f18 ?v1) 0) ?v0) f1)) (=> (not (= (f10 (f17 (f18 ?v2) 0) ?v0) f1)) (not (= (f10 (f17 (f18 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f10 (f17 (f18 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f10 (f17 (f18 ?v1) 0) ?v0) f1)) (not (= (f10 (f17 (f18 ?v2) 0) ?v0) f1))) (not (= (f10 (f17 (f18 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f6 ?v0) f1) (=> (< 0 ?v1) (=> (= (f10 (f17 (f18 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f10 (f17 (f18 ?v1) 0) ?v0) f1) (= (f10 (f17 (f18 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 ?v1))) (=> (= (f6 ?v0) f1) (=> (< 0 ?v1) (=> (= (f10 (f17 (f18 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f10 (f17 ?v_0 1) ?v0) f1) (= (f10 (f17 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 (- 1)))) (let ((?v_1 (f15 ?v_0 ?v1)) (?v_2 (f15 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f10 (f17 (f18 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f23 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (= (f10 (f23 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f17 (f18 ?v0) 0) ?v1) f1) (= (f10 (f23 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f17 (f18 ?v0) 0) ?v1) f1) (= (f10 (f23 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 ?v1))) (=> (< 0 (f15 f16 ?v0)) (=> (= (f10 ?v_0 ?v2) f1) (= (f10 ?v_0 (f15 (f21 f22 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 ?v1))) (=> (<= 0 ?v0) (=> (= (f6 ?v1) f1) (=> (= (f10 ?v_0 (* ?v0 ?v2)) f1) (or (= (f10 ?v_0 ?v0) f1) (= (f10 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 ?v0))) (=> (= (f6 ?v0) f1) (=> (= (f10 ?v_0 (* ?v1 ?v2)) f1) (or (= (f10 ?v_0 ?v1) f1) (= (f10 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f6 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f10 (f23 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f23 ?v0))) (=> (= (f6 ?v0) f1) (=> (= (f10 ?v_0 (f15 (f21 f22 ?v1) ?v2)) f1) (=> (< 0 (f15 f16 ?v2)) (= (f10 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (=> (= (f10 (f17 (f18 ?v3) ?v4) ?v2) f1) (= (f10 (f17 (f18 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (=> (= (f10 (f17 (f18 ?v3) ?v4) ?v2) f1) (= (f10 (f17 (f18 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (=> (= (f10 (f17 (f18 ?v3) ?v4) ?v2) f1) (= (f10 (f17 (f18 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f18 ?v0))) (=> (= (f10 (f17 ?v_0 ?v1) ?v2) f1) (=> (= (f10 (f17 (f18 ?v1) ?v3) ?v2) f1) (= (f10 (f17 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f18 ?v0))) (=> (= (f10 (f17 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f10 (f17 (f18 ?v3) ?v4) ?v2) f1) (= (f10 (f17 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (= (f10 (f17 (f18 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (= (f10 (f17 (f18 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (= (f10 (f17 (f18 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f18 ?v3))) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (= (= (f10 (f17 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f10 (f17 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f18 ?v3))) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (= (= (f10 (f17 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f10 (f17 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 ?v1))) (=> (< 2 ?v0) (=> (= (f10 (f17 ?v_0 (- 1)) ?v0) f1) (not (= (f10 (f17 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f10 (f17 (f18 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f10 (f17 (f18 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f10 (f17 (f18 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f10 (f17 (f18 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f10 (f17 (f18 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f10 (f17 (f18 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f17 (f18 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f17 (f18 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f17 (f18 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int)) (= (f10 (f17 (f18 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 (f18 ?v0) ?v1))) (= (= (f10 ?v_0 (- ?v2)) f1) (= (f10 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (= (f10 (f17 (f18 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f17 (f18 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f15 (f21 f22 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S5)) (=> (= (f10 (f17 (f18 ?v0) ?v1) ?v2) f1) (= (f10 (f17 (f18 (f15 (f21 f22 ?v0) ?v3)) (f15 (f21 f22 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 ?v0) f1) (=> (not (= (f10 (f23 ?v0) ?v1) f1)) (= (f10 (f17 (f18 (f15 (f21 f22 ?v1) (f13 f14 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f23 ?v0))) (=> (= (f6 ?v0) f1) (=> (= (f10 ?v_0 (f15 (f21 f22 ?v1) ?v2)) f1) (= (f10 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f23 (f15 (f21 f22 ?v0) ?v2)))) (=> (= (f6 ?v0) f1) (=> (not (= (f10 (f23 ?v0) ?v1) f1)) (=> (= (f10 ?v_0 (* ?v3 ?v1)) f1) (= (f10 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f23 (f15 (f21 f22 ?v0) ?v2)))) (=> (= (f6 ?v0) f1) (=> (not (= (f10 (f23 ?v0) ?v1) f1)) (=> (= (f10 ?v_0 (* ?v1 ?v3)) f1) (= (f10 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f10 (f17 (f18 ?v0) 0) ?v1) f1)) (=> (= (f10 (f17 (f18 (f15 (f21 f22 ?v2) (f13 f14 2))) ?v0) ?v1) f1) (not (= (f10 (f23 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f10 (f23 (f15 (f21 f22 ?v0) ?v1)) (f15 (f21 f22 ?v2) ?v1)) f1) (=> (not (= ?v1 (f13 f14 0))) (= (f10 (f23 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f13 f14 0))) (= (= (f10 (f23 (f15 (f21 f22 ?v1) ?v0)) (f15 (f21 f22 ?v2) ?v0)) f1) (= (f10 (f23 ?v1) ?v2) f1)))))
(assert (= (f24 f25 (f26 f20 1)) (* (+ (* 4 f4) 1) f5)))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f21 f22 ?v0))) (=> (= (f10 (f23 (f15 ?v_0 ?v1)) ?v2) f1) (=> (<= (f15 f16 ?v3) (f15 f16 ?v1)) (= (f10 (f23 (f15 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f24 f25 (f26 ?v0 ?v1)) (f24 f25 (f26 ?v2 ?v3))) (f24 f25 (f26 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f7 f27 (f15 (f21 f22 ?v0) ?v1)) (f15 (f21 f22 (f7 f27 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f15 (f21 f22 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 Int)) (<= ?v0 (f15 (f21 f22 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f15 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f15 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f15 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f15 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (* ?v0 (f15 ?v_0 (f13 f14 2))) (f15 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 3))) (= (f15 (f21 f22 (- ?v0)) ?v_0) (- (f15 (f21 f22 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f15 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (f15 (f21 f22 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f15 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f15 (f21 f22 (- ?v0 ?v1)) ?v_0) (+ (- (f15 (f21 f22 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f15 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f21 f22 ?v0)) (?v_3 (f21 f22 ?v1))) (= (f15 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f15 ?v_1 ?v_0) (* (* 3 (f15 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f15 ?v_3 ?v_2))) (f15 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f21 f22 ?v1)) (?v_1 (f21 f22 ?v0))) (= (f15 (f21 f22 (- ?v0 ?v1)) ?v_0) (- (+ (- (f15 ?v_1 ?v_0) (* (* 3 (f15 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f15 ?v_3 ?v_2))) (f15 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f15 (f21 f22 ?v0) ?v_0) (f15 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2)) (?v_1 (f21 f22 ?v0))) (= (f15 (f21 f22 (f15 ?v_1 ?v_0)) ?v_0) (f15 ?v_1 (f13 f14 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (= (f15 (f21 f22 ?v0) ?v_0) (f15 (f21 f22 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 ?v1)) (?v_1 (f13 f14 ?v0))) (=> (< 0 ?v0) (= (f15 ?v_0 ?v_1) (* ?v1 (f15 ?v_0 (f13 f14 (- (f15 f16 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (=> (= (f15 (f21 f22 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f6 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f10 (f23 ?v0) ?v1) f1) (= (f10 (f23 (f15 (f21 f22 ?v0) ?v2)) (f15 (f21 f22 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (<= (f15 f16 ?v0) (f15 f16 ?v1)) (= (f10 (f23 (f15 ?v_0 ?v0)) (f15 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S5)) (=> (= (f10 (f23 ?v0) ?v1) f1) (=> (<= (f15 f16 ?v2) (f15 f16 ?v3)) (= (f10 (f23 (f15 (f21 f22 ?v0) ?v2)) (f15 (f21 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f3 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f24 f25 (f26 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f6 ?v1) f1) (= (f10 (f23 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f10 (f17 (f18 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f10 (f17 (f18 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f6 ?v0) f1) (= (f10 (f17 (f18 (f7 (f8 f9 ?v1) ?v0)) (f15 (f21 f22 ?v1) (f13 f14 (f7 (f8 f28 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f6 ?v0) f1) (=> (not (= (f10 (f17 (f18 ?v1) 0) ?v0) f1)) (=> (not (= (f10 (f11 ?v0) ?v1) f1)) (= (f10 (f17 (f18 (f15 (f21 f22 ?v1) (f13 f14 (f7 (f8 f28 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f6 ?v0) f1) (=> (not (= (f10 (f17 (f18 ?v1) 0) ?v0) f1)) (=> (= (f10 (f11 ?v0) ?v1) f1) (= (f10 (f17 (f18 (f15 (f21 f22 ?v1) (f13 f14 (f7 (f8 f28 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f7 (f8 f28 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f7 (f8 f28 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f7 (f8 f28 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f6 ?v0) f1) (=> (= (f10 (f17 (f18 ?v1) 0) ?v0) f1) (= (f10 (f17 (f18 0) (f15 (f21 f22 ?v1) (f13 f14 (f7 (f8 f28 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f6 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f10 (f17 (f18 ?v1) 0) ?v0) f1)) (=> (not (= (f10 (f11 ?v0) ?v1) f1)) (= (f10 (f17 (f18 (f7 f29 ?v_0)) (f15 (f21 f22 ?v1) (f13 f14 (f7 (f8 f28 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f10 (f23 ?v0) ?v1) f1) (= (f15 (f21 f22 (f7 (f8 f28 ?v1) ?v0)) ?v2) (f7 (f8 f28 (f15 (f21 f22 ?v1) ?v2)) (f15 (f21 f22 ?v0) ?v2))))))
(assert (forall ((?v0 S5) (?v1 Int)) (let ((?v_1 (f15 f16 ?v0)) (?v_0 (f21 f22 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f7 (f8 f28 (f15 ?v_0 ?v0)) ?v1) (f15 ?v_0 (f13 f14 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f23 ?v0) ?v1) f1) (= (* ?v0 (f7 (f8 f28 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 (f8 f28 ?v1) ?v0))) (=> (= (f10 (f23 ?v0) ?v1) f1) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f7 (f8 f28 (ite (< ?v1 0) (- ?v1) ?v1)) (ite (< ?v0 0) (- ?v0) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f13 f14 (f7 (f8 f28 (f15 f16 (f13 f14 ?v0))) (f15 f16 (f13 f14 ?v1)))) (f13 f14 (f7 (f8 f28 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f13 f14 (f7 (f8 f28 ?v0) ?v1)) (f13 f14 (f7 (f8 f28 (f15 f16 (f13 f14 ?v0))) (f15 f16 (f13 f14 ?v1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 (f8 f28 (f15 f16 ?v0)) (f15 f16 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 (f8 f28 (f15 f16 ?v0)) (f15 f16 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S4) (?v1 Int) (?v2 Int)) (= (= (f10 ?v0 (f7 (f8 f28 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f10 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f10 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (* ?v2 ?v3) ?v4)))) (= (f10 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int)) (= (f7 (f8 f28 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f7 (f8 f28 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 S5)) (= (f13 f14 (f15 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f15 f16 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f15 f16 (f13 f14 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f7 (f8 f28 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f7 (f8 f30 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
