(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () S2)
(declare-fun f12 () S3)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 (Int) S1)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 (Int) S1)
(declare-fun f20 (S6 Int) Int)
(declare-fun f21 (S7 Int) S6)
(declare-fun f22 () S7)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 () S3)
(declare-fun f25 () Int)
(declare-fun f26 (Int Int Int) S1)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (S8 S9) Int)
(declare-fun f30 () S8)
(declare-fun f31 (Int Int) S9)
(declare-fun f32 () S6)
(declare-fun f33 () S7)
(declare-fun f34 () S7)
(assert (not (= f1 f2)))
(assert (let ((?v_5 (* 2 f9)) (?v_1 (+ 1 (f3 f11 f12)))) (let ((?v_3 (* f13 ?v_1)) (?v_4 (* 2 f6)) (?v_2 (* f10 ?v_1)) (?v_0 (f7 f8 2))) (let ((?v_6 (f3 (f4 f5 ?v_1) ?v_0))) (not (= (+ (+ (- (- (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* ?v_4 ?v_2)) (* ?v_5 ?v_3)) (f3 (f4 f5 ?v_2) ?v_0)) (f3 (f4 f5 ?v_3) ?v_0)) (+ (+ (- (- (* ?v_1 (+ (* 4 f14) 1)) (* ?v_1 (* ?v_4 f10))) (* ?v_1 (* ?v_5 f13))) (* ?v_6 (f3 (f4 f5 f10) ?v_0))) (* ?v_6 (f3 (f4 f5 f13) ?v_0)))))))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ (* 4 f14) 1) (+ 1 (f3 f11 f12))))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (let ((?v_3 (* f13 ?v_0)) (?v_2 (* f10 ?v_0)) (?v_1 (f7 f8 2))) (= (+ (f3 (f4 f5 (- f6 ?v_2)) ?v_1) (f3 (f4 f5 (- f9 ?v_3)) ?v_1)) (+ (+ (- (- (+ (f3 (f4 f5 f6) ?v_1) (f3 (f4 f5 f9) ?v_1)) (* (* 2 f6) ?v_2)) (* (* 2 f9) ?v_3)) (f3 (f4 f5 ?v_2) ?v_1)) (f3 (f4 f5 ?v_3) ?v_1))))))
(assert (< 1 f15))
(assert (< 0 (f3 f11 f12)))
(assert (not (= (f16 (* (+ (* 4 f14) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f14) 1)))
(assert (< 0 (+ 1 (f3 f11 f12))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ (* 4 f14) 1) (+ 1 (f3 f11 f12))))))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f14) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f16 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (let ((?v_3 (* f13 ?v_0)) (?v_2 (* f10 ?v_0)) (?v_1 (f7 f8 2))) (= (+ (f3 (f4 f5 (- f6 ?v_2)) ?v_1) (f3 (f4 f5 (- f9 ?v_3)) ?v_1)) (+ (+ (- (- (+ (f3 (f4 f5 f6) ?v_1) (f3 (f4 f5 f9) ?v_1)) (* (* 2 f6) ?v_2)) (* (* 2 f9) ?v_3)) (f3 (f4 f5 ?v_2) ?v_1)) (f3 (f4 f5 ?v_3) ?v_1))))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f17 (- f6 (* f10 ?v_0))) (<= (* 2 (ite (< f17 0) (- f17) f17)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f18 (- f9 (* f13 ?v_0))) (<= (* 2 (ite (< f18 0) (- f18) f18)) ?v_0))))
(assert (= (f19 (+ (* 4 f14) 1)) f1))
(assert (= (f20 (f21 f22 (- 1)) (+ (* 4 f14) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f6 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f9 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f14) 1) (+ 1 (f3 f11 f12)))) false))) false))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f14) 1))) (and (< ?v_1 ?v_0) (= (f16 (* ?v_0 ?v_1)) f1))))
(assert (= (f23 (+ (* 4 f14) 1) (- 1)) f1))
(assert (= f24 (f7 f8 (- (f3 f11 (f7 f8 f15)) 1))))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f17) ?v_0) (f3 (f4 f5 f18) ?v_0)) (+ (f3 (f4 f5 (- f6 (* f10 ?v_1))) ?v_0) (f3 (f4 f5 (- f9 (* f13 ?v_1))) ?v_0)))))
(assert (let ((?v_1 (+ 1 (f3 f11 f12)))) (let ((?v_3 (* f13 ?v_1)) (?v_2 (* f10 ?v_1)) (?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f17) ?v_0) (f3 (f4 f5 f18) ?v_0)) (+ (+ (- (- (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (* 2 f6) ?v_2)) (* (* 2 f9) ?v_3)) (f3 (f4 f5 ?v_2) ?v_0)) (f3 (f4 f5 ?v_3) ?v_0))))))
(assert (< f15 (+ (* 4 f14) 1)))
(assert (= (+ (f3 (f4 f5 f25) (f7 f8 2)) 1) (* (+ (* 4 f14) 1) f15)))
(assert (= (f26 (f3 (f4 f5 f27) (f7 f8 2)) (- 1) (+ (* 4 f14) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f25) (f7 f8 2)) 1) (* (+ (* 4 f14) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f3 (f4 f5 f25) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f14) 1))) (=> (not (= (f23 ?v_0 (- 1)) f1)) (not (= (f20 (f21 f22 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f26 (f3 (f4 f5 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f14) 1)) f1) false)) false))
(assert (=> (= f15 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f14) 1))))))
(assert (< 0 (f3 f11 f24)))
(assert (<= 1 f15))
(assert (let ((?v_0 (+ (* 4 f14) 1))) (and (<= 0 f25) (and (< f25 ?v_0) (= (f26 f27 f25 ?v_0) f1)))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f11 (f7 f8 f15)) 1))) (=> (< 0 (f3 f11 ?v0)) false))) false))
(assert (= (f16 (* (+ (* 4 f14) 1) f15)) f1))
(assert (= (f26 (f3 (f4 f5 f25) (f7 f8 2)) (- 1) (+ (* 4 f14) 1)) f1))
(assert (let ((?v_0 (f7 f8 2))) (= (f26 (f3 (f4 f5 f25) ?v_0) (f3 (f4 f5 f27) ?v_0) (+ (* 4 f14) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f14) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f26 f27 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f14) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f26 f27 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f26 f27 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f19 ?v_0) f1) (= (f20 (f21 f22 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (= (f16 ?v1) f1) (= (f16 (* ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f20 (f21 f22 ?v0) ?v1) (ite (= (f26 ?v0 0 ?v1) f1) 0 (ite (= (f23 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f26 (f3 (f4 f5 ?v2) (f7 f8 2)) ?v1 ?v0) f1)))))
(assert (= (f28 (+ (* 4 f14) 1) (- (f3 (f4 f5 f25) (f7 f8 2)) (- 1))) f1))
(assert (= (f28 (+ (* 4 f14) 1) (+ (f3 (f4 f5 f25) (f7 f8 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f19 ?v0) f1) (=> (not (= (f26 ?v1 0 ?v0) f1)) (=> (not (= (f26 ?v2 0 ?v0) f1)) (not (= (f26 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f26 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f19 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f26 ?v1 0 ?v0) f1)) (not (= (f26 ?v2 0 ?v0) f1))) (not (= (f26 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f19 ?v0) f1) (=> (< 0 ?v1) (=> (= (f26 (* ?v1 ?v2) 0 ?v0) f1) (or (= (f26 ?v1 0 ?v0) f1) (= (f26 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0) f1) (=> (< 0 ?v1) (=> (= (f26 (* ?v1 ?v1) 1 ?v0) f1) (or (= (f26 ?v1 1 ?v0) f1) (= (f26 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f26 ?v0 ?v1 ?v2) f1) (= (f28 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f26 ?v0 0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f26 ?v0 0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f11 ?v0)) (=> (= (f28 ?v1 ?v2) f1) (= (f28 ?v1 (f3 (f4 f5 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f19 ?v1) f1) (=> (= (f28 ?v1 (* ?v0 ?v2)) f1) (or (= (f28 ?v1 ?v0) f1) (= (f28 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f19 ?v0) f1) (=> (= (f28 ?v0 (* ?v1 ?v2)) f1) (or (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f19 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f28 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f19 ?v0) f1) (=> (= (f28 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f11 ?v2)) (= (f28 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (=> (= (f26 ?v3 ?v4 ?v2) f1) (= (f26 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (=> (= (f26 ?v3 ?v4 ?v2) f1) (= (f26 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (=> (= (f26 ?v3 ?v4 ?v2) f1) (= (f26 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (=> (= (f26 ?v1 ?v3 ?v2) f1) (= (f26 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f26 ?v3 ?v4 ?v2) f1) (= (f26 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (= (f26 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (= (f26 (* ?v0 ?v3) (* ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (= (f26 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (= (= (f26 ?v3 (* ?v4 ?v0) ?v2) f1) (= (f26 ?v3 (* ?v4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (= (= (f26 ?v3 (* ?v0 ?v4) ?v2) f1) (= (f26 ?v3 (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f26 ?v1 (- 1) ?v0) f1) (not (= (f26 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f26 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f26 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f26 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f26 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f26 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f26 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f26 (* ?v0 ?v1) (* ?v2 ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int)) (= (f26 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f26 ?v0 ?v1 (- ?v2)) f1) (= (f26 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f26 ?v0 ?v1 ?v2) f1) (= (f26 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f26 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f26 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f26 ?v0 ?v1 ?v2) f1) (= (f26 (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f19 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (= (f26 (f3 (f4 f5 ?v1) (f7 f8 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f19 ?v0) f1) (=> (= (f28 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f19 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (* ?v3 ?v1)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f19 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (* ?v1 ?v3)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f26 ?v0 0 ?v1) f1)) (=> (= (f26 (f3 (f4 f5 ?v2) (f7 f8 2)) ?v0 ?v1) f1) (not (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f28 (f3 (f4 f5 ?v1) ?v0) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f28 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f28 (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f28 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f26 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f26 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (* ?v1 (f3 ?v_0 (f7 f8 (- (f3 f11 ?v_1) 1)))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f4 f5 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (* ?v0 (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (= (f19 2) f1))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f19 ?v1) f1) (= (f28 ?v1 ?v0) f1))))))
(assert (= (f29 f30 (f31 f25 1)) (* (+ (* 4 f14) 1) f15)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f28 ?v0 ?v1) f1) (= (f28 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (<= (f3 f11 ?v0) (f3 f11 ?v1)) (= (f28 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f28 ?v0 ?v1) f1) (=> (<= (f3 f11 ?v2) (f3 f11 ?v3)) (= (f28 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f29 f30 (f31 ?v0 ?v1)) (f29 f30 (f31 ?v2 ?v3))) (f29 f30 (f31 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f20 f32 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f20 f32 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f28 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f11 ?v3) (f3 f11 ?v1)) (= (f28 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f16 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f29 f30 (f31 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f26 ?v1 ?v2 ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f26 ?v1 ?v3 ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f19 ?v0) f1) (= (f26 (f20 (f21 f22 ?v1) ?v0) (f3 (f4 f5 ?v1) (f7 f8 (f20 (f21 f33 (- ?v0 1)) 2))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f19 ?v0) f1) (=> (not (= (f26 ?v1 0 ?v0) f1)) (=> (= (f23 ?v0 ?v1) f1) (= (f26 (f3 (f4 f5 ?v1) (f7 f8 (f20 (f21 f33 (- ?v0 1)) 2))) 1 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f20 (f21 f33 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f20 (f21 f33 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f20 (f21 f33 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f11 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f11 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f11 (f7 f8 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f20 (f21 f33 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f20 (f21 f34 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
