(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () S2)
(declare-fun f11 () S3)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 (Int) S1)
(declare-fun f19 (Int) S1)
(declare-fun f20 (S6 Int) Int)
(declare-fun f21 (S7 Int) S6)
(declare-fun f22 () S7)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 () S3)
(declare-fun f25 () Int)
(declare-fun f26 (Int Int Int) S1)
(declare-fun f27 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f10 f11)))) (not (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* ?v_1 (+ (- (- (+ (* 4 f12) 1) (* (* 2 f13) f14)) (* (* 2 f15) f16)) (* ?v_1 (+ (f3 (f4 f5 f14) ?v_0) (f3 (f4 f5 f16) ?v_0)))))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f10 f11)))) (let ((?v_2 (f3 (f4 f5 ?v_1) ?v_0))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (+ (- (- (* ?v_1 (+ (* 4 f12) 1)) (* ?v_1 (* (* 2 f13) f14))) (* ?v_1 (* (* 2 f15) f16))) (* ?v_2 (f3 (f4 f5 f14) ?v_0))) (* ?v_2 (f3 (f4 f5 f16) ?v_0)))))))
(assert (< 1 f17))
(assert (< 0 (f3 f10 f11)))
(assert (not (= (f18 (* (+ (* 4 f12) 1) (+ 1 0))) f1)))
(assert (< 0 (+ 1 (f3 f10 f11))))
(assert (< 0 (+ (* 4 f12) 1)))
(assert (let ((?v_1 (+ 1 (f3 f10 f11))) (?v_0 (+ (* 4 f12) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f18 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f3 f10 f11)))) (and (= f6 (- f13 (* f14 ?v_0))) (<= (* 2 (ite (< f6 0) (- f6) f6)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f10 f11)))) (and (= f9 (- f15 (* f16 ?v_0))) (<= (* 2 (ite (< f9 0) (- f9) f9)) ?v_0))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0)) (* (+ (* 4 f12) 1) (+ 1 (f3 f10 f11))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f10 f11)))) (let ((?v_2 (f3 (f4 f5 ?v_1) ?v_0))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (+ (- (- (* ?v_1 (+ (* 4 f12) 1)) (* ?v_1 (* (* 2 f13) f14))) (* ?v_1 (* (* 2 f15) f16))) (* ?v_2 (f3 (f4 f5 f14) ?v_0))) (* ?v_2 (f3 (f4 f5 f16) ?v_0)))))))
(assert (= (f19 (+ (* 4 f12) 1)) f1))
(assert (= (f20 (f21 f22 (- 1)) (+ (* 4 f12) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f10 f11)))) (=> (and (= ?v1 (- f13 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f10 f11)))) (=> (and (= ?v1 (- f15 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f12) 1) (+ 1 (f3 f10 f11)))) false))) false))
(assert (let ((?v_1 (f7 f8 2)) (?v_0 (+ 1 (f3 f10 f11)))) (let ((?v_2 (* f14 ?v_0)) (?v_3 (* f16 ?v_0))) (= (+ (f3 (f4 f5 (- f13 ?v_2)) ?v_1) (f3 (f4 f5 (- f15 ?v_3)) ?v_1)) (+ (+ (- (- (+ (f3 (f4 f5 f13) ?v_1) (f3 (f4 f5 f15) ?v_1)) (* (* 2 f13) ?v_2)) (* (* 2 f15) ?v_3)) (f3 (f4 f5 ?v_2) ?v_1)) (f3 (f4 f5 ?v_3) ?v_1))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f10 f11))) (?v_5 (* 2 f15)) (?v_4 (* 2 f13))) (let ((?v_6 (f3 (f4 f5 ?v_1) ?v_0)) (?v_2 (* f14 ?v_1)) (?v_3 (* f16 ?v_1))) (= (+ (+ (- (- (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0)) (* ?v_4 ?v_2)) (* ?v_5 ?v_3)) (f3 (f4 f5 ?v_2) ?v_0)) (f3 (f4 f5 ?v_3) ?v_0)) (+ (+ (- (- (* ?v_1 (+ (* 4 f12) 1)) (* ?v_1 (* ?v_4 f14))) (* ?v_1 (* ?v_5 f16))) (* ?v_6 (f3 (f4 f5 f14) ?v_0))) (* ?v_6 (f3 (f4 f5 f16) ?v_0)))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f10 f11)))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (f3 (f4 f5 (- f13 (* f14 ?v_1))) ?v_0) (f3 (f4 f5 (- f15 (* f16 ?v_1))) ?v_0)))))
(assert (let ((?v_1 (+ 1 (f3 f10 f11))) (?v_0 (+ (* 4 f12) 1))) (and (< ?v_1 ?v_0) (= (f18 (* ?v_0 ?v_1)) f1))))
(assert (= (f23 (+ (* 4 f12) 1) (- 1)) f1))
(assert (= f24 (f7 f8 (- (f3 f10 (f7 f8 f17)) 1))))
(assert (< f17 (+ (* 4 f12) 1)))
(assert (= (+ (f3 (f4 f5 f25) (f7 f8 2)) 1) (* (+ (* 4 f12) 1) f17)))
(assert (= (f26 (f3 (f4 f5 f27) (f7 f8 2)) (- 1) (+ (* 4 f12) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f25) (f7 f8 2)) 1) (* (+ (* 4 f12) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f3 (f4 f5 f25) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f12) 1))) (=> (not (= (f23 ?v_0 (- 1)) f1)) (not (= (f20 (f21 f22 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f26 (f3 (f4 f5 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f12) 1)) f1) false)) false))
(assert (=> (= f17 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f12) 1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (< 0 (f3 f10 f24)))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f10 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f10 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
