(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 () Int)
(declare-fun f8 () S3)
(declare-fun f9 (S4 Int) S3)
(declare-fun f10 () S4)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 (S5 Int) S2)
(declare-fun f18 () S5)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 (Int) S1)
(declare-fun f22 (S6 Int) Int)
(declare-fun f23 (S7 Int) S6)
(declare-fun f24 () S7)
(declare-fun f25 () Int)
(declare-fun f26 (Int Int) S1)
(declare-fun f27 (Int Int) S1)
(declare-fun f28 (Int Int Int) S1)
(declare-fun f29 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (not (< (* ?v_0 (- (* 2 ?v_0) (* 4 f6))) (* ?v_0 0)))))
(assert (< (- (* 2 (+ 1 (f3 f4 f5))) (* 4 f6)) 0))
(assert (< 0 (+ 1 (f3 f4 f5))))
(assert (< 1 f7))
(assert (< 0 (+ 1 (f3 f4 f5))))
(assert (< 0 (f3 f4 f5)))
(assert (< (- (* 2 (+ 1 (f3 f4 f5))) (* 4 f6)) 0))
(assert (not (< f6 (+ 1 (f3 f4 f5)))))
(assert (<= (- (+ 1 (f3 f4 f5)) f6) 0))
(assert (<= (- (* 4 (+ 1 (f3 f4 f5))) (* 4 f6)) 0))
(assert (= f8 (f9 f10 (- (f3 f4 (f9 f10 f7)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f11 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f12 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f13 (- f11 (* f14 ?v_0))) (<= (* 2 (ite (< f13 0) (- f13) f13)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f15 (- f12 (* f16 ?v_0))) (<= (* 2 (ite (< f15 0) (- f15) f15)) ?v_0))))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f17 f18 f13) ?v_0) (f3 (f17 f18 f15) ?v_0)) (* (+ 1 (f3 f4 f5)) f6))))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f19) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (* ?v_0 ?v_1)) f1))))))
(assert (<= 1 f7))
(assert (let ((?v_1 (+ 1 (f3 f4 f5))) (?v_0 (+ (* 4 f19) 1))) (and (< ?v_1 ?v_0) (= (f20 (* ?v_0 ?v_1)) f1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f3 (f17 f18 ?v0) ?v_0) (f3 (f17 f18 ?v1) ?v_0)) (* (+ (* 4 f19) 1) (+ 1 (f3 f4 f5)))) false))) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f3 (f17 f18 f13) ?v_0) (f3 (f17 f18 f15) ?v_0)) (* (+ 1 (f3 f4 f5)) ?v0)) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f17 f18 f11) ?v_0) (f3 (f17 f18 f12) ?v_0)) (* (+ (* 4 f19) 1) (+ 1 (f3 f4 f5))))))
(assert (< 0 (f3 f4 f8)))
(assert (not (= (f20 (* (+ (* 4 f19) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f19) 1)))
(assert (< f7 (+ (* 4 f19) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f9 f10 (- (f3 f4 (f9 f10 f7)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (= (f20 (* (+ (* 4 f19) 1) f7)) f1))
(assert (= (f21 (+ (* 4 f19) 1)) f1))
(assert (= (f22 (f23 f24 (- 1)) (+ (* 4 f19) 1)) 1))
(assert (= (+ (f3 (f17 f18 f25) (f9 f10 2)) 1) (* (+ (* 4 f19) 1) f7)))
(assert (=> (= f7 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f17 f18 ?v0) ?v_0) (f3 (f17 f18 ?v1) ?v_0)) (+ (* 4 f19) 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (= (f20 ?v1) f1) (= (f20 (* ?v0 ?v1)) f1)))))
(assert (= (f26 (+ (* 4 f19) 1) (- 1)) f1))
(assert (let ((?v_0 (f9 f10 2))) (= (f27 (+ 1 (f3 f4 f5)) (+ (f3 (f17 f18 f13) ?v_0) (f3 (f17 f18 f15) ?v_0))) f1)))
(assert (= (f28 (f3 (f17 f18 f29) (f9 f10 2)) (- 1) (+ (* 4 f19) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f17 f18 f25) (f9 f10 2)) 1) (* (+ (* 4 f19) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f3 (f17 f18 f25) (f9 f10 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (=> (not (= (f26 ?v_0 (- 1)) f1)) (not (= (f22 (f23 f24 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f28 (f3 (f17 f18 ?v0) (f9 f10 2)) (- 1) (+ (* 4 f19) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f17 f18 ?v0) (f9 f10 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f9 f10 2))) (let ((?v_0 (f3 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (and (<= 0 f25) (and (< f25 ?v_0) (= (f28 f29 f25 ?v_0) f1)))))
(assert (= (f28 (f3 (f17 f18 f25) (f9 f10 2)) (- 1) (+ (* 4 f19) 1)) f1))
(assert (= (f27 (+ (* 4 f19) 1) (- (f3 (f17 f18 f25) (f9 f10 2)) (- 1))) f1))
(assert (= (f27 (+ (* 4 f19) 1) (+ (f3 (f17 f18 f25) (f9 f10 2)) 1)) f1))
(assert (let ((?v_0 (f9 f10 2))) (= (f28 (f3 (f17 f18 f25) ?v_0) (f3 (f17 f18 f29) ?v_0) (+ (* 4 f19) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f29 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f29 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f28 f29 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f17 f18 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (=> (= (f27 ?v_0 (* ?v1 ?v3)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f17 f18 ?v0) ?v2))) (=> (= (f21 ?v0) f1) (=> (not (= (f27 ?v0 ?v1) f1)) (=> (= (f27 ?v_0 (* ?v3 ?v1)) f1) (= (f27 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f21 ?v0) f1) (=> (= (f27 ?v0 (f3 (f17 f18 ?v1) ?v2)) f1) (= (f27 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 (* ?v0 ?v1) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f27 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f27 ?v0 (- ?v1 ?v2)) f1) (=> (= (f27 ?v0 ?v2) f1) (= (f27 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 ?v1) f1) (=> (= (f27 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f27 ?v0 ?v1) f1) (= (= (f27 ?v0 (+ ?v2 ?v3)) f1) (= (f27 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f27 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f27 ?v0 ?v1) f1) (=> (= (f27 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f21 ?v_0) f1) (= (f22 (f23 f24 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f27 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f27 (* ?v0 ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f27 ?v0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f27 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (= (= (f27 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f21 2) f1))
(assert (forall ((?v0 S3)) (= (f9 f10 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
