(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 (S5 Int) S3)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () S3)
(declare-fun f19 (Int Int) S1)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 (Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f8 f9 2))) (let ((?v_1 (f3 (f4 f5 (+ 1 (f3 f6 f7))) ?v_0))) (not (<= (+ ?v_1 (f3 (f4 f5 (* 2 (ite (< f10 0) (- f10) f10))) ?v_0)) (+ ?v_1 ?v_1))))))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (and (= f10 (- f11 (* f12 ?v_0))) (<= (* 2 (ite (< f10 0) (- f10) f10)) ?v_0))))
(assert (and (<= 0 (* 2 (ite (< f13 0) (- f13) f13))) (<= 0 (* 2 (ite (< f10 0) (- f10) f10)))))
(assert (< 1 f14))
(assert (and (<= 0 (* 2 (ite (< f13 0) (- f13) f13))) (<= 0 (* 2 (ite (< f10 0) (- f10) f10)))))
(assert (< 0 (f3 f6 f7)))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (and (= f10 (- f11 (* f12 ?v_0))) (<= (* 2 (ite (< f10 0) (- f10) f10)) ?v_0))))
(assert (< 0 (+ 1 (f3 f6 f7))))
(assert (not (< f15 (+ 1 (f3 f6 f7)))))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (* 4 (f3 (f4 f5 f13) ?v_0)) (* 4 (f3 (f4 f5 f10) ?v_0))) (+ (f3 (f4 f5 (* 2 (ite (< f13 0) (- f13) f13))) ?v_0) (f3 (f4 f5 (* 2 (ite (< f10 0) (- f10) f10))) ?v_0)))))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (and (= f13 (- f16 (* f17 ?v_0))) (<= (* 2 (ite (< f13 0) (- f13) f13)) ?v_0))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f6 f7)))) (=> (and (= ?v1 (- f11 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f8 f9 2))) (let ((?v_1 (f3 (f4 f5 (* 2 (ite (< f10 0) (- f10) f10))) ?v_0))) (<= (+ (f3 (f4 f5 (* 2 (ite (< f13 0) (- f13) f13))) ?v_0) ?v_1) (+ (f3 (f4 f5 (+ 1 (f3 f6 f7))) ?v_0) ?v_1)))))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f10) ?v_0)) (* (+ 1 (f3 f6 f7)) f15))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f8 f9 2))) (=> (= (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f10) ?v_0)) (* (+ 1 (f3 f6 f7)) ?v0)) false))) false))
(assert (= f18 (f8 f9 (- (f3 f6 (f8 f9 f14)) 1))))
(assert (let ((?v_0 (+ 1 (f3 f6 f7))) (?v_1 (f8 f9 2))) (<= (* (* 4 ?v_0) f15) (+ (f3 (f4 f5 ?v_0) ?v_1) (f3 (f4 f5 (* 2 (ite (< f10 0) (- f10) f10))) ?v_1)))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f6 f7)))) (=> (and (= ?v1 (- f16 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f8 f9 2))) (= (* (* 4 (+ 1 (f3 f6 f7))) f15) (+ (* 4 (f3 (f4 f5 f13) ?v_0)) (* 4 (f3 (f4 f5 f10) ?v_0))))))
(assert (<= (- (+ 1 (f3 f6 f7)) f15) 0))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (< (* ?v_0 (- (* 2 ?v_0) (* 4 f15))) 0)))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (< (* ?v_0 (- (* 2 ?v_0) (* 4 f15))) (* ?v_0 0))))
(assert (< (- (* 2 (+ 1 (f3 f6 f7))) (* 4 f15)) 0))
(assert (<= (- (* 4 (+ 1 (f3 f6 f7))) (* 4 f15)) 0))
(assert (let ((?v_0 (f8 f9 2))) (= (f19 (+ 1 (f3 f6 f7)) (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f10) ?v_0))) f1)))
(assert (let ((?v_0 (f3 (f4 f5 f20) (f8 f9 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f11) ?v_0)) (* (+ (* 4 f21) 1) (+ 1 (f3 f6 f7))))))
(assert (< 0 (f3 f6 f18)))
(assert (not (= (f22 (* (+ (* 4 f21) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f21) 1)))
(assert (<= 1 f14))
(assert (let ((?v_1 (+ 1 (f3 f6 f7))) (?v_0 (+ (* 4 f21) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f22 (* ?v_0 ?v_1)) f1))))))
(assert (= (+ (f3 (f4 f5 f20) (f8 f9 2)) 1) (* (+ (* 4 f21) 1) f14)))
(assert (< f14 (+ (* 4 f21) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f8 f9 (- (f3 f6 (f8 f9 f14)) 1))) (=> (< 0 (f3 f6 ?v0)) false))) false))
(assert (forall ((?v0 S3)) (= (f8 f9 (f3 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f6 (f8 f9 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f6 (f8 f9 ?v0)) 0))))
(check-sat)
(exit)
