(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () S2)
(declare-fun f14 () S3)
(declare-fun f15 () S3)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (Int Int) S1)
(declare-fun f22 (Int) S1)
(declare-fun f23 (Int) S1)
(declare-fun f24 (S6 Int) Int)
(declare-fun f25 (S7 Int) S6)
(declare-fun f26 () S7)
(declare-fun f27 (Int Int) S1)
(declare-fun f28 (Int Int Int) S1)
(declare-fun f29 () Int)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 2))) (not (= (* (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f11) ?v_0))) (+ (f3 (f4 f5 (+ (* f6 f10) (* f9 f11))) ?v_0) (f3 (f4 f5 (- (* f6 f11) (* f9 f10))) ?v_0))))))
(assert (< 1 f12))
(assert (< 0 (f3 f13 f14)))
(assert (= f15 (f7 f8 (- (f3 f13 (f7 f8 f12)) 1))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f10 (- f6 (* f16 ?v_0))) (<= (* 2 (ite (< f10 0) (- f10) f10)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f11 (- f9 (* f17 ?v_0))) (<= (* 2 (ite (< f11 0) (- f11) f11)) ?v_0))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f11) ?v_0)) (* (+ 1 (f3 f13 f14)) f18))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f11) ?v_0)) (* (+ 1 (f3 f13 f14)) ?v0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (let ((?v_1 (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f11) ?v_0)))) (= (* (* (+ (* 4 f19) 1) (+ 1 (f3 f13 f14))) ?v_1) (* (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) ?v_1)))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (* (+ (* 4 f19) 1) (+ 1 (f3 f13 f14))))))
(assert (let ((?v_0 (f3 (f4 f5 f20) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f13 f14)))) (=> (and (= ?v1 (- f6 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f13 f14)))) (=> (and (= ?v1 (- f9 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (f21 (+ 1 (f3 f13 f14)) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f11) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (< 0 (f3 f13 f15)))
(assert (not (= (f22 (* (+ (* 4 f19) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f19) 1)))
(assert (< 0 (+ 1 (f3 f13 f14))))
(assert (<= 1 f12))
(assert (let ((?v_1 (+ 1 (f3 f13 f14))) (?v_0 (+ (* 4 f19) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f22 (* ?v_0 ?v_1)) f1))))))
(assert (= (+ (f3 (f4 f5 f20) (f7 f8 2)) 1) (* (+ (* 4 f19) 1) f12)))
(assert (< f12 (+ (* 4 f19) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f13 (f7 f8 f12)) 1))) (=> (< 0 (f3 f13 ?v0)) false))) false))
(assert (< f18 (+ 1 (f3 f13 f14))))
(assert (= (f21 (+ (* 4 f19) 1) (- (f3 (f4 f5 f20) (f7 f8 2)) (- 1))) f1))
(assert (= (f21 (+ (* 4 f19) 1) (+ (f3 (f4 f5 f20) (f7 f8 2)) 1)) f1))
(assert (= (f23 (+ (* 4 f19) 1)) f1))
(assert (= (f24 (f25 f26 (- 1)) (+ (* 4 f19) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f19) 1) (+ 1 (f3 f13 f14)))) false))) false))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f20) (f7 f8 2)) 1) (* (+ (* 4 f19) 1) ?v0)) false)) false))
(assert (let ((?v_1 (+ 1 (f3 f13 f14))) (?v_0 (+ (* 4 f19) 1))) (and (< ?v_1 ?v_0) (= (f22 (* ?v_0 ?v_1)) f1))))
(assert (= (f22 (* (+ (* 4 f19) 1) f12)) f1))
(assert (=> (= f12 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f19) 1))))))
(assert (forall ((?v0 Int)) (= (= (f21 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f21 ?v0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f21 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f21 (* ?v0 ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f21 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f21 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f21 ?v0 ?v1) f1) (= (= (f21 ?v0 (+ ?v2 ?v3)) f1) (= (f21 ?v0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 ?v0 (- ?v1 ?v2)) f1) (=> (= (f21 ?v0 ?v2) f1) (= (f21 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 (* ?v0 ?v1) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f21 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f13 ?v1) (f3 f13 ?v2)))) (* (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (= (f27 (+ (* 4 f19) 1) (- 1)) f1))
(assert (= (f28 (f3 (f4 f5 f20) (f7 f8 2)) (- 1) (+ (* 4 f19) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (and (<= 0 f20) (and (< f20 ?v_0) (= (f28 f29 f20 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f21 (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f21 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f13 ?v0)) (=> (= (f21 ?v1 ?v2) f1) (= (f21 ?v1 (f3 (f4 f5 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f21 (f3 (f4 f5 ?v1) ?v0) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f21 ?v1 ?v2) f1)))))
(assert (= (f30 f31 (f32 f20 1)) (* (+ (* 4 f19) 1) f12)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f21 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f13 ?v3) (f3 f13 ?v1)) (= (f21 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f21 ?v0 ?v1) f1) (=> (<= (f3 f13 ?v2) (f3 f13 ?v3)) (= (f21 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (<= (f3 f13 ?v0) (f3 f13 ?v1)) (= (f21 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f21 ?v0 ?v1) f1) (= (f21 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (= (f28 (f3 (f4 f5 f29) (f7 f8 2)) (- 1) (+ (* 4 f19) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f19) 1))) (=> (not (= (f27 ?v_0 (- 1)) f1)) (not (= (f24 (f25 f26 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f28 (f3 (f4 f5 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f19) 1)) f1) false)) false))
(assert (let ((?v_0 (f7 f8 2))) (= (f28 (f3 (f4 f5 f20) ?v_0) (f3 (f4 f5 f29) ?v_0) (+ (* 4 f19) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f29 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f19) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f28 f29 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f28 f29 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f13 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f13 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
