(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 (S5 Int) S3)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 (Int) S1)
(declare-fun f18 (Int) S1)
(declare-fun f19 (S6 Int) Int)
(declare-fun f20 (S7 Int) S6)
(declare-fun f21 () S7)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 (Int Int) S1)
(declare-fun f25 () S3)
(declare-fun f26 (Int Int) S1)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int Int) S1)
(declare-fun f29 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_1 (f8 f9 2))) (let ((?v_0 (f3 (f4 f5 (+ 1 (f3 f6 f7))) ?v_1))) (not (= (* ?v_0 (* (+ (* 4 f10) 1) f11)) (* ?v_0 (+ (f3 (f4 f5 (+ (+ (* f12 f13) (* f14 f15)) f11)) ?v_1) (f3 (f4 f5 (- (* f12 f15) (* f14 f13))) ?v_1))))))))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0)) (* (+ 1 (f3 f6 f7)) f11))))
(assert (let ((?v_1 (+ 1 (f3 f6 f7))) (?v_0 (f8 f9 2))) (let ((?v_2 (f3 (f4 f5 ?v_1) ?v_0))) (= (* (* (+ (* 4 f10) 1) ?v_1) (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0))) (+ (* ?v_2 (f3 (f4 f5 (+ (+ (* f12 f13) (* f14 f15)) f11)) ?v_0)) (* ?v_2 (f3 (f4 f5 (- (* f12 f15) (* f14 f13))) ?v_0)))))))
(assert (< 1 f16))
(assert (< 0 (f3 f6 f7)))
(assert (not (= (f17 (* (+ (* 4 f10) 1) (+ 1 0))) f1)))
(assert (< 0 (+ 1 (f3 f6 f7))))
(assert (< 0 (+ (* 4 f10) 1)))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0)) (* (+ 1 (f3 f6 f7)) f11))))
(assert (let ((?v_1 (+ 1 (f3 f6 f7))) (?v_0 (+ (* 4 f10) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f17 (* ?v_0 ?v_1)) f1))))))
(assert (< f11 (+ 1 (f3 f6 f7))))
(assert (let ((?v_1 (+ 1 (f3 f6 f7))) (?v_0 (f8 f9 2))) (let ((?v_2 (f3 (f4 f5 ?v_1) ?v_0))) (= (* (* (+ (* 4 f10) 1) ?v_1) (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0))) (+ (* ?v_2 (f3 (f4 f5 (+ (+ (* f12 f13) (* f14 f15)) f11)) ?v_0)) (* ?v_2 (f3 (f4 f5 (- (* f12 f15) (* f14 f13))) ?v_0)))))))
(assert (= (f18 (+ (* 4 f10) 1)) f1))
(assert (= (f19 (f20 f21 (- 1)) (+ (* 4 f10) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f9 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (* (+ (* 4 f10) 1) (+ 1 (f3 f6 f7)))) false))) false))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (and (= f13 (- f22 (* f12 ?v_0))) (<= (* 2 (ite (< f13 0) (- f13) f13)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f6 f7)))) (and (= f15 (- f23 (* f14 ?v_0))) (<= (* 2 (ite (< f15 0) (- f15) f15)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f6 f7))) (?v_3 (f8 f9 2))) (let ((?v_1 (+ (* f12 ?v_0) f13)) (?v_2 (+ (* f14 ?v_0) f15))) (= (+ (f3 (f4 f5 (+ (* ?v_1 f13) (* ?v_2 f15))) ?v_3) (f3 (f4 f5 (- (* ?v_1 f15) (* ?v_2 f13))) ?v_3)) (+ (f3 (f4 f5 (+ (+ (* ?v_0 (* f12 f13)) (* ?v_0 (* f14 f15))) (+ (f3 (f4 f5 f13) ?v_3) (f3 (f4 f5 f15) ?v_3)))) ?v_3) (f3 (f4 f5 (- (* ?v_0 (* f12 f15)) (* ?v_0 (* f14 f13)))) ?v_3))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f8 f9 2))) (=> (= (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0)) (* (+ 1 (f3 f6 f7)) ?v0)) false))) false))
(assert (let ((?v_0 (+ 1 (f3 f6 f7))) (?v_1 (f8 f9 2))) (let ((?v_2 (+ (* ?v_0 (* f12 f13)) (* ?v_0 (* f14 f15)))) (?v_3 (f3 (f4 f5 (- (* ?v_0 (* f12 f15)) (* ?v_0 (* f14 f13)))) ?v_1))) (= (+ (f3 (f4 f5 (+ ?v_2 (+ (f3 (f4 f5 f13) ?v_1) (f3 (f4 f5 f15) ?v_1)))) ?v_1) ?v_3) (+ (f3 (f4 f5 (+ ?v_2 (* ?v_0 f11))) ?v_1) ?v_3)))))
(assert (let ((?v_1 (+ 1 (f3 f6 f7))) (?v_0 (f8 f9 2))) (= (* (* (+ (* 4 f10) 1) ?v_1) (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0))) (+ (f3 (f4 f5 (+ (+ (* ?v_1 (* f12 f13)) (* ?v_1 (* f14 f15))) (* ?v_1 f11))) ?v_0) (f3 (f4 f5 (- (* ?v_1 (* f12 f15)) (* ?v_1 (* f14 f13)))) ?v_0)))))
(assert (let ((?v_1 (+ 1 (f3 f6 f7))) (?v_0 (+ (* 4 f10) 1))) (and (< ?v_1 ?v_0) (= (f17 (* ?v_0 ?v_1)) f1))))
(assert (= (f24 (+ (* 4 f10) 1) (- 1)) f1))
(assert (= f25 (f8 f9 (- (f3 f6 (f8 f9 f16)) 1))))
(assert (let ((?v_0 (f8 f9 2))) (= (f26 (+ 1 (f3 f6 f7)) (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0))) f1)))
(assert (< f16 (+ (* 4 f10) 1)))
(assert (let ((?v_0 (f8 f9 2))) (= (+ (f3 (f4 f5 f22) ?v_0) (f3 (f4 f5 f23) ?v_0)) (* (+ (* 4 f10) 1) (+ 1 (f3 f6 f7))))))
(assert (let ((?v_1 (+ 1 (f3 f6 f7))) (?v_0 (f8 f9 2))) (let ((?v_2 (+ (* f12 ?v_1) f13)) (?v_3 (+ (* f14 ?v_1) f15))) (= (+ (f3 (f4 f5 (+ (* f22 f13) (* f23 f15))) ?v_0) (f3 (f4 f5 (- (* f22 f15) (* f23 f13))) ?v_0)) (+ (f3 (f4 f5 (+ (* ?v_2 f13) (* ?v_3 f15))) ?v_0) (f3 (f4 f5 (- (* ?v_2 f15) (* ?v_3 f13))) ?v_0))))))
(assert (let ((?v_0 (f8 f9 2))) (let ((?v_1 (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0)))) (= (* (* (+ (* 4 f10) 1) (+ 1 (f3 f6 f7))) ?v_1) (* (+ (f3 (f4 f5 f22) ?v_0) (f3 (f4 f5 f23) ?v_0)) ?v_1)))))
(assert (= (+ (f3 (f4 f5 f27) (f8 f9 2)) 1) (* (+ (* 4 f10) 1) f16)))
(assert (= (f28 (f3 (f4 f5 f29) (f8 f9 2)) (- 1) (+ (* 4 f10) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f27) (f8 f9 2)) 1) (* (+ (* 4 f10) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f3 (f4 f5 f27) (f8 f9 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (f8 f9 2))) (= (* (+ (f3 (f4 f5 f22) ?v_0) (f3 (f4 f5 f23) ?v_0)) (+ (f3 (f4 f5 f13) ?v_0) (f3 (f4 f5 f15) ?v_0))) (+ (f3 (f4 f5 (+ (* f22 f13) (* f23 f15))) ?v_0) (f3 (f4 f5 (- (* f22 f15) (* f23 f13))) ?v_0)))))
(assert (< 0 (f3 f6 f25)))
(assert (forall ((?v0 S3)) (= (f8 f9 (f3 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f6 (f8 f9 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f6 (f8 f9 ?v0)) 0))))
(check-sat)
(exit)
