(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 () Int)
(declare-fun f5 () Int)
(declare-fun f6 (S2 S3) Int)
(declare-fun f7 (S4 Int) S2)
(declare-fun f8 () S4)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 (S5 Int) S3)
(declare-fun f14 () S5)
(declare-fun f15 () Int)
(declare-fun f16 () S2)
(declare-fun f17 () S3)
(declare-fun f18 (Int) S1)
(declare-fun f19 (S6 Int) Int)
(declare-fun f20 (S7 Int) S6)
(declare-fun f21 () S7)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 () S3)
(declare-fun f24 () Int)
(declare-fun f25 (Int Int Int) S1)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 () Int)
(declare-fun f29 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (* (+ (* 4 f4) 1) f5)) f1)))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f6 (f7 f8 (+ (+ (* f9 f10) (* f11 f12)) f5)) ?v_0) (f6 (f7 f8 (- (* f9 f12) (* f11 f10))) ?v_0)) (* (+ (* 4 f4) 1) f5))))
(assert (< 1 f15))
(assert (not (= (f3 (* (+ (* 4 f4) 1) (+ 1 0))) f1)))
(assert (< 0 (f6 f16 f17)))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f6 (f7 f8 (+ (+ (* f9 f10) (* f11 f12)) f5)) ?v_0) (f6 (f7 f8 (- (* f9 f12) (* f11 f10))) ?v_0)) (* (+ (* 4 f4) 1) f5))))
(assert (= (f18 (+ (* 4 f4) 1)) f1))
(assert (= (f19 (f20 f21 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (let ((?v_0 (+ (* 4 f4) 1)) (?v_1 (+ 1 (f6 f16 f17)))) (not (=> (< ?v_1 ?v_0) (not (= (f3 (* ?v_0 ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (* ?v0 ?v1)) f1)))))
(assert (= (f22 (+ (* 4 f4) 1) (- 1)) f1))
(assert (= f23 (f13 f14 (- (f6 f16 (f13 f14 f15)) 1))))
(assert (= (f3 (* (+ (* 4 f4) 1) f15)) f1))
(assert (< f15 (+ (* 4 f4) 1)))
(assert (let ((?v_0 (+ (* 4 f4) 1)) (?v_1 (+ 1 (f6 f16 f17)))) (and (< ?v_1 ?v_0) (= (f3 (* ?v_0 ?v_1)) f1))))
(assert (< f5 (+ 1 (f6 f16 f17))))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f6 (f7 f8 f10) ?v_0) (f6 (f7 f8 f12) ?v_0)) (* (+ 1 (f6 f16 f17)) f5))))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f22 ?v_0 (- 1)) f1)) (not (= (f19 (f20 f21 (- 1)) ?v_0) 1)))))
(assert (= (+ (f6 (f7 f8 f24) (f13 f14 2)) 1) (* (+ (* 4 f4) 1) f15)))
(assert (= (f25 (f6 (f7 f8 f26) (f13 f14 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f7 f8 f24) (f13 f14 2)) 1) (* (+ (* 4 f4) 1) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (* (+ (* 4 f4) 1) (+ 1 (f6 f16 f17)))) false))) false))
(assert (< 0 (f6 f16 f23)))
(assert (< 0 (+ 1 (f6 f16 f17))))
(assert (<= 1 f15))
(assert (let ((?v_0 (f6 (f7 f8 f24) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f24) (and (< f24 ?v_0) (= (f25 f26 f24 ?v_0) f1)))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f13 f14 (- (f6 f16 (f13 f14 f15)) 1))) (=> (< 0 (f6 f16 ?v0)) false))) false))
(assert (= (f25 (f6 (f7 f8 f24) (f13 f14 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (+ 1 (f6 f16 f17)))) (and (= f12 (- f27 (* f11 ?v_0))) (<= (* 2 (ite (< f12 0) (- f12) f12)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f16 f17)))) (and (= f10 (- f28 (* f9 ?v_0))) (<= (* 2 (ite (< f10 0) (- f10) f10)) ?v_0))))
(assert (=> (forall ((?v0 Int)) (=> (= (f25 (f6 (f7 f8 ?v0) (f13 f14 2)) (- 1) (+ (* 4 f4) 1)) f1) false)) false))
(assert (let ((?v_0 (f13 f14 2))) (= (f25 (f6 (f7 f8 f24) ?v_0) (f6 (f7 f8 f26) ?v_0) (+ (* 4 f4) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f25 f26 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f25 f26 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f25 f26 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f6 (f7 f8 f10) ?v_0) (f6 (f7 f8 f12) ?v_0)) (* (+ 1 (f6 f16 f17)) ?v0)) false))) false))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f6 (f7 f8 f28) ?v_0) (f6 (f7 f8 f27) ?v_0)) (* (+ (* 4 f4) 1) (+ 1 (f6 f16 f17))))))
(assert (=> (= f15 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f6 (f7 f8 ?v0) ?v_0) (f6 (f7 f8 ?v1) ?v_0)) (+ (* 4 f4) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f18 ?v_0) f1) (= (f19 (f20 f21 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (f13 f14 2))) (= (f29 (+ 1 (f6 f16 f17)) (+ (f6 (f7 f8 f10) ?v_0) (f6 (f7 f8 f12) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f16 f17)))) (=> (and (= ?v1 (- f28 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f16 f17)))) (=> (and (= ?v1 (- f27 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f19 (f20 f21 ?v0) ?v1) (ite (= (f25 ?v0 0 ?v1) f1) 0 (ite (= (f22 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f25 (f6 (f7 f8 ?v2) (f13 f14 2)) ?v1 ?v0) f1)))))
(assert (= (f29 (+ (* 4 f4) 1) (- (f6 (f7 f8 f24) (f13 f14 2)) (- 1))) f1))
(assert (= (f29 (+ (* 4 f4) 1) (+ (f6 (f7 f8 f24) (f13 f14 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (not (= (f25 ?v1 0 ?v0) f1)) (=> (not (= (f25 ?v2 0 ?v0) f1)) (not (= (f25 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f25 (* ?v1 ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f25 ?v1 0 ?v0) f1)) (not (= (f25 ?v2 0 ?v0) f1))) (not (= (f25 (* ?v1 ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f25 ?v0 ?v1 ?v2) f1) (= (f29 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f25 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f6 f16 ?v0)) (=> (= (f29 ?v1 ?v2) f1) (= (f29 ?v1 (f6 (f7 f8 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f18 ?v1) f1) (=> (= (f29 ?v1 (* ?v0 ?v2)) f1) (or (= (f29 ?v1 ?v0) f1) (= (f29 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (= (f29 ?v0 (* ?v1 ?v2)) f1) (or (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f18 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f29 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f18 ?v0) f1) (=> (= (f29 ?v0 (f6 (f7 f8 ?v1) ?v2)) f1) (=> (< 0 (f6 f16 ?v2)) (= (f29 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= (f25 ?v3 ?v4 ?v2) f1) (= (f25 (* ?v0 ?v3) (* ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= (f25 ?v3 ?v4 ?v2) f1) (= (f25 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= (f25 ?v3 ?v4 ?v2) f1) (= (f25 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= (f25 ?v1 ?v3 ?v2) f1) (= (f25 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f25 ?v3 ?v4 ?v2) f1) (= (f25 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f25 ?v0 ?v1 ?v2) f1) (= (f25 (* ?v3 ?v0) (* ?v3 ?v1) ?v2) f1))))
(assert (forall ((?v0 S3)) (= (f13 f14 (f6 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f16 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f16 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
