(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 (Int Int) S1)
(declare-fun f7 (S4 Int) S2)
(declare-fun f8 () S4)
(declare-fun f9 () Int)
(declare-fun f10 (S5 Int) S3)
(declare-fun f11 () S5)
(declare-fun f12 () Int)
(assert (not (= f1 f2)))
(assert (< 0 (f3 f4 f5)))
(assert (let ((?v_0 (f10 f11 2))) (= (f6 (+ 1 (f3 f4 f5)) (+ (f3 (f7 f8 f9) ?v_0) (f3 (f7 f8 f12) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f6 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f7 f8 ?v0) ?v_0) (f3 (f7 f8 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f7 f8 ?v0) (f10 f11 2)))))
(assert (let ((?v_0 (f10 f11 2))) (not (<= 0 (+ (f3 (f7 f8 f9) ?v_0) (f3 (f7 f8 f12) ?v_0))))))
(assert (forall ((?v0 S3)) (= (f10 f11 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
