(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 () Int)
(declare-fun f5 (S2 S3) Int)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 () S3)
(declare-fun f9 (S4 Int) S3)
(declare-fun f10 () S4)
(declare-fun f11 (Int) S1)
(declare-fun f12 () Int)
(declare-fun f13 (S5 Int) S2)
(declare-fun f14 () S5)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (Int) S1)
(declare-fun f22 (S6 Int) Int)
(declare-fun f23 (S7 Int) S6)
(declare-fun f24 () S7)
(declare-fun f25 () Int)
(assert (not (= f1 f2)))
(assert (not (<= 0 f3)))
(assert (< 1 f4))
(assert (< 0 (f5 f6 f7)))
(assert (not (= f3 0)))
(assert (= f8 (f9 f10 (- (f5 f6 (f9 f10 f4)) 1))))
(assert (< f3 (+ 1 (f5 f6 f7))))
(assert (= (f11 (* (+ (* 4 f12) 1) f3)) f1))
(assert (<= 1 f4))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f5 (f13 f14 f15) ?v_0) (f5 (f13 f14 f16) ?v_0)) (* (+ 1 (f5 f6 f7)) f3))))
(assert (< 0 (+ 1 (f5 f6 f7))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f9 f10 (- (f5 f6 (f9 f10 f4)) 1))) (=> (< 0 (f5 f6 ?v0)) false))) false))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 ?v0) f1) (=> (= (f11 ?v1) f1) (= (f11 (* ?v0 ?v1)) f1)))))
(assert (not (= (f11 (* (+ (* 4 f12) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f12) 1)))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f5 (f13 f14 (+ (+ (* f17 f15) (* f18 f16)) f3)) ?v_0) (f5 (f13 f14 (- (* f17 f16) (* f18 f15))) ?v_0)) (* (+ (* 4 f12) 1) f3))))
(assert (< 0 (f5 f6 f8)))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f12) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f11 (* ?v_0 ?v_1)) f1))))))
(assert (let ((?v_0 (f9 f10 2))) (not (= (+ (f5 (f13 f14 f15) ?v_0) (* 1 (f5 (f13 f14 f16) ?v_0))) 0))))
(assert (< f4 (+ (* 4 f12) 1)))
(assert (let ((?v_1 (+ 1 (f5 f6 f7))) (?v_0 (+ (* 4 f12) 1))) (and (< ?v_1 ?v_0) (= (f11 (* ?v_0 ?v_1)) f1))))
(assert (let ((?v_0 (f9 f10 2))) (< 0 (+ (f5 (f13 f14 f15) ?v_0) (f5 (f13 f14 f16) ?v_0)))))
(assert (let ((?v_0 (f9 f10 2))) (<= 0 (+ (f5 (f13 f14 f15) ?v_0) (f5 (f13 f14 f16) ?v_0)))))
(assert (let ((?v_0 (f9 f10 2))) (=> (= (+ (f5 (f13 f14 f15) ?v_0) (f5 (f13 f14 f16) ?v_0)) 0) false)))
(assert (= (f11 (* (+ (* 4 f12) 1) f4)) f1))
(assert (let ((?v_0 (+ 1 (f5 f6 f7)))) (and (= f15 (- f19 (* f17 ?v_0))) (<= (* 2 (ite (< f15 0) (- f15) f15)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f5 f6 f7)))) (and (= f16 (- f20 (* f18 ?v_0))) (<= (* 2 (ite (< f16 0) (- f16) f16)) ?v_0))))
(assert (= (f21 (+ (* 4 f12) 1)) f1))
(assert (= (f22 (f23 f24 (- 1)) (+ (* 4 f12) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f5 (f13 f14 ?v0) ?v_0) (f5 (f13 f14 ?v1) ?v_0)) (* (+ (* 4 f12) 1) (+ 1 (f5 f6 f7)))) false))) false))
(assert (= (+ (f5 (f13 f14 f25) (f9 f10 2)) 1) (* (+ (* 4 f12) 1) f4)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f5 (f13 f14 f15) ?v_0) (f5 (f13 f14 f16) ?v_0)) (* (+ 1 (f5 f6 f7)) ?v0)) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f5 (f13 f14 f19) ?v_0) (f5 (f13 f14 f20) ?v_0)) (* (+ (* 4 f12) 1) (+ 1 (f5 f6 f7))))))
(assert (=> (= f4 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (+ (f5 (f13 f14 ?v0) ?v_0) (f5 (f13 f14 ?v1) ?v_0)) (+ (* 4 f12) 1))))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
