(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 () S3)
(declare-fun f8 (S4 Int) S1)
(declare-fun f9 () S4)
(declare-fun f10 () Int)
(declare-fun f11 () S4)
(declare-fun f12 (S5 Int) Int)
(declare-fun f13 (S6 Int) S5)
(declare-fun f14 () S6)
(declare-fun f15 (S7 Int) S3)
(declare-fun f16 () S7)
(declare-fun f17 () Int)
(declare-fun f18 (S8 Int) S4)
(declare-fun f19 () S8)
(declare-fun f20 () S3)
(declare-fun f21 (S9 Int) S2)
(declare-fun f22 () S9)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 () Int)
(declare-fun f29 () Int)
(declare-fun f30 (S10 Int) S8)
(declare-fun f31 () S10)
(declare-fun f32 () Int)
(declare-fun f33 () S8)
(declare-fun f34 (S11 S12) Int)
(declare-fun f35 () S11)
(declare-fun f36 (Int Int) S12)
(declare-fun f37 (S13 S3) S1)
(declare-fun f38 (S14 S3) S13)
(declare-fun f39 () S14)
(declare-fun f40 (S15 S3) S3)
(declare-fun f41 (S16 S3) S15)
(declare-fun f42 () S16)
(declare-fun f43 () S5)
(declare-fun f44 () S5)
(declare-fun f45 () S6)
(declare-fun f46 () S16)
(declare-fun f47 () S6)
(assert (not (= f1 f2)))
(assert (not (< (+ 1 (f3 f4 f5)) (+ (* 4 f6) 1))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f7)))) (and (< ?v_1 ?v_0) (= (f8 f9 (* ?v_0 ?v_1)) f1))))
(assert (< (f3 f4 f5) (f3 f4 f7)))
(assert (< 1 f10))
(assert (< 0 (+ 1 (f3 f4 f7))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f7)))) (and (< ?v_1 ?v_0) (= (f8 f9 (* ?v_0 ?v_1)) f1))))
(assert (not (= (f8 f9 (* (+ (* 4 f6) 1) (+ 1 0))) f1)))
(assert (< (f3 f4 f5) (f3 f4 f7)))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f7)))) (not (=> (< ?v_1 ?v_0) (not (= (f8 f9 (* ?v_0 ?v_1)) f1))))))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (= (f8 f11 (+ (* 4 f6) 1)) f1))
(assert (= (f12 (f13 f14 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (and (= f5 (f15 f16 (- (f3 f4 (f15 f16 f17)) 1))) (= (f8 f9 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f5)))) f1)))
(assert (= (f8 (f18 f19 (+ (* 4 f6) 1)) (- 1)) f1))
(assert (= f20 (f15 f16 (- (f3 f4 (f15 f16 f10)) 1))))
(assert (< f10 (+ (* 4 f6) 1)))
(assert (= (f8 f9 (* (+ (* 4 f6) 1) f10)) f1))
(assert (= (f8 f9 (* (+ (* 4 f6) 1) f17)) f1))
(assert (= (f8 f9 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 (f15 f16 (- (f3 f4 (f15 f16 f17)) 1)))))) f1))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f8 (f18 f19 ?v_0) (- 1)) f1)) (not (= (f12 (f13 f14 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 S3)) (=> (and (= ?v0 (f15 f16 (- (f3 f4 (f15 f16 f17)) 1))) (= (f8 f9 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 ?v0)))) f1)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 f9 ?v0) f1) (=> (= (f8 f9 ?v1) f1) (= (f8 f9 (* ?v0 ?v1)) f1)))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (=> (= (+ (f3 (f21 f22 ?v0) ?v_0) (f3 (f21 f22 ?v1) ?v_0)) (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f7)))) false))) false))
(assert (<= 1 f10))
(assert (let ((?v_0 (f15 f16 2))) (= (+ (f3 (f21 f22 f23) ?v_0) (f3 (f21 f22 f24) ?v_0)) (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f7))))))
(assert (< 0 (f3 f4 f7)))
(assert (< 0 (f3 f4 f20)))
(assert (= (+ 1 (f3 f4 (f15 f16 (- (f3 f4 (f15 f16 f17)) 1)))) f17))
(assert (< 0 f17))
(assert (< f17 (+ 1 (f3 f4 f7))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f15 f16 (- (f3 f4 (f15 f16 f10)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f7)))) (=> (and (= ?v1 (- f24 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f7)))) (=> (and (= ?v1 (- f23 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (= (+ (f3 (f21 f22 f25) (f15 f16 2)) 1) (* (+ (* 4 f6) 1) f10)))
(assert (=> (= f10 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (+ (f3 (f21 f22 ?v0) ?v_0) (f3 (f21 f22 ?v1) ?v_0)) (+ (* 4 f6) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f8 f11 ?v_0) f1) (= (f12 (f13 f14 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (+ 1 (f3 f4 f7)))) (and (= f26 (- f23 (* f27 ?v_0))) (<= (* 2 (ite (< f26 0) (- f26) f26)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f4 f7)))) (and (= f28 (- f24 (* f29 ?v_0))) (<= (* 2 (ite (< f28 0) (- f28) f28)) ?v_0))))
(assert (let ((?v_0 (f15 f16 2))) (= (+ (f3 (f21 f22 f26) ?v_0) (f3 (f21 f22 f28) ?v_0)) (* (+ 1 (f3 f4 f7)) f17))))
(assert (= (f8 (f18 (f30 f31 (f3 (f21 f22 f32) (f15 f16 2))) (- 1)) (+ (* 4 f6) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f21 f22 f25) (f15 f16 2)) 1) (* (+ (* 4 f6) 1) ?v0)) false)) false))
(assert (let ((?v_0 (f3 (f21 f22 f25) (f15 f16 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (f8 (f18 (f30 f31 (f3 (f21 f22 ?v0) (f15 f16 2))) (- 1)) (+ (* 4 f6) 1)) f1) false)) false))
(assert (= (f8 f11 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f8 f11 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (and (<= 0 f25) (and (< f25 ?v_0) (= (f8 (f18 (f30 f31 f32) f25) ?v_0) f1)))))
(assert (= (f8 (f18 (f30 f31 (f3 (f21 f22 f25) (f15 f16 2))) (- 1)) (+ (* 4 f6) 1)) f1))
(assert (let ((?v_0 (f15 f16 2))) (= (f8 (f18 (f30 f31 (f3 (f21 f22 f25) ?v_0)) (f3 (f21 f22 f32) ?v_0)) (+ (* 4 f6) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f8 (f18 (f30 f31 f32) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f8 (f18 (f30 f31 f32) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f8 (f18 (f30 f31 f32) ?v0) ?v_0) f1))) false))) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2))) (=> (= (+ (f3 (f21 f22 f26) ?v_0) (f3 (f21 f22 f28) ?v_0)) (* (+ 1 (f3 f4 f7)) ?v0)) false))) false))
(assert (let ((?v_0 (f15 f16 2))) (= (+ (f3 (f21 f22 (+ (+ (* f27 f26) (* f29 f28)) f17)) ?v_0) (f3 (f21 f22 (- (* f27 f28) (* f29 f26))) ?v_0)) (* (+ (* 4 f6) 1) f17))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f8 (f18 (f30 f31 (* ?v0 ?v_0)) 1) ?v1) f1) (= (f8 (f18 (f30 f31 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f21 f22 ?v0) (f15 f16 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (= (f3 (f21 f22 ?v0) ?v_0) (f3 (f21 f22 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2)) (?v_1 (f21 f22 ?v0))) (= (f3 (f21 f22 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f15 f16 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (* (+ ?v0 ?v1) (- ?v0 ?v1)) (- (f3 (f21 f22 ?v0) ?v_0) (f3 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_3 (f21 f22 ?v1)) (?v_1 (f21 f22 ?v0))) (= (f3 (f21 f22 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_1 (f21 f22 ?v0)) (?v_3 (f21 f22 ?v1))) (= (f3 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (* (* 3 (f3 ?v_1 ?v_2)) ?v1)) (* (* 3 ?v0) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f3 (f21 f22 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f21 f22 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f3 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f21 f22 ?v0) ?v_0) (* (* 2 ?v0) ?v1)) (f3 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 3))) (= (f3 (f21 f22 (- ?v0)) ?v_0) (- (f3 (f21 f22 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (* ?v0 (f3 ?v_0 (f15 f16 2))) (f3 ?v_0 (f15 f16 3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f21 f22 ?v0))) (= (f3 ?v_0 (f15 f16 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (* (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f15 f16 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f15 f16 3))) (let ((?v_0 (f3 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f15 f16 2))) (let ((?v_0 (f3 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f21 f22 ?v0) (f15 f16 2)))))
(assert (let ((?v_0 (f15 f16 2))) (= (f8 (f18 f33 (+ 1 (f3 f4 f7))) (+ (f3 (f21 f22 f26) ?v_0) (f3 (f21 f22 f28) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 ?v0) ?v1) (ite (= (f8 (f18 (f30 f31 ?v0) 0) ?v1) f1) 0 (ite (= (f8 (f18 f19 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f18 f19 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f8 (f18 (f30 f31 (f3 (f21 f22 ?v2) (f15 f16 2))) ?v1) ?v0) f1)))))
(assert (= (f8 (f18 f33 (+ (* 4 f6) 1)) (+ (f3 (f21 f22 f25) (f15 f16 2)) 1)) f1))
(assert (= (f8 (f18 f33 (+ (* 4 f6) 1)) (- (f3 (f21 f22 f25) (f15 f16 2)) (- 1))) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f30 f31 ?v1))) (=> (= (f8 f11 ?v0) f1) (=> (< 0 ?v1) (=> (= (f8 (f18 (f30 f31 (* ?v1 ?v1)) 1) ?v0) f1) (or (= (f8 (f18 ?v_0 1) ?v0) f1) (= (f8 (f18 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 f11 ?v0) f1) (=> (< 0 ?v1) (=> (= (f8 (f18 (f30 f31 (* ?v1 ?v2)) 0) ?v0) f1) (or (= (f8 (f18 (f30 f31 ?v1) 0) ?v0) f1) (= (f8 (f18 (f30 f31 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 f11 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f8 (f18 (f30 f31 ?v1) 0) ?v0) f1)) (not (= (f8 (f18 (f30 f31 ?v2) 0) ?v0) f1))) (not (= (f8 (f18 (f30 f31 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 (f18 f33 (* ?v0 ?v1)) (* ?v0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f8 (f18 f33 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f33 ?v0))) (=> (= (f8 ?v_0 (- ?v1 ?v2)) f1) (=> (= (f8 ?v_0 ?v2) f1) (= (f8 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f18 f33 ?v0) ?v1) f1) (=> (= (f8 (f18 f33 ?v1) ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f18 f33 ?v0) ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f18 f33 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (= (= (f8 ?v_0 (+ ?v2 ?v3)) f1) (= (f8 ?v_0 (+ (+ ?v2 (* ?v4 ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f8 (f18 f33 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f8 (f18 f33 ?v0) ?v1) f1) (=> (= (f8 (f18 f33 ?v1) ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f8 (f18 f33 ?v1) ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f8 (f18 f33 (* ?v0 ?v1)) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f8 (f18 f33 ?v2) (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f18 (f30 f31 ?v0) 0) ?v1) f1) (= (f8 (f18 f33 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f18 (f30 f31 ?v0) 0) ?v1) f1) (= (f8 (f18 f33 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f33 ?v0))) (= (= (f8 ?v_0 (+ ?v1 (* ?v0 ?v2))) f1) (= (f8 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (= (f8 (f18 f33 ?v0) 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f33 ?v1))) (=> (< 0 (f3 f4 ?v0)) (=> (= (f8 ?v_0 ?v2) f1) (= (f8 ?v_0 (f3 (f21 f22 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f33 ?v1))) (=> (<= 0 ?v0) (=> (= (f8 f11 ?v1) f1) (=> (= (f8 ?v_0 (* ?v0 ?v2)) f1) (or (= (f8 ?v_0 ?v0) f1) (= (f8 ?v_0 ?v2) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f33 ?v0))) (=> (= (f8 f11 ?v0) f1) (=> (= (f8 ?v_0 (* ?v1 ?v2)) f1) (or (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (= (= (f8 f11 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f8 (f18 f33 ?v1) ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f18 f33 ?v0) ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f18 f33 ?v0))) (=> (= (f8 f11 ?v0) f1) (=> (= (f8 ?v_0 (f3 (f21 f22 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f8 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f18 f33 (f3 (f21 f22 ?v0) ?v2)))) (=> (= (f8 f11 ?v0) f1) (=> (not (= (f8 (f18 f33 ?v0) ?v1) f1)) (=> (= (f8 ?v_0 (* ?v1 ?v3)) f1) (= (f8 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f18 f33 (f3 (f21 f22 ?v0) ?v2)))) (=> (= (f8 f11 ?v0) f1) (=> (not (= (f8 (f18 f33 ?v0) ?v1) f1)) (=> (= (f8 ?v_0 (* ?v3 ?v1)) f1) (= (f8 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f18 f33 ?v0))) (=> (= (f8 f11 ?v0) f1) (=> (= (f8 ?v_0 (f3 (f21 f22 ?v1) ?v2)) f1) (= (f8 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f18 (f30 f31 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (* ?v2 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f8 (f18 (f30 f31 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 (f30 f31 ?v0) ?v1))) (= (= (f8 ?v_0 (- ?v2)) f1) (= (f8 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f8 (f18 (f30 f31 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f18 (f30 f31 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f18 (f30 f31 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f18 (f30 f31 (* ?v0 ?v1)) (* ?v2 ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f8 (f18 (f30 f31 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f8 (f18 (f30 f31 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f8 (f18 (f30 f31 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f8 (f18 (f30 f31 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f8 (f18 (f30 f31 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f30 f31 ?v1))) (=> (< 2 ?v0) (=> (= (f8 (f18 ?v_0 (- 1)) ?v0) f1) (not (= (f8 (f18 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f30 f31 ?v3))) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (= (= (f8 (f18 ?v_0 (* ?v0 ?v4)) ?v2) f1) (= (f8 (f18 ?v_0 (* ?v1 ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f30 f31 ?v3))) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (= (= (f8 (f18 ?v_0 (* ?v4 ?v0)) ?v2) f1) (= (f8 (f18 ?v_0 (* ?v4 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f8 (f18 (f30 f31 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f8 (f18 (f30 f31 (* ?v0 ?v3)) (* ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f8 (f18 (f30 f31 (* ?v3 ?v0)) (* ?v3 ?v1)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f8 (f18 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f8 (f18 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f8 (f18 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f30 f31 ?v0))) (=> (= (f8 (f18 ?v_0 ?v1) ?v2) f1) (=> (= (f8 (f18 (f30 f31 ?v1) ?v3) ?v2) f1) (= (f8 (f18 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (= (f8 (f18 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f8 (f18 (f30 f31 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (= (f8 (f18 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f8 (f18 (f30 f31 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (=> (= (f8 (f18 (f30 f31 ?v3) ?v4) ?v2) f1) (= (f8 (f18 (f30 f31 (* ?v0 ?v3)) (* ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f8 (f18 (f30 f31 ?v0) ?v1) ?v2) f1) (= (f8 (f18 (f30 f31 (f3 (f21 f22 ?v0) ?v3)) (f3 (f21 f22 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f8 f11 ?v0) f1) (=> (not (= (f8 (f18 (f30 f31 ?v1) 0) ?v0) f1)) (=> (not (= (f8 (f18 (f30 f31 ?v2) 0) ?v0) f1)) (not (= (f8 (f18 (f30 f31 (* ?v1 ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 f11 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f8 (f18 (f30 f31 (* ?v1 ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 f11 ?v0) f1) (=> (not (= (f8 (f18 f33 ?v0) ?v1) f1)) (= (f8 (f18 (f30 f31 (f3 (f21 f22 ?v1) (f15 f16 (- ?v0 1)))) 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f8 (f18 (f30 f31 ?v0) 0) ?v1) f1)) (=> (= (f8 (f18 (f30 f31 (f3 (f21 f22 ?v2) (f15 f16 2))) ?v0) ?v1) f1) (not (= (f8 (f18 f33 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f8 f11 ?v1) f1) (= (f8 (f18 f33 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f8 (f18 f33 (f3 (f21 f22 ?v0) ?v1)) (f3 (f21 f22 ?v2) ?v1)) f1) (=> (not (= ?v1 (f15 f16 0))) (= (f8 (f18 f33 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f15 f16 0))) (= (= (f8 (f18 f33 (f3 (f21 f22 ?v1) ?v0)) (f3 (f21 f22 ?v2) ?v0)) f1) (= (f8 (f18 f33 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f21 f22 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f8 (f18 (f30 f31 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f8 (f18 (f30 f31 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 ?v1)) (?v_1 (f15 f16 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (* ?v1 (f3 ?v_0 (f15 f16 (- (f3 f4 ?v_1) 1)))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f21 f22 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (= (f34 f35 (f36 f25 1)) (* (+ (* 4 f6) 1) f10)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f8 (f18 f33 ?v0) ?v1) f1) (= (f8 (f18 f33 (f3 (f21 f22 ?v0) ?v2)) (f3 (f21 f22 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f37 (f38 f39 (f40 (f41 f42 ?v0) ?v2)) (f40 (f41 f42 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f8 (f18 f33 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f37 (f38 f39 (f40 ?v_0 ?v0)) (f40 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f8 (f18 f33 ?v0) ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f8 (f18 f33 (f3 (f21 f22 ?v0) ?v2)) (f3 (f21 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f37 (f38 f39 (f40 (f41 f42 ?v0) ?v2)) (f40 (f41 f42 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f15 f16 (f3 (f21 f22 ?v0) ?v1)) (f40 (f41 f42 (f15 f16 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f21 f22 (f3 f4 ?v0)) ?v1) (f3 f4 (f40 (f41 f42 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f40 (f41 f42 ?v0) ?v1)) (f3 (f21 f22 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f8 (f18 f33 (f3 f4 ?v0)) (f3 f4 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f8 (f18 f33 ?v0) (f3 f4 ?v1)) f1) (= (f37 (f38 f39 (f15 f16 (ite (< ?v0 0) (- ?v0) ?v0))) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f8 (f18 f33 (f3 f4 ?v0)) ?v1) f1) (= (f37 (f38 f39 ?v0) (f15 f16 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f37 (f38 f39 (f15 f16 ?v0)) ?v1) f1) (ite (<= 0 ?v0) (= (f8 (f18 f33 ?v0) (f3 f4 ?v1)) f1) (= ?v1 (f15 f16 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f34 f35 (f36 ?v0 ?v1)) (f34 f35 (f36 ?v2 ?v3))) (f34 f35 (f36 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f12 f43 (f3 (f21 f22 ?v0) ?v1)) (f3 (f21 f22 (f12 f43 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f3 (f21 f22 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f40 (f41 f42 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f21 f22 ?v0))) (=> (= (f8 (f18 f33 (f3 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f8 (f18 f33 (f3 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f37 (f38 f39 (f40 ?v_0 ?v1)) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f37 (f38 f39 (f40 ?v_0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f8 f9 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f34 f35 (f36 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int)) (=> (= (f8 f11 ?v0) f1) (= (f8 (f18 (f30 f31 (f12 f44 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f8 (f18 (f30 f31 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f8 (f18 (f30 f31 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 0))) (not (and (= (f37 (f38 f39 ?v_0) ?v0) f1) (not (= (f37 (f38 f39 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 1))) (not (and (= (f37 (f38 f39 ?v0) ?v_0) f1) (not (= (f37 (f38 f39 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (= (f37 (f38 f39 (f15 f16 1)) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f37 (f38 f39 ?v0) (f15 f16 0)) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 1))) (= (not (= ?v0 ?v_0)) (and (= (f37 (f38 f39 ?v_0) ?v0) f1) (not (= (f37 (f38 f39 ?v0) ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 0))) (= (not (= ?v0 ?v_0)) (and (= (f37 (f38 f39 ?v0) ?v_0) f1) (not (= (f37 (f38 f39 ?v_0) ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 0))) (= (= (f37 (f38 f39 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 1))) (= (= (f37 (f38 f39 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 0))) (=> (= (f37 (f38 f39 ?v_0) ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f37 (f38 f39 ?v1) ?v0) f1) (< 0 (f3 f4 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 1))) (=> (= (f37 (f38 f39 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f15 f16 0))) (= (= (f37 (f38 f39 (f40 (f41 f42 ?v1) ?v0)) (f40 (f41 f42 ?v2) ?v0)) f1) (= (f37 (f38 f39 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f4 ?v0)) (<= ?v_0 (f3 f4 (f40 (f41 f42 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (< 0 (f3 f4 ?v0)) (=> (< (f3 f4 (f40 ?v_0 ?v1)) (f3 f4 (f40 ?v_0 ?v2))) (< (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f15 f16 (+ 0 1)))) (= (= (f40 (f41 f42 ?v0) ?v1) ?v_0) (or (= ?v1 (f15 f16 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 (+ 0 1)))) (= (f40 (f41 f42 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f4 (f40 (f41 f42 ?v0) ?v1))) (or (< 0 (f3 f4 ?v0)) (= ?v1 (f15 f16 0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f41 f42 ?v0))) (=> (= (f37 (f38 f39 (f40 ?v_0 ?v1)) (f40 ?v_0 ?v2)) f1) (=> (< 1 (f3 f4 ?v0)) (<= (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3)) (= (f37 (f38 f39 (f15 f16 (+ 0 1))) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f37 (f38 f39 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f21 f22 (f3 f4 ?v0)) ?v1) (f3 f4 (f40 (f41 f42 ?v0) ?v1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v0) f1))) (not (and ?v_0 (not ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 1))) (= (= (f37 (f38 f39 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f37 (f38 f39 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (= ?v_0 (or (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f15 f16 (+ 0 1)))) (= (= (f37 (f38 f39 ?v0) ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f38 f39 ?v0))) (= (= (f37 ?v_0 (f15 f16 (+ (f3 f4 ?v1) (f3 f4 ?v0)))) f1) (= (f37 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (= (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (and ?v_0 (not (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (and (= (f37 (f38 f39 ?v0) ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (=> (not (= ?v0 ?v1)) (=> ?v_0 (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f4 ?v0))) (=> (< 0 ?v_0) (=> (< ?v_0 (f3 f4 ?v1)) (not (= (f37 (f38 f39 ?v1) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f37 (f38 f39 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (= (= (f37 (f38 f39 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (=> ?v_0 (or (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (=> ?v_0 (=> (not (= ?v0 ?v1)) (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f4 ?v1))) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (=> (< 0 ?v_0) (<= (f3 f4 ?v0) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f37 (f38 f39 ?v1) ?v2) f1) (= (f37 (f38 f39 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f37 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f37 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (=> (= (f37 (f38 f39 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (=> (= (f37 (f38 f39 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f37 ?v_0 ?v1) f1) (=> (= (f37 (f38 f39 ?v1) ?v2) f1) (= (f37 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f37 ?v_0 ?v1) f1) (=> (= (f37 ?v_0 ?v2) f1) (= (f37 ?v_0 (f15 f16 (- (f3 f4 ?v1) (f3 f4 ?v2)))) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v2))) (=> (= ?v0 ?v1) (=> (and (= (f37 (f38 f39 ?v1) ?v2) f1) (not (= (f37 ?v_0 ?v1) f1))) (and (= (f37 (f38 f39 ?v0) ?v2) f1) (not (= (f37 ?v_0 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0)) (?v_1 (f38 f39 ?v2))) (=> (= (f37 ?v_0 ?v1) f1) (=> (and (= (f37 (f38 f39 ?v1) ?v2) f1) (not (= (f37 ?v_1 ?v1) f1))) (and (= (f37 ?v_0 ?v2) f1) (not (= (f37 ?v_1 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0)) (?v_1 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (=> (= (f37 ?v_0 (f15 f16 (- ?v_2 ?v_1))) f1) (=> (= (f37 ?v_0 ?v1) f1) (=> (<= ?v_1 ?v_2) (= (f37 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0)) (?v_1 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (=> (= (f37 ?v_0 (f15 f16 (- ?v_2 ?v_1))) f1) (=> (= (f37 ?v_0 ?v2) f1) (=> (<= ?v_1 ?v_2) (= (f37 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f37 (f38 f39 ?v0) ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (not (and ?v_0 (not ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (= (f37 (f38 f39 ?v0) ?v1) f1))) (=> (and ?v_0 (not (= (f37 (f38 f39 ?v1) ?v0) f1))) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (not (and ?v_0 (not ?v_1))) true)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f37 (f38 f39 ?v0) ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (and (= (f37 (f38 f39 ?v0) ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (= (=> (and ?v_0 (not ?v_1)) (= ?v2 f1)) true)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (and (= (f37 ?v_0 ?v1) f1) (not (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (= ?v1 ?v2) (and (= (f37 ?v_0 ?v2) f1) (not (= (f37 (f38 f39 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f38 f39 ?v0)) (?v_0 (f38 f39 ?v1))) (=> (and (= (f37 ?v_1 ?v1) f1) (not (= (f37 ?v_0 ?v0) f1))) (=> (= (f37 ?v_0 ?v2) f1) (and (= (f37 ?v_1 ?v2) f1) (not (= (f37 (f38 f39 ?v2) ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (and ?v_0 (not ?v_1)) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f38 f39 ?v0)) (?v_0 (f38 f39 ?v1)) (?v_2 (f38 f39 ?v2))) (=> (and (= (f37 ?v_1 ?v1) f1) (not (= (f37 ?v_0 ?v0) f1))) (=> (and (= (f37 ?v_0 ?v2) f1) (not (= (f37 ?v_2 ?v1) f1))) (and (= (f37 ?v_1 ?v2) f1) (not (= (f37 ?v_2 ?v0) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (= (f37 (f38 f39 ?v0) ?v1) f1)) (?v_0 (= (f37 (f38 f39 ?v1) ?v0) f1))) (=> (and ?v_1 (not ?v_0)) (=> (=> (not false) (and ?v_0 (not ?v_1))) false)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (f37 (f38 f39 (f15 f16 ?v0)) (f15 f16 ?v1)) f1) (= (f8 (f18 f33 ?v0) ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f8 (f18 f33 (f3 f4 ?v0)) (f3 f4 ?v1)) f1) (= (f37 (f38 f39 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f40 (f41 f42 (f15 f16 ?v0)) ?v1) (f15 f16 (f3 (f21 f22 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f37 (f38 f39 (f40 (f41 f42 ?v0) ?v1)) (f40 (f41 f42 ?v2) ?v1)) f1) (=> (not (= ?v1 (f15 f16 0))) (= (f37 (f38 f39 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f37 (f38 f39 (f40 (f41 f42 ?v0) ?v2)) (f40 (f41 f42 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f37 ?v_0 ?v1) f1) (= (f37 ?v_0 (f40 (f41 f42 ?v1) (f15 f16 (+ (f3 f4 ?v2) 1)))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (=> (= (f37 ?v_0 ?v1) f1) (=> (= (f37 ?v_0 (f15 f16 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) f1) (= (f37 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (or (= ?v1 (f15 f16 0)) (<= (f3 f4 ?v0) (f3 f4 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (and (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f37 (f38 f39 ?v1) ?v0) f1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f15 f16 (+ (f3 f4 ?v1) 1)))) (= (<= (f3 f4 (f40 (f41 f42 ?v0) ?v_0)) (f3 f4 (f40 (f41 f42 ?v2) ?v_0))) (<= (f3 f4 ?v0) (f3 f4 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f15 f16 (+ (f3 f4 ?v1) 1)))) (= (< (f3 f4 (f40 (f41 f42 ?v0) ?v_0)) (f3 f4 (f40 (f41 f42 ?v2) ?v_0))) (< (f3 f4 ?v0) (f3 f4 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f15 f16 (+ (f3 f4 ?v1) 1)))) (= (= (f40 (f41 f42 ?v0) ?v_0) (f40 (f41 f42 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f15 f16 1))) (= (= (f40 (f41 f42 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f15 f16 0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f15 f16 0))) (= (= (f40 (f41 f42 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f15 f16 0))) (=> (= (f37 (f38 f39 (f40 (f41 f42 ?v1) ?v0)) ?v2) f1) (= (f37 (f38 f39 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f8 f11 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f8 (f18 (f30 f31 ?v1) 0) ?v0) f1)) (=> (not (= (f8 (f18 f19 ?v0) ?v1) f1)) (= (f8 (f18 (f30 f31 (f12 f44 ?v_0)) (f3 (f21 f22 ?v1) (f15 f16 (f12 (f13 f45 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int)) (= (f12 f44 ?v0) (ite (<= ?v0 0) 1 (* ?v0 (f12 f44 (- ?v0 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (* ?v2 ?v0) ?v0)) (<= (f12 (f13 f45 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (* ?v2 ?v0)) (< (f12 (f13 f45 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (* ?v0 (f12 (f13 f45 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 f11 ?v0) f1) (=> (= (f8 (f18 (f30 f31 ?v1) 0) ?v0) f1) (= (f8 (f18 (f30 f31 0) (f3 (f21 f22 ?v1) (f15 f16 (f12 (f13 f45 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 f11 ?v0) f1) (=> (not (= (f8 (f18 (f30 f31 ?v1) 0) ?v0) f1)) (=> (not (= (f8 (f18 f19 ?v0) ?v1) f1)) (= (f8 (f18 (f30 f31 (f3 (f21 f22 ?v1) (f15 f16 (f12 (f13 f45 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 f11 ?v0) f1) (=> (not (= (f8 (f18 (f30 f31 ?v1) 0) ?v0) f1)) (=> (= (f8 (f18 f19 ?v0) ?v1) f1) (= (f8 (f18 (f30 f31 (f3 (f21 f22 ?v1) (f15 f16 (f12 (f13 f45 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f8 f11 ?v0) f1) (= (f8 (f18 (f30 f31 (f12 (f13 f14 ?v1) ?v0)) (f3 (f21 f22 ?v1) (f15 f16 (f12 (f13 f45 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f8 (f18 f33 ?v0) ?v1) f1) (= (f3 (f21 f22 (f12 (f13 f45 ?v1) ?v0)) ?v2) (f12 (f13 f45 (f3 (f21 f22 ?v1) ?v2)) (f3 (f21 f22 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f37 (f38 f39 ?v0) ?v1) f1) (= (f40 (f41 f42 (f40 (f41 f46 ?v1) ?v0)) ?v2) (f40 (f41 f46 (f40 (f41 f42 ?v1) ?v2)) (f40 (f41 f42 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_1 (f3 f4 ?v0)) (?v_0 (f21 f22 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f12 (f13 f45 (f3 ?v_0 ?v0)) ?v1) (f3 ?v_0 (f15 f16 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f12 (f13 f45 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f12 (f13 f45 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f15 f16 (f12 (f13 f45 ?v0) ?v1)) (f15 f16 (f12 (f13 f45 (f3 f4 (f15 f16 ?v0))) (f3 f4 (f15 f16 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f15 f16 (f12 (f13 f45 (f3 f4 (f15 f16 ?v0))) (f3 f4 (f15 f16 ?v1)))) (f15 f16 (f12 (f13 f45 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (* ?v1 ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f12 (f13 f45 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f12 (f13 f45 ?v1) ?v2) (f12 (f13 f45 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f12 (f13 f45 ?v0) ?v2) (f12 (f13 f45 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f12 (f13 f45 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f45 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f12 (f13 f45 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f12 (f13 f45 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f12 (f13 f45 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f12 (f13 f45 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f12 (f13 f45 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 S3)) (= (f15 f16 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f15 f16 ?v0)) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f12 (f13 f45 ?v0) ?v1) (ite (or (= ?v0 0) (= ?v1 0)) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (div ?v0 ?v1) (div (- ?v0) (- ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (< 0 ?v1))) (= (f12 (f13 f47 ?v0) ?v1) (ite (= ?v1 0) ?v0 (ite (= ?v0 0) 0 (ite (or (and (< 0 ?v0) ?v_0) (and (< ?v0 0) ?v_0)) (mod ?v0 ?v1) (- (mod (- ?v0) (- ?v1))))))))))
(check-sat)
(exit)
