(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) Int)
(declare-fun f4 () S3)
(declare-fun f5 () S2)
(declare-fun f6 () Int)
(declare-fun f7 (Int) S1)
(declare-fun f8 () S2)
(declare-fun f9 (S4 Int) S2)
(declare-fun f10 () S4)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 (Int) S1)
(declare-fun f14 (S5 Int) Int)
(declare-fun f15 (S6 Int) S5)
(declare-fun f16 () S6)
(declare-fun f17 (Int Int) S1)
(declare-fun f18 () S2)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (S7 Int) S3)
(declare-fun f22 () S7)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 S2)) (let ((?v_0 (f3 f4 ?v0)) (?v_1 (+ (* 4 f6) 1))) (let ((?v_2 (+ 1 ?v_0))) (and (< ?v_0 (f3 f4 f5)) (not (=> (< ?v_2 ?v_1) (not (= (f7 (* ?v_1 ?v_2)) f1))))))))))
(assert (and (= f8 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1))) (= (f7 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f8)))) f1)))
(assert (< (f3 f4 f8) (f3 f4 f5)))
(assert (< (+ 1 (f3 f4 f8)) (+ (* 4 f6) 1)))
(assert (< 0 f11))
(assert (= (+ 1 (f3 f4 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1)))) f11))
(assert (< 1 f12))
(assert (< (+ 1 (f3 f4 f8)) (+ (* 4 f6) 1)))
(assert (< (f3 f4 f8) (f3 f4 f5)))
(assert (< 0 (f3 f4 f5)))
(assert (and (= f8 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1))) (= (f7 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f8)))) f1)))
(assert (not (= (f7 (* (+ (* 4 f6) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (< 0 (+ 1 (f3 f4 f5))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f5)))) (not (=> (< ?v_1 ?v_0) (not (= (f7 (* ?v_0 ?v_1)) f1))))))
(assert (< f11 (+ 1 (f3 f4 f5))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f5)))) (and (< ?v_1 ?v_0) (= (f7 (* ?v_0 ?v_1)) f1))))
(assert (= (f7 (* (+ (* 4 f6) 1) f11)) f1))
(assert (= (f7 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1)))))) f1))
(assert (= (f13 (+ (* 4 f6) 1)) f1))
(assert (= (f14 (f15 f16 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (=> (forall ((?v0 S2)) (=> (and (= ?v0 (f9 f10 (- (f3 f4 (f9 f10 f11)) 1))) (= (f7 (* (+ (* 4 f6) 1) (+ 1 (f3 f4 ?v0)))) f1)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (= (f7 ?v1) f1) (= (f7 (* ?v0 ?v1)) f1)))))
(assert (= (f17 (+ (* 4 f6) 1) (- 1)) f1))
(assert (= f18 (f9 f10 (- (f3 f4 (f9 f10 f12)) 1))))
(assert (= (f7 (* (+ (* 4 f6) 1) f12)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f19 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f20 (* ?v0 ?v_0))) (<= (* 2 (ite (< ?v1 0) (- ?v1) ?v1)) ?v_0)) false))) false))
(assert (< f12 (+ (* 4 f6) 1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f3 (f21 f22 ?v0) ?v_0) (f3 (f21 f22 ?v1) ?v_0)) (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f5)))) false))) false))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f3 (f21 f22 f19) ?v_0) (f3 (f21 f22 f20) ?v_0)) (* (+ (* 4 f6) 1) (+ 1 (f3 f4 f5))))))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f17 ?v_0 (- 1)) f1)) (not (= (f14 (f15 f16 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f23 (- f19 (* f24 ?v_0))) (<= (* 2 (ite (< f23 0) (- f23) f23)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f25 (- f20 (* f26 ?v_0))) (<= (* 2 (ite (< f25 0) (- f25) f25)) ?v_0))))
(assert (<= 1 f12))
(assert (< 0 (f3 f4 f18)))
(assert (forall ((?v0 S2)) (= (f9 f10 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
