(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 (S4 Int) S3)
(declare-fun f6 () S4)
(declare-fun f7 () Int)
(declare-fun f8 () S3)
(declare-fun f9 () Int)
(declare-fun f10 (Int) S1)
(declare-fun f11 (S5 Int) S2)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 (S6 S7) Int)
(declare-fun f15 () S6)
(declare-fun f16 (Int Int) S7)
(declare-fun f17 (Int) S1)
(declare-fun f18 (S8 Int) Int)
(declare-fun f19 (S9 Int) S8)
(declare-fun f20 () S9)
(declare-fun f21 (Int Int) S1)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 (Int Int Int) S1)
(declare-fun f24 () Int)
(assert (not (= f1 f2)))
(assert (not (= (+ 1 (f3 f4 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1)))) f7)))
(assert (<= 1 f7))
(assert (< 0 (f3 f4 f8)))
(assert (<= 1 f7))
(assert (< 1 f7))
(assert (= f8 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (< f7 (+ (* 4 f9) 1)))
(assert (not (= (f10 (* (+ (* 4 f9) 1) (+ 1 (f3 f4 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1)))))) f1)))
(assert (= (f10 (* (+ (* 4 f9) 1) f7)) f1))
(assert (and (< (+ 1 (f3 f4 f8)) (+ (* 4 f9) 1)) (= f8 (f5 f6 (- (f3 f4 (f5 f6 f7)) 1)))))
(assert (= (+ (f3 (f11 f12 f13) (f5 f6 2)) 1) (* (+ (* 4 f9) 1) f7)))
(assert (=> (= f7 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 f6 2))) (= (+ (f3 (f11 f12 ?v0) ?v_0) (f3 (f11 f12 ?v1) ?v_0)) (+ (* 4 f9) 1))))))
(assert (= (f14 f15 (f16 f13 1)) (* (+ (* 4 f9) 1) f7)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (= (f10 ?v1) f1) (= (f10 (* ?v0 ?v1)) f1)))))
(assert (not (= (f10 (* (+ (* 4 f9) 1) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f9) 1)))
(assert (let ((?v_0 (f3 (f11 f12 f13) (f5 f6 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f9) 1)) (?v_1 (+ 1 (f3 f4 f8)))) (=> (< ?v_1 ?v_0) (not (= (f10 (* ?v_0 ?v_1)) f1)))))
(assert (= (f17 (+ (* 4 f9) 1)) f1))
(assert (= (f18 (f19 f20 (- 1)) (+ (* 4 f9) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f11 f12 f13) (f5 f6 2)) 1) (* (+ (* 4 f9) 1) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (* (f14 f15 (f16 ?v0 ?v1)) (f14 f15 (f16 ?v2 ?v3))) (f14 f15 (f16 (+ (* ?v0 ?v2) (* ?v1 ?v3)) (- (* ?v0 ?v3) (* ?v1 ?v2)))))))
(assert (= (f21 (+ (* 4 f9) 1) (- 1)) f1))
(assert (forall ((?v0 Int)) (= (= (f10 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f14 f15 (f16 ?v1 ?v2)) ?v0)))))
(assert (= (f22 (+ (* 4 f9) 1) (+ (f3 (f11 f12 f13) (f5 f6 2)) 1)) f1))
(assert (= (f22 (+ (* 4 f9) 1) (- (f3 (f11 f12 f13) (f5 f6 2)) (- 1))) f1))
(assert (= (f23 (f3 (f11 f12 f13) (f5 f6 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (and (<= 0 f13) (and (< f13 ?v_0) (= (f23 f24 f13 ?v_0) f1)))))
(assert (= (f23 (f3 (f11 f12 f24) (f5 f6 2)) (- 1) (+ (* 4 f9) 1)) f1))
(assert (let ((?v_0 (f5 f6 2))) (= (f23 (f3 (f11 f12 f13) ?v_0) (f3 (f11 f12 f24) ?v_0) (+ (* 4 f9) 1)) f1)))
(assert (let ((?v_0 (+ (* 4 f9) 1))) (=> (not (= (f21 ?v_0 (- 1)) f1)) (not (= (f18 (f19 f20 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f23 (f3 (f11 f12 ?v0) (f5 f6 2)) (- 1) (+ (* 4 f9) 1)) f1) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f9) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f24 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 S3)) (= (f5 f6 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
