(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun NULL_CHECK (Int) Int)
(declare-fun LIFT (Int) Int)
(declare-fun BIT_BAND (Int Int) Int)
(declare-fun POW2 (Int) Int)
(declare-fun choose (Int Int Int) Int)
(declare-fun DIV (Int Int) Int)
(declare-fun MULT (Int Int) Int)
(declare-fun PLUS (Int Int Int) Int)
(declare-fun MINUS_LEFT_PTR (Int Int Int) Int)
(declare-fun MINUS_BOTH_PTR_OR_BOTH_INT (Int Int Int) Int)
(declare-fun g_fooInv (Int) Int)
(declare-fun g_foo (Int) Int)
(declare-fun S_g_fooInv (Int) Int)
(declare-fun S_g_foo (Int) Int)
(declare-fun f_fooInv (Int) Int)
(declare-fun f_foo (Int) Int)
(declare-fun S_f_fooInv (Int) Int)
(declare-fun S_f_foo (Int) Int)
(declare-fun i_barInv (Int) Int)
(declare-fun i_bar (Int) Int)
(declare-fun S_i_barInv (Int) Int)
(declare-fun S_i_bar (Int) Int)
(declare-fun h_barInv (Int) Int)
(declare-fun h_bar (Int) Int)
(declare-fun S_h_barInv (Int) Int)
(declare-fun S_h_bar (Int) Int)
(declare-fun Match (Int Int) Int)
(declare-fun foo_name () Int)
(declare-fun i_bar_name () Int)
(declare-fun h_bar_name () Int)
(declare-fun bar_name () Int)
(declare-fun HasType (Int Int) Int)
(declare-fun Pfoo_name () Int)
(declare-fun Field (Int) Int)
(declare-fun Pbar_name () Int)
(declare-fun PPfoo_name () Int)
(declare-fun PPbar_name () Int)
(declare-fun INT4_name () Int)
(declare-fun PINT4_name () Int)
(declare-fun g_foo_name () Int)
(declare-fun f_foo_name () Int)
(declare-fun Values (Int) Int)
(declare-fun Unified (Int) Int)
(declare-fun Disjoint (Int Int) Int)
(declare-fun Subset (Int Int) Int)
(declare-fun Equal (Int Int) Int)
(declare-fun Inverse (Int Int) Int)
(declare-fun Difference (Int Int) Int)
(declare-fun Singleton (Int) Int)
(declare-fun Union (Int Int) Int)
(declare-fun Dereference (Int Int) Int)
(declare-fun Intersection (Int Int) Int)
(declare-fun Empty () Int)
(declare-fun HavocArray (Int Int Int) Int)
(declare-fun AtLeast (Int Int) Int)
(declare-fun Rep (Int Int) Int)
(declare-fun FourBytesToInt (Int Int Int Int) Int)
(declare-fun TwoBytesToInt (Int Int) Int)
(declare-fun OneByteToInt (Int) Int)
(declare-fun BYTE () Int)
(declare-fun FREED () Int)
(declare-fun ALLOCATED () Int)
(declare-fun UNALLOCATED () Int)
(declare-fun result_main_20_4_1__0 () Int)
(declare-fun Base (Int) Int)
(declare-fun alloc_1 () Int)
(declare-fun alloc () Int)
(declare-fun Mem_1 () Int)
(declare-fun Mem () Int)
(declare-fun call4953formal_new_0 () Int)
(declare-fun alloc_0 () Int)
(declare-fun pb () Int)
(declare-fun Mem_0 () Int)
(declare-fun result_main_20_4_1_ () Int)
(declare-fun pf () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct UNALLOCATED ALLOCATED FREED BYTE h_bar_name i_bar_name f_foo_name g_foo_name INT4_name PINT4_name PPbar_name PPfoo_name Pbar_name Pfoo_name bar_name foo_name)) (not (forall ((?b0 Int) (?c0 Int)) (! (=> (= (OneByteToInt ?b0) (OneByteToInt ?c0)) (= ?b0 ?c0)) :pattern ((OneByteToInt ?b0) (OneByteToInt ?c0)) ))) (not (forall ((?b0 Int) (?b1 Int) (?c0 Int) (?c1 Int)) (! (=> (= (TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1))))) :pattern ((TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) ))) (not (forall ((?b0 Int) (?b1 Int) (?b2 Int) (?b3 Int) (?c0 Int) (?c1 Int) (?c2 Int) (?c3 Int)) (! (=> (= (FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1)) (not (= ?b2 ?c2)) (not (= ?b3 ?c3))))) :pattern ((FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (= (select1 (AtLeast ?n ?x_1) ?y) true_1) (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y)))))) :pattern ((select1 (AtLeast ?n ?x_1) ?y)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y))))) (= (select1 (AtLeast ?n ?x_1) ?y) true_1)) :pattern ((AtLeast ?n ?x_1) (Rep ?n ?x_1) (Rep ?n ?y)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (= (select1 (AtLeast ?n ?x_1) ?x_1) true_1) :pattern ((AtLeast ?n ?x_1)) ))) (not (forall ((?n Int) (?x_1 Int) (?z Int)) (! (= (Rep ?n ?x_1) (Rep ?n (PLUS ?x_1 ?n ?z))) :pattern ((PLUS ?x_1 ?n ?z)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (exists ((?k Int)) (= (- (Rep ?n ?x_1) ?x_1) (* ?n ?k))) :pattern ((Rep ?n ?x_1)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (<= ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) Empty) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (> ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) (Difference (AtLeast ?n ?x_1) (AtLeast ?n (PLUS ?x_1 ?n ?z)))) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int)) (not (= (select1 Empty ?x_1) true_1)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (select1 (Singleton ?y) ?x_1) true_1) (= ?x_1 ?y)) :pattern ((select1 (Singleton ?y) ?x_1)) ))) (not (forall ((?y Int)) (! (= (select1 (Singleton ?y) ?y) true_1) :pattern ((Singleton ?y)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Union ?S ?T) ?x_1) true_1) (or (= (select1 ?S ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((select1 (Union ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?T ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Intersection ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 (Intersection ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Difference ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((select1 (Difference ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (or (= (select1 (Difference ?S ?T) ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((Difference ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 (Dereference ?S ?M) ?x_1) true_1) (exists ((?y Int)) (not (or (not (= ?x_1 (select1 ?M ?y))) (not (= (select1 ?S ?y) true_1)))))) :pattern ((select1 (Dereference ?S ?M) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Dereference ?S ?M) (select1 ?M ?x_1)) true_1)) :pattern ((select1 ?M ?x_1) (select1 ?S ?x_1) (Dereference ?S ?M)) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (= (select1 ?S ?x_1) true_1)) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Dereference ?S ?M)) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (let ((?v_0 (select1 ?M ?x_1))) (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Equal (Intersection (Inverse ?M ?v_0) ?S) (Singleton ?x_1)) true_1)))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Difference (Dereference ?S ?M) (Singleton ?v_0)) (Singleton ?y))) true_1))) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (Equal (Intersection (Inverse ?M (select1 ?M ?x_1)) ?S) (Singleton ?x_1)) true_1))))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Dereference ?S ?M) (Singleton ?y))) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?f Int) (?x_1 Int)) (! (= (select1 (Inverse ?f (select1 ?f ?x_1)) ?x_1) true_1) :pattern ((Inverse ?f (select1 ?f ?x_1))) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int)) (! (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?y) (Union (Inverse ?f ?y) (Singleton ?x_1))) true_1) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?y)) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int) (?z Int)) (! (or (= ?y ?z) (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?z) (Difference (Inverse ?f ?z) (Singleton ?x_1))) true_1)) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?z)) ))) (not (forall ((?S Int) (?T Int)) (! (= (= (Equal ?S ?T) true_1) (not (or (not (= (Subset ?S ?T) true_1)) (not (= (Subset ?T ?S) true_1))))) :pattern ((Equal ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Subset ?S ?T) true_1)))) (= (select1 ?T ?x_1) true_1)) :pattern ((select1 ?S ?x_1) (Subset ?S ?T)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Subset ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1))))))) :pattern ((Subset ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (not (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Disjoint ?S ?T) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 ?S ?x_1) (Disjoint ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Disjoint ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((Disjoint ?S ?T)) ))) (not (forall ((?M Int) (?x_1 Int)) (! (= (select1 (Unified ?M) ?x_1) (select1 (select1 ?M (Field ?x_1)) ?x_1)) :pattern ((select1 (Unified ?M) ?x_1)) ))) (not (forall ((?M Int) (?x_1 Int) (?y Int)) (! (let ((?v_1 (Field ?x_1))) (= (Unified (store1 ?M ?v_1 (store1 (select1 ?M ?v_1) ?x_1 ?y))) (store1 (Unified ?M) ?x_1 ?y))) :pattern ((Unified (store1 ?M (Field ?x_1) (store1 (select1 ?M (Field ?x_1)) ?x_1 ?y)))) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (select1 (Values ?t) ?v) true_1) (= (HasType ?v ?t) true_1)) :pattern ((select1 (Values ?t) ?v)) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (HasType ?v ?t) true_1) (= (select1 (Values ?t) ?v) true_1)) :pattern ((HasType ?v ?t) (Values ?t)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a h_bar_name) true_1) (= (Field ?a) h_bar_name)) :pattern ((Match ?a h_bar_name)) ))) (not (forall ((?v Int)) (= (HasType ?v h_bar_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a i_bar_name) true_1) (= (Field ?a) i_bar_name)) :pattern ((Match ?a i_bar_name)) ))) (not (forall ((?v Int)) (= (HasType ?v i_bar_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a f_foo_name) true_1) (= (Field ?a) f_foo_name)) :pattern ((Match ?a f_foo_name)) ))) (not (forall ((?v Int)) (= (HasType ?v f_foo_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a g_foo_name) true_1) (= (Field ?a) g_foo_name)) :pattern ((Match ?a g_foo_name)) ))) (not (forall ((?v Int)) (= (HasType ?v g_foo_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a INT4_name) true_1) (= (Field ?a) INT4_name)) :pattern ((Match ?a INT4_name)) ))) (not (forall ((?v Int)) (= (HasType ?v INT4_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a PINT4_name) true_1) (= (Field ?a) PINT4_name)) :pattern ((Match ?a PINT4_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PINT4_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v INT4_name) true_1)))))) :pattern ((HasType ?v PINT4_name))  :pattern ((Match ?v INT4_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PPbar_name) true_1) (= (Field ?a) PPbar_name)) :pattern ((Match ?a PPbar_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PPbar_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v Pbar_name) true_1)))))) :pattern ((HasType ?v PPbar_name))  :pattern ((Match ?v Pbar_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PPfoo_name) true_1) (= (Field ?a) PPfoo_name)) :pattern ((Match ?a PPfoo_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PPfoo_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v Pfoo_name) true_1)))))) :pattern ((HasType ?v PPfoo_name))  :pattern ((Match ?v Pfoo_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a Pbar_name) true_1) (= (Field ?a) Pbar_name)) :pattern ((Match ?a Pbar_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v Pbar_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v bar_name) true_1)))))) :pattern ((HasType ?v Pbar_name))  :pattern ((Match ?v bar_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a Pfoo_name) true_1) (= (Field ?a) Pfoo_name)) :pattern ((Match ?a Pfoo_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v Pfoo_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v foo_name) true_1)))))) :pattern ((HasType ?v Pfoo_name))  :pattern ((Match ?v foo_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a bar_name) true_1) (not (or (not true) (not (= (Match (h_bar ?a) h_bar_name) true_1)) (not (= (Match (i_bar ?a) i_bar_name) true_1))))) :pattern ((Match ?a bar_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a foo_name) true_1) (not (or (not true) (not (= (Match (f_foo ?a) h_bar_name) true_1)) (not (= (Match (g_foo ?a) i_bar_name) true_1))))) :pattern ((Match ?a foo_name)) ))) (not (forall ((?x_1 Int)) (! (= (h_barInv (h_bar ?x_1)) ?x_1) :pattern ((h_bar ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (h_bar (h_barInv ?x_1)) ?x_1) :pattern ((h_barInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_h_bar ?S) ?x_1) true_1) (= (select1 ?S (h_barInv ?x_1)) true_1)) :pattern ((select1 (S_h_bar ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_h_barInv ?S) ?x_1) true_1) (= (select1 ?S (h_bar ?x_1)) true_1)) :pattern ((select1 (S_h_barInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_h_bar ?S) (h_bar ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_h_bar ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_h_barInv ?S) (h_barInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_h_barInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (h_bar ?x_1) (+ ?x_1 0)) :pattern ((h_bar ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (h_barInv ?x_1) (- ?x_1 0)) :pattern ((h_barInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1) (h_barInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 0) (h_barInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 0)) ))) (not (forall ((?x_1 Int)) (! (= (i_barInv (i_bar ?x_1)) ?x_1) :pattern ((i_bar ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (i_bar (i_barInv ?x_1)) ?x_1) :pattern ((i_barInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_i_bar ?S) ?x_1) true_1) (= (select1 ?S (i_barInv ?x_1)) true_1)) :pattern ((select1 (S_i_bar ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_i_barInv ?S) ?x_1) true_1) (= (select1 ?S (i_bar ?x_1)) true_1)) :pattern ((select1 (S_i_barInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_i_bar ?S) (i_bar ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_i_bar ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_i_barInv ?S) (i_barInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_i_barInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (i_bar ?x_1) (+ ?x_1 4)) :pattern ((i_bar ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (i_barInv ?x_1) (- ?x_1 4)) :pattern ((i_barInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1) (i_barInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 4) (i_barInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 4)) ))) (not (forall ((?x_1 Int)) (! (= (f_fooInv (f_foo ?x_1)) ?x_1) :pattern ((f_foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (f_foo (f_fooInv ?x_1)) ?x_1) :pattern ((f_fooInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_f_foo ?S) ?x_1) true_1) (= (select1 ?S (f_fooInv ?x_1)) true_1)) :pattern ((select1 (S_f_foo ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_f_fooInv ?S) ?x_1) true_1) (= (select1 ?S (f_foo ?x_1)) true_1)) :pattern ((select1 (S_f_fooInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_f_foo ?S) (f_foo ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_f_foo ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_f_fooInv ?S) (f_fooInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_f_fooInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (f_foo ?x_1) (+ ?x_1 0)) :pattern ((f_foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (f_fooInv ?x_1) (- ?x_1 0)) :pattern ((f_fooInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1) (f_fooInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 0) (f_fooInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 0)) ))) (not (forall ((?x_1 Int)) (! (= (g_fooInv (g_foo ?x_1)) ?x_1) :pattern ((g_foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (g_foo (g_fooInv ?x_1)) ?x_1) :pattern ((g_fooInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_g_foo ?S) ?x_1) true_1) (= (select1 ?S (g_fooInv ?x_1)) true_1)) :pattern ((select1 (S_g_foo ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_g_fooInv ?S) ?x_1) true_1) (= (select1 ?S (g_foo ?x_1)) true_1)) :pattern ((select1 (S_g_fooInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_g_foo ?S) (g_foo ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_g_foo ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_g_fooInv ?S) (g_fooInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_g_fooInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (g_foo ?x_1) (+ ?x_1 4)) :pattern ((g_foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (g_fooInv ?x_1) (- ?x_1 4)) :pattern ((g_fooInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1) (g_fooInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 4) (g_fooInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 4)) ))) (not (forall ((?a Int) (?b Int) (?size Int)) (! (let ((?v_3 (MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) (?v_2 (- ?a ?b))) (not (or (not (<= (* ?size ?v_3) ?v_2)) (not (< ?v_2 (* ?size (+ ?v_3 1))))))) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (MINUS_LEFT_PTR ?a ?a_size ?b) (- ?a (* ?a_size ?b))) :pattern ((MINUS_LEFT_PTR ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (PLUS ?a ?a_size ?b) (+ ?a (* ?a_size ?b))) :pattern ((PLUS ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (MULT ?a ?b) (* ?a ?b)) :pattern ((MULT ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_4 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (> ?b 0)))) (not (or (not (<= (* ?b ?v_4) ?a)) (not (< ?a (* ?b (+ ?v_4 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_5 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (< ?b 0)))) (not (or (not (<= (* ?b ?v_5) ?a)) (not (< ?a (* ?b (- ?v_5 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_6 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (> ?b 0)))) (not (or (not (>= (* ?b ?v_6) ?a)) (not (> ?a (* ?b (- ?v_6 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_7 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (< ?b 0)))) (not (or (not (>= (* ?b ?v_7) ?a)) (not (> ?a (* ?b (+ ?v_7 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (= (POW2 1) true_1)) (not (= (POW2 2) true_1)) (not (= (POW2 4) true_1)) (not (= (POW2 8) true_1)) (not (= (POW2 16) true_1)) (not (= (POW2 32) true_1)) (not (= (POW2 64) true_1)) (not (= (POW2 128) true_1)) (not (= (POW2 256) true_1)) (not (= (POW2 512) true_1)) (not (= (POW2 1024) true_1)) (not (= (POW2 2048) true_1)) (not (= (POW2 4096) true_1)) (not (= (POW2 8192) true_1)) (not (= (POW2 16384) true_1)) (not (= (POW2 32768) true_1)) (not (= (POW2 65536) true_1)) (not (= (POW2 131072) true_1)) (not (= (POW2 262144) true_1)) (not (= (POW2 524288) true_1)) (not (= (POW2 1048576) true_1)) (not (= (POW2 2097152) true_1)) (not (= (POW2 4194304) true_1)) (not (= (POW2 8388608) true_1)) (not (= (POW2 16777216) true_1)) (not (= (POW2 33554432) true_1)) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (= ?a true_1) (= (choose ?a ?b ?c) ?b)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (not (= ?a true_1)) (= (choose ?a ?b ?c) ?c)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= ?a ?b) (= (BIT_BAND ?a ?b) ?a)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (not (or (not (= (POW2 ?a) true_1)) (not (= (POW2 ?b) true_1)) (not (not (= ?a ?b))))) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (or (= ?a 0) (= ?b 0)) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int)) (! (= (= ?a true_1) (not (= (LIFT ?a) 0))) :pattern ((LIFT ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (boolNot ?a) 0))) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (boolNot ?a) 0)) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (NULL_CHECK ?a) 0))) :pattern ((NULL_CHECK ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (NULL_CHECK ?a) 0)) :pattern ((NULL_CHECK ?a)) ))))))
(assert (let ((?v_28 (= result_main_20_4_1__0 0)) (?v_27 (forall ((?f Int)) (! (let ((?v_30 (Base ?f))) (let ((?v_29 (select1 alloc ?v_30))) (or (= ?v_29 UNALLOCATED) (= ?v_29 (select1 alloc_1 ?v_30))))) :pattern ((select1 alloc_1 (Base ?f))) ))) (?v_26 (forall ((?f Int) (?m Int)) (! (= (select1 (select1 Mem_1 ?f) ?m) (select1 (select1 Mem ?f) ?m)) :pattern ((select1 (select1 Mem_1 ?f) ?m)) ))) (?v_15 (forall ((?a Int)) (! (let ((?v_31 (Field ?a))) (= (HasType (select1 (select1 Mem_1 ?v_31) ?a) ?v_31) true_1)) :pattern ((select1 (select1 Mem_1 (Field ?a)) ?a)) )))) (let ((?v_16 (not ?v_15)) (?v_25 (= (HasType result_main_20_4_1__0 INT4_name) true_1)) (?v_24 (= (select1 alloc_0 call4953formal_new_0) ALLOCATED))) (let ((?v_23 (not ?v_24)) (?v_22 (= (Base call4953formal_new_0) call4953formal_new_0)) (?v_21 (i_bar call4953formal_new_0)) (?v_20 (h_bar call4953formal_new_0))) (let ((?v_19 (= (select1 alloc_0 (Base ?v_21)) ALLOCATED)) (?v_5 (not (= call4953formal_new_0 0)))) (let ((?v_11 (not ?v_5)) (?v_18 (= (select1 alloc_0 (Base ?v_20)) ALLOCATED)) (?v_2 (= (HasType call4953formal_new_0 Pfoo_name) true_1))) (let ((?v_4 (not ?v_2)) (?v_17 (= (HasType call4953formal_new_0 Pbar_name) true_1)) (?v_3 (= (HasType pb Pbar_name) true_1))) (let ((?v_10 (not ?v_3)) (?v_13 (g_foo call4953formal_new_0))) (let ((?v_14 (Field ?v_13)) (?v_12 (= (select1 alloc_0 (Base ?v_13)) ALLOCATED)) (?v_9 (forall ((?a Int)) (! (let ((?v_32 (Field ?a))) (= (HasType (select1 (select1 Mem_0 ?v_32) ?a) ?v_32) true_1)) :pattern ((select1 (select1 Mem_0 (Field ?a)) ?a)) ))) (?v_7 (f_foo call4953formal_new_0))) (let ((?v_8 (Field ?v_7)) (?v_6 (= (select1 alloc_0 (Base ?v_7)) ALLOCATED)) (?v_1 (forall ((?a Int)) (! (let ((?v_33 (Field ?a))) (= (HasType (select1 (select1 Mem ?v_33) ?a) ?v_33) true_1)) :pattern ((select1 (select1 Mem (Field ?a)) ?a)) ))) (?v_0 (>= 8 0))) (not (=> true (=> ?v_1 (=> true (not (or (not ?v_0) (not (=> ?v_0 (=> (> call4953formal_new_0 0) (=> (forall ((?x_1 Int)) (! (=> (not (or (not (<= call4953formal_new_0 ?x_1)) (not (< ?x_1 (+ call4953formal_new_0 8))))) (= (Base ?x_1) call4953formal_new_0)) :pattern ((Base ?x_1)) )) (=> (forall ((?x_1 Int)) (! (or (= ?x_1 call4953formal_new_0) (= (select1 alloc ?x_1) (select1 alloc_0 ?x_1))) :pattern ((select1 alloc_0 ?x_1)) )) (=> (not (or (not (= (select1 alloc call4953formal_new_0) UNALLOCATED)) ?v_23)) (=> ?v_2 (=> (not (or (not (= (Subset Empty (HavocArray call4953formal_new_0 8 1)) true_1)) (not (forall ((?x_2 Int)) (! (=> (= (select1 (HavocArray call4953formal_new_0 8 1) ?x_2) true_1) (= (Match ?x_2 foo_name) true_1)) :pattern ((select1 (HavocArray call4953formal_new_0 8 1) ?x_2)) ))))) (=> (= (Match call4953formal_new_0 foo_name) true_1) (=> ?v_3 (=> (= (HasType pf Pfoo_name) true_1) (=> (= (HasType result_main_20_4_1_ INT4_name) true_1) (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> true (not (or (not ?v_1) (not (=> ?v_1 (not (or ?v_4 (not (=> ?v_2 (not (or ?v_10 (not (=> ?v_3 (not (or ?v_4 (not (=> ?v_2 (=> true (=> true (=> true (not (or ?v_11 (not (=> ?v_5 (not (or (not ?v_6) (not (=> ?v_6 (=> (= Mem_0 (store1 Mem ?v_8 (store1 (select1 Mem ?v_8) ?v_7 42))) (not (or (not ?v_9) (not (=> ?v_9 (not (or ?v_4 (not (=> ?v_2 (not (or ?v_10 (not (=> ?v_3 (not (or ?v_4 (not (=> ?v_2 (=> true (=> true (=> true (not (or ?v_11 (not (=> ?v_5 (not (or (not ?v_12) (not (=> ?v_12 (=> (= Mem_1 (store1 Mem_0 ?v_14 (store1 (select1 Mem_0 ?v_14) ?v_13 7))) (not (or ?v_16 (not (=> ?v_15 (not (or ?v_4 (not (=> ?v_2 (not (or ?v_10 (not (=> ?v_3 (not (or ?v_4 (not (=> ?v_2 (=> true (=> true (=> true (not (or ?v_16 (not (=> ?v_15 (not (or ?v_4 (not (=> ?v_2 (not (or (not ?v_17) (not (=> ?v_17 (not (or ?v_4 (not (=> ?v_2 (=> true (=> true (=> true (not (or ?v_11 (not (=> ?v_5 (not (or (not ?v_18) (not (=> ?v_18 (not (or ?v_11 (not (=> ?v_5 (not (or (not ?v_19) (not (=> ?v_19 (=> (= result_main_20_4_1__0 (MINUS_BOTH_PTR_OR_BOTH_INT (MINUS_BOTH_PTR_OR_BOTH_INT 49 (select1 (select1 Mem_1 (Field ?v_20)) ?v_20) 1) (select1 (select1 Mem_1 (Field ?v_21)) ?v_21) 1)) (=> true (=> true (=> true (not (or (not ?v_22) (not (=> ?v_22 (not (or ?v_23 (not (=> ?v_24 (=> (forall ((?x_1 Int)) (! (or (= ?x_1 call4953formal_new_0) (= (select1 alloc_0 ?x_1) (select1 alloc_1 ?x_1))) :pattern ((select1 alloc_1 ?x_1)) )) (=> (= (select1 alloc_1 call4953formal_new_0) FREED) (=> (forall ((?m Int)) (! (let ((?v_35 (Field ?m)) (?v_34 (Base ?m))) (=> (not (or (not (not (= (select1 alloc_1 ?v_34) ALLOCATED))) (not (not (= (select1 alloc ?v_34) ALLOCATED))))) (= (select1 (select1 Mem_1 ?v_35) ?m) (select1 (select1 Mem ?v_35) ?m)))) :pattern ((select1 (select1 Mem_1 (Field ?m)) ?m)) )) (=> true (=> true (not (or (not ?v_25) (not (=> ?v_25 (not (or ?v_16 (not (=> ?v_15 (not (or (not ?v_26) (not (=> ?v_26 (not (or (not ?v_27) (not (=> ?v_27 (not (or (not ?v_28) (not (=> ?v_28 true)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
