(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun NULL_CHECK (Int) Int)
(declare-fun LIFT (Int) Int)
(declare-fun BIT_BAND (Int Int) Int)
(declare-fun POW2 (Int) Int)
(declare-fun choose (Int Int Int) Int)
(declare-fun DIV (Int Int) Int)
(declare-fun MULT (Int Int) Int)
(declare-fun PLUS (Int Int Int) Int)
(declare-fun MINUS_LEFT_PTR (Int Int Int) Int)
(declare-fun MINUS_BOTH_PTR_OR_BOTH_INT (Int Int Int) Int)
(declare-fun HasType (Int Int) Int)
(declare-fun UINT4_name () Int)
(declare-fun Match (Int Int) Int)
(declare-fun Field (Int) Int)
(declare-fun PINT4_name () Int)
(declare-fun PPINT4_name () Int)
(declare-fun INT4_name () Int)
(declare-fun Values (Int) Int)
(declare-fun Unified (Int) Int)
(declare-fun Disjoint (Int Int) Int)
(declare-fun Subset (Int Int) Int)
(declare-fun Equal (Int Int) Int)
(declare-fun Inverse (Int Int) Int)
(declare-fun Difference (Int Int) Int)
(declare-fun Singleton (Int) Int)
(declare-fun Union (Int Int) Int)
(declare-fun Dereference (Int Int) Int)
(declare-fun Intersection (Int Int) Int)
(declare-fun Empty () Int)
(declare-fun HavocArray (Int Int Int) Int)
(declare-fun AtLeast (Int Int) Int)
(declare-fun Rep (Int Int) Int)
(declare-fun FourBytesToInt (Int Int Int Int) Int)
(declare-fun TwoBytesToInt (Int Int) Int)
(declare-fun OneByteToInt (Int) Int)
(declare-fun BYTE () Int)
(declare-fun FREED () Int)
(declare-fun ALLOCATED () Int)
(declare-fun UNALLOCATED () Int)
(declare-fun Base (Int) Int)
(declare-fun alloc_2 () Int)
(declare-fun alloc () Int)
(declare-fun Mem_2 () Int)
(declare-fun Mem () Int)
(declare-fun result_main_19_5_1_ () Int)
(declare-fun i_2 () Int)
(declare-fun i_4 () Int)
(declare-fun tmp1_0 () Int)
(declare-fun tmp1_2 () Int)
(declare-fun Mem_0 () Int)
(declare-fun LOOP_21_Mem_0 () Int)
(declare-fun alloc_0 () Int)
(declare-fun LOOP_21_alloc_0 () Int)
(declare-fun alloc_1 () Int)
(declare-fun tmp2_0 () Int)
(declare-fun tmp2_2 () Int)
(declare-fun call3675formal_new_0 () Int)
(declare-fun tmp2_1 () Int)
(declare-fun result_free_46_6_3_ () Int)
(declare-fun i_3 () Int)
(declare-fun tmp2 () Int)
(declare-fun i_0 () Int)
(declare-fun tmp1_1 () Int)
(declare-fun i_1 () Int)
(declare-fun Mem_1 () Int)
(declare-fun tmp1 () Int)
(declare-fun result_malloc_21_23_2_ () Int)
(declare-fun a_2_21_7_main () Int)
(declare-fun i () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct UNALLOCATED ALLOCATED FREED BYTE INT4_name PINT4_name PPINT4_name UINT4_name)) (not (forall ((?b0 Int) (?c0 Int)) (! (=> (= (OneByteToInt ?b0) (OneByteToInt ?c0)) (= ?b0 ?c0)) :pattern ((OneByteToInt ?b0) (OneByteToInt ?c0)) ))) (not (forall ((?b0 Int) (?b1 Int) (?c0 Int) (?c1 Int)) (! (=> (= (TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1))))) :pattern ((TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) ))) (not (forall ((?b0 Int) (?b1 Int) (?b2 Int) (?b3 Int) (?c0 Int) (?c1 Int) (?c2 Int) (?c3 Int)) (! (=> (= (FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1)) (not (= ?b2 ?c2)) (not (= ?b3 ?c3))))) :pattern ((FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (= (select1 (AtLeast ?n ?x_1) ?y) true_1) (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y)))))) :pattern ((select1 (AtLeast ?n ?x_1) ?y)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y))))) (= (select1 (AtLeast ?n ?x_1) ?y) true_1)) :pattern ((AtLeast ?n ?x_1) (Rep ?n ?x_1) (Rep ?n ?y)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (= (select1 (AtLeast ?n ?x_1) ?x_1) true_1) :pattern ((AtLeast ?n ?x_1)) ))) (not (forall ((?n Int) (?x_1 Int) (?z Int)) (! (= (Rep ?n ?x_1) (Rep ?n (PLUS ?x_1 ?n ?z))) :pattern ((PLUS ?x_1 ?n ?z)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (exists ((?k Int)) (= (- (Rep ?n ?x_1) ?x_1) (* ?n ?k))) :pattern ((Rep ?n ?x_1)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (<= ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) Empty) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (> ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) (Difference (AtLeast ?n ?x_1) (AtLeast ?n (PLUS ?x_1 ?n ?z)))) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int)) (not (= (select1 Empty ?x_1) true_1)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (select1 (Singleton ?y) ?x_1) true_1) (= ?x_1 ?y)) :pattern ((select1 (Singleton ?y) ?x_1)) ))) (not (forall ((?y Int)) (! (= (select1 (Singleton ?y) ?y) true_1) :pattern ((Singleton ?y)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Union ?S ?T) ?x_1) true_1) (or (= (select1 ?S ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((select1 (Union ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?T ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Intersection ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 (Intersection ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Difference ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((select1 (Difference ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (or (= (select1 (Difference ?S ?T) ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((Difference ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 (Dereference ?S ?M) ?x_1) true_1) (exists ((?y Int)) (not (or (not (= ?x_1 (select1 ?M ?y))) (not (= (select1 ?S ?y) true_1)))))) :pattern ((select1 (Dereference ?S ?M) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Dereference ?S ?M) (select1 ?M ?x_1)) true_1)) :pattern ((select1 ?M ?x_1) (select1 ?S ?x_1) (Dereference ?S ?M)) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (= (select1 ?S ?x_1) true_1)) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Dereference ?S ?M)) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (let ((?v_0 (select1 ?M ?x_1))) (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Equal (Intersection (Inverse ?M ?v_0) ?S) (Singleton ?x_1)) true_1)))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Difference (Dereference ?S ?M) (Singleton ?v_0)) (Singleton ?y))) true_1))) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (Equal (Intersection (Inverse ?M (select1 ?M ?x_1)) ?S) (Singleton ?x_1)) true_1))))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Dereference ?S ?M) (Singleton ?y))) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?f Int) (?x_1 Int)) (! (= (select1 (Inverse ?f (select1 ?f ?x_1)) ?x_1) true_1) :pattern ((Inverse ?f (select1 ?f ?x_1))) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int)) (! (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?y) (Union (Inverse ?f ?y) (Singleton ?x_1))) true_1) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?y)) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int) (?z Int)) (! (or (= ?y ?z) (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?z) (Difference (Inverse ?f ?z) (Singleton ?x_1))) true_1)) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?z)) ))) (not (forall ((?S Int) (?T Int)) (! (= (= (Equal ?S ?T) true_1) (not (or (not (= (Subset ?S ?T) true_1)) (not (= (Subset ?T ?S) true_1))))) :pattern ((Equal ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Subset ?S ?T) true_1)))) (= (select1 ?T ?x_1) true_1)) :pattern ((select1 ?S ?x_1) (Subset ?S ?T)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Subset ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1))))))) :pattern ((Subset ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (not (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Disjoint ?S ?T) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 ?S ?x_1) (Disjoint ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Disjoint ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((Disjoint ?S ?T)) ))) (not (forall ((?M Int) (?x_1 Int)) (! (= (select1 (Unified ?M) ?x_1) (select1 (select1 ?M (Field ?x_1)) ?x_1)) :pattern ((select1 (Unified ?M) ?x_1)) ))) (not (forall ((?M Int) (?x_1 Int) (?y Int)) (! (let ((?v_1 (Field ?x_1))) (= (Unified (store1 ?M ?v_1 (store1 (select1 ?M ?v_1) ?x_1 ?y))) (store1 (Unified ?M) ?x_1 ?y))) :pattern ((Unified (store1 ?M (Field ?x_1) (store1 (select1 ?M (Field ?x_1)) ?x_1 ?y)))) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (select1 (Values ?t) ?v) true_1) (= (HasType ?v ?t) true_1)) :pattern ((select1 (Values ?t) ?v)) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (HasType ?v ?t) true_1) (= (select1 (Values ?t) ?v) true_1)) :pattern ((HasType ?v ?t) (Values ?t)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a INT4_name) true_1) (= (Field ?a) INT4_name)) :pattern ((Match ?a INT4_name)) ))) (not (forall ((?v Int)) (= (HasType ?v INT4_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a PINT4_name) true_1) (= (Field ?a) PINT4_name)) :pattern ((Match ?a PINT4_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PINT4_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v INT4_name) true_1)))))) :pattern ((HasType ?v PINT4_name))  :pattern ((Match ?v INT4_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PPINT4_name) true_1) (= (Field ?a) PPINT4_name)) :pattern ((Match ?a PPINT4_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PPINT4_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v PINT4_name) true_1)))))) :pattern ((HasType ?v PPINT4_name))  :pattern ((Match ?v PINT4_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a UINT4_name) true_1) (= (Field ?a) UINT4_name)) :pattern ((Match ?a UINT4_name)) ))) (not (forall ((?v Int)) (= (HasType ?v UINT4_name) true_1))) (not (forall ((?a Int) (?b Int) (?size Int)) (! (let ((?v_3 (MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) (?v_2 (- ?a ?b))) (not (or (not (<= (* ?size ?v_3) ?v_2)) (not (< ?v_2 (* ?size (+ ?v_3 1))))))) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (MINUS_LEFT_PTR ?a ?a_size ?b) (- ?a (* ?a_size ?b))) :pattern ((MINUS_LEFT_PTR ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (PLUS ?a ?a_size ?b) (+ ?a (* ?a_size ?b))) :pattern ((PLUS ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (MULT ?a ?b) (* ?a ?b)) :pattern ((MULT ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_4 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (> ?b 0)))) (not (or (not (<= (* ?b ?v_4) ?a)) (not (< ?a (* ?b (+ ?v_4 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_5 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (< ?b 0)))) (not (or (not (<= (* ?b ?v_5) ?a)) (not (< ?a (* ?b (- ?v_5 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_6 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (> ?b 0)))) (not (or (not (>= (* ?b ?v_6) ?a)) (not (> ?a (* ?b (- ?v_6 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_7 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (< ?b 0)))) (not (or (not (>= (* ?b ?v_7) ?a)) (not (> ?a (* ?b (+ ?v_7 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (= (POW2 1) true_1)) (not (= (POW2 2) true_1)) (not (= (POW2 4) true_1)) (not (= (POW2 8) true_1)) (not (= (POW2 16) true_1)) (not (= (POW2 32) true_1)) (not (= (POW2 64) true_1)) (not (= (POW2 128) true_1)) (not (= (POW2 256) true_1)) (not (= (POW2 512) true_1)) (not (= (POW2 1024) true_1)) (not (= (POW2 2048) true_1)) (not (= (POW2 4096) true_1)) (not (= (POW2 8192) true_1)) (not (= (POW2 16384) true_1)) (not (= (POW2 32768) true_1)) (not (= (POW2 65536) true_1)) (not (= (POW2 131072) true_1)) (not (= (POW2 262144) true_1)) (not (= (POW2 524288) true_1)) (not (= (POW2 1048576) true_1)) (not (= (POW2 2097152) true_1)) (not (= (POW2 4194304) true_1)) (not (= (POW2 8388608) true_1)) (not (= (POW2 16777216) true_1)) (not (= (POW2 33554432) true_1)) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (= ?a true_1) (= (choose ?a ?b ?c) ?b)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (not (= ?a true_1)) (= (choose ?a ?b ?c) ?c)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= ?a ?b) (= (BIT_BAND ?a ?b) ?a)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (not (or (not (= (POW2 ?a) true_1)) (not (= (POW2 ?b) true_1)) (not (not (= ?a ?b))))) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (or (= ?a 0) (= ?b 0)) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int)) (! (= (= ?a true_1) (not (= (LIFT ?a) 0))) :pattern ((LIFT ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (boolNot ?a) 0))) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (boolNot ?a) 0)) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (NULL_CHECK ?a) 0))) :pattern ((NULL_CHECK ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (NULL_CHECK ?a) 0)) :pattern ((NULL_CHECK ?a)) ))))))
(assert (let ((?v_69 (forall ((?f Int)) (! (let ((?v_71 (Base ?f))) (let ((?v_70 (select1 alloc ?v_71))) (or (= ?v_70 UNALLOCATED) (= ?v_70 (select1 alloc_2 ?v_71))))) :pattern ((select1 alloc_2 (Base ?f))) ))) (?v_68 (forall ((?f Int) (?m Int)) (! (= (select1 (select1 Mem_2 ?f) ?m) (select1 (select1 Mem ?f) ?m)) :pattern ((select1 (select1 Mem_2 ?f) ?m)) ))) (?v_67 (forall ((?a Int)) (! (let ((?v_72 (Field ?a))) (= (HasType (select1 (select1 Mem_2 ?v_72) ?a) ?v_72) true_1)) :pattern ((select1 (select1 Mem_2 (Field ?a)) ?a)) ))) (?v_66 (= (HasType result_main_19_5_1_ INT4_name) true_1)) (?v_64 (Base call3675formal_new_0))) (let ((?v_65 (= (select1 alloc_0 ?v_64) ALLOCATED)) (?v_63 (= ?v_64 call3675formal_new_0)) (?v_62 (< i_2 50)) (?v_61 (=> true (=> false true))) (?v_54 (= (HasType tmp2_1 PINT4_name) true_1))) (let ((?v_60 (not ?v_54)) (?v_47 (= (HasType tmp1_0 PINT4_name) true_1))) (let ((?v_51 (not ?v_47)) (?v_14 (= (HasType call3675formal_new_0 INT4_name) true_1))) (let ((?v_18 (not ?v_14)) (?v_3 (= (HasType result_free_46_6_3_ INT4_name) true_1))) (let ((?v_13 (not ?v_3)) (?v_59 (= (HasType i_3 INT4_name) true_1)) (?v_11 (= (HasType call3675formal_new_0 PINT4_name) true_1))) (let ((?v_17 (not ?v_11)) (?v_26 (forall ((?a Int)) (! (let ((?v_73 (Field ?a))) (= (HasType (select1 (select1 Mem_0 ?v_73) ?a) ?v_73) true_1)) :pattern ((select1 (select1 Mem_0 (Field ?a)) ?a)) )))) (let ((?v_46 (not ?v_26)) (?v_25 (Field 0))) (let ((?v_50 (select1 (select1 Mem_0 ?v_25) 0))) (let ((?v_52 (= ?v_50 ?v_50)) (?v_49 (forall ((?f Int) (?m Int)) (! (let ((?v_74 (select1 (select1 Mem_0 ?f) ?m))) (= ?v_74 ?v_74)) :pattern ((select1 (select1 Mem_0 ?f) ?m)) )))) (let ((?v_58 (not ?v_49)) (?v_22 (forall ((?f Int)) (! (let ((?v_75 (select1 alloc_0 (Base ?f)))) (or (= ?v_75 UNALLOCATED) (= ?v_75 ?v_75))) :pattern ((select1 alloc_0 (Base ?f))) )))) (let ((?v_39 (not ?v_22)) (?v_57 (<= i_3 50)) (?v_56 (<= 0 i_3)) (?v_55 (= (select1 (select1 Mem_0 (Field tmp2_1)) tmp2_1) 0)) (?v_53 (= (HasType i_2 INT4_name) true_1)) (?v_6 (= (HasType tmp2 PINT4_name) true_1))) (let ((?v_16 (not ?v_6)) (?v_2 (= (HasType 0 INT4_name) true_1))) (let ((?v_12 (not ?v_2)) (?v_20 (<= 0 50))) (let ((?v_48 (not ?v_20)) (?v_19 (<= 0 0))) (let ((?v_7 (not ?v_19))) (let ((?v_8 (not (or ?v_7 ?v_7))) (?v_44 (not (= (Subset Empty (HavocArray call3675formal_new_0 4 50)) true_1)))) (let ((?v_45 (not (or ?v_44 (not (forall ((?H_x Int)) (! (=> (= (select1 (HavocArray call3675formal_new_0 4 50) ?H_x) true_1) (= (select1 (select1 Mem_0 (Field ?H_x)) ?H_x) 0)) :pattern ((select1 (HavocArray call3675formal_new_0 4 50) ?H_x)) )))))) (?v_43 (< i_0 50)) (?v_28 (= (HasType tmp1_1 PINT4_name) true_1))) (let ((?v_35 (not ?v_28)) (?v_42 (= (HasType i_1 INT4_name) true_1)) (?v_33 (forall ((?a Int)) (! (let ((?v_76 (Field ?a))) (= (HasType (select1 (select1 Mem_1 ?v_76) ?a) ?v_76) true_1)) :pattern ((select1 (select1 Mem_1 (Field ?a)) ?a)) )))) (let ((?v_41 (not ?v_33)) (?v_24 (select1 (select1 Mem ?v_25) 0)) (?v_40 (forall ((?f Int) (?m Int)) (! (or (not (or (not (= (select1 (HavocArray call3675formal_new_0 4 50) ?m) true_1)) (not (= ?f (Field ?m))))) (= (select1 (select1 Mem_1 ?f) ?m) (select1 (select1 Mem ?f) ?m))) :pattern ((select1 (select1 Mem_1 ?f) ?m)) ))) (?v_38 (not (or (not (= (Subset Empty (HavocArray call3675formal_new_0 4 i_1)) true_1)) (not (forall ((?H_x Int)) (! (=> (= (select1 (HavocArray call3675formal_new_0 4 i_1) ?H_x) true_1) (= (select1 (select1 Mem_1 (Field ?H_x)) ?H_x) 0)) :pattern ((select1 (HavocArray call3675formal_new_0 4 i_1) ?H_x)) )))))) (?v_37 (<= i_1 50)) (?v_36 (<= 0 i_1)) (?v_27 (= (HasType i_0 INT4_name) true_1))) (let ((?v_34 (not ?v_27)) (?v_30 (PLUS call3675formal_new_0 4 i_0))) (let ((?v_32 (Field ?v_30)) (?v_31 (= (select1 alloc_0 (Base ?v_30)) ALLOCATED)) (?v_29 (not (= call3675formal_new_0 0))) (?v_5 (= (HasType tmp1 PINT4_name) true_1))) (let ((?v_15 (not ?v_5)) (?v_0 (forall ((?a Int)) (! (let ((?v_77 (Field ?a))) (= (HasType (select1 (select1 Mem ?v_77) ?a) ?v_77) true_1)) :pattern ((select1 (select1 Mem (Field ?a)) ?a)) )))) (let ((?v_10 (not ?v_0)) (?v_23 (forall ((?f Int) (?m Int)) (! (let ((?v_78 (select1 (select1 Mem ?f) ?m))) (or (not (or (not (= (select1 (HavocArray call3675formal_new_0 4 50) ?m) true_1)) (not (= ?f (Field ?m))))) (= ?v_78 ?v_78))) :pattern ((select1 (select1 Mem ?f) ?m)) ))) (?v_21 (not (or (not (= (Subset Empty (HavocArray call3675formal_new_0 4 0)) true_1)) (not (forall ((?H_x Int)) (! (=> (= (select1 (HavocArray call3675formal_new_0 4 0) ?H_x) true_1) (= (select1 (select1 Mem (Field ?H_x)) ?H_x) 0)) :pattern ((select1 (HavocArray call3675formal_new_0 4 0) ?H_x)) )))))) (?v_9 (>= 200 0)) (?v_4 (= (HasType result_malloc_21_23_2_ INT4_name) true_1)) (?v_1 (= (HasType a_2_21_7_main PINT4_name) true_1))) (not (=> true (=> ?v_0 (=> true (=> ?v_1 (=> (= (HasType i INT4_name) true_1) (=> ?v_3 (=> ?v_4 (=> ?v_5 (=> ?v_6 (=> ?v_66 (=> true (=> true (=> true (=> true (=> true (=> true (not (or ?v_10 (not (=> ?v_0 (not (or (not ?v_1) (not (=> ?v_1 (not (or ?v_12 (not (=> ?v_2 (not (or ?v_13 (not (=> ?v_3 (not (or (not ?v_4) (not (=> ?v_4 (not (or ?v_15 (not (=> ?v_5 (not (or ?v_16 (not (=> ?v_6 (=> ?v_8 (=> true (=> ?v_8 (=> ?v_8 (=> true (=> ?v_8 (not (or (not ?v_9) (not (=> ?v_9 (=> (> call3675formal_new_0 0) (=> (forall ((?x_1 Int)) (! (=> (not (or (not (<= call3675formal_new_0 ?x_1)) (not (< ?x_1 (+ call3675formal_new_0 200))))) (= (Base ?x_1) call3675formal_new_0)) :pattern ((Base ?x_1)) )) (=> (forall ((?x_1 Int)) (! (or (= ?x_1 call3675formal_new_0) (= (select1 alloc ?x_1) (select1 alloc_0 ?x_1))) :pattern ((select1 alloc_0 ?x_1)) )) (=> (not (or (not (= (select1 alloc call3675formal_new_0) UNALLOCATED)) (not (= (select1 alloc_0 call3675formal_new_0) ALLOCATED)))) (=> ?v_11 (=> (not (or ?v_44 (not (forall ((?x_2 Int)) (! (=> (= (select1 (HavocArray call3675formal_new_0 4 50) ?x_2) true_1) (= (Match ?x_2 INT4_name) true_1)) :pattern ((select1 (HavocArray call3675formal_new_0 4 50) ?x_2)) ))))) (=> (= (Match call3675formal_new_0 INT4_name) true_1) (=> ?v_8 (=> true (=> ?v_8 (not (or ?v_10 (not (=> ?v_0 (not (or ?v_17 (not (=> ?v_11 (not (or ?v_12 (not (=> ?v_2 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_15 (not (=> ?v_5 (not (or ?v_16 (not (=> ?v_6 (=> ?v_8 (=> true (=> ?v_8 (=> ?v_8 (=> true (=> ?v_8 (=> ?v_8 (=> true (=> ?v_8 (not (or ?v_10 (not (=> ?v_0 (not (or ?v_17 (not (=> ?v_11 (not (or ?v_12 (not (=> ?v_2 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_15 (not (=> ?v_5 (not (or ?v_16 (not (=> ?v_6 (=> ?v_8 (=> true (=> ?v_8 (=> ?v_8 (=> true (not (or ?v_7 (not (=> ?v_19 (not (or ?v_48 (not (=> ?v_20 (not (or (not ?v_21) (not (=> ?v_21 (not (or ?v_39 (not (=> ?v_22 (not (or (not ?v_23) (not (=> ?v_23 (=> (= ?v_24 ?v_24) (not (or ?v_10 (not (=> ?v_0 (not (or ?v_17 (not (=> ?v_11 (not (or ?v_12 (not (=> ?v_2 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_15 (not (=> ?v_5 (not (or ?v_16 (not (=> ?v_6 (=> true (=> true (=> true (=> (<= 0 i_0) (=> (<= i_0 50) (=> (not (or (not (= (Subset Empty (HavocArray call3675formal_new_0 4 i_0)) true_1)) (not (forall ((?H_x Int)) (! (=> (= (select1 (HavocArray call3675formal_new_0 4 i_0) ?H_x) true_1) (= (select1 (select1 Mem_0 (Field ?H_x)) ?H_x) 0)) :pattern ((select1 (HavocArray call3675formal_new_0 4 i_0) ?H_x)) ))))) (=> ?v_22 (=> (forall ((?f Int) (?m Int)) (! (or (not (or (not (= (select1 (HavocArray call3675formal_new_0 4 50) ?m) true_1)) (not (= ?f (Field ?m))))) (= (select1 (select1 Mem_0 ?f) ?m) (select1 (select1 Mem ?f) ?m))) :pattern ((select1 (select1 Mem_0 ?f) ?m)) )) (=> (= ?v_50 ?v_24) (=> ?v_26 (=> ?v_11 (=> ?v_27 (=> ?v_3 (=> ?v_14 (=> ?v_47 (=> ?v_6 (=> true (not (or (not (=> true (=> true (=> ?v_43 (=> true (=> true (=> true (=> true (=> true (=> true (=> (= tmp1_1 ?v_30) (not (or ?v_46 (not (=> ?v_26 (not (or ?v_17 (not (=> ?v_11 (not (or ?v_34 (not (=> ?v_27 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_35 (not (=> ?v_28 (not (or ?v_16 (not (=> ?v_6 (=> true (=> true (=> true (not (or (not ?v_29) (not (=> ?v_29 (not (or (not ?v_31) (not (=> ?v_31 (=> (= Mem_1 (store1 Mem_0 ?v_32 (store1 (select1 Mem_0 ?v_32) ?v_30 0))) (not (or ?v_41 (not (=> ?v_33 (not (or ?v_17 (not (=> ?v_11 (not (or ?v_34 (not (=> ?v_27 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_35 (not (=> ?v_28 (not (or ?v_16 (not (=> ?v_6 (=> true (=> true (=> true (=> (= i_1 (PLUS i_0 1 1)) (=> true (=> true (=> true (not (or (not ?v_36) (not (=> ?v_36 (not (or (not ?v_37) (not (=> ?v_37 (not (or (not ?v_38) (not (=> ?v_38 (not (or ?v_39 (not (=> ?v_22 (not (or (not ?v_40) (not (=> ?v_40 (=> (= (select1 (select1 Mem_1 ?v_25) 0) ?v_24) (not (or ?v_41 (not (=> ?v_33 (not (or ?v_17 (not (=> ?v_11 (not (or (not ?v_42) (not (=> ?v_42 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_35 (not (=> ?v_28 (not (or ?v_16 (not (=> ?v_6 ?v_61))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> (not ?v_43) (=> true (=> true (=> true (not (or (not ?v_45) (not (=> ?v_45 (=> true (=> true (=> true (=> true (=> true (=> true (not (or ?v_46 (not (=> ?v_26 (not (or ?v_17 (not (=> ?v_11 (not (or ?v_12 (not (=> ?v_2 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_51 (not (=> ?v_47 (not (or ?v_16 (not (=> ?v_6 (=> ?v_8 (=> true (=> ?v_8 (=> ?v_8 (=> true (not (or ?v_7 (not (=> ?v_19 (not (or ?v_48 (not (=> ?v_20 (not (or ?v_39 (not (=> ?v_22 (not (or ?v_58 (not (=> ?v_49 (=> ?v_52 (not (or ?v_46 (not (=> ?v_26 (not (or ?v_17 (not (=> ?v_11 (not (or ?v_12 (not (=> ?v_2 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_51 (not (=> ?v_47 (not (or ?v_16 (not (=> ?v_6 (=> true (=> true (=> true (=> (<= 0 i_2) (=> (<= i_2 50) (=> ?v_22 (=> ?v_49 (=> ?v_52 (=> ?v_26 (=> ?v_11 (=> ?v_53 (=> ?v_3 (=> ?v_14 (=> ?v_47 (=> (= (HasType tmp2_0 PINT4_name) true_1) (=> true (not (or (not (=> true (=> true (=> ?v_62 (=> true (=> true (=> true (=> true (=> true (=> true (=> (= tmp2_1 (PLUS call3675formal_new_0 4 i_2)) (not (or ?v_46 (not (=> ?v_26 (not (or ?v_17 (not (=> ?v_11 (not (or (not ?v_53) (not (=> ?v_53 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_51 (not (=> ?v_47 (not (or ?v_60 (not (=> ?v_54 (=> true (=> true (=> true (not (or (not ?v_55) (not (=> ?v_55 (=> true (=> true (=> true (=> (= i_3 (PLUS i_2 1 1)) (=> true (=> true (=> true (not (or (not ?v_56) (not (=> ?v_56 (not (or (not ?v_57) (not (=> ?v_57 (not (or ?v_39 (not (=> ?v_22 (not (or ?v_58 (not (=> ?v_49 (=> ?v_52 (not (or ?v_46 (not (=> ?v_26 (not (or ?v_17 (not (=> ?v_11 (not (or (not ?v_59) (not (=> ?v_59 (not (or ?v_13 (not (=> ?v_3 (not (or ?v_18 (not (=> ?v_14 (not (or ?v_51 (not (=> ?v_47 (not (or ?v_60 (not (=> ?v_54 ?v_61)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> (not ?v_62) (=> true (=> true (=> true (not (or (not ?v_63) (not (=> ?v_63 (not (or (not ?v_65) (not (=> ?v_65 (=> (forall ((?x_1 Int)) (! (or (= ?x_1 call3675formal_new_0) (= (select1 alloc_0 ?x_1) (select1 alloc_1 ?x_1))) :pattern ((select1 alloc_1 ?x_1)) )) (=> (= (select1 alloc_1 call3675formal_new_0) FREED) (=> true (=> true (=> true (=> (forall ((?m Int)) (! (let ((?v_80 (Field ?m)) (?v_79 (Base ?m))) (=> (not (or (not (not (= (select1 alloc_1 ?v_79) ALLOCATED))) (not (not (= (select1 alloc ?v_79) ALLOCATED))))) (= (select1 (select1 Mem_0 ?v_80) ?m) (select1 (select1 Mem ?v_80) ?m)))) :pattern ((select1 (select1 Mem_0 (Field ?m)) ?m)) )) (=> true (=> true (=> (= tmp2_2 tmp2_0) (=> (= Mem_2 Mem_0) (=> (= alloc_2 alloc_1) (=> (= LOOP_21_alloc_0 alloc_0) (=> (= LOOP_21_Mem_0 Mem_0) (=> (= tmp1_2 tmp1_0) (=> (= i_4 i_2) (=> true (=> true (not (or (not ?v_66) (not (=> ?v_66 (not (or (not ?v_67) (not (=> ?v_67 (not (or (not ?v_68) (not (=> ?v_68 (not (or (not ?v_69) (not (=> ?v_69 true)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
