(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun NULL_CHECK (Int) Int)
(declare-fun LIFT (Int) Int)
(declare-fun BIT_BAND (Int Int) Int)
(declare-fun POW2 (Int) Int)
(declare-fun choose (Int Int Int) Int)
(declare-fun DIV (Int Int) Int)
(declare-fun MULT (Int Int) Int)
(declare-fun PLUS (Int Int Int) Int)
(declare-fun MINUS_LEFT_PTR (Int Int Int) Int)
(declare-fun MINUS_BOTH_PTR_OR_BOTH_INT (Int Int Int) Int)
(declare-fun g__FooInv (Int) Int)
(declare-fun g__Foo (Int) Int)
(declare-fun S_g__FooInv (Int) Int)
(declare-fun S_g__Foo (Int) Int)
(declare-fun f__FooInv (Int) Int)
(declare-fun f__Foo (Int) Int)
(declare-fun S_f__FooInv (Int) Int)
(declare-fun S_f__Foo (Int) Int)
(declare-fun Match (Int Int) Int)
(declare-fun Foo_name () Int)
(declare-fun g__Foo_name () Int)
(declare-fun f__Foo_name () Int)
(declare-fun HasType (Int Int) Int)
(declare-fun UINT4_name () Int)
(declare-fun Field (Int) Int)
(declare-fun P_Foo_name () Int)
(declare-fun PP_Foo_name () Int)
(declare-fun PCHAR_name () Int)
(declare-fun PPCHAR_name () Int)
(declare-fun INT4_name () Int)
(declare-fun PINT4_name () Int)
(declare-fun CHAR_name () Int)
(declare-fun Values (Int) Int)
(declare-fun Unified (Int) Int)
(declare-fun Disjoint (Int Int) Int)
(declare-fun Subset (Int Int) Int)
(declare-fun Equal (Int Int) Int)
(declare-fun Inverse (Int Int) Int)
(declare-fun Difference (Int Int) Int)
(declare-fun Singleton (Int) Int)
(declare-fun Union (Int Int) Int)
(declare-fun Dereference (Int Int) Int)
(declare-fun Intersection (Int Int) Int)
(declare-fun Empty () Int)
(declare-fun HavocArray (Int Int Int) Int)
(declare-fun AtLeast (Int Int) Int)
(declare-fun Rep (Int Int) Int)
(declare-fun FourBytesToInt (Int Int Int Int) Int)
(declare-fun TwoBytesToInt (Int Int) Int)
(declare-fun OneByteToInt (Int) Int)
(declare-fun BYTE () Int)
(declare-fun FREED () Int)
(declare-fun ALLOCATED () Int)
(declare-fun UNALLOCATED () Int)
(declare-fun Base (Int) Int)
(declare-fun alloc_1 () Int)
(declare-fun alloc () Int)
(declare-fun Mem_1 () Int)
(declare-fun Mem () Int)
(declare-fun result_main_12_5_1_ () Int)
(declare-fun call4437formal_new_0 () Int)
(declare-fun alloc_0 () Int)
(declare-fun y_1 () Int)
(declare-fun result_free_24_5_3_ () Int)
(declare-fun Mem_0 () Int)
(declare-fun y_0 () Int)
(declare-fun y () Int)
(declare-fun x_1 () Int)
(declare-fun result_malloc_14_23_2_ () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct UNALLOCATED ALLOCATED FREED BYTE f__Foo_name g__Foo_name CHAR_name INT4_name PCHAR_name PINT4_name PPCHAR_name PP_Foo_name P_Foo_name UINT4_name Foo_name)) (not (forall ((?b0 Int) (?c0 Int)) (! (=> (= (OneByteToInt ?b0) (OneByteToInt ?c0)) (= ?b0 ?c0)) :pattern ((OneByteToInt ?b0) (OneByteToInt ?c0)) ))) (not (forall ((?b0 Int) (?b1 Int) (?c0 Int) (?c1 Int)) (! (=> (= (TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1))))) :pattern ((TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) ))) (not (forall ((?b0 Int) (?b1 Int) (?b2 Int) (?b3 Int) (?c0 Int) (?c1 Int) (?c2 Int) (?c3 Int)) (! (=> (= (FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1)) (not (= ?b2 ?c2)) (not (= ?b3 ?c3))))) :pattern ((FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (= (select1 (AtLeast ?n ?x_1) ?y) true_1) (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y)))))) :pattern ((select1 (AtLeast ?n ?x_1) ?y)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y))))) (= (select1 (AtLeast ?n ?x_1) ?y) true_1)) :pattern ((AtLeast ?n ?x_1) (Rep ?n ?x_1) (Rep ?n ?y)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (= (select1 (AtLeast ?n ?x_1) ?x_1) true_1) :pattern ((AtLeast ?n ?x_1)) ))) (not (forall ((?n Int) (?x_1 Int) (?z Int)) (! (= (Rep ?n ?x_1) (Rep ?n (PLUS ?x_1 ?n ?z))) :pattern ((PLUS ?x_1 ?n ?z)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (exists ((?k Int)) (= (- (Rep ?n ?x_1) ?x_1) (* ?n ?k))) :pattern ((Rep ?n ?x_1)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (<= ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) Empty) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (> ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) (Difference (AtLeast ?n ?x_1) (AtLeast ?n (PLUS ?x_1 ?n ?z)))) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int)) (not (= (select1 Empty ?x_1) true_1)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (select1 (Singleton ?y) ?x_1) true_1) (= ?x_1 ?y)) :pattern ((select1 (Singleton ?y) ?x_1)) ))) (not (forall ((?y Int)) (! (= (select1 (Singleton ?y) ?y) true_1) :pattern ((Singleton ?y)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Union ?S ?T) ?x_1) true_1) (or (= (select1 ?S ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((select1 (Union ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?T ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Intersection ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 (Intersection ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Difference ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((select1 (Difference ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (or (= (select1 (Difference ?S ?T) ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((Difference ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 (Dereference ?S ?M) ?x_1) true_1) (exists ((?y Int)) (not (or (not (= ?x_1 (select1 ?M ?y))) (not (= (select1 ?S ?y) true_1)))))) :pattern ((select1 (Dereference ?S ?M) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Dereference ?S ?M) (select1 ?M ?x_1)) true_1)) :pattern ((select1 ?M ?x_1) (select1 ?S ?x_1) (Dereference ?S ?M)) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (= (select1 ?S ?x_1) true_1)) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Dereference ?S ?M)) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (let ((?v_0 (select1 ?M ?x_1))) (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Equal (Intersection (Inverse ?M ?v_0) ?S) (Singleton ?x_1)) true_1)))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Difference (Dereference ?S ?M) (Singleton ?v_0)) (Singleton ?y))) true_1))) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (Equal (Intersection (Inverse ?M (select1 ?M ?x_1)) ?S) (Singleton ?x_1)) true_1))))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Dereference ?S ?M) (Singleton ?y))) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?f Int) (?x_1 Int)) (! (= (select1 (Inverse ?f (select1 ?f ?x_1)) ?x_1) true_1) :pattern ((Inverse ?f (select1 ?f ?x_1))) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int)) (! (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?y) (Union (Inverse ?f ?y) (Singleton ?x_1))) true_1) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?y)) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int) (?z Int)) (! (or (= ?y ?z) (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?z) (Difference (Inverse ?f ?z) (Singleton ?x_1))) true_1)) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?z)) ))) (not (forall ((?S Int) (?T Int)) (! (= (= (Equal ?S ?T) true_1) (not (or (not (= (Subset ?S ?T) true_1)) (not (= (Subset ?T ?S) true_1))))) :pattern ((Equal ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Subset ?S ?T) true_1)))) (= (select1 ?T ?x_1) true_1)) :pattern ((select1 ?S ?x_1) (Subset ?S ?T)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Subset ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1))))))) :pattern ((Subset ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (not (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Disjoint ?S ?T) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 ?S ?x_1) (Disjoint ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Disjoint ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((Disjoint ?S ?T)) ))) (not (forall ((?M Int) (?x_1 Int)) (! (= (select1 (Unified ?M) ?x_1) (select1 (select1 ?M (Field ?x_1)) ?x_1)) :pattern ((select1 (Unified ?M) ?x_1)) ))) (not (forall ((?M Int) (?x_1 Int) (?y Int)) (! (let ((?v_1 (Field ?x_1))) (= (Unified (store1 ?M ?v_1 (store1 (select1 ?M ?v_1) ?x_1 ?y))) (store1 (Unified ?M) ?x_1 ?y))) :pattern ((Unified (store1 ?M (Field ?x_1) (store1 (select1 ?M (Field ?x_1)) ?x_1 ?y)))) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (select1 (Values ?t) ?v) true_1) (= (HasType ?v ?t) true_1)) :pattern ((select1 (Values ?t) ?v)) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (HasType ?v ?t) true_1) (= (select1 (Values ?t) ?v) true_1)) :pattern ((HasType ?v ?t) (Values ?t)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a f__Foo_name) true_1) (= (Field ?a) f__Foo_name)) :pattern ((Match ?a f__Foo_name)) ))) (not (forall ((?v Int)) (= (HasType ?v f__Foo_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a g__Foo_name) true_1) (= (Field ?a) g__Foo_name)) :pattern ((Match ?a g__Foo_name)) ))) (not (forall ((?v Int)) (= (HasType ?v g__Foo_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a CHAR_name) true_1) (= (Field ?a) CHAR_name)) :pattern ((Match ?a CHAR_name)) ))) (not (forall ((?v Int)) (= (HasType ?v CHAR_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a INT4_name) true_1) (= (Field ?a) INT4_name)) :pattern ((Match ?a INT4_name)) ))) (not (forall ((?v Int)) (= (HasType ?v INT4_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a PCHAR_name) true_1) (= (Field ?a) PCHAR_name)) :pattern ((Match ?a PCHAR_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PCHAR_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v CHAR_name) true_1)))))) :pattern ((HasType ?v PCHAR_name))  :pattern ((Match ?v CHAR_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PINT4_name) true_1) (= (Field ?a) PINT4_name)) :pattern ((Match ?a PINT4_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PINT4_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v INT4_name) true_1)))))) :pattern ((HasType ?v PINT4_name))  :pattern ((Match ?v INT4_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PPCHAR_name) true_1) (= (Field ?a) PPCHAR_name)) :pattern ((Match ?a PPCHAR_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PPCHAR_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v PCHAR_name) true_1)))))) :pattern ((HasType ?v PPCHAR_name))  :pattern ((Match ?v PCHAR_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PP_Foo_name) true_1) (= (Field ?a) PP_Foo_name)) :pattern ((Match ?a PP_Foo_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PP_Foo_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v P_Foo_name) true_1)))))) :pattern ((HasType ?v PP_Foo_name))  :pattern ((Match ?v P_Foo_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a P_Foo_name) true_1) (= (Field ?a) P_Foo_name)) :pattern ((Match ?a P_Foo_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v P_Foo_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v Foo_name) true_1)))))) :pattern ((HasType ?v P_Foo_name))  :pattern ((Match ?v Foo_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a UINT4_name) true_1) (= (Field ?a) UINT4_name)) :pattern ((Match ?a UINT4_name)) ))) (not (forall ((?v Int)) (= (HasType ?v UINT4_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a Foo_name) true_1) (not (or (not true) (not (= (Match (f__Foo ?a) f__Foo_name) true_1)) (not (= (Match (g__Foo ?a) g__Foo_name) true_1))))) :pattern ((Match ?a Foo_name)) ))) (not (forall ((?x_1 Int)) (! (= (f__FooInv (f__Foo ?x_1)) ?x_1) :pattern ((f__Foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (f__Foo (f__FooInv ?x_1)) ?x_1) :pattern ((f__FooInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_f__Foo ?S) ?x_1) true_1) (= (select1 ?S (f__FooInv ?x_1)) true_1)) :pattern ((select1 (S_f__Foo ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_f__FooInv ?S) ?x_1) true_1) (= (select1 ?S (f__Foo ?x_1)) true_1)) :pattern ((select1 (S_f__FooInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_f__Foo ?S) (f__Foo ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_f__Foo ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_f__FooInv ?S) (f__FooInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_f__FooInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (f__Foo ?x_1) (+ ?x_1 0)) :pattern ((f__Foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (f__FooInv ?x_1) (- ?x_1 0)) :pattern ((f__FooInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1) (f__FooInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 0) (f__FooInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 0)) ))) (not (forall ((?x_1 Int)) (! (= (g__FooInv (g__Foo ?x_1)) ?x_1) :pattern ((g__Foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (g__Foo (g__FooInv ?x_1)) ?x_1) :pattern ((g__FooInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_g__Foo ?S) ?x_1) true_1) (= (select1 ?S (g__FooInv ?x_1)) true_1)) :pattern ((select1 (S_g__Foo ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_g__FooInv ?S) ?x_1) true_1) (= (select1 ?S (g__Foo ?x_1)) true_1)) :pattern ((select1 (S_g__FooInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_g__Foo ?S) (g__Foo ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_g__Foo ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_g__FooInv ?S) (g__FooInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_g__FooInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (g__Foo ?x_1) (+ ?x_1 4)) :pattern ((g__Foo ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (g__FooInv ?x_1) (- ?x_1 4)) :pattern ((g__FooInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1) (g__FooInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 4) (g__FooInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 4)) ))) (not (forall ((?a Int) (?b Int) (?size Int)) (! (let ((?v_3 (MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) (?v_2 (- ?a ?b))) (not (or (not (<= (* ?size ?v_3) ?v_2)) (not (< ?v_2 (* ?size (+ ?v_3 1))))))) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (MINUS_LEFT_PTR ?a ?a_size ?b) (- ?a (* ?a_size ?b))) :pattern ((MINUS_LEFT_PTR ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (PLUS ?a ?a_size ?b) (+ ?a (* ?a_size ?b))) :pattern ((PLUS ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (MULT ?a ?b) (* ?a ?b)) :pattern ((MULT ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_4 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (> ?b 0)))) (not (or (not (<= (* ?b ?v_4) ?a)) (not (< ?a (* ?b (+ ?v_4 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_5 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (< ?b 0)))) (not (or (not (<= (* ?b ?v_5) ?a)) (not (< ?a (* ?b (- ?v_5 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_6 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (> ?b 0)))) (not (or (not (>= (* ?b ?v_6) ?a)) (not (> ?a (* ?b (- ?v_6 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_7 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (< ?b 0)))) (not (or (not (>= (* ?b ?v_7) ?a)) (not (> ?a (* ?b (+ ?v_7 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (= (POW2 1) true_1)) (not (= (POW2 2) true_1)) (not (= (POW2 4) true_1)) (not (= (POW2 8) true_1)) (not (= (POW2 16) true_1)) (not (= (POW2 32) true_1)) (not (= (POW2 64) true_1)) (not (= (POW2 128) true_1)) (not (= (POW2 256) true_1)) (not (= (POW2 512) true_1)) (not (= (POW2 1024) true_1)) (not (= (POW2 2048) true_1)) (not (= (POW2 4096) true_1)) (not (= (POW2 8192) true_1)) (not (= (POW2 16384) true_1)) (not (= (POW2 32768) true_1)) (not (= (POW2 65536) true_1)) (not (= (POW2 131072) true_1)) (not (= (POW2 262144) true_1)) (not (= (POW2 524288) true_1)) (not (= (POW2 1048576) true_1)) (not (= (POW2 2097152) true_1)) (not (= (POW2 4194304) true_1)) (not (= (POW2 8388608) true_1)) (not (= (POW2 16777216) true_1)) (not (= (POW2 33554432) true_1)) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (= ?a true_1) (= (choose ?a ?b ?c) ?b)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (not (= ?a true_1)) (= (choose ?a ?b ?c) ?c)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= ?a ?b) (= (BIT_BAND ?a ?b) ?a)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (not (or (not (= (POW2 ?a) true_1)) (not (= (POW2 ?b) true_1)) (not (not (= ?a ?b))))) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (or (= ?a 0) (= ?b 0)) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int)) (! (= (= ?a true_1) (not (= (LIFT ?a) 0))) :pattern ((LIFT ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (boolNot ?a) 0))) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (boolNot ?a) 0)) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (NULL_CHECK ?a) 0))) :pattern ((NULL_CHECK ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (NULL_CHECK ?a) 0)) :pattern ((NULL_CHECK ?a)) ))))))
(assert (let ((?v_31 (forall ((?f Int)) (! (let ((?v_33 (Base ?f))) (let ((?v_32 (select1 alloc ?v_33))) (or (= ?v_32 UNALLOCATED) (= ?v_32 (select1 alloc_1 ?v_33))))) :pattern ((select1 alloc_1 (Base ?f))) ))) (?v_30 (forall ((?f Int) (?m Int)) (! (= (select1 (select1 Mem_1 ?f) ?m) (select1 (select1 Mem ?f) ?m)) :pattern ((select1 (select1 Mem_1 ?f) ?m)) ))) (?v_22 (forall ((?a Int)) (! (let ((?v_34 (Field ?a))) (= (HasType (select1 (select1 Mem_1 ?v_34) ?a) ?v_34) true_1)) :pattern ((select1 (select1 Mem_1 (Field ?a)) ?a)) )))) (let ((?v_29 (not ?v_22)) (?v_28 (= (HasType result_main_12_5_1_ INT4_name) true_1)) (?v_26 (Base call4437formal_new_0))) (let ((?v_27 (= (select1 alloc_0 ?v_26) ALLOCATED)) (?v_25 (= ?v_26 call4437formal_new_0)) (?v_8 (f__Foo call4437formal_new_0))) (let ((?v_9 (Field ?v_8))) (let ((?v_24 (= (select1 (select1 Mem_1 ?v_9) ?v_8) 11)) (?v_23 (= (HasType y_1 PCHAR_name) true_1)) (?v_4 (= (HasType call4437formal_new_0 P_Foo_name) true_1))) (let ((?v_13 (not ?v_4)) (?v_3 (= (HasType call4437formal_new_0 INT4_name) true_1))) (let ((?v_12 (not ?v_3)) (?v_2 (= (HasType result_free_24_5_3_ INT4_name) true_1))) (let ((?v_11 (not ?v_2)) (?v_21 (Field y_1)) (?v_20 (= (select1 alloc_0 (Base y_1)) ALLOCATED)) (?v_19 (not (= y_1 0))) (?v_18 (= (HasType y_0 PCHAR_name) true_1)) (?v_10 (forall ((?a Int)) (! (let ((?v_35 (Field ?a))) (= (HasType (select1 (select1 Mem_0 ?v_35) ?a) ?v_35) true_1)) :pattern ((select1 (select1 Mem_0 (Field ?a)) ?a)) )))) (let ((?v_17 (not ?v_10)) (?v_6 (not (= call4437formal_new_0 0)))) (let ((?v_16 (not ?v_6)) (?v_15 (= (select1 (select1 Mem_0 ?v_9) ?v_8) 11)) (?v_5 (= (HasType y PCHAR_name) true_1))) (let ((?v_14 (not ?v_5)) (?v_7 (= (select1 alloc_0 (Base ?v_8)) ALLOCATED)) (?v_1 (forall ((?a Int)) (! (let ((?v_36 (Field ?a))) (= (HasType (select1 (select1 Mem ?v_36) ?a) ?v_36) true_1)) :pattern ((select1 (select1 Mem (Field ?a)) ?a)) ))) (?v_0 (>= 8 0))) (not (=> true (=> ?v_1 (=> true (=> ?v_2 (=> (= (HasType result_malloc_14_23_2_ INT4_name) true_1) (=> (= (HasType x_1 P_Foo_name) true_1) (=> ?v_5 (=> ?v_28 (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> true (not (or (not ?v_0) (not (=> ?v_0 (=> (> call4437formal_new_0 0) (=> (forall ((?x_1 Int)) (! (=> (not (or (not (<= call4437formal_new_0 ?x_1)) (not (< ?x_1 (+ call4437formal_new_0 8))))) (= (Base ?x_1) call4437formal_new_0)) :pattern ((Base ?x_1)) )) (=> (forall ((?x_1 Int)) (! (or (= ?x_1 call4437formal_new_0) (= (select1 alloc ?x_1) (select1 alloc_0 ?x_1))) :pattern ((select1 alloc_0 ?x_1)) )) (=> (not (or (not (= (select1 alloc call4437formal_new_0) UNALLOCATED)) (not (= (select1 alloc_0 call4437formal_new_0) ALLOCATED)))) (=> ?v_4 (=> (not (or (not (= (Subset Empty (HavocArray call4437formal_new_0 8 1)) true_1)) (not (forall ((?x_2 Int)) (! (=> (= (select1 (HavocArray call4437formal_new_0 8 1) ?x_2) true_1) (= (Match ?x_2 Foo_name) true_1)) :pattern ((select1 (HavocArray call4437formal_new_0 8 1) ?x_2)) ))))) (=> (= (Match call4437formal_new_0 Foo_name) true_1) (=> true (=> true (=> true (not (or (not ?v_1) (not (=> ?v_1 (not (or ?v_11 (not (=> ?v_2 (not (or ?v_12 (not (=> ?v_3 (not (or ?v_13 (not (=> ?v_4 (not (or ?v_14 (not (=> ?v_5 (=> true (=> true (=> true (not (or ?v_16 (not (=> ?v_6 (not (or (not ?v_7) (not (=> ?v_7 (=> (= Mem_0 (store1 Mem ?v_9 (store1 (select1 Mem ?v_9) ?v_8 11))) (not (or ?v_17 (not (=> ?v_10 (not (or ?v_11 (not (=> ?v_2 (not (or ?v_12 (not (=> ?v_3 (not (or ?v_13 (not (=> ?v_4 (not (or ?v_14 (not (=> ?v_5 (=> true (=> true (=> true (not (or (not ?v_15) (not (=> ?v_15 (=> true (=> true (=> true (not (or ?v_16 (not (=> ?v_6 (=> (= y_0 ?v_8) (not (or ?v_17 (not (=> ?v_10 (not (or ?v_11 (not (=> ?v_2 (not (or ?v_12 (not (=> ?v_3 (not (or ?v_13 (not (=> ?v_4 (not (or (not ?v_18) (not (=> ?v_18 (=> true (=> true (=> true (=> (= y_1 (PLUS y_0 1 1)) (=> true (=> true (=> true (not (or (not ?v_19) (not (=> ?v_19 (not (or (not ?v_20) (not (=> ?v_20 (=> (= Mem_1 (store1 Mem_0 ?v_21 (store1 (select1 Mem_0 ?v_21) y_1 42))) (not (or ?v_29 (not (=> ?v_22 (not (or ?v_11 (not (=> ?v_2 (not (or ?v_12 (not (=> ?v_3 (not (or ?v_13 (not (=> ?v_4 (not (or (not ?v_23) (not (=> ?v_23 (=> true (=> true (=> true (not (or (not ?v_24) (not (=> ?v_24 (=> true (=> true (=> true (not (or (not ?v_25) (not (=> ?v_25 (not (or (not ?v_27) (not (=> ?v_27 (=> (forall ((?x_1 Int)) (! (or (= ?x_1 call4437formal_new_0) (= (select1 alloc_0 ?x_1) (select1 alloc_1 ?x_1))) :pattern ((select1 alloc_1 ?x_1)) )) (=> (= (select1 alloc_1 call4437formal_new_0) FREED) (=> true (=> true (=> true (=> (forall ((?m Int)) (! (let ((?v_38 (Field ?m)) (?v_37 (Base ?m))) (=> (not (or (not (not (= (select1 alloc_1 ?v_37) ALLOCATED))) (not (not (= (select1 alloc ?v_37) ALLOCATED))))) (= (select1 (select1 Mem_1 ?v_38) ?m) (select1 (select1 Mem ?v_38) ?m)))) :pattern ((select1 (select1 Mem_1 (Field ?m)) ?m)) )) (=> true (=> true (not (or (not ?v_28) (not (=> ?v_28 (not (or ?v_29 (not (=> ?v_22 (not (or (not ?v_30) (not (=> ?v_30 (not (or (not ?v_31) (not (=> ?v_31 true)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
