(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun NULL_CHECK (Int) Int)
(declare-fun LIFT (Int) Int)
(declare-fun BIT_BAND (Int Int) Int)
(declare-fun POW2 (Int) Int)
(declare-fun choose (Int Int Int) Int)
(declare-fun DIV (Int Int) Int)
(declare-fun MULT (Int Int) Int)
(declare-fun PLUS (Int Int Int) Int)
(declare-fun MINUS_LEFT_PTR (Int Int Int) Int)
(declare-fun MINUS_BOTH_PTR_OR_BOTH_INT (Int Int Int) Int)
(declare-fun Match (Int Int) Int)
(declare-fun PINT4_name () Int)
(declare-fun HasType (Int Int) Int)
(declare-fun PPINT4_name () Int)
(declare-fun Field (Int) Int)
(declare-fun INT4_name () Int)
(declare-fun Values (Int) Int)
(declare-fun Unified (Int) Int)
(declare-fun Disjoint (Int Int) Int)
(declare-fun Subset (Int Int) Int)
(declare-fun Equal (Int Int) Int)
(declare-fun Inverse (Int Int) Int)
(declare-fun Difference (Int Int) Int)
(declare-fun Singleton (Int) Int)
(declare-fun Union (Int Int) Int)
(declare-fun Dereference (Int Int) Int)
(declare-fun Intersection (Int Int) Int)
(declare-fun Empty () Int)
(declare-fun HavocArray (Int Int Int) Int)
(declare-fun AtLeast (Int Int) Int)
(declare-fun Rep (Int Int) Int)
(declare-fun FourBytesToInt (Int Int Int Int) Int)
(declare-fun TwoBytesToInt (Int Int) Int)
(declare-fun OneByteToInt (Int) Int)
(declare-fun BYTE () Int)
(declare-fun FREED () Int)
(declare-fun ALLOCATED () Int)
(declare-fun UNALLOCATED () Int)
(declare-fun arr1 () Int)
(declare-fun size1 () Int)
(declare-fun Mem_6 () Int)
(declare-fun Mem () Int)
(declare-fun aux_2 () Int)
(declare-fun aux_4 () Int)
(declare-fun tmp_3 () Int)
(declare-fun tmp_5 () Int)
(declare-fun Mem_4 () Int)
(declare-fun LOOP_11_Mem_1 () Int)
(declare-fun LOOP_11_Mem_2 () Int)
(declare-fun i_2 () Int)
(declare-fun i_4 () Int)
(declare-fun LOOP_11_alloc_1 () Int)
(declare-fun LOOP_11_alloc_2 () Int)
(declare-fun Base (Int) Int)
(declare-fun alloc () Int)
(declare-fun aux_0 () Int)
(declare-fun tmp_0 () Int)
(declare-fun Mem_0 () Int)
(declare-fun LOOP_11_Mem_0 () Int)
(declare-fun i_0 () Int)
(declare-fun LOOP_11_alloc_0 () Int)
(declare-fun aux_1 () Int)
(declare-fun tmp_1 () Int)
(declare-fun Mem_1 () Int)
(declare-fun i_1 () Int)
(declare-fun tmp_4 () Int)
(declare-fun i_3 () Int)
(declare-fun aux_3 () Int)
(declare-fun Mem_5 () Int)
(declare-fun tmp_2 () Int)
(declare-fun Mem_3 () Int)
(declare-fun Mem_2 () Int)
(declare-fun tmp () Int)
(declare-fun i () Int)
(declare-fun aux () Int)
(declare-fun size () Int)
(declare-fun arr () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct UNALLOCATED ALLOCATED FREED BYTE INT4_name PINT4_name PPINT4_name)) (not (forall ((?b0 Int) (?c0 Int)) (! (=> (= (OneByteToInt ?b0) (OneByteToInt ?c0)) (= ?b0 ?c0)) :pattern ((OneByteToInt ?b0) (OneByteToInt ?c0)) ))) (not (forall ((?b0 Int) (?b1 Int) (?c0 Int) (?c1 Int)) (! (=> (= (TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1))))) :pattern ((TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) ))) (not (forall ((?b0 Int) (?b1 Int) (?b2 Int) (?b3 Int) (?c0 Int) (?c1 Int) (?c2 Int) (?c3 Int)) (! (=> (= (FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1)) (not (= ?b2 ?c2)) (not (= ?b3 ?c3))))) :pattern ((FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (= (select1 (AtLeast ?n ?x_1) ?y) true_1) (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y)))))) :pattern ((select1 (AtLeast ?n ?x_1) ?y)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y))))) (= (select1 (AtLeast ?n ?x_1) ?y) true_1)) :pattern ((AtLeast ?n ?x_1) (Rep ?n ?x_1) (Rep ?n ?y)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (= (select1 (AtLeast ?n ?x_1) ?x_1) true_1) :pattern ((AtLeast ?n ?x_1)) ))) (not (forall ((?n Int) (?x_1 Int) (?z Int)) (! (= (Rep ?n ?x_1) (Rep ?n (PLUS ?x_1 ?n ?z))) :pattern ((PLUS ?x_1 ?n ?z)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (exists ((?k Int)) (= (- (Rep ?n ?x_1) ?x_1) (* ?n ?k))) :pattern ((Rep ?n ?x_1)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (<= ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) Empty) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (> ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) (Difference (AtLeast ?n ?x_1) (AtLeast ?n (PLUS ?x_1 ?n ?z)))) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int)) (not (= (select1 Empty ?x_1) true_1)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (select1 (Singleton ?y) ?x_1) true_1) (= ?x_1 ?y)) :pattern ((select1 (Singleton ?y) ?x_1)) ))) (not (forall ((?y Int)) (! (= (select1 (Singleton ?y) ?y) true_1) :pattern ((Singleton ?y)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Union ?S ?T) ?x_1) true_1) (or (= (select1 ?S ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((select1 (Union ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?T ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Intersection ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 (Intersection ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Difference ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((select1 (Difference ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (or (= (select1 (Difference ?S ?T) ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((Difference ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 (Dereference ?S ?M) ?x_1) true_1) (exists ((?y Int)) (not (or (not (= ?x_1 (select1 ?M ?y))) (not (= (select1 ?S ?y) true_1)))))) :pattern ((select1 (Dereference ?S ?M) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Dereference ?S ?M) (select1 ?M ?x_1)) true_1)) :pattern ((select1 ?M ?x_1) (select1 ?S ?x_1) (Dereference ?S ?M)) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (= (select1 ?S ?x_1) true_1)) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Dereference ?S ?M)) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (let ((?v_0 (select1 ?M ?x_1))) (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Equal (Intersection (Inverse ?M ?v_0) ?S) (Singleton ?x_1)) true_1)))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Difference (Dereference ?S ?M) (Singleton ?v_0)) (Singleton ?y))) true_1))) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (Equal (Intersection (Inverse ?M (select1 ?M ?x_1)) ?S) (Singleton ?x_1)) true_1))))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Dereference ?S ?M) (Singleton ?y))) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?f Int) (?x_1 Int)) (! (= (select1 (Inverse ?f (select1 ?f ?x_1)) ?x_1) true_1) :pattern ((Inverse ?f (select1 ?f ?x_1))) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int)) (! (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?y) (Union (Inverse ?f ?y) (Singleton ?x_1))) true_1) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?y)) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int) (?z Int)) (! (or (= ?y ?z) (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?z) (Difference (Inverse ?f ?z) (Singleton ?x_1))) true_1)) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?z)) ))) (not (forall ((?S Int) (?T Int)) (! (= (= (Equal ?S ?T) true_1) (not (or (not (= (Subset ?S ?T) true_1)) (not (= (Subset ?T ?S) true_1))))) :pattern ((Equal ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Subset ?S ?T) true_1)))) (= (select1 ?T ?x_1) true_1)) :pattern ((select1 ?S ?x_1) (Subset ?S ?T)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Subset ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1))))))) :pattern ((Subset ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (not (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Disjoint ?S ?T) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 ?S ?x_1) (Disjoint ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Disjoint ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((Disjoint ?S ?T)) ))) (not (forall ((?M Int) (?x_1 Int)) (! (= (select1 (Unified ?M) ?x_1) (select1 (select1 ?M (Field ?x_1)) ?x_1)) :pattern ((select1 (Unified ?M) ?x_1)) ))) (not (forall ((?M Int) (?x_1 Int) (?y Int)) (! (let ((?v_1 (Field ?x_1))) (= (Unified (store1 ?M ?v_1 (store1 (select1 ?M ?v_1) ?x_1 ?y))) (store1 (Unified ?M) ?x_1 ?y))) :pattern ((Unified (store1 ?M (Field ?x_1) (store1 (select1 ?M (Field ?x_1)) ?x_1 ?y)))) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (select1 (Values ?t) ?v) true_1) (= (HasType ?v ?t) true_1)) :pattern ((select1 (Values ?t) ?v)) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (HasType ?v ?t) true_1) (= (select1 (Values ?t) ?v) true_1)) :pattern ((HasType ?v ?t) (Values ?t)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a INT4_name) true_1) (= (Field ?a) INT4_name)) :pattern ((Match ?a INT4_name)) ))) (not (forall ((?v Int)) (= (HasType ?v INT4_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a PINT4_name) true_1) (= (Field ?a) PINT4_name)) :pattern ((Match ?a PINT4_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PINT4_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v INT4_name) true_1)))))) :pattern ((HasType ?v PINT4_name))  :pattern ((Match ?v INT4_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PPINT4_name) true_1) (= (Field ?a) PPINT4_name)) :pattern ((Match ?a PPINT4_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PPINT4_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v PINT4_name) true_1)))))) :pattern ((HasType ?v PPINT4_name))  :pattern ((Match ?v PINT4_name)) ))) (not (forall ((?a Int) (?b Int) (?size Int)) (! (let ((?v_3 (MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) (?v_2 (- ?a ?b))) (not (or (not (<= (* ?size ?v_3) ?v_2)) (not (< ?v_2 (* ?size (+ ?v_3 1))))))) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (MINUS_LEFT_PTR ?a ?a_size ?b) (- ?a (* ?a_size ?b))) :pattern ((MINUS_LEFT_PTR ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (PLUS ?a ?a_size ?b) (+ ?a (* ?a_size ?b))) :pattern ((PLUS ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (MULT ?a ?b) (* ?a ?b)) :pattern ((MULT ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_4 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (> ?b 0)))) (not (or (not (<= (* ?b ?v_4) ?a)) (not (< ?a (* ?b (+ ?v_4 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_5 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (< ?b 0)))) (not (or (not (<= (* ?b ?v_5) ?a)) (not (< ?a (* ?b (- ?v_5 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_6 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (> ?b 0)))) (not (or (not (>= (* ?b ?v_6) ?a)) (not (> ?a (* ?b (- ?v_6 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_7 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (< ?b 0)))) (not (or (not (>= (* ?b ?v_7) ?a)) (not (> ?a (* ?b (+ ?v_7 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (= (POW2 1) true_1)) (not (= (POW2 2) true_1)) (not (= (POW2 4) true_1)) (not (= (POW2 8) true_1)) (not (= (POW2 16) true_1)) (not (= (POW2 32) true_1)) (not (= (POW2 64) true_1)) (not (= (POW2 128) true_1)) (not (= (POW2 256) true_1)) (not (= (POW2 512) true_1)) (not (= (POW2 1024) true_1)) (not (= (POW2 2048) true_1)) (not (= (POW2 4096) true_1)) (not (= (POW2 8192) true_1)) (not (= (POW2 16384) true_1)) (not (= (POW2 32768) true_1)) (not (= (POW2 65536) true_1)) (not (= (POW2 131072) true_1)) (not (= (POW2 262144) true_1)) (not (= (POW2 524288) true_1)) (not (= (POW2 1048576) true_1)) (not (= (POW2 2097152) true_1)) (not (= (POW2 4194304) true_1)) (not (= (POW2 8388608) true_1)) (not (= (POW2 16777216) true_1)) (not (= (POW2 33554432) true_1)) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (= ?a true_1) (= (choose ?a ?b ?c) ?b)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (not (= ?a true_1)) (= (choose ?a ?b ?c) ?c)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= ?a ?b) (= (BIT_BAND ?a ?b) ?a)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (not (or (not (= (POW2 ?a) true_1)) (not (= (POW2 ?b) true_1)) (not (not (= ?a ?b))))) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (or (= ?a 0) (= ?b 0)) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int)) (! (= (= ?a true_1) (not (= (LIFT ?a) 0))) :pattern ((LIFT ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (boolNot ?a) 0))) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (boolNot ?a) 0)) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (NULL_CHECK ?a) 0))) :pattern ((NULL_CHECK ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (NULL_CHECK ?a) 0)) :pattern ((NULL_CHECK ?a)) ))))))
(assert (let ((?v_23 (HavocArray arr1 4 0))) (let ((?v_65 (not (= (Subset Empty (Difference (HavocArray arr1 4 size1) ?v_23)) true_1)))) (let ((?v_66 (not (or ?v_65 (not (forall ((?H_i Int) (?H_j Int)) (! (let ((?v_69 (Difference (HavocArray arr1 4 size1) ?v_23))) (=> (not (or (not (= (select1 ?v_69 ?H_i) true_1)) (not (= (select1 ?v_69 ?H_j) true_1)))) (=> (<= ?H_i ?H_j) (<= (select1 (select1 Mem_6 (Field ?H_i)) ?H_i) (select1 (select1 Mem_6 (Field ?H_j)) ?H_j))))) :pattern ((select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?H_i) (select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?H_j)) )))))) (?v_64 (forall ((?f Int) (?m Int)) (! (or (not (or (not (= (select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?m) true_1)) (not (= ?f (Field ?m))))) (= (select1 (select1 Mem_6 ?f) ?m) (select1 (select1 Mem ?f) ?m))) :pattern ((select1 (select1 Mem_6 ?f) ?m)) ))) (?v_63 (forall ((?a Int)) (! (let ((?v_70 (Field ?a))) (= (HasType (select1 (select1 Mem_6 ?v_70) ?a) ?v_70) true_1)) :pattern ((select1 (select1 Mem_6 (Field ?a)) ?a)) )))) (let ((?v_68 (=> true (=> true (=> (forall ((?m Int)) (! (let ((?v_72 (Field ?m)) (?v_71 (not (not (= (select1 alloc (Base ?m)) ALLOCATED))))) (=> (not (or ?v_71 ?v_71)) (= (select1 (select1 Mem_4 ?v_72) ?m) (select1 (select1 Mem ?v_72) ?m)))) :pattern ((select1 (select1 Mem_4 (Field ?m)) ?m)) )) (=> true (=> true (=> (= LOOP_11_alloc_2 LOOP_11_alloc_1) (=> (= i_4 i_2) (=> (= LOOP_11_Mem_2 LOOP_11_Mem_1) (=> (= Mem_6 Mem_4) (=> (= tmp_5 tmp_3) (=> (= aux_4 aux_2) (=> true (=> true (not (or (not ?v_63) (not (=> ?v_63 (not (or (not ?v_64) (not (=> ?v_64 (not (or (not ?v_66) (not (=> ?v_66 true)))))))))))))))))))))))))) (?v_67 (= 1 0)) (?v_62 (= aux_1 0)) (?v_61 (=> true (=> false true))) (?v_60 (= (HasType tmp_1 INT4_name) true_1)) (?v_1 (= (HasType size1 INT4_name) true_1))) (let ((?v_14 (not ?v_1)) (?v_35 (= (HasType i_1 INT4_name) true_1))) (let ((?v_42 (not ?v_35)) (?v_34 (= (HasType aux_1 INT4_name) true_1))) (let ((?v_41 (not ?v_34)) (?v_0 (= (HasType arr1 PINT4_name) true_1))) (let ((?v_11 (not ?v_0)) (?v_33 (forall ((?a Int)) (! (let ((?v_73 (Field ?a))) (= (HasType (select1 (select1 Mem_1 ?v_73) ?a) ?v_73) true_1)) :pattern ((select1 (select1 Mem_1 (Field ?a)) ?a)) )))) (let ((?v_59 (not ?v_33)) (?v_9 (Field 0))) (let ((?v_3 (select1 (select1 Mem ?v_9) 0)) (?v_58 (select1 (select1 Mem_1 ?v_9) 0)) (?v_57 (forall ((?f Int) (?m Int)) (! (or (not (or (not (= (select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?m) true_1)) (not (= ?f (Field ?m))))) (= (select1 (select1 Mem_1 ?f) ?m) (select1 (select1 Mem ?f) ?m))) :pattern ((select1 (select1 Mem_1 ?f) ?m)) ))) (?v_8 (forall ((?f Int)) (! (let ((?v_74 (select1 alloc (Base ?f)))) (or (= ?v_74 UNALLOCATED) (= ?v_74 ?v_74))) :pattern ((select1 alloc (Base ?f))) ))) (?v_56 (< i_1 (MINUS_BOTH_PTR_OR_BOTH_INT size1 1 1))) (?v_53 (= (HasType tmp_4 INT4_name) true_1)) (?v_52 (= (HasType i_3 INT4_name) true_1)) (?v_51 (= (HasType aux_3 INT4_name) true_1)) (?v_50 (forall ((?a Int)) (! (let ((?v_75 (Field ?a))) (= (HasType (select1 (select1 Mem_5 ?v_75) ?a) ?v_75) true_1)) :pattern ((select1 (select1 Mem_5 (Field ?a)) ?a)) ))) (?v_26 (select1 (select1 Mem_0 ?v_9) 0)) (?v_49 (forall ((?f Int) (?m Int)) (! (or (not (or (not (= (select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?m) true_1)) (not (= ?f (Field ?m))))) (= (select1 (select1 Mem_5 ?f) ?m) (select1 (select1 Mem_0 ?f) ?m))) :pattern ((select1 (select1 Mem_5 ?f) ?m)) ))) (?v_48 (not (or (not (= (Subset Empty (Difference (HavocArray arr1 4 (PLUS i_3 1 1)) (HavocArray arr1 4 aux_3))) true_1)) (not (forall ((?H_i Int) (?H_j Int)) (! (let ((?v_76 (Difference (HavocArray arr1 4 (PLUS i_3 1 1)) (HavocArray arr1 4 aux_3)))) (=> (not (or (not (= (select1 ?v_76 ?H_i) true_1)) (not (= (select1 ?v_76 ?H_j) true_1)))) (=> (<= ?H_i ?H_j) (<= (select1 (select1 Mem_5 (Field ?H_i)) ?H_i) (select1 (select1 Mem_5 (Field ?H_j)) ?H_j))))) :pattern ((select1 (Difference (HavocArray arr1 4 (PLUS i_3 1 1)) (HavocArray arr1 4 aux_3)) ?H_i) (select1 (Difference (HavocArray arr1 4 (PLUS i_3 1 1)) (HavocArray arr1 4 aux_3)) ?H_j)) )))))) (?v_47 (not (or (not (<= 0 i_3)) (not (< i_3 size1))))) (?v_29 (PLUS i_1 1 1))) (let ((?v_55 (=> true (=> true (=> (= i_3 ?v_29) (=> true (=> true (=> true (not (or (not ?v_47) (not (=> ?v_47 (not (or (not ?v_48) (not (=> ?v_48 (=> ?v_8 (not (or (not ?v_49) (not (=> ?v_49 (=> (= (select1 (select1 Mem_5 ?v_9) 0) ?v_26) (not (or (not ?v_50) (not (=> ?v_50 (not (or ?v_11 (not (=> ?v_0 (not (or (not ?v_51) (not (=> ?v_51 (not (or (not ?v_52) (not (=> ?v_52 (not (or ?v_14 (not (=> ?v_1 (not (or (not ?v_53) (not (=> ?v_53 ?v_61))))))))))))))))))))))))))))))))))))))))))))) (?v_31 (PLUS arr1 4 i_1))) (let ((?v_37 (Field ?v_31))) (let ((?v_38 (select1 Mem_1 ?v_37))) (let ((?v_32 (select1 ?v_38 ?v_31)) (?v_30 (PLUS arr1 4 ?v_29))) (let ((?v_44 (Field ?v_30))) (let ((?v_39 (select1 (select1 Mem_1 ?v_44) ?v_30))) (let ((?v_54 (< ?v_39 ?v_32)) (?v_36 (= (HasType tmp_2 INT4_name) true_1))) (let ((?v_43 (not ?v_36)) (?v_45 (forall ((?a Int)) (! (let ((?v_77 (Field ?a))) (= (HasType (select1 (select1 Mem_3 ?v_77) ?a) ?v_77) true_1)) :pattern ((select1 (select1 Mem_3 (Field ?a)) ?a)) )))) (let ((?v_46 (not ?v_45)) (?v_27 (not (= arr1 0)))) (let ((?v_28 (not ?v_27)) (?v_40 (forall ((?a Int)) (! (let ((?v_78 (Field ?a))) (= (HasType (select1 (select1 Mem_2 ?v_78) ?a) ?v_78) true_1)) :pattern ((select1 (select1 Mem_2 (Field ?a)) ?a)) ))) (?v_15 (= (HasType tmp_0 INT4_name) true_1))) (let ((?v_20 (not ?v_15)) (?v_12 (= (HasType 0 INT4_name) true_1))) (let ((?v_19 (not ?v_12)) (?v_10 (forall ((?a Int)) (! (let ((?v_79 (Field ?a))) (= (HasType (select1 (select1 Mem_0 ?v_79) ?a) ?v_79) true_1)) :pattern ((select1 (select1 Mem_0 (Field ?a)) ?a)) )))) (let ((?v_18 (not ?v_10)) (?v_25 (forall ((?f Int) (?m Int)) (! (let ((?v_80 (select1 (select1 Mem_0 ?f) ?m))) (or (not (or (not (= (select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?m) true_1)) (not (= ?f (Field ?m))))) (= ?v_80 ?v_80))) :pattern ((select1 (select1 Mem_0 ?f) ?m)) ))) (?v_24 (not (or (not (= (Subset Empty (Difference (HavocArray arr1 4 (PLUS 0 1 1)) ?v_23)) true_1)) (not (forall ((?H_i Int) (?H_j Int)) (! (let ((?v_81 (Difference (HavocArray arr1 4 (PLUS 0 1 1)) ?v_23))) (=> (not (or (not (= (select1 ?v_81 ?H_i) true_1)) (not (= (select1 ?v_81 ?H_j) true_1)))) (=> (<= ?H_i ?H_j) (<= (select1 (select1 Mem_0 (Field ?H_i)) ?H_i) (select1 (select1 Mem_0 (Field ?H_j)) ?H_j))))) :pattern ((select1 (Difference (HavocArray arr1 4 (PLUS 0 1 1)) ?v_23) ?H_i) (select1 (Difference (HavocArray arr1 4 (PLUS 0 1 1)) ?v_23) ?H_j)) )))))) (?v_16 (not (<= 0 0)))) (let ((?v_22 (not (or ?v_16 (not (< 0 size1))))) (?v_21 (not (or ?v_16 ?v_16 ?v_16 ?v_16))) (?v_17 (not (or ?v_16 ?v_16))) (?v_13 (= (HasType i_0 INT4_name) true_1)) (?v_7 (= (HasType tmp INT4_name) true_1)) (?v_6 (= (HasType i INT4_name) true_1)) (?v_5 (= (HasType aux INT4_name) true_1)) (?v_4 (forall ((?a Int)) (! (let ((?v_82 (Field ?a))) (= (HasType (select1 (select1 Mem ?v_82) ?a) ?v_82) true_1)) :pattern ((select1 (select1 Mem (Field ?a)) ?a)) ))) (?v_2 (forall ((?f Int) (?m Int)) (! (let ((?v_83 (select1 (select1 Mem ?f) ?m))) (or (not (or (not (= (select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?m) true_1)) (not (= ?f (Field ?m))))) (= ?v_83 ?v_83))) :pattern ((select1 (select1 Mem ?f) ?m)) )))) (not (=> true (=> ?v_1 (=> ?v_0 (=> ?v_4 (=> (> size1 0) (=> (not (or ?v_65 (not (forall ((?H_i Int)) (! (=> (= (select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?H_i) true_1) (= (HasType ?H_i PINT4_name) true_1)) :pattern ((select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?H_i)) ))))) (=> (> arr1 0) (=> true (=> (not (= (select1 alloc arr1) UNALLOCATED)) (=> (= (HasType arr PINT4_name) true_1) (=> ?v_0 (=> ?v_5 (=> ?v_6 (=> (= (HasType size INT4_name) true_1) (=> ?v_1 (=> ?v_7 (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> true (=> ?v_8 (not (or (not ?v_2) (not (=> ?v_2 (=> (= ?v_3 ?v_3) (not (or (not ?v_4) (not (=> ?v_4 (not (or ?v_11 (not (=> ?v_0 (not (or (not ?v_5) (not (=> ?v_5 (not (or (not ?v_6) (not (=> ?v_6 (not (or ?v_14 (not (=> ?v_1 (not (or (not ?v_7) (not (=> ?v_7 (=> true (=> true (=> true (=> ?v_8 (=> (forall ((?f Int) (?m Int)) (! (or (not (or (not (= (select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?m) true_1)) (not (= ?f (Field ?m))))) (= (select1 (select1 Mem_0 ?f) ?m) (select1 (select1 Mem ?f) ?m))) :pattern ((select1 (select1 Mem_0 ?f) ?m)) )) (=> (= ?v_26 ?v_3) (=> ?v_10 (=> ?v_0 (=> (= (HasType aux_0 INT4_name) true_1) (=> ?v_13 (=> ?v_1 (=> ?v_15 (=> true (not (or (not (=> true (=> true (=> (not ?v_67) (=> true (=> true (=> true (=> true (=> true (=> true (not (or ?v_18 (not (=> ?v_10 (not (or ?v_11 (not (=> ?v_0 (not (or ?v_19 (not (=> ?v_12 (not (or (not ?v_13) (not (=> ?v_13 (not (or ?v_14 (not (=> ?v_1 (not (or ?v_20 (not (=> ?v_15 (=> ?v_17 (=> true (=> ?v_17 (=> ?v_17 (=> true (=> ?v_17 (not (or ?v_18 (not (=> ?v_10 (not (or ?v_11 (not (=> ?v_0 (not (or ?v_19 (not (=> ?v_12 (not (or ?v_19 (not (=> ?v_12 (not (or ?v_14 (not (=> ?v_1 (not (or ?v_20 (not (=> ?v_15 (=> ?v_21 (=> true (=> ?v_21 (=> ?v_21 (=> true (=> ?v_21 (=> ?v_21 (=> true (=> ?v_21 (=> ?v_21 (=> true (not (or (not ?v_22) (not (=> ?v_22 (not (or (not ?v_24) (not (=> ?v_24 (=> ?v_8 (not (or (not ?v_25) (not (=> ?v_25 (=> (= ?v_26 ?v_26) (not (or ?v_18 (not (=> ?v_10 (not (or ?v_11 (not (=> ?v_0 (not (or ?v_19 (not (=> ?v_12 (not (or ?v_19 (not (=> ?v_12 (not (or ?v_14 (not (=> ?v_1 (not (or ?v_20 (not (=> ?v_15 (=> true (=> true (=> true (=> (not (or (not (<= 0 i_1)) (not (< i_1 size1)))) (=> (not (or (not (= (Subset Empty (Difference (HavocArray arr1 4 ?v_29) (HavocArray arr1 4 aux_1))) true_1)) (not (forall ((?H_i Int) (?H_j Int)) (! (let ((?v_84 (Difference (HavocArray arr1 4 ?v_29) (HavocArray arr1 4 aux_1)))) (=> (not (or (not (= (select1 ?v_84 ?H_i) true_1)) (not (= (select1 ?v_84 ?H_j) true_1)))) (=> (<= ?H_i ?H_j) (<= (select1 (select1 Mem_1 (Field ?H_i)) ?H_i) (select1 (select1 Mem_1 (Field ?H_j)) ?H_j))))) :pattern ((select1 (Difference (HavocArray arr1 4 ?v_29) (HavocArray arr1 4 aux_1)) ?H_i) (select1 (Difference (HavocArray arr1 4 ?v_29) (HavocArray arr1 4 aux_1)) ?H_j)) ))))) (=> ?v_8 (=> (forall ((?f Int) (?m Int)) (! (or (not (or (not (= (select1 (Difference (HavocArray arr1 4 size1) ?v_23) ?m) true_1)) (not (= ?f (Field ?m))))) (= (select1 (select1 Mem_1 ?f) ?m) (select1 (select1 Mem_0 ?f) ?m))) :pattern ((select1 (select1 Mem_1 ?f) ?m)) )) (=> (= ?v_58 ?v_26) (=> ?v_33 (=> ?v_0 (=> ?v_34 (=> ?v_35 (=> ?v_1 (=> ?v_60 (=> true (not (or (not (=> true (=> true (=> ?v_56 (=> true (=> true (=> true (not (or ?v_28 (not (=> ?v_27 (not (or ?v_28 (not (=> ?v_27 (=> true (not (or (not (=> true (=> true (=> ?v_54 (=> true (=> true (=> true (=> true (=> true (=> true (not (or ?v_28 (not (=> ?v_27 (=> (= tmp_2 ?v_32) (not (or ?v_59 (not (=> ?v_33 (not (or ?v_11 (not (=> ?v_0 (not (or ?v_41 (not (=> ?v_34 (not (or ?v_42 (not (=> ?v_35 (not (or ?v_14 (not (=> ?v_1 (not (or ?v_43 (not (=> ?v_36 (=> true (=> true (=> true (not (or ?v_28 (not (=> ?v_27 (not (or ?v_28 (not (=> ?v_27 (=> (= Mem_2 (store1 Mem_1 ?v_37 (store1 ?v_38 ?v_31 ?v_39))) (not (or (not ?v_40) (not (=> ?v_40 (not (or ?v_11 (not (=> ?v_0 (not (or ?v_41 (not (=> ?v_34 (not (or ?v_42 (not (=> ?v_35 (not (or ?v_14 (not (=> ?v_1 (not (or ?v_43 (not (=> ?v_36 (=> true (=> true (=> true (not (or ?v_28 (not (=> ?v_27 (=> (= Mem_3 (store1 Mem_2 ?v_44 (store1 (select1 Mem_2 ?v_44) ?v_30 tmp_2))) (not (or ?v_46 (not (=> ?v_45 (not (or ?v_11 (not (=> ?v_0 (not (or ?v_41 (not (=> ?v_34 (not (or ?v_42 (not (=> ?v_35 (not (or ?v_14 (not (=> ?v_1 (not (or ?v_43 (not (=> ?v_36 (=> true (=> true (=> true (not (or ?v_46 (not (=> ?v_45 (not (or ?v_11 (not (=> ?v_0 (not (or ?v_42 (not (=> ?v_35 (not (or ?v_42 (not (=> ?v_35 (not (or ?v_14 (not (=> ?v_1 (not (or ?v_43 (not (=> ?v_36 (=> true (=> true (=> (= Mem_5 Mem_3) (=> (= tmp_4 tmp_2) (=> (= aux_3 i_1) ?v_55))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> (not ?v_54) (=> true (=> true (=> (= Mem_5 Mem_1) (=> (= tmp_4 tmp_1) (=> (= aux_3 aux_1) ?v_55))))))))))))))))))))))))))) (not (=> true (=> true (=> (not ?v_56) (=> true (=> true (=> true (=> true (not (or (not (=> true (=> true (=> (not ?v_62) (=> true (=> true (=> true (=> ?v_8 (not (or (not ?v_57) (not (=> ?v_57 (=> (= ?v_58 ?v_3) (not (or ?v_59 (not (=> ?v_33 (not (or ?v_11 (not (=> ?v_0 (not (or ?v_41 (not (=> ?v_34 (not (or ?v_42 (not (=> ?v_35 (not (or ?v_14 (not (=> ?v_1 (not (or (not ?v_60) (not (=> ?v_60 ?v_61))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> ?v_62 (=> (not (or (not (<= 0 aux_1)) (not (<= aux_1 0)))) (=> true (=> (= LOOP_11_alloc_1 alloc) (=> (= i_2 i_1) (=> (= LOOP_11_Mem_1 Mem_0) (=> (= Mem_4 Mem_1) (=> (= tmp_3 tmp_1) (=> (= aux_2 aux_1) ?v_68)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> ?v_67 (=> true (=> true (=> (= LOOP_11_alloc_1 LOOP_11_alloc_0) (=> (= i_2 i_0) (=> (= LOOP_11_Mem_1 LOOP_11_Mem_0) (=> (= Mem_4 Mem_0) (=> (= tmp_3 tmp_0) (=> (= aux_2 aux_0) ?v_68)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
