(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun NULL_CHECK (Int) Int)
(declare-fun LIFT (Int) Int)
(declare-fun BIT_BAND (Int Int) Int)
(declare-fun POW2 (Int) Int)
(declare-fun choose (Int Int Int) Int)
(declare-fun DIV (Int Int) Int)
(declare-fun MULT (Int Int) Int)
(declare-fun PLUS (Int Int Int) Int)
(declare-fun MINUS_LEFT_PTR (Int Int Int) Int)
(declare-fun MINUS_BOTH_PTR_OR_BOTH_INT (Int Int Int) Int)
(declare-fun i__CInv (Int) Int)
(declare-fun i__C (Int) Int)
(declare-fun S_i__CInv (Int) Int)
(declare-fun S_i__C (Int) Int)
(declare-fun g__CInv (Int) Int)
(declare-fun g__C (Int) Int)
(declare-fun S_g__CInv (Int) Int)
(declare-fun S_g__C (Int) Int)
(declare-fun f__CInv (Int) Int)
(declare-fun f__C (Int) Int)
(declare-fun S_f__CInv (Int) Int)
(declare-fun S_f__C (Int) Int)
(declare-fun e__CInv (Int) Int)
(declare-fun e__C (Int) Int)
(declare-fun S_e__CInv (Int) Int)
(declare-fun S_e__C (Int) Int)
(declare-fun d__BInv (Int) Int)
(declare-fun d__B (Int) Int)
(declare-fun S_d__BInv (Int) Int)
(declare-fun S_d__B (Int) Int)
(declare-fun c__BInv (Int) Int)
(declare-fun c__B (Int) Int)
(declare-fun S_c__BInv (Int) Int)
(declare-fun S_c__B (Int) Int)
(declare-fun b__AInv (Int) Int)
(declare-fun b__A (Int) Int)
(declare-fun S_b__AInv (Int) Int)
(declare-fun S_b__A (Int) Int)
(declare-fun a__AInv (Int) Int)
(declare-fun a__A (Int) Int)
(declare-fun S_a__AInv (Int) Int)
(declare-fun S_a__A (Int) Int)
(declare-fun Match (Int Int) Int)
(declare-fun C_name () Int)
(declare-fun A_name () Int)
(declare-fun INT4_name () Int)
(declare-fun f__C_name () Int)
(declare-fun e__C_name () Int)
(declare-fun B_name () Int)
(declare-fun d__B_name () Int)
(declare-fun VOID_name () Int)
(declare-fun HasType (Int Int) Int)
(declare-fun P_C_name () Int)
(declare-fun Field (Int) Int)
(declare-fun P_B_name () Int)
(declare-fun P_A_name () Int)
(declare-fun PVOID_name () Int)
(declare-fun PP_C_name () Int)
(declare-fun PP_B_name () Int)
(declare-fun PP_A_name () Int)
(declare-fun PPVOID_name () Int)
(declare-fun PINT4_name () Int)
(declare-fun PPINT4_name () Int)
(declare-fun CHAR_name () Int)
(declare-fun PCHAR_name () Int)
(declare-fun g__C_name () Int)
(declare-fun b__A_name () Int)
(declare-fun a__A_name () Int)
(declare-fun Values (Int) Int)
(declare-fun Unified (Int) Int)
(declare-fun Disjoint (Int Int) Int)
(declare-fun Subset (Int Int) Int)
(declare-fun Equal (Int Int) Int)
(declare-fun Inverse (Int Int) Int)
(declare-fun Difference (Int Int) Int)
(declare-fun Singleton (Int) Int)
(declare-fun Union (Int Int) Int)
(declare-fun Dereference (Int Int) Int)
(declare-fun Intersection (Int Int) Int)
(declare-fun Empty () Int)
(declare-fun HavocArray (Int Int Int) Int)
(declare-fun AtLeast (Int Int) Int)
(declare-fun Rep (Int Int) Int)
(declare-fun FourBytesToInt (Int Int Int Int) Int)
(declare-fun TwoBytesToInt (Int Int) Int)
(declare-fun OneByteToInt (Int) Int)
(declare-fun i__C_name () Int)
(declare-fun c__B_name () Int)
(declare-fun BYTE () Int)
(declare-fun FREED () Int)
(declare-fun ALLOCATED () Int)
(declare-fun UNALLOCATED () Int)
(declare-fun Mem () Int)
(declare-fun Base (Int) Int)
(declare-fun alloc () Int)
(declare-fun x1 () Int)
(declare-fun y () Int)
(declare-fun x_1 () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct UNALLOCATED ALLOCATED FREED BYTE a__A_name b__A_name c__B_name d__B_name e__C_name f__C_name g__C_name i__C_name CHAR_name INT4_name PCHAR_name PINT4_name PPINT4_name PPVOID_name PP_A_name PP_B_name PP_C_name PVOID_name P_A_name P_B_name P_C_name VOID_name A_name B_name C_name)) (not (forall ((?b0 Int) (?c0 Int)) (! (=> (= (OneByteToInt ?b0) (OneByteToInt ?c0)) (= ?b0 ?c0)) :pattern ((OneByteToInt ?b0) (OneByteToInt ?c0)) ))) (not (forall ((?b0 Int) (?b1 Int) (?c0 Int) (?c1 Int)) (! (=> (= (TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1))))) :pattern ((TwoBytesToInt ?b0 ?b1) (TwoBytesToInt ?c0 ?c1)) ))) (not (forall ((?b0 Int) (?b1 Int) (?b2 Int) (?b3 Int) (?c0 Int) (?c1 Int) (?c2 Int) (?c3 Int)) (! (=> (= (FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) (not (or (not (= ?b0 ?c0)) (not (= ?b1 ?c1)) (not (= ?b2 ?c2)) (not (= ?b3 ?c3))))) :pattern ((FourBytesToInt ?b0 ?b1 ?b2 ?b3) (FourBytesToInt ?c0 ?c1 ?c2 ?c3)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (= (select1 (AtLeast ?n ?x_1) ?y) true_1) (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y)))))) :pattern ((select1 (AtLeast ?n ?x_1) ?y)) ))) (not (forall ((?n Int) (?x_1 Int) (?y Int)) (! (=> (not (or (not (<= ?x_1 ?y)) (not (= (Rep ?n ?x_1) (Rep ?n ?y))))) (= (select1 (AtLeast ?n ?x_1) ?y) true_1)) :pattern ((AtLeast ?n ?x_1) (Rep ?n ?x_1) (Rep ?n ?y)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (= (select1 (AtLeast ?n ?x_1) ?x_1) true_1) :pattern ((AtLeast ?n ?x_1)) ))) (not (forall ((?n Int) (?x_1 Int) (?z Int)) (! (= (Rep ?n ?x_1) (Rep ?n (PLUS ?x_1 ?n ?z))) :pattern ((PLUS ?x_1 ?n ?z)) ))) (not (forall ((?n Int) (?x_1 Int)) (! (exists ((?k Int)) (= (- (Rep ?n ?x_1) ?x_1) (* ?n ?k))) :pattern ((Rep ?n ?x_1)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (<= ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) Empty) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int) (?n Int) (?z Int)) (! (=> (> ?z 0) (= (Equal (HavocArray ?x_1 ?n ?z) (Difference (AtLeast ?n ?x_1) (AtLeast ?n (PLUS ?x_1 ?n ?z)))) true_1)) :pattern ((HavocArray ?x_1 ?n ?z)) ))) (not (forall ((?x_1 Int)) (not (= (select1 Empty ?x_1) true_1)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (select1 (Singleton ?y) ?x_1) true_1) (= ?x_1 ?y)) :pattern ((select1 (Singleton ?y) ?x_1)) ))) (not (forall ((?y Int)) (! (= (select1 (Singleton ?y) ?y) true_1) :pattern ((Singleton ?y)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Union ?S ?T) ?x_1) true_1) (or (= (select1 ?S ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((select1 (Union ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?T ?x_1) true_1) (= (select1 (Union ?S ?T) ?x_1) true_1)) :pattern ((Union ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Intersection ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 (Intersection ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))) (= (select1 (Intersection ?S ?T) ?x_1) true_1)) :pattern ((Intersection ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (= (= (select1 (Difference ?S ?T) ?x_1) true_1) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((select1 (Difference ?S ?T) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (= (select1 ?S ?x_1) true_1) (or (= (select1 (Difference ?S ?T) ?x_1) true_1) (= (select1 ?T ?x_1) true_1))) :pattern ((Difference ?S ?T) (select1 ?S ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 (Dereference ?S ?M) ?x_1) true_1) (exists ((?y Int)) (not (or (not (= ?x_1 (select1 ?M ?y))) (not (= (select1 ?S ?y) true_1)))))) :pattern ((select1 (Dereference ?S ?M) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int) (?M Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (Dereference ?S ?M) (select1 ?M ?x_1)) true_1)) :pattern ((select1 ?M ?x_1) (select1 ?S ?x_1) (Dereference ?S ?M)) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (= (select1 ?S ?x_1) true_1)) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Dereference ?S ?M)) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (let ((?v_0 (select1 ?M ?x_1))) (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Equal (Intersection (Inverse ?M ?v_0) ?S) (Singleton ?x_1)) true_1)))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Difference (Dereference ?S ?M) (Singleton ?v_0)) (Singleton ?y))) true_1))) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?x_1 Int) (?y Int) (?S Int) (?M Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (Equal (Intersection (Inverse ?M (select1 ?M ?x_1)) ?S) (Singleton ?x_1)) true_1))))) (= (Equal (Dereference ?S (store1 ?M ?x_1 ?y)) (Union (Dereference ?S ?M) (Singleton ?y))) true_1)) :pattern ((Dereference ?S (store1 ?M ?x_1 ?y))) ))) (not (forall ((?f Int) (?x_1 Int)) (! (= (select1 (Inverse ?f (select1 ?f ?x_1)) ?x_1) true_1) :pattern ((Inverse ?f (select1 ?f ?x_1))) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int)) (! (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?y) (Union (Inverse ?f ?y) (Singleton ?x_1))) true_1) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?y)) ))) (not (forall ((?f Int) (?x_1 Int) (?y Int) (?z Int)) (! (or (= ?y ?z) (= (Equal (Inverse (store1 ?f ?x_1 ?y) ?z) (Difference (Inverse ?f ?z) (Singleton ?x_1))) true_1)) :pattern ((Inverse (store1 ?f ?x_1 ?y) ?z)) ))) (not (forall ((?S Int) (?T Int)) (! (= (= (Equal ?S ?T) true_1) (not (or (not (= (Subset ?S ?T) true_1)) (not (= (Subset ?T ?S) true_1))))) :pattern ((Equal ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (=> (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Subset ?S ?T) true_1)))) (= (select1 ?T ?x_1) true_1)) :pattern ((select1 ?S ?x_1) (Subset ?S ?T)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Subset ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (not (= (select1 ?T ?x_1) true_1))))))) :pattern ((Subset ?S ?T)) ))) (not (forall ((?x_1 Int) (?S Int) (?T Int)) (! (not (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (Disjoint ?S ?T) true_1)) (not (= (select1 ?T ?x_1) true_1))))) :pattern ((select1 ?S ?x_1) (Disjoint ?S ?T) (select1 ?T ?x_1)) ))) (not (forall ((?S Int) (?T Int)) (! (or (= (Disjoint ?S ?T) true_1) (exists ((?x_1 Int)) (not (or (not (= (select1 ?S ?x_1) true_1)) (not (= (select1 ?T ?x_1) true_1)))))) :pattern ((Disjoint ?S ?T)) ))) (not (forall ((?M Int) (?x_1 Int)) (! (= (select1 (Unified ?M) ?x_1) (select1 (select1 ?M (Field ?x_1)) ?x_1)) :pattern ((select1 (Unified ?M) ?x_1)) ))) (not (forall ((?M Int) (?x_1 Int) (?y Int)) (! (let ((?v_1 (Field ?x_1))) (= (Unified (store1 ?M ?v_1 (store1 (select1 ?M ?v_1) ?x_1 ?y))) (store1 (Unified ?M) ?x_1 ?y))) :pattern ((Unified (store1 ?M (Field ?x_1) (store1 (select1 ?M (Field ?x_1)) ?x_1 ?y)))) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (select1 (Values ?t) ?v) true_1) (= (HasType ?v ?t) true_1)) :pattern ((select1 (Values ?t) ?v)) ))) (not (forall ((?v Int) (?t Int)) (! (=> (= (HasType ?v ?t) true_1) (= (select1 (Values ?t) ?v) true_1)) :pattern ((HasType ?v ?t) (Values ?t)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a a__A_name) true_1) (= (Field ?a) a__A_name)) :pattern ((Match ?a a__A_name)) ))) (not (forall ((?v Int)) (= (HasType ?v a__A_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a b__A_name) true_1) (= (Field ?a) b__A_name)) :pattern ((Match ?a b__A_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v b__A_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v INT4_name) true_1)))))) :pattern ((HasType ?v b__A_name))  :pattern ((Match ?v INT4_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a d__B_name) true_1) (= (Field ?a) d__B_name)) :pattern ((Match ?a d__B_name)) ))) (not (forall ((?v Int)) (= (HasType ?v d__B_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a e__C_name) true_1) (= (Field ?a) e__C_name)) :pattern ((Match ?a e__C_name)) ))) (not (forall ((?v Int)) (= (HasType ?v e__C_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a f__C_name) true_1) (= (Field ?a) f__C_name)) :pattern ((Match ?a f__C_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v f__C_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v INT4_name) true_1)))))) :pattern ((HasType ?v f__C_name))  :pattern ((Match ?v INT4_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a g__C_name) true_1) (= (Field ?a) g__C_name)) :pattern ((Match ?a g__C_name)) ))) (not (forall ((?v Int)) (= (HasType ?v g__C_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a CHAR_name) true_1) (= (Field ?a) CHAR_name)) :pattern ((Match ?a CHAR_name)) ))) (not (forall ((?v Int)) (= (HasType ?v CHAR_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a INT4_name) true_1) (= (Field ?a) INT4_name)) :pattern ((Match ?a INT4_name)) ))) (not (forall ((?v Int)) (= (HasType ?v INT4_name) true_1))) (not (forall ((?a Int)) (! (= (= (Match ?a PCHAR_name) true_1) (= (Field ?a) PCHAR_name)) :pattern ((Match ?a PCHAR_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PCHAR_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v CHAR_name) true_1)))))) :pattern ((HasType ?v PCHAR_name))  :pattern ((Match ?v CHAR_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PINT4_name) true_1) (= (Field ?a) PINT4_name)) :pattern ((Match ?a PINT4_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PINT4_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v INT4_name) true_1)))))) :pattern ((HasType ?v PINT4_name))  :pattern ((Match ?v INT4_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PPINT4_name) true_1) (= (Field ?a) PPINT4_name)) :pattern ((Match ?a PPINT4_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PPINT4_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v PINT4_name) true_1)))))) :pattern ((HasType ?v PPINT4_name))  :pattern ((Match ?v PINT4_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PPVOID_name) true_1) (= (Field ?a) PPVOID_name)) :pattern ((Match ?a PPVOID_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PPVOID_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v PVOID_name) true_1)))))) :pattern ((HasType ?v PPVOID_name))  :pattern ((Match ?v PVOID_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PP_A_name) true_1) (= (Field ?a) PP_A_name)) :pattern ((Match ?a PP_A_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PP_A_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v P_A_name) true_1)))))) :pattern ((HasType ?v PP_A_name))  :pattern ((Match ?v P_A_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PP_B_name) true_1) (= (Field ?a) PP_B_name)) :pattern ((Match ?a PP_B_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PP_B_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v P_B_name) true_1)))))) :pattern ((HasType ?v PP_B_name))  :pattern ((Match ?v P_B_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PP_C_name) true_1) (= (Field ?a) PP_C_name)) :pattern ((Match ?a PP_C_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PP_C_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v P_C_name) true_1)))))) :pattern ((HasType ?v PP_C_name))  :pattern ((Match ?v P_C_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a PVOID_name) true_1) (= (Field ?a) PVOID_name)) :pattern ((Match ?a PVOID_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v PVOID_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v VOID_name) true_1)))))) :pattern ((HasType ?v PVOID_name))  :pattern ((Match ?v VOID_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a P_A_name) true_1) (= (Field ?a) P_A_name)) :pattern ((Match ?a P_A_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v P_A_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v A_name) true_1)))))) :pattern ((HasType ?v P_A_name))  :pattern ((Match ?v A_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a P_B_name) true_1) (= (Field ?a) P_B_name)) :pattern ((Match ?a P_B_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v P_B_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v B_name) true_1)))))) :pattern ((HasType ?v P_B_name))  :pattern ((Match ?v B_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a P_C_name) true_1) (= (Field ?a) P_C_name)) :pattern ((Match ?a P_C_name)) ))) (not (forall ((?v Int)) (! (= (= (HasType ?v P_C_name) true_1) (or (= ?v 0) (not (or (not (> ?v 0)) (not (= (Match ?v C_name) true_1)))))) :pattern ((HasType ?v P_C_name))  :pattern ((Match ?v C_name)) ))) (not (forall ((?a Int)) (! (= (Match ?a VOID_name) true_1) :pattern ((Match ?a VOID_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a A_name) true_1) (not (or (not true) (not (= (Match (a__A ?a) e__C_name) true_1)) (not (= (Match (b__A ?a) f__C_name) true_1))))) :pattern ((Match ?a A_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a B_name) true_1) (not (or (not true) (not (= (Match (c__B ?a) A_name) true_1)) (not (= (Match (d__B ?a) d__B_name) true_1))))) :pattern ((Match ?a B_name)) ))) (not (forall ((?a Int)) (! (= (= (Match ?a C_name) true_1) (not (or (not true) (not (= (Match (e__C ?a) e__C_name) true_1)) (not (= (Match (f__C ?a) f__C_name) true_1)) (not (= (Match (g__C ?a) INT4_name) true_1)) (not (= (Match (i__C ?a) A_name) true_1))))) :pattern ((Match ?a C_name)) ))) (not (forall ((?x_1 Int)) (! (= (a__AInv (a__A ?x_1)) ?x_1) :pattern ((a__A ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (a__A (a__AInv ?x_1)) ?x_1) :pattern ((a__AInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_a__A ?S) ?x_1) true_1) (= (select1 ?S (a__AInv ?x_1)) true_1)) :pattern ((select1 (S_a__A ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_a__AInv ?S) ?x_1) true_1) (= (select1 ?S (a__A ?x_1)) true_1)) :pattern ((select1 (S_a__AInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_a__A ?S) (a__A ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_a__A ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_a__AInv ?S) (a__AInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_a__AInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (a__A ?x_1) (+ ?x_1 0)) :pattern ((a__A ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (a__AInv ?x_1) (- ?x_1 0)) :pattern ((a__AInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1) (a__AInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 0) (a__AInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 0)) ))) (not (forall ((?x_1 Int)) (! (= (b__AInv (b__A ?x_1)) ?x_1) :pattern ((b__A ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (b__A (b__AInv ?x_1)) ?x_1) :pattern ((b__AInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_b__A ?S) ?x_1) true_1) (= (select1 ?S (b__AInv ?x_1)) true_1)) :pattern ((select1 (S_b__A ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_b__AInv ?S) ?x_1) true_1) (= (select1 ?S (b__A ?x_1)) true_1)) :pattern ((select1 (S_b__AInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_b__A ?S) (b__A ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_b__A ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_b__AInv ?S) (b__AInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_b__AInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (b__A ?x_1) (+ ?x_1 4)) :pattern ((b__A ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (b__AInv ?x_1) (- ?x_1 4)) :pattern ((b__AInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1) (b__AInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 4) (b__AInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 4)) ))) (not (forall ((?x_1 Int)) (! (= (c__BInv (c__B ?x_1)) ?x_1) :pattern ((c__B ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (c__B (c__BInv ?x_1)) ?x_1) :pattern ((c__BInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_c__B ?S) ?x_1) true_1) (= (select1 ?S (c__BInv ?x_1)) true_1)) :pattern ((select1 (S_c__B ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_c__BInv ?S) ?x_1) true_1) (= (select1 ?S (c__B ?x_1)) true_1)) :pattern ((select1 (S_c__BInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_c__B ?S) (c__B ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_c__B ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_c__BInv ?S) (c__BInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_c__BInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (c__B ?x_1) (+ ?x_1 0)) :pattern ((c__B ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (c__BInv ?x_1) (- ?x_1 0)) :pattern ((c__BInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1) (c__BInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 0) (c__BInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 0)) ))) (not (forall ((?x_1 Int)) (! (= (d__BInv (d__B ?x_1)) ?x_1) :pattern ((d__B ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (d__B (d__BInv ?x_1)) ?x_1) :pattern ((d__BInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_d__B ?S) ?x_1) true_1) (= (select1 ?S (d__BInv ?x_1)) true_1)) :pattern ((select1 (S_d__B ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_d__BInv ?S) ?x_1) true_1) (= (select1 ?S (d__B ?x_1)) true_1)) :pattern ((select1 (S_d__BInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_d__B ?S) (d__B ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_d__B ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_d__BInv ?S) (d__BInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_d__BInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (d__B ?x_1) (+ ?x_1 8)) :pattern ((d__B ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (d__BInv ?x_1) (- ?x_1 8)) :pattern ((d__BInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 8 1) (d__BInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 8 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 8) (d__BInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 8)) ))) (not (forall ((?x_1 Int)) (! (= (e__CInv (e__C ?x_1)) ?x_1) :pattern ((e__C ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (e__C (e__CInv ?x_1)) ?x_1) :pattern ((e__CInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_e__C ?S) ?x_1) true_1) (= (select1 ?S (e__CInv ?x_1)) true_1)) :pattern ((select1 (S_e__C ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_e__CInv ?S) ?x_1) true_1) (= (select1 ?S (e__C ?x_1)) true_1)) :pattern ((select1 (S_e__CInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_e__C ?S) (e__C ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_e__C ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_e__CInv ?S) (e__CInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_e__CInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (e__C ?x_1) (+ ?x_1 0)) :pattern ((e__C ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (e__CInv ?x_1) (- ?x_1 0)) :pattern ((e__CInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1) (e__CInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 0 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 0) (e__CInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 0)) ))) (not (forall ((?x_1 Int)) (! (= (f__CInv (f__C ?x_1)) ?x_1) :pattern ((f__C ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (f__C (f__CInv ?x_1)) ?x_1) :pattern ((f__CInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_f__C ?S) ?x_1) true_1) (= (select1 ?S (f__CInv ?x_1)) true_1)) :pattern ((select1 (S_f__C ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_f__CInv ?S) ?x_1) true_1) (= (select1 ?S (f__C ?x_1)) true_1)) :pattern ((select1 (S_f__CInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_f__C ?S) (f__C ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_f__C ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_f__CInv ?S) (f__CInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_f__CInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (f__C ?x_1) (+ ?x_1 4)) :pattern ((f__C ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (f__CInv ?x_1) (- ?x_1 4)) :pattern ((f__CInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1) (f__CInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 4 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 4) (f__CInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 4)) ))) (not (forall ((?x_1 Int)) (! (= (g__CInv (g__C ?x_1)) ?x_1) :pattern ((g__C ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (g__C (g__CInv ?x_1)) ?x_1) :pattern ((g__CInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_g__C ?S) ?x_1) true_1) (= (select1 ?S (g__CInv ?x_1)) true_1)) :pattern ((select1 (S_g__C ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_g__CInv ?S) ?x_1) true_1) (= (select1 ?S (g__C ?x_1)) true_1)) :pattern ((select1 (S_g__CInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_g__C ?S) (g__C ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_g__C ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_g__CInv ?S) (g__CInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_g__CInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (g__C ?x_1) (+ ?x_1 8)) :pattern ((g__C ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (g__CInv ?x_1) (- ?x_1 8)) :pattern ((g__CInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 8 1) (g__CInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 8 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 8) (g__CInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 8)) ))) (not (forall ((?x_1 Int)) (! (= (i__CInv (i__C ?x_1)) ?x_1) :pattern ((i__C ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (i__C (i__CInv ?x_1)) ?x_1) :pattern ((i__CInv ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_i__C ?S) ?x_1) true_1) (= (select1 ?S (i__CInv ?x_1)) true_1)) :pattern ((select1 (S_i__C ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (= (= (select1 (S_i__CInv ?S) ?x_1) true_1) (= (select1 ?S (i__C ?x_1)) true_1)) :pattern ((select1 (S_i__CInv ?S) ?x_1)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_i__C ?S) (i__C ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_i__C ?S)) ))) (not (forall ((?x_1 Int) (?S Int)) (! (=> (= (select1 ?S ?x_1) true_1) (= (select1 (S_i__CInv ?S) (i__CInv ?x_1)) true_1)) :pattern ((select1 ?S ?x_1) (S_i__CInv ?S)) ))) (not (forall ((?x_1 Int)) (! (= (i__C ?x_1) (+ ?x_1 12)) :pattern ((i__C ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (i__CInv ?x_1) (- ?x_1 12)) :pattern ((i__CInv ?x_1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 12 1) (i__CInv ?x_1)) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?x_1 12 1)) ))) (not (forall ((?x_1 Int)) (! (= (MINUS_LEFT_PTR ?x_1 1 12) (i__CInv ?x_1)) :pattern ((MINUS_LEFT_PTR ?x_1 1 12)) ))) (not (forall ((?a Int) (?b Int) (?size Int)) (! (let ((?v_3 (MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) (?v_2 (- ?a ?b))) (not (or (not (<= (* ?size ?v_3) ?v_2)) (not (< ?v_2 (* ?size (+ ?v_3 1))))))) :pattern ((MINUS_BOTH_PTR_OR_BOTH_INT ?a ?b ?size)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (MINUS_LEFT_PTR ?a ?a_size ?b) (- ?a (* ?a_size ?b))) :pattern ((MINUS_LEFT_PTR ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?a_size Int) (?b Int)) (! (= (PLUS ?a ?a_size ?b) (+ ?a (* ?a_size ?b))) :pattern ((PLUS ?a ?a_size ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (MULT ?a ?b) (* ?a ?b)) :pattern ((MULT ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_4 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (> ?b 0)))) (not (or (not (<= (* ?b ?v_4) ?a)) (not (< ?a (* ?b (+ ?v_4 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_5 (DIV ?a ?b))) (=> (not (or (not (>= ?a 0)) (not (< ?b 0)))) (not (or (not (<= (* ?b ?v_5) ?a)) (not (< ?a (* ?b (- ?v_5 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_6 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (> ?b 0)))) (not (or (not (>= (* ?b ?v_6) ?a)) (not (> ?a (* ?b (- ?v_6 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (let ((?v_7 (DIV ?a ?b))) (=> (not (or (not (< ?a 0)) (not (< ?b 0)))) (not (or (not (>= (* ?b ?v_7) ?a)) (not (> ?a (* ?b (+ ?v_7 1)))))))) :pattern ((DIV ?a ?b)) ))) (not (= (POW2 1) true_1)) (not (= (POW2 2) true_1)) (not (= (POW2 4) true_1)) (not (= (POW2 8) true_1)) (not (= (POW2 16) true_1)) (not (= (POW2 32) true_1)) (not (= (POW2 64) true_1)) (not (= (POW2 128) true_1)) (not (= (POW2 256) true_1)) (not (= (POW2 512) true_1)) (not (= (POW2 1024) true_1)) (not (= (POW2 2048) true_1)) (not (= (POW2 4096) true_1)) (not (= (POW2 8192) true_1)) (not (= (POW2 16384) true_1)) (not (= (POW2 32768) true_1)) (not (= (POW2 65536) true_1)) (not (= (POW2 131072) true_1)) (not (= (POW2 262144) true_1)) (not (= (POW2 524288) true_1)) (not (= (POW2 1048576) true_1)) (not (= (POW2 2097152) true_1)) (not (= (POW2 4194304) true_1)) (not (= (POW2 8388608) true_1)) (not (= (POW2 16777216) true_1)) (not (= (POW2 33554432) true_1)) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (= ?a true_1) (= (choose ?a ?b ?c) ?b)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int) (?c Int)) (! (=> (not (= ?a true_1)) (= (choose ?a ?b ?c) ?c)) :pattern ((choose ?a ?b ?c)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= ?a ?b) (= (BIT_BAND ?a ?b) ?a)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (not (or (not (= (POW2 ?a) true_1)) (not (= (POW2 ?b) true_1)) (not (not (= ?a ?b))))) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (or (= ?a 0) (= ?b 0)) (= (BIT_BAND ?a ?b) 0)) :pattern ((BIT_BAND ?a ?b)) ))) (not (forall ((?a Int)) (! (= (= ?a true_1) (not (= (LIFT ?a) 0))) :pattern ((LIFT ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (boolNot ?a) 0))) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (boolNot ?a) 0)) :pattern ((boolNot ?a)) ))) (not (forall ((?a Int)) (! (=> (= ?a 0) (not (= (NULL_CHECK ?a) 0))) :pattern ((NULL_CHECK ?a)) ))) (not (forall ((?a Int)) (! (=> (not (= ?a 0)) (= (NULL_CHECK ?a) 0)) :pattern ((NULL_CHECK ?a)) ))))))
(assert (let ((?v_4 (forall ((?f Int) (?m Int)) (! (let ((?v_5 (select1 (select1 Mem ?f) ?m))) (= ?v_5 ?v_5)) :pattern ((select1 (select1 Mem ?f) ?m)) ))) (?v_1 (forall ((?a Int)) (! (let ((?v_6 (Field ?a))) (= (HasType (select1 (select1 Mem ?v_6) ?a) ?v_6) true_1)) :pattern ((select1 (select1 Mem (Field ?a)) ?a)) )))) (let ((?v_3 (not ?v_1)) (?v_2 (= (HasType x1 P_A_name) true_1)) (?v_0 (= (HasType x1 PVOID_name) true_1))) (not (=> true (=> ?v_0 (=> ?v_1 (=> ?v_2 (=> true (=> (not (= (select1 alloc x1) UNALLOCATED)) (=> (= (HasType x_1 PVOID_name) true_1) (=> ?v_0 (=> (= (HasType y P_A_name) true_1) (=> true (=> true (=> true (=> true (=> true (=> true (not (or ?v_3 (not (=> ?v_1 (not (or (not ?v_0) (not (=> ?v_0 (not (or (not ?v_2) (not (=> ?v_2 (=> true (=> true (=> true (=> (forall ((?m Int)) (! (let ((?v_8 (select1 (select1 Mem (Field ?m)) ?m)) (?v_7 (not (not (= (select1 alloc (Base ?m)) ALLOCATED))))) (=> (not (or ?v_7 ?v_7)) (= ?v_8 ?v_8))) :pattern ((select1 (select1 Mem (Field ?m)) ?m)) )) (=> true (=> true (not (or ?v_3 (not (=> ?v_1 (not (or (not ?v_4) (not (=> ?v_4 true)))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
