(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun Length (Int Int Int) Int)
(declare-fun mutable () Int)
(declare-fun status_tag () Int)
(declare-fun good_meta (Int) Int)
(declare-fun dot (Int Int) Int)
(declare-fun ArrayList_length () Int)
(declare-fun inv (Int Int Int Int) Int)
(declare-fun ArrayList () Int)
(declare-fun consistent () Int)
(declare-fun ValidArrayList (Int Int Int) Int)
(declare-fun ArrayList_capacity () Int)
(declare-fun typed (Int Int) Int)
(declare-fun ptr (Int Int) Int)
(declare-fun ref (Int) Int)
(declare-fun ArrayList_array () Int)
(declare-fun array (Int Int) Int)
(declare-fun int () Int)
(declare-fun set_eq (Int Int) Int)
(declare-fun set_singleton (Int) Int)
(declare-fun owned_tag () Int)
(declare-fun is (Int Int) Int)
(declare-fun ptr_to (Int) Int)
(declare-fun ts_is_array_elt (Int) Int)
(declare-fun ts_tag () Int)
(declare-fun ts_path (Int) Int)
(declare-fun emb (Int Int) Int)
(declare-fun field_offset (Int) Int)
(declare-fun in_extent_of (Int Int Int) Int)
(declare-fun in_full_extent_of (Int Int) Int)
(declare-fun ptr_level (Int) Int)
(declare-fun kind_composite () Int)
(declare-fun kind_of (Int) Int)
(declare-fun sizeof (Int) Int)
(declare-fun set_in (Int Int) Int)
(declare-fun array_range (Int Int Int) Int)
(declare-fun idx (Int Int Int) Int)
(declare-fun is_array (Int Int Int Int) Int)
(declare-fun kind_array () Int)
(declare-fun array_length (Int) Int)
(declare-fun element_type (Int) Int)
(declare-fun set_disjoint (Int Int) Int)
(declare-fun dont_instantiate (Int) Int)
(declare-fun set_subset (Int Int) Int)
(declare-fun set_subtraction (Int Int) Int)
(declare-fun set_union (Int Int) Int)
(declare-fun set_empty () Int)
(declare-fun full_extent (Int) Int)
(declare-fun is_primitive (Int) Int)
(declare-fun good_state (Int) Int)
(declare-fun typ (Int) Int)
(declare-fun ts_typed (Int) Int)
(declare-fun ts_emb (Int) Int)
(declare-fun dont_instantiate_int (Int) Int)
(declare-fun void () Int)
(declare-fun null () Int)
(declare-fun kind_primitive () Int)
(declare-fun map_t (Int Int) Int)
(declare-fun map_range (Int) Int)
(declare-fun map_domain (Int) Int)
(declare-fun unptr_to (Int) Int)
(declare-fun hasowner_tag () Int)
(declare-fun committed () Int)
(declare-fun ptrset () Int)
(declare-fun A () Int)
(declare-fun state_11 () Int)
(declare-fun meta_9 () Int)
(declare-fun state () Int)
(declare-fun meta () Int)
(declare-fun oldArr_1 () Int)
(declare-fun oldArr_2 () Int)
(declare-fun tmp_1 () Int)
(declare-fun tmp_2 () Int)
(declare-fun res__alloc_0_0 () Int)
(declare-fun res__alloc_0_1 () Int)
(declare-fun state_10 () Int)
(declare-fun whileMeta_1_0 () Int)
(declare-fun whileMeta_1_1 () Int)
(declare-fun i_2 () Int)
(declare-fun i_3 () Int)
(declare-fun newCapacity_1 () Int)
(declare-fun newCapacity_2 () Int)
(declare-fun newArr_1 () Int)
(declare-fun newArr_2 () Int)
(declare-fun whileState_1_0 () Int)
(declare-fun whileState_1_1 () Int)
(declare-fun meta_8 () Int)
(declare-fun state_9 () Int)
(declare-fun meta_7 () Int)
(declare-fun instantiate_int (Int) Int)
(declare-fun state_8 () Int)
(declare-fun call9224formal_T_0 () Int)
(declare-fun call9224formal__l_0 () Int)
(declare-fun meta_6 () Int)
(declare-fun state_7 () Int)
(declare-fun v () Int)
(declare-fun state_6 () Int)
(declare-fun oldArr () Int)
(declare-fun res__alloc_0 () Int)
(declare-fun state_1 () Int)
(declare-fun newArr () Int)
(declare-fun whileMeta_1 () Int)
(declare-fun i () Int)
(declare-fun newCapacity () Int)
(declare-fun tmp () Int)
(declare-fun whileState_1 () Int)
(declare-fun meta_1 () Int)
(declare-fun oldArr_0 () Int)
(declare-fun call8166formal__r_0 () Int)
(declare-fun state_5 () Int)
(declare-fun newArr_0 () Int)
(declare-fun meta_2 () Int)
(declare-fun i_0 () Int)
(declare-fun newCapacity_0 () Int)
(declare-fun tmp_0 () Int)
(declare-fun meta_5 () Int)
(declare-fun meta_4 () Int)
(declare-fun meta_3 () Int)
(declare-fun state_4 () Int)
(declare-fun state_2 () Int)
(declare-fun i_1 () Int)
(declare-fun state_3 () Int)
(declare-fun call8166formal__t_0 () Int)
(declare-fun state_0 () Int)
(declare-fun call8096formal_T_0 () Int)
(declare-fun call8096formal__l_0 () Int)
(declare-fun meta_0 () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct int void ptrset kind_composite kind_primitive kind_array mutable consistent committed status_tag ts_tag owned_tag hasowner_tag ArrayList ArrayList_capacity ArrayList_length ArrayList_array)) (not (= (sizeof int) 4)) (not (= (ptr_level int) 0)) (not (= (ptr_level void) 0)) (not (forall ((?n Int)) (! (= (unptr_to (ptr_to ?n)) ?n) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (ptr_level (ptr_to ?n)) (+ (ptr_level ?n) 2)) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (sizeof (ptr_to ?n)) 8) :pattern ((ptr_to ?n)) ))) (not (forall ((?r Int) (?d Int)) (! (= (ptr_level (map_t ?r ?d)) (+ (ptr_level ?r) 3)) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_domain (map_t ?r ?d)) ?d) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_range (map_t ?r ?d)) ?r) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (is_primitive (map_t ?r ?d)) true_1) :pattern ((map_t ?r ?d)) ))) (not (forall ((?t Int)) (! (= (= (is_primitive ?t) true_1) (= (kind_of ?t) kind_primitive)) :pattern ((is_primitive ?t)) ))) (not (forall ((?n Int)) (! (= (is_primitive (ptr_to ?n)) true_1) :pattern ((ptr_to ?n)) ))) (not (= (is_primitive int) true_1)) (not (forall ((?t_1 Int) (?b Int)) (= (typ (ptr ?t_1 ?b)) ?t_1))) (not (forall ((?t_1 Int) (?b Int)) (= (ref (ptr ?t_1 ?b)) ?b))) (not (= null (ptr void 0))) (not (forall ((?p_1 Int) (?t_1 Int)) (= (= (is ?p_1 ?t_1) true_1) (= (typ ?p_1) ?t_1)))) (not (forall ((?p_1 Int) (?t_1 Int)) (! (=> (= (is ?p_1 ?t_1) true_1) (exists ((?r Int)) (! (= ?p_1 (ptr ?t_1 ?r)) :pattern ((dont_instantiate_int ?r)) ))) :pattern ((is ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (= (emb ?m ?p_1) (ts_emb (select2 ?m ?p_1 ts_tag))) :pattern ((emb ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (= (good_meta ?m) true_1) (= (= (typed ?m ?p_1) true_1) (= (ts_typed (select2 ?m ?p_1 ts_tag)) true_1))) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (typed ?m ?p_1) true_1)))) (> (ref ?p_1) 0)) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?s Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array))) (not (= (typ ?p_1) ?t_1)))) (= (= (inv ?m ?s ?p_1 ?t_1) true_1) true)) :pattern ((inv ?m ?s ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?r Int) (?t_1 Int)) (! (=> (= (good_meta ?m) true_1) (=> (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array)) (= (select2 ?m (ptr ?t_1 ?r) owned_tag) set_empty))) :pattern ((select2 ?m (ptr ?t_1 ?r) owned_tag)) ))) (not (forall ((?m Int) (?s Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (good_state ?s) true_1)) (not (= (select2 ?m ?p_1 status_tag) consistent)))) (= (inv ?m ?s ?p_1 ?t_1) true_1)) :pattern ((inv ?m ?s ?p_1 ?t_1)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?r_1 Int) (?p Int)) (! (let ((?v_0 (ptr ?T ?r_1))) (= (= (in_full_extent_of ?p ?v_0) true_1) (= ?p ?v_0))) :pattern ((in_full_extent_of ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?M Int) (?r_1 Int) (?p Int)) (! (let ((?v_1 (ptr ?T ?r_1))) (= (= (in_extent_of ?M ?p ?v_1) true_1) (= ?p ?v_1))) :pattern ((in_extent_of ?M ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?p_1 Int) (?l Int)) (! (= (= (set_in ?p_1 (full_extent ?l)) true_1) (= (in_full_extent_of ?p_1 ?l) true_1)) :pattern ((set_in ?p_1 (full_extent ?l))) ))) (not (forall ((?o_1 Int)) (! (not (= (set_in ?o_1 set_empty) true_1)) :pattern ((set_in ?o_1 set_empty)) ))) (not (forall ((?r Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_singleton ?r)) true_1) (= ?r ?o_1)) :pattern ((set_in ?o_1 (set_singleton ?r))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_union ?a ?b)) true_1) (or (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 (set_union ?a ?b))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_subtraction ?a ?b)) true_1) (not (or (not (= (set_in ?o_1 ?a) true_1)) (not (not (= (set_in ?o_1 ?b) true_1)))))) :pattern ((set_in ?o_1 (set_subtraction ?a ?b))) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_subset ?a ?b) true_1) (forall ((?o_1 Int)) (! (=> (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_subset ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (forall ((?o_1 Int)) (! (= (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((dont_instantiate ?o_1)) )) (= (set_eq ?a ?b) true_1)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= (set_eq ?a ?b) true_1) (= ?a ?b)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_disjoint ?a ?b) true_1) (forall ((?o_1 Int)) (! (or (not (= (set_in ?o_1 ?a) true_1)) (not (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_disjoint ?a ?b)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (element_type (array ?T ?s_1)) ?T) :pattern ((array ?T ?s_1)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (array_length (array ?T ?s_1)) ?s_1) :pattern ((array ?T ?s_1)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (ptr_level (array ?T ?s_1)) 0) :pattern ((array ?T ?s_1)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (kind_of (array ?T ?s_1)) kind_array) :pattern ((array ?T ?s_1)) ))) (not (forall ((?p_1 Int) (?i_4 Int) (?t_1 Int)) (! (= (idx ?p_1 ?i_4 ?t_1) (ptr ?t_1 (+ (ref ?p_1) (* ?i_4 (sizeof ?t_1))))) :pattern ((idx ?p_1 ?i_4 ?t_1)) ))) (not (forall ((?p Int) (?i Int) (?j Int) (?T Int)) (! (=> (not (= ?i 0)) (= (idx (idx ?p ?i ?T) ?j ?T) (idx ?p (+ ?i ?j) ?T))) :pattern ((idx (idx ?p ?i ?T) ?j ?T)) ))) (not (forall ((?M Int) (?p Int) (?T Int) (?sz Int)) (! (= (= (is_array ?M ?p ?T ?sz) true_1) (not (or (not (= (is ?p ?T) true_1)) (not (forall ((?i Int)) (! (let ((?v_2 (idx ?p ?i ?T))) (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (not (or (not (= (ts_is_array_elt (select2 ?M ?v_2 ts_tag)) true_1)) (not (= (typed ?M ?v_2) true_1)))))) :pattern ((idx ?p ?i ?T)) )))))) :pattern ((is_array ?M ?p ?T ?sz)) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_3 (ptr (array ?T ?sz) ?r))) (= (= (in_full_extent_of ?p ?v_3) true_1) (or (= ?p ?v_3) (exists ((?i_4 Int)) (! (not (or (not (<= 0 ?i_4)) (not (< ?i_4 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_4 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_4 ?T)) ))))) :pattern ((in_full_extent_of ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_4 (ptr (array ?T ?sz) ?r))) (= (= (in_extent_of ?M ?p ?v_4) true_1) (or (= ?p ?v_4) (exists ((?i_4 Int)) (! (not (or (not (<= 0 ?i_4)) (not (< ?i_4 ?sz)) (not (= (in_extent_of ?M ?p (idx (ptr ?T ?r) ?i_4 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_4 ?T)) ))))) :pattern ((in_extent_of ?M ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?r Int) (?T Int) (?sz Int)) (! (=> (= (typed ?M (ptr (array ?T ?sz) ?r)) true_1) (not (or (not (= (is_array ?M (ptr ?T ?r) ?T ?sz) true_1)) (not (forall ((?i Int)) (! (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (= (emb ?M (idx (ptr ?T ?r) ?i ?T)) (ptr (array ?T ?sz) ?r))) :pattern ((idx (ptr ?T ?r) ?i ?T)) )))))) :pattern ((typed ?M (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (= (= (set_in ?p (array_range (ptr ?T ?r) ?T ?sz)) true_1) (exists ((?i_4 Int)) (! (not (or (not (<= 0 ?i_4)) (not (< ?i_4 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_4 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_4 ?T)) ))) :pattern ((set_in ?p (array_range (ptr ?T ?r) ?T ?sz))) ))) (not (= (sizeof ArrayList) 16)) (not (= (kind_of ArrayList) kind_composite)) (not (= (ptr_level ArrayList) 0)) (not (forall ((?r Int) (?q Int)) (! (let ((?v_5 (ptr ArrayList ?r))) (= (= (in_full_extent_of ?q ?v_5) true_1) (or (= ?q ?v_5) (= ?q (dot ?v_5 ArrayList_capacity)) (= ?q (dot ?v_5 ArrayList_length)) (= ?q (dot ?v_5 ArrayList_array))))) :pattern ((in_full_extent_of ?q (ptr ArrayList ?r))) ))) (not (forall ((?m Int) (?r Int) (?q Int)) (! (let ((?v_6 (ptr ArrayList ?r))) (= (= (in_extent_of ?m ?q ?v_6) true_1) (or (= ?q ?v_6) (= ?q (dot ?v_6 ArrayList_capacity)) (= ?q (dot ?v_6 ArrayList_length)) (= ?q (dot ?v_6 ArrayList_array))))) :pattern ((in_extent_of ?m ?q (ptr ArrayList ?r))) ))) (not (= (field_offset ArrayList_capacity) 0)) (not (forall ((?p_1 Int)) (! (=> (= (is ?p_1 ArrayList) true_1) (= (dot ?p_1 ArrayList_capacity) (ptr int (+ (ref ?p_1) 0)))) :pattern ((dot ?p_1 ArrayList_capacity)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_7 (dot ?p_1 ArrayList_capacity))) (let ((?v_8 (select2 ?m ?v_7 ts_tag))) (=> (not (or (not (= (is ?p_1 ArrayList) true_1)) (not (= (typed ?m ?p_1) true_1)))) (not (or (not (= (typed ?m ?v_7) true_1)) (not (= (emb ?m ?v_7) ?p_1)) (not (= (ts_path ?v_8) ArrayList_capacity)) (not (not (= (ts_is_array_elt ?v_8) true_1)))))))) :pattern ((typed ?m (dot ?p_1 ArrayList_capacity)))  :pattern ((dot ?p_1 ArrayList_capacity) (typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_11 (dot ?p_1 ArrayList_capacity)) (?v_10 (not (= (typed ?m ?p_1) true_1))) (?v_9 (not (= (is ?p_1 ArrayList) true_1)))) (=> (not (or ?v_9 ?v_10 ?v_9 ?v_10 (not (= (select2 ?m ?p_1 status_tag) mutable)))) (not (or (not (= (is ?v_11 int) true_1)) (not (= (typed ?m ?v_11) true_1)) (not (= (select2 ?m ?v_11 status_tag) mutable)))))) :pattern ((select2 ?m (dot ?p_1 ArrayList_capacity) status_tag)) ))) (not (= (field_offset ArrayList_length) 4)) (not (forall ((?p_1 Int)) (! (=> (= (is ?p_1 ArrayList) true_1) (= (dot ?p_1 ArrayList_length) (ptr int (+ (ref ?p_1) 4)))) :pattern ((dot ?p_1 ArrayList_length)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_12 (dot ?p_1 ArrayList_length))) (let ((?v_13 (select2 ?m ?v_12 ts_tag))) (=> (not (or (not (= (is ?p_1 ArrayList) true_1)) (not (= (typed ?m ?p_1) true_1)))) (not (or (not (= (typed ?m ?v_12) true_1)) (not (= (emb ?m ?v_12) ?p_1)) (not (= (ts_path ?v_13) ArrayList_length)) (not (not (= (ts_is_array_elt ?v_13) true_1)))))))) :pattern ((typed ?m (dot ?p_1 ArrayList_length)))  :pattern ((dot ?p_1 ArrayList_length) (typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_16 (dot ?p_1 ArrayList_length)) (?v_15 (not (= (typed ?m ?p_1) true_1))) (?v_14 (not (= (is ?p_1 ArrayList) true_1)))) (=> (not (or ?v_14 ?v_15 ?v_14 ?v_15 (not (= (select2 ?m ?p_1 status_tag) mutable)))) (not (or (not (= (is ?v_16 int) true_1)) (not (= (typed ?m ?v_16) true_1)) (not (= (select2 ?m ?v_16 status_tag) mutable)))))) :pattern ((select2 ?m (dot ?p_1 ArrayList_length) status_tag)) ))) (not (= (field_offset ArrayList_array) 8)) (not (forall ((?p_1 Int)) (! (=> (= (is ?p_1 ArrayList) true_1) (= (dot ?p_1 ArrayList_array) (ptr (ptr_to int) (+ (ref ?p_1) 8)))) :pattern ((dot ?p_1 ArrayList_array)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_17 (dot ?p_1 ArrayList_array))) (let ((?v_18 (select2 ?m ?v_17 ts_tag))) (=> (not (or (not (= (is ?p_1 ArrayList) true_1)) (not (= (typed ?m ?p_1) true_1)))) (not (or (not (= (typed ?m ?v_17) true_1)) (not (= (emb ?m ?v_17) ?p_1)) (not (= (ts_path ?v_18) ArrayList_array)) (not (not (= (ts_is_array_elt ?v_18) true_1)))))))) :pattern ((typed ?m (dot ?p_1 ArrayList_array)))  :pattern ((dot ?p_1 ArrayList_array) (typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_21 (dot ?p_1 ArrayList_array)) (?v_20 (not (= (typed ?m ?p_1) true_1))) (?v_19 (not (= (is ?p_1 ArrayList) true_1)))) (=> (not (or ?v_19 ?v_20 ?v_19 ?v_20 (not (= (select2 ?m ?p_1 status_tag) mutable)))) (not (or (not (= (is ?v_21 (ptr_to int)) true_1)) (not (= (typed ?m ?v_21) true_1)) (not (= (select2 ?m ?v_21 status_tag) mutable)))))) :pattern ((select2 ?m (dot ?p_1 ArrayList_array) status_tag)) ))) (not (forall ((?s Int) (?m Int)) (forall ((?A Int)) (= (= (inv ?m ?s ?A ArrayList) true_1) (= (ValidArrayList ?m ?s ?A) true_1))))) (not (forall ((?m Int) (?s Int) (?A Int)) (! (let ((?v_22 (select1 ?s (dot ?A ArrayList_capacity))) (?v_24 (select1 ?s (dot ?A ArrayList_length)))) (let ((?v_23 (ptr (array int ?v_22) (ref (select1 ?s (dot ?A ArrayList_array)))))) (= (= (ValidArrayList ?m ?s ?A) true_1) (not (or (not (= (is ?A ArrayList) true_1)) (not (= (typed ?m ?A) true_1)) (not (>= ?v_22 0)) (not (= (set_eq (select2 ?m ?A owned_tag) (set_singleton ?v_23)) true_1)) (not (= (typed ?m ?v_23) true_1)) (not (>= ?v_24 0)) (not (<= ?v_24 ?v_22))))))) :pattern ((ValidArrayList ?m ?s ?A)) ))) (not (forall ((?m1 Int) (?s1 Int) (?m2 Int) (?s2 Int) (?A Int)) (! (=> (not (or (not (= (good_meta ?m1) true_1)) (not (= (good_meta ?m2) true_1)) (not (= (select1 ?s1 ?A) (select1 ?s2 ?A))) (not (or (not (= (select2 ?m1 ?A status_tag) mutable)) (not (= (select2 ?m2 ?A status_tag) mutable)))))) (= (= (ValidArrayList ?m1 ?s1 ?A) true_1) (= (ValidArrayList ?m2 ?s2 ?A) true_1))) :pattern ((ValidArrayList ?m1 ?s1 ?A) (ValidArrayList ?m2 ?s2 ?A)) ))) (not (forall ((?m Int) (?s Int) (?A Int)) (! (=> (not (or (not (= (select2 ?m ?A status_tag) consistent)) (not (= (inv ?m ?s ?A ArrayList) true_1)))) (= (Length ?m ?s ?A) (select1 ?s (dot ?A ArrayList_length)))) :pattern ((Length ?m ?s ?A)) ))) (not (forall ((?m1 Int) (?s1 Int) (?m2 Int) (?s2 Int) (?A Int)) (! (=> (not (or (not (= (good_meta ?m1) true_1)) (not (= (good_meta ?m2) true_1)) (not (= (select1 ?s1 ?A) (select1 ?s2 ?A))) (not (or (not (= (select2 ?m1 ?A status_tag) mutable)) (not (= (select2 ?m2 ?A status_tag) mutable)))))) (= (Length ?m1 ?s1 ?A) (Length ?m2 ?s2 ?A))) :pattern ((Length ?m1 ?s1 ?A) (Length ?m2 ?s2 ?A)) ))))))
(assert (let ((?v_87 (not (or (not (= (select2 meta_9 A status_tag) consistent)) (not (= (inv meta_9 state_11 A ArrayList) true_1))))) (?v_86 (= (Length meta_9 state_11 A) (+ (Length meta state A) 1))) (?v_85 (= (is_primitive ArrayList) true_1)) (?v_84 (= (inv meta_7 state_9 A ArrayList) true_1)) (?v_83 (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (select2 meta_7 A owned_tag)) true_1) (= (select2 meta_7 ?p_1 status_tag) consistent)) :pattern ((select2 meta_7 ?p_1 status_tag)) ))) (?v_78 (select2 meta_7 A status_tag))) (let ((?v_82 (= ?v_78 mutable)) (?v_40 (typ A))) (let ((?v_4 (= ?v_40 ArrayList))) (let ((?v_81 (not ?v_4)) (?v_80 (forall ((?p_1 Int)) (! (let ((?v_106 (select2 meta_7 ?p_1 status_tag))) (=> (= (set_in ?p_1 (select2 meta_7 A owned_tag)) true_1) (or (= ?p_1 A) (not (or (not (or (= (select2 meta ?p_1 status_tag) committed) (= (instantiate_int ?v_106) true_1))) (not (or (= ?v_106 mutable) (= ?v_106 consistent)))))))) :pattern ((dont_instantiate ?p_1)) ))) (?v_0 (select2 meta A status_tag))) (let ((?v_37 (= ?v_0 committed)) (?v_36 (= A A))) (let ((?v_79 (or ?v_36 (not (or (not (or ?v_37 (= (instantiate_int ?v_78) true_1))) (not (or ?v_82 (= ?v_78 consistent))))))) (?v_77 (= (inv meta_6 state_8 call9224formal__l_0 call9224formal_T_0) true_1)) (?v_76 (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (select2 meta_6 call9224formal__l_0 owned_tag)) true_1) (= (select2 meta_6 ?p_1 status_tag) consistent)) :pattern ((select2 meta_6 ?p_1 status_tag)) ))) (?v_75 (= (select2 meta_6 call9224formal__l_0 status_tag) mutable)) (?v_74 (= (typ call9224formal__l_0) call9224formal_T_0)) (?v_5 (dot A ArrayList_array)) (?v_7 (dot A ArrayList_capacity))) (let ((?v_70 (ptr (array int (select1 state_8 ?v_7)) (ref (select1 state_8 ?v_5))))) (let ((?v_73 (forall ((?p_1 Int)) (! (let ((?v_107 (select2 meta_6 ?p_1 status_tag))) (=> (= (set_in ?p_1 (select2 meta_6 ?v_70 owned_tag)) true_1) (or (= ?p_1 A) (not (or (not (or (= (select2 meta ?p_1 status_tag) committed) (= (instantiate_int ?v_107) true_1))) (not (or (= ?v_107 mutable) (= ?v_107 consistent)))))))) :pattern ((dont_instantiate ?p_1)) ))) (?v_71 (select2 meta_6 ?v_70 status_tag)) (?v_61 (select1 state ?v_5))) (let ((?v_69 (= (ptr (array int (select1 state ?v_7)) (ref ?v_61)) A))) (let ((?v_72 (or ?v_69 (not (or (not (or (= (select2 meta ?v_70 status_tag) committed) (= (instantiate_int ?v_71) true_1))) (not (or (= ?v_71 mutable) (= ?v_71 consistent))))))) (?v_14 (not (= (is ?v_7 int) true_1)))) (let ((?v_68 (not (or ?v_14 (not (= (typed meta_6 ?v_7) true_1))))) (?v_25 (not (= (is ?v_5 (ptr_to int)) true_1)))) (let ((?v_56 (not (or ?v_25 (not (= (typed meta_6 ?v_5) true_1)))))) (let ((?v_67 (not ?v_56)) (?v_16 (dot A ArrayList_length))) (let ((?v_65 (select2 meta_6 ?v_16 status_tag))) (let ((?v_66 (or (= ?v_16 A) (not (or (not (or (= (select2 meta ?v_16 status_tag) committed) (= (instantiate_int ?v_65) true_1))) (not (or (= ?v_65 mutable) (= ?v_65 consistent))))))) (?v_57 (not (= (is ?v_16 int) true_1)))) (let ((?v_58 (not (or ?v_57 (not (= (typed meta_6 ?v_16) true_1)))))) (let ((?v_64 (not ?v_58)) (?v_59 (idx (select1 state_6 ?v_5) (select1 state_6 ?v_16) int))) (let ((?v_62 (select2 meta_6 ?v_59 status_tag))) (let ((?v_63 (or (= (idx ?v_61 (select1 state ?v_16) int) A) (not (or (not (or (= (select2 meta ?v_59 status_tag) committed) (= (instantiate_int ?v_62) true_1))) (not (or (= ?v_62 mutable) (= ?v_62 consistent))))))) (?v_60 (not (or (not (= (is ?v_59 int) true_1)) (not (= (typed meta_6 ?v_59) true_1)))))) (let ((?v_105 (=> true (=> true (=> (exists ((?r Int)) (= (ptr int ?r) (select1 state_6 ?v_5))) (not (or ?v_67 (not (=> ?v_56 (not (or ?v_64 (not (=> ?v_58 (not (or (not ?v_60) (not (=> ?v_60 (not (or (not ?v_63) (not (=> ?v_63 (=> (= state_7 (store1 state_6 ?v_59 v)) (not (or ?v_64 (not (=> ?v_58 (not (or ?v_64 (not (=> ?v_58 (not (or (not ?v_66) (not (=> ?v_66 (=> (= state_8 (store1 state_7 ?v_16 (+ (select1 state_7 ?v_16) 1))) (=> (exists ((?r Int)) (= (ptr int ?r) (select1 state_8 ?v_5))) (not (or ?v_67 (not (=> ?v_56 (not (or (not ?v_68) (not (=> ?v_68 (not (or (not ?v_72) (not (=> ?v_72 (not (or (not ?v_73) (not (=> ?v_73 (=> (= call9224formal__l_0 ?v_70) (=> (= call9224formal_T_0 (typ ?v_70)) (not (or (not ?v_74) (not (=> ?v_74 (not (or (not ?v_75) (not (=> ?v_75 (not (or (not ?v_76) (not (=> ?v_76 (not (or (not ?v_77) (not (=> ?v_77 (=> (= (good_meta meta_7) true_1) (=> (= (good_state state_9) true_1) (=> (= (inv meta_7 state_9 call9224formal__l_0 call9224formal_T_0) true_1) (=> (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (select2 meta_6 call9224formal__l_0 owned_tag)) true_1) (not (or (not (= (select2 meta_7 ?p_1 status_tag) committed)) (not (= (select2 meta_6 ?p_1 status_tag) consistent))))) :pattern ((select2 meta_7 ?p_1 status_tag)) )) (=> (forall ((?p_1 Int)) (! (=> (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_7 ?p_1) call9224formal__l_0)))) (not (or (not (= (select2 meta_7 ?p_1 status_tag) committed)) (not (= (select2 meta_6 ?p_1 status_tag) mutable))))) :pattern ((select2 meta_7 ?p_1 status_tag)) )) (=> (= (select2 meta_7 call9224formal__l_0 status_tag) consistent) (=> (forall ((?p_1 Int) (?t_1 Int)) (! (or (not (or (not (or (= ?p_1 call9224formal__l_0) (= (set_in ?p_1 (select2 meta_6 call9224formal__l_0 owned_tag)) true_1) (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_7 ?p_1) call9224formal__l_0)))))) (not (= ?t_1 status_tag)))) (= (select2 meta_7 ?p_1 ?t_1) (select2 meta_6 ?p_1 ?t_1))) :pattern ((select2 meta_7 ?p_1 ?t_1)) )) (=> (exists ((?x_2 Int)) (= state_9 (store1 state_8 call9224formal__l_0 ?x_2))) (=> (=> (= (is_primitive call9224formal_T_0) true_1) (= state_8 state_9)) (not (or (not ?v_79) (not (=> ?v_79 (not (or (not ?v_80) (not (=> ?v_80 (not (or ?v_81 (not (=> ?v_4 (not (or (not ?v_82) (not (=> ?v_82 (not (or (not ?v_83) (not (=> ?v_83 (not (or (not ?v_84) (not (=> ?v_84 (=> (= (good_meta meta_8) true_1) (=> (= (good_state state_10) true_1) (=> (= (inv meta_8 state_10 A ArrayList) true_1) (=> (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (select2 meta_7 A owned_tag)) true_1) (not (or (not (= (select2 meta_8 ?p_1 status_tag) committed)) (not (= (select2 meta_7 ?p_1 status_tag) consistent))))) :pattern ((select2 meta_8 ?p_1 status_tag)) )) (=> (forall ((?p_1 Int)) (! (=> (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_8 ?p_1) A)))) (not (or (not (= (select2 meta_8 ?p_1 status_tag) committed)) (not (= (select2 meta_7 ?p_1 status_tag) mutable))))) :pattern ((select2 meta_8 ?p_1 status_tag)) )) (=> (= (select2 meta_8 A status_tag) consistent) (=> (forall ((?p_1 Int) (?t_1 Int)) (! (or (not (or (not (or (= ?p_1 A) (= (set_in ?p_1 (select2 meta_7 A owned_tag)) true_1) (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_8 ?p_1) A)))))) (not (= ?t_1 status_tag)))) (= (select2 meta_8 ?p_1 ?t_1) (select2 meta_7 ?p_1 ?t_1))) :pattern ((select2 meta_8 ?p_1 ?t_1)) )) (=> (exists ((?x_2 Int)) (= state_10 (store1 state_9 A ?x_2))) (=> (=> ?v_85 (= state_9 state_10)) (=> true (=> true (=> true (=> true (=> true (=> (= meta_9 meta_8) (=> (= whileState_1_1 whileState_1_0) (=> (= newArr_2 newArr_1) (=> (= newCapacity_2 newCapacity_1) (=> (= i_3 i_2) (=> (= whileMeta_1_1 whileMeta_1_0) (=> (= state_11 state_10) (=> (= res__alloc_0_1 res__alloc_0_0) (=> (= tmp_2 tmp_1) (=> (= oldArr_2 oldArr_1) (=> true (not (or (not ?v_86) (not (=> ?v_86 (not (or (not ?v_87) (not (=> ?v_87 true))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_97 (select1 state_1 ?v_16)) (?v_19 (select1 state_1 ?v_7))) (let ((?v_104 (= ?v_19 ?v_97)) (?v_24 (<= 0 i_0)) (?v_55 (not (= (select2 meta_4 newArr_0 hasowner_tag) true_1))) (?v_41 (= (kind_of ?v_40) kind_composite))) (let ((?v_54 (not ?v_41)) (?v_52 (select2 meta_4 A status_tag))) (let ((?v_53 (or ?v_36 (not (or (not (or ?v_37 (= (instantiate_int ?v_52) true_1))) (not (or (= ?v_52 mutable) (= ?v_52 consistent))))))) (?v_50 (select2 meta_4 newArr_0 status_tag))) (let ((?v_51 (or (= newArr_0 A) (not (or (not (or (= (select2 meta newArr_0 status_tag) committed) (= (instantiate_int ?v_50) true_1))) (not (or (= ?v_50 mutable) (= ?v_50 consistent))))))) (?v_49 (= (typed meta_3 oldArr_0) true_1)) (?v_48 (forall ((?p_1 Int)) (! (let ((?v_108 (select2 meta_3 ?p_1 status_tag))) (=> (= (in_extent_of meta_3 ?p_1 oldArr_0) true_1) (or (= ?p_1 A) (not (or (not (or (= (select2 meta ?p_1 status_tag) committed) (= (instantiate_int ?v_108) true_1))) (not (or (= ?v_108 mutable) (= ?v_108 consistent)))))))) :pattern ((dont_instantiate ?p_1)) ))) (?v_46 (select2 meta_3 oldArr_0 status_tag)) (?v_45 (= (select2 meta oldArr_0 status_tag) committed)) (?v_44 (= oldArr_0 A))) (let ((?v_47 (or ?v_44 (not (or (not (or ?v_45 (= (instantiate_int ?v_46) true_1))) (not (or (= ?v_46 mutable) (= ?v_46 consistent))))))) (?v_43 (select2 meta_2 A owned_tag))) (let ((?v_42 (= (set_in oldArr_0 ?v_43) true_1)) (?v_38 (select2 meta_2 A status_tag))) (let ((?v_39 (or ?v_36 (not (or (not (or ?v_37 (= (instantiate_int ?v_38) true_1))) (not (or (= ?v_38 mutable) (= ?v_38 consistent))))))) (?v_34 (select2 meta_2 oldArr_0 status_tag))) (let ((?v_35 (or ?v_44 (not (or (not (or ?v_45 (= (instantiate_int ?v_34) true_1))) (not (or (= ?v_34 mutable) (= ?v_34 consistent))))))) (?v_27 (not (or ?v_14 (not (= (typed meta_2 ?v_7) true_1)))))) (let ((?v_28 (not ?v_27)) (?v_26 (not (or ?v_25 (not (= (typed meta_2 ?v_5) true_1)))))) (let ((?v_31 (not ?v_26)) (?v_32 (select2 meta_2 ?v_5 status_tag))) (let ((?v_33 (or (= ?v_5 A) (not (or (not (or (= (select2 meta ?v_5 status_tag) committed) (= (instantiate_int ?v_32) true_1))) (not (or (= ?v_32 mutable) (= ?v_32 consistent))))))) (?v_29 (select2 meta_2 ?v_7 status_tag))) (let ((?v_30 (or (= ?v_7 A) (not (or (not (or (= (select2 meta ?v_7 status_tag) committed) (= (instantiate_int ?v_29) true_1))) (not (or (= ?v_29 mutable) (= ?v_29 consistent))))))) (?v_92 (select1 state_2 ?v_5))) (let ((?v_91 (exists ((?r Int)) (= (ptr int ?r) ?v_92))) (?v_90 (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_2 ?p_1 status_tag) committed) (= (set_in ?p_1 (array_range tmp_0 int ?v_97)) true_1) (= (select1 state_1 ?p_1) (select1 state_2 ?p_1))) :pattern ((select1 state_2 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (let ((?v_109 (select2 meta_2 ?pm ?t_1))) (or (= (select2 meta_2 ?pm status_tag) committed) (= (set_in ?pm (array_range tmp_0 int ?v_97)) true_1) (= ?v_109 ?v_109))) :pattern ((select2 meta_2 ?pm ?t_1)) ))))))) (let ((?v_103 (=> ?v_24 (=> true (=> ?v_24 (=> ?v_90 (=> ?v_91 (not (or ?v_31 (not (=> ?v_26 (not (or ?v_28 (not (=> ?v_27 (=> (= oldArr_0 (ptr (array int (select1 state_2 ?v_7)) (ref ?v_92))) (not (or ?v_28 (not (=> ?v_27 (not (or (not ?v_30) (not (=> ?v_30 (=> (= state_4 (store1 state_2 ?v_7 newCapacity_0)) (=> (exists ((?r Int)) (= (ptr int ?r) (select1 state_4 ?v_5))) (not (or ?v_31 (not (=> ?v_26 (not (or (not ?v_33) (not (=> ?v_33 (=> (= state_5 (store1 state_4 ?v_5 tmp_0)) (=> (exists ((?r Int)) (= (ptr int ?r) (select1 state_5 ?v_5))) (not (or ?v_31 (not (=> ?v_26 (not (or ?v_28 (not (=> ?v_27 (=> (= newArr_0 (ptr (array int (select1 state_5 ?v_7)) (ref (select1 state_5 ?v_5)))) (not (or (not ?v_35) (not (=> ?v_35 (not (or (not ?v_39) (not (=> ?v_39 (not (or ?v_54 (not (=> ?v_41 (not (or (not ?v_42) (not (=> ?v_42 (=> (= (good_meta meta_3) true_1) (=> (not (= (select2 meta_3 oldArr_0 hasowner_tag) true_1)) (=> (= (select2 meta_3 A owned_tag) (set_subtraction ?v_43 (set_singleton oldArr_0))) (=> (forall ((?q Int) (?t_1 Int)) (! (or (not (or (not (= ?q A)) (not (= ?t_1 owned_tag)))) (not (or (not (= ?q oldArr_0)) (not (= ?t_1 hasowner_tag)))) (= (select2 meta_3 ?q ?t_1) (select2 meta_2 ?q ?t_1))) :pattern ((select2 meta_3 ?q ?t_1)) )) (not (or (not ?v_47) (not (=> ?v_47 (not (or (not ?v_48) (not (=> ?v_48 (not (or (not ?v_49) (not (=> ?v_49 (=> (= (good_meta meta_4) true_1) (=> (forall ((?p_1 Int) (?f_1 Int)) (! (or (= (in_full_extent_of ?p_1 oldArr_0) true_1) (= (select2 meta_3 ?p_1 ?f_1) (select2 meta_4 ?p_1 ?f_1))) :pattern ((select2 meta_4 ?p_1 ?f_1)) )) (not (or (not ?v_51) (not (=> ?v_51 (not (or (not ?v_53) (not (=> ?v_53 (not (or ?v_54 (not (=> ?v_41 (not (or (not ?v_55) (not (=> ?v_55 (=> (= (good_meta meta_5) true_1) (=> (= (select2 meta_5 A owned_tag) (set_union (set_singleton newArr_0) (select2 meta_4 A owned_tag))) (=> (forall ((?q Int) (?t_1 Int)) (! (or (not (or (not (= ?q A)) (not (= ?t_1 owned_tag)))) (not (or (not (= ?q newArr_0)) (not (= ?t_1 hasowner_tag)))) (= (select2 meta_5 ?q ?t_1) (select2 meta_4 ?q ?t_1))) :pattern ((select2 meta_5 ?q ?t_1)) )) (=> ?v_24 (=> true (=> (= meta_6 meta_5) (=> (= whileState_1_0 state_1) (=> (= tmp_1 tmp_0) (=> (= newCapacity_1 newCapacity_0) (=> (= i_2 i_0) (=> (= whileMeta_1_0 meta_2) (=> (= newArr_1 newArr_0) (=> (= state_6 state_5) (=> (= res__alloc_0_0 call8166formal__r_0) (=> (= oldArr_1 oldArr_0) ?v_105))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (?v_102 (select1 state_2 ?v_16)) (?v_101 (<= 0 i_1)) (?v_100 (>= i_1 0)) (?v_93 (idx ?v_92 i_0 int)) (?v_95 (idx tmp_0 i_0 int))) (let ((?v_98 (select2 meta_2 ?v_95 status_tag))) (let ((?v_99 (or (= (set_in ?v_95 (array_range tmp_0 int ?v_97)) true_1) (not (or (not (or (= ?v_98 committed) (= (instantiate_int ?v_98) true_1))) (not (or (= ?v_98 mutable) (= ?v_98 consistent))))))) (?v_96 (not (or (not (= (is ?v_95 int) true_1)) (not (= (typed meta_2 ?v_95) true_1))))) (?v_94 (not (or (not (= (is ?v_93 int) true_1)) (not (= (typed meta_2 ?v_93) true_1))))) (?v_88 (not (or ?v_57 (not (= (typed meta_2 ?v_16) true_1)))))) (let ((?v_89 (not ?v_88)) (?v_22 (<= 0 0)) (?v_23 (>= 0 0))) (let ((?v_21 (not ?v_22)) (?v_20 (forall ((?p_1 Int)) (! (let ((?v_110 (select2 meta_2 ?p_1 status_tag))) (=> (= (set_in ?p_1 (array_range tmp_0 int ?v_97)) true_1) (or (= ?p_1 A) (not (or (not (or (= (select2 meta ?p_1 status_tag) committed) (= (instantiate_int ?v_110) true_1))) (not (or (= ?v_110 mutable) (= ?v_110 consistent)))))))) :pattern ((dont_instantiate ?p_1)) ))) (?v_15 (not (or ?v_14 (not (= (typed meta_1 ?v_7) true_1)))))) (let ((?v_18 (not ?v_15)) (?v_17 (not (or ?v_57 (not (= (typed meta_1 ?v_16) true_1))))) (?v_13 (= (typ call8096formal__l_0) call8096formal_T_0)) (?v_12 (= (select2 meta_0 call8096formal__l_0 status_tag) consistent)) (?v_9 (ptr (array int (select1 state_0 ?v_7)) (ref (select1 state_0 ?v_5))))) (let ((?v_10 (select2 meta_0 ?v_9 status_tag))) (let ((?v_11 (or ?v_69 (not (or (not (or (= (select2 meta ?v_9 status_tag) committed) (= (instantiate_int ?v_10) true_1))) (not (or (= ?v_10 mutable) (= ?v_10 consistent))))))) (?v_8 (not (or ?v_14 (not (= (typed meta_0 ?v_7) true_1))))) (?v_6 (not (or ?v_25 (not (= (typed meta_0 ?v_5) true_1))))) (?v_1 (= ?v_0 consistent))) (let ((?v_3 (not ?v_1)) (?v_2 (or ?v_36 (not (or (not (or ?v_37 (= (instantiate_int ?v_0) true_1))) (not (or (= ?v_0 mutable) ?v_1))))))) (not (=> true (=> (= (good_meta meta) true_1) (=> (= (good_state state) true_1) (=> (= (is A ArrayList) true_1) (=> (not (or ?v_3 (not (= (inv meta state A ArrayList) true_1)))) (=> true (not (or (not ?v_2) (not (=> ?v_2 (not (or ?v_3 (not (=> ?v_1 (not (or ?v_81 (not (=> ?v_4 (=> (= (good_meta meta_0) true_1) (=> (= (good_state state_0) true_1) (=> (= (inv meta_0 state_0 A ArrayList) true_1) (=> (= (select2 meta_0 A status_tag) mutable) (=> (forall ((?p_1 Int)) (! (=> (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_0 ?p_1) A)))) (not (or (not (= (select2 meta_0 ?p_1 status_tag) mutable)) (not (= (select2 meta ?p_1 status_tag) committed))))) :pattern ((select2 meta_0 ?p_1 status_tag)) )) (=> (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (select2 meta A owned_tag)) true_1) (not (or (not (= (select2 meta_0 ?p_1 status_tag) consistent)) (not (= (select2 meta ?p_1 status_tag) committed))))) :pattern ((select2 meta_0 ?p_1 status_tag))  :pattern ((select2 meta ?p_1 status_tag)) )) (=> (forall ((?p_1 Int) (?t_1 Int)) (! (or (not (or (not (or (= ?p_1 A) (= (set_in ?p_1 (select2 meta A owned_tag)) true_1) (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_0 ?p_1) A)))))) (not (= ?t_1 status_tag)))) (= (select2 meta_0 ?p_1 ?t_1) (select2 meta ?p_1 ?t_1))) :pattern ((select2 meta_0 ?p_1 ?t_1)) )) (=> (exists ((?x_2 Int)) (= state_0 (store1 state A ?x_2))) (=> (=> ?v_85 (= state state_0)) (=> (exists ((?r Int)) (= (ptr int ?r) (select1 state_0 ?v_5))) (not (or (not ?v_6) (not (=> ?v_6 (not (or (not ?v_8) (not (=> ?v_8 (not (or (not ?v_11) (not (=> ?v_11 (=> (= call8096formal__l_0 ?v_9) (=> (= call8096formal_T_0 (typ ?v_9)) (not (or (not ?v_12) (not (=> ?v_12 (not (or (not ?v_13) (not (=> ?v_13 (=> (= (good_meta meta_1) true_1) (=> (= (good_state state_1) true_1) (=> (= (inv meta_1 state_1 call8096formal__l_0 call8096formal_T_0) true_1) (=> (= (select2 meta_1 call8096formal__l_0 status_tag) mutable) (=> (forall ((?p_1 Int)) (! (=> (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_1 ?p_1) call8096formal__l_0)))) (not (or (not (= (select2 meta_1 ?p_1 status_tag) mutable)) (not (= (select2 meta_0 ?p_1 status_tag) committed))))) :pattern ((select2 meta_1 ?p_1 status_tag)) )) (=> (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (select2 meta_0 call8096formal__l_0 owned_tag)) true_1) (not (or (not (= (select2 meta_1 ?p_1 status_tag) consistent)) (not (= (select2 meta_0 ?p_1 status_tag) committed))))) :pattern ((select2 meta_1 ?p_1 status_tag))  :pattern ((select2 meta_0 ?p_1 status_tag)) )) (=> (forall ((?p_1 Int) (?t_1 Int)) (! (or (not (or (not (or (= ?p_1 call8096formal__l_0) (= (set_in ?p_1 (select2 meta_0 call8096formal__l_0 owned_tag)) true_1) (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_1 ?p_1) call8096formal__l_0)))))) (not (= ?t_1 status_tag)))) (= (select2 meta_1 ?p_1 ?t_1) (select2 meta_0 ?p_1 ?t_1))) :pattern ((select2 meta_1 ?p_1 ?t_1)) )) (=> (exists ((?x_2 Int)) (= state_1 (store1 state_0 call8096formal__l_0 ?x_2))) (=> (=> (= (is_primitive call8096formal_T_0) true_1) (= state_0 state_1)) (not (or ?v_18 (not (=> ?v_15 (not (or (not ?v_17) (not (=> ?v_17 (=> true (not (or (not (=> true (=> true (=> ?v_104 (not (or ?v_18 (not (=> ?v_15 (=> (= newCapacity_0 (+ (* ?v_19 2) 1)) (=> (= call8166formal__t_0 (array int newCapacity_0)) (=> (= (good_meta meta_2) true_1) (=> (not (or (not (= (is call8166formal__r_0 call8166formal__t_0) true_1)) (not (= (typed meta_2 call8166formal__r_0) true_1)))) (=> (= (select2 meta_2 call8166formal__r_0 owned_tag) set_empty) (=> (not (= (select2 meta_2 call8166formal__r_0 hasowner_tag) true_1)) (=> (forall ((?p_1 Int) (?f_1 Int)) (! (=> (or (= (typed meta_1 ?p_1) true_1) (not (= (select2 meta_1 ?p_1 status_tag) committed))) (= (select2 meta_1 ?p_1 ?f_1) (select2 meta_2 ?p_1 ?f_1))) :pattern ((select2 meta_2 ?p_1 ?f_1)) )) (=> (forall ((?p_1 Int)) (! (=> (= (in_full_extent_of ?p_1 call8166formal__r_0) true_1) (not (or (not (= (select2 meta_2 ?p_1 status_tag) mutable)) (not (= (select2 meta_1 ?p_1 status_tag) committed))))) :pattern ((select2 meta_1 ?p_1 status_tag))  :pattern ((select2 meta_2 ?p_1 status_tag)) )) (=> (exists ((?rf Int)) (= (ptr call8166formal__t_0 ?rf) call8166formal__r_0)) (=> (not (= (typed meta_1 call8166formal__r_0) true_1)) (=> (= tmp_0 (ptr int (ref call8166formal__r_0))) (not (or (not ?v_20) (not (=> ?v_20 (=> (not (or ?v_21 ?v_21)) (=> ?v_22 (not (or (not ?v_23) (not (=> ?v_23 (=> ?v_22 (=> true (=> (= (good_state state_2) true_1) (=> ?v_24 (=> (>= i_0 0) (=> ?v_24 (not (or (not (=> true (=> ?v_24 (=> (not true) ?v_103)))) (not (=> true (=> ?v_24 (=> true (not (or ?v_89 (not (=> ?v_88 (not (or ?v_89 (not (=> ?v_88 (=> ?v_90 (=> ?v_24 (not (or (not (=> true (=> ?v_24 (=> (< i_0 ?v_102) (=> ?v_91 (not (or ?v_31 (not (=> ?v_26 (not (or (not ?v_94) (not (=> ?v_94 (not (or (not ?v_96) (not (=> ?v_96 (not (or (not ?v_99) (not (=> ?v_99 (=> (= state_3 (store1 state_2 ?v_95 (select1 state_2 ?v_93))) (=> (= i_1 (+ i_0 1)) (=> (<= 1 i_1) (=> true (=> ?v_101 (not (or (not ?v_100) (not (=> ?v_100 (=> ?v_101 (=> false true)))))))))))))))))))))))))))))))) (not (=> true (=> ?v_24 (=> (>= i_0 ?v_102) ?v_103))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (not (=> true (=> true (=> (not ?v_104) (=> true (=> true (=> (= meta_6 meta_1) (=> (= whileState_1_0 whileState_1) (=> (= tmp_1 tmp) (=> (= newCapacity_1 newCapacity) (=> (= i_2 i) (=> (= whileMeta_1_0 whileMeta_1) (=> (= newArr_1 newArr) (=> (= state_6 state_1) (=> (= res__alloc_0_0 res__alloc_0) (=> (= oldArr_1 oldArr) ?v_105))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
