(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun Length (Int Int Int) Int)
(declare-fun mutable () Int)
(declare-fun status_tag () Int)
(declare-fun good_meta (Int) Int)
(declare-fun dot (Int Int) Int)
(declare-fun Stack_topOfStack () Int)
(declare-fun inv (Int Int Int Int) Int)
(declare-fun Stack () Int)
(declare-fun consistent () Int)
(declare-fun IsFull (Int Int Int) Int)
(declare-fun Capacity () Int)
(declare-fun IsEmpty (Int Int Int) Int)
(declare-fun ValidStack (Int Int Int) Int)
(declare-fun set_empty () Int)
(declare-fun owned_tag () Int)
(declare-fun idx (Int Int Int) Int)
(declare-fun int () Int)
(declare-fun Stack_array () Int)
(declare-fun emb (Int Int) Int)
(declare-fun is_array (Int Int Int Int) Int)
(declare-fun typed (Int Int) Int)
(declare-fun is (Int Int) Int)
(declare-fun ptr (Int Int) Int)
(declare-fun ref (Int) Int)
(declare-fun field_offset (Int) Int)
(declare-fun ts_is_array_elt (Int) Int)
(declare-fun ts_tag () Int)
(declare-fun ts_path (Int) Int)
(declare-fun in_extent_of (Int Int Int) Int)
(declare-fun in_full_extent_of (Int Int) Int)
(declare-fun ptr_level (Int) Int)
(declare-fun kind_composite () Int)
(declare-fun kind_of (Int) Int)
(declare-fun sizeof (Int) Int)
(declare-fun set_in (Int Int) Int)
(declare-fun array_range (Int Int Int) Int)
(declare-fun array (Int Int) Int)
(declare-fun kind_array () Int)
(declare-fun array_length (Int) Int)
(declare-fun element_type (Int) Int)
(declare-fun set_disjoint (Int Int) Int)
(declare-fun set_eq (Int Int) Int)
(declare-fun dont_instantiate (Int) Int)
(declare-fun set_subset (Int Int) Int)
(declare-fun set_subtraction (Int Int) Int)
(declare-fun set_union (Int Int) Int)
(declare-fun set_singleton (Int) Int)
(declare-fun full_extent (Int) Int)
(declare-fun is_primitive (Int) Int)
(declare-fun good_state (Int) Int)
(declare-fun typ (Int) Int)
(declare-fun ts_typed (Int) Int)
(declare-fun ts_emb (Int) Int)
(declare-fun dont_instantiate_int (Int) Int)
(declare-fun void () Int)
(declare-fun null () Int)
(declare-fun ptr_to (Int) Int)
(declare-fun kind_primitive () Int)
(declare-fun map_t (Int Int) Int)
(declare-fun map_range (Int) Int)
(declare-fun map_domain (Int) Int)
(declare-fun unptr_to (Int) Int)
(declare-fun hasowner_tag () Int)
(declare-fun committed () Int)
(declare-fun ptrset () Int)
(declare-fun S () Int)
(declare-fun state_2 () Int)
(declare-fun meta_1 () Int)
(declare-fun state_1 () Int)
(declare-fun meta_0 () Int)
(declare-fun instantiate_int (Int) Int)
(declare-fun meta () Int)
(declare-fun state_0 () Int)
(declare-fun state () Int)
(assert (not (or (not (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v))) (not (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j))))) (not (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct int void ptrset kind_composite kind_primitive kind_array mutable consistent committed status_tag ts_tag owned_tag hasowner_tag Stack Stack_topOfStack Stack_array)) (not (= (sizeof int) 4)) (not (= (ptr_level int) 0)) (not (= (ptr_level void) 0)) (not (forall ((?n Int)) (! (= (unptr_to (ptr_to ?n)) ?n) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (ptr_level (ptr_to ?n)) (+ (ptr_level ?n) 2)) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (sizeof (ptr_to ?n)) 8) :pattern ((ptr_to ?n)) ))) (not (forall ((?r Int) (?d Int)) (! (= (ptr_level (map_t ?r ?d)) (+ (ptr_level ?r) 3)) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_domain (map_t ?r ?d)) ?d) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_range (map_t ?r ?d)) ?r) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (is_primitive (map_t ?r ?d)) true_1) :pattern ((map_t ?r ?d)) ))) (not (forall ((?t Int)) (! (= (= (is_primitive ?t) true_1) (= (kind_of ?t) kind_primitive)) :pattern ((is_primitive ?t)) ))) (not (forall ((?n Int)) (! (= (is_primitive (ptr_to ?n)) true_1) :pattern ((ptr_to ?n)) ))) (not (= (is_primitive int) true_1)) (not (forall ((?t_1 Int) (?b Int)) (= (typ (ptr ?t_1 ?b)) ?t_1))) (not (forall ((?t_1 Int) (?b Int)) (= (ref (ptr ?t_1 ?b)) ?b))) (not (= null (ptr void 0))) (not (forall ((?p_1 Int) (?t_1 Int)) (= (= (is ?p_1 ?t_1) true_1) (= (typ ?p_1) ?t_1)))) (not (forall ((?p_1 Int) (?t_1 Int)) (! (=> (= (is ?p_1 ?t_1) true_1) (exists ((?r Int)) (! (= ?p_1 (ptr ?t_1 ?r)) :pattern ((dont_instantiate_int ?r)) ))) :pattern ((is ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (= (emb ?m ?p_1) (ts_emb (select2 ?m ?p_1 ts_tag))) :pattern ((emb ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (= (good_meta ?m) true_1) (= (= (typed ?m ?p_1) true_1) (= (ts_typed (select2 ?m ?p_1 ts_tag)) true_1))) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (typed ?m ?p_1) true_1)))) (> (ref ?p_1) 0)) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?s Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array))) (not (= (typ ?p_1) ?t_1)))) (= (= (inv ?m ?s ?p_1 ?t_1) true_1) true)) :pattern ((inv ?m ?s ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?r Int) (?t_1 Int)) (! (=> (= (good_meta ?m) true_1) (=> (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array)) (= (select2 ?m (ptr ?t_1 ?r) owned_tag) set_empty))) :pattern ((select2 ?m (ptr ?t_1 ?r) owned_tag)) ))) (not (forall ((?m Int) (?s Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (good_state ?s) true_1)) (not (= (select2 ?m ?p_1 status_tag) consistent)))) (= (inv ?m ?s ?p_1 ?t_1) true_1)) :pattern ((inv ?m ?s ?p_1 ?t_1)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?r_1 Int) (?p Int)) (! (let ((?v_0 (ptr ?T ?r_1))) (= (= (in_full_extent_of ?p ?v_0) true_1) (= ?p ?v_0))) :pattern ((in_full_extent_of ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?M Int) (?r_1 Int) (?p Int)) (! (let ((?v_1 (ptr ?T ?r_1))) (= (= (in_extent_of ?M ?p ?v_1) true_1) (= ?p ?v_1))) :pattern ((in_extent_of ?M ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?p_1 Int) (?l Int)) (! (= (= (set_in ?p_1 (full_extent ?l)) true_1) (= (in_full_extent_of ?p_1 ?l) true_1)) :pattern ((set_in ?p_1 (full_extent ?l))) ))) (not (forall ((?o_1 Int)) (! (not (= (set_in ?o_1 set_empty) true_1)) :pattern ((set_in ?o_1 set_empty)) ))) (not (forall ((?r Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_singleton ?r)) true_1) (= ?r ?o_1)) :pattern ((set_in ?o_1 (set_singleton ?r))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_union ?a ?b)) true_1) (or (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 (set_union ?a ?b))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_subtraction ?a ?b)) true_1) (not (or (not (= (set_in ?o_1 ?a) true_1)) (not (not (= (set_in ?o_1 ?b) true_1)))))) :pattern ((set_in ?o_1 (set_subtraction ?a ?b))) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_subset ?a ?b) true_1) (forall ((?o_1 Int)) (! (=> (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_subset ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (forall ((?o_1 Int)) (! (= (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((dont_instantiate ?o_1)) )) (= (set_eq ?a ?b) true_1)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= (set_eq ?a ?b) true_1) (= ?a ?b)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_disjoint ?a ?b) true_1) (forall ((?o_1 Int)) (! (or (not (= (set_in ?o_1 ?a) true_1)) (not (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_disjoint ?a ?b)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (element_type (array ?T ?s_1)) ?T) :pattern ((array ?T ?s_1)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (array_length (array ?T ?s_1)) ?s_1) :pattern ((array ?T ?s_1)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (ptr_level (array ?T ?s_1)) 0) :pattern ((array ?T ?s_1)) ))) (not (forall ((?T Int) (?s_1 Int)) (! (= (kind_of (array ?T ?s_1)) kind_array) :pattern ((array ?T ?s_1)) ))) (not (forall ((?p_1 Int) (?i_1 Int) (?t_1 Int)) (! (= (idx ?p_1 ?i_1 ?t_1) (ptr ?t_1 (+ (ref ?p_1) (* ?i_1 (sizeof ?t_1))))) :pattern ((idx ?p_1 ?i_1 ?t_1)) ))) (not (forall ((?p Int) (?i Int) (?j Int) (?T Int)) (! (=> (not (= ?i 0)) (= (idx (idx ?p ?i ?T) ?j ?T) (idx ?p (+ ?i ?j) ?T))) :pattern ((idx (idx ?p ?i ?T) ?j ?T)) ))) (not (forall ((?M Int) (?p Int) (?T Int) (?sz Int)) (! (= (= (is_array ?M ?p ?T ?sz) true_1) (not (or (not (= (is ?p ?T) true_1)) (not (forall ((?i Int)) (! (let ((?v_2 (idx ?p ?i ?T))) (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (not (or (not (= (ts_is_array_elt (select2 ?M ?v_2 ts_tag)) true_1)) (not (= (typed ?M ?v_2) true_1)))))) :pattern ((idx ?p ?i ?T)) )))))) :pattern ((is_array ?M ?p ?T ?sz)) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_3 (ptr (array ?T ?sz) ?r))) (= (= (in_full_extent_of ?p ?v_3) true_1) (or (= ?p ?v_3) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_1 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_1 ?T)) ))))) :pattern ((in_full_extent_of ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_4 (ptr (array ?T ?sz) ?r))) (= (= (in_extent_of ?M ?p ?v_4) true_1) (or (= ?p ?v_4) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 ?sz)) (not (= (in_extent_of ?M ?p (idx (ptr ?T ?r) ?i_1 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_1 ?T)) ))))) :pattern ((in_extent_of ?M ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?r Int) (?T Int) (?sz Int)) (! (=> (= (typed ?M (ptr (array ?T ?sz) ?r)) true_1) (not (or (not (= (is_array ?M (ptr ?T ?r) ?T ?sz) true_1)) (not (forall ((?i Int)) (! (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (= (emb ?M (idx (ptr ?T ?r) ?i ?T)) (ptr (array ?T ?sz) ?r))) :pattern ((idx (ptr ?T ?r) ?i ?T)) )))))) :pattern ((typed ?M (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (= (= (set_in ?p (array_range (ptr ?T ?r) ?T ?sz)) true_1) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_1 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_1 ?T)) ))) :pattern ((set_in ?p (array_range (ptr ?T ?r) ?T ?sz))) ))) (not (> Capacity 0)) (not (= (sizeof Stack) 404)) (not (= (kind_of Stack) kind_composite)) (not (= (ptr_level Stack) 0)) (not (forall ((?r Int) (?q Int)) (! (let ((?v_5 (ptr Stack ?r))) (= (= (in_full_extent_of ?q ?v_5) true_1) (or (= ?q ?v_5) (= ?q (dot ?v_5 Stack_topOfStack)) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 100)) (not (= ?q (idx (dot ?v_5 Stack_array) ?i_1 int))))) :pattern ((idx (dot ?v_5 Stack_array) ?i_1 int)) ))))) :pattern ((in_full_extent_of ?q (ptr Stack ?r))) ))) (not (forall ((?m Int) (?r Int) (?q Int)) (! (let ((?v_6 (ptr Stack ?r))) (= (= (in_extent_of ?m ?q ?v_6) true_1) (or (= ?q ?v_6) (= ?q (dot ?v_6 Stack_topOfStack)) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 100)) (not (= ?q (idx (dot ?v_6 Stack_array) ?i_1 int))))) :pattern ((idx (dot ?v_6 Stack_array) ?i_1 int)) ))))) :pattern ((in_extent_of ?m ?q (ptr Stack ?r))) ))) (not (= (field_offset Stack_topOfStack) 0)) (not (forall ((?p_1 Int)) (! (=> (= (is ?p_1 Stack) true_1) (= (dot ?p_1 Stack_topOfStack) (ptr int (+ (ref ?p_1) 0)))) :pattern ((dot ?p_1 Stack_topOfStack)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_7 (dot ?p_1 Stack_topOfStack))) (let ((?v_8 (select2 ?m ?v_7 ts_tag))) (=> (not (or (not (= (is ?p_1 Stack) true_1)) (not (= (typed ?m ?p_1) true_1)))) (not (or (not (= (typed ?m ?v_7) true_1)) (not (= (emb ?m ?v_7) ?p_1)) (not (= (ts_path ?v_8) Stack_topOfStack)) (not (not (= (ts_is_array_elt ?v_8) true_1)))))))) :pattern ((typed ?m (dot ?p_1 Stack_topOfStack)))  :pattern ((dot ?p_1 Stack_topOfStack) (typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_11 (dot ?p_1 Stack_topOfStack)) (?v_10 (not (= (typed ?m ?p_1) true_1))) (?v_9 (not (= (is ?p_1 Stack) true_1)))) (=> (not (or ?v_9 ?v_10 ?v_9 ?v_10 (not (= (select2 ?m ?p_1 status_tag) mutable)))) (not (or (not (= (is ?v_11 int) true_1)) (not (= (typed ?m ?v_11) true_1)) (not (= (select2 ?m ?v_11 status_tag) mutable)))))) :pattern ((select2 ?m (dot ?p_1 Stack_topOfStack) status_tag)) ))) (not (= (field_offset Stack_array) 4)) (not (forall ((?p_1 Int)) (! (=> (= (is ?p_1 Stack) true_1) (= (dot ?p_1 Stack_array) (ptr int (+ (ref ?p_1) 4)))) :pattern ((dot ?p_1 Stack_array)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_12 (dot ?p_1 Stack_array))) (=> (not (or (not (= (is ?p_1 Stack) true_1)) (not (= (typed ?m ?p_1) true_1)))) (not (or (not (= (typed ?m ?v_12) true_1)) (not (= (is_array ?m ?v_12 int 100) true_1)) (not (forall ((?i Int)) (! (=> (not (or (not (<= 0 ?i)) (not (< ?i 100)))) (= (emb ?m (idx ?v_12 ?i int)) ?p_1)) :pattern ((idx ?v_12 ?i int)) ))))))) :pattern ((typed ?m (dot ?p_1 Stack_array)))  :pattern ((dot ?p_1 Stack_array) (typed ?m ?p_1)) ))) (not (forall ((?s Int) (?m Int)) (forall ((?S Int)) (= (= (inv ?m ?s ?S Stack) true_1) (= (ValidStack ?m ?s ?S) true_1))))) (not (forall ((?m Int) (?s Int) (?S Int)) (! (let ((?v_13 (select1 ?s (dot ?S Stack_topOfStack)))) (= (= (ValidStack ?m ?s ?S) true_1) (not (or (not (= (is ?S Stack) true_1)) (not (= (typed ?m ?S) true_1)) (not (= (is_array ?m (dot ?S Stack_array) int Capacity) true_1)) (not (forall ((?i Int)) (! (=> (not (or (not (<= 0 ?i)) (not (< ?i Capacity)))) (= (emb ?m (idx (dot ?S Stack_array) ?i int)) ?S)) :pattern ((idx (dot ?S Stack_array) ?i int)) ))) (not (>= ?v_13 0)) (not (<= ?v_13 Capacity)) (not (= (select2 ?m ?S owned_tag) set_empty)))))) :pattern ((ValidStack ?m ?s ?S)) ))) (not (forall ((?m1 Int) (?s1 Int) (?m2 Int) (?s2 Int) (?S Int)) (! (=> (not (or (not (= (good_meta ?m1) true_1)) (not (= (good_meta ?m2) true_1)) (not (= (select1 ?s1 ?S) (select1 ?s2 ?S))) (not (or (not (= (select2 ?m1 ?S status_tag) mutable)) (not (= (select2 ?m2 ?S status_tag) mutable)))))) (= (= (ValidStack ?m1 ?s1 ?S) true_1) (= (ValidStack ?m2 ?s2 ?S) true_1))) :pattern ((ValidStack ?m1 ?s1 ?S) (ValidStack ?m2 ?s2 ?S)) ))) (not (forall ((?m Int) (?s Int) (?S Int)) (! (=> (not (or (not (= (select2 ?m ?S status_tag) consistent)) (not (= (inv ?m ?s ?S Stack) true_1)))) (= (= (IsEmpty ?m ?s ?S) true_1) (= (select1 ?s (dot ?S Stack_topOfStack)) 0))) :pattern ((IsEmpty ?m ?s ?S)) ))) (not (forall ((?m1 Int) (?s1 Int) (?m2 Int) (?s2 Int) (?S Int)) (! (=> (not (or (not (= (good_meta ?m1) true_1)) (not (= (good_meta ?m2) true_1)) (not (= (select1 ?s1 ?S) (select1 ?s2 ?S))) (not (or (not (= (select2 ?m1 ?S status_tag) mutable)) (not (= (select2 ?m2 ?S status_tag) mutable)))))) (= (= (IsEmpty ?m1 ?s1 ?S) true_1) (= (IsEmpty ?m2 ?s2 ?S) true_1))) :pattern ((IsEmpty ?m1 ?s1 ?S) (IsEmpty ?m2 ?s2 ?S)) ))) (not (forall ((?m Int) (?s Int) (?S Int)) (! (=> (not (or (not (= (select2 ?m ?S status_tag) consistent)) (not (= (inv ?m ?s ?S Stack) true_1)))) (= (= (IsFull ?m ?s ?S) true_1) (= (select1 ?s (dot ?S Stack_topOfStack)) Capacity))) :pattern ((IsFull ?m ?s ?S)) ))) (not (forall ((?m1 Int) (?s1 Int) (?m2 Int) (?s2 Int) (?S Int)) (! (=> (not (or (not (= (good_meta ?m1) true_1)) (not (= (good_meta ?m2) true_1)) (not (= (select1 ?s1 ?S) (select1 ?s2 ?S))) (not (or (not (= (select2 ?m1 ?S status_tag) mutable)) (not (= (select2 ?m2 ?S status_tag) mutable)))))) (= (= (IsFull ?m1 ?s1 ?S) true_1) (= (IsFull ?m2 ?s2 ?S) true_1))) :pattern ((IsFull ?m1 ?s1 ?S) (IsFull ?m2 ?s2 ?S)) ))) (not (forall ((?m Int) (?s Int) (?S Int)) (! (=> (not (or (not (= (select2 ?m ?S status_tag) consistent)) (not (= (inv ?m ?s ?S Stack) true_1)))) (= (Length ?m ?s ?S) (select1 ?s (dot ?S Stack_topOfStack)))) :pattern ((Length ?m ?s ?S)) ))) (not (forall ((?m1 Int) (?s1 Int) (?m2 Int) (?s2 Int) (?S Int)) (! (=> (not (or (not (= (good_meta ?m1) true_1)) (not (= (good_meta ?m2) true_1)) (not (= (select1 ?s1 ?S) (select1 ?s2 ?S))) (not (or (not (= (select2 ?m1 ?S status_tag) mutable)) (not (= (select2 ?m2 ?S status_tag) mutable)))))) (= (Length ?m1 ?s1 ?S) (Length ?m2 ?s2 ?S))) :pattern ((Length ?m1 ?s1 ?S) (Length ?m2 ?s2 ?S)) ))))))
(assert (let ((?v_21 (= (inv meta_1 state_2 S Stack) true_1)) (?v_20 (= (select2 meta_1 S status_tag) consistent))) (let ((?v_22 (not (or (not ?v_20) (not ?v_21)))) (?v_19 (= (IsEmpty meta_1 state_2 S) true_1)) (?v_18 (= (is_primitive Stack) true_1)) (?v_17 (= (inv meta_0 state_1 S Stack) true_1)) (?v_16 (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (select2 meta_0 S owned_tag)) true_1) (= (select2 meta_0 ?p_1 status_tag) consistent)) :pattern ((select2 meta_0 ?p_1 status_tag)) ))) (?v_11 (select2 meta_0 S status_tag))) (let ((?v_12 (= ?v_11 mutable)) (?v_4 (= (typ S) Stack))) (let ((?v_15 (not ?v_4)) (?v_14 (forall ((?p_1 Int)) (! (let ((?v_23 (select2 meta_0 ?p_1 status_tag))) (=> (= (set_in ?p_1 (select2 meta_0 S owned_tag)) true_1) (or (= ?p_1 S) (not (or (not (or (= (select2 meta ?p_1 status_tag) committed) (= (instantiate_int ?v_23) true_1))) (not (or (= ?v_23 mutable) (= ?v_23 consistent)))))))) :pattern ((dont_instantiate ?p_1)) ))) (?v_0 (select2 meta S status_tag))) (let ((?v_10 (= ?v_0 committed)) (?v_9 (= S S))) (let ((?v_13 (or ?v_9 (not (or (not (or ?v_10 (= (instantiate_int ?v_11) true_1))) (not (or ?v_12 (= ?v_11 consistent))))))) (?v_5 (dot S Stack_topOfStack))) (let ((?v_7 (select2 meta_0 ?v_5 status_tag))) (let ((?v_8 (or (= ?v_5 S) (not (or (not (or (= (select2 meta ?v_5 status_tag) committed) (= (instantiate_int ?v_7) true_1))) (not (or (= ?v_7 mutable) (= ?v_7 consistent))))))) (?v_6 (not (or (not (= (is ?v_5 int) true_1)) (not (= (typed meta_0 ?v_5) true_1))))) (?v_1 (= ?v_0 consistent))) (let ((?v_3 (not ?v_1)) (?v_2 (or ?v_9 (not (or (not (or ?v_10 (= (instantiate_int ?v_0) true_1))) (not (or (= ?v_0 mutable) ?v_1))))))) (not (=> true (=> (= (good_meta meta) true_1) (=> (= (good_state state) true_1) (=> (= (is S Stack) true_1) (=> (not (or ?v_3 (not (= (inv meta state S Stack) true_1)))) (=> true (not (or (not ?v_2) (not (=> ?v_2 (not (or ?v_3 (not (=> ?v_1 (not (or ?v_15 (not (=> ?v_4 (=> (= (good_meta meta_0) true_1) (=> (= (good_state state_0) true_1) (=> (= (inv meta_0 state_0 S Stack) true_1) (=> ?v_12 (=> (forall ((?p_1 Int)) (! (=> (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_0 ?p_1) S)))) (not (or (not (= (select2 meta_0 ?p_1 status_tag) mutable)) (not (= (select2 meta ?p_1 status_tag) committed))))) :pattern ((select2 meta_0 ?p_1 status_tag)) )) (=> (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (select2 meta S owned_tag)) true_1) (not (or (not (= (select2 meta_0 ?p_1 status_tag) consistent)) (not (= (select2 meta ?p_1 status_tag) committed))))) :pattern ((select2 meta_0 ?p_1 status_tag))  :pattern ((select2 meta ?p_1 status_tag)) )) (=> (forall ((?p_1 Int) (?t_1 Int)) (! (or (not (or (not (or (= ?p_1 S) (= (set_in ?p_1 (select2 meta S owned_tag)) true_1) (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_0 ?p_1) S)))))) (not (= ?t_1 status_tag)))) (= (select2 meta_0 ?p_1 ?t_1) (select2 meta ?p_1 ?t_1))) :pattern ((select2 meta_0 ?p_1 ?t_1)) )) (=> (exists ((?x_2 Int)) (= state_0 (store1 state S ?x_2))) (=> (=> ?v_18 (= state state_0)) (not (or (not ?v_6) (not (=> ?v_6 (not (or (not ?v_8) (not (=> ?v_8 (=> (= state_1 (store1 state_0 ?v_5 0)) (not (or (not ?v_13) (not (=> ?v_13 (not (or (not ?v_14) (not (=> ?v_14 (not (or ?v_15 (not (=> ?v_4 (not (or (not ?v_12) (not (=> ?v_12 (not (or (not ?v_16) (not (=> ?v_16 (not (or (not ?v_17) (not (=> ?v_17 (=> (= (good_meta meta_1) true_1) (=> (= (good_state state_2) true_1) (=> ?v_21 (=> (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (select2 meta_0 S owned_tag)) true_1) (not (or (not (= (select2 meta_1 ?p_1 status_tag) committed)) (not (= (select2 meta_0 ?p_1 status_tag) consistent))))) :pattern ((select2 meta_1 ?p_1 status_tag)) )) (=> (forall ((?p_1 Int)) (! (=> (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_1 ?p_1) S)))) (not (or (not (= (select2 meta_1 ?p_1 status_tag) committed)) (not (= (select2 meta_0 ?p_1 status_tag) mutable))))) :pattern ((select2 meta_1 ?p_1 status_tag)) )) (=> ?v_20 (=> (forall ((?p_1 Int) (?t_1 Int)) (! (or (not (or (not (or (= ?p_1 S) (= (set_in ?p_1 (select2 meta_0 S owned_tag)) true_1) (not (or (not (= (is_primitive (typ ?p_1)) true_1)) (not (= (emb meta_1 ?p_1) S)))))) (not (= ?t_1 status_tag)))) (= (select2 meta_1 ?p_1 ?t_1) (select2 meta_0 ?p_1 ?t_1))) :pattern ((select2 meta_1 ?p_1 ?t_1)) )) (=> (exists ((?x_2 Int)) (= state_2 (store1 state_1 S ?x_2))) (=> (=> ?v_18 (= state_1 state_2)) (=> true (=> true (=> true (=> true (=> true (not (or (not ?v_19) (not (=> ?v_19 (not (or (not ?v_22) (not (=> ?v_22 true)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
