(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(set-info :source |
    VCC and HAVOC benchmarks.  Contributed by Nikolaj Bjorner, Leonardo de Moura,
    Michal Moskal, and Shaz Qadeer.
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun x (Int Int) Int)
(declare-fun true_1 () Int)
(declare-fun false_1 () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun intLess (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun boolNot (Int) Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun store1 (Int Int Int) Int)
(declare-fun typed (Int Int) Int)
(declare-fun dot (Int Int) Int)
(declare-fun A_x () Int)
(declare-fun idx (Int Int Int) Int)
(declare-fun int () Int)
(declare-fun emb (Int Int) Int)
(declare-fun is_array (Int Int Int Int) Int)
(declare-fun is (Int Int) Int)
(declare-fun A () Int)
(declare-fun ptr (Int Int) Int)
(declare-fun ref (Int) Int)
(declare-fun field_offset (Int) Int)
(declare-fun in_extent_of (Int Int Int) Int)
(declare-fun in_full_extent_of (Int Int) Int)
(declare-fun ptr_level (Int) Int)
(declare-fun kind_composite () Int)
(declare-fun kind_of (Int) Int)
(declare-fun sizeof (Int) Int)
(declare-fun set_in (Int Int) Int)
(declare-fun array_range (Int Int Int) Int)
(declare-fun array (Int Int) Int)
(declare-fun ts_is_array_elt (Int) Int)
(declare-fun ts_tag () Int)
(declare-fun kind_array () Int)
(declare-fun array_length (Int) Int)
(declare-fun element_type (Int) Int)
(declare-fun set_disjoint (Int Int) Int)
(declare-fun set_eq (Int Int) Int)
(declare-fun dont_instantiate (Int) Int)
(declare-fun set_subset (Int Int) Int)
(declare-fun set_subtraction (Int Int) Int)
(declare-fun set_union (Int Int) Int)
(declare-fun set_singleton (Int) Int)
(declare-fun set_empty () Int)
(declare-fun full_extent (Int) Int)
(declare-fun is_primitive (Int) Int)
(declare-fun inv (Int Int Int Int) Int)
(declare-fun consistent () Int)
(declare-fun status_tag () Int)
(declare-fun good_state (Int) Int)
(declare-fun good_meta (Int) Int)
(declare-fun owned_tag () Int)
(declare-fun typ (Int) Int)
(declare-fun ts_typed (Int) Int)
(declare-fun ts_emb (Int) Int)
(declare-fun dont_instantiate_int (Int) Int)
(declare-fun void () Int)
(declare-fun null () Int)
(declare-fun ptr_to (Int) Int)
(declare-fun kind_primitive () Int)
(declare-fun map_t (Int Int) Int)
(declare-fun map_range (Int) Int)
(declare-fun map_domain (Int) Int)
(declare-fun unptr_to (Int) Int)
(declare-fun hasowner_tag () Int)
(declare-fun committed () Int)
(declare-fun mutable () Int)
(declare-fun ptrset () Int)
(declare-fun meta_8 () Int)
(declare-fun meta_7 () Int)
(declare-fun call6151formal__x_0 () Int)
(declare-fun x_0 () Int)
(declare-fun instantiate_int (Int) Int)
(declare-fun meta () Int)
(declare-fun meta_6 () Int)
(declare-fun state_6 () Int)
(declare-fun state_5 () Int)
(declare-fun meta_5 () Int)
(declare-fun call6107formal_arr_0 () Int)
(declare-fun state_4 () Int)
(declare-fun meta_4 () Int)
(declare-fun state_3 () Int)
(declare-fun meta_3 () Int)
(declare-fun state_2 () Int)
(declare-fun meta_2 () Int)
(declare-fun state_1 () Int)
(declare-fun meta_1 () Int)
(declare-fun state_0 () Int)
(declare-fun meta_0 () Int)
(declare-fun state () Int)
(declare-fun call6006formal__r_0 () Int)
(declare-fun call6006formal__t_0 () Int)
(assert (not (or (not (forall ((?A_1 Int) (?i Int) (?v Int)) (= (select1 (store1 ?A_1 ?i ?v) ?i) ?v))) (not (forall ((?A_1 Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A_1 ?i ?v) ?j) (select1 ?A_1 ?j))))) (not (forall ((?A_1 Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A_1 ?o ?f ?v) ?o ?f) ?v))) (not (forall ((?A_1 Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A_1 ?o ?f ?v) ?p ?g) (select2 ?A_1 ?p ?g))))) (not (forall ((?A_1 Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A_1 ?o ?f ?v) ?p ?g) (select2 ?A_1 ?p ?g))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolIff ?x_1 ?y) true_1) (= (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolImplies ?x_1 ?y) true_1) (=> (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolAnd ?x_1 ?y) true_1) (not (or (not (= ?x_1 true_1)) (not (= ?y true_1))))))) (not (forall ((?x_1 Int) (?y Int)) (= (= (boolOr ?x_1 ?y) true_1) (or (= ?x_1 true_1) (= ?y true_1))))) (not (forall ((?x_1 Int)) (! (= (= (boolNot ?x_1) true_1) (not (= ?x_1 true_1))) :pattern ((boolNot ?x_1)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (anyEqual ?x_1 ?y) true_1) (= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (! (= (= (anyNeq ?x_1 ?y) true_1) (not (= ?x_1 ?y))) :pattern ((anyNeq ?x_1 ?y)) ))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intLess ?x_1 ?y) true_1) (< ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtMost ?x_1 ?y) true_1) (<= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intAtLeast ?x_1 ?y) true_1) (>= ?x_1 ?y)))) (not (forall ((?x_1 Int) (?y Int)) (= (= (intGreater ?x_1 ?y) true_1) (> ?x_1 ?y)))) (not (distinct false_1 true_1)) (not (forall ((?t Int)) (! (= (x ?t ?t) true_1) :pattern ((x ?t ?t)) ))) (not (forall ((?t Int) (?u Int) (?v Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?v) true_1)))) (= (x ?t ?v) true_1)) :pattern ((x ?t ?u) (x ?u ?v)) ))) (not (forall ((?t Int) (?u Int)) (! (=> (not (or (not (= (x ?t ?u) true_1)) (not (= (x ?u ?t) true_1)))) (= ?t ?u)) :pattern ((x ?t ?u) (x ?u ?t)) ))))))
(assert (not (or (not (distinct int void ptrset kind_composite kind_primitive kind_array mutable consistent committed status_tag ts_tag owned_tag hasowner_tag A A_x)) (not (= (sizeof int) 4)) (not (= (ptr_level int) 0)) (not (= (ptr_level void) 0)) (not (forall ((?n Int)) (! (= (unptr_to (ptr_to ?n)) ?n) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (ptr_level (ptr_to ?n)) (+ (ptr_level ?n) 2)) :pattern ((ptr_to ?n)) ))) (not (forall ((?n Int)) (! (= (sizeof (ptr_to ?n)) 8) :pattern ((ptr_to ?n)) ))) (not (forall ((?r Int) (?d Int)) (! (= (ptr_level (map_t ?r ?d)) (+ (ptr_level ?r) 3)) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_domain (map_t ?r ?d)) ?d) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (map_range (map_t ?r ?d)) ?r) :pattern ((map_t ?r ?d)) ))) (not (forall ((?r Int) (?d Int)) (! (= (is_primitive (map_t ?r ?d)) true_1) :pattern ((map_t ?r ?d)) ))) (not (forall ((?t Int)) (! (= (= (is_primitive ?t) true_1) (= (kind_of ?t) kind_primitive)) :pattern ((is_primitive ?t)) ))) (not (forall ((?n Int)) (! (= (is_primitive (ptr_to ?n)) true_1) :pattern ((ptr_to ?n)) ))) (not (= (is_primitive int) true_1)) (not (forall ((?t_1 Int) (?b Int)) (= (typ (ptr ?t_1 ?b)) ?t_1))) (not (forall ((?t_1 Int) (?b Int)) (= (ref (ptr ?t_1 ?b)) ?b))) (not (= null (ptr void 0))) (not (forall ((?p_1 Int) (?t_1 Int)) (= (= (is ?p_1 ?t_1) true_1) (= (typ ?p_1) ?t_1)))) (not (forall ((?p_1 Int) (?t_1 Int)) (! (=> (= (is ?p_1 ?t_1) true_1) (exists ((?r Int)) (! (= ?p_1 (ptr ?t_1 ?r)) :pattern ((dont_instantiate_int ?r)) ))) :pattern ((is ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (= (emb ?m ?p_1) (ts_emb (select2 ?m ?p_1 ts_tag))) :pattern ((emb ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (= (good_meta ?m) true_1) (= (= (typed ?m ?p_1) true_1) (= (ts_typed (select2 ?m ?p_1 ts_tag)) true_1))) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (typed ?m ?p_1) true_1)))) (> (ref ?p_1) 0)) :pattern ((typed ?m ?p_1)) ))) (not (forall ((?m Int) (?s_1 Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array))) (not (= (typ ?p_1) ?t_1)))) (= (= (inv ?m ?s_1 ?p_1 ?t_1) true_1) true)) :pattern ((inv ?m ?s_1 ?p_1 ?t_1)) ))) (not (forall ((?m Int) (?r Int) (?t_1 Int)) (! (=> (= (good_meta ?m) true_1) (=> (or (= (is_primitive ?t_1) true_1) (= (kind_of ?t_1) kind_array)) (= (select2 ?m (ptr ?t_1 ?r) owned_tag) set_empty))) :pattern ((select2 ?m (ptr ?t_1 ?r) owned_tag)) ))) (not (forall ((?m Int) (?s_1 Int) (?p_1 Int) (?t_1 Int)) (! (=> (not (or (not (= (good_meta ?m) true_1)) (not (= (good_state ?s_1) true_1)) (not (= (select2 ?m ?p_1 status_tag) consistent)))) (= (inv ?m ?s_1 ?p_1 ?t_1) true_1)) :pattern ((inv ?m ?s_1 ?p_1 ?t_1)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?r_1 Int) (?p Int)) (! (let ((?v_0 (ptr ?T ?r_1))) (= (= (in_full_extent_of ?p ?v_0) true_1) (= ?p ?v_0))) :pattern ((in_full_extent_of ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?T Int)) (! (=> (= (is_primitive ?T) true_1) (forall ((?M Int) (?r_1 Int) (?p Int)) (! (let ((?v_1 (ptr ?T ?r_1))) (= (= (in_extent_of ?M ?p ?v_1) true_1) (= ?p ?v_1))) :pattern ((in_extent_of ?M ?p (ptr ?T ?r_1))) ))) :pattern ((is_primitive ?T)) ))) (not (forall ((?p_1 Int) (?l Int)) (! (= (= (set_in ?p_1 (full_extent ?l)) true_1) (= (in_full_extent_of ?p_1 ?l) true_1)) :pattern ((set_in ?p_1 (full_extent ?l))) ))) (not (forall ((?o_1 Int)) (! (not (= (set_in ?o_1 set_empty) true_1)) :pattern ((set_in ?o_1 set_empty)) ))) (not (forall ((?r Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_singleton ?r)) true_1) (= ?r ?o_1)) :pattern ((set_in ?o_1 (set_singleton ?r))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_union ?a ?b)) true_1) (or (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 (set_union ?a ?b))) ))) (not (forall ((?a Int) (?b Int) (?o_1 Int)) (! (= (= (set_in ?o_1 (set_subtraction ?a ?b)) true_1) (not (or (not (= (set_in ?o_1 ?a) true_1)) (not (not (= (set_in ?o_1 ?b) true_1)))))) :pattern ((set_in ?o_1 (set_subtraction ?a ?b))) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_subset ?a ?b) true_1) (forall ((?o_1 Int)) (! (=> (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_subset ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (forall ((?o_1 Int)) (! (= (= (set_in ?o_1 ?a) true_1) (= (set_in ?o_1 ?b) true_1)) :pattern ((dont_instantiate ?o_1)) )) (= (set_eq ?a ?b) true_1)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (=> (= (set_eq ?a ?b) true_1) (= ?a ?b)) :pattern ((set_eq ?a ?b)) ))) (not (forall ((?a Int) (?b Int)) (! (= (= (set_disjoint ?a ?b) true_1) (forall ((?o_1 Int)) (! (or (not (= (set_in ?o_1 ?a) true_1)) (not (= (set_in ?o_1 ?b) true_1))) :pattern ((set_in ?o_1 ?a))  :pattern ((set_in ?o_1 ?b)) ))) :pattern ((set_disjoint ?a ?b)) ))) (not (forall ((?T Int) (?s Int)) (! (= (element_type (array ?T ?s)) ?T) :pattern ((array ?T ?s)) ))) (not (forall ((?T Int) (?s Int)) (! (= (array_length (array ?T ?s)) ?s) :pattern ((array ?T ?s)) ))) (not (forall ((?T Int) (?s Int)) (! (= (ptr_level (array ?T ?s)) 0) :pattern ((array ?T ?s)) ))) (not (forall ((?T Int) (?s Int)) (! (= (kind_of (array ?T ?s)) kind_array) :pattern ((array ?T ?s)) ))) (not (forall ((?p_1 Int) (?i_1 Int) (?t_1 Int)) (! (= (idx ?p_1 ?i_1 ?t_1) (ptr ?t_1 (+ (ref ?p_1) (* ?i_1 (sizeof ?t_1))))) :pattern ((idx ?p_1 ?i_1 ?t_1)) ))) (not (forall ((?p Int) (?i Int) (?j Int) (?T Int)) (! (=> (not (= ?i 0)) (= (idx (idx ?p ?i ?T) ?j ?T) (idx ?p (+ ?i ?j) ?T))) :pattern ((idx (idx ?p ?i ?T) ?j ?T)) ))) (not (forall ((?M Int) (?p Int) (?T Int) (?sz Int)) (! (= (= (is_array ?M ?p ?T ?sz) true_1) (not (or (not (= (is ?p ?T) true_1)) (not (forall ((?i Int)) (! (let ((?v_2 (idx ?p ?i ?T))) (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (not (or (not (= (ts_is_array_elt (select2 ?M ?v_2 ts_tag)) true_1)) (not (= (typed ?M ?v_2) true_1)))))) :pattern ((idx ?p ?i ?T)) )))))) :pattern ((is_array ?M ?p ?T ?sz)) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_3 (ptr (array ?T ?sz) ?r))) (= (= (in_full_extent_of ?p ?v_3) true_1) (or (= ?p ?v_3) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_1 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_1 ?T)) ))))) :pattern ((in_full_extent_of ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?p Int) (?r Int) (?T Int) (?sz Int)) (! (let ((?v_4 (ptr (array ?T ?sz) ?r))) (= (= (in_extent_of ?M ?p ?v_4) true_1) (or (= ?p ?v_4) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 ?sz)) (not (= (in_extent_of ?M ?p (idx (ptr ?T ?r) ?i_1 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_1 ?T)) ))))) :pattern ((in_extent_of ?M ?p (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?M Int) (?r Int) (?T Int) (?sz Int)) (! (=> (= (typed ?M (ptr (array ?T ?sz) ?r)) true_1) (not (or (not (= (is_array ?M (ptr ?T ?r) ?T ?sz) true_1)) (not (forall ((?i Int)) (! (=> (not (or (not (<= 0 ?i)) (not (< ?i ?sz)))) (= (emb ?M (idx (ptr ?T ?r) ?i ?T)) (ptr (array ?T ?sz) ?r))) :pattern ((idx (ptr ?T ?r) ?i ?T)) )))))) :pattern ((typed ?M (ptr (array ?T ?sz) ?r))) ))) (not (forall ((?p Int) (?r Int) (?T Int) (?sz Int)) (! (= (= (set_in ?p (array_range (ptr ?T ?r) ?T ?sz)) true_1) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 ?sz)) (not (= (in_full_extent_of ?p (idx (ptr ?T ?r) ?i_1 ?T)) true_1)))) :pattern ((idx (ptr ?T ?r) ?i_1 ?T)) ))) :pattern ((set_in ?p (array_range (ptr ?T ?r) ?T ?sz))) ))) (not (= (sizeof A) 400)) (not (= (kind_of A) kind_composite)) (not (= (ptr_level A) 0)) (not (forall ((?r Int) (?q Int)) (! (let ((?v_5 (ptr A ?r))) (= (= (in_full_extent_of ?q ?v_5) true_1) (or (= ?q ?v_5) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 100)) (not (= ?q (idx (dot ?v_5 A_x) ?i_1 int))))) :pattern ((idx (dot ?v_5 A_x) ?i_1 int)) ))))) :pattern ((in_full_extent_of ?q (ptr A ?r))) ))) (not (forall ((?m Int) (?r Int) (?q Int)) (! (let ((?v_6 (ptr A ?r))) (= (= (in_extent_of ?m ?q ?v_6) true_1) (or (= ?q ?v_6) (exists ((?i_1 Int)) (! (not (or (not (<= 0 ?i_1)) (not (< ?i_1 100)) (not (= ?q (idx (dot ?v_6 A_x) ?i_1 int))))) :pattern ((idx (dot ?v_6 A_x) ?i_1 int)) ))))) :pattern ((in_extent_of ?m ?q (ptr A ?r))) ))) (not (= (field_offset A_x) 0)) (not (forall ((?p_1 Int)) (! (=> (= (is ?p_1 A) true_1) (= (dot ?p_1 A_x) (ptr int (+ (ref ?p_1) 0)))) :pattern ((dot ?p_1 A_x)) ))) (not (forall ((?m Int) (?p_1 Int)) (! (let ((?v_7 (dot ?p_1 A_x))) (=> (not (or (not (= (is ?p_1 A) true_1)) (not (= (typed ?m ?p_1) true_1)))) (not (or (not (= (typed ?m ?v_7) true_1)) (not (= (is_array ?m ?v_7 int 100) true_1)) (not (forall ((?i Int)) (! (=> (not (or (not (<= 0 ?i)) (not (< ?i 100)))) (= (emb ?m (idx ?v_7 ?i int)) ?p_1)) :pattern ((idx ?v_7 ?i int)) ))))))) :pattern ((typed ?m (dot ?p_1 A_x)))  :pattern ((dot ?p_1 A_x) (typed ?m ?p_1)) ))))))
(assert (let ((?v_17 (= (typed meta_7 call6151formal__x_0) true_1)) (?v_12 (array int 100))) (let ((?v_13 (ptr ?v_12 (ref x_0)))) (let ((?v_16 (forall ((?p_1 Int)) (! (let ((?v_18 (select2 meta_7 ?p_1 status_tag))) (=> (= (in_extent_of meta_7 ?p_1 ?v_13) true_1) (not (or (not (or (= (select2 meta ?p_1 status_tag) committed) (= (instantiate_int ?v_18) true_1))) (not (or (= ?v_18 mutable) (= ?v_18 consistent))))))) :pattern ((dont_instantiate ?p_1)) ))) (?v_14 (select2 meta_7 ?v_13 status_tag))) (let ((?v_15 (not (or (not (or (= (select2 meta ?v_13 status_tag) committed) (= (instantiate_int ?v_14) true_1))) (not (or (= ?v_14 mutable) (= ?v_14 consistent)))))) (?v_11 (= (is call6107formal_arr_0 int) true_1)) (?v_10 (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (array_range call6107formal_arr_0 int 90)) true_1) (= (select2 meta_5 ?p_1 status_tag) mutable)) :pattern ((select2 meta_5 ?p_1 status_tag)) ))) (?v_9 (= (is_array meta_5 call6107formal_arr_0 int 90) true_1)) (?v_8 (forall ((?p_1 Int)) (! (let ((?v_19 (select2 meta_5 ?p_1 status_tag))) (=> (= (set_in ?p_1 (array_range (idx x_0 10 int) int 90)) true_1) (not (or (not (or (= (select2 meta ?p_1 status_tag) committed) (= (instantiate_int ?v_19) true_1))) (not (or (= ?v_19 mutable) (= ?v_19 consistent))))))) :pattern ((dont_instantiate ?p_1)) ))) (?v_3 (= (is x_0 int) true_1))) (let ((?v_7 (not ?v_3)) (?v_6 (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (array_range x_0 int 50)) true_1) (= (select2 meta_3 ?p_1 status_tag) mutable)) :pattern ((select2 meta_3 ?p_1 status_tag)) ))) (?v_5 (= (is_array meta_3 x_0 int 50) true_1)) (?v_4 (forall ((?p_1 Int)) (! (let ((?v_20 (select2 meta_3 ?p_1 status_tag))) (=> (= (set_in ?p_1 (array_range x_0 int 50)) true_1) (not (or (not (or (= (select2 meta ?p_1 status_tag) committed) (= (instantiate_int ?v_20) true_1))) (not (or (= ?v_20 mutable) (= ?v_20 consistent))))))) :pattern ((dont_instantiate ?p_1)) ))) (?v_2 (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (array_range x_0 int 100)) true_1) (= (select2 meta_1 ?p_1 status_tag) mutable)) :pattern ((select2 meta_1 ?p_1 status_tag)) ))) (?v_1 (= (is_array meta_1 x_0 int 100) true_1)) (?v_0 (forall ((?p_1 Int)) (! (let ((?v_21 (select2 meta_1 ?p_1 status_tag))) (=> (= (set_in ?p_1 (array_range x_0 int 100)) true_1) (not (or (not (or (= (select2 meta ?p_1 status_tag) committed) (= (instantiate_int ?v_21) true_1))) (not (or (= ?v_21 mutable) (= ?v_21 consistent))))))) :pattern ((dont_instantiate ?p_1)) )))) (not (=> true (=> (= (good_meta meta) true_1) (=> (= (good_state state) true_1) (=> true (=> (= call6006formal__t_0 ?v_12) (=> (= (good_meta meta_0) true_1) (=> (not (or (not (= (is call6006formal__r_0 call6006formal__t_0) true_1)) (not (= (typed meta_0 call6006formal__r_0) true_1)))) (=> (= (select2 meta_0 call6006formal__r_0 owned_tag) set_empty) (=> (not (= (select2 meta_0 call6006formal__r_0 hasowner_tag) true_1)) (=> (forall ((?p_1 Int) (?f_1 Int)) (! (=> (or (= (typed meta ?p_1) true_1) (not (= (select2 meta ?p_1 status_tag) committed))) (= (select2 meta ?p_1 ?f_1) (select2 meta_0 ?p_1 ?f_1))) :pattern ((select2 meta_0 ?p_1 ?f_1)) )) (=> (forall ((?p_1 Int)) (! (=> (= (in_full_extent_of ?p_1 call6006formal__r_0) true_1) (not (or (not (= (select2 meta_0 ?p_1 status_tag) mutable)) (not (= (select2 meta ?p_1 status_tag) committed))))) :pattern ((select2 meta ?p_1 status_tag))  :pattern ((select2 meta_0 ?p_1 status_tag)) )) (=> (exists ((?rf Int)) (= (ptr call6006formal__t_0 ?rf) call6006formal__r_0)) (=> (not (= (typed meta call6006formal__r_0) true_1)) (=> (= x_0 (ptr int (ref call6006formal__r_0))) (=> (= (good_state state_0) true_1) (=> (= (good_meta meta_1) true_1) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_0 ?p_1 status_tag) committed) (= (select1 state ?p_1) (select1 state_0 ?p_1))) :pattern ((select1 state_0 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta_0 ?pm status_tag) committed) (= (select2 meta_0 ?pm ?t_1) (select2 meta_1 ?pm ?t_1))) :pattern ((select2 meta_1 ?pm ?t_1)) ))))) (not (or (not ?v_0) (not (=> ?v_0 (not (or (not ?v_1) (not (=> ?v_1 (not (or (not ?v_2) (not (=> ?v_2 (not (or ?v_7 (not (=> ?v_3 (=> (= (good_state state_1) true_1) (=> (= (good_meta meta_2) true_1) (=> (= (is_array meta_2 x_0 int 100) true_1) (=> (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (array_range x_0 int 100)) true_1) (= (select2 meta_2 ?p_1 status_tag) mutable)) :pattern ((select2 meta_2 ?p_1 status_tag)) )) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_1 ?p_1 status_tag) committed) (= (set_in ?p_1 (array_range x_0 int 100)) true_1) (= (select1 state_0 ?p_1) (select1 state_1 ?p_1))) :pattern ((select1 state_1 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta_1 ?pm status_tag) committed) (= (set_in ?pm (array_range x_0 int 100)) true_1) (= (select2 meta_1 ?pm ?t_1) (select2 meta_2 ?pm ?t_1))) :pattern ((select2 meta_2 ?pm ?t_1)) ))))) (=> (= (good_state state_2) true_1) (=> (= (good_meta meta_3) true_1) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_2 ?p_1 status_tag) committed) (= (select1 state_1 ?p_1) (select1 state_2 ?p_1))) :pattern ((select1 state_2 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta_2 ?pm status_tag) committed) (= (select2 meta_2 ?pm ?t_1) (select2 meta_3 ?pm ?t_1))) :pattern ((select2 meta_3 ?pm ?t_1)) ))))) (not (or (not ?v_4) (not (=> ?v_4 (not (or (not ?v_5) (not (=> ?v_5 (not (or (not ?v_6) (not (=> ?v_6 (not (or ?v_7 (not (=> ?v_3 (=> (= (good_state state_3) true_1) (=> (= (good_meta meta_4) true_1) (=> (= (is_array meta_4 x_0 int 50) true_1) (=> (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (array_range x_0 int 50)) true_1) (= (select2 meta_4 ?p_1 status_tag) mutable)) :pattern ((select2 meta_4 ?p_1 status_tag)) )) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_3 ?p_1 status_tag) committed) (= (set_in ?p_1 (array_range x_0 int 50)) true_1) (= (select1 state_2 ?p_1) (select1 state_3 ?p_1))) :pattern ((select1 state_3 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta_3 ?pm status_tag) committed) (= (set_in ?pm (array_range x_0 int 50)) true_1) (= (select2 meta_3 ?pm ?t_1) (select2 meta_4 ?pm ?t_1))) :pattern ((select2 meta_4 ?pm ?t_1)) ))))) (=> (= (good_state state_4) true_1) (=> (= (good_meta meta_5) true_1) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_4 ?p_1 status_tag) committed) (= (select1 state_3 ?p_1) (select1 state_4 ?p_1))) :pattern ((select1 state_4 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta_4 ?pm status_tag) committed) (= (select2 meta_4 ?pm ?t_1) (select2 meta_5 ?pm ?t_1))) :pattern ((select2 meta_5 ?pm ?t_1)) ))))) (not (or (not ?v_8) (not (=> ?v_8 (=> (= call6107formal_arr_0 (idx x_0 10 int)) (not (or (not ?v_9) (not (=> ?v_9 (not (or (not ?v_10) (not (=> ?v_10 (not (or (not ?v_11) (not (=> ?v_11 (=> (= (good_state state_5) true_1) (=> (= (good_meta meta_6) true_1) (=> (= (is_array meta_6 call6107formal_arr_0 int 90) true_1) (=> (forall ((?p_1 Int)) (! (=> (= (set_in ?p_1 (array_range call6107formal_arr_0 int 90)) true_1) (= (select2 meta_6 ?p_1 status_tag) mutable)) :pattern ((select2 meta_6 ?p_1 status_tag)) )) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_5 ?p_1 status_tag) committed) (= (set_in ?p_1 (array_range call6107formal_arr_0 int 90)) true_1) (= (select1 state_4 ?p_1) (select1 state_5 ?p_1))) :pattern ((select1 state_5 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta_5 ?pm status_tag) committed) (= (set_in ?pm (array_range call6107formal_arr_0 int 90)) true_1) (= (select2 meta_5 ?pm ?t_1) (select2 meta_6 ?pm ?t_1))) :pattern ((select2 meta_6 ?pm ?t_1)) ))))) (=> (= (good_state state_6) true_1) (=> (= (good_meta meta_7) true_1) (=> (not (or (not (forall ((?p_1 Int)) (! (or (= (select2 meta_6 ?p_1 status_tag) committed) (= (select1 state_5 ?p_1) (select1 state_6 ?p_1))) :pattern ((select1 state_6 ?p_1)) ))) (not (forall ((?pm Int) (?t_1 Int)) (! (or (= (select2 meta_6 ?pm status_tag) committed) (= (select2 meta_6 ?pm ?t_1) (select2 meta_7 ?pm ?t_1))) :pattern ((select2 meta_7 ?pm ?t_1)) ))))) (not (or (not ?v_15) (not (=> ?v_15 (not (or (not ?v_16) (not (=> ?v_16 (=> (= call6151formal__x_0 ?v_13) (not (or (not ?v_17) (not (=> ?v_17 (=> (= (good_meta meta_8) true_1) (=> (forall ((?p_1 Int) (?f_1 Int)) (! (or (= (in_full_extent_of ?p_1 call6151formal__x_0) true_1) (= (select2 meta_7 ?p_1 ?f_1) (select2 meta_8 ?p_1 ?f_1))) :pattern ((select2 meta_8 ?p_1 ?f_1)) )) (=> true (=> true (=> true (=> true true))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(check-sat)
(exit)
